<!doctype html>
<%@ page import="com.actimind.actiplans.ScrollingCalculator" %>
<%@ page import="com.actimind.actiplans.administration.LeaveTimePlanningSettings" %>
<%@ page import="com.actimind.actiplans.services.beans.LeaveTimePlanningData" %>
<%@ page import="com.actimind.actitime.beans.NamedBean" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="java.util.Calendar" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.actitime.beans.GroupType" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/actiplans/error.jsp" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap"%>
<bean:define id="form" name="LeaveTimePlanningForm" type="com.actimind.actiplans.administration.LeaveTimePlanningForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />

<%
    LeaveTimePlanningSettings leaveTimePlanningSettings = ( LeaveTimePlanningSettings ) request.getAttribute( Keys.LEAVE_TIME_PLANNING_SETTINGS );
    LeaveTimePlanningData data = ( LeaveTimePlanningData ) request.getAttribute( Keys.LEAVE_TIME_PLANNING_DATA );
    String dataJSON = jsHelper.toJSON( data );

    @SuppressWarnings("unchecked")
    List<NamedBean> userGroups = ( List<NamedBean> ) request.getAttribute( Keys.USER_GROUPS_LIST_KEY );
    String allUserGroupsJSON = userGroups != null ? jsHelper.toJSON( userGroups.toArray() ) : null;
    List<NamedBean> timeZoneGroups = ( List<NamedBean> ) request.getAttribute( Keys.TIME_ZONE_GROUPS_LIST_KEY );
    String allTimeZoneGroupsJSON = timeZoneGroups != null ? jsHelper.toJSON( timeZoneGroups.toArray() ) : null;
    String selectedGroupIdsJSON = jsHelper.toJSON( leaveTimePlanningSettings.getGroupsFilter() );
    GroupType selectedGroupsType = leaveTimePlanningSettings.getGroupsFilterType();
    boolean displayOnlyAssignedToMeUsers = leaveTimePlanningSettings.isDisplayOnlyAssignedToMeUsers();

    Calendar fromCal = TimeUtils.createSystemCalendar();
    fromCal.setTime( form.getDateFrom() );

    Boolean canEditPastRequests = (Boolean) request.getAttribute(Keys.CAN_EDIT_PAST_REQUESTS);
    Boolean wasAtIntegrated = (Boolean) request.getAttribute(Keys.IS_OTHER_PRODUCT_HAS_ACTIVE_LICENSE);
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> Corporate Schedule</title>
    <jsp:include page="/actiplans/include_scripts.jsp"/>
</head>
<body class="leaveTimePlanning with-navigation">

<%-- Navigation --%>
<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected" value="corporate_schedule" />
</jsp:include>


<div id="contentDiv" class="invisibleWhileLoading" style="min-width: 980px; text-align: center; margin-left: 15px; margin-right: 15px;"><div id="contentInnerDiv" style="text-align: left; display: inline-block;">

<div style="padding-bottom: 30px;" class="pagetitle">
    <bean:message key="actiplans.leaves_management.title"/>
    <div id="leavesManagementPageSpinner"></div>
</div>

<table cellpadding="0" cellspacing="0" id="leaveTimePlanningPage">
    <tr>
        <td>
            <jsp:include page="leave_management_tabs.jsp">
                <jsp:param name="currentTab" value="LTP"/>
            </jsp:include>
        </td>
    </tr>
    <tr>
        <td>
            <table style="display: none;" id="leaveTimePlanningHeaderContainer">
                <tr id="leaveTimePlanningTableHeaderRow" class="tableHeaderRow">
                    <td colspan="2" rowspan="4" class="tableHeaderCell groupEmployeeCell">
                        <span id="tipLTPSorting" data-sortBy="<%=LeaveTimePlanningSettings.SORT_BY_USER%>">
                            <span class="sortButton" id="sortByUserButton">User</span>
                            <span class="sortIndicator">
                                <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                                <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                            </span>
                        </span>
                        <span class="sortByUserGroupSeparator">|</span>
                        <span id="sortByUserGroupLink" data-sortBy="<%=LeaveTimePlanningSettings.SORT_BY_USER_GROUP%>">
                            <span class="sortButton" id="sortByUserGroupButton">Group</span>
                            <span class="sortIndicator">
                                <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                                <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                            </span>
                        </span>
                        <span class="sortByTimeZoneGroupSeparator">|</span>
                        <span id="sortByTimeZoneGroupLink" data-sortBy="<%=LeaveTimePlanningSettings.SORT_BY_TIME_ZONE_GROUP%>">
                            <span class="sortButton" id="sortByTimeZoneGroupButton">Time Zone</span>
                            <span class="sortIndicator">
                                <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                                <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                            </span>
                        </span>

                        <table class="user_filters display-for-print"><tbody><tr>
                            <td>
                                <div class='userGroupsFilterPlaceholder filterBlock'></div>
                            </td>
                            <td id="displayOnlyAssignedToMeUsersBlock">
                                <div class="displayOnlyAssignedToMeFilter">
                                    <label for="displayOnlyAssignedToMeUsersChBox"><input id="displayOnlyAssignedToMeUsersChBox" type="checkbox"/><bean:message key="actiplans.corporate_requests.assigned_to_me"/></label>
                                </div>
                            </td>
                        <tr></tbody></table>
                    </td>
                    <td rowspan="4" class="tableHeaderCell timeTotalHeaderCell">
                        Planned Leave Time (hours)
                    </td>
                    <td class="employeesSpacerCell" rowspan="4"></td>
                    <td id="leaveTimePlanningScrollPanel">
                    </td>
                </tr>
            </table>
            <div style="position: relative;">
                <div id="searchFieldContainer">
                    <input type="text" class="searchField" name="searchField" id="employeesSearchField" maxlength="32">
                    <div id="spinnerPlaceholderSearchField"></div>
                </div>
            </div>
            <div id="leaveTimePlanningTablePlaceholder">
            </div>
        </td>
    </tr>
    <tr>
        <td style="padding-top: 15px;">
            <table cellpadding="0" cellspacing="0" border="0" id="leaveTimePlanningFooterTable" style="width: 100%;">
                <tr>
                    <td style="vertical-align: top;">
                        <jsp:include page="/administration/pager_panel.jsp"/>
                    </td>
                    <td id="legendContainer" style="text-align: right;">
                        <div id="scheduleLegend" class="leaveTableLegend" style="display: inline-block; padding-top: 5px;">
                            <table id="scheduleLegendTable">
                                <tr style="padding: 0;">
                                    <td id="scheduleLegendFirstBlock">
                                        <div class="scheduleLegendLTBlock" id="notApprovedRequestBlock">
                                            <div class="workingDayColorBlock">
                                                <div class="legendRequestImg"><ap:defImg page="not_approved_request.png" width="11" height="11" style="margin-top: 2px;"/></div>
                                            </div>
                                            <span class="scheduleLegendDayType"><bean:message key="my_schedule.page.my_schedule.legend.hatched_request"/></span>
                                        </div>
                                        <div class="scheduleLegendLTBlock" id="approvedRequestBlock">
                                            <div class="workingDayColorBlock">
                                                <div class="legendRequestImg"><ap:defImg page="approved_request.png" width="11" height="11" style="margin-top: 2px;"/></div>
                                            </div>
                                            <span class="scheduleLegendDayType"><bean:message key="my_schedule.page.my_schedule.legend.solid_request"/></span>
                                        </div>
                                    </td>
                                    <td id="scheduleLegendSecondBlock" class="withFloat">
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>
</div></div>

<div id="notApplicableRequestLabel">
    <bean:message key="actiplans.leavestable.not_applicable_request_tooltip"/>
</div>

<div id="requestAutoApprovalLabel">
    <bean:message key="actiplans.corporate_requests.tooltip.request_auto_approval"/>
</div>

<jsp:include page="../controls/leave_request_dialog.jsp"/>
<jsp:include page="../controls/request_resolution_dialog.jsp"/>

<at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

<%@ include file="/actiplans/util/InvocationResultCodes.jsp" %>

<at:script page="/actiplans/js/user/DateRangeCalculator.js"/>
<at:script page="/js/ArraySlice.js"/>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/actiplans/js/administration/scroll_panel.js"/>
<%@ include file="/actiplans/administration/scroll_panel.jsp" %>

<script type="text/javascript">
    function ie8fixTable() {}
</script>

<!--[if lte IE 8]>
<script type="text/javascript">
    // IE8 cannot correctly render grouping column if it was previously hidden
    function ie8fixTable()
    {
        $( '.groupName' ).css( "display", "none" );
        setTimeout( function ()
                    {
                        $( '.groupName' ).css( "display", "block" );
                    }, 1 );
    }
</script>

<style type="text/css">
    /* see Bug 47574 */
    #leaveTimePlanningTable .filterBlock .at-selector-button .contents .ellipsis {
        width: 80px;
    }
</style>
<![endif]-->

<script type="text/javascript">
    var LeaveTimePlanningPageConstants = {};
    LeaveTimePlanningPageConstants.SORT_BY_USER_GROUP = <%=LeaveTimePlanningSettings.SORT_BY_USER_GROUP%>;
    LeaveTimePlanningPageConstants.SORT_BY_TIME_ZONE_GROUP = <%=LeaveTimePlanningSettings.SORT_BY_TIME_ZONE_GROUP%>;

    var dateFrom = Date.create( <%=String.valueOf( fromCal.get( Calendar.YEAR ) )%>, <%=String.valueOf( fromCal.get( Calendar.MONTH ) )%>, <%=String.valueOf( fromCal.get( Calendar.DAY_OF_MONTH ) )%> );

    var data = <%=dataJSON%>;

    var allUserGroups = <%=allUserGroupsJSON%>;
    var allTimeZoneGroups = <%=allTimeZoneGroupsJSON%>;
    var selectedGroupIds = <%=selectedGroupIdsJSON%>;
    var selectedGroupsType = "<%=selectedGroupsType%>";
    var displayOnlyAssignedToMeUsers = <%=displayOnlyAssignedToMeUsers%>;

    if (!allUserGroups && !allTimeZoneGroups)
    {
        $("#leaveTimePlanningHeaderContainer").find(".userGroupsFilterPlaceholder").hide();
    }
    if (!allUserGroups)
    {
        $("#sortByUserGroupLink").hide();
        $("#leaveTimePlanningTableHeaderRow").find(".sortByUserGroupSeparator").hide();
    }
    if (!allTimeZoneGroups)
    {
        $("#sortByTimeZoneGroupLink").hide();
        $("#leaveTimePlanningTableHeaderRow").find(".sortByTimeZoneGroupSeparator").hide();
    }

    LeaveTimePlanningPage.scheduleCalculator = new CorporateScheduleCalculator().init(invertedDaysDateMap, <%=Arrays.toString( settings.getDefaultWorkSchedule() ) %>);
    LeaveTimePlanningPage.corporateScheduleWidthCalculator = new CorporateScheduleWidthCalculator(<%=ScrollingCalculator.MAX_VISIBLE_DAYS%>);

    var dateRangeCalculator = new DateRangeCalculator(<%=ScrollingCalculator.MAX_VISIBLE_DAYS%>, <%=ScrollingCalculator.FIRST_SCROLLING_DAYS%>, <%=ScrollingCalculator.ADDITION_SCROLLING_DAYS%>);

    var stateController = new StateController().init( {
                                                          recordsPerPage: <%=leaveTimePlanningSettings.getRecordsPerPage()%>,
                                                          pageNum: data.pageNum,
                                                          totalRecords: data.totalCount,
                                                          sortBy: <%=leaveTimePlanningSettings.getSortBy()%>,
                                                          isAscending: <%=leaveTimePlanningSettings.isAscending()%>,
                                                          employeesSearchText: ""
                                                      } );

    var canEditPastRequests = <%=canEditPastRequests%>;
    var wasAtIntegrated = <%=wasAtIntegrated%>;

    LeaveTimePlanningPage.init( dateFrom, data, allUserGroups, allTimeZoneGroups, selectedGroupIds, selectedGroupsType, displayOnlyAssignedToMeUsers,
                                dateRangeCalculator, stateController, canEditPastRequests, wasAtIntegrated );

    $( '.invisibleWhileLoading' ).removeClass( 'invisibleWhileLoading' );
</script>

</body>
</html>