<!doctype html>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.beans.LeaveTypeBean" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Set" %>
<%@ page import="com.actimind.actiplans.administration.LeaveTypeAPInfo" %>
<%@ page import="com.actimind.actiplans.administration.LeaveTypeAPInfoImpl" %>
<%@ page import="com.actimind.actitime.Constants" %>
<%@ page import="com.actimind.actitime.util.*" %>

<%@ page errorPage="/actiplans/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<%
    List<LeaveTypeBean> leaveTypeBeans = (List<LeaveTypeBean>) request.getAttribute( Keys.LEAVE_TYPE_LIST_KEY );
    Set<Integer> leaveTypesInUseIds = (Set<Integer>) request.getAttribute( Keys.LEAVE_TYPE_IN_USE_KEY );

    @SuppressWarnings( "Convert2Diamond" )
    List<LeaveTypeAPInfo> leaveTypesInfo = new ArrayList<LeaveTypeAPInfo>();
    for ( LeaveTypeBean bean : leaveTypeBeans ) {
        leaveTypesInfo.add( new LeaveTypeAPInfoImpl( bean, leaveTypesInUseIds.contains( bean.getId() ) ) );
    }

    Features ef = FeaturesUtil.getFeatures();

    int newLeaveTypeDefaultIconId = (Integer) request.getAttribute( Keys.NEW_LEAVE_TYPE_DEFAULT_ICON_ID );
    String showIntegrationIcons = ((Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) && ef.isEnabled(Feature.LVT)) ? Keys.SHOW_INTEGRATION_ICONS : "";

    String hideAffectedBalanceSection = settings.isApPtoBalanceCalculationEnabled() || settings.isApSickBalanceCalculationEnabled() ? "" : "hideAffectedBalanceSection";
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="leave_type.list.title"/></title>
    <jsp:include page="/actiplans/include_scripts.jsp"/>
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" class="with-navigation leave-types-list-page ap <%=hideAffectedBalanceSection%>">
<div id="container" class="<%=showIntegrationIcons%> <%=hideAffectedBalanceSection%> hideUserRatesSections">

    <jsp:include page="../top.jsp" flush="false" />

    <jsp:include page="/administration/leave_type_list_common.jsp"/>

</div>

<p>&nbsp;</p>

<script>
    $( document ).ready(function ( )
                        {
                            var leaveTypesInfo = <%=jsHelper.toJSON(leaveTypesInfo)%>;
                            var newLeaveTypeDefaultIconId = <%=newLeaveTypeDefaultIconId%>;

                            /* Note: if we want to add here some images for leave types interface or parameters for LeaveTypeListPageController common for aT and aP,
                             * we should add them both on this page and on similar in actitime package
                             * */
                            var arrowImagesPaths = { downArrowImagePath: "<at:defImgpath page="leave_types/move-down.png"/>",
                                                     upArrowImagePath: "<at:defImgpath page="leave_types/move-up.png"/>",
                                                     downArrowHoverImagePath: "<at:defImgpath page="leave_types/move-down-hover.png"/>",
                                                     upArrowHoverImagePath: "<at:defImgpath page="leave_types/move-up-hover.png"/>" };

                            var leaveTypeListPageController = new LeaveTypeAPListPageController().init( leaveTypesInfo,
                                                                                                        arrowImagesPaths,
                                                                                                        {  decimalSeparator:       "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
                                                                                                           digitGroupingSymbol:    "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>",
                                                                                                           ptoMaxNumber:           <%=Constants.MAX_PTO_COEFFICIENT%> },
                                                                                                        newLeaveTypeDefaultIconId
                            );

                            leaveTypeListPageController.render();
                            PageOverlayTipsManager.setInstance(new LeaveTypesPageOverlayTipsManager());
                        });
</script>

</body>
</html>