<!doctype html>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%
    String productsIntegrated = (Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) ? Keys.PRODUCTS_INTEGRATED : "";
    String userEmail = AuthController.getLoggedInUser( request ).getEmail();
    boolean userEmailPresent = userEmail != null && !userEmail.equals("");
%>
<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="actiplans.notifications.page_title" /></title>
    <jsp:include page="/actiplans/include_scripts.jsp"/>

    <at:script page='/js/day_time.js'/>
    <at:script page='/js/sections_state_controller.js'/>

    <script language="JavaScript">
        var fieldErrors = {};
        var isUserEmailPresented = <%= userEmailPresent %>;
        var userEmail = '<%=ResponseUtils.filter(userEmail)%>';
        function form()
        {
            return document.forms["NotificationForm"];
        }
        function canSubmit()
        {
            if ( ClientSideErrors.hasErrors() )
            {
                ClientSideErrors.showClientSideErrorMessage();
                sectionsStateController.baseOpenSectionsWithErrors(fieldErrors);
                return false;
            }
            return true;
        }
        function doSubmit()
        {
            if (canSubmit())
            {
                if ( RpcControlManager.isRpcBusy() )
                    RpcControlManager.cleanup();

                ExitConfirmation.disableConfirmationOnUnloadPage();

                $(form()).submit();
            }
        }
        var daysBeforeWaitingLtrToRemindValidator = new IntegerNumbersValidator(1, 366, false, false);
        function checkDaysBeforeWaitingLtrToRemind()
        {
            var field = document.getElementById("daysBeforeWaitingLtrToRemindId");
            if ( daysBeforeWaitingLtrToRemindValidator.checkField(field, false,  "actiplans.notifications.request_approvers.about_waiting.days.invalid",
                                                                            "actiplans.notifications.request_approvers.about_waiting.days.invalid",
                                                                            "actiplans.notifications.request_approvers.about_waiting.days.invalid"))
            {
                ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
            }
        }
        function checkDayTimeToRemindAboutWaitingLtrStr()
        {
            var field = document.getElementById("dayTimeToRemindAboutWaitingLtrStrId");
            var timeValStr = field.value;
            if(isNotEmpty(timeValStr) && DayTime.isDayTimeValid(timeValStr))
            {
                field.value = DayTime.addZerosAndTrimIfNeeded(timeValStr);
                ClientSideErrors.markTextFieldAsValid(field);
                ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
            }
            else
            {
                ClientSideErrors.markTextFieldAsInvalid(field, messageResource.getMessage("actiplans.notifications.request_approvers.about_waiting.day_time.invalid"));
            }
        }
        function checkAdminMailAddress()
        {
            var emailFieldEl = document.getElementById("adminMailAddressId");
            var emailField = ($('#adminMailAddressId'));
            var emailStr = emailField.pVal();

            if (emailStr.length != 0 && !isEmailValid(emailStr))
            {
                ClientSideErrors.markTextFieldAsInvalid(emailFieldEl,
                                                        messageResource.getMessage("actiplans.notifications.error_processing.email.invalid"));
            } else {
                ClientSideErrors.markTextFieldAsValid(emailFieldEl);
                ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
            }
            handleChange(true);
        }
        function getFooterValueForUpdatingLengthNote() {
            return getStringWithUnifiedNewLineSymbol(($('#mailMessageFooterId')).pVal());
        }
        function handleFooterChanges()
        {
            var value = getFooterValueForUpdatingLengthNote();
            if (value != form().mailMessageFooter.defaultValue){
                handleChange(true);
            }
            footerLengthNote.update(value);
            checkMailMessageFooter();
        }

        function handleFooterOnBlur(footerEl) {
            var value = getFooterValueForUpdatingLengthNote();
            if(value.length>0 && trim(value).length === 0) {
                $(footerEl).pVal('');
            }
            handleFooterChanges();
        }

        function handleMailSubjectChanges(mailSubjectEl) {
            mailSubjectEl.value = trim(mailSubjectEl.value);
        }

        function checkMailMessageFooter()
        {
            var textElement = document.getElementById("mailMessageFooterFieldLabel");
            var footerFieldEl = document.getElementById("mailMessageFooterId");
            var errorClassName = isChrome() ? "input-field-error" : null; //a workaround for jumping text inside textarea
            // in Chrome when error occurs.
            if( footerLengthNote.getTextLength() > footerLengthNote.maxValue )
            {
                var errorMessage = messageResource.getMessage("actiplans.notifications.message_parameters.footer.too_long",
                                                              [ footerLengthNote.maxValue, footerLengthNote.getTextLength() ] );
                ClientSideErrors.markTextFieldAsInvalid(footerFieldEl, errorMessage, errorClassName);
                ClientSideErrors.markFieldLabelsAsInvalid( textElement, errorMessage );
            }
            else
            {
                ClientSideErrors.markTextFieldAsValid(footerFieldEl, errorClassName);
                ClientSideErrors.markFieldLabelsAsValid( textElement );
                ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
            }
        }
        function onLoad()
        {
            confirmDlg = new ConfirmExitDlg(400, messageResource.getMessage("actiplans.notifications.modification_not_finished_warning"),
                                            messageResource.getMessage("actiplans.notifications.cancel_modification_confirm"),
                                            messageResource.getMessage("common.buttons.save_changes"),
                                            messageResource.getMessage("common.buttons.discard_changes"),
                                            messageResource.getMessage("common.buttons.remain_on_page"));

            sectionsStateController = new SectionsStateController().init( "notificationsSettingsSections" );
            sectionsStateController.loadSectionsStateFromCookies();

            registerChangeable();

            initFooterLengthNote();
            initResendRemindersNowButton();
            enableOrDisableSendTestMessageButton();

            <logic:messagesPresent property="adminMailAddress">
                ClientSideErrors.paintElementAsInvalid(form().adminMailAddress, messageResource.getMessage("actiplans.notifications.error_processing.email.invalid"));
            </logic:messagesPresent>

            ExitConfirmation.setUpBaseExitConfirmation( "actiplans.notifications.exit_confirmation", false );
        }

        function initFooterLengthNote() {
            footerLengthNote = new TextAreaLengthNote('mailFooter', 'Message footer', 2000);
            footerLengthNote.setTextLengthCounter( footerLengthNote.fullCounter );
            footerLengthNote.update( getFooterValueForUpdatingLengthNote() );
            footerLengthNote.show();
        }
        function initResendRemindersNowButton() {
            var createResendButton = new GraphicButton( GraphicButton.getRoundedBox('resendRemindersNowDiv',
                                                                                      messageResource.getMessage('actiplans.notifications.request_approvers.resend_button.text') ));
            createResendButton.defineStandardEventHandlers(true, true, true, true);
            createResendButton.button.el.on("click", resendRemindersNow);
        }

        function resendRemindersNow() {
            var button = document.getElementById("resendRemindersNowDiv");
            var note = document.getElementById("resendRemindersNow_progress_note");

            var manager = new SendNotificationsNowButtonStatesController(button, note, "<%=jsMessage(request, "actiplans.notifications.request_approvers.resend_button.success_message")%>");
            var states = manager.getStates();
            manager.setState(states.sending);
            makeRpcCall( "ResendRemindersNowService.resendRemindersNow",
                            [],
                            function () {
                                    manager.setState(states.success);
                            },
                            function (jqXHR, textStatus, errorThrown) {
                                if (textStatus == 'timeout')
                                    manager.setState(states.timeout);
                                else
                                    manager.setState(states.error);
                            });
        }

        function registerChangeable()
        {
            var form = document.getElementById("notificationsForm");
            registerChangeableControl(form.notifyApproversOnLtrCreated);
            registerChangeableControl(form.notifyApproversOnLtrModified);
            registerChangeableControl(form.notifyApproversOnLtrDeleted);
            registerChangeableControl(form.notifyApproversOnLtrStatusChanged);
            registerChangeableControl(form.remindApproversAboutWaitingLtr);
            registerChangeableControl(form.daysBeforeWaitingLtrToRemind);
            registerChangeableControl(form.dayTimeToRemindAboutWaitingLtrStr);
            registerChangeableControl(form.notifyUsersOnLtrChanged);
            registerChangeableControl(form.notifyUsersOnLtrCreatedOrDeleted);
            registerChangeableControl(form.mailSubjectPrefix);

            registerFormChangedHandlers(true);

            setSubmitHandler(doSubmit);
        }
        function enableOrDisableSendTestMessageButton()
        {
            var button = document.getElementById("sendTestMessage_button");
            if(isUserEmailPresented)
                button.disabled = undefined;
            else
                button.disabled = true;
        }
        function sendTestMessage()
        {
            var button = document.getElementById("sendTestMessage_button");
            var icon = document.getElementById("sendTestMessage_icon");
            var note = document.getElementById("sendTestMessage_note");
            var aForm = form();
            var statesManager = new SendTestMessageButtonStatesController(button, icon, note, userEmail, undefined, atImgPath("note_mark.gif"));
            var states = statesManager.getStates();
            statesManager.setState(states.sending);
            var subjectPrefixValue = getPropertyValue(aForm.mailSubjectPrefix, "value");
            var footerValue = isNotEmpty(($('#mailMessageFooterId')).pVal()) ? aForm.mailMessageFooter.value : "";
            makeRpcCall( "BaseSendTestMailService.sendTestMessageInOnline",
                            [ subjectPrefixValue ? subjectPrefixValue : "", footerValue ],
                            function (result) {
                                if (result.success)
                                    statesManager.setState(states.success, result.sentTo);
                                else
                                    statesManager.setState(states.error, result.sentTo);
                            },
                            function (jqXHR, textStatus, errorThrown) {
                                var additionalMessage = (errorThrown.exceptionClass =='javax.mail.SendFailedException') ?
                                                        ". " + messageResource.getMessage( "actiplans.notifications.message_parameters.send_button.email_error_message") : "";
                                if (textStatus == 'rpc_customException')
                                {
                                    statesManager.setState( states.error, errorThrown.email, errorThrown.message, additionalMessage );
                                    return true;
                                }
                                else
                                    statesManager.setState(states.error);
                            });
        }
    </script>

</head>
<body onload="onLoad()" class="settings gen_setting emailNotifications with-navigation">
<div id="container">

    <jsp:include page="../top.jsp" flush="false"/>

    <html:form action="/administration/notifications.do" method="post" styleId="notificationsForm" onsubmit="return canSubmit();">
    <html:hidden property="redirectUrl"/>
    <html:hidden property="formDataModified"/>
    <html:hidden property="afterReloginUrl"/>
    <html:hidden property="beforeReloginUsername"/>
    <table cellpadding="0" cellspacing="0" border="0" width="800" align="center">
        <tr>
            <td align="left" class="mainContentPadding rightPadding <%=productsIntegrated%>">

                <div>
                    <table width="100%" cellspacing="0" cellpadding="0" valign="top" border="0">
                        <tr width="100%">
                            <td class="pagetitle"><bean:message key="actiplans.notifications.page_title" /></td>
                            <td align="right"><%@include file="/form_modified_div.jsp" %></td>
                        </tr>
                    </table>
                </div>

                <div height="10" style="padding-left:20px; padding-top: 10px;">
                    <%@include file="/messages.jsp"%>
                    <div id="ClientSideErrorMessage" style="display:none; padding-top:8px;">
                        <bean:define id="details" value="saving email notifications settings" toScope="request"/>
                        <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
                    </div>
                </div>

                <%--  Notifications for Request Approvers block --%>

                <div class="collapsibleGroupHeaderBlock">
                    <div class="showCollapsibleBlockButton" id="requestApproversBlockButton"></div>
                    <div class="collapsibleGroupHeader"><bean:message key="actiplans.notifications.request_approvers.section_title"/></div>
                </div>

                <div class="collapsibleBlock" id="requestApproversBlock">
                    <div class="collapsibleBlockContent">
                        <table id="requestApproversBlockTable" cellpadding="0" cellspacing="0">
                            <tr>
                                <td class="sectionLabel">
                                    <span><bean:message key="actiplans.notifications.request_approvers.notify_on_requests_changes.label"/></span>
                                </td>
                            </tr>
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="notifyApproversOnLtrCreated" styleId="notifyNewLtrId"/></td>
                                            <td><label for="notifyNewLtrId"><bean:message key="actiplans.notifications.request_approvers.on_new.label"/></label></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="notifyApproversOnLtrModified" styleId="notifyModifiedLtrId"/></td>
                                            <td><label for="notifyModifiedLtrId"><bean:message key="actiplans.notifications.request_approvers.on_modified.label"/></label></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="notifyApproversOnLtrDeleted" styleId="notifyDeletedLtrId"/></td>
                                            <td><label for="notifyDeletedLtrId"><bean:message key="actiplans.notifications.request_approvers.on_deleted.label"/></label></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="notifyApproversOnLtrStatusChanged" styleId="notifyStatusChangedLtrId"/></td>
                                            <td><label for="notifyStatusChangedLtrId"><bean:message key="actiplans.notifications.request_approvers.on_status_changed.label"/></label></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td class="sectionLabel">
                                    <span><bean:message key="actiplans.notifications.request_approvers.about_waiting.label"/></span>
                                </td>
                            </tr>
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="remindApproversAboutWaitingLtr" styleId="notifyWaitingLtrId"/></td>
                                            <td><label for="notifyWaitingLtrId"><bean:message key="actiplans.notifications.request_approvers.about_waiting.send"/></label></td>
                                            <td><html:text property="daysBeforeWaitingLtrToRemind" styleId="daysBeforeWaitingLtrToRemindId" maxlength="3" style="width: 25px; text-align: right;" onchange="checkDaysBeforeWaitingLtrToRemind();"/></td>
                                            <td><span><bean:message key="actiplans.notifications.request_approvers.about_waiting.days"/></span></td>
                                            <td><html:text property="dayTimeToRemindAboutWaitingLtrStr" style="width: 70px;" styleId="dayTimeToRemindAboutWaitingLtrStrId" onchange="checkDayTimeToRemindAboutWaitingLtrStr();" maxlength="8"/></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                        </table>
                        <table>
                            <tr>
                                <td style="padding-left: 29px;">
                                    <div id="resendRemindersNowDiv"><!--Place for rendering "Resend Reminders Now" button--></div>
                                </td>
                                <td style="padding-left: 10px;">
                                    <div id="resendRemindersNow_progress_note">&nbsp;</div>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>

                <%--  Notifications for Regular Users block --%>

                <div class="collapsibleGroupHeaderBlock">
                    <div class="showCollapsibleBlockButton" id="regularUsersBlockButton"></div>
                    <div class="collapsibleGroupHeader"><bean:message key="actiplans.notifications.regular_users.section_title"/></div>
                </div>

                <div class="collapsibleBlock" id="regularUsersBlock">
                    <div class="collapsibleBlockContent">
                        <table id="regularUsersBlockTable" cellpadding="0" cellspacing="0">
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="notifyUsersOnLtrChanged" styleId="notifyConsideredLtrId"/></td>
                                            <td><label for="notifyConsideredLtrId"><bean:message key="actiplans.notifications.regular_users.on_changed_status.label"/></label></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr>
                                <td class="rule">
                                    <table>
                                        <tr>
                                            <td><html:checkbox property="notifyUsersOnLtrCreatedOrDeleted" styleId="notifyCreatedOrDeletedLtrId"/></td>
                                            <td><label for="notifyCreatedOrDeletedLtrId"><bean:message key="actiplans.notifications.regular_users.on_new_or_deleted.label"/></label></td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>

                <%--  Message Parameters block --%>

                <div class="collapsibleGroupHeaderBlock">
                    <div class="showCollapsibleBlockButton" id="messageParametersBlockButton"></div>
                    <div class="collapsibleGroupHeader"><bean:message key="actiplans.notifications.message_parameters.section_title"/></div>
                </div>

                <div class="collapsibleBlock" id="messageParametersBlock">
                    <div class="collapsibleBlockContent">
                        <table cellpadding="0" cellspacing="0" border="0">
                            <tr>
                                <td class="formfieldtitle">
                                    <span><bean:message key="actiplans.notifications.message_parameters.add_prefix.label"/>:</span>
                                </td>
                                <td align="right" style="padding-left: 8px; width: 280px;">
                                    <html:text property="mailSubjectPrefix" onblur="handleMailSubjectChanges(this)" maxlength="100" style="width: 270px; min-width: 280px;"/>
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2" class="textAreaLabel">
                                    <span id="mailMessageFooterFieldLabel"><bean:message key="actiplans.notifications.message_parameters.footer.label"/>:</span>
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2">
                                    <html:textarea property="mailMessageFooter" styleId="mailMessageFooterId"  onkeyup="handleFooterChanges()" onblur="handleFooterOnBlur(this)" style="overflow:auto;font-family: Arial, sans-serif; font-weight: normal;font-size: 12px;width: 670px; height: 75px"/>
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2" style="padding-top: 5px; padding-bottom: 10px;"><jsp:include page="/textarea_length_note.jsp">
                                    <jsp:param name="note_id" value="mailFooter"/>
                                    <jsp:param name="note_name" value="Message footer"/>
                                    <jsp:param name="use_coloured_img" value="true"/>
                                </jsp:include></td>
                            </tr>
                            <jsp:include page="/administration/settings_test_message_button_row.jsp" />
                        </table>
                    </div>
                </div>

                <%--  Error Processing block --%>

                <div class="collapsibleGroupHeaderBlock">
                    <div class="showCollapsibleBlockButton" id="errorProcessingBlockButton"></div>
                    <div class="collapsibleGroupHeader">
                        <span class="settingsGroupTitle"><bean:message key="actiplans.notifications.error_processing.section_title"/></span>
                        <span class="sharedSettingsImage sharedImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
                    </div>
                </div>

                <div class="collapsibleBlock" id="errorProcessingBlock">
                    <div class="collapsibleBlockContent">
                        <table cellpadding="0" cellspacing="0" border="0">
                            <tr>
                                <td class="textAreaLabel">
                                    <span><bean:message key="actiplans.notifications.error_processing.email.label"/>:</span>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <html:text property="adminMailAddress" styleId="adminMailAddressId" onchange="checkAdminMailAddress();" onkeyup="handleChange();" style="width: 280px;" maxlength="255"/>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>

                <%--  Save button --%>

                <div class="formbuttonpane" id="ButtonPane">
                    <input type="button" class="saveButton" id="saveSettingsButton" onclick="doSubmit();" value="<bean:message key="actiplans.notifications.save_settings"/>">
                </div>

            </td>
        </tr>
    </table>
    <input type="hidden" value="1" name="submitted">
    </html:form>

    <jsp:include page="/form_changed_confirm.jsp"/>

</div>

    <script>
        //JS START POINT
        $( document ).ready(function ( )
                            {
                            var footerPlaceHolderText = messageResource.getMessage("actiplans.notifications.message_parameters.footer.placeholder");
                            var emailPlaceHolderText = messageResource.getMessage("actiplans.notifications.error_processing.email.placeholder");
                            $("#mailMessageFooterId").attr('placeholder', footerPlaceHolderText).placeholder();
                            $("#adminMailAddressId").attr('placeholder', emailPlaceHolderText).placeholder();
                                PageOverlayTipsManager.setInstance(new EmailNotificationsPageOverlayTipsManager());
                            });
    </script>

</body>
</html>
