<!doctype html>
<%@ page import="com.actimind.actiplans.administration.ColleaguesVisibility" %>
<%@ page import="com.actimind.actitime.administration.ATNamings" %>
<%@ page import="com.actimind.actitime.resources.SystemSettings" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="java.util.Calendar" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actiplans.pastleaves.PastLeaveRequestsProcessType" %>
<%@ page errorPage="/actiplans/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<bean:define id="form" name="GeneralSettingsForm" type="com.actimind.actiplans.administration.GeneralSettingsForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="settingsData" name="<%=Keys.GENERAL_SETTINGS_DATA_KEY%>" type="com.actimind.common.administration.BaseGeneralSettingsAction.GeneralSettingsData"/>
<%
    Boolean isProductsIntegrated = (Boolean) request.getAttribute(Keys.PRODUCTS_INTEGRATED);
    Boolean wereProductsIntegrated = (Boolean) request.getAttribute(Keys.PRODUCTS_WERE_INTEGRATED);
    String productsIntegrated = isProductsIntegrated ? Keys.PRODUCTS_INTEGRATED : "";
    String groupsSynchronized = (Boolean) request.getAttribute( Keys.GROUPS_SYNCHRONIZED ) ? Keys.GROUPS_SYNCHRONIZED : "";
    String ptoFeatureIsEnabledInAt = FeaturesUtil.isEnabled(Feature.PTO) ? "ptoSynchronized" : "";
%>
<html>
    <head>
        <jsp:include page="/actiplans/include_scripts.jsp"/>
        <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="general_settings.page_title" /></title>

        <at:script page='/js/day_time.js'/>
        <at:script page="/js/controls/LabelController.js"/>

        <at:script page='/js/settings_util.js'/>
        <at:script page='/actiplans/js/administration/settings.js'/>
        <at:script page='/js/customizable_field.js'/>
        <at:script page='/js/base_settings.js'/>
        <at:script page='/js/sections_state_controller.js'/>

        <jsp:include page='/util/google_api_place_script.jsp'/>

        <script language="JavaScript">

            PageOverlayTipsManager.setInstance(new SettingsPageOverlayTipsManager());

            function openSectionsWithErrors()
            {
                if (workdayDurationsEditor.hasErrors())
                    sectionsStateController.showBlock("scheduleBlock");
                baseOpenSectionsWithErrors();
            }

            function onNumberFormatChange()
            {
                var separator = decimalSeparatorField.getValue();
                var digitGroupingSymbol = digitGroupingSymbolField.getValue();

                if (separator == "")
                    return;

                updateFormatPreview();

                SystemSettings.decimalSeparator = separator;
                SystemSettings.digitGroupingSymbol = digitGroupingSymbol;
                updateWorkdayDurationsEditorTooltip();
                updateWorkdayDurationsLabelErrorState();

                if(ptoRulesEditor) {
                    ptoRulesEditor.updateDecimalSeparator();
                    ptoRulesEditor.updateDigitGroupingSymbol();
                }
                if(sickRulesEditor) {
                    sickRulesEditor.updateDecimalSeparator();
                    sickRulesEditor.updateDigitGroupingSymbol();
                }


                validateWorkdayDuration();
            }

            function beforeSubmit() {}
            
            settingsClosure = apSettingsClosure(
                    {
                        decimalSeparatorField: <%=com.actimind.actitime.util.StringUtils.getJSStringValue(form.getDecimalSeparator().getValue())%>,
                        digitGroupingSymbolField: <%=StringUtils.getJSStringValue(form.getDigitGroupingSymbol().getValue())%>,
                        isEnabledGroups: <%=form.isUserGroupsEnabled()%>,
                        isEnabledTZGroups: <%=form.isTimeZoneGroupsEnabled()%>,
                        defaultTZGroupCityName: "<%=form.getDefaultTZGroupCityName()%>",
                        defaultTZGroupTimeZoneId: "<%=form.getDefaultTZGroupTimeZoneId()%>",
                        defaultTZGroupTimeZoneOffset: '<%=settingsData.getOffsetInSecondsOfDefaultTimeZone()%>',
                        defaultTZGroupCurrentTime: '<%=settingsData.getCurrentTimeOfDefaultTZGroup()%>',
                        isPtoEnabled: <%=form.isPtoEnabled()%>,
                        isSickBalanceEnabled: <%=form.isSickEnabled()%>,
                        wdDurations: <%=jsHelper.toJSON( form.getDefaultWorkScheduleArray() )%>,
                        wdWeekStartDay: <%=String.valueOf( form.getWeekStartDay() )%>,
                        isPtoAccrualRuleEnabled: <%=form.isPtoAccrualRuleEnabled()%>,
                        ptoAccrualRuleValue: <%=form.getPtoAccrualRuleValue()%>,
                        ptoAccrualRuleFrequencyTypeName: "<%=form.getPtoAccrualRuleFrequencyTypeName()%>",
                        ptoAccrualRuleParameters: [<%=form.getPtoAccrualRuleParameters()%>],
                        isPtoResetRuleEnabled: <%=form.isPtoResetRuleEnabled()%>,
                        ptoResetRuleValue: <%=form.getPtoResetRuleValue()%>,
                        ptoResetRuleFrequencyTypeName: "<%=form.getPtoResetRuleFrequencyTypeName()%>",
                        ptoResetRuleParameters: [<%=form.getPtoResetRuleParameters()%>],
                        isPtoCapRuleEnabled: <%=form.isPtoCapRuleEnabled()%>,
                        ptoCapRuleValue: <%=form.getPtoCapRuleValue()%>,
                        workdayDuration: <%=form.getWorkdayDuration()%>,
                        isPtoShowInHours: <%=form.isPtoShowInHours()%>,
                        isSickAccrualRuleEnabled: <%=form.isSickAccrualRuleEnabled()%>,
                        sickAccrualRuleValue: <%=form.getSickAccrualRuleValue()%>,
                        sickAccrualRuleFrequencyTypeName: "<%=form.getSickAccrualRuleFrequencyTypeName()%>",
                        sickAccrualRuleParameters: [<%=form.getSickAccrualRuleParameters()%>],
                        isSickResetRuleEnabled: <%=form.isSickResetRuleEnabled()%>,
                        sickResetRuleValue: <%=form.getSickResetRuleValue()%>,
                        sickResetRuleFrequencyTypeName: "<%=form.getSickResetRuleFrequencyTypeName()%>",
                        sickResetRuleParameters: [<%=form.getSickResetRuleParameters()%>],
                        isSickCapRuleEnabled: <%=form.isSickCapRuleEnabled()%>,
                        sickCapRuleValue: <%=form.getSickCapRuleValue()%>,
                        isSickShowInHours: <%=form.isSickShowInHours()%>,
                        images: ['<at:imgpath page="sending-progress.gif"/>', '<at:imgpath page="success.gif"/>', '<at:imgpath page="error.gif"/>']
                    });

        </script>

        <!--[if IE 8]>
        <style type="text/css">
            .modificationsInfo:before, .modificationsInfo:after {
                display: none;
            }
        </style>
        <![endif]-->

    </head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      onload="settingsClosure.onLoadHandler()"
      class="settings gen_setting with-navigation">
<div id="container">

<jsp:include page="../top.jsp" flush="false"/>

<html:form action="/administration/settings.do" method="post" styleId="settingsForm" onsubmit="return settingsClosure.canSubmit();">
<html:hidden property="redirectUrl"/>
<html:hidden property="formDataModified"/>
<html:hidden property="afterReloginUrl"/>
<html:hidden property="beforeReloginUsername"/>
<table cellpadding="0" cellspacing="0" border="0" width="800" align="center">
<tr>
<td align="left" class="mainContentPadding rightPadding <%=productsIntegrated%>">

<div>
    <table width="100%" cellspacing="0" cellpadding="0" valign="top" border="0">
        <tr width="100%">
            <td class="pagetitle"><bean:message key="general_settings.page_title" /></td>
            <td align="right"><%@include file="/form_modified_div.jsp" %></td>
        </tr>
    </table>
</div>

<div height="10" style="padding-left:20px; padding-top: 10px;">
    <%@include file="/messages.jsp"%>
    <div id="ClientSideErrorMessage" style="display:none; padding-top:8px;">
        <bean:define id="details" value="saving general settings" toScope="request"/>
        <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
    </div>
</div>

<div id="collapseMenuBlock" class="collapseMenuBlock" style="visibility: hidden">
    <div id="collapseAllButton" class="collapseButton">
        <span class="text"><bean:message key="general_settings.collapse_all"/></span>
        <at:img page="collapse_all.png" styleClass="collapseDescription"/>
    </div>
    <div id="expandAllButton" class="collapseButton">
        <span class="text"><bean:message key="general_settings.expand_all"/></span>
        <at:img page="expand_all.png" styleClass="expandDescription"/>
    </div>
</div>

<%-- User Groups block --%>

<div class="collapsibleGroupHeaderBlock <%=groupsSynchronized%>" id="userGroupsSettingsHeaderBlock">
    <div class="showCollapsibleBlockButton" id="userGroupsSettingsBlockButton"></div>
    <div class="collapsibleGroupHeader">
        <span class="settingsGroupTitle"><bean:message key="actiplans.general_settings.user_groups.user_groups" /></span>
        <span id="sharedGroupsSettings" class="sharedGroupsSettingsImage sharedImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        <span class="toggleButtons" style="display: none;"><%-- buttons placeholder --%></span>
    </div>
</div>

<div class="collapsibleBlock" id="userGroupsSettingsBlock">

    <table cellpadding="0" cellspacing="0" border="0" class="collapsibleBlockContent">
        <tr class="switcherRow">
            <td class="formfieldtitle formFieldCaption tableLabel">
                <bean:message key="actiplans.general_settings.user_groups.join_users_into_groups" />
            </td>
            <td colspan="2">
                <div id="userGroupsSwitcher"></div>
                <html:hidden property="userGroupsEnabled"/>
            </td>
        </tr>
        <tr id="userGroupNamingSection" class="formfieldtitle">
            <td class="formfieldtitle formFieldCaption" id="userGroupsNamingLabel"><bean:message key="actiplans.general_settings.user_groups.name_user_groups_as" />:</td>
            <td class="levelCodeSelect">
                <html:select property="userGroupNamingCode" styleId="userGroupNamingCodeSelect">
                    <html:option
                            value="<%= Integer.toString(ATNamings.CUSTOM_LEVEL_NAMING_CODE) %>">
                        <bean:message key="hierarchy_levels.custom_level"/>
                    </html:option>
                    <html:optionsCollection property="userGroupNamingList"
                                            label="singularForm"
                                            value="code"/>
                </html:select>
            </td>
            <td>
               <table cellpadding="0" cellspacing="0" id="customUserGroupNaming" style="display: none;">
                   <tr>
                       <td class="customNamingArrow">
                           <at:defImg page="settings/arrow.png"/>
                       </td>
                       <td>
                           <html:text property="userGroupNamingSingularForm" styleId="userGroupNamingSingularFormId" maxlength="20"/>
                           <script>
                               userGroupNamingSingularFormController = createFieldController(
                                       "userGroupNamingSingularFormId",
                                       messageResource.getMessage( "general_settings.naming.user_groups.singular_form_placeholder" )
                               );
                           </script>
                       </td>
                       <td class="namingPluralForm">
                           <html:text property="userGroupNamingPluralForm" styleId="userGroupNamingPluralFormId" maxlength="22"/>
                           <script>
                               userGroupNamingPluralFormController = createFieldController(
                                       "userGroupNamingPluralFormId",
                                       messageResource.getMessage( "general_settings.naming.user_groups.plural_form_placeholder" )
                               );
                           </script>
                       </td>
                   </tr>
               </table>
            </td>
        </tr>
    </table>
</div>

<%-- Time Zone & Calendar Setting block --%>

<div class="collapsibleGroupHeaderBlock ">
    <div class="showCollapsibleBlockButton" id="dateTimeSettingsBlockButton"></div>
    <div class="collapsibleGroupHeader">
        <span class="settingsGroupTitle"><bean:message key="actiplans.general_settings.calendar.section_title"/></span>
        <span class="sharedSettingsImage sharedImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
    </div>
</div>

<div class="collapsibleBlock" id="dateTimeSettingsBlock">
    <div class="collapsibleBlockContent narrow">
        <div class="formfieldtitle formFieldCaption switcherLabel">
            <bean:message key="actiplans.general_settings.calendar.time_zone_switcher_lable"/>
        </div>
        <div id="tzGroupSwitcher" class="switcher"></div>
        <html:hidden property="timeZoneGroupsEnabled"/>
    </div>
    <table cellpadding="0" cellspacing="0" border="0" class="collapsibleBlockContent">
        <jsp:include page="../../administration/time_zone_groups_block.jsp"/>
        <tr>
            <td class="formfieldtitle formFieldCaption"><bean:message key="general_settings.date_time.calendar_layout"/></td>
            <td>
                <html:select property="weekStartDay" styleId="weekStartDaySelect">
                    <%
                        // Starting from sunday add option for each day
                        for(int weekDay = Calendar.SUNDAY; weekDay <= Calendar.SATURDAY; weekDay++){
                    %>
                    <html:option value="<%=String.valueOf(weekDay)%>"><%=message( request, "general_settings.date_time.week_starts_on", message( request, TimeUtils.getDayOfWeekFullNameKey( weekDay ) ))%></html:option>
                    <%
                        }
                    %>
                </html:select>
            </td>
        </tr>
    </table>
</div>
    
<%-- PTO & Sick block --%>

<div class="collapsibleGroupHeaderBlock <%=ptoFeatureIsEnabledInAt%>"  id="ptoSettingsHeaderBlock">
    <div class="showCollapsibleBlockButton" id="ptoAndSickBlockSectionButton"></div>
    <div class="collapsibleGroupHeader">
        <span class="settingsGroupTitle"><bean:message key="general_settings.pto_sick_section.label"/></span>
        <span class="sharedPtoSettingsImage sharedImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        <span class="toggleButtons" style="display: none;"><%-- buttons placeholder --%></span>
    </div>
</div>

<div class="collapsibleBlock" id="ptoAndSickBlockSection">
    <div class="collapsibleBlockContent narrow">
        <div class="formfieldtitle formFieldCaption switcherLabel">
            <bean:message key="actiplans.general_settings.pto_switcher_label"/>
        </div>
        <div id="ptoSwitcher" class="switcher"></div>
        <html:hidden property="ptoEnabled"/>
    </div>
    <jsp:include page="/administration/balance_settings_block.jsp">
        <jsp:param name="leaveTypeBalanceTypePrefix" value="pto"/>
        <jsp:param name="numberOfUsersWithDefaultBalanceSettings" value="<%=settingsData.getNumberOfUsersWithDefaultPTOSettings()%>"/>
        <jsp:param name="balanceTypeKeyMessage" value="general_settings.pto_section_key"/>
        <jsp:param name="className" value="innerBlock"/>
    </jsp:include>

    <div class="collapsibleBlockContent narrow">
        <div class="formfieldtitle formFieldCaption switcherLabel">
            <bean:message key="actiplans.general_settings.sick_switcher_label"/>
        </div>
        <div id="sickSwitcher" class="switcher"></div>
        <html:hidden property="sickEnabled"/>
    </div>
    <jsp:include page="/administration/balance_settings_block.jsp">
        <jsp:param name="leaveTypeBalanceTypePrefix" value="sick"/>
        <jsp:param name="numberOfUsersWithDefaultBalanceSettings"
                   value="<%=settingsData.getNumberOfUsersWithDefaultSDBSettings()%>"/>
        <jsp:param name="balanceTypeKeyMessage" value="general_settings.sick_section_key"/>
        <jsp:param name="className" value="innerBlock"/>
    </jsp:include>
</div>
    
    
<%-- Corporate Work Schedule --%>

<div class="collapsibleGroupHeaderBlock">
    <div class="showCollapsibleBlockButton" id="scheduleBlockButton"></div>
    <div class="collapsibleGroupHeader">
        <span class="settingsGroupTitle"><bean:message key="actiplans.general_settings.work_schedule.section_title"/></span>
        <span class="sharedSettingsImage sharedImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
    </div>
</div>
<div class="collapsibleBlock" id="scheduleBlock">
    <div class="collapsibleBlockContent">
        <jsp:include page="/administration/work_schedule_settings_block_content.jsp">
            <jsp:param name="numberOfUsersWithDefaultSchedule" value="<%=settingsData.getNumberOfUsersWithDefaultSchedule()%>"/>
        </jsp:include>
    </div>
</div>


<%-- Visibility of Personal Work Schedules block --%>
<div id="colleaguesVisibilityBlock">
    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="personalSchedulesVisibilityBlockButton"></div>
        <div class="collapsibleGroupHeader"><bean:message key="actiplans.general_settings.my_schedule_visibility.section_title"/></div>
    </div>

    <div class="collapsibleBlock" id="personalSchedulesVisibilityBlock">
        <div class="collapsibleBlockContent">
            <span class="sectionLabel"><bean:message key="actiplans.general_settings.my_schedule_visibility.allow_users_to_see_colleagues_schedule"/></span>
            <table cellpadding="0" cellspacing="0">
                <tr>
                    <td><html:radio property="colleaguesVisibility" value="<%=ColleaguesVisibility.ALL_USERS.name()%>" styleId="myScheduleVisibility_all"/></td>
                    <td><label for="myScheduleVisibility_all"><bean:message key="actiplans.general_settings.my_schedule_visibility.show_all_users"/></label></td>
                </tr>
                <tr id="colleaguesUserGroupsVisibility">
                    <td><html:radio property="colleaguesVisibility" value="<%=ColleaguesVisibility.USER_GROUP_ONLY.name()%>" styleId="myScheduleVisibility_userGroup"/></td>
                    <td><label for="myScheduleVisibility_userGroup"><bean:message key="actiplans.general_settings.my_schedule_visibility.show_only_colleagues_from_user_group"/></label></td>
                </tr>
                <tr id="colleaguesTimeZoneGroupsVisibility">
                    <td><html:radio property="colleaguesVisibility" value="<%=ColleaguesVisibility.TIME_ZONE_GROUP_ONLY.name()%>" styleId="myScheduleVisibility_timeZoneGroup"/></td>
                    <td><label for="myScheduleVisibility_timeZoneGroup"><bean:message key="actiplans.general_settings.my_schedule_visibility.show_only_colleagues_from_tz_group"/></label></td>
                </tr>
            </table>
        </div>
    </div>
</div>



<%-- LTM Access block --%>

<div class="collapsibleGroupHeaderBlock">
    <div class="showCollapsibleBlockButton" id="ltmAccessBlockButton"></div>
    <div class="collapsibleGroupHeader"><bean:message key="actiplans.general_settings.ltm_access.section_title"/></div>
</div>


<div class="collapsibleBlock" id="ltmAccessBlock">
    <div class="collapsibleBlockContent">

        <% if (!wereProductsIntegrated) { %>
            <table id="canEditRequestsInPast" cellpadding="0" cellspacing="0">
                <tr>
                    <td><html:checkbox property="userCanEditRequestsInPast" styleId="userCanEditRequestsInPastId"/></td>
                    <td><label for="userCanEditRequestsInPastId"><bean:message key="actiplans.general_settings.edit_requests_in_past"/></label></td>
                </tr>
            </table>
        <% } %>
        <span class="sectionsLabel"><bean:message key="actiplans.general_settings.ltm_access.define_what_ltm_can_do"/></span>
        <table id="ltmAccessBlockTable" cellpadding="0" cellspacing="0">
            <tr>
                <td><html:checkbox property="ltmCanSeeAutoApproved" styleId="showAutoApprovedId"/></td>
                <td><label for="showAutoApprovedId"><bean:message key="actiplans.general_settings.ltm_access.show_auto_approved"/></label></td>
            </tr>
            <tr>
                <td><html:checkbox property="ltmCanManageAutoApproved" styleId="ltmCanManageAutoApprovedId"/></td>
                <td><label for="ltmCanManageAutoApprovedId"><bean:message key="actiplans.general_settings.ltm_access.manage_auto_approved"/></label></td>
            </tr>
            <tr>
                <td><html:checkbox property="ltmCanSeeAllRequests" styleId="showUsersAssignedToAnotherLTMId"/></td>
                <td><label for="showUsersAssignedToAnotherLTMId"><bean:message key="actiplans.general_settings.ltm_access.show_other_requests"/></label></td>
            </tr>
        </table>

        <% if (wereProductsIntegrated) { %>
        <div class="processLeaveRequestsLabel"><bean:message key="actiplans.general_settings.ltm_access.past_leaves_title"/></div>
        <table id="processLeaveRequestsBlockTable" cellpadding="0" cellspacing="0">
            <tr>
                <td><html:radio property="pastLeaveRequestsProcessType" value="<%=PastLeaveRequestsProcessType.AUTOMATICALLY_APPROVE_PAST_LEAVES.name()%>" styleId="autoApprovePastLeaves"/></td>
                <td><label for="autoApprovePastLeaves"><bean:message key="actiplans.general_settings.ltm_access.approve_past_leaves"/></label></td>
            </tr>
            <tr>
                <td><html:radio property="pastLeaveRequestsProcessType" value="<%=PastLeaveRequestsProcessType.AUTOMATICALLY_REJECT_PAST_LEAVES.name()%>" styleId="autoRejectPastLeaves"/></td>
                <td><label for="autoRejectPastLeaves"><bean:message key="actiplans.general_settings.ltm_access.reject_past_leaves"/></label></td>
            </tr>
        </table>
        <% } %>
    </div>
</div>

<%-- Formats block --%>
<div class="collapsibleGroupHeaderBlock">
    <div class="showCollapsibleBlockButton" id="formatsSettingsBlockButton"></div>
    <div class="collapsibleGroupHeader">
        <span class="settingsGroupTitle"><bean:message key="actiplans.general_settings.formats.section_title"/></span>
        <span class="sharedSettingsImage sharedImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
    </div>
</div>

<div class="collapsibleBlock" id="formatsSettingsBlock">

    <table cellpadding="0" cellspacing="0" border="0" width="100%" class="collapsibleBlockContent">
        <tr>
            <td class="formfieldtitle formFieldCaption"><span id="decimalSeparatorFieldLabel"><bean:message key="general_settings.decimal_symbol"/>:</span></td>
            <td width="102px">
                <div class="markingDivForSelect">
                    <html:select property="decimalSeparator.predefined" styleId="decimalSeparatorFieldPredefined"
                                 onchange="decimalSeparatorField.validateField(); onCustomFieldsChange();" >
                        <html:option value="."><bean:message key="general_settings.formats.dot"/></html:option>
                        <html:option value=","><bean:message key="general_settings.formats.comma"/></html:option>
                        <html:option value="<%=SystemSettings.CUSTOM_VALUE_STRING%>"><bean:message key="general_settings.formats.custom"/></html:option>
                    </html:select>
                </div>
            </td>
            <td style="padding:0" width="107px">
                <span><html:text size="1" maxlength="1" style="display:none" property="decimalSeparator.custom"
                                 styleId="decimalSeparatorFieldCustom" styleClass="customValue"
                                 onchange="decimalSeparatorField.validateField(); onCustomFieldsChange();"/></span>
            </td>
            <td rowspan="2" valign="bottom">
                <div id="numberFormatPreview">
                    <jsp:include page="../../administration/format_preview.jsp">
                        <jsp:param name="previewId" value="numbersFormatPreviewField"/>
                        <jsp:param name="previewWidth" value="110"/>
                        <jsp:param name="previewHeight" value="48"/>
                    </jsp:include>
                </div>
            </td>
        </tr>
        <tr>
            <td class="formfieldtitle formFieldCaption"><span id="digitGroupingSymbolLabel"><%=message( request, "general_settings.digit_grouping_symbol" )%>:</span></td>
            <td>
                <div class="markingDivForSelect" width="102px">
                    <html:select property="digitGroupingSymbol.predefined" styleId="digitGroupingSymbolFieldPredefined"
                                 onchange="digitGroupingSymbolField.validateField(); onCustomFieldsChange();">
                        <html:option value=","><bean:message key="general_settings.formats.comma"/></html:option>
                        <html:option value=""><bean:message key="general_settings.formats.none"/></html:option>
                        <html:option value=" "><bean:message key="general_settings.formats.space"/></html:option>
                        <html:option value="<%=SystemSettings.CUSTOM_VALUE_STRING%>"><bean:message key="general_settings.formats.custom"/></html:option>
                    </html:select>
                </div>
            </td>
            <td style="padding:0">
                <span><html:text size="1" maxlength="1" style="display:none" property="digitGroupingSymbol.custom"
                                 styleId="digitGroupingSymbolFieldCustom" styleClass="customValue"
                                 onchange="digitGroupingSymbolField.validateField(); onCustomFieldsChange();"/></span>
            </td>
        </tr>
    </table>

</div>

<div class="formbuttonpane" id="ButtonPane">
    <input type="button" id="saveSettingsButton" class="saveButton" onclick="doSubmit()" value="<bean:message key="general_settings.save_settings"/>">
</div>


</td>
</tr>
</table>
<input type="hidden" value="1" name="submitted">
</html:form>
<jsp:include page="/form_changed_confirm.jsp"/>
</div>

<p>&nbsp;</p>

</body>
</html>
