<!doctype html>
<%@ page import="com.actimind.actiplans.administration.user.UserListOrder" %>
<%@ page import="com.actimind.actiplans.administration.user.UserListSettings" %>
<%@ page import="com.actimind.actiplans.administration.user.UserRolesFilter" %>
<%@ page import="com.actimind.actiplans.administration.user.UserStatusFilter" %>
<%@ page import="com.actimind.actiplans.services.UserManagementService" %>
<%@ page import="com.actimind.common.licensing.LicenseUserCounters" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.actitime.Constants" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="com.actimind.common.licensing.LicenseHelper" %>
<%@ page import="com.actimind.common.ATGlobals" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%--suppress HtmlUnknownAttribute --%>
<%--suppress HtmlFormInputWithoutLabel HtmlUnknownTag--%>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%@ taglib prefix="logic" uri="http://struts.apache.org/tags-logic" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld"%>
<%@ taglib prefix="ap" uri="/WEB-INF/ap.tld"%>

<bean:define id="loggedInUser" name="<%=Keys.LOGGEDIN_USER_KEY%>" type="com.actimind.actitime.beans.UserBean"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />

<%
    boolean isUGREnabled = settings.isApUserGroupsEnabled();
    boolean isTZGEnabled = settings.isTimeZoneGroupsEnabled();
    boolean isSickEnabled = settings.isApSickBalanceCalculationEnabled();
    boolean isPTOEnabled = settings.isApPtoBalanceCalculationEnabled();

    Boolean userGroupsSynchronized = (Boolean) request.getAttribute(Keys.GROUPS_SYNCHRONIZED);
    boolean tzGroupsSynchronized = LicenseHelper.isOtherProductIntegrated(Product.actiPLANS);
%>

<html>
<head>
    <jsp:include page="/actiplans/include_scripts.jsp"/>
    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="actiplans.user_list.title"/> </title>

    <!--[if IE 8]>
    <style type="text/css">
        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-user-col{
            width: 330px !important;
        }

        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-week-col{
            width: 131px;
        }

        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-manageBalance-col,
        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-manageRequests-col{
            width: 92px;
        }

        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-manageAccounts-col{
            width: 66px;
        }

        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-usersForApproverSelector-col{
            width: 78px;
        }

        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-approvedBy-col{
            width: 184px;
        }

        .userList #userListPageContent #userListTable.manageBalanceColumnHidden .accountTab-account-col{
            width: 100px;
        }
    </style>
    <![endif]-->

</head>
<body class="userList with-navigation">

<at:script page='/js/md5.js'/>

<at:script page="/js/administration/userManagement/LicenseCounterManager.js"/>

<%-- MAIN FILES TO SHOW BASIC PAGE--%>
<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected" value="employees" />
</jsp:include>
<jsp:include page="/form_changed_confirm.jsp"/>

<%-- END MAIN FILES TO SHOW BASIC PAGE--%>

<jsp:include page="/administration/UserListConfirmationConstants.jsp"/>
<at:script page="/js/administration/userManagement/UserListConfirmation.js"/>

<at:script page="/js/administration/userManagement/UserDataLightBox.js"/>
<at:script page="/js/administration/userManagement/CreateUserLightBox.js"/>
<at:script page="/js/administration/userManagement/EditUserLightBox.js"/>
<at:script page="/js/administration/userManagement/InviteSeveralUsersLightBox.js"/>
<at:script page="/actiplans/js/administration/APInviteSeveralUsersLightBox.js"/>
<at:script page="/js/InvitationDialog.js"/>

<at:script page='/js/administration/userManagement/CopyUserSettingsSelector.js'/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<at:script page="/js/administration/userManagement/ratesEditor/FloatNumberValidator.js"/>



<at:script page="/js/administration/userManagement/LeaveBalanceEditor.js"/>

<jsp:include page="/administration/userManagement/leave_balance_editor.jsp"/>

<%-- selectors scripts --%>
<%@ include file="/js/description_util_entities_init_js.jsp"%>

<%--//todo check for duplicates --%>
<at:script page="/js/hierarchySelector/approversSelector/OneLevelTreeNodesHierarchyMaker.js"/>

<at:script page="/js/usersSelector/users_for_approver_selector_panel.js"/>
<at:script page="/js/usersSelector/ap_users_for_approver_selector_panel.js"/>

<%-- required for tree_selector_dialog --%>
<at:script page="/js/util/jquery_customization.js"/>

<at:script page="/js/controls/approvers_dialog.js"/>
<at:script page="/js/controls/tree_selector_dialog.js"/>
<at:script page="/js/controls/users_for_approver_dialog.js"/>
<at:script page="/actiplans/js/controls/UsersForLTRApproverDialog.js"/>
<at:script page="/js/controls/ApproversTooltip.js"/>

<at:script page="/js/BalanceHistoryPanel.js"/>


<at:script page="/js/hierarchySelector/userSelector/usersForApproverSelector/user_for_approver_node_renderer.js" />
<div id="userListPageContent" >

<div class="userListPageHeaderContainer">
    <table id="userListPageHeader">
        <tr>
            <td>
                <div id="title"><bean:message key="actiplans.user_list.title"/></div>
            </td>
            <td>
                <div id="spinnerPlaceholder"></div>
            </td>
    </table>
    <span id="licenseCountId" class="licenseCount" style="display: none;"></span>
    <div class="msgBlock">
        <%@ include file="/messages.jsp" %>
    </div>
</div>

<div id="tabsPanel">
        <div id="userListTabs"></div>
        <div>
            <div class="greyButton withIcon addUserButton dropdown" >
                <span class="buttonIcon">&nbsp;
                    <% if (ATGlobals.isOl()) { %>
                    <bean:message key="actiplans.user_list.add_users"/>
                    <% } else { %>
                    <bean:message key="actiplans.user_list.add_user"/>
                    <% } %>
                </span>
                <% if (ATGlobals.isOl()) { %>
                <span class="arrowIcon"></span>
                <% } %>
            </div>
            <% if (isUGREnabled) { %>
                <span id="manageDepartmentsToAddUserButtonSeparator"></span>
                <a class="editDepartmentsLink">
                    <bean:message  key="actiplans.user_list.manage_departments"/>
                </a>
                <at:img page="userManagement/userList/manage-departments.png" styleId="editDepartmentImgId"/>
            <% } %>
            <% if (isTZGEnabled) { %>
                <span id="manageTimeZoneGroupsToManageDepartmentsSeparator"></span>
                <a class="editTimeZoneGroupsLink">
                    <bean:message key="actiplans.user_list.manage_time_zone_groups"/>
                </a>
                <at:img page="userManagement/userList/manage-time-zone.png" styleId="editTimeZoneGroupImgId"/>
            <% } %>
        </div>
</div>

<table id="userListTable">
    <colgroup>
        <col class="accountTab-user-col">

        <col class="ptoTabCell balance-col">
        <col class="ptoTabCell balanceHistoryShow-td">
        <col class="ptoTabCell plannedBalanceApproved-col">
        <col class="ptoTabCell plannedBalanceWaitingForApproval-col">
        <col class="ptoTabCell accrueRule-col">
        <col class="ptoTabCell resetRule-col">
        <col class="ptoTabCell capRule-col">
        <col class="ptoTabCell userBalanceEnabled-col">

        <col class="sickDaysTabCell balance-col">
        <col class="sickDaysTabCell balanceHistoryShow-td">
        <col class="sickDaysTabCell plannedBalanceApproved-col">
        <col class="sickDaysTabCell plannedBalanceWaitingForApproval-col">
        <col class="sickDaysTabCell accrueRule-col">
        <col class="sickDaysTabCell resetRule-col">
        <col class="sickDaysTabCell capRule-col">
        <col class="sickDaysTabCell userBalanceEnabled-col">

        <col class="accountTabCell accountTab-week-col">
        <col class="accountTabCell accountTab-manageBalance-col">
        <col class="accountTabCell accountTab-manageRequests-col">
        <col class="accountTabCell accountTab-manageAccounts-col">
        <col class="accountTabCell accountTab-usersForApproverSelector-col">
        <col class="accountTabCell accountTab-approvedBy-col">
        <col class="accountTabCell accountTab-account-col">
    </colgroup>

    <thead>
    <tr>
        <th class="userListTableHeaderCell" id="userListTableHeaderCell_filterCell" rowspan="2">
            <div id="userList_usersFilter">
                <div class="userGroupsFilterPlaceholder filterBlock"></div>
            </div>
            <div class="sortButtonsContainer">
                <span class="sortByText">
                    <% if (isUGREnabled && isTZGEnabled ){%>
                         <bean:message key="actiplans.user_list.by"/>
                    <%}else{%>
                         <bean:message key="userlist.head.sortby"/>
                    <%}%>
                </span>
                <span data-sortBy="<%=UserListOrder.USER_NAME%>" data-spinnerPlaceholder="spinnerPlaceholder">
                    <span class="sortButton"><bean:message key="actiplans.user_list.user"/></span>
                    <span class="sortIndicator">
                        <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                        <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                    </span>
                </span>
                <% if (isUGREnabled){%>
                    <span class="separatorUGR">|</span>
                    <span data-sortBy="<%=UserListOrder.GROUP_NAME%>" data-spinnerPlaceholder="spinnerPlaceholder" class="sortByGroupButton" style="white-space: nowrap; margin-left: 2px;">
                        <span class="sortButton"><bean:message key="actiplans.user_list.group"/></span>
                        <span class="sortIndicator">
                            <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                            <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                        </span>
                    </span>
                <%}%>
                <% if (isTZGEnabled){%>
                    <span class="separatorTZG">|</span>
                    <span data-sortBy="<%=UserListOrder.TIME_ZONE_GROUP_NAME%>" data-spinnerPlaceholder="spinnerPlaceholder" class="sortByTimeZoneGroupButton" style="white-space: nowrap; margin-left: 2px;">
                        <span class="sortButton"><bean:message key="actiplans.user_list.time_zone"/></span>
                        <span class="sortIndicator">
                            <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                            <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                        </span>
                    </span>
                <%}%>
            </div>
            <div class="accountEnabledFilterAndUserNameInputContainers">
                <div class="userNameInputContainer"></div>
                <div class="userList_accountEnabledFilter-container">
                    <table>
                        <tr>
                            <td><input type="checkbox" id="userList_accountEnabledFilter"></td>
                            <td>
                                <label for="userList_accountEnabledFilter" class="userList_accountEnabledFilter-label">
                                    <bean:message key="actiplans.user_list.show_disabled_accounts"/>
                                </label>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </th>

        <th class="ptoTabCell userListTableHeaderCell" rowspan="2" colspan="2">
            <span data-sortBy="<%=UserListOrder.PTO_BALANCE%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.current_pto_balance"/></span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>

        <th class="ptoTabCell userListTableHeaderCell firstHeaderRowCell" colspan="2">
            <span class="ptoTab-requestedPtoText-span"><bean:message key="actiplans.user_list.requested_pto"/></span>
        </th>

        <th class="ptoTabCell userListTableHeaderCell firstHeaderRowCell" rowspan="1" colspan="3">
            <span class="ptoTab-accuralRulesText-span"><bean:message key="actiplans.user_list.pto_accrual_rules"/></span>
        </th>

        <th class="ptoTabCell userListTableHeaderCell ptoStatusHeader" rowspan="2">
            <span data-sortBy="<%=UserListOrder.PTO_STATUS%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.pto_control"/></span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>



        <th class="sickDaysTabCell userListTableHeaderCell" rowspan="2" colspan="2">
            <span data-sortBy="<%=UserListOrder.SICK_DAYS_BALANCE%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.current_sick_days_balance"/></span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>

        <th class="sickDaysTabCell userListTableHeaderCell firstHeaderRowCell" colspan="2">
            <span class="sickDaysTab-requestedSickDaysText-span"><bean:message key="actiplans.user_list.requested_sick_days"/></span>
        </th>

        <th class="sickDaysTabCell userListTableHeaderCell firstHeaderRowCell" rowspan="1" colspan="3">
            <span class="sickDaysTab-accuralRulesText-span"><bean:message key="actiplans.user_list.sick_days_accrual_rules"/></span>
        </th>

        <th class="sickDaysTabCell userListTableHeaderCell sickDaysStatusHeader" rowspan="2">
            <span data-sortBy="<%=UserListOrder.SICK_DAYS_STATUS%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.sick_days_control"/></span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>



        <th class="accountTabCell userListTableHeaderCell" rowspan="2">
            <span data-sortBy="<%=UserListOrder.WORKING_WEEK%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.working_week"/></span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>
        <th class="accountTabCell userListTableHeaderCell accountTab-manageRolesCell" colspan="4" rowspan="2">
            <span class="accountTab-manageRolesText-span"><bean:message key="actiplans.user_list.manage"/></span>
            <span class="accountTab-manageRoles-manageInfoImg-span"></span>
            <%--<div class="userList_onlyManagerFilter-container">--%>
                <%--<input type="checkbox" id="userList_onlyManagersFilter">--%>
                <%--<label for="userList_onlyManagersFilter" class="userList_onlyManagersFilter-label"><bean:message key="actiplans.user_list.show_managers_only"/></label>--%>
            <%--</div>--%>
            <div class="userList_onlyManagerFilter-container">
                <table>
                    <tr>
                        <td><input type="checkbox" id="userList_onlyManagersFilter"></td>
                        <td>
                            <label for="userList_onlyManagersFilter" class="userList_onlyManagersFilter-label">
                                <bean:message key="actiplans.user_list.show_managers_only"/>
                            </label>
                        </td>
                    </tr>
                </table>
            </div>
        </th>
        <th class="accountTabCell userListTableHeaderCell approvedByHeader" rowspan="2">
            <div class="accountTab-approvedByText-span"><bean:message key="actiplans.user_list.approved_by"/></div>

            <span id="showUsersWithoutApproversLinkContainer">

               <span id="onlyUsersWithoutApproversCaption"><bean:message key="actiplans.user_list.show_users_without_approvers"/></span>

               <span id="cancelOnlyUsersWithoutApproversCaption">
                 <bean:message key="actiplans.user_list.users_without_approvers"/>
                 <span id="cancelOnlyUsersWithoutApproversButton"></span>
               </span>

            </span>
        </th>
        <%--do not change rowspan to 2, it causes thead hiding in chrome --%>
        <th class="accountTabCell userListTableHeaderCell" rowspan="1">
            <span id="accountStatusSortDataHolder" data-sortBy="<%=UserListOrder.STATUS%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.account"/></span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>
    </tr>

    <tr>
        <th class="ptoTabCell userListTableHeaderCell-secondRow">
            <span data-sortBy="<%=UserListOrder.APPROVED_PTO%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.approved"/> </span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>
        <th class="ptoTabCell userListTableHeaderCell-secondRow">
            <span data-sortBy="<%=UserListOrder.NOT_APPROVED_PTO%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"> <bean:message key="actiplans.user_list.for_approval"/>  </span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>

        <th class="ptoTabCell userListTableHeaderCell-secondRow"> <bean:message key="actiplans.user_list.reset_to"/> </th>
        <th class="ptoTabCell userListTableHeaderCell-secondRow"> <bean:message key="actiplans.user_list.accrue"/> </th>
        <th class="ptoTabCell userListTableHeaderCell-secondRow"> <bean:message key="actiplans.user_list.limit_to"/> </th>


        <th class="sickDaysTabCell userListTableHeaderCell-secondRow">
            <span data-sortBy="<%=UserListOrder.APPROVED_SICK_DAYS%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"><bean:message key="actiplans.user_list.approved"/> </span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>
        <th class="sickDaysTabCell userListTableHeaderCell-secondRow">
            <span data-sortBy="<%=UserListOrder.NOT_APPROVED_SICK_DAYS%>" data-spinnerPlaceholder="spinnerPlaceholder">
                <span class="sortButton"> <bean:message key="actiplans.user_list.for_approval"/>  </span>
                <span class="sortIndicator">
                    <div class="for-print-only down"><ap:defImg page="tables/sort-down-for-print.png" /></div>
                    <div class="for-print-only up"><ap:defImg page="tables/sort-up-for-print.png" /></div>
                </span>
            </span>
        </th>

        <th class="sickDaysTabCell userListTableHeaderCell-secondRow"> <bean:message key="actiplans.user_list.reset_to"/> </th>
        <th class="sickDaysTabCell userListTableHeaderCell-secondRow"> <bean:message key="actiplans.user_list.accrue"/> </th>
        <th class="sickDaysTabCell userListTableHeaderCell-secondRow"> <bean:message key="actiplans.user_list.limit_to"/> </th>
    </tr>

    </thead>

    <tbody class="actualContent">
    </tbody>


    <tbody class="templates" style="display: none">
        <tr class="noUsersRow">
            <td class="ptoTabCell noUsersTextPlaceholder" colspan="9"></td>
            <td class="sickDaysTabCell noUsersTextPlaceholder" colspan="9"></td>
            <td class="accountTabCell noUsersTextPlaceholder" colspan="<%=(isSickEnabled || isPTOEnabled) ? "8":"7"%>"></td>
        </tr>
        <tr class="userRow">
            <td class="accountTab-user-td firstCell">
                <div class="accountTab-userNameText-div">
                    <span class="userInOtherProduct" title="<bean:message key="actiplans.user_list.info.enabled_in_at"/>"></span>
                    <span class="accountTab-userNameText-span"></span>
                    <span class="infoSpan"></span>
                </div>
                <div class='userGroups'>
                    <div class="accountTab-userGroupText-div"></div>
                    <div class="accountTab-timeZoneGroupText-div"></div>
                </div>
                <div class="warningsInRow"></div>
            </td>

            <td class="ptoTabCell balance-td">
                <span class="balanceText-span"></span>
                <span class="balanceRevertedText-span"></span>
            </td>

            <td class="ptoTabCell balanceHistoryShow-td">
                <at:img page="userManagement/userList/showPtoHistory.png"/>
                <div class="ptoHistorySpinnerPlaceholder" style="display: inline-block"></div>
            </td>

            <td class="ptoTabCell plannedBalanceApproved-td">

            </td>

            <td class="ptoTabCell plannedBalanceWaitingForApproval-td">

            </td>


            <td class="ptoTabCell resetRule-td">

            </td>

            <td class="ptoTabCell accrueRule-td">

            </td>

            <td class="ptoTabCell capRule-td">

            </td>

            <td class="ptoTabCell userBalanceEnabled-td lastCell">

            </td>


            <td class="sickDaysTabCell balance-td">
                <span class="balanceText-span"></span>
                <span class="balanceRevertedText-span"></span>
            </td>

            <td class="sickDaysTabCell balanceHistoryShow-td">
                <at:img page="userManagement/userList/showPtoHistory.png"/>
                <div class="ptoHistorySpinnerPlaceholder" style="display: inline-block"></div>
            </td>

            <td class="sickDaysTabCell plannedBalanceApproved-td">

            </td>

            <td class="sickDaysTabCell plannedBalanceWaitingForApproval-td">

            </td>


            <td class="sickDaysTabCell resetRule-td">

            </td>

            <td class="sickDaysTabCell accrueRule-td">

            </td>

            <td class="sickDaysTabCell capRule-td">

            </td>

            <td class="sickDaysTabCell userBalanceEnabled-td lastCell">

            </td>


            <td class="accountTabCell accountTab-week-td"><span class="accountTab-weekText-span"></span></td>

            <td class="accountTabCell tableButtonCell accountTab-manageBalance-td" changeRight="pto">
                <div class="accountTab-manageBalanceImg-div"></div>
                <span class="accountTab-manageBalanceImgText-span"><bean:message key="actiplans.user_list.pto"/></span>
            </td>

            <td class="accountTabCell tableButtonCell accountTab-manageAccounts-td" changeRight="accounts">
                <div class="accountTab-manageAccountsImg-div"></div>
                <span class="accountTab-manageAccountsImgText-span"><bean:message key="actiplans.user_list.system"/></span>
            </td>

            <td class="accountTabCell tableButtonCell accountTab-manageRequests-td" changeRight="requests">
                <div class="accountTab-manageRequestsImg-div"></div>
                <span class="accountTab-manageRequestsImgText-span"><bean:message key="actiplans.user_list.requests"/></span>
            </td>

            <td class="accountTabCell tableButtonCell accountTab-usersForApproverSelector-td">
            </td>

            <td class="accountTabCell tableButtonCell accountTab-approvedBy-td">
                <span class="accountTab-approvedByText-span"></span>
            </td>

            <td class="accountTabCell accountTab-accountState-td lastCell">
                <span class="accountTab-accountStateText-span"></span>
            </td>
        </tr>
        <tr class="empty row"></tr>
        <tr class="apUserListSpacer">
            <td class="accountTab-user-td">&nbsp;</td>

            <td class="ptoTabCell">&nbsp;</td>

            <td class="ptoTabCell"> &nbsp;</td>

            <td class="ptoTabCell"> &nbsp;</td>

            <td class="ptoTabCell">&nbsp;</td>

            <td class="ptoTabCell">&nbsp;</td>

            <td class="ptoTabCell">&nbsp;</td>

            <td class="ptoTabCell">&nbsp;</td>

            <td class="ptoTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="sickDaysTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>

            <td class="accountTabCell">&nbsp;</td>
        </tr>
    </tbody>
</table>

<jsp:include page="/administration/pager_panel.jsp"/>

</div>

<jsp:include page="/user/balance_history_panel.jsp"/>

<jsp:include page="/controls/balance_rules_editor_dialog.jsp">
    <jsp:param name="prefixId" value="sick"/>
</jsp:include>

<jsp:include page="/controls/balance_rules_editor_dialog.jsp">
    <jsp:param name="prefixId" value="pto"/>
</jsp:include>


<div id="userRolesPopupDiv">
    <%if(settings.isApPtoBalanceCalculationEnabled() || settings.isApSickBalanceCalculationEnabled()) {%>
    <div class="balanceManager roleInfo">
        <div class="roleTitle"><bean:message key="actiplans.user_list.info.balance_manager_title" /></div>
        <div class="roleDescr"><bean:message key="actiplans.user_list.info.balance_manager_descr" /></div>
    </div>
    <%}%>
    <div class="systemManager roleInfo">
        <div class="roleTitle"><bean:message key="actiplans.user_list.info.sys_manager_title" /></div>
        <div class="roleDescr"><bean:message key="actiplans.user_list.info.sys_manager_descr" /></div>
    </div>
    <div class="leaveTimeManager roleInfo">
        <div class="roleTitle"><bean:message key="actiplans.user_list.info.ltm_manager_title" /></div>
        <div class="roleDescr"><bean:message key="actiplans.user_list.info.ltm_manager_descr" /></div>
    </div>
</div>

<div id="userWorkScheduleTooltip" class="yellowTooltip">
         <span id="userWorkScheduleTooltip_scheduleHeader">XX</span>
         <span id="userWorkScheduleTooltip_weekTextPlaceholder">XX</span>

    <div id="userWorkScheduleTooltip_durationsTablePlaceholder"> </div>
</div>
<div id="userIsAutoApprovedTooltip" class="yellowTooltip tooltipText"></div>
<div id="approverManagesAllUsersTooltip" class="yellowTooltip tooltipText"></div>

<jsp:include page="/controls/approvers_tooltip.jsp"/>

<div id="usersForApproverTooltip" class="yellowTooltip tooltipText">
    <bean:message key="actiplans.user_list.approvers_tooltip.approver_for" />
</div>

<div class="warningsToShowDiv">
</div>

<%-- CREATE/EDIT LIGHT BOX --%>
<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='groupManagementLightBox'/>
    <jsp:param name="title" value='<%=filteredMessage(request, "group_management.lightbox_title.user_group")%>'/>
    <jsp:param name="innerJsp" value='/administration/userManagement/group_management.jsp'/>
    <jsp:param name="groupNamingPlural" value='<%=filteredMessage(request, "common.User_Groups")%>'/>
    <jsp:param name="additionalClasses" value="groupManagementLightBox userGroupManagementLightBox lightboxWithWhiteContent"/>
    <jsp:param name="groupsSynchronized" value='<%=userGroupsSynchronized%>'/>
</jsp:include>
<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='timeZoneGroupManagementLightBox'/>
    <jsp:param name="title" value='<%=filteredMessage(request, "group_management.lightbox_title.time_zone_group")%>'/>
    <jsp:param name="innerJsp" value='/administration/userManagement/group_management.jsp'/>
    <jsp:param name="groupNamingPlural" value='<%=filteredMessage(request, "common.Time_Zone_Groups")%>'/>
    <jsp:param name="additionalClasses" value="groupManagementLightBox timeZoneGroupManagementLightBox lightboxWithWhiteContent"/>
    <jsp:param name="groupsSynchronized" value='<%=tzGroupsSynchronized%>'/>
</jsp:include>

<jsp:include page="/loading_popup.jsp">
    <jsp:param name="id" value='userDataLoadingPopup'/>
</jsp:include>
<%--END CREATE/EDIT LIGHT BOX --%>

<%-- MANAGE GROUPS --%>
<jsp:include page='/util/google_api_place_script.jsp'/>
<at:script page="/js/administration/userlist_util.js"/>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='userDataLightBox'/>
    <jsp:param name="innerJsp" value='/actiplans/administration/user_data_popup.jsp'/>
    <jsp:param name="additionalClasses" value='lightboxWithWhiteContent scrollable'/>
</jsp:include>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='inviteSeveralUsersLightBox'/>
    <jsp:param name="innerJsp" value='/administration/userManagement/invite_several_users_popup.jsp'/>
    <jsp:param name="additionalClasses" value='lightboxWithWhiteContent'/>
</jsp:include>

<jsp:include page="/controls/approvers_dialog.jsp"/>
<jsp:include page="/controls/tree_selector_dialog.jsp">
    <jsp:param name="id" value="usersForApproverDialog"/>
</jsp:include>


<%-- END MANAGE GROUPS --%>


<script type="text/javascript">
    var UserListPageConstants = {};
    UserListPageConstants.USER_STATUS_FILTER_ALL = '<%=UserStatusFilter.ALL%>';
    UserListPageConstants.USER_STATUS_FILTER_ENABLED_ONLY = '<%=UserStatusFilter.ENABLED_ONLY%>';
    UserListPageConstants.USER_ROLES_FILTER_ALL = '<%=UserRolesFilter.ALL%>';
    UserListPageConstants.USER_ROLES_FILTER_MANAGERS_ONLY = '<%=UserRolesFilter.MANAGERS_ONLY%>';
    UserListPageConstants.LICENSE_UNLIM = '<%=LicenseUserCounters.UNLIMITED_VAL%>';
    UserListPageConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_LICENSE_TERMS  = <%= UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_DUE_TO_LICENSE_TERMS%>;
    UserListPageConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_LICENSE_TERMS  = <%= UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_LICENSE_TERMS%>;
    UserListPageConstants.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_LICENSE_TERMS  = <%= UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_LICENSE_TERMS%>;
    UserListPageConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_FUTURE_HIRE_DATE  = <%= UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_DUE_TO_FUTURE_HIRE_DATE%>;
    UserListPageConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_FUTURE_HIRE_DATE  = <%= UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_FUTURE_HIRE_DATE%>;
    UserListPageConstants.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_FUTURE_HIRE_DATE  = <%= UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_FUTURE_HIRE_DATE%>;
    UserListPageConstants.WARNING_NO_RIGHT_TO_EDIT_STATUS_IN_OTHER_PRODUCT = '<%=UserManagementService.UserManagementResult.WARNING_NO_RIGHT_TO_EDIT_STATUS_IN_OTHER_PRODUCT%>';
    UserListPageConstants.WARNING_USER_GROUP_NO_LONGER_EXISTS  = <%= UserManagementService.UserManagementResult.WARNING_USER_GROUP_NO_LONGER_EXISTS %>;
    UserListPageConstants.WARNING_TIME_ZONE_GROUP_NO_LONGER_EXISTS  = <%= UserManagementService.UserManagementResult.WARNING_TIME_ZONE_GROUP_NO_LONGER_EXISTS %>;

    UserListPageConstants.ACCOUNT_SETTINGS_TAB_NUM = 1;
    UserListPageConstants.PTO_SETTINGS_TAB_NUM = 2;
    UserListPageConstants.SICK_DAYS_SETTINGS_TAB_NUM = 3;

    //todo it better to have only  UserListPageConstants
    UserManagementConstants= {};
    UserManagementConstants.ERROR_DUPLICATE_USERNAME = 1;
    UserManagementConstants.USER_GROUP_NOT_ASSIGNED_ID = -1;
    UserManagementConstants.DEFAULT_TIME_ZONE_GROUP_ID = <%=Constants.DEFAULT_TIME_ZONE_GROUP_ID%>;
    UserManagementConstants.ERROR_EMAIL_INVALID = 2;

    $( function (){
        var pageData = <%=jsHelper.toJSON( request.getAttribute( Keys.AP_USERS_LIST_DATA_KEY ) )%>;

        <%
            UserListSettings userListSettings = (UserListSettings)request.getAttribute( Keys.USER_LIST_SETTINGS_KEY );
            String groupType = jsHelper.toJSON(userListSettings.getFilter().getGroupType());
        %>

        var pageState = {
            userListFilter: {
                statusFilter: '<%=userListSettings.getFilter().makeStatusFilter()%>',
                rolesFilter: '<%=userListSettings.getFilter().makeRolesFilter()%>',
                groupIds: <%=jsHelper.toJSON(userListSettings.getFilter().getGroupIds())%>,
                groupType: <%if (groupType == null || groupType.equals("null")) {%> null <%} else {%> '<%=groupType%>' <%}%>,
                onlyUsersWithoutApprovers: <%=jsHelper.toJSON(userListSettings.getFilter().isOnlyUsersWithoutApprovers())%>
            },
            sortBy: '<%=userListSettings.makeOrder()%>',
            isAscending: <%=userListSettings.isAsc()%>,
            pageNum: pageData.pageNum,
            recordsPerPage: <%=userListSettings.getRecordsPerPage()%>,
            totalRecords: pageData.totalRecords,
            userNameFilterText: ""
        };

        var userListPage = new UserListPage().init(pageData, pageState, <%= loggedInUser.getId() %>, pageData.weekStartDay, <%= loggedInUser.getTimeZoneGroupId() %>);
    } );
</script>

</body>
</html>