function TextAreaLengthManager() {
    this.constructor = TextAreaLengthManager;
}

TextAreaLengthManager.prototype.init = function (textarea, maxTextLenght, titleMessage) {
    this._titleMessage = titleMessage;
    this._maxTextLenght = maxTextLenght;
    this._textarea = textarea;

    var self = this;
    $( textarea ).keyup(function() {self.update()});
};

TextAreaLengthManager.prototype.setDependentButton = function ( button, handler ) {
    var self = this;
    this._submitButton = button;
    this._onclickHandler = function() {
        if ( !self.isIncorrectLenght() )
            handler();
        else
            self.update();
    };
    $(this._submitButton ).off('click');
    $(this._submitButton ).on('click', this._onclickHandler);
};

TextAreaLengthManager.prototype.isIncorrectLenght = function () {
    var val = trim( $( this._textarea ).pVal() );
    return val && val.length > this._maxTextLenght;
};

TextAreaLengthManager.prototype.update = function () {
    var newState = this.isIncorrectLenght();

    if (this._disabled === newState ) {
        return;
    }

    this._disabled = newState;
    this._updateTextarea();
    if (this._submitButton)
        this._updateButton();

};

TextAreaLengthManager.prototype._updateTextarea = function () {
    if ( this._disabled ) {
        $(this._textarea).addClass("error");
        $(this._textarea).attr("title", this._titleMessage);
    } else {
        $(this._textarea).removeClass("error");
        $(this._textarea).removeAttr("title");
    }
};

TextAreaLengthManager.prototype._updateButton = function () {
    if ( this._disabled ) {
        this._submitButton.title = this._titleMessage;
        $(this._submitButton).addClass("disabled");
        $(this._submitButton ).off('click');
    } else {
        this._submitButton.title = "";
        $(this._submitButton).removeClass("disabled");
        $(this._submitButton ).off('click');
        $(this._submitButton ).on('click', this._onclickHandler);
    }
};