function LeaveRequestsBalanceTypeFilter(renderTo, onChange, balanceTypeFilter)
{
    var leaveBalanceFilterTypes = [];

    $.each(LeaveBalanceFilter, function()
    {
        leaveBalanceFilterTypes.push(this);
    });
    var select = $(renderTo);

    var leaveBalanceFilterTexts = {
        ALL: messageResource.getMessage("actiplans.balance_type_filter.all"),
        PTO: messageResource.getMessage("actiplans.balance_type_filter.pto"),
        SICK: messageResource.getMessage("actiplans.balance_type_filter.sick")
    };

    $.each(leaveBalanceFilterTypes, function()
    {
        select.append($('<option/>').val(this).text(leaveBalanceFilterTexts[this]));
    });

    var button = new AT.DropdownListButton({applyTo: select[0]});

    function balanceTypeFilterToggleClass(value)
    {
        $(".balanceTypeFilterBlock").toggleClass("active", value != LeaveBalanceFilter.ALL);
    }

    balanceTypeFilterToggleClass(balanceTypeFilter);
    this.button = button;

    button.addListener('change', function()
    {
        var value = button.getValue();
        onChange(value);
        balanceTypeFilterToggleClass(value);
    });

    this.setActiveItemByValue = function(value, suppressOnChangeEvent)
    {
        this.button.setActiveItemByValue(value, suppressOnChangeEvent);
    };

    this.setActiveItemByValue(balanceTypeFilter, true);
}