function LeaveRequestsStatusFilter(renderTo, onChange, statusFilter)
{
    var statuses = [];

    _.each(LeaveTimeRequestStatus, function(status)
    {
        statuses.push(status);
    });

    var select = $(renderTo);

    function addOption(value, text)
    {
        select.append($('<option/>').val(value).text(text));
    }

    addOption(-1, messageResource.getMessage('actiplans.corporate_requests.all_statuses'));

    //TODO temporary. Need to move to another place
    var statusTextMap = {};
    statusTextMap[LeaveTimeRequestStatus.REQUESTED] = messageResource.getMessage('actiplans.request_status.waiting_for_approval');
    statusTextMap[LeaveTimeRequestStatus.APPROVED] = messageResource.getMessage('actiplans.request_status.approved');
    statusTextMap[LeaveTimeRequestStatus.REJECTED] = messageResource.getMessage('actiplans.request_status.rejected');

    _.each(statuses, function(status)
    {
        addOption(status, statusTextMap[status]);
    });

    var currentStatus = statusFilter && statusFilter[0];
    currentStatus = currentStatus !== null ? currentStatus : -1;
    var button = new AT.DropdownListButton({applyTo: select[0]});

    function statusFilterToggleClass(value)
    {
        $(".statusFilterBlock").toggleClass("active", value != -1);
    }

    statusFilterToggleClass(currentStatus);
    this.button = button;

    button.addListener('change', function()
    {
        var value = button.getValue();
        onChange(value == -1 ? null : [value]);
        statusFilterToggleClass(value);
    });

    this.setActiveItemByValue = function(value, suppressOnChangeEvent)
    {
        this.button.setActiveItemByValue(value, suppressOnChangeEvent);
    };

    this.setActiveItemByValue(currentStatus, true);
}