function LeaveTimeRequestsPageTooltip(tooltipEl)
{
    this._tooltipEl = tooltipEl;
}

LeaveTimeRequestsPageTooltip.prototype = {
    bind: function(bindElements)
    {
        _.each(bindElements, function(bindEl)
        {
            bindEl.mouseover(_.bind(this._mouseOver, this))
                    .mouseout(_.bind(this._mouseOut, this))
                    .mousemove(_.bind(this._setPosition, this));
        }, this);
    },

    show: function()
    {
        this._tooltipEl.show();
    },

    hide: function()
    {
        this._tooltipEl.hide();
    },

    _mouseOver: function(e)
    {
        this._tooltipEl.show();
        this._setPosition(e);
    },

    _mouseOut: function()
    {
        this._tooltipEl.hide();
    },

    _setPosition: function(e)
    {
        var tooltipWidth = this._tooltipEl.outerWidth();
        var tooltipHeight = this._tooltipEl.outerHeight();

        var x = e.clientX + 10;
        var y = e.clientY + 15;

        if (x + tooltipWidth > $(window).width())
            x -= tooltipWidth;

        if (y + tooltipHeight > $(window).height())
            y -= tooltipHeight + 15;

        this._tooltipEl.offset({top: y + getBodyScrollTop(), left: x + getBodyScrollLeft()});
    }
};