function LeaveTypeAPLightBox() {
}

LeaveTypeAPLightBox.CREATE_POPUP_DEFAULT_LEAVE_TYPE_REQUIRES_APPROVAL = true;    // requires approval

LeaveTypeAPLightBox.prototype = _.create(LeaveTypeLightBox.prototype);

LeaveTypeAPLightBox.prototype.init = function ( numberSettings, iconSelectorPanel )
{
    var balancesEditPanelControllerConstructor = NoBalancesEditPanelController;
    if ( SystemSettings.apPtoBalanceCalculationEnabled && SystemSettings.apSickBalanceCalculationEnabled )
        balancesEditPanelControllerConstructor = LeaveTypeBalancesEditPanelController;
    else if ( SystemSettings.apPtoBalanceCalculationEnabled )
        balancesEditPanelControllerConstructor = PtoBalanceEditPanelController;
    else if ( SystemSettings.apSickBalanceCalculationEnabled )
        balancesEditPanelControllerConstructor = SickDaysBalanceEditPanelController;

    LeaveTypeLightBox.prototype.init.call(this, numberSettings, iconSelectorPanel, balancesEditPanelControllerConstructor);

    this.initRequireApprovalField();

    return this;
};

LeaveTypeAPLightBox.prototype.initRequireApprovalField = function ()
{
    var self = this;
    this.requireApprovalCheckbox = this.getElementBySubId( "requireApproval" );
    this.requireApprovalCheckbox.onclick = function() { self.changesCallback(); };
};
LeaveTypeAPLightBox.prototype.getRequireApproval = function ()
{
    return this.requireApprovalCheckbox.checked;
};

LeaveTypeAPLightBox.prototype.initAsCreatePopup = function ( ) {
    LeaveTypeLightBox.prototype.initAsCreatePopup.call(this);

    this.requireApprovalCheckbox.checked = LeaveTypeAPLightBox.CREATE_POPUP_DEFAULT_LEAVE_TYPE_REQUIRES_APPROVAL;
};

LeaveTypeAPLightBox.prototype.performSpecificCheck = function () {
    return this.balancesEditPanel.isAsPTOChecked() ?
           !this.balancesEditPanel.checkEmpty() && this.balancesEditPanel.validate() :
           true;
};

LeaveTypeAPLightBox.prototype.getDataToCommit = function()
{
    return  [{  id: this.leaveTypeId,
                name: this.getLeaveTypeName(),
                iconId: this.iconSelector.getIconId(),
                active: this.getStatus(),
                requiresApproval: this.getRequireApproval(),
                balanceType: this.balancesEditPanel.getBalanceType(),
                balanceCoefficient: this.balancesEditPanel.getBalanceCoefficient()
            }];
};