function LeaveTypeAPListPageController() {
    this.constructor = LeaveTypeAPListPageController;
}

LeaveTypeAPListPageController.prototype = _.create(LeaveTypeListPageController.prototype);

LeaveTypeAPListPageController.prototype.init = function ( leaveTypesInfo, arrowImagesPaths, numberSettings, newLeaveTypeDefaultIconId )
{
    LeaveTypeListPageController.prototype.init.call(this, leaveTypesInfo, numberSettings, newLeaveTypeDefaultIconId);

    this.tableHeaderTooltipsOffsetParams = "-66px 3px";

    this.leaveTypeListTableController = new LeaveTypeAPListTableController().init({
                                                                                    tHeadEl: this.tHeadEl,
                                                                                    containerEl: this.containerEl,
                                                                                    leaveTypeRecords: leaveTypesInfo,
                                                                                    handlersMap: this.handlersMap,
                                                                                    arrowImagesPaths: arrowImagesPaths,
                                                                                    numberSettings: this.numberSettings,
                                                                                    iconSelectorPanel: this.iconSelectorPanel,
                                                                                    isPtoEnabled: SystemSettings.apPtoBalanceCalculationEnabled,
                                                                                    isSickEnabled: SystemSettings.apSickBalanceCalculationEnabled
                                                                                });

    return this;
};

LeaveTypeAPListPageController.prototype.initializeHandlersMap = function ()
{
    var that = this;

    this.handlersMap = this.createBaseHandlersMap();
    this.handlersMap.changeRequiresApproval = function (leaveTypeId, currentRequiresApproval) { that.changeRequiresApproval(leaveTypeId, currentRequiresApproval) };
};

LeaveTypeAPListPageController.prototype.createAndInitLeaveTypeLightBox = function () {
    return new LeaveTypeAPLightBox().init(this.numberSettings, this.iconSelectorPanel);
};

LeaveTypeAPListPageController.prototype.createAndInitIconSelectorPanel = function () {
    return new LeaveTypeIconSelectorPanel().init("leaveTypeIconSelectorPanel", true);
};

LeaveTypeAPListPageController.prototype.changeRequiresApproval = function ( leaveTypeId, currentRequiresApproval )
{
    this.callLeaveTypeServiceMethod("LeaveTypeService.setRequiresApproval", [leaveTypeId, !currentRequiresApproval], true);
};

LeaveTypeAPListPageController.prototype.leaveTypeServiceResultHandler = function ( result, customSuccessHandler )
{
    if (!LeaveTypeListPageController.prototype.leaveTypeServiceResultHandler.call(this, result, customSuccessHandler))
    {
        var newPtoBalanceCalculationEnabled = result.balancesInfo.ptoBalanceCalculationEnabled;
        var newSickBalanceCalculationEnabled = result.balancesInfo.sickBalanceCalculationEnabled;

        if( SystemSettings.apPtoBalanceCalculationEnabled != newPtoBalanceCalculationEnabled )
        {
            var pto_message = newPtoBalanceCalculationEnabled ? messageResource.getMessage( "leave_type.warning.pto_feature_enabled" ) : messageResource.getMessage( "leave_type.warning.pto_feature_disabled" );
            alert( pto_message );
            window.location.reload();
        }
        else if ( SystemSettings.apSickBalanceCalculationEnabled != newSickBalanceCalculationEnabled )
        {
            var sick_message = newSickBalanceCalculationEnabled ? messageResource.getMessage( "leave_type.warning.sdb_feature_enabled" ) : messageResource.getMessage( "leave_type.warning.sdb_feature_disabled" );
            alert( sick_message );
            window.location.reload();
        }

        PageOverlayTipsManager.getInstance().refreshDynamicTips(false);
    }
};
