function LeaveTypeAPListTableController ()
{
    this.constructor = LeaveTypeAPListTableController;
}

LeaveTypeAPListTableController.prototype = _.create(LeaveTypeListTableController.prototype);

LeaveTypeAPListTableController.prototype.getLeaveTypeListTableRenderer = function () {
    return new LeaveTypeAPListTableRenderer();
};

LeaveTypeAPListTableController.prototype.render = function ()
{
    LeaveTypeListTableController.prototype.render.call(this);
    if ( this.isPtoEnabled || this.isSickEnabled )
        this.setupTableHeaderEventHandlers();
};

LeaveTypeAPListTableController.prototype.addCellsToRow = function ( row, leaveTypeRecord )
{
    row.addCellObj( this.createLeaveTypeChangeOrderCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeImageCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeNameCell(leaveTypeRecord, row) );
    if ( this.isPtoEnabled || this.isSickEnabled )
        row.addCellObj( this.createLeaveTypeAffectedBalanceCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeRequiresApprovalCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeStatusCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeDeleteCell(leaveTypeRecord, row) );
};

LeaveTypeAPListTableController.prototype.createLeaveTypeRequiresApprovalCell = function (leaveTypeRecord, row)
{
    var leaveTypeRequiresApprovalCell = new TableCell( leaveTypeRecord, row );
    leaveTypeRequiresApprovalCell.setRenderer( new LeaveTypeRequiresApprovalCellRenderer().init(this.handlersMap.changeRequiresApproval) );
    return leaveTypeRequiresApprovalCell;
};
