function LeaveTypesListDialog( successor, withCustomOption )
{
    this.successor = successor;

    var me = this;

    var customAddListener = function()
    {
        me.successor.customAddSelected();
    };

    var customAddItem = {
        text: "Custom Add",
        value: -1,
        icon: null,
        listeners: { click: customAddListener },
        href: "javascript: void(0)"
    };


    var selectLeaveTypeListener = function(leaveTypeId)
    {
        me.menu.hide();
        me.successor.leaveTypeSelected( leaveTypeId );
    };

    this.menu = withCustomOption ? new AT.LeaveTypesMenu(selectLeaveTypeListener, [customAddItem]) :
                new AT.LeaveTypesMenu(selectLeaveTypeListener);
    this.menu.extMenu.addListener("hide", function(){ successor.hide(); });

    doOnceOnWindowResize( function () { me.hide(); } );
}

LeaveTypesListDialog.prototype.showAt = function (element)
{
    this.menu.showAt( element );
};

LeaveTypesListDialog.prototype.hide = function ()
{
    this.menu.hide();
};

