$( document ).ready( function ()
                     {
                         disableTextSelection( document.getElementById( 'scrollPanel' ) );
                     } );

ScrollPanelController.COUNT_MILL_SECONDS_IN_DAY= 1000 * 3600 * 24;

function ScrollPanelController()
{
}

ScrollPanelController.prototype.init = function ( containerId, prevWeekCallback, nextWeekCallback, customWeekCallback, dateFrom, todayFunc, scheduleCalculator, minDateFunc )
{
    var weekStartDay = SystemSettings.weekStartDay - 1;
    this._todayFunc = todayFunc;
    this.minDate = new Date(0);
    this._dateSelector = new WeekSelector( {
                                               minValue: this.minDate,
                                               maxValue: MAX_ALLOWED_DATE_FOR_TIME_TRACK,
                                               weekStartDay: weekStartDay,
                                               renderTo: document.getElementById( "fromDateSelector" ),
                                               scheduleCalculator: scheduleCalculator,
                                               date: new Date( dateFrom ), // dateFrom must not be changed in dateSelector
                                               scrollableContainer: window,
                                               minText: messageResource.getMessage( "my_schedule.page.my_schedule.navigation.week_selector.min_text" )
                                           } );
    var that = this;
    this._dateSelector.on( "change",
                           function ()
                           {
                               customWeekCallback( that._dateSelector.getValue() );
                           } );

    this._previousWeekButton = $( '#previousWeekButton' );
    this._nextWeekButton = $( '#nextWeekButton' );
    this._backToCurrentWeekButton = $( '#backToCurrentWeekButton' );
    this._currentWeekToggle = $( '#currentWeekToggle' );

    this._previousWeekButton.click( function ()
                                    {
                                        if( $( this ).hasClass( "activeScrollButton" ) )
                                        {
                                            prevWeekCallback();
                                        }
                                    } );
    this._nextWeekButton.click( function()
                                {
                                    if( $( this ).hasClass( "activeScrollButton" ) )
                                    {
                                        nextWeekCallback();
                                    }
                                } );
    this._backToCurrentWeekButton.click( function () { customWeekCallback( todayFunc().getWeekStartDate( weekStartDay ) ); } );

    this.moveInContainer( containerId );

    return this;
};

ScrollPanelController.prototype.updateControls = function ( fromDate )
{
    fromDate = new Date( fromDate );
    var toDate = fromDate.getNDaysAfter( 6 );
    var today = this._todayFunc();
    if( compareDates( fromDate, today ) <= 0 && compareDates( today, toDate ) <= 0 )
    {
        this._currentWeekToggle.removeClass( "otherWeekSelected" ).addClass( "currentWeekSelected" );
    }
    else
    {
        this._currentWeekToggle.removeClass( "currentWeekSelected" ).addClass( "otherWeekSelected" );
    }
    if ( (fromDate.getTime() - this.minDate.getTime()) / ScrollPanelController.COUNT_MILL_SECONDS_IN_DAY < 7)
    {
        this._previousWeekButton.removeClass("activeScrollButton").addClass("inactiveScrollButton");
    }
    else
    {
        this._previousWeekButton.removeClass("inactiveScrollButton").addClass("activeScrollButton");
    }
    if( compareDates( toDate, MAX_ALLOWED_DATE_FOR_TIME_TRACK ) < 0 )
    {
        this._nextWeekButton.removeClass( "inactiveScrollButton" ).addClass( "activeScrollButton" );
    }
    else
    {
        this._nextWeekButton.removeClass( "activeScrollButton" ).addClass( "inactiveScrollButton" );
    }

    this._dateSelector.setValue( fromDate );
};

ScrollPanelController.prototype.moveInContainer = function ( containerId )
{
    var panel = $( '#scrollPanel' );
    panel.removeClass( 'invisiblePanel' );
    document.getElementById( containerId ).appendChild( panel[0] );
};
