    /*
     * Validates form on submit (should be registred as listener).
     */
        function validateForm() {
            deleteMessages();
            removeClientSideErrors();

            var result = checkMissedData();
            result = checkDuplication() && result;

            validateFormatFields();
            validateWorkdayDuration();

            result = result && !ClientSideErrors.hasErrors();

            if (!result) {
                ClientSideErrors.showClientSideErrorMessage();
            }

            return result;
        }


    /*------------------------------------------------- PRIVATE -------------------------------------------------*/


    /*
     * Determines whether form fields has missed values, and if it is marks them as invalid.
     */
        function checkMissedData() {
            var isValid = true;

            var emptyLevelFields = getEmptyCustomLevelFields();
            if (emptyLevelFields.length > 0) {
                markEmptyFieldsAsInvalid(emptyLevelFields, messageResource.getMessage("general_settings.edit.one_form_was_missed"));
                isValid = false;
            }

            updateUserGroupsNamingLabelErrorState();

            if (!isDecimalFieldIsNotEmpty())
            {
                var message = messageResource.getMessage("general_settings.edit.empty_decimal_field");

                ClientSideErrors.markTextFieldAsInvalid(document.getElementById(decimalSeparatorField.getCustomFieldName()), message);
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("decimalSeparatorFieldLabel"), message);
                isDecimalSeparatorRowHighlightedOnSubmit = true;
                isValid = false;
            }
            else
                isDecimalSeparatorRowHighlightedOnSubmit = false;

            isValid = checkDefaultTZGroupNameField(true) && isValid;

            return isValid;
        }


        function updateUserGroupsNamingLabelErrorState()
        {
            updateLabelErrorState( "userGroupsNamingLabel", getEmptyCustomLevelFields().length > 0,
                                   messageResource.getMessage("general_settings.edit.one_form_was_missed" ) );
        }


        var decimalSeparatorField;
        var digitGroupingSymbolField;

        /**
         * Initializes format symbols fields.
         *
         * @param decimalSeparatorFieldName - base name for custom and predefined decimal separator fields
         * @param decimalSeparatorInitialValue - initial value for decimal separator field
         * @param digitGroupingSymbolFieldName - base name for custom and predefined digit grouping symbol fields
         * @param digitGroupingSymbolInitialValue - initial value for digit grouping symbol field
         */
        function initCustomizedFields(decimalSeparatorFieldName, decimalSeparatorInitialValue,
                                      digitGroupingSymbolFieldName, digitGroupingSymbolInitialValue)
        {

            decimalSeparatorField = new CustomizableField(decimalSeparatorFieldName);
            digitGroupingSymbolField = new CustomizableField(digitGroupingSymbolFieldName);

            decimalSeparatorField.initField(decimalSeparatorInitialValue);
            digitGroupingSymbolField.initField(digitGroupingSymbolInitialValue);

            validateFormatFields();
        }

