function LeaveBalancesFilter() {}

LeaveBalancesFilter.prototype.init = function( renderTo, changesCallback, params )
{
    var self = this;
    this.containerElement = $( renderTo );
    this.containerElement.addClass("filter");
    this.filter = new HeaderTextListSelector( {
        menuCls: "filterMenu",
        renderTo: renderTo,
        value: params.value
    } );
    this.addItems();
    this.filter.on( "change", function ()
    {
        self.changesCallback(self.filter.getSelectedItem().value);
        changesCallback();
    } );
    self.changesCallback(self.filter.getSelectedItem().value);

    return this;
};

LeaveBalancesFilter.prototype.addItems = function(){

    var items = [];
    var pushToItems = function( messageKey, headerKey, value )
    {
        items.push({
                      text: messageResource.getEscapedMessage( messageKey ),
                      headerText: messageResource.getEscapedMessage( headerKey ),
                      value: value
                   });
    };
    pushToItems( "leave_balances_filter.all", "leave_balances_filter.header.all", LeaveBalanceFilter.ALL );
    pushToItems( "leave_balances_filter.pto", "leave_balances_filter.header.pto", LeaveBalanceFilter.PTO );
    pushToItems( "leave_balances_filter.sick", "leave_balances_filter.header.sick", LeaveBalanceFilter.SICK );

    this.filter.addItems( items );
};

LeaveBalancesFilter.prototype.changesCallback = function(value) {
    this.containerElement.toggleClass( "active",this.isActiveFilter(value));
};

LeaveBalancesFilter.prototype.isActiveFilter = function(value){
    return value != LeaveBalanceFilter.ALL;
};

LeaveBalancesFilter.prototype.getValue = function(){
    return this.filter.getSelectedItem().value;
};

LeaveBalancesFilter.prototype.setActiveItemByValue = function(value, suppressChangeEvent) {
    this.filter.setActiveItemByValue(value, suppressChangeEvent);
    if(suppressChangeEvent){
        this.changesCallback(value);
    }
};