Ext.namespace("AT");

AT.UserForLeaveHistorySelectorPanelWithInlineSearch = Ext.extend(AT.UserForLeaveHistorySelectorPanel, {

    createComponents: function()
    {
        AT.UserForLeaveHistorySelectorPanelWithInlineSearch.superclass.createComponents.call(this);

        this.filterFieldPanel = new Ext.Panel({
                                                  html: '<div class="filterWordsFieldPlaceholder"></div>',
                                                  cls: "filterWordsFieldPanel"
                                              });
    },

    getCustomOptionSection: function()
    {
        return [this.filterFieldPanel];
    },

    processFirstPanelOpen: function()
    {
        var context = this;
        AT.UserForLeaveHistorySelectorPanelWithInlineSearch.superclass.processFirstPanelOpen.call(this);

        this.filterWordsField = new FilterWordsField().initAndRender(function() { context.onFilterFieldChanged() },
                                                                     $(context.filterFieldPanel.getEl(), ".filterWordsFieldPlaceholder").get(0),
                                                                     "actiplans.leave_time_history.user_selector.filter_field.placeholder",
                                                                     function() { context.onFilterFieldChanged() });
        this.filterWordsField.alwaysPaintFocusedBorderIfInputHasValue(true);

        $(this.filterWordsField.getInnerInputElement()).off("keydown");
    },

    showCallback: function()
    {
        var context = this;

        if (!this.isAlreadyShown())
            this.processFirstPanelOpen();

        KeyDownHandler.setOnKeyDownHandler(function(event) {
            if (isLetterOrDigitSymbolPressed(event)) {
                context.filterWordsField.activateAndFocus();
            }
        });
        this.canRemoveKeyHandler = true;
        this.panelOpened = true;
    },

    processHide: function ()
    {
        if (!this.panelOpened)
            return false;

        var onlyDeactivatingFilterField = this.filterWordsField.isInputFieldActive() && window.event && isEscapePressed(window.event);
        if (onlyDeactivatingFilterField)
        {
            this.filterWordsField.clearInputValue();
            this.onFilterFieldChanged();
            return false;
        }
        else
        {
            this.filterWordsField.clearInputValue(true);
            if (this.canRemoveKeyHandler)
            {
                this.canRemoveKeyHandler = false;
                KeyDownHandler.restoreOnKeyDownHandler();
            }
            this.panelOpened = false;
            return true;
        }
    }
});