

AT.UsersForMyScheduleSelectorPanel = Ext.extend(AT.UsersSelectorPanel, {
    groupBySettingCookieName: "mySchedulePageUserSelectorGroupBySetting",
    collapsedCookiesKey: "mySchedulePageUserSelector",
    closeButtonLabelKey: "my_schedule.users_selector.apply_and_close.button.caption",
    labelItemNounPluralKey: "my_schedule.users_selector.label.plural",
    allItemsOptionValue: true,
    customOptionValue: false,
    showShowInactiveCheckbox: false,

    createFooterButtons: function() {
        this.resetButton = new AT.FlatButton({
            icon: atImgPath("undo.gif"),
            text: messageResource.getMessage(this.resetButtonLabelKey)
        });

        this.closeButton = new AT.GradientButton({
            text: messageResource.getMessage(this.closeButtonLabelKey),
            minWidth: 60,
            cls: "greyButton close-button"
        });
    },

    getFooterSection: function() {
        return [this.closeButton, this.resetButton];
    },

    saveCurrentState: function()
    {
        var selection = this.getUserSelection();
        this.setPredefinedParameters( this.getPredefinedParameters(selection));
        this.updateInitialGroupType();
    },


    getUserSelection: function(){
        var selection = this.getSelection();
        return {
            allUsers:!this.isCustomOptionSelected(),
            selectedGroups : selection.getFirstLevel(),
            selectedUsers : selection.getSecondLevel(),
            groupType : this.getGroupType()
        }
    },

    initialize: function (userGroupsEnabled, timeZoneGroupsEnabled, users, userGroups, timeZoneGroups, selection)
    {
        AT.UsersForMyScheduleSelectorPanel.superclass.initialize.call(this, userGroupsEnabled, timeZoneGroupsEnabled, users, userGroups, timeZoneGroups);
        this.updateSelector(selection);

    },

    updateSelector: function(selection){
        this.loadState(this.getPredefinedParameters(selection));
        this.updateState();
        this.saveCurrentState();
    },

    makeSelectionHelper: function() {

        AT.UsersForMyScheduleSelectorPanel.superclass.makeSelectionHelper.call(this);
        this.selectionHelper.userGroupMessageKey = "common.User_Group";
        this.selectionHelper.timeZoneGroupMessageKey = "common.Time_Zone_Group";
    },


    getPredefinedParameters: function(selection){
        return {
            optionValue: selection.allUsers,
            selection: selection.allUsers ? TwoLevelSelection.emptySelection()
                    : new TwoLevelSelection(selection.selectedGroups, selection.selectedUsers)
        }
    },

    createEmptyMessageBuilder: function() {
        return new UsersForMyScheduleSelectorEmptyMessageBuilder(this.userSelectorGroupsStrategy);
    },

    getAllItemsOptionLabelKey: function()
    {
        if (SystemSettings.apUGREnabled && SystemSettings.apScheduleColleaguesVisibility === ColleaguesVisibility.USER_GROUP_ONLY)
        {
            return "my_schedule.users_selector.all_users_from_my_department";
        }
        if (SystemSettings.apTZGEnabled && SystemSettings.apScheduleColleaguesVisibility === ColleaguesVisibility.TIME_ZONE_GROUP_ONLY)
        {
            return "my_schedule.users_selector.all_users_from_my_timezone";
        }
        return "my_schedule.users_selector.all_users";

    },

    getCustomOptionLabelKey: function()
    {
        if (SystemSettings.apUGREnabled && SystemSettings.apScheduleColleaguesVisibility === ColleaguesVisibility.USER_GROUP_ONLY)
        {
            return "my_schedule.users_selector.selected_users_from_my_department";
        }
        if (SystemSettings.apTZGEnabled && SystemSettings.apScheduleColleaguesVisibility === ColleaguesVisibility.TIME_ZONE_GROUP_ONLY)
        {
            return "my_schedule.users_selector.selected_users_from_my_timezone";
        }
        return "my_schedule.users_selector.selected_users";
    }
});