Ext.namespace("AT");

/**
 * Selector panel for the leave types list in aP.
 *
 * @constructor
 */
AT.APLeaveTypesSelectorPanel = Ext.extend(AT.BaseLeavesSelectorPanel, {
    allItemsOptionLabelKey: 'leaves_selector.options.all_items_with_bold',
    customOptionLabelKey: "leaves_selector.options.custom",
    showInactiveLabelKey: "leaves_selector.show_disabled",

    labelNoItemsSelectedKey: "leaves_selector.options.all_leave_types",
    labelItemNounPluralKey: "leaves_selector.label.leave_types",
    labelDisabledMultipleKey: "leaves_selector.label.disabled_multiple",
    labelItemNounSingularKey: "leaves_selector.label.singular",

    cls: "selector-panel leave-types-selector-panel",
    closeButtonLabelKey: "leaves_selector.close_button.label",

    createCustomOption: function ()
    {
        this.customOption = new Ext.form.Radio({
                                                   boxLabel: messageResource.getMessage('leaves_selector.options.custom_with_bold'),
                                                   name: this.realOptionsName,
                                                   inputValue: this.customOptionValue
                                               });
    },

    getAllSelectedString: function(maxLength) {
        return messageResource.getMessage('leaves_selector.options.all_leave_types');
    },

    createFooterButtons: function() {
        this.resetButton = new AT.FlatButton({
                                                 icon: atImgPath("undo.gif"),
                                                 text: messageResource.getMessage(this.resetButtonLabelKey)
                                             });
        this.closeButton = new AT.GradientButton({
                                              text: messageResource.getMessage(this.closeButtonLabelKey),
                                              minWidth: 60,
                                              cls: "greyButton close-button"
                                          });
    }
});


Ext.reg("at_leave_types_selector_panel", AT.APLeaveTypesSelectorPanel);