function RequestResolutionDialog (){
    this.constructor = RequestResolutionDialog;
}

RequestResolutionDialog.prototype.init = function(userInfo, leaveTimeId, isPast, callBacks, maxCommentLenght)
{

    var that = this;

    this.userName =  UserNameFormat.formatFML(escapeHtmlSymbols(userInfo.firstName),
                                              escapeHtmlSymbols(userInfo.lastName),
                                              escapeHtmlSymbols(userInfo.middleInitial));
    this.leaveTypeId =leaveTimeId;
    this.past = isPast;

    this.callBacks=callBacks;

    var dialogDiv = $("#requestResolutionDialog");

    //todo fantaev  make it as subId function
    this.titlePrefixEl = document.getElementById("requestResolutionDialog_titlePrefix");
    this.titleEl = document.getElementById("requestResolutionDialog_userName");
    this.selectedLeaveTypeEl = document.getElementById("selectedLeaveType_title");
    this.leaveTypeImage = document.getElementById("selectedLeaveType_image");
    this.commentEl = document.getElementById("requestResolutionDialog_comment");

    this._textareaManager = new TextAreaLengthManager();
    this._textareaManager.init(
                            this.commentEl,
                            maxCommentLenght,
                            messageResource.getMessage("actiplans.leave_time_planning.long_comment")
    );

    $(this.commentEl).attr('placeholder', messageResource.getMessage("actiplans.leavestable.request_resolution.enter_reason") ).placeholder();

    this.dialog = dialogDiv.dialog({
                                       autoOpen: false,
                                       draggable: false,
                                       resizable: false,
                                       modal: true, // this is needed for overlay to appear, so we can handle 'outside' clicks to close the dialog
                                       close: this.callBacks.closed,
                                       width: 340,
                                       dialogClass: "requestResolutionDialog"
                                   });


    doOnceOnWindowResize( function () { that.close(); } );

    return this;
};

RequestResolutionDialog.prototype.close = function (){
    this.dialog.dialog("close");
};

RequestResolutionDialog.prototype.onSubmitCallback = function ( comment ){
    this.callBacks.submitted( comment );
    this.dialog.dialog('close');
};

//abstract
RequestResolutionDialog.prototype._createButtons = function ( buttonsPane ){

};

//abstract
RequestResolutionDialog.prototype._getTitlePrefix = function (){

};


RequestResolutionDialog.prototype._fillInPanel = function ( buttonsPane ){
    this._setTitle();
    this._fillInButtonPane( buttonsPane );
    this._setLeaveType( );
};

RequestResolutionDialog.prototype._fillInButtonPane = function ( buttonsPane ){
    this._createButtons(buttonsPane);
    var cancelButton = this._createButton(buttonsPane, messageResource.getMessage("actiplans.leavestable.resolution_dialog.cancel"), "cancelButton");
    var self = this;
    $(cancelButton).click( function () { self.dialog.dialog('close'); } );
};

RequestResolutionDialog.prototype._setTitle = function (){
    this.titlePrefixEl.innerHTML=this._getTitlePrefix();
    this.titleEl.innerHTML=this.userName;
};

RequestResolutionDialog.prototype._setLeaveType = function ( leaveTypeId ){
    var url = LEAVE_TYPES[  this.leaveTypeId ].getIconPath();
    var name = LEAVE_TYPES[ this.leaveTypeId ].name;

    this.leaveTypeImage.src = url;
    this.selectedLeaveTypeEl.innerHTML= escapeHtmlSymbols(name);
};

RequestResolutionDialog.prototype._createButton = function ( buttonsPane, text, className, withIcon ) {

    var buttonEl = document.createElement( "div" );
    var additionalClass = className ?  className : "";

    if ( withIcon ) {
        var spanEl = document.createElement( "span" );
        spanEl.innerHTML = text;
        spanEl.className = "buttonIcon";
        additionalClass += " withIcon";
        buttonEl.appendChild( spanEl );
    } else {
        buttonEl.innerHTML = text;
        additionalClass += " noIcon";
    }

    buttonEl.className = "greyButton " + additionalClass;

    buttonsPane[0].appendChild( buttonEl );

    return buttonEl;
};

RequestResolutionDialog.prototype.outerWidth = function() {
    return this.dialog.parent().outerWidth();
};

RequestResolutionDialog.prototype.outerHeight = function() {
    return this.dialog.parent().outerHeight();
};

RequestResolutionDialog.prototype.show = function( showElement )
{
    var me = this;

    this.dialog.dialog( "option", "buttons", [{text: "", "class": "hiddenButton" }]);

    var buttonsPane = this.dialog.parent().find(".ui-dialog-buttonpane" );

    buttonsPane[0].innerHTML = '';

    this._fillInPanel( buttonsPane );

    $( this.commentEl ).pVal("");

    this.dialog.dialog( "open" );

    // when the dialog is created, it is wrapped into a container, that's why we use parent()
    showElement.call(this.dialog.parent());

    // close the dialog when user clicks outside
    $('.ui-widget-overlay').click( function() { me.dialog.dialog('close'); } );

    this._textareaManager.update();

    //to show placeholder text inside textarea
    this.dialog.focus();
};

RequestResolutionDialog.prototype.showAt = function ( element, offset )
{
    this.show(function() {
        this.position({
                          of: $( element ),
                          my: "left top",
                          at: "left bottom",
                          offset: offset,
                          collision: "flip"
                      });
    });
};



/*-----  APPROVE DIALOG----------*/

function RequestApproveDialog (){
    this.constructor = RequestApproveDialog;
}

RequestApproveDialog.prototype = _.create(RequestResolutionDialog.prototype);

RequestApproveDialog.prototype.init = function(userInfo, leaveTimeRequestId, isPast, callBacks, maxCommentLenght)
{
    RequestResolutionDialog.prototype.init.call(this, userInfo, leaveTimeRequestId, isPast, callBacks, maxCommentLenght);
    return this;
};

RequestApproveDialog.prototype._createButtons = function (buttonsPane){
    var self = this;
    var buttonElement = this._createButton(buttonsPane,  messageResource.getMessage( "actiplans.leavestable.resolution_dialog.approve") , "approveButton", true );
    var onclickHandler = function () {
        var comment = trim( $( self.commentEl ).pVal() ); //function to get text from element with placeholder plugin
        self.onSubmitCallback( comment )
    };

    this._textareaManager.setDependentButton(buttonElement, onclickHandler);
};

RequestApproveDialog.prototype._getTitlePrefix = function()
{
    return this.past ? messageResource.getMessage("actiplans.leavestable.resolution_dialog.approve_past_request")
            : messageResource.getMessage("actiplans.leavestable.resolution_dialog.approve_request");

};

/*-----  REJECT DIALOG----------*/

function RequestRejectDialog (){
    this.constructor = RequestRejectDialog;
}

RequestRejectDialog.prototype = _.create(RequestResolutionDialog.prototype);

RequestRejectDialog.prototype.init = function(userInfo, leaveTimeRequestId, isPast, callBacks, maxCommentLenght)
{
    RequestResolutionDialog.prototype.init.call(this, userInfo, leaveTimeRequestId, isPast, callBacks, maxCommentLenght);
    return this;
};

RequestRejectDialog.prototype._createButtons = function ( buttonsPane ){

    var self = this;
    var buttonElement = this._createButton( buttonsPane, messageResource.getMessage( "actiplans.leavestable.resolution_dialog.reject"), "rejectButton", true );
    var onclickHandler = function () {
        var comment = trim( $( self.commentEl ).pVal() ); //function to get text from element with placeholder plugin
        self.onSubmitCallback( comment )
    };

    this._textareaManager.setDependentButton(buttonElement, onclickHandler);
};

RequestRejectDialog.prototype._getTitlePrefix = function()
{
    return this.past ? messageResource.getMessage("actiplans.leavestable.resolution_dialog.reject_past_request")
            : messageResource.getMessage("actiplans.leavestable.resolution_dialog.reject_request");
};



