/**
 * @author filatov
 */

function APIntegrationSection(){}

APIntegrationSection.prototype = _.create(IntegrationSection.prototype, {

    setCustomChangeState: function(state){
        switch (state){
            case IntegrationStates.REQUESTS_IN_PAST_NOT_APPROVE:
                this.pastLeaveRequestsApproveBlock = this.initAndShowPastLeaveRequestApproveBlock();
                break;
        }
    },

    initAndShowPastLeaveRequestApproveBlock: function(){
        var self = this;
        this._blockEl = this._getIntegrationStateBlock("pastRequestsNotApproved");
        this._blockEl.find(".cancelButton").off()
                .on("click", function(){self.setState(IntegrationStates.ACCOUNT_DOES_NOT_EXIST)});
        this._blockEl.find(".applyButton").off()
                .on("click", function(){
                    self._integrateProduct([self._getOperationForPastRequests()]);
                });
        this._blockEl.show();
        this.runSpinner(BaseIntegrationSection.additionalRequestSpinnerOptions,  this._blockEl.find(".spinnerPlaceholder")[0]);
    },

    _integrationRpcErrorHandler: function( jqXHR, textStatus, errorThrown){
        if( errorThrown.exception == 'com.actimind.actiplans.services.IntegrationService$HasPastLeaveRequestsException')
        {
            this.setState( IntegrationStates.REQUESTS_IN_PAST_NOT_APPROVE );
            return true;
        }
        return IntegrationSection.prototype._integrationRpcErrorHandler.call(this,jqXHR, textStatus, errorThrown );
    },

    _getOperationForPastRequests : function(){
        return this._getIntegrationStateBlock("pastRequestsNotApproved").find("input[type='radio'][name='pastRequestOperation']:checked").val();
    }
});

