APReportsPage.BalanceHistoryPage = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

APReportsPage.BalanceHistoryPage.prototype = _.create(APReportsPage.SubPage.prototype, {
    html: "<div id='balanceHistoryPage'>" +
          "<div class='printOnly'></div>" +
          " <div id='balanceHistoryConfigurationPanel' class='balanceHistorySelectors reportPageHeaderFooter'></div>" +
          " <div class='pdfActionError'></div>" +
          " <div class='balanceHistoryPageContent'>" +
          "     <div id='balancesViewer' class='balancesViewer'></div>" +
          "     <div id='balancesViewerSpinner'></div>" +
          "     <div id='ptoBalanceHistoryTablePlaceholder'></div>" +
          "     <div id='sickBalanceHistoryTablePlaceholder'></div>" +
          " </div>" +
          "</div>",

    afterRender: function()
    {
        var historyMoire = new LoadingMoire($(".balanceHistoryPageContent"), APReportsPageUtils.SPINNER_SETTINGS).init();
        this.printableHeader = new APReportsPage.BalanceHistoryPage.PrintableHeader(this.$containerEl.find('.printOnly')).init();
        if (hasServerSideErrors)
        {
            this.find(".pdfActionError").append($("#apReport_generatePDFErrors"));
        }

        var self = this;
        $(document).on("apReports.balanceHistoryPage.beginLoadSickHistory", function() {historyMoire.show()});
        $(document).on("apReports.balanceHistoryPage.beginLoadPTOHistory", function() {historyMoire.show()});
        $(document).on("apReports.balanceHistoryPage.endLoadSickHistory", function() {historyMoire.hide(); self.update();});
        $(document).on("apReports.balanceHistoryPage.endLoadPTOHistory", function() {historyMoire.hide(); self.update();});
    },

    update: function()
    {
        this.printableHeader.update();
        this._updateVisibilityClasses();
        PageOverlayTipsManager.getInstance().refreshDynamicTips();
    },

    _updateVisibilityClasses: function()
    {
        var store = APReportsPage.BalanceHistoryPage.Store;
        this.$el.toggleClass("viewSick", store.getBalanceType() == BalanceHistory.BalanceTypes.SICK);
        this.$el.toggleClass("viewPTO", store.getBalanceType() == BalanceHistory.BalanceTypes.PTO);
        this.$el.toggleClass("sickControlOffWarn", !store.isBalanceControlOn() && store.getBalanceType() == BalanceHistory.BalanceTypes.SICK);
        this.$el.toggleClass("ptoControlOffWarn", !store.isBalanceControlOn() && store.getBalanceType() == BalanceHistory.BalanceTypes.PTO);
    }
});