APReportsPage.BalanceHistoryPage.BalancesViewerController = function($containerEl) {BaseBalancesViewerController.call(this, $containerEl)};

APReportsPage.BalanceHistoryPage.BalancesViewerController.prototype = _.create(BaseBalancesViewerController.prototype, {

    createBalanceViewer: function($containerEl)
    {
        return new APReportsPage.BalanceHistoryPage.SingleBalanceViewer($containerEl);
    },

    getUserWorkScheduleData: function()
    {
        return APReportsPage.BalanceHistoryPage.Store.getUserWorkScheduleData();
    },

    getFormatterSettings: function()
    {
        return APReportsPage.BalanceHistoryPage.Store.getFormatterSettings();
    },

    onDateChange: function(e, selectedDate)
    {
        $(document).trigger("apReports.balanceHistoryPage.balancesViewerDateChange", selectedDate);
    },

    _getConfig: function()
    {
        var store = APReportsPage.BalanceHistoryPage.Store;
        var displayPto = BalanceHistory.BalanceTypes.PTO == store.getBalanceType();
        var formatterSettings = this.getFormatterSettings();

        return _.extend(BaseBalancesViewerController.prototype._getConfig.call(this), {
            displayPto: displayPto,
            showInHours: displayPto ? formatterSettings.showPTOInHours: formatterSettings.showSickInHours
        });
    },

    _reInitBalanceViewer: function(config)
    {
        var userWorkScheduleData = this.getUserWorkScheduleData();
        if (_.isNull(userWorkScheduleData))
            return false;

        if (this.displayPto != config.displayPto)
        {
            this.displayPto = config.displayPto;
            this.balancesViewer.updateBalanceType(config);
        }

        return BaseBalancesViewerController.prototype._reInitBalanceViewer.call(this, config);
    }
});
