APReportsPage.BalanceHistoryPage.PrintableHeader = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

APReportsPage.BalanceHistoryPage.PrintableHeader.prototype = _.create(TemplateView.prototype, {
    html: "<div class='pagetitle'></div>" +
          "<div class='printableDateRangeHeader'></div>",

    afterRender: function()
    {
        this.$printableDateRange = this.$containerEl.find('.printableDateRangeHeader');
        this.$title = this.$containerEl.find('.pagetitle');
        this.dateFormat = new DateFormat(SystemSettings.dateFormat);
    },

    update: function()
    {
        var user = _.find(APReportsStore.getVisibleUsers(), function(user) {return user.id == APReportsPage.BalanceHistoryPage.Store.getSelectedUserId()});
        var userFormattedName = UserNameFormat.formatFML(user.firstName, user.lastName, user.middleName);
        var balanceTypeMessageKey = APReportsPage.BalanceHistoryPage.Store.getBalanceType() == BalanceHistory.BalanceTypes.PTO ?
                                    "actiplans.reports.tabs.pto.print" :
                                    "actiplans.reports.tabs.sick.print";

        var title = messageResource.getMessage("actiplans.reports.tabs.balance_history.print",
                                               [messageResource.getMessage(balanceTypeMessageKey), userFormattedName]);
        this.$title.text(title);

        this.$printableDateRange.text(
                messageResource.getMessage("actiplans.reports.balance_history.printable_date",
                                           [this.dateFormat.formatDate(currentUserTime().clearTime())]));
    }
});
