APReportsPage.BalanceHistoryPage.Store = {

    formatterSettings: {
        workHoursPerDay: 8,
        showPTOInHours: false,
        showSickInHours: false
    },

    ptoHistorySettings: {
        recordsPerPage: 10,
        pageSet: []
    },

    sickHistorySettings: {
        recordsPerPage: 10,
        pageSet: []
    },

    selectedUserId: null,
    userSelectorState: null,

    balanceType: BalanceHistory.BalanceTypes.PTO,
    sickModels: [],
    ptoModels: [],

    backup: {},

    balancesViewerBalance: null,
    balancesViewerDate: null,
    workScheduleData: {
        hireDate: null,
        releaseDate: null,
        initialSchedule: [],
        schedules: []
    },
    balanceControlOn: true,

    setFormatterSettings: function(formatterConfig)
    {
        this.formatterSettings = formatterConfig;
    },

    getFormatterSettings: function()
    {
        return this.formatterSettings;
    },

    getBalanceType: function()
    {
        return this.balanceType;
    },

    setBalanceType: function(type)
    {
        this.balanceType = type;
        $(this).trigger("balanceTypeChanged");
    },

    setSickModels: function(sickModels)
    {
        this.sickModels = sickModels;
    },

    getSickModels: function()
    {
        return this.sickModels;
    },

    setPTOModels: function(ptoModels)
    {
        this.ptoModels = ptoModels;
    },

    getPTOModels: function()
    {
        return this.ptoModels;
    },

    getPTOHistorySettings: function()
    {
        return this.ptoHistorySettings;
    },

    getSickHistorySettings: function()
    {
        return this.sickHistorySettings;
    },

    setPTOHistorySettings: function(newSettings)
    {
        this.ptoHistorySettings.recordsPerPage = newSettings.balanceHistoryRecordsPerPage;
        if (!_.isUndefined(newSettings.pageSet))
        {
            this.ptoHistorySettings.pageSet = newSettings.pageSet;
        }
        $(this).trigger("ptoHistorySettingsChanged");
    },

    setSickHistorySettings: function(newSettings)
    {
        this.sickHistorySettings.recordsPerPage = newSettings.balanceHistoryRecordsPerPage;
        if (!_.isUndefined(newSettings.pageSet))
        {
            this.sickHistorySettings.pageSet = newSettings.pageSet;
        }
        $(this).trigger("sickHistorySettingsChanged");
    },

    setCommonSettings: function(newSettings)
    {
        this.setBalanceType(newSettings.balanceType == BalanceType.PTO ? BalanceHistory.BalanceTypes.PTO : BalanceHistory.BalanceTypes.SICK);
        this.setSelectedUserId(newSettings.selectedUserId);
        this.setBalancesViewerDate(newSettings.balanceViewerDate);
    },

    getSelectedUserId: function()
    {
        return this.selectedUserId;
    },

    setSelectedUserId: function(selectedUserId)
    {
        this.selectedUserId = selectedUserId;
        $(this).trigger("selectedUserIdChanged");
    },

    setUserSelectorState: function(userSelectorState)
    {
        this.userSelectorState = userSelectorState;
    },

    getUserSelectorState: function()
    {
        return this.userSelectorState;
    },

    backupSelectors: function()
    {
        this.backup.selectedUserId = this.getSelectedUserId();
        this.backup.userSelectorState = this.getUserSelectorState();
        this.backup.balanceType = this.getBalanceType();
        this.backupBalancesViewerDate();
    },

    restoreSelectors: function()
    {
        this.setSelectedUserId(this.backup.selectedUserId);
        this.setUserSelectorState(this.backup.userSelectorState);
        this.setBalanceType(this.backup.balanceType);
        this.restoreBalancesViewerDate();
    },

    backupBalancesViewerDate: function()
    {
        this.backup.balancesViewerDate = this.getBalancesViewerDate();
    },

    restoreBalancesViewerDate: function()
    {
        this.setBalancesViewerDate(this.backup.balancesViewerDate);
    },

    setBalancesViewerBalance: function(balance)
    {
        this.balancesViewerBalance = balance;
    },

    getBalancesViewerBalance: function()
    {
        return this.balancesViewerBalance;
    },

    setBalancesViewerDate: function(date)
    {
        this.balancesViewerDate = date;
    },

    getBalancesViewerDate: function()
    {
        return this.balancesViewerDate;
    },

    setUserWorkScheduleData: function(workScheduleData)
    {
        this.workScheduleData = workScheduleData;
    },

    getUserWorkScheduleData: function()
    {
        return this.workScheduleData;
    },

    setBalanceControlOn: function(controlOn)
    {
        this.balanceControlOn = controlOn;
    },

    isBalanceControlOn: function()
    {
        return this.balanceControlOn;
    }
};