// TODO: separate Sick and Pto Pagers from Table classes

APReportsPage.BalanceHistoryPage.Table = function($containerEl)
{};

APReportsPage.BalanceHistoryPage.Table.prototype = _.create(BalanceHistory.Table.prototype, {
    html: "<div class='balanceHistoryTableContainer'>" +
          "  <table class='balanceHistoryTable display-for-print dataTable' cellspacing='0' cellpadding='0'><thead></thead><tbody></tbody></table>" +
          "  <div class='historyPagerPlaceholder'></div>" +
          "</div>",

    _initPagerController: function(pagerModel)
    {
        var that = this;
        this._pagerController = new PagerController().init(
                {
                    pagerData: {
                        pageNum: 1,
                        recordsPerPage: this._getHistorySettings().recordsPerPage,
                        totalRecords: this.getBalanceModels().length
                    },
                    handlersMap: {
                        pageChanged: function(pageNum)
                        {
                            var recordsPerPage = that._getHistorySettings().recordsPerPage;
                            that.renderPage(pageNum, recordsPerPage);
                            that._pagerController.setPagerStateAndUpdateUI(that.getBalanceModels().length, pageNum,
                                                                           recordsPerPage);
                        },
                        recordsPerPageChanged: function(recordsPerPage)
                        {
                            $(document).trigger(that._changeHistorySettingsEvent, {recordsPerPage: recordsPerPage});
                        }
                    },
                    pagerControlsElementId: pagerModel.pagerPanelId,
                    pagerElementId: pagerModel.prefix + "pager",
                    recordsPerPageSelectorId: pagerModel.prefix + "recordsPerPageSelector",
                    minRecordsPerPage: this._getHistorySettings().pageSet[0],
                    ignoreHashChange: true
                });
    },

    renderPage: function (pageNum, recordsPerPage) {
        var index1 = recordsPerPage*(pageNum-1);
        this.$balanceRows.find("> tr.visible" ).removeClass("visible lastRow");
        this.$balanceRows.find("> tr:eq("+index1+")").addClass("visible" );
        this.$balanceRows.find("> tr:gt("+index1+"):lt("+(recordsPerPage-1)+")").addClass("visible" ).last().addClass("lastRow");
    },

    afterRender: function()
    {
        BalanceHistory.Table.prototype.afterRender.call(this);
        this._initPagerView();
        var pagerModel = this.pagerView.templateModel();
        this._initPagerController(pagerModel);
        this.$totalRecordsPlaceholder = this.find("#" + pagerModel.prefix + "totalRecordsPlaceholder");
        this._updateTotalRecords();
        var pagerController = this._pagerController;
        pagerController.loadPage(1);
        $(APReportsPage.BalanceHistoryPage.Store).on(this._historySettingChangedEvent, function()
        {
            pagerController.loadPage(1);
        });
    },

    update: function()
    {
        BalanceHistory.Table.prototype.update.call(this);
        this._pagerController.loadPage(1);
        this._updateTotalRecords();
    },

    _updateTotalRecords: function()
    {
        this.$totalRecordsPlaceholder.text(this.getBalanceModels().length);
    }
});

APReportsPage.BalanceHistoryPage.SickTable = function($containerEl)
{
    var formatterConfig = APReportsPage.BalanceHistoryPage.Store.getFormatterSettings();
    BalanceHistory.Table.call(this, $containerEl, formatterConfig.workHoursPerDay, formatterConfig.showSickInHours);
};

APReportsPage.BalanceHistoryPage.SickTable.prototype = _.create(APReportsPage.BalanceHistoryPage.Table.prototype, {

    getBalanceModels: function()
    {
        return APReportsPage.BalanceHistoryPage.Store.getSickModels();
    },

    getBalanceType: function()
    {
        return BalanceHistory.BalanceTypes.SICK;
    },

    templateModel: function()
    {
        return {
            balanceTypeClass: BalanceHistory.BalanceTypes.SICK
        }
    },

    _getHistorySettings: function()
    {
        return APReportsPage.BalanceHistoryPage.Store.getSickHistorySettings();
    },

    _initPagerView: function()
    {
        this.pagerView = new APReportsPage.BalanceHistoryPage.Table.SickPager(this.find(".historyPagerPlaceholder")).init();
    },

    _changeHistorySettingsEvent: "apReports.balanceHistoryPage.SickTable.changeHistorySettings",

    _historySettingChangedEvent: "sickHistorySettingsChanged"

});


APReportsPage.BalanceHistoryPage.PTOTable = function($containerEl)
{
    var formatterConfig = APReportsPage.BalanceHistoryPage.Store.getFormatterSettings();
    BalanceHistory.Table.call(this, $containerEl, formatterConfig.workHoursPerDay, formatterConfig.showPTOInHours);
};

APReportsPage.BalanceHistoryPage.PTOTable.prototype = _.create(APReportsPage.BalanceHistoryPage.Table.prototype, {

    getBalanceModels: function()
    {
        return APReportsPage.BalanceHistoryPage.Store.getPTOModels();
    },

    getBalanceType: function()
    {
        return BalanceHistory.BalanceTypes.PTO;
    },

    templateModel: function()
    {
        return {
            balanceTypeClass: BalanceHistory.BalanceTypes.PTO
        }
    },

    _getHistorySettings: function()
    {
        return APReportsPage.BalanceHistoryPage.Store.getPTOHistorySettings();
    },

    _initPagerView: function()
    {
        this.pagerView = new APReportsPage.BalanceHistoryPage.Table.PTOPager(this.find(".historyPagerPlaceholder")).init();
    },

    _changeHistorySettingsEvent: "apReports.balanceHistoryPage.PTOTable.changeHistorySettings",

    _historySettingChangedEvent: "ptoHistorySettingsChanged"
});