APReportsPage.ConfigPanel.DateRangeSelectorCell = function($containerEl, dateRangeSelection, eventConfigCreate, eventConfigChange) {
    TemplateView.call(this, $containerEl);
    this.dateRangeSelection = dateRangeSelection;
    this.eventConfigCreate = eventConfigCreate;
    this.eventConfigChange = eventConfigChange;
};

APReportsPage.ConfigPanel.DateRangeSelectorCell.prototype = _.create(TemplateView.prototype, {
    html: "<table id='dateRangeSelectorSection'>" +
          "   <tr>" +
          "      <td class='reportFormBlockBodyCell'>" +
          "         <div id='dateSelector' class='customDateRangeSelectorPanel'></div>" +
          "      </td>" +
          "   </tr>" +
          "</table>",


    afterRender: function()
    {
        var self = this;
        var dateRangeSelectorConfig = {
            dateRangeParsed: true,
            dateRangeSelection: this.dateRangeSelection,
            menuStates: new DateRangeMenuItemsUtil().createDateRangeMenuItemsWithFuture(function(){return true;})
        };
        this.dateRangeSelector = new DateRangeSelectorController().init(dateRangeSelectorConfig);

        if (this.dateRangeSelector)
        {
            this.dateRangeSelector.setOnChangeCallback(function() {self.onDateRangeChanged(self.eventConfigChange)});
        }

        this.onDateRangeChanged(this.eventConfigCreate);
    },

    onDateRangeChanged: function(eventName)
    {
        $(document).trigger(eventName, {dateRangeSelection: this.dateRangeSelector.getSelectedRange()});
    }
});
