APReportsPage.HeaderTab = function() {};

APReportsPage.HeaderTab.prototype = _.create(TemplateView.prototype, {

    update: function(selectedId)
    {
        var tabId = selectedId || APReportsStore.getSelectedTabId();
        this.updateVisualClasses(tabId);
    },

    updateVisualClasses: function(selectedId)
    {
        this.$containerEl.toggleClass("selected", selectedId == this.getTabId());
    },

    getTabId: function()
    {
        return this.$containerEl.attr('id');
    },

    afterRender: function()
    {
        if (!this.pageInfo.confirm())
        {
            this.$containerEl.addClass("disabled");
        }
    }
});


// Leave Time Report Tab
APReportsPage.LeaveTimeReportsTab = function($element)
{
    TemplateView.call(this, $element);
};

APReportsPage.LeaveTimeReportsTab.prototype = _.create(APReportsPage.HeaderTab.prototype, {
    html: "<span class='tabContainer'><span class='textTab'><%=tabTitle%></span></span>" +
          "<span class='titleSeparator'>&nbsp;</span>",

    pageInfo: APReportsPageInfo.LEAVE_TIME_REPORT,

    messageKeys: function()
    {
        var balanceCalculationOn = SystemSettings.apSickBalanceCalculationEnabled || SystemSettings.apPtoBalanceCalculationEnabled;
        return {
            "tabTitle": balanceCalculationOn ?
                        this._enabledBalancesMessageKey("actiplans.reports.tabs.leave_time_and_balances_report") :
                        "actiplans.reports.tabs.leave_time_report"
        }
    },

    _enabledBalancesMessageKey: function(baseKey)
    {
        if (!SystemSettings.apSickBalanceCalculationEnabled)
            baseKey += '.pto';
        else if (!SystemSettings.apPtoBalanceCalculationEnabled)
            baseKey += '.sick';

        return baseKey;
    }
});


// Past Leaves Calendar Tab
APReportsPage.PastLeavesCalendarTab = function($element)
{
    TemplateView.call(this, $element);
};

APReportsPage.PastLeavesCalendarTab.prototype = _.create(APReportsPage.HeaderTab.prototype, {
    html: "<span class='tabContainer'><span class='textTab'><%=tabTitle%></span></span>",

    pageInfo: APReportsPageInfo.PAST_LEAVES_CALENDAR,

    messageKeys: function()
    {
        var tabTitleKey = (APReportsStore.getVisibleUsers().length > 1) ?
                          "actiplans.reports.tabs.past_leaves_calendar" : "actiplans.reports.tabs.my_past_leaves_calendar";
        return {
            "tabTitle": tabTitleKey
        }
    }
});


// Balances History Tab
APReportsPage.BalanceHistoryTab = function($element)
{
    TemplateView.call(this, $element);
};

APReportsPage.BalanceHistoryTab.prototype = _.create(APReportsPage.HeaderTab.prototype, {
    html: "<span class='titleSeparator'>&nbsp;</span>" +
          "<span class='tabContainer'><span class='textTab'><%=tabTitle%></span></span>",

    pageInfo: APReportsPageInfo.BALANCE_HISTORY,

    messageKeys: function()
    {
        var tabTitleKey = (APReportsStore.getVisibleUsers().length > 1) ?
                          "actiplans.reports.tabs.balance_history" : "actiplans.reports.tabs.my_balance_history";
        return {
            "tabTitle": tabTitleKey
        }
    }
});