APReportsPage.LeaveTimeBalancesReportPage = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

APReportsPage.LeaveTimeBalancesReportPage.prototype = _.create(APReportsPage.SubPage.prototype, {
    html: "<div class='leaveTimeBalancesReportPage'>" +
          "  <div class='printOnly'></div>" +
          "  <div id='leaveTimeConfigurationPanel' class='reportPageHeaderFooter'></div>" +
          "  <div class='leaveTimeBalancesReportPageContent'>" +
          "    <div class='reportLoadingError'></div>" +
          "    <div id='leaveTimeAndBalancesChartSectionContainer'></div>" +
          "    <div class='tableContainer'></div>" +
          "    <div class='notemsg'><div class='noteMark'><%=balanceNoteLabel%></div></div>" +
          "  </div>" +
          "  <div class='pdfPreviewLightboxContainer'></div>" +
          "</div>",

    afterRender: function()
    {
        var printeableHeader = new APReportsPage.LeaveTimeBalancesReportPage.PrintableHeader(this.$el.find('.printOnly')).init();
        this.$errorPlaceHolder = this.$containerEl.find('.reportLoadingError');
        this.$el.toggleClass("noBalances", !SystemSettings.apPtoBalanceCalculationEnabled && !SystemSettings.apSickBalanceCalculationEnabled);
        this.$el.toggleClass("noRightsToManageBalances", !UserRights.LEAVE_BALANCE_MANAGER);

        var loadingMoire = new LoadingMoire(this.find(".leaveTimeBalancesReportPageContent"), APReportsPageUtils.SPINNER_SETTINGS).init();
        $(document).on("apReports.leaveTimeBalancesReport.beginLoadReportData", function() { loadingMoire.show(); });
        $(document).on("apReports.leaveTimeBalancesReport.endLoadReportData", function() { loadingMoire.hide(); printeableHeader.update(); });
    },

    showReportError: function(errorMessage)
    {
        this.$errorPlaceHolder.html(errorMessage);
        this.$containerEl.toggleClass('withError', true);
    },

    hideReportError: function()
    {
        this.$containerEl.toggleClass('withError', false);
    },

    messageKeys: function()
    {
        var pto = SystemSettings.apPtoBalanceCalculationEnabled;
        var sdb = SystemSettings.apSickBalanceCalculationEnabled;
        return {
            balanceNoteLabel: !pto ? "report.leaves.sick_shown_within_date_range" :
                              !sdb ? "report.leaves.pto_shown_within_date_range" :
                              "report.leaves.balances_shown_within_date_range"
        }
    }
});