APReportsPage.LeaveTimeBalancesReportPage.Mediator = function() {};

APReportsPage.LeaveTimeBalancesReportPage.Mediator.prototype = _.create(PageMediator.prototype, {
    getPage: function()
    {
        return this.page
    },

    beforeOpenPageFirstTime: function()
    {
        this.tipsManager = new LeaveTimeBalancesPageOverlayTipsManager();
        var self = this;

        this.page = new APReportsPage.LeaveTimeBalancesReportPage($("#apLeaveTimeReportPlaceholder")).init();

        // ConfigPanel initialization
        var reportParameters = APReportsPage.LeaveTimeBalancesReportPage.Store.getReportParams();
        var configPanel = new APReportsPage.LeaveTimeBalancesReportPage.ConfigPanel($("#leaveTimeConfigurationPanel")).init();

        $(document).on("apReports.leaveTimeBalancesReport.reportConfig.create", function(e, config)
        {
            self._saveReportConfig(config);
        });

        new APReportsPage.ConfigPanel.DateRangeSelectorCell(
                $("#leaveTimeDateRangeSelector"),
                reportParameters.dateRangeSelection,
                "apReports.leaveTimeBalancesReport.reportConfig.create",
                "apReports.leaveTimeBalancesReport.reportConfig.change").init();
        var editConfigPanel = new APReportsPage.ConfigPanel.EditConfigPanel($("#leaveTimeEditConfigSelector"), reportParameters).init();
        var oldIE = isOldIE();
        this.exportSelector = new APReportsPage.ConfigPanel.ExportSelector(
                configPanel.exportSelectorPlaceHolder(), 'leaveTimeExportSelector',
                oldIE ? null : "apReports.leaveTimeBalancesReport.showPDFPreview",
                "apReports.leaveTimeBalancesReport.createCSV").init();

        this.chartController = new APReportsPage.ChartController().init();
        new APReportsPage.LeaveTimeBalancesReportPage.Table($(".leaveTimeBalancesReportPage .tableContainer")).init();

        $(document).on("apReports.leaveTimeBalancesReport.createCSV", function()
        {
            var spinner = new SpinnerController();
            spinner.spin("leaveTimeExportSelector");
            self.generateCSV(spinner);

        });

        if (oldIE) // IE8 and IE9 don't support pdf preview and pdf generate
        {
            ReportUtils.generateOldIEPDFTooltip(this.exportSelector.findPDFButton());
        }
        else
        {
            new BaseReport.PDFPreviewLightboxTemplateView($(
                    ".leaveTimeBalancesReportPage .pdfPreviewLightboxContainer"), "leaveTimeAndBalancesPdfPreviewLightbox", "lightboxWithWhiteContent pdfPreviewLightbox noprint").init();

            this.productSettingsValidator = new APProductSettingsValidator();
            this.reportRightsValidator = new APReportRightsValidator();
            this.pdfPreviewLightbox = new APReportsPage.PDFPreviewLightbox().init({
                                                                                      popupId: "leaveTimeAndBalancesPdfPreviewLightbox",
                                                                                      closeBtnId: "closeViewTTPdfPreviewLightboxButton",
                                                                                      eventNamespace: "apReports.leaveTimeBalancesReport",
                                                                                      productSettingsValidator: this.productSettingsValidator,
                                                                                      reportRightsValidator : this.reportRightsValidator
                                                                                  });

            $(document).on("apReports.leaveTimeBalancesReport.showPDFPreview", function()
            {
                self.pdfPreviewLightbox.show();
            });

            $(document).on("apReports.leaveTimeBalancesReport.pdfPreview.lightbox.hide", function()
            {
                self.cancelAllPDFExportingProcesses();
            });
            $(document).on("apReports.leaveTimeBalancesReport.pdfPreview.printParametersForSaveChange", function(event, printParametersForSave)
            {
                APReportsPage.LeaveTimeBalancesReportPage.Store.setPrintParametersForSave(printParametersForSave);
            });
            $(document).on("apReports.leaveTimeBalancesReport.pdfPreview.printParametersForGenerateChange", function(event, printParametersForGenerate)
            {
                APReportsPage.LeaveTimeBalancesReportPage.Store.setPrintParametersForGenerate(printParametersForGenerate);
                self.cancelAllPDFExportingProcesses();
                self.generatePDF();
            });
            $(document).on("apReports.leaveTimeBalancesReport.downloadPDF", function()
            {
                new PDFGeneratorUtil().downloadPDF(APReportsPage.LeaveTimeBalancesReportPage.Store.getGeneratedPDF(),
                                                   APReportsPage.LeaveTimeBalancesReportPage.Store.getPDFFileName());
            });
        }

        $(document).on("apReports.leaveTimeBalancesReport.chartConfig.change", function(e, config)
        {
            APReportsPage.LeaveTimeBalancesReportPage.Store.setChartSectionConfig(config);
            makeRpcCall("LeavesReportService.saveLeaveReportChartSettings", [config], function() {}, function() {return true;});
        });

        $(document).on("apReports.leaveTimeBalancesReport.reportConfig.change", function(e, config)
        {
            self._saveReportConfig(config);
            self._loadReportData();
        });

        $(document).on("apReports.leaveTimeBalancesReport.assignedOnly.change", function(e, showAssignedOnly)
        {
            APReportsPage.LeaveTimeBalancesReportPage.Store.setShowAssignedOnly(showAssignedOnly);
            self._loadReportData();
        });

        editConfigPanel.validateWithUI();
        this._loadReportData();
        $(document).trigger("apReports.leaveTimeBalancesReport.init");
    },

    beforeOpenPage: function()
    {
        $(document).trigger("apReports.leaveTimeBalancesReport.openPage");
        PageOverlayTipsManager.setInstance(this.tipsManager);
    },

    beforeLeavePage: function()
    {
        $(document).trigger("apReports.leaveTimeBalancesReport.leavePage");
    },

    _loadReportData: function()
    {
        var self = this;
        $(document).trigger("apReports.leaveTimeBalancesReport.beginLoadReportData");

        this._abortRpcCall(this._reportDataRpc);

        this._reportDataRpc = makeRpcCall("LeavesReportService.getLeavesReport",
                                          [{
                                              leaveReportParameters: APReportsPage.LeaveTimeBalancesReportPage.Store.getReportParams(),
                                              showOnlyAssignedUsers: APReportsPage.LeaveTimeBalancesReportPage.Store.isShowAssignedOnly()
                                                                        && APReportsPage.LeaveTimeBalancesReportPage.Store.isShowAssignedOnlyEnabled()
                                          }],
                                          function(data)
                                          {
                                              var reportParams = APReportsPage.LeaveTimeBalancesReportPage.Store.getReportParams();
                                              var info = {};
                                              var groupingLevels = LeavesReport.ConvertUtils.getGroupingLevels(reportParams);
                                              for (var i = 0; i < data["groupingLevelsInfoLists"].length; ++i) {
                                                  var groupingType = LeavesReport.ConvertUtils.getGroupingType(i, groupingLevels);
                                                  info[groupingType] = data["groupingLevelsInfoLists"][i];
                                              }

                                              var usersMap = arrayToMapById(info[ReportGroupingLevel.USER]);
                                              var userGroupsMap = arrayToMapById(info[ReportGroupingLevel.USER_GROUP]);
                                              var timeZoneGroupsMap = arrayToMapById(info[ReportGroupingLevel.TIME_ZONE_GROUP]);

                                              APReportsPage.LeaveTimeBalancesReportPage.Store.setDefaultWorkDayDuration(data["defaultWorkDayDuration"]);
                                              APReportsPage.LeaveTimeBalancesReportPage.Store.setReportData(data["rootItem"], usersMap, userGroupsMap,
                                                                                                            timeZoneGroupsMap);
                                              self._hideReportError();
                                              $(document).trigger("apReports.leaveTimeBalancesReport.endLoadReportData");
                                          },
                                          function(jqXHR, textStatus, errorThrown)
                                          {
                                              self.exportSelector.disableExport();

                                              if (textStatus == "rpc_sessionExpired" || textStatus == "rpc_noRights")
                                                  return false;

                                              if (textStatus == "rpc_customException")
                                              {
                                                  var messageKey;
                                                  switch (errorThrown.exception)
                                                  {
                                                      case "com.actimind.actiplans.reports.AssignedUsersNotSelected":
                                                      case "com.actimind.actitime.reports.AllSelectedUsersWereDeletedException":
                                                          messageKey = "report.js.report_loading_error.no_selected_users";
                                                          break;
                                                      case "com.actimind.actitime.reports.AllSelectedLeaveTypesWereDeletedException":
                                                          messageKey = "report.js.report_loading_error.no_selected_leave_types";
                                                          break;
                                                  }

                                                  if (messageKey)
                                                  {
                                                      self._showReportError(messageResource.getMessage(messageKey));
                                                      $(document).trigger("apReports.leaveTimeBalancesReport.endLoadReportData");
                                                      return true;
                                                  }
                                              }

                                              self._showReportError(messageResource.getMessage("report.js.report_loading_error.network_error", [PRODUCT_NAME]));

                                              $(document).trigger("apReports.leaveTimeBalancesReport.endLoadReportData");
                                          });
    },


    _saveReportConfig: function(config)
    {
        var storeParameters = APReportsPage.LeaveTimeBalancesReportPage.Store.getReportParams();
        _.extend(storeParameters, config);
        APReportsPage.LeaveTimeBalancesReportPage.Store.setReportParams(storeParameters);
    },

    _abortRpcCall: function(rpc)
    {
        if (!_.isUndefined(rpc))
        {
            rpc.abort();
        }
    },

    generateCSV: function(spinner)
    {
        var store = APReportsPage.LeaveTimeBalancesReportPage.Store;
        var users = mergeArraysById(store.getUsers(), APReportsStore.getVisibleUsers());
        var groups = mergeArraysById(store.getUserGroups(), APReportsStore.getUserGroups());
        var tzGroups = mergeArraysById(store.getTimeZoneGroups(), APReportsStore.getTimeZoneGroups());

        var generator = new LeaveCSVJsonConverter().init(users, groups, tzGroups, store.getDefaultWorkDayDuration());

        var csvParams = APReportsPage.LeaveTimeBalancesReportPage.Store.getReportParams();

        csvParams.viewerInfo = APReportsPage.LeaveTimeBalancesReportPage.Store.getViewerInfo();
        csvParams.isShowOnlyAssigned = APReportsPage.LeaveTimeBalancesReportPage.Store.isShowAssignedOnlyEnabled() &&  APReportsPage.LeaveTimeBalancesReportPage.Store.isShowAssignedOnly();

        var jsonTitle = generator.convertTitle(csvParams,
                                               APReportsStore.getUserGroupsEnabled(),
                                               APReportsStore.getTimeZoneGroupsEnabled());
        var jsonTable = generator.convertTable(APReportsPage.LeaveTimeBalancesReportPage.Store.getReportParams(),
                                               APReportsPage.LeaveTimeBalancesReportPage.Store.getReportData());
        
        this.downloadJsonAsCSV([jsonTitle, jsonTable],
                               generator.generateCSVName(csvParams, new APProductSettingsValidator(), true),
                               spinner);
    },


    downloadJsonAsCSV: function(jsons, fileName, spinner)
    {
        if (!saveFileSupported())
            alert(messageResource.getMessage("import_csv_tasks.result.operation_unsupported"));

        var eol = '\r\n';
        var separator = SystemSettings.csvSeparator;

        json2csv(jsons, separator, eol, false, function(csv)
        {
            saveFile(csv, fileName, {encoding: "UTF-8", 'type': 'text/plain;charset=UTF-8'});
            spinner.stop();
        });
    },

    generatePDF: function()
    {
        this.pdfGenerator = new LeavesReportPDFGenerator.PDFGenerator().init(APReportsPage.LeaveTimeBalancesReportPage.Store, APReportsStore,
                                                                             this.productSettingsValidator, this.reportRightsValidator);

        $(document).trigger("apReports.leaveTimeBalancesReport.pdfGenerator.start");
        var self = this;
        this.pdfGenerator.generatePDF(
                function(config, onDataProvided)
                {
                    self.chartController.exportChart(config["chartImageSizes"], function(img)
                    {
                        onDataProvided({
                                           chartImage: img
                                       });
                    });
                }
        ).then(
                function(pdf)
                {
                    var store = APReportsPage.LeaveTimeBalancesReportPage.Store;
                    store.setGeneratedPDF(pdf.encodedPDF);
                    store.setPDFFileName(pdf.fileName);
                },
                function(error)
                {
                    if (error.message != "abort")
                    {
                        console.error(error);
                    }
                });
    },

    cancelAllPDFExportingProcesses: function()
    {
        if (this.pdfGenerator)
            this.pdfGenerator.interruptGeneration();
        this.pdfPreviewLightbox.cancelAllExportingProcesses();
    },

    _showReportError: function(message)
    {
        this.page.showReportError(message);
    },

    _hideReportError: function()
    {
        this.page.hideReportError();
        this.exportSelector.enableExport();
    }
})
;