APReportsPage.LeaveTimeBalancesReportPage.PrintableHeader = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

APReportsPage.LeaveTimeBalancesReportPage.PrintableHeader.prototype = _.create(TemplateView.prototype, {
    html: "<div class='pagetitle'><%=tabTitle%></div>" +
          "<div class='printableDateRangeHeader'></div>" +
          "<div class='reportConfig'>" +
          " <div class='staffFilter'></div>" +
          " <div class='leaveTypesFilter'></div>" +
          "</div>",

    messageKeys: function()
    {
        return APReportsPage.LeaveTimeReportsTab.prototype.messageKeys()
    },

    afterRender: function()
    {
        this.$dateRange = this.$containerEl.find(".printableDateRangeHeader");
        this.formatDateStrategy = new DateRangeFormattingStrategy().init(new DateFormat(SystemSettings.dateFormat));

        this.$staffFilter = this.$containerEl.find(".staffFilter");
        this.$leaveTypesFilter = this.$containerEl.find(".leaveTypesFilter");
    },
    
    update: function()
    {
        var store = APReportsPage.LeaveTimeBalancesReportPage.Store;
        var reportParams = store.getReportParams();
        var showAssignedOnly = store.isShowAssignedOnlyEnabled() && store.isShowAssignedOnly();

        var dateRangeText = this.formatDateStrategy.formatForDateInformation({dateRangeSelection: reportParams.dateRangeSelection}) +
                            this.formatDateStrategy.formatSpecifyingInformation({dateRangeSelection: reportParams.dateRangeSelection});
        this.$dateRange.text(dateRangeText);

        var paramsBuilder = new ReportParamsStringBuilder().init(
                {
                    leaveTypes: LeaveTypeStore.getLeaveTypesOrdered(),
                    leaveTypesMap: LeaveTypeStore.getLeaveTypes(),
                    users: APReportsStore.getVisibleUsers(),
                    userGroups: APReportsStore.getUserGroups(),
                    timeZoneGroups: APReportsStore.getTimeZoneGroups()
                });


        this.$staffFilter.text(paramsBuilder.getUserSelectionParamString(reportParams.userSelection,
                                                                         {
                                                                             viewerInfo: store.getViewerInfo(),
                                                                             isShowOnlyAssigned: showAssignedOnly
                                                                         }));
        this.$leaveTypesFilter.text(paramsBuilder.getLeaveTypeSelectionParamString(reportParams.leaveTypeSelection));
    }
});