APReportsPage.ChartSection.ChartTypeSelector = function($containerEl, selectedChartType)
{
    DropdownTemplateView.call(this, $containerEl);
    this._selectedChartType = selectedChartType;
    this.updateOnInit = false;
};

APReportsPage.ChartSection.ChartTypeSelector.prototype = _.create(DropdownTemplateView.prototype, {

    html: "<div class='leaveTimeAndBalancesChartTypeSelector noprint menuZindex' style='display: none;'>" +
          "    <div class='row leaveTime'><div class='type'><%-leaveTime%></div></div>" +
          "    <div class='row pto'><div class='type'><%-ptoBalance%></div></div>" +
          "    <div class='row sick'><div class='type'><%-sickBalance%></div></div>" +
          "</div>",

    afterRender: function()
    {
        this.isShown = false;
        this.rowsVisibility = {};

        this.$leaveTimeRow = this.find(".leaveTime");
        this.$ptoRow = this.find(".pto");
        this.$sickRow = this.find(".sick");

        this._bindRowClickFunction(APReportChartType.LEAVE_TIME);
        this._bindRowClickFunction(APReportChartType.PTO_BALANCE);
        this._bindRowClickFunction(APReportChartType.SICK_BALANCE);
    },

    messageKeys: function()
    {
        return {
            "leaveTime": "common.reports.chart_type_selector.leave_time",
            "ptoBalance": "common.reports.chart_type_selector.pto_balance",
            "sickBalance": "common.reports.chart_type_selector.sick_balance"
        }
    },

    setChartTypesVisibilityDataAndCurrentChartType: function(visibilityData, currentChartType)
    {
        this.rowsVisibility = visibilityData;
        this._selectedChartType = currentChartType;
    },

    update: function()
    {
        this.find(".selected").removeClass("selected");
        this._getRowByType(this._selectedChartType).addClass("selected");
        this._updateRowsVisibility();
    },

    _updateRowsVisibility: function()
    {
        var self = this;
        _.each(this.rowsVisibility, function(value, key)
        {
            self._getRowByType(key).toggleClass("hidden", !value);
        });
    },

    _getRowByType: function(chartType)
    {
        switch (chartType)
        {
            case APReportChartType.LEAVE_TIME:
                return this.$leaveTimeRow;
            case APReportChartType.PTO_BALANCE:
                return this.$ptoRow;
            case APReportChartType.SICK_BALANCE:
                return this.$sickRow;
        }
    },

    _bindRowClickFunction: function(chartType)
    {
        this._getRowByType(chartType).on(
                "click",
                _.bind(function()
                       {
                           this.hide();
                           this._onChartTypeSelected(chartType);
                       },
                       this)
        )
    },

    _onChartTypeSelected: function(chartType)
    {
        if (this._selectedChartType != chartType)
        {
            this._selectedChartType = chartType;
            $(this).trigger("chartTypeChanged", chartType);
        }
    }
});