APReportsPage.ChartSection.TotalsTable = function($containerEl)
{
    TemplateView.call(this, $containerEl);
    this.headerData = undefined;
    this.rowsData = [];
};

APReportsPage.ChartSection.TotalsTable.prototype = _.create(TemplateView.prototype, {
    MAX_ROWS_COUNT_WITHOUT_SCROLL: 8,

    html: "<div>" +
          "  <div class='header'>" +
          "    <div class='headerLabel'></div>" +
          "    <div class='headerTotalValue'></div>" +
          "  </div>" +
          "  <div class='scrollWrapper'>" +
          "    <div class='totalsWrapper'>" +
          "      <div class='totalsTable'></div>" +
          "    </div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        this.$table = this.find(".totalsTable");
        this.$headerLabel = this.find(".headerLabel");
        this.$headerValue = this.find(".headerTotalValue");
        this.$scrollWrapper = this.find(".scrollWrapper");

        this.scroll = ScrollUtils.addVerticalScroll(this.$scrollWrapper, {isFaded: false});
    },

    update: function()
    {
        var self = this;
        if (!_.isUndefined(this.headerData))
        {
            this.$headerLabel.text(this.headerData.label);
            this.$headerValue.text(this.headerData.value);
        }
        this.$table.empty();

        _.each(this.rowsData, function(rowData)
        {
            new APReportsPage.ChartSection.TotalsTable.Row(self.$table, rowData).init();
        });

        this.$scrollWrapper.toggleClass("withScroll", this.rowsData.length > this.MAX_ROWS_COUNT_WITHOUT_SCROLL);
        ScrollUtils.refreshCustomScroll(this.scroll);
    },

    setData: function(model)
    {
        this.headerData = model.headerData;
        this.rowsData = model.rowsData;
    }
});