APReportsPage.PastLeavesPage.Mediator = function() {};

APReportsPage.PastLeavesPage.Mediator.prototype = _.create(PageMediator.prototype, {
    getPage: function()
    {
        return this.page
    },

    beforeOpenPageFirstTime: function()
    {
        this.tipsManager = new PastLeavesPageOverlayTipsManager();
        this.page = new APReportsPage.PastLeavesPage($("#apPastLeavesCalendarPlaceholder")).init();
        this.initComponents();
    },

    initComponents: function()
    {
        var calendar = $("#tmpCalendarTemplateContainer");
        calendar.appendTo("#pastLeavesCalendarContainer");
        this.updateCalendar();
        calendar.show();
        var leaveTimeHistoryManager =  this.leaveTimeHistoryManager;
        new APReportsPage.ConfigPanel.ExportSelector(this.page.findExportButtonPlaceHolder(), "pastLeaveExportSelector", "apReports.pastLeavePage.exportPDF", "").init();
        $(document).on("apReports.pastLeavePage.exportPDF", function()
        {
            var spinner = new SpinnerController();
            spinner.spin("pastLeaveExportSelector");
            if (!_.isUndefined(leaveTimeHistoryManager))
            {
                leaveTimeHistoryManager.getPdfForm().submit();
            }
            setTimeout( function () {spinner.stop();}, 2000 );
        });
    },

    updateCalendar: function()
    {
        if (!this.leaveTimeHistoryManager)
        {
            var filter = _.extend({},
                                  APReportsPage.PastLeavesPage.Store.getUserSettings(),
                                  {nameService: "ReportsService"});

            filter.leaveTimeDetailsSettings = APReportsPage.PastLeavesPage.Store.getLeaveTimeDetailsSettings();
            filter.startSelectorDate = APReportsPage.PastLeavesPage.Store.getStartSelectorDate();
            filter.lastSelectorDate = APReportsPage.PastLeavesPage.Store.getLastSelectorDate();

            var visibleUsers = APReportsStore.getVisibleUsers();
            if (visibleUsers.length > 1)
            {
                filter.userGroupsEnabled = APReportsStore.getUserGroupsEnabled();
                filter.timeZoneGroupsEnabled = APReportsStore.getTimeZoneGroupsEnabled();
                filter.users = APReportsStore.getVisibleUsers();
                filter.userGroups = APReportsStore.getUserGroups();
                filter.timeZoneGroups = APReportsStore.getTimeZoneGroups();

                this.leaveTimeHistoryManager = new CorporateScheduleLeaveTimeHistoryManager().init(filter);
            }
            else
            {
                $("#leaveHistorySelector_userSelector").hide();
                $("#leaveHistorySelector_separator").hide();
                this.leaveTimeHistoryManager = new MyScheduleLeaveTimeHistoryManager().init(filter);
            }
        }
    },

    beforeOpenPage: function()
    {
        $(document).trigger("apReports.PastLeavesPage.openPage");
        PageOverlayTipsManager.setInstance(this.tipsManager);
    }
});