APReportsPage.PastLeavesPage.PrintableHeader = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

APReportsPage.PastLeavesPage.PrintableHeader.prototype = _.create(TemplateView.prototype, {
    html: "<div class='pagetitle'></div>" +
          "<div class='printableDateRangeHeader'></div>" +
          "<div class='reportConfig'>" +
          " <div class='leaveTypesFilter'></div>" +
          "</div>",

    afterRender: function()
    {
        this.$title = this.$containerEl.find(".pagetitle");
        this.$printableDateRange = this.$containerEl.find('.printableDateRangeHeader');
        this.dateFormat = new DateFormat(SystemSettings.dateFormat);
        this.$leaveTypesFilter = this.$containerEl.find(".leaveTypesFilter");
    },
    
    onDataUpdate: function()
    {
        var managerState = APReportsPage.PastLeavesPage.Store.getPeriodState();
        // not the best way to get user id from selector
        var selectedUserId = APReportsPage.PastLeavesPage.Store.getSelectedUserId();
        var user = _.find(APReportsStore.getVisibleUsers(), function(user) {return user.id == selectedUserId;});
        var title = messageResource.getMessage("actiplans.reports.tabs.past_leaves_calendar.print",
                                               [UserNameFormat.formatFML(user.firstName, user.lastName, user.middleName)]);
        this.$title.text(title);

        var period = managerState.period;
        var dateFrom = managerState.dateFrom;
        var periodMessage;

        var currentDate = new Date();
        if( period > 1)
        {
            var dateTo = new Date(dateFrom);
            dateTo.setMonth(dateTo.getMonth() + period - 1);
            periodMessage = messageResource.getMessage(dateTo.getYear() == currentDate.getYear() && dateTo.getMonth() == currentDate.getMonth() ?
                                                       "leave_time_history.print.date_range.last":
                                                       "leave_time_history.print.date_range.custom",
                                                       [this.dateFormat.formatDate(dateFrom) + " - " + this.dateFormat.formatDate(dateTo), period]);
        }
        else
        {
            periodMessage = messageResource.getMessage(dateFrom.getYear() == currentDate.getYear() && dateFrom.getMonth() == currentDate.getMonth() ?
                                                       "leave_time_history.print.date_range.current_month" :
                                                       "leave_time_history.print.date_range.custom",
                                                       [this.dateFormat.formatDate(dateFrom)]);
        }

        this.$printableDateRange.text(periodMessage);


        var leaveTypeSelection = APReportsPage.PastLeavesPage.Store.getLeaveTypeSelection();
        var liveTypeSelectionString = leaveTypeSelection == null ?
                                      messageResource.getMessage("leaves_selector.options.all_leave_types") :
                                      (leaveTypeSelection.length == 1 ?
                                       LEAVE_TYPES[leaveTypeSelection[0]].name :
                                       messageResource.getMessage("saved_reports.leaves_selector.multiple_types", [leaveTypeSelection.length]));
        this.$leaveTypesFilter.text(liveTypeSelectionString);
    }
});
