function DayHeaderCellRenderer()
{
    TableCellRenderer.apply( this, arguments );
}

DayHeaderCellRenderer.prototype = _.create(TableCellRenderer.prototype);

DayHeaderCellRenderer.prototype.generateContent = function( cell )
{
    var dateInfo = cell.getValue();
    cell.getCellEl().innerHTML = Date.dayNamesAbbr[ dateInfo.date.getDay() ];
};

DayHeaderCellRenderer.prototype.getCellClassName = function( cell )
{
    var table = cell.getRow().getTable();
    var corporateScheduleSlice = table.getCorporateScheduleSlice();
    var today = table.getToday();

    var result = [ "dateCell" ];

    if( corporateScheduleSlice.get( cell.getColIdx() ) > 0 )
        result.push("working");
    else
        result.push("nonWorking");

    var date = cell.getValue().date;

    if(date < today)
        result.push("past");
    if (table.isTodayCell(cell))
        result.push("today");

    return result;
};

DayHeaderCellRenderer.prototype.appendSelectionClassesIfNeeded = function( cell, classesArray )
{
    TableCellRenderer.call( this, cell, classesArray );

    if( this.isColumnIncludedIntoSelection( cell ) )
        classesArray.push("markSelection");
};


DayHeaderCellRenderer.prototype.isColumnIncludedIntoSelection = function( cell )
{
    return this.getSelectionController( cell ).getSelection().containsCol( cell.getColIdx() );
};
