/**
 *
 * @param today
 * @param workdayDurationsSlice ArraySlice object, where workdayDurationsSlice.get(0) matches to dateFrom day
 * @param hireDate - hire_date of user
 * @constructor
 */
function LeaveRow( today, workdayDurationsSlice, hireDate )
{
    TableRow.call(this);
    this.hireDate = hireDate;
    this.today = today;
    this.workdayDurationsSlice = workdayDurationsSlice;
}

LeaveRow.prototype = _.create(TableRow.prototype);

LeaveRow.prototype.getToday = function()
{
    return this.today;
};

LeaveRow.prototype.getHireDate = function()
{
    return this.hireDate;
};

LeaveRow.prototype.getWorkdayDurationsSlice = function ()
{
    return this.workdayDurationsSlice;
};

LeaveRow.prototype.isPastDateCell = function( cell )
{
    return this.getTable().getDateForCell(cell) < this.today;
};

LeaveRow.prototype.isTodayCell = function( cell )
{
    return this.getTable().getDateForCell(cell).getTime() == this.today.getTime();
};

LeaveRow.prototype.isHireDateCell = function( cell )
{
    return this.hireDate ? this.getTable().getDateForCell(cell).getTime() == this.hireDate.getTime() : false;
};

LeaveRow.prototype.isBeforeHireDateCell = function( cell )
{
    return this.hireDate ? this.getTable().getDateForCell(cell) < this.hireDate : false;
};

LeaveRow.prototype.isStatusCell = function(cell)
{
    return false;
};

LeaveRow.prototype.createCellRenderer = function( cell )
{
    return new LeaveRequestCellRenderer();
};

LeaveRow.prototype.accept = function( visitor, cell )
{
    if( visitor.visitLeaveRow )
        visitor.visitLeaveRow( cell );
};

/*
LeaveRow.prototype.updateLeaveCellsValues = function ( dateFrom, dateTo, requests )
{
    var from = dateFrom;
    var fromIdx = 0;
    for( var i = 0; i < requests.length; i++ )
    {
        var req = requests[i];
        if( req.getFirstDate() > dateTo )
            break;
        this.setEmptyValues( from, req.getFirstDate().prevDay() );
        this.addDayCellsForRequest( req, dateFrom, dateTo );
        from = req.getLastDate().nextDay();
    }
    if( from <= dateTo )
        this.setEmptyValues( from, dateTo );

};



function LeaveCellValuesIterator( dateFrom, dateTo, requests )
{
    this.dateFrom = dateFrom;
    this.dateTo = dateTo;
    this.requests = requests;
    this.reqIdx = 0;
    this.dayIdx = 0;
}

LeaveCellValuesIterator.prototype.hasNext = function()
{
    return this.dateFrom <= this.dateTo;
};

LeaveCellValuesIterator.prototype.next = function()
{
    if( this.requests.length - 1 < this.reqIdx )
        return null;

    var request = this.requests[ this.reqIdx ];
    var date = request.days[ this.dayIdx ].date;

    if( this.dateFrom < date )
        return null;

    this.dateFrom = this.dateFrom.nextDay();
    this.dayIdx ++;
    if( this.dayIdx >= request.days.length  )
    {
        this.reqIdx++;
        this.dayIdx = 0;
    }

     return new LeaveRowDayInfo( date, request );
};*/
