function LeaveTableCellRenderer()
{
    TableCellRenderer.apply(this, arguments);
}

LeaveTableCellRenderer.prototype = _.create(TableCellRenderer.prototype, {
    appendToCellClassesArray: function(cell, classesArray)
    {
        TableCellRenderer.prototype.appendToCellClassesArray.call(this, cell, classesArray);
        this.appendWaitingForDeletionClassesIfNeeded(cell, classesArray);
    },

    appendWaitingForDeletionClassesIfNeeded: function(cell, classesArray)
    {
        var data = this.getWaitingDeletionData(cell);
        if (data)
        {
            if (data.isLeftmost)
                classesArray.push("waitingDeletionLeftInnerBorder");
            if (data.isRightmost)
                classesArray.push("waitingDeletionRightInnerBorder");
            classesArray.push("waitingDeletionTopInnerBorder");
            classesArray.push("waitingDeletionBottomInnerBorder");
        }
        var leftData = this.getWaitingDeletionData(cell.leftCell());
        if (leftData && leftData.isRightmost)
             classesArray.push("waitingDeletionLeftOuterBorder");

        var upperData = this.getWaitingDeletionData(cell.upperCell());
        if (upperData)
             classesArray.push("waitingDeletionTopOuterBorder");
    },

    getWaitingDeletionData: function(cell)
    {
        if (cell && cell.getValue() && cell.getValue().requestData)
        {
            var requestData = cell.getValue().requestData;
            if (requestData.waitingDeletion)
            {
                var cellDate = cell.getTable().getDateForCell(cell);
                var firstDate = requestData.firstDate.parseJSONDate();
                var lastDate = requestData.lastDate.parseJSONDate();

                return {
                    isLeftmost: cellDate.getTime() == firstDate.getTime(),
                    isRightmost: cellDate.getTime() == lastDate.getTime()
                };
            }
        }
    }
});

