function LeaveTableDayCellRenderer()
{
    TableCellRenderer.apply(this, arguments);
}

LeaveTableDayCellRenderer.prototype = _.create(LeaveTableCellRenderer.prototype, {
    getCellClassName: function(cell)
    {
        var className = ["dayCell"];

        var row = cell.getRow();
        var workdayDurationsSlice = row.getWorkdayDurationsSlice();
        var table = row.getTable();
        var date = table.getDateForCell(cell);

        if (workdayDurationsSlice.get(cell.getColIdx()) == 0)
            className.push("nonWorking");

        if (date.getDay() == SystemSettings.weekStartDay - 1)
            className.push("weekStartDay");
        if (cell.getRow().isPastDateCell(cell))
            className.push("pastDay");
        if (cell.getRow().isTodayCell(cell))
            className.push("today");

        if(cell.getRow().isHireDateCell(cell)){
            className.push("hireDate");
        }

        if(cell.getRow().isBeforeHireDateCell(cell)){
            className.push("beforeHireDate");
        }

        return className;
    },
    generateContent: function(cell)
    {
        if (cell.getRow().isBeforeHireDateCell(cell))
        {
            var contentDiv = document.createElement("div");
            contentDiv.className = "contentDiv";

            cell.getCellEl().appendChild(contentDiv);

            var moireDiv = document.createElement("div");
            moireDiv.className = "moireDiv";
            contentDiv.appendChild(moireDiv);
        }
    }
});