function LeaveTableTooltip(balanceHoursPerDay)
{
    this.balanceHoursPerDay = balanceHoursPerDay;
}

LeaveTableTooltip.prototype = {
    init: function()
    {
        this.tooltip = document.createElement("div");
        this.tooltip.className = "leaveTable tooltip";

        this.contentEl = document.createElement("div");
        this.contentEl.className = "tooltipContent";

        this.userNameEl = document.createElement("div");
        this.userNameEl.className = "userName";

        this.notApplicableUserEl = document.createElement("div");
        this.notApplicableUserEl.className = "notApplicableLabel";

        this.dateEl = document.createElement("div");
        this.dateEl.className = "leaveDate";

        this.dateValueEl = document.createElement("span");
        this.dateValueEl.className = "date";

        this.dateRangeDashEl = document.createElement("span");
        this.dateRangeDashEl.innerHTML = "&nbsp;&nbsp;-&nbsp;&nbsp;";

        this.lastDateEl = document.createElement("div");
        this.lastDateEl.className = "leaveDate";

        this.lastDateValueEl = document.createElement("span");
        this.lastDateValueEl.className = "date";

        this.beforeHireNote = document.createElement("div");
        this.beforeHireNote.className = "beforeHireNote";
        this.beforeHireNote.innerHTML = "(" + messageResource.getMessage("actiplans.leavestable.tooltip.beforehiredate") + ")";

        this.nonWorkingNote = document.createElement("span");
        this.nonWorkingNote.className = "nonWorkingNote";
        this.nonWorkingNote.innerHTML = "(" + messageResource.getMessage("actiplans.leavestable.tooltip.nonworkingday") + ")";

        this.leaveInfoEl = document.createElement("div");
        this.leaveInfoEl.className = "leaveInfo";

        this.leaveBlockEl = document.createElement("div");
        this.leaveBlockEl.className = "leaveBlock";

        this.leaveNameEl = document.createElement("span");
        this.leaveNameEl.className = "leaveName";

        this.leaveDatesEl = document.createElement("span");
        this.leaveDatesEl.className = "leaveDates";

        this.leaveTimeTotalEl = document.createElement("div");
        this.leaveTimeTotalEl.className = "leaveTimeTotal";

        this.leaveCommentEl = document.createElement("div");
        this.leaveCommentEl.className = "comment";

        this.ptoBalanceEl = document.createElement("div");
        this.ptoBalanceEl.className = "ptoBalance balance";
        this.ptoBalanceEl.innerHTML = "<span class='dash'>&ndash;</span>" + messageResource.getMessage("schedule.tooltip.pto_balance");

        this.sickBalanceEl = document.createElement("div");
        this.sickBalanceEl.className = "sickBalance balance";
        this.sickBalanceEl.innerHTML = "<span class='dash'>&ndash;</span>" + messageResource.getMessage("schedule.tooltip.sick_balance");

        this.ptoBalanceColonEl = document.createElement("span");
        this.ptoBalanceColonEl.innerHTML = ": ";
        this.ptoBalanceValueEl = document.createElement("span");

        this.sickBalanceColonEl = document.createElement("span");
        this.sickBalanceColonEl.innerHTML = ": ";
        this.sickBalanceValueEl = document.createElement("span");

        this.balanceForDateRangeEl = document.createElement("div");
        this.balanceForDateRangeEl.className = "balanceForDateRange";

        this.requestedBalanceParagrafEl = document.createElement("p");
        this.requestedBalanceParagrafEl.id = "requestedBalanceCaption";

        this.balanceNoteEl = document.createElement("div");
        this.balanceNoteEl.id = "balanceNote";

        this.currentPTOBalanceEl = document.createElement("div");
        this.currentPTOBalanceEl.id = "currentPTOBalance";
        this.currentPTOBalanceEl.className = "modificationsBalance";

        this.currentSickBalanceEl = document.createElement("div");
        this.currentSickBalanceEl.id = "currentSickBalance";
        this.currentSickBalanceEl.className = "modificationsBalance";

        this.currentPTOBalanceAfterEl = document.createElement("div");
        this.currentPTOBalanceAfterEl.id = "currentPTOBalanceAfter";
        this.currentPTOBalanceAfterEl.className = "modificationsBalance";

        this.currentSickBalanceAfterEl = document.createElement("div");
        this.currentSickBalanceAfterEl.id = "currentSickBalanceAfter";
        this.currentSickBalanceAfterEl.className = "modificationsBalance";

        this.balanceStartCapacityEl = document.createElement("div");
        this.balanceStartCapacityEl.id = "balanceStartCapacityCaption";
        this.balanceStartCapacityEl.className = "balanceCapacity";

        this.balanceStartCapacityBalanceCaption = document.createElement("span");
        this.balanceStartCapacityBalanceCaption.className = "balanceCaption";
        this.balanceStartCapacityBalanceSubCaption = document.createElement("span");
        this.balanceStartCapacityBalanceSubCaption.id = "balanceStartTextSubCaption";
        this.balanceStartCapacityMessage = document.createElement("span");

        this.balanceEndCapacityEl = document.createElement("div");
        this.balanceEndCapacityEl.id = "balanceStartCapacityCaption";
        this.balanceEndCapacityEl.className = "balanceCapacity";

        this.balanceEndCapacityBalanceCaption = document.createElement("span");
        this.balanceEndCapacityBalanceCaption.className = "balanceCaption";
        this.balanceEndCapacityBalanceSubCaption = document.createElement("span");
        this.balanceEndCapacityBalanceSubCaption.id = "balanceEndTextSubCaption";
        this.balanceEndCapacityMessage = document.createElement("span");

        this.requestNotAffectBalanceTextEl = document.createElement("p");
        this.requestNotAffectBalanceTextEl.id = "requestNotAffectBalanceText";
        this.requestNotAffectBalanceTextEl.className = "balanceCaption";

        this.balanceCapacityEl = document.createElement("div");
        this.balanceCapacityEl.className = "balanceCapacity";

        this.footerEl = document.createElement("div");
        this.footerEl.className = "footer";
        this.footerEl.innerHTML = "click to edit request";
        this.footerEl.style.display = "none";
        this.notApplicableUserEl.innerHTML = messageResource.getMessage("actiplans.leavestable.edit_leave_popup.not_applicable_request");

        this.tooltip.appendChild(this.contentEl);
        this.contentEl.appendChild(this.userNameEl);
        this.contentEl.appendChild(this.notApplicableUserEl);
        this.contentEl.appendChild(this.dateEl);
        this.dateEl.appendChild(this.dateValueEl);
        this.dateEl.appendChild(this.nonWorkingNote);
        this.contentEl.appendChild(this.beforeHireNote);
        this.contentEl.appendChild(this.dateRangeDashEl);
        this.contentEl.appendChild(this.lastDateEl);
        this.lastDateEl.appendChild(this.lastDateValueEl);
        this.contentEl.appendChild(this.leaveInfoEl);
        this.leaveInfoEl.appendChild(this.leaveBlockEl);
        this.leaveBlockEl.appendChild(this.leaveNameEl);
        this.leaveBlockEl.appendChild(this.leaveDatesEl);
        this.contentEl.appendChild(this.leaveTimeTotalEl);
        this.contentEl.appendChild(this.ptoBalanceEl);
        this.ptoBalanceEl.appendChild(this.ptoBalanceColonEl);
        this.ptoBalanceEl.appendChild(this.ptoBalanceValueEl);
        this.contentEl.appendChild(this.sickBalanceEl);
        this.sickBalanceEl.appendChild(this.sickBalanceColonEl);
        this.sickBalanceEl.appendChild(this.sickBalanceValueEl);
        this.contentEl.appendChild(this.balanceForDateRangeEl);
        this.contentEl.appendChild(this.requestNotAffectBalanceTextEl);
        this.balanceForDateRangeEl.appendChild(this.requestedBalanceParagrafEl);
        this.balanceForDateRangeEl.appendChild(this.balanceNoteEl);
        this.balanceForDateRangeEl.appendChild(this.currentPTOBalanceEl);
        this.balanceForDateRangeEl.appendChild(this.currentPTOBalanceAfterEl);
        this.balanceForDateRangeEl.appendChild(this.currentSickBalanceEl);
        this.balanceForDateRangeEl.appendChild(this.currentSickBalanceAfterEl);
        this.balanceForDateRangeEl.appendChild(this.balanceCapacityEl);
        this.balanceCapacityEl.appendChild(this.balanceStartCapacityEl);
        this.balanceStartCapacityEl.appendChild(this.balanceStartCapacityBalanceCaption);
        this.balanceStartCapacityEl.appendChild(this.balanceStartCapacityBalanceSubCaption);
        this.balanceStartCapacityEl.appendChild(this.balanceStartCapacityMessage);
        this.balanceCapacityEl.appendChild(this.balanceEndCapacityEl);
        this.balanceEndCapacityEl.appendChild(this.balanceEndCapacityBalanceCaption);
        this.balanceEndCapacityEl.appendChild(this.balanceEndCapacityBalanceSubCaption);
        this.balanceEndCapacityEl.appendChild(this.balanceEndCapacityMessage);
        this.contentEl.appendChild(this.leaveCommentEl);
        this.tooltip.appendChild(this.footerEl);

        document.body.appendChild(this.tooltip);

        this.numberFormatter = new NumberFormatter(
                SystemSettings.decimalSeparator,
                SystemSettings.digitGroupingSymbol,
                1,
                true
        );

        this.cell = null;

        this._ptoFormatter = new PTOFormatter().init(this.balanceHoursPerDay);
        this._sickFormatter = new SickFormatter().init(this.balanceHoursPerDay);

        this.commentTemplate = _.template("<div class='commentTitle'><%=title%></div>" +
                                          "<div class='commentBody'>" +
                                          "<span class='commentLeftQuote'>&ldquo;</span>" +
                                          "<span class='commentText'><%=text%><span class='commentRightQuote'>&rdquo;</span></span>" +
                                          "</div>");

        return this;
    },

    configureForCell: function(cell)
    {
        this._setUserName(cell);

        var row = cell.getRow();
        var dateOfSelectedCell = row.getTable().getDateForCell(cell);

        this.dateValueEl.innerHTML = dateOfSelectedCell.format("D, M d") + (row.isHireDateCell(cell) ? "&nbsp (Hire Date)" : "");
        var dailyPTOSlice = row.getDailyPTOSlice();
        var dailySickSlice = row.getDailySickSlice();
        var requestChange = cell.value && cell.value.requestData && cell.value.requestData.requestChange;
        var balanceData = cell.value && cell.value.requestData && cell.value.requestData.balanceData;
        var changedTodayBalance = cell.value && cell.value.requestData && cell.value.requestData.changedTodayBalance;
        var leaveTimeTotal = requestChange ? requestChange.leaveTimeTotal : (cell.value && cell.value.requestData && cell.value.requestData.leaveTimeTotal);
        var canEditPastRequests = cell.getTable().canEditPastRequests;
        var wasAtIntegrated = cell.getTable().wasAtIntegrated;
        var isEnabledInAT = cell.getTable().isActiveInAT();

        var isPTOUser = !!(dailyPTOSlice && dailyPTOSlice.getArray());
        var isSickUser = !!(dailySickSlice && dailySickSlice.getArray());

        this._setBeforeHireNote(row.isBeforeHireDateCell(cell));
        this._setNonWorkingNote(cell, row.isBeforeHireDateCell(cell));
        this.notApplicableUserEl.style.display = this._notApplicableUserLabelDisplay(cell);

        var $footer = $(this.footerEl);

        var comment = null;
        var commentTitleKey = "actiplans.leavestable.tooltip.comment_title";
        var value = cell.getValue();

        if (row.isBeforeHireDateCell(cell))
        {
            // do not show daily pto and daily sick
            this._configureForCellNoValue(cell, null, null);
            this._updateClasses(LeaveTimeRequestUtils.ViewBalanceAs.DO_NOT_VIEW,
                                LeaveTimeRequestUtils.RequiresApproval.DOES_NOT_REQUIRE,
                                false,
                                false);
        }
        else if (value == null || value.requestData == null)
        {
            this._configureForCellNoValue(cell, dailyPTOSlice, dailySickSlice);
            this._updateClasses(false, false, false, false);
        }
        else
        {
            var leaveTypeId = new LeaveModificationsUtil().getActualLeaveTypeId(value.requestData);
            var leaveType = LEAVE_TYPES[leaveTypeId];
            var startBeforeHireDate = Date.parseJSONDate(value.requestData.firstDate) < row.hireDate;
            var endBeforeHireDate = Date.parseJSONDate(value.requestData.lastDate) < row.hireDate;

            var viewBalanceAs = LeaveTimeRequestUtils.viewBalanceAsType(value.requestData, isPTOUser, isSickUser, endBeforeHireDate);
            var requestRequiresApproval = LeaveTimeRequestUtils.requestRequiresApprovalType(value.requestData, row.getUserInfo() && !row.getUserInfo().requiresLTRApproval);
            var leaveTypeAffectsBalance = LeaveTimeRequestUtils.leaveTypeAffectsBalance(leaveType, isPTOUser, isSickUser, endBeforeHireDate);

            this._updateClasses(viewBalanceAs, requestRequiresApproval, leaveTypeAffectsBalance, isPTOUser || isSickUser);

            this.nonWorkingNote.style.display = "none";
            this.dateEl.style.display = "none";
            this.ptoBalanceEl.style.display = "none";
            this.sickBalanceEl.style.display = "none";
            this.leaveInfoEl.style.display = "block";
            this.balanceForDateRangeEl.style.display = "block";

            var isPast = value.requestData.past;
            if (!this._alwaysHideFooter())
            {
                $footer.show().empty();
                if (isPast)
                {
                    if (canEditPastRequests && !startBeforeHireDate)
                    {
                        if (value.requestData.waitingDeletion)
                        {
                            $footer.append($("<span>").addClass("markedForDeletion").html(
                                    messageResource.getMessage("actiplans.leavestable.tooltip.marked_for_deletion")));
                            $footer.append($("<span>").addClass("deletionCancel").html(this._waitingDeletionMessage()));
                        }
                        else
                            $footer.append($("<span>").html(messageResource.getMessage("actiplans.leavestable.tooltip.click_to_edit_past")));
                    }
                    else
                    {
                        if( startBeforeHireDate || wasAtIntegrated && isEnabledInAT || !canEditPastRequests)
                        {
                            if (startBeforeHireDate)
                            {
                                $footer.append($("<span>").html(messageResource.getMessage("actiplans.leavestable.tooltip.before_hire_date.past", [row.getHireDate().format("D, M d")])));
                                $footer.append("<br>");
                            }
                            if (wasAtIntegrated && isEnabledInAT)
                            {
                                $footer.append($("<span>").html(messageResource.getMessage("actiplans.leavestable.tooltip.edit_in_at")));
                            }else{
                                if(!canEditPastRequests)
                                    $footer.append($("<span>").html(this._getMessageNotRightModify()));
                            }
                        }
                        else
                            $footer.hide();
                    }
                }
                else
                {
                    var footerMessage = startBeforeHireDate ?
                                        messageResource.getMessage("actiplans.leavestable.tooltip.before_hire_date", [row.getHireDate().format("D, M d")]) :
                                        messageResource.getMessage("actiplans.leavestable.tooltip.click_to_edit");

                    $footer.append($("<span>").html(footerMessage));
                }
            }

            this.leaveBlockEl.style.backgroundImage = "url('" + leaveType.getIconPath() + "')";
            this.leaveNameEl.innerHTML = escapeHtmlSymbols(truncateStringByLength(leaveType.name, 25));

            var firstDate = value.requestData.firstDate.parseJSONDate();
            var lastDate = value.requestData.lastDate.parseJSONDate();
            var firstDateString = firstDate.format("M d");
            var lastDateString = lastDate.format("M d");
            this._setRequestDateRangeText(cell, firstDate, lastDate, firstDateString, lastDateString);
            this._setTotalLeaveTimeText(leaveTypeAffectsBalance, dateOfSelectedCell, firstDate, leaveTimeTotal, isPast, value.requestData.waitingDeletion);
            if (dailyPTOSlice && dailySickSlice)
            {
                this._setRequestBalanceText(isPTOUser, isSickUser, balanceData, changedTodayBalance, leaveTimeTotal,
                                            cell.getRow().currentBalanceInfo, leaveType, firstDateString, lastDateString,
                                            startBeforeHireDate, value.requestData, requestChange, isPast, value.requestData.waitingDeletion,
                                            viewBalanceAs, requestRequiresApproval, leaveTypeAffectsBalance);
            }
            var rawComment = LeaveTimeRequestUtils.getCommentFromRequestWithChanges(value.requestData);
            if (rawComment)
                comment = escapeHtmlSymbols(truncateStringByLength(rawComment, 150));
        }

        if (value && value.statusData)
        {
            var preCommentKey;
            var time;
            if (value.statusData.type === "LEAVING_EARLY")
            {
                preCommentKey = "actiplans.leavestable.tooltip.mobile_comment_leaving_early";
                time = value.statusData.fromTime;
            }
            else if (value.statusData.type === "COMING_LATE")
            {
                preCommentKey = "actiplans.leavestable.tooltip.mobile_comment_coming_late";
                time = value.statusData.toTime;
            }
            else
                throw new Error("Unknown leave status type");

            comment = messageResource.getMessage(preCommentKey);
            if (time)
                comment += " " + messageResource.getMessage("actiplans.leavestable.tooltip.mobile_comment_at", [this._formatLeaveStatusTime(time)]);
            if (value.statusData.comment)
                comment += "<br/>" + escapeHtmlSymbols(truncateStringByLength(value.statusData.comment),150);
            commentTitleKey = "actiplans.leavestable.tooltip.mobile_comment_title";
        }

        if (comment)
        {
            this.leaveCommentEl.style.display = "block";
            this.leaveCommentEl.innerHTML = this.commentTemplate({title: messageResource.getMessage(commentTitleKey), text: comment});
        }
        else
        {
            this.leaveCommentEl.innerHTML = "";
            this.leaveCommentEl.style.display = "none";
        }

        this.dateRangeDashEl.style.display = "none";
        this.lastDateEl.style.display = "none";
    },

    _getMessageNotRightModify: function(){
        return messageResource.getMessage("actiplans.leavestable.tooltip.cannot_modify.default");
    },

    configureForCellRange: function(anchorCell, lastChosenCell)
    {
        var anchorRow = anchorCell.getRow();
        var anchorCellDate = anchorRow.getTable().getDateForCell(anchorCell);
        var lastChosenCellRow = lastChosenCell.getRow();
        var lastChosenCellDate = lastChosenCellRow.getTable().getDateForCell(lastChosenCell);

        if (anchorCellDate < lastChosenCellDate)
        {
            this.dateValueEl.innerHTML = anchorCellDate.format("D, M d");
            this.lastDateValueEl.innerHTML = lastChosenCellDate.format("D, M d");
        }
        else
        {
            this.dateValueEl.innerHTML = lastChosenCellDate.format("D, M d");
            this.lastDateValueEl.innerHTML = anchorCellDate.format("D, M d");
        }

        this.dateEl.style.display = "inline-block";
        this.lastDateEl.style.display = "inline-block";
        this.dateRangeDashEl.style.display = "inline-block";

        this.userNameEl.style.display = "none";
        this.notApplicableUserEl.style.display = "none";
        this.nonWorkingNote.style.display = "none";
        this.leaveInfoEl.style.display = "none";
        this.leaveTimeTotalEl.style.display = "none";
        this.ptoBalanceEl.style.display = "none";
        this.sickBalanceEl.style.display = "none";
        this.balanceForDateRangeEl.style.display = "none";
        this.footerEl.style.display = "none";
    },

    _updateClasses: function(viewBalanceAs, requestRequiresApproval, leaveTypeAffectsBalance, balanceTypeEnabled)
    {
        var $tooltip = $(this.tooltip);

        $tooltip.toggleClass("doNotViewBalance", viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.DO_NOT_VIEW);
        $tooltip.toggleClass("viewBalanceOnStartEnd", viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.BALANCE_ON_START_END);
        $tooltip.toggleClass("viewCurrentBalanceBeforeAfter", viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.CURRENT_BALANCE_BEFORE_AFTER_APPROVAL);
        $tooltip.toggleClass("doesNotAffectCurrentBalance", viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.DOES_NOT_AFFECT_CURRENT_BALANCE);
        $tooltip.toggleClass("doesNotAffectBalance", viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.DOES_NOT_AFFECT_BALANCE);

        $tooltip.toggleClass("requestRequiresApproval", !!requestRequiresApproval);
        $tooltip.toggleClass("leaveTypeAffectsBalance", leaveTypeAffectsBalance);
        $tooltip.toggleClass("balanceTypeEnabled", balanceTypeEnabled);
    },

    _configureForCellNoValue: function(cell, dailyPTOSlice, dailySickSlice)
    {
        this.leaveInfoEl.style.display = "none";
        this.footerEl.style.display = "none";
        this.dateEl.style.display = "block";
        this.balanceForDateRangeEl.style.display = "none";
        this.leaveTimeTotalEl.style.display = "none";
        this.leaveCommentEl.style.display = "none";
        this._setPTOForSingleDate(cell, dailyPTOSlice, dailySickSlice);
    },

    show: function()
    {
        this.tooltip.style.display = "block";
    },

    hide: function()
    {
        this.tooltip.style.display = "none";
    },

    moveTo: function(x, y)
    {
        this.tooltip.style.left = x + "px";
        this.tooltip.style.top = y + "px";
    },

    getEl: function()
    {
        return this.tooltip;
    },

    _showUserName: function()
    {
        return false;
    },

    _alwaysHideFooter: function()
    {
        return false;
    },

    _notApplicableUserLabelDisplay: function(cell)
    {
        return "none";
    },

    _waitingDeletionMessage: function()
    {
        return messageResource.getMessage("actiplans.leavestable.tooltip.click_to_cancel")
    },

    _setUserName: function(cell)
    {
        if (this._showUserName())
        {
            this.userNameEl.style.display = "block";
            this.userNameEl.innerHTML = this._formatUserName(cell.getRow().getUserInfo());
        }
        else
            this.userNameEl.style.display = "none";

    },

    _setBeforeHireNote: function(isBeforeHireDate)
    {
        this.beforeHireNote.style.display = (isBeforeHireDate) ? "inline" : "none";
    },

    _setNonWorkingNote: function(cell, isBeforeHireDate)
    {
        if (!this._isDayWorking(cell) && !isBeforeHireDate)
        {
            this.nonWorkingNote.style.display = "inline";
        }
        else
        {
            this.nonWorkingNote.style.display = "none";
        }
    },

    _setRequestDateRangeText: function(cell, firstDate, lastDate, firstDateString, lastDateString)
    {
        if (firstDate.isSameDate(lastDate))
        {
            this.leaveDatesEl.innerHTML = " (" + firstDateString;
            if (this._isDayWorking(cell))
            {
                this.leaveDatesEl.innerHTML += ") ";
            }
            else
            {
                this.leaveDatesEl.innerHTML += ",<span class='nonWorkingNote'>" +
                                               messageResource.getMessage('actiplans.leavestable.tooltip.nonworkingday') +
                                               "</span>)";
            }

        }
        else
        {
            this.leaveDatesEl.innerHTML = " (" + firstDateString + " - " + lastDateString + ")";
        }
    },

    _setTotalLeaveTimeText: function(showBalance, dateOfSelectedCell, firstDate, leaveTimeTotal, isPast, isWaitingDeletion)
    {
        if (showBalance || !leaveTimeTotal)
        {
            this.leaveTimeTotalEl.style.display = "none";
            return;
        }

        if (leaveTimeTotal)
        {
            var requestedBalanceMsgKey;
            if (isPast)
            {
                if (isWaitingDeletion)
                {
                    requestedBalanceMsgKey = "actiplans.leavestable.tooltip.to_delete_time";
                }
                else
                {
                    requestedBalanceMsgKey = "actiplans.leavestable.tooltip.spent_time";
                }
            }
            else
            {
                requestedBalanceMsgKey= "actiplans.leavestable.tooltip.requested_time";
            }
            this.leaveTimeTotalEl.style.display = "block";
            this.leaveTimeTotalEl.innerHTML = messageResource.getMessage(requestedBalanceMsgKey) + " <span class='leave_total_day'>" + this.numberFormatter.format(
                            leaveTimeTotal.days) + "d</span> " + " (" + this.numberFormatter.format(leaveTimeTotal.hours) + "h)";
        }
    },

    _setRequestBalanceText: function(userPTOEnabled, userSickEnabled, balanceData, changedTodayBalance, leaveTimeTotal, currentBalanceInfo, leaveType,
                                     balanceStartDateString, balanceEndDateString, beforeHireDate, request, requestChange, isPast, waitingDeletion,
                                     viewBalanceAs, requestRequiresApproval, leaveTypeAffectsBalance)
    {

        var balanceType = leaveType.balanceType;
        var balanceStartCapacity;
        var balanceEndCapacity;

        var balanceTypeMsgKey = balanceType == BalanceType.PTO ? 'pto' : 'sick';
        var balanceFormatter = balanceType == BalanceType.PTO ? this._ptoFormatter : this._sickFormatter;


        var notAffectMsgKey = (userPTOEnabled && userSickEnabled ? "actiplans.leavestable.edit_leave_popup.request_not_affect_balances" :
                              ( userPTOEnabled ? "actiplans.leavestable.edit_leave_popup.request_not_affect_pto" :
                                "actiplans.leavestable.edit_leave_popup.request_not_affect_sick" )) + ((isPast) ? ".past" : "");

        var notAffectCurrentMsgKey = userPTOEnabled && userSickEnabled ? "actiplans.leavestable.edit_leave_popup.request_not_affect_current_balances" :
                                     ( userPTOEnabled ? "actiplans.leavestable.edit_leave_popup.request_not_affect_current_pto" :
                                       "actiplans.leavestable.edit_leave_popup.request_not_affect_current_sick" );
        if (viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.DOES_NOT_AFFECT_BALANCE)
            this.requestNotAffectBalanceTextEl.innerHTML = messageResource.getMessage(notAffectMsgKey);
        else if (viewBalanceAs == LeaveTimeRequestUtils.ViewBalanceAs.DOES_NOT_AFFECT_CURRENT_BALANCE)
            this.requestNotAffectBalanceTextEl.innerHTML = messageResource.getMessage(notAffectCurrentMsgKey);


        var modificationsNoteKey;
        switch (requestRequiresApproval)
        {
            case LeaveTimeRequestUtils.RequiresApproval.REQUIRES_BECAUSE_OF_LEAVE_TYPE:
                modificationsNoteKey = waitingDeletion ? "actiplans.leavestable.tooltip.deletion_note" : "actiplans.leavestable.tooltip.modifications_note";
                break;
            case LeaveTimeRequestUtils.RequiresApproval.REQUIRES_BECAUSE_CURRENT_BALANCE_CHANGES:
                modificationsNoteKey = waitingDeletion ? "actiplans.leavestable.tooltip.deletion_note_affects_balance" : "actiplans.leavestable.tooltip.modifications_note_affects_balance";
                break;
        }
        this.balanceNoteEl.innerHTML = modificationsNoteKey ? messageResource.getMessage(modificationsNoteKey) : "";

        var requestChangeTodayBalance = LeaveTimeRequestUtils.changedTodayBalanceTuple(requestChange || request);
        var requestedBalance;
        if (_.isNumber(requestChangeTodayBalance.PTOBalance) || _.isNumber(requestChangeTodayBalance.sickBalance))
        {
            this._setRequestChange(leaveType, requestChangeTodayBalance, currentBalanceInfo, waitingDeletion);
            requestedBalance = LeaveTimeRequestUtils.getRequestedBalanceFromLeaveTime(leaveTimeTotal, leaveType);
        }
        else if (balanceData && balanceData.balanceChangeData)
        {
            requestedBalance = balanceData.requestedPaidTime;
            
            balanceStartCapacity = balanceData.balanceChangeData.startBalance;
            balanceEndCapacity = balanceData.balanceChangeData.endBalance;

            var balanceAsOfMsgKey = 'actiplans.leavestable.tooltip.' + balanceTypeMsgKey + '_as_of';

            this.balanceStartCapacityBalanceCaption.innerHTML = messageResource.getMessage(balanceAsOfMsgKey) + " " + balanceStartDateString + ":";
            this.balanceStartCapacityMessage.innerHTML = messageResource.getMessage("actiplans.leavestable.tooltip.before_req");

            this.balanceEndCapacityBalanceCaption.innerHTML = messageResource.getMessage(balanceAsOfMsgKey) + " " + balanceEndDateString + ":";
            this.balanceEndCapacityMessage.innerHTML = messageResource.getMessage("actiplans.leavestable.tooltip.after_req");
        }

        this.balanceStartCapacityBalanceSubCaption.className = this._getBalanceValueClasses(balanceStartCapacity, balanceFormatter);
        this.balanceStartCapacityBalanceSubCaption.innerHTML = balanceStartCapacity != null ? balanceFormatter.format(balanceStartCapacity) : "N/A";
        this.balanceEndCapacityBalanceSubCaption.className = this._getBalanceValueClasses(balanceEndCapacity, balanceFormatter);
        this.balanceEndCapacityBalanceSubCaption.innerHTML = balanceEndCapacity != null ? balanceFormatter.format(balanceEndCapacity) : "N/A";

        if (leaveTypeAffectsBalance)
        {
            if (!_.isNumber(requestedBalance) && _.isObject(leaveTimeTotal))
                requestedBalance = LeaveTimeRequestUtils.getRequestedBalanceFromLeaveTime(leaveTimeTotal, leaveType);
            
            var requestedBalanceMsgKey;
            if (!isPast) {
                requestedBalanceMsgKey = 'actiplans.leavestable.tooltip.requested_' + balanceTypeMsgKey;
            } else if (waitingDeletion) {
                requestedBalanceMsgKey = 'actiplans.leavestable.tooltip.to_delete_' + balanceTypeMsgKey;
            } else {
                requestedBalanceMsgKey = 'actiplans.leavestable.tooltip.spent_' + balanceTypeMsgKey;
            }
            this.requestedBalanceParagrafEl.innerHTML = this._makeBalanceValue(requestedBalanceMsgKey, "requestedBalanceSubCaption", balanceFormatter, requestedBalance);
        }
    },

    _setRequestChange: function(leaveType, changedTodayBalance, currentBalanceInfo, waitingDeletion)
    {
        var waitingDeletionSubKey = (waitingDeletion) ? '.waiting_deletion' : '';
        if (_.isNumber(changedTodayBalance.PTOBalance))
        {
            this.currentPTOBalanceEl.innerHTML = this._makeBalanceValue("actiplans.leavestable.tooltip.current_pto" + waitingDeletionSubKey, null, this._ptoFormatter, currentBalanceInfo.PTOBalance);
            this.currentPTOBalanceAfterEl.innerHTML = this._makeBalanceValue("actiplans.leavestable.tooltip.current_pto_after" + waitingDeletionSubKey, null, this._ptoFormatter, changedTodayBalance.PTOBalance);
        }
        else
        {
            this.currentPTOBalanceEl.innerHTML = "";
            this.currentPTOBalanceAfterEl.innerHTML = "";
        }

        if (_.isNumber(changedTodayBalance.sickBalance))
        {
            this.currentSickBalanceEl.innerHTML = this._makeBalanceValue("actiplans.leavestable.tooltip.current_sick" + waitingDeletionSubKey, null, this._sickFormatter, currentBalanceInfo.sickBalance);
            this.currentSickBalanceAfterEl.innerHTML = this._makeBalanceValue("actiplans.leavestable.tooltip.current_sick_after" + waitingDeletionSubKey, null, this._sickFormatter, changedTodayBalance.sickBalance);
        }
        else
        {
            this.currentSickBalanceEl.innerHTML = "";
            this.currentSickBalanceAfterEl.innerHTML = "";
        }
    },

    _setPTOForSingleDate: function(cell, dailyPTOSlice, dailySickSlice)
    {
        if (dailyPTOSlice && dailyPTOSlice.getArray())
        {
            var ptoData = dailyPTOSlice.get(cell.getColIdx());

            this.ptoBalanceValueEl.innerHTML = this._ptoFormatter.format(ptoData);
            this.ptoBalanceValueEl.className = this._getBalanceValueClasses(ptoData, this._ptoFormatter);
            this.ptoBalanceEl.style.display = "block";
            $(this.ptoBalanceEl).addClass("top");
            $(this.sickBalanceEl).removeClass("top");
        }
        else
        {
            this.ptoBalanceEl.style.display = "none";
            $(this.ptoBalanceEl).removeClass("top");
            $(this.sickBalanceEl).addClass("top");
        }

        if (dailySickSlice && dailySickSlice.getArray())
        {
            var data = dailySickSlice.get(cell.getColIdx());

            this.sickBalanceValueEl.innerHTML = this._sickFormatter.format(data);
            this.sickBalanceValueEl.className = this._getBalanceValueClasses(data, this._sickFormatter);
            this.sickBalanceEl.style.display = "block";
        }
        else
        {
            this.sickBalanceEl.style.display = "none";
        }
    },

    _isDayWorking: function(cell)
    {
        return cell.getRow().getWorkdayDurationsSlice().get(cell.getColIdx()) > 0;
    },

    _getBalanceValueClasses: function(value, balanceFormatter)
    {
        return ( value && balanceFormatter.isNegativePTO(value)) ? "balanceValue negative" : "balanceValue";
    },

    _makeBalanceValue: function(captionMsgKey, subCaptionId, balanceFormatter, requestedBalance)
    {
        var subId = !!subCaptionId ? " id='" + subCaptionId + "'" : "";
        return "<span class='balanceCaption'>" + messageResource.getMessage(captionMsgKey) + "</span> " +
               " <span" + subId + " class='" + this._getBalanceValueClasses(requestedBalance, balanceFormatter) + "'>" +
               balanceFormatter.format(requestedBalance) +
               "</span> ";
    },

    _formatUserName: function(userInfo)
    {
        return UserNameFormat.formatFML(escapeHtmlSymbols(userInfo.firstName),
                                        escapeHtmlSymbols(userInfo.lastName),
                                        escapeHtmlSymbols(userInfo.middleInitial));
    },

    _formatLeaveStatusTime: function(time)
    {
        return time.split(":").slice(0, 2).join(":");
    },
    
    removeTooltipElement: function()
    {
        $(this.tooltip).remove();
    }
};
