function LeaveTableTooltipController(tooltip)
{
    this.tooltip = tooltip;
}

LeaveTableTooltipController.prototype = _.create(Object.prototype, {
    showTooltip: function(cell, mouseEvent, anchorCell)
    {
        if (anchorCell)
            this.tooltip.configureForCellRange(anchorCell, cell);
        else
        {
            if (cell != this.cell)
                this.tooltip.configureForCell(cell);
        }
        this.moveTooltip(cell, mouseEvent);
        this.tooltip.show();

        var that = this;
        doOnceOnWindowResize(function() { that.hideTooltip(); });
    },

    scrollTop: function()
    {
        return getBodyScrollTop();
    },

    scrollLeft: function()
    {
        return getBodyScrollLeft();
    },

    moveTooltip: function(cell, mouseEvent)
    {
        var tooltipWidth = $(this.tooltip.getEl()).outerWidth();
        var tooltipHeight = $(this.tooltip.getEl()).outerHeight();

        var x = mouseEvent.clientX + 15;
        if (x + tooltipWidth > $(window).width())
            x -= tooltipWidth;

        var y = mouseEvent.clientY + 15;
        if (y + tooltipHeight > $(window).height())
            y -= tooltipHeight + 15;

        this.tooltip.moveTo(
                x + this.scrollLeft(),
                y + this.scrollTop()
        );
    },

    hideTooltip: function(mouseEvent)
    {
        this.tooltip.hide();
    },

    removeTooltip: function()
    {
        this.tooltip.removeTooltipElement();
    }
});
