/**
 *
 * @param userInfo
 * @param requests
 * @param statuses
 * @param today
 * @param workdayDurationsSlice ArraySlice object, where workdayDurationsSlice.get(0) matches to dateFrom day
 * @param tokensHighlighter
 * @constructor
 */
function ColleaguesScheduleRow( userInfo, requests, statuses, today, workdayDurationsSlice, tokensHighlighter )
{
    this.tokensHighlighter = tokensHighlighter;
    UserLeaveRow.call( this, userInfo, requests, statuses, today, workdayDurationsSlice );
    this.getRowEl().appendChild( this.createUseNameCell( userInfo ) );
    this.getRowEl().appendChild( this.createSpacerCell( ) );
}

ColleaguesScheduleRow.prototype = _.create(UserLeaveRow.prototype);
ColleaguesScheduleRow.superclass = UserLeaveRow.prototype;

ColleaguesScheduleRow.prototype.createUseNameCell = function( userNames )
{
    var uEl = document.createElement("td");
    uEl.className = "colleagueNameCell";
    uEl.innerHTML = '<div class="colleagueNameContainer">' +
                    this.tokensHighlighter.highlightTokens( this.formatUserName( userNames ) ) +
                    '</div>';
    return uEl;
};

ColleaguesScheduleRow.prototype.createSpacerCell = function()
{
    var spacerEl = document.createElement("td");
    spacerEl.className = "colleaguesSpacerCell";
    return spacerEl;
};

ColleaguesScheduleRow.prototype.formatUserName = function(userNames)
{
    return UserNameFormat.formatLFM(
            userNames.firstName,
            userNames.lastName,
            userNames.middleInitial
    );
};
/**
 * Override for delete "return false" in oncontextmenu event
 * It allows to see context menu in schedule of colleagues
 * @param value
 */
ColleaguesScheduleRow.prototype.addCell = function( value ) {
    ColleaguesScheduleRow.superclass.addCell.apply(this, arguments );
    this.getLastCell().getCellEl().oncontextmenu = function( evt ) { return true; };
};
