/**
 *
 * @param today
 * @param dateFrom
 * @param dateTo
 * @param corporateScheduleSlice ArraySlice object, where corporateScheduleSlice.get(0) matches to dateFrom day
 * @param hasColleagues
 * @constructor
 */
function NoColleaguesRow( today, dateFrom, dateTo, corporateScheduleSlice, hasColleagues )
{
    LeaveRow.call( this, today, corporateScheduleSlice );

    this.getRowEl().appendChild( this._createUseNameCell( hasColleagues ) );
    this.getRowEl().appendChild( this._createSpacerCell() );

    for( var d = new DatesIterator( dateFrom, dateTo ); d.hasNext(); d.next() )
        this.addCell( null );
}

NoColleaguesRow.prototype = _.create(LeaveRow.prototype);

NoColleaguesRow.prototype._createUseNameCell = function ( hasColleagues )
{
    var uEl = document.createElement( "td" );
    uEl.className = "colleagueNameCell colleaguesNotExist";
    uEl.innerHTML = '<div class="colleagueNameContainer">' +
                    (hasColleagues ?
                     messageResource.getMessage( "my_schedule.js.colleagues.not_found" ) :
                     messageResource.getMessage( "my_schedule.js.colleagues.not_exist" )) +
                    '</div>';
    return uEl;
};

NoColleaguesRow.prototype._createSpacerCell = function ()
{
    var spacerEl = document.createElement( "td" );
    spacerEl.className = "colleaguesSpacerCell";
    spacerEl.innerHTML = "";
    return spacerEl;
};

NoColleaguesRow.prototype.accept = function( visitor, cell )
{
    // do nothing
};

