/**
 *
 * @param today
 * @param dateFrom
 * @param dateTo
 * @param corporateScheduleSlice ArraySlice object, where corporateScheduleSlice.get(0) matches to dateFrom day
 * @param hasUsers
 * @constructor
 */
function LeaveTimePlanningNoUsersRow( today, dateFrom, dateTo, corporateScheduleSlice, hasUsers )
{
    LeaveRow.call( this, today, corporateScheduleSlice );

    this.getRowEl().appendChild( this._createUserNameCell( hasUsers ) );
    this.getRowEl().appendChild( this._createCell( "timeTotalCell usersNotExist", "&ndash;" ) );
    this.getRowEl().appendChild( this._createCell( "employeesSpacerCell", "" ) );

    for( var d = new DatesIterator( dateFrom, dateTo ); d.hasNext(); d.next() )
        this.addCell( null );
}

LeaveTimePlanningNoUsersRow.prototype = _.create(LeaveRow.prototype);

LeaveTimePlanningNoUsersRow.prototype._createUserNameCell = function ( hasColleagues )
{
    var el = this._createCell( "userNameCell usersNotExist firstInRow",
                               '<div class="userNameContainer">' +
                               (hasColleagues ?
                                messageResource.getMessage( "corporate_schedule.leave_time_planning.js.users.not_found" ) :
                                messageResource.getMessage( "corporate_schedule.leave_time_planning.js.users.not_exist" )) +
                               '</div>'
    );
    el.colSpan = 2;
    return el;
};

LeaveTimePlanningNoUsersRow.prototype._createCell = function ( className, inner )
{
    var el = document.createElement( "td" );
    el.className = className;
    el.innerHTML = inner;
    return el;
};
