/**
 *
 * @param containerEl Table container in DOM
 * @param dateFrom
 * @param dateTo
 * @param corporateScheduleSlice ArraySlice object, where corporateScheduleSlice.get(0) matches to dateFrom day
 * @param scheduleSlice ArraySlice object, where scheduleSlice.get(0) matches to dateFrom day
 * @param today
 * @param requests
 * @param statuses
 * @param userInfo
 * @param dailyPTOSlice ArraySlice object, where dailyPTOSlice.get(0) matches to dateFrom day
 * @param dailySickSlice ArraySlice object, where dailySickSlice.get(0) matches to dateFrom day
 * @param leaveTypeNotFoundCallback
 * @param ptoHoursPerDay used to convert days to hours when displaying PTO balance
 * @param canEditPastRequests Indicates if editing past requests is allowed
 * @param wasAtIntegrated Indicates if actiTIME was ever integrated
 * @param currentBalanceInfo Current balance info (balance of today)
 * @constructor
 */
function MyScheduleTable(containerEl,
                         dateFrom,
                         dateTo,
                         corporateScheduleSlice,
                         scheduleSlice,
                         today,
                         requests,
                         statuses,
                         userInfo,
                         dailyPTOSlice,
                         dailySickSlice,
                         leaveTypeNotFoundCallback,
                         ptoHoursPerDay,
                         canEditPastRequests,
                         wasAtIntegrated,
                         currentBalanceInfo)
{
    this.requests = requests;
    this.statuses = statuses;
    this.userInfo = userInfo;
    this.scheduleSlice = scheduleSlice;
    this.dailyPTOSlice = dailyPTOSlice;
    this.dailySickSlice = dailySickSlice;
    this.leaveTypeNotFoundCallback = leaveTypeNotFoundCallback;
    this.currentBalanceInfo = currentBalanceInfo;
    LeaveTable.call(
            this,
            containerEl,
            dateFrom,
            dateTo,
            corporateScheduleSlice,
            today,
            document.createElement("tr"),
            document.createElement("tr"),
            undefined,
            ptoHoursPerDay,
            canEditPastRequests,
            wasAtIntegrated,
            currentBalanceInfo,
            this.userInfo.activeInAT);
    this.tableEl.id = "myScheduleTable";
}

//noinspection JSCheckFunctionSignatures
MyScheduleTable.prototype = _.create(LeaveTable.prototype, {
    createModelRows: function()
    {
        var myScheduleRow = new MyScheduleRow(this.requests, this.statuses, this.getToday(), this.userInfo, this.scheduleSlice, this.dailyPTOSlice, this.dailySickSlice, this.currentBalanceInfo);
        myScheduleRow.setLeaveTypeNotFoundCallback(this.leaveTypeNotFoundCallback);
        myScheduleRow.addLeaveCells(this.dateFrom, this.dateTo, this.getCorporateScheduleSlice(), this.ptoHoursPerDay);
        this.addRow(myScheduleRow);
    }
});