function DateRangeCalculator( maxVisibleDays, firstScrollingDays, additionalScrollingDays )
{
    this.maxVisibleDays = maxVisibleDays;
    this.firstScrollingDays = firstScrollingDays;
    this.additionalScrollingDays = additionalScrollingDays;
}

DateRangeCalculator.prototype.getDateRangeWithLeftScrolling = function ( dateFrom )
{
    return this._createDateRange( dateFrom, this.additionalScrollingDays, 0 );
};

DateRangeCalculator.prototype.getDateRangeWithRightScrolling = function ( dateFrom )
{
    return this._createDateRange( dateFrom, 0, this.additionalScrollingDays );
};

DateRangeCalculator.prototype.getDateRangeWithoutScrolling = function ( dateFrom )
{
    return this._createDateRange( dateFrom, 0, 0 );
};

DateRangeCalculator.prototype._createDateRange = function ( dateFrom, leftAdditionOffset, rightAdditionOffset )
{
    var dateFromWithOffset = dateFrom.getNDaysBefore(this.firstScrollingDays + leftAdditionOffset );
    if (dateFromWithOffset.getTime() < 0)
        dateFromWithOffset = new Date(0);

    return {
        dateFrom: dateFromWithOffset,
        dateTo: dateFrom.getNDaysAfter( this.maxVisibleDays - 1 + this.firstScrollingDays + rightAdditionOffset )
    };
};
