function MyScheduleLeaveTimeHistoryManager () {}

MyScheduleLeaveTimeHistoryManager.prototype = new LeaveTimeHistoryManager();

MyScheduleLeaveTimeHistoryManager.prototype.init = function ( initialData )
{
    this._initElements();

    this.userId = initialData.selectedUserId;
    this.nameService = initialData.nameService;

    return LeaveTimeHistoryManager.prototype.init.call(this, initialData);
};

MyScheduleLeaveTimeHistoryManager.prototype.makeInitRequest = function(initialData)
{
    var self = this;
    this._updateDataRequestFunction(
            function(userLeaveTimeHistoryData)
            {
                initialData.userLeaveTimeHistoryData = userLeaveTimeHistoryData;
                self.baseInit(initialData);
                $(document).trigger("apReports.leaveTimeHistory.dataUpdated");
            },
            initialData);
};

MyScheduleLeaveTimeHistoryManager.prototype.updateDataRequestFunction = function ( params ) {
    var scrollToCalendars = this.scrollToFunctionFactory();

    var self = this;
    this._updateDataRequestFunction(
                  function (userLeaveTimeHistoryData) {
                      self.successResultCallback(userLeaveTimeHistoryData);
                      scrollToCalendars();
                      $(document).trigger("apReports.leaveTimeHistory.dataUpdated")
                  }, params
    );
};

MyScheduleLeaveTimeHistoryManager.prototype._updateDataRequestFunction = function ( successResultCallback, params ) {
    var self = this;
    $(document).trigger("apReports.leaveTimeHistory.updateData");
    makeRpcCall ( this.nameService + '.getLeaveTimeHistory', [ APReportsStore.getViewerId(), params.dateFrom, params.period, params.rangeType, params.leaveTypeIds],
                  successResultCallback,
                  function (jqXHR, textStatus, errorThrown) {
                      $(document).trigger("apReports.leaveTimeHistory.dataUpdated");
                      return self.defaultErrorHandler(jqXHR, textStatus, errorThrown);
                  }
    );
};

MyScheduleLeaveTimeHistoryManager.prototype.getSelectedUserId = function () {
    return this.userId;
};

MyScheduleLeaveTimeHistoryManager.prototype.getPdfElementForm = function(){
    return document.forms["LeaveTimeHistoryFormOnMySchedule"];
};