function CorporateScheduleErrorHandler(updateTableFunc, userInfo, onOperationFailedCallBack) {

    var self = this;

    this.singleUserErrorHandler = function(jqXHR, textStatus, errorThrown) {
        return self.errorHandler(errorThrown.exception, updateTableFunc,
                messageResource.getMessage("actiplans.leave_time_requests.noRightsForApprovingUserRequest", [userInfo.firstName, userInfo.lastName]), onOperationFailedCallBack );
    };

    this.multipleUsersErrorHandler = function(jqXHR, textStatus, errorThrown) {
        return self.errorHandler(errorThrown.exception, updateTableFunc,
                messageResource.getMessage("actiplans.leave_time_requests.noRightsForApprovingUsersRequests"), onOperationFailedCallBack);
    };

    this.defaultErrorHandler = function(jqXHR, textStatus, errorThrown) {
        return self.errorHandler(errorThrown.exception, updateTableFunc,
                messageResource.getMessage("actiplans.leave_time_requests.noRightsForApprovingRequest"), onOperationFailedCallBack);
    }

}

CorporateScheduleErrorHandler.prototype.errorHandler = function(exception, updateTableFunc, message, onOperationFailedCallBack) {
    var EXCEPTION_NO_RIGHTS_FOR_PAGE = "com.actimind.actitime.services.NoRightsForRemoteCallException";
    var EXCEPTION_NO_RIGHTS_FOR_OPERATION = "com.actimind.actiplans.services.NoRightsForEditingUserRequests";
    var EXCEPTION_NO_SUCH_USER = "com.actimind.actitime.administration.NoSuchUserException";

    if(onOperationFailedCallBack)
        onOperationFailedCallBack();

    if (exception === EXCEPTION_NO_RIGHTS_FOR_PAGE) {
        alert(messageResource.getMessage("actiplans.leave_time_requests.noRightsForPage"));
        doSafeLocationChange("../user/my_schedule.do");
        return true;
    }
    if (exception === EXCEPTION_NO_RIGHTS_FOR_OPERATION) {
        alert(message);
        updateTableFunc();
        return true;
    }
    if (exception === EXCEPTION_NO_SUCH_USER) {
        alert(messageResource.getMessage("actiplans.leave_time_requests.user_was_deleted"));
        updateTableFunc();
        return true;
    }
    
    return false;
};