function InvocationResultHandler(){

    this.constructor = InvocationResultHandler;

}

//variable InvocationResultCodes declared in InvocationResultCodes.jsp
InvocationResultHandler.prototype.handleResultCode = function ( resultCode )
{
    switch( resultCode )
    {
        case InvocationResultCodes.RESULT_CODE_OK:
            break;

        case InvocationResultCodes.RESULT_CODE_REQUEST_REJECTED:
        {
            this.handleRequestRejectedError();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_PAST_LEAVE_PROCESSING_AFTER_INTEGRATION:
        {
            this.handlePastLeaveProcessingAfterIntegration();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_DELETED:
        {
            this.handleRequestDeletedError();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_ALREADY_EXISTS:
        {
            this.handleRequestExistsError();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_DELETED_PARTIALLY:
        {
            this.handlePartiallyDeletedRequest();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_BEFORE_HIRE_DATE:
        {
            this.handleCreateRequestBeforeHireDate();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_NO_SUCH_LEAVE_TYPE:
        {
            this.handleNoSuchLeaveTypeError();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_MADE_AUTO_APPROVAL:
        {
            this.handleRequestLeaveTypeMadeAutoApproval();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_REVOKED:
        {
            this.handleRequestWasRevoked();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_APPROVED:
        {
            this.handleRequestWasApproved();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_ROLLBACKED:
        {
            this.handleRequestWasRollbacked();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_ALREADY_PROCESSED_WAITING_DELETION:
        {
            this.handleAlreadyProcessedWaitngDeletion();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_REQUEST_MARKED_FOR_DELETION:
        {
            this.handleRequestWasMarkedForDeletion();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_PAST_LEAVE_MODIFICATION_NOT_ALLOWED:
        {
            this.handlePastLeaveModificationNotAllowed();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_PAST_LEAVE_DELETION_NOT_ALLOWED:
        {
            this.handlePastLeaveDeletionNotAllowed();
            break;
        }

        case InvocationResultCodes.RESULT_CODE_PAST_LEAVE_CREATION_NOT_ALLOWED:
        {
            this.handlePastLeaveCreationNotAllowed();
            break;
        }

        default:
            this.handleUnknownError( resultCode );
    }
};

InvocationResultHandler.prototype.handleRequestRejectedError = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.request_concurrently_rejected") );
};

InvocationResultHandler.prototype.handlePastLeaveProcessingAfterIntegration = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.past_leave_processing.after_integration") );
};

InvocationResultHandler.prototype.handleRequestDeletedError = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.request_concurrently_deleted") );
};

InvocationResultHandler.prototype.handleRequestExistsError = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.another_request_concurrently_added") );
};

InvocationResultHandler.prototype.handlePartiallyDeletedRequest = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.request_deleted_partially"));
};

InvocationResultHandler.prototype.handleCreateRequestBeforeHireDate = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.date_before_hire_date") );
};


InvocationResultHandler.prototype.handleNoSuchLeaveTypeError = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.no_such_leave") );
    document.location.reload();
};

InvocationResultHandler.prototype.handleRequestLeaveTypeMadeAutoApproval = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_planning.requestTypeMadeAutoApproval") );
    document.location.reload();
};

InvocationResultHandler.prototype.handleUnknownError = function()
{
    alert( messageResource.getMessage("actiplans.leave_time_requests.unknown_error") );
};

InvocationResultHandler.prototype.handleRequestWasRevoked = function()
{
    alert( messageResource.getMessage("actiplans.corporate_requests.requestWasRevoked") );
};

InvocationResultHandler.prototype.handleRequestWasApproved = function()
{
    alert( messageResource.getMessage("actiplans.corporate_requests.requestWasApproved") );
};

InvocationResultHandler.prototype.handleRequestWasRollbacked = function()
{
    alert( messageResource.getMessage("actiplans.corporate_requests.requestWasRollbacked") );
};

InvocationResultHandler.prototype.handleAlreadyProcessedWaitngDeletion = function()
{
    alert(messageResource.getMessage("actiplans.leave_time_requests.process_selected_dialog.one_request_already_processed"));
};

InvocationResultHandler.prototype.handleRequestWasMarkedForDeletion = function()
{
    alert(messageResource.getMessage("actiplans.leave_time_requests.request_concurrently_marked_for_deletion"));
};

InvocationResultHandler.prototype.handlePastLeaveModificationNotAllowed = function()
{
    alert(messageResource.getMessage("actiplans.leave_time_requests.past_leave_modification.not_allowed"));
};

InvocationResultHandler.prototype.handlePastLeaveDeletionNotAllowed = function()
{
    alert(messageResource.getMessage("actiplans.leave_time_requests.past_leave_deletion.not_allowed"));
};

InvocationResultHandler.prototype.handlePastLeaveCreationNotAllowed = function()
{
    alert(messageResource.getMessage("actiplans.leave_time_requests.past_leave_creation.not_allowed"));
};