<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="com.actimind.actitime.services.beans.report.TimeFormat" %>

<div id="editReportConfigurationPanel" style="display: none;">
    <table>
        <tr>
            <td class="editReportConfigurationHeader">
                <bean:message key="report.selector_label.edit_report_configuration"/>
            </td>
            <td id="spinnerPlaceholderId"></td>
        </tr>
    </table>
    <div class="controlsContainer">
        <table>
            <tr>
                <td class="reportConfigPanelLabel">
                    <bean:message key="report.form.data_grouping"/>
                </td>
                <td class="reportGroupingSelectorContainer">
                    <at:roundedbox styleClass="roundedFormSection">
                        <table cellpadding="0" cellspacing="0" border="0" id="reportGroupingSelector" class="reportGroupingSelector">
                            <tr id="reportGroupingSelector_treeRow1">
                                <td class="tree-cell-text" colspan="4" id="reportGroupingSelector_groupingLevel0"></td>
                            </tr>
                            <tr id="reportGroupingSelector_treeRow2">
                                <td>
                                    <div class="tree-cell-1">&nbsp;</div>
                                </td>
                                <td class="tree-cell-text" colspan="3" id="reportGroupingSelector_groupingLevel1"></td>
                            </tr>
                            <tr id="reportGroupingSelector_treeRow3">
                                <td>
                                    <div class="tree-cell-1">&nbsp;</div>
                                </td>
                                <td>
                                    <div class="tree-cell-2">&nbsp;</div>
                                </td>
                                <td class="tree-cell-text" colspan="2" id="reportGroupingSelector_groupingLevel2"></td>
                            </tr>
                            <tr id="reportGroupingSelector_treeRow4">
                                <td>
                                    <div class="tree-cell-1">&nbsp;</div>
                                </td>
                                <td>
                                    <div class="tree-cell-2">&nbsp;</div>
                                </td>
                                <td>
                                    <div class="tree-cell-3">&nbsp;</div>
                                </td>
                                <td class="tree-cell-text" id="reportGroupingSelector_groupingLevel3"></td>
                            </tr>
                        </table>
                    </at:roundedbox>
                </td>
            </tr>
            <tr>
                <td class="reportConfigPanelLabel">
                    <bean:message key="report.form.selected_staff"/>
                </td>
                <td>
                    <div id="userSelectorId" class="userSelector"></div>
                </td>
            </tr>
            <tr>
                <td class="reportConfigPanelLabel">
                    <bean:message key="report.form.leave_types"/>
                </td>
                <td>
                    <div id="leavesButton" class="leavesSelector"></div>
                </td>
            </tr>

            <tr id="columnsFormatFilterRow" class="leaveColumnFormatRow">
                <td class="reportConfigPanelLabel">
                    <bean:message key="report.form.report_columns"/>
                </td>
                <td class="reportColumnsFormatSelector">
                    <div class="roundedFormSection roundedBoxTag">
                        <div id="columnsDisplayFormat"></div>
                    </div>
                </td>
            </tr>

            <tr>
                <td class="reportConfigPanelLabel">
                    <bean:message key="time_format_selector.select_time_format"/>
                </td>
                <td class="reportConfigTimeFormatSelector">
                    <%-- contains data of row with time format selector in rounded box
                    icon for tooltip and container for tooltip --%>
                    <bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings"
                                 type="com.actimind.actitime.resources.SystemSettings"/>

                    <%
                        String customNoteKey = request.getParameter("customNoteKey");

                        String reportFormatNote = ATMessageResources.message(request,
                                                                             customNoteKey != null ? customNoteKey : "time_format_selector.time_format_note",
                                                                             settings.getDecimalSeparatorAsString());
                    %>

                    <at:roundedbox styleClass="roundedFormSection">
                        <select id="timeFormatSelect">
                            <option value="<%=String.valueOf(TimeFormat.TIME)%>">
                                <bean:message key="time_format_selector.time_format_hhmm"/>
                            </option>
                            <option value="<%=String.valueOf(TimeFormat.DECIMAL)%>">
                                <%=ATMessageResources.message(request, "time_format_selector.time_format_decimal",
                                                              settings.getDecimalSeparatorAsString(),
                                                              settings.getDecimalSeparatorAsString())%>
                            </option>
                        </select>
                    </at:roundedbox>
                    <div id="timeFormatInfo" class="infoIcon"></div>
                    <div id="timeFormatTooltip" class="yellowTooltip" style="display: none;">
                        <div id="timeFormatTooltip_textPlaceholder"><%=reportFormatNote%>
                        </div>
                    </div>


                </td>
            </tr>

        </table>
    </div>
    <div class="buttonsPanel">
        <input type="button" id="cancelReportConfiguration" class="cancelReportConfiguration" value="<bean:message key='common.approvers_dialog.cancel'/>"/>
        <input type="button" id="applyReportConfiguration" class="applyReportConfiguration" value="<bean:message key='common.approvers_dialog.apply'/>"/>
        <div class="errorMessage"></div>
    </div>
</div>

<div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
    <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
</div>

<div id='reportOverlay' class='reportOverlay'></div>
<div id='spinnerReportOverlay'></div>