<%@ page import="com.actimind.actitime.AccessRight" %>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.beans.UserBeanWithAccessRights" %>
<%@ page import="com.actimind.actitime.beans.UserBean" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<!doctype html>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/><bean:message key="actiplans.reports.title"/></title>
    <!--[if !IE]> -->
    <!-- IMPORTANT!! need to include pdfmake BEFORE "/include_scripts.jsp" -->
    <at:script page="/js/pdfmake/pdfmake.min.js"/>
    <at:script page="/js/pdfmake/vfs_fonts.js"/>
    <!-- <![endif]-->

    <at:script page="/js/native.history.js"/>

    <jsp:include page="/actiplans/include_scripts.jsp"/>
    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

    <at:script page="/invertedDays.js" preserveSessionID="true"
               timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

    <%@include file="/js/util/server_date_time_utils_js.jsp" %>

    <at:script page="/js/controls/custom_dropdown_button.js"/>
    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/single_date_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_dropdown_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>
    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
    <at:script page='/js/controls/LeaveReportColumnsFormatSelector.js'/>

    <at:script page='/js/reports/save_configuration_control.js'/>
    <at:script page="/js/reports/SaveReportManager.js"/>
    <at:script page="/js/reports/saveDialogControl.js"/>

    <at:script page="/js/reports/edit_config_controller/ReportEditConfigErrorTooltip.js"/>
    <at:script page="/js/reports/ErrorTooltipsForSectionsController.js"/>
    <at:script page="/js/reports/edit_config_controller/ReportEditConfigController.js"/>
    <at:script page="/js/reports/edit_config_controller/LeavesReportEditConfigController.js"/>

    <at:script page="/js/controls/selectorControls/at_report_leaves_selector_panel.js"/>
    <at:script page="/js/controls/ReportLeaveTypesSelectorButton.js"/>


    <at:script page="/js/amcharts/amcharts.js"/>
    <at:script page="/js/amcharts/themes/light.js"/>
    <at:script page="/js/amcharts/serial.js"/>

    <!--[if !IE]> -->
    <at:script page="/js/amcharts/plugins/export/export.min.js"/>
    <at:style page="/js/amcharts/plugins/export/export.css"/>

    <at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
    <!-- <![endif]-->

    <!--[if !IE]> -->
    <at:script page="/js/pdfjs/compatibility.js"/>
    <at:script page="/js/pdfjs/pdf.worker.js"/>
    <at:script page="/js/pdfjs/pdf.js"/>
    <!-- <![endif]-->
</head>
<%--TODO: "reportResultsPage", "leavesReport" classes are borrewed from aT, should make better names --%>
<body class="apReportsPage reportConfigPage reportResultsPage leavesReport with-navigation">
<%-- Navigation --%>
<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected" value="reports"/>
</jsp:include>

<%--TODO: evdokimov remove jsps--%>
<%-- Load users and groups to JS, for use in the users selector. --%>
<%@ include file="/actiplans/util/ap_users_util.jsp"%>
<jsp:include page="/actiplans/util/ap_users.jsp"/>
<jsp:include page="/util/user_groups.jsp"/>
<jsp:include page="/util/time_zone_groups.jsp"/>

<div id="tmpCalendarTemplateContainer" style="display: none;">
    <jsp:include page="../administration/leave_time_history_calendar.jsp" flush="false"/>
</div>

<at:form styleId="BalanceHistoryForm" action="/administration/prepareptohistorypdfonapreports">
    <html:hidden styleId="selectedUserFormId" property="userId" value=""/>
    <html:hidden styleId="balanceTypeFormId" property="balanceType" value=""/>
</at:form>

<jsp:include page="editConfig.jsp" flush="false"/>

<div id="apReport_generatePDFErrors">
    <%@ include file="/messages.jsp" %>
</div>

<script type="text/javascript">
    <% UserBeanWithAccessRights loggedInUser = AuthController.getLoggedInUserWithAccessRights(request); %>

    var UserRights = {
        LEAVE_BALANCE_MANAGER: <%=loggedInUser.isCanManageLeaveBalances(Product.actiPLANS)%>,
        LEAVE_TIME_MANAGER: <%=loggedInUser.isLeaveTimeManager()%>
    };

    var viewerInfo =  <% printUserBeanAsJSObject(out, loggedInUser);%>;
    var reportData = <%=jsHelper.toJSON(request.getAttribute(Keys.REPORT_DATA))%>;
    var defaultWorkSchedule = <%=Arrays.toString(settings.getDefaultWorkSchedule())%>;
    var apReportsPageSetting = <%=jsHelper.toJSON(request.getAttribute(Keys.AP_REPORTS_PAGE_SETTINGS))%>;

    var userSettings = <%=jsHelper.toJSON(request.getAttribute(Keys.LEAVE_TIME_HISTORY_SETTINGS_KEY))%>;
    var leaveTimeDetailsSettings = <%=jsHelper.toJSON(request.getAttribute(Keys.LEAVE_TIME_DETAILS_SETTINGS_KEY))%>;


    <%DateRange leaveTimeHistorySelectorDateRange = (DateRange) request.getAttribute(Keys.LEAVE_TIME_HISTORY_DATE_RANGE);%>
    var leaveTimeHistorySelectorDateRange = {};
    leaveTimeHistorySelectorDateRange.from = "<%=jsHelper.toJSON(leaveTimeHistorySelectorDateRange.getFrom())%>";
    leaveTimeHistorySelectorDateRange.to = "<%=jsHelper.toJSON(leaveTimeHistorySelectorDateRange.getTo())%>";

    Router.init('/' + '<%=RequestUtil.getContextName(request)%>');

    var leaveReportSettings = <%=jsHelper.toJSON(request.getAttribute(Keys.REPORT_PARAMS))%>;
    var leaveReportChartSettings = <%=jsHelper.toJSON(request.getAttribute(Keys.LEAVE_REPORT_CHART_SETTINGS))%>;

    var pagerSet = [];
    <% for( int i : Pager.CUSTOM_PAGES_SET_3 ) { %>
        pagerSet.push(<%=i%>);
    <% } %>
    var balanceHistorySettings = {
        formatterSettings: {
            workHoursPerDay: <%=((double)(Integer)request.getAttribute(Keys.DEFAULT_WORKDAY_DURATION))/60%>,
            showPTOInHours:<%=settings.isShowPTOInHours()%>,
            showSickInHours:<%=settings.isShowSickInHours()%>
        },
        ptoSettings: _.extend(<%=jsHelper.toJSON(request.getAttribute(Keys.MY_PTO_BALANCE_HISTORY_SETTINGS_KEY))%>, {pageSet: pagerSet}),
        sickSettings: _.extend(<%=jsHelper.toJSON(request.getAttribute(Keys.MY_SICK_BALANCE_HISTORY_SETTINGS_KEY))%>, {pageSet: pagerSet}),
        commonSettings: _.extend(<%=jsHelper.toJSON(request.getAttribute(Keys.BALANCE_HISTORY_SETTINGS_KEY))%>,
                                 {
                                     balanceViewerDate: currentUserTime().clearTime()
                                 })
    };

    var leaveParams = leaveReportSettings.leaveReportParameters;
    leaveParams.dateRangeSelection.fromDate = (Date.parseJSONDate(leaveParams.dateRangeSelection.fromDate));
    leaveParams.dateRangeSelection.toDate = (Date.parseJSONDate(leaveParams.dateRangeSelection.toDate));
    var showAssignedOnlyEnabled = <%=(loggedInUser.isLeaveTimeManager() && (settings.isLtmCanSeeAutoApproved() || (!loggedInUser.isCanManageAllUsersLTR() && settings.isLtmCanSeeAllRequests())))%>

    $(function()
      {
          new APReportsMediator().init({
                                           viewerInfo: viewerInfo,
                                           apReportsPageSetting: apReportsPageSetting,
                                           reportData: reportData,
                                           visibleUsers: users,
                                           userGroups: SystemSettings.apUGREnabled ? userGroups : null,
                                           timeZoneGroups: SystemSettings.apTZGEnabled ? timeZoneGroups : null,
                                           showAssignedOnlyEnabled: showAssignedOnlyEnabled,
                                           defaultWorkSchedule: defaultWorkSchedule,
                                           calendarUserSettings: userSettings,
                                           leaveTimeDetailsSettings: leaveTimeDetailsSettings,
                                           leaveTimeHistorySelectorDateRange: leaveTimeHistorySelectorDateRange,
                                           leaveReportChartSettings: leaveReportChartSettings,
                                           leaveReportSettings: leaveReportSettings,
                                           balanceHistorySettings: balanceHistorySettings
                                       });
      });
</script>
</body>
</html>
