<%@ page import="com.actimind.actiplans.APLicCountDownConfig"%>
<%@ page import="com.actimind.actitime.AccessRight"%>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean"%>
<%@ page import="com.actimind.actitime.util.StringUtils"%>
<%@ page import="com.actimind.common.LicCountDown" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.messageNoFilterArgs" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="com.actimind.actitime.beans.GUINotificationBean" %>
<%@ page import="com.actimind.actitime.colors.CustomizationSettings" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap"%>

<bean:define id="product" name="<%= Keys.PRODUCT %>" type="com.actimind.common.Product"/>

<%!
    private static enum MenuItem
    {
        my_schedule("navigator.my_schedule_menu_item", "/user/my_schedule.do")
        {
            @Override protected boolean isShown( UserAccessRightsBean userRights )
            {
                return true;
            }
        },

        corporate_schedule("navigator.corporate_schedule_menu_item", "/administration/leave_time_planning.do")
        {
            @Override protected boolean isShown( UserAccessRightsBean userRights )
            {
                return userRights.hasRight( AccessRight.LEAVE_TIME_MANAGER );
            }
        },

        reports("navigator.ap_reports_menu_item", "/reports/reports.do")
        {
            @Override protected boolean isShown( UserAccessRightsBean userRights ) { return true; }
        },

        employees("navigator.ap_users_menu_item", "/administration/userlist.do")
        {
            @Override protected boolean isShown( UserAccessRightsBean userRights )
            {
                return true;
            }
        };

        private final String titleKey;
        private final String path;
        MenuItem( String titleKey, String path ) { this.titleKey = titleKey; this.path = path; }
        protected abstract boolean isShown( UserAccessRightsBean userRights );
        protected String getTitleKey() { return titleKey; }
        protected String getPath() { return path; }
        private static int getNumberOfShown( UserAccessRightsBean userRights )
        {
            int count = 0;
            for( MenuItem item: MenuItem.values() )
                if( item.isShown( userRights ) )
                    count ++;
            return count;
        }
    }

%>
<%

    UserAccessRightsBean accessRights = (UserAccessRightsBean) request.getSession().getAttribute(Keys.LOGGEDIN_USER_RIGHTS_KEY);
    String selectedMenuItemName = request.getParameter("menuSelected");
    MenuItem selectedMenuItem = selectedMenuItemName == null ? null : MenuItem.valueOf( selectedMenuItemName );
    int menuItemsCount = MenuItem.getNumberOfShown( accessRights );

    String productSwitcherURL = ( String ) request.getAttribute( Keys.PRODUCT_SWITCHER_URL );

    GUINotificationBean guiNotification = ( GUINotificationBean ) request.getAttribute( Keys.USER_GUI_NOTIFICATION );
%>
<jsp:include page="../actiplans/css/ap_scheme_styles.jsp"/>
<at:script page="/js/refresh_session.js"/>
<at:script page='/js/spin.min.js'/>


<script  type="text/javascript">
    var REFRESH_SESSION_URL = '<html:rewrite page="/refreshSession"/>';
    var moireHelper = new MoireHelper();

    function onUserProfileLinkClicked()
    {
        var successCallback = function(){
            var accountWithoutEmail = $(".account-without-email");
            if (accountWithoutEmail){
                accountWithoutEmail.addClass("hide");
            }
        };
        loadPopupContent( '<html:rewrite page="/profile.do"/>', function() { showUserAPProfilePopup(successCallback); }, true );
    }

</script>

<bean:define id="user" name="<%=Keys.LOGGEDIN_USER_KEY%>" type="com.actimind.actitime.beans.UserBean" scope="session"/>
<bean:define id="userAccessRights" name="<%=Keys.LOGGEDIN_USER_RIGHTS_KEY%>" type="com.actimind.actitime.beans.UserAccessRightsBean" scope="session"/>

<div id="moireDiv" class="noprint"><ap:defImg styleId="muar" page="shade.png"/></div>

<logic:present name="<%=Keys.IS_DEMO_DATA_REMOVED%>" scope="session">
    <jsp:include page="/user/demo_data_removed.jsp"/>
</logic:present>
<jsp:include page="util/after_login_screen_helper.jsp"/>

<div class="navBg">
<table class="navTable actiplans" cellpadding=0 cellspacing=0 id="topnav">
	<tr>
		<td class="logoCell navCell" valign="top">
            <div style="position: relative">
                <div><ap:defImg page="pixel.gif" width="190" height="1"/></div>

                <% if( CustomizationSettings.get( request ).isDefaultInterfaceLogo() ) { %>
                    <div style="padding:24px 0 0 26px"><ap:img page="navigation/default-logo.png" width="125" height="40"/></div>
                <% } else { %>
                    <div class="logo">
                        <div class="logo-frame-top"><ap:defImg page="pixel.gif" width="1" height="1" border="0" alt=""/></div>
                        <div class="logo-frame-middle"><div class="logo-container"><at:logo/></div></div>
                        <div class="logo-frame-bottom"><ap:defImg page="pixel.gif" width="1" height="1" border="0" alt=""/></div>
                    </div>
                <% } %>
            </div>
		</td>
        <% boolean prevItemSelected = false; %>

        <% for( MenuItem menuItem: MenuItem.values() )  {%>
            <% if( menuItem.isShown( accessRights ) ) { %>
        
                <td class='navItem navCell relative <%=menuItem == selectedMenuItem ? "selected" : "notSelected"%>'>

                        <% if( menuItem == selectedMenuItem ) { %>

                            <a class='content <%=menuItem.name()%> selected'>
                                <div class="img">&nbsp;</div>
                                <div class="label">
                                    <%=ResponseUtils.filter(StringUtils.trimWithDots( messageNoFilterArgs( request, menuItem.getTitleKey() ), 18 ))%>
                                </div>
                            </a>

                        <% } else { %>

                            <html:link page='<%=menuItem.getPath()%>' styleClass='<%="content " + menuItem.name()%>'>
                                <div class="img">&nbsp;</div>
                                <div class="label" style="z-index:155; "><%=ResponseUtils.filter(StringUtils.trimWithDots( messageNoFilterArgs( request, menuItem.getTitleKey() ), 18 ))%></div>
                            </html:link>

                        <% } %>

                        <% prevItemSelected = menuItem == selectedMenuItem; %>
                </td>

            <% } %>
        <% } %>

        <td class="menuCell navCell" valign="top">
            <table cellpadding=0 cellspacing=0>
                <tr>
                    <td valign="top">
                        <% if (productSwitcherURL != null)
                        { %>
                        <span class="bottomBorder"><ap:defImg page="pixel.gif" width="1" height="1"/></span>
                        <div>
                            <a href="<%=productSwitcherURL%>" class="productSwitcher">
                                <div class="productName"><span><%=message(request, "navigator.switcher_title." + product.name())%></span></div>
                            </a>
                        </div>
                        <% } %>
                    </td>
                    <td valign="top">
                        <div class="menuCellDiv">
                            <table class="menuTableWrap<%=user.hasEmail() ? "" : " userWithoutEmail"%>" cellpadding=0 cellspacing=0 border=0>
                                <tr class="logoutContainer">
                                    <td class="profileCell">
                                            <a class='userProfileLink username' href='javascript:void(0)'
                                               onclick="onUserProfileLinkClicked(); return false;">
                                                <bean:write name="user" property="firstName"/>
                                                <logic:notEmpty name="user" property="middleName">
                                                    <bean:write name="user" property="middleName"/>.
                                                </logic:notEmpty>
                                                <bean:write name="user" property="lastName"/>
                                            </a>
                                            <% if (!user.hasEmail()) { %>
                                            <div class="account-without-email">
                                                <a class='userProfileLink warningImg' href='javascript:void(0)'
                                                   onclick="onUserProfileLinkClicked(); return false;">
                                                    <at:defImg page="warning_red_mark.png"
                                                               title='<%=message(request, "password_recovery.email_not_specified.ap", user.getFirstName())%>'/>
                                                </a>
                                            </div>
                                            <% } %>
                                    </td>
                                    <td class="logoutSeparator">&nbsp;|&nbsp;</td>
                                    <td class="logoutCell">
                                        <html:link styleClass="logout" styleId="logoutLink" page="/logout.do"><bean:message key="login.logout"/></html:link>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="3">
                                        <div class="menuTable">
                                            <% if (userAccessRights.hasRight(AccessRight.ACCOUNT_SETTINGS_MANAGER)) { %>
                                            <div class="topMenuButton">
                                                <jsp:include page="/actiplans/support/settings_popup_menu.jsp"/>
                                            </div>
                                            <%}%>
                                            <div class="topMenuButton">
                                                <jsp:include page="/actiplans/support/addons_popup_menu.jsp"/>
                                            </div>
                                            <div class="topMenuButton">
                                                <jsp:include page="/actiplans/support/support_popup_menu.jsp"/>
                                                <% new LicCountDown(new APLicCountDownConfig(request)).showIfNeeded(out, request); %>
                                            </div>
                                            <div class="topMenuButton">
                                                <!--Tips menu button placeholder-->
                                                <div class="popup_menu_container">
                                                    <div class="popup_menu_button popup_menu_button_tips"
                                                         onclick="PageOverlayTipsManager.getInstance().toggle()">
                                                        <div class="popup_menu_icon tips_icon"></div>
                                                        <div class="popup_menu_label">
                                                            <%=message(request, "navigator.tips_menu_item")%>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>
            </table>
        </td>
	</tr>
    <%-- GUI notifications --%>
    <% if (guiNotification != null) {%>
    <tr>
        <td>
            <jsp:include page="/support/gui_notification.jsp" flush="false"/>
        </td>
    </tr>
    <%}%>
</table>
</div>

<div class="noprint navBottomSpace <%=guiNotification != null ? "withGUINotification" : ""%>"></div>

<script type="text/javascript" defer>
    var topNav = document.getElementById("topnav");
    disableTextSelection(topNav);
    hideFocusForLinks(topNav);
    // Add strut to page bottom
    addListener(window, "load", function(){
        setTimeout( addStrutToPageBottom, 500);
    });
</script>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='aboutPopup'/>
    <jsp:param name="additionalClasses" value="noprint"/>
    <jsp:param name="innerJsp" value='/support/about.jsp'/>
</jsp:include>

<jsp:include page="/loading_popup.jsp">
    <jsp:param name="id" value='contentLoadingPopup'/>
</jsp:include>

<div id="popupContentLoadingPlaceholder"></div>

<script  type="text/javascript">
    $( document ).ready(function ()
                        {
                            <% if ( session.getAttribute( Keys.SHOW_MY_PROFILE ) != null ) {
                                session.removeAttribute( Keys.SHOW_MY_PROFILE );
                            %>
                                onUserProfileLinkClicked();
                            <% } %>
                        });
</script>

<script type="text/javascript">
    $(document).ready(function()
                      {
                          PageOverlayTipsManager.getInstance().init();
                      })
</script>