<!doctype html>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="java.util.Calendar" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.beans.UserScheduleBean" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.actiplans.ScrollingCalculator" %>
<%@ page import="com.actimind.actitime.beans.UserBean" %>
<%@ page import="com.actimind.actiplans.user.*" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="com.actimind.actiplans.administration.ColleaguesVisibility" %>
<%@ page errorPage="/actiplans/error.jsp" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%@ taglib prefix="logic" uri="http://struts.apache.org/tags-logic" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap"%>
<%@ taglib prefix="tiles" uri="http://struts.apache.org/tags-tiles" %>
<bean:define id="form" name="MyScheduleForm" type="com.actimind.actiplans.user.MyScheduleForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />
<%
    MyScheduleSettings myScheduleSettings = ( MyScheduleSettings ) request.getAttribute( Keys.MY_SCHEDULE_SETTINGS_KEY );
    MySchedulePageData mySchedulePageData = ( MySchedulePageData ) request.getAttribute( Keys.MY_SCHEDULE_PAGE_DATA );
    String mySchedulePageDataJson = jsHelper.toJSON( mySchedulePageData );
    Calendar fromCal = TimeUtils.createSystemCalendar();
    fromCal.setTime( form.getDateFrom() );

    UserBean user = AuthController.getLoggedInUser( request );

    Boolean wasAtIntegrated = (Boolean) request.getAttribute(Keys.IS_OTHER_PRODUCT_HAS_ACTIVE_LICENSE);
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="my_schedule.page.title"/></title>
    <jsp:include page="/actiplans/include_scripts.jsp"/>

    <%-- todo : when deleting jquery datatables from project keep some styles from dataTables.css: see note inside --%>
</head>
<body class="my_schedule with-navigation">

<%-- Navigation --%>
<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected" value="my_schedule" />
</jsp:include>

<%-- Load users and groups to JS, for use in the users selector. --%>
<%@ include file="/actiplans/util/ap_users_util.jsp"%>
<jsp:include page="/actiplans/util/ap_users.jsp"/>
<jsp:include page="/util/user_groups.jsp"/>
<jsp:include page="/util/time_zone_groups.jsp"/>

<div id="contentDiv" class="myScheduleContentDiv">

    <div id="contentInnerDiv" class="contentInnerDiv" >

        <logic:present name="<%=Keys.LOADED_DEMO_DATA_NAME%>" scope="session">
            <div style="padding-bottom: 23px;">
                <jsp:include page="/user/demo_data_loaded.jsp"/>
            </div>
        </logic:present>

        <div style="padding-bottom: 30px;" class="pagetitle">
            <bean:message key="my_schedule.page.title"/>
            <div id="editRequestSpinner"></div>
        </div>

        <div id="pageTabsHeader">
            <div id="pageTabsSwitcher"></div>
            <div id="balancesViewerPlaceholder"></div>
        </div>

        <div id="pageTabsSection" class="pageTabsSection">
            <div id="scheduleTab" class="scheduleTab">
                <table cellpadding="0" cellspacing="0" id="myScheduleSectionTable">
                    <tr>
                        <td id="legendCell">
                            <div id="legendHeader"><bean:message key="my_schedule.page.my_schedule.legend.header"/></div>
                            <div class="legendAction"><bean:message key="my_schedule.page.my_schedule.legend.first_action"/></div>
                            <div class="legendAction"><bean:message key="my_schedule.page.my_schedule.legend.second_action"/></div>
                            <table id="cellLegend">
                                <tr>
                                    <td>
                                        <div class="legendRequestImg"><ap:defImg page="not_approved_request.png" width="11" height="11" style="margin-top: 2px;"/></div>
                                        <div class="legendRequestPrintImg"><ap:defImg page="not_approved_request_print.png" width="11" height="11" style="margin-top: 2px;"/></div>
                                    </td>
                                    <td><bean:message key="my_schedule.page.my_schedule.legend.hatched_request"/></td>
                                </tr>
                                <tr>
                                    <td>
                                        <div class="legendRequestImg"><ap:defImg page="approved_request.png" width="11" height="11" style="margin-top: 2px;"/></div>
                                        <div class="legendRequestPrintImg"><ap:defImg page="approved_request_print.png" width="11" height="11" style="margin-top: 2px;"/></div>
                                    </td>
                                    <td><bean:message key="my_schedule.page.my_schedule.legend.solid_request"/></td>
                                </tr>
                            </table>
                        </td>
                        <td id="mSpacerCell">&nbsp;</td>
                        <td id="contentCell">
                            <table id="mainContentTable">
                                <tr>
                                    <td style="padding: 0" id="myScheduleScrollPanel"></td>
                                </tr>
                                <tr>
                                    <td id="mainCell">
                                        <div id="myScheduleTableContainer"></div>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>

                <div id="scheduleLegend" class="leaveTableLegend">
                    <table id="scheduleLegendTable">
                        <tr style="padding: 0;">
                            <td id="scheduleLegendFirstBlock">
                                <div class="scheduleLegendLTBlock">
                                    <div class="workingDayColorBlock">
                                        <div class="workingDayColor">&nbsp;</div>
                                    </div>
                                    <span class="scheduleLegendDayType"><bean:message key="my_schedule.page.legend.working_day"/></span>
                                </div>
                                <div class="scheduleLegendLTBlock" id="nonWorkingDayBlock">
                                    <div class="workingDayColorBlock">
                                        <div class="nonWorkingDayColor">&nbsp;</div>
                                    </div>
                                    <span class="scheduleLegendDayType"><bean:message key="my_schedule.page.legend.non_working_day"/></span>
                                </div>
                            </td>
                            <td id="scheduleLegendSecondBlock">
                                <table id="scheduleLegendSecondBlockTable">

                                </table>
                            </td>
                        </tr>
                    </table>
                </div>

                <div id="colleaguesTableSection" class="colleaguesTableSection">
                    <div class="colleaguesTableName"><bean:message key="my_schedule.page.colleagues_table.title"/></div>
                    <div id="usersSelectorId" class="usersSelector"></div>
                    <div style="position: relative; z-index: 1">
                        <div style="position: absolute; top: 12px; left: 12px;">
                            <input type="text" class="searchField colleaguesSearchField" name="searchField" id="colleaguesSearchField" maxlength="32">
                            <div id="spinnerPlaceholderSearchField"></div>
                        </div>
                    </div>
                    <div id="colleaguesTable"></div>
                    <jsp:include page="/administration/pager_panel.jsp"/>
                </div>
            </div>

            <div id="requestsTableTab" class="requestsTableTab">
                <div id="myRequestsTable">
                    <jsp:include page="../controls/leave_request_table.jsp"/>
                </div>
            </div>

        </div>
    </div>
</div>

<div id="wasAtIntegratedTooltip" class="leaveTimeRequestsPageTooltip">
    <bean:message key="my_schedule.page.leave_requests_table.tooltip.was_at_integrated"/>
</div>

<div id="cannotEditPastRequestTooltip" class="leaveTimeRequestsPageTooltip">
    <bean:message key="my_schedule.page.leave_requests_table.tooltip.cannot_edit_past"/>
</div>



<jsp:include page="../controls/leave_request_dialog.jsp"/>

<at:script page="/js/jquery/jquery.dataTables.min.js"/>

<at:script page='/js/controls/dataTables_helpers.js'/>

<at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

<%@ include file="/actiplans/util/InvocationResultCodes.jsp" %>

<at:script page="/actiplans/js/user/DateRangeCalculator.js"/>
<at:script page="/js/ArraySlice.js"/>
<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/actiplans/js/administration/scroll_panel.js"/>
<%@ include file="/actiplans/administration/scroll_panel.jsp" %>


<script type="text/javascript">

    var MySchedulePageConstants = {};
    MySchedulePageConstants.MAX_VISIBLE_DAYS = <%=ScrollingCalculator.MAX_VISIBLE_DAYS%>;

    var dateRangeCalculator = new DateRangeCalculator(<%=ScrollingCalculator.MAX_VISIBLE_DAYS%>, <%=ScrollingCalculator.FIRST_SCROLLING_DAYS%>, <%=ScrollingCalculator.ADDITION_SCROLLING_DAYS%>);

    var dateFrom = Date.create( <%=String.valueOf( fromCal.get( Calendar.YEAR ) )%>, <%=String.valueOf( fromCal.get( Calendar.MONTH ) )%>, <%=String.valueOf( fromCal.get( Calendar.DAY_OF_MONTH ) )%> );

    var mySchedulePageData = <%=mySchedulePageDataJson%>;
    var userInitialSchedule = <%=jsHelper.toJSON(user.getInitialSchedule())%>;
    var userSchedules = <%=jsHelper.toJSON((List<UserScheduleBean>) request.getAttribute( Keys.USER_SCHEDULES ))%>;

    var wasAtIntegrated = <%=wasAtIntegrated%>;

    var ColleaguesVisibility = {
        ALL_USERS: '<%=ColleaguesVisibility.ALL_USERS%>',
        USER_GROUP_ONLY: '<%=ColleaguesVisibility.USER_GROUP_ONLY%>',
        TIME_ZONE_GROUP_ONLY: '<%=ColleaguesVisibility.TIME_ZONE_GROUP_ONLY%>'
    };

    SystemSettings.apScheduleColleaguesVisibility = '<%=settings.getColleaguesVisibility()%>';

    $(document).on("ready", function(){
        new MySchedulePageController().init(
                dateFrom,
                dateRangeCalculator,
                mySchedulePageData,
                userInitialSchedule,
                userSchedules,
                {
                    recordsPerPage: <%=myScheduleSettings.getColleaguesPerPage()%>,
                    userSelection: <%=jsHelper.toJSON(myScheduleSettings.getUserSelection())%>
                },
                wasAtIntegrated,
                {
                    userGroups:  userGroups,
                    timeZoneGroups:  timeZoneGroups,
                    users: users
                }
        );
    });

    PageOverlayTipsManager.setInstance(new MySchedulePageOverlayTipsManager());
</script>

</body>
</html>