 <%@ page import="com.actimind.actitime.util.TimeUtils" %>
<%@ page import="com.actimind.actitime.Keys" %>
 <%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
 <%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<bean:define id="form" name="GeneralSettingsForm" type="com.actimind.common.administration.BaseGeneralSettingsForm"/>
<bean:define id="userTimeZone" name="<%=Keys.USER_TIME_ZONE%>" scope="request" type="java.util.TimeZone"/>

<bean:parameter id="numberOfUsersWithDefaultBalanceSettings" name="numberOfUsersWithDefaultBalanceSettings"/>
<bean:parameter id="leaveTypeBalanceTypePrefix" name="leaveTypeBalanceTypePrefix"/>
<bean:parameter id="balanceTypeKeyMessage" name="balanceTypeKeyMessage"/>
<bean:parameter id="className" name="className"/>

 <% String showInHoursProperty=  leaveTypeBalanceTypePrefix + "ShowInHours";%>
 <% String userBalanceEnabled= leaveTypeBalanceTypePrefix + "UserEnabled";%>
 <% String userBalanceEnabledId= leaveTypeBalanceTypePrefix + "UserEnabledId";%>
 <% String roundLeaveBalanceOnUserlist = leaveTypeBalanceTypePrefix + "RoundBalanceOnUserlist"; %>
 <% String roundLeaveBalanceOnUserlistId = leaveTypeBalanceTypePrefix + "RoundBalanceOnUserlistId"; %>
 <% String showInDaysId = leaveTypeBalanceTypePrefix + "ShowInDays"; %>
 <% String showInHoursId = leaveTypeBalanceTypePrefix + "ShowInHours"; %>


<div class="<%=className%>" id="<%=leaveTypeBalanceTypePrefix%>Block">
    <div class="collapsibleBlockContent">

        <table cellpadding="0" cellspacing="0" border="0" class="showBalanceSettings" style="margin-top: 10px;">
            <tr>
                <td class="formfieldtitle formFieldCaption">
                    <bean:message key="general_settings.balance.show_balance.in"/>
                </td>
                <td style="width: 23px;">
                    <html:radio property="<%=showInHoursProperty%>" value="false" styleId="<%=showInDaysId%>"/>
                </td>
                <td style="width: 55px;">
                    <label for="<%=leaveTypeBalanceTypePrefix%>ShowInDays"><bean:message key="general_settings.balance.days"/></label>
                </td>
                <td style="width: 23px;">
                    <html:radio property="<%=showInHoursProperty%>" value="true" styleId="<%=showInHoursId%>"/>
                </td>
                <td class="showInHoursLabelCell">
                    <label for="<%=leaveTypeBalanceTypePrefix%>ShowInHours"><bean:message key="general_settings.balance.hours"/></label>
                </td>
            </tr>
            <tr>
                <td class="secondRow">&nbsp;</td>
                <td class="secondRow">
                    <html:checkbox styleId="<%=roundLeaveBalanceOnUserlistId%>" property="<%=roundLeaveBalanceOnUserlist%>"/>
                </td>
                <td colspan="3" class="secondRow">
                    <label for="<%=roundLeaveBalanceOnUserlistId%>" id="round<%=leaveTypeBalanceTypePrefix%>BalanceLabel" class="roundLabel"><bean:message key="general_settings.balance.round_balance_on_userlist"/></label>
                </td>
            </tr>
        </table>

        <table cellpadding="0" cellspacing="0" border="0" class="balanceRulesTable">
            <tr>
                <td class="formfieldtitle formFieldCaption" style="vertical-align: top; padding-top: 23px;">
                    <span id="<%=leaveTypeBalanceTypePrefix%>RulesLabel"><bean:message key="general_settings.balance.default_accrual_rules"/></span>
                </td>
                <td colspan="4" class="rulesEditor">
                    <div class="defaultBalanceNoteBlock noteContainer">
                        <at:img page="note_mark.gif" styleClass="noteImage"/>
                        <span class="defaultBalanceNoteText"><bean:message key="general_settings.balance.info.custom"/></span>
                    </div>
                    <jsp:include page="/controls/leave_balance_rules_editor.jsp">
                        <jsp:param name="leaveTypeBalanceTypePrefix" value="<%=leaveTypeBalanceTypePrefix%>"/>
                    </jsp:include>
                    <div class="userInfo">
                        <logic:equal name="numberOfUsersWithDefaultBalanceSettings" value="1">
                            <bean:message key="general_settings.balance.one_user_use_default" arg0="<%=message(request, balanceTypeKeyMessage)%>"/>
                        </logic:equal>
                        <logic:notEqual name="numberOfUsersWithDefaultBalanceSettings" value="1">
                            <bean:message key="general_settings.balance.some_users_use_default" arg0="<%=numberOfUsersWithDefaultBalanceSettings%>" arg1="<%=message(request, balanceTypeKeyMessage)%>"/>
                        </logic:notEqual>
                    </div>
                    <div class="modificationsInfo" id="<%=leaveTypeBalanceTypePrefix%>LeaveBalanceModificationsInfo">
                        <bean:message key="general_settings.balance.balance_modification_note"
                                arg0='<%=TimeUtils.formatTimestamp( request, TimeUtils.getNDaysAfter( new java.util.Date(), 1, false), "EEEE, MMMMM dd", userTimeZone )%>'/>
                        <div id="undoLeaveBalanceModifications" class="undoModifications"><bean:message key="general_settings.balance.undo_modifications" arg0="<%=message(request, balanceTypeKeyMessage)%>"/></div>
                    </div>
                </td>
            </tr>
        </table>
        <table cellpadding="0" cellspacing="0" border="0" class="controlMode">
            <tr>
                <td class="formfieldtitle formFieldCaption">
                    <bean:message key="general_settings.balance.default_control_mode"/>
                </td>
                <td style="width: 23px;">
                    <html:checkbox styleId="<%=userBalanceEnabledId%>" property="<%=userBalanceEnabled%>"/>
                </td>
                <td colspan="3">
                    <label for="<%=userBalanceEnabledId%>" id="resetRuleLabel"><bean:message key="general_settings.balance.turn_on_for_new_users" arg0="<%=message(request, balanceTypeKeyMessage)%>"/></label>
                </td>
            </tr>
        </table>

        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>AccrualRuleEnabled">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>AccrualRuleValue">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>AccrualRuleFrequencyTypeName">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>AccrualRuleParameters">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>ResetRuleEnabled">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>ResetRuleValue">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>ResetRuleFrequencyTypeName">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>ResetRuleParameters">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>CapRuleEnabled">
        <input type="hidden" name="<%=leaveTypeBalanceTypePrefix%>CapRuleValue">

    </div>

</div>