<!doctype html>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.util.Util" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<bean:define id="form" name="BillingTypeModifyForm" type="com.actimind.actitime.administration.BillingTypeModifyForm" scope="session"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="billing_type.edit.title"/></title>

    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <script language="JavaScript">
        var fieldErrors = {};

        function deleteType()
        {
            var confirmationMessage = messageResource.getMessage('billing_type.confirm_delete');
            if (confirm(confirmationMessage))
            {
                ExitConfirmation.disableConfirmationOnUnloadPage();
                var form = document.getElementById('billingTypeEditForm');
                form.action = '<html:rewrite page="/administration/btdelete.do"/>';
                form.submit();
            }
        }

        function onLoad()
        {
            init();

            confirmDlg = new ConfirmExitDlg(400, messageResource.getMessage("billing_type.edit.creation_not_finished_warning"),
                    messageResource.getMessage("billing_type.edit.save_modification_confirm"),
                    messageResource.getMessage("common.buttons.save_changes"),
                    messageResource.getMessage("common.buttons.discard_changes"),
                    messageResource.getMessage("common.buttons.remain_on_page"));

            registerChangeable();

            validateForm();

            markServerErrors();

            ExitConfirmation.setUpBaseExitConfirmation( "billing_type.edit.exit_confirmation", false );
            addListener(document.getElementById('billingTypeEditForm'), "submit", ExitConfirmation.disableConfirmationOnUnloadPage);
        }
    </script>

</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" onload="onLoad()" class="with-navigation">
<div id="container">
<jsp:include page="/top.jsp" flush="false">
    <jsp:param name="menuSelected" value="<%=Navigator.NO_SELECTION_KEY%>"/>
</jsp:include>
    <table cellpadding="0" cellspacing="0" border="0" width="800" align="center">
        <tr>
            <td align="center" class="mainContentPadding rightPadding">
                <table cellspacing="0" cellpadding="5" align="center" valign="top" border="0" width="800">
                    <tr>
                        <td class="pagetitle" style="padding-bottom:13px;">
                            <bean:message key="billing_type.edit.title"/>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <at:roundedbox styleClass="roundedFormSection formsummarybackground">
                                <table width="100%" cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td>
                                            <table>
                                                <tr>
                                                    <td class="formblocktitle" nowrap="1">
                                                        <bean:message key="billing_type.edit.header.type_name"/>
                                                    </td>
                                                    <td class="textemphasis" style="padding-left:10px;">
                                                        <bean:write name="form" property="savedName"/>
                                                    </td>
                                                    <logic:equal value="true" name="form" property="default">
                                                        <td class="formfieldtitle">
                                                            (<bean:message key="billing_type.default_billing_type"/>)
                                                        </td>
                                                    </logic:equal>
                                                </tr>
                                                <tr>
                                                    <td class="formblocktitle" nowrap="1">
                                                        <bean:message key="common.status"/>:
                                                    </td>
                                                    <logic:equal value="true" name="form" property="savedActive">
                                                        <td colspan="2" class="formblocktitle"
                                                            style="padding-left:10px;">
                                                        <span class="textenabled"><bean:message
                                                                key="billing_type.edit.header.active"/></span>
                                                        </td>
                                                    </logic:equal>
                                                    <logic:notEqual value="true" name="form" property="savedActive">
                                                        <td colspan="2" class="formblocktitle"
                                                            style="padding-left:10px;">
                                                        <span class="textdisabled"><bean:message
                                                                key="billing_type.edit.header.archived"/></span>
                                                        </td>
                                                    </logic:notEqual>
                                                </tr>
                                                <tr>
                                                    <td class="formblocktitle" nowrap="1" style="padding-top:10px;">
                                                        <bean:message key="billing_type.edit.header.billing_type"/>
                                                    </td>
                                                    <td colspan="2" class="text"
                                                        style="padding-left:10px;padding-top:10px;">
                                                        <logic:equal value="true" name="form" property="savedBillable">
                                                            <bean:message key="billing_type.billable"/>
                                                        </logic:equal>
                                                        <logic:equal value="false" name="form" property="savedBillable">
                                                            <bean:message key="billing_type.non_billable"/>
                                                        </logic:equal>
                                                    </td>
                                                </tr>
                                                <logic:equal value="true" name="form" property="braEnabled">
                                                    <tr>
                                                        <td class="formblocktitle" nowrap="1">
                                                            <bean:message key="billing_type.edit.header.rate"/>
                                                        </td>
                                                        <td colspan="2" class="text" style="padding-left:10px;">
                                                            <logic:equal value="true" name="form" property="savedBillable">
                                                                <%=form.getSavedFormattedRate(settings)%>
                                                                <bean:message key="billing_type.rate_postfix"
                                                                              arg0="<%=ResponseUtils.filter(settings.getCurrencySign())%>"/>
                                                            </logic:equal>
                                                            <logic:equal value="false" name="form" property="savedBillable">
                                                                <bean:message key="common.not_available"/>
                                                            </logic:equal>
                                                        </td>
                                                    </tr>
                                                </logic:equal>
                                            </table>
                                        </td>
                                        <td align="right" valign="top">
                                            <%
                                                String deleteButtonTitle = filteredMessage( request, "billing_type.edit.header.delete_button_caption" );
                                                String deleteButtonWidth = (Util.getButtonWidthPixels(deleteButtonTitle) - 4) + "px";
                                            %>
                                            <table cellpadding="0" cellspacing="0" border="0"
                                                   style="width:<%=deleteButtonWidth%>">
                                                <tr>
                                                    <td align="right">
                                                        <input type="button"
                                                                <logic:equal value="true" name="form" property="inUse">
                                                                    disabled='true'
                                                                </logic:equal>
                                                               value='<%=deleteButtonTitle%>'
                                                               onclick='deleteType();'
                                                               style="width:<%=deleteButtonWidth%>"/>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td align="right">
                                                        <logic:equal value="true" name="form" property="inUse">
                                                            <div class="noteContainer">
                                                                <at:img page="note_mark.gif" styleClass="noteImage"/>
                                                                <span class="notemsg"><bean:message key="billing_type.delete.tooltip.type_in_use"/></span>
                                                            </div>
                                                        </logic:equal>
                                                    </td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </at:roundedbox>
                        </td>
                    </tr>
                    <tr>
                        <td class="pagetitle" height="10px">
                            <div id="ClientSideErrorMessage" style="display:none; padding-top:8px;">
                                <bean:define id="details" value="saving modifications" toScope="request"/>
                                <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <bean:define id="type_form" name="form" toScope="request"/>
                            <jsp:include page="/administration/billing_type_form.jsp">
                                <jsp:param name="action" value="/administration/btedit.do"/>
                                <jsp:param name="formId" value="billingTypeEditForm"/>
                                <jsp:param name="mainSectionTitle"
                                           value='<%=filteredMessage( request, "billing_type.edit.title")%>'/>
                                <jsp:param name="submitButtonCaption"
                                           value='<%=filteredMessage( request, "billing_type.edit.save_button_caption")%>'/>
                                <jsp:param name="cancelConfirmMsg"
                                           value='<%=jsMessage( request, "billing_type.edit.cancel_button_confirm")%>'/>
                                <jsp:param name="highlightModificationsDetected" value="true"/>
                            </jsp:include>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</div>

<p>&nbsp;</p>
</body>
</html>