<%@ page import="com.actimind.actitime.colors.ColorHelper" %>
<%@ page import="com.actimind.actitime.util.Util" %>
<%@ page import="org.apache.struts.action.ActionMessages" %>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="org.apache.struts.action.ActionMessage" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.actimind.actitime.administration.ATTypeConstants" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.Constants" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="com.actimind.actitime.beans.BillingTypeBean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%--
  This jsp creates billing type form.
  Parameters are:
     - action                         - action for form submiting (String, not null);
     - formId                         - specify id for form access from js (String, null)
     - mainSectionTitle               - title of the main section (String, not null);
     - submitButtonCaption            - caption of the submit button (String, not null);
     - cancelConfirmMsg               - message which will be shown if user cancel modifications (String, not null);
     - highlightModificationsDetected - highlight modifications detected text on form changes if "true",
                                        not display modifications detected text if "false"
                                        (String; expected values: "true", "false");
  Requires:
    - include "form_changes.js" and initialize "confirmDlg" variable
    - call "registerChangeable" function on page load to initialize changes handler.
    - define type_form bean is request scope.
--%>
<bean:define id="form" name="type_form" scope="request" type="com.actimind.actitime.administration.BillingTypeModifyForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<%
    String formId = request.getParameter("formId");
    if (Util.isEmpty(formId))
    {
        formId = "billingTypeForm";
    }
%>

<script type="text/javascript">
    var numbersValidator;
    var isPreviousRateValueEmpty = false;
    var braEnabled = <%=form.isBraEnabled()%>;
    var isNonBillableDefault = <%=String.valueOf( form.getId() == BillingTypeBean.NON_BILLABLE_DEFAULT_ID )%>
    
    function registerChangeable()
    {
        var form = getForm();
        registerChangeableControl(form.name);
        if( !isNonBillableDefault )
        {
            registerChangeableControl(form.active);
            registerChangeableControl(form.billable[0]);
            registerChangeableControl(form.billable[1]);
            if (braEnabled) {
                registerChangeableControl(form.rateStr);
            }
        }
        registerFormChangedHandlers(<%=request.getParameter("highlightModificationsDetected")%>);

        setSubmitHandler(doSubmit);
    };

    function init()
    {
        numbersValidator = new FloatNumbersValidator( "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
                    "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>", <%=Constants.MAX_RATE%>);

        getForm().elements['<%=ATTypeConstants.TYPE_NAME_FIELD%>'].focus();
    }

    function handleCancel()
    {
        cancelForm('<%=request.getParameter("cancelConfirmMsg")%>', '<html:rewrite page="/administration/btlist.do"/>', ExitConfirmation.disableConfirmationOnUnloadPage);
    }

    function handleIconChange()
    {
        handleChange(true);
    }

    var currentNameValue = trim('<%=StringUtils.getStringEscapedForJS(form.getName())%>');

    function nameChanged(nameField)
    {
        if (trim(nameField.value) != currentNameValue)
        {
            ClientSideErrors.markTextFieldAsValid(nameField);
            ClientSideErrors.markFieldLabelsAsValid(document.getElementById("nameLabel"));

            ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
            currentNameValue = trim(nameField.value);
        }
    }

    function billableChangedToFalse()
    {
        if (!braEnabled) return;

        if (trim(getForm().rateStr.value) == "")
        {
            document.getElementById('rateValue').value = "";
        }
        resetRateErrors();
    }

    function billableChangedToTrue()
    {
        if (!braEnabled) return;

        checkRateIsValid(getForm().rateStr);
    }

    function resetRateErrors()
    {
        ClientSideErrors.markFieldLabelsAsValid(document.getElementById("rateLabel"));
        ClientSideErrors.markTextFieldAsValid(getForm().rateStr);
        ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
    }

    function checkRateIsNotEmpty(field)
    {
        if (!braEnabled) return;

        var isBillable = getForm().billable[0].checked;
        if (trim(field.value) == "" && isBillable)
        {
            isPreviousRateValueEmpty = true;
            var message = messageResource.getMessage("billing_type.error.rate_required");
            ClientSideErrors.markTextFieldAsInvalid(field, message);
            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("rateLabel"), message);
        }
    }
    
    function checkRateIsValid(field)
    {
        var isBillable = getForm().billable[0].checked;

        if (trim(field.value) == "")
        {
            if (!isPreviousRateValueEmpty)
            {
                resetRateErrors();
            }
            return;
        }
        
        isPreviousRateValueEmpty = false;
        if (isBillable)
        {
            var isRateValid = numbersValidator.checkNumber(field, "rates.errors.invalid_rate",
                                                              "rates.errors.large.rate");
            if (isRateValid)
            {
                document.getElementById('rateValue').value = numbersValidator.parseNumber(field.value);
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById("rateLabel"));
            }
            else
            {
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("rateLabel"), field.title);
            }
        }
        else
        {
            ClientSideErrors.markFieldLabelsAsValid(document.getElementById("rateLabel"));
        }

        ClientSideErrors.hideClientSideErrorMessageIfNoErrors();
    }

    function getForm()
    {
        return document.getElementById("<%=formId%>");
    }

    function validateForm()
    {
        var form = getForm();

        checkTypeName(form);

        if (!isNonBillableDefault && braEnabled) {
            checkRateIsValid(form.rateStr);
            checkRateIsNotEmpty(form.rateStr);
        }

        if (ClientSideErrors.hasErrors())
            ClientSideErrors.showClientSideErrorMessage();                
    }

    function checkTypeName(form)
    {
        if (trim(form.name.value) == "")
        {
            var message = messageResource.getMessage("billing_type.error.name_required");

            ClientSideErrors.markTextFieldAsInvalid(form.name, message);
            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("nameLabel"), message);
        }
    }

    function canSubmit()
    {
        ClientSideErrors.hideClientSideErrorMessage();

        validateForm();

        if (ClientSideErrors.hasErrors())
        {
            ClientSideErrors.showClientSideErrorMessage();
            return false;
        }

        return true;
    }

    function doSubmit()
    {
        if (canSubmit())
        {
            ExitConfirmation.disableConfirmationOnUnloadPage();
            document.getElementById('<%=formId%>').submit();
        }
    }
</script>

<at:form action='<%=request.getParameter("action")%>' method="post" autocomplete="off"
         styleId='<%=formId%>' onsubmit="return canSubmit();">

<input type="hidden" name="submitted" value="1" />
<html:hidden property="formDataModified"/>
<html:hidden property="redirectUrl"/>
<html:hidden property="afterReloginUrl"/>
<html:hidden property="beforeReloginUsername"/>
<html:hidden property="id"/>  

<script type="text/javascript">
    function markFieldAsInvalid(fieldName, messageKey, messageParams)
    {
        ClientSideErrors.markTextFieldAsInvalid(document.getElementById(fieldName),
                messageResource.getMessage(messageKey, messageParams));
        ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(fieldName+"Label"),
                messageResource.getMessage(messageKey, messageParams));
    }

    function markServerErrors()
    {
        var messageParams;
    <%
        ActionMessages messages = (ActionMessages) session.getAttribute(Globals.ERROR_KEY);

        if( (messages != null) && !messages.isEmpty() )
        {
            Iterator propIterator = messages.properties();
            while(propIterator.hasNext())
            {
                String property = (String) propIterator.next();
                Iterator messIt = messages.get(property);
                while(messIt.hasNext())
                {
                    ActionMessage message = (ActionMessage) messIt.next();

                    if ( ((message != null) && (message.getKey().length() > 0) ) )
                    {
    %>
        messageParams = [];
    <%
                        Object[] values = message.getValues();
                        if (values != null)
                        {
                            for(int i = 0; i < values.length; i++)
                            {
    %>
        messageParams[<%="" + i%>] = "<%=values[i].toString()%>";
    <%
                            }
                        }
    %>
        markFieldAsInvalid("<%=property%>", "<%=message.getKey()%>", messageParams);
    <%
                    }
                }
            }
            session.removeAttribute(Globals.ERROR_KEY);
        }
    %>

        if (ClientSideErrors.hasErrors())
            ClientSideErrors.showClientSideErrorMessage();
    }
</script>

<table width="100%" cellspacing="0" cellpadding="0" align="left" valign="top" border="0" bgcolor="<%=ColorHelper.getColor("default.bg.color", request )%>">
    <tr>
        <td>
            <%@include file="/required_fields_note.jsp"%>
        </td>
        <td align="right">
            <%@include file="/form_modified_div.jsp" %>
        </td>
    </tr>
    <tr>
        <td colspan="2"><at:img height="15" width="1" page="pixel.gif" /></td>
    </tr>
    <tr>
        <td class="formblocktitle" colspan="2">
            <%=request.getParameter("mainSectionTitle")%>
        </td>
    </tr>
    <tr>
        <td colspan="2"><at:img height="15" width="1" page="pixel.gif" /></td>
    </tr>
    <tr>
        <td colspan="2" style="padding-left:40px;">
            <table cellspacing="0" cellpadding="3" align="left" valign="top" border="0" bgcolor="<%=ColorHelper.getColor("default.bg.color", request )%>">
                <tr>
                    <td class="formfieldtitlereq">
                        *
                    </td>
                    <td class="formfieldtitle" nowrap="true" width="46">
                        <span id="nameLabel">
                            <bean:message key="billing_type.form.name"/>:
                        </span>
                    </td>
                    <td colspan="2" style="padding-left:10px;">
                        <html:text property="name" styleId="<%=ATTypeConstants.TYPE_NAME_FIELD%>" style="width: 450px" maxlength="80" onchange="nameChanged(this);"/>
                    </td>
                </tr>
                <% if( form.getId() != BillingTypeBean.NON_BILLABLE_DEFAULT_ID ) {%>
                <tr>
                    <td colspan="3"><at:img height="5" width="1" page="pixel.gif" /></td>
                </tr>
                <tr>
                    <td class="formfieldtitlereq">
                        &nbsp;
                    </td>
                    <td class="formfieldtitle" width="46">
                        <bean:message key="common.status"/>:
                    </td>
                    <td colspan="2" style="padding-left:10px;">
                        <html:select property="active">
                            <html:option value="true"><bean:message key="billing_type.active"/></html:option>
                            <html:option value="false"><bean:message key="billing_type.archived"/></html:option>
                        </html:select>
                    </td>
                </tr>
                <tr>
                    <td colspan="3"><at:img height="10" width="1" page="pixel.gif" /></td>
                </tr>
                <tr>
                    <td style="vertical-align:top;padding-top:6px;" class="formfieldtitlereq">
                        *
                    </td>
                    <td style="vertical-align:top;padding-top:6px;" class="formfieldtitle" width="46">
                            <bean:message key="billing_type.form.billing_type"/>:
                    </td>
                    <td style="vertical-align:top; padding-left:20px">
                        <table cellspacing="0" cellpadding="0" border="0">
                            <tr>
                                <td class="aligned_radio_button_cell"><html:radio property="billable" value="true" onclick="billableChangedToTrue()" styleId="billingType_setBillable"/></td>
                                <td class="aligned_radio_button_text" valign="middle">
                                    <table cellpadding="0" cellspacing="0" border=0 width=150>
                                        <tr>
                                            <td class="aligned_radio_button_text"><label for="billingType_setBillable"><bean:message key="billing_type.billable"/></label></td>
                                            <td class="aligned_radio_button_text" style="text-align: right">
                                                <logic:equal value="true" name="form" property="braEnabled">
                                                    <label for="billingRate_input"><span id="rateLabel" style="padding-left:5px; padding-right:5px">
                                                        <bean:message key="billing_type.edit.header.rate"/>
                                                    </span></label>
                                                </logic:equal>
                                            </td>
                                        </tr>
                                    </table>
                                </td>
                                <logic:equal value="true" name="form" property="braEnabled">
                                    <td class="aligned_radio_button_text">
                                        <input id="billingRate_input" onchange="checkRateIsValid(this);"
                                            onfocus="this.form.billable[0].checked = true"
                                            maxlength="11" size="9"
                                            class="rate"
                                            name="rateStr"
                                            value="<%=StringUtils.encodeNbspCharacter( StringUtils.encodeQuoteCharacter( form.getFormattedRate(settings) ) )%>">
                                        <html:hidden property="rateValue" styleId="rateValue"/>
                                    </td>
                                    <td class="aligned_radio_button_text" style="padding-left:3px;">
                                        <bean:message key="billing_type.rate_postfix" arg0="<%=ResponseUtils.filter(settings.getCurrencySign())%>"/>
                                    </td>
                                </logic:equal>
                            </tr>
                            <tr>
                                <td class="aligned_radio_button_cell"><html:radio property="billable" value="false" onclick="billableChangedToFalse()" styleId="billingType_setNonBillable"/></td>
                                <td colspan="<%=(form.isBraEnabled() ? 3 : 1)%>" class="aligned_radio_button_text"><label for="billingType_setNonBillable"><bean:message key="billing_type.non_billable"/></label></td>
                            </tr>
                            <% } %>
                        </table>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td colspan="2"><at:img height="20" width="1" page="pixel.gif" /></td>
    </tr>
    <tr>
        <td id="ButtonPane" align="center" class="formbuttonpane" colspan="2" style="padding: 5px;">
            <input type="submit" value='   <%=request.getParameter("submitButtonCaption")%>   '/>
            <at:img height="1" width="100" page="pixel.gif" />
            <input type="button" value="      <bean:message key="common.cancel" />      " onclick="handleCancel();" />
        </td>
    </tr>
</table>
</at:form>

<jsp:include page="/form_changed_confirm.jsp"/>