<!doctype html>
<%@ page import="com.actimind.actitime.Constants"%>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.administration.ATTypeConstants" %>
<%@ page import="com.actimind.actitime.beans.BasicATTypeBean" %>
<%@ page import="com.actimind.actitime.resources.ATTypeStatusCriterion" %>
<%@ page import="com.actimind.actitime.resources.BillingTypeBillableCriterion" %>
<%@ page import="com.actimind.actitime.user.rates.RatesFormat" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.beans.BillingTypeBean" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<bean:define id="form" name="BillingTypeListForm" scope="session" type="com.actimind.actitime.administration.BillingTypeListForm"/>
<bean:define id="typeList" name="<%=Keys.BILLING_TYPE_LIST_KEY%>" type="java.util.List" />
<bean:define id="typesInUse" name="<%=Keys.BILLING_TYPE_IN_USE_KEY%>" type="java.util.Set" />
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="filter" name="<%=Keys.BILLING_TYPE_FILTER_KEY%>" scope="session" type="com.actimind.actitime.resources.BillingTypeFilter"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="billing_type.list.title"/></title>

    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <script type="text/javascript">
        PageOverlayTipsManager.setInstance(new BillingTypesPageOverlayTipsManager());
        var braEnabled = <%=form.isBraEnabled()%>;

        var numbersValidator = new FloatNumbersValidator( "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
                    "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>", <%=Constants.MAX_RATE%>);

        function onLoad()
        {
            initCreateBillingTypeButton();
            removeLastMovedRowHighlightingWithDelay();
        }


        function getForm()
        {
            return document.getElementById('typesListForm');
        }

        function initCreateBillingTypeButton() {
            var createCustomerButton = new GraphicButton( GraphicButton.getRoundedBox('createBillingTypeDiv',
                messageResource.getMessage("billing_type.list.add_button_text")));
            createCustomerButton.defineStandardEventHandlers(true, true, true, true);
            createCustomerButton.button.el.on("click", handleAddTypeButtonPress);
        }

        function handleAddTypeButtonPress()
        {
            document.location.href='<html:rewrite page="/administration/btadd.do?resetForm=true"/>';
        }

        function filterTypes()
        {
            var form = getForm();
            form.elements['pageAction'].value = '<%= ATTypeConstants.FILTER_TYPES_ACTION %>';
            form.submit();
        }

        function deleteType(typeId)
        {
            var confirmationMessage = messageResource.getMessage('billing_type.confirm_delete');
            if (confirm(confirmationMessage))
            {
                var form = getForm();
                form.elements['id'].value = typeId;
                form.action = '<html:rewrite page="/administration/btdelete.do"/>';
                form.submit();
            }
        }

        function moveType(currentTypeId, targetTypeId)
        {
            var form = getForm();
            form.elements['id'].value = currentTypeId;
            form.elements['moveTargetTypeId'].value = targetTypeId;
            form.elements['pageAction'].value = '<%= ATTypeConstants.MOVE_TYPE_ACTION %>';
            form.submit();
        }

        function toggleStatus(cell, typeId) {
            var manager = new StatusCellManager(cell, typeId);
            var wasActive = manager.isChecked();
            var isDefaultCell = document.getElementById("type_" + typeId + "_isdefault");
            manager.onDataSavingComplete = function(defaultBillingTypeId) {
                if (!wasActive) {
                    new IsDefaultCellManager(isDefaultCell, typeId).updateCell(false);
                } else {
                    new IsDefaultCellManager(isDefaultCell).disableCell();
                    var newDefaultCell = document.getElementById( "type_" + defaultBillingTypeId + "_isdefault" );
                    newDefaultCell.innerHTML = messageResource.getMessage("billing_type.list.is_default");
                    setCurrentDefaultCell(newDefaultCell, defaultBillingTypeId);
                }
            };
            RpcControlManager.saveRpcControlBoundData(manager);
            hideMessages();
        }

        function toggleType(cell, typeId)
        {
            var manager = new TypeCellManager(cell, typeId);
            manager.enabledCellClassName = "listtblcell billableStatusCell";
            manager.disabledCellClassName = "listtblcell billableStatusCell";
            manager.onDataSavingComplete = function(result)
            {
                if (braEnabled) {
                    var idPrefix = "type_" + typeId + "_";
                    document.getElementById(idPrefix + "billing_rate").innerHTML =
                            result == null ? "-" : numbersValidator.formatNumber(result);
                }
                cell.parentNode.className = cell.parentNode.className == "typelisttblrow" ?
                                            "typelisttblrow_non-billable" : "typelisttblrow";
                PageOverlayTipsManager.getInstance().refreshDynamicTips();
            };

            RpcControlManager.saveRpcControlBoundData(manager);
            hideMessages();
        }

        function setDefault(cell, typeId) {
            var manager = new IsDefaultCellManager(cell, typeId);
            RpcControlManager.saveRpcControlBoundData(manager);
            hideMessages();
        }
    </script>

</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" onload="onLoad()" class="with-navigation">
<div id="container">
<jsp:include page="/top.jsp" flush="false">
    <jsp:param name="menuSelected" value="<%=Navigator.NO_SELECTION_KEY%>" />
</jsp:include>

<at:script page='/js/cell_manager.js'/>
<at:script page='/js/attype_cell_manager.js'/>
<at:script page='/js/billing_type_cell_manager.js'/>

<html:form action="/administration/btlist.do" method="post" styleId="typesListForm">
    <html:hidden property="submitted" value="1"/>
    <html:hidden property="afterReloginUrl"/>
    <html:hidden property="beforeReloginUsername"/>
    <input type="hidden" name="id" value=""/>
    <input type="hidden" name="moveTargetTypeId" value=""/>
    <input type="hidden" name="pageAction" value=""/>

        <table cellpadding="0" cellspacing="0" border="0" width="770" align="center">
        <tr>
            <td align="center" class="mainContentPadding rightPadding">
    <table cellspacing="0" cellpadding="5" align="center" border="0"  width="770">
        <tr>
            <td class="pagetitle">
                <span><bean:message key="billing_type.list.title"/></span>
            </td>
            <td align="right" rowspan="2" valign="top">
                <div id="createBillingTypeDiv"><!--Place for rendering "Create billing type" button--></div>
            </td>
        </tr>
        <tr>
            <td colspan="2" class="pagetitle" height="10px">
                <%@ include file="/messages.jsp"%>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <table cellspacing="0" cellpadding="10" align="center" valign="top" border="0" width="100%">
                    <tr>
                        <td nowrap="1" class="formbuttonpane" style="text-align:left; vertical-align:middle">
                            <table cellspacing="0" cellpadding="0" align="left" width="100%">
                                <tr>
                                    <td class="formblocktitle" valign="top" nowrap="1" style="padding-top:2px;">
                                        <bean:message key="billing_type.list.filter.status.caption"/>
                                    </td>
                                    <td><at:img width="5" page="pixel.gif" /></td>
                                    <td class="formfieldtitle" valign="top">
                                        <table cellspacing="0" cellpadding="0" border="0">
                                        <tr>
                                            <td class="aligned_radio_button_cell"><html:radio property="statusCriterionAsString" value="<%= ATTypeStatusCriterion.ALL.toString() %>" styleId="filterStatusCriterion_All"/></td>
                                            <td class="aligned_radio_button_text"><label for="filterStatusCriterion_All"><bean:message key="billing_type.list.filter.status.criterion.all"/></label></td>
                                        </tr>
                                        <tr>
                                            <td class="aligned_radio_button_cell"><html:radio property="statusCriterionAsString" value="<%= ATTypeStatusCriterion.ACTIVE.toString() %>" styleId="filterStatusCriterion_Active"/></td>
                                            <td class="aligned_radio_button_text"><label for="filterStatusCriterion_Active"><bean:message key="billing_type.list.filter.status.criterion.active"/></label></td>
                                        </tr>
                                        <tr>
                                            <td class="aligned_radio_button_cell"><html:radio property="statusCriterionAsString" value="<%= ATTypeStatusCriterion.ARCHIVED.toString() %>" styleId="filterStatusCriterion_Archived"/></td>
                                            <td class="aligned_radio_button_text"><label for="filterStatusCriterion_Archived"><bean:message key="billing_type.list.filter.status.criterion.archived"/></label></td>
                                        </tr>
                                        </table>
                                    </td>
                                    <td><at:img width="25" page="pixel.gif" /></td>
                                    <td class="formblocktitle" valign="top" nowrap="1" style="padding-top:2px;">
                                        <bean:message key="billing_type.list.filter.type.caption"/>
                                    </td>
                                    <td><at:img width="5" page="pixel.gif" /></td>
                                    <td class="formfieldtitle" valign="top">
                                        <table cellspacing="0" cellpadding="0" border="0">
                                        <tr>
                                            <td class="aligned_radio_button_cell"><html:radio name="form" property="billableCriterionAsString" value="<%= BillingTypeBillableCriterion.ALL.toString() %>" styleId="filterBillableCriterion_All"/></td>
                                            <td class="aligned_radio_button_text"><label for="filterBillableCriterion_All"><bean:message key="billing_type.list.filter.type.criterion.all"/></label></td>
                                        </tr>
                                        <tr>
                                            <td class="aligned_radio_button_cell"><html:radio name="form" property="billableCriterionAsString" value="<%= BillingTypeBillableCriterion.BILLABLE.toString() %>" styleId="filterBillableCriterion_Billable"/></td>
                                            <td class="aligned_radio_button_text"><label for="filterBillableCriterion_Billable"><bean:message key="billing_type.list.filter.type.criterion.billable"/></label></td>
                                        </tr>
                                        <tr>
                                            <td class="aligned_radio_button_cell"><html:radio name="form" property="billableCriterionAsString" value="<%= BillingTypeBillableCriterion.NON_BILLABLE.toString() %>" styleId="filterBillableCriterion_NonBillable"/></td>
                                            <td class="aligned_radio_button_text"><label for="filterBillableCriterion_NonBillable"><bean:message key="billing_type.list.filter.type.criterion.non_billable"/></label></td>
                                        </tr>
                                        </table>  
                                    </td>
                                    <td><at:img width="40" page="pixel.gif" /></td>
                                    <td align="left" valign="top" width="30%">
                                        <table cellpadding="0" cellspacing="0" border="0" style="">
                                            <tr>
                                                <td align="right">
                                                    <input style="padding-left: 24px; padding-right: 24px;" type="button" value="<%=filteredMessage(request, "billing_type.list.show_billing_types")%>" onclick="filterTypes()"/>
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr>
            <td colspan="2" class="text" align="left">
                <span class="formblocktitle">
                    &nbsp;<bean:message key="billing_type.list.filter.criteria.title"/>:
                </span>
                <% pageContext.setAttribute("filterCriteriaKey", "billing_type.list.filter.criteria." + filter.toString().toLowerCase()); %>
                <bean:message name="filterCriteriaKey" scope="page"/>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <table class="withRoundCorners" id="billingTypesTable" border="0" cellspacing="0" cellpadding="5" align="center" width="770">
                    <tr>
                        <th class="listtblcolheader firstInRow" style="text-align:left; padding: 11px;">
                            <bean:message key="billing_type.list.columns.name"/>
                        </th>
                        <th width="10%" class="listtblcolheader">
                            <bean:message key="billing_type.list.columns.status"/>
                        </th>
                        <th width="13%" class="listtblcolheader">
                            <bean:message key="billing_type.list.columns.type"/>
                        </th>
                        <logic:equal value="true" name="form" property="braEnabled">
                            <th width="12%" class="listtblcolheader">
                                <bean:message key="billing_type.list.columns.rate"/>
                                <span style="font-weight:normal">(<bean:message key="billing_type.rate_postfix" arg0="<%=ResponseUtils.filter(settings.getCurrencySign())%>"/>)</span>
                            </th>
                        </logic:equal>
                        <th width="18%" class="listtblcolheader">
                            <bean:message key="billing_type.list.columns.default"/>
                        </th>
                        <th width="13%" class="listtblcolheader">
                            <bean:message key="billing_type.list.columns.order"/>
                        </th>
                        <th width="10%" class="listtblcolheader lastInRow">
                            <bean:message key="billing_type.list.columns.delete"/> 
                        </th>
                    </tr>
                <% if (typeList.size() == 0) { %>
                    <tr>
                        <td class="listtblcell lastInRow" colspan="7" align="center"><br/>
                            <%
                                String criteriaString = "";
                                if (form.getStatusCriterion() == ATTypeStatusCriterion.ACTIVE)
                                {
                                    criteriaString += message( request, "billing_type.active" ) + " ";
                                }
                                else if (form.getStatusCriterion() == ATTypeStatusCriterion.ARCHIVED)
                                {
                                    criteriaString += message( request, "billing_type.archived") + " ";
                                }
                                if (form.getBillableCriterion() == BillingTypeBillableCriterion.BILLABLE)
                                {
                                    criteriaString += message( request, "billing_type.billable").toLowerCase() + " ";
                                }
                                else if (form.getBillableCriterion() == BillingTypeBillableCriterion.NON_BILLABLE)
                                {
                                    criteriaString += message( request, "billing_type.non_billable").toLowerCase() + " ";
                                }
                            %>
                            <bean:message key="billing_type.list.no_types" arg0="<%=criteriaString%>"/>
                        <br/>&nbsp;</td>
                    </tr>
                <% } else { %>
                <logic:iterate id="type" name="typeList" type="com.actimind.actitime.beans.BillingTypeBean">
                    <%
                        int typeIndex = typeList.indexOf(type);
                        boolean isInUse = typesInUse.contains(type.getId());
                        boolean isFirst = typeIndex == 0;
                        boolean isLast = typeIndex == typeList.size() - 1;
                        int precedingTypeId = isFirst ? -1 : ((BasicATTypeBean) typeList.get(typeIndex - 1)).getId();
                        int followingTypeId = isLast ? -1 : ((BasicATTypeBean) typeList.get(typeIndex + 1)).getId();
                        boolean isLastMovedTypeRow = form.getLastMovedTypeId() == type.getId();
                        if (isLastMovedTypeRow)
                        {
                            form.setLastMovedTypeId(-1);
                        }
                        String rowClassName = "typelisttblrow" + (type.isBillable() ? "" : "_non-billable") + (isLastMovedTypeRow ? "_last-moved" : "");
                    %>

                    <tr class="<%= rowClassName %>" <% if (isLastMovedTypeRow) {%>id="last_moved_type_row"<%}%>>
                        <%-- Billing Type column --%>
                        <td class="listtblcell billingTypeCell">
                            <html:link page='<%="/administration/btedit.do?id=" + type.getId() + "&resetForm=true"%>'>
                                <bean:write name="type" property="name" filter="true"/>
                            </html:link>
                        </td>

                        <%-- Status column --%>
                        <logic:equal name="type" property="active" value="true">
                            <td class="listtblcellenabled"
								nowrap="1" align="center"
                                <% if( type.getId() != BillingTypeBean.NON_BILLABLE_DEFAULT_ID ) { %>
                                title="<bean:message key='billing_type.list.active_tooltip'/>"
                                onmouseover="if (typeof highlightCell != typeof undefined) highlightCell(this)"
                                onmouseout="if (typeof removeHighlighting != typeof undefined) removeHighlighting(this)"
                                onclick='toggleStatus(this, <%=type.getId()%>)'
                                <% } else { %>
                                title="<%=message(request, "billing_type.list.cannot_archive")%>"
                                style="color: #999"
                                <% } %>><bean:message key="billing_type.active"/></td>
                        </logic:equal>
                        <logic:equal name="type" property="active" value="false">
                            <td class="listtblcelldisabled"
								nowrap="1" align="center" title="<bean:message key='billing_type.list.archived_tooltip'/>"
                                onmouseover="if (typeof highlightCell != typeof undefined) highlightCell(this)"
                                onmouseout="if (typeof removeHighlighting != typeof undefined) removeHighlighting(this)"
                                onclick='toggleStatus(this, <%=type.getId()%>)'><bean:message key="billing_type.archived"/></td>
                        </logic:equal>

                        <%-- Type column--%>
                        <logic:equal name="type" property="billable" value="true">
                            <td class="listtblcell billableStatusCell"
								nowrap="1" align="center" title='<bean:message key="billing_type.list.billable_tooltip"/>'
                                onmouseover="if (typeof highlightCell != typeof undefined) highlightCell(this)"
                                onmouseout="if (typeof removeHighlighting != typeof undefined) removeHighlighting(this)"
                                onclick="toggleType(this, <%=type.getId()%>)"><bean:message key="billing_type.billable"/></td>
                        </logic:equal>
                        <logic:equal name="type" property="billable" value="false">
                            <td nowrap="1" align="center"
                                <% if( type.getId() != BillingTypeBean.NON_BILLABLE_DEFAULT_ID ) { %>
                                class="listtblcell billableStatusCell"
                                title='<bean:message key="billing_type.list.non_billable_tooltip"/>'
                                onmouseover="if (typeof highlightCell != typeof undefined) highlightCell(this)"
                                onmouseout="if (typeof removeHighlighting != typeof undefined) removeHighlighting(this)"
                                onclick="toggleType(this, <%=type.getId()%>)"
                                <% } else { %>
                                class="listtblcell billableStatusCell nonBillableDefault"
                                title="<%=message(request, "billing_type.list.cannot_make_billable")%>"
                                style="color: #999"
                                <% } %>><bean:message key="billing_type.non_billable"/></td>
                        </logic:equal>

                        <logic:equal value="true" name="form" property="braEnabled">
                            <%-- Rate column--%>
                            <td class="listtblcell" align="center" nowrap="1" <% if( type.getId() != BillingTypeBean.NON_BILLABLE_DEFAULT_ID ) { %> title="<bean:message key='billing_type.list.rate_tooltip'/>"<% } %>>
                                <span id="type_<%=type.getId()%>_billing_rate">
                                    <logic:equal name="type" property="billable" value="true">
                                        <%=(type.getRate() != null ? RatesFormat.formatRate(type.getRate().doubleValue(), settings) : "")%>
                                    </logic:equal>
                                    <logic:equal name="type" property="billable" value="false">-</logic:equal>
                                </span>
                            </td>
                        </logic:equal>
                            
                        <%-- Set As Default column--%>
                        <td class="listtblcell" nowrap="1" align="center"
                            id="type_<%=type.getId()%>_isdefault"
                            <logic:equal name="type" property="default" value="true">
                                ><div>
                                    <bean:message key="billing_type.list.is_default"/>
                                    <script type="text/javascript">
                                        var cell = document.getElementById("type_<%=type.getId()%>_isdefault");
                                        setCurrentDefaultCell(cell, <%=type.getId()%>);
                                    </script>
                                </div
                            </logic:equal>
                            <logic:equal name="type" property="default" value="false">
                                <logic:equal name="type" property="active" value="true">
                                    ><a href="javascript:;" onclick="setDefault(this.parentNode, <%=type.getId()%>)"
                                    ><bean:message key="billing_type.list.set_as_default"/></a
                                </logic:equal>
                                <logic:equal name="type" property="active" value="false">
                                    title="<bean:message key='billing_type.list.cannot_be_default_tooltip'/>"
                                    ><span class="textinactive"
                                        ><bean:message key="billing_type.list.is_archived"
                                    /></span
                                </logic:equal>
                             </logic:equal>
                        ></td>

                        <%-- Change Order column --%>
                        <td class="listtblcell" nowrap="1" align="center" style="padding-left:10px;padding-right:10px;"
                            <%if (!(isFirst && isLast)) { %>
                                onmouseover="if (typeof highlightRow != typeof undefined) highlightRow(this.parentNode)"
                                onmouseout="if (typeof removeRowHighlighting != typeof undefined) removeRowHighlighting(this.parentNode)"
                            <%}%> >
                            <table width="100%"><tr>
                                <td align="right" valign="baseline" style="padding-right:4px;">
                                    <% if (isLast) { %>
                                        <at:img page="pixel.gif" width='15px' height='15px'/>
                                    <% } else { %>
                                         <a href='<%= "javascript: moveType(" + type.getId() + ", " + followingTypeId + ");" %>'
                                             ><at:img page="leave_types/move_down.gif" border="0"
                                                     title='<%=message( request, "billing_type.list.move_down")%>'
                                                     alt='<%=message( request, "billing_type.list.move_down")%>'
                                         /></a>
                                    <% } %>
                                </td>
                                <td align="left" valign="baseline" style="padding-left:4px;">
                                    <% if (isFirst) { %>
                                        <at:img page="pixel.gif" width='15px' height='15px'/>
                                    <% } else { %>
                                        <a href='<%= "javascript: moveType(" + type.getId() + ", " + precedingTypeId + ");" %>'
                                            ><at:img page="leave_types/move_up.gif" border="0"
                                                    title='<%=message( request, "billing_type.list.move_up")%>'
                                                    alt='<%=message( request, "billing_type.list.move_up")%>'
                                        /></a>
                                    <% } %>
                                </td>
                            </tr></table>
                        </td>

                        <%-- Delete column --%>
                        <bean:define id="inUse" value="<%=Boolean.toString(isInUse)%>" />
                        <logic:equal name="inUse" value="true">
                            <td class="listtblcell lastInRow" nowrap="1" align="center"
                                title='<%=filteredMessage(request, "billing_type.delete.tooltip.type_in_use")%>'>
                                <span class="textinactive">
                                    <bean:message key="billing_type.list.in_use"/>
                                </span>
                            </td>
                        </logic:equal>
                        <logic:equal name="inUse" value="false">
                            <td class="listtblcell lastInRow" nowrap="1" align="center">
                                <a href='javascript:deleteType(<%=type.getId() %>);'>
                                    <bean:message key="billing_type.list.delete"/>
                                </a>
                            </td>
                        </logic:equal>
                    </tr>
                </logic:iterate>
                <% } %>
                </table>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <div class="noteContainer">
                    <at:img page="note_mark.gif" styleClass="noteImage"/>
                    <span class="notemsg"><bean:message key="billing_type.list.note_message" /></span>
                </div>
            </td>
        </tr>
    </table>
   </td>
            </tr>
        </table>
    </html:form>
</div>

<p>&nbsp;</p>
</body>
</html>
