<%@ page import="com.actimind.actitime.administration.CustomizationSettingsForm"%>
<%@ page import="com.actimind.actitime.administration.InvalidUploadedFile" %>
<%@ page import="java.io.IOException" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="java.util.Objects" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%
    boolean showCustomizeReportsPanel = Boolean.valueOf( request.getParameter( "showCustomizeReportsPanel" ) );
    String useDefaultLogoMessageKey = request.getParameter( "useDefaultLogoMessageKey" );
    String productName = message(request, request.getParameter( "productNameMessageKey" ));
    String productsIntegrated = (Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) ? Keys.PRODUCTS_INTEGRATED : "";
%>

<script type="text/javascript">
    PageOverlayTipsManager.setInstance(new CustomizationPageOverlayTipsManager());

    var productName = "<%=productName%>";
    var showCustomizeReportsPanel = <%=showCustomizeReportsPanel%>;
    var productInterfacesMessage = messageResource.getMessage("logo_color_scheme.client.product_interfaces", [productName]);
    var printableReportsMessage;

    if(showCustomizeReportsPanel){
          printableReportsMessage =  messageResource.getMessage('logo_color_scheme.client.printable_reports');
    }

    var isFormSubmitting = false;
    function doSubmit()
    {
        if (isFormSubmitting)
            return;

        //noinspection XHTMLIncompatabilitiesJS
        var form = document.getElementById('customizitionForm');
        if( validateField( form , 'formCustomInterfaceLogo.logo', productInterfacesMessage, productName) &&
            (!showCustomizeReportsPanel || validateField( form , 'formCustomReportLogo.logo', printableReportsMessage, productName )) )
        {
            isFormSubmitting = true;

            $("#FormModifiedDivButton").addClass("disabled");
            $("#ButtonPane").find(".saveButton").attr("disabled", true);

            ExitConfirmation.disableConfirmationOnUnloadPage();
            form.submit();
            return true;
        }
        else
            form.redirectUrl.value = "";
        return false;
    }

    function disableUploadField(form, fieldName)
    {
        form[fieldName].disabled = true;
    }

    function enableUploadField(form,fieldName)
    {
        form[fieldName].disabled = false;
    }
    /*
     function validateFields()
     {
     var form = document.getElementById('customizitionForm');
     if( validateField( form , 'formCustomInterfaceLogo.logo') && validateField( form , 'formCustomReportLogo.logo'))
     document.getElementById('customizitionForm').submit();
     }
     */
    function validateField(form, fieldName, logoname, productName)
    {
        var uploadField = form[fieldName];
        if(!uploadField.disabled)
        {
            var customLogo = trim(uploadField.value);
            if(customLogo.length == 0)
            {
                alert(messageResource.getMessage("logo_color_scheme.client.no_file", [logoname, productName]));
                return false;
            }
            var ext = customLogo.substring(customLogo.length-4).toLowerCase();
            if( ext != ".gif" && ext != ".jpg" && ext != ".png" && ext != ".jpeg")
            {
                alert(messageResource.getMessage("logo_color_scheme.client.wrong_type", [logoname]));
                return false;
            }
        }
        return true;
    }

    function registerChangeable()
    {
        confirmDlg = new ConfirmExitDlg(500, messageResource.getMessage("logo_color_scheme.client.modifications_not_saved_warning"),
                                        messageResource.getMessage("logo_color_scheme.client.cancel_modification_confirm"),
                                        messageResource.getMessage("common.buttons.save_changes"), messageResource.getMessage("common.buttons.discard_changes"), messageResource.getMessage("common.buttons.remain_on_page"));
        registerChangeableControl(document.getElementById('customizitionForm')['colorScheme']);
        registerFormChangedHandlers(true);

        if ( showCustomizeReportsPanel ) {
            registerChangeableControl(document.getElementById('customizitionForm')['formCustomReportLogo.logoOption'][0]);
            registerChangeableControl(document.getElementById('customizitionForm')['formCustomReportLogo.logoOption'][1]);
            registerChangeableControl(document.getElementById('customizitionForm')['formCustomReportLogo.logoOption'][2]);
            registerChangeableControl(document.getElementById('customizitionForm')['formCustomReportLogo.logoOption'][3]);
        }

        registerChangeableControl(document.getElementById('customizitionForm')['formCustomInterfaceLogo.logoOption'][0]);
        registerChangeableControl(document.getElementById('customizitionForm')['formCustomInterfaceLogo.logoOption'][1]);
        registerChangeableControl(document.getElementById('customizitionForm')['formCustomInterfaceLogo.logoOption'][2]);
        setSubmitHandler(doSubmit);

        ExitConfirmation.setUpBaseExitConfirmation( "logo_color_scheme.client.exit_confirmation", false );
    }

</script>

<html:form action="/administration/customization.do"
           method="post" styleId="customizitionForm"   styleClass="customizationForm"
           enctype="multipart/form-data"
           onsubmit="doSubmit();return false;">
<html:hidden property="redirectUrl"/>
<html:hidden property="colorScheme"  />
<input type="hidden" value="1" name="submitted">
<table cellpadding="0" cellspacing="0" border="0" width="770" align="center">
<tr>
<td align="center" class="mainContentPadding rightPadding  <%=productsIntegrated%>">
<table class="leftAligned" cellspacing="0" cellpadding="4" border="0" width="770">
<tr>
    <td>
        <table width="100%" cellspacing="0" cellpadding="0" align="left" valign="top" border="0">
            <tr width="100%">
                <td class="pagetitle">
                    <span class="pageTitleWithSharedSettingsImage"><bean:message key="logo_color_scheme.title"/></span>
                    <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
                </td>
                <td align="right"><%@include file="/form_modified_div.jsp" %></td>
            </tr>
        </table>
    </td>
</tr>
<tr>
    <td height="10">
        <%
            Exception ex = ( Exception ) session.getAttribute( CustomizationSettingsForm.UPLOAD_EXCEPTION );
        %>
        <%@include file="/messages.jsp"%>

        <%
            if( ex instanceof InvalidUploadedFile ) {
        %>
        <br>
        <jsp:include page="customization_upload_trouble.jsp">
            <jsp:param name="msg" value="<%=ex.getMessage()%>"/>
            <jsp:param name="productName" value="<%=productName%>"/>
        </jsp:include>
        <%
            }
        %>
        <div id="ClientSideErrorMessage" style="display:none; padding-top:8px;">
            <bean:define id="details" value="saving modifications" toScope="request"/>
            <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
        </div>
    </td>
</tr>
<tr>
    <td>
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
            <tr>
                <td style="padding-top: 20px; width: 200px; text-align: left"  valign="top"><span class="formblocktitle"><bean:message key="logo_color_scheme.choose_color_scheme"/></span></td>
                <td>
                    <table border="0" cellpadding="4" cellspacing="0">
                        <tr>
                            <td>
                                <table>
                                    <tr>
                                        <td>
                                            <div id="default" class="default imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                        <td>
                                            <div id="azureblue" class="azureblue imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                        <td>
                                            <div id="aquamarine" class="aquamarine imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            <div id="ferngreen" class="ferngreen imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>

                                        </td>
                                        <td>
                                            <div id="yellowgreen" class="yellowgreen imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                        <td>
                                            <div id="charcoalgrey" class="charcoalgrey imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            <div id="orange" class="orange imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                        <td>
                                            <div id="purple" class="purple imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor"></div>
                                            </div>
                                        </td>
                                        <td>
                                            <div id="red" class="red imageContainer" onclick="changeImage(this)">
                                                <div class="backgroundColor">
                                                </div>
                                            </div>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                            <td>
                                <div id="screenshotWrapper" class="screenshotWrapper">   <%-- workaround for IE11 (bug 49623) --%>
                                    <div id="screenshot" class="screenshot"></div>
                                </div>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr style="height: 30px"/>
            <tr>
                <td style="padding-top: 8px; text-align: left;" valign="top"><span class="formblocktitle"><bean:message key="logo_color_scheme.configure_logo"/></span></td>
                <td>
                    <table border="0" cellpadding="4" cellspacing="0">
                        <tr>
                            <td class="formfieldtitle">
                                <table cellspacing="0" cellpadding="2" border="0">
                                    <tr>
                                        <td class="aligned_radio_button_cell">
                                            <html:radio styleId="useDefaultLogoOption"
                                                        property="formCustomInterfaceLogo.logoOption"
                                                        value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_DEFAULT)%>"
                                                        onclick="disableUploadField(this.form, 'formCustomInterfaceLogo.logo')"/>
                                        </td>
                                        <td class="aligned_radio_button_text" colspan="2">
                                            <label for="useDefaultLogoOption"><bean:message key="logo_color_scheme.use_default_logo" arg0="<%=productName%>"/></label>
                                        </td>
                                    </tr>
                                    <logic:equal name="CustomizationSettingsForm" property="formCustomInterfaceLogo.customLogoShow" value="true">
                                        <tr>
                                            <td class="aligned_radio_button_cell">
                                                <html:radio styleId="keepCurrentCustomLogoOption"
                                                            property="formCustomInterfaceLogo.logoOption"
                                                            value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_KEEP_CURRENT_CUSTOM)%>"
                                                            onclick="disableUploadField(this.form, 'formCustomInterfaceLogo.logo')"/>
                                            </td>
                                            <td class="aligned_radio_button_text" colspan="2">
                                                <label for="keepCurrentCustomLogoOption"><bean:message key="logo_color_scheme.keep_current_logo"/></label>
                                            </td>
                                        </tr>
                                    </logic:equal>
                                    <tr>
                                        <td class="aligned_radio_button_cell">
                                            <html:radio styleId="uploadNewLogoOption"
                                                        property="formCustomInterfaceLogo.logoOption"
                                                        value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_UPLOAD)%>"
                                                        onclick="enableUploadField(this.form, 'formCustomInterfaceLogo.logo')"/>
                                        </td>
                                        <td class="aligned_radio_button_text">
                                            <label for="uploadNewLogoOption">
                                                <logic:equal name="CustomizationSettingsForm"
                                                             property="formCustomInterfaceLogo.customLogoShow"
                                                             value="false">
                                                    <bean:message key="logo_color_scheme.use_custom_logo"/>:
                                                </logic:equal>
                                                <logic:equal name="CustomizationSettingsForm" property="formCustomInterfaceLogo.customLogoShow" value="true">
                                                    <bean:message key="logo_color_scheme.replace_current_logo"/>:
                                                </logic:equal>
                                            </label>
                                        </td>
                                        <td style="padding-left:8px">
                                            <html:file property="formCustomInterfaceLogo.logo" size="41"
                                                       disabled="true" styleClass="inputChooseFile"/>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td colspan="4" style="padding-left:8px; padding-top:18px;">
                                            <table border="0" cellpadding="0" cellspacing="0">
                                                <tr>
                                                    <td valign="top" style="padding-right:8px;"><div class="noteMark"/></td>
                                                    <td valign="top"><div class="notemsg"><bean:message key="logo_color_scheme.custom_logo.note"/></div></td>
                                                </tr>
                                            </table>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
<% if ( showCustomizeReportsPanel ) { %>
            <tr style="height: 30px"></tr>
<tr>
    <td rowspan="2" style="padding-top: 8px;" valign="top"><span class="formblocktitle"><bean:message key="logo_color_scheme.configure_printable_logo" /></span></td>
    <td>
        <table border="0" cellpadding="4" cellspacing="0">
            <tr>
                <td class="formfieldtitle">
                    <table cellspacing="0" cellpadding="2" border="0">
                        <tr>
                            <td class="aligned_radio_button_cell">
                                <html:radio styleId="noReportLogo" property="formCustomReportLogo.logoOption"
                                            value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_NO_LOGO)%>"
                                            onclick="disableUploadField(this.form, 'formCustomReportLogo.logo')"/>
                            </td>
                            <td class="aligned_radio_button_text" colspan="2">
                                <label for="noReportLogo"><bean:message key="logo_color_scheme.do_not_show_printable_logo" /></label>
                            </td>
                        </tr>
                        <tr>
                            <td class="aligned_radio_button_cell">
                                <html:radio styleId="useDefaultReportLogoOption"
                                            property="formCustomReportLogo.logoOption"
                                            value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_DEFAULT)%>"
                                            onclick="disableUploadField(this.form, 'formCustomReportLogo.logo')"/>
                            </td>
                            <td class="aligned_radio_button_text" colspan="2">
                                <label for="useDefaultReportLogoOption"><bean:message key="logo_color_scheme.use_default_logo" arg0="<%=productName%>" /></label>&nbsp;&nbsp;&nbsp;(<a
                                    href="javascript:void(0)"
                                    onclick="popup('reportpreview.jsp?isShowDefault=true', 'DefaultPrintableLogoPreview', 850, 500, false, false, false);"><bean:message key="logo_color_scheme.preview_default_logo" /></a>)
                            </td>
                        </tr>
                        <logic:equal name="CustomizationSettingsForm"
                                     property="formCustomReportLogo.customLogoShow" value="true">
                            <tr>
                                <td class="aligned_radio_button_cell">
                                    <html:radio styleId="keepCurrentReportCustomLogoOption"
                                                property="formCustomReportLogo.logoOption"
                                                value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_KEEP_CURRENT_CUSTOM)%>"
                                                onclick="disableUploadField(this.form, 'formCustomReportLogo.logo')"/>

                                </td>
                                <td class="aligned_radio_button_text" colspan="2">
                                    <label for="keepCurrentReportCustomLogoOption">
                                        <bean:message key="logo_color_scheme.keep_current_logo" />
                                    </label>&nbsp;&nbsp;&nbsp;(<a href="javascript:void(0)" onclick="popup('reportpreview.jsp', 'PrintableLogoPreview', 850, 500, false, false, false);"><bean:message key="logo_color_scheme.preview_current_logo" /></a>)
                                </td>
                            </tr>
                        </logic:equal>
                        <tr>
                            <td class="aligned_radio_button_cell" >
                                <html:radio styleId="uploadNewReportLogoOption"
                                            property="formCustomReportLogo.logoOption"
                                            value="<%=String.valueOf(CustomizationSettingsForm.LOGO_OPTION_UPLOAD)%>"
                                            onclick="enableUploadField(this.form, 'formCustomReportLogo.logo')"/>
                            </td>
                            <td class="aligned_radio_button_text">
                                <label for="uploadNewReportLogoOption">
                                    <logic:equal name="CustomizationSettingsForm"
                                                 property="formCustomReportLogo.customLogoShow" value="false">
                                        <bean:message key="logo_color_scheme.use_custom_logo" />:
                                    </logic:equal>
                                    <logic:equal name="CustomizationSettingsForm"
                                                 property="formCustomReportLogo.customLogoShow" value="true">
                                        <bean:message key="logo_color_scheme.replace_custom_logo" />:
                                    </logic:equal>
                                </label>
                            </td>
                            <td style="padding-left:8px"><html:file property="formCustomReportLogo.logo"
                                                                    size="41" disabled="true" styleClass="inputChooseFile"/></td>
                        </tr>
                        <tr>
                            <td colspan="4" style="padding-left:8px; padding-top:18px;">
                                <table border="0" cellpadding="0" cellspacing="0">
                                    <tr>
                                        <td valign="top" style="padding-right:8px;"><at:img
                                                page="note_mark.gif"/></td>
                                        <td valign="top">
                                            <div class="notemsg"><bean:message key="logo_color_scheme.custom_printable_logo.note" /></div>
                                        </td>
                                    </tr>
                                </table>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
    </td>
</tr>
<% } %>
        </table>
    </td>
</tr>
<tr>
    <td><br></td>
</tr>
<tr>
    <td align="center" class="formbuttonpane" id="ButtonPane">
        <input type="submit" class="saveButton" value="<bean:message key="logo_color_scheme.save_settings" />" >
    </td>
</tr>
</table>
</td>
</tr>
</table>

</html:form>
<jsp:include page="/form_changed_confirm.jsp"/>

<div id="selectedColorIcon" class="selectedColorIcon"> <at:defImg page="tick.png"/></div>
<%session.removeAttribute( CustomizationSettingsForm.UPLOAD_EXCEPTION );%>


<script type="text/javascript">
    var screenshot = document.getElementById('screenshot');
    var colorScheme =  $(document.getElementsByName('colorScheme'))[0];
    var selectedColorIcon = document.getElementById('selectedColorIcon');
    var selectedContainerEl = document.getElementById(colorScheme.value);
    $(selectedContainerEl).addClass('selected');
    $(screenshot).addClass( selectedContainerEl.id);

    var selectedBackgroundColorEl = selectedContainerEl.children[0];
    selectedBackgroundColorEl.appendChild(selectedColorIcon);

    function changeImage(image) {
        if (image.id == selectedContainerEl.id){
            return;
        }

        handleChange(true);
        $(screenshot).removeClass(selectedContainerEl.id);
        $(selectedContainerEl ).removeClass('selected');
        selectedBackgroundColorEl.removeChild(selectedColorIcon);

        selectedContainerEl = document.getElementById(image.id);
        $(selectedContainerEl ).addClass('selected');
        $(screenshot).addClass(selectedContainerEl.id);

        selectedBackgroundColorEl = selectedContainerEl.children[0];
        selectedBackgroundColorEl.appendChild(selectedColorIcon);

        colorScheme.value = image.id;
    }

    function getScreenshotPath(){

    }

</script>
