<!doctype html>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="static com.actimind.actitime.util.Feature.*" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="com.actimind.actitime.administration.FeaturesAction" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="java.util.Date" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>

<bean:define id="settings" name="<%= Keys.SYSTEM_SETTINGS_LOADER %>"  property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />

<%
    //noinspection unchecked
    ArrayList<FeaturesAction.Section> sections = ( ArrayList<FeaturesAction.Section> ) request.getAttribute( Keys.CUSTOMIZABLE_FEATURES );
    Boolean areThereNotAutoapprovedUsers = ( Boolean ) request.getAttribute( Keys.THERE_ARE_NOT_AUTO_APPROVED_USERS_IN_THE_SYSTEM );
    Date ttApprovalLastDisablingTimestamp = ( Date ) request.getAttribute( Keys.TT_APPROVAL_FEATURE_LAST_DISABLING_TIMESTAMP );
    boolean showDialogOnTTAEnabling = ( areThereNotAutoapprovedUsers == null ) ? false : areThereNotAutoapprovedUsers;
    if ( showDialogOnTTAEnabling && ttApprovalLastDisablingTimestamp != null ) {
        int weekStartDay = settings.getWeekStartDay();
        Date lastWeek = TimeUtils.getTuesdayOfWeek(weekStartDay, ttApprovalLastDisablingTimestamp);
        Date currentWeek = TimeUtils.getTuesdayOfWeek(weekStartDay, TimeUtils.now());
        showDialogOnTTAEnabling = currentWeek.after(TimeUtils.getNDaysAfter(lastWeek, 7, true));
    }
%>
<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="features.page_title"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>
</head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" class="featuresPage with-navigation">
<div id="container">
    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected" value="settings" />
    </jsp:include>

    <table align="center">
        <tr>
            <td class="pagetitle"><span><bean:message key="features.page_title"/></span></td>
            <td class="descriptionNote"><span class="note"><bean:message key="features.description_note"/></span></td>
        </tr>
        <tr>
            <td colspan=2 style="padding-top: 18px;">

                <table border=0 cellspacing=0 cellpadding="0" class="featuresTable">
                    <%
                        boolean firstSection = true;
                        for( FeaturesAction.Section section : sections )
                        {
                            if( !firstSection )
                            {
                    %> <tr><td colspan=2 class="spacer"></td></tr> <%
                    }
                %>

                    <tr>
                        <th rowspan=<%=String.valueOf(section.blocks.length)%>>
                            <%=message( request, section.nameKey )%>
                        </th>
                    <%
                        boolean firstBlock = true;
                        for( int i = 0; i < section.blocks.length; i++ )
                        {
                            FeaturesAction.Block block = section.blocks[i];
                            if(!firstBlock)
                            {
                    %><tr><%
                    }
                    String styleClass = firstBlock ? "first" : "";
                    if( i == section.blocks.length - 1  )
                        styleClass += " last";

                %>

                    <td class="<%=styleClass%>">
                        <div id="FEATURE_<%=block.feature.toString()%>" class="init"></div>
                        <%
                            if( block.subFeatures != null ) {
                                for ( Feature subFeature : block.subFeatures ) {
                        %>
                                <div id="FEATURE_<%=subFeature.toString()%>" class="init subfeature"></div>
                        <%
                                }
                            }
                        %>
                    </td>

                    <%
                            firstBlock = false;
                        }
                    %>
                </tr>
                    <%
                            firstSection = false;
                        }
                    %>

                </table>

            </td>
        </tr>
    </table>

</div>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='ttaConfirmDialog'/>
    <jsp:param name="additionalClasses" value='ttaConfirmDialog'/>
    <jsp:param name="innerJsp" value='/administration/ttaConfirmDialogContent.jsp'/>
</jsp:include>

<div id="featureDescriptionPopupContent" style="display: none; width: 515px;">
    <div>
        <at:img title='<%=message(request, "common.lightbox.close_title")%>' styleId="closeFeatureDescription" page="settings/features/close.png"/>
        <span id="featureDescriptionTitle">Title</span>
    </div>
    <div id="featureDescriptionContent" tabindex="1"></div>
</div>

<jsp:include page="/administration/feature_descriptions.jsp"/>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/administration/ttaConfirmDialog.js"/>
<at:script page="/js/administration/features.js"/>


<script>
    PageOverlayTipsManager.setInstance(new FeaturesPageOverlayTipsManager());

    var features = {};
    var featureDependencies = {};
    var handlers = {};

    <%
    for(FeaturesAction.Section section : sections)
    {
        for(FeaturesAction.Block block : section.blocks)
        {
            %>features["<%=block.feature.toString()%>"]=<%= FeaturesUtil.isAvailable(block.feature) ? FeaturesUtil.isEnabled(block.feature) : null %>;<%
            %>FeaturesPage.sentAjaxRequests["<%=block.feature.toString()%>"]=undefined;<%
            if( block.subFeatures != null ) {
                for ( int i = 0; i < block.subFeatures.length; i++ ) {
                    %>features["<%=block.subFeatures[i].toString()%>"]=<%=FeaturesUtil.isAvailable(block.subFeatures[i]) ? FeaturesUtil.isEnabled(block.subFeatures[i]) : null %>;<%
                    %>featureDependencies["<%=block.subFeatures[i].toString()%>"]={parentFeatureCode:"<%=block.feature.toString()%>",isLast:<%= i == block.subFeatures.length - 1 %>};<%
                }
            }
        }
    }
    %>

    FeaturesPage.featureMenuItemIds = {"<%=BTY.toString()%>": "popup_menu_item_2"};
    <% if( FeaturesUtil.isAvailable(CLT) ) {%>
        FeaturesPage.featureMenuItemIds["<%=LVT.toString()%>"] = "popup_menu_item_3";
    <% } %>
    
    var lastDisablingTimestamp = '<%=TimeUtils.formatUniformDate(ttApprovalLastDisablingTimestamp)%>';
    
    handlers["<%=TTA.toString()%>"] = new FeaturesPage.TTApprovalHandler(<%=showDialogOnTTAEnabling%>,
            !!lastDisablingTimestamp ? parseDate(lastDisablingTimestamp, "yyyy-MM-dd") : null);

    FeaturesPage.init( features, featureDependencies, handlers );

    FeaturesPage.subtasksCode = "<%=SUB.toString()%>";


</script>
</body>
</html>