<!doctype html>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.beans.LeaveTypeBean" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Set" %>
<%@ page import="com.actimind.actitime.administration.LeaveTypeATInfo" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="com.actimind.actitime.administration.LeaveTypeATInfoImpl" %>
<%@ page import="com.actimind.actitime.Constants" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="static com.actimind.actitime.util.Feature.PTO" %>
<%@ page import="static com.actimind.actitime.util.Feature.SDB" %>
<%@ page import="static com.actimind.actitime.util.Feature.URA" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>

<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%
    List<LeaveTypeBean> leaveTypeBeans = (List<LeaveTypeBean>) request.getAttribute( Keys.LEAVE_TYPE_LIST_KEY );
    Set<Integer> leaveTypesInUseIds = (Set<Integer>) request.getAttribute( Keys.LEAVE_TYPE_IN_USE_KEY );
    List<LeaveTypeATInfo> leaveTypesInfo = new ArrayList<LeaveTypeATInfo>();
    for ( LeaveTypeBean bean : leaveTypeBeans ) {
        leaveTypesInfo.add( new LeaveTypeATInfoImpl( bean, leaveTypesInUseIds.contains( bean.getId() ) ) );
    }

    int newLeaveTypeDefaultIconId = (Integer) request.getAttribute( Keys.NEW_LEAVE_TYPE_DEFAULT_ICON_ID );
    String showIntegrationIcons = (Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) ? Keys.SHOW_INTEGRATION_ICONS : "";

    boolean isPTOEnabled = FeaturesUtil.isEnabled(PTO);
    boolean isSickEnabled = FeaturesUtil.isEnabled(SDB);
    boolean isUserRatesEnabled = FeaturesUtil.isEnabled(URA);

    String hideAffectedBalanceSection = isPTOEnabled || isSickEnabled ? "" : "hideAffectedBalanceSection";
    String hideUserRatesSections = isUserRatesEnabled ? "" : "hideUserRatesSections";
%>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="leave_type.list.title"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" class="with-navigation leave-types-list-page at hideLeaveRequestsSections <%=hideAffectedBalanceSection%> <%=hideUserRatesSections%>">
<div id="container" class="<%=showIntegrationIcons%> hideLeaveRequestsSections <%=hideAffectedBalanceSection%> <%=hideUserRatesSections%> hideRequestColorInIconSelector">
    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.NO_SELECTION_KEY%>" />
    </jsp:include>

    <jsp:include page="/administration/leave_type_list_common.jsp"/>

    <div id="LeaveTypeDefaultRatePopup" style="display:none; width: 330px; height: 52px;">
        <table>
            <tbody>
            <tr>
                <td><input class="inputDiv" maxlength="80"/></td>
                <td style="vertical-align: top; padding-top: 7px"><span class="regText">&nbsp;&nbsp;x&nbsp;&nbsp;&nbsp;<bean:message
                        key="leave_type.list.rate_coefficient_cell.text"/></span></td>
                <td>
                    <div class="applyButton"></div>
                </td>
                <td>
                    <div class="cancelButton"></div>
                </td>
            <tr>
                <td colspan="4">
                    <div class="errorPlaceholder"></div>
                </td>
            </tr>
            </tbody>
        </table>
    </div>

    <!--[if IE 8]>
    <script type="text/javascript">
        document.getElementById("LeaveTypeDefaultRatePopup").className = "ie8";
    </script>
    <![endif]-->
    <!--[if IE 9]>
    <script type="text/javascript">
        document.getElementById("LeaveTypeDefaultRatePopup").className = "ie9";
    </script>
    <![endif]-->
</div>

<p>&nbsp;</p>


<script>
    $( document ).ready(function ( )
                        {
                            var isPtoEnabled = <%=isPTOEnabled%>;
                            var isSickEnabled = <%=isSickEnabled%>;
                            var isUserRatesEnabled = <%=isUserRatesEnabled%>;

                            var leaveTypesInfo = <%=jsHelper.toJSON(leaveTypesInfo)%>;
                            var newLeaveTypeDefaultIconId = <%=newLeaveTypeDefaultIconId%>;

                            /* Note: if we want to add here some images for leave types interface or parameters for LeaveTypeListPageController common for aT and aP,
                            * we should add them both on this page and on similar in actiplans package
                            * */
                            var arrowImagesPaths = { downArrowImagePath: "<at:defImgpath page="leave_types/move-down.png"/>",
                                                    upArrowImagePath: "<at:defImgpath page="leave_types/move-up.png"/>",
                                                    downArrowHoverImagePath: "<at:defImgpath page="leave_types/move-down-hover.png"/>",
                                                    upArrowHoverImagePath: "<at:defImgpath page="leave_types/move-up-hover.png"/>" };

                            var leaveTypeListPageController = new LeaveTypeATListPageController().init( leaveTypesInfo,
                                                                                                        arrowImagesPaths,
                                                                                                        {  decimalSeparator:       "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
                                                                                                           digitGroupingSymbol:    "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>",
                                                                                                           ptoMaxNumber:           <%=Constants.MAX_PTO_COEFFICIENT%>,
                                                                                                           rateMaxNumber:          <%=Constants.MAX_RATE_COEFFICIENT%> },
                                                                                                        newLeaveTypeDefaultIconId,
                                                                                                        isPtoEnabled,
                                                                                                        isSickEnabled,
                                                                                                        isUserRatesEnabled
                            );

                            leaveTypeListPageController.render();

                            PageOverlayTipsManager.getInstance().addTableTips(isPtoEnabled, isSickEnabled);
                        });

    PageOverlayTipsManager.setInstance(new LeaveTypesPageOverlayTipsManager());
</script>
</body>
</html>
