<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="static com.actimind.actitime.util.Feature.PTO" %>
<%@ page import="static com.actimind.actitime.util.Feature.SDB" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>

<bean:define id="productName" name="<%= Keys.PRODUCT_CONFIG %>" property="productName" type="java.lang.String"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<%
    boolean isAt = Product.valueOf( productName ).equals( Product.actiTIME );
    boolean ptoPartEnabledOfAffectedBalanceTooltip = isAt ?
                                                     FeaturesUtil.isEnabled(PTO) :
                                                     settings.isApPtoBalanceCalculationEnabled();
    boolean sickPartEnabledOfAffectedBalanceTooltip = isAt ?
                                                      FeaturesUtil.isEnabled(SDB) :
                                                      settings.isApSickBalanceCalculationEnabled();
%>

<table cellpadding="0" cellspacing="0" border="0" width="870" align="center">
    <tr>
        <td align="center" class="mainContentPadding rightPadding">
            <table cellspacing="0" cellpadding="5" align="center" border="0"  width="770">
                <tr>
                    <td class="pagetitle">
                        <span class="pageTitleWithSharedSettingsImage"><bean:message key="leave_type.list.title"/></span>
                        <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
                    </td>
                    <td>
                        <div id="spinnerPlaceholder"></div>
                    </td>
                    <td class="createLeaveType">
                        <div id="createLeaveTypeDiv"><!--Place for rendering "Create leave type" button--></div>
                    </td>
                </tr>
                <tr>
                    <td colspan="3">
                            <span id="leaveTypeListTableContainer">
                                <%--place for rendering leave types list table--%>
                            </span>
                    </td>
                </tr>
                <tr>
                    <td colspan="3">
                        <div class="leaveTypesNoteInfo noteContainer">
                                <at:img page="note_mark.gif" styleClass="noteImage"/>
                            <span class="notemsg"><bean:message key="leave_type.list.note_message" /></span>
                        </div>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>

<%--header for leave types list table--%>
<table class="leaveTypesListTable" border="0" cellspacing="0" align="center" style="display: none">
    <thead id="leaveTypesListTableHeader">
    <tr>
        <th class="leaveTypeChangeOrderCell">
            <bean:message key="leave_type.list.columns.order"/>
        </th>
        <th class="leaveTypeIconCell">
            <bean:message key="leave_type.list.columns.icon"/>
        </th>
        <th class="leaveTypeNameImageCell">
            <bean:message key="leave_type.list.columns.name"/>
        </th>
        <th class="leaveTypeAffectedBalanceCell leaveTypeAffectedBalanceSection" id="leaveTypeAffectedBalanceHeaderCell">
            <bean:message key="leave_type.list.columns.affected_balance"/>&nbsp;
            <div id="affectedBalanceInfoIcon"><at:img page="info.png"/></div>
        </th>
        <th class="leaveTypeRequiresApprovalCell leaveRequestSection">
            <bean:message key="leave_type.list.columns.requests"/>
        </th>
        <th class="leaveTypeDefaultRateCell userRatesSection">
            <bean:message key="leave_type.list.columns.default_rate"/>
        </th>
        <th class="leaveTypeStatusCell">
            <bean:message key="leave_type.list.columns.status"/>
        </th>
        <th class="leaveTypeDeleteCell">
            <bean:message key="leave_type.list.columns.delete"/>
        </th>
    </tr>
    </thead>
</table>

<div id="LeaveNamePopup"  style="display:none; width: 330px; height: 52px;">
    <table>
        <tbody>
        <tr>
            <td><input id="inputDiv" class="inputDiv" maxlength="80"/></td>
            <td><div class="applyButton"></div></td>
            <td> <div class="cancelButton"></div></td>
        </tr>
        <tr><td colspan="3"> <div class="errorPlaceholder"></div></td></tr>
        </tbody>
    </table>
</div>

<!--[if IE 8]>
    <script type="text/javascript">
        document.getElementById("LeaveNamePopup").className = "ie8";
    </script>
<![endif]-->
<!--[if IE 9]>
    <script type="text/javascript">
        document.getElementById("LeaveNamePopup").className = "ie9";
    </script>
<![endif]-->


<div id="AffectedBalancePopup" style="display: none;">
    <jsp:include page="leave_type_balances_edit_panel.jsp">
        <jsp:param name="suffix" value="affectedBalancePopup"/>
    </jsp:include>
</div>

<div id="AffectedBalanceHeaderTooltip" style="display: none;">
    <%
        if ( ptoPartEnabledOfAffectedBalanceTooltip ) {
    %>
            <p><bean:message key="leave_type.list.columns.affected_balance.header.tooltip.pto_part"/></p>
    <%
            if ( !sickPartEnabledOfAffectedBalanceTooltip ) {
    %>
                <p><bean:message key="leave_type.list.columns.affected_balance.header.tooltip.common_pto_part"/></p>
    <%
            }
        }
        if ( sickPartEnabledOfAffectedBalanceTooltip ) {
    %>
            <p><bean:message key="leave_type.list.columns.affected_balance.header.tooltip.sick_days_part"/></p>
    <%
            if ( !ptoPartEnabledOfAffectedBalanceTooltip ) {
    %>
                <p><bean:message key="leave_type.list.columns.affected_balance.header.tooltip.common_sick_days_part"/></p>
    <%
            }
        }
        if ( ptoPartEnabledOfAffectedBalanceTooltip && sickPartEnabledOfAffectedBalanceTooltip ) {
    %>
            <p><bean:message key="leave_type.list.columns.affected_balance.header.tooltip.common_part"/></p>
    <%
        }
    %>
</div>

<div id="cantDeleteLeaveTypeTooltip" class="yellowTooltip tooltipText">
    <bean:message key="leave_type.list.in_use_tooltip"/>
</div>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value="leaveTypeLightBox"/>
    <jsp:param name="innerJsp" value="/administration/leave_type_popup.jsp"/>
</jsp:include>

<jsp:include page="/administration/icon_selector_panel.jsp"/>
