<%@ page import="com.actimind.actitime.*" %>
<%@ page import="com.actimind.actitime.colors.ColorHelper" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="com.actimind.common.licensing.LicenseInfo" %>
<%@ page import="com.actimind.actitime.util.TimeUtils" %>
<%@ page import="java.util.LinkedList" %>
<%@ page import="com.actimind.common.ATGlobals" %>
<%@ page import="com.actimind.common.licensing.LicenseHelper" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%!
    private static void defineLicenseToRequest(Object license, HttpServletRequest request) {
        request.setAttribute("lic", license);
    }
%>

<jsp:include page="license_area_controller.jsp"/>

<%
    LicenseInfo latestLic = ( LicenseInfo ) request.getAttribute( Keys.LATEST_ONLINE_LICENSE );
    LicenseInfo latestUsedLic = ( LicenseInfo ) request.getAttribute( Keys.ACTIVE_LICENSE );
    if( latestUsedLic == null )
    {
        LinkedList<LicenseInfo> expiredLicenses = ( LinkedList<LicenseInfo> ) request.getAttribute( Keys.EXPIRED_AND_INCOMPATIBLE_LICENSES );
        if( expiredLicenses.size() > 0 ) latestUsedLic = expiredLicenses.getFirst();
    }
%>

<script>
    var licenseAreaController = null;
    function initLicenseAreaController()
    {
        <%  if ( !ATGlobals.isOl() ) { %>
        licenseAreaController = new LicenseAreaController();
            LicenseAreaController.prototype.emptyCaption = "<%=StringUtils.getStringEscapedForJS(ATMessageResources.message(request, "licensing.key_area.emptyText"))%>";
        licenseAreaController.init("keyArea");
        <% } %>
    }

    function submitForm(form)
    {
        licenseAreaController.hideGrayTextIfShown();
        form.submit();
    }

    function keyAreaButtonClicked()
    {
        $( ".keyAreaButtonPane" ).toggleClass( "hideArea" );
    }

    function openServiceAgreement()
    {
        <%-- Open popup and set focus to it --%>
        var link = '<%=(latestUsedLic == null || latestUsedLic.getLic().isTrial() ? request.getParameter("readTrialServiceAgreementLink") : LicenseHelper.getOnlineServiceAgreementURL(latestUsedLic.getLic()))%>';
        windowOpen(link, "saWnd",
                   "directories=no,height=500, width=1020, location=no, menubar=no, resizable=yes, scrollbars=no, status=yes, titlebar=yes, toolbar=no");
    }

    function showSupportForm()
    {
        MenuHandler.sendAQuestionToVendor();
    }

</script>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<table cellpadding="0" cellspacing="0" border="0" align="center">
    <tr>
        <td align="center" class="mainContentPadding rightPadding">
            <table cellspacing="5" cellpadding="0" align="center" valign="top" border="0" width="778px">
                <tr>
                    <td class="title">
                        <div class="pagetitle"><bean:message key="licensing.manage.page_title"/></div>
                        <jsp:include page="/messages.jsp"/>
                        <table cellpadding="0" cellspacing="0" border="0" width="768px">
                            <tr>
                                <td align="right" valign="bottom">
                                    <at:img page="settings/feature-info.png" styleClass="noteInfoImg"/>
                                    <% if( ATGlobals.isOl() ) { %>
                                    <a id="serviceAgreementRef" href="javascript: void(0)" onclick="openServiceAgreement()"><bean:message
                                            key="licensing.manage.read_service_agreement"/></a>
                                    <span class="separator"></span>
                                    <% } %>
                                    <a href="javascript: void(0)" onclick="showSupportForm()"><bean:message
                                            key="licensing.manage.contact_support"/></a>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>

                <%-- Active license --%>
                <logic:present name="<%=Keys.ACTIVE_LICENSE%>">
                    <bean:define id="activeLic" name="<%=Keys.ACTIVE_LICENSE%>"
                                 type="com.actimind.common.licensing.LicenseInfo" toScope="page"/>
                    <% defineLicenseToRequest(activeLic, request); %>
                    <bean:define id="header_text" toScope="request"><bean:message key="licensing.manage.active_title"/></bean:define>
                    <bean:define id="header" toScope="request">
                        <logic:notEmpty name="lic" property="lic.expirationDate">
                            <logic:lessThan name="lic" property="lic.daysToExpiration" value="15">
                                <table cellpadding="0" cellspacing="0" border="0">
                                    <tr>
                                        <td><at:img page="exclamation_mark.gif" style="margin-right: 10px"/></td>
                                        <td class="expiration_note" valign="middle"><bean:message
                                                key="licensing.manage.days_to_expiration_note"
                                                arg0="<%=String.valueOf( activeLic.getLic().getDaysToExpiration() )%>"
                                                arg1='<%=activeLic.getLic().getDaysToExpiration() > 1 ? "s" : "" %>'
                                                /></td>
                                    </tr>
                                </table>
                            </logic:lessThan>
                        </logic:notEmpty><!--suppress CheckTagEmptyBody --><b></b><%-- this is a workaround for bean:define tag --%>
                    </bean:define>
                    <tr>
                        <td class="licenseView">
                            <jsp:include page="license_view.jsp">
                                <jsp:param name="styleClass" value="active"/>
                                <jsp:param name="showUpgradeLink" value='<%=(activeLic.getLic().isTrial() ? "false" : "true")%>'/>
                                <jsp:param name="showExtendLink" value='<%=( latestLic == null && activeLic.getLic().isTrial() || latestLic != null && activeLic.getLic().equals( latestLic.getLic() ) ? "true" : "false" ) %>'/>
                            </jsp:include>
                        </td>
                    </tr>
                </logic:present>

                <%-- Latest incompatible or expired license --%>
                <logic:notPresent name="<%=Keys.ACTIVE_LICENSE%>">
                    <logic:iterate id="lic" name="<%=Keys.EXPIRED_AND_INCOMPATIBLE_LICENSES%>"
                                   type="com.actimind.common.licensing.LicenseInfo" length="1">
                        <% defineLicenseToRequest(lic, request); %>
                        <bean:define id="header_text" toScope="request"><bean:message
                                key="licensing.manage.license_title"/></bean:define>
                        <bean:define id="header" toScope="request">
                            <table cellpadding="0" cellspacing=0 border=0>
                                <tr>
                                    <logic:equal name="lic" property="compatible" value="false">
                                        <td class="incompatible_note" valign="middle"><bean:message key="licensing.manage.incompatible"/></td>
                                    </logic:equal>
                                    <logic:equal name="lic" property="compatible" value="true">
                                        <td><at:img page="exclamation_mark.gif" style="margin-right: 10px"/></td>
                                        <td class="expiration_note" valign="middle"><bean:message
                                                key="licensing.manage.expired"/></td>
                                    </logic:equal>
                                </tr>
                            </table>
                        </bean:define>
                        <tr>
                            <td class="licenseView">
                                <jsp:include page="license_view.jsp">
                                    <jsp:param name="styleClass" value="inactive"/>
                                    <jsp:param name="showExtendLink" value='<%=( latestLic == null && lic.getLic().isTrial() || latestLic != null && lic.getLic().equals( latestLic.getLic() ) ? "true" : "false" ) %>'/>
                                </jsp:include>
                            </td>
                        </tr>
                    </logic:iterate>
                </logic:notPresent>

                <%-- keyArea --%>
                <% if( !ATGlobals.isOl() ) { %>
                <tr>
                    <at:form action="/administration/manage_licenses">
                        <html:hidden property="submitted" value="1"/>
                        <td class="keyarea">
                            <div class="formbuttonpane keyAreaButtonPane hideArea" style="padding: 7px 13px 7px 13px">

                                <div class="keyAreaTitle" onselectstart="return false;">
                                    <div class="keyAreaButton" onclick="keyAreaButtonClicked()">
                                        <span class="keyAreaTitleMessage"><bean:message key="licensing.manage.key_area.title"/></span>
                                        <div class="keyAreaTitleImage"></div>
                                    </div>
                                </div>
                                <!--suppress CheckTagEmptyBody -->
                                    <span spellcheck="false" class="keyAreaShown"><html:textarea styleId="keyArea" property="key" rows="7" cols="55"
                                                                                                 styleClass="controlBorder" disabled='<%=ATGlobals.isDemoMode()%>'></html:textarea></span>
                                <table border="0" cellpadding="0" cellspacing="0" style="padding-top: 7px" class="keyAreaShown">
                                    <tr>
                                        <td valign="top">
                                            <div class="notemsg medium_text"><bean:message key="licensing.key_area.copy_note"/></div>
                                        </td>
                                    </tr>
                                </table>
                                <div class="keyAreaButtonDiv keyAreaShown">
                                    <button class="manageLicensesButton keyAreaSubmitButton"
                                            style="margin: 7px 0 7px 0"
                                            onclick="submitForm(this.form);"
                                            <% if( ATGlobals.isDemoMode() ) {%>disabled<%}%>>
                                        <bean:message key="licensing.manage.submit_btn.title"/>
                                    </button>
                                </div>
                                <% if( ATGlobals.isDemoMode() ) {%><div class="keyAreaDemoText keyAreaShown notemsg mediumtext"><bean:message key="licensing.manage.submit_btn.note"/></div><%}%>


                            </div>
                        </td>
                    </at:form>
                </tr>
                <% } %>

                <%-- License Renewals --%>
                <logic:iterate id="lic" name="<%=Keys.LICENSE_RENEWALS%>"
                               type="com.actimind.common.licensing.LicenseInfo">
                    <% defineLicenseToRequest(lic, request); %>
                    <bean:define id="header_text" toScope="request">
                        <% if( lic.getLic().getStartDate() != null ) { %>
                            <bean:message key="licensing.manage.renewal_title_with_start_date"
                                          arg0="<%=TimeUtils.formatDate( lic.getLic().getStartDate(), settings.getDateFormat() )%>"/>
                        <% } else { %>
                            <bean:message key="licensing.manage.renewal_title"/>
                        <% } %>
                    </bean:define>
                    <bean:define id="header" toScope="request">
                        <% if( !ATGlobals.isOl() ) { %>
                        <table cellpadding="0" cellspacing=0 border=0 width="100%">
                            <tr>
                                <td class="deleteRenewalLink" align="left"><html:link action="/administration/licensing/delete_renewal" paramName="lic"
                                               paramProperty="key.id" paramId="keyId"><bean:message
                                        key="licensing.manage.delete_renewal"/></html:link></td>
                            </tr>
                        </table>
                        <% } %><!--suppress CheckTagEmptyBody --><b></b><%-- this is a workaround for bean:define tag --%>
                    </bean:define>
                    <tr>
                        <td class="licenseView">
                            <jsp:include page="license_view.jsp">
                                <jsp:param name="styleClass" value="inactive renewal"/>
                                <jsp:param name="showUpgradeLink" value='<%=(lic.getLic().isTrial() ? "false" : "true")%>'/>
                                <jsp:param name="showExtendLink" value='<%=( latestLic == null && lic.getLic().isTrial() || latestLic != null && lic.getLic().equals( latestLic.getLic() ) ? "true" : "false" ) %>'/>
                            </jsp:include>
                        </td>
                    </tr>
                </logic:iterate>

                <%-- Other valid licenses --%>
                <logic:notEmpty name="<%=Keys.OTHER_VALID_LICENSES%>">
                    <tr>
                        <td>
                            <br>
                            <hr style="width: 100%; height: 1px; border: none; border-top: 1px dotted <%=ColorHelper.getColor("button.pane.border.color", request )%>;"/>
                            <br>
                            <div class="pagetitle field_name_bold" style="padding-bottom: 14px"><bean:message key="licensing.manage.other_valid_licenses"/></div>
                        </td>
                    </tr>

                    <logic:iterate id="lic" name="<%=Keys.OTHER_VALID_LICENSES%>"
                                   type="com.actimind.common.licensing.LicenseInfo">
                        <% defineLicenseToRequest(lic, request); %>
                        <bean:define id="header_text" toScope="request"><bean:message
                                key="licensing.manage.old_license_title"/></bean:define>
                        <bean:define id="header" toScope="request" value=""/>
                    <tr>
                        <td class="licenseView">
                            <jsp:include page="license_view.jsp">
                                <jsp:param name="styleClass" value="inactive"/>
                            </jsp:include>
                        </td>
                    </tr>
                    </logic:iterate>
                </logic:notEmpty>
            </table>
        </td>
    </tr>
</table>

<% if( !ATGlobals.isOl() ) { %>
<script>
    $( document ).ready( function() {
    initLicenseAreaController();
    if( hasServerSideErrors || !licenseAreaController.isEmpty() )
    $( ".keyAreaButtonPane" ).toggleClass( "hideArea", false );
    });
</script>
<% } %>

<script>
    PageOverlayTipsManager.setInstance(new LicensesPageOverlayTipsManager());
</script>
