<!doctype html>
<%@ page import="com.actimind.actitime.*,
                 com.actimind.actitime.administration.ATNamings"%>
<%@ page import="com.actimind.actitime.administration.GeneralSettingsForm" %>
<%@ page import="com.actimind.actitime.colors.ColorHelper" %>
<%@ page import="com.actimind.actitime.resources.SystemSettings" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="java.util.Calendar" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.actitime.TimeFormat" %>
<%@ page import="com.actimind.common.*" %>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.administration.user.BasicUserInfoWithOvertime" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="static com.actimind.actitime.util.Feature.*" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<bean:define id="form" name="GeneralSettingsForm" type="com.actimind.actitime.administration.GeneralSettingsForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="userTimeZone" name="<%=Keys.USER_TIME_ZONE%>" scope="request" type="java.util.TimeZone"/>
<bean:define id="settingsData" name="<%=Keys.GENERAL_SETTINGS_DATA_KEY%>" type="com.actimind.common.administration.BaseGeneralSettingsAction.GeneralSettingsData"/>
<%
    Features ef = FeaturesUtil.getFeatures();
    String userEmail = AuthController.getLoggedInUser(request).getEmail();
    String mailNotificationFooterNoteId = "mailFooter";
    String mailNotificationFooterNoteName = "Message footer";
    boolean userEmailPresent = userEmail != null && !userEmail.equals("");
    boolean isOnlineInstallation = ATGlobals.isOl();
    boolean isEmailNotificationsAvailable = FeaturesUtil.isAvailable(EMA);
    boolean isFourthHLEnabled = ef.isEnabled(SUB);
    String productsIntegrated = (Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) ? Keys.PRODUCTS_INTEGRATED : "";
    String groupsSynchronized = (Boolean) request.getAttribute( Keys.GROUPS_SYNCHRONIZED ) ? Keys.GROUPS_SYNCHRONIZED : "";
    String ptoSettingsIsEnabledAp = settings.isApPtoBalanceCalculationEnabled() ? "ptoSynchronized" : "";
    String sickSettingsIsEnabledAp = settings.isApSickBalanceCalculationEnabled() ? "sickSynchronized" : "";
%>

<html>
    <head>
        <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="general_settings.page_title" /></title>
        <%@include file="../css/scheme_styles.jsp"%>
        <jsp:include page="/include_scripts.jsp"/>

        <at:script page='/js/day_time.js'/>
        <at:script page="/js/controls/LabelController.js"/>

        <jsp:include page='/util/google_api_place_script.jsp'/>

        <script>
            PageOverlayTipsManager.setInstance(new SettingsPageOverlayTipsManager(<%= ef.isEnabled(UGR) ? "true" : "false" %>, <%= ef.isEnabled(URA) ? "true" : "false" %>));

            var URA = <%= ef.isEnabled(URA  ) ? "true" : "false" %>;
            var BRA = <%= ef.isEnabled(BRA  ) ? "true" : "false" %>;
            var SUB = <%= ef.isEnabled(SUB  ) ? "true" : "false" %>;
            var OVR = <%= ef.isEnabled(OVR  ) ? "true" : "false" %>;
            var EMA = <%= isEmailNotificationsAvailable ? "true" : "false" %>;
            var ONLINE = <%= isOnlineInstallation? "true" :"false" %>;
            var SAVED_SMTP_PASSWORD = null;
            var IS_SECURE_CONNECTION = <%=request.isSecure()%>;

            var isHostValid = false;
            var isPortValid = false;
            var isSMTPAuthenticationValid = false;
            var isFromValid = false;
            var isUrlValid = false;
            var isServerErrorInAdressFrom = false;
            var isUserEmailPresented = <%= userEmailPresent %>;

            /*
             * Standart hierarchy levels singular forms to display in the preview panel.
             */
            var previewTitles = {};
            /*
             * Standart hierarchy levels plural forms.
             */
            var standartPluralForms = {};
            <%
                List hierarchyLevels = ATNamings.getHierarchyLevelsList();
                Iterator itit = hierarchyLevels.iterator();
                while(itit.hasNext()) {
                    ATNamings.ATNamingBean hierarchyLevel = (ATNamings.ATNamingBean)itit.next();
            %>
            previewTitles[<%= Integer.toString(hierarchyLevel.getCode()) %>]       = "<%= hierarchyLevel.getSingularForm() %>";
            standartPluralForms[<%= Integer.toString(hierarchyLevel.getCode()) %>] = "<%= hierarchyLevel.getPluralForm() %>";
            <%
                }
            %>

        </script>

        <at:script page='/js/settings_util.js'/>
        <at:script page='/js/settings.js'/>
        <at:script page='/js/customizable_field.js'/>
        <at:script page='/js/base_settings.js'/>
        <at:script page='/js/sections_state_controller.js'/>

        <script language="JavaScript">

        var numbersValidator;
        var portValidator;

        var examples = [];
        <%
        Iterator it = GeneralSettingsForm.getDateFormatExamples(TimeUtils.today( userTimeZone )).iterator();
        int idx = 0;
        while (it.hasNext()) {
            String ex = (String)it.next();
            %>examples[<%=idx%>] = '<%=ex%>';
            <%
            idx++;
        }
        %>

        function updateExample(obj) {
            var selectedIdx = obj.selectedIndex;
            var exEl = document.getElementById('dateFormatPreviewField');
            if (exEl && exEl.firstChild) {
                exEl.firstChild.nodeValue = examples[selectedIdx];
                updateDefaultTZGroupTimeFormat(obj[selectedIdx].value)
            }
        }

        function openSectionsWithErrors()
        {
            if (workdayDurationsEditor.hasErrors())
                sectionsStateController.showBlock("ttLimitationsScheduleSettingsBlock");
            return baseOpenSectionsWithErrors();
        }

        function handleMailSubjectChanges(mailSubjectEl) {
            mailSubjectEl.value = trim(mailSubjectEl.value);
        }

        function canSubmit()
        {
            <% if(ef.isEnabled(URA  ) || ef.isEnabled(BRA  )) { %>
            trimCustomFieldsValues();
            <% } %>

			form().separator.disabled = false;
            <% if ( !isOnlineInstallation ) {%>
                mailAddressFromController.hideGrayTextIfShown();
                smtpHostNameController.hideGrayTextIfShown();
            <%}%>
            <% if ( isEmailNotificationsAvailable ) {%>
                mailMessageFooterController.hideGrayTextIfShown();
            <%}%>
            adminMailAddressController.hideGrayTextIfShown();

            if (ptoRulesEditor != null && ptoRulesEditor.hasErrors())
                sectionsStateController.showBlock("ptoBlock");

            if (ptoRulesEditor != null && ptoRulesEditor.hasErrors())
                sectionsStateController.showBlock("ptoBlock");

            return baseCanSubmit() && confirmWeakSecureConnectionIfNeeded();
        }

        function beforeSubmit()
        {
            <% if( !isOnlineInstallation ) { %>
            prepareSMTPAuthenticationParams();
            <% } %>
        }

        function registerChangeable()
        {
            baseRegisterChangeable();

            registerChangeableControl(form().dateFormat);
            registerChangeableControl(form().maximumMinutesPerDayStr);
            registerChangeableControl(form().hoursPerDayLimited[0]);
            registerChangeableControl(form().hoursPerDayLimited[1]);
            registerChangeableControl(form().separator);
            registerChangeableControl(form().restrictTT);
            registerChangeableControl(form().hideNotAssignedTTDetails)
            registerChangeableControl(form().hideAccountSettingsWhenDisabled);
            registerChangeableControl(form().enableCsvMultilanguage);
            registerChangeableControl(form().timeFormat[0]);
            registerChangeableControl(form().timeFormat[1]);
            registerChangeableControl(form().ttmCanSeeAutoApproved);

        <% if(ef.isEnabled(URA  )) { %>
            registerChangeableControl(form().rateCoefficientStr);
        <% } %>

        <% if( !isOnlineInstallation ) { %>
            registerChangeableControl(form().smtpPort);
            registerChangeableControl(form().urlOfActitimeInstallation);
            registerChangeableControl(form().enableSMTPEncryption);
            registerChangeableControl(form().enableSMTPAuthentication);
            registerChangeableControl(form().smtpEncryptionType);
            registerChangeableControl(form().smtpUsername);
            registerChangeableControl(form().smtpPassword);
        <% } %>
        <% if( isEmailNotificationsAvailable ) { %>
            registerChangeableControl(form().dayTimeToSendNotificationAt);
            registerChangeableControl(form().mailSubjectPrefix);
        <% } %>

        <% if( ef.isEnabled(URA  ) || ef.isEnabled(BRA  )) { %>
            registerChangeableControl(document.getElementById('currencySignFieldCustom'));
            registerChangeableControl(document.getElementById('currencySignFieldPredefined'));
        <% } %>

            var settingsForm = document.getElementById('settingsForm');

            registerChangeableControl(settingsForm['firstHierarchyLevelCode']);
            registerChangeableControl(settingsForm['secondHierarchyLevelCode']);
            registerChangeableControl(settingsForm['thirdHierarchyLevelCode']);
            <% if( isFourthHLEnabled )  {%>
                registerChangeableControl(settingsForm['fourthHierarchyLevelCode']);
                registerChangeableControl(settingsForm['fourthHierarchyLevelSingularForm']);
                registerChangeableControl(settingsForm['fourthHierarchyLevelPluralForm']);
            <% } %>
            registerChangeableControl(settingsForm['firstHierarchyLevelSingularForm']);
            registerChangeableControl(settingsForm['firstHierarchyLevelPluralForm']);
            registerChangeableControl(settingsForm['secondHierarchyLevelSingularForm']);
            registerChangeableControl(settingsForm['secondHierarchyLevelPluralForm']);
            registerChangeableControl(settingsForm['thirdHierarchyLevelSingularForm']);
            registerChangeableControl(settingsForm['thirdHierarchyLevelPluralForm']);
            <% if (ef.isEnabled(UGR  )) { %>
                registerChangeableControl(settingsForm['userGroupNamingCode']);
                registerChangeableControl(settingsForm['userGroupNamingSingularForm']);
                registerChangeableControl(settingsForm['userGroupNamingPluralForm']);
            <% } %>
            registerFormChangedHandlers(true);

            var controls = new Array(settingsForm['firstHierarchyLevelCode'],
                                     settingsForm['secondHierarchyLevelCode'],
                                     settingsForm['thirdHierarchyLevelCode'],
                                     <% if( isFourthHLEnabled )  {%>
                                         settingsForm['fourthHierarchyLevelCode'],
                                     <% } %>
                                     settingsForm['firstHierarchyLevelSingularForm'],
                                     settingsForm['secondHierarchyLevelSingularForm'],
                                     settingsForm['thirdHierarchyLevelSingularForm']
                                     <% if( isFourthHLEnabled )  {%>
                                     ,settingsForm['fourthHierarchyLevelSingularForm']
                                     <% } %>
            );
            setHandlersForControls(controls, hierarchyLevelsPreviewUpdate);

            <% if (ef.isEnabled(UGR  )) { %>
                setHandlersForControls([settingsForm['userGroupNamingCode'],
                                        settingsForm['userGroupNamingSingularForm']],
                                       changeUserGroupNaming);
            <% } %>

            var missedDataArray = [settingsForm['firstHierarchyLevelSingularForm'],
                                   settingsForm['firstHierarchyLevelPluralForm'],
                                   settingsForm['secondHierarchyLevelSingularForm'],
                                   settingsForm['secondHierarchyLevelPluralForm'],
                                   settingsForm['thirdHierarchyLevelSingularForm'],
                                   settingsForm['thirdHierarchyLevelPluralForm']
                                   <% if( isFourthHLEnabled )  {%>
                                      ,settingsForm['fourthHierarchyLevelSingularForm'],
                                      settingsForm['fourthHierarchyLevelPluralForm']
                                   <% } %>
            ];

            <% if (ef.isEnabled(UGR  )) { %>
                missedDataArray.push(settingsForm['userGroupNamingSingularForm']);
                missedDataArray.push(settingsForm['userGroupNamingPluralForm']);
            <% } %>

            addNamingsToControlMissedData(missedDataArray);

            addElementsToControlDuplication([settingsForm['firstHierarchyLevelCode'],
                                             settingsForm['firstHierarchyLevelSingularForm'],
                                             settingsForm['firstHierarchyLevelPluralForm'],
                                             settingsForm['secondHierarchyLevelCode'],
                                             settingsForm['secondHierarchyLevelSingularForm'],
                                             settingsForm['secondHierarchyLevelPluralForm'],
                                             settingsForm['thirdHierarchyLevelCode'],
                                             settingsForm['thirdHierarchyLevelSingularForm'],
                                             settingsForm['thirdHierarchyLevelPluralForm']
                                             <% if( isFourthHLEnabled )  {%>
                                              ,settingsForm['fourthHierarchyLevelCode'],
                                               settingsForm['fourthHierarchyLevelSingularForm'],
                                               settingsForm['fourthHierarchyLevelPluralForm']
                                             <% } %>
                                            ]);

            setHandlersForControls([settingsForm['firstHierarchyLevelPluralForm'],
                                    settingsForm['secondHierarchyLevelPluralForm'],
                                    settingsForm['thirdHierarchyLevelPluralForm']
                                    <% if( isFourthHLEnabled )  {%>
                                       ,settingsForm['fourthHierarchyLevelPluralForm']
                                   <% } %>
                                   ],
                                   duplicationHandler);

            <% if (ef.isEnabled(PTO  )) { %>
            registerChangeableControl(form().ptoShowInHours[0]);
            registerChangeableControl(form().ptoShowInHours[1]);
            registerChangeableControl( settingsForm['ptoUserEnabled'] );
            registerChangeableControl( settingsForm['ptoRoundBalanceOnUserlist'] );
            <% } %>

            <% if (ef.isEnabled(SDB  )) { %>
            registerChangeableControl(form().sickShowInHours[0]);
            registerChangeableControl(form().sickShowInHours[1]);
            registerChangeableControl( settingsForm['sickUserEnabled'] );
            registerChangeableControl( settingsForm['sickRoundBalanceOnUserlist'] );
            <% } %>

            var tzGroupField = form()['defaultTZGroupName']
            registerChangeableControl(tzGroupField);
            $(tzGroupField).on("blur", function() {checkDefaultTZGroupNameField(false)});
        }

    function createTooltip(wrapperClass, dialogDivId) {
        return new DropdownDialog({
                                      wrapperClass: wrapperClass,
                                      dialogDiv: $( "#" + dialogDivId ),
                                      hideButtons: true,
                                      hideOnResize: true,
                                      showEmptyTitleBar: false,
                                      isWithBeak: false
                                  });
    }

    function createRestrictTTNoteTooltip() {
        var showRestrictTTTooltip = createTooltip( "restrictTTNoteTooltipWrapper", "restrictTTNoteTooltip" );
        $("#restrictTTNote").click( function() { showRestrictTTTooltip.showAt( $("#restrictTTNote"), {my: "left top", at: "right bottom", collision: "none"}); } );
    }

    var SettingsConstants ={};
    SettingsConstants.OVERTIME_AUTO = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_AUTO )%>;
    SettingsConstants.OVERTIME_MANUAL = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_MANUAL )%>;
    SettingsConstants.OVERTIME_AUTO_HIDDEN = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_AUTO_HIDDEN )%>;
    SettingsConstants.OVERTIME_OFF = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_OFF )%>;

    function initDefaultOvertimeSelector( currentValue, renderTo, changeCallback )
    {
        var listItems = [
            {
                text:  messageResource.getMessage("userlist.js.overtime_off"),
                value: SettingsConstants.OVERTIME_OFF
            },
            {
                text: messageResource.getMessage("userlist.js.overtime_auto_hidden"),
                value: SettingsConstants.OVERTIME_AUTO_HIDDEN
            },
            {
                text: messageResource.getMessage("userlist.js.overtime_auto"),
                value: SettingsConstants.OVERTIME_AUTO
            },
            {
                text: messageResource.getMessage("userlist.js.overtime_manual"),
                value: SettingsConstants.OVERTIME_MANUAL
            }
        ];

        var selector = new ListSelector({
                                            menuCls: "overtimeSelectorMenu",
                                            renderTo: renderTo,
                                            value: currentValue,
                                            name: "defaultOvertimeLevel",
                                            listItems: listItems
                                        });
        selector.defaultValue = currentValue;

        selector.on( "change", function ( e )
        {
            if( changeCallback )
                changeCallback( selector.value );
            changeableHandler( e )
        } );

        return selector;
    }
     function onLoadHandler()
     {
         <% if(ef.isEnabled(URA  )) { %>
         numbersValidator = new FloatNumbersValidator(
                                "<%=StringUtils.escapeQuoteCharacter(form.getDecimalSeparator().getValue())%>",
                                "", <%=Constants.MAX_RATE_COEFFICIENT%>);
         <% } %>
         initCustomizedFields("currencySignField", <%=StringUtils.getJSStringValue(form.getCurrencySign().getValue())%>,
                                 "decimalSeparatorField", <%=StringUtils.getJSStringValue(form.getDecimalSeparator().getValue())%>,
                                 "digitGroupingSymbolField", <%=StringUtils.getJSStringValue(form.getDigitGroupingSymbol().getValue())%>);

         var overtimeSelectorPlaceholderEl = this.getElementById( "defaultOvertimeSelectorPlaceholder" );
         var changeOvertimeLevel = function(value) {
             document.getElementById('defaultOvertimeSelector').value = value;
         };
         var defaultOvertimeSelector = initDefaultOvertimeSelector(<%=form.getDefaultOvertimeLevel()%>, overtimeSelectorPlaceholderEl, changeOvertimeLevel );
         registerChangeableControl(defaultOvertimeSelector);

         updateTimeFormatPreview();
         updateFormatPreview();
         updateMaximumReportedHoursField();
         var aForm = form();
         updateExample(aForm.dateFormat);

         var workdayDurationsEditor = initWorkdayDurationsEditor(<%=jsHelper.toJSON( form.getDefaultWorkScheduleArray() )%>, <%=String.valueOf( form.getWeekStartDay() )%>);
         var PTOenabled;
         var sickEnabled;
         <% if (ef.isEnabled(PTO  )) { %>
         PTOenabled = true;
         var ptoRulesValues = {};
         ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_ENABLED] = <%=form.isPtoAccrualRuleEnabled( )%>;
         ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_VALUE] = <%=form.getPtoAccrualRuleValue( )%>;
         ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_FREQUENCY_TYPE] = "<%=form.getPtoAccrualRuleFrequencyTypeName( )%>";
         ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_PARAMETERS] = [<%=form.getPtoAccrualRuleParameters( )%>];

         ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_ENABLED] = <%=form.isPtoResetRuleEnabled( )%>;
         ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_VALUE] = <%=form.getPtoResetRuleValue( )%>;
         ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_FREQUENCY_TYPE] = "<%=form.getPtoResetRuleFrequencyTypeName( )%>";
         ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_PARAMETERS] = [<%=form.getPtoResetRuleParameters( )%>];

         ptoRulesValues[BALANCE_RULES_VALUES.CAP_RULE_ENABLED] = <%=form.isPtoCapRuleEnabled( )%>;
         ptoRulesValues[BALANCE_RULES_VALUES.CAP_RULE_VALUE] = <%=form.getPtoCapRuleValue( )%>;
         initPtoRulesEditor(ptoRulesValues, <%=form.getWorkdayDuration()%>, <%=form.isPtoShowInHours()%>);

         <% } %>

         <% if (ef.isEnabled(SDB  )) { %>
         sickEnabled = true;
         var sickRulesValues = {};
         sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_ENABLED] = <%=form.isSickAccrualRuleEnabled( )%>;
         sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_VALUE] = <%=form.getSickAccrualRuleValue( )%>;
         sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_FREQUENCY_TYPE] = "<%=form.getSickAccrualRuleFrequencyTypeName( )%>";
         sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_PARAMETERS] = [<%=form.getSickAccrualRuleParameters( )%>];

         sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_ENABLED] = <%=form.isSickResetRuleEnabled( )%>;
         sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_VALUE] = <%=form.getSickResetRuleValue( )%>;
         sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_FREQUENCY_TYPE] = "<%=form.getSickResetRuleFrequencyTypeName( )%>";
         sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_PARAMETERS] = [<%=form.getSickResetRuleParameters( )%>];

         sickRulesValues[BALANCE_RULES_VALUES.CAP_RULE_ENABLED] = <%=form.isSickCapRuleEnabled( )%>;
         sickRulesValues[BALANCE_RULES_VALUES.CAP_RULE_VALUE] = <%=form.getSickCapRuleValue( )%>;

         initSDBRulesEditor(sickRulesValues, <%=form.getWorkdayDuration()%>, <%=form.isSickShowInHours()%>);
         <% } %>

         if(PTOenabled || sickEnabled)
             initDWDModificationsHandler();


         registerChangeable( workdayDurationsEditor );

         checkDuplication();

         if (ClientSideErrors.hasErrors())
             ClientSideErrors.showClientSideErrorMessage();

         var images = [ '<at:imgpath page="sending-progress.gif"/>',
                       '<at:imgpath page="success.gif"/>',
                       '<at:imgpath page="error.gif"/>'];
        var preloader = new ImagePreloader( images );
        <% if( !isOnlineInstallation ) { %>
          <logic:messagesPresent property="mailAddressFrom">
            isServerErrorInAdressFrom = true;
          </logic:messagesPresent>
          portValidator = new IntegerNumbersValidator(1, 65535, "", false);
          checkAddressFrom();
          checkPort();
          isHostValid = !smtpHostNameController.isEmpty();
          checkUrlOfActitimeInstallation();

          SAVED_SMTP_PASSWORD = smtpPasswordController.getValue();
          checkSMTPAuthenticationParams();
        <% } else { %>
          isHostValid = true;
          isUrlValid = true;
          isPortValid = true;
          isFromValid = true;
          isSMTPAuthenticationValid = true;
        <% } %>
        enableOrDisableSendTestMessageButton();
        <% if(isEmailNotificationsAvailable) { %>
          footerLengthNote = new TextAreaLengthNote('<%=mailNotificationFooterNoteId%>', '<%=mailNotificationFooterNoteName%>', 2000);
          footerLengthNote.setTextLengthCounter( footerLengthNote.fullCounter );
          footerLengthNote.update(mailMessageFooterController.getValue());
          footerLengthNote.show();
        <% } %>

         sectionsStateController = new SectionsStateController().init( "settingSections" );
         sectionsStateController.loadSectionsStateFromCookies();

         $( '.collapsibleGroupHeaderBlock' ).each( function ()
                                                {
                                                    disableTextSelection( this, true );
                                                } );

         createRestrictTTNoteTooltip();
         $(".actualInstallationUrl" ).click( function() { copyActualInstallationUrlToField($("#urlOfActitimeInstallation")); });
         ExitConfirmation.setUpBaseExitConfirmation( "general_settings.exit_confirmation", false );

         var tzGroupsEnabled = '<%=ef.isEnabled(TZG)%>' == 'true';
         switchTimeZoneAndTimeZoneGroupsElements(tzGroupsEnabled);
         updateDefaultTZGroupTime("<%=settingsData.getCurrentTimeOfDefaultTZGroup()%>");
         initDefaultTZGroupTimeZoneSelector(
                 "tzSelector",
                 "<%=form.getDefaultTZGroupCityName()%>",
                 "<%=form.getDefaultTZGroupTimeZoneId()%>",
                 "<%=settingsData.getOffsetInSecondsOfDefaultTimeZone()%>"
         )
     }

    function copyActualInstallationUrlToField(input)
    {
        input.val("<%=request.getAttribute( Keys.GENERAL_SETTINGS_ACTUAL_AT_INSTALLATION_URL ) %>");
        checkUrlOfActitimeInstallation();
    }

    function confirmWeakSecureConnectionIfNeeded( )
    {
        if( !ONLINE && !IS_SECURE_CONNECTION && isSMTPAuthenticationEnabled() )
            return confirm( messageResource.getMessage("general_settings.edit.weakly_secured_connection") );

        return true;
    }

    <% if(ef.isEnabled(OVR  ) && ef.isEnabled(URA  )) { %>
    function checkRateCoefficient(field)
    {
        if (trim(field.value)=="")
            field.value = numbersValidator.formatNumber(0);

        var validationResult = numbersValidator.checkNumber(field,
                "common.errors.invalid_coefficient", "common.errors.large_coefficient", true);

        if (validationResult)
        {
            document.getElementById('rateCoefficientValue').value = numbersValidator.parseNumber(field.value);
            ClientSideErrors.markFieldLabelsAsValid(document.getElementById(field.name+"FieldLabel"));
        }
        else
        {
            if (numbersValidator.parseNumber(field.value))
            {
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(field.name+"FieldLabel"),
                                                          messageResource.getMessage("common.errors.large_coefficient", [<%=Constants.MAX_RATE_COEFFICIENT%>]));
            }
            else
            {
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(field.name+"FieldLabel"),
                                                      messageResource.getMessage("common.errors.invalid_coefficient", [SystemSettings.decimalSeparator]));
            }
        }
        return validationResult;
    }
    <% } %>

    function markValidIfMailFieldsAreEmpty()
    {
        //If all required fields are empty then Mail data is valid.
        if (areMailSettingsEmpty())
        {
            markFieldAsValid(smtpHostNameController.getElement());
            markFieldAsValid(form().smtpPort);
            markFieldAsValid(urlOfActitimeInstallationController.getElement());
            markFieldAsValid(mailAddressFromController.getElement());
            markFieldAsValid(adminMailAddressController.getElement());
            markFieldAsValid(smtpUsernameController.getElement());
            markFieldAsValid(smtpPasswordController.getElement());
            <%  if(isEmailNotificationsAvailable) { %>
                markFieldAsValid(form().dayTimeToSendNotificationAtId);
            <%  } %>
            hideClientSideErrorMessageIfNoErrors();
        }
    }
    function areMailSettingsEmpty()
    {
        var isHostEmpty = smtpHostNameController.isEmpty();
        var isPortEmpty = trim(form().smtpPort.value) === "";
        var isFromEmpty = mailAddressFromController.isEmpty();
        var isUrlEmpty = urlOfActitimeInstallationController.isEmpty();
        var isAdminMailAddressEmpty = adminMailAddressController.isEmpty();
        var isAuthenticationSettingsEmpty = !isSMTPAuthenticationEnabled() ||
                                            (smtpUsernameController.isEmpty() && smtpPasswordController.isEmpty() );
        return isHostEmpty && isPortEmpty && isFromEmpty && isUrlEmpty && isAdminMailAddressEmpty && isAuthenticationSettingsEmpty;
    }


        <%  if(!isOnlineInstallation) { %>
        function checkPort()
        {
            var field = document.getElementById("smtpPortId");
            isPortValid = portValidator.checkField(field, true , "general_settings.edit.invalid_mail_port",
                "general_settings.edit.invalid_mail_port", "general_settings.edit.invalid_mail_port");
            if(isPortValid)
            {
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById(field.name+"FieldLabel"));
                hideClientSideErrorMessageIfNoErrors();
            } else {
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(field.name+"FieldLabel"),
                        messageResource.getMessage("general_settings.edit.invalid_mail_port"));
            }
            isPortValid = isPortValid && trim(field.value) != '';
            enableOrDisableSendTestMessageButton();
            markValidIfMailFieldsAreEmpty()
        }

        function checkAddressFrom()
        {
            var fromStr = trim(mailAddressFromController.getValue());
            if (mailAddressFromController.isModified())
                handleChange(true);
            //Test valid email. Note: this checking not full, only simple problem, but in many cases it enough.
            if(!testFromEmail(fromStr))
            {
                ClientSideErrors.markTextFieldAsInvalid(mailAddressFromController.getElement(),
                        messageResource.getMessage("general_settings.edit.address_from_wrong"));
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(mailAddressFromController.getElement().name+"FieldLabel"), messageResource.getMessage("general_settings.edit.address_from_wrong"));
                isFromValid = false;
            }else {
                if(!isServerErrorInAdressFrom)//Only first time check if there is a server error
                {
                    ClientSideErrors.markTextFieldAsValid(mailAddressFromController.getElement());
                    ClientSideErrors.markFieldLabelsAsValid(document.getElementById(mailAddressFromController.getElement().name+"FieldLabel"));
                    hideClientSideErrorMessageIfNoErrors();
                }else{
                    isServerErrorInAdressFrom = false;
                }
                    isFromValid = !mailAddressFromController.isEmpty();
            }
            enableOrDisableSendTestMessageButton();
            markValidIfMailFieldsAreEmpty();
        }

        function changeEnableSMTPEncryption( checkbox )
        {
            displayElement( "smtpEncryptionParams", checkbox.checked )
        }

        function changeEnableSMTPAuthentication( checkbox )
        {
            displayElement( "smtpAuthenticationParams", checkbox.checked );
            checkSMTPAuthenticationParams();
        }

        function changeSMTPEncryptionType( )
        {
            var portField = form().smtpPort;
            if( isDefaultPort( parseInt( trim(portField.value) ) ) )
            {
                switch( parseInt( form().smtpEncryptionType.value ) )
                {
                    case <%=MailServerSettings.TLS_ENCRYPTION_TYPE%>:
                        portField.value = 465;
                        break;
                    case <%=MailServerSettings.STARTTLS_ENCRYPTION_TYPE%>:
                        portField.value = 25;
                        break;
                    case <%=MailServerSettings.SSL_ENCRYPTION_TYPE%>:
                        portField.value = 465;
                        break;
                }
            }
        }

        function isDefaultPort( port )
        {
            return port == <%=MailServerSettings.DEFAULT_SMTP_PORT%> ||
                   port == <%=MailServerSettings.DEFAULT_SMTPS_PORT%> ||
                   isNaN(port) ;
        }

        function displayElement( elementId, isDisplay )
        {
            var element = getElementById( elementId );
            element.style.display = isDisplay ? "" : "none";
        }

        function storeSavedSMTPPasswordAndShowInput( link )
        {
            link.style.display = "none";
            var input = smtpPasswordController.getElement();
            input.style.display = "";
            input.focus();
            input.value = "";
            smtpPasswordLabelController.setDisplay(false);
        }

        function prepareSMTPAuthenticationParams( )
        {
            if( smtpPasswordController.isEmpty() )
                smtpPasswordEncodedController.setValue( SAVED_SMTP_PASSWORD );
            else
                smtpPasswordEncodedController.setValue( smtpPasswordController.getValue() );

            smtpUsernameEncodedController.setValue( smtpUsernameController.getValue() );


            smtpUsernameController.setValue("");
            smtpUsernameController.showGreyText(messageResource.getMessage("general_settings.saving").toLowerCase());
            smtpPasswordController.setValue("");
            smtpPasswordLabelController.setText(messageResource.getMessage("general_settings.saving").toLowerCase());
            smtpPasswordLabelController.setDisplay(true);
        }

        function checkSMTPAuthenticationParams( )
        {
            isSMTPAuthenticationValid = checkSMTPPassword() && checkSMTPUsername();
            enableOrDisableSendTestMessageButton();
            markValidIfMailFieldsAreEmpty();
            if( isSMTPAuthenticationValid )
                clearSMTPAuthenticationErrors();
        }

        function checkSMTPUsername()
        {
            return !( isSMTPAuthenticationEnabled() && smtpUsernameController.isEmpty() ) ;
        }

        function checkSMTPPassword()
        {
            var noPasswordSpecified = smtpPasswordController.isEmpty() && !SAVED_SMTP_PASSWORD;
            if( smtpPasswordController.isEmpty() )
                smtpPasswordLabelController.setDisplay(true);
            else
                smtpPasswordLabelController.setDisplay(false);

            return !( isSMTPAuthenticationEnabled() && noPasswordSpecified );
        }

        function clearSMTPAuthenticationErrors()
        {
            ClientSideErrors.markTextFieldAsValid(smtpUsernameController.getElement());
            ClientSideErrors.markTextFieldAsValid(smtpPasswordController.getElement());
            ClientSideErrors.markFieldLabelsAsValid( document.getElementById("loginInfoLabel"), FieldController.LABEL_ERROR_CLASS );
        }

        function isSMTPAuthenticationEnabled()
        {
            return form().enableSMTPAuthentication.checked;
        }

        <% } %>

        function handleFooterChanges()
        {
            var footerStr = mailMessageFooterController.getValue();
            if ( trim(footerStr) != mailMessageFooterController.getElement().defaultValue)
                handleChange(true);
            footerLengthNote.update(footerStr);
            checkEmailMessageFooter( footerStr );
        }

        function checkEmailMessageFooter( footerStr )
        {            
            var textElement = document.getElementById(mailMessageFooterController.getElement().name+"FieldLabel");
            var errorClassName = isChrome() ? "input-field-error" : null; //a workaround for jumping text inside textarea
            // in Chrome when error occurs.
            if( footerLengthNote.getTextLength() > footerLengthNote.maxValue )
            {
                var errorMessage = messageResource.getMessage("general_settings.edit.mail_footer_too_long",
                                                              [ footerLengthNote.maxValue, footerLengthNote.getTextLength() ] );
                ClientSideErrors.markTextFieldAsInvalid(mailMessageFooterController.getElement(), errorMessage, errorClassName);
                ClientSideErrors.markFieldLabelsAsInvalid( textElement, errorMessage );
            }
            else
            {
                ClientSideErrors.markTextFieldAsValid(mailMessageFooterController.getElement(), errorClassName);
                ClientSideErrors.markFieldLabelsAsValid( textElement );
                hideClientSideErrorMessageIfNoErrors();
            }

        }

        function updateAddressFrom()
        {
            if (smtpHostNameController.isModified())
                handleChange(true);
            isHostValid = !smtpHostNameController.isEmpty();
            if(isHostValid && mailAddressFromController.isEmpty())
            {
                mailAddressFromController.hideGrayTextIfShown();
                mailAddressFromController.getElement().value = "actiTIME <no-reply@" + trim(smtpHostNameController.getValue()) + ">"
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById(mailAddressFromController.getElement().name+"FieldLabel"));
                checkAddressFrom();
            }
            else{
                enableOrDisableSendTestMessageButton();
                markValidIfMailFieldsAreEmpty()
            }

        }

        function checkUrlOfActitimeInstallation()
        {
            var urlValue = trim(urlOfActitimeInstallationController.getValue());
            if (urlValue != urlOfActitimeInstallationController.getElement().defaultValue)
                handleChange(true);
            if (!testUrl(urlValue))
            {
                ClientSideErrors.markTextFieldAsInvalid(urlOfActitimeInstallationController.getElement(),
                        messageResource.getMessage("general_settings.edit.actitime_url_wrong"));
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(urlOfActitimeInstallationController.getElement().name+"FieldLabel"),
                        messageResource.getMessage("general_settings.edit.actitime_url_wrong"));
                isUrlValid = false;
            }
            else
            {
                ClientSideErrors.markTextFieldAsValid(urlOfActitimeInstallationController.getElement());
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById(urlOfActitimeInstallationController.getElement().name+"FieldLabel"));
                hideClientSideErrorMessageIfNoErrors();
                isUrlValid = !urlOfActitimeInstallationController.isEmpty();
            }

            enableOrDisableSendTestMessageButton();
            markValidIfMailFieldsAreEmpty();
        }

        function checkAdminAddress()
        {
            var isAdminMailAddressEmpty = adminMailAddressController.isEmpty();
            var addressStr = trim(adminMailAddressController.getValue());
            if (adminMailAddressController.isModified())
                handleChange(true);

            if(!isAdminMailAddressEmpty && !testEmail(addressStr))
            {
                ClientSideErrors.markTextFieldAsInvalid(adminMailAddressController.getElement(),
                        messageResource.getMessage("general_settings.edit.admin_mail_address_wrong"));
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(adminMailAddressController.getElement().name+"FieldLabel"),
                        messageResource.getMessage("general_settings.edit.admin_mail_address_wrong"));
            }else{
                ClientSideErrors.markTextFieldAsValid(adminMailAddressController.getElement());
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById(adminMailAddressController.getElement().name+"FieldLabel"));
                hideClientSideErrorMessageIfNoErrors();
            }
            if (!ONLINE) {
                markValidIfMailFieldsAreEmpty();
            }
        }

        //Test valid email. Note: this checking not full, only simple problem, but in many cases it enough.
        function testEmail(email)
        {
            return email == null || email == "" || isEmailValid(email);
        }

        function testFromEmail(email)
        {
            return email == null || email == "" || /\w@\w/.test(email);
        }

        //Tests whether url is valid (just checks that protocol is provided)
        function testUrl(url)
        {
            return url == null || url == "" || (/^https?:\/\/\S*[^.]$/.test(url) && !/\.[./]/.test());
        }

        function checkDayTimeToSendNotificationAt()
        {
            var field = document.getElementById("dayTimeToSendNotificationAtId");
            var timeValStr = field.value;
            if(isEqualsIgnoreCase(trim(field.value), "") || DayTime.isDayTimeValid(timeValStr))
            {
                field.value = DayTime.addZerosAndTrimIfNeeded(timeValStr);
                ClientSideErrors.markTextFieldAsValid(field);
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById(field.name + "FieldLabel"));
                hideClientSideErrorMessageIfNoErrors();
            }
            else
            {
                ClientSideErrors.markTextFieldAsInvalid(field,
                        messageResource.getMessage("general_settings.edit.invalide_day_time_format"));
                ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById(field.name + "FieldLabel"),
                        messageResource.getMessage("general_settings.edit.invalide_day_time_format"));
            }
        }

   function sendTestMessage()
   {
       <% if(! isOnlineInstallation) { %>
       validateAddressFrom();
       if(!checkMailValid())
            return;
       <% } %>

       if( !confirmWeakSecureConnectionIfNeeded() )
            return;

       var button = document.getElementById("sendTestMessage_button");
       var icon = document.getElementById("sendTestMessage_icon");
       var note = document.getElementById("sendTestMessage_note");
       var aForm = form();
       var smtpPassword;
       var manager;
       var statesManager = new SendTestMessageButtonStatesController(button, icon, note, '<%=ResponseUtils.filter(userEmail)%>', enableOrDisableSendTestMessageButton, atImgPath("note_mark.gif"));
       var states = statesManager.getStates();
       RpcControlManager.setRpcTimeout( 15000 ); // 15 seconds;
       if( ONLINE )
       {
           manager = new SendTestMailManager(null, null, null, null, null, null, null, null,
                                             getPropertyValue(aForm.mailSubjectPrefix, "value"), null,
                                             mailMessageFooterController.isEmpty()? "":aForm.mailMessageFooter.value,
                                             states, statesManager, true);
       }
       else
       {
           smtpPassword = smtpPasswordController.isEmpty() ? SAVED_SMTP_PASSWORD : smtpPasswordController.getValue();
           var footerValue = (!EMA || mailMessageFooterController.isEmpty()) ? "" : getPropertyValue(aForm.mailMessageFooter, "value");
           var subjectPrefixValue = getPropertyValue(aForm.mailSubjectPrefix, "value");
           manager = new SendTestMailManager(smtpHostNameController.getValue(),
                                             getPropertyValue(aForm.smtpPort, "value"),
                                             getPropertyValue(aForm.enableSMTPEncryption, "checked"),
                                             getPropertyValue(aForm.smtpEncryptionType, "value"),
                                             getPropertyValue(aForm.enableSMTPAuthentication, "checked"),
                                             smtpUsernameController.getValue(), smtpPassword,
                                             mailAddressFromController.getValue(),
                                             subjectPrefixValue ? subjectPrefixValue : "",
                                             getPropertyValue(aForm.urlOfActitimeInstallation, "value"),
                                             footerValue, states, statesManager, false);

       }
       RpcControlManager.saveRpcControlBoundData(manager);
   }

   function checkMailValid()
   {
       return isHostValid && isPortValid && isFromValid && isUserEmailPresented && isUrlValid && isSMTPAuthenticationValid;
   }

   function enableOrDisableSendTestMessageButton()
   {
       var button = document.getElementById("sendTestMessage_button");

       if(checkMailValid())
       {
           button.disabled = undefined;
           button.title = ""
       }
       else
       {
           button.disabled = true;
           button.title = getDisabledTestMessageButtonTooltip();
       }
   }

   function getDisabledTestMessageButtonTooltip()
   {
       if( ONLINE )
            return "";
       else if( isSMTPAuthenticationEnabled && isSMTPAuthenticationEnabled() )
            return '<%=jsMessage(request, "general_settings.edit.mail.send_test_message.with_authentication.button_disabled")%>';
       else
            return '<%=jsMessage(request, "general_settings.edit.mail.send_test_message.button_disabled")%>';
   }


   function onNumberFormatChange()
   {
       var separator = decimalSeparatorField.getValue();
       var digitGroupingSymbol = digitGroupingSymbolField.getValue();

       if (separator == "")
         return;

       updateTimeFormatPreview();
       updateFormatPreview();

       SystemSettings.decimalSeparator = separator;
       SystemSettings.digitGroupingSymbol = digitGroupingSymbol;
       updateWorkdayDurationsEditorTooltip();
       updateWorkdayDurationsLabelErrorState();

       if (EnabledFeatures.PTO)
       {
           ptoRulesEditor.updateDecimalSeparator();
           ptoRulesEditor.updateDigitGroupingSymbol();
       }
       if (EnabledFeatures.SDB)
       {
           sickRulesEditor.updateDecimalSeparator();
           sickRulesEditor.updateDigitGroupingSymbol();
       }

       validateWorkdayDuration();
       validateMaximumMinutesPerDay();
       <% if(ef.isEnabled(OVR  ) && ef.isEnabled(URA  )) { %>
       numbersValidator = new FloatNumbersValidator(
               separator, digitGroupingSymbol, <%=Constants.MAX_RATE_COEFFICIENT%>);

       var rateField = document.getElementById("overtimeRateCoefficient");

       if (!fieldErrors["rateCoefficientStr"])
       {
            rateField.value =
                numbersValidator.formatNumber(
                        document.getElementById('rateCoefficientValue').value
                        );
       }
       else
       {
          checkRateCoefficient(rateField);
       }
       <% } %>

       document.getElementById("timeFormat_decimal_label").innerHTML =
           messageResource.getMessage("time_format_selector.time_format_decimal", [separator]);

       document.getElementById("timeFormat_note").innerHTML =
           messageResource.getMessage("general_settings.edit.time_format_note", [separator]);


   }

   var previousSeparatorIndex = -1;

   function onEnableCsvMultilanguage()
   {
		var aForm = form();
		var csvMultilanguageEnabled = aForm.enableCsvMultilanguage.checked;
		var separatorDropdown = aForm.separator;
		var separatorIndex = separatorDropdown.selectedIndex;
		separatorDropdown.disabled = csvMultilanguageEnabled;
		if (csvMultilanguageEnabled)
		{
			previousSeparatorIndex = separatorIndex;
			document.getElementById("tab_separator_option").selected = true;
		}
		else if (previousSeparatorIndex > -1)
		{
			separatorDropdown.options[previousSeparatorIndex].selected = true;
		}
   }

    function onConfigureEmailSettingsClick() {
        var scrollToBlock = function() {
            $(window).scrollTop($('#emailConfigurationLink').position().top);
        };
        var sectionId = 'downloadableEmailSettingsBlock';
        if (sectionsStateController.isSectionHidden( sectionId ))
        {
            sectionsStateController.showOrHideBlock( sectionId );
            window.setTimeout( scrollToBlock, 250 );
        }
        else
        {
            scrollToBlock();
        }
        return false;
    }

        </script>

        <!--[if IE 8]>
        <style type="text/css">
            .modificationsInfo:before, .modificationsInfo:after {
                display: none;
            }
        </style>
        <![endif]-->

    </head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      onload="onLoadHandler()"
      class="settings with-navigation">
<div id="container">
<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected" value="<%=Navigator.NO_SELECTION_KEY%>" />
</jsp:include>

<html:form action="/administration/settings.do" method="post" styleId="settingsForm" onsubmit="return canSubmit();">
<html:hidden property="redirectUrl"/>
<html:hidden property="formDataModified"/>
<html:hidden property="afterReloginUrl"/>
<html:hidden property="beforeReloginUsername"/>
    <table cellpadding="0" cellspacing="0" border="0" width="800" align="center">
        <tr>
            <td align="left" class="mainContentPadding rightPadding <%=productsIntegrated%>">

    <div>
        <table width="100%" cellspacing="0" cellpadding="0" valign="top" border="0">
            <tr width="100%">
                <td class="pagetitle"><bean:message key="general_settings.page_title" /></td>
                <td align="right"><%@include file="/form_modified_div.jsp" %></td>
            </tr>
        </table>
    </div>

    <div height="10" style="padding-left:20px; padding-top: 10px;">
        <%@include file="/messages.jsp"%>
        <div id="ClientSideErrorMessage" style="display:none; padding-top:8px;">
            <bean:define id="details" value="saving general settings" toScope="request"/>
            <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
        </div>
    </div>

<% if( !MailServerSettingsGlobalInstance.getMailServerSettings().areMailSettingsSpecified() ) { %>

    <div>
        <at:roundedbox id="warningMessageBox" styleClass="warningMessageBox">
            <div id="warningMessageBoxTitle" class="title"><bean:message key="password_recovery.notifications_not_configured" /></div>
            <div id="warningMessageBoxDescription" class="description">
                <bean:message key="password_recovery.notifications_not_configured.description" />
                <div style="height:5px; line-height:1px;"></div>
                <a href="javascript:void(0)" onclick="onConfigureEmailSettingsClick();"><bean:message key="password_recovery.notifications_not_configured.configure_link.text" /></a>
            </div>
        </at:roundedbox>
    </div>

<% } %>

    <div id="collapseMenuBlock" class="collapseMenuBlock" style="visibility: hidden">
        <div id="collapseAllButton" class="collapseButton">
            <span class="text"><bean:message key="general_settings.collapse_all"/></span>
            <at:img page="collapse_all.png" styleClass="collapseDescription"/>
        </div>
        <div id="expandAllButton" class="collapseButton">
            <span class="text"><bean:message key="general_settings.expand_all"/></span>
            <at:img page="expand_all.png" styleClass="expandDescription"/>
        </div>
    </div>
                
<%-- Naming block --%>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="namingSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle namingGroupTitle"><bean:message key="general_settings.naming_section.label"/></span>
        </div>
    </div>

    <div class="collapsibleBlock <%=groupsSynchronized%>" id="namingSettingsBlock">

        <table cellpadding="0" cellspacing="0" border="0" width="100%" class="collapsibleBlockContent">
            <jsp:include page="settings_hierarchy_levels.jsp"/>

            <% if (ef.isEnabled(UGR)) { %>

            <tr>
                <td class="titleCell" style="padding-top: 15px;">
                    <span class="formblocktitle">
                        <bean:message key="general_settings.user_groups.label"/>
                    </span>
                    <span class="sharedGroupsSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
                </td>
            </tr>

            <tr id="userGroupsSettings">
                <td class="contentCell" style="padding-top: 4px;">
                    <div class="levelCodeSelect">
                        <html:select property="userGroupNamingCode" styleId="userGroupNamingCodeSelect">
                            <html:option
                                    value="<%= Integer.toString(ATNamings.CUSTOM_LEVEL_NAMING_CODE) %>">
                                <bean:message key="hierarchy_levels.custom_level"/>
                            </html:option>
                            <html:optionsCollection property="userGroupNamingList"
                                                    label="singularForm"
                                                    value="code"/>
                        </html:select>
                    </div>
                </td>
            </tr>

            <tr id="customUserGroupNaming" style="display: none;">
                <td class="userGroupNamingCell contentCell">
                    <jsp:include page="settings_custom_level_inputs.jsp">
                        <jsp:param name="singularFormInputName"
                                   value="userGroupNamingSingularForm"/>
                        <jsp:param name="pluralFormInputName"
                                   value="userGroupNamingPluralForm"/>
                        <jsp:param name="singularFormLabelId"
                                   value="userGroupNamingSingularFormLabel"/>
                        <jsp:param name="pluralFormLabelId"
                                   value="userGroupNamingPluralFormLabel"/>
                        <jsp:param name="singularValueExample"
                                   value="<%= SystemSettings.getDefaultUserGroupNaming().getSingularForm() %>"/>
                        <jsp:param name="pluralValueExample"
                                   value="<%= SystemSettings.getDefaultUserGroupNaming().getPluralForm() %>"/>
                    </jsp:include>
                </td>
            </tr>

            <% } %>
        </table>

    </div>


    <%-- Date & Time Setting block --%>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="dateTimeSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle dateTimeGroupTitle"><bean:message key="general_settings.date_time_section.label"/></span>
            <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        </div>

    </div>

    <div class="collapsibleBlock" id="dateTimeSettingsBlock">

        <table cellpadding="0" cellspacing="0" border="0" class="collapsibleBlockContent" style="margin-top: 8px; margin-bottom: 8px;">
            <tr>
                <td class="formfieldtitle formFieldCaption"><bean:message key="general_settings.date_time.calendar_layout"/></td>
                <td colspan="2">
                    <html:select property="weekStartDay" styleId="weekStartDaySelect" style="float:left; margin-left:2px;">
                        <%
                            // Starting from sunday add option for each day
                            for(int weekDay = Calendar.SUNDAY; weekDay <= Calendar.SATURDAY; weekDay++){
                        %>
                        <html:option value="<%=String.valueOf(weekDay)%>"><%=message( request, "general_settings.date_time.week_starts_on", message( request, TimeUtils.getDayOfWeekFullNameKey( weekDay ) ))%></html:option>
                        <%
                            }
                        %>
                    </html:select>
                </td>
            </tr>
            <tr>
                <td class="formfieldtitle formFieldCaption"><bean:message key="general_settings.date_time.date_format"/></td>
                <td width="235px">
                    <html:select property="dateFormat" styleId="dateFormatSelect" onchange="updateExample(this);" onkeyup="updateExample(this);" style="float:left; margin-left:2px">
                        <html:optionsCollection property="supportedDateFormats" label="textPresentation" value="javaFormat" />
                    </html:select>
                </td>
                <td class="formfieldtitle">
                    <div style="position:relative; top:-8px;">
                        <jsp:include page="format_preview.jsp">
                            <jsp:param name="previewId" value="dateFormatPreviewField"/>
                            <jsp:param name="previewWidth" value="110"/>
                            <jsp:param name="previewHeight" value="23"/>
                        </jsp:include>
                    </div>
                </td>
            </tr>
            <jsp:include page="time_zone_groups_block.jsp"/>
        </table>
    </div>


<%-- Time-track block --%>

<div>
    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="ttLimitationsScheduleSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle timeTrackGroupTitle"><bean:message key="general_settings.tt_limitations_schedule_section.label"/></span>
        </div>
    </div>
</div>

<div class="collapsibleBlock" id="ttLimitationsScheduleSettingsBlock">
    <div class="collapsibleBlockContent">
        <table class="reportLimitTable">
            <tr>
                <td class="formfieldtitle" nowrap><span id="maximumMinutesPerDayStrFieldLabel"><bean:message key="general_settings.tt_limitations.maximum_reported_hours_per_day"/></span></td>
                <td>
                    <table border="0" cellpadding="0" cellspacing="2">
                        <tr>
                            <td>
                                <html:radio property="hoursPerDayLimited" value="true" styleId="hoursPerDayLimited_LimitTo" onchange="updateMaximumReportedHoursField();validateMaximumMinutesPerDay();" onclick="validateMaximumMinutesPerDay();"/>
                            </td>
                            <td style="padding-right: 10px"><label for="hoursPerDayLimited_LimitTo"><bean:message key="general_settings.tt_limitations.limit_to"/></label></td>
                            <td>
                                <html:text property="maximumMinutesPerDayStr"
                                           styleId="maximumMinutesPerDayId"
                                           onchange="this.form.hoursPerDayLimited[0].checked = true"
                                           onblur="validateMaximumMinutesPerDay()"
                                           size="3" maxlength="6"/>
                            </td>
                            <td><bean:message key="general_settings.tt_limitations.hours"/></td>
                        </tr>
                        <tr>
                            <td><html:radio property="hoursPerDayLimited" value="false" styleId="hoursPerDayLimited_Unlimited" onchange="updateMaximumReportedHoursField(); validateMaximumMinutesPerDay();" onclick="validateMaximumMinutesPerDay();"/></td>
                            <td colspan="3" style="padding-top: 0px;"><label for="hoursPerDayLimited_Unlimited"><bean:message key="general_settings.tt_limitations.unlimited"/></label></td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td>
                    <div class="noteContainer">
                        <at:img page="note_mark.gif" styleClass="noteImage"/>
                        <span class="notemsg"><bean:message key="general_settings.tt_limitations.limit_working_time.note"/></span>
                    </div>
                </td>
            </tr>


        </table>
        <jsp:include page="/administration/work_schedule_settings_block_content.jsp">
            <jsp:param name="numberOfUsersWithDefaultSchedule" value="<%=settingsData.getNumberOfUsersWithDefaultSchedule()%>"/>
        </jsp:include>
    </div>
</div>

    <%-- Default PTO block --%>

<% if(ef.isEnabled(PTO)) { %>

    <div class="collapsibleGroupHeaderBlock <%=ptoSettingsIsEnabledAp%>">
        <div class="showCollapsibleBlockButton" id="ptoBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle ptoGroupTitle"><bean:message key="general_settings.pto_section.label"/></span>
            <span class="sharedPtoSettingsImage sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        </div>
    </div>

    <jsp:include page="/administration/balance_settings_block.jsp">
        <jsp:param name="leaveTypeBalanceTypePrefix" value="pto"/>
        <jsp:param name="numberOfUsersWithDefaultBalanceSettings" value="<%=settingsData.getNumberOfUsersWithDefaultPTOSettings()%>"/>
        <jsp:param name="balanceTypeKeyMessage" value="general_settings.pto_section_key"/>
        <jsp:param name="className" value="collapsibleBlock"/>
    </jsp:include>

<% } %>
<%-- Default SDB block --%>
<% if( ef.isEnabled(SDB) )
{ %>
                <div class="collapsibleGroupHeaderBlock <%=sickSettingsIsEnabledAp%>">
                    <div class="showCollapsibleBlockButton" id="sickBlockButton"></div>
                    <div class="collapsibleGroupHeader">
                        <span class="settingsGroupTitle sickDaysGroupTitle"><bean:message
                                key="general_settings.sick_section.label"/></span>
                        <span class="sharedSickSettingsImage sharedSettingsImage"
                              title='<bean:message key="general_settings.shared_settings"/>'></span>
                    </div>
                </div>
                <jsp:include page="/administration/balance_settings_block.jsp">
                    <jsp:param name="leaveTypeBalanceTypePrefix" value="sick"/>
                    <jsp:param name="numberOfUsersWithDefaultBalanceSettings"
                               value="<%=settingsData.getNumberOfUsersWithDefaultSDBSettings()%>"/>
                    <jsp:param name="balanceTypeKeyMessage" value="general_settings.sick_section_key"/>
                    <jsp:param name="className" value="collapsibleBlock"/>
                </jsp:include>
<% } %>


<%-- Overtime block --%>
<% if (ef.isEnabled(OVR)) { %>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="overtimeBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle overtimeGroupTitle"><bean:message key="general_settings.overtime_section.label"/></span>
        </div>
    </div>

    <div class="collapsibleBlock" id="overtimeBlock">
        <div class="collapsibleBlockContent">

            <table cellpadding="0" cellspacing="0" style="margin-top: 5px; margin-bottom: 20px;" id="defaultOvertimeLevelTable">
                <tr>
                    <td>
                        <table cellpadding="0" cellspacing="0" border="0">
                            <tr>
                                <td class="formfieldtitle" style="padding-top: 13px;">
                                    <span id="defaultOvertimeLevelLabel">
                                        <bean:message key="general_settings.overtime.default_overtime_level"/>
                                    </span>
                                </td>
                                <td class="formfieldtitle">
                                    <input type="hidden"
                                           name="defaultOvertimeLevel"
                                           property="defaultOvertimeLevel"
                                           value="<%=String.valueOf( form.getDefaultOvertimeLevel() )%>"
                                           id="defaultOvertimeSelector"
                                           defaultValue="<%=String.valueOf( form.getDefaultOvertimeLevel() )%>"/>
                                    <span id="defaultOvertimeSelectorPlaceholder">&nbsp;</span>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            <% if (ef.isEnabled(URA)) { %>

                <table cellpadding="0" cellspacing="0" style="margin-top: 5px; margin-bottom: 6px;" id="defaultHourRateTable">
                    <tr>
                        <td>
                            <table cellpadding="0" cellspacing="0" border="0">
                                <tr>
                                    <td class="formfieldtitle">
                                        <span id="rateCoefficientStrFieldLabel">
                                            <bean:message key="general_settings.overtime_settings.default_overtime_rate"/>
                                        </span>
                                    </td>
                                    <td class="formfieldtitle">
                                        <input onblur="checkRateCoefficient(this);"
                                               maxlength="7" size="1"
                                               class="rateCoefficient"
                                               name="rateCoefficientStr"
                                               type="text"
                                               id="overtimeRateCoefficient"
                                               defaultValue="<%=StringUtils.encodeQuoteCharacter(form.getFormattedOvertimeRateCoefficient(settings))%>"
                                               value="<%=StringUtils.encodeQuoteCharacter(form.getFormattedOvertimeRateCoefficient(settings))%>">

                                        <html:hidden property="overtimeRateCoefficient" styleId="rateCoefficientValue"/>
                                    </td>
                                    <td class="formfieldtitle">
                                        <nobr>&nbsp;&nbsp;x <bean:message key="general_settings.time_track.overtime.options.hour_rate.right_caption"/></nobr>
                                    </td>
                                    <logic:messagesPresent property="overtimeRateCoefficient">
                                        <script>
                                            var msg = messageResource.getMessage("common.errors.large_coefficient", [<%=Constants.MAX_RATE_COEFFICIENT%>]);
                                            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("rateCoefficientStrFieldLabel"), msg);
                                            ClientSideErrors.paintElementAsInvalid(form().rateCoefficientStr, msg);
                                        </script>
                                    </logic:messagesPresent>
                                </tr>
                            </table>
                        </td>
                    </tr>

                </table>
            <% } %>
        </div>
    </div>

<% } %>


<%-- Formats block --%>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="formatsSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle formatsGroupTitle"><bean:message key="general_settings.formats_section.label"/></span>
        </div>
    </div>

    <div class="collapsibleBlock" id="formatsSettingsBlock">

        <table cellpadding="0" cellspacing="0" border="0" width="100%" class="collapsibleBlockContent">

            <tr>
                <td class="titleCell"><span class="formblocktitle" style="margin-top: 4px; margin-bottom: 4px;">
                    <%=message( request, "general_settings.configure_numbers_format" )%></span>
                    <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>' style="margin-top: 6px;"></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="0" cellspacing="0">
                    <tr class="formfieldtitle">
                        <td class="formFieldSecondLevelCaption"><span id="decimalSeparatorFieldLabel"><%=message( request, "general_settings.decimal_symbol" )%>:</span></td>
                        <td width="102px">
                            <div class="markingDivForSelect">
                                <html:select property="decimalSeparator.predefined" styleId="decimalSeparatorFieldPredefined"
                                        onchange="decimalSeparatorField.validateField(); onCustomFieldsChange();" >
                                    <html:option value="."><bean:message key="general_settings.formats.dot"/></html:option>
                                    <html:option value=","><bean:message key="general_settings.formats.comma"/></html:option>
                                    <html:option value="<%=SystemSettings.CUSTOM_VALUE_STRING%>"><bean:message key="general_settings.formats.custom"/></html:option>
                                </html:select>
                            </div>
                        </td>
                        <td style="padding:0" width="107px">
                            <span><html:text size="1" maxlength="1" style="display:none" property="decimalSeparator.custom"
                                       styleId="decimalSeparatorFieldCustom" styleClass="customValue"
                                       onchange="decimalSeparatorField.validateField(); onCustomFieldsChange();"/></span>
                        </td>
                        <td rowspan="2" valign="bottom">
                            <div style="position:relative; top:-10px;">
                                <jsp:include page="format_preview.jsp">
                                    <jsp:param name="previewId" value="numbersFormatPreviewField"/>
                                    <jsp:param name="previewWidth" value="110"/>
                                    <jsp:param name="previewHeight" value="48"/>
                                </jsp:include>
                            </div>
                        </td>
                    </tr>
                    <tr class="formfieldtitle">
                        <td class="formFieldSecondLevelCaption"><span id="digitGroupingSymbolLabel"><%=message( request, "general_settings.digit_grouping_symbol" )%>:</span></td>
                        <td>
                            <div class="markingDivForSelect" width="102px">
                                <html:select property="digitGroupingSymbol.predefined" styleId="digitGroupingSymbolFieldPredefined"
                                    onchange="digitGroupingSymbolField.validateField(); onCustomFieldsChange();">
                                    <html:option value=","><bean:message key="general_settings.formats.comma"/></html:option>
                                    <html:option value=""><bean:message key="general_settings.formats.none"/></html:option>
                                    <html:option value=" "><bean:message key="general_settings.formats.space"/></html:option>
                                    <html:option value="<%=SystemSettings.CUSTOM_VALUE_STRING%>"><bean:message key="general_settings.formats.custom"/></html:option>
                                </html:select>
                            </div>
                        </td>
                        <td style="padding:0">
                            <span><html:text size="1" maxlength="1" style="display:none" property="digitGroupingSymbol.custom"
                                       styleId="digitGroupingSymbolFieldCustom" styleClass="customValue"
                                       onchange="digitGroupingSymbolField.validateField(); onCustomFieldsChange();"/></span>
                        </td>
                    </tr>
                    </table>
                </td>
            </tr>
            <% if(ef.isEnabled(URA) || ef.isEnabled(BRA)) { %>
            <tr>
                <td class="titleCell"><span class="formblocktitle" style="margin-top: 15px; margin-bottom: 3px;">
                    <%=message( request, "general_settings.configure_currency_sign" )%></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tr class="formfieldtitle">
                            <td class="formFieldSecondLevelCaption">
                                <span id="currencySignFieldLabel">
                                    <%=message( request, "general_settings.currency_sign" )%>:
                                </span>
                            </td>
                            <td>
                                <div class="markingDivForSelect">
                                    <html:select property="currencySign.predefined" styleId="currencySignFieldPredefined"
                                        onchange="hideCurrencyErrorsIfFieldValid(); currencySignField.validateField(); onCustomFieldsChange();">
                                        <html:option value="$" />
                                        <html:option value="US$" />
                                        <html:option value="CAD" />
                                        <html:option value="&euro;" />
                                        <html:option value="&pound;" />
                                        <html:option value="&yen;" />
                                        <html:option value="<%=SystemSettings.CUSTOM_VALUE_STRING%>"><bean:message key="general_settings.formats.custom"/></html:option>
                                    </html:select>
                                </div>
                            </td>
                            <td width="72" style="padding:0">
                                <span><html:text size="6" maxlength="6"  style="display:none" property="currencySign.custom"
                                           styleId="currencySignFieldCustom" styleClass="customValue"
                                           onchange="hideCurrencyErrorsIfFieldValid(); currencySignField.validateField(); onCustomFieldsChange();"/></span>
                            </td>
                        </tr>
                     </table>
                </td>
           </tr>
            <% } %>
            <tr>
                <td class="titleCell"><span class="formblocktitle blockTitleWithMargin"><bean:message key="general_settings.formats_section.format_of_csv_report"/></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin-top: 5px;">
                        <tr>
                            <td style="padding-left:0px; padding-bottom:6px;">
                                <table cellpadding="0" cellspacing="4" border="0">
                                    <tr>
                                        <td><html:checkbox property="enableCsvMultilanguage" value="true" styleId="csvMultilanguage_multilanguage" onclick="onEnableCsvMultilanguage()" style="margin-left: -4px;"/></td>
                                        <td class="formfieldtitle" style="padding-left:2px;"><label for="csvMultilanguage_multilanguage"><%=message( request, "general_settings.formats_section.use_utf_16_instead_of", Util.getEnvironmentEnconding() )%></label></td>
                                    </tr>
                                    <tr>
                                        <td>&nbsp;</td>
                                        <td valign="top">
                                            <div class="noteContainer">
                                                <at:img page="note_mark.gif" styleClass="noteImage"/>
                                                <span class="notemsg"><bean:message key="general_settings.formats_section.use_utf_16.note"/></span>
                                            </div>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td class="titleCell">
                                <span class="formfieldtitle"><bean:message key="general_settings.formats_section.field_separator_in_csv"/>:</span>
                                <html:select property="separator" disabled='<%=form.isEnableCsvMultilanguage()%>' styleId="separatorSelect">
                                    <html:option value='<%=""+CSVSeparatorUtil.COMMA_SEPARATOR%>'><bean:message key="general_settings.formats.comma"/></html:option>
                                    <html:option value='<%=""+CSVSeparatorUtil.SEMICOLON_SEPARATOR%>'><bean:message key="general_settings.formats.semicolon"/></html:option>
                                    <html:option value='<%=""+CSVSeparatorUtil.COLON_SEPARATOR%>'><bean:message key="general_settings.formats.colon"/></html:option>
                                    <html:option styleId="tab_separator_option" value='<%=""+CSVSeparatorUtil.TAB_SEPARATOR%>'><bean:message key="general_settings.formats.tab"/></html:option>
                                    <html:option value='<%=""+CSVSeparatorUtil.SLASH_SEPARATOR%>'><bean:message key="general_settings.formats.slash"/></html:option>
                                    <%-- A java expression is used to display the back slash symbol because of Resin peculiarity: it
                                                                             does not display this symbol in HTML --%>
                                    <html:option value='<%=""+CSVSeparatorUtil.BACK_SLASH_SEPARATOR%>'><%= "\\" %> <bean:message key="general_settings.formats.back_slash"/></html:option>
                                    <html:option value='<%=""+CSVSeparatorUtil.VERTICAL_BAR_SEPARATOR%>'><bean:message key="general_settings.formats.vertical_bar"/></html:option>
                                </html:select><br/>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td class="titleCell"><span class="formblocktitle blockTitleWithMargin" style="margin-bottom: 3px;"><%=message( request, "general_settings.default_time_format_title" )%></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table cellpadding="0" cellspacing="0" style="margin-top: 5px; margin-bottom: 13px;">
                        <tr>
                            <td class="text" valign="middle" style="width:138px;"><nobr><%=message( request, "general_settings.select_time_format" )%>:</nobr></td>
                            <td style="width:20px; height: 25px;">
                                <html:radio property="timeFormat" value="<%=String.valueOf(TimeFormat.TIME_FORMAT_HHMM)%>"
                                            styleId="timeFormat_hhmm" onclick="updateTimeFormatPreview()" />
                            </td>
                            <td style="width:78px;white-space:nowrap;">
                                <label for="timeFormat_hhmm"><nobr><%=message( request, "time_format_selector.time_format_hhmm" )%></nobr></label><br>
                            </td>
                            <td align="left" rowspan="2">
                                <jsp:include page="format_preview.jsp">
                                    <jsp:param name="previewId" value="timeFormatPreviewField"/>
                                    <jsp:param name="previewWidth" value="110"/>
                                    <jsp:param name="previewHeight" value="23"/>
                                </jsp:include>
                            </td>
                            <td align="left" rowspan="2" style="padding-left: 32px;">
                                <div class="noteContainer">
                                    <at:img page="note_mark.gif" styleClass="noteImage"/>
                                    <span id="timeFormat_note" class="notemsg"><%=message( request, "general_settings.edit.time_format_note",
                                                                                           settings.getDecimalSeparatorAsString() )%></span>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>&nbsp;</td>
                            <td style="width:20px; height: 25px;">
                                <html:radio property="timeFormat" value="<%=String.valueOf(TimeFormat.TIME_FORMAT_DECIMAL)%>"
                                            styleId="timeFormat_decimal" onclick="updateTimeFormatPreview()" />
                            </td>
                            <td>
                                <label for="timeFormat_decimal" id="timeFormat_decimal_label"><%=message( request, "time_format_selector.time_format_decimal",
                                                                                                          settings.getDecimalSeparatorAsString(), settings.getDecimalSeparatorAsString() )%></label><br>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>

    </div>
<%-- Access to users' information settings block --%>
<div class="collapsibleGroupHeaderBlock">
    <div class="showCollapsibleBlockButton" id="accessToUserInfoSettingsBlockButton"></div>
    <div class="collapsibleGroupHeader">
        <span class="settingsGroupTitle accessGroupTitle"><bean:message key="general_settings.access_to_user_info_section.label"/></span>
        <!--span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span-->
    </div>

</div>

<div class="collapsibleBlock" id="accessToUserInfoSettingsBlock">
    <table border="0" cellpadding="0" cellspacing="0">
        <tr>
            <td style="vertical-align: top;">
                <html:checkbox property="restrictTT" styleId="restrict_tt"/>
            </td>
            <td style="padding-top: 0px; padding-left:6px; line-height: 1.6;" colspan="2">
                <label for="restrict_tt">
                    <bean:message key="general_settings.tt_limitations_section.hide_reported_time_and_comments"/>
                </label>
                <span id="restrictTTNote">
                    <bean:message key="general_settings.tt_limitations_section.extended_access_rights"/>
                </span>
                <div id="restrictTTNoteTooltip" style="display: none;">
                    <ul>
                        <li><bean:message key="<%= AccessRight.SUBMIT_OTHER_USER_TIME_TRACK.getDescriptionKey( application )%>"/>
                        <li><bean:message key="<%= AccessRight.LOCK_TIME_TRACK.getDescriptionKey( application )%>"/></li>
                        <li><bean:message key="<%= AccessRight.GENERATE_TIME_REPORTS.getDescriptionKey( application )%>"/></li>
                        <% if(ef.isEnabled(URA) || ef.isEnabled(BRA)) {%>
                            <li><bean:message key="<%= AccessRight.GENERATE_MONEY_REPORTS.getDescriptionKey( application )%>"/></li>
                        <% } %>
                        <li><bean:message key="<%= AccessRight.MANAGE_TASKS.getDescriptionKey( application )%>"/></li>
                        <li><bean:message key="<%= AccessRight.MANAGE_USERS.getDescriptionKey( application )%>"/></li>
                    </ul>
                </div>
            </td>
        </tr>
        <% if (ef.isEnabled(Feature.PAS)) {%>
            <tr>
                <td style="vertical-align: top;">
                    <html:checkbox property="hideNotAssignedTTDetails" styleId="hide_not_assigned_tt"/>
                </td>
                <td style="padding-top: 0px; padding-left:6px; line-height: 1.6;" colspan="2">
                    <label for="hide_not_assigned_tt">
                        <bean:message key="general_settings.tt_limitations_section.hide_time_track_details"/>
                    </label>
                    <div align="left" style="padding-left: 22px; margin-top: 5px" class="noteContainer">
                        <at:img page="note_mark.gif" styleClass="noteImage"/>
                        <span id="hide_tt_note" class="notemsg">
                            <% if (ef.isEnabled(Feature.LTT)) { %>
                            <bean:message key="general_settings.tt_limitations_section.hide_tt_note"/>
                            <% } else { %>
                            <bean:message key="general_settings.tt_limitations_section.hide_tt_note.without_lock_tt"/>
                            <% } %>
                        </span>
                    </div>
                </td>
            </tr>
        <% } %>
        <tr>
            <td style="vertical-align: top;">
                <html:checkbox property="hideAccountSettingsWhenDisabled" styleId="hide_account_settings"/>
            </td>
            <td style="padding-top: 0px; padding-left:6px; line-height: 1.6;" colspan="2">
                <label for="hide_account_settings">
                    <bean:message key="general_settings.tt_limitations_section.hide_account_settings"/>
                </label>
            </td>
        </tr>
        <% if( ef.isEnabled(TTA) ) { %>
        <tr>
            <td style="vertical-align: top;">
                <html:checkbox property="ttmCanSeeAutoApproved" styleId="ttm_can_see_auto_approve"/>
            </td>
            <td style="padding-top: 0px; padding-left:6px; line-height: 1.6;" colspan="2">
                <label for="ttm_can_see_auto_approve">
                    <bean:message key="general_settings.ttm_can_see_auto_approved"/>
                </label>
            </td>
        </tr>
        <% } %>
    </table>
</div>


<%--Email Settings block (for downloadble) --%>

<div style="padding:0px; margin:0px; font-size:0px; line-height:0px;"><a name="emailConfiguration" id="emailConfigurationLink" ></a></div>

<% if(!isOnlineInstallation) { %>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="downloadableEmailSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle emailGroupTitle"><bean:message key="general_settings.email_section.label"/></span>
            <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        </div>

    </div>

    <div class="collapsibleBlock" id="downloadableEmailSettingsBlock">

        <table cellpadding="0" cellspacing="0" border="0" width="100%" class="collapsibleBlockContent">
            <tr>
                <td class="titleCell"><span class="formblocktitle" style="margin-top: 3px;"><bean:message key="general_settings.mail.outgoing_mail_server"/></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-spacing: 0 4px;">
                        <tr>
                            <td style="padding-top: 3px; padding-bottom: 3px;">
                                <html:text property="smtpHostName" styleId="smtpHostName" size="47" style="padding-bottom: 3px;" onchange="updateAddressFrom()" onkeyup="handleChange();"/>
                                <script>
                                    smtpHostNameController = createFieldController(
                                            "smtpHostName",
                                            messageResource.getMessage("general_settings.edit.smtp_host_name.placeholder")
                                    );
                                </script>
                            </td>
                            <td class="formfieldtitle" style="width:38px;">
                                <span style="padding-right:0; padding-left:10px" id="smtpPortFieldLabel"><bean:message key="general_settings.mail.port"/>:</span>
                            </td>
                            <td>
                                <html:text property="smtpPort"
                                           styleId="smtpPortId"
                                           onchange="checkPort();"
                                           size="1" maxlength="5"/>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3">
                                <table cellpadding="0" cellspacing="0">
                                    <tr>
                                        <td>
                                            <html:checkbox property="enableSMTPEncryption" styleId="enableSMTPEncryption" value="true" onclick="changeEnableSMTPEncryption(this)"/>
                                        </td>
                                        <td class="formfieldtitle" height="26">
                                            <label for="enableSMTPEncryption" id="enableSMTPEncryptionLable" ><bean:message key="general_settings.mail.use_encrypted_connection"/></label>
                                        </td>
                                        <td  id="smtpEncryptionParams" style='display: <%=form.isEnableSMTPEncryption() ? "" : "none"%>;'>
                                            <table cellpadding="0" cellspacing="0">
                                                <tr>
                                                    <td class="formfieldtitle"><bean:message key="general_settings.mail.type"/>:</td>
                                                    <td><html:select property="smtpEncryptionType"
                                                             styleId="smtpEncryptionType"
                                                             onchange="changeSMTPEncryptionType()"
                                                             style="margin-left: 10px;" >
                                                    <html:option value='<%=""+MailServerSettings.TLS_ENCRYPTION_TYPE%>'><bean:message key="general_settings.mail.tls"/></html:option>
                                                    <html:option value='<%=""+MailServerSettings.STARTTLS_ENCRYPTION_TYPE%>'><bean:message key="general_settings.mail.starttls"/></html:option>
                                                    <html:option value='<%=""+MailServerSettings.SSL_ENCRYPTION_TYPE%>'><bean:message key="general_settings.mail.ssl"/></html:option>
                                                 </html:select></td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3" >
                                <table cellspacing="0" cellpadding="0">
                                    <tr>
                                        <td><html:checkbox property="enableSMTPAuthentication" styleId="enableSMTPAuthentication" value="true" onclick="changeEnableSMTPAuthentication(this)"/></td>
                                        <td class="formfieldtitle"><label for="enableSMTPAuthentication" id="enableSMTPAuthenticationLable"><bean:message key="general_settings.mail.outgoing_server_requires_authentication"/></label></td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                        <tr id="smtpAuthenticationParams" <%= form.isEnableSMTPAuthentication() ? "" : "style='display: none;'"%> >
                            <td style="padding-left: 28px;" colspan="3" class="formfieldtitle"><div style="position: relative;">
                                <span id="loginInfoLabel" ><bean:message key="general_settings.mail.login_info"/>:</span>
                                <html:text property="smtpUsername" styleId="smtpUsername"
                                           onblur="checkSMTPAuthenticationParams()" />&nbsp;<%
                                    if( form.isEnableSMTPAuthentication() ) {
                                        %><a id="changeSMTPPasswordLink" href="javascript: void(0);" onclick="storeSavedSMTPPasswordAndShowInput(this)"><bean:message key="general_settings.mail.change_password"/></a><%
                                    } %>
                                <div style="position: relative; display: inline-block;">
                                <html:password onfocus="smtpPasswordLabelController.setDisplay(false);" onblur="checkSMTPAuthenticationParams()" property="smtpPassword"
                                               styleId="smtpPassword" style='<%=form.isEnableSMTPAuthentication() ? "display: none;" : ""%>' />
                                <label style='<%= form.isEnableSMTPAuthentication() ? "display: none;" : ""%>' for="smtpPassword" id="smtpPasswordLabel" >
                                    <%= form.isEnableSMTPAuthentication() ? message( request, "general_settings.edit.new_password.placeholder") : message( request, "general_settings.edit.password.placeholder")%>
                                </label>
                                </div></div>

                                <html:hidden property="smtpUsernameEncoded" styleId="smtpUsernameEncoded" />
                                <html:hidden property="smtpPasswordEncoded" styleId="smtpPasswordEncoded" />
                                <script type="text/javascript">
                                    smtpUsernameController = new SecureFieldController();
                                    smtpUsernameController.emptyCaption = messageResource.getMessage("general_settings.edit.username.placeholder");
                                    smtpUsernameController.init("smtpUsername");
                                    smtpUsernameController.setDefaultValueIfNeeded();

                                    smtpPasswordController = new SecureFieldController();
                                    smtpPasswordController.emptyCaption = "";
                                    smtpPasswordController.init("smtpPassword");
                                    smtpPasswordController.setDefaultValueIfNeeded();

                                    smtpPasswordLabelController = new LabelController();
                                    smtpPasswordLabelController.init("smtpPasswordLabel");

                                    smtpUsernameEncodedController = new FieldController();
                                    smtpUsernameEncodedController.init("smtpUsernameEncoded");
                                    smtpPasswordEncodedController = new FieldController();
                                    smtpPasswordEncodedController.init("smtpPasswordEncoded");
                                </script>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td class="titleCell"><span class="formblocktitle blockTitleWithMargin" ><bean:message key="general_settings.mail.message_parameters"/></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="4" cellspacing="0" width="100%">
                        <tr>
                            <td width="210px" nowrap="true" class="formfieldtitle">
                                <span id="mailAddressFromFieldLabel" <logic:messagesPresent property="mailAddressFrom"> class ="errormsg"</logic:messagesPresent>><bean:message key="general_settings.mail.from_address"/>:</span>
                            </td>
                            <td colspan="2">
                                <html:text property="mailAddressFrom" styleId="mailAddressFrom" size="47" onchange="checkAddressFrom();" onkeyup="handleChange();"/>
                                <script>
                                    if(navigator.appVersion && navigator.appVersion.indexOf('MSIE') > -1){
                                        form().mailAddressFrom.size=68;
                                    }
                                    mailAddressFromController = new FieldController();
                                    mailAddressFromController.emptyCaption = messageResource.getMessage("general_settings.edit.mail_address_from.placeholder");
                                    mailAddressFromController.init("mailAddressFrom");
                                    mailAddressFromController.setDefaultValueIfNeeded();
                                    <logic:messagesPresent property="mailAddressFrom">
                                        ClientSideErrors.paintElementAsInvalid(form().mailAddressFrom,
                                                messageResource.getMessage("general_settings.edit.address_from_wrong"));
                                        ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("mailAddressFromFieldLabel"),
                                                messageResource.getMessage("general_settings.edit.address_from_wrong"));
                                        setModificationsHandler(form().mailAddressFrom);
                                    </logic:messagesPresent>
                                </script>
                            </td>
                        </tr>
                        <tr>
                            <td width="210px" nowrap="true" style="padding-top:4px;" class="formfieldtitle">
                                <span id="urlOfActitimeInstallationFieldLabel" style="white-space: nowrap;"><bean:message key="general_settings.mail.url_of_installation"/>:</span>
                            </td>
                            <td colspan="2" style="padding-top:4px;">
                                <html:text property="urlOfActitimeInstallation" styleId="urlOfActitimeInstallation" size="47" onchange="checkUrlOfActitimeInstallation();"/>
                                <script>
                                    if(navigator.appVersion && navigator.appVersion.indexOf('MSIE') > -1){
                                        form().urlOfActitimeInstallation.size=68;
                                    }
                                    urlOfActitimeInstallationController = new FieldController();
                                    urlOfActitimeInstallationController.initField("urlOfActitimeInstallation", false);
                                </script>
                            </td>
                        </tr>
                        <% if (request.getAttribute(Keys.GENERAL_SETTINGS_ACTUAL_AT_INSTALLATION_URL) != null) {%>
                            <tr>
                                <td>
                                    &nbsp;
                                </td>
                                <td class="wrongInstallationUrl_warning" colspan="2">
                                    <div class="warningmsg">
                                        <bean:message key="general_settings.mail.url_of_installation_reminder"/>
                                    </div>
                                    <div class="actualInstallationUrl warningmsg">
                                        <span> <%= request.getAttribute( Keys.GENERAL_SETTINGS_ACTUAL_AT_INSTALLATION_URL )%> </span>
                                    </div>
                                    <div class="warningmsg" style="margin-top: 8px; margin-bottom: 8px">
                                        <bean:message key="general_settings.mail.url_of_installation_click_to_copy_message"/>
                                    </div>
                                </td>

                            </tr>
                        <% } %>
                        <tr>
                            <td>
                                &nbsp;
                            </td>
                            <td class="installationUrlInfo <% if (request.getAttribute(Keys.GENERAL_SETTINGS_ACTUAL_AT_INSTALLATION_URL) != null) {%> topBorder <% } %>">
                                <div class="noteContainer" style="margin-left: 2px; margin-right: 3px;">
                                    <span id="urlOfActitimeInstallation_note" class="notemsg"><%=message( request, "general_settings.edit.mail.actitime_url.note" )%></span>
                                </div>
                            </td>
                            <td></td>
                        </tr>
                        <%--
                            'Send Test Message' button section
                        --%>
                        <tr>
                            <td colspan="4" style="padding:9px 2px 8px 3px">
                                <div style='border-top: 1px solid <%=ColorHelper.getColor("general_settings.email_notifications.separator", request )%>;width:702px; height: 4px;'><at:img page="pixel.gif" width="702px" height="1px"/></div>
                            </td>
                        </tr>
                        <jsp:include page="settings_test_message_button_row.jsp" />
                        <tr>
                            <td colspan="4" style="padding:4px 2px 8px 3px">
                                <div style='border-top: 1px solid <%=ColorHelper.getColor("general_settings.email_notifications.separator", request )%>;width:702px;'><at:img page="pixel.gif" width="702px" height="1px"/></div>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td class="titleCell"><span class="formblocktitle"><bean:message key="general_settings.mail.error_processing"/></span></td>
            </tr>
            <%--
                'Administrator Emal Address' section
            --%>
            <jsp:include page="settings_admin_email_address_row.jsp" />
        </table>

    </div>

<% } %>

<%-- Notifications block --%>
<% if(  isEmailNotificationsAvailable  ) { %>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="notificationsSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle notificationsGroupTitle"><bean:message key="general_settings.notifications_section.label"/></span>
        </div>
    </div>

    <div class="collapsibleBlock" id="notificationsSettingsBlock">

        <table cellpadding="0" cellspacing="0" border="0" width="100%" class="collapsibleBlockContent">
            <tr>
                <td class="titleCell"><span class="formblocktitle" style="margin-top: 5px;"><bean:message key="general_settings.mail.message_parameters"/></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="2" cellspacing="0" width="100%" style="border-spacing: 0 3px;">
                        <tr style="padding-top:2px;">
                            <td width="247px" nowrap="true" valign="middle" style="padding-top:4px;" class="formfieldtitle">
                                <span style="padding-right: 4px;"><bean:message key="general_settings.mail.prefix_to_notification_subject"/>:</span>
                            </td>
                            <td valign="middle" style="padding-top:4px;">
                                <html:text property="mailSubjectPrefix" onblur="handleMailSubjectChanges(this)" size="17" maxlength="100"/>
                            </td>
                            <td style="padding-top:4px;">
                            </td>
                        </tr>
                        <tr>
                            <td width="247px" nowrap="true" class="formfieldtitle" style="height: 20px; vertical-align: bottom;">
                                <span id="mailMessageFooterFieldLabel"><bean:message key="general_settings.mail.standart_message_footer"/>:</span>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="3" style="height: 89px; vertical-align: top;">
                                <html:textarea property="mailMessageFooter" style="overflow:auto;font-family: Arial, sans-serif; font-weight: normal;font-size: 12px;width: 702px; height: 75px" styleId="mailMessageFooter" onkeyup="handleFooterChanges()" onblur="handleFooterChanges()"/>
                                <script>
                                    mailMessageFooterController = new FieldController();
                                    mailMessageFooterController.emptyCaption = messageResource.getMessage("general_settings.edit.mail_message_footer.placeholder");
                                    mailMessageFooterController.init("mailMessageFooter");
                                </script>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2"><jsp:include page="/textarea_length_note.jsp">
                                <jsp:param name="note_id" value="<%=mailNotificationFooterNoteId%>"/>
                                <jsp:param name="note_name" value="<%=mailNotificationFooterNoteName%>"/>
                                <jsp:param name="use_coloured_img" value="true"/>
                            </jsp:include></td>
                        </tr>
                        <% if( isOnlineInstallation ) { %>
                        <%--
                            'Send Test Message' button section
                        --%>
                            <tr>
                                <td colspan="4" style="padding:9px 2px 8px 3px">
                                    <div style='border-top: 1px solid <%=ColorHelper.getColor("general_settings.email_notifications.separator", request )%>;width:702px; height: 4px;'><at:img page="pixel.gif" width="702px" height="1px"/></div>
                                </td>
                            </tr>
                            <jsp:include page="settings_test_message_button_row.jsp" />
                            <tr>
                                <td colspan="4" style="padding:4px 2px 8px 3px">
                                    <div style='border-top: 1px solid <%=ColorHelper.getColor("general_settings.email_notifications.separator", request )%>;width:702px;'><at:img page="pixel.gif" width="702px" height="1px"/></div>
                                </td>
                            </tr>
                        <% } %>
                    </table>
                </td>
            </tr>
            <tr>
                <td class="titleCell"><span class="formblocktitle blockTitleWithMargin"><bean:message key="general_settings.mail.notification_scheduling"/></span></td>
            </tr>
            <tr>
                <td class="contentCell">
                    <table border="0" cellpadding="0" cellspacing="0" width="100%" style="border-spacing: 0 3px;">
                        <tr>
                            <td valign="middle" style="padding-left:0;width:162px" nowrap="true" class="formfieldtitle">
                                <span style="padding-right: 5px; white-space:nowrap;" id="dayTimeToSendNotificationAtFieldLabel"><bean:message key="general_settings.mail.time_to_send_notifications_at"/>:</span>
                            </td>
                            <td valign="middle" style="padding-right: 5px;">
                               <html:text property="dayTimeToSendNotificationAt"
                                           styleId="dayTimeToSendNotificationAtId"
                                           onchange="checkDayTimeToSendNotificationAt();"
                                           size="5" maxlength="8"/>
                            </td>
                            <td valign="middle">
                                <div class="noteContainer" style="line-height:16px; margin-left: 5px;">
                                    <at:img page="note_mark.gif" styleClass="noteImage"/>
                                    <span id="mailMessageSchedulingTime_note" class="notemsg"><%=message( request, "general_settings.edit.mail.message_scheduling_time.note" )%></span>
                                </div>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>

    </div>

<% } %>

<%--Email Settings block (for online) --%>
<% if(isOnlineInstallation) { %>

    <div class="collapsibleGroupHeaderBlock">
        <div class="showCollapsibleBlockButton" id="emailSettingsBlockButton"></div>
        <div class="collapsibleGroupHeader">
            <span class="settingsGroupTitle emailGroupTitle"><bean:message key="general_settings.email_section.label"/></span>
            <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        </div>
    </div>

    <div class="collapsibleBlock" id="emailSettingsBlock">

        <table cellpadding="0" cellspacing="0" border="0" width="100%" class="collapsibleBlockContent">
            <tr>
                <td class="titleCell"><span class="formblocktitle"><bean:message key="general_settings.mail.error_processing"/></span></td>
            </tr>
            <%--
                'Administrator Emal Address' section
            --%>
            <jsp:include page="settings_admin_email_address_row.jsp" />
        </table>

    </div>

<% } %>


    <div class="formbuttonpane" id="ButtonPane">
        <input type="button" class="saveButton" id="saveSettingsButton" onclick="doSubmit()" value="<bean:message key="general_settings.save_settings"/>">
    </div>


            </td>
        </tr>
    </table>
<input type="hidden" value="1" name="submitted">
</html:form>
<jsp:include page="/form_changed_confirm.jsp"/>
</div>

<p>&nbsp;</p>
</body>
</html>
