<!doctype html>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="com.actimind.actitime.administration.user.*" %>
<%@ page import="static com.actimind.actitime.Navigator.USERS_KEY" %>
<%@ page import="static com.actimind.actitime.Navigator.USERS_SUBMENU_KEY" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.common.licensing.LicenseUserCounters" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>
<%@ page import="com.actimind.actitime.services.UserManagementService" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="com.actimind.common.util.TimeZoneGroupUtil" %>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean" %>
<%@ page import="com.actimind.actitime.*" %>
<%@ page import="com.actimind.common.licensing.LicenseHelper" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%
    Features features = FeaturesUtil.getFeatures();
    boolean isPASEnabled = features.isEnabled( Feature.PAS );
    boolean isTTAEnabled = features.isEnabled( Feature.TTA );
    boolean isPTOEnabled = features.isEnabled( Feature.PTO );
    boolean isSickEnabled = features.isEnabled( Feature.SDB );
    boolean isUGREnabled = features.isEnabled( Feature.UGR );
    boolean isTZGEnabled = features.isEnabled( Feature.TZG );
    boolean canManageAccounts = UserAccessRightsBean.getUserRights(request).hasRight(AccessRight.MANAGE_USERS);
    String TTADisabledSuffix = isTTAEnabled ? "" : ".TTADisabled";

    Boolean userGroupsSynchronized = (Boolean) request.getAttribute(Keys.GROUPS_SYNCHRONIZED);
    boolean tzGroupsSynchronized = LicenseHelper.isOtherProductIntegrated(Product.actiTIME);
%>
<html>
<head>
    <%@include file="/css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>
    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="userlist.title"/> </title>

    <script>
        var UserManagementConstants ={};
        UserManagementConstants.OVERTIME_AUTO = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_AUTO )%>;
        UserManagementConstants.OVERTIME_MANUAL = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_MANUAL )%>;
        UserManagementConstants.OVERTIME_AUTO_HIDDEN = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_AUTO_HIDDEN )%>;
        UserManagementConstants.OVERTIME_OFF = <%=String.valueOf( BasicUserInfoWithOvertime.OVERTIME_OFF )%>;

        UserManagementConstants.USER_LIST_ORDER_BY_NAME = <%=UserListOrder.BY_NAME%>;
        UserManagementConstants.USER_LIST_ORDER_BY_GROUP_NAME = <%=UserListOrder.BY_GROUP_NAME%>;
        UserManagementConstants.USER_LIST_ORDER_BY_TIME_ZONE_GROUP_NAME = <%=UserListOrder.BY_TIME_ZONE_GROUP_NAME%>;
        UserManagementConstants.USER_LIST_ORDER_BY_PTO_BALANCE = <%=UserListOrder.BY_PTO_BALANCE%>;
        UserManagementConstants.USER_LIST_ORDER_BY_APPROVED_PTO = <%=UserListOrder.BY_APPROVED_PTO%>;
        UserManagementConstants.USER_LIST_ORDER_BY_PTO_CONTROL_STATUS = <%=UserListOrder.BY_PTO_STATUS%>;

        UserManagementConstants.USER_LIST_ORDER_BY_SICK_BALANCE = <%=UserListOrder.BY_SICK_DAYS_BALANCE%>;
        UserManagementConstants.USER_LIST_ORDER_BY_APPROVED_SICK = <%=UserListOrder.BY_APPROVED_SICK_DAYS%>;
        UserManagementConstants.USER_LIST_ORDER_BY_SICK_CONTROL_STATUS = <%=UserListOrder.BY_SICK_DAYS_STATUS%>;

        UserManagementConstants.UGRFeature = '<%=Feature.UGR.name()%>';
        UserManagementConstants.OvertimeFeature = '<%=Feature.OVR.name()%>';
        UserManagementConstants.PTOFeature = '<%=Feature.PTO.name()%>';
        UserManagementConstants.SDBFeature = '<%=Feature.SDB.name()%>';
        UserManagementConstants.URAFeature = '<%=Feature.URA.name()%>';
        UserManagementConstants.BRAFeature = '<%=Feature.BRA.name()%>';
        UserManagementConstants.TTCFeature = '<%=Feature.TTC.name()%>';
        UserManagementConstants.ESTFeature = '<%=Feature.EST.name()%>';
        UserManagementConstants.OVRFeature = '<%=Feature.OVR.name()%>';
        UserManagementConstants.CLTFeature = '<%=Feature.CLT.name()%>';
        UserManagementConstants.LVTFeature = '<%=Feature.LVT.name()%>';
        UserManagementConstants.BTYFeature = '<%=Feature.BTY.name()%>';
        UserManagementConstants.PASFeature = '<%=Feature.PAS.name()%>';
        UserManagementConstants.TTAFeature = '<%=Feature.TTA.name()%>';
        UserManagementConstants.TZGFeature = '<%=Feature.TZG.name()%>';
        UserManagementConstants.LTTFeature = '<%=Feature.LTT.name()%>';
        UserManagementConstants.LICENSE_UNLIM = '<%=LicenseUserCounters.UNLIMITED_VAL%>';
        UserManagementConstants.MIN_RECORDS_PER_PAGE = '<%=Pager.CUSTOM_PAGES_SET_2[0]%>';
        UserManagementConstants.USER_WITHOUT_GROUP = <%=Constants.USERS_WITHOUT_GROUP_ID%>;

        UserManagementConstants.TASK_HIERARCHY_NO_PERMISSION = <%=UserManagementService.TASK_HIERARCY_NO_PERMISSION%>;
        UserManagementConstants.TASK_HIERARCHY_TASKS_PERMISSION = <%=UserManagementService.TASK_HIERARCY_TASKS_PERMISSION%>;
        UserManagementConstants.TASK_HIERARCHY_CP_PERMISSION = <%=UserManagementService.TASK_HIERARCY_CP_PERMISSION%>;

        UserManagementConstants.TASK_HIERARCHY_FILTER_ALL_STAFF = '<%=TaskHierarchyFilter.ALL%>';
        UserManagementConstants.TASK_HIERARCHY_FILTER_CAN_MANAGE_CUSTOMERS_PROJECTS = '<%=TaskHierarchyFilter.CAN_MANAGE_CUSTOMERS_AND_PROJECTS%>';
        UserManagementConstants.TASK_HIERARCHY_FILTER_HAS_ACCESS_TO_ALL_PROJECTS = '<%=TaskHierarchyFilter.HAS_ACCESS_TO_ALL_PROJECTS%>';
        UserManagementConstants.TASK_HIERARCHY_FILTER_HAS_NO_PROJECT_ASSIGNED = '<%=TaskHierarchyFilter.HAS_NO_PROJECT_ASSIGNED%>';

        UserManagementConstants.TIME_TRACK_APPROVAL_FILTER_ALL_STAFF = '<%=TimeTrackApprovalFilter.ALL%>';
        UserManagementConstants.TIME_TRACK_APPROVAL_FILTER_APPROVERS_ONLY = '<%=TimeTrackApprovalFilter.APPROVERS_ONLY%>';
        UserManagementConstants.TIME_TRACK_APPROVAL_FILTER_APPROVERS_WITHOUT_USERS = '<%=TimeTrackApprovalFilter.APPROVERS_WITHOUT_USERS%>';
        UserManagementConstants.TIME_TRACK_APPROVAL_FILTER_USERS_WITH_AUTOAPPROVED = '<%=TimeTrackApprovalFilter.USERS_WITH_AUTOAPPROVED%>';
        UserManagementConstants.TIME_TRACK_APPROVAL_FILTER_USERS_WITHOUT_APPROVERS = '<%=TimeTrackApprovalFilter.USERS_WITHOUT_APPROVERS%>';

        UserManagementConstants.LEAVE_BALANCES_MANAGER_FILTER_ALL = '<%=LeaveBalancesManagerFilter.ALL%>';
        UserManagementConstants.LEAVE_BALANCES_MANAGER_FILTER_LEAVE_BALANCES_MANAGERS_ONLY = '<%=LeaveBalancesManagerFilter.LEAVE_BALANCES_MANAGERS_ONLY%>';

        UserManagementConstants.ACCOUNT_SETTINGS_TAB_NUM = 1;
        UserManagementConstants.PTO_SETTINGS_TAB_NUM = 2;
        UserManagementConstants.SICK_DAYS_SETTINGS_TAB_NUM = 3;

        UserManagementConstants.RESULT_CODE_SUCCESS ='<%=UserManagementService.UserManagementResult.RESULT_CODE_SUCCESS%>';
        UserManagementConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_LICENSE_TERMS = '<%=UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_DUE_TO_LICENSE_TERMS%>';
        UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_LICENSE_TERMS = '<%=UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_LICENSE_TERMS%>';
        UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_LICENSE_TERMS = '<%=UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_LICENSE_TERMS%>';
        UserManagementConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_FUTURE_HIRE_DATE = '<%=UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_DUE_TO_FUTURE_HIRE_DATE%>';
        UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_FUTURE_HIRE_DATE = '<%=UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_FUTURE_HIRE_DATE%>';
        UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_FUTURE_HIRE_DATE = '<%=UserManagementService.UserManagementResult.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_FUTURE_HIRE_DATE%>';
        UserManagementConstants.WARNING_NO_RIGHT_TO_EDIT_STATUS_IN_OTHER_PRODUCT = '<%=UserManagementService.UserManagementResult.WARNING_NO_RIGHT_TO_EDIT_STATUS_IN_OTHER_PRODUCT%>';
        UserManagementConstants.WARNING_MANAGE_BALANCE_RIGHT_REVOKED = '<%=UserManagementService.UserManagementResult.WARNING_MANAGE_PTO_AND_SICK_RIGHT_REVOKED%>';
        UserManagementConstants.WARNING_MANAGE_ACCOUNT_SETTINGS_RIGHT_REVOKED = '<%=UserManagementService.UserManagementResult.WARNING_MANAGE_ACCOUNT_SETTINGS_RIGHT_REVOKED%>';
        UserManagementConstants.WARNING_USER_GROUP_NO_LONGER_EXISTS = '<%=UserManagementService.UserManagementResult.WARNING_USER_GROUP_NO_LONGER_EXISTS%>';
        UserManagementConstants.WARNING_TIME_ZONE_GROUP_NO_LONGER_EXISTS = '<%=UserManagementService.UserManagementResult.WARNING_TIME_ZONE_GROUP_NO_LONGER_EXISTS%>';
        UserManagementConstants.WARNING_PTO_FEATURE_DISABLED = '<%=UserManagementService.UserManagementResult.WARNING_PTO_FEATURE_DISABLED%>';
        UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_ACCOUNT_SETTINGS = '<%=UserManagementService.UserManagementResult.ERROR_NO_RIGHTS_TO_MANAGE_ACCOUNT_SETTINGS%>';
        UserManagementConstants.ERROR_DUPLICATE_USERNAME ='<%=UserManagementService.UserManagementResult.ERROR_DUPLICATE_USERNAME%>';
        UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_PTO_AND_SICK = '<%=UserManagementService.UserManagementResult.ERROR_NO_RIGHTS_TO_MANAGE_PTO_AND_SICK%>';
        UserManagementConstants.ERROR_PTO_FEATURE_DISABLED = '<%=UserManagementService.UserManagementResult.ERROR_PTO_FEATURE_DISABLED%>';
        UserManagementConstants.ERROR_PTO_CONTROL_DISABLED = '<%=UserManagementService.UserManagementResult.ERROR_PTO_CONTROL_DISABLED%>';
        UserManagementConstants.ERROR_SICK_CONTROL_DISABLED = '<%=UserManagementService.UserManagementResult.ERROR_SICK_CONTROL_DISABLED%>';
        UserManagementConstants.ERROR_NO_SUCH_USER = '<%=UserManagementService.UserManagementResult.ERROR_NO_SUCH_USER%>';
        UserManagementConstants.ERROR_CANT_DELETE = '<%=UserManagementService.UserManagementResult.ERROR_CANT_DELETE%>';
        UserManagementConstants.ERROR_BALANCE_CAP_EXCEEDED = '<%=UserManagementService.UserManagementResult.ERROR_BALANCE_CAP_EXCEEDED%>';

        UserManagementConstants.ERROR_USER_EMAIL_IS_INVALID = '<%=UserManagementService.UserManagementResult.ERROR_EMAIL_INVALID%>';

        UserManagementConstants.ERROR_CANNOT_DISABLE_LAST_USER_MANAGER_IN_OTHER_PRODUCT = '<%=UserManagementService.UserManagementResult.ERROR_CANNOT_DISABLE_LAST_USER_MANAGER_IN_OTHER_PRODUCT%>';

        UserManagementConstants.USER_GROUP_NOT_ASSIGNED_ID = <%=Constants.USERS_WITHOUT_GROUP_ID%>;
        UserManagementConstants.DEFAULT_TIME_ZONE_GROUP_ID = <%=Constants.DEFAULT_TIME_ZONE_GROUP_ID%>;

        UserManagementConstants.UM_RESULT_CODE_DUPLICATE_USERNAME = <%=UserManagementService.UserManagementResult.ERROR_DUPLICATE_USERNAME%>;


        UserManagementConstants.REPORT_TO_REPORT_NAME_MAP = {
            STAFF_PERFORMANCE :    '<%=   message( request, "report.staffoutput.staff_report" )  %>',
            TIME_TRACK_IN_DETAIL : '<%=   message( request, "reports.comments_report.title")     %>',
            ESTIMATED_VS_ACTUAL :  '<%=    message( request, "report.budgeted_vs_actual.title" ) %>',
            OVERTIME:              '<%=    message( request, ReportType.OVERTIME.getFullNameKey(request))          %>',
            LEAVE_TIME :           '<%=    message( request, ReportType.LEAVE_TIME.getFullNameKey( request ))%>',
            COST_OF_WORK :         '<%=       message( request, "report.cost.title")             %>',
            BILLING_SUMMARY :      '<%=        message( request, "report.billing_summary.title") %>',
            PROFIT_LOSS :          '<%=       message( request,  "report.profit_loss.title" )    %>',
            INVOICING :            '<%=       message( request, "report.invoice.title")          %>'
        };
    </script>
    <!--[if IE 8]>
    <style type="text/css">
        .filterBySelectorTableHeaderButton{
            width:130px;
            overflow: hidden;
            text-overflow: ellipsis;
        }

        .userListHead .userName .filterBySelectorTableHeaderButton .dropdown-button.at-selector-button.x-btn td.middle-left-cell.contents span {
            max-width: 108px ! important;
        }
        .tzgDisabled .filterBySelectorTableHeaderButton {
            width: 190px;
        }
        .tzgDisabled .userListHead .userName .filterBySelectorTableHeaderButton .dropdown-button.at-selector-button.x-btn td.middle-left-cell.contents span {
            max-width: 165px !important;
        }

        .userListHead .userName {
            width: 370px !important;
        }
    </style>
    <![endif]-->

</head>

<body id="usersManagementBodyTagId" class="userList with-navigation">

<div id="container">

    <bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
    <bean:define id="license" name="<%=Keys.LICENSE_CONTERS%>"  type="com.actimind.common.licensing.LicenseUserCounters" />

    <%-- MAIN FILES TO SHOW BASIC PAGE--%>

    <jsp:include page="../../top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=USERS_KEY%>" />
        <jsp:param name="submenuSelected" value="<%=USERS_SUBMENU_KEY%>" />
    </jsp:include>
    <%@ include file="/js/description_util_entities_init_js.jsp"%>

    <jsp:include page="/form_changed_confirm.jsp"/>
    <%-- END MAIN FILES TO SHOW BASIC PAGE--%>

    <%-- GENERAL JSP --%>
    <jsp:include page="/js/description_util_entities_init_js.jsp"/>
    <%-- GENERAL JSP --%>

    <%-- GENERAL JS --%>
    <jsp:include page="groupManagement_files.jsp"/>
    <at:script page="/js/administration/userlist_util.js"/>
    <at:script page='/js/md5.js'/>
    <%@include file="/js/util/server_date_time_utils_js.jsp"%>
    <%-- /GENERAL JS --%>

    <%-- required for tree_selector_dialog --%>
    <at:script page="/js/util/jquery_customization.js"/>

    <%-- need for customer_project_selector_dialog.js and for users_for_approver_dialog.js --%>
    <at:script page="/js/controls/tree_selector_dialog.js"/>

    <%--cp_selector START--%>

    <at:script page="/cp_selector/at_customer_project_selector_only_projects_panel.js"/>
    <at:script page="/cp_selector/at_cpselector_only_projects_panel_for_dialog.js"/>

    <at:script page="/js/controls/selectorControls/customer_project_selector_dialog.js"/>
    <jsp:include page="/cp_selector/cp_selector_server_util_js.jsp">
        <jsp:param name="formName" value="UserListForm"/>
        <jsp:param name="scope" value="request"/>
    </jsp:include>
    <%--cp_selector END--%>

    <%-- CUSTOM JS FOR THIS PAGE --%>
    <jsp:include page="/administration/UserListConfirmationConstants.jsp"/>
    <jsp:include page="userManagement_JS_files.jsp"/>

    <at:script page="/js/InvitationDialog.js"/>

    <at:script page="/js/administration/userManagement/ratesEditor/FloatNumberValidator.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/LeaveRatesEditorComponent.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/LeaveRatesEditorItem.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/LeaveRatesMenu.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/LeaveRatesEditor.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/RatesTable.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/RatesTableRow.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/RateCellRenderer.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/RateCellValidator.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/LeaveRatesCellRenderer.js"/>
    <at:script page="/js/administration/userManagement/ratesEditor/LeaveRatesCellValidator.js"/>
    <at:script page="/js/administration/userManagement/UserRatesSection.js"/>

    <%-- END MAIN FILES TO SHOW BASIC PAGE--%>
    <%-- These files depend on dhtml_popup_with_moire.js, which is included in top.jsp --%>
    <at:script page="/js/administration/userManagement/UserDataLightBox.js"/>
    <at:script page="/js/administration/userManagement/CreateUserLightBox.js"/>
    <at:script page="/js/administration/userManagement/InviteSeveralUsersLightBox.js"/>
    <at:script page="/js/administration/userManagement/ATInviteSeveralUsersLightBox.js"/>
    <at:script page="/js/administration/userManagement/EditUserLightBox.js"/>
    <at:script page="/js/administration/userManagement/LeaveBalanceEditor.js"/>

    <%-- CopyUserSettingsSelector files --%>
    <at:script page='/js/administration/userManagement/CopyUserSettingsSelector.js'/>

    <at:script page="/js/BalanceHistoryPanel.js"/>

    <at:script page="/js/hierarchySelector/approversSelector/OneLevelTreeNodesHierarchyMaker.js"/>

    <at:script page="/js/hierarchySelector/userSelector/usersForApproverSelector/user_for_approver_node_renderer.js" />
    <at:script page="/js/usersSelector/users_for_approver_selector_panel.js"/>
    <at:script page="/js/usersSelector/at_users_for_tt_approver_selector_panel.js"/>
    <at:script page="/js/usersSelector/at_users_for_tt_manager_selector_panel.js"/>
    <at:script page="/js/controls/users_for_approver_dialog.js"/>
    <at:script page="/js/controls/selectorControls/UsersForTTApproverDialog.js"/>
    <at:script page="/js/controls/approvers_dialog.js"/>
    <at:script page="/js/controls/assignments_tooltip.js"/>
    <at:script page="/js/controls/manage_rights_tooltip.js"/>
    <at:script page="/js/controls/assign_users_to_tta_tooltip.js"/>
    <at:script page="/js/controls/task_hierarchy_tooltip.js"/>
    <at:script page="/js/controls/ApproversTooltip.js"/>

    <at:script page="/js/administration/userManagement/userList/BaseFilter.js"/>
    <at:script page="/js/administration/userManagement/userList/TaskHierarchyFilter.js"/>
    <at:script page="/js/administration/userManagement/userList/TimeTrackApprovalFilter.js"/>
    <at:script page="/js/administration/userManagement/userList/LeaveBalancesManagerFilter.js"/>


    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

    <%-- PAGE BODY --%>
        <table id="pageBody" class='<%="usersManagement pageBody"%>'>

            <tr>
                <td>
                    <div class="pagetitle"><span><bean:message key="userlist.pagebody.mainHeader"/></span><div id="spinnerPlaceholderId"></div></div>
                </td>
                <td class="pagetitle">
                    <div class="msgBlock">
                        <%@ include file="/messages.jsp" %>
                    </div>
                </td>
                <td class="licenseInfo" style="display: none;">
                    <% if (canManageAccounts) { %>
                        <span id="licenseCountId" class="licenseCount"></span>
                    <% } %>
                </td>
            </tr>
            <tr id="pageHeader">
                <td class="section ">
                    <div id="userListTabs"></div>
                </td>

                <td class="manageSection section" colspan="2">
                    <div id="createUserDiv"><!--Place for rendering "Create user" button--></div>
                    <% if (isUGREnabled && canManageAccounts) { %>
                        <span id="manageDepartmentsToAddUserButtonSeparator"></span>
                        <a id="editDepartmentsLink">
                            <bean:message  key="userlist.manage_user_groups"/>
                        </a>
                        <at:img page="userManagement/userList/manage-departments.png" styleId="editDepartmentImgId"/>
                    <% } %>
                    <% if (isTZGEnabled && canManageAccounts) { %>
                        <span id="manageTimeZoneGroupsToManageDepartmentsSeparator"></span>
                        <a id="editTimeZoneGroupsLink">
                            <bean:message key="userlist.manage_time_zone_groups"/>
                        </a>
                        <at:img page="userManagement/userList/manage-time-zone.png" styleId="editTimeZoneGroupImgId"/>
                    <% } %>
                </td>
            </tr>

            <tr>
                   <td id="userListFromHeaderToTableContentSpacer"></td>
            </tr>

            <tr>
                <td colspan="3">

                    <span id="userListTableContainer"></span>
                    <span id="noUsersToShowId"></span>

                    <table id="userListFooterId" class="userListFooter">
                        <tr>
                            <td class="usersPerPage">

                                <table>
                                    <tr>
                                        <td class="showCaption">
                                            <bean:message key="userlist.table.show"/>
                                        </td>

                                        <td class="selector" >

                                            <select name="recordsPerPage" id="recordsPerPageSelector">
                                                <% for( int i : Pager.CUSTOM_PAGES_SET_2 ) { %>
                                                    <option value="<%=i%>"><%=i%></option>
                                                <% } %>
                                            </select>

                                        </td>

                                        <td class="userPerPageCaption">
                                            <bean:message key="userlist.table.users_per_page"/>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                            <td class="tableNavigation" colspan="5">
                                <div class="pager" id="pager"></div>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        <%-- END PAGE BODY --%>


    <%-- GROUP MANAGEMENT --%>

    <jsp:include page="/loading_popup.jsp">
        <jsp:param name="id" value='userDataLoadingPopup'/>
    </jsp:include>

    <jsp:include page="/lightbox.jsp">
        <jsp:param name="id" value='userDataLightBox'/>
        <jsp:param name="innerJsp" value='/administration/userManagement/user_data_popup.jsp'/>
        <jsp:param name="additionalClasses" value='scrollable lightboxWithWhiteContent'/>
    </jsp:include>

    <jsp:include page="/lightbox.jsp">
        <jsp:param name="id" value='inviteSeveralUsersLightBox'/>
        <jsp:param name="innerJsp" value='/administration/userManagement/invite_several_users_popup.jsp'/>
        <jsp:param name="additionalClasses" value='lightboxWithWhiteContent'/>
    </jsp:include>

    <%-- LIGHT BOX --%>
    <jsp:include page="/lightbox.jsp">
        <jsp:param name="id" value='groupManagementLightBox'/>
        <jsp:param name="title" value='<%=filteredMessage(request, "group_management.lightbox_title.user_group")%>'/>
        <jsp:param name="innerJsp" value='/administration/userManagement/group_management.jsp'/>
        <jsp:param name="groupNamingPlural" value='<%=filteredMessage(request, "common.User_Groups")%>'/>
        <jsp:param name="additionalClasses" value="groupManagementLightBox userGroupManagementLightBox lightboxWithWhiteContent"/>
        <jsp:param name="groupsSynchronized" value='<%=userGroupsSynchronized%>'/>
    </jsp:include>
    <jsp:include page="/lightbox.jsp">
        <jsp:param name="id" value='timeZoneGroupManagementLightBox'/>
        <jsp:param name="title" value='<%=filteredMessage(request, "group_management.lightbox_title.time_zone_group")%>'/>
        <jsp:param name="innerJsp" value='/administration/userManagement/group_management.jsp'/>
        <jsp:param name="groupNamingPlural" value='<%=filteredMessage(request, "common.Time_Zone_Groups")%>'/>
        <jsp:param name="additionalClasses" value="groupManagementLightBox timeZoneGroupManagementLightBox lightboxWithWhiteContent"/>
        <jsp:param name="groupsSynchronized" value='<%=tzGroupsSynchronized%>'/>
    </jsp:include>
    <%-- LIGHT BOX --%>

    <%-- END GROUP MANAGEMENT --%>

    <jsp:include page="leave_balance_editor.jsp"/>

</div>

<p>&nbsp;</p>

<table style="display: none">
    <thead id="userListTableHeader">
        <tr class="userListHead">
            <th class="userName firstLayer">
                <%--suppress HtmlUnknownTag --%>
                <table class="userNameSelectorsTable" cellpadding=0 cellspacing=0 border=0>
                    <tr>
                        <td class="filterByDepartments">
                            <div id="filterByDepartmentButton" class="filterBySelectorTableHeaderButton"></div>
                        </td>
                        <td id="sortByNameOrGroup" class="sortByContainer">
                            <span>
                                  <% if (isUGREnabled && isTZGEnabled ){%>
                                    <bean:message key="userlist.head.by"/>
                                  <%}else{%>
                                    <bean:message key="userlist.head.sort_by"/>
                                  <%}%>
                            </span>
                            <a id="sortByNameLink" class="sortByNameLink"><bean:message key="userlist.head.name"/></a> <span class="nameSortArrow"></span>
                            <span class="sortByUGRSeparator"></span>
                            <a id="sortByGroupLink" class="sortByGroupLink"><bean:message key="userlist.usertable.group"/></a> <span class="groupNameSortArrow"></span>
                            <span class="sortByTZGSeparator"></span>
                            <a id="sortByTimeZoneGroupLink" class="sortByTimeZoneGroupLink"><bean:message key="userlist.usertable.time_zone"/></a> <span class="timeZoneGroupSortArrow"></span>
                        </td>
                    </tr>
                </table>
            </th>

            <%--account settings tab--%>
            <th class="accountTab taskHierarchyHeader firstLayer" <% if( isPASEnabled ) { %> colspan="2" <% } %> >
                <div id="taskHierarchyFilter" class="taskHierarchyFilter"></div>
                <span class="taskHierarchyCellTextHeader">
                    <span class="textHeader"><span class="textContainer"><span class="prefixText"><bean:message key="userlist.head.task_hierarchy_prefix"/></span>&nbsp;
                     <bean:message key="userlist.head.task_hierarchy_suffix"/></span></span>
                </span>
            </th>
            <th class="accountTab ttApprovalHeader firstLayer" colspan="<%= isTTAEnabled ? "3" : "2" %>">
                <div id="timeTrackApprovalFilter" class="timeTrackApprovalFilter"></div>
                <div class="text"></div>
                <span class="textHeader"> <bean:message key='<%= "userlist.head.tt_approval" + TTADisabledSuffix %>'/></span></th>
            <th class="accountTab editManagePTOHeader managePTOHeader firstLayer <%= isSickEnabled ? "leftTextHeader" : "" %> <%= isPTOEnabled && isSickEnabled ? "ptoAndSickHeader" : "" %>">
                <div id="balanceManagerFilter" class="balanceManagerFilter"></div>
                <% if ( isPTOEnabled && isSickEnabled ) { %>
                    <span class="textHeader"><bean:message key="userlist.head.manage_pto_and"/></span><br>
                    <span class="textHeader"><bean:message key="userlist.head.manage_sick"/></span>
                <% } else if ( isPTOEnabled ) { %>
                    <span class="textHeader"><bean:message key="userlist.head.manage_pto"/></span>
                <% } else { %>
                    <span class="textHeader"><bean:message key="userlist.head.manage_sick"/></span>
                <% } %>
            </th>

            <%--pto & sick days settings tabs--%>
            <th class="ptoTab ptoBalancesHeader managePTOHeader firstLayer" id="sortByPTOLink" colspan="2">
                <a><bean:message key="userlist.pagebody.usersListTable.header.pto"/></a>
                <span class="ptoSortArrow"></span>
            </th>

            <th class="sickDaysTab sickBalancesHeader manageSickDaysHeader firstLayer" id="sortBySickLink" colspan="2">
                <a><bean:message key="userlist.pagebody.usersListTable.header.sick_days"/></a>
                <span class="sickSortArrow"></span>
            </th>

            <th id="sortByApprovedPTO" class="ptoTab plannedLeavesHeader manageSickDaysHeader managePTOHeader firstLayer">
                <span class="sortLink"><bean:message key="userlist.head.planned_leaves"/></span>
                <span class="ptoSortArrow"></span>
            </th>

            <th id="sortByApprovedSick" class="sickDaysTab plannedLeavesHeader manageSickDaysHeader managePTOHeader firstLayer">
                <span class="sortLink"><bean:message key="userlist.head.planned_leaves"/></span>
                <span class="sickSortArrow"></span>
            </th>

            <th class="ptoTab ptoRulesHeader managePTOHeader firstLayer" colspan="3"><bean:message key="userlist.head.pto_accrual_rules"/></th>
            <th id="sortByPTOControl" class="ptoTab ptoControlHeader managePTOHeader firstLayer">
                <span class="sortLink"><bean:message key="userlist.head.pto_control"/></span>
                <span class="ptoSortArrow"></span>
            </th>

            <th class="sickDaysTab sickDaysRulesHeader manageSickDaysHeader firstLayer" colspan="3"><bean:message key="userlist.head.sick_days_accrual_rules"/></th>
            <th id="sortBySickControl" class="sickDaysTab sickControlHeader manageSickDaysHeader firstLayer">
                <span class="sortLink"><bean:message key="userlist.head.pto_control"/></span>
                <span class="sickSortArrow"></span>
            </th>


        </tr>
        <tr class="userListHead">
            <th class="userName secondLayer">
                <table class="userNameSelectorsTable" cellpadding=0 cellspacing=0 border=0>
                    <tr class="userNameFilterContainer">
                        <td class="firstCell"></td>
                        <td class="secondCell">
                            <div id="showDisabledUsersContainer">
                                <input type="checkbox" id="showDisabledUsersChBox">
                                <label for="showDisabledUsersChBox"><span><bean:message key="userlist.show_disabled_users"/> </span></label>
                            </div>
                        </td>
                    </tr>
                </table>
            </th>

            <%--account settings tab--%>
            <th class="accountTab taskHierarchyHeader manageHierarchyHeader secondLayer"><bean:message key="userlist.head.task_hierarchy_manage"/></th>
            <th class="accountTab taskHierarchyHeader grantHierarchyHeader secondLayer"><bean:message key="userlist.head.task_hierarchy_assignment"/></th>
            <th class="accountTab ttApprovalHeader manageApproveHeader secondLayer" colspan="2">
                <bean:message key='<%= "userlist.head.tt_approval_manage_approve" + TTADisabledSuffix %>'/>
            </th>
            <th class="accountTab ttApprovalHeader assignApproversHeader secondLayer"><bean:message key="userlist.head.tt_approval_assign_approvers"/></th>
            <th class="accountTab managePTOHeader secondLayer"><bean:message key="userlist.head.manage_pto_manage"/></th>

            <%--pto settings tab--%>
            <th class="ptoTab managePTOHeader secondLayer currentPtoBalance"><bean:message key="userlist.head.pto_balance_current"/></th>
            <th class="ptoTab managePTOHeader secondLayer historyPtoBalance"><bean:message key="userlist.head.pto_balance_history"/></th>
            <th class="ptoTab managePTOHeader secondLayer"><bean:message key="userlist.head.planned_leaves_reported_by_users"/></th>
            <th class="ptoTab managePTOHeader secondLayer resetPtoRules"><bean:message key="userlist.head.pto_accrual_rules_reset"/></th>
            <th class="ptoTab managePTOHeader secondLayer accruePtoRules"><bean:message key="userlist.head.pto_accrual_rules_accrue"/></th>
            <th class="ptoTab managePTOHeader secondLayer limitPtoRules"><bean:message key="userlist.head.pto_accrual_rules_cap"/></th>
            <th class="ptoTab managePTOHeader secondLayer"><bean:message key="userlist.head.pto_control_turn"/></th>

            <%--sickDays settings tab--%>
            <th class="sickDaysTab manageSickDaysHeader secondLayer currentSickDaysBalance"><bean:message key="userlist.head.pto_balance_current"/></th>
            <th class="sickDaysTab manageSickDaysHeader secondLayer historySickDaysBalance"><bean:message key="userlist.head.pto_balance_history"/></th>
            <th class="sickDaysTab manageSickDaysHeader secondLayer"><bean:message key="userlist.head.planned_leaves_reported_by_users"/></th>
            <th class="sickDaysTab manageSickDaysHeader secondLayer resetSickDaysRules"><bean:message key="userlist.head.pto_accrual_rules_reset"/></th>
            <th class="sickDaysTab manageSickDaysHeader secondLayer accrueSickDaysRules"><bean:message key="userlist.head.pto_accrual_rules_accrue"/></th>
            <th class="sickDaysTab manageSickDaysHeader secondLayer limitSickDaysRules"><bean:message key="userlist.head.pto_accrual_rules_cap"/></th>
            <th class="sickDaysTab manageSickDaysHeader secondLayer"><bean:message key="userlist.head.pto_control_turn"/></th>
        </tr>
    </thead>
</table>

<jsp:include page="/user/balance_history_panel.jsp"/>

<jsp:include page="/controls/tree_selector_dialog.jsp">
    <jsp:param name="id" value="usersForApproverDialog"/>
</jsp:include>
<jsp:include page="/controls/approvers_dialog.jsp"/>
<jsp:include page="/controls/approvers_tooltip.jsp"/>
<jsp:include page="/controls/tree_selector_dialog.jsp">
    <jsp:param name="id" value="CustomerProjectSelectorDialog"/>
</jsp:include>
<div id="approverManagesAllUsersTooltip" class="yellowTooltip tooltipText"></div>
<div id="userIsAutoApprovedTooltip" class="yellowTooltip tooltipText"></div>
<div id="assignmentsTooltip" class="yellowTooltip">
    <div id="assignmentsTooltip_textPlaceholder" class="tooltipText"></div>
</div>
<div id="userListTaskHierarchyTooltip" class="yellowTooltip">
    <div id="userListTaskHierarchyTooltip_textPlaceholder" class="tooltipText"></div>
</div>
<div id="userListManageRightsTooltip" class="yellowTooltip">
    <div id="userListManageRightsTooltip_textPlaceholder" class="tooltipText"></div>
</div>
<div id="userListAssignUsersToTTATooltip" class="yellowTooltip">
    <div id="userListAssignUsersToTTATooltip_textPlaceholder" class="tooltipText"></div>
</div>
<div class="warningsToShowDiv">
</div>

<jsp:include page="/controls/balance_rules_editor_dialog.jsp">
    <jsp:param name="prefixId" value="sick"/>
</jsp:include>

<jsp:include page="/controls/balance_rules_editor_dialog.jsp">
    <jsp:param name="prefixId" value="pto"/>
</jsp:include>


<script>
    var pageData = <%=jsHelper.toJSON( request.getAttribute( Keys.USERS_LIST_DATA_KEY  ) )%>;
    var userListSettings =<%=jsHelper.toJSON( request.getAttribute(  Keys.USER_LIST_SETTINGS_KEY ) )%>;

    //JS START POINT
    $( document ).ready(function ( )
        {
            var createUserButton = document.createElement('div');
            if (isOlVersion)
            {
                createUserButton.innerHTML = "<div class='icon'></div>" +
                                              "<div class='buttonText'>" + messageResource.getMessage("user.add_user", ["s"]) + "</div>" +
                                              "<div class='arrowIcon'></div>";
                createUserButton.className = "inviteUsersButton beigeButton";
            }
            else
            {
                createUserButton.innerHTML = "<div class='icon'></div><div class='buttonText'>" + messageResource.getMessage("user.add_user", [""]) + "</div>";
                createUserButton.className = "addUserButton beigeButton";
            }
            document.getElementById("createUserDiv").appendChild(createUserButton);

            this.pageHeaderEl = document.getElementById("pageHeader" );
            this.userListFooterEl = document.getElementById("userListFooterId" );

            this.sortByPTOLink = document.getElementById("sortByPTOLink" );
            this.sortByNameOrGroup = document.getElementById("sortByNameOrGroup" );
            this.sortByApprovedPTO = document.getElementById("sortByApprovedPTO" );
            this.sortByPTOControl = document.getElementById("sortByPTOControl" );

            this.sortBySickLink = document.getElementById("sortBySickLink" );
            this.sortByApprovedSick = document.getElementById("sortByApprovedSick" );
            this.sortBySickControl = document.getElementById("sortBySickControl" );


            disableTextSelection(this.pageHeaderEl);
            disableTextSelection(this.userListFooterEl);
            disableTextSelection(this.sortByPTOLink);
            disableTextSelection(this.sortByNameOrGroup);
            disableTextSelection(this.sortByApprovedPTO);
            disableTextSelection(this.sortByPTOControl);
            disableTextSelection(this.sortBySickLink);
            disableTextSelection(this.sortByApprovedSick);
            disableTextSelection(this.sortBySickControl);

            var userBeans =  pageData.records;

            var pagerData = {
                totalRecords: pageData.totalRecords,
                recordsPerPage: userListSettings.recordsPerPage,
                pageNum: pageData.pageNum
            };
            
            var license = <%=jsHelper.toJSON( license )%>;

            var loggedInUserId = <%=AuthController.getLoggedInUserId( session )%>;
            var loggedInUserTZGroupId = <%=AuthController.getLoggedInUser(session).getTimeZoneGroupId()%>;

            window.userlistMediator = new UserManagementMediator().init(
                    userBeans,
                    pagerData,
                    pageData.allUserGroups,
                    pageData.allTimeZoneGroups,
                    pageData.viewerSettings,
                    userListSettings,
                    license,
                    loggedInUserId,
                    pageData.ptoHoursPerDay,
                    pageData.allApprovers,
                    pageData.ptoDefaults,
                    pageData.sickDefaults,
                    loggedInUserTZGroupId
            );

            window.userlistMediator.render();

            PageOverlayTipsManager.getInstance().addTitleTips();
            PageOverlayTipsManager.getInstance().refreshDynamicTips();
        });

    PageOverlayTipsManager.setInstance(new UserListPageOverlayTipsManager(pageData.viewerSettings));
</script>
</body>
</html>
