<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.TimeUtils" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="static com.actimind.actitime.util.Feature.PTO" %>
<%@ page import="static com.actimind.actitime.util.Feature.SDB" %>
<%@ page import="static com.actimind.actitime.util.Feature.LVT" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<bean:define id="form" name="GeneralSettingsForm" type="com.actimind.common.administration.BaseGeneralSettingsForm"/>
<bean:define id="productName" name="<%= Keys.PRODUCT_CONFIG %>" property="productName" type="java.lang.String"/>
<bean:define id="userTimeZone" name="<%= Keys.USER_TIME_ZONE %>" scope="request" type="java.util.TimeZone"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<%
    boolean isPTOon;
    boolean isSickDaysOn;
    boolean isAP = productName.equals( Product.actiPLANS.name() );
    if( isAP ){
        isPTOon = settings.isApPtoBalanceCalculationEnabled();
        isSickDaysOn = settings.isApSickBalanceCalculationEnabled();
    } else {
        isPTOon = FeaturesUtil.isEnabled(PTO);
        isSickDaysOn = FeaturesUtil.isEnabled(SDB);
    }
%>

<bean:parameter id="numberOfUsersWithDefaultSchedule" name="numberOfUsersWithDefaultSchedule"/>


        <table class="workScheduleTable" cellpadding="0" cellspacing="0" border="0">
            <colgroup>
                <col class="formFieldCaptionCol">
                <col class="workdayDurationsEditorCol">
                <col>
            </colgroup>
            <tr>
                <td class="formfieldtitle formFieldCaption wsLabel"><span id="workScheduleLabel"><bean:message key="general_settings.work_schedule.default_work_schedule"/>:</span></td>
                <td id="workdayDurationsEditorPlaceholder"></td>
                <td class="wdTotal"><bean:message key="general_settings.work_schedule.week_total"/>: <span id="weekTotalPlaceholder"></span></td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td colspan="2">
                    <div class="userInfo">
                        <logic:equal name="numberOfUsersWithDefaultSchedule" value="1">
                            <bean:message key="general_settings.work_schedule.one_user_use_default"/>
                        </logic:equal>
                        <logic:notEqual name="numberOfUsersWithDefaultSchedule" value="1">
                            <bean:message key="general_settings.work_schedule.some_users_use_default" arg0="<%=numberOfUsersWithDefaultSchedule%>"/>
                        </logic:notEqual>
                    </div>
                    <div class="modificationsInfo" id="scheduleModificationsInfo">
                        <bean:message key="general_settings.work_schedule.schedule_modification_note"
                                arg0='<%=TimeUtils.formatTimestamp( request, new java.util.Date(), "EEEE, MMMMM dd", userTimeZone )%>'/>
                        <div id="undoScheduleModifications" class="undoModifications"><bean:message key="general_settings.work_schedule.undo_schedule_modifications"/></div>
                    </div>
                </td>
            </tr>
        </table>
        <table cellpadding=0 cellspacing=0 border=0 class="defaultWorkdayDurationTable">
            <tr>
                <td class="formfieldtitle formFieldCaption"><span id="workdayDurationStrFieldLabel"><bean:message key="general_settings.time_track.default_workday_duration.caption"/>:</span></td>
                <td>
                    <table cellpadding="0" cellspacing="0" border="0" class="containerTable"> <%-- Table is needed to show properly some controls instead of nested selects when moire is shown --%>
                        <tr>
                            <td style="padding-right: 8px;">
                                <html:text property="workdayDurationStr"
                                           styleId="workdayDurationId"
                                           onblur="checkDuration(this);"
                                           size="3" maxlength="6"/>
                            </td>
                            <td class="formfieldtitle"><bean:message key="common.hh_mm"/></td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td style="padding-top: 10px;">
                    <div class="noteContainer">
                        <at:img page="note_mark.gif" styleClass="noteImage" styleId="workdayDurationNoteImg"/>
                        <span class="notemsg">
                            <bean:message key="general_settings.work_schedule.dwd_is_used_for"/>
                            <ul class="noteList">
                                <%
                                    if (isAP || FeaturesUtil.isEnabled(LVT)) { %>
                                    <li class="noteItem">
                                        <% if( isPTOon || isSickDaysOn ) {
                                            String balancesName = ATMessageResources.message(
                                                    request,
                                                    isPTOon && isSickDaysOn ? "general_settings.work_schedule.dwd_is_used_for.part1.balance.both" :
                                                            isPTOon ? "general_settings.work_schedule.dwd_is_used_for.part1.balance.pto" :
                                                                    "general_settings.work_schedule.dwd_is_used_for.part1.balance.sick_days");
                                        %>
                                            <%=ATMessageResources.message( request, "general_settings.work_schedule.dwd_is_used_for.part1", balancesName)%>
                                        <% } else { %>
                                            <bean:message key="general_settings.work_schedule.dwd_is_used_for.part1.without_balances"/>
                                        <% } %>
                                    </li>
                                <% } %>
                                <li class="noteItem"><bean:message key="general_settings.work_schedule.dwd_is_used_for.part2"/></li>
                            </ul>
                        </span>
                    </div>
                    <div class="modificationsInfo" id="dwdModificationsInfo">
                        <bean:message key="general_settings.work_schedule.dwd_modification_note"
                                      arg0='<%=TimeUtils.formatTimestamp( request, new java.util.Date(), "EEEE, MMMMM dd", userTimeZone )%>'/>
                        <div id="undoDWDModifications" class="undoModifications"><bean:message key="general_settings.work_schedule.undo_wd_modifications"/></div>
                    </div>
                </td>
            </tr>
        </table>
        <% for( int i = 0; i < form.getDefaultWorkScheduleArray().length; i++ ) {%>
        <input type="hidden" name="defaultWorkSchedule[<%=String.valueOf(i)%>]" value="<%=String.valueOf(form.getDefaultWorkScheduleArray()[i])%>">
        <% } %>
    </div>

</div>