<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.TimeUtils" %>
<%@ page import="com.actimind.common.administration.WorkDaysForm" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="java.util.Date" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%-- Common part for aT & aP Default Work Schedule pages, extracted from workingdays.jsp --%>

<bean:define id="form" scope="session" name="WorkDaysForm" type="com.actimind.common.administration.WorkDaysForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="timeZone" name="<%=Keys.USER_TIME_ZONE%>" scope="request" type="java.util.TimeZone"/>

<%
    final Date today = TimeUtils.today( timeZone ); // Today date
    boolean canManageWorkSchedule = form.isCanManageWorkSchedule();
    String pageTitleKey = request.getParameter( "pageTitleKey" );
    String productsIntegrated = (Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) ? Keys.PRODUCTS_INTEGRATED : "";
%>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>



<script type="text/javascript">

var timeout = 10000;

<%--
    Performs execution of "Work Schedule Remote Services"
--%>
function ServiceExecutor(monthCal, dateStr, cell, callBackFunc){

    this.monthCal = monthCal;   // month calendar
    this.dateStr = dateStr;     // selected date value
    this.cell = cell;           // selected day cell
    this.isWeekend = monthCal.isWeekend(cell); // Is selected day weekend
    this.callBackFunc = callBackFunc; // function to invoke after service ended its execution or failed
    this.requestId = null;

    this.methods = [ 'WorkScheduleService.switchToHoliday', 'WorkScheduleService.switchToWorkingDay' ];
}

<%--
    Executes service
--%>
ServiceExecutor.prototype.executeService = function(){
    <%-- Save previous settings --%>
    var $cell = $(this.cell);
    var span = $cell.find("span").first();
    span.after($("<span>").html(messageResource.getMessage("work_days.saving_msg")));
    span.remove();
    this.cellSpanClone = span.clone();

    this.cell.style.backgroundColor = '';
    this.cell.style.cursor = '';
    addClass(this.cell, "calendarDaySaving");
    this.cell.title = '';

    <%-- Invoke method that actually performs service call --%>
    this.startToggleDayStatus();
}

<%--
    Returns message for service call abort confirmation dialog
--%>
ServiceExecutor.prototype.getAbortConfirmMsg = function(){

    var msg;
    <%-- Different messages for each day type --%>
    if (this.isWeekend)
        msg = messageResource.getMessage("work_days.calendar.mark_day_working_timeout");
    else
        msg = messageResource.getMessage("work_days.calendar.mark_day_non_working_timeout");

    return msg;
};

ServiceExecutor.prototype.savingTimeout = function() {
    this.retryController.stop();

    if (this.requestId) {
        JSONRpcClient.cancelRequest(this.requestId);
    }

    <%-- Abort all pending requests --%>
    jsonrpc.abortAllRequests();

    <%-- Ask user if he wants to continue calling service --%>
    if (!confirm(this.getAbortConfirmMsg())) {

        <%-- Report failure and exit --%>
        this.failed();
    } else {
        <%-- In case user wants to continue trying reset request initialization time --%>
        this.retryController.start();
    }

};

ServiceExecutor.prototype.startToggleDayStatus = function() {
    var thisObj = this;

    this.retryController = new RpcRetryController( timeout,
                                                   function() { thisObj.toggleDayStatus() },
                                                   function() { thisObj.savingTimeout() },
                                                   function( exception ) {
                                                       thisObj.handleException( exception );
                                                       thisObj.failed();
                                                   } );
    this.retryController.start();
};

<%--
    Calls remote service
    @param initTime time at which service call was initiated
--%>
ServiceExecutor.prototype.toggleDayStatus = function() {

    try {
        var thisObj = this; <%-- Define reference to this object for uses in call back functions --%>

        if (!isRpcReady( this.methods )) {

            this.retryController.retry();
            return;
        }

        if (!jsonrpc.WorkScheduleService) {
            /* service is unavailable, most likely we've been logged out */
            document.location.reload();
            return;
        }

        <%-- Call back function to invoke after service execution --%>
        var jsonrpcCallBack = function(result, exception){
            thisObj.jsonrpcCallBack(result, exception);
        }

        <%-- If selected day is weekend switch it to working day otherwise to holiday --%>
        if (this.isWeekend)
            this.requestId = jsonrpc.WorkScheduleService.switchToWorkingDay(jsonrpcCallBack, this.dateStr);
        else
            this.requestId = jsonrpc.WorkScheduleService.switchToHoliday(jsonrpcCallBack, this.dateStr);

    } catch(e) {

        this.retryController.handleErrorOrRetry( e );
    }
}

<%--
    Call back method for remote service calls
    @param result result of service call
    @param exception service call exception
--%>
ServiceExecutor.prototype.jsonrpcCallBack = function(result, exception){

    if(exception != null){
        this.retryController.handleErrorOrRetry( exception );
    } else {
        <%-- Report successful service execution --%>
        this.success();
    }
}

<%--
    Handles exception
    @param exception exception to handle
 --%>
ServiceExecutor.prototype.handleException = function(exception){

    <%-- Reload page if user does not have permission to execute the service --%>
    if (exception.name.indexOf('com.actimind.actitime.services.NoRightsForRemoteCallException') != -1)
    {
        var form = document.getElementById('formatSelectorForm');
        form.elements.pageAction.value = '<%= WorkDaysForm.SHOW_NO_MANAGE_RIGHTS_ERROR_ACTION %>';
        form.submit();
        return;
    }

    var msg;

    <%-- Choose appropriate message with respect to selected day type --%>
    if (this.isWeekend)
        msg = messageResource.getMessage("work_days.calendar.mark_day_working_error");
    else
        msg = messageResource.getMessage("work_days.calendar.mark_day_non_working_error");

    <%-- Display message --%>
    alert(msg);
}

<%--
    Reports service execution failure
 --%>
ServiceExecutor.prototype.failed = function(){

    this.cleanup(false);
}

<%--
    Reports successful service execution
--%>
ServiceExecutor.prototype.success = function(){

    this.cleanup(true);
}

<%--
    Performs all clean up for this service executor
    @param revertDay if true day status will be reverted, otherwise will not
 --%>
ServiceExecutor.prototype.cleanup = function(revertDay){

    <%-- Change inner span to previous state --%>
    var $cell = $(this.cell);
    var span = $cell.find("span").first();
    span.after(this.cellSpanClone);
    span.remove();

    removeClass(this.cell, "calendarDaySaving");
    Calendar_setCellStyle(this.cell, revertDay ? !this.isWeekend : this.isWeekend);

    <%-- Finally execute call back function --%>
    this.callBackFunc();

    this.retryController.stop();
}


<%--
    Highlights specified cell of specified calendar
    @param cal calendar cell of which should be highlighted
    @param cell cell to be highlighted
--%>
CalendarState.prototype.highlightCell = function(cal, cell){

    <%-- Do nothing --%>
}

<%--
    Removes highlighting of specified cell of specified calendar
    @param cal calendar to which cell belongs to
    @param cell cell to remove highlighting from
--%>
CalendarState.prototype.unhighlightCell = function(cell){

    <%-- Do nothing --%>
}

<%--
    Handles click on calendar cell
    @param calendar calendar cell of which underwent mouse click
    @param dateStr string representation of cell date
    @param cell cell that was clicked
--%>
CalendarState.prototype.handleCellClick = function(calendar, dateStr, cell){

    <%-- Do nothing --%>
}

<%--
    Caledar state
--%>
function CalendarState(calendar){

    this.context = calendar; <%-- Holds this state's context --%>
}

<%--
    Active state of calendar
 --%>
CalendarActiveState.prototype = new CalendarState();

function CalendarActiveState(calendar){

    this.constructor(calendar); <%-- Invoke parent constructor --%>
}

CalendarActiveState.prototype.highlightCell = function(cal, cell){

    Calendar_highlightCell(cell);
    cell.title = cal.isWeekend(cell) ? messageResource.getMessage("work_days.calendar.non_working_day_mouse_over_title")
            : messageResource.getMessage("work_days.calendar.working_day_mouse_over_title");
}

CalendarActiveState.prototype.unhighlightCell = function(cell){

    Calendar_unhighlightCell(cell);
    cell.title = '';
}

CalendarActiveState.prototype.handleCellClick = function(monthCal, dateStr, cell){

    <%-- Define reference for context and call back function for service executor --%>
    var thisStateContext = this.context;
    var serviceExecutorCallBack = function(){

        thisStateContext.moveToActiveState();
    }

    <%-- Move context to blocked state --%>
    thisStateContext.moveToBlockedState();

    <%-- Create service executor and execute service --%>
    var serviceExecutor = new ServiceExecutor(monthCal, dateStr, cell, serviceExecutorCallBack);
    serviceExecutor.executeService();
}


<%--
    Blocked state of calendar
--%>
CalendarBlockedState.prototype = new CalendarState();

function CalendarBlockedState(calendar){

    this.constructor(calendar); <%-- Invoke parent class constructor --%>
}


<%-- Create calendar strategy object to be shared by all instances of work schedule month calendars --%>
var calendarStrategy = new CalendarStrategy();

<%--
    Strategy for calendar
--%>
function CalendarStrategy(){
    <%-- Initially in active state if user has rights to edit schedule, otherwise in blocked state --%>
    this.calendarState = new Calendar<%=(canManageWorkSchedule ? "Active" : "Blocked")%>State(this);
}

<%--
    Switches to active state
--%>
CalendarStrategy.prototype.moveToActiveState = function(){

    this.calendarState = new CalendarActiveState(this);
}

<%--
    Switches to blocked state
--%>
CalendarStrategy.prototype.moveToBlockedState = function(){

    this.calendarState = new CalendarBlockedState(this);
}

<%--
    Highlights specified cell of specified calendar
    @param cal calendar cell of which should be highlighted
    @param cell cell to be highlighted
--%>
CalendarStrategy.prototype.highlightCell = function(cal, cell){

    this.calendarState.highlightCell(cal, cell);
}

<%--
    Removes highlighting of specified cell of specified calendar
    @param cal calendar to which cell belongs to
    @param cell cell to remove highlighting from
--%>
CalendarStrategy.prototype.unhighlightCell = function(cal, cell){

    this.calendarState.unhighlightCell(cell);
}

<%--
    The method is called when one of the cells of some calendar is clicked
    @param calendar calendar cell of which underwent mouse click
    @param dateStr string representation of cell date
    @param cell cell that was clicked
--%>
CalendarStrategy.prototype.dateClicked = function(calendar, dateStr, cell){

    this.calendarState.handleCellClick(calendar, dateStr, cell);
}

<%--
    Defines single month calendar

    @param thisObjName name of this calendar object. It is used to construct call back functions for calendar
    @param strDate string representation of month start date
    @param calendarStrategy strategy for this calendar
--%>
function WorkScheduleMonthCalendar(thisObjName, strDate, calendarStrategy){

    this.calendarStrategy = calendarStrategy; // Set calendar strategy

    /**
     * @name createLayoutCalendar declared in calendar.js
     * @name invertedDaysDateMap declared in InvertedDaysServlet.java
     */

    var defaultWorkSchedule = <%=Arrays.toString( settings.getDefaultWorkSchedule() )%>;

    <%-- Create instance of calendar --%>
    this.cal = createLayoutCalendar(strDate, // Start of month date
                                    '<%=TimeUtils.formatDate(today, TimeUtils.UNIFORM_DATE_FORMAT)%>', // Today string
                                    '',
                                    '',
                                    thisObjName + '.dateClicked', <%-- Function to call when date of calendar is clicked --%>
            <bean:write name="settings" property="weekStartDay"/>, <%-- Week start day --%>
                                    new CorporateScheduleCalculator().init(
                                            invertedDaysDateMap,
                                            defaultWorkSchedule
                                    ),
                                    defaultWorkSchedule
    );

    <%-- Configure calendar --%>
    this.cal.setWeekDays(new Array(
            '<bean:message key="week.short.sun"/>',
            '<bean:message key="week.short.mon"/>',
            '<bean:message key="week.short.tue"/>',
            '<bean:message key="week.short.wed"/>',
            '<bean:message key="week.short.thu"/>',
            '<bean:message key="week.short.fri"/>',
            '<bean:message key="week.short.sat"/>'));
    this.cal.setHeader(false);   // Do not show calendar header
    this.cal.setDisplayDaysOfOtherMonths(false); <%-- Do not display days those do not belong to base month --%>
    this.cal.setMouseOverHandler('if(typeof ' + thisObjName + ' != typeof undefined) ' + thisObjName + '.highlightCell(this)');
    this.cal.setMouseOutHandler('if(typeof ' + thisObjName + ' != typeof undefined) ' + thisObjName + '.unhighlightCell(this)');
}

<%--
    Outputs calendar for this month
--%>
WorkScheduleMonthCalendar.prototype.printCalendar = function(){

    document.writeln(this.cal.getCalendarHTML());
}

<%--
    Highlights cell specified as a parameter
    @param cell cell to highlight
--%>
WorkScheduleMonthCalendar.prototype.highlightCell = function(cell){

    this.calendarStrategy.highlightCell(this.cal, cell);
}

<%--
    Removes highlighting of cell specified as a parameter
    @param cell cell to "unhighlight"
--%>
WorkScheduleMonthCalendar.prototype.unhighlightCell = function(cell){

    this.calendarStrategy.unhighlightCell(this.cal, cell);
}

<%--
    This method is called when day cell of calendar is clicked
    @param dateStr string representation of the cell's day
    @param cell clicked cell
--%>
WorkScheduleMonthCalendar.prototype.dateClicked = function(dateStr, cell){

    this.calendarStrategy.dateClicked(this.cal, dateStr, cell);
}

</script>

<table cellspacing="4" cellpadding="0" border="0" align="center" class="<%=productsIntegrated%>">
    <tr>
        <td rowspan="4"><at:img page="pixel.gif" width="100" height="1" alt=""/></td>
        <td class="pagetitle" style="padding-bottom: 12px;">
            <span class="pageTitleWithSharedSettingsImage"><bean:message key="<%=pageTitleKey%>" /></span>
            <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        </td>
        <td rowspan="3"><at:img page="pixel.gif" width="170" height="1" alt=""/></td>
    </tr>
    <tr>
        <td class="pagetitle" height="10px">
            <jsp:include page="/messages.jsp"/>
        </td>
    </tr>
    <tr>
        <td style="padding-left: 2px; padding-bottom: 10px">
            <table border="0" cellpadding="0" cellspacing="0" align="left" width="100%">
                <tr>
                    <td class="currentDate">
                        <bean:message key="work_days.today_date"/>
                        <%
                            final String todayStr = TimeUtils.formatDate(today, settings.getDateFormat() );

                            // If today date is not current mount show link that will allow to switch to current month
                            if(!form.isDateInCurrentMonth(today)) {

                        %><a href="javascript:submitMonthSelectorForm(<%=TimeUtils.getYear(today)%>, <%=TimeUtils.getMonth(today)%>)"
                             title="<bean:message key="work_days.today_date_link.title"/>"
                             style="font-family: Arial, Helvetica; font-size: 10pt; font-weight: bold;">
                        <%=todayStr%></a>
                        <%
                            }
                            else{
                                out.print(todayStr);
                            }
                        %>
                    </td>
                    <td align="right"><a href="javascript:void(0)"id="formatSelectorElm"
                                         title="<bean:message key="work_days.calendar_format_selector.title"/>"
                                         onclick="showOrHideFormatSelectorPopup();"><span class="label"><bean:message
                            key="work_days.calendar_configuration_link"/></span></a>
                        <script>
                            addListener(document.getElementById("formatSelectorElm"), "mousedown",
                                        stopEventPropagation);

                        </script>
                    </td>
                </tr>
            </table>
        </td>
    </tr>

    <tr>
        <td>
            <table cellpadding="0" cellspacing="0" border="0" width="495">
                <%
                    // Get selected month and year
                    final int selectedMonth = form.getMonth(), selectedYear = form.getYear();
                %>
                <%-- For each month in calendar --%>
                <logic:iterate id="monthCalendar" name="<%=Keys.WORK_DAYS_CALENDAR_KEY%>" type="com.actimind.common.administration.WorkScheduleMonthCalendar">

                    <%
                        final boolean isSelected = (selectedMonth == monthCalendar.getMonth() && selectedYear == monthCalendar.getYear());
                        String monthCalendarClass = isSelected ?
                                                    "selectedMonthCalendar" : "otherMonthCalendar";
                    %>

                    <tr>
                        <td style="padding-bottom: 14px;" ><%-- Table that holds month name and calendar --%>
                            <div style="position: absolute;">
                                <div class="calendarHeaderYear" style="position: relative; top: 4px; left: 6px;">
                                    <bean:write name="monthCalendar" property="year"/>
                                </div>
                            </div>
                            <table align="center" cellspacing="0" cellpadding="0" class="<%=monthCalendarClass%>">
                                <tr>
                                    <td class="monthHeader">
                                        <div class="monthName" align="center">
                                            <% if(isSelected) { %>
                                            <div title="<bean:message key="work_days.month_selector.title"/>" align="center"
                                                 style="margin-left:17px;">
                                                <table align="center" cellpadding="2" cellspacing="0" border="0"
                                                       onclick="displayMonthSelectorPopup();" id="monthSelectorElm" class="monthName"
                                                        >
                                                    <tr>
                                                        <td align="left">
                                                            <bean:message name="monthCalendar" property="monthNameKey"/>
                                                        </td>
                                                        <td align="left" style="font-size: 0;"><at:img page="work_days/down_arrow.gif" align="middle" border="0"/></td>
                                                    </tr>
                                                </table></div>
                                            <script>
                                                addListener(document.getElementById("monthSelectorElm"), "mousedown",
                                                            stopEventPropagation);
                                            </script>
                                        <% } else { %>
                                        <bean:message name="monthCalendar" property="monthNameKey"/>
                                        <% } %>
                                        </div>
                                    </td>
                                    <bean:define id="calendarObjName">
                                        calendar<bean:write name="monthCalendar" property="date.time" />
                                    </bean:define>
                                    <td>
                                        <script type="text/javascript">

                                            <%-- Create and print month calendar --%>
                                            var <bean:write name="calendarObjName"/> = new WorkScheduleMonthCalendar(
                                                    '<bean:write name="calendarObjName"/>',
                                                    '<%= TimeUtils.formatDate(monthCalendar.getDate(), TimeUtils.UNIFORM_DATE_FORMAT) %>',
                                                    calendarStrategy
                                            );
                                            <bean:write name="calendarObjName"/>.printCalendar();
                                        </script>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </logic:iterate>
            </table>
        </td>
        <td valign="top" align="right">
            <table border="0" cellspacing="0" cellpadding="0" style="padding-left: 30px">
                <tr>
                    <td colspan="2" style="padding-bottom: 19px" class="usageNote">
                        <% if (canManageWorkSchedule) { %>
                            <bean:message key="work_days.calendar_usage_note"/>
                        <% } %>
                    </td>
                </tr>
                <tr>
                    <td class="calendarWorkingDay legendCell">&nbsp;</td>
                    <td class="formcomment calendarDayTitle" nowrap="nowrap"> -&ensp;<bean:message key="work_days.working_day_txt"/></td>
                </tr>
                <tr>
                    <td colspan="2" style="height: 9px"></td>
                </tr>
                <tr>
                    <td class="calendarWeekendDay legendCell">&nbsp;</td>
                    <td class="formcomment calendarDayTitle" nowrap="nowrap"> -&ensp;<bean:message key="work_days.nonworking_day_txt"/></td>
                </tr>
            </table>
        </td>
    </tr>

</table>
<BR/>

<bean:define id="currentFormatId" value="currentFormat" type="java.lang.String"/>
<bean:define id="formatIdPrefix" value="format" type="java.lang.String"/>
<bean:define id="highlightedFormatClass" value="highlightedCalendarFormat" type="java.lang.String"/>
<bean:define id="nonselectedFormatClass" value="nonselectedCalendarFormat" type="java.lang.String"/>
<bean:define id="selectedFormatClass" value="selectedCalendarFormat" type="java.lang.String"/>

<script type="text/javascript">

    <%-- Create format selector popup --%>
    var formatSelectorPopup = new PanelDhtmlPopup("formatSelectorPopup");
    <%-- Set element relative positionin strategy --%>
    formatSelectorPopup.setPositioningStrategy(new ElementRelativePositioning("formatSelectorElm"));

    function showOrHideFormatSelectorPopup(){
        if(!formatSelectorPopup.isVisible())
            formatSelectorPopup.show(-5,22);
        else
        {
            formatSelectorPopup.hide();
        }
    }

    <%--
        Submits calendar format selector form if new calendar format was selected
        @param formatId selected calendar format id
        @param monthCount number of mounth in calendar to set
    --%>
    function submitFormatSelectorForm(formatId, monthCount){

        var currentFormatId = '<bean:write name="currentFormatId"/>';

        <%-- Hide popup --%>
        formatSelectorPopup.hide();

        <%-- If format changed submit form --%>
        if(formatId != currentFormatId){
            <%-- Otherwise set the value for month count and submit form --%>
            var formatSelectorForm = document.getElementById('formatSelectorForm');
            formatSelectorForm.calendarMonthCount.value = monthCount;
            formatSelectorForm.submit();
        }
    }

    <%--
        Executed when mouse is moved out of calendar format cell
    --%>
    function calendarFormatMouseOut(formatElm){

        var currentFormatId = '<bean:write name="currentFormatId"/>';

        <%-- If moved out of not currently used format --%>
        if(formatElm.id != currentFormatId){

            <%-- Display this format cell as "non-selected" and also highlight current format --%>
            formatElm.className = '<bean:write name="nonselectedFormatClass"/>' ;
            var currentFormatElm = document.getElementById(currentFormatId);
            currentFormatElm.className = '<bean:write name="highlightedFormatClass"/>';
        }
    }

    <%--
        Executed when mouse is moved over calendar format cell
    --%>
    function calendarFormatMouseOver(formatElm){

        var currentFormatId = '<bean:write name="currentFormatId"/>'

        <%-- Set this element as selected --%>
        formatElm.className = '<bean:write name="highlightedFormatClass"/>';

        <%-- If this is not current format set style for current format --%>
        if(formatElm.id != currentFormatId){

            var currentFormatElm = document.getElementById(currentFormatId);
            currentFormatElm.className = '<bean:write name="selectedFormatClass"/>';
        }
    }

</script>

<%-- Form to send when new calendar format is choosen --%>
<html:form action="/administration/workingdays" styleId="formatSelectorForm" method="post">
    <input type="hidden" name="calendarMonthCount" value=""/>
    <input type="hidden" name="submitted" value="1" />
    <input type="hidden" name="pageAction" value=""/>
</html:form>

<div id="formatSelectorPopup" style="display:none; z-index:1001; width:240px;">
    <table border="0" cellspacing="0" cellpadding="0" class="popupBody">
        <tr>
            <%
                for(int i = WorkDaysForm.MIN_CALENDAR_MONTH_COUNT;
                    i<= WorkDaysForm.MAX_CALENDAR_MONTH_COUNT ;i++){

                    String formatClass; // Class name for this format
                    String formatId;


                    if(i == form.getCalendarMonthCount()){

                        formatClass = highlightedFormatClass;
                        formatId = currentFormatId;
                    }
                    else{
                        formatClass = nonselectedFormatClass;
                        formatId = formatIdPrefix + i;
                    }
            %>
            <td valign="top" align="center" style="margin: 0px; padding: 0px; border: none;">
                <div id="<%=formatId%>" onclick="submitFormatSelectorForm(this.id, <%=i%>)" onmouseover="calendarFormatMouseOver(this)"
                     onmouseout="calendarFormatMouseOut(this)" class="<%=formatClass%>">
                    <table cellpadding="0" cellspacing="0">
                        <%
                            for(int j=0; j<i; j++){
                        %>
                        <tr>
                            <%
                                if(j == 0) {

                            %>
                            <td><at:img page="work_days/selected_month.gif"/></td>
                            <%
                            } else{

                            %>
                            <td><at:defImg page="work_days/other_month.gif"/></td>
                            <%  } %>
                        </tr>
                        <%
                            }
                        %>
                    </table>
                </div>
            </td>
            <%
                }
            %>
        </tr>
    </table>
</div>

<script type="text/javascript">
    <%--
        Submits month selector form
        @param year selected year
        @param month selected month
    --%>
    function submitMonthSelectorForm(year, month)
    {
        <%-- Set the value for date in yyyy-mm-dd format and submit form --%>
        var monthSelectorForm = document.getElementById('monthSelectorForm');
        monthSelectorForm.date.value = year + "-" + month + "-01";
        monthSelectorForm.submit();
    }

    function displayMonthSelectorPopup()
    {
        showOrHideMonthSelectorPopup(-48, 28);
    }
</script>

<%-- Form to send when new calendar format is choosen --%>
<html:form action="/administration/workingdays" styleId="monthSelectorForm" method="get">
    <input type="hidden" name="date" value=""/> <%-- Date in format yyyy-mm-dd --%>
</html:form>

<bean:define id="monthSelectorYearRange" name="form" property="monthSelectorYearRange" type="java.util.List" />

<jsp:include page="/controls/monthselector.jsp">
    <jsp:param name="startYear" value="<%= monthSelectorYearRange.get(0) %>"/>
    <jsp:param name="endYear" value="<%= monthSelectorYearRange.get(1) %>"/>
    <jsp:param name="selectedMonth" value="<%= String.valueOf(selectedMonth) %>"/>
    <jsp:param name="selectedYear" value="<%= String.valueOf(selectedYear) %>"/>
    <jsp:param name="monthSelectorElm" value="monthSelectorElm"/>
    <jsp:param name="changeHandler" value="submitMonthSelectorForm"/>
</jsp:include>
