function getCommandLineArguments
    dim i, args, argName

    set args = WScript.Arguments
    set getCommandLineArguments = CreateObject("Scripting.Dictionary")

    for i = 0 to args.Count - 1
        if left(args(i), 1) = "/" then
            argName = lcase(right(args(i), len(args(i)) - 1))
            if not getCommandLineArguments.Exists(argName) then
                getCommandLineArguments.Add argName, ""
            end if
        else
            getCommandLineArguments.Item(argName) = args(i)
        end if
    next
end function

Function getArgValue(args, argName, defaultValue)
    if args.Exists(argName) then
        getArgValue = args.Item(argName)
    else
        getArgValue = defaultValue
    end if
End Function


Set wShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")


set args = getCommandLineArguments
ROOT = getArgValue(args, "script_base", fso.getFolder("."))

msg = "Are you sure you want to remove all your data from database?" 
response = MsgBox(msg, vbCritical Or vbOKCancel Or vbDefaultButton2, "Please confirm database cleanup")
If response = vbCancel Then 
   WScript.Quit 1
End If

dbPath = Null
defaultDbPath = ROOT & "\" & "actitime.access97.mdb" ' Default data base file to look up

odbc = "HKEY_LOCAL_MACHINE\SOFTWARE\ODBC\ODBC.INI\"

On Error Resume Next
datasource = wShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\ODBC\ODBC.INI\actitimedb\DBQ")

' If ODBS source exists and it points to valid location
If Not isEmpty(datasource) And fso.FileExists(datasource) Then 

	dbPath = datasource
' Otherwise check if data base file exists in default location
ElseIf fso.FileExists(defaultDbPath) Then
	
	' Show confirmation box for whether user wants to delete data base file from default location
	msg = "Cleanup could not automatically determine path to your database file." & vbNewLine & _
		"However there is the actiTIME database file at the following location:" & vbNewLine & vbNewLine & _
		defaultDbPath & vbNewLine & vbNewLine & _
		"Do you want to delete this file?"
	response = MsgBox(msg, vbCritical Or vbYesNo Or vbDefaultButton2, "Please confirm database cleanup")

	' If user chooses "Yes"
	If response = vbYes Then
		dbPath = defaultDbPath
	End If 

Else ' In case "clean up" was unable to determine data base file
	MsgBox ("Database file was not found. Nothing to clean.")
End If 

' If "clean up" determined data base file 
If not isNull(dbPath) Then

	On Error Resume Next
    fso.DeleteFile dbPath ' Delete file

    If Err.Number <> 0 Then ' If error occured display error message and exit
        MsgBox "File could not be deleted: " & dbPath & vbNewLine & "Reason: " & Err.Description
		WScript.Quit 1
    End If
End if

dbPropPath = ROOT & "\WEB-INF\classes\com\actimind\actitime\AT.properties" ' Data base properties path

' If data base properties file exists
If fso.FileExists(dbPropPath) Then 

	On Error Resume Next
    fso.DeleteFile dbPropPath ' Delete properties file
End If

wShell.RegDelete odbc & "actitimedb\Engines\Jet\"
wShell.RegDelete odbc & "actitimedb\Engines\"
wShell.RegDelete odbc & "actitimedb\"
wShell.RegDelete odbc & "ODBC Data Sources\actitimedb"

WScript.Echo "Cleanup completed successfully"
