'BEGIN
dim args

set args = getCommandLineArguments

set fso = CreateObject("Scripting.FileSystemObject")
set WshShell = CreateObject("WScript.Shell")

ROOT = getArgValue(args, "script_base", fso.getFolder("."))
ATPROPS_PATH=ROOT & "/WEB-INF/classes/com/actimind/actitime"
ATPROPS=ATPROPS_PATH & "/AT.properties"

if not fso.fileExists(ATPROPS) then
    die "You can not clean MySQL database, since actiTIME database is not installed."
end if

if getPropertyValue(ATPROPS, "DBdriver") = "sun.jdbc.odbc.JdbcOdbcDriver" then
    die _
        "Your current actiTIME installation is configured to work with MS Access database, " & _
        "but you have launched script for MySQL database (cleanup_mysql.vbs)." & Chr(13) & Chr(13) & _
        "To cleanup database launch cleanup_access.vbs."
end if

MYSQLPATH = ""
USERNAME  = ""
PASSWORD  = ""
HOST      = ""
PORT      = ""
DBNAME    = ""

dim dbParams
dbParams = readATProperties(ATPROPS)

if ubound(dbParams) = 6 then
    if dbParams(5) = "sun.jdbc.odbc.JdbcOdbcDriver" then
        die "Warning! Your current actiTIME installation is configured to work with MS Access database, " & _
            "but you have launched script for MySQL database (setup_mysql.vbs)." & vbNewLine & vbNewLine & _
            "To upgrade actiTIME to a newer version, launch setup_access.vbs." & vbNewLine & vbNewLine & _
            "To install actiTIME with MySQL support, unzip installation package into another " & _
            "directory and launch setup_mysql.vbs." & vbNewLine
    end if
    USERNAME = dbParams(0)
    PASSWORD = dbParams(1)
    HOST     = dbParams(2)
    PORT     = dbParams(3)
    DBNAME   = dbParams(4)
    URL      = dbParams(6)
end if



msg = "Are you sure you want to remove all your data from database?"
response = MsgBox(msg, vbCritical Or vbOKCancel Or vbDefaultButton2, "Please confirm database cleanup")
If response = vbCancel Then
   WScript.Quit 1
End If

MYSQLPATH = getArgValue(args, "mysqlpath", "")
if MYSQLPATH = "" then
    MYSQLPATH = InputBox("Enter the path to the MySQL executables")
end if

if USERNAME="" then
    USERNAME = InputBox("Enter username")
end if
'if username is finally empty, just guess that we are cool root user
if USERNAME="" then
    USERNAME="root"
end if
if PASSWORD="" then
    PASSWORD = InputBox("Enter password for MySQL user " & USERNAME)
end if
'if password is finally empty, we dont need -p option
if PASSWORD<>"" then
    PASSOPTION=" " & escapeParamForCommandLine("-p" & PASSWORD)
end if
if DBNAME="" then
    DBNAME="actitime"
end if
if HOST="" then
    HOST="localhost"
end if
if PORT="" then
    URL=HOST
    AUTH = " -u " & escapeParamForCommandLine(USERNAME) & " " & PASSOPTION & " -h " & HOST
else
    URL=HOST&":"&PORT
    AUTH = " -u " & escapeParamForCommandLine(USERNAME) & " " & PASSOPTION & " -h " & HOST & " -P " & PORT
end if


MYSQLEXE  =  MYSQLPATH & "\" & "mysql.exe"


'try threat the given path as the MySQL home directory
if not fso.FileExists(MYSQLEXE) then
  MYSQLPATH2 = MYSQLPATH & "\" & "bin"
  MYSQLEXE2 = MYSQLPATH2 & "\" & "mysql.exe"
  if fso.FileExists(MYSQLEXE2) then
    MYSQLPATH = MYSQLPATH2
    MYSQLEXE = MYSQLEXE2
  else
    die "Could not find mysql.exe in " & MYSQLPATH & vbNewLine & vbNewLine
  end if
end if

MYSQLADMINEXE   = mysqlPath & "\" & "mysqladmin.exe"

if not fso.FileExists(MYSQLADMINEXE) then
    die("Failed to run mysql. File " & MYSQLADMINEXE & " is not found.")
end if

MYSQLADMINEXE = Chr(34) & MYSQLADMINEXE & Chr(34)

dim cmd
cmd = MYSQLADMINEXE & " -f " & AUTH & " drop " & DBNAME
execHuman cmd, "Could not drop database", "mysqladmin", "MySQL is not installed or misconfigured"

' If data base properties file exists
If fso.FileExists(ATPROPS) Then
    On Error Resume Next
    fso.DeleteFile ATPROPS ' Delete properties file
End If

WScript.Echo "Cleanup completed successfully"
'END



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''                                  FUNCTIONS                                 ''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

function getCommandLineArguments
    dim i, args, argName, params

    set args = WScript.Arguments
    set getCommandLineArguments = CreateObject("Scripting.Dictionary")

    for i = 0 to args.Count - 1
        if left(args(i), 1) = "/" then
            argName = lcase(right(args(i), len(args(i)) - 1))
            if not getCommandLineArguments.Exists(argName) then
                getCommandLineArguments.Add argName, ""
            end if
        else
            getCommandLineArguments.Item(argName) = args(i)
        end if
    next
end function

function getArgValue(args, argName, defaultValue)
    if args.Exists(argName) then
        getArgValue = args.Item(argName)
    else
        getArgValue = defaultValue
    end if
end function


function execHuman(path,errMsg,prog,suggestion)
    On Error Resume Next
    exitCode = WshShell.Run(path, 0, true)
    if(Err.Number<>0) then
        die("Could not run " & prog & ", probably " & suggestion & ". Installation terminated.")
    end if
    on Error goto 0
    if exitCode <> 0 then
        die(errMsg&". Cleanup terminated.")
    end if
end function

function die(msg)
    WScript.Echo msg
    WScript.Quit 1
end function

' Tries to read database connection params from the file propFile.
' Returns an array of 6 elements:
'  - 1st element - username
'  - 2nd element - password
'  - 3rd element - host
'  - 4th element - port
'  - 5th element - database
'  - 6th element - DB driver
'  - 7th element - JDBC URL
' If the file does not exist returns empty array.
' If any of the properties could not be read (does not exists or contains slashes inside)
' the value at the corresponding index will be empty.
function readATProperties(propFile)
    dim url, hostAndPort
    dim params()
    redim params(0)

    if fso.fileExists(propFile) then
        redim params(6)

        params(0) = getPropertyValue(propFile, "DBuser")
        params(1) = getPropertyValue(propFile, "DBpassword")
        params(5) = getPropertyValue(propFile, "DBdriver")
        url = getPropertyValue(propFile, "DBurl")
        if inStrRev(url, "?") > 0 Then
            url = left(url, inStrRev(url, "?") - 1)
        End if
        params(6) = url
        if Len(url) > 0 then
            if inStrRev(url, "/") > 0 and _
               left(url, 13) = "jdbc:mysql://" and _
               inStrRev(url, "/") > 13 then
                hostAndPort = mid(url, 14, inStrRev(url, "/") - 14)
                if inStr(hostAndPort, ":") > 0 then
                    params(2) = left(hostAndPort, inStr(hostAndPort, ":") - 1)
                    params(3) = right(hostAndPort, len(hostAndPort) - inStr(hostAndPort, ":"))
                else
                    params(2) = hostAndPort
                end if
                params(4) = trim(right(url, len(url) - inStrRev(url, "/")))
            end if
        end if
    end if

    readATProperties = params
end function

function getPropertyValue(fileName, propertyName)
    dim stream, strLine, res

    set stream = fso.OpenTextFile(fileName)

    res = ""
    do while not stream.atEndOfStream
        strLine = trim(stream.readLine())

        if (inStr(strLine, "=") > 0) and (left(strLine, len(propertyName)) = propertyName) then
            if inStr(strLine, "\") = 0 then
                res = trim(right(strLine, len(strLine) - inStr(strLine, "=")))
            end if
            exit do
        end if
    loop

    getPropertyValue = res
end function

Function isQuote(character)
    isQuote = (character = """")
End Function

Function isWhitespace(character)
    set whiteSpaceRE = new RegExp
    whiteSpaceRE.global = true
    whiteSpaceRE.pattern = "\s"
    Set matches = whiteSpaceRE.Execute(character)
    isWhitespace = (matches.Count > 0)
End Function


' MySQL parameters should be escaped by this function for using them in command line.
Function escapeParamForCommandLine(param)
    Dim result, regExpResult, char, prevChar, nextChar

    regExpResult = param

    set re = new RegExp
    re.global = true

    ' Wrap strings of spaces with quotes
    re.pattern = "(\s+)"
    regExpResult = re.replace(regExpResult, """$1""")

    ' Double slashes that stand before quote.
    re.pattern = "(\\+)"""
    regExpResult = re.replace(regExpResult, "$1$1""")

    ' Escape quotes. Quotes that stand before spaces should not be escaped.
    for charNum = 1 to Len(regExpResult)
        char = Mid(regExpResult, charNum, 1)
        ' equals to "^""(?!\s)"
        if charNum = 1 Then
            if isQuote(char) and not isWhitespace(char) Then
                result = result & "\"
            end if
        elseif charNum = Len(regExpResult) Then
            ' equals to "(\S)""(?!\s)"
            prevChar = Mid(regExpResult, charNum - 1, 1)
            if isQuote(char) and not isWhitespace(prevChar) Then
                result = result & "\"
            end if
        else
            ' equals to "(\S)""(?!\s)"
            prevChar = Mid(regExpResult, charNum - 1, 1)
            nextChar = Mid(regExpResult, charNum + 1, 1)
            if isQuote(char) and not isWhitespace(prevChar) and not isWhitespace(nextChar) Then
                result = result & "\"
            end if
        end if
        result = result & char

    next

    EscapeParamForCommandLine = result
End Function
