<%@ page import="com.actimind.actitime.util.TimeUtils" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%
/**
 * required parametrs
 * @param startYear start year of month selection interval
 * @param endYear end year of month selection interval
 * @param selectedYear year, which contains selected month, should be inside [startYear, endYear] interval
 * @param selectedMonth number of selected month, can be [1, 12]
 *           selectedYear and selectedMonth identify month, which will be marked as selected into popup
 * @param monthSelectorElm id of html element, popup will be shown under this element
 * @param changeHandler name of js function, which will be called when user select month different from current
 *                      function gets 2 parameters: first - year, which contains selected month
 *                                                  second - number of selected month
 * Note: call "showOrHideMonthSelectorPopup(offsetX, offsetY)" js function to display popup.
 *     params: offsetX - horizontal offset of popup relative to monthSelectorElm
 *             offsetY - vertical offset of popup relative to monthSelectorElm
 */
%>

<%
    final int startYear = Integer.parseInt(request.getParameter("startYear")),
              endYear = Integer.parseInt(request.getParameter("endYear")),
              selectedMonth = Integer.parseInt(request.getParameter("selectedMonth")),
              selectedYear = Integer.parseInt(request.getParameter("selectedYear"));

%>

<%-- Month selector popup --%>
<script type="text/javascript">

    <%-- Create month selector popup --%>
    var monthSelectorPopup = new PanelDhtmlPopup("monthSelectorPopup");
    <%-- Set element relative positionin strategy --%>
    monthSelectorPopup.setPositioningStrategy(new ElementRelativePositioning('<%= request.getParameter("monthSelectorElm") %>'));
    <%-- After month selector is shown it is scrolled to selected month --%>
    monthSelectorPopup.setAfterShowHandler(
            function(){

                <%-- Get "selected month" and "month container" elements --%>
                var month = document.getElementById("selectedMonth");
                var container = document.getElementById("monthSelectorContainer");

                <%-- Maximum top position is total container height minus visible area height --%>
                var maxScrollTop = container.scrollHeight - container.clientHeight;

                <%-- Calculate scroll top; top of month element - (half of visible area - half of month height) --%>
                var scrollTop = month.offsetTop - (container.clientHeight - month.clientHeight) / 2;

                <%-- If calculated scroll top does not spans out lower and upper limits use its value otherwise
                    appropriate limit value is used--%>
                container.scrollTop = (scrollTop < 0) ? 0 : ((scrollTop > maxScrollTop) ? maxScrollTop : scrollTop);
            }
            );
    /**
     * Shows month selector popup if popup popupnot visible and hide if visible
     */
    function showOrHideMonthSelectorPopup(offsetX, offsetY){
        if(!monthSelectorPopup.isVisible())
            monthSelectorPopup.show(offsetX, offsetY);
        else
        {
            monthSelectorPopup.hide();
        }
    }

    function handleMonthChange(year, month)
    {
        <%-- Hide month selector popup --%>
        monthSelectorPopup.hide();

        <%= request.getParameter("changeHandler")%>(year, month);
    }

</script>

<div id="monthSelectorPopup" style="position:absolute; display:none; z-index:1001; width:160px;">
    <div class="monthSelectorContainer" id="monthSelectorContainer">
    <table border="0" cellspacing="0" cellpadding="2" width="100%">
        <colgroup>
            <col width="40%"/>
            <col width="60%"/>
        </colgroup>
    <%
        for(int year=startYear; year<=endYear; year++){

            for(int i=0; i<12; i++) {

                final int month = i + 1; // Month values start from one
                String monthClass;
                String onclick;
                String monthId="";

                if((year == selectedYear) && (month == selectedMonth)){

                    monthClass = "selectedMonth";
                    onclick = "monthSelectorPopup.hide()";
                    monthId = "selectedMonth";
                }
                else{

                    monthClass = "nonselectedMonth";
                    onclick = "handleMonthChange(" + year + ", " + month + ")";
                }
    %>
                <tr class="<%=monthClass%>" onclick="<%=onclick%>" onmouseover="this.className = 'highlightedMonth';"
                        onmouseout="this.className = '<%=monthClass%>'">
                    <td><%=((month == 1) ? String.valueOf(year) : "")%></td>
                    <td id="<%=monthId%>"><%=ATMessageResources.message( request, TimeUtils.getMonthNameKey(month) )%></td>
                </tr>
    <%
            }

            if(year != endYear){
    %>
                <tr class="yearSeparator">
                    <td> </td>
                    <td><hr size="1" noshade="noshade" style="color: #999999;"/></td>
                </tr>
    <%
            }
        }
    %>
    </table>
</div>
</div>
