<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>

<%--

     @param id - id of the progress bar instance. Will be used as a global var identifier.

     Usage example:

        <jsp:include page="/controls/progress_bar.jsp">
            <jsp:param name="id" value="myProgressBar"/>
        </jsp:include>

        <script>
            myProgressBar.start();
        </script>

--%>

<%
    String id = request.getParameter("id");

    int ticksCount = 11;
    int tickDelay = 389;
%>

<script language="JavaScript">

if (!window.ProgressBar)
{
    var ProgressBar = function (id)
    {
        this.id = id;
    }

    ProgressBar.prototype.start = function ()
    {
        this.showProgress(1);
    }

    ProgressBar.prototype.showProgress = function (step)
    {
        var obj = this;

        if (step <= <%=ticksCount%>)
        {
            setTimeout(
                    function ()
                        {
                            obj.getTickElem(step).style.visibility = "visible";
                            obj.showProgress(step + 1);
                        },
                    <%=tickDelay%>);
        }
        else
        {
            setTimeout(
                    function ()
                        {
                            obj.clearProgress();
                            obj.showProgress(1);
                        },
                    <%=tickDelay%>);
        }
    }

    ProgressBar.prototype.clearProgress = function ()
    {
        for (var i = 1; i <= <%=ticksCount%>; i++)
        {
            this.getTickElem(i).style.visibility = "hidden";
        }
    }

    ProgressBar.prototype.getTickElem = function (step)
    {
        return document.getElementById(this.id + "_" + step);
    }
}

var <%=id%> = new ProgressBar("<%=id%>");

</script>


<div class="progressBarContainer">
    <div class="progressBarBackground"></div>
    <table class="progressBar" cellpadding="0" cellspacing="0" border="0">
        <tr>
            <% for (int i = 1; i <= ticksCount; i++) {%>
                <td style="padding-left: <%=i!=1?"1":"0"%>px;">
                    <div class="progressBarTick" style="visibility:hidden" id='<%= id + "_" + i %>'></div>
                </td>
            <% } %>
        </tr>
    </table>
</div>

