Ext.namespace("AT");

AT.CustomerProjectSelectorOnlyProjectsPanel = Ext.extend(AT.CustomerProjectSelectorPanel, {

    customOptionLabelKey: "projects_customers_selector.selected_customers_or_projects",
    showInactiveLabelKey: "projects_customers_selector.show_archived_projects",

    getNodeRenderers: function()
    {
        var selectionHelper = this.getSelectionHelper();

        var result = {};
        result[TreeNode.TYPE_CUSTOMER] = new CustomerWithoutCheckboxNodeRenderer(this.selectorTree, this.selectorFilter, this.getExpandCollapseCallback(), selectionHelper);
        result[TreeNode.TYPE_PROJECT] = new ProjectNodeRenderer(this.selectorTree, this.selectorFilter, selectionHelper);
        result[TreeNode.TYPE_ARCHIVED_PROJECTS_PARENT] = new ArchivedProjectsParentNodeRenderer(this.selectorTree, this.selectorFilter, selectionHelper);
        result[TreeNode.TYPE_ARCHIVED_CUSTOMERS_PARENT] = new ArchivedCustomersParentNodeRenderer(this.selectorTree, this.selectorFilter, selectionHelper);
        return result;
    },

    createCpSelectorTreeBuilderObserver: function(searchIndex, allActiveSet)
    {
        return new CPSelectorTreeBuilderObserver(searchIndex, allActiveSet, false);
    },

    createEmptyMessageBuilder: function()
    {
        return new CustomerProjectSelectorOnlyProjectsEmptyMessageBuilder(this.isCustomersProjectsFiltered);
    }
})
;