<%@ page import="com.actimind.actitime.CustomersProjectsSelector" %>
<%@ page import="com.actimind.actitime.task.TaskListConstants" %>
<%@ page import="com.actimind.actitime.beans.CustomersProjectsOutputData" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%--
    @param formName - name of the cp selector form
    @param scope(optional) - scope of the form (default - "session")
--%>

<%
    String formName = request.getParameter("formName");
    String scope = request.getParameter("scope");
    if (scope == null)
    {
        scope = "session";
    }
%>
<bean:define id="form" name="<%=formName%>" scope="<%=scope%>" type="com.actimind.actitime.CustomerProjectSelectorForm"/>

<script>
    <%
            CustomersProjectsSelector cpSelector = form.getCustomersProjectsSelector();
            CustomersProjectsOutputData outputData = form.getCustomersProjectsOutputData();
    %>

    function CPSelectorServerUtil() {

    }

    CPSelectorServerUtil.getPredefinedState = function() {
        if (CPSelectorServerUtil.predefinedState) {
            return CPSelectorServerUtil.predefinedState;
        }
        var selectedCustomers = [];
        <% for (int customerId : cpSelector.getCustomers()) { %>
            selectedCustomers.push(<%=customerId%>);
        <% } %>

        var selectedProjects = [];
        <% for (int projectId : cpSelector.getProjects()) { %>
            selectedProjects.push(<%=projectId%>);
        <% } %>

        var optionValue = '<%=cpSelector.getCoarseSelection()%>';
        var showInactive = <%=cpSelector.isShowArchived()%>;

        CPSelectorServerUtil.predefinedState = {
            selection: optionValue == CoarseSelection.SPECIFIC ?
                       new TwoLevelSelection(selectedCustomers, selectedProjects) : TwoLevelSelection.emptySelection(),
            optionValue: optionValue,
            showInactive: showInactive
        };
        return CPSelectorServerUtil.predefinedState;
    };

    CPSelectorServerUtil.makePredefinedSelection = function(panel, predefinedState) {
        if (!CPSelectorServerUtil.predefinedState) {
            CPSelectorServerUtil.getPredefinedState();
        }
        var state = predefinedState || CPSelectorServerUtil.predefinedState;
        if (state.optionValue == CoarseSelection.SPECIFIC) {
            var selectedCustomers = state.selection.getFirstLevel().slice(0);
            var selectedProjects = state.selection.getSecondLevel().slice(0);
            if (selectedCustomers.length + selectedProjects.length == 1) {
                if (selectedProjects.length == 0) {
                    selectedCustomers[0] = new Customer(selectedCustomers[0], '<%=StringUtils.getStringEscapedForJS(outputData.getCustomerName())%>',
                        <%=!outputData.isSingleSelectedEntityArchived()%>);
                } else {
                    selectedProjects[0] = new Project(selectedProjects[0], '<%=StringUtils.getStringEscapedForJS(outputData.getProjectName())%>',
                        <%=!outputData.isSingleSelectedEntityArchived()%>);
                }
            }
            return panel.getSelectionHelper().getDescription(new TwoLevelSelection(selectedCustomers, selectedProjects), undefined, state.showInactive);
        } else if (state.optionValue == CoarseSelection.ALL) {
            return panel.getAllSelectedMessage();
        } else {
            return panel.getAllActiveItemsMessage();
        }
    };

    CPSelectorServerUtil.setCpSelectorParameters = function(form, cpSelector) {
        if (cpSelector.isAlreadyShown()) {
            var selection = cpSelector.getSelection(false);

            form["<%=TaskListConstants.CP_COARSE_SELECTION_PROPERTY%>"].value = (cpSelector.isCustomOptionSelected()) ? CoarseSelection.SPECIFIC :
                                                                                ((cpSelector.isAllItemsOptionSelected()) ? CoarseSelection.ALL :
                                                                                 CoarseSelection.ALL_ACTIVE);
            form["<%=TaskListConstants.CP_SHOW_ARCHIVED_PROPERTY%>"].value = cpSelector.getShowInactive();
            form["<%=TaskListConstants.CUSTOMER_LIST_PROPERTY%>"].value = selection.getFirstLevel().join();
            form["<%=TaskListConstants.PROJECT_LIST_PROPERTY%>"].value = selection.getSecondLevel().join();
        }
    };

    CPSelectorServerUtil.createCPSelectorButton = function(panelCtr, rpcManager, buttonAdditionalConfig, panelCtrConfig, renderTo) {
        panelCtrConfig = panelCtrConfig ? panelCtrConfig : {};
        var panel = new panelCtr(
            Ext.apply({
                          isCustomersProjectsFiltered: <%=outputData.isCustomersProjectsFiltered()%>,
                          rpcManager: rpcManager
                      }, panelCtrConfig));
        var menu = new AT.SharedUserButtonMenu(
            {
                panel: panel
            });
        rpcManager.setSelectorMenu(menu);

        var config = buttonAdditionalConfig ? buttonAdditionalConfig : {};
        config.renderTo= renderTo ? renderTo : "cpSelectorButton";
        config.labelCls= "hierarchySelectorButton";
        config.menu= menu;
        config.tooltipObject= new DhtmlTitle("form-field-tooltip");

        var button = new AT.HierarchySelectorDropdownButton(config);

        button.setText(CPSelectorServerUtil.makePredefinedSelection(menu.panel));
        button.setTooltipEnabled(false);
        return button;
    };

    CPSelectorServerUtil.initSelectorInReports = function(reportName) {
        var button = CPSelectorServerUtil.createCPSelectorButton(AT.CustomerProjectSelectorTwoGenericOptionsPanel,
                                                                 new RetrieveAllCustomersProjectsRPCManager(true), null,{collapsedCookiesKey: reportName } );

        window.customerProjectSelector = button.menu.getSelectorPanel();
        window.customerProjectSelector.setSelectionChangedHandler( function() {CPSelectorClientUtil.handleChange(window.customerProjectSelector)} );
    };

    CPSelectorServerUtil.checkCustomersProjectsSelected = function(cpSelector) {
        var predifinedState = CPSelectorServerUtil.getPredefinedState();
        var isAllPredifined = predifinedState.optionValue == CoarseSelection.ALL_ACTIVE || predifinedState.optionValue == CoarseSelection.ALL;

        if ((cpSelector.isAlreadyShown() && cpSelector.isCustomOptionSelected() && cpSelector.isEmptySelection())
            || (!cpSelector.isAlreadyShown() && predifinedState.selection.isEmpty() && !isAllPredifined))
        {
            alert(messageResource.getMessage('projects_customers_selector.please_select_customer_or_project'));
            return false;
        }

        return true;
    }
</script>