<%@ page import="org.apache.struts.util.ResponseUtils"%>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.messageNoFilterArgs" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>

<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>


<bean:define id="settings" name="<%= Keys.SYSTEM_SETTINGS_LOADER %>"  property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />
<%
    /*
       This page implements DHTML-window for editing description / comments
       of tasks, customers, projects and possibly other entities.
       Parameters:
         - includeTaskDateInfo : Should be "true" only when popup is used for editing comment of
                                 tasks for specific date.
                                 Default value is "false".
         - taskName            : Name of task when includeTaskDateInfo is "true".
         - saveButtonFunction  : Function that is executed when user click on "save" button.
                                 Used when we need, for example, to save description
                                 not into database directly but store it on the page and save in
                                 database after user click "submit tt" button.
                                 Default value is "saveDescription()";
         - saveButtonTitle     : Title of save button.
                                 Uses in cases when for need, example we, use "OK" title
                                 instead of "Save".
                                 Default value: "Save";
         - currentHierarchyLevelSingularForm : Title of entity(task or subtask) in edit comment selection(task for default)
           Specifies only if includeTaskDateInfo is "true"
    */

    boolean includeTaskDateInfo = Boolean.valueOf( request.getParameter( "includeTaskDateInfo" ) );
    String taskName = null;
    String hlSuffix = null;
    if (includeTaskDateInfo) {
        taskName = (String) session.getAttribute("taskName");
        session.removeAttribute("taskName");
        hlSuffix = request.getParameter("hlSuffix");
        if (hlSuffix == null)
            hlSuffix = "task";
    }

    hlSuffix = StringUtils.capitalizeFirstLetter( hlSuffix );

    String saveButtonFunction = request.getParameter("saveButtonFunction");
    if (saveButtonFunction == null)
        saveButtonFunction = "saveDescription()";

    String saveButtonTitle = request.getParameter("saveButtonTitle");
    if (saveButtonTitle == null)
        saveButtonTitle = message( request, "common.save");
%>
<script type="text/javascript">
    function handleDescriptionChange(owner)
    {
        if (editDescriptionState)
            editDescriptionState.textLengthNote.update(owner.value);
    }
</script>

<div id="editDescriptionPopup" class="customPopup" style="position:absolute; display:none;">
    <table cellspacing="0" cellpadding="0" border="0" width="100%">
        <tr>
            <td class="lightPopupHeader">
                <div class="dhtml_popup_title" id="editDescriptionPopupTitle">&nbsp;</div>
                <span id="closeEditDescriptionPopupActiveSpan" class="closeButton">
                    <a href="#" onclick="editDescriptionPopup.hide(); return false;">
                        <at:img page="dialogs/comments/close.png" border="0" title='<%=message(request, "task.description_popup.close_title")%>' width="17" height="17" align="absmiddle"/>
                    </a>
                </span>
                <span id="closeEditDescriptionPopupDisabledSpan" class="closeButton" style="display:none">
                    <at:img page="dialogs/comments/close_grayed.png" border="0" width="17" height="17" align="absmiddle"/>
                </span>
                <hr/>
            </td>
        </tr>
        <tr>
            <td class="popupContent">
                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                    <%if(includeTaskDateInfo && taskName != null){%>
                        <tr>
                            <td style="padding-bottom: 8px;">
                                <table border=0 cellpadding=0 cellspacing=0>
                                    <tr>
                                        <td class="formblocktitle" valign=top><%=message( request, "common." + hlSuffix )%>:&nbsp;</td>
                                        <td class="formfieldtitle"><%= ResponseUtils.filter(StringUtils.trimWithDots(taskName, 45 - messageNoFilterArgs( request, "common." + hlSuffix ).length())) %></td>
                                    </tr>
                                    <tr>
                                        <td class="formblocktitle" valign=top><bean:message key="common.date"/>:&nbsp;</td>
                                        <td class="formfieldtitle"><span id='editPopupCommentDate'></span></td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    <%}%>
                    <tr>
                        <td>
                            <div id="editDescriptionPopupEditingState" style="text-align: center;"><textarea
                               name="comment" wrap="virtual" style="width: 257px; height: 80px"
                               id="editDescriptionPopupText" tabindex="7" class="controlBorder"
                               onkeyup="handleDescriptionChange(this)"
                               onpaste="handleDescriptionChange(this)"
                               onblur="handleDescriptionChange(this)"
                                    >&nbsp;</textarea></div>
                            <div id="editDescriptionPopupSavingState" style="display: none; padding: 50px 0;" align="center" class="text"><bean:message key="common.popup.saving"/></div>
                            <div id="editDescriptionPopupLoadingState" style="display: none; padding: 50px 0;" align="center" class="text"><bean:message key="common.popup.loading"/></div>
                        </td>
                    </tr>
                    <tr>
                        <td style="padding: 5px 0 0 2px;">
                            <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                <tr>
                                    <td style="padding-right: 2px;">
                                        <jsp:include page="/textarea_length_note.jsp">
                                            <jsp:param name="message_pattern" value="textarea_length_note.short"/>
                                        </jsp:include>
                                    </td>
                                    <td>
                                        <div id="editDescriptionPopupButtons" style="display: none; text-align: right; white-space: nowrap;">
                                            <input type="button" class="infobutton" style="margin-right: 2px;" value="  <%=saveButtonTitle%>  " id="scbutton" name="nscbutton" onclick="<%=saveButtonFunction%>;" tabindex="8">
                                            <input type="button" class="infobutton" value="<bean:message key="common.cancel"/>" onclick="editDescriptionPopup.hide();" name="nccbutton" tabindex="9">
                                        </div>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</div>
