<%@ page import="com.actimind.actitime.util.jsHelper"%>
<%@ page import="com.actimind.common.licensing.License"%>
<%@ page import="com.actimind.common.licensing.LicenseKeysLoader"%>
<%@ page import="com.actimind.common.licensing.LicenseWithKey"%>
<%@ page import="com.actimind.common.util.Client"%>
<%@ page import="com.actimind.common.util.ClientMap"%>
<%@ page import="com.actimind.common.util.ThreadConnection"%>
<%@ page import="org.json.JSONObject"%>
<%@ page import="java.sql.SQLException"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.List"%>
<%@ page contentType="application/json;charset=UTF-8" language="java" %>
<%
    if (request.getMethod().equals("GET"))
    {
        String code = request.getParameter("code_client");
        if (code == null)
        {
            response.sendError(400);
        }
        else if (code.equals("-not-found"))
        {
            response.sendError(404);
        }
        else if (code.equals("-internal-error"))
        {
            response.sendError(500);
        }
        else if (code.equals("-break-server"))
        {
            out.println("~!@#$%^&*()_+");
        }
        else
        {
            Client client = ClientMap.getClient(code);
            if (client != null)
            {
                try
                {
                    ThreadConnection.connectAndSet(client);

                    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
                    SimpleDateFormat dateTimeFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

                    JSONObject json = new JSONObject();
                    List<LicenseWithKey> licensesFromDatabase = new LicenseKeysLoader().loadLicensesWithKeysFromDatabase();
                    for(int i = 0; i < licensesFromDatabase.size(); i++)
                    {
                        LicenseWithKey licenseWithKey = licensesFromDatabase.get(i);
                        if (!licenseWithKey.isCompatible())
                            continue;

                        License license = licenseWithKey.getLicense();
                        JSONObject licenseJson = new JSONObject();
                        licenseJson.put(License.ID_FIELD, license.getId());
                        licenseJson.put(License.REPLACES_ID_FIELD, license.getReplacesId());
                        if (license.getStartDate() != null)
                            licenseJson.put(License.START_DATE_FIELD, dateFormat.format(license.getStartDate()));
                        if (license.getExpirationDate() != null)
                            licenseJson.put(License.EXPIRATION_DATE_FIELD, dateFormat.format(license.getExpirationDate()));
                        if (license.getNextLicStartDate() != null)
                            licenseJson.put(License.NEXT_LIC_START_DATE_FIELD, dateFormat.format(license.getNextLicStartDate()));
                        if (license.getIssueDate() != null)
                            licenseJson.put(License.ISSUE_DATE_FIELD, dateTimeFormat.format(license.getIssueDate()));
                        licenseJson.put(License.TRIAL_FLAG_FIELD, license.isTrial());
                        licenseJson.put(License.EDITION_NAME_FIELD, license.getEditionName());
                        licenseJson.put(License.EDITION_CODE_FIELD, license.getEditionCode());
                        licenseJson.put(License.VERSION_FIELD, license.getVersion());
                        licenseJson.put(License.AGREEMENT_PDF_FILE_NAME_FIELD, license.getAgreementFileName());
                        licenseJson.put(License.SIGNER_EMAIL_FIELD, license.getEmail());
                        licenseJson.put(License.SIGNER_FIRST_NAME_FIELD, license.getFirstName());
                        licenseJson.put(License.SIGNER_LAST_NAME_FIELD, license.getLastName());
                        licenseJson.put(License.COMPANY_NAME_FIELD, license.getCompanyName());
                        licenseJson.put(License.CONTEXT_NAME_FIELD, license.getContextName());
                        licenseJson.put(License.USERS_NUMBER_FIELD, license.getAllowedActiveUsersNumber());
                        licenseJson.put(License.PRODUCT_FIELD, license.getProduct());
                        licenseJson.put(License.FEATURES_FIELD, license.getFeaturesString());
                        licenseJson.put(License.CUSTOM_FEATURES_FIELD, license.getCustomFeaturesString());
                        json.put(String.valueOf(i), licenseJson);
                    }

                    out.println(jsHelper.toJSON(json));
                }
                catch (Exception e)
                {
                    e.printStackTrace();
                    response.sendError(500);
                }
                finally
                {
                    try
                    {
                        ThreadConnection.cleanupAndRemove();
                    }
                    catch (SQLException e)
                    {
                        e.printStackTrace();
                    }
                }
            }
            else
            {
                response.sendError(404);
            }
        }
    }
    else
    {
        response.sendError(405);
    }
%>
