<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="com.actimind.common.integration.IntegrationData" %>
<%@ page import="com.actimind.common.ProductWebSiteURLs" %>
<%@ page import="com.actimind.actiplans.pastleaves.PastLeaveRequestsProcessType" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="tiles" uri="http://struts.apache.org/tags-tiles" %>

<%
    Product product = ( Product ) request.getAttribute( Keys.PRODUCT );
    ProductWebSiteURLs anotherSiteUrls = ProductWebSiteURLs.get( product.otherProduct() );
    boolean isAT = product == Product.actiTIME;
    String productClass =  isAT ? "at" : "ap";
%>

<table class="dialog-header">
    <tr>
        <td class="lightBoxTitle">
            <bean:message key="integration.title"/>
        </td>
        <td class="close-button">
            <div id="closeIntegrationPopupButton" class="closeButton"></div>
        </td>
    </tr>
</table>
<div class="innerContent <%=productClass%>">
    <div class="productInfo">
        <div class="productLogo">
            <% if ( isAT ) { %>
            <at:img page="integration/ap-logo.png"/>
            <% } else { %>
            <at:img page="integration/at-logo.png"/>
            <% } %>
        </div>
        <bean:message key="integration.about_info"/>
        <div id="productInfoLink">
            <a href="<%=anotherSiteUrls.getWebSiteURL()%>" target="_blank"><bean:message key="integration.visit_for_info"/></a>
        </div>
    </div>
    <table cellspacing="0" cellpadding="0" class="integrationContent">
        <tr>
            <td>
                <div class="integrationSection" id="currentProductIntegration">
                <div class="integrationState accountDoesNotExist">
                    <div class="iconsWithIntegrate">
                        <span class="currentProductIcon"></span>
                        <span class="integrationIcon"></span>
                        <span class="otherProductIcon"></span>
                    </div>
                    <span class="integrateProductLinkText"><bean:message key="integration.integrate_other_product"/></span>
                    <span class="hasRights">
                        <span class="additionalInfoText"><bean:message key="integration.start_using.synchronized_items"/></span>
                    </span>
                    <span class="noRights">
                         <span class="additionalInfoText"><bean:message key="integration.no_rights"/></span>
                    </span>
                </div>
                <div class="integrationState accountCreating">
                    <div class="spinnerPlaceholder" id="integrationSpinnerPlaceholder"></div>
                    <span class="creatingAccountText"><bean:message key="integration.creating_account"/></span>
                </div>
                <div class="integrationState accountActive">
                    <div class="iconsWithIntegrate">
                        <span class="currentProductIcon"></span>
                        <span class="integrationIcon"></span>
                        <span class="otherProductIcon"></span>
                    </div>
                    <span class="accountAvailableText"><bean:message key="integration.account_available"/></span>
                                <a class="trialUrl" href="#" target="_blank">
                                    <span class="productUrl"></span><span class="contextName"></span>
                                </a>
                    <span class="additionalInfoText"><bean:message key="integration.account_available.at_address"/></span>
                </div>
                <div class="integrationState accountExpired">
                    <div class="iconsWithIntegrate">
                        <span class="currentProductIcon"></span>
                        <span class="integrationIcon"></span>
                        <span class="otherProductIcon"></span>
                    </div>
                    <span class="purchase integrateProductLinkText"><bean:message key="integration.license_expired"/></span>
                    <span class="renew integrateProductLinkText"><bean:message key="integration.license_renew"/></span>
                    <span class="hasRights">
                        <div class="additionalInfoText renew"><bean:message key="integration.renew.info"/></div>
                        <div class="additionalInfoText purchase"><bean:message key="integration.purchase.info"/></div>
                    </span>
                    <span class="noRights">
                        <span class="additionalInfoText renew"><bean:message key="integration.renew.no_rights"/></span>
                        <span class="additionalInfoText purchase"><bean:message key="integration.purchase.no_rights"/></span>
                    </span>
                    <div class="applyButton" id="renewButton">
                        <span class="renew"><bean:message key="integration.renew.button.text"/></span>
                        <span class="purchase"><bean:message key="integration.purchase.button.text"/></span>
                    </div>
                </div>
                    <% if (!isAT){ %>
                    <div class="integrationState pastRequestsNotApproved">
                        <div class="spinnerPlaceholder"></div>
                        <span class="creatingAccountText"><bean:message key="integration.creating_account"/></span>
                        <span class="errorText"><bean:message key="integration.past_requests.info_text"/></span>
                        <div class="radioButtons">
                            <div class="approveButton">
                                <input type="radio" id="approvePastRequests" name="pastRequestOperation" checked
                                       value="<%=PastLeaveRequestsProcessType.AUTOMATICALLY_APPROVE_PAST_LEAVES%>">
                                <label for="approvePastRequests"> <bean:message key="integration.past_requests.approve"/></label>
                            </div>
                            <div class="rejectButton">
                                <input type="radio" id="rejectPastRequests" name="pastRequestOperation"
                                       value="<%=PastLeaveRequestsProcessType.AUTOMATICALLY_REJECT_PAST_LEAVES%>">
                                <label for="rejectPastRequests"> <bean:message key="integration.past_requests.reject"/></label>
                            </div>
                        </div>
                        <div class="buttons">
                            <div class="cancelButton" ><bean:message key="integration.button.cancel"/></div>
                            <div class="applyButton"><bean:message key="integration.past_requests.button.apply"/></div>
                        </div>
                    </div>
                    <%}%>
                <div class="integrationState accountError">
                    <div class="integrationError">
                        <span class="mainErrorText"><bean:message key="integration.js.error.internal_error.main"/></span>
                        <span class="additionalErrorText"><bean:message key="integration.js.error.internal_error.additional_text"/></span>
                    </div>
                </div>
                    </div>
            </td>
            <td>
                <div  class="integrationSection" id="independentIntegration">

                <div class="integrationState accountDoesNotExist">
                    <div class="iconsWithIntegrate">
                        <span class="otherProductIcon"></span>
                    </div>
                    <span class="integrateProductLinkText"><bean:message key="integration.integrate_trial_other_product"/></span>
                    <span class="additionalInfoText"><bean:message key="integration.start_using.no_data"/></span>
                </div>

                <div class="integrationState nameAccountContext">
                        <div class="smallOtherProductIcon"></div>
                        <div class="integrateProductLinkText">
                            <bean:message key="integration.independent.button.text"/>
                        </div>
                        <table class="contextNameInputContainer" cellspacing="0" cellpadding="0">
                            <tr>
                                <td><span class="productUrl"></span></td>
                                <td><input type="text" id="contextNameInput" maxlength="20"/></td>
                            </tr>
                        </table>
                        <div class="contextNameError"></div>
                        <div class="buttons">
                           <div class="cancelButton"><bean:message key="integration.button.cancel"/></div>
                           <div class="applyButton"><bean:message key="integration.input_name.button.start"/></div>
                        </div>
                </div>
                <div class="integrationState accountCreating">
                    <div class="spinnerPlaceholder" id="independentTrialSpinnerPlaceholder"></div>
                    <span class="creatingAccountText"><bean:message key="integration.creating_account"/></span>
                </div>
                <div class="integrationState accountActive">
                    <div class="iconsWithIntegrate">
                        <span class="otherProductIcon"></span>
                    </div>
                    <span class="accountAvailableText"><bean:message key="integration.independent_account_available"/></span>
                    <a class="trialUrl" href="#" target="_blank">
                        <span class="productUrl"></span><span class="contextName"></span>
                    </a>
                    <span class="additionalInfoText"><bean:message key="integration.independent_account_available.at_address"/></span>
                </div>
                    <div class="integrationState accountError">
                        <div class="integrationError">
                            <span class="mainErrorText"><bean:message key="integration.js.error.internal_error.main"/></span>
                            <span class="additionalErrorText"><bean:message key="integration.js.error.internal_error.additional_text"/></span>
                        </div>
                    </div>
                </div>
            </td>
        </tr>
    </table>
    <table cellspacing="0" cellpadding="0" class="integrationAgreement">
        <tr>
            <td>
                <input type="checkbox" id="integrationAgreementCheckbox" checked="checked">
            </td>
            <td>
                <label for="integrationAgreementCheckbox">
                    <bean:message key="integration.agreement_label"/>
                </label>
                <a href="<%=anotherSiteUrls.getTrialServiceAgreementURL()%>" target="_blank"><bean:message key="integration.service_agreement"/></a>
            </td>
        </tr>
    </table>
</div>

<script type="text/javascript">
    var IntegrationStates = {};
    IntegrationStates.ACCOUNT_DOES_NOT_EXIST = "<%=IntegrationData.IntegrationState.DOES_NOT_EXIST%>";
    IntegrationStates.ACCOUNT_ACTIVE = "<%=IntegrationData.IntegrationState.ACTIVE%>";
    IntegrationStates.ACCOUNT_EXPIRED = "<%=IntegrationData.IntegrationState.EXPIRED%>";
    IntegrationStates.ACCOUNT_CREATING = "Creating";
    IntegrationStates.ACCOUNT_ERROR = "Error";
    IntegrationStates.ACCOUNT_INSERT_NAME ="AccountInsertName";
    IntegrationStates.REQUESTS_IN_PAST_NOT_APPROVE = "requestsInPastNotApproveError";

    var IntegrationPopupErrorMessages = {};
    IntegrationPopupErrorMessages.EMPTY_CONTEXT_NAME = '<%=jsMessage(request, "integration.js.error.empty_address")%>';
    IntegrationPopupErrorMessages.WRONG_CONTEXT_NAME_FORMAT = '<%=jsMessage(request, "integration.js.error.wrong_address_format")%>';
    IntegrationPopupErrorMessages.CONTEXT_NAME_EXISTS = '<%=jsMessage(request, "integration.js.error.address_already_exists")%>';
    IntegrationPopupErrorMessages.COMMUNICATION_ERROR = '<%=jsMessage(request, "integration.js.error.hms_pvs_communication_error")%>';
    IntegrationPopupErrorMessages.NO_RIGHT_FOR_INTEGRATION = '<%=jsMessage(request, "integration.js.error.no_rights_for_integration")%>';
    IntegrationPopupErrorMessages.USER_ALREADY_HAS_TRIAL = '<%=jsMessage(request, "integration.js.error.user_already_has_trial")%>';
    IntegrationPopupErrorMessages.USER_WITHOUT_EMAIL = '<%=jsMessage(request, "integration.js.error.user_without_email")%>';
</script>
