function BalanceHistoryPanel () {}

BalanceHistoryPanel.prototype.init = function()
{
    var that = this;
    this.dialogDiv = $("#userBalanceHistoryDiv");
    this.wrapperClass = "UserBalanceHistoryDiv";
    this.linkDiv = this.dialogDiv.find("#exportToPDFLinkDiv");
    this.balanceHistoryForm = document.getElementById("BalanceHistoryForm" );

    this._balanceHistoryDialog = new DropdownDialog({
                                                           wrapperClass: this.wrapperClass,
                                                           dialogDiv: this.dialogDiv,
                                                           hideButtons: true,
                                                           hideOnResize: true,
                                                           showEmptyTitleBar : false,
                                                           onClose: function() {
                                                               if (that.closeCallback) that.closeCallback();
                                                           }
                                                       });

    this.dialogDiv.find(".closeButton img" ).click( function() { that.hide(); } );

    return this;
};

BalanceHistoryPanel.prototype.setOnCloseCallback = function (closeCallback)
{
    this.closeCallback = closeCallback;
};

BalanceHistoryPanel.prototype.updateTitle = function(message){
    this.dialogDiv.find(".userBalanceHistoryTitle" ).html(message);
};

BalanceHistoryPanel.prototype.showAt = function (element, params)
{
    if( !params ) params = {};
    if( !params.collision ) params.collision = "fit flip";
    this._balanceHistoryDialog.showAt(element, params);
};

BalanceHistoryPanel.prototype.hide = function()
{
    this._balanceHistoryDialog.hide();
};

BalanceHistoryPanel.prototype.updateLinkState = function(recordsLength, userId, balanceType)
{
    if (recordsLength == 0)
        this.linkDiv.hide();
    else
    {
        this.balanceHistoryForm.userId.value = userId;
        this.balanceHistoryForm.balanceType.value = balanceType;
        this.linkDiv.show();
    }
};