function ChangeWeekApprovalStatusMediator ()
{
    this.constructor = ChangeWeekApprovalStatusMediator;
}

ChangeWeekApprovalStatusMediator.prototype.getWeekStatusHistory = function ( userId, dateFrom, dateTo, successCallback, errorCallback )
{
    var self = this;
    makeRpcCall(
            'EnterTTService.getTTAHistory',
            [userId, dateFrom, dateTo],
            function (historyResult) {
                successCallback(historyResult.list);
            },
            function ( jqXHR, textStatus, errorThrown ) {
                errorCallback();
                if( errorThrown.exception == 'com.actimind.actitime.services.FeatureIsDisabledException' )
                {
                    alert( messageResource.getMessage( 'userlist.js.error_tta_feature_disabled' ) );
                    reloadSubmitTTPageWithoutFormReloading();
                    return true;
                }
                else if ( errorThrown.exception == 'com.actimind.actitime.services.EnterTTService$NoRightsToViewUserTTAHistory' )
                {
                    alert( messageResource.getMessage( 'change_week_approval_status.error.no_rights_to_view_history', [self.formatUserInfo()] ) );
                    reloadSubmitTTPageWithoutFormReloading();
                    return true;
                }
                return self.commonErrorHandler(jqXHR, textStatus, errorThrown);
            }
    );
};

ChangeWeekApprovalStatusMediator.prototype.commonErrorHandler = function ( jqXHR, textStatus, errorThrown )
{
    if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' ||
        errorThrown.exception == 'com.actimind.actitime.administration.UserIsDisabledException' ||
        errorThrown.exception == 'com.actimind.actitime.services.NoRightsForRemoteCallException' )
    {
        reloadSubmitTTPageWithoutFormReloading();
        return true;
    }
    else if ( errorThrown.exception == 'com.actimind.actitime.services.DateBeforeHireDateException' )
    {
        alert(messageResource.getMessage('change_week_approval_status.error.before_hire_date', [this.formatUserInfo()]));
        reloadSubmitTTPageWithoutFormReloading();
        return true;
    }
    else if ( errorThrown.exception == 'com.actimind.actitime.administration.NoRightsToApproveUser' )
    {
        alert(messageResource.getMessage("change_week_approval_status.error.user_not_managable_anymore", [this.formatUserInfo()]));
        reloadSubmitTTPageWithoutFormReloading();
        return true;
    }
    else if( errorThrown.exception == 'com.actimind.actitime.administration.TimeTrackChangedException' )
    {
        alert( messageResource.getMessage( 'change_week_approval_status.error.time_track_changed_alert' ) );
        document.SubmitTTForm.pageAction.value = '';
        submitSubmitTTForm();
        return true;
    }
};
