function CustomCheckbox($containerEl)
{
    TemplateView.call(this, $containerEl);
    this.checked = false;
}

CustomCheckbox.prototype = _.create(TemplateView.prototype, {
    afterRender: function()
    {
        this.bindClick(function() { this.setChecked(!this.checked); })
    },

    update: function()
    {
        this.$el.toggleClass("checked", this.checked);
    },

    isChecked: function()
    {
        return this.checked;
    },

    setChecked: function(checked)
    {
        if (this.checked != checked)
        {
            this.checked = checked;
            this.update();
            $(this).trigger("check", this.checked);
        }
    }
});