function DropdownTemplateView($containerEl)
{
    TemplateView.call(this, $containerEl);
}

DropdownTemplateView.prototype = _.create(TemplateView.prototype, {

    showAt: function($element, positionParams, $positionEl)
    {
        if (!$positionEl)
            $positionEl = $element;

        // prevent next showing if closed by mouse down to $element
        if (this.ignoreNextShowing)
        {
            this.ignoreNextShowing = false;
            return;
        }

        var ie8 = isIE8();
        if (ie8)
        {
            this.lastWindowWidth = $(window).width;
            this.lastWindowHeight = $(window).height;
        }

        this.$containerEl.on("mousedown.dropdownList", $.proxy(this._mouseDownHandler, this));
        $(window).on("resize.dropdownList", $.proxy(ie8 ? this._resizeIE8Handler : this._resizeHandler, this));

        this.update();// update before show

        this.$elementShowAt = $element;
        positionParams = positionParams || {};
        positionParams.of = $positionEl;
        this.$el.show();
        showElementAt(this.$el, positionParams);
        if (!this.isShown)
        {
            this.isShown = true;
            this.onShow();
        }
    },

    onShow: function()
    {
        KeyDownHandler.setOnKeyDownHandler($.proxy(this._keyDownHandler, this));
    },

    onHide: function()
    {
        KeyDownHandler.restoreOnKeyDownHandler();
    },

    hide: function()
    {
        if (this.isShown)
        {
            this.isShown = false;
            this.$el.hide();

            this.$containerEl.off("mousedown.dropdownList");
            $(window).off("resize.dropdownList");
            this.$containerEl.off("keydown.dropdownList");
            this.onHide();
        }
    },

    _resizeHandler: function()
    {
        this.hide();
    },

    _resizeIE8Handler: function()
    {
        if ($(window).width() != this.lastWindowWidth || $(window).height() != this.lastWindowHeight)
        {
            this.lastWindowWidth = $(window).width();
            this.lastWindowHeight = $(window).height();
            this.hide();
        }
    },

    _scrollHandler: function()
    {
        this.hide();
    },

    _keyDownHandler: function(event)
    {
        if (this.isShown)
        {
            switch (event.keyCode)
            {
                case KEY_CODE_ESC:
                case KEY_CODE_TAB:
                    this.hide();
                    cancelBubble(event.originalEvent);
                    return false;
            }
        }
    },

    _mouseDownHandler: function(event)
    {
        if (this.isShown)
        {
            var target = event.target;
            while (target)
            {
                if (target == this.$elementShowAt[0])
                {
                    this.ignoreNextShowing = true;
                }
                if (target == this.$el[0])
                {
                    cancelBubble(event);
                    return false;
                }
                target = target.parentElement;
            }
            cancelBubble(event);
            this.hide();
            event.preventDefault();
        }
    }
});
