function EditTaskCustomerProjectSelector() {

}

EditTaskCustomerProjectSelector.prototype = new CustomerProjectSelectorForTaskPopup();

EditTaskCustomerProjectSelector.prototype.MAX_PROJECT_LABEL_LENGTH = 55;
EditTaskCustomerProjectSelector.prototype.PROJECT_NOT_SELECTED = -1;

EditTaskCustomerProjectSelector.prototype.init = function( containerId, customerSelectorContainerId, projectSelectorContainerId,
                                                           customers, projects, selectedCustomerId, selectedProjectId,
                                                           changesCallback, scrollableContainer )
{
    CustomerProjectSelectorForTaskPopup.prototype.init.call(this, containerId, customerSelectorContainerId, projectSelectorContainerId,
                                                            customers, projects, selectedCustomerId, selectedProjectId,
                                                            changesCallback, scrollableContainer, true, "editTaskCustomerProjectSelector" );

    return this;
};

EditTaskCustomerProjectSelector.prototype.addCustomCustomerItems = function( items ) {
    // no custom items
};

EditTaskCustomerProjectSelector.prototype.addCustomProjectItems = function( items )
{
    items.push( {
                    text: messageResource.getEscapedMessage( "task.edit_popup.option.select_project" ),
                    value: this.PROJECT_NOT_SELECTED
                } );
};

EditTaskCustomerProjectSelector.prototype.createListSelector = function( items, containerEl, selectorCls, changeCallback, selectedValue )
{
    var listSelector = CustomerProjectSelectorForTaskPopup.prototype.createListSelector.call(this, items, containerEl,
                                                                                             selectorCls, changeCallback, selectedValue );

    var handler = function()
    {
        var value = listSelector.getSelectedItem().value;
        //$( containerEl ).addClass("notSelected");
    };

    listSelector.on( "change", function () {
        handler();
    });

    handler();

    return listSelector;
};

EditTaskCustomerProjectSelector.prototype.createProjectList = function( projects )
{
    if ( !projects || projects.length == 0 )
        return;

    var self = this;
    var table = document.createElement( "table");
    for ( var i=0; i < projects.length; i++ )
    {
        var project = projects[i];
        var row = document.createElement( "tr");

        var labelCell = document.createElement( "td");
        $( labelCell ).html( "<label for='projectName" + project.id + "'>" + escapeHtmlSymbols( project.name ) + "</label>" );
        if ( project.name.length > this.MAX_PROJECT_LABEL_LENGTH )
            $( labelCell ).attr( 'title', escapeHtmlSymbols( project.name ) );

        row.appendChild( labelCell );
        table.appendChild( row );
    }
    this.projectListContainer.appendChild( table );
};

EditTaskCustomerProjectSelector.prototype.customerChanged = function()
{
    var customerValue = this.getSelectedCustomerId();

    if ( this.customerHasProjects( customerValue ) ) {
        this.loadCustomerProjects();
    } else {
        this.projectButton.setActiveItemByValue( this.PROJECT_NOT_SELECTED );
    }
};

EditTaskCustomerProjectSelector.prototype.projectChanged = function()
{
    var customerValue = this.getSelectedCustomerId();
    var projectValue = this.getSelectedProjectId();

    var customerId = this.findProjectCustomerId( projectValue );
    if( customerId != customerValue ){
        this.customerButton.setActiveItemByValue( customerId );
        this.loadCustomerProjects();
    }
};

EditTaskCustomerProjectSelector.prototype.loadCustomerProjects = function()
{
    var projects = CustomerProjectSelectorForTaskPopup.prototype.loadCustomerProjects.call(this);

};

EditTaskCustomerProjectSelector.prototype.validate = function()
{
    return !this.hasErrors();
};

EditTaskCustomerProjectSelector.prototype.hasErrors = function()
{
    //noinspection LoopStatementThatDoesntLoopJS
    for( var prop in this.errors ) {
        if( this.errors[prop] == true )
            return true;
    }
    return false;
};

EditTaskCustomerProjectSelector.prototype.isProjectSelected = function()
{
    return this.getSelectedProjectId() != this.PROJECT_NOT_SELECTED;
};

EditTaskCustomerProjectSelector.prototype.addProjectNotSelectedError = function()
{
    //this.addError( CreateTasksCustomerProjectSelectorErrors.PROJECT_NOT_SELECTED );
};

EditTaskCustomerProjectSelector.prototype.removeProject = function( projectId )
{
    for ( var i=0; i < this.projects.length; i++ )
    {
        if ( this.projects[i].id == projectId )
        {
            this.projects.splice( i, 1 );
            break;
        }
    }

    this.createProjectSelector( this.projects );
};

EditTaskCustomerProjectSelector.prototype.removeAllProjectsOfSelectedCustomer = function()
{
    var customerValue = this.getSelectedCustomerId();
    if ( !this.isConcreteCustomerId( customerValue ) )
    {
        this.setProjectsAndUpdateSelector( null );
    }
    else
    {
        for ( var i=0; i < this.projects.length; i++ )
        {
            if ( this.projects[i].customerId == customerValue )
                this.projects.splice( i, 1 );
        }

        this.createProjectSelector( this.projects );
    }
};
