function LoadingMoire($containerEl, additionalSpinnerSettings, animated, delay)
{
    // TODO: too many parameters, wrap them into config.
    TemplateView.call(this, $containerEl);
    this.additionalSpinnerSettings = additionalSpinnerSettings;
    this.animated = _.isBoolean(animated) ? animated : true;
    // TODO: accept showAnimated/hideAnimated in initial config
    this.showAnimated = this.animated;
    this.hideAnimated = this.animated;
    this.delay = delay;
}

LoadingMoire.prototype = _.create(TemplateView.prototype, {
    html: "<div class='loadingMoire'>" +
          "  <div class='spinnerPlaceholder'></div>" +
          "</div>",

    useUnderscoreTemplate: false,

    afterRender: function()
    {
        this.$el.hide();
        this.$spinnerPlaceholder = this.find(".spinnerPlaceholder");
        this.spinnerController = new SpinnerController(true);
        var spinnerSettings = SpinnerController.getDefaultSettings();
        spinnerSettings = _.extend(spinnerSettings, this.additionalSpinnerSettings);
        this.spinnerController.setSpinner(new Spinner(spinnerSettings));
    },

    show: function()
    {
        clearTimeout(this._showOpaqueTimeout);
        this._showOpaqueCalled = false;

        if (this.delay)
        {
            var self = this;
            this._showTransparent();
            this._showOpaqueTimeout = setTimeout(function() { self._showOpaque() }, this.delay);
        }
        else
        {
            this._showOpaque();
        }
    },

    hide: function()
    {
        clearTimeout(this._showOpaqueTimeout);

        if (this.hideAnimated && this._showOpaqueCalled)
            this.$el.atAnimation().fadeOut();
        else
            this.$el.hide();

        this.spinnerController.stop();
    },

    _showTransparent: function()
    {
        this.$el.addClass("transparent");
        this.$el.show();
    },

    _showOpaque: function()
    {
        this.$el.removeClass("transparent");
        this._showOpaqueCalled = true;
        if (this.showAnimated)
            this.$el.atAnimation().fadeIn();
        else
            this.$el.show();
        this.spinnerController.spinInElement(this.$spinnerPlaceholder);
    }
});