var operationConfirmDlg = null;

function highlightText(text) {
    return '<span class="highlightText">' + text + '</span>';
}

function highlightNumber(number) {
    return '<span class="highlightNumber">' + number + '</span>';
}

function OperationConfirmDlg() {
    this.confirmDlgDiv = $("#operationConfirmDialogDiv");
    this.dialogInnerDiv = this.confirmDlgDiv.find(".confirmDialogInnerDiv");
    this.dialogTable = this.confirmDlgDiv.find(".confirmDialogTable");
    this.header = this.confirmDlgDiv.find(".header");
    this.message = this.confirmDlgDiv.find(".confirmMessage");
    this.attention = this.confirmDlgDiv.find(".operationAttention");
    this.confirmButton = this.confirmDlgDiv.find(".confirmDialogApplyButton");
    this.confirmAnotherButton = this.confirmDlgDiv.find(".confirmDialogApplyAnotherButton");
    this.cancelButton = this.confirmDlgDiv.find(".confirmDialogCancelButton");

    this.onConfirm = undefined;
    this.attentionTitleText = "";
}

OperationConfirmDlg.prototype.open = function(doNotShowMoire) {
    KeyDownHandler.setOnKeyDownHandler(function(evt) {handleEscape(function(){operationConfirmDlg.close();}, evt);});
    var that = this;
    this.withoutMoireMode = doNotShowMoire ? true : false;
    if (!this.withoutMoireMode)
        showMoire("moireDiv", "container");

    this.confirmDlgDiv.show();
    this.positionDlg();
    window.setTimeout(function () { try { that.confirmButton.focus(); } catch(e){} }, 200);
};

OperationConfirmDlg.prototype.confirmClick = function() {
    this.close();
    if (this.onConfirm)
        this.onConfirm( 1 );
};

OperationConfirmDlg.prototype.confirmAnotherClick = function() {
    this.close();
    if (this.onConfirm)
        this.onConfirm( 2 );
};

OperationConfirmDlg.prototype.cancelClick = function() {
    this.close();
    if (this.onCancel)
        this.onCancel();
};

OperationConfirmDlg.prototype.close = function() {
    KeyDownHandler.restoreOnKeyDownHandler();
    this.confirmDlgDiv.hide();
    if (!this.withoutMoireMode)
        hideMoire("moireDiv");

    if (this.onClose)
        this.onClose();
};

OperationConfirmDlg.prototype.positionDlg = function() {
    var top = getBodyScrollTop();
    this.confirmDlgDiv.css({ top: (top)+'px' });
    this.dialogInnerDiv.css({"margin-top": (-this.dialogTable.height()/2)+'px'});
    this.dialogTable.width(this.width);
    this.dialogInnerDiv.width(this.dialogTable.width());
    this.dialogInnerDiv.height(this.dialogTable.height());
};

OperationConfirmDlg.prototype.initWithDataAsConfirmDeletionDialog = function(isAttention, headerText, confirmButtonsCaptions, deletingItemsDescription, attentionText, onConfirm)
{
    if (this.attentionTitleText == "") {
        this.attentionTitleText = messageResource.getMessage( "operation.confirm.dialog.attention" );
    }
    this.dialogTable.toggleClass("attention", isAttention);
    this.attention.get(0).innerHTML = (isAttention ? "<div class='attention'>" + this.attentionTitleText + "</div>" : "") + attentionText;

    this.initWithData(  headerText,
                        confirmButtonsCaptions,
                        messageResource.getMessage("delete.confirm.dialog.about_to_delete", [ deletingItemsDescription ]),
                        messageResource.getMessage("common.cancel"),
                        {onConfirm: onConfirm},
                        false, false );
};

OperationConfirmDlg.prototype.initWithData = function(headerText, confirmButtonsCaptions, confirmMessage, cancelButtonCaption, handlers, hideExclamationMarkSection, smallDialog)
{
    this.header.html(headerText);
    this.confirmButton.prop('value', confirmButtonsCaptions[0]);
    if( confirmButtonsCaptions[1] )
    {
        this.confirmAnotherButton.show();
        this.confirmAnotherButton.prop( 'value', confirmButtonsCaptions[1] );
    }
    else
    {
        this.confirmAnotherButton.hide();
        this.confirmAnotherButton.prop( 'value', '' );
    }
    this.message.html(confirmMessage);
    this.cancelButton.prop('value', cancelButtonCaption);
    this.onConfirm = handlers.onConfirm;
    this.onCancel = handlers.onCancel;
    this.onClose = handlers.onClose;
    this.dialogInnerDiv.toggleClass("hideExclamationMarkSection", hideExclamationMarkSection);
    this.dialogInnerDiv.toggleClass("smallDialog", smallDialog);
};
