function PDFGeneratorUtil() {}

PDFGeneratorUtil.prototype = _.create(Object.prototype, {
    /**
     * Download last generated pdf from browser to client
     * Filesaver.js are used
     */
    downloadPDF: function(encodedPDF, fileName)
    {
        var blob;
        try
        {
            blob = new Blob([encodedPDF], {type: 'application/pdf'});
        }
        catch (e)
        {
            // Old browser which can't handle it without making it an byte array (ie10)
            if (e.name == "InvalidStateError")
            {
                var byteArray = new Uint8Array(encodedPDF);
                blob = new Blob([byteArray.buffer], {type: 'application/pdf'});
            }
        }
        if (blob)
        {
            saveAs(blob, fileName); // used FileSaver.js library
        }
        else
        {
            throw 'Could not generate blob';
        }
    }

});
