function PageMediator() {}

PageMediator.prototype = {
    init: function()
    {
        return this;
    },

    getPage: function()
    {
        // Abstract
    },

    openPage: function()
    {
        if (!this._openedPageBefore)
        {
            this.beforeOpenPageFirstTime();
            this._openedPageBefore = true;
        }
        this.beforeOpenPage();

        this.getPage().show();
        this.getPage().$el.atAnimation().fadeIn();
    },

    leavePage: function()
    {
        if (this._openedPageBefore)
        {
            this.beforeLeavePage();
            this.getPage().hide();
            this.getPage().$el.atAnimation().fadeOut();
        }
    },

    beforeOpenPageFirstTime: function()
    {
        // Abstract
    },

    beforeOpenPage: function()
    {
        // Abstract
    },

    beforeLeavePage: function()
    {
        // Abstract
    },

    showAlertAndReloadPage: function(msgKey)
    {
        alert(messageResource.getMessage(msgKey));
        window.location.reload();
        return true;
    },

    abortRpcCall: function(rpc)
    {
        if (!_.isUndefined(rpc))
        {
            rpc.abort();
        }
    }
};
