function SimpleListMenuButton($containerEl, config)
{
    TemplateView.call(this, $containerEl);
    config = config || {};
    this.emptySelectionMessageKey = config.emptySelectionMessageKey;
    this.emptyListMessageKey = config.emptyListMessageKey;
    this.itemHtmlCallback = config.itemHtmlCallback;
}

SimpleListMenuButton.prototype = _.create(TemplateView.prototype, {
    html: "<div class='simpleListMenuButton'>" +
          "  <div class='title'></div>" +
          "  <div class='downIcon'>&nbsp;</div>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        this.$title = this.find(".title");
        this.menu = new SimpleListMenu($("body"), this.itemHtmlCallback).init();
        this.menu.on("itemClick", function(e, item)
        {
            self._selectItem(item);
            $(self).trigger("select", item);
        });
        this.$el.click(function()
                       {
                           if (self.getItems().length > 0)
                           {
                               self.menu.$el.width(self.$el.width());
                               self.menu.showAt(self.$el)
                           }
                       });
        this.setItems([]);
    },

    getSelectedItem: function()
    {
        return this.selectedItem
    },

    getItems: function()
    {
        return this.menu.getItems()
    },

    setItems: function(items, selectedItem)
    {
        this.menu.setItems(items, selectedItem);
        this.$el.toggleClass("empty", items.length === 0);
        this.$el.toggleClass("notEmpty", items.length > 0);
        this._selectItem(selectedItem);
    },

    _selectItem: function(item)
    {
        if (!item)
        {
            if (this.getItems().length > 0)
            {
                this.$title.text(messageResource.getMessage(this.emptySelectionMessageKey));
            }
            else
            {
                this.$title.text(messageResource.getMessage(this.emptyListMessageKey));
                this.$el.addClass("emptyList");
            }
            this.$el.addClass("emptySelection");
        }
        else
        {
            this.$title.text(this.menu.itemHtmlCallback(item));
            this.$el.removeClass("emptySelection");
        }

        this.selectedItem = item;
    },

    getMenu: function()
    {
        return this.menu;
    }
});