function Toasts($containerEl)
{
    TemplateView.call(this, $containerEl);
    this.toasts = {};
    this.idSequence = 0;
}

Toasts.prototype = _.create(TemplateView.prototype, {
    html: "<div class='toasts'></div>",

    templateKey: "Toasts",

    addToastWithHtml: function(html)
    {
        var self = this;

        var toast = new Toast(this.$el, html).init();
        toast.id = this.idSequence++;
        this.toasts[toast.id] = toast;

        toast.show();
        toast.on("hide", function(e)
        {
            delete self.toasts[e.target.id];
        });
    },

    addToastWithText: function(text)
    {
        this.addToastWithHtml(escapeHtmlSymbols(text));
    }
});

Toasts.getInstance = function()
{
    if (!Toasts.instance)
        Toasts.instance = new Toasts($("body")).init();
    return Toasts.instance;
};

Toasts.addToastWithHtml = function(html)
{
    Toasts.getInstance().addToastWithHtml(html);
};

Toasts.addToastWithText = function(text)
{
    Toasts.getInstance().addToastWithText(text);
};

function Toast($containerEl, innerHtml, timeout)
{
    TemplateView.call(this, $containerEl);
    this.innerHtml = innerHtml;
    this.timeout = timeout || 5000;
}

Toast.prototype = _.create(TemplateView.prototype, {
    html: "<div class='toast' style='display: none'>" +
          "  <span class='innerHtml'><%=innerHtml%></span><br/>" +
          "</div>",

    templateKey: "Toast",

    show: function()
    {
        var self = this;
        this.$el.atAnimation().fadeIn();
        setTimeout(function()
                   {
                       self.$el.atAnimation().fadeOut(function()
                                                      {
                                                          self.$el.remove();
                                                          $(self).trigger("hide");
                                                      })
                   }, this.timeout);
    }
});