function ActivationPageController() {}

ActivationPageController.prototype.init = function()
{
    this.form = document.getElementById( "activationForm" );

    this.newPasswordText = document.getElementById( "newPwd" );
    this.newPasswordConfirmText = document.getElementById( "newPwdConfirm" );
    this.newPasswordField = document.getElementById( "newPassword" );

    this.errorMessagesArea = $("#errorMessagesArea" );
    this.whiteBoxBody = $( "#whiteBoxWithLogoBody" );

    $(this.newPasswordText).attr('placeholder', messageResource.getMessage("activation_page.password_field.placeholder")).placeholder();
    $(this.newPasswordConfirmText).attr('placeholder', messageResource.getMessage("activation_page.confirm_password_field.placeholder")).placeholder();

    var self = this;

    this.activationButton = $("#activationButton");
    this.activationButton.click( function() {
        self.submitForm();
    });

    $(this.newPasswordText).keyup( function() { self.hideError() });
    $(this.newPasswordConfirmText).keyup( function() { self.hideError() });

    return this;
};

ActivationPageController.prototype.submitForm = function()
{
    if ( this.inProgress )
        return;

    this.setInProgressState();

    var errorMessage = this.validate();
    if( errorMessage )
    {
        this.showError( errorMessage );
        this.setNormalState();
        return;
    }

    this.newPasswordField.value = MD5( $(this.newPasswordText).pVal() );
    this.clearInputs();
    this.form.submit();
};

ActivationPageController.prototype.clearInputs = function()
{
    $(this.newPasswordText).pVal("");
    $(this.newPasswordConfirmText).pVal("");
};

ActivationPageController.prototype.validate = function()
{
    var password = $(this.newPasswordText).pVal();
    var passwordConfirm = $(this.newPasswordConfirmText).pVal();
    if( !(password.length > 0) )
        return messageResource.getMessage("activation_page.error.password_empty", [], true);

    if( !(password == passwordConfirm) )
        return messageResource.getMessage("activation_page.error.passwords_do_not_match", [], true);

    return null;
};

ActivationPageController.prototype.showError = function( errorMessage )
{
    this.errorMessagesArea.find( "#errorSpan" ).html( errorMessage );
    this.errorMessagesArea.show();
};

ActivationPageController.prototype.hideError = function()
{
    this.errorMessagesArea.hide();
};

ActivationPageController.prototype.setInProgressState = function()
{
    this.inProgress = true;
    this.whiteBoxBody.addClass( "inProgress" );
};

ActivationPageController.prototype.setNormalState = function()
{
    this.inProgress = false;
    this.whiteBoxBody.removeClass( "inProgress" );
};