/**
 * Created by evdokimov on 02.06.2016.
 */

function LoadTasksFromCSVPopup()
{
    DHTMLPopupWithMoire.call(this, "loadTasksFromCSVPopup");
}

function _DropzoneStrategy(contentEl, dropzone)
{
    this.contentEl = contentEl;
    this.dropzone = dropzone;
}

_DropzoneStrategy.prototype.removeAllFiles = function()
{
    this.isReloadState = false;
    this.dropzone.removeAllFiles();
    this.dropzone.multipleFileLoad = false;
};

_DropzoneStrategy.prototype.reloadFile = function()
{
    this.isReloadState = true;

    var file = this.dropzone.getAcceptedFiles()[0];
    if (!file)
    {
        file = this.dropzone.getRejectedFiles()[0];
    }
    this.dropzone.uploadFile(file);
};

_DropzoneStrategy.prototype.removeImportedFile = function()
{
    this.dropzone.removeAllFiles();
};
_DropzoneStrategy.prototype.getSelectedFilesNumber = function()
{
    return this.dropzone.files.length;
};

function _DropzoneFallbackStrategy(reloadCallback, uploadCallback, container)
{
    this.reloadCallback = reloadCallback;
    this.uploadCallback = uploadCallback;
    this.container = container;
    this.fileSelected = true;
}

_DropzoneFallbackStrategy.prototype.removeAllFiles = function()
{
    this.isReloadState = false;
    this.fileSelected = false;
    this.container.empty();
    this.reloadCallback();
};

_DropzoneFallbackStrategy.prototype.removeImportedFile = function()
{
    this.fileSelected = false;
};
_DropzoneFallbackStrategy.prototype.getSelectedFilesNumber = function()
{
    return this.fileSelected ? 1 : 0;
};

_DropzoneFallbackStrategy.prototype.reloadFile = function()
{
    this.isReloadState = true;
    this.container.empty();
    this.uploadCallback();
};


LoadTasksFromCSVPopup.prototype = _.create(DHTMLPopupWithMoire.prototype, {
    hideOnMouseDown: _.constant(false),
    hideOnResize: _.constant(false),
    hideOnEscape: _.constant(true),

    innerId: function(id)
    {
        return "#" + this.popupId + id;
    },

    innerElement: function(id)
    {
        return $(this.innerId(id));
    },

    init: function(uploadCSVActionUrl, onCSVLoadSuccessCallback, completeImportCallback, successTaskCreationCallback, fileRemovedCallback)
    {
        this.popupEl = this.innerElement("");
        this.choseFileContent = this.innerElement("_fileContent");
        this.resultContent = this.innerElement("_resultContent");

        var closeFn = _.bind(this.hide, this);
        $("#closeLoadTasksFromCSVPopupButton").click(closeFn);
        this.innerElement("_cancelBtn").click(closeFn);

        this.completeImportCallback = completeImportCallback;
        this.importButton = this.innerElement("_commitBtn");
        this.importButton.click(_.bind(this.completeImport, this));

        this.innerContent = this.innerElement("_innerContent");
        this.dropZoneEl = this.innerElement("_dropzone");
        this.slideWrapper = this.innerElement("_slideWrapper");
        this.successLinkContainer = $("#successLinkContainer");
        this.failsLinkContainer = $("#failsLinkContainer");
        this.importPreviewSection = $("#importPreviewSection");
        this.buttonsSection = this.innerElement("_buttonsSection");
        this.importingProgressBarContainer = this.innerElement("_importingProgressBarContainer");
        this.dynamicProgressBar = this.importingProgressBarContainer.find(".dynamicProgressBar");
        this.importingProgressText = this.importingProgressBarContainer.find(".improtingProgressText");

        this.fallbackInput = $("#dropzoneFailbackSelector");

        this.initDropzone(uploadCSVActionUrl, onCSVLoadSuccessCallback);

        this.innerElement("_startNewImport").click(_.bind(this.restartImport, this));

        this.modificationsMade = false;
        this.successTaskCreationCallback = successTaskCreationCallback;
        this.fileRemovedCallback = fileRemovedCallback;

        this.infoPopup = new InfoPopup("loadTasksFromCSVInfoPopup").init(this);
        $("#infoLink").click(this.wrapEventHandler(_.bind(this.infoPopup.show, this.infoPopup)));

        return this;
    },

    /**
     * Prevent event handling if rendering is not complete
     * Used when we not cover elements by moire
     * @param {Function} handler
     * @returns {Function}
     */
    wrapEventHandler: function(handler) {
        return _.bind(function(event) {
                if(this.renderingComplete === false)
                     return;
                return handler(event);
            }, this);
    },

    startRendering: function() {
        if(this.renderingTimeOutId) {
            window.clearTimeout(this.renderingTimeOutId);
            this.finishRenderingBinded();
        }
        this.renderingComplete = false;
    },

    finishRendering: function() {
        this.renderingComplete = true;
        this.renderingTimeOutId = null;
    },

    /**
     * Remove moire on loading for {@link #finishRenderingDeferred}
     */
    removeLoadingMoire: function() {
        this.innerContent.removeClass("renderingInProgress");
    },

    /**
     * Remove moire on reloading for {@link #finishRenderingDeferred}
     */
    removeReloadingMoire: function() {
        this.innerContent.removeClass("reloadingInProgress");
        this.slideWrapper.find(".reloadCSVMoire").removeClass("animate");
    },

    /**
     * Indicate finishing of loading CSV data after processing current event queue
     */
    finishRenderingDeferred: function(removeMoire) {
        this.finishRenderingBinded = _.bind(function() {
            this.finishRendering();
            removeMoire.call(this);
        },this);
        this.renderingTimeOutId = setTimeout(this.finishRenderingBinded, 50);
    },

    switchToResult: function()
    {
        this.dropzoneStrategy.removeImportedFile();
        this.choseFileContent.hide();
        this.resultContent.show();
        this.toggleImportingProcessScreen(false);
        this.modificationsMade = true;
    },

    switchToImportFile: function()
    {
        this.choseFileContent.show();
        this.resultContent.hide();
    },

    toggleImportEnabled: function(enabled)
    {
        this.importEnabled = enabled;
        this.importButton.toggleClass("disabled", !enabled);
    },

    completeImport: function()
    {
        if (!this.importEnabled)
            return;

        var self = this;
        this.toggleImportingProcessScreen(true);
        var errorCallback = function()
        {
            self.toggleImportingProcessScreen(false);
            return false;
        };
        this.completeImportCallback(_.bind(this.switchToResult, this), errorCallback, _.bind(this.progressFrame, this));
    },

    restartImport: function()
    {
        this.removeAllFiles();
        this.switchToImportFile();
    },

    showInnerContent: function(showTableLinks)
    {
        this.failsLinkContainer.toggle(showTableLinks);
        this.successLinkContainer.toggleClass("showTableLinks", showTableLinks);
        this.importPreviewSection.addClass("visible");
        this.buttonsSection.addClass("visible");
    },

    hideInnerContent: function()
    {
        this.failsLinkContainer.hide();
        this.importPreviewSection.removeClass("visible");
        this.buttonsSection.removeClass("visible");
    },

    toggleImportingProcessScreen: function(show)
    {
        this.importingInProgress = show;
        this.popupEl.toggleClass("importingInProgress", show);
        this.innerContent.toggleClass("importingInProgress", show);
        if (!show)
            this.progressFrame(0);
    },

    initDropzone: function(uploadCSVActionUrl, onCSVLoadSuccessCallback)
    {
        var self = this;
        this.onCSVLoadSuccessCallback = onCSVLoadSuccessCallback;

        var multipleUploadErr = messageResource.getMessage("common.multiple_upload_error");
        var responseError = JQUERY_RPC_ERROR_MESSAGES.NETWORK_ERROR;

        var dropzoneTemplate = document.querySelector('#dropzoneTemplate').innerHTML;
        this.dropzone = new Dropzone(this.innerId("_dropzone"), {
            previewTemplate: dropzoneTemplate,
            url: uploadCSVActionUrl,
            maxFilesize: 10,
            createImageThumbnails: false,
            maxFiles: 1,
            dictMaxFilesExceeded: multipleUploadErr,
            dictResponseError: responseError,
            clickable: "#dropzoneClickableArea",
            success: _.bind(self.dropzoneSuccess, self),
            accept: function(file, done)
            {
                if (this.files.length == 1)
                    done();
                else
                    done(multipleUploadErr);
            },
            error: function(file, result)
            {
                if (result == multipleUploadErr)
                {
                    //noinspection JSJQueryEfficiency
                    $(".dz-details").hide();
                    if (!this.multipleFileLoad)
                        alert(multipleUploadErr);

                    this.multipleFileLoad = true;
                    this.removeFile(file);
                    //noinspection JSJQueryEfficiency
                    $(".dz-details").show();
                    return;
                }
                
                if (result == responseError) 
                {
                    if (self.dropzoneStrategy.isReloadState)
                    {
                        alert(messageResource.getMessage("import_csv_tasks.error.connection_error"));
                        self.innerContent.removeClass("reloadingInProgress");
                        self.slideWrapper.find(".reloadCSVMoire").removeClass("animate");
                    }
                    else
                    {
                        alert(responseError);
                        self.removeAllFiles();
                    }

                    return;
                }

                var msg = (self.dropzoneStrategy.isReloadState && result.indexOf("Stream ended unexpectedly") > 0) ?
                          "import_csv_tasks.error.reload_failed" :
                          "import_csv_tasks.error.loading_failed";

                alert(messageResource.getMessage(msg));
                self.removeAllFiles();
            },
            /*forceFallback: true,*/
            fallback: _.bind(this.dropzoneFallback, this, uploadCSVActionUrl, onCSVLoadSuccessCallback, dropzoneTemplate)
        });

        this.dropzone.on("addedfile", _.bind(this.setDropzoneTemplateHandlers, this));
        this.dropzone.on("removedfile", function()
        {
            self.dropzone.setupEventListeners();
        });
    },

    processBigData: function (bigDataHandler) {
        if (!bigDataHandler)
            return;
        
        if (!this.hidingInProgress)
            bigDataHandler();
        else
            this.fileRemovedCallback();
    },
    
    dropzoneSuccess: function(file, resultStr)
    {
        if (this.hidingInProgress)
            return;
        
        this.dropzone.removeEventListeners();
        var resultJson = JSON.parse(resultStr);

        var successObj = this.onCSVLoadSuccessCallback(resultJson);
        var success = successObj.success;
        var bigDataHandler = successObj.handler;

        if (!success)
        {
            this.removeAllFiles();
        }

        if (this.dropzoneStrategy.isReloadState)
        {
            this.startRendering();
            this.processBigData(bigDataHandler);
            this.finishRenderingDeferred(this.removeReloadingMoire);
            return;
        }

        if (!success)
            return;

        var self = this;
        if (!bigDataHandler)
        {
            this.renderingComplete = true;
            this.dropZoneElAnimated = this.dropZoneEl.atAnimation();
            this.dropZoneElAnimated.oneAnimationEnd(function(event)
                                                          {
                                                              self.dropZoneEl.removeClass("fileLoading collapsing").addClass("fileSelected");
                                                              event.stopPropagation();
                                                          });
            this.dropZoneEl.addClass("collapsing");
            this.setInnerContent(file);
        }
        else
        {
            this.startRendering();
            this.dropZoneEl.removeClass("fileLoading collapsing").addClass("fileSelected");
            var bigDataSprinner = new Spinner({length: 5, width: 2, radius: 4, lines: 10, color: '#aaaaaa', trail: 60});
            var spinnerEl = document.getElementById("bigDataSpinner");
            bigDataSprinner.spin(spinnerEl);

            this.innerContent.addClass("renderingInProgress");
            this.setInnerContent(file);
            setTimeout(function()
                       {
                           self.processBigData(bigDataHandler);
                           bigDataSprinner.stop();
                           self.finishRenderingDeferred(self.removeLoadingMoire);
                       }, 50);
        }
    },

    setInnerContent: function(file)
    {
        this.slideWrapper.addClass("visible");
        this.importingProgressText[0].innerHTML = escapeHtmlSymbols(messageResource.getMessage("import_csv_tasks.importing_from", [file.name]));
    },

    animateMoireOverTable: function()
    {
        this.innerContent.addClass("reloadingInProgress");
        this.slideWrapper.find(".reloadCSVMoire").addClass("animate");
    },

    reloadFile: function()
    {
        this.animateMoireOverTable();
        this.dropzone.setupEventListeners();
        this.dropzoneStrategy.reloadFile();
    },

    dropzoneFallback: function(uploadCSVActionUrl, onCSVLoadSuccessCallback, dropzoneTemplate)
    {
        var dropzone = this.dropZoneEl;
        dropzone.addClass("fallback");

        var container = $("#dropzoneFailbackFileContainer");

        var input = this.fallbackInput;
        input[0].innerHTML = "<input name='file' type='file' />";
        var inputEl = input.find('input[type=file]');

        var form = $('<form action="' + uploadCSVActionUrl + '" method="post" enctype="multipart/form-data" target="iframe-name"></form>');
        inputEl.before('<iframe name="iframe-name" src="#" style="display:none;"></iframe>').wrap(form).delay(1500);

        if (_.isUndefined(this.fallbackSpinner))
            this.fallbackSprinner = new Spinner({length: 5, width: 2, radius: 4, lines: 10, color: '#aaaaaa', trail: 60});

        var self = this;
        var spinnerEl = document.getElementById("dropzoneFailbackSelectorSpinner");
        var uploadFn = function()
        {
            var fileName = $(this).val();
            if (!fileName)
                return;

            var isReload = !_.isUndefined(self.dropzoneStrategy) && self.dropzoneStrategy.isReloadState;

            if (isReload)
                self.animateMoireOverTable();
            else
                dropzone.addClass("fileLoading");

            self.fallbackSprinner.spin(spinnerEl);

            var parent = inputEl.parent();
            parent.submit();
            parent.prev().one('load',
                              function()
                              {
                                  self.fallbackSprinner.stop();
                                  var formEl = $(this).next()[0];
                                  self.hideCallback = function() {formEl.reset();};

                                  if (self.hidingInProgress)
                                      return;
                                  
                                  try
                                  {
                                      var result = $(this).contents().find('body').html();
                                  }
                                  catch (e)
                                  {
                                      alert(JQUERY_RPC_ERROR_MESSAGES.NETWORK_ERROR);
                                      self.innerContent.removeClass("reloadingInProgress");
                                      self.removeAllFiles();
                                      return;
                                  }

                                  self.innerContent.removeClass("reloadingInProgress");

                                  var successObj = onCSVLoadSuccessCallback(JSON.parse(result));
                                  var bigDataHandler = successObj.handler;
                                  if (!successObj.success)
                                  {
                                      self.removeAllFiles();
                                      return;
                                  }

                                  self.renderingComplete = false;
                                  self.processBigData(bigDataHandler);

                                  dropzone.removeClass("fileLoading").addClass("fileSelected");
                                  self.innerContent.removeClass("reloadingInProgress");
                                  self.slideWrapper.addClass("visible");
                                  self.renderingComplete = true;
                              });

            container.append(dropzoneTemplate);
            var fileNameShort = fileName.replace(/^.*[\\\/]/, '');
            container.find(".dz-filename")[0].innerHTML = escapeHtmlSymbols(fileNameShort);
            self.importingProgressText[0].innerHTML = escapeHtmlSymbols(messageResource.getMessage("import_csv_tasks.importing_from", [fileNameShort]));
            container.find(".dz-progress").addClass("dz-complete");

            if (!isReload)
                self.dropzoneStrategy = new _DropzoneFallbackStrategy(function()
                                                                      {
                                                                          self.dropzoneFallback(uploadCSVActionUrl, onCSVLoadSuccessCallback, dropzoneTemplate);
                                                                      }, _.bind(uploadFn, this), container);
            self.setDropzoneTemplateHandlers();
        };

        inputEl.off().change(uploadFn);

        this.fallbackInput.removeClass("fileSelected fileLoading");
    },

    progressFrame: function(percent)
    {
        if (percent <= 100)
            this.dynamicProgressBar.width(percent + '%');
    },

    setDropzoneTemplateHandlers: function()
    {
        if (_.isUndefined(this.dropzoneStrategy))
            this.dropzoneStrategy = new _DropzoneStrategy(this.innerContent, this.dropzone);

        if (this.dropzoneStrategy.getSelectedFilesNumber() > 1)
            return;

        this.dropZoneEl.addClass("fileLoading");
        this.dropZoneEl.find(".dz-remove").click(_.bind(this.removeAllFiles, this));
        this.dropZoneEl.find(".dz-reload").click(_.bind(this.reloadFile, this));
    },

    removeAllFiles: function()
    {
        if (this.dropzoneStrategy)
            this.dropzoneStrategy.removeAllFiles();

        this.fileRemovedCallback();

        this.hideInnerContent();
        this.innerContent.removeClass("reloadingInProgress");
        this.dropZoneEl.find(".dz-upload").width(0);
        this.dropZoneEl.removeClass("fileSelected fileLoading");
        this.slideWrapper.removeClass("visible");
        this.fallbackInput.removeClass("fileSelected");
        this.importingInProgress = false;
    },

    show: function()
    {
        this.hidingInProgress = false;
        this.removeAllFiles();
        this.hideInnerContent();

        ExitConfirmationHandlersManager.setUpExitConfirmation(messageResource.getMessage("import_csv_tasks.error.confirm_close"), 
                                                              _.bind(this.isFileSelected, this), false);
        
        DHTMLPopupWithMoire.prototype.show.call(this);
        if (this.dropzone)
            this.dropzone.setupEventListeners();
    },

    isModified: function () {
        return this.modificationsMade;
    },
    
    isFileSelected: function () {
        return this.renderingComplete && !_.isUndefined(this.dropzoneStrategy) && this.dropzoneStrategy.getSelectedFilesNumber() > 0;
    },
    
    hide: function()
    {
        if (this.importingInProgress)
            return;

        if (this.infoPopup.isShowed)
            return;

        if (this.isFileSelected() && !confirm(messageResource.getMessage("import_csv_tasks.error.confirm_close")))
            return;

        this.hidingInProgress = true;
        this.fileRemovedCallback();
        ExitConfirmationHandlersManager.restoreExitConfirmation();
        
        if (this.dropzone)
        {
            this.dropzone.removeEventListeners();
            this.dropzone.removeAllFiles();
        }

        if (this.innerContent) {
            this.innerContent.on(AtAnimation.getAnimationEndEventName(), stopEventPropagation);
        }

        DHTMLPopupWithMoire.prototype.hide.call(this);

        if (this.modificationsMade)
            this.successTaskCreationCallback();

        this.toggleImportingProcessScreen(false);
        this.innerContent.removeClass("reloadingInProgress");

        if (this.hideCallback)
            this.hideCallback();
    },

    onHideAnimationEnd: function()
    {
        if (this.innerContent)
            this.innerContent.off(AtAnimation.getAnimationEndEventName());
    }
});