function TaskClearLineCellRenderer()
{}

TaskClearLineCellRenderer.prototype = _.create(TableCellRenderer.prototype);

TaskClearLineCellRenderer.prototype.init = function()
{
    TableCellRenderer.call( this );
    return this;
};

TaskClearLineCellRenderer.prototype.generateContent = function( cell )
{
    var div = document.createElement( "div" );
    var img = document.createElement( "img" );
    div.appendChild(img);
    cell.clearLineImg = img;

    cell.getCellEl().appendChild( div );

    cell.getCellEl().title =  messageResource.getMessage("add_new_tasks.clear_line_tooltip");
    $( cell.getCellEl() ).click( function() {
        cell.getRow().clearLine();
    } );

    $( cell.getCellEl() ).hover( function ()
                                 {
                                     if ( cell.getRow().isModified() )
                                     {
                                         cell.getRow().highlight();
                                         $( cell.getCellEl() ).addClass( "active" );
                                     }

                                 },
                                 function ()
                                 {
                                     if ( cell.getRow().isModified() )
                                     {
                                         cell.getRow().unhighlight();
                                         $( cell.getCellEl() ).removeClass( "active" );
                                     }
                                 } );
};

TaskClearLineCellRenderer.prototype.updateUI = function( cell )
{
    TableCellRenderer.prototype.updateUI.call( this, cell );

    cell.getCellEl().title = messageResource.getMessage("add_new_tasks.clear_line_tooltip");

    if ( cell.getRow().isModified() )
    {
        cell.clearLineImg.src = defImgPath("delete_row.gif");
        cell.getCellEl().title = messageResource.getMessage("add_new_tasks.clear_line_tooltip");
    }
    else
    {
        cell.clearLineImg.src = defImgPath("delete_row_gray.gif");
        cell.getCellEl().title = '';
    }
};

TaskClearLineCellRenderer.prototype.getCellClassName = function( cell )
{
    return ["clearLineCell"];
};
