function TaskEstimateCellRenderer()
{}

TaskEstimateCellRenderer.prototype = _.create(TableCellRenderer.prototype);

TaskEstimateCellRenderer.prototype.init = function( changesCallback )
{
    TableCellRenderer.call( this );
    this.changesCallback = changesCallback;
    return this;
};

TaskEstimateCellRenderer.prototype.generateContent = function( cell )
{
    var self = this;
    var input = createElementWithProperties("input", {
        type : "text",
        value: cell.getValue(),
        maxLength : "6",
        onblur : function() {
            if( this.prevValue != this.value && !( this.prevValue === undefined && this.value == '' ) )
            {
                cell.setValue( $( this ).pVal() );
                cell.updateUI();
                self.changesCallback( cell );
                this.prevValue = this.value;
            }
        }
    });
    $( input ).addClass("inputFieldWithPlaceholder");
    $( input ).attr("placeholder", messageResource.getMessage( "add_new_tasks.task_estimate.placeholder" ));
    $( input ).placeholder();

    cell.getCellEl().appendChild( input );
    cell.estimateInput = input;
};

TaskEstimateCellRenderer.prototype.updateUI = function( cell )
{
    TableCellRenderer.prototype.updateUI.call( this, cell );
    $( cell.estimateInput ).removeClass( "error" );
    cell.estimateInput.title = '';
    if ( !cell.isEmpty() )
    {
        if( cell.isValid() )
        {
            var ttValue = UserTime.parseTimeWithSystemSettings( cell.getValue() );
            var formattedValue = UserTime.formatTime( ttValue );
            $( cell.estimateInput ).pVal( formattedValue );
        }
        else
        {
            $( cell.estimateInput ).addClass( "error" );
            cell.estimateInput.title = messageResource.getMessage( "add_new_tasks.err_invalid_budget", [SystemSettings.decimalSeparator] );
        }
    }
    else
    {
        $( cell.estimateInput ).pVal( "" );
    }
};

TaskEstimateCellRenderer.prototype.getCellClassName = function( cell )
{
    return ["estimateCell"];
};
