function TaskNameCellRenderer()
{}

TaskNameCellRenderer.prototype = _.create(TableCellRenderer.prototype);

TaskNameCellRenderer.prototype.init = function( changesCallback, checkDuplicatesCallback )
{
    TableCellRenderer.call( this );
    this.changesCallback = changesCallback;
    this.checkDuplicatesCallback = checkDuplicatesCallback;
    return this;
};

TaskNameCellRenderer.prototype.generateContent = function( cell )
{
    var self = this;
    var input = createElementWithProperties("input", {
        type : "text",
        maxLength : "191",
        onkeyup: function() {
            if( this.keyUpValue != this.value )
            {
                cell.setValue( $( this ).pVal() );
                self.changesCallback( cell );
                this.keyUpValue = this.value;
            }
        },
        onblur: function() {
            if( this.blurValue != this.value && !( this.blurValue === undefined && this.value == '' ) )
            {
                cell.setValue( $( this ).pVal().trim() );
                self.changesCallback( cell );
                self.checkDuplicatesCallback();
                this.blurValue = this.value;
            }
        },
        value: cell.getValue()
    });
    $( input ).addClass("inputFieldWithPlaceholder");
    $( input ).attr("placeholder", messageResource.getMessage( "add_new_tasks.task_name.placeholder" ));
    $( input ).placeholder();

    cell.getCellEl().appendChild( input );
    cell.nameInput = input;
};

TaskNameCellRenderer.prototype.updateUI = function( cell )
{
    TableCellRenderer.prototype.updateUI.call( this, cell );

    $( cell.nameInput ).pVal( cell.getValue() );
    if ( cell.isValid() )
    {
        $( cell.nameInput ).removeClass( "error" );
        cell.nameInput.title = '';
    }
    else
    {
        $( cell.nameInput ).addClass( "error" );
        cell.nameInput.title = cell.tooltip ? cell.tooltip : ''
    }
};

TaskNameCellRenderer.prototype.getCellClassName = function( cell )
{
    return ["nameCell"];
};
