function ChildUserRowRenderer () {
    this.constructor = ChildUserRowRenderer;
}

ChildUserRowRenderer.prototype = new ChildRowRenderer();

ChildUserRowRenderer.prototype.init = function ( conf )
{
    ChildRowRenderer.prototype.init.call(this, conf);
    this.tokensHighlightCallback = conf.tokensHighlightCallback;
    return this;
};

ChildUserRowRenderer.prototype.formatSubmitTTLinkText = function ( childRowInfo )
{
    var self = this;
    var userInfo = childRowInfo.approvalRowInfo;
    return UserNameFormat.formatLFM(self.tokensHighlightCallback(userInfo.firstName),
                                    self.tokensHighlightCallback(userInfo.lastName),
                                    self.tokensHighlightCallback(userInfo.middleName ));
};

ChildUserRowRenderer.prototype.formatSubmitTTLink = function ( link, childRowInfo, approvalRowInfo )
{
    return new ApproveTTUtil().generateSubmitTTLink(link, childRowInfo.approvalRowInfo, approvalRowInfo);
};

ChildUserRowRenderer.prototype.getWeekIdDate = function ( childRow )
{
    return childRow.parent().find(".groupingRow" ).first().data("rowInfo" ).approvalRowInfo.weekIdDate.parseJSONDate();
};

ChildUserRowRenderer.prototype.hl = function ( str )
{
    return this.tokensHighlighter.highlightTokens( str );
};
