function GroupRowRenderer ()
{
    this.constructor = GroupRowRenderer;
}

GroupRowRenderer.prototype = new RowRenderer();

GroupRowRenderer.prototype.init = function ( conf )
{
    this.groupingRowTemplate = $("#approveTTTable" ).find("tbody.templates").find("tr.groupingRow");
    return this;
};

GroupRowRenderer.prototype.createRow = function (groupingRowInfo, onCheckCallback, revokeCallback)
{
    var newRow = this.groupingRowTemplate.clone();

    this.initTitleCell( newRow, groupingRowInfo );
    this.initWorkingTimeCell( newRow, groupingRowInfo );
    this.initLeaveTimeCell( newRow, groupingRowInfo );
    this.initSelectionCell(newRow, onCheckCallback );
    newRow.data("rowInfo", groupingRowInfo);

    if (groupingRowInfo.weekApprovalStatus){
        newRow.addClass("operationWasApplied");
        newRow.addClass(this.weekApprovalStatusCaptionClass[groupingRowInfo.weekApprovalStatus]);
        this.initRevokeCell(newRow, revokeCallback);
    }
    newRow.click(function(){
        newRow.parent().toggleClass("hiddenChild");
    });

    newRow.find("td:not(:last-child)").hover( //we need to highlight expand/collapse button on row's hover event except last cell with checkbox
            function () { newRow.addClass('hoverClass') },
            function () { newRow.removeClass('hoverClass') });

    return newRow;
};

GroupRowRenderer.prototype.initTitleCell = function ()
{
    // abstract
};

GroupRowRenderer.prototype.initWorkingTimeCell = function ( row, groupingRowInfo )
{
    row.find(".workingTimeCell .duration").text(this.formatTime(!!groupingRowInfo.ttInfo ? groupingRowInfo.ttInfo.workingTime : 0));
};

GroupRowRenderer.prototype.initLeaveTimeCell = function ( row, groupingRowInfo )
{
    var totalLeaveTime = 0;
    if (groupingRowInfo.ttInfo != null && groupingRowInfo.ttInfo.leavesInfo != null){
        totalLeaveTime = groupingRowInfo.ttInfo.leavesInfo.totalLeaveTime;
    }
    row.find(".leaveTimeCell .duration").text(this.formatTime(totalLeaveTime));
};


GroupRowRenderer.prototype.updateChildRowsMapInGroupingRow = function ( groupingRow, childRowsMap )
{
    groupingRow.data( "childRowsMap", jQuery.extend( childRowsMap, groupingRow.data( "childRowsMap" ) ) );
};

GroupRowRenderer.prototype.getLastChildRow = function ( groupingRow )
{
    return $( groupingRow ).parent().find( ".childRow" ).last();
};


