function RowController()
{
    this.constructor = RowController;
}

RowController.prototype.init = function (  )
{
    return this;
};

RowController.prototype.getNumberOfChildRows = function ( groupingRow )
{
   var arr = [];
    var childRowsMap = this.getChildRowsMap(groupingRow);
    for (var key in childRowsMap) {
        if (childRowsMap.hasOwnProperty(key))
            arr.push(key);
    }
    return arr.length;
};

RowController.prototype.getChildRows = function ( groupingRow )
{
    var childRowsMap = this.getChildRowsMap(groupingRow);
    var childRows = [];

    for (var name in childRowsMap)
    {
        if( childRowsMap.hasOwnProperty( name ) )
            childRows.push(childRowsMap[name]);
    }
    return childRows;
};

RowController.prototype.getChildRowsMap = function ( groupingRow )
{
    return groupingRow.data("childRowsMap");
};

RowController.prototype.getLastChildRow = function ( groupingRow )
{
    return groupingRow.parent().find( ".childRow" ).last();
};

RowController.prototype.getRowInfo = function ( row ){
    return row.data("rowInfo");
};

RowController.prototype.getWorkingTime = function ( row ){
    return this.getRowInfo( row ).ttInfo.workingTime;
};

RowController.prototype.getOvertime = function ( row ){
    return this.getRowInfo( row ).ttInfo.overtime;
};

RowController.prototype.getLeavesInfo = function ( row ){
    return this.getRowInfo( row ).ttInfo.leavesInfo;
};

RowController.prototype.getModel = function ( row ){
    return this.getRowInfo( row ).approvalRowInfo;
};

RowController.prototype.getModelIdForChildRow = function (  ){
    //    abstract
};

RowController.prototype.getModelIdForGroupingRow = function (  ){
    //    abstract
};

RowController.prototype.getUserForChildRow = function (  ){
    //    abstract
};

RowController.prototype.getUserIdForChildRow = function (childRow) {
    return this.getUserForChildRow( childRow ).id;
};

RowController.prototype.getWeekIdForChildRow = function (  ){
    //    abstract
};

RowController.prototype.getGroupingRow = function ( childRow ){
    return childRow.parent().find( ".groupingRow" );
};

RowController.prototype.isChildRowApproved = function ( childRow )
{
    return this.getWeekApprovalStatus(childRow) == WeekApprovalStatus.APPROVED;
};

RowController.prototype.isChildRowRejected = function ( childRow )
{
    return  this.getWeekApprovalStatus(childRow) == WeekApprovalStatus.REJECTED;
};

RowController.prototype.isRowStatusNewlyChanged = function ( row )
{
    return this.getRowInfo(row).changedDirectly;
};

RowController.prototype.getWeekApprovalStatus = function ( row )
{
    return this.getRowInfo(row).weekApprovalStatus;
};

RowController.prototype.getWeekApprovalStatusTimeStamp = function ( row )
{
    return this.getRowInfo(row).statusTimestamp;
};

RowController.prototype.getUserWeekForChildRow = function ( childRow )
{
    return {
        userId: this.getUserIdForChildRow( childRow ),
        weekIdDate: this.getWeekIdForChildRow( childRow )
    };
};

RowController.prototype.isChildRowStatusChangedTogetherWithGroupingRow = function ( groupingRow, childRow )
{
    var childRowStatusTimeStamp = this.getRowInfo( childRow ).statusTimestamp;
    var groupingRowStatusTimeStamp = this.getRowInfo( groupingRow ).statusTimestamp;
    
    return childRowStatusTimeStamp != null && groupingRowStatusTimeStamp != null && childRowStatusTimeStamp == groupingRowStatusTimeStamp;
};