function ShowMoreRowRenderer ()
{
    this.constructor = ShowMoreRowRenderer;
}

ShowMoreRowRenderer.prototype = new RowRenderer();

ShowMoreRowRenderer.prototype.init = function ()
{
    this.showMoreRowTemplate = $("#approveTTTable" ).find("tbody.templates").find("tr.showMoreRow");

    return this;
};

ShowMoreRowRenderer.prototype.createRow = function ( shownCount, countLeft, onClickCallback, onDeselectedCallback )
{
    var newRow = this.showMoreRowTemplate.clone();

    $(newRow).find(".showMore").click(function(){
           if (!newRow.data("disabledWhenOperation"))
                onClickCallback()
    });

    var undoLink = newRow.find(".undoCell .undoLink");

    var self = this;
    var undoClickHandler = function(){
        var disabled = newRow.data("disabled") || newRow.data("disabledWhenOperation");
        if (!disabled){
            self.deselectRow(newRow);
            onDeselectedCallback(newRow);
        }
    };

    undoLink.click(undoClickHandler);

    this.initContent( newRow, shownCount,  countLeft);

    var topSpacer = document.createElement("tr");
    var bottomSpacer = document.createElement("tr");
    topSpacer.className = "messageRow_spacer_top";
    bottomSpacer.className = "messageRow_spacer_bottom";

    return [topSpacer, newRow, bottomSpacer];
};

ShowMoreRowRenderer.prototype.transformToMessageRow = function( showMoreRow, message )
{
    showMoreRow.find(".text" ).html( message );
    showMoreRow.find(".textWhenSelected" ).remove();
    showMoreRow.find(".showMore" ).remove();
    showMoreRow.find(".undoLink" ).remove();
};

ShowMoreRowRenderer.prototype.initContent = function ( row, shownCount,  countLeft, groupingName)
{
    var pluralGrouipingName = messageResource.getMessage("approve_tt.approve_table.show_more_row." + groupingName + "s");
    var singularGrouipingName = messageResource.getMessage("approve_tt.approve_table.show_more_row." + groupingName);
    row.find(".contentCell .text").text(messageResource.getMessage("approve_tt.approve_table.show_more_row.common_text",[countLeft,countLeft > 1? pluralGrouipingName : singularGrouipingName]));
    var totalCount = shownCount+countLeft;
    row.find(".contentCell .textWhenSelected").text(messageResource.getMessage("approve_tt.approve_table.show_more_row.selected_text",[totalCount, totalCount > 1 ? pluralGrouipingName : singularGrouipingName]));
};

ShowMoreRowRenderer.prototype.updateSelectionUI = function(row){
    var selection =  row.data("selected");
    row.toggleClass("selected",selection);
    row.find(".undoLink" ).toggleClass("disabled",row.data("disabled")== true);
};

ShowMoreRowRenderer.prototype.disableWhenOperation = function(row){
    row.data( "disabledWhenOperation", true );
    row.addClass("disabledWhenOperation");
};

ShowMoreRowRenderer.prototype.enableWhenOperation = function(row){
    row.removeData("disabledWhenOperation");
    row.removeClass("disabledWhenOperation");
};