function WeekGroupingStrategy ()
{
    this.constructor = WeekGroupingStrategy;
}

WeekGroupingStrategy.prototype = new TableGroupingStrategy();

WeekGroupingStrategy.prototype.init = function ( conf )
{
    TableGroupingStrategy.prototype.init.call(this, conf);
    return this;
};

WeekGroupingStrategy.prototype.createGroupingRowRenderer = function ( conf )
{
    return new GroupWeekRowRenderer().init( conf );
};

WeekGroupingStrategy.prototype.createRowController = function ()
{
    return new WeekGroupingRowController().init();
};


WeekGroupingStrategy.prototype.createChildRowRenderer = function (conf)
{
    return new ChildUserRowRenderer().init(conf);
};

WeekGroupingStrategy.prototype.createShowMoreRowRenderer = function ()
{
    return new ShowMoreUsersRowRenderer().init();
};

WeekGroupingStrategy.prototype.getMoreGroupingRows = function ( lastGroupingRowId,
                                                                limit,
                                                                rowsPerUserLimit,
                                                                params,
                                                                successHandler,
                                                                errorHandler,
                                                                successCallback,
                                                                errorCallback )
{
    return makeRpcCall( "ApprovalManagementService.getMoreWeekGroupingRows",
                        [lastGroupingRowId].concat( params ).concat( [limit, rowsPerUserLimit] ),
                        successCallback,
                        errorCallback
    );
};

//getMoreChildRowsForWeek( HttpServletRequest request, WeekInfoImpl groupRowId, UserInfoImpl lastChildRowId, ApproveTTFilter filter, 
//                         String[] searchTerms, SortBy sortBy, int limit, Date groupTimestamp, WeekApprovalStatus groupStatus )
WeekGroupingStrategy.prototype.getMoreChildRows = function (groupingRowId, lastChildRowId, params, limit, successHandler, errorHandler)
{
    var filter = params.filter;
    return makeRpcCall( "ApprovalManagementService.getMoreChildRowsForWeek",
                        [groupingRowId, lastChildRowId, filter[0], filter[1], filter[2], limit, params.groupTimestamp, params.groupStatus],
                        successHandler,
                        errorHandler
    );
};

//TODO Filatov nedeed refactoring parse
WeekGroupingStrategy.prototype.getGroupingRowIdFromChildRowId = function(userWeek){
    return userWeek.weekIdDate;
};

WeekGroupingStrategy.prototype.getChildRowIdFromChildRowId = function(userWeek){
    return userWeek.userId;
};

WeekGroupingStrategy.prototype.getServiceMethodForApprove = function(selection){
    if (selection.getAllRowsSelected())
        return  "ApprovalManagementService.approveAllWeeksForWeeksGrouping";
    return "ApprovalManagementService.approveWeeksForWeeksGrouping"
};

WeekGroupingStrategy.prototype.getServiceMethodForReject = function(selection){
    if (selection.getAllRowsSelected())
        return"ApprovalManagementService.rejectAllWeeksForWeeksGrouping";
    return "ApprovalManagementService.rejectWeeksForWeeksGrouping"
};

WeekGroupingStrategy.prototype.getFilterParamsForOperation = function(params){
    var paramsOperation = [];
    paramsOperation.push(params[0]);
    paramsOperation.push(params[1]);
    paramsOperation.push(params[2]);
    return paramsOperation;
};

WeekGroupingStrategy.prototype.getServiceMethodForGroupingRevoke = function(){
    return "ApprovalManagementService.revokeWeeksForWeeksGrouping";
};