function LeaveTypeATLightBox() {}

LeaveTypeATLightBox.CREATE_POPUP_DEFAULT_RATE_COEFF = 1;               // as default in SystemSettings

LeaveTypeATLightBox.prototype = _.create(LeaveTypeLightBox.prototype);

LeaveTypeATLightBox.prototype.init = function (numberSettings, iconSelectorPanel, isPtoEnabled, isSickEnabled, isUserRatesEnabled)
{
    var balancesEditPanelControllerConstructor = NoBalancesEditPanelController;
    if ( isPtoEnabled && isSickEnabled )
        balancesEditPanelControllerConstructor = LeaveTypeBalancesEditPanelController;
    else if ( isPtoEnabled )
        balancesEditPanelControllerConstructor = PtoBalanceEditPanelController;
    else if ( isSickEnabled )
        balancesEditPanelControllerConstructor = SickDaysBalanceEditPanelController;

    LeaveTypeLightBox.prototype.init.call(this, numberSettings, iconSelectorPanel, balancesEditPanelControllerConstructor);

    this.isPtoEnabled = isPtoEnabled;
    this.isUserRatesEnabled = isUserRatesEnabled;
    if (this.isUserRatesEnabled)
        this.initUserRateField();
    return this;
};

LeaveTypeATLightBox.prototype.initUserRateField = function ()
{
    var self = this;
    this.rateCoeffFieldEl = this.getElementBySubId("rateCoefficient");
    this.rateCoeffField = new DecimalField( this.rateCoeffFieldEl, true, 5, 2, this.numberSettings.decimalSeparator, false, this.numberSettings.digitGroupingSymbol, undefined, true, this.numberSettings.rateMaxNumber);
    this.rateCoeffFieldEl.onblur = function () {
        self.checkRateCoeffOnChange();
        var newValue = self.rateCoeffField.getValueAsNumber();
        if (newValue != self.rateCoeffOldValue)
        {
            self.rateCoeffOldValue = newValue;
            self.changesCallback();
        }
    };
    this.rateCoeffInvalidErrorEl = this.getElementBySubId("rateCoeffInvalidError");
    this.rateCoeffInvalidErrorEl.innerHTML = messageResource.getEscapedMessage("leave_type.error.invalid_rate_coefficient", [this.numberSettings.decimalSeparator, this.numberSettings.rateMaxNumber]);
};
LeaveTypeATLightBox.prototype.setRateCoeffFieldValue = function ( value ) {
    this.rateCoeffField.setValueAsNumber(value);
    this.rateCoeffOldValue = value;
};
LeaveTypeATLightBox.prototype.isRateCoeffValid = function( checkIfNotEmpty )
{
    return this.isCoeffValid(this.rateCoeffField, this.rateCoeffFieldEl, LeaveTypeLightBox.RATE_COEFF_EMPTY, LeaveTypeLightBox.RATE_COEFF_INVALID, checkIfNotEmpty);
};
LeaveTypeATLightBox.prototype.checkRateCoeffOnChange = function ()
{
    this.isRateCoeffValid(true);
    this.updateErrors(false);
};

LeaveTypeATLightBox.prototype.initAsCreatePopup = function ( ) {
    LeaveTypeLightBox.prototype.initAsCreatePopup.call(this);

    if (this.isUserRatesEnabled)
        this.setRateCoeffFieldValue(LeaveTypeATLightBox.CREATE_POPUP_DEFAULT_RATE_COEFF);
};

LeaveTypeATLightBox.prototype.performSpecificCheck = function () {
    return (!this.isPtoEnabled ||
           ( this.balancesEditPanel.isAsPTOChecked() ? !this.balancesEditPanel.checkEmpty() && this.balancesEditPanel.validate() : true) ) &
           (!this.isUserRatesEnabled || this.isRateCoeffValid(false));
};

LeaveTypeATLightBox.prototype.getDataToCommit = function()
{
    return  [{  id: this.leaveTypeId,
                name: this.getLeaveTypeName(),
                iconId: this.iconSelector.getIconId(),
                active: this.getStatus(),
                balanceType: this.balancesEditPanel.getBalanceType(),
                balanceCoefficient: this.balancesEditPanel.getBalanceCoefficient(),
                rateCoefficient: this.isUserRatesEnabled ? this.rateCoeffField.getValueAsNumber() : null
            }];
};
