function LeaveTypeATListPageController() {
    this.constructor = LeaveTypeATListPageController;
}

LeaveTypeATListPageController.prototype = _.create(LeaveTypeListPageController.prototype);

LeaveTypeATListPageController.prototype.init = function ( leaveTypesInfo, arrowImagesPaths, numberSettings, newLeaveTypeDefaultIconId, isPtoEnabled, isSickEnabled, isUserRatesEnabled )
{
    this.isPtoEnabled = isPtoEnabled;
    this.isSickEnabled = isSickEnabled;
    this.isUserRatesEnabled = isUserRatesEnabled;

    LeaveTypeListPageController.prototype.init.call(this, leaveTypesInfo, numberSettings, newLeaveTypeDefaultIconId);

    this.tableHeaderTooltipsOffsetParams = "-66px 4px";

    this.leaveTypeListTableController = new LeaveTypeATListTableController().init({
                                                                                    tHeadEl: this.tHeadEl,
                                                                                    containerEl: this.containerEl,
                                                                                    leaveTypeRecords: leaveTypesInfo,
                                                                                    handlersMap: this.handlersMap,
                                                                                    arrowImagesPaths: arrowImagesPaths,
                                                                                    numberSettings: this.numberSettings,
                                                                                    isPtoEnabled: this.isPtoEnabled,
                                                                                    isSickEnabled: this.isSickEnabled,
                                                                                    isUserRatesEnabled: this.isUserRatesEnabled,
                                                                                    iconSelectorPanel: this.iconSelectorPanel
                                                                                });

    return this;
};

LeaveTypeATListPageController.prototype.initializeHandlersMap = function ()
{
    var self = this;
    this.handlersMap = this.createBaseHandlersMap();
    this.handlersMap.setRateCoefficient = function (leaveTypeId, newDefaultRate, customSuccessCallback) { self.setRateCoefficient(leaveTypeId, newDefaultRate, customSuccessCallback) };
};

LeaveTypeATListPageController.prototype.createAndInitLeaveTypeLightBox = function () {
    return new LeaveTypeATLightBox().init(this.numberSettings, this.iconSelectorPanel, this.isPtoEnabled, this.isSickEnabled, this.isUserRatesEnabled);
};

LeaveTypeATListPageController.prototype.leaveTypeServiceResultHandler = function ( result, customSuccessHandler )
{
    if (!LeaveTypeListPageController.prototype.leaveTypeServiceResultHandler.call(this, result, customSuccessHandler))
    {
        PageOverlayTipsManager.getInstance().refreshDynamicTips(false);

        var newPtoEnabled = result.featuresInfo.ptoEnabled;
        var newSickEnabled = result.featuresInfo.sickEnabled;
        var newUserRatesEnabled = result.featuresInfo.userRatesEnabled;

        if( this.isPtoEnabled != newPtoEnabled )
        {
            var pto_message = newPtoEnabled ? messageResource.getMessage( "leave_type.warning.pto_feature_enabled" ) : messageResource.getMessage( "leave_type.warning.pto_feature_disabled" );
            alert( pto_message );
            window.location.reload();
        }
        else if ( this.isSickEnabled != newSickEnabled )
        {
            var sick_message = newSickEnabled ? messageResource.getMessage( "leave_type.warning.sdb_feature_enabled" ) : messageResource.getMessage( "leave_type.warning.sdb_feature_disabled" );
            alert( sick_message );
            window.location.reload();
        }
        else if( this.isUserRatesEnabled != newUserRatesEnabled )
        {
            var rates_message = newUserRatesEnabled ? messageResource.getMessage( "leave_type.warning.ura_feature_enabled" ) : messageResource.getMessage( "leave_type.warning.ura_feature_disabled" );
            alert( rates_message );
            window.location.reload();
        }
        PageOverlayTipsManager.getInstance().refreshDynamicTips();
    }
};

LeaveTypeATListPageController.prototype.leaveTypeServiceErrorHandler = function ( jqXHR, textStatus, errorThrown, customErrorHandler )
{
    LeaveTypeListPageController.prototype.leaveTypeServiceErrorHandler.call(this, jqXHR, textStatus, errorThrown, customErrorHandler);

    if ( errorThrown.exception == "com.actimind.actitime.services.FeatureIsDisabledException" )
    {
        alert(messageResource.getMessage("leave_type.error.lvt_feature_disabled"));
        ExitConfirmationHandlersManager.resetExitConfirmation();
        window.location.reload();
        return true;
    }
};

LeaveTypeATListPageController.prototype.createAndInitIconSelectorPanel = function () {
    return new LeaveTypeIconSelectorPanel().init("leaveTypeIconSelectorPanel", false);
};

LeaveTypeATListPageController.prototype.setRateCoefficient = function ( leaveTypeId, defaultRate,customSuccessCallback )
{
    this.callLeaveTypeServiceMethod("LeaveTypeService.setRateCoefficient", [leaveTypeId, defaultRate], true, customSuccessCallback);
};