function LeaveTypeATListTableController ()
{
    this.constructor = LeaveTypeATListTableController;
}

LeaveTypeATListTableController.prototype = _.create(LeaveTypeListTableController.prototype);

LeaveTypeATListTableController.prototype.init = function ( conf )
{
    this.isPtoEnabled = conf.isPtoEnabled;
    this.isSickEnabled = conf.isSickEnabled;
    this.isUserRatesEnabled = conf.isUserRatesEnabled;

    LeaveTypeListTableController.prototype.init.call(this, conf);
    return this;
};

LeaveTypeATListTableController.prototype.getLeaveTypeListTableRenderer = function () {
    return new LeaveTypeATListTableRenderer();
};

LeaveTypeATListTableController.prototype.render = function ()
{
    LeaveTypeListTableController.prototype.render.call(this);
    if (this.isPtoEnabled || this.isSickEnabled)
        this.setupTableHeaderEventHandlers();
};

LeaveTypeATListTableController.prototype.addCellsToRow = function ( row, leaveTypeRecord )
{
    row.addCellObj( this.createLeaveTypeChangeOrderCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeImageCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeNameCell(leaveTypeRecord, row) );
    if (this.isPtoEnabled || this.isSickEnabled)
    {
        row.addCellObj( this.createLeaveTypeAffectedBalanceCell( leaveTypeRecord, row ) );
    }
    if (this.isUserRatesEnabled)
    {
        row.addCellObj( this.createLeaveTypeDefaultRateCell( leaveTypeRecord, row ) );
    }
    row.addCellObj( this.createLeaveTypeStatusCell(leaveTypeRecord, row) );
    row.addCellObj( this.createLeaveTypeDeleteCell(leaveTypeRecord, row) );
};

LeaveTypeATListTableController.prototype.createLeaveTypeDefaultRateCell = function ( leaveTypeRecord )
{
    var leaveTypeDefaultRateCell = new TableCell( leaveTypeRecord );
    leaveTypeDefaultRateCell.setRenderer( new LeaveTypeDefaultRateCellRenderer().init(this.coefficientsFormatter, this.numberSettings, this.handlersMap.setRateCoefficient) );
    return leaveTypeDefaultRateCell;
};