function LeaveTypeChangeOrderCellRenderer ()
{
    this.constructor = LeaveTypeChangeOrderCellRenderer;
}

LeaveTypeChangeOrderCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeChangeOrderCellRenderer.prototype.init = function ( arrowImagesPaths, onMoveLeaveTypeCallback )
{
    TableCellRenderer.call( this );
    this.arrowImagesPaths = arrowImagesPaths;
    this.onMoveLeaveTypeCallback = onMoveLeaveTypeCallback;
    return this;
};

LeaveTypeChangeOrderCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeChangeOrderCell"];
};

LeaveTypeChangeOrderCellRenderer.prototype.generateContent = function ( cell )
{

    var moveTypeTable = document.createElement("div");
    moveTypeTable.className = "moveTypesTable";
    var that = this;

    var orderNumberDiv = document.createElement("div");
    orderNumberDiv.className ="orderNumber";

    orderNumberDiv.innerHTML = cell.getValue().position;

    cell.getCellEl().appendChild(orderNumberDiv);

    var upArrowTd = document.createElement("div");
    upArrowTd.className = "upArrow";
    var upArrowImg = document.createElement("img");
    upArrowImg.src = this.arrowImagesPaths.upArrowImagePath;
    upArrowTd.onclick = function () {
        var srcRow = cell.getRow();
        var targetRow =  srcRow.getTable().getRow(srcRow.getRowIdx()-1);
        if ( targetRow )
            that.onMoveLeaveTypeCallback(cell.value.id, targetRow.getLeaveTypeInfo().id);
    };
    upArrowTd.onmouseover = function () {
        upArrowImg.src = that.arrowImagesPaths.upArrowHoverImagePath;
    };
    upArrowTd.onmouseout = function () {
        upArrowImg.src = that.arrowImagesPaths.upArrowImagePath;
    };
    upArrowTd.appendChild(upArrowImg);
    moveTypeTable.appendChild(upArrowTd);

    var downArrowTd = document.createElement("div");
    downArrowTd.className = "downArrow";
    var downArrowImg = document.createElement("img");
    downArrowImg.src = this.arrowImagesPaths.downArrowImagePath;
    downArrowTd.onclick = function () {
        var srcRow = cell.getRow();
        var targetRow =  srcRow.getTable().getRow(srcRow.getRowIdx()+1);
        if ( targetRow )
            that.onMoveLeaveTypeCallback(cell.value.id, targetRow.getLeaveTypeInfo().id);
    };
    downArrowTd.onmouseover = function () {
        downArrowImg.src = that.arrowImagesPaths.downArrowHoverImagePath;
    };
    downArrowTd.onmouseout = function () {
        downArrowImg.src = that.arrowImagesPaths.downArrowImagePath;
    };
    downArrowTd.appendChild(downArrowImg);
    moveTypeTable.appendChild(downArrowTd);

    cell.getCellEl().appendChild(moveTypeTable);
};
