function LeaveTypeDefaultRateCellRenderer ()
{
    this.constructor = LeaveTypeDefaultRateCellRenderer;
}

LeaveTypeDefaultRateCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeDefaultRateCellRenderer.prototype.init = function ( coefficientsFormatter, numberSettings, onEditLeaveTypeDefaultRateCallback )
{
    TableCellRenderer.call( this );
    this.coefficientsFormatter = coefficientsFormatter;
    this.numberSettings = numberSettings;
    this.onEditLeaveTypeDefaultRateCallback = onEditLeaveTypeDefaultRateCallback;
    return this;
};

LeaveTypeDefaultRateCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeDefaultRateCell"];
};

LeaveTypeDefaultRateCellRenderer.prototype.generateContent = function ( cell )
{
    var self = this;

    var rateCoefficientSpan = document.createElement("span");
    rateCoefficientSpan.className = "leaveTypeInfoText";
    $(rateCoefficientSpan).html("<span style='font-weight:bold'>" + this.coefficientsFormatter.format(cell.getValue().rateCoefficient)
                                + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;x &nbsp;&nbsp;"
                                + messageResource.getMessage("leave_type.list.rate_coefficient_cell.text") );

    cell.getCellEl().onclick = function(){
        var table = cell.getTable();
        if(!table.defaultRatePopup){
            table.defaultRatePopup = new LeaveTypeDefaultRatePopup().init("LeaveTypeDefaultRatePopup",
                                                                          self.numberSettings,
                                                                          self.onEditLeaveTypeDefaultRateCallback);
        }
        table.defaultRatePopup.setLeaveType(cell.value);
        var offset = "1px -1px";
        table.defaultRatePopup.show( $(cell.getCellEl()),
                                     {my: "left top", at: "left top",  offset: offset},
                                     function(){cell.getRow().addOpenPopupClass()},
                                     function(){cell.getRow().removeOpenPopupClass()});
    };
     cell.getCellEl().appendChild( rateCoefficientSpan );
};