/**
 * Created by filatov on 01.12.2015.
 */

function LeaveTypeDefaultRatePopup(){}

LeaveTypeDefaultRatePopup.prototype.init = function(containerId, numberSettings, editHandlerCallback){
    var self = this;
    this.container = $("#" + containerId );
    this.numberSettings = numberSettings;
    this.dialog = new DropdownDialog( {
                                          wrapperClass: "leaveTypeDefaultRatePopup",
                                          dialogDiv: this.container,
                                          hideButtons: true,
                                          hideOnResize: true,
                                          showEmptyTitleBar: false,
                                          isWithBeak: false,
                                          onClose: function(){
                                              if(self.afterCloseHandler)
                                                self.afterCloseHandler()
                                         }
                                      });

    this.rateCoeffFieldEl = this.container.find(".inputDiv");
    this.rateCoeffFieldEl.on( "blur", function ()
    {
        if( self.newValue != self.rateCoeffField.getValue() && self.hasError )
            self.hideError();
    } );
    this.rateCoeffField = new DecimalField( this.rateCoeffFieldEl, true, 5, 2, this.numberSettings.decimalSeparator, false, this.numberSettings.digitGroupingSymbol, undefined, true, this.numberSettings.rateMaxNumber);

    this.applyButton = this.container.find(".applyButton");

    this.applyButton.on("click", function(){
            self.newValue = trim( self.rateCoeffField.getValue());
            self.container.removeClass("longError");
            if (self.newValue == "")
            {
                self.showError(messageResource.getMessage( "leave_type.error.rate_coefficient_required") );
                return;
            }
            if (!self.rateCoeffField.isValid()){
                self.showError(messageResource.getMessage( "leave_type.error.invalid_rate_coefficient", [self.numberSettings.decimalSeparator, self.numberSettings.ptoMaxNumber]) );
                self.container.addClass("longError");
                return;
            }
            editHandlerCallback(self.leaveType.id, self.rateCoeffField.getValueAsNumber(), function(){
                    self.dialog.hide();
                });
    });

    this.cancelButton = this.container.find(".cancelButton");
    this.cancelButton.on("click", function(){
        self.dialog.hide();
    });

    return this;
};

LeaveTypeDefaultRatePopup.prototype.setLeaveType = function(leaveType){
    this.leaveType = leaveType;
    this.rateCoeffField.setValueAsNumber(leaveType.rateCoefficient);
};

LeaveTypeDefaultRatePopup.prototype.show = function(element, positionParams, beforeShowHandler, afterCloseHandler ){
    if(beforeShowHandler)
         beforeShowHandler();
    this.afterCloseHandler = afterCloseHandler;
    this.hideError();
    this.dialog.showAt(element, positionParams);
};

LeaveTypeDefaultRatePopup.prototype.showError = function(message){
    this.container.find(".errorPlaceholder" ).text(message);
    this.container.addClass("error");
    this.hasError = true;
};

LeaveTypeDefaultRatePopup.prototype.hideError = function(){

    this.container.removeClass("error");
    this.hasError = false;
};

