function LeaveTypeDeleteCellRenderer ()
{
    this.constructor = LeaveTypeDeleteCellRenderer;
}

LeaveTypeDeleteCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeDeleteCellRenderer.prototype.init = function ( onDeleteCallBack,
                                                        deleteCellMouseOn,
                                                        deleteCellMouseMove,
                                                        deleteCellMouseOut )
{
    TableCellRenderer.call( this );
    this.onDeleteCallBack = onDeleteCallBack;
    this.mouseOn = deleteCellMouseOn;
    this.mouseMove = deleteCellMouseMove;
    this.mouseOut = deleteCellMouseOut;
    return this;
};

LeaveTypeDeleteCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeDeleteCell"];
};

LeaveTypeDeleteCellRenderer.prototype.generateContent = function ( cell )
{
    var self = this;
    var jQCell = $(cell.getCellEl());

    if (cell.value.inUse)
    {
        jQCell.off( "mouseenter mouseleave" ); // remove tooltip handlers
        jQCell.hover( function ( event )
                      {
                          self.mouseOn( {}, event );
                      },
                      function ()
                      {
                          self.mouseOut();
                      } );
        jQCell.mousemove( function ( event )
                          {
                              self.mouseMove( event );
                          }
        );
    }
    else
    {
        cell.getCellEl().onclick = function () { self.onDeleteCallBack( cell.value ) };
    }
};
