function LeaveTypeIconSelector () {
    this.constructor = LeaveTypeIconSelector;
}

LeaveTypeIconSelector.prototype.init = function ( iconSelectorPanel, changesCallback ) {
    this.iconSelectorPanel = iconSelectorPanel;
    if (changesCallback)
        this.changesCallback = changesCallback;
    return this;
};

LeaveTypeIconSelector.prototype.getSelectorEl = function ( ) {
    var self = this;
    var selectorDiv = document.createElement("div");
    selectorDiv.className = "leaveTypeIconSelector";

    var requestColorDiv = document.createElement("div");
    requestColorDiv.className = "requestColorDiv";
    this.requestColorDiv = $(requestColorDiv);
    selectorDiv.appendChild(requestColorDiv);

    var iconDiv = document.createElement("div");
    iconDiv.className = "leaveTypeIconDiv";
    var iconImg = document.createElement("img");
    this.iconImg = iconImg;
    iconDiv.appendChild(iconImg);
    selectorDiv.appendChild(iconDiv);

    var arrowDiv = document.createElement("div");
    arrowDiv.className = "arrowDiv";
    selectorDiv.appendChild(arrowDiv);

    selectorDiv.onclick = function () { self.iconSelectorPanel.initAndShow( self.currentIconId, selectorDiv,
                                                                            function ( iconId ) { self.handlePanelClicking(iconId) } ) };
    return selectorDiv;
};

LeaveTypeIconSelector.prototype.setIcon = function ( iconId ) {
    this.currentIconId = iconId;
    this.iconImg.src = getLeaveTypeIconPath( this.currentIconId );
    var newClass = "leave_icon" + iconId;
    this.requestColorDiv.removeClass();
    this.requestColorDiv.addClass("requestColorDiv "+newClass);
};

LeaveTypeIconSelector.prototype.getIconId = function ( ) {
    return this.currentIconId;
};

LeaveTypeIconSelector.prototype.handlePanelClicking = function ( iconId ) {
    this.iconSelectorPanel.hide();
    if (this.changesCallback)
        this.changesCallback();
    this.setIcon(iconId);
};
