function LeaveTypeIconSelectorPanel () {
    this.constructor = LeaveTypeIconSelectorPanel;
}

LeaveTypeIconSelectorPanel.prototype.init = function ( elementId, showRequestColorDiv, afterCloseCallback ) {
    var that = this;

    this.afterCloseCallback = afterCloseCallback;
    this.iconSelectorPanelEl = $(document.getElementById(elementId));
    this.panel = new DropdownDialog({
                                        wrapperClass: "LeaveTypeIconSelectorPanel",
                                        dialogDiv: this.iconSelectorPanelEl,
                                        hideButtons: true,
                                        hideOnResize: true,
                                        showEmptyTitleBar : false,
                                        onClose: function (event) {
                                            if ( that.afterCloseCallback )
                                                that.afterCloseCallback();
                                            /* here we restore old key-down-handler
                                             * and stop propagation of the event in order to avoid restored handler immediate invoking,
                                             * because current key-down event is related only to panel and should be handled only by panel
                                             * */
                                            event.stopPropagation();
                                            KeyDownHandler.restoreOnKeyDownHandler();
                                        }
                                    });
    if (!showRequestColorDiv)
        this.iconSelectorPanelEl.addClass("hideRequestColorInIconPanel");
    this.iconSelectorPanelEl.find("div.iconDiv").each( function( ) {
            $(this).click( function() {
                var newIconId = $(this).attr('id' ).substring(8);
                that.iconSelectedCallback(newIconId);
            });
    });

    return this;
};

LeaveTypeIconSelectorPanel.prototype.initAndShow = function ( currentIconId, elementToShowAt, iconSelectedCallback ) {
    this.currentIconId = currentIconId;
    this.iconSelectorPanelEl.find(".iconDiv.selectedIcon").removeClass("selectedIcon");
    this.iconSelectorPanelEl.find("#div_icon"+currentIconId ).addClass("selectedIcon");
    this.iconSelectedCallback = iconSelectedCallback;
    this.panel.showAt(elementToShowAt, {my: "left top",
                                        at: "left bottom",
                                        collision: "flip"});
    var leaveTypeLightBox_ZIndex = $("#leaveTypeLightBox" ).zIndex();
    $(".ui-widget-overlay" ).zIndex(leaveTypeLightBox_ZIndex+1);
    $(".LeaveTypeIconSelectorPanel").zIndex(leaveTypeLightBox_ZIndex+2);
    /* we set empty key-down-handler, because:
     * - after the panel is shown, all key-down-events are related only to it and it handles them itself;
     * - we need to save old handler and restore it after the panel is hidden.
     * */
    KeyDownHandler.setOnKeyDownHandler( function () {} );
};

LeaveTypeIconSelectorPanel.prototype.hide = function () {
    this.panel.hide();
};

LeaveTypeIconSelectorPanel.prototype.setAfterCloseCallback = function( afterCloseCallback )
{
    this.afterCloseCallback = afterCloseCallback;
};
