function LeaveTypeImageCellRenderer ()
{
    this.constructor = LeaveTypeImageCellRenderer;
}

LeaveTypeImageCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeImageCellRenderer.prototype.init = function ( onSetLeaveTypeIconCallback, iconSelectorPanel )
{
    TableCellRenderer.call( this );
    this.iconSelectorPanel = iconSelectorPanel;
    this.onSetLeaveTypeIconCallback = onSetLeaveTypeIconCallback;
    return this;
};

LeaveTypeImageCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeImageCell"];
};

LeaveTypeImageCellRenderer.prototype.generateContent = function ( cell )
{
    this.iconSelector = new ExtendedLeaveTypeIconSelector().init(this.iconSelectorPanel, cell.value.id, this.onSetLeaveTypeIconCallback);
    cell.getCellEl().appendChild( this.iconSelector.getSelectorEl() );
    this.iconSelector.setIcon(cell.value.iconId);

    cell.getCellEl().onclick = function()
    {
        cell.getRow().addOpenPopupClass();
        $( cell.getCellEl() ).addClass( "iconSelectorOpened" );
    };
};
