function LeaveTypeNameCellRenderer ()
{
    this.constructor = LeaveTypeNameCellRenderer;
}

LeaveTypeNameCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeNameCellRenderer.prototype.init = function ( onEditLeaveTypeNameCallback )
{
    TableCellRenderer.call( this );
    this.onEditLeaveTypeNameCallback = onEditLeaveTypeNameCallback;
    return this;
};

LeaveTypeNameCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeNameCell"];
};

LeaveTypeNameCellRenderer.prototype.generateContent = function ( cell )
{
    var that = this;

    var table = document.createElement("table");
    var row = document.createElement("tr");
    var column1 = document.createElement("td");
    var column2 = document.createElement("td");
    column2.className = "leaveNameOnHoverElement";

    var nameDiv = document.createElement("div");
    nameDiv.className = "leaveTypeNameText";
    var nameSpan = document.createElement("span");
    nameSpan.className = "leaveTypeNameText";
    $(nameSpan).text( cell.getValue().name );

    column1.appendChild(nameDiv);
    row.appendChild(column1);

    row .appendChild(column2);
    table.appendChild(row);


    cell.getCellEl().onclick = function(){
        var table = cell.getTable();
        if(!table.leaveNamePopup){
            table.leaveNamePopup = new LeaveNamePopup().init("LeaveNamePopup", that.onEditLeaveTypeNameCallback);
        }
        var offset = "1px -1px";

        table.leaveNamePopup.setValue(cell.value);
        table.leaveNamePopup.show( $(cell.getCellEl()), {my: "left top", at: "left top",  offset: offset},
                                   function(){cell.getRow().addOpenPopupClass()},
                                   function(){cell.getRow().removeOpenPopupClass()});
    };

    nameDiv.appendChild(nameSpan);
     cell.getCellEl().appendChild( table );
};
