function LeaveTypeRequiresApprovalCellRenderer ()
{
    this.constructor = LeaveTypeRequiresApprovalCellRenderer;
}

LeaveTypeRequiresApprovalCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeRequiresApprovalCellRenderer.prototype.init = function ( changeRequiresApprovalCallback )
{
    TableCellRenderer.call( this );
    this.changeRequiresApprovalCallback = changeRequiresApprovalCallback;
    return this;
};

LeaveTypeRequiresApprovalCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeRequiresApprovalCell"];
};

LeaveTypeRequiresApprovalCellRenderer.prototype.generateContent = function ( cell )
{
    var self = this;
    var leaveTypeInfo = cell.getValue();

    var requiresApprovalSpan = document.createElement("span");
    requiresApprovalSpan.className = "leaveTypeInfoText";
    $(requiresApprovalSpan).text( leaveTypeInfo.requiresApproval ? messageResource.getMessage("leave_type.list.require_approval") : "\u2013" );

    cell.getCellEl().onclick = function () { self.changeRequiresApprovalCallback(leaveTypeInfo.id, leaveTypeInfo.requiresApproval) };

    cell.getCellEl().appendChild( requiresApprovalSpan );
};
