function LeaveTypeStatusCellRenderer ()
{
    this.constructor = LeaveTypeStatusCellRenderer;
}

LeaveTypeStatusCellRenderer.prototype = _.create(TableCellRenderer.prototype);

LeaveTypeStatusCellRenderer.prototype.init = function ( changeStatusCallback )
{
    TableCellRenderer.call( this );
    this.changeStatusCallback = changeStatusCallback;
    return this;
};

LeaveTypeStatusCellRenderer.prototype.getCellClassName = function ( cell )
{
    return ["leaveTypeStatusCell"];
};

LeaveTypeStatusCellRenderer.prototype.generateContent = function ( cell )
{
    var self = this;
    var leaveTypeInfo = cell.getValue();

    var statusSpan = document.createElement("span");
    statusSpan.className = "leaveTypeStatusSpan leaveTypeInfoText";
    $(statusSpan).text( leaveTypeInfo.active ? messageResource.getMessage("leave_type.active") : messageResource.getMessage("leave_type.archived") );

    cell.getCellEl().onclick = function () { self.changeStatusCallback(leaveTypeInfo.id, leaveTypeInfo.active) };

    cell.getCellEl().appendChild( statusSpan );
};

