function AddButtonStrategy(){}

AddButtonStrategy.prototype.init = function()
{
    // abstract
};

AddButtonStrategy.prototype.callback = function()
{
    // abstract
};


function AddButtonOnlineStrategy(){}

AddButtonOnlineStrategy.prototype = _.create(AddButtonStrategy.prototype, {
    init: function($addUserButton, createUserCallback, inviteSeveralUsersCallback)
    {
        this.$addUserButton = $addUserButton;
        var self = this;
        var $content = $('<div>').addClass("content");
        var createItem = function(labelKey, itemClasses, callback, changeBeakColorOnHover)
        {
            var $div = $('<div>').addClass("item " + (itemClasses ? itemClasses : ""));
            if (changeBeakColorOnHover)
            {
                var onHover = function(toggle)
                {
                    $(".inviteUserModePopup").toggleClass("beakColor", toggle);
                };
                $div.hover(_.bind(onHover, this, true), _.bind(onHover, this, false));
            }
            $div.append($('<div>').addClass("label").text(messageResource.getMessage(labelKey)));
            $div.click(function()
                       {
                           self.inviteUserModeDialog.hide();
                           if (callback)
                           {
                               callback();
                           }
                       });
            return $div;
        };

        $content.append(createItem("userlist.js.invite_user_mode_popup.invite_user", "addOneUserIcon", createUserCallback, true));
        $content.append(createItem("userlist.js.invite_user_mode_popup.invite_several_users", "inviteSeveralUsersIcon", inviteSeveralUsersCallback, false));

        this.inviteUserModeDialog = new DropdownDialog({
            wrapperClass: "inviteUserModePopup",
            dialogDiv: $content,
            notModal: false,
            hideButtons: true,
            hideOnResize: true,
            showEmptyTitleBar: false
        });

        return this;
    },

    callback: function()
    {
        this.inviteUserModeDialog.showAt(this.$addUserButton[0], {offset: "-114px 10px"});
    }
});


function AddButtonDownloadableStrategy(){}

AddButtonDownloadableStrategy.prototype = _.create(AddButtonStrategy.prototype, {
    init: function(clickCallback)
    {
        this.clickCallback = clickCallback;
        return this;
    },

    callback: function()
    {
        if (this.clickCallback)
        {
            this.clickCallback();
        }
    }
});