/**
 * Created by filatov on 29.01.2016.
 */
function DownloadableAccountFieldsUserPopupDrawer(){}

DownloadableAccountFieldsUserPopupDrawer.prototype = new BaseFieldsDrawerController();

DownloadableAccountFieldsUserPopupDrawer.prototype.init =function(config){
    BaseFieldsDrawerController.prototype.init.call(this, config);
    this.passwordDrawer = new PasswordFieldsDrawer().init(config);
    this.userNameDrawer = new UserNameDrawer().init(config);
    this.addDrawer(this.passwordDrawer);
    this.addDrawer(this.userNameDrawer);
    return this;
};

DownloadableAccountFieldsUserPopupDrawer.prototype.getNotCopyValues = function(){
  return {passwordData : this.passwordDrawer.getPlainPasswordValues(), username: this.userNameDrawer.getObjectValues().username}
};

DownloadableAccountFieldsUserPopupDrawer.prototype.getNewPassword = function(){
  return  this.passwordDrawer.getNewPassword();
};

/*Create Drawer*/
function DownloadableAccountFieldsCreateUserPopupDrawer(){}

DownloadableAccountFieldsCreateUserPopupDrawer.prototype = new DownloadableAccountFieldsUserPopupDrawer();

DownloadableAccountFieldsCreateUserPopupDrawer.prototype.initFields = function(config){
    this.passwordDrawer.setPasswordsAreMandatory(true);
    BaseFieldsDrawerController.prototype.initFields.call(this, config.accountSettings);
    this.passwordDrawer.setPasswordFieldsPlaceholders(
            messageResource.getMessage("user.add.js.password_field.placeholder"),
            messageResource.getMessage("user.add.js.password_copy_field.placeholder")
    );
};

/* Edit drawer */
function DownloadableAccountFieldsEditUserPopupDrawer(){}

DownloadableAccountFieldsEditUserPopupDrawer.prototype = new DownloadableAccountFieldsUserPopupDrawer();

DownloadableAccountFieldsEditUserPopupDrawer.prototype.initFields = function(config){
    this.passwordDrawer.setPasswordsAreMandatory(false);
    BaseFieldsDrawerController.prototype.initFields.call(this, config.accountSettings);
    this.passwordDrawer.setPasswordFieldsPlaceholders(
            messageResource.getMessage("user.edit.js.password_field.placeholder"),
            messageResource.getMessage("user.edit.js.password_copy_field.placeholder")
    );
};

