/**
 * Created by filatov on 03.02.2016.
 */
function InvitationDrawer(){}

InvitationDrawer.prototype = new BaseFieldsDrawer();


InvitationDrawer.prototype.initFields = function(accountSettings){
    this.resetPasswordButton =  $(this.getElementByIdFunction("resetPasswordLink"));
    this.resendButton = $(this.getElementByIdFunction("resendInvitation"));
    this.resetPasswordButton.hide();
    this.resendButton.hide();
    if(this.isNeedDrawResendButton)
        this.initResendInvitationButton(accountSettings);
    if(this.isNeedDrawResetButton)
        this.initResetPasswordButton(accountSettings);
};

InvitationDrawer.prototype.setNeedDrawResetButton = function(isNeed){
    this.isNeedDrawResetButton = isNeed;
};

InvitationDrawer.prototype.setNeedDrawResendButton = function(isNeed){
    this.isNeedDrawResendButton = isNeed;
};

InvitationDrawer.prototype.initResetPasswordButton = function(accountSettings){

    this.resetPasswordButton.off();
    var self = this;

    var onOkDialogClick = function()
    {
        self._invitationDialog.showSpinner();

        makeRpcCall( "UserManagementService.resetPassword", [accountSettings.id],
                     function ()
                     {
                         self._invitationDialog.hideSpinner();
                         self._invitationDialog.hideAndRemove();
                         self._populateAndShowSecondConfirmationDialog(
                                 "<span class='secondResetPasswordDialog secondConfirmDialog'>" +
                                    messageResource.getEscapedMessage( "userlist.user_popup.confirmation.reset_password.has_been_sent", [self._formatName(accountSettings)] ) +
                                 "</span>",
                                 self.resetPasswordButton);
                     },
                     function ( jqXHR, textStatus, errorThrown )
                     {
                         self._invitationDialog.hideSpinner();
                         self._invitationDialog.hideAndRemove();
                         if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' ) {
                             alert( messageResource.getMessage( 'userlist.js.error_no_such_user.edit_user' ) );
                             if(self.handlerIfNoSuchUserAfterAjax)
                                 self.handlerIfNoSuchUserAfterAjax();
                             return true;
                         }
                         if(errorThrown.exception == 'ccom.actimind.common.administration.LastManagerInOtherProductException'){
                             alert(messageResource.getMessage('userlist.js.error_last_admin_in_other_product'));
                             return true;
                         }
                     });
    };

    this.resetPasswordButton.on("click", function() {
        self._invitationDialog = self._createConfirmDialog();
        self._invitationDialog.setWrappedContent( messageResource.getEscapedMessage( "userlist.user_popup.confirmation.reset_password", 
                                                                                     [ self._formatName(accountSettings), accountSettings.email ] ) );
        self._invitationDialog.show( self.resetPasswordButton, { offset: "28px 15px" }, onOkDialogClick );
    });

    this.resetPasswordButton.show();
};

InvitationDrawer.prototype.initResendInvitationButton = function(accountSettings){

    this.resendButton.off();
    var self = this;

    var onOkDialogClick = function()
    {
        self._invitationDialog.showSpinner();

        makeRpcCall( "UserManagementService.resendInvitation", [accountSettings.id],
                     function ()
                     {
                         self._invitationDialog.hideSpinner();
                         self._invitationDialog.hideAndRemove();
                         self._populateAndShowSecondConfirmationDialog(
                                 "<span class='secondResendInvitationDialog secondConfirmDialog'>" +
                                    messageResource.getEscapedMessage( "userlist.user_popup.confirmation.resend.has_been_sent", [accountSettings.email] ) +
                                 "</span>",
                                 self.resendButton);
                     },
                     function ( jqXHR, textStatus, errorThrown )
                     {
                         self._invitationDialog.hideSpinner();
                         self._invitationDialog.hideAndRemove();
                         if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                         {
                             alert( messageResource.getMessage( 'userlist.js.error_no_such_user.edit_user' ) );
                             if( self.handlerIfNoSuchUserAfterAjax )
                                 self.handlerIfNoSuchUserAfterAjax();
                             return true;
                         }
                     } );
    };

    var onResendButtonClick = function()
    {
        self._invitationDialog = self._createConfirmDialog();
        self._invitationDialog.setWrappedContent( messageResource.getEscapedMessage( "userlist.user_popup.confirmation.resend", 
                                                                                     [ self._formatName(accountSettings), accountSettings.email ] ) );
        self._invitationDialog.show( self.resendButton, { offset: "28px 15px" }, onOkDialogClick );
    };

    this.resendButton.on("click", onResendButtonClick );
    this.resendButton.show();
};

InvitationDrawer.prototype._formatName = function(accountSettings) {
    return UserNameFormat.formatFML(accountSettings.firstName, accountSettings.lastName, accountSettings.middleInitial);
};

InvitationDrawer.prototype._createConfirmDialog = function() {
    return new InvitationDialog().init( $("#userDataLightBox") );
};

InvitationDrawer.prototype._populateAndShowSecondConfirmationDialog = function( content, elementShowAt ) {
    var timerId = null;
    var secondInvitationDialog = InvitationDrawer.prototype._createConfirmDialog();
    
    timerId = setTimeout( function()
                          {
                              if ( timerId == null )
                                  return;
                              secondInvitationDialog.hideAndRemove();
                          }, 5000 );

    secondInvitationDialog.setWrappedContent( content );
    var secondInvitationDialogWrapper = secondInvitationDialog.getWrapperElement();
    secondInvitationDialogWrapper.addClass( "onlyCloseButton" );
    var lastButton = secondInvitationDialogWrapper.find( ".ui-dialog-buttonset button" ).filter( ":last-child" );
    lastButton.find( "span" ).text( "Close" );
    lastButton.addClass( "shown" );
    secondInvitationDialogWrapper.find( ".invitationDialog" ).css( "height", "40px" );

    secondInvitationDialog.show( elementShowAt, { offset: "28px 15px" }, null, function() { timerId = null; } );
};


