//TODO: copy-paste from UserManagementMediator. refactor and reuse
function LicenseCounterManager() {}

LicenseCounterManager.prototype.init = function ( licenseEl ) {
    this._licenseEl = licenseEl;
    return this;
}

LicenseCounterManager.prototype.setLicenseCounter = function ( licenseCounters ) {
    this._license = licenseCounters;
};

LicenseCounterManager.prototype.setAllowedToView = function ( allowedToManageAccountSettings ) {
    this._allowedToManageAccountSettings = allowedToManageAccountSettings;
};

LicenseCounterManager.prototype.update = function() {
    var text;

    if( this._isLicenseViolated() ) {
        var extraUsersCount = this._license.extraUsersCount;
        text = messageResource.getMessage(extraUsersCount == 1 ? "userlist.license.disable_user":
                                          "userlist.license.disable_users",[extraUsersCount] );
    } else {
        var remainingCount = this._license.remainingCount;
        var remainingCountText = this._haveMoreLicenses() ? remainingCount :  messageResource.getMessage("userlist.pagebody.no_licenses_left");
        text = messageResource.getMessage(remainingCount == 1 ? "userlist.pagebody.license_left" :
                                          "userlist.pagebody.licenses_left",[remainingCountText]);
    }

    this._licenseEl.innerHTML = text;
    this._updateTextClasses();
}

LicenseCounterManager.prototype._updateTextClasses = function() {
    var classes = ["licenseCount"];
    if (this._allowedToManageAccountSettings && !this._isLicenseUnlimited())
    {
        classes.push("licenseShown");
        if (!this._haveMoreLicenses())
        {
            classes.push("licenseError");
        }
    }
    this._licenseEl.className = classes.join(" ");
}

LicenseCounterManager.prototype._isLicenseUnlimited = function() {
    return this._license.remainingCount == UserListPageConstants.LICENSE_UNLIM;
};

LicenseCounterManager.prototype._isLicenseViolated = function (){
	return this._license.licenseViolated;
};

LicenseCounterManager.prototype._haveMoreLicenses = function (){
	var remainingCount = this._license.remainingCount;
	return this._isLicenseUnlimited() || remainingCount > 0;
};