/**
 * Created by filatov on 03.02.2016.
 */
/**
 * Created by filatov on 29.01.2016.
 */
PasswordFieldsDrawer.PASSWORD_EMPTY = "passwordEmpty";
PasswordFieldsDrawer.PASSWORD_COPY_EMPTY = "passwordCopyEmpty";
PasswordFieldsDrawer.PASSWORDS_DO_NOT_MATCH = "passwordsDoNotMatch";

function PasswordFieldsDrawer(){}

PasswordFieldsDrawer.prototype = new BaseFieldsDrawer();

PasswordFieldsDrawer.prototype.init = function(config){
    BaseFieldsDrawer.prototype.init.call(this,config);
    this.passwordsAreMandatory = config.passwordsAreMandatory;
    return this;
};

PasswordFieldsDrawer.prototype.initFields = function(accountSettings){
    this.passwordField = $(this.getElementByIdFunction("passwordField"));
    this.passwordCopyField = $(this.getElementByIdFunction("passwordCopyField"));
    this.savedPasswordData = accountSettings.passwordData;
    var self = this;
    this.passChangedHandler = function()
    {
        this.keyPressed = false;
        if (this.value.length > 0) self.changeDetectedFunction( true );
    };

    this.passwordBlurHandler = function()
    {
        $(this).pVal( this.value );
        //see Bug 48539
        if ( this.keyPressed )
        {
            self.passChangedHandler.call(this);
            self.changeDetectedFunction();
        }

        self._checkPasswordsMatch();
        self.validationDetectedCallback();
        self.updateUICallback();
    };
};

PasswordFieldsDrawer.prototype.setPasswordsAreMandatory = function( passwordsAreMandatory )
{
    this.passwordsAreMandatory = passwordsAreMandatory;
};

PasswordFieldsDrawer.prototype._checkPasswordsMatch = function()
{
    var pswEmpty = this.passwordField.pVal().length == 0;
    var pswCopyEmpty = this.passwordCopyField.pVal().length == 0;


    this.errors[PasswordFieldsDrawer.PASSWORD_EMPTY] = this.passwordsAreMandatory ? pswEmpty : false;
    this.errors[PasswordFieldsDrawer.PASSWORD_COPY_EMPTY] = this.passwordsAreMandatory ? ( !pswEmpty && pswCopyEmpty ): false;

    return (this.errors[ PasswordFieldsDrawer.PASSWORDS_DO_NOT_MATCH ] =
            ( this.passwordsAreMandatory && !pswEmpty && !pswCopyEmpty || !this.passwordsAreMandatory ) &&
            this.passwordField.pVal() != this.passwordCopyField.pVal());
};

PasswordFieldsDrawer.prototype.setPasswordFieldsPlaceholders = function( pwdPlaceholder, pwdCopyPlaceholder )
{
    /* In case of IE8, Placeholder plug-in creates 2 input fields with the same id */
    var passFields = document.getElementsByName("password");
    var passCopyFields = document.getElementsByName("passwordCopy");

    if (passFields.length > 1 && passCopyFields.length > 1) {
        $(passFields[0]).remove();
        $(passCopyFields[0]).remove();
    }

    this.passwordField = $(this.getElementByIdFunction("passwordField"));
    this.passwordCopyField = $(this.getElementByIdFunction("passwordCopyField"));

    this.passwordField.off();
    this.passwordCopyField.off();

    if ( this.savedPasswordData )
    {
        this.setValue( this.passwordField, this.savedPasswordData.password );
        this.setValue( this.passwordCopyField, this.savedPasswordData.passwordCopy );
    }
    else
    {
        this.setValue( this.passwordField, "");
        this.setValue( this.passwordCopyField, "");
    }

    if (pwdPlaceholder)
        this.passwordField.attr("placeholder", pwdPlaceholder);

    if (pwdCopyPlaceholder)
        this.passwordCopyField.attr("placeholder", pwdCopyPlaceholder);

    this.passwordField.placeholder();
    this.passwordCopyField.placeholder();

    this.passwordField.keydown(this.onKeyPressedHandler);
    this.passwordCopyField.keydown(this.onKeyPressedHandler);
    this.passwordField.keyup(this.passChangedHandler);
    this.passwordCopyField.keyup(this.passChangedHandler);
    this.passwordField.blur(this.passwordBlurHandler);
    this.passwordCopyField.blur(this.passwordBlurHandler);
};

PasswordFieldsDrawer.prototype.getNewPassword = function()
{
    if(!this.passwordField) return null;
    var passwordValue = this.passwordField.pVal();
    if(passwordValue.length > 0)
        return MD5(passwordValue);
    return null;
};

PasswordFieldsDrawer.prototype.validateFields = function(){
    this._checkPasswordsMatch();
    return this.errors;
};

PasswordFieldsDrawer.prototype.getObjectValues = function()
{
    return {newPassword : this.getNewPassword()};
};

PasswordFieldsDrawer.prototype.getPlainPasswordValues = function()
{
    return {
        password: this.passwordField.pVal(),
        passwordCopy: this.passwordCopyField.pVal()
    };
};

BaseFieldsDrawer.prototype.getNotCopyValues = function(){
    return {passwordData : this.getPlainPasswordValues()} ;
};







