function PermissionsSectionMediatorTemplatesMenuWithoutChoosing(){}

PermissionsSectionMediatorTemplatesMenuWithoutChoosing.prototype = _.create(PermissionsSectionMediator.prototype, {

    init: function(config)
    {
        PermissionsSectionMediator.prototype.init.call(this, config);
        this.onUpdatePermissionsTemplatesCallback = config.onUpdatePermissionsTemplatesCallback;
        return this;
    },

    createAndInitPermissionTemplatesMenu: function(permissionsTemplates, forceCancelCb, checkLightBoxIsShown)
    {
        var self = this;

        this.permissionTemplatesMenu = new PermissionsTemplatesMenuWithoutChoosing().init(
                "permissionTemplatesMenuWithoutChoosingId",
                permissionsTemplates,
                function() {self._showCreatePopup();},
                function(templateData) {self._showEditPopup(templateData);},
                function()
                {
                    if (forceCancelCb)
                    {
                        forceCancelCb();
                    }
                },
                function(data)
                {
                    if (self.onUpdatePermissionsTemplatesCallback)
                    {
                        self.onUpdatePermissionsTemplatesCallback(data);
                    }
                },
                checkLightBoxIsShown
        );

        var permissionTemplatesMenuButton = this.$lightBoxEl.find(".innerContent .editPermissionsTemplateButton");
        permissionTemplatesMenuButton.off("click").on("click", function(event)
        {
            self.permissionTemplatesMenu.showAt(permissionTemplatesMenuButton, {left: -44, top: 2});
            event.preventDefault();
        });

        var hideMenuOnScrollContentCallback = function()
        {
            self.permissionTemplatesMenu.hide();
        };
        this.$lightBoxEl.find(".innerContent").off("scroll.templatesMenu", hideMenuOnScrollContentCallback).on("scroll.templatesMenu", hideMenuOnScrollContentCallback);
    },

    _getInitialAccessRights: function(config)
    {
        return [];
    },

    _showPopup: function()
    {
        PermissionsSectionMediator.prototype._showPopup.call(this);
        var offset = {};
        offset.left = this.$lightBoxEl.offset().left + (this.$lightBoxEl.innerWidth() - this.$permissionsSectionEl.innerWidth()) / 2;
        offset.top = this.$lightBoxEl.find(".editPermissionsTemplateButton").offset().top + 42;
        this.$permissionsSectionEl.offset(offset);
    },

    updateTemplates: function(templatesData)
    {
        PermissionsSectionMediator.prototype.updateTemplates.call(this, templatesData);
        if (this.onUpdatePermissionsTemplatesCallback)
        {
            this.onUpdatePermissionsTemplatesCallback(templatesData);
        }
    }
});
