function UserInputDataFetcher (){

}

UserInputDataFetcher.prototype.init = function (  ){

};

UserInputDataFetcher.prototype.getUserInputData = function ( ){
    //abstract
};

UserInputDataFetcher.prototype.getCreateUserInputData = function ( ){
    //abstract
};

UserInputDataFetcher.prototype.getUserInputDataThatNotWillBeCopied = function ( userManagementData ){

    var accountSection =  this._accountSection;
    var dataThatNotWillBeCopied = null;

    if( userManagementData.viewerSettings.allowedToManageAccountSettings)
    {
        var releaseDate = accountSection.getReleaseDate();

        dataThatNotWillBeCopied = {
            id: accountSection.getUserId(),
            firstName: accountSection.getFirstName(),
            lastName: accountSection.getLastName(),
            middleInitial: accountSection.getMiddleInitial(),
            enabled: accountSection.isEnabled(),
            enabledInOtherProduct: accountSection.isEnabledInOtherProduct(),
            email: accountSection.getEmail(),
            hireDate: accountSection.getHireDate().toJSONString(),
            releaseDate: releaseDate ? releaseDate.toJSONString() : null
        };
        var specificNotCopyValues = accountSection.getSpecificNotCopyValues();
        if(specificNotCopyValues)
            $.extend(dataThatNotWillBeCopied, {passwordData : specificNotCopyValues.passwordData, username : specificNotCopyValues.username});
    }

    return dataThatNotWillBeCopied;
};

UserInputDataFetcher.prototype.getUserInputDataForAccountCreatedState = function ( userManagementData ){

    var accountSection =  this._accountSection;
    var userData = null;

    if( userManagementData.viewerSettings.allowedToManageAccountSettings)
    {
        userData = {
            firstName: accountSection.getFirstName(),
            lastName: accountSection.getLastName(),
            middleInitial: accountSection.getMiddleInitial(),
            email: accountSection.getEmail(),
            hireDate: accountSection.getHireDate().toJSONString()
        };
    }

    return userData;
};


function ActitimeUserInputDataFetcher(){

}

ActitimeUserInputDataFetcher.prototype = new  UserInputDataFetcher();

ActitimeUserInputDataFetcher.prototype.init = function ( accountSection, workScheduleAndOvertimeSection, userRatesSection, permissionsSection ){
    this._accountSection  = accountSection;
    this._workScheduleAndOvertimeSection  = workScheduleAndOvertimeSection;
    this._userRatesSection = userRatesSection;
    this._permissionsSection = permissionsSection;
    return this;
};

ActitimeUserInputDataFetcher.prototype.getCreateUserInputData = function ( userManagementData ){
    var accountSection =  this._accountSection;
    var workScheduleAndOvertimeSection = this._workScheduleAndOvertimeSection;
    var userRatesSection = this._userRatesSection;
    var permissionsSection = this._permissionsSection;

    var newPassword = null;
    var newUserGroupName = null;
    var newTimeZoneGroup = null;
    var id;

    var accountSettings;

    if( userManagementData.viewerSettings.allowedToManageAccountSettings)
    {
        var accessRights = permissionsSection ? permissionsSection.getSelectedRights() : null;

        var releaseDate = accountSection.getReleaseDate();
        accountSettings = {
            firstName: accountSection.getFirstName(),
            lastName: accountSection.getLastName(),
            middleInitial: accountSection.getMiddleInitial(),
            enabled: accountSection.isEnabled(),
            enabledInOtherProduct: accountSection.isEnabledInOtherProduct(),
            userGroupId: accountSection.getUserGroupId(),
            timeZoneGroupId: accountSection.getTimeZoneGroupId(),
            overtimeLevel: workScheduleAndOvertimeSection.getOvertimeTrackingLevel(),
            email: accountSection.getEmail(),
            hireDate: accountSection.getHireDate().toJSONString(),
            releaseDate: releaseDate ? releaseDate.toJSONString() : null,
            initialSchedule: workScheduleAndOvertimeSection.getInitialSchedule(),
            defaultInitialSchedule: workScheduleAndOvertimeSection.isDefaultInitialSchedule(),
            workSchedule: workScheduleAndOvertimeSection.getSchedules(),
            rates: userRatesSection ? userRatesSection.getRates() : null,
            accessRights: accessRights
        };

        var specificValues = this._accountSection.getSpecificValues();
        $.extend(accountSettings, {username : specificValues.username});
        newPassword = specificValues.newPassword;
        newUserGroupName = accountSection.getNewUserGroupName();
        newTimeZoneGroup = accountSection.getNewTimeZoneGroup();
        id = accountSection.getUserId();
    }
    return  [ id, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword ];
};


ActitimeUserInputDataFetcher.prototype.getUserInputData = function ( userManagementData ){
    var createUserData = this.getCreateUserInputData( userManagementData );
    if( userManagementData.viewerSettings.allowedToManageAccountSettings)
        createUserData[1].overtimeLevel = this._workScheduleAndOvertimeSection.getOvertimeTrackingLevel();

    return createUserData;
};


function ActiplansUserInputDataFetcher(){

}

ActiplansUserInputDataFetcher.prototype = new  UserInputDataFetcher();

ActiplansUserInputDataFetcher.prototype.init = function ( accountSection, workScheduleSection ){
    this._accountSection =  accountSection;
    this._workScheduleSection =  workScheduleSection;
    return this;
};

ActiplansUserInputDataFetcher.prototype.getCreateUserInputData = function ( ){
    return this.getUserInputData();
};

ActiplansUserInputDataFetcher.prototype.getUserInputData = function (  ){

    var accountSection = this._accountSection;
    var workScheduleSection = this._workScheduleSection;

    var releaseDate = accountSection.getReleaseDate();
    var accountSettings = {
        firstName: accountSection.getFirstName(),
        lastName: accountSection.getLastName(),
        middleInitial: accountSection.getMiddleInitial(),
        enabled: accountSection.isEnabled(),
        enabledInOtherProduct: accountSection.isEnabledInOtherProduct(),
        userGroupId: accountSection.getUserGroupId(),
        timeZoneGroupId: accountSection.getTimeZoneGroupId(),
        email: accountSection.getEmail(),
        hireDate: accountSection.getHireDate().toJSONString(),
        releaseDate: releaseDate ? releaseDate.toJSONString() : null,
        initialSchedule: workScheduleSection.getInitialSchedule(),
        defaultInitialSchedule: workScheduleSection.isDefaultInitialSchedule(),
        workSchedule: workScheduleSection.getSchedules()
    };

    var specificValues = this._accountSection.getSpecificValues();
    $.extend(accountSettings, {username : specificValues.username});
    var newPassword = specificValues.newPassword;
    var newUserGroupName = accountSection.getNewUserGroupName();
    var newTimeZoneGroup = accountSection.getNewTimeZoneGroup();

    return  [ accountSection.getUserId() , accountSettings, newUserGroupName, newTimeZoneGroup, newPassword ];

};





