    function UserManagementMediator()
    {
        this.constructor= UserManagementMediator;

    }

    UserManagementMediator.warningMap = {};
    UserManagementMediator.errorMap = {};

    UserManagementMediator.warningMap[UserManagementConstants.WARNING_MANAGE_BALANCE_RIGHT_REVOKED] =  messageResource.getEscapedMessage("userlist.js.warning_manage_balance_right_revoked") ;
    UserManagementMediator.warningMap[UserManagementConstants.WARNING_MANAGE_ACCOUNT_SETTINGS_RIGHT_REVOKED] = messageResource.getEscapedMessage("userlist.js.warning_manage_account_settings_right_revoked") ;
    UserManagementMediator.warningMap[UserManagementConstants.WARNING_PTO_FEATURE_DISABLED] = messageResource.getEscapedMessage("userlist.js.warning_pto_feature_disabled") ;
    UserManagementMediator.warningMap[UserManagementConstants.WARNING_SICK_FEATURE_DISABLED] = messageResource.getEscapedMessage("userlist.js.warning_pto_feature_disabled") ;
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_ACCOUNT_SETTINGS] = messageResource.getEscapedMessage("userlist.js.error_manage_account_settings_right_revoked") ;
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_DUPLICATE_USERNAME] = true;     //no need in error message
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_PTO_AND_SICK] =  messageResource.getEscapedMessage("userlist.js.error_no_rights_to_manage_leave_balance") ;
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_PTO_FEATURE_DISABLED] =  messageResource.getEscapedMessage("userlist.js.error_pto_feature_disabled");
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_PTO_CONTROL_DISABLED] =  messageResource.getEscapedMessage("userlist.js.error_pto_control_disabled");
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_SICK_CONTROL_DISABLED] =  messageResource.getEscapedMessage("userlist.js.error_sick_control_disabled");
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_NO_SUCH_USER] =  messageResource.getEscapedMessage("userlist.js.error_no_such_user");
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_CANT_DELETE] =  messageResource.getEscapedMessage("userlist.js.error_cant_delete");
    UserManagementMediator.errorMap[UserManagementConstants.ERROR_CANNOT_DISABLE_LAST_USER_MANAGER_IN_OTHER_PRODUCT] = messageResource.getEscapedMessage("user.edit.js.cannot_disable.last_admin_at") ;

    UserManagementMediator.BOTTOM_BAR_HEIGHT = 29;


    UserManagementMediator.prototype._initPagerController = function( pagerData, pageNumChangedCallback, recordsPerPageChangedCallback )
    {
        return new PagerController().init(
            {
                pagerData: pagerData,
                handlersMap:{
                    pageChanged :pageNumChangedCallback,
                    recordsPerPageChanged :recordsPerPageChangedCallback
                },
                pagerControlsElementId: "userListFooterId",
                pagerElementId: "pager",
                recordsPerPageSelectorId: "recordsPerPageSelector",
                minRecordsPerPage: UserManagementConstants.MIN_RECORDS_PER_PAGE
            }
        );
    };

    UserManagementMediator.prototype._initUserTableController = function( userListSettings, viewerSettings, userListBeans, groupMap, timeZoneGroupMap, allApprovers, ptoDefaults, sickDefaults )
    {
        var tHeadEl = document.getElementById("userListTableHeader" ),
            self = this,
            handlersMap = {};

        handlersMap.sortByName = function (event) { self._sortingChangedCallback(event, UserManagementConstants.USER_LIST_ORDER_BY_NAME); };
        handlersMap.sortByGroup= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_GROUP_NAME); };
        handlersMap.sortByTimeZoneGroup = function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_TIME_ZONE_GROUP_NAME); };
        handlersMap.sortByPTO= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_PTO_BALANCE); };
        handlersMap.sortByApprovedPTO= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_APPROVED_PTO); };
        handlersMap.sortByPTOControl= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_PTO_CONTROL_STATUS); };

        handlersMap.sortBySick= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_SICK_BALANCE); };
        handlersMap.sortByApprovedSick= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_APPROVED_SICK); };
        handlersMap.sortBySickControl= function (event){ self._sortingChangedCallback(event,UserManagementConstants.USER_LIST_ORDER_BY_SICK_CONTROL_STATUS); };

        handlersMap.typingByName= function ( event ) { self._searchTermsChangedCallback( event ); };
        handlersMap.clearTypedName = function(){ self._searchTerms("") };
        handlersMap.editUser= function(user) { self.editUser( user); };
        handlersMap.editPTOBalance = function (cell) { self.editBalance(cell, BalanceType.PTO) };
        handlersMap.editSickDaysBalance = function (cell) { self.editBalance(cell, BalanceType.SICK) };
        handlersMap.switchManagePTOAndSickRight = function (cell) { self.switchManagePTOAndSickRight(cell)};
        handlersMap.showPtoHistory = function (cell) { self.showPtoHistory(cell) };
        handlersMap.showSickHistory = function (cell) { self.showSickHistory(cell) };
        handlersMap.togglePTOControlStatus = function (cell, value) { self.toggleBalanceControlStatus(cell, BalanceType.PTO, value) };
        handlersMap.toggleSickDaysControlStatus = function (cell, value) { self.toggleBalanceControlStatus(cell, BalanceType.SICK, value) };
        handlersMap.toggleIsTTApprover = function (cell) { self.toggleIsTTApprover(cell) };
        handlersMap.modifyPTOAccrualRules = function ( cell, dialogValues, onCompleteCallback ) { self.modifyBalanceAccrualRules(cell, BalanceType.PTO, dialogValues, onCompleteCallback) };
        handlersMap.modifySickAccrualRules = function ( cell, dialogValues, onCompleteCallback ) { self.modifyBalanceAccrualRules(cell, BalanceType.SICK, dialogValues, onCompleteCallback) };
        handlersMap.showAssignTTApproversDialog = function (conf) { self.showAssignTTApproversDialog(conf) };
        handlersMap.showAssignedApproversTooltip = self.getShowTooltip( self.approversTooltip );
        handlersMap.moveAssignedApproversTooltip = self.getMoveTooltip( self.approversTooltip );
        handlersMap.hideAssignedApproversTooltip = self.getHideTooltip( self.approversTooltip );
        handlersMap.showAssignUsersForTTApproverDialog = function (conf) { self.showAssignUsersForTTApproverDialog(conf) };
        handlersMap.showAssignUsersForTTApproverTooltip = self.getShowTooltip( self.assignUsersForTTApproverTooltip );
        handlersMap.moveAssignUsersForTTApproverTooltip = self.getMoveTooltip( self.assignUsersForTTApproverTooltip );
        handlersMap.hideAssignUsersForTTApproverTooltip = self.getHideTooltip( self.assignUsersForTTApproverTooltip );
        handlersMap.showManageRightsTooltip = self.getShowTooltip( self.manageRightsTooltip );
        handlersMap.moveManageRightsTooltip = self.getMoveTooltip( self.manageRightsTooltip );
        handlersMap.hideManageRightsTooltip = self.getHideTooltip( self.manageRightsTooltip );
        handlersMap.manageTaskHierarchy = function( cell ) { self.manageTaskHierarchy( cell ) };
        handlersMap.showTaskHierarchyTooltip = self.getShowTooltip( self.taskHierarchyTooltip );
        handlersMap.moveTaskHierarchyTooltip = self.getMoveTooltip( self.taskHierarchyTooltip );
        handlersMap.hideTaskHierarchyTooltip = self.getHideTooltip( self.taskHierarchyTooltip );
        handlersMap.editProjectAssignments = function( cell ) { self.editProjectAssignments( cell ) };
        handlersMap.showAssignmentsTooltip = self.getShowTooltip( self.assignmentsTooltip );
        handlersMap.moveAssignmentsTooltip = self.getMoveTooltip( self.assignmentsTooltip );
        handlersMap.hideAssignmentsTooltip = self.getHideTooltip( self.assignmentsTooltip );

        return new UserTableController().init(
                {
                    isPTOEnabled: this._isPTOEnabled(),
                    isSickEnabled: this._isSickEnabled(),
                    isTTAEnabled: this._isTTAEnabled(),
                    isPASEnabled: this._isPASEnabled(),
                    isAccountSettingsVisible: viewerSettings.showAccountSettings,
                    canManageLeaveBalances: viewerSettings.allowedToManageLeaveBalanceSettings,
                    canManageAccounts: viewerSettings.allowedToManageAccountSettings,
                    userBeans: userListBeans,
                    allApprovers: allApprovers,
                    sortOrder: userListSettings.order,
                    tHeadEl: tHeadEl,
                    containerEl: this.$userListTableContainer[0],
                    handlersMap:handlersMap,
                    groupMap: groupMap,
                    timeZoneGroupMap: timeZoneGroupMap,
                    ptoHoursPerDay: this.ptoHoursPerDay,
                    ptoDefaults: ptoDefaults,
                    sickDefaults: sickDefaults
                }
        );
    };

    UserManagementMediator.prototype.initGroupMapAndGroupWrappersList = function( groupList, selectedGroupsSet, includeNullGroup, defaultGroupId )
    {
        var groupMap = null;
        var groupWrappersList = [];

        if( groupList != null )
        {
            groupMap={};

            if (includeNullGroup)
            {
                groupMap[UserManagementConstants.USER_WITHOUT_GROUP] = messageResource.getEscapedMessage("userlist.js.table.username_cell.user_without_group");
                groupWrappersList.push(
                    {
                        id: UserManagementConstants.USER_WITHOUT_GROUP,
                        name: messageResource.getMessage("common.users_without_group"),
                        active: true,
                        selected: selectedGroupsSet[UserManagementConstants.USER_WITHOUT_GROUP] ? true : false,
                        isDefault: true
                    }
                );
            }

            for( var i = 0; i < groupList.length; i++ )
            {
                var group = groupList[i];
                if (includeNullGroup && group.id == UserManagementConstants.USER_WITHOUT_GROUP)
                    continue;

                groupMap[ group.id ] = escapeHtmlSymbols(group.name);
                groupWrappersList.push(
                        {
                            id: group.id,
                            name: group.name,
                            active: true,
                            selected: selectedGroupsSet[ group.id ] ? true : false,
                            isDefault: group.id == defaultGroupId
                        }
                );
            }
        }

        return {
            groupMap: groupMap,
            groupWrappersList: groupWrappersList
        }
    };

    UserManagementMediator.prototype.showManageDepartmentsPopup = function( departmentsChangedCallback )
    {
        if( !this.manageDeparmentsController )
        {
            this.manageDeparmentsController = GroupManagementUtil.initializeGroupsLightBox();
        }

        var self = this;

        var popup = createLightbox(
                "groupManagementLightBox",
                function () {
                    self.manageDeparmentsController.hideLightboxHandler( function () {
                        departmentsChangedCallback(self.manageDeparmentsController);
                    } );
                },
                makeHandler( this.manageDeparmentsController.isPermitToHideLightbox, this.manageDeparmentsController ) );

        this.manageDeparmentsController.setLightbox( popup );
        this.manageDeparmentsController.initAfterShowing();
    };

    UserManagementMediator.prototype.showManageTimeZoneGroupsPopup = function( timeZoneGroupsChangedCallback )
    {
        if( !this.manageTimeZoneGroupsController )
        {
            this.manageTimeZoneGroupsController = GroupManagementUtil.initializeTimeZoneGroupsLightBox();
        }

        var self = this;

        var popup = createLightbox(
                "timeZoneGroupManagementLightBox",
                function () {
                    self.manageTimeZoneGroupsController.hideLightboxHandler( function () {
                        timeZoneGroupsChangedCallback(self.manageTimeZoneGroupsController);
                    } );
                },
                makeHandler( this.manageTimeZoneGroupsController.isPermitToHideLightbox, this.manageTimeZoneGroupsController ) );

        this.manageTimeZoneGroupsController.setLightbox( popup );
        this.manageTimeZoneGroupsController.initAfterShowing();
    };


    UserManagementMediator.prototype.createSelectedGroupsSet = function( groupIdsArray )
    {
        var selectedGroupsSet = {};
        if( groupIdsArray != null )
            for( var i = 0; i < groupIdsArray.length; i++ )
                selectedGroupsSet[ groupIdsArray[i] ] = true;
        return selectedGroupsSet;
    };

    UserManagementMediator.prototype.abortPreparedAndActiveRequests = function ()
    {
        clearTimeout(this.timer);

        if( this.rpcRequest )
            this.rpcRequest.abort();
    };

    UserManagementMediator.prototype.prepareInitialRequest = function(onTimer, withDelay)
    {

        this.abortPreparedAndActiveRequests();

        this.abortPreparedOrActiveSpin();

        if(withDelay)
        {
            this.timer = setTimeout( onTimer, 200 );
            this.spinInAfterDelay(200);
        }
        else
        {
            this.spinner.spin( this.spinnerEl );
            onTimer();
        }
    };

    UserManagementMediator.prototype._abortRequestsAndRevertState = function ()
    {
        this.abortPreparedAndActiveRequests();
        this.abortPreparedOrActiveSpin();
        this._revertState();
    };

    UserManagementMediator.prototype.init = function(userListBeans, pagerData, userGroupList, timeZoneGroupList, viewerSettings, userListSettings,
                                                     license, loggedInUserId, ptoHoursPerDay, allApprovers,
                                                     ptoDefaults, sickDefaults, loggedInUserTZGroupId)
    {
        this.loggedInUserId = loggedInUserId;
        this.time = null;
        this.rpcRequest = null;
        this.spinnerTimer = null;
        this.ptoHoursPerDay = ptoHoursPerDay;

        this.currentState = {};
        this.currentState.userListSettings = userListSettings;
        this.currentState.viewerSettings = viewerSettings;
        this.currentState.recordsPerPage = pagerData.recordsPerPage;
        this.currentState.pageNum = pagerData.pageNum;
        this.currentState.totalRecords = pagerData.totalRecords;
        this.currentState.userListOrder = userListSettings.order;
        this.currentState.searchText = "";
        this.currentState.license = license;
        this.currentState.noUsersShown = userListBeans.length <= 0;
        this._updateThereAreApproversInTheSystem(allApprovers);

        this.newState = $.extend( true, {}, this.currentState );

        this.$addUserButton = $("#createUserDiv > div");
        this.beigeButtonClassesController = new BeigeButtonClassesController().init(this.$addUserButton);
        this.$userListTableContainer = $( "#userListTableContainer" );

        this.addButtonStrategy = isOlVersion ?
                                 new AddButtonOnlineStrategy().init(this.$addUserButton, this.cl(this.createUser), this.cl(this.inviteSeveralUsers)) :
                                 new AddButtonDownloadableStrategy().init(this.cl(this.createUser));

        this.selectedGroupsSet = this.createSelectedGroupsSet( this.currentState.userListSettings.filter.groupIds );

        var selectedGroupType = this.currentState.userListSettings.filter.groupType;
        var userGroupsData = this.initGroupMapAndGroupWrappersList( userGroupList, selectedGroupType == GroupType.USER_GROUP ? this.selectedGroupsSet : {}, true, SystemSettings.usersWithoutGroupId );
        this.userGroupMap = userGroupsData.groupMap;
        this.userGroupWrappersList = userGroupsData.groupWrappersList;

        var timeZoneGroupsData = this.initGroupMapAndGroupWrappersList( timeZoneGroupList, selectedGroupType == GroupType.TIME_ZONE_GROUP ? this.selectedGroupsSet : {}, false, DEFAULT_TIME_ZONE_GROUP_ID);
        this.timeZoneGroupMap = timeZoneGroupsData.groupMap;
        this.timeZoneGroupWrappersList = timeZoneGroupsData.groupWrappersList;

        var self = this;
        this._initTabs();
        this._initFilters();
        this.pagerController = this._initPagerController(
                pagerData,
                function ( pageNum ) { self._pageNumChangedCallback( pageNum ); },
                function ( recordsPerPage ) { self._recordsPerPageChangedCallback( recordsPerPage ); }
        );


        if( this._isPASEnabled() )
        {
            this.assignmentsTooltip = new AssignmentsTooltip().init( "assignmentsTooltip" );
        }
        this.approversTooltip = new ApproversTooltip().init( "approversTooltip" );

        if( this._isAccountSettingsVisible() ) {
            this.taskHierarchyTooltip = new TaskHierarchyTooltip().init("userListTaskHierarchyTooltip");
            this.assignUsersForTTApproverTooltip = new AssignUsersToTTATooltip(viewerSettings.enabledFeatures.TTA).init("userListAssignUsersToTTATooltip");
            this.manageRightsTooltip = new ManageRightsTooltip().init("userListManageRightsTooltip");
        }

        this.userTableController = this._initUserTableController(
                userListSettings, viewerSettings, userListBeans, this.userGroupMap, this.timeZoneGroupMap, allApprovers, ptoDefaults, sickDefaults
        );

        this.filterByDepartmentPanel = new AT.ExtendedGroupsSelectorPanel(
                {
                    userListFilter: this.currentState.userListSettings.filter,
                    customOnChangeHandler: function () {
                        var groups = self._getSelectedGroupIds();
                        $("#filterByDepartmentButton").toggleClass("activeFilter", !!groups && groups.length != 0);
                    },
                    userGroupsData: this.userGroupWrappersList,
                    timeZoneGroupsData : this.timeZoneGroupWrappersList,
                    groupType: this.currentState.userListSettings.filter.groupType
                }
        );

        var editUserGroupsLink = document.getElementById("editDepartmentsLink");
        if (editUserGroupsLink)
        {
            editUserGroupsLink.onclick = function()
            {
                self.showManageDepartmentsPopup(function(controller)
                                                {
                                                    self._departmentsChanged(controller);
                                                }
                );
            };
        }

        var editTimeZoneGroupsLink = document.getElementById("editTimeZoneGroupsLink");
        if (editTimeZoneGroupsLink)
        {
            // time zone group of logged in user
            var previousLoggedInUserTZGroup = _.find(
                    timeZoneGroupList,
                    function(tzGroup)
                    {
                        return tzGroup.id == loggedInUserTZGroupId;
                    }
            );
            editTimeZoneGroupsLink.onclick = function()
            {
                self.showManageTimeZoneGroupsPopup(function(controller)
                                                   {
                                                       // get actual time zone group off logged in user
                                                       var newLoggedInUserTZGroup = _.find(
                                                               controller.storedData,
                                                               function(tzGroupWithUsers)
                                                               {
                                                                   var tzGroupUserIds = _.map(tzGroupWithUsers.users, function(user)
                                                                   {
                                                                       return user.id;
                                                                   });
                                                                   return _.contains(tzGroupUserIds, loggedInUserId);
                                                               }
                                                       );
                                                       // check new and prev tz group of logged in user
                                                       if (previousLoggedInUserTZGroup.id != newLoggedInUserTZGroup.id ||
                                                           previousLoggedInUserTZGroup.timeZoneId != newLoggedInUserTZGroup.timeZoneId ||
                                                           previousLoggedInUserTZGroup.cityName != newLoggedInUserTZGroup.cityName)
                                                       {
                                                           // update user list if his time zone group will be changed
                                                           alert(messageResource.getMessage('userlist.js.time_zone_was_changed'));
                                                           self._reloadPage();
                                                           return;
                                                       }

                                                       self._timeZoneGroupsChanged(controller);
                                                   }
                );
            };
        }

        this.toggleNoUsersCaption(userListBeans.length,this.currentState.userListSettings.filter.groupIds);

        this.spinner = this.createSpinner();
        this.spinnerEl = "spinnerPlaceholderId";
        this.licenseEl = document.getElementById("licenseCountId");
        this.pageBodyEl = document.getElementById("pageBody" );

        this.initHeaderSelectorsFunction = function () {
            this.filterButton = new AT.SelectorDropdownButton(
                    {
                        isNoShadow:true,
                        selectorPanel: this.filterByDepartmentPanel,
                        renderTo: document.getElementById("filterByDepartmentButton"),
                        minWidth: 457,
                        menuAlign: "tl-bl?",
                        menuAnchor: "td.middle-left-cell",
                        showMenu: function()
                        {
                            AT.DropdownButton.prototype.showMenu.call(this);
                        }
                    }
            );
            this.filterButton.setMenuHideCallback(
                    function() {
                        self.filterByDepartmentPanel.setAllIfNoneSelected();

                        if( self.filterByDepartmentPanel.isStateChanged() )
                            self._filterByDepartmentChangedCallBack( self._getShowDisabledUsers(), self._getSelectedGroupIds(), self._getSelectedGroupType() );
                    }
            );

            self.$showDisabledUsersChBox = $("#showDisabledUsersChBox" );
            self.$showDisabledUsersChBox[0].checked=this.currentState.userListSettings.filter.showDisabled;
            self.$showDisabledUsersChBox.change(function () { self.onShowDisabledUsersCallBack(self._getShowDisabledUsers()) });

            self.filterByDepartmentPanel.customOnChangeHandler();
        };

        this._updateUIAccordingToViewerPermissions();

        this.leaveBalanceEditor = new LeaveBalanceEditor();

        this._balanceHistoryPanel = new BalanceHistoryPanel().init();

        this.$tableContainerEl = $("#balanceHistoryTableBodyDiv");

        this.initApproversDialog();
        this.initUsersForApproverDialog();

        if( this._isPASEnabled() )
        {
            this.initProjectAssignmentDialog();
        }

        return this;
    };

    UserManagementMediator.prototype.initProjectAssignmentDialog = function ()
    {
        var self = this;

        this._projectAssignmentRequestObject = null;

        this.projectAssignmentDialog = new CustomerProjectSelectorDialog().init(
                {
                    dialogId: "CustomerProjectSelectorDialog",
                    dialogWidth: 456,
                    panelConstructor: AT.CPSelectorOnlyProjectsPanelForDialog,
                    configCtr:{collapsedCookiesKey: "userList"},
                    abortDataLoading: function()
                    {
                        if( self._projectAssignmentRequestObject != null )
                            self._projectAssignmentRequestObject.abort();
                    },
                    loadData: function ( dialogInfo, dataLoadedCallback )
                    {
                        self._projectAssignmentRequestObject = makeRpcCall(
                                "UserManagementService.getProjectAssignmentsData",
                                [dialogInfo.userId],
                                function ( data ) {
                                    self.userTableController.updateTaskHierarchyAssignmentsCellAfterDialogOpened(dialogInfo.cellObj, data);
                                    dataLoadedCallback(data);
                                },

                                function ( jqXHR, textStatus, errorThrown ) {
                                    if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                                    {
                                        alert(messageResource.getMessage('userlist.js.error_no_such_user.edit_user'));
                                        self.projectAssignmentDialog.close();
                                        self._deleteUser(dialogInfo.userId);
                                        return true;
                                    }
                                    if( errorThrown.exception == 'com.actimind.actitime.services.FeatureIsDisabledException' )
                                    {
                                        alert(messageResource.getMessage('userlist.js.error_pas_feature_disabled'));
                                        self.projectAssignmentDialog.close();
                                        self._reloadPage();
                                        return true;
                                    }
                                    if( errorThrown.exception == 'com.actimind.actitime.services.UserCanManageAssignmentsException' )
                                    {
                                        alert( messageResource.getMessage( "userlist.js.error_user_can_manage_assignments" ) );
                                        self.projectAssignmentDialog.close();
                                        self.updateCallSucceeded(errorThrown.result, null, false, null, dialogInfo.userId );
                                        return true;
                                    }
                                    self.projectAssignmentDialog.close();
                                }
                        );
                    },
                    saveData: function ( dialogInfo, allProjectsAssigned, assignedProjectIds )
                    {
                        self.saveProjectAssignments( dialogInfo, allProjectsAssigned, assignedProjectIds );
                    }
                } );
    };

    UserManagementMediator.prototype.saveProjectAssignments = function( dialogInfo, allProjectsAssigned, assignedProjectIds )
    {
        var self = this;
        makeRpcCall("UserManagementService.setProjectAssignments",
                    [dialogInfo.userId, allProjectsAssigned, assignedProjectIds],
                    function (result)
                    {
                        self.projectAssignmentDialog.hideAfterSaving();
                        self.updateCallSucceeded(result, null, false, null, dialogInfo.userId );
                    },
                    function ( jqXHR, textStatus, errorThrown )
                    {
                        if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                        {
                            self.projectAssignmentDialog.hideAfterSaving();
                            alert(messageResource.getMessage('userlist.js.error_no_such_user'));
                            self._deleteUser(dialogInfo.userId);
                            return true;
                        }
                        if( errorThrown.exception == 'com.actimind.actitime.services.AllAssignedProjectsNoLongerExistException' )
                        {
                            alert( messageResource.getMessage( "userlist.js.error_all_assigned_projects_deleted" ) );
                            self.projectAssignmentDialog._dataLoadedCallback(
                                    {
                                        customerProjectList: errorThrown.cpList,
                                        // Selection is empty because all assigned projects are deleted
                                        // But in database saved previous assignment
                                        allProjectsAssigned: false,
                                        assignedProjectIds: []
                                    }
                            );
                            return true;
                        }
                    }
        );
    };

    UserManagementMediator.prototype.initUsersForApproverDialog = function ()
    {
        var self = this;

        this._getUsersAssignedToApproverDataRequestObject = null;

        this.assignUsersToApproverDialog = new UsersForTTApproverDialog().init(
                {
                    dialogId: "usersForApproverDialog",
                    panelConstructor: self._isTTAEnabled() ? AT.UsersForTTApproverSelectorPanel : AT.UsersForTTManagerSelectorPanel,
                    abortDataLoading: function()
                    {
                        if( self._getUsersAssignedToApproverDataRequestObject != null )
                            self._getUsersAssignedToApproverDataRequestObject.abort( 'abortDataLoading' );
                    },
                    userGroupsEnabled: self._isUGREnabled(),
                    timeZoneGroupsEnabled: self._isTZGEnabled(),
                    loadData: function ( dialogInfo, dataLoadedCallback )
                    {
                        self._getUsersAssignedToApproverDataRequestObject = makeRpcCall(
                                "UserManagementService.getUsersAssignedToApprover",
                                [dialogInfo.userId],
                                function ( assignedUsersData ) {
                                    if ( self._checkReloadNeededAfterGetAssignedUsersRequest(assignedUsersData, self._isTTAEnabled(), self._isUGREnabled(), self._isTZGEnabled(), self.assignUsersToApproverDialog) ) {
                                        self._reloadPage();
                                        return;
                                    }

                                    self.userTableController.updateUsersForTTApproverCellAfterDialogOpened(dialogInfo.cellObj, assignedUsersData);

                                    dataLoadedCallback(assignedUsersData);
                                },

                                function ( jqXHR, textStatus, errorThrown )
                                {
                                    return self.handleTTADialogsLoadingDataErrors(  jqXHR, textStatus, errorThrown, dialogInfo,
                                                                                    function () { self.assignUsersToApproverDialog.close() }
                                    );
                                }
                        );
                    },
                    saveData: function ( dialogInfo, canManageAllUsers, selectedUserIds )
                    {
                        self.sendAssignUsersToApproverRequest( dialogInfo, canManageAllUsers, selectedUserIds );
                    }
                } );
    };

    UserManagementMediator.prototype._checkReloadNeededAfterGetAssignedUsersRequest = function( assignedUsersData, TTAEnabledOnPage, UGREnabledOnPage, TZGEnabledOnPage, dialog )
    {
        var needToReload = checkReloadNeededAfterGetAssignedUsersRequest( assignedUsersData, UGREnabledOnPage, TZGEnabledOnPage, dialog );
        if( !needToReload && TTAEnabledOnPage != assignedUsersData.TTAEnabled )
        {
            var message = messageResource.getMessage( assignedUsersData.TTAEnabled ?
                                                      'userlist.js.error_tta_feature_enabled' :
                                                      'userlist.js.error_tta_feature_disabled' );
            alert( message );
            dialog.close();
            needToReload = true;
        }
        return needToReload;
    };

    UserManagementMediator.prototype.sendAssignUsersToApproverRequest = function (dialogInfo, canManageAllUsers, selectedUserIds)
    {
        var self = this;

        makeRpcCall("UserManagementService.assignUsersToApprover",
                    [dialogInfo.userId, canManageAllUsers, selectedUserIds, self.userTableController.getVisibleUsersIds()],
                    function (resultWithAdditionalUsersInfo)
                    {
                        self.assignUsersToApproverDialog.hideAfterSaving();
                        self.updateCallSucceeded(resultWithAdditionalUsersInfo, null, false, null, dialogInfo.userId );
                    },
                    function ( jqXHR, textStatus, errorThrown )
                    {
                        if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                        {
                            alert(messageResource.getMessage('userlist.js.error_no_such_user'));
                            self.assignUsersToApproverDialog.hideAfterSaving();
                            self._deleteUser(dialogInfo.userId);
                            return true;
                        }
                        if( errorThrown.exception == 'com.actimind.actitime.user.NoSuchUsersException')
                        {
                            alert( messageResource.getMessage('userlist.js.error_all_selected_useds_deleted') );
                            self._deleteUsers(selectedUserIds);
                            self.assignUsersToApproverDialog.refreshData(dialogInfo, true);

                            return true;
                        }
                        self.assignUsersToApproverDialog.hideAfterSaving();
                    }
        );
    };

    UserManagementMediator.prototype.initApproversDialog = function ()
    {
        var self = this;

        this._getApproversDataRequestObject = null;
        this.assignApproversDialog = new ApproversDialog().init(
                {
                    submit: function ( dialogInfo, isAutoApproved, selectedApproverIds )
                    {
                        self.sendAssignApproversToUserRequest(dialogInfo, isAutoApproved, selectedApproverIds);
                    },
                    loadData: function ( dialogInfo, dataLoadedCallback, loadingFailedCallback )
                    {
                        self._getApproversDataRequestObject = makeRpcCall(
                                "UserManagementService.getManageApproversData",
                                [dialogInfo.userId],
                                function ( manageApproversData )
                                {
                                    var approversSortingProcessor = createApproversSortingProcessor( manageApproversData.allApprovers );
                                    var userApprovers = approversSortingProcessor( manageApproversData.userApproverIds );

                                    self.userTableController.updateAssignTTApproversCellAfterDialogOpened(dialogInfo.cellObj, manageApproversData, userApprovers);

                                    dataLoadedCallback( manageApproversData.allApprovers,
                                                        !manageApproversData.userRequiresApproval,
                                                        manageApproversData.userApproverIds );

                                    if ( self.currentState.thereAreApproversInTheSystem && manageApproversData.allApprovers.length == 0 )
                                    {
                                        alert(messageResource.getMessage("user_list.approvers_dialog.concurrently_no_tt_managers"));
                                        self._reloadPage();
                                    }
                                },
                                function ( jqXHR, textStatus, errorThrown )
                                {
                                    return self.handleTTADialogsLoadingDataErrors(jqXHR, textStatus, errorThrown, dialogInfo, loadingFailedCallback);
                                }
                        );
                    },
                    abortDataLoading: function ()
                    {
                        if( self._getApproversDataRequestObject != null )
                        {
                            self._getApproversDataRequestObject.abort( 'abortDataLoading' );
                        }
                    }
                }, 411 );
    };

    UserManagementMediator.prototype.handleTTADialogsLoadingDataErrors = function ( jqXHR, textStatus, errorThrown, dialogInfo, loadingFailedCallback )
    {
        var self = this;
        var errorWasFullyProcessed = false;

        if( textStatus == 'abortDataLoading' )
            errorWasFullyProcessed = true;
        else if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
        {
            alert( messageResource.getMessage( 'userlist.js.error_no_such_user.edit_user' ) );
            self._deleteUser( dialogInfo.userId );
            errorWasFullyProcessed = true;
        }
        else if( errorThrown.exception == 'com.actimind.actitime.services.FeatureIsDisabledException' )
        {
            alert( messageResource.getMessage( 'userlist.js.error_tta_feature_disabled' ) );
            self._reloadPage();
            errorWasFullyProcessed = true;
        }

        loadingFailedCallback();
        return errorWasFullyProcessed;
    };

    UserManagementMediator.prototype.sendAssignApproversToUserRequest = function (dialogInfo, isAutoApproved, selectedApproverIds)
    {
        var self = this;

        makeRpcCall(
                "UserManagementService.assignApproversToUser",
                [dialogInfo.userId, isAutoApproved, selectedApproverIds, self.userTableController.getVisibleUsersIds()],
                function ( resultWithAdditionalUsersInfo ) {
                    self.assignApproversDialog.hideAfterSaving();
                    self.updateCallSucceeded(resultWithAdditionalUsersInfo, null, false, null, dialogInfo.userId );
                },
                function ( jqXHR, textStatus, errorThrown ) {
                    if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                    {
                        alert(messageResource.getMessage('userlist.js.error_no_such_user'));
                        self.assignApproversDialog.hideAfterSaving();
                        self._deleteUser(dialogInfo.userId);
                        return true;
                    }
                    if( errorThrown.exception == 'com.actimind.actitime.administration.NoTimeTrackManagerException' )
                    {
                        alert(messageResource.getMessage("user_list.approvers_dialog.error.no_tt_managers"));
                        self.assignApproversDialog.hideAfterSaving();
                        self._reloadPage();
                        return true;
                    }
                    if( errorThrown.exception == 'com.actimind.common.administration.SomeOfSelectedApproversNotValidException' )
                    {
                        var allApprovers = errorThrown.allApprovers;
                        if ( allApprovers.length == 0 )
                        {
                            alert(messageResource.getMessage("user_list.approvers_dialog.error.no_tt_managers"));
                            self._reloadPage();
                        }
                        else
                            alert(messageResource.getMessage("user_list.some_of_selected_users_are_no_longer_approvers"));

                        var approversSortingProcessor = createApproversSortingProcessor( allApprovers );
                        var actualApprovers = approversSortingProcessor( selectedApproverIds );

                        self.userTableController.updateAssignTTApproversCellWithActualApprovers(dialogInfo.cellObj, actualApprovers);

                        var actualApproverIds = [];
                        for( var i = 0; i < actualApprovers.length; i++ )
                            actualApproverIds.push( actualApprovers[i].id );

                        self.assignApproversDialog.update( allApprovers, isAutoApproved, actualApproverIds );

                        return true;
                    }
                    self.assignApproversDialog.hideAfterSaving();
                }
        );
    };

    UserManagementMediator.prototype.onShowDisabledUsersCallBack = function(showDisabled)
    {
        this._filterByDepartmentChangedCallBack( showDisabled, this._getSelectedGroupIds(), this._getSelectedGroupType() );
    };


    UserManagementMediator.prototype.createSpinner = function()
    {
        return new SpinnerController();
    };


    UserManagementMediator.prototype.spinInAfterDelay = function(delay)
    {
        var self = this;
        this.spinnerTimer=setTimeout( function () {
            self.spinner.spin(self.spinnerEl)}, delay);
    };

    UserManagementMediator.prototype.abortPreparedOrActiveSpin=function()
    {
        clearTimeout(this.spinnerTimer);
        this.spinner.stop();
    };

    UserManagementMediator.prototype.hideNoUsersCaptionAndBottomSpacer = function () {
        if ( this.noUsersCaptionisHidden )
            return;

        $(".bottomSpacer").remove();
        var noUsersCaptionEl = document.getElementById("noUsersToShowId" );
        noUsersCaptionEl.style.display='none';
    };

    UserManagementMediator.prototype.toggleNoUsersCaption = function (recordsSize,customGroupSelected){
        var noUsersCaptionEl = document.getElementById("noUsersToShowId" );
        if(recordsSize==0){
            noUsersCaptionEl.style.display='block';
            this.noUsersCaptionisHidden = false;
            var groupType = this.currentState.userListSettings.filter.groupType;
            var noEnabledUsersMsg = customGroupSelected ?
                                       (groupType == GroupType.USER_GROUP ?
                                        messageResource.getEscapedMessage('userlist.js.users_table_no_enabled_users_found_in_selected_user_groups') :
                                        messageResource.getMessage('userlist.js.users_table_no_enabled_users_found_in_selected_time_zone_groups')) :
                                       messageResource.getMessage('userlist.js.users_table_no_enabled_users_found');
            var noUsersMsg = customGroupSelected ?
                                (groupType == GroupType.USER_GROUP ?
                                 messageResource.getEscapedMessage('userlist.js.users_table_no_users_found_in_selected_user_groups') :
                                 messageResource.getMessage('userlist.js.users_table_no_users_found_in_selected_time_zone_groups')) :
                                messageResource.getMessage('userlist.js.users_table_no_users_found');
            noUsersCaptionEl.innerHTML= this.currentState.userListSettings.filter.showDisabled ? noUsersMsg : noEnabledUsersMsg;
        }else{
            noUsersCaptionEl.style.display='none';
            this.noUsersCaptionisHidden = true;
        }
    };

    UserManagementMediator.prototype.getSortedUserList = function(userListBeansArrivedCallBack,withDelay)
    {
        var self=this;

        this.tokens = this.newState.searchText ==null ? [] : new StringTokenizer(UserTableController.PUNCTUATORS).getTokens( this.newState.searchText.toLowerCase() );

        var params = [this.newState.userListSettings.filter, this.tokens ,
                      this.newState.userListOrder,this.newState.pageNum,this.newState.recordsPerPage];
        var successHandler = function (result, textStatus, jqXHR)
        {
            self.abortPreparedOrActiveSpin();
            userListBeansArrivedCallBack( result );
        };

        var failHandler = function (result, textStatus, jqXHR)
        {
            if( textStatus == 'abort' )
                return;

            self.abortPreparedOrActiveSpin();
            self._revertState();
        };

        this.prepareInitialRequest(function () {self.rpcRequest= makeRpcCall( "UserManagementService.getUsers" , params, successHandler,failHandler )},withDelay);

    };

    UserManagementMediator.prototype._revertState = function(){
        this._revertUI();
        this.newState = $.extend(true,{},this.currentState);
    };

    UserManagementMediator.prototype._revertUI = function(  )
    {
        this.filterByDepartmentPanel.resetState(true);
        if(this.timeTrackApprovalFilter)  this.timeTrackApprovalFilter.setActiveItemByValue(this.currentState.userListSettings.filter.timeTrackApprovalFilter, true);
        if(this.taskHierarchyFilter) this.taskHierarchyFilter.setActiveItemByValue(this.currentState.userListSettings.filter.taskHierarchyFilter, true);
        if(this.balanceManagersFilter) this.balanceManagersFilter.setActiveItemByValue(this.currentState.userListSettings.filter.leaveBalancesManagerFilter, true);
        this.$showDisabledUsersChBox[0].checked =  this.currentState.userListSettings.filter.showDisabled;
        this.userTableController.setSearchText( this.currentState.searchText );
        this.pagerController.setRecordsPerPage( this.currentState.recordsPerPage );
    };


    UserManagementMediator.prototype._updateCurrentState = function( userListPageData  )
    {
        this.currentState.recordsPerPage = this.newState.recordsPerPage;
        this.currentState.userListOrder.order = this.newState.userListOrder.order;
        this.currentState.userListOrder.asc = this.newState.userListOrder.asc;
        this.currentState.searchText =  this.newState.searchText;
        this.currentState.totalRecords=userListPageData.totalRecords;
        this.currentState.pageNum=userListPageData.pageNum;
        this.currentState.viewerSettings=userListPageData.viewerSettings;
        this.currentState.userListSettings.filter.showDisabled=this.newState.userListSettings.filter.showDisabled;
        this.currentState.userListSettings.filter.groupIds=this._getSelectedGroupIds();
        this.currentState.userListSettings.filter.groupType=this.newState.userListSettings.filter.groupType;
        this.currentState.userListSettings.filter.taskHierarchyFilter = this.taskHierarchyFilter.getValue();
        this.currentState.userListSettings.filter.timeTrackApprovalFilter=this.newState.userListSettings.filter.timeTrackApprovalFilter;
        this.currentState.userListSettings.filter.leaveBalancesManagerFilter=this.newState.userListSettings.filter.leaveBalancesManagerFilter;
        this.currentState.noUsersShown = userListPageData.records.length <= 0;
        this._updateThereAreApproversInTheSystem(userListPageData.allApprovers);
    };

    UserManagementMediator.prototype._updateThereAreApproversInTheSystem = function( allApprovers )
    {
        // currentState.thereAreApproversInTheSystem : this field is needed to catch the situation
        //   when all approvers were made not approvers concurrently while opening the assign approvers to user dialog
        if (this._isTTAEnabled())
            this.currentState.thereAreApproversInTheSystem = allApprovers.length != 0;
    };

    UserManagementMediator.prototype._updateCurrentStateFromUserData = function(userData)
    {
        var oldFeatures = this.currentState.viewerSettings.enabledFeatures;
        var newFeatures = userData.userManagementData.viewerSettings.enabledFeatures;

        var featureDiff = new FeatureDiffStateController().init(oldFeatures, newFeatures);
        var areRightsChanged = this._areUserRightsChanged(this.currentState.viewerSettings, userData.userManagementData.viewerSettings);

        SystemSettings.dateFormat = userData.userManagementData.dateFormat;

        this.currentState.viewerSettings = userData.userManagementData.viewerSettings;

        return {featureDiff: featureDiff, areRightsChanged: areRightsChanged};
    };

    UserManagementMediator.prototype._getShowDisabledUsers = function() {
        return this.$showDisabledUsersChBox[0].checked;
    };

    UserManagementMediator.prototype._getSelectedGroupIds = function() {
        return this.filterByDepartmentPanel.getSelectedGroupIds();
    };

    UserManagementMediator.prototype._getSelectedGroupType = function() {
        return this.filterByDepartmentPanel.getGroupType();
    };

    UserManagementMediator.prototype._getDiffBetweenFeaturesAndRights = function(data, oldFeatureDiff){
        var currentState = this.currentState;
        var oldFeatures = currentState.viewerSettings.enabledFeatures;
        var newFeatures = data.viewerSettings.enabledFeatures;
        var newFeatureDiff =  new FeatureDiffStateController().init( oldFeatures, newFeatures );
        if (oldFeatureDiff != null){
            if (newFeatureDiff.featuresChanged)
                newFeatureDiff = this._intersectTwoSuccessiveFeaturesChanges(oldFeatureDiff, newFeatureDiff);
            else
                newFeatureDiff = oldFeatureDiff;
        }

        return {
            // !Note, that the _getFeatureDiff() method changes the oldFeatures object.
            // If you will need it later, make its copy before calling this method.
            featureDiff: newFeatureDiff,
            userRightsChanged: this._areUserRightsChanged( currentState.viewerSettings, data.viewerSettings ),
            areAllowedToManageAccountSettingsChanged: this._areAllowedToManageAccountSettingsChanged( currentState.viewerSettings, data.viewerSettings ),
            areAllowedToManageLeaveBalanceSettingsChanged: this._areAllowedToManageLeaveBalanceSettingsChanged( currentState.viewerSettings, data.viewerSettings ),
            showAccountSettingsChanged: this._areShowAccountSettingsChanged( currentState.viewerSettings, data.viewerSettings )
        }
    };

    UserManagementMediator.prototype._getDiffBetweenStates = function(data){

        var currentState = this.currentState;
        var oldLicense= currentState.license;
        var newLicense= this.newState.license;
        var oldShowDisabledUsers = this.currentState.userListSettings.filter.showDisabled;
        var newShowDisabledUsers = this._getShowDisabledUsers();
        var oldNoUsersShown = currentState.noUsersShown;
        var newNoUsersShown = data.records.length<=0;

        var result = this._getDiffBetweenFeaturesAndRights(data, null);
        result.licenseChanged = this._isLicenseChanged( oldLicense, newLicense );
        result.numOfRecordsChanged = oldNoUsersShown!= newNoUsersShown || oldShowDisabledUsers != newShowDisabledUsers;
        result.groupTypeChanged = currentState.userListSettings.filter.groupType != this.newState.userListSettings.filter.groupType;

        return result;
    };

    UserManagementMediator.prototype._isLicenseChanged = function (oldLicense,newLicense){

        return oldLicense.allowedCount!= newLicense.allowedCount ||
               oldLicense.actualCount!=newLicense.actualCount;

    };

    UserManagementMediator.prototype._areUserRightsChanged = function (oldViewerSettings,newViewerSettings){
        return this._areAllowedToManageAccountSettingsChanged(oldViewerSettings, newViewerSettings) ||
               this._areAllowedToManageLeaveBalanceSettingsChanged(oldViewerSettings, newViewerSettings) ||
               this._areShowAccountSettingsChanged(oldViewerSettings, newViewerSettings);
    };

    UserManagementMediator.prototype._areAllowedToManageAccountSettingsChanged= function (oldViewerSettings,newViewerSettings){
        return oldViewerSettings.allowedToManageAccountSettings!=newViewerSettings.allowedToManageAccountSettings
    };

    UserManagementMediator.prototype._areShowAccountSettingsChanged= function (oldViewerSettings,newViewerSettings){
        return oldViewerSettings.showAccountSettings!=newViewerSettings.showAccountSettings
    };

    UserManagementMediator.prototype._areAllowedToManageLeaveBalanceSettingsChanged= function (oldViewerSettings,newViewerSettings){
        return oldViewerSettings.allowedToManageLeaveBalanceSettings!=newViewerSettings.allowedToManageLeaveBalanceSettings
    };




    //this method intersect two successive changes features  (nedded for show popups user)
    UserManagementMediator.prototype._intersectTwoSuccessiveFeaturesChanges = function(oldFeaturesDiff, newFeaturesDiff){
        for( var f in oldFeaturesDiff.addedFeatures )
        {
            if( newFeaturesDiff.deletedFeatures[f] )
            {
                delete  oldFeaturesDiff.addedFeatures[f];
                delete  newFeaturesDiff.deletedFeatures[f]
            }
        }
        for( var f in oldFeaturesDiff.deletedFeatures )
        {
            if( newFeaturesDiff.addedFeatures[f] )
            {
                delete  oldFeaturesDiff.deletedFeatures[f];
                delete  newFeaturesDiff.addedFeatures[f];
            }
        }
        for( var f in newFeaturesDiff.addedFeatures )
        {
            oldFeaturesDiff.addedFeatures[f] = true;
        }
        for( var f in newFeaturesDiff.deletedFeatures )
        {
            oldFeaturesDiff.deletedFeatures[f] = true;
        }

        oldFeaturesDiff.validateFeaturesChanged();
        return oldFeaturesDiff;
    };


    UserManagementMediator.prototype._userListPageDataReceived = function( userListPageData )
    {
        var diffBetweenStates = this._getDiffBetweenStates( userListPageData );
        this._updateCurrentState( userListPageData );

        if(!this.validateIsChangedFeaturesOrRights(diffBetweenStates, false))
            return;

        this.ptoHoursPerDay = userListPageData.ptoHoursPerDay;

        if( this._isUGREnabled() || this._isTZGEnabled() )
        {
            var previouslySelectedGroupIds = this._rebuildGroupMapAndUpdateFilter( userListPageData.allUserGroups, userListPageData.allTimeZoneGroups );
            if (this.currentState.userListSettings.filter.groupType == GroupType.USER_GROUP)
            {
                for( var groupId in previouslySelectedGroupIds.userGroups )
                {
                    if (!this.userGroupMap[groupId])
                    {
                        this._onGroupDeletedCallBack();
                        break;
                    }
                }
            }
            else if (this.currentState.userListSettings.filter.groupType == GroupType.TIME_ZONE_GROUP)
            {
                for( var groupId in previouslySelectedGroupIds.timeZoneGroups )
                {
                    if (!this.timeZoneGroupMap[groupId])
                    {
                        this._onGroupDeletedCallBack();
                        break;
                    }
                }
            }
        }

        this.pagerController.setPagerStateAndUpdateUI( this.currentState.totalRecords, this.currentState.pageNum, this.currentState.recordsPerPage );

        this.userTableController.setUserTableStateAndUpdateUI(
                userListPageData.records,
                this.userGroupMap,
                this.timeZoneGroupMap,
                this.currentState.viewerSettings,
                this.currentState.userListOrder,
                this.tokens,
                this._isPTOEnabled(),
                this.ptoHoursPerDay,
                userListPageData.allApprovers
        );

        if( diffBetweenStates.featureDiff.areFeaturesChanged() || diffBetweenStates.licenseChanged )
            this._updateUIAccordingToViewerPermissions();

        var userGroupIds = this.currentState.userListSettings.filter.groupIds;

        if( diffBetweenStates.numOfRecordsChanged || diffBetweenStates.groupTypeChanged )
            this.toggleNoUsersCaption( userListPageData.records.length, userGroupIds && userGroupIds.length > 0 );

        this.$showDisabledUsersChBox.checked = this.currentState.userListSettings.filter.showDisabled;

        this._scrollToTableTop();
        
        PageOverlayTipsManager.getInstance().refreshDynamicTips();
    };

    UserManagementMediator.prototype._scrollToTableTop = function (){
        var windowTop = $(window).scrollTop();
        var topPositionMustBeVisible = this.$userListTableContainer.offset().top-55;

        if(windowTop>topPositionMustBeVisible)
        {
            window.scrollTo(0,topPositionMustBeVisible);
        }
    };

    UserManagementMediator.prototype._updateUIAccordingToViewerPermissions = function (){
        if ( this._hasManageAccountSettings()  && !this._isLicenseUnlimited() && this._isLicenseViolated() ){
        	this.$addUserButton.addClass("disabled");
        } else {
            this.$addUserButton.removeClass("disabled");
        }
        this.pageBodyEl.className=this._getPageBodyClasses();
        if( !this._hasManageAccountSettings() || this._isLicenseViolated() )
            this._disableAddUserButtonEvent();
        else
            this._enableAddUserButtonEvent();

        if( this._hasManageAccountSettings() )
            this._updateLicenseText();
    };

    UserManagementMediator.prototype._hasManageAccountSettings = function (){
       return this.currentState.viewerSettings.allowedToManageAccountSettings;
    };

    UserManagementMediator.prototype._disableAddUserButtonEvent = function (){
        this.$addUserButton.off();
    };

    UserManagementMediator.prototype._enableAddUserButtonEvent  = function (){
        this.$addUserButton.off();
        this.$addUserButton.click(this.cl(function() { this.addButtonStrategy.callback() }));
        this.beigeButtonClassesController.addListenersIfNeeded();
    };

    UserManagementMediator.prototype._updateLicenseText = function (){
        var text;

        if(this._isLicenseViolated())
            {
                var extraUsersCount = this.currentState.license.extraUsersCount;
                text= messageResource.getMessage(extraUsersCount==1 ? "userlist.license.disable_user":
                                                                      "userlist.license.disable_users",[extraUsersCount] );
            }
        else {
            var remainingCount = this.currentState.license.remainingCount;
            var remainingCountText =this._haveMoreLicenses() ? remainingCount :  messageResource.getMessage("userlist.pagebody.no_licenses_left");
            text=   messageResource.getMessage(remainingCount==1 ?"userlist.pagebody.license_left" :
                                                                   "userlist.pagebody.licenses_left",[remainingCountText]);
        }

        this.licenseEl.innerHTML=text;

    };

    UserManagementMediator.prototype._getPageBodyClasses = function (){
        var classes = [];
        if(!this._hasManageAccountSettings()){
            classes.push("addUserHidden");
            classes.push("editGroupsHidden");
        }

        if (this._hasManageAccountSettings() && !this._isLicenseUnlimited())
        {
            classes.push("licenseShown");
            if (this._haveMoreLicenses())
                classes.push("licenseNormal");
            else
                classes.push("licenseError");
        }

        if(!this._isUGREnabled())
            classes.push("ugrDisabled");

        if(!this._isTZGEnabled())
            classes.push("tzgDisabled");

        classes.push("usersManagement pageBody");

        return classes.join(" ");

    };

    UserManagementMediator.prototype._isLicenseViolated = function (){
        return this.currentState.license.licenseViolated;
    };

    UserManagementMediator.prototype._isLicenseUnlimited = function (){
        return this.currentState.license.remainingCount==UserManagementConstants.LICENSE_UNLIM;
    };

    UserManagementMediator.prototype._haveMoreLicenses = function (){
        var remainingCount = this.currentState.license.remainingCount;
        return this._isLicenseUnlimited() || remainingCount>0;
    };

    UserManagementMediator.prototype._isUGREnabled = function (){
        return this.validateEnabledFeature(UserManagementConstants.UGRFeature);
    };

    UserManagementMediator.prototype._isTZGEnabled = function (){
        return this.validateEnabledFeature(UserManagementConstants.TZGFeature);
    };

    UserManagementMediator.prototype._isPASEnabled = function (){
        return this.validateEnabledFeature(UserManagementConstants.PASFeature);
    };

    UserManagementMediator.prototype._onFeatureChanged = function(isEnablesFeature, featureTitle){
        var msg = messageResource.getMessage ("userlist.js.error_change_feature.prefix");
        msg += " ";
        msg += isEnablesFeature ?  messageResource.getMessage ("userlist.js.error_change_feature.enabled")
                : messageResource.getMessage ("userlist.js.error_change_feature.disabled");
        msg +=" ";
        msg += featureTitle;
        msg +=" ";
        msg += messageResource.getMessage("userlist.js.error_change_feature.suffix");

        alert(msg);
        this._reloadPage();
    };

    UserManagementMediator.prototype._onShowPTOSettingsChanged = function(){
        var ptoEnabled = this._isPTOEnabled();
        var sickEnabled = this._isSickEnabled();
        var haveRightMsg;
        var noRightMsg;
        if( ptoEnabled && sickEnabled )
        {
            haveRightMsg = "userlist.js.error_have_right_to_view_pto_and_sick_tabs";
            noRightMsg = "userlist.js.error_no_right_to_view_pto_and_sick_tabs";
        }
        else if( ptoEnabled )
        {
            haveRightMsg = "userlist.js.error_have_right_to_view_pto_tab";
            noRightMsg = "userlist.js.error_no_right_to_view_pto_tab";
        }
        else if( sickEnabled )
        {
            haveRightMsg = "userlist.js.error_have_right_to_view_sick_tab";
            noRightMsg = "userlist.js.error_no_right_to_view_sick_tab";
        }
        this._onRightChanged( this.currentState.viewerSettings.allowedToManageLeaveBalanceSettings,
                              haveRightMsg,
                              noRightMsg );
    };

    UserManagementMediator.prototype._onShowAccountSettingsChanged = function(){
        this._onRightChanged(this._isAccountSettingsVisible(),
             "userlist.js.error_have_right_to_view_account_tab",
                "userlist.js.error_no_right_to_view_account_tab");
    };


    UserManagementMediator.prototype._onManageAccountSettingsChanged = function(){
        this._onRightChanged(this._hasManageAccountSettings(),
                             "userlist.js.error_have_right_to_manage_account",
                             "userlist.js.error_no_right_to_view_account_tab_readonly");
    };

    UserManagementMediator.prototype._onRightChanged = function(isVisible, keyTextHaveRights, keyTextNotHaveRights){
        var messageKey = isVisible ? keyTextHaveRights : keyTextNotHaveRights;
        alert(messageResource.getMessage(messageKey));
        this._reloadPage();
    };

    UserManagementMediator.prototype._onUGRChanged = function(){
        this._onFeatureChanged(this._isUGREnabled(), messageResource.getMessage("userlist.js.error_change_feature.user_groups"));
    };

    UserManagementMediator.prototype._onTZGChanged = function(){
        this._onFeatureChanged(this._isTZGEnabled(), messageResource.getMessage("userlist.js.error_change_feature.time_zone_groups"));
    };

    UserManagementMediator.prototype._onPASChanged = function(){
        this._onFeatureChanged(this._isPASEnabled(), messageResource.getMessage("features.PAS.title"));
    };

    UserManagementMediator.prototype._onPTOChanged = function(){
        this._onFeatureChanged(this._isPTOEnabled(), messageResource.getMessage("features.PTO.title"));
    };

    UserManagementMediator.prototype._onSickChanged = function(){
        this._onFeatureChanged(this._isSickEnabled(), messageResource.getMessage("features.SDB.title"));
    };

    UserManagementMediator.prototype._onTTAChanged = function(){
        this._onFeatureChanged(this._isTTAEnabled(), messageResource.getMessage("features.TTA.title"));
    };

    UserManagementMediator.prototype._isPTOEnabled = function (){
        return this.validateEnabledFeature(UserManagementConstants.PTOFeature);
    };

    UserManagementMediator.prototype._isSickEnabled = function (){
        return this.validateEnabledFeature(UserManagementConstants.SDBFeature);
    };

    UserManagementMediator.prototype._isTTAEnabled = function () {
        return this.validateEnabledFeature(UserManagementConstants.TTAFeature);
    };

    UserManagementMediator.prototype._isAccountSettingsVisible = function() {
        return this.currentState.viewerSettings.showAccountSettings;
    };

    UserManagementMediator.prototype._isPTOSettingsVisible = function() {
        return this.currentState.viewerSettings.allowedToManageLeaveBalanceSettings && this._isPTOEnabled();
    };

    UserManagementMediator.prototype._isSickDaysSettingsVisible = function() {
        return this.currentState.viewerSettings.allowedToManageLeaveBalanceSettings && this._isSickEnabled();
    };

    UserManagementMediator.prototype.validateEnabledFeature = function(featureName){
        return this.currentState.viewerSettings.enabledFeatures.hasOwnProperty(featureName);
    };

    UserManagementMediator.prototype._pageNumChangedCallback = function( pageNum )
    {
        var self = this;
        this.newState.pageNum=pageNum;

        this.getSortedUserList(
                function( userListPageData ) {
                    self.filterByDepartmentPanel.setInitialValuesFromCurrent();
                    self._userListPageDataReceived( userListPageData );

                    if( self._hasManageAccountSettings() ){
                        licenseChanged = self._isLicenseChanged( self.currentState.license, userListPageData.licenseCounters );
                        self.currentState.license = userListPageData.licenseCounters;
                        self._updateUIAccordingToViewerPermissions();
                    }
                }
        );

    };

    UserManagementMediator.prototype._recordsPerPageChangedCallback = function( recordsPerPage )
    {
        this.newState.recordsPerPage = recordsPerPage;
        this.pagerController.loadPage(1);
    };

    UserManagementMediator.prototype._groupAssignmentsChangedCallback = function()
    {
        if ( this.newState.userListSettings.filter.groupIds && this.pagerController.pageNum === 1 ) {
            this.pagerController.loadPage(1);
        }
    };

    UserManagementMediator.prototype._sortingChangedCallback = function( event,order )
    {
        //this.spinner.spin(this.spinnerEl);
        this.userTableController.removeTrSpacers();

        this.newState.userListOrder.asc = order != this.currentState.userListOrder.order || !this.currentState.userListOrder.asc;
        this.newState.userListOrder.order = order;
        this.newState.pageNum = 1;

        this.pagerController.loadPage(1);
        //this.spinner.stop();
    };

    UserManagementMediator.prototype._searchTermsChangedCallback = function( event )
    {
        this.userTableController.removeTrSpacers();

        var inputText = $.trim(event.target.value);

        if( event.keyCode == KEY_CODE_ESC && inputText!="" )
        {
            inputText="";
            event.target.value=inputText;
        }
        this._searchTerms( inputText );
    };

    UserManagementMediator.prototype._searchTerms = function( text )
    {
        this.newState.searchText = text;
        if( this.currentState.searchText != this.newState.searchText )
        {
            var pagerController = this.pagerController;

            // set timer to make request later to prevent from too fast keyboard typing
            this.prepareInitialRequest( function () {pagerController.loadPage( 1 );}, true );
        }
    };

    UserManagementMediator.prototype._filterByDepartmentChangedCallBack = function( showDisabled, groupIds, groupType )
    {
        this.newState.userListSettings.filter.showDisabled = showDisabled;
        this.newState.userListSettings.filter.groupIds = groupIds;
        this.newState.userListSettings.filter.groupType = groupType;
        this.pagerController.loadPage(1);
    };

    UserManagementMediator.prototype._filterChange = function(nameFilter, value){
        //this.spinner.spin(this.spinnerEl);
        this.newState.userListSettings.filter[nameFilter] = value;
        this.pagerController.loadPage(1);
        //this.spinner.stop();
    };

    UserManagementMediator.prototype._onGroupDeletedCallBack = function (){
        this._filterByDepartmentChangedCallBack( this._getShowDisabledUsers(), this._getSelectedGroupIds(), this._getSelectedGroupType() );
    };

    UserManagementMediator.prototype._departmentsChanged = function (departmentController)
    {
        var noGroupObj = departmentController.storedData.shift();
        var previouslySelectedGroupIds = this._rebuildGroupMapAndUpdateFilter(departmentController.storedData, this.filterByDepartmentPanel.timeZoneGroupsData);

        var deletedGroupFind = false;
        for( var groupId in previouslySelectedGroupIds.userGroups )
        {
            if( !this.userGroupMap[groupId] )
            {
                this._onGroupDeletedCallBack(); // reload page data if group deleted
                deletedGroupFind = true;
                break;
            }
        }
        if(!deletedGroupFind)
        {
            // update first page only if  update not performed before.See Bug 54149
            this._groupAssignmentsChangedCallback();
        }

        departmentController.storedData.unshift( noGroupObj );
        var userIdGroupIdMap = this.convertToUserToGroupMap(departmentController.storedData);
        this.userTableController.updateUserGroups(userIdGroupIdMap, this.userGroupMap);
    };

    UserManagementMediator.prototype._timeZoneGroupsChanged = function(timeZoneGroupController)
    {
        var previouslySelectedTimeZoneGroupIds = this._rebuildGroupMapAndUpdateFilter(this.filterByDepartmentPanel.userGroupsData, timeZoneGroupController.storedData);

        var deletedGroupFind = false;
        for (var groupId in previouslySelectedTimeZoneGroupIds.timeZoneGroups)
        {
            if (!this.timeZoneGroupMap[groupId])
            {
                this._onGroupDeletedCallBack(); // reload page data if group deleted
                deletedGroupFind = true;
                break;
            }
        }
        if(!deletedGroupFind)
        {
            // update first page only if  update not performed before.See Bug 54149
            this._groupAssignmentsChangedCallback();
        }
        var userIdGroupIdMap = this.convertToUserToGroupMap(timeZoneGroupController.storedData);
        this.userTableController.updateTimeZoneGroups(userIdGroupIdMap, this.timeZoneGroupMap);
    };

    UserManagementMediator.prototype._rebuildGroupMapAndUpdateFilter = function (userGroupList, timeZoneGroupList)
    {
        var previouslySelectedGroupIds = { userGroups: null, timeZoneGroups: null };
        var previouslySelectedGroupType = this.filterByDepartmentPanel.groupType;
        this.userGroupWrappersList = null;
        this.timeZoneGroupWrappersList = null;
        if(this._isUGREnabled())
        {
            this.filterByDepartmentPanel.groupByUserGroup();
            previouslySelectedGroupIds.userGroups = this.filterByDepartmentPanel.getSelectedGroupIdsSet(true);
            var userGroupsData = this.initGroupMapAndGroupWrappersList(userGroupList, previouslySelectedGroupIds.userGroups, true, SystemSettings.usersWithoutGroupId);
            this.userGroupMap = userGroupsData.groupMap;
            this.userGroupWrappersList = userGroupsData.groupWrappersList;
        }
        if(this._isTZGEnabled())
        {
            this.filterByDepartmentPanel.groupByTimeZoneGroup();
            previouslySelectedGroupIds.timeZoneGroups = this.filterByDepartmentPanel.getSelectedGroupIdsSet(true);
            var timeZoneGroupsData = this.initGroupMapAndGroupWrappersList(timeZoneGroupList, previouslySelectedGroupIds.timeZoneGroups, false, DEFAULT_TIME_ZONE_GROUP_ID);
            this.timeZoneGroupMap = timeZoneGroupsData.groupMap;
            this.timeZoneGroupWrappersList = timeZoneGroupsData.groupWrappersList;
        }
        if(this._isTZGEnabled() && this._isUGREnabled())
        {
            previouslySelectedGroupType == GroupType.USER_GROUP ? this.filterByDepartmentPanel.groupByUserGroup() : this.filterByDepartmentPanel.groupByTimeZoneGroup();
        }
        this.filterByDepartmentPanel.updateGroupsData(this.userGroupWrappersList,
                                                      this.timeZoneGroupWrappersList);
        return previouslySelectedGroupIds;
    };

    UserManagementMediator.prototype._updateGroupsOnUserCreateOrUpdate = function (groupList, timeZoneGroupsList)
    {
        if (this._isUGREnabled() || this._isTZGEnabled())
            this._rebuildGroupMapAndUpdateFilter(groupList, timeZoneGroupsList);

        if (this._isUGREnabled())
        {
            var userIdGroupIdMap = this.userTableController.makeUserIdGroupIdMapForVisibleUser();
            this.userTableController.updateUserGroups(userIdGroupIdMap, this.userGroupMap);
        }
        if (this._isTZGEnabled())
        {
            var timeZoneIdGroupIdMap = this.userTableController.makeTimeZoneIdGroupIdMapForVisibleUser();
            this.userTableController.updateTimeZoneGroups(timeZoneIdGroupIdMap, this.timeZoneGroupMap);
        }
    };

    UserManagementMediator.prototype.convertToUserToGroupMap = function (groupWithUsersList)
    {
        var userGroupMap = {};

        for( var i = 0; i < groupWithUsersList.length; i++ )
        {
            var group = groupWithUsersList[i];
            var users = group.users;

            if( users )
                for( var j = 0; j < users.length; j++ )
                {
                    var userId = group.users[j].id;
                    userGroupMap[userId] =  group.id;
                }
        }

        return userGroupMap;
    };

    UserManagementMediator.prototype.render = function (  )
    {
        this.userTableController.render();
        this.pagerController.render();
        this.initHeaderSelectorsFunction();
    };

    UserManagementMediator.prototype.cl = function( func )
    {
        var self = this;
        return function() { func.apply( self, arguments ); }
    };

    UserManagementMediator.prototype.createUser = function ()
    {
        this._abortRequestsAndRevertState();

        this._showLoadingPopup();
        var self = this;
        makeRpcCall( "UserManagementService.getCreateUserData", [],
                     function( createUserData )
                     {
                         self.showCreateUserPopup( createUserData );
                     },
                     function ( jqXHR, textStatus, errorThrown )
                     {
                         self._hideLoadingPopup();

                         if( errorThrown.exception == 'com.actimind.actitime.services.NoRightsToManageAccountSettings' )
                         {
                             alert( messageResource.getMessage( 'userlist.js.error_cant_create_user_account' ) );
                             document.location.reload();
                             return true;
                         }
                         return false;
                     }
        );
    };

    UserManagementMediator.prototype.inviteSeveralUsers = function()
    {
        this._abortRequestsAndRevertState();

        this._showLoadingPopup();
        var self = this;
        makeRpcCall("UserManagementService.getInviteSeveralUsersData", [],
                    function(inviteUsersData)
                    {
                        self.showInviteSeveralUsersPopup(inviteUsersData);
                    },
                    function(jqXHR, textStatus, errorThrown)
                    {
                        self._hideLoadingPopup();

                        if (errorThrown.exception == 'com.actimind.actitime.services.NoRightsToManageAccountSettings')
                        {
                            alert(messageResource.getMessage('userlist.js.error_cant_create_user_account'));
                            document.location.reload();
                            return true;
                        }
                        return false;
                    }
        );
    };

    UserManagementMediator.prototype.showInviteSeveralUsersPopup = function(inviteUsersData)
    {
        this._hideLoadingPopup();

        var lb = new ATInviteSeveralUsersLightBox()
                .init(
                        inviteUsersData,
                        function()
                        {
                            // show getting started menu if need
                            if(!_.isUndefined(window.GettingStartedShortcuts))
                            {
                                GettingStartedShortcuts.showJustCheckedShortcutIfExists();
                            }
                        }
                );
        var changes = this._updateCurrentStateFromUserData(inviteUsersData);
        var pageUIMustBeUpdated = changes.featureDiff.areFeaturesChanged() || changes.areRightsChanged;
        var self = this;

        lb.setSuccessCallback(function(userFieldsArray)
                              {
                                  if (userFieldsArray.length == 0)
                                  {
                                      return;
                                  }
                                  lb.disableUserInputWhileSaving();
                                  makeRpcCall("UserManagementService.inviteUsers", [userFieldsArray],
                                              function(inviteUsersResult)
                                              {
                                                  lb.enableUserInputWhileSaving();
                                                  self.createSeveralUsersCallSucceeded(inviteUsersResult, lb, pageUIMustBeUpdated, changes.featureDiff)
                                              },
                                              function(jqXHR, textStatus, errorThrown)
                                              {
                                                  lb.enableUserInputWhileSaving();
                                                  if (errorThrown.exception == "com.actimind.actitime.services.InviteSeveralUsersExceptionWithPermissionsTemplates")
                                                  {
                                                      lb.showServerErrors(errorThrown.userTableErrors);
                                                      lb.updatePermissionsTemplatesData(errorThrown.permissionsTemplates);
                                                      return true;
                                                  }
                                                  if (errorThrown.exception == "com.actimind.actitime.administration.UserExistsException")
                                                  {
                                                      alert(messageResource.getMessage("userlist.js.invite_user_mode_popup.duplicate_username"));
                                                      return true;
                                                  }
                                                  return false;
                                              }
                                  );
                              }
        );
        lb.setCancelCallback(function()
                             {
                                 lb.hide();

                                 if (!self.validateIsChangedFeaturesOrRights(changes))
                                 {
                                     if (pageUIMustBeUpdated)
                                         self._updateUIAccordingToViewerPermissions();
                                     return;
                                 }

                                 self._updateGroupsOnUserCreateOrUpdate(inviteUsersData.userManagementData.allUserGroups,
                                                                        inviteUsersData.userManagementData.allTimeZoneGroups);
                             });
        lb.show();
    };

    UserManagementMediator.prototype._makeDefaultUserAccountSettings = function( userManagementData, otherProductStatusEditable )
    {
        var defaultTempl = _.find(userManagementData.permissionsTemplates, function(template)
        {
            return template.id == DEFAULT_PERMISSIONS_TEMPLATE_ID;
        });
        var defaultPermissions = defaultTempl ? defaultTempl.permissions : []; // get default permission from default permissions template

        return {
            firstName: "",
            lastName: "",
            middleInitial: "",
            username: "",
            enabled: true,
            enabledInOtherProduct: otherProductStatusEditable ? true : null,
            userGroupId: UserManagementConstants.USER_GROUP_NOT_ASSIGNED_ID,
            timeZoneGroupId: UserManagementConstants.DEFAULT_TIME_ZONE_GROUP_ID,
            overtimeLevel: SystemSettings.defaultOvertimeLevel,
            email:"",
            hireDate: currentUserTime().toJSON(),
            releaseDate: null,
            allProjectsAssigned: false,
            initialSchedule: userManagementData.defaultWorkSchedule.slice(0),
            defaultInitialSchedule: true,
            workSchedule: [],
            rates: userManagementData.viewerSettings.enabledFeatures[ UserManagementConstants.URAFeature ] ? [] : null,
            accessRights: defaultPermissions,
            assignedProjectIds: []
        };
    };

    UserManagementMediator.prototype._initAndShowCreateUserPopup = function( userData, userAccountSettings, currentTime, selectedUserId, collectedChanges, showOvertime )
    {
        var changes;
        if (!!collectedChanges)
        {
            changes = this._getDiffBetweenFeaturesAndRights(userData.userManagementData, collectedChanges.featureDiff);
            this.currentState.viewerSettings = userData.userManagementData.viewerSettings;
        }
        else
        {
            changes = this._updateCurrentStateFromUserData(userData);
        }

        var pageUIMustBeUpdated = changes.featureDiff.areFeaturesChanged() || changes.areRightsChanged || ( !!collectedChanges && collectedChanges.pageUIMustBeUpdated ),

            sectionBuilderParams = new ActitimeUserManagementSectionsBuilderParams().setUserManagementSectionsBuilderParams(
                new CommonUserManagementSectionsBuilderParams()
                        .setPreparatoryStrategy(new CreateSectionsPreparatoryStrategy().init())
                        .setWorkdayDurationsTableBuilder(new CreateWorkDayDurationsTableBuilder().init( userData.userManagementData ))
                        .setUserManagementData(userData.userManagementData)
                        .setCurrentTime(currentTime)
                        .setAccountSettings(userAccountSettings)
                        .setEditedUserIsLoggedIn(false)
                        .setRatesTableStrategy(new CreateUserPopupRatesTableStrategy())
            ).setPtoHoursPerDay(this.ptoHoursPerDay ),

            sectionsBuilder = new ActitimeUserManagementSectionsBuilder().init(sectionBuilderParams ),
            self = this,
            lb = new CreateUserLightBox().init( sectionsBuilder,  userData.userManagementData, userAccountSettings,
                                                userData.allUsers, this.cl( this.getCopyUserSettingsData ), selectedUserId,
                                                function()
                                                {
                                                    self._abortGetCopyUserSettingsDataRequest();
                                                    // on hide show getting started menu if need
                                                    if(!_.isUndefined(window.GettingStartedShortcuts))
                                                    {
                                                        GettingStartedShortcuts.showJustCheckedShortcutIfExists();
                                                    }
                                                } ,
                                                userData.userManagementData.viewerSettings.enabledFeatures.UGR,
                                                userData.userManagementData.viewerSettings.enabledFeatures.TZG,
                    showOvertime);

        lb.collectedChanges = { featureDiff: changes.featureDiff, pageUIMustBeUpdated: pageUIMustBeUpdated };

        lb.setSuccessCallback(
                function( userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword ) {
                    lb.cancelAllServerSideChecks();
                    var createUserRequest = function()
                    {
                        self.makeCreateUserRequest( lb, userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword, pageUIMustBeUpdated, changes.featureDiff );
                    };

                    if ( isOlVersion )
                    {
                        lb.disableUserInputWhileSaving();
                        self.getCurrentTime( accountSettings.timeZoneGroupId,
                                             function( currentTimeInfo )
                                             {
                                                 lb.enableUserInputWhileSaving();
                                                 var hireDate = accountSettings.hireDate.parseJSONDate();
                                                 if( hireDate.getTime() <= currentTimeInfo.currentTime.parseJSONDate().getTime() ) //hire date isn't in future
                                                     createUserRequest();
                                                 else
                                                 {
                                                     var hireDatePlaceholder = $( "#userDataLightBox_hireDatePlaceholder" );
                                                     scrollToElementInPopup(lb.innerContent, hireDatePlaceholder);
                                                     var invitationDialog = new InvitationDialog().init( $( "#userDataLightBox" ) );
                                                     var formattedHireDate = new DateFormat( SystemSettings.dateFormat ).formatDate( hireDate );
                                                     invitationDialog.setContent( messageResource.getMessage( "userlist.user_popup.confirmation.hire_date", [formattedHireDate] ) );
                                                     invitationDialog.show( hireDatePlaceholder, {offset: "0 7px" }, function ()
                                                     {
                                                         createUserRequest();
                                                         invitationDialog.hideAndRemove();
                                                     } );
                                                 }
                                             },
                                             function() {self._getCreateOrUpdateErrorHandler();} );
                    }
                    else
                    {
                        createUserRequest();
                    }
                }
        );
        lb.setCancelCallback(
                function() {
                    lb.cancelAllServerSideChecks();
                    lb.hide();

                    if (!lb.isDataLoaded)
                        return;

                    if (!self.validateIsChangedFeaturesOrRights(changes)) {
                        if( pageUIMustBeUpdated )
                            self._updateUIAccordingToViewerPermissions();
                        return;
                    }

                    self._updateGroupsOnUserCreateOrUpdate( userData.userManagementData.allUserGroups,
                                                            userData.userManagementData.allTimeZoneGroups );
                });
        lb.show();

        return lb;
    };

    UserManagementMediator.prototype.showCreateUserPopup = function( createUserData )
    {
        this._hideLoadingPopup();

        var defaultCreateUserAccountSettings = this._makeDefaultUserAccountSettings( createUserData.userManagementData,
                                                                                     createUserData.showAPStatusControl );

        var lb = this._initAndShowCreateUserPopup( createUserData, defaultCreateUserAccountSettings,
                                                   createUserData.currentTimeInDefaultTimeZone, null, null, false );

        lb.scrollToTop();
    };

    UserManagementMediator.prototype.makeCreateUserRequest = function( createLightBox, userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword, pageUIMustBeUpdated, oldFeatureDiff)
    {
        this._abortGetCopyUserSettingsDataRequest();

        createLightBox.disableUserInputWhileSaving();
        createLightBox.hideSpinner();
        var self = this;
        makeRpcCall(
                "UserManagementService.createUser",
                [ accountSettings, newUserGroupName, newTimeZoneGroup, newPassword],
                function( createUserResult ) {
                    createLightBox.enableUserInputWhileSaving();
                    if (createUserResult.resultCode == UserManagementConstants.ERROR_DUPLICATE_USERNAME)
                    {
                        alert(messageResource.getMessage("userlist.js.create_user_popup.duplicate_username"));
                    }
                    else
                    {
                        self.createSingleUserCallSucceeded(createUserResult, createLightBox, pageUIMustBeUpdated, oldFeatureDiff, userId);
                    }
                },
                self._getCreateOrUpdateErrorHandler( createLightBox )
        );
    };

    UserManagementMediator.prototype._getCreateOrUpdateErrorHandler = function( lightBox ) {

        return function (jqXHR, textStatus, errorThrown)
        {
            lightBox.enableUserInputWhileSaving();
            if ( errorThrown.exception == "com.actimind.common.services.UserEmailInvalidException" )
            {
                lightBox.handleSectionError( UserManagementConstants.USER_EMAIL_IS_INVALID );
                return true;
            }

            if ( errorThrown.exception == "com.actimind.actitime.administration.DuplicateTimeZoneGroupNameException" )
            {
                lightBox.handleDuplicateTimeZoneError(errorThrown.timeZones);
                return true;
            }

            if( textStatus == "rpc_sessionExpired" )
            {
                //hide to prevent confirmation dialog
                lightBox.hide();
            }

            return false; // pass flow to default jquery error handler
        }
    };

    UserManagementMediator.prototype._getDeleteErrorHandler = function( editLightBox ) {

        return function (jqXHR, textStatus, errorThrown)
        {
            editLightBox.setDeleteButtonEnabled(true);
            editLightBox.enableButtons();

            if( textStatus == "rpc_sessionExpired" || textStatus == "rpc_noRights" )
            {
                //hide to prevent confirmation dialog
                editLightBox.hide();
            }

            return false; // pass flow to default jquery error handler
        }
    };

    UserManagementMediator.prototype.makeDeleteUserRequest = function(editLightBox, userId, pageUIMustBeUpdated, forceChanges, featuresDiff)
    {
        editLightBox.setDeleteButtonEnabled(false);
        editLightBox.disableButtons();
        var self = this;
        makeRpcCall(
            "UserManagementService.deleteUser",
            [userId, forceChanges],
            function(deleteUserResult) {
                self.updateOrDeleteCallSucceeded( function() { self.deleteCallSucceeded(deleteUserResult, userId, editLightBox, pageUIMustBeUpdated, featuresDiff); } );
            },
            function ( jqXHR, textStatus, errorThrown ) {
                var isProcessed = self.updateOrDeleteCallFailed( errorThrown, editLightBox,
                                                                 function() {
                                                                     self.makeDeleteUserRequest(editLightBox, userId, pageUIMustBeUpdated, true);
                                                                 },
                                                                 true);
                //TODO: evdokimov complicated logic.
                return isProcessed || self._getDeleteErrorHandler( editLightBox )(jqXHR, textStatus, errorThrown);
            }
        );
    };

    UserManagementMediator.prototype.updateCurrentStateFromResult = function( licenseCounters, userGroups  )
    {
        var pageUIMustBeUpdated = false;

        if(!licenseCounters){
            pageUIMustBeUpdated = this.currentState.viewerSettings.allowedToManageAccountSettings != false;
            this.currentState.viewerSettings.allowedToManageAccountSettings = false;
        }
       if(!userGroups){
           pageUIMustBeUpdated = this.currentState.viewerSettings.enabledFeatures[UserManagementConstants.UGRFeature] != false;
           delete this.currentState.viewerSettings.enabledFeatures[UserManagementConstants.UGRFeature];
       }

        return pageUIMustBeUpdated;

    };

    UserManagementMediator.prototype.createSingleUserCallSucceeded = function(createUserResult, createLightBox, pageUIMustBeUpdated, oldFeatureDiff, userId)
    {
        this.createCallSucceeded(createUserResult, createLightBox, pageUIMustBeUpdated, oldFeatureDiff, [createUserResult.userInfo], userId);
        if (isOlVersion)
        {
            createLightBox.switchToAccountCreatedState(createUserResult.additionalResultData.map.invitationSent, this.cl(function()
            {
                this.createUser();
            }));
        }
        else
        {
            createLightBox.hide();
        }
    };

    UserManagementMediator.prototype.createSeveralUsersCallSucceeded = function(inviteUsersResult, inviteLightBox, pageUIMustBeUpdated, oldFeatureDiff)
    {
        var $body = $("body");
        var scrollTop = $body.scrollTop();
        var userId = inviteUsersResult.additionalUsersInfo ? inviteUsersResult.additionalUsersInfo[0].id : null;
        this.createCallSucceeded(inviteUsersResult, inviteLightBox, pageUIMustBeUpdated, oldFeatureDiff, inviteUsersResult.additionalUsersInfo, userId);
        $body.scrollTop(scrollTop);
        inviteLightBox.switchToUsersInvitedState();
    };

    UserManagementMediator.prototype.createCallSucceeded = function(createResult, createLightBox, pageUIMustBeUpdated, oldFeatureDiff, userInfos, userId)
    {
        // mark on client that user(s) will be created
        if(!_.isUndefined(window.GettingStartedShortcuts) && userInfos.length > 0)
        {
            GettingStartedShortcuts.markShortcutAsChecked(GettingStartedShortcut.USERS);
        }

        var changeData = this._getDiffBetweenFeaturesAndRights(createResult, oldFeatureDiff);
        this.currentState.viewerSettings = createResult.viewerSettings;
        var featureDiff = changeData.featureDiff;

        if (!this.wasOperationSuccessful(createResult))
        {
            this.handleError(createResult, createLightBox, userId);
        }
        else
        {

            pageUIMustBeUpdated |=  featureDiff.areFeaturesChanged();

            var licenseChanged = false;

            if( this._hasManageAccountSettings() ){
                licenseChanged = this._isLicenseChanged(this.currentState.license, createResult.licenseCounters);
                this.currentState.license = createResult.licenseCounters;
            }

            if (!this.validateIsChangedFeaturesOrRights(changeData))
            {
                return;
            }

            var groupName;

            this._updateGroupsOnUserCreateOrUpdate(createResult.userGroups, createResult.timeZoneGroups);
            groupName = this._isUGREnabled() ? this.userGroupMap[userInfos[0].userGroupId] : " ";
            var timeZoneGroupName = this._isTZGEnabled() ? this.timeZoneGroupMap[userInfos[0].timeZoneGroupId] : " ";
            var warningMsgs;
            var self = this;
            for (var i = userInfos.length - 1; i > -1; i--)
            {
                var userInfo = userInfos[i];
                warningMsgs = self._createWarningMsgs(userInfo, true);
                self.userTableController.addCreatedUser(userInfos[i], groupName, timeZoneGroupName, warningMsgs, self._getApproversSortingProcessor(createResult));
            }

            this.hideNoUsersCaptionAndBottomSpacer();

            if( pageUIMustBeUpdated || licenseChanged )
                        this._updateUIAccordingToViewerPermissions();

            this.currentState.noUsersShown = false;
        }
    };

    /**
     * @param userResult
     * @param dialog {UserDataLightBox|LeaveBalanceEditor}
     * @param userId
     */
    UserManagementMediator.prototype.handleError = function( userResult, dialog, userId )
    {
        var errorMessage = UserManagementMediator.errorMap[userResult.resultCode];

        if(!errorMessage && userResult.resultCode==UserManagementConstants.ERROR_BALANCE_CAP_EXCEEDED)
        {
            dialog.showCapExceededError( userResult.additionalResultData.map.cap );
            return false;
        }

        if(!errorMessage)
            throw "unknown user create/update/delete result error code:" +userResult.resultCode ;

        if(userResult.resultCode==UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_ACCOUNT_SETTINGS                                            ||
           userResult.resultCode==UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_PTO_AND_SICK                                                         ||
           userResult.resultCode==UserManagementConstants.ERROR_PTO_FEATURE_DISABLED                                                            ||
           userResult.resultCode==UserManagementConstants.ERROR_PTO_CONTROL_DISABLED ||
           userResult.resultCode==UserManagementConstants.ERROR_SICK_CONTROL_DISABLED){
            dialog.hide();
            alert(errorMessage);
            this._reloadPage();
            return true;
        }

        if( userResult.resultCode==UserManagementConstants.ERROR_DUPLICATE_USERNAME )
        {
            dialog.handleSectionError( userResult.resultCode );
            return true;
        }

        if(userResult.resultCode==UserManagementConstants.ERROR_NO_SUCH_USER){
            dialog.hide();
            alert( errorMessage );
            this._deleteUser( userId );
            return false;
        }

        alert(errorMessage);
    };

    UserManagementMediator.prototype.makeUpdateUserRequest = function( editLightBox, userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword, pageUIMustBeUpdated, featuresDiff, previousTimeZoneGroupId, forceChanges )
    {
        editLightBox.disableUserInputWhileSaving();
        var self = this;
        makeRpcCall(
                "UserManagementService.updateUser",
                [userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword, forceChanges],
                function( editUserResult ) {
                    self.updateOrDeleteCallSucceeded( function() {
                                                          editLightBox.enableUserInputWhileSaving();
                                                          self.updateCallSucceeded( editUserResult, editLightBox, pageUIMustBeUpdated, featuresDiff,
                                                                                    userId, previousTimeZoneGroupId );
                                                      } );
                },
                function ( jqXHR, textStatus, errorThrown ) {
                    var isProcessed = self.updateOrDeleteCallFailed( errorThrown, editLightBox,
                                                                     function() {
                                                                         self.makeUpdateUserRequest( editLightBox, userId, accountSettings, newUserGroupName, newTimeZoneGroup,
                                                                                                     newPassword, pageUIMustBeUpdated, featuresDiff, previousTimeZoneGroupId, true );
                                                                     },
                                                                     false);

                    return isProcessed || self._getCreateOrUpdateErrorHandler( editLightBox )(jqXHR, textStatus, errorThrown);
                }
        );
    };

    /**
     * @param updateUserResult
     * @param dialog {UserDataLightBox|LeaveBalanceEditor}
     * @param pageUIMustBeUpdated
     * @param oldFeatureDiff
     * @param userId
     * @param previousTimeZoneGroupId
     * @param customErrHandler
     * @param forceNoHighlight
     */
    UserManagementMediator.prototype.updateCallSucceeded = function( updateUserResult, dialog, pageUIMustBeUpdated, oldFeatureDiff,
                                                                     userId, previousTimeZoneGroupId, customErrHandler, forceNoHighlight )
    {
        var changeData = this._getDiffBetweenFeaturesAndRights(updateUserResult, oldFeatureDiff);
        var featureDiff = changeData.featureDiff;
        this.currentState.viewerSettings=updateUserResult.viewerSettings;

        if( updateUserResult.userInfo && (updateUserResult.userInfo.id == this.loggedInUserId) ){
                 var isLeaveSettingsTabVisible = this.currentState.viewerSettings.allowedToManageLeaveBalanceSettings && ( this._isPTOEnabled() || this._isSickEnabled() );
                 if( isLeaveSettingsTabVisible != updateUserResult.userInfo.hasManagePTOAndSickRight){
                     this.currentState.viewerSettings.allowedToManageLeaveBalanceSettings = updateUserResult.userInfo.hasManagePTOAndSickRight;
                     changeData.areAllowedToManageLeaveBalanceSettingsChanged = true;
                 }
        }

        var successfulResult = this.wasOperationSuccessful( updateUserResult );

        if( !successfulResult )
        {
            if ( dialog && !this.handleError( updateUserResult, dialog, userId ))
                return this.validateIsChangedFeaturesOrRights(changeData);
            else if ( customErrHandler )
                customErrHandler(updateUserResult);
        }
        else
        {
            pageUIMustBeUpdated |=  featureDiff.areFeaturesChanged();

            var licenseChanged = false;

            if( this._hasManageAccountSettings() ){
                licenseChanged = this._isLicenseChanged( this.currentState.license, updateUserResult.licenseCounters );
                this.currentState.license = updateUserResult.licenseCounters;
            }

            if ( dialog )
                dialog.hide();

            if (!this.validateIsChangedFeaturesOrRights(changeData)) return;

            if ( previousTimeZoneGroupId !== undefined && this.loggedInUserId == updateUserResult.userInfo.id
                    && previousTimeZoneGroupId != updateUserResult.userInfo.timeZoneGroupId )
            {
                // update user list if user has changed his time zone
                alert(messageResource.getMessage('userlist.js.time_zone_was_changed'));
                this._reloadPage();
                return;
            }


            this._updateGroupsOnUserCreateOrUpdate( updateUserResult.userGroups, updateUserResult.timeZoneGroups );
            var userInfo =  updateUserResult.userInfo;
            this.updateUser(userInfo, !forceNoHighlight, this._getApproversSortingProcessor(updateUserResult));
            if (updateUserResult.additionalUsersInfo)
            {
                var additionalUsersInfos = updateUserResult.additionalUsersInfo;
                for (var i=0; i < additionalUsersInfos.length; i++)
                    this.updateUser( additionalUsersInfos[i], false, this._getApproversSortingProcessor(updateUserResult));
            }

            if( pageUIMustBeUpdated || licenseChanged )
                this._updateUIAccordingToViewerPermissions();

        }
    };

    UserManagementMediator.prototype.updateUser = function ( userInfo, isHighlight, approversSortingProcessor )
    {
        var groupName = this._isUGREnabled() ? this.userGroupMap[userInfo.userGroupId] : " ";
        var timeZoneGroupName = this._isTZGEnabled() ? this.timeZoneGroupMap[userInfo.timeZoneGroupId] : " ";

        var warningMsgs = this._createWarningMsgs( userInfo, false );

        var editedUserIsLoggedInUser = userInfo.id == this.loggedInUserId;
        this.userTableController.updateUser( userInfo, groupName, timeZoneGroupName, warningMsgs, editedUserIsLoggedInUser, !isHighlight, approversSortingProcessor );
    };

    UserManagementMediator.prototype._reloadPage = function(  )
    {
        location.reload();
    };

    UserManagementMediator.prototype.wasOperationSuccessful = function( userResult )
    {
       return  userResult.resultCode ==  UserManagementConstants.RESULT_CODE_SUCCESS;
    };

    UserManagementMediator.prototype.updateOrDeleteCallSucceeded = function( confirmationNotNeededCallback )
    {
        if ( confirmationNotNeededCallback )
            confirmationNotNeededCallback();
    };

    UserManagementMediator.prototype.updateOrDeleteCallFailed = function( errorThrown, lightBox, resendRequestWithForceParameterCallback, hideLightBoxBeforeConfirmation )
    {
        var confirmationMessage;
        if ( errorThrown.exception == "com.actimind.common.administration.EditUserConfirmationIsNeededException" )
            confirmationMessage = new UserListConfirmation().createEditConfirmationMsg(errorThrown);
        else if ( errorThrown.exception == "com.actimind.common.administration.DeleteUserConfirmationIsNeededException" )
            confirmationMessage = new UserListConfirmation().createDeleteConfirmationMsg(errorThrown);
        else
            return false;


        if ( hideLightBoxBeforeConfirmation )
            lightBox.hide();

        if ( confirm( confirmationMessage ) )
            resendRequestWithForceParameterCallback();
        else if ( !hideLightBoxBeforeConfirmation )
            lightBox.enableUserInputWhileSaving();

        return true;
    };

    UserManagementMediator.prototype.deleteCallSucceeded = function( deleteUserResult, userId, editLightBox, pageUIMustBeUpdated, oldFeaturesDiff )
    {

        editLightBox.enableButtons();

        var changeData = this._getDiffBetweenFeaturesAndRights(deleteUserResult, oldFeaturesDiff);
        var featureDiff = changeData.featureDiff;
        this.currentState.viewerSettings= deleteUserResult.viewerSettings;


        if (deleteUserResult.userGroups != null || deleteUserResult.timeZoneGroups != null) {
            this._updateGroupsOnUserCreateOrUpdate(deleteUserResult.userGroups, deleteUserResult.timeZoneGroups);
        }
        var licenses = deleteUserResult.licenseCounters;
        if (licenses != null && (pageUIMustBeUpdated || this._isLicenseChanged(this.currentState.license, licenses))) {
            this.currentState.license = licenses;
            this._updateUIAccordingToViewerPermissions();
        }
        var result = deleteUserResult.resultCode;
        if (result == UserManagementConstants.RESULT_CODE_SUCCESS || result == UserManagementConstants.ERROR_NO_SUCH_USER) {
            editLightBox.hide();
            this._deleteUser( userId );
        } else {
            alert(UserManagementMediator.errorMap[result]);
            editLightBox.setDeleteButtonEnabled(false, UserManagementMediator.errorMap[result]);
        }
        this.validateIsChangedFeaturesOrRights(changeData);
    };

    UserManagementMediator.prototype._deleteUser = function ( userId )
    {
        this.userTableController.deleteUser( userId );
        if( this.userTableController.getRows().length == 0 )
        {
            this.pagerController.reloadEmptyPage();
        }
    };

    UserManagementMediator.prototype._deleteUsers = function ( userIdsArray )
    {
        for (var i = 0, usersLength = userIdsArray.length; i < usersLength; i++)
        try {
            this.userTableController.deleteUser( userIdsArray[i] );
        }
        catch(e) {}// user with this id is not on this page, move on

        if( this.userTableController.getRows().length == 0 )
        {
            this.pagerController.reloadEmptyPage();
        }
    };

    UserManagementMediator.prototype._createWarningMsgs = function( userInfo, isCreatingUser )
    {
        var warnings = userInfo.warnings;
        if ( !warnings )
            return {};
        
        var warningMsgs = [];
        var infoMsgs = [];

        var fullName = UserNameFormat.formatFML(
                userInfo.firstName ,
                userInfo.lastName,
                userInfo.middleInitial
        );

        for( var i = 0; i < warnings.length; i++ )
        {
            var warningCode = warnings[i];

            if(warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_LICENSE_TERMS ||
               warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_LICENSE_TERMS ||
               warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_LICENSE_TERMS){

                var key = warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_LICENSE_TERMS ?
                    "userlist.js.warning_account_disabled_due_to_license_terms_at" :
                    warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_LICENSE_TERMS ?
                        "userlist.js.warning_account_disabled_due_to_license_terms_ap" :
                        "userlist.js.warning_account_disabled_due_to_license_terms_both_products";

                var messagePart1 = messageResource.getEscapedMessage(key, [fullName]);
                var messagePart2 = messageResource.getEscapedMessage("userlist.js.warning_account_disabled_due_to_license_terms_info",[fullName]);

                warningMsgs.push(messagePart1 + "<p class='sameMsgNewParagraph'>"+messagePart2+"</p>");
            }
            else if(warningCode == UserManagementConstants.WARNING_USER_GROUP_NO_LONGER_EXISTS){
                warningMsgs.push(messageResource.getEscapedMessage("userlist.js.warning_user_group_no_longer_exists",[fullName]));

            }
            else if(warningCode == UserManagementConstants.WARNING_TIME_ZONE_GROUP_NO_LONGER_EXISTS){
                warningMsgs.push(messageResource.getEscapedMessage("userlist.js.warning_time_zone_group_no_longer_exists",[fullName]));
            }
            else if(warningCode == UserManagementConstants.WARNING_NO_RIGHT_TO_EDIT_STATUS_IN_OTHER_PRODUCT){
                warningMsgs.push(messageResource.getEscapedMessage(
                        isCreatingUser ?
                            "userlist.js.warning_no_right_to_edit_status_in_ap.creating" :
                            "userlist.js.warning_no_right_to_edit_status_in_ap.editing" ));
            }
            else if( warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_DUE_TO_FUTURE_HIRE_DATE){
                var formattedHireDate = new DateFormat(SystemSettings.dateFormat).formatDate(userInfo.hireDate.parseJSONDate());
                infoMsgs.push(messageResource.getEscapedMessage("userlist.js.warning_account_disabled_due_to_future_hire_date_at",[formattedHireDate]));
            }
            else if( warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_OTHER_PRODUCT_DUE_TO_FUTURE_HIRE_DATE){
                var formattedHireDate = new DateFormat(SystemSettings.dateFormat).formatDate(userInfo.hireDate.parseJSONDate());
                infoMsgs.push(messageResource.getEscapedMessage("userlist.js.warning_account_disabled_due_to_future_hire_date_ap",[formattedHireDate]));
            }
            else if( warningCode == UserManagementConstants.WARNING_ACCOUNT_DISABLED_IN_BOTH_PRODUCTS_DUE_TO_FUTURE_HIRE_DATE){
                var formattedHireDate = new DateFormat(SystemSettings.dateFormat).formatDate(userInfo.hireDate.parseJSONDate());
                infoMsgs.push(messageResource.getEscapedMessage("userlist.js.warning_account_disabled_due_to_future_hire_date_both_products",[formattedHireDate]));
            }
            else if (UserManagementMediator.warningMap.hasOwnProperty([warningCode]))
                warningMsgs.push(UserManagementMediator.warningMap[warningCode]);
            else
                throw "Unknown warning code has been received from the server: "+warningCode;
        }

        return { warningMsgs: warningMsgs, infoMsgs: infoMsgs };
    };


    UserManagementMediator.prototype._initFilters = function()
    {
        var self = this;
        this.taskHierarchyFilter = new TaskHierarchyFilter().init( "taskHierarchyFilter",
                                                                   function ()
                                                                   {
                                                                       self._filterChange( "taskHierarchyFilter", self.taskHierarchyFilter.getValue() );
                                                                   },
                                                                   {
                                                                       pasEnabled: this.currentState.viewerSettings.enabledFeatures[UserManagementConstants.PASFeature],
                                                                       value: this.currentState.userListSettings.filter.taskHierarchyFilter
                                                                   } );

        if( this._isTTAEnabled() && this._isAccountSettingsVisible() )
        {
            this.timeTrackApprovalFilter = new TimeTrackApprovalFilter().init( "timeTrackApprovalFilter",
                                                                               function ()
                                                                               {
                                                                                   self._filterChange( "timeTrackApprovalFilter", self.timeTrackApprovalFilter.getValue() );
                                                                               },
                                                                               {
                                                                                   value: this.currentState.userListSettings.filter.timeTrackApprovalFilter
                                                                               } );
        }

        if( this._isPTOEnabled() || this._isSickEnabled() )
        {
            this.balanceManagersFilter = new LeaveBalancesManagerFilter().init( "balanceManagerFilter",
                                                                  function ()
                                                                  {
                                                                      self._filterChange( "leaveBalancesManagerFilter", self.balanceManagersFilter.getValue() );
                                                                  },
                                                                  {
                                                                      value: this.currentState.userListSettings.filter.leaveBalancesManagerFilter,
                                                                      isPtoEnabled: this._isPTOEnabled(),
                                                                      isSickEnabled: this._isSickEnabled()
                                                                  } );
        }
    };


    UserManagementMediator.prototype.editUser = function (user)
    {
        this._abortRequestsAndRevertState();

        var userId = user.id;
        this._showLoadingPopup();
        var self = this;
        makeRpcCall( "UserManagementService.getEditUserData", [userId],
                     this.cl( function(editUserData) {
                        self.showEditUserPopup(editUserData, user);
                     } ),
                     function ( jqXHR, textStatus, errorThrown )
                     {
                         self._hideLoadingPopup();

                         if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                         {
                             alert( messageResource.getMessage( 'userlist.js.error_no_such_user.edit_user' ) );
                             self._deleteUser( userId );
                             return true;
                         }
                         if( errorThrown.exception == 'com.actimind.actitime.services.NoRightsToManageAccountSettings' )
                         {
                             alert( messageResource.getMessage( 'userlist.js.error_cant_edit_user_account' ) );
                             document.location.reload();
                             return true;
                         }
                         return false;
                     }
        );
    };
    
    UserManagementMediator.prototype.getCopyUserSettingsData = function ( createUserLightBox, userId )
    {
        this._abortGetCopyUserSettingsDataRequest();

        var self = this;
        this.getCopyUserSettingsDataRequestObject = makeRpcCall( "UserManagementService.getCopyUserSettingsData", [userId],
                                 function( copyUserSettingsData )
                                 {
                                     var createUserLightBoxState = createUserLightBox.getLightBoxState();
                                     createUserLightBox.hide();

                                     self._processCopyUserSettingsData( copyUserSettingsData, createUserLightBoxState.userInputData,
                                                                        createUserLightBoxState.errorState, createUserLightBoxState.scrollPosition,
                                                                        createUserLightBoxState.collectedChanges );
                                 },
                                 function ( jqXHR, textStatus, errorThrown )
                                 {
                                     createUserLightBox.hideSpinner();
                                     if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                                     {
                                         alert( messageResource.getMessage( 'userlist.js.error_no_such_user.edit_user' ) );
                                         usersSelector.removeUser( userId );
                                         return true;
                                     }
                                     if( errorThrown.exception == 'com.actimind.actitime.services.NoRightsToManageAccountSettings' )
                                     {
                                         alert( messageResource.getMessage( 'userlist.js.error_cant_create_user_account' ) );
                                         document.location.reload();
                                         return true;
                                     }
                                     usersSelector.enableInput();
                                     usersSelector.rollbackSelection();
                                     return false;
                                 }

        );
    };

    UserManagementMediator.prototype._abortGetCopyUserSettingsDataRequest = function ()
    {
        if ( this.getCopyUserSettingsDataRequestObject )
        {
            this.getCopyUserSettingsDataRequestObject.abort();
            this.getCopyUserSettingsDataRequestObject = null;
        }
    };

    UserManagementMediator.prototype._processCopyUserSettingsData = function ( copyUserSettingsData, userInputData, errorState, scrollPosition, collectedChanges )
    {
        copyUserSettingsData.fullUserInfo.userAccountSettings.firstName = userInputData.firstName;
        copyUserSettingsData.fullUserInfo.userAccountSettings.lastName = userInputData.lastName;
        copyUserSettingsData.fullUserInfo.userAccountSettings.middleInitial = userInputData.middleInitial;
        copyUserSettingsData.fullUserInfo.userAccountSettings.username = userInputData.username;
        copyUserSettingsData.fullUserInfo.userAccountSettings.enabled = userInputData.enabled;
        copyUserSettingsData.fullUserInfo.userAccountSettings.enabledInOtherProduct = userInputData.enabledInOtherProduct;
        copyUserSettingsData.fullUserInfo.userAccountSettings.email = userInputData.email;
        copyUserSettingsData.fullUserInfo.userAccountSettings.releaseDate = userInputData.releaseDate;
        copyUserSettingsData.fullUserInfo.userAccountSettings.hireDate = userInputData.hireDate;
        copyUserSettingsData.fullUserInfo.userAccountSettings.passwordData = userInputData.passwordData;

        var lb = this._initAndShowCreateUserPopup( copyUserSettingsData, copyUserSettingsData.fullUserInfo.userAccountSettings,
                                            copyUserSettingsData.currentTimeInUserTimeZone,
                                            copyUserSettingsData.fullUserInfo.id, collectedChanges, true );

        lb.restoreState( errorState, scrollPosition );
    };

    UserManagementMediator.prototype.showEditUserPopup = function( editUserData, user )
    {
        this._hideLoadingPopup();

        var changes = this._updateCurrentStateFromUserData(editUserData ),
            pageUIMustBeUpdated  = changes.featureDiff.areFeaturesChanged() || changes.areRightsChanged,
            editUserIsLoggedIn = editUserData.fullUserInfo.id == this.loggedInUserId,

            sectionBuilderParams = new ActitimeUserManagementSectionsBuilderParams().setUserManagementSectionsBuilderParams(
                    new CommonUserManagementSectionsBuilderParams()
                            .setPreparatoryStrategy(new EditSectionsPreparatoryStrategy().init(editUserData, editUserIsLoggedIn))
                            .setWorkdayDurationsTableBuilder(new EditWorkDayDurationsTableBuilder().init( editUserData.userManagementData, editUserData.currentTimeInUserTimeZone ))
                            .setUserManagementData(editUserData.userManagementData)
                            .setCurrentTime(editUserData.currentTimeInUserTimeZone)
                            .setUserId(editUserData.fullUserInfo.id)
                            .setAccountSettings(editUserData.fullUserInfo.userAccountSettings)
                            .setEditedUserIsLoggedIn(editUserIsLoggedIn)
                            .setFirstTTDate(editUserData.firstTTDate)
                            .setFirstRequestDate(editUserData.firstLeaveRequestDate)
                            .setRatesTableStrategy(new EditUserPopupRatesTableStrategy())
            ).setPtoHoursPerDay(this.ptoHoursPerDay ),

            sectionsBuilder = new ActitimeUserManagementSectionsBuilder().init(sectionBuilderParams),
            lb = new EditUserLightBox().init(sectionsBuilder, editUserData.userManagementData, editUserData.fullUserInfo.userAccountSettings, user, editUserData.hasTimeTrack,
                                             false, editUserData.lastOtherProductAdmin, editUserData.lastLoginTime, function(){self._handlerIfNoSuchUserAfterAjaxInEditPopup(user.id)} ),
            self = this;

        lb.setSuccessCallback(
                function( userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword ) {
                    lb.cancelAllServerSideChecks();
                    var previousTimeZoneGroupId = editUserData.fullUserInfo.userAccountSettings ? editUserData.fullUserInfo.userAccountSettings.timeZoneGroupId : undefined;
                    self.makeUpdateUserRequest( lb, userId, accountSettings, newUserGroupName, newTimeZoneGroup, newPassword, pageUIMustBeUpdated, changes.featureDiff, previousTimeZoneGroupId, false );
                }
        );
        lb.setDeleteCallback(
            function(userId) {
                lb.cancelAllServerSideChecks();
                self.makeDeleteUserRequest(lb, userId, pageUIMustBeUpdated, false, changes.featureDiff);
            }
        );
        lb.setCancelCallback(
                function() {
                    lb.cancelAllServerSideChecks();
                    lb.hide();

                    self._updateGroupsOnUserCreateOrUpdate( editUserData.userManagementData.allUserGroups, 
                                                            editUserData.userManagementData.allTimeZoneGroups );

                    if (!self.validateIsChangedFeaturesOrRights(changes))
                    {
                        if( pageUIMustBeUpdated )
                            self._updateUIAccordingToViewerPermissions();
                        lb.hide();
                    }
                });
        lb.show();
        lb.scrollToTop();
    };

    UserManagementMediator.prototype._handlerIfNoSuchUserAfterAjaxInEditPopup = function(userId){
        this._deleteUser(userId);
    };


    UserManagementMediator.prototype._showLoadingPopup = function ()
    {
        this._loadingPopup = new LoadingPopup().init( "userDataLoadingPopup" );
        this._loadingPopup.show();
    };

    UserManagementMediator.prototype._hideLoadingPopup = function ()
    {
        this._loadingPopup.hide();
    };

    UserManagementMediator.prototype.switchManagePTOAndSickRight = function( cell ) {
        this._abortRequestsAndRevertState();

        var self = this;
        var cellValue = cell.getValue();
        var userId = cellValue.id;

        this.spinner.spin(this.spinnerEl);

        makeRpcCall('UserManagementService.setManagePTOAndSickRight',
                    [userId, !cellValue.hasManagePTOAndSickRight],
                    function( result ) {
                        self.spinner.stop();
                        self.updateCallSucceeded( result, null, false, null, userId, undefined, self.defaultErrorHandler );
                    },
                    function ( jqXHR, textStatus, errorThrown ) {
                        self.spinner.stop();
                        return self.handlePTOExceptions(errorThrown, userId, self);
                    }
        );
    };

    UserManagementMediator.prototype.editBalance = function( cell, balanceType )
    {
        this._abortRequestsAndRevertState();

        var self = this;
        var cellValue = cell.getValue();
        var userId = cellValue.id;
        var userName = UserNameFormat.formatFML( cellValue.firstName, cellValue.lastName, cellValue.middleInitial );
        var currentBalance;
        if ( balanceType == BalanceType.PTO )
            currentBalance = cellValue.currentPTOBalance.balance;
        if ( balanceType == BalanceType.SICK )
            currentBalance = cellValue.currentSickDaysBalance.balance;

        var row = $( cell.getRow().getRowEl() );
        this.addRowSelection(row);

        this.leaveBalanceEditor.show( cell.getCellEl(), currentBalance, userName, this.ptoHoursPerDay, balanceType );
        this.leaveBalanceEditor.setOnCloseCallback( function () { self.clearRowSelection(row) } );
        this.leaveBalanceEditor.setOnApplyCallback( function( correctionType, valueInDays, comment ) {
            makeRpcCall( "UserManagementService.addBalanceCorrection",
                         [userId, correctionType, valueInDays, balanceType, comment],
                         function( result ) {
                             self.leaveBalanceEditor.busyModeOff();
                             self.updateCallSucceeded( result, self.leaveBalanceEditor, false, null, userId );
                         },
                         function() {
                             self.leaveBalanceEditor.busyModeOff();
                         }
            );
        })
    };

    UserManagementMediator.prototype.handlePtoHistoryError = function ( resultCode, userId )
    {
        if (resultCode == UserManagementConstants.ERROR_NO_RIGHTS_TO_MANAGE_PTO_AND_SICK )
        {
            alert(UserManagementMediator.errorMap[resultCode]);
            this._reloadPage();
        }
        else
            if (resultCode == UserManagementConstants.ERROR_NO_SUCH_USER)
            {
                alert(messageResource.getEscapedMessage("userlist.js.error_no_such_user.short"));
                this._deleteUser( userId );
            }

    };

    UserManagementMediator.prototype.showSickHistory = function(cell){
        this._balanceHistoryPanel.updateTitle(messageResource.getMessage("common.balance_history.balance_history_panel.title", [messageResource.getMessage("common.balance_history.table.sick")]));

        var config = {};
        config.balanceHistoryService ='UserManagementService.getUserSickBalanceHistory';
        config.prefix = BalanceHistory.BalanceTypes.SICK;
        config.balanceType = BalanceType.SICK;
        config.showBalanceInHours = SystemSettings.showSickInHours;
        this.showBalanceHistory(cell, config);
    };

    UserManagementMediator.prototype.showPtoHistory = function(cell){
        this._balanceHistoryPanel.updateTitle(messageResource.getMessage("common.balance_history.balance_history_panel.title", [messageResource.getMessage("common.balance_history.table.pto")]));

        var config = {};
        config.balanceHistoryService ='UserManagementService.getUserPtoBalanceHistory';
        config.prefix = BalanceHistory.BalanceTypes.PTO;
        config.balanceType = BalanceType.PTO;
        config.showBalanceInHours = SystemSettings.showPTOInHours;
        this.showBalanceHistory(cell, config);
    };

    UserManagementMediator.prototype.showBalanceHistory = function( cell, historyConfig )
    {
        this._abortRequestsAndRevertState();

        var self = this;
        var cellValue = cell.getValue();
        var userId = cellValue.id;

        var cellEl = cell.getCellEl();
        var jQcell = $(cellEl);
        var row = $( cell.getRow().getRowEl() );
        this.addRowSelection(row);
        this.showLoadingHistoryProgress(jQcell);

        makeRpcCall(
                        historyConfig.balanceHistoryService,
                        [userId],
                        function (extendedUserPtoBalanceHistoryData) {
                            jQcell.removeClass("hovered");
                            if( !self.wasOperationSuccessful( extendedUserPtoBalanceHistoryData ) )
                            {
                                self.handlePtoHistoryError( extendedUserPtoBalanceHistoryData.resultCode, userId );
                                self.clearRowSelection(row);
                                self.hideLoadingHistoryProgress(jQcell);
                            }
                            else
                            {
                                new PanelBalanceHistoryTable(self.$tableContainerEl, extendedUserPtoBalanceHistoryData.userBalanceHistoryRecords.list, self.ptoHoursPerDay, historyConfig.showBalanceInHours, historyConfig.prefix ).init();
                                self._balanceHistoryPanel.setOnCloseCallback( function () {row.removeClass("balanceHistorySelected"); self.clearRowSelection(row) } );
                                self._balanceHistoryPanel.updateLinkState( extendedUserPtoBalanceHistoryData.userBalanceHistoryRecords.list.length, userId, historyConfig.balanceType );
                                self._balanceHistoryPanel.showAt( cellEl, {my: "left top", at: "left bottom"} );
                                self.hideLoadingHistoryProgress(jQcell);
                                row.addClass("balanceHistorySelected");
                            }
                        },
                        function () { self.clearRowSelection(row); self.hideLoadingHistoryProgress(jQcell); jQcell.removeClass("hovered"); }
        );
    };

    UserManagementMediator.prototype.defaultErrorHandler = function( userResult ) {
        var errorMessage = UserManagementMediator.errorMap[userResult.resultCode];
        alert(errorMessage);
        location.reload();
    };

    UserManagementMediator.prototype.handlePTOExceptions = function( errorThrown, userId, tableManager ) {
        if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' ) {
            alert( messageResource.getMessage( 'userlist.js.error_no_such_user.edit_user' ) );
            tableManager._deleteUser( userId );
            return true;
        }
        if( errorThrown.exception == 'com.actimind.common.administration.UserPTOControlTurnedOff' ) {
            alert( messageResource.getMessage( 'userlist.js.error_pto_control_disabled' ) );
            this._reloadPage();
            return true;
        }
        if( errorThrown.exception == 'com.actimind.common.administration.UserSickBalanceControlTurnedOff' ) {
            alert( messageResource.getMessage( 'userlist.js.error_sick_control_disabled' ) );
            this._reloadPage();
            return true;
        }
        return false;
    };

    UserManagementMediator.prototype.handleTTStatusExceptions = function( errorThrown, confirmCallback ) {
        if( errorThrown.exception == 'com.actimind.common.administration.UserIsLastTimeTrackApproverException' ) {
            if( confirm( messageResource.getMessage( 'userlist.js.status_changed_confirmation.last_tt_approver' ) ) )
                confirmCallback();

            return true;
        }
        return false;
    };

    UserManagementMediator.prototype.toggleBalanceControlStatus = function( cell, balanceType, value )
    {
        this._abortRequestsAndRevertState();

        var self = this;
        var cellValue = cell.getValue();
        var userId = cellValue.id;

        this.spinner.spin(this.spinnerEl);

        makeRpcCall('UserManagementService.setBalanceControlStatus',
                    [userId, balanceType, value],
                    function( result ) {
                        self.spinner.stop();
                        self.updateCallSucceeded( result, null, false, null, userId, undefined, self.defaultErrorHandler );
                    },
                    function ( jqXHR, textStatus, errorThrown ) {
                        self.spinner.stop();
                        return self.handlePTOExceptions(errorThrown, userId, self);
                    }
        );
    };

    UserManagementMediator.prototype.toggleIsTTApprover = function( cell )
    {
        this._abortRequestsAndRevertState();

        var cellValue = cell.getValue();
        var userId = cellValue.id;

        this.toggleIsTTApproverCall(userId, !cellValue.hasManageOtherTTRight, false);

    };

    UserManagementMediator.prototype.toggleIsTTApproverCall = function( userId, newValue, forceChange )
    {
        var self = this;

        this.spinner.spin(this.spinnerEl);
        makeRpcCall('UserManagementService.setTTApproverStatus',
                    [userId, newValue, forceChange],
                    function( result ) {
                        self.spinner.stop();

                        if ( !forceChange )
                            self.updateCallSucceeded( result, null, false, null, userId, undefined, self.defaultErrorHandler );
                        else
                            location.reload();
                    },
                    function ( jqXHR, textStatus, errorThrown ) {
                        self.spinner.stop();
                        if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                        {
                            alert(messageResource.getMessage('userlist.js.error_no_such_user'));
                            self._deleteUser(userId);
                            return true;
                        }
                        return self.handleTTStatusExceptions(errorThrown, function() {
                            self.toggleIsTTApproverCall(userId, newValue, true);
                        });
                    }
        );
    };

    UserManagementMediator.prototype.modifyBalanceAccrualRules = function( cell, balanceType, dialogValues, onCompleteCallback )
    {
        this._abortRequestsAndRevertState();

        var self = this;
        var cellValue = cell.getValue();
        var userId = cellValue.id;

        makeRpcCall('UserManagementService.setBalanceRules',
                    [userId, balanceType, dialogValues.useDefaults, dialogValues.accrualRule, dialogValues.resetRule, dialogValues.capRule],
                    function( result ) {
                        onCompleteCallback();
                        self.updateCallSucceeded( result, null, false, null, userId, undefined, self.defaultErrorHandler );
                    },
                    function ( jqXHR, textStatus, errorThrown ) {
                        onCompleteCallback();
                        return self.handlePTOExceptions(errorThrown, userId, self);
                    }
        );

    };

    UserManagementMediator.prototype.showAssignTTApproversDialog = function( conf )
    {
        var self = this;
        var row = $( conf.cellObj.getRow().getRowEl() );

        conf.cellObj.setEditorSelected();
        this.assignApproversDialog.setOnCloseCallback(function() {
            conf.cellObj.unsetEditorSelected();
            self.clearRowSelection(row);
        });

        this.addRowSelection(row);

        this.assignApproversDialog.showAt( {
                                            userId: conf.userId,
                                            element: conf.cellEl,
                                            offset: conf.offset,
                                            cellObj: conf.cellObj
                                      } );
    };

    UserManagementMediator.prototype.showAssignUsersForTTApproverDialog = function( conf )
    {
        var self = this;
        var row = $( conf.cellObj.getRow().getRowEl() );

        conf.cellObj.setEditorSelected();
        this.assignUsersToApproverDialog.setOnCloseCallback(function() {
            conf.cellObj.unsetEditorSelected();
            self.clearRowSelection(row);
        });

        this.addRowSelection(row);

        this.assignUsersToApproverDialog.showAt( {
                                                     userId: conf.userId,
                                                     element: conf.cellEl,
                                                     offset: conf.offset,
                                                     cellObj: conf.cellObj,
                                                     minimizedMode: conf.cellObj.value.canManageAllUsers
                                                 } );
    };

    UserManagementMediator.prototype.getShowTooltip = function( tooltip )
    {
        return function( config, event ) {
            tooltip.updateUIAndShow( config, calculateTooltipOffset( tooltip, event, UserManagementMediator.BOTTOM_BAR_HEIGHT ) );
        };
    };

    UserManagementMediator.prototype.getMoveTooltip = function( tooltip )
    {
        return function( event ) {
            tooltip.move( calculateTooltipOffset( tooltip, event, UserManagementMediator.BOTTOM_BAR_HEIGHT ) );
        };
    };

    UserManagementMediator.prototype.getHideTooltip = function( tooltip )
    {
        return function() {
            tooltip.hide();
        }
    };

    UserManagementMediator.prototype.manageTaskHierarchy = function( cell )
    {
        this._abortRequestsAndRevertState();

        var self = this;
        var cellValue = cell.getValue();
        var userId = cellValue.id;
        var permissionValue = cell.taskHierarchySelector.getValue();

        this.spinner.spin(this.spinnerEl);

        makeRpcCall('UserManagementService.setTaskHierarchyPermission',
                    [ userId, permissionValue ],
                    function( result ) {
                        self.spinner.stop();
                        self.updateCallSucceeded( result, null, false, null, userId );
                    },
                    function ( jqXHR, textStatus, errorThrown ) {
                        self.spinner.stop();
                        if( errorThrown.exception == 'com.actimind.actitime.administration.NoSuchUserException' )
                        {
                            alert(messageResource.getMessage('userlist.js.error_no_such_user'));
                            self._deleteUser(userId);
                            return true;
                        }
                    }
        );

    };

    UserManagementMediator.prototype.editProjectAssignments = function( conf )
    {
        var self = this;
        var row = $( conf.cellObj.getRow().getRowEl() );

        conf.cellObj.setEditorSelected();
        this.projectAssignmentDialog.setOnCloseCallback(function() {
            conf.cellObj.unsetEditorSelected();
            self.clearRowSelection(row);
        });
        this.addRowSelection(row);

        this.projectAssignmentDialog.showAt( {
                                                     userId: conf.userId,
                                                     element: conf.cellEl,
                                                     offset: conf.offset,
                                                     cellObj: conf.cellObj,
                                                     minimizedMode: conf.cellObj.value.allProjectsAssigned
                                                 } );
    };

    UserManagementMediator.prototype.addRowSelection = function ( row ) {
        this.userTableController.addRowSelection(row);
    };

    UserManagementMediator.prototype.clearRowSelection = function ( row ) {
        this.userTableController.clearRowSelection(row);
    };

    UserManagementMediator.prototype.showLoadingHistoryProgress = function ( cell ) {
        this.userTableController.showLoadingHistoryProgress(cell, this.spinner);
    };

    UserManagementMediator.prototype.hideLoadingHistoryProgress = function ( cell ) {
        this.userTableController.hideLoadingHistoryProgress(cell, this.spinner);
    };

    UserManagementMediator.prototype._getApproversSortingProcessor = function(userManagementResult) {
        return this._isTTAEnabled() ?
                    createApproversSortingProcessor( userManagementResult.allApprovers ) :
                    function () {};
    };
    UserManagementMediator.prototype._initTabs = function(){
        var self = this;
        var items = [];
        if (self._isAccountSettingsVisible())
            items.push({id:'tabAccountSettings',text: "userlist.tabs.account_settings", value:UserManagementConstants.ACCOUNT_SETTINGS_TAB_NUM});

        if (self._isPTOSettingsVisible())
            items.push({id:'tabPTOSettings',text: "userlist.tabs.users_pto", value:UserManagementConstants.PTO_SETTINGS_TAB_NUM});

        if (self._isSickDaysSettingsVisible())
            items.push({id:'tabSickDaysSettings',text: "userlist.tabs.users_sick_days", value:UserManagementConstants.SICK_DAYS_SETTINGS_TAB_NUM});

        var activeTabValue = this._loadActiveTabNum();
        if(items.length > 1)
        {
            this.tabs = new UserlistTabs().init(
                    {
                        id: "userListTabs",
                        items: items,
                        activeTabValue: activeTabValue,
                        changeCallback: function ()
                        {
                            self._toggleTableClassForTabs( self.tabs.getActiveTab() );
                            $.cookie( "actiTime-userlist-tabs", self.tabs.getActiveTab(), {expires: 4000} );
                        }
                    }
            );
        }
        self._toggleTableClassForTabs(activeTabValue);
    };

    UserManagementMediator.prototype._toggleTableClassForTabs =function(activeTabValue){
            var isShowPTO = activeTabValue == UserManagementConstants.PTO_SETTINGS_TAB_NUM;
            var isShowSickDays = activeTabValue == UserManagementConstants.SICK_DAYS_SETTINGS_TAB_NUM;
            var isShowAccountSettings = activeTabValue == UserManagementConstants.ACCOUNT_SETTINGS_TAB_NUM;
            this.$userListTableContainer.toggleClass( "showPTOSettings", isShowPTO);
            this.$userListTableContainer.toggleClass( "showSickDaysSettings", isShowSickDays);
            this.$userListTableContainer.toggleClass( "showAccSettings", (isShowAccountSettings));
    };

    UserManagementMediator.prototype._loadActiveTabNum = function ()
    {
        var tabNum = $.cookie("actiTime-userlist-tabs");
        if (!tabNum )
            tabNum = UserManagementConstants.ACCOUNT_SETTINGS_TAB_NUM ;
        if(!this._isPTOSettingsVisible() && tabNum == UserManagementConstants.PTO_SETTINGS_TAB_NUM){
            tabNum = UserManagementConstants.ACCOUNT_SETTINGS_TAB_NUM ;
        }
        if(!this._isSickDaysSettingsVisible() && tabNum == UserManagementConstants.SICK_DAYS_SETTINGS_TAB_NUM){
            tabNum = UserManagementConstants.ACCOUNT_SETTINGS_TAB_NUM ;
        }
        if (!this._isAccountSettingsVisible()){
            if (this._isPTOSettingsVisible())
                tabNum = UserManagementConstants.PTO_SETTINGS_TAB_NUM;
            else
                tabNum = UserManagementConstants.SICK_DAYS_SETTINGS_TAB_NUM;
        }
        return tabNum;
    };

    UserManagementMediator.prototype.validateIsChangedFeaturesOrRights = function(changeData){
        return this.validateCanViewUserList(changeData) &&
               this.validateIsChangedFeatures(changeData.featureDiff) &&
               this.validateIsChangedRights(changeData);
    };

    UserManagementMediator.prototype.validateCanViewUserList = function( diffBetweenData ){
        if (!this._isPTOSettingsVisible() && !this._isSickDaysSettingsVisible() && !this._isAccountSettingsVisible()){
            alert(messageResource.getMessage("userlist.js.error_no_right_to_view_userlist"));
            this._reloadPage();
            return false;
        }

        return true;
    };

    UserManagementMediator.prototype.validateIsChangedRights = function( diffBetweenData ){
        if (diffBetweenData.areAllowedToManageLeaveBalanceSettingsChanged)
        {
            this._onShowPTOSettingsChanged();
            return false;
        }
        if (diffBetweenData.showAccountSettingsChanged)
        {
            this._onShowAccountSettingsChanged();
            return false;
        }
        if (diffBetweenData.areAllowedToManageAccountSettingsChanged)
        {
            this._onManageAccountSettingsChanged();
            return false;
        }
        return true;
    };

    UserManagementMediator.prototype.validateIsChangedFeatures =function(featureDiff){
        if(featureDiff.wasFeatureChanged( UserManagementConstants.UGRFeature )){
            this._onUGRChanged();
            return false;
        }
        if(featureDiff.wasFeatureChanged(UserManagementConstants.TZGFeature)){
            this._onTZGChanged();
            return false;
        }
        if( featureDiff.wasFeatureChanged( UserManagementConstants.PASFeature ) ) {
            this._onPASChanged();
            return false;
        }
        if( featureDiff.wasFeatureChanged( UserManagementConstants.TTAFeature ) ) {
            this._onTTAChanged();
            return false;
        }
        if( featureDiff.wasFeatureChanged( UserManagementConstants.PTOFeature ) ) {
            this._onPTOChanged();
            return false;
        }
        if( featureDiff.wasFeatureChanged( UserManagementConstants.SDBFeature ) ) {
            this._onSickChanged();
            return false;
        }
        return true;
    };

    UserManagementMediator.prototype.getCurrentTime = function(timeZoneGroupId, successCallback, errorCallback)
    {
        makeRpcCall("CurrentTimeInfoService.getCurrentTimeInfo", [timeZoneGroupId], successCallback, errorCallback);
    };