/**
 * Created by filatov on 03.02.2016.
 */

/**
 * Created by filatov on 29.01.2016.
 */
function UserNameDrawer(){}

UserNameDrawer.USERNAME_EMPTY = "usernameEmpty";
UserNameDrawer.USERNAME_DUPLICATE = "duplicateUsername";

UserNameDrawer.prototype = new BaseFieldsDrawer();


UserNameDrawer.prototype.initFields = function(accountSettings){
    this.usernameCheckRpcCall = null;
    this.usernameCheckTimeId = null;
    var self = this;
    this.usernameField = $(this.getElementByIdFunction("usernameField"));
    this.setValue(this.usernameField,"");
    this.usernameField.off();
    this.usernameField.placeholder();
    if(accountSettings.username)
        this.setValue( this.usernameField, accountSettings.username );
    var onUsernameFieldKeyUp = function()
    {
        this.keyPressed = false;
        //noinspection JSPotentiallyInvalidUsageOfThis
        if( (!this.prevValue && !!this.value) || this.prevValue != this.value )
        {
            this.prevValue = this.value;
            self.errors[UserNameDrawer.USERNAME_EMPTY] = self.usernameField.pVal().length == 0;

            if (!self.errors[UserNameDrawer.USERNAME_EMPTY])
                self._checkUsernameDuplicates(this.value, accountSettings.id);
            else
            {
                self._cancelUsernameDuplicateCheck();
                self.errors[UserNameDrawer.USERNAME_DUPLICATE] = false;
            }
            self.changeDetectedFunction( true );
            self.updateUICallback(self.errors);
        }
    };

    // see Bug 47490
    var onUsernameFieldBlur = function() {
        self.usernameField.pVal( trim(this.value) );
        if (this.keyPressed || this.prevValue != this.value)
        {
            onUsernameFieldKeyUp.call(this);
        }
    };

    this.usernameField.blur( onUsernameFieldBlur );
    this.usernameField.keyup( onUsernameFieldKeyUp );
    this.usernameField.on("input", onUsernameFieldKeyUp);

    $(this.getElementByIdFunction("usernameColumn" )).show();
};

UserNameDrawer.prototype.getObjectValues = function()
{
    return {username: this.usernameField.pVal()};
};


UserNameDrawer.prototype._cancelUsernameDuplicateCheck = function()
{
    clearTimeout( this.usernameCheckTimeId );
    if( this.usernameCheckRpcCall )
        this.usernameCheckRpcCall.abort();
    this.usernameCheckRpcCall = null;
};

UserNameDrawer.prototype.cancelAllServerSideChecks = function()
{
    this._cancelUsernameDuplicateCheck();
};

UserNameDrawer.prototype._checkUsernameDuplicates = function(username, id)
{
    this._cancelUsernameDuplicateCheck();
    if( !username || !isNotEmpty( username ) )
    {
        this._checkUsernameDuplicatesCallback( false );
    }
    else
    {
        var self = this;
        this.usernameCheckTimeId = setTimeout(function() { self._doCheckUsernameDuplicatesRPCCall(trim(username), id) }, 200);
    }
};

UserNameDrawer.prototype._doCheckUsernameDuplicatesRPCCall = function(username, id)
{
    var self = this;
    this.usernameCheckRpcCall = makeRpcCall(
            "UserManagementService.checkUsernameExists",
            [username, id],
            function(result) {self._checkUsernameDuplicatesCallback( result ) },
            this.checkUsernameErrorHandler
    );
};

UserNameDrawer.prototype._checkUsernameDuplicatesCallback = function( result )
{
    if (result)
    {
        this.errors[UserNameDrawer.USERNAME_EMPTY] = false;
    }
    this.errors[ UserNameDrawer.USERNAME_DUPLICATE ] = result;
    this.validationDetectedCallback();
    this.updateUICallback(this.errors);
};

UserNameDrawer.prototype.validateFields = function(oldErrors){
    if(this.usernameField.pVal().length == 0)
    {
        this.errors[UserNameDrawer.USERNAME_EMPTY] = true;
        this.errors[UserNameDrawer.USERNAME_DUPLICATE] = false;
    }
    else
        this.errors[ UserNameDrawer.USERNAME_DUPLICATE ] = oldErrors[UserNameDrawer.USERNAME_DUPLICATE];
    return this.errors;
};

UserNameDrawer.prototype.setDuplicateNameError = function()
{
    this.errors[UserNameDrawer.USERNAME_EMPTY] = false;
    this.errors[UserNameDrawer.USERNAME_DUPLICATE] = true;
    return this.errors;
};
