function UserRatesSection() {}

UserRatesSection.getSectionIdSuffix = function()
{
    return "userRatesSection";
};

UserRatesSection.getSectionEl = function( lightBoxEl )
{
    return document.getElementById( lightBoxEl.id + "_" + UserRatesSection.getSectionIdSuffix() );
};

UserRatesSection.hideSectionBlock = function( lightBoxEl )
{
    return UserRatesSection.getSectionEl( lightBoxEl ).style.display = "none";
};

UserRatesSection.prototype = new BaseUserDataSection();

UserRatesSection.prototype.init = function( lightBoxEl, accountSettings, userManagementData, changesCallback, validateCallback, corporateSchedule, currentTimeInUserTimeZone, ratesTableStrategy, showOvertime )
{
    BaseUserDataSection.prototype.init.call( this, lightBoxEl, changesCallback, validateCallback );

    this.sectionEl = UserRatesSection.getSectionEl( lightBoxEl );
    this.sectionEl.style.display = "block";

    this.corporateSchedule = corporateSchedule;
    this.userRatesEditorPlaceholder = this.getElementBySubId("userRatesEditorPlaceholder");
    this.userRatesEditorPlaceholder.innerHTML = "";
    this.ratesTable = new RatesTable().init( accountSettings.rates, userManagementData, changesCallback, this.sectionEl.parentNode, validateCallback, this.corporateSchedule, currentTimeInUserTimeZone, ratesTableStrategy, showOvertime );
    this.ratesTable.buildDOM( this.userRatesEditorPlaceholder );
    this.overtimeLevel = accountSettings.overtimeLevel;
    this.ratesTable.setOvertimeLevel( this.overtimeLevel );
    this.overtimeFeatureEnabled = userManagementData.viewerSettings.enabledFeatures[ UserManagementConstants.OVRFeature ];
    this.showOvertime = showOvertime;
    this.updateSectionClasses(showOvertime);
    return this;
};

UserRatesSection.prototype.setOvertimeLevel = function( overtimeLevel )
{
    if( this.overtimeLevel != overtimeLevel )
    {
        this.ratesTable.setOvertimeLevel( overtimeLevel );
        this.overtimeLevel = overtimeLevel;
        this.updateUI();
        this.validationDetected();
    }
};

UserRatesSection.prototype.updateSectionClasses = function(showOvertime)
{
    this.sectionEl.className = !this.overtimeFeatureEnabled || !showOvertime|| this.overtimeLevel == UserManagementConstants.OVERTIME_OFF ? "overtimeOff" : null;
};

UserRatesSection.prototype.hideOvertimeSection = function()
{
    $(this.sectionEl).addClass("overtimeOff");
};

UserRatesSection.prototype.showOvertimeSection = function()
{
    $(this.sectionEl).addClass("overtimeOff");
};

UserRatesSection.prototype.updateUI = function()
{
    this.updateSectionClasses(this.showOvertime);
    this.ratesTable.updateUI();
};

UserRatesSection.prototype.validate = function()
{
    return this.ratesTable.validate();
};

UserRatesSection.prototype.getRates = function()
{
    return this.ratesTable.getRates();
};

UserRatesSection.prototype.hasErrors = function()
{
    return this.ratesTable.hasErrors();
};

UserRatesSection.prototype.getSectionElement = function(  )
{
    return this.sectionEl;
};

UserRatesSection.prototype.updateAfterShowing = function()
{
    this.ratesTable.updateAfterShowing();
};
