function WorkScheduleAndOvertimeSection()
{
}

WorkScheduleAndOvertimeSection.prototype = new WorkScheduleSection();

WorkScheduleAndOvertimeSection.prototype.init = function( workdayDurationsTableBuilder, lightBoxEl, userManagementData, accountSettings, changesCallback, validateCallback, showOvertime )
{
    WorkScheduleSection.prototype.init.call( this,
                                             workdayDurationsTableBuilder,
                                             lightBoxEl,
                                             userManagementData,
                                             accountSettings,
                                             changesCallback,
                                             validateCallback );

    var overtimeSelectorPlaceholderEl = this.getElementBySubId( "overtimeSelectorPlaceholder" );
    this.preloadOvertimeLevel = accountSettings.overtimeLevel;


    var enabledFeatures = userManagementData.viewerSettings.enabledFeatures;

    var headerKey;
    if ( showOvertime && enabledFeatures.hasOwnProperty( UserManagementConstants.OVRFeature ) ) {
        overtimeSelectorPlaceholderEl.innerHTML = "";
        this._overtimeSelector = this.createOvertimeSelector( this.preloadOvertimeLevel, overtimeSelectorPlaceholderEl );

        headerKey = "userlist.userdata.schedule.work_schedule_and_overtime";
    } else
        headerKey = "userlist.userdata.schedule.work_schedule";

    this.getElementBySubId( "sectionHeaderPlaceholder" ).innerHTML = messageResource.getMessage(headerKey);

    this._hideElementsAccordingToFeatures( enabledFeatures );

    return this;
};

WorkScheduleSection.prototype._getSectionEl = function()
{
    return this.getElementBySubId( "workScheduleAndOvertimeSection" );
};

WorkScheduleAndOvertimeSection.prototype.createOvertimeSelector = function( userOvertimeValue, renderTo)
{
    var defaultLevel = SystemSettings.defaultOvertimeLevel;
    var defaultLevelExpl = " " + messageResource.getMessage("userlist.js.overtime_selector.default");
    var listItems = [
        {
            text: messageResource.getMessage("userlist.js.overtime_off") + (defaultLevel == UserManagementConstants.OVERTIME_OFF ? defaultLevelExpl: ""),
            value: UserManagementConstants.OVERTIME_OFF
        },
        {
            text: messageResource.getMessage("userlist.js.overtime_auto_hidden") + (defaultLevel == UserManagementConstants.OVERTIME_AUTO_HIDDEN ? defaultLevelExpl: ""),
            value: UserManagementConstants.OVERTIME_AUTO_HIDDEN
        },
        {
            text: messageResource.getMessage("userlist.js.overtime_auto") + (defaultLevel == UserManagementConstants.OVERTIME_AUTO ? defaultLevelExpl: ""),
            value: UserManagementConstants.OVERTIME_AUTO
        },
        {
            text: messageResource.getMessage("userlist.js.overtime_manual") + (defaultLevel == UserManagementConstants.OVERTIME_MANUAL ? defaultLevelExpl: ""),
            value: UserManagementConstants.OVERTIME_MANUAL
        }
    ];

    var selector = new ListSelector({
                                        menuCls: "overtimeSelectorMenu",
                                        renderTo: renderTo,
                                        value: userOvertimeValue,
                                        listItems: listItems,
                                        scrollableContainer: this._getSectionEl().parentNode
                                    });

    var self = this;
    selector.on("change", function( context, item ) {
        self.changesDetected();
    });

    return selector;
};

WorkScheduleAndOvertimeSection.prototype.getOvertimeTrackingLevel = function()
{
    return this._overtimeSelector ? this._overtimeSelector.getSelectedItem().value : this.preloadOvertimeLevel;
};

WorkScheduleAndOvertimeSection.prototype.setOvertimeTrackingLevelCallback = function( callback )
{
    if (this._overtimeSelector)
        this._overtimeSelector.on("change", function( context, item ) { callback( item.value ); });
};

WorkScheduleAndOvertimeSection.prototype._hideElementsAccordingToFeatures = function( newFeaturesMap )
{
    var scheduleOvertimeTable = this.getElementBySubId( "scheduleOvertimeTable" );

    if ( newFeaturesMap.hasOwnProperty( UserManagementConstants.OVRFeature ) )
        scheduleOvertimeTable.style.display="block";
    else
        scheduleOvertimeTable.style.display="none";

};
