function WorkScheduleSection()
{
}

WorkScheduleSection.prototype = new BaseUserDataSection();

WorkScheduleSection.prototype.init = function( workdayDurationsTableBuilder, lightBoxEl, userManagementData, accountSettings, changesCallback, validateCallback, showOvertime )
{
    BaseUserDataSection.prototype.init.call( this, lightBoxEl, changesCallback, validateCallback );

    this._sectionEl = this._getSectionEl();
    var tablePlaceholderEl = this.getElementBySubId( "scheduleDurationsTablePlaceholder" );

    this._workdayDurationsTable =  workdayDurationsTableBuilder.createTable(  this._sectionEl, tablePlaceholderEl, accountSettings, changesCallback, validateCallback );

    return this;
};

WorkScheduleSection.prototype._getSectionEl = function()
{
    return this.getElementBySubId( "workScheduleSection" );
};

WorkScheduleSection.prototype.hasErrors = function()
{
    return this._workdayDurationsTable.hasErrors();
};

WorkScheduleSection.prototype.validate = function()
{
    return this._workdayDurationsTable.validate();
};

WorkScheduleSection.prototype.getInitialSchedule = function()
{
    return this._workdayDurationsTable.getInitialSchedule();
};

WorkScheduleSection.prototype.isDefaultInitialSchedule = function()
{
    return this._workdayDurationsTable.isDefaultInitialSchedule();
};

WorkScheduleSection.prototype.getSchedules = function()
{
    return this._workdayDurationsTable.getSchedules();
};

WorkScheduleSection.prototype.updateUI = function()
{
    this._workdayDurationsTable.updateUI();
};

WorkScheduleSection.prototype.getSectionElement = function(  )
{
    return this._sectionEl;
};
