function PermissionsTemplatesPopupFrame(){}

PermissionsTemplatesPopupFrame.prototype.init = function($lightBoxEl, $scrollableLightboxContent, $permissionSectionEl, keyDownCallback, preventDefault, closeButtonCallback)
{
    this.$lightBoxEl = $lightBoxEl;
    this.$scrollableLightboxContent = $scrollableLightboxContent;
    this.$permissionSectionEl = $permissionSectionEl;
    this.keyDownCallback = keyDownCallback;
    this.preventDefault = preventDefault;
    this.closeButtonCallback = closeButtonCallback;
    this.$closeButton = $(".permissionsTemplatesPopupCloseButton");
    this.isIE8 = isIE8();
    this.$overlay = this._createOverlayIfNeededAndGet($lightBoxEl);

    return this;
};

PermissionsTemplatesPopupFrame.prototype.show = function()
{
    var self = this;
    KeyDownHandler.setOnKeyDownHandler(this.keyDownCallback);
    this.$overlay.css("display", "");

    this.$lightBoxEl.off();
    this.$lightBoxEl.on("wheel", function(event) {self.preventDefault(event)}); // modern standard
    this.$lightBoxEl.on("mousewheel", function(event) {self.preventDefault(event)}); // older browsers, IE
    this.$lightBoxEl.on("touchmove", function(event) {self.preventDefault(event)}); // mobile
    this.$lightBoxEl.on("mousedown", function(event) {return self._preventMouseMiddleButtonPress(event)});

    this.$closeButton.off();
    this.$closeButton.click(this.closeButtonCallback);

    this.$permissionSectionEl.addClass("permissionTemplatePopupShown");

    if (this.isIE8)
    {
        this.$scrollableLightboxContent.css("overflow-y", "hidden");
    }
};

PermissionsTemplatesPopupFrame.prototype.hide = function()
{
    KeyDownHandler.restoreOnKeyDownHandler();
    this.$overlay.css("display", "none");
    this.$lightBoxEl.off();
    this.$permissionSectionEl.removeClass("permissionTemplatePopupShown");

    if (this.isIE8)
    {
        this.$scrollableLightboxContent.css("overflow-y", "");
    }
};

PermissionsTemplatesPopupFrame.prototype._createOverlayIfNeededAndGet = function($element)
{
    var $overlay = $element.find(".permissionsTemplatesSectionOverlay");
    if ($overlay.length == 0)
    {
        $overlay = $("<div>").addClass("permissionsTemplatesSectionOverlay");
        $overlay.css({"display": "none", "position": "absolute", "top": 0, "height" : "100%"});
        $overlay.width($element.width());
        $element.append($overlay);
    }
    return $overlay;
};

PermissionsTemplatesPopupFrame.prototype._preventMouseMiddleButtonPress = function(event)
{
    if (whichButtonPressed(event) == "middle")
    {
        this.preventDefault(event);
        return false;
    }
    return true;
};