function LeaveRatesCellValidator()
{}

LeaveRatesCellValidator.prototype = new TabularDataTableCellValidator();

LeaveRatesCellValidator.prototype.init = function()
{
    TabularDataTableCellValidator.prototype.init.call( this );
    return this;
};

LeaveRatesCellValidator.prototype.isEmpty = function( cell )
{
    var leaveRates = cell.getValue();
    if( !leaveRates )
        return true;
    for( var i = 0; i < leaveRates.length; i++ )
    {
        var leaveRateObj = leaveRates[i];
        if( this.isRateSpecified( leaveRateObj ) )
            return false;
    }
    return true;
};

LeaveRatesCellValidator.prototype.isValid = function( cell )
{
    var leaveRates = cell.getValue();
    if( !leaveRates )
        return false;
    var floatNumberValidator = cell.getTable().getFloatNumberValidator();
    for( var i = 0; i < leaveRates.length; i++ )
    {
        var leaveRateObj = leaveRates[i];
        if (!this.isRateSpecified(leaveRateObj) ||
            !floatNumberValidator.isValidNumber(leaveRateObj.rate) || floatNumberValidator.parseFloat(leaveRateObj.rate) >= MAX_RATE)
        {
            return false;
        }
    }
    return true;
};

LeaveRatesCellValidator.prototype.isRateSpecified = function( leaveRateObj )
{
    return leaveRateObj.rate !== undefined && leaveRateObj.rate != null && String(leaveRateObj.rate).length > 0;
};
