function LeaveRatesMenu(config)
{
    LeaveRatesMenu.superclass.constructor.call(this, config);
    this.plain = true;
    this.item = new LeaveRatesEditorItem(config);
    this.add(this.item);
    this.canceled = false;
    var self = this;
    this.item.component.on( "cancelclick", function() { self.canceled = true; self.hide(); } );
    this.item.component.on( "okclick", function() { self.canceled = false; self.hide(); } );
}

Ext.extend(LeaveRatesMenu, Ext.menu.Menu, {

    cls:'userDataLightBox_leaveRatesMenu',

    setActivatedButton: function( activatedButton )
    {
        this.activatedButton = activatedButton;
    },

    getActivatedButton: function()
    {
        return this.activatedButton;
    },

    setUp: function( leaveRatesArray, defaultValue )
    {
        this.item.component.setUp(  leaveRatesArray, defaultValue );
    },

    getLeaveRates: function()
    {
        return this.item.component.getLeaveRates();
    },

    show : function(el, pos, parentMenu)
    {
        this.parentMenu = parentMenu;
        if(!this.el){
            this.render();
        }
        this.fireEvent("beforeshow", this);
        this.fireEvent("show", this);
        this.el.setXY([-1000,-1000]);
        this.el.show();
        this.hidden = false;
        this.focus();

        // delay position correction since the menu width is changed before show.
        var self = this;
        setTimeout( function() {
            self.el.setXY( self.el.getAlignToXY( el, pos || self.defaultAlign, self.offsetXY ) );
        }, 5 );

        this.canceled = false;
    },

    wasCanceled: function()
    {
        return this.canceled;
    }

});