function BaseFilter(){}

BaseFilter.prototype.init = function(renderTo, changesCallback, params)
{
    var self = this;
    this.containerElement = this.getElementById(renderTo);
    this.containerElement.addClass("filter");
    this.filter =   new ListSelector( {
                                          menuCls: "filterMenu",
                                          renderTo: renderTo,
                                          value: params.value
                                      } );
    this.addItems(params);
    this.filter.on( "change", function ()
    {
        self.changesCallback(self.filter.getSelectedItem().value);
        changesCallback();
    } );
    self.changesCallback(self.filter.getSelectedItem().value);

    return this;
};

BaseFilter.prototype.addItems = function(params){
    //abstract;
};

BaseFilter.prototype.changesCallback = function(value) {
    this.containerElement.toggleClass( "active",this.isActiveFilter(value));
};

BaseFilter.prototype.isActiveFilter = function(){
    return true;
};

BaseFilter.prototype.getValue = function(){
    return this.filter.getSelectedItem().value;
};

BaseFilter.prototype.getElementById = function(elementId){
    return $("#"+ elementId);
};

BaseFilter.prototype.setActiveItemByValue = function(value, suppressChangeEvent) {
    this.filter.setActiveItemByValue(value, suppressChangeEvent);
    if(suppressChangeEvent){
       this.changesCallback(value);
    }
};
