function AssignTTApproversCellRenderer ()
{
    this.constructor = AssignTTApproversCellRenderer;
}
AssignTTApproversCellRenderer.prototype = _.create(EditableCellRenderer.prototype);

AssignTTApproversCellRenderer.cellStates = {
    NO_APPROVERS_STATE : {
        getCellClass: function () { return "noApprovers" },
        getCellTextValue: function ( cell )
        {
            return "<span class='numberOfApprovers noApprovers'>" + messageResource.getMessage( "user_list.not_selected" ) + "</span>";
            //return "<table><tr><td>" + messageResource.getMessage( "user_list.not_selected" ) +
            //                          "</td><td class='warning-round'>&nbsp;</td></tr></table>";
        }
    },
    SOME_APPROVERS_STATE : {
        getCellClass: function () { return "someApprovers" },
        getCellTextValue: function ( cell )
        {
            return "<span class='userNameText'>" + formatAssignApproversCellText( cell.getUserApprovers() ) + "</span>";
        }
    },
    AUTO_APPROVED_STATE : {
        getCellClass: function () { return "autoApprove" },
        getCellTextValue: function ( cell )
        {
            return messageResource.getMessage( "user_list.automatically_approved" );
        }
    },
    ANY_TT_MANAGER_STATE : {
        getCellClass: function () { return "anyTTManager" },
        getCellTextValue: function ( cell )
        {
            return messageResource.getMessage( "user_list.any_time_track_manager" );
        }
    }
};

AssignTTApproversCellRenderer.prototype.calculateCellState = function ( cell ) {
    var userInfo = cell.getValue();

    if( !userInfo.requiresTTApproval )
        return AssignTTApproversCellRenderer.cellStates.AUTO_APPROVED_STATE;

    var userApprovers = cell.getUserApprovers();
    if( !userApprovers || userApprovers == null || userApprovers.length == 0 )
        return AssignTTApproversCellRenderer.cellStates.NO_APPROVERS_STATE;

    return AssignTTApproversCellRenderer.cellStates.SOME_APPROVERS_STATE;
};

AssignTTApproversCellRenderer.prototype.init = function ( handlers, viewerCanManageAccounts )
{
    EditableCellRenderer.prototype.init.call( this );

    this.handlers = handlers;
    this.viewerCanManageAccounts = viewerCanManageAccounts;

    return this;
};

AssignTTApproversCellRenderer.prototype.getCellClassName = function ( cell )
{
    return [ "assignTTApproversCell", this.calculateCellState(cell).getCellClass() ];
};

AssignTTApproversCellRenderer.prototype.generateContent = function ( cell )
{
    var self = this;

    var userInfo = cell.getValue();
    var cellEl = cell.getCellEl();
    var jQCell = $(cellEl);

    this.updateContent(cell);

    jQCell.hover(   function (event)
                    {
                        self.handlers.onMouseIn( {
                                                   requiresApproval: userInfo.requiresTTApproval,
                                                   userIsManager: userInfo.hasManageOtherTTRight,
                                                   userApprovers: cell.getUserApprovers()
                                               }, event );
                    },
                    function ()
                    {
                        self.handlers.onMouseOut();
                    }
    );
    jQCell.mousemove(   function (event)
                        {
                            self.handlers.onMouseMove(event);
                        }
    );

    if ( this.viewerCanManageAccounts )
    {
        cellEl.onclick = function ()
        {
            self.handlers.onMouseOut(); // force onMouseOut event for ie, safari to hide tooltip
            self.handlers.onClick( {
                            userId: userInfo.id,
                            offset: "0px 0px",
                            cellObj: cell,
                            cellEl: cellEl
                          } );
        };
    }
};

AssignTTApproversCellRenderer.prototype.updateContent = function ( cell ) {
    $(cell.getCellEl()).html( this.calculateCellState(cell).getCellTextValue(cell) );
};
