function ShowBalanceHistoryCellRenderer ()
{
    this.constructor = ShowBalanceHistoryCellRenderer;
}
ShowBalanceHistoryCellRenderer.prototype = _.create(TableCellRenderer.prototype, {

    /**
     * @param onClick function( cell )
     */
    init: function(onClick)
    {
        TableCellRenderer.call(this);

        this.onClick = onClick;

        return this;
    },

    getCellGeneralClassName: function()
    {
        //abstract
    },

    getFlagValue: function(value)
    {
        //abstract
    },

    getCellTooltipText: function()
    {
        //abstract
    },

    getCellClassName: function(cell)
    {
        var classes = [this.getCellGeneralClassName()];

        if (!this.getFlagValue(cell.getValue()))
        {
            classes.push("off");
        }
        else
        {
            classes.push("on");
        }

        return classes;
    },

    generateContent: function(cell)
    {
        var value = cell.getValue();
        var cellEl = cell.getCellEl();
        var jQcell = $(cellEl);
        var title = "";
        var content = "";

        if (this.getFlagValue(value))
        {
            var self = this;

            cellEl.onclick = function()
            {
                self.onClick(cell);
            };

            jQcell.hover(function() { jQcell.addClass("hovered"); }, function() { jQcell.removeClass("hovered") });

            title = this.getCellTooltipText();

            content += '<div class="ptoHistorySpinnerPlaceholder" style="display: inline-block"></div>';
        }

        cellEl.title = title;
        cellEl.innerHTML = content;
    }
});