function DurationsCellRenderer() {}

DurationsCellRenderer.prototype = _.create(TableCellRenderer.prototype);

DurationsCellRenderer.prototype.init = function( changesCallback, weekStartDay, showEditorHeader, decimalSeparator )
{
    this.changesCallback = changesCallback;
    this.weekStartDay = weekStartDay;
    this.showEditorHeader = showEditorHeader;
    this._decimalSeparator = decimalSeparator;
    return this;
};

DurationsCellRenderer.prototype.generateContent = function( cell )
{
    var self = this;
    var workdayDurationsEditor = new WorkdayDurationsEditor().init( cell.getValue(), this.weekStartDay, function() {
        cell.setValue( workdayDurationsEditor.getDurations() );
        self.changesCallback();
    }, this.showEditorHeader, null, this._decimalSeparator );

    workdayDurationsEditor.renderTo( cell.getCellEl() );
    cell.workdayDurationsEditor = workdayDurationsEditor;
};

DurationsCellRenderer.prototype.updateUI = function( cell )
{
    TableCellRenderer.prototype.updateUI.call( this, cell );
    cell.getCellEl().className = "durationsCell";
    cell.workdayDurationsEditor.setDurations( cell.getValue() );
    cell.workdayDurationsEditor.setInputDisabled( cell.getRow().isMarkedToRemove() || cell.getRow().isMarkedAsDefault() );
    cell.workdayDurationsEditor.updateUI();
};

