var jsonrpc;

RpcControlManager.prototype.handleSpecificError = function(exception)
{
    if (exception.name.indexOf('com.actimind.actitime.administration.NoSuchATTypeException') != -1) {
        alert(messageResource.getMessage(this.messagePrefix + ".js.error_type_was_deleted"));
        document.location.reload();
        return true;
    } else if (exception.name.indexOf('com.actimind.actitime.administration.ATTypeArchivedException') != -1) {
        alert(messageResource.getMessage(this.messagePrefix + ".js.error_type_was_archived"));
        document.location.reload();
        return true;
    }
    return false;
};

/*
 * Provides methods to manage a type status cell.
 * cell - status cell object
 * typeId - id of leave type, which status cell contains
 */
function StatusCellManager(cell, typeId)
{
    this.base = TextCellManager;
    this.base(cell,
              messageResource.getMessage(this.messagePrefix + ".list.active_tooltip"),
              messageResource.getMessage(this.messagePrefix + ".list.archived_tooltip"),
              messageResource.getMessage(this.messagePrefix + ".list.error_activate"),
              messageResource.getMessage(this.messagePrefix + ".list.error_archive"),
              messageResource.getMessage(this.messagePrefix + ".active"),
              messageResource.getMessage(this.messagePrefix + ".archived"));

    this.typeId = typeId;
}

StatusCellManager.prototype = new TextCellManager();

StatusCellManager.prototype.getTimeoutMsg = function() {
    return messageResource.getMessage(this.messagePrefix + ".list.timeout_update_status");
};

StatusCellManager.prototype.makeRemoteCall = function(callback)
{
    var reqId;
    if (this.initialState)
        reqId = this.getService().archiveType(callback, this.typeId);
    else
        reqId = this.getService().activateType(callback, this.typeId);

    return reqId;
};


var savedClassName = "";
var lastMovedRowInitialClassName = "";
var lastMovedRowHighlightInterval;

function highlightRow(row)
{
    savedClassName = row.className;
    row.className = "listtblrow_highlighted";
}

function removeRowHighlighting(row)
{
    row.className = savedClassName;
}

function removeLastMovedRowHighlightingWithDelay()
{
    var row = getLastMovedTypeRow();
    if (row)
    {
        lastMovedRowHighlightInterval =
            window.setInterval(removeLastMovedRowHighlighting, 800);
    }
}

function removeLastMovedRowHighlighting()
{
    var row = getLastMovedTypeRow();
    if (row)
    {
        row.className = row.className.replace("_last-moved", "");
        window.clearInterval(lastMovedRowHighlightInterval);
        savedClassName = lastMovedRowInitialClassName;
    }
}

function getLastMovedTypeRow()
{
    return document.getElementById("last_moved_type_row");
}