BalanceHistory.Table.AutoAdjustmentRow = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.BalanceRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.AutoAdjustmentRow.prototype = _.create(BalanceHistory.Table.BalanceRow.prototype, {

    templateModel: function()
    {
        return _.extend(BalanceHistory.Table.BalanceRow.prototype.templateModel.call(this), {
            recordImgPath: atDefImgPath("auto-adjustment.png"),
            recordPrintImgPath: atDefImgPath("auto-adjustment_print.png"),
            comment: null
        });
    }
});

// Auto Limit

BalanceHistory.Table.AutoAdjustmentRow.Limit = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.AutoAdjustmentRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.AutoAdjustmentRow.Limit.prototype = _.create(BalanceHistory.Table.AutoAdjustmentRow.prototype, {

    templateModel: function()
    {
        var descriptionLabel = messageResource.getMessage("common.balance_history.table.automatic_balance_limit.label",
                                                          [messageResource.getMessage("common.balance_history.table." + this.balanceType)]);
        return _.extend(BalanceHistory.Table.AutoAdjustmentRow.prototype.templateModel.call(this), {
            descriptionTitle: descriptionLabel
        });
    },

    additionalValueSign: "=",

    recordClass: "automaticBalanceLimitRecord"
});

// Auto Reset

BalanceHistory.Table.AutoAdjustmentRow.Reset = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.AutoAdjustmentRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.AutoAdjustmentRow.Reset.prototype = _.create(BalanceHistory.Table.AutoAdjustmentRow.prototype, {

    templateModel: function()
    {
        var descriptionLabel = messageResource.getMessage("common.balance_history.table.automatic_balance_reset.label",
                                                          [messageResource.getMessage("common.balance_history.table." + this.balanceType)]);
        return _.extend(BalanceHistory.Table.AutoAdjustmentRow.prototype.templateModel.call(this), {
            descriptionTitle: descriptionLabel
        });
    },

    additionalValueSign: "=",

    recordClass: "automaticBalanceResetRecord"
});

// Auto Accrue

BalanceHistory.Table.AutoAdjustmentRow.Accrue = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.AutoAdjustmentRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.AutoAdjustmentRow.Accrue.prototype = _.create(BalanceHistory.Table.AutoAdjustmentRow.prototype, {

    messageKeys: function()
    {
        return {
            descriptionTitle: "common.balance_history.table.automatic_balance_accrue.label"
        }
    },

    afterRender: function()
    {
        BalanceHistory.Table.AutoAdjustmentRow.prototype.afterRender.call(this);
        this.find(".valueCell > span.mainValue").addClass("increased");
        this.find(".valueCell > span.additionalValue").addClass("increased");
    },

    additionalValueSign: "+",

    recordClass: "automaticBalanceAccrueRecord"
});