BalanceHistory.Table.BalanceRow = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    TemplateView.call(this, $containerEl);
    this.balanceType = balanceType;
    this.balanceModel = balanceModel;
    this.balanceFormatter = balanceFormatter;
};


BalanceHistory.Table.BalanceRow.prototype = _.create(TemplateView.prototype, {
    html: "<tr class='record <%=recordClass%>'>" +
          "    <td class='effectiveDateCell'><%=effectiveDate%></td>" +
          "    <td class='descriptionCell'>" +
          "        <div class='descriptionDiv'>" +
          "            <img src='<%=recordImgPath%>'>" +
          "            <div class='for-print-only'><img src='<%=recordPrintImgPath%>'></div>" +
          "            <div class='descriptionTitle'><%=descriptionTitle%></div>" +
          "            <% if (!_.isNull(comment)) { %>" +
          "             <div title='<%-comment%>' class='descriptionComment'><%-comment%></div>" +
          "            <% } %>" +
          "        </div>" +
          "    </td>" +
          "    <td class='valueCell'>" +
          "        <span class='mainValue'><%=mainValue%></span>" +
          "        <span class='additionalValue'>&nbsp;&nbsp;(<%=additionalValue%>)</span>" +
          "    </td>" +
          "    <td class='endingBalanceCell'>" +
          "        <span class='bold mainValue'><%=endingMainValue%></span>" +
          "        <span class='additionalValue'>&nbsp;&nbsp;(<%=endingAdditionalValue%>)</span>" +
          "    </td>" +
          "</tr>",

    templateModel: function()
    {
        var balanceModel = this.balanceModel;
        var addSign = this.additionalValueSign;
        var balanceFormatter = this.balanceFormatter;
        return {
            effectiveDate: balanceModel.effectiveDate.parseJSONDate().format("M d, y"),
            mainValue: addSign + ' ' + balanceFormatter.format(balanceModel.differenceValue),
            additionalValue: balanceFormatter.format(balanceModel.differenceValue, true),
            endingMainValue: balanceFormatter.format(balanceModel.endingBalance),
            endingAdditionalValue: balanceFormatter.format(balanceModel.endingBalance, true),
            recordClass: this.recordClass
        }
    },

    afterRender: function()
    {
        if (this.balanceFormatter.isNegativePTO(this.balanceModel.endingBalance))
        {
            this.find(".endingBalanceCell > span.mainValue").addClass("negative");
            this.find(".endingBalanceCell > span.additionalValue").addClass("negative");
        }
    }
});