BalanceHistory.Table.LeaveTimeCompletedRow = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.BalanceRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.LeaveTimeCompletedRow.prototype = _.create(BalanceHistory.Table.BalanceRow.prototype, {
    additionalValueSign: "-",

    recordClass: "leaveTimeCompletedRecord",

    templateModel: function()
    {
        var comment = this.balanceModel.comment;
        var leaveType = LeaveTypeStore.getLeaveType(this.balanceModel.leaveTypeId);
        var leaveTimeLabel = messageResource.getEscapedMessage("common.balance_history.table.leave_time_completed.label", [leaveType.name]);
        return _.extend(BalanceHistory.Table.BalanceRow.prototype.templateModel.call(this), {
            descriptionTitle: leaveTimeLabel,
            comment: comment,
            recordImgPath: getLeaveTypeIconPath(leaveType.iconId),
            recordPrintImgPath: getLeaveTypePrintIconPath(leaveType.iconId)
        });
    },

    afterRender: function()
    {
        BalanceHistory.Table.BalanceRow.prototype.afterRender.call(this);
        this.find(".valueCell > span.mainValue").addClass("decreased");
        this.find(".valueCell > span.additionalValue").addClass("decreased");
    }
});