BalanceHistory.Table.ManualAdjustmentRow = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.BalanceRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.ManualAdjustmentRow.prototype = _.create(BalanceHistory.Table.BalanceRow.prototype, {

    formatBalanceManagerInfo: function(balanceManager)
    {
        return messageResource.getMessage("common.balance_history.table.leave_time_completed.by.label",
                                          [UserNameFormat.formatFML(balanceManager.firstName, balanceManager.lastName, balanceManager.middleInitial)]);
    },

    formatCommentIfPresent: function(comment)
    {
        return comment && isNotEmpty(comment) ? ' - ' + comment : '';
    },

    templateModel: function()
    {
        var description = this.formatBalanceManagerInfo(this.balanceModel.balanceManagerInfo) +
                          this.formatCommentIfPresent(this.balanceModel.comment);
        return _.extend(BalanceHistory.Table.BalanceRow.prototype.templateModel.call(this), {
            recordImgPath: atDefImgPath("manual-adjustment.png"),
            recordPrintImgPath: atDefImgPath("manual-adjustment_print.png"),
            comment: description
        });
    }
});

// Increase

BalanceHistory.Table.ManualAdjustmentRow.Increase = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.ManualAdjustmentRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.ManualAdjustmentRow.Increase.prototype = _.create(BalanceHistory.Table.ManualAdjustmentRow.prototype, {

    messageKeys: function()
    {
        return {
            descriptionTitle: "common.balance_history.table.manual_increase.label"
        }
    },

    afterRender: function()
    {
        BalanceHistory.Table.ManualAdjustmentRow.prototype.afterRender.call(this);
        this.find(".valueCell > span.mainValue").addClass("increased");
        this.find(".valueCell > span.additionalValue").addClass("increased");
    },

    additionalValueSign: "+",

    recordClass: "manualIncreaseRecord"
});

// Decrease

BalanceHistory.Table.ManualAdjustmentRow.Decrease = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.ManualAdjustmentRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.ManualAdjustmentRow.Decrease.prototype = _.create(BalanceHistory.Table.ManualAdjustmentRow.prototype, {

    messageKeys: function()
    {
        return {
            descriptionTitle: "common.balance_history.table.manual_decrease.label"
        }
    },

    afterRender: function()
    {
        BalanceHistory.Table.ManualAdjustmentRow.prototype.afterRender.call(this);
        this.find(".valueCell > span.mainValue").addClass("decreased");
        this.find(".valueCell > span.additionalValue").addClass("decreased");
    },

    additionalValueSign: "-",

    recordClass: "manualDecreaseRecord"
});

// Manual Set

BalanceHistory.Table.ManualAdjustmentRow.ManualSet = function($containerEl, balanceType, balanceModel, balanceFormatter)
{
    BalanceHistory.Table.ManualAdjustmentRow.call(this, $containerEl, balanceType, balanceModel, balanceFormatter);
};

BalanceHistory.Table.ManualAdjustmentRow.ManualSet.prototype = _.create(BalanceHistory.Table.ManualAdjustmentRow.prototype, {

    messageKeys: function()
    {
        return {
            descriptionTitle: "common.balance_history.table.manual_set.label"
        }
    },

    additionalValueSign: "=",

    recordClass: "manualSetRecord"
});