function AffectedBalancePopup() {}

AffectedBalancePopup.prototype.init = function ( container, onEditCallback, balanceEditPanel )
{
    var self = this;
    this.container = container;
    this.balancesEditPanel = balanceEditPanel;
    this.onEditCallBack = onEditCallback;
    this.affectedBalanceDialog = new DropdownDialog( {
        wrapperClass: "affectedBalancePopup",
        dialogDiv: this.container,
        hideOnResize: true,
        showEmptyTitleBar: false,
        okButtonText: messageResource.getMessage( "common.apply" ),
        onOkClick: function() { self.onApplyClickCallback(); },
        onClose: function()
                 {
                     if ( self.afterCloseHandler )
                         self.afterCloseHandler();
                 }
    } );

    this.balancesEditPanel.setOnblurPtoCoefficientInputElement( function() { self.onblurCallback(); } );

    return this;
};

AffectedBalancePopup.prototype.show = function ( element, beforeShowHandler, afterCloseHandler )
{
    this.beforeShowHandler = beforeShowHandler;
    this.afterCloseHandler = afterCloseHandler;
    this.balancesEditPanel.hideAllErrors();
    this.balancesEditPanel.populate( { balanceType: this.value.balanceType, ptoCoefficient: this.value.balanceCoefficient } );
    if ( this.beforeShowHandler )
        this.beforeShowHandler();
    this.affectedBalanceDialog.showAt( element );
};

AffectedBalancePopup.prototype.onApplyClickCallback = function()
{
    this.balancesEditPanel.hideAllErrors();
    if ( this.balancesEditPanel.isAsPTOChecked() && this.balancesEditPanel.checkEmpty() )
    {
        this.balancesEditPanel.showEmptyPtoErrorMessage();
        return;
    }
    if ( this.balancesEditPanel.validate() )
    {
        this.onEditCallBack( this.value.id, this.balancesEditPanel.getBalanceType(), this.balancesEditPanel.getBalanceCoefficient() );
        this.affectedBalanceDialog.hide();
    }
    else
        this.balancesEditPanel.showErrors();
};

AffectedBalancePopup.prototype.onblurCallback = function()
{
    if ( this.balancesEditPanel.checkEmpty() )
    {
        this.balancesEditPanel.hideErrors();
        return;
    }
    this.balancesEditPanel.hideEmptyError();
    if ( this.balancesEditPanel.validate() )
        this.balancesEditPanel.hideErrors();
    else
        this.balancesEditPanel.showErrors();
};

AffectedBalancePopup.prototype.setValue = function( value )
{
    this.value = value;
};

