function ApproversTooltip () {}

ApproversTooltip.prototype = new DelayTooltip();

ApproversTooltip.prototype.init = function ( tooltipId )
{
    DelayTooltip.prototype.init.call( this, tooltipId );
    this._tooltipHeader = this._tooltipEl.find( "#" + tooltipId + "_header" );

    return this;
};

ApproversTooltip.prototype.updateUI = function ( config )
{
    var tooltipText = "";
    var withHeader = false;

    this.needDelay( true );

    if( config.requiresApproval )
    {
        if( config.userApprovers != null && config.userApprovers.length > 0 )
        {
            var visibleApproversCount = 5;
            tooltipText = "<ul>";
            for( var i = 0; i < config.userApprovers.length && i < visibleApproversCount; i++ )
            {
                var approver = config.userApprovers[i];
                tooltipText += "<li><div>" + UserNameFormat.formatLFM(
                        escapeHtmlSymbols( approver.firstName ),
                        escapeHtmlSymbols( approver.lastName ),
                        escapeHtmlSymbols( approver.middleInitial ) ) + "</div></li>";
            }
            tooltipText += "</ul>";
            if( config.userApprovers.length > visibleApproversCount )
            {
                tooltipText += "<div class='otherUsersText'> " +
                               messageResource.getMessage( (config.userApprovers.length - visibleApproversCount == 1) ? "user_list.and_1_other" : "user_list.and_n_others", [config.userApprovers.length - visibleApproversCount] ) +
                               "  </div>";
            }
            withHeader = true;
        }
        else
        {
            this.needDelay( false );
            tooltipText = messageResource.getMessage( "user_list.approvers_tooltip.approvers_not_selected" );
        }
    }
    else if ( !config.requiresApproval )
    {
        tooltipText = messageResource.getMessage( "user_list.approvers_tooltip.auto_approved" );
    }

    this._tooltipHeader.css( 'display', withHeader ? 'block' : 'none' );
    this._tooltipTextPlaceholder.html( tooltipText );
};
