/**
 * Extends Field controller, preserves element class names instead of their deletion if grey text shown.
**/

function EnhancedFieldController()
{
    FieldController.call(this);
}

EnhancedFieldController.prototype = new FieldController();

EnhancedFieldController.prototype.hideGrayText = function()
{
    this.fieldElement.value = "";
    if (this.defaultMaxlength != null)
    {
        this.fieldElement.setAttribute("maxlength", this.defaultMaxlength);
    }
    removeClass(this.fieldElement, this.emptyCaptionStyleClass);
    this.fieldElement.spellcheck = true;
    this.emptyCaptionShown = false;
};

EnhancedFieldController.prototype.showGreyText = function( textToShow )
{
    addClass(this.fieldElement, this.emptyCaptionStyleClass);
    if (this.defaultMaxlength != null)
    {
        this.fieldElement.setAttribute("maxlength", this.emptyCaption.length);
    }
    this.fieldElement.value = textToShow ? textToShow : this.emptyCaption;
    this.fieldElement.spellcheck = false;
    this.emptyCaptionShown = true;
};

EnhancedFieldController.prototype.isEmpty = function()
{
    return this.emptyCaptionShown || trim(this.fieldElement.value).length == 0;
};