/**
 * Created by filatov on 30.11.2015.
 */
function LeaveNamePopup(){}

LeaveNamePopup.prototype.init = function(containerId, editHandler, beforeShowHandler, afterCloseHandler){
    var self = this;
    this.container = $("#" + containerId );
    this.dialog = new DropdownDialog( {
                                   wrapperClass: "leaveNamePopup",
                                   dialogDiv: this.container,
                                   hideButtons: true,
                                   hideOnResize: true,
                                   showEmptyTitleBar: false,
                                   isWithBeak: false,
                                   onClose: function(){
                                              if(self.afterCloseHandler)
                                                     self.afterCloseHandler()
                                        }
                                      });
    this.inputDiv = this.container.find(".inputDiv");
    this.inputDiv.on("blur", function(){
       if (self.currentName != self.getValue() && self.hasError){
          self.hideError();
       }
    });
    this.applyButton = this.container.find(".applyButton");


    function customCallback( result )
    {
        if( result.resultCode != LeaveTypeListPageController.ERROR_NAME_DUPLICATE )
            self.dialog.hide();
        else
            self.showError("leave_type.edit.error.name_duplicate");
    }

    this.applyButton.on("click", function(){
        // if there is error then no apply actions
        if(self.hasError){
            return;
        }
        var newName  = self.getValue();
        // if name equals with original name then hide dialog (case sensitive comparison)
        if(newName == self.originName){
            self.dialog.hide();
            return;
        }

        if (newName  == "")
            self.showError("leave_type.error.name_required");
        else
        {
            self.currentName = newName;
            editHandler( self.value.id,self.currentName, customCallback );
        }
    });

    this.cancelButton = this.container.find(".cancelButton");
    this.cancelButton.on("click", function(){
        self.dialog.hide();
    });

    return this;
};

LeaveNamePopup.prototype.getValue = function(){
    return trim( $(this.inputDiv).pVal());
};

LeaveNamePopup.prototype.showError = function(messageKey){
     this.container.find(".errorPlaceholder" ).text(messageResource.getMessage(messageKey));
     this.container.addClass("error");
     this.hasError = true;
};

LeaveNamePopup.prototype.hideError = function(){
    this.container.removeClass("error");
    this.hasError = false;
};

LeaveNamePopup.prototype.setValue = function(value){
   this.value = value;
   this.currentName = value.name;
   $(this.inputDiv).val(value.name);
};

LeaveNamePopup.prototype.show = function(element, positionParams, beforeShowHandler, afterCloseHandler){
  if(beforeShowHandler)
       beforeShowHandler();
  this.hideError();
  this.afterCloseHandler = afterCloseHandler;
  this.dialog.showAt(element, positionParams);
    // save origin leave type name
    this.originName = this.getValue();
};



