function ReportLeaveTypesSelectorButton() {}

ReportLeaveTypesSelectorButton.prototype.init = function ( renderTo, leavesSelection, leavesData,
                                                           ptoFeatureEnabled, sickBalanceFeatureEnabled, changeCallback, withApplyButton )
{
    var leaveSelectorUtil = new LeaveTypesSelectorUtil().init(leavesData, ptoFeatureEnabled, sickBalanceFeatureEnabled, leavesSelection.leaveTypes);

    var ptoName = messageResource.getMessage("leaves_selector.group_label.pto_balance");
    var sdbName = messageResource.getMessage("leaves_selector.group_label.sick_days_balance");
    var bothName = ptoFeatureEnabled && sickBalanceFeatureEnabled ?
        messageResource.getMessage("leaves_selector.group_label.both") : ptoFeatureEnabled ? ptoName : sdbName;

    var leaveSelectorData = leaveSelectorUtil.getDataForSelector(
        {
            ptoLabel : messageResource.getMessage('leaves_selector.group_label.affects', [ptoName]),
            sickDaysLabel : messageResource.getMessage('leaves_selector.group_label.affects', [sdbName]),
            withoutBalancesLabel : messageResource.getMessage('leaves_selector.group_label.does_not_affect', [bothName])
        }
    );

    var leavesConfig = {
        data: leaveSelectorData,
        optionValue: leavesSelection.qualifier,
        showInactive: leaveSelectorUtil.isNeedToShowInactiveLeaves() || leavesSelection.showInactive,
        showResetButton: true,
        isMarkAllSelectedIsEmpty: false
    };

    var panelConstructor = AT.ReportLeavesSelectorPanel;
    leaveSelectorUtil.setSelectorTreeConstructorToPanel(panelConstructor);

    if ( withApplyButton )
        Ext.apply( leavesConfig, SelectorPanelWithApplyButtonHelper.getApplyButtonExtension( panelConstructor ) );
    var leavesSelector = new panelConstructor( leavesConfig );

    var self = this;
    leavesSelector.on("change", function() {
        self.leavesSelector.wasChanged = true;
    });

    this.leavesSelector = new AT.SelectorDropdownButton({
                                                            additionalMenuCls: "leaveTypeSelector",
                                                            renderTo: renderTo,
                                                            labelCls: "hierarchySelectorButton",
                                                            minWidth: 457,
                                                            selectorPanel: leavesSelector
                                                        });

    this.leavesSelector.setMenuHideCallback(function(){
        if (changeCallback && self.leavesSelector.wasChanged) self.leavesSelector.wasChanged = false; changeCallback();
    });

    return this;
};

ReportLeaveTypesSelectorButton.prototype.getLeaveTypeSelection = function ()
{
    var leavesSelector = this.leavesSelector.selectorPanel;
    var leaveTypes = [];
    for ( var i = 0; i < leavesSelector.getSelection().length; ++i ) {
        leaveTypes.push(leavesSelector.getSelection()[i].id);
    }

    return  {
        leaveTypes: leaveTypes,
        qualifier: leavesSelector.getCurrentOptionValue(),
        showArchived: leavesSelector.getShowInactive()
    };
};

ReportLeaveTypesSelectorButton.prototype.resetLeavesSelectionFunction = function()
{
    this.leavesSelector.selectorPanel.resetState(true);
};

ReportLeaveTypesSelectorButton.prototype.setInitialValuesFromCurrent = function()
{
    this.leavesSelector.selectorPanel.setInitialValuesFromCurrent();
};

ReportLeaveTypesSelectorButton.prototype.isEmptySelection = function()
{
    return this.leavesSelector.selectorPanel.isEmptySelection();
};

ReportLeaveTypesSelectorButton.prototype.isStateChanged = function()
{
    return this.leavesSelector.selectorPanel.isStateChanged();
};