/**
 * @autor: kamenev
 *
 * depends upon:
 *      /js/controls/FieldController
 */

function SecureFieldController()
{
    FieldController.call(this);
}

SecureFieldController.prototype = new FieldController();

SecureFieldController.prototype.init = function( elementId )
{
    FieldController.prototype.init.call( this, elementId );
    if( !this.isEmpty() )
    {
        this.getElement().value = this.decode( this.getElement().value );
        this.getElement().defaultValue = this.getElement().value;
    }
};

/**
 * Returns encoded value of an input field associated with the field controller.
 */
SecureFieldController.prototype.getValue = function()
{
    return this.encode( FieldController.prototype.getValue.call(this) );
};

/**
 * Encodes given string
 * @param str string to encode
 */
SecureFieldController.prototype.encode = function( str )
{
    return Base64.encode( str, false )
};

/**
 * Decodes given string
 * @param str string to decode
 */
SecureFieldController.prototype.decode = function( str )
{
    return Base64.decode( str, false )
};

/**
 * Sets up field with encoded representation of its current value
 */
SecureFieldController.prototype.encodeFieldValue = function ()
{
    this.setValue( this.getValue() );
};

/**
 * Sets up field with encoded representation of its current value
 */
SecureFieldController.prototype.encodeFieldValueMD5 = function ()
{
    this.setValue( MD5(FieldController.prototype.getValue.call(this)) );
};

/**
 * Sets up field with encoded representation of its current value
 */
SecureFieldController.prototype.getPlainTextValue = function ()
{
    return FieldController.prototype.getValue.call(this);
};
