function TTUsersSelector ()
{
    BaseUsersSelector.call(this);
}

TTUsersSelector.prototype = _.create(BaseUsersSelector.prototype, {
    init: function( users, groups, initialValue, emptyText, hiddenFieldName, width, comboListClass, ugrEnabled, tzgEnabled)
    {
        BaseUsersSelector.prototype.init.call(this,  users, groups, initialValue, emptyText, hiddenFieldName, width, comboListClass, ugrEnabled, tzgEnabled);
        this.$userSelectorTd= $(".userSelectorTd").addClass("showSelector");
        this.$selectedUserButton = $(".userSelectorButton");
        var loggedInUserId = this._getLoggedInUserId();
        this.hasSubmitMyTTRight = !_.isUndefined(_.find(users, function(user) { return user.id == loggedInUserId}));
        $(".backToMyTTImg").click(_.bind(this.onUserSelect, this, loggedInUserId));
        $(".backToMyTtText").click(_.bind(this.onUserSelect, this, loggedInUserId));
        this.$selectedUserButton.click(_.bind(this.expandSelectorList, this));
        this.spinnerPlaceholder = this.$userSelectorTd.find(".userSelectorSpinnerPlaceholder");
        if (!_.isUndefined(this.spinnerPlaceholder))
        {
            this.spinner = new SpinnerController();
        }
        this.updateUI();
    },

    /*
     * Hides users drop-down and shows text field instead of that one with text informing about user's time-track loading.
     */
    leaveAndShowAnimationSpinner: function()
    {
        if (this.spinner)
        {
            this.spinner.spinInElement(this.spinnerPlaceholder);
        }
        this.usersCombo.setEditable( false );
        this.usersCombo.disabled = true;
        this.usersCombo.blur();
    },

    expandSelectorList: function()
    {
        this.$userSelectorTd.find(".x-form-trigger").click();
    },

    formatUserName: function( selectorValue, user )
    {
        return this._getLoggedInUserId() == selectorValue ?
               messageResource.getMessage("usersselector.me") : user.formatNameLFM();
    },

    getData: function(){
        var data = BaseUsersSelector.prototype.getData.call(this);
        data.push({name: 'isRequiresTTApproval', mapping: "isRequiresTTApproval"});
        return data;
    },

    formatHighlightedUserName: function(value)
    {
        var  isAutoApproved =  (!value.isRequiresTTApproval) && EnabledFeatures.TTA;
        var  clsUserName = "userName";
        clsUserName += isAutoApproved ? " autoApproved" : "";
        var  formattedText= "<span class='" + clsUserName +"'>" + BaseUsersSelector.prototype.formatHighlightedUserName.call(this, value)+ "</span>";
        if (isAutoApproved)
            formattedText += "<span class='autoApprovedText'>" + messageResource.getMessage("usersselector.auto") + "</span>";
        return formattedText;
    },

    isLoggedInUserId: function(id)
    {
        return this._getLoggedInUserId() == id;
    },

    updateUI: function()
    {
        this.$userSelectorTd.toggleClass("backToMySheetShown", this.usersCombo.getValue() != this._getLoggedInUserId() && this.hasSubmitMyTTRight);
        var lastSelectionText = _.isUndefined(this.usersCombo.lastSelectionText) ?  this.usersCombo.emptyText : this.usersCombo.lastSelectionText;
        this.$selectedUserButton.find(".dashedLink").html(escapeHtmlSymbols(lastSelectionText));
        this.$userSelectorTd.toggleClass("showSelector", this.needToRenderSelector())
    },
    
    _getLoggedInUserId: function()
    {
        // abstract
    },

    needToRenderSelector: function()
    {
    //    abstract
        return true;
    }
});