/**
 * Created by filatov on 24.11.2015.
 */
function UserlistTabs(){}

UserlistTabs.prototype.init = function(config){
    this._activeTabValue = config.activeTabValue;
    this.items = config.items;
    this.tabs = $("#" + config.id );
    this.tabs.addClass("customHeaderTabs");
    this.mapValues = new AtMap();
    var self = this;
    var changeActiveTab = function ( tabValue )
    {
        if( !(self._activeTabValue == tabValue) )
        {
            self.setActiveTab( tabValue );
            self.updateUI();
            if( config.changeCallback )
                config.changeCallback();
            
            PageOverlayTipsManager.getInstance().refreshDynamicTips();
        }
    };
    for( var i = 0; i < this.items.length; ++i )
    {
        var item = this.items[i];
        var tabEl = document.createElement( "span" );
        tabEl.id = item.id || ("tab" +  (i + 1));
        $(tabEl).addClass( "tab" );

        var titleEl = document.createElement( "span" );
        $( titleEl ).addClass( "tabContainer" );

        var textTab = document.createElement( "span" );
        $( textTab ).addClass( "textTab" );
        $( textTab ).html( messageResource.getMessage( item.text ) );
        $( titleEl ).on( "click", function ( x )
        {
            return function () {changeActiveTab( x )}
        }( item.value ) );

        this.mapValues.put(item.value, tabEl.id);
        if(i>0){
            var titleSeparator = document.createElement("span");
            $(titleSeparator ).addClass("titleSeparator");
            $(titleSeparator ).html("&nbsp");
            $(tabEl).append(titleSeparator);
        }
        $(titleEl).append(textTab);
        $(tabEl).append(titleEl);
        this.tabs.append(tabEl);
    }
    this.updateUI();
    return this;
};

UserlistTabs.prototype.getJQueryTab = function(tabValue){
    return this.tabs.find("#" + this.mapValues.get(tabValue));
};

UserlistTabs.prototype.updateUI =function(){
    this.tabs.find(".selected" ).removeClass("selected");
    this.getJQueryTab(this._activeTabValue).addClass("selected");
};

UserlistTabs.prototype.getActiveTab = function(){
    return this._activeTabValue;
};

UserlistTabs.prototype.setActiveTab = function ( tabValue )
{
    this._activeTabValue = tabValue;
};

UserlistTabs.prototype.disableTab = function ( tabValue )
{
    this.getJQueryTab(tabValue).addClass("disabled");
};

UserlistTabs.prototype.hide = function ()
{
   this.tabs.hide();
};


UserlistTabs.prototype.show = function ()
{
    this.tabs.show();
};

UserlistTabs.prototype.unDisableTab = function ( tabValue )
{
    this.getJQueryTab(tabValue).removeClass("disabled");
};
