/**
 * @author kostenko
 *
 * @deprecated DO NOT USE
 *
 * Helper functions and objects used for DataTables initialization.
 */
var DataTablesHelpers =
{
    /**
     * Default object to use for oLanguage property.
     */
    defaultTexts: {
        sLengthMenu: messageResource.getMessage('common.shown_by_x_a_page')
    },

    /**
     * Creates a function to use for fnInfoCallback property.
     *
     * @param oneEntryTextKey the message key for '1 entry' text
     * @param multipleEntriesTextKey the message key for 'X entries' text
     * @return {Function}
     */
    createInfoStringRenderer: function (oneEntryTextKey, multipleEntriesTextKey)
    {
        return function (oSettings, iStart, iEnd, iMax, iTotal, sPre)
        {
            return messageResource.getMessage( iTotal == 1 ? oneEntryTextKey : multipleEntriesTextKey, [iTotal] ) + ', ';
        }
    },

    /**
     * This function reattaches column header click handlers (used for sorting) from column header cells to the inner
     * "sortingLink" elements. This is useful when there are additional controls inside column header cells.
     *
     * This function can be used directly as fnInitComplete DataTable initialization parameter value.
     * Otherwise be sure to call it in the context of DataTable.
     */
    narrowColumnHeaderClickAreas: function()
    {
        this.find("th").each( function( index ) {
            var header = $(this);

            header.removeAttr("tabindex");

            var handlers = header.data("events");

            if( handlers && handlers.click )
            {
                header.find(".sortingLink").click( handlers.click[0].handler );
                header.off("click");
            }
        });
    }
};