// see also constants_js.jsp DateRangeStateUtil
function DateRangeMenuItemsUtil() {}

DateRangeMenuItemsUtil.prototype.ttfItems = [
    DateRangeSelectionQualifier.CURRENT_MONTH_TILL_TODAY,
    DateRangeSelectionQualifier.CURRENT_WEEK_TILL_TODAY,
    DateRangeSelectionQualifier.CURRENT_YEAR_TILL_TODAY
];

DateRangeMenuItemsUtil.prototype.isShowTTFItems = function ( selectedQualifier ) {
    return EnabledFeatures.TTF || this.ttfItems.indexOf(selectedQualifier) != -1;
};

DateRangeMenuItemsUtil.prototype.createDefaultDateRangeMenuItems = function ( selectedQualifier ) {
    var result = [new AT.CurrentMonthMenuItem(), new AT.PreviousMonthMenuItem()];

    if ( this.isShowTTFItems(selectedQualifier) )
        result.push(AT.DateRangeSelectorSeparator,
                    new AT.CurrentMonthTillTodayMenuItem(),
                    new AT.CurrentWeekTillTodayMenuItem());

    result.push(AT.DateRangeSelectorSeparator,
                new AT.CurrentWeekMenuItem(),
                new AT.PreviousWeekMenuItem(),
                new AT.CurrentAndPreviousWeeksMenuItem(),
                new AT.CurrentAndTwoPreviousWeeksMenuItem(),
                AT.DateRangeSelectorSeparator,
                new AT.Last7DaysMenuItem(),
                new AT.Last14DaysMenuItem(),
                new AT.Last21DaysMenuItem(),
                AT.DateRangeSelectorSeparator,
                new AT.CustomDateRangeMenuItem());

    return result; 
};

DateRangeMenuItemsUtil.prototype.createDateRangeMenuItemsWithFuture = function ( showFutureValidator ) {
    var result = [new AT.CurrentMonthMenuItem(), 
                  new AT.NextMonthMenuItem(),
                  new AT.PreviousMonthMenuItem()];


    if ( showFutureValidator() )
        result.push(AT.DateRangeSelectorSeparator,
                    new AT.CurrentMonthTillTodayMenuItem(),
                    new AT.CurrentWeekTillTodayMenuItem(),
                    new AT.CurrentYearTillTodayMenuItem());

    result.push(AT.DateRangeSelectorSeparator,
                new AT.CurrentWeekMenuItem(),
                new AT.NextWeekMenuItem(),
                new AT.PreviousWeekMenuItem(),
                AT.DateRangeSelectorSeparator,
                new AT.Last7DaysMenuItem(),
                new AT.Last14DaysMenuItem(),
                new AT.Last21DaysMenuItem(),
                AT.DateRangeSelectorSeparator,
                new AT.CurrentYearMenuItem(),
                new AT.PreviousYearMenuItem(),
                AT.DateRangeSelectorSeparator,
                new AT.CustomDateRangeMenuItem());

    return result;
};

DateRangeMenuItemsUtil.prototype.sortLastDaysBySystemSettingsWeekStartDay = function () {
    var lastDays = [
        new AT.LastSundayMenuItem(),
        new AT.LastMondayMenuItem(),
        new AT.LastTuesdayMenuItem(),
        new AT.LastWednesdayMenuItem(),
        new AT.LastThursdayMenuItem(),
        new AT.LastFridayMenuItem(),
        new AT.LastSaturdayMenuItem()
    ];
    var weekStartDay = SystemSettings.weekStartDay - 1;
    var daysAfterWeekStartDay = lastDays.splice(0, weekStartDay);
    return lastDays.concat(daysAfterWeekStartDay);
};

DateRangeMenuItemsUtil.prototype.createDefaultSingleDateMenuItems = function () {
    var result = [];
    result.push(
            new AT.TodayMenuItem(),
            new AT.YesterdayMenuItem(),
            AT.DateRangeSelectorSeparator);
    
    result = result.concat(this.sortLastDaysBySystemSettingsWeekStartDay());
    
    result.push(
            AT.DateRangeSelectorSeparator,
            new AT.EndOfThePreviousMonthMenuItem(),
            new AT.BeginningOfTheCurrentMonthMenuItem(),
            AT.DateRangeSelectorSeparator,
            new AT.CustomDateMenuItem()
    );
    return result;    
};
