DateSelector = Ext.extend(AT.AbstractPickerButton,
{
    showToday: true,
    showOkCancelButtons: true,
    scheduleCalculator: null,
    menuListeners:
    {
        select : function (m, d)
        {
            if( this.date || !this.menu.wasSelectionOnHide )
                this.updateValueAndFireIfChanged( m, d );
            else
                this.menu.onDatePickerCancel();
        },

        datePickerUpdate : function(date)
        {
            // display the given date, but don't actually change the date
            if( this.date )
                this.displayValue(date);
        },

        datePickerCancel : function()
        {
            // display the stored value
            this.displayValue(this.getValue());
            // rollback changes made in the picker
            this.menu.picker.setValue( this.getValueOrDefaultValue() );
        }
    },

    getValueOrDefaultValue: function()
    {
        return this.getValue() ? this.getValue() : currentUserTime().clearTime();
    },

    createMenu: function()
    {
        return new AT.menu.DatePickerMenu(
                {
                    mode: "dynamic",
                    minDate: this.minValue,
                    maxDate: this.maxValue,
                    format: this.format,
                    showToday: this.showToday,
                    showOkCancelButtons: this.showOkCancelButtons,
                    scheduleCalculator: this.scheduleCalculator,
                    startDay: this.weekStartDay,
                    value: this.getValueOrDefaultValue(),
                    minText: this.minText,
                    maxText: this.maxText
                });
    },

    hideMenuOnScrollOrResize: function()
    {
        if(this.getValue())
            this.menu.picker.selectActiveDate();
        this.hideMenu(); // hides the menu faster than the previous call
    }
});
