/**
 * Created by filatov on 15.05.2015.
 */

function RejectCommentDialog(){}

RejectCommentDialog.prototype.init = function(rejectCommentDialogDiv, rejectCallback){

    var self = this;
    this.rejectCallback = rejectCallback;
    this.rejectCommentDialogDiv = $("#" + rejectCommentDialogDiv);
    this.rejectCommentDialog = new DropdownDialog({
                                                      wrapperClass: "rejectCommentDialogWrapper",
                                                      dialogDiv: this.rejectCommentDialogDiv,
                                                      hideButtons: false,
                                                      isWithBeak: true,
                                                      hideOnResize: true,
                                                      showEmptyTitleBar: false,
                                                      okButtonText: messageResource.getMessage("change_week_approval_status.reject_comment_dialog.reject_button"),
                                                      onOkClick: function () {
                                                          return self.rejectCallback();
                                                      }
                                                  });
    this.rejectCommentDialogUserInfo = this.rejectCommentDialogDiv.find("span.userInfo");
    this.rejectCommentField = this.rejectCommentDialogDiv.find(".rejectWeekComment");

    this.rejectCommentTextArea = $("#rejectWeekCommentTextArea");
    this.rejectCommentLengthNote = new TextAreaLengthNote('rejectCommentLength', null, 255);
    this.rejectCommentTextChangeHandler = function ()
    {
        self.rejectCommentLengthNote.update( self.rejectCommentTextArea.pVal() );
    };
    this.rejectCommentTextArea.blur( self.rejectCommentTextChangeHandler );
    this.rejectCommentTextArea.keyup( self.rejectCommentTextChangeHandler );
    this.rejectCommentTextArea.on( "paste", self.rejectCommentTextChangeHandler );
    this.rejectCommentLengthNote.show();

    return this;
};

RejectCommentDialog.prototype._open = function (pressedButton, popupConfig, rejectCallBack)
{
    if (rejectCallBack)
        this.rejectCallback = rejectCallBack;

    this.rejectCommentDialogUserInfo.text(messageResource.getMessage(
            "reject_comment_dialog.caption.part2",
            [popupConfig.userInfo]));
    this.rejectCommentField.val("");

    this.rejectCommentField.placeholder();
    var popupConfigPosition;
    if (popupConfig.isBottom)
        popupConfigPosition = {
            offset: "47px -15px",
            my:  "right bottom",
            at: "right top",
            collision: "none"
        };
    else
        popupConfigPosition = {
            offset: "47px 15px",
            my:  "right top",
            at: "right bottom",
            collision: "none"
        };

    this.rejectCommentDialog.setBeak(popupConfig.isBottom);
    this.rejectCommentDialog.showAt( pressedButton, popupConfigPosition );
    this.rejectCommentTextChangeHandler();
    this.rejectCommentTextArea.focus();
};

RejectCommentDialog.prototype.isValid = function(){
    return this.rejectCommentLengthNote.isTextLengthValid();
};


RejectCommentDialog.prototype.getComment = function(){
    return  this.rejectCommentField.pVal();
};

