AT.SelectorPanel.ShowDisabledCheckbox = function(messageKey)
{
    CustomCheckbox.call(this);
    this.messageKey = messageKey;
};

AT.SelectorPanel.ShowDisabledCheckbox.prototype = _.create(CustomCheckbox.prototype, {
    html: "<div class='showDisabledCheckbox'>" +
          "  <div class='labelWrapper'>" +
          "    <span class='label'></span>" +
          "  </div>" +
          "</div>",

    useUnderscoreTemplate: false,

    afterRender: function()
    {
        CustomCheckbox.prototype.afterRender.call(this);

        if (this.showLater)
            this.show();
        else if (this.hideLater)
            this.hide();

        this.$label = this.find(".label");
        disableTextSelection(this.$label[0], true);
    },

    update: function()
    {
        if (this.rendered)
        {
            CustomCheckbox.prototype.update.call(this);
            var showOrHide = messageResource.getMessage(this.checked ? "common.hide" : "common.show");
            this.$label.html(messageResource.getEscapedMessage(this.messageKey, [showOrHide]));
        }
    },

    show: function()
    {
        if (this.rendered)
        {
            CustomCheckbox.prototype.show.call(this);
        }
        else
        {
            this.showLater = true;
            this.hideLater = false;
        }
    },

    hide: function()
    {
        if (this.rendered)
        {
            CustomCheckbox.prototype.hide.call(this);
        }
        else
        {
            this.hideLater = true;
            this.showLater = false;
        }
    }
});