Ext.namespace("AT");

/**
 * @see AT.TreeNodeHelper
 *
 * Depends on:
 * <code>/js/notifications/at_tree_node_helper.js</code>
 * <code>/js/message_resources.js</code>
 *
 * @constructor
 */
AT.AccessRightsUserTreeNodeHelper = Ext.extend(AT.UserTreeNodeHelper, {

    /**
     * @see AT.AccessRightsUsersSelectorPanel.accessRight (required)
     */
    accessRight: null,

    /**
     * @see AT.TreeNodeHelper
     */
    getTooltipMessage: function (item)
    {
        var message = null;
        if ( this.tooltipMessageParams )
        {
            if( !this.hasRight( item ) )
                message = this.getSingleTooltipMessage( item, "accessRight" );
            else
                message = AT.AccessRightsUserTreeNodeHelper.superclass.getTooltipMessage.call(this, item);
        }
        return message;
    },

    /**
     * @see AT.TreeNodeHelper
     */
    isActive: function(item){
        return AT.AccessRightsUserTreeNodeHelper.superclass.isActive.call( this, item ) &&
               this.hasRight(item);
    },

    hasRight: function(item){
        return this.accessRight.isGranted( this.propertiesController.getAccessRights(item) );
    }


});