Ext.namespace("AT");

/**
 * Selector panel for the leaves list.
 *
 * Depends on:
 * <code>/js/controls/selectorControls/base_leave_types_selector_panel.js</code>
 * <code>/js/message_resources.js</code> with prefixes "common" and "leaves_selector"
 *
 * @constructor
 */
AT.ReportLeavesSelectorPanel = Ext.extend(AT.BaseLeavesSelectorPanel, {
    allItemsOptionLabelKey: "leaves_selector.options.all_items",
    customOptionLabelKey: "leaves_selector.options.custom",
    showInactiveLabelKey: "leaves_selector.show_disabled",

    labelItemNounSingularKey: "leaves_selector.label.singular",
    labelItemNounPluralKey: "leaves_selector.label.plural",
    labelDisabledMultipleKey: "common.archived_multiple",
    labelNoItemsSelectedKey: "leaves_selector.label.no_items_selected",

    customOptionValue : LeaveTypeSelectionQualifier.SELECTED,
    allItemsOptionValue : LeaveTypeSelectionQualifier.ALL,
    resetOnHide: false,

    isEmptySelection: function()
    {
        return this.isCustomOptionSelected() && AT.ReportLeavesSelectorPanel.superclass.isEmptySelection.call(this);
    }
});

Ext.reg("at_report_leaves_selector_panel", AT.ReportLeavesSelectorPanel);