function GenericAdditionalCheckboxExtension(){}

GenericAdditionalCheckboxExtension.prototype.getExtension = function(extendedClass, label){

    return {
        genericCls: "generic withCheckbox",
        _createAdditionalCheckBox : function(){
            var self = this;
            this.additionalCheckBox= new Ext.form.Checkbox({
                boxLabel: label,
                checked: this.additionalCheckBoxValue,
                handler: function(){
                    self.fireEvent("change");
                }
            });
            return this.additionalCheckBox;
        },

        getPreFooterSection: function()
        {
            return [this._createAdditionalCheckBox()];
        },

        getAdditionalCheckboxValue : function(){
            if(this.additionalCheckBox){
                return this.additionalCheckBox.getValue();
            } else {
                return this.additionalCheckBoxValue;
            }
        },

        _setInitialAdditionalCheckBoxValue : function( checked ){
            this.additionalCheckBoxInitValue =   checked;
        },

        _setAdditionalCheckboxValue : function( checked ) {
            if(this.additionalCheckBox){
                if (!this.additionalCheckBox.disabled)
                    this.additionalCheckBox.setValue(checked);
                this.additionalCheckBox.prevValue = checked;
            }
        },

        loadState: function(state)
        {
            this.additionalCheckBoxValue = state.additionalCheckBoxValue;
            this._setInitialAdditionalCheckBoxValue(state.additionalCheckBoxValue);
            extendedClass.superclass.loadState.apply(this, arguments);

        },

        resetState: function(isEnableActiveActions){
            this.additionalCheckBoxValue = this.additionalCheckBoxInitValue;
            this._setAdditionalCheckboxValue(this.additionalCheckBoxInitValue);
            extendedClass.superclass.resetState.apply(this, arguments);
        },

        setInitialValueFromCurrent: function(){
            if(this.isAlreadyShown())
            {
                this._setInitialAdditionalCheckBoxValue(this.getAdditionalCheckboxValue());
                this.setFilterFlag(this.getShowInactive());
                this.selectorTree.initializeByNodeSet(this.makeNodeSet(this.getSelection()));
                this.setInitialOptionValue( !this.isCustomOptionSelected());
                this.updateInitialTreeSet();
            }
        },

        getLabelTextTemplate: function()
        {
            var result = extendedClass.superclass.getLabelTextTemplate.apply(this, arguments);
            if (this.getAdditionalCheckboxValue() == true)
                result += " (" + label + ")";
            return result;
        }
    }
};
