function CustomerProjectSelectorDialog() {
    this.constructor = CustomerProjectSelectorDialog;
}

CustomerProjectSelectorDialog.prototype = new TreeSelectorDialog();

CustomerProjectSelectorDialog.prototype.getShowInactive = function () {
    return this.selector.getShowInactive();
};

CustomerProjectSelectorDialog.prototype._initPanel = function ( data )
{
    this.configCtr = this._configCtr ? this._configCtr : {};
    this.configCtr.isCustomersProjectsFiltered = false;
    this._addSpecificInitialPanelParams(this.configCtr);
    this.selector = new this._panelConstructor( this.configCtr );

    var self = this;
    this._resetSelectionLink.click( function () {
        self.selector.resetState(true);
        self.selector.afterResetAction();
    } );

    this._treeContainer.find(".selector-panel").remove();

    this.selector.renderOnPage( this._treeContainer[0] );
    this.selector.processFirstPanelOpen();
    this.loadStateToPanel( data );
};

CustomerProjectSelectorDialog.prototype.loadStateToPanel = function ( data )
{
    var panel = this.selector;

    var state = {
        optionValue: data.allProjectsAssigned ? panel.allItemsOptionValue : panel.customOptionValue,
        selection: new TwoLevelSelection( [], data.assignedProjectIds ),
        forceHideInactive: !this.getShowInactiveState(),
        showInactive: this.getShowInactiveState()
    };
    panel.initializeSelector( data.customerProjectList, state );
};

CustomerProjectSelectorDialog.prototype._readyStateSave = function () {
    this._switchDialogInSavingState();
    this._callBacks.saveData(
            this._dialogInfo,
            this.selector.isAllItemsOptionSelected(),
            this.selector.getSelection(false, true).getSecondLevel()
    );
};

CustomerProjectSelectorDialog.prototype._addSpecificInitialPanelParams = function( params, assignedUsersData )
{
    var self = this;
    params.onAllOptionSelected = function(){ self._dialogDiv.addClass("hideCustomOptionField")};
    params.onCustomOptionSelected = function(){self._dialogDiv.removeClass("hideCustomOptionField")};
    return params;
};
