/**
 * Represents a selection in two level selector
 * @param firstLevel selected first level entity
 * @param secondLevel selected users (users in selected groups do not include in this parameter)
 */
function TwoLevelSelection(firstLevel, secondLevel) {
    this.firstLevel = firstLevel;
    this.secondLevel = secondLevel;
}

TwoLevelSelection.prototype.getFirstLevel = function() {
    return this.firstLevel;
};

TwoLevelSelection.prototype.getSecondLevel = function() {
    return this.secondLevel;
};

TwoLevelSelection.prototype.isEmpty = function() {
    return (this.firstLevel.length == 0) && (this.secondLevel.length == 0);
};

TwoLevelSelection.emptySelection = function() {
    if (!TwoLevelSelection.EMPTY_SELECTION) {
        TwoLevelSelection.EMPTY_SELECTION = new TwoLevelSelection([], []);
    }
    return TwoLevelSelection.EMPTY_SELECTION;
};

TwoLevelSelection.FIRST_LEVEL_INDEX = 0;
TwoLevelSelection.SECOND_LEVEL_INDEX = 1;