CustomerStatusButton = function($containerEl, editable)
{
    MenuButton.call(this, $containerEl, editable);
};

CustomerStatusButton.prototype = _.create(MenuButton.prototype, {
    html: "<div class='customerStatusButton'>" +
          "  <div class='active'>" +
          "    <%-active%>" +
          "    <div class='downIcon'>&nbsp;</div>" +
          "  </div>" +
          "  <div class='archived'>" +
          "    <%-archived%>" +
          "    <div class='downIcon'>&nbsp;</div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        MenuButton.prototype.afterRender.call(this);
        this.active = false;
    },

    update: function()
    {
        this.$el.toggleClass("active", this.active);
        this.$el.toggleClass("archived", !this.active);
        this.$el.toggleClass("disabled", this.disabled);
    },

    messageKeys: function()
    {
        return {
            active: "customer.edit.status.active",
            archived: "customer.edit.status.archived"
        }
    },

    isActive: function()
    {
        return this.active;
    },

    setActive: function(isActive)
    {
        this.active = isActive;
        this.update();
    },

    getMenu: function()
    {
        var menu = CustomerStatusMenu.getInstance();
        menu.setActive(this.active);
        return menu;
    },

    _change: function(active)
    {
        if (this.active !== active)
        {
            this.active = active;
            return true;
        }
        return false;
    }
});