CustomerStatusMenu = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

CustomerStatusMenu.getInstance = function()
{
    if (!CustomerStatusMenu.instance)
        CustomerStatusMenu.instance = new CustomerStatusMenu($("body")).init();
    return CustomerStatusMenu.instance;
};

CustomerStatusMenu.prototype = _.create(DropdownTemplateView.prototype, {
    html: "<div class='dropdownContainer customerStatusMenu'>" +
          "  <div class='item activeContainer'>" +
          "    <div class='active'><%-active%></div>" +
          "  </div>" +
          "  <div class='item archivedContainer'>" +
          "    <div class='archived'><%-archived%></div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        this.findAndBindClick(".activeContainer", function(e) { stopEventPropagation(e); self._itemClick(e, true); });
        this.findAndBindClick(".archivedContainer", function(e) { stopEventPropagation(e); self._itemClick(e, false);});
    },

    update: function()
    {
        this.$el.toggleClass("active", this.active);
        this.$el.toggleClass("archived", !this.active);
    },

    showAt: function($element, positionParams, callback)
    {
        DropdownTemplateView.prototype.showAt.call(this, $element, positionParams);
        this.update();
        this.callback = callback;
    },

    messageKeys: function()
    {
        return {
            active: "customer.edit.status.active",
            archived: "customer.edit.status.archived"
        }
    },

    onHide: function()
    {
        DropdownTemplateView.prototype.onHide.call(this);
        this.callback(this.active);
    },

    isActive: function()
    {
        return this.active;
    },

    setActive: function(active)
    {
        this.active = active;
    },

    _itemClick: function(e, active)
    {
        this.active = active;
        this.hide();
    }
});