TaskManagement.EditActionButton = function($containerEl, $panel, $header, needMove, needCopy, needDelete)
{
    TemplateView.call(this, $containerEl);
    this.$panel = $panel;
    this.$header = $header;
    this.needMove = needMove;
    this.needCopy = needCopy;
    this.needDelete = needDelete;
};

TaskManagement.EditActionButton.prototype = _.create(TemplateView.prototype, {
    html: "<div class='actionButtonWrapper'>" +
          "  <div class='actionButton'>" +
          "    <div class='img'></div>" +
          "    <div class='action'><%=action%></div>" +
          "  </div>" +
          "</div>",

    updateOnInit: false,
    positionParams: {offset: "-1px -4px"},

    messageKeys: function()
    {
        return {
            action: "edit_panel.actions.title"
        }
    },

    afterRender: function()
    {
        var self = this;
        this.menu = new TaskManagement.EditActionMenu(this.$panel, this.find(".actionButton")).init();
        this.menu.setMove(this.needMove);
        this.menu.setCopy(this.needCopy);
        this.menu.setDelete(this.needDelete);
        this.menu.setEnableDeleteButton();

        this.bindClick(function()
                       {
                           self.$el.addClass('pressed');
                           self.menu.showAt(self.$el, self.$header, self.positionParams, _.bind(self._onSelect, self));
                       });
    },

    _onSelect: function()
    {
        this.hideMenu();
    },

    disableDeleteButton: function(text)
    {
        if (text)
            this.menu.setDisableDeleteButton(text);
        else
            this.menu.setEnableDeleteButton();
    },

    hideMenu: function()
    {
        this.menu.hide();
    }
});