TaskStatusButton = function($containerEl, editable)
{
    MenuButton.call(this, $containerEl, editable);
};

TaskStatusButton.prototype = _.create(MenuButton.prototype, {
    html: "<div class='taskStatusButton'>" +
          "  <div class='open'>" +
          "    <%-openLabel%>" +
          "    <div class='downIcon'>&nbsp;</div>" +
          "  </div>" +
          "  <div class='completed'>" +
          "    <%-completedLabel%>" +
          "    <div class='downIcon'>&nbsp;</div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        MenuButton.prototype.afterRender.call(this);
        this.completed = false;
    },

    update: function()
    {
        this.$el.toggleClass("completed", this.completed);
        this.$el.toggleClass("disabled", this.disabled);
        this.$el.toggleClass('editable', this.editable);
    },

    messageKeys: function()
    {
        return {
            openLabel: "customers_projects.Open",
            completedLabel: "customers_projects.completed"
        }
    },

    isCompleted: function()
    {
        return this.completed;
    },

    setCompleted: function(completed)
    {
        this.completed = completed;
        this.update();
    },
    
    getMenu: function()
    {
        var menu = TaskStatusMenu.getInstance();
        menu.setCompleted(this.completed);
        return menu;
    },

    _change: function(completed)
    {
        if (this.completed !== completed)
        {
            this.completed = completed;
            return true;
        }
        return false;
    }
});