TaskStatusMenu = function($containerEl)
{
    DropdownTemplateView.call(this, $containerEl);
};

TaskStatusMenu.getInstance = function()
{
    if (!TaskStatusMenu.instance)
        TaskStatusMenu.instance = new TaskStatusMenu($("body")).init();
    return TaskStatusMenu.instance;
};

TaskStatusMenu.prototype = _.create(DropdownTemplateView.prototype, {
    html: "<div class='dropdownContainer taskStatusMenu'>" +
          "  <div class='item openContainer'>" +
          "    <div class='open'><%-openLabel%></div>" +
          "  </div>" +
          "  <div class='item completedContainer'>" +
          "    <div class='completed'><%-completedLabel%></div>" +
          "  </div>" +
          "</div>   ",

    afterRender: function()
    {
        var self = this;
        this.findAndBindClick(".openContainer", function(e) { stopEventPropagation(e); self._itemClick(e, false); });
        this.findAndBindClick(".completedContainer", function(e) { stopEventPropagation(e); self._itemClick(e, true);});
    },

    update: function()
    {
        this.$el.toggleClass("open", !this.completed);
        this.$el.toggleClass("completed", this.completed);
    },

    resetSelection: function()
    {
        this.$el.toggleClass("open", true);
        this.$el.toggleClass("completed", true);
    },

    showAt: function($element, positionParams, callback)
    {
        DropdownTemplateView.prototype.showAt.call(this, $element, positionParams);
        this.update();
        this.callback = callback;
    },

    messageKeys: function()
    {
        return {
            openLabel: "customers_projects.Open",
            completedLabel: "customers_projects.completed"
        }
    },

    onHide: function()
    {
        DropdownTemplateView.prototype.onHide.call(this);
        this.callback(this.completed);
    },

    isCompleted: function()
    {
        return this.completed;
    },

    setCompleted: function(completed)
    {
        this.completed = completed;
    },

    _itemClick: function(e, completed)
    {
        this.completed = completed;
        this.hide();
    }
});