TypeOfWorkButton = function($containerEl, editable)
{
    TemplateView.call(this, $containerEl);
    this.editable = editable;
};

TypeOfWorkButton.prototype = _.create(MenuButton.prototype, {

    html: "<div class='typeOfWorkButton'>" +
          " <div class='value ellipsis'/>" +
          " <div class='downIcon'>&nbsp;</div>" +
          "</div>",


    afterRender: function()
    {
        MenuButton.prototype.afterRender.call(this);
        this.typeOfWorkId = TypeOfWorkMenu.BILLING_TYPE_NOT_SELECTED_VALUE;
        this.$typeLabel = this.find('.value');
    },

    update: function()
    {
        this.$el.toggleClass('notSelected', this.typeOfWorkId === TypeOfWorkMenu.BILLING_TYPE_NOT_SELECTED_VALUE);
        this.$el.toggleClass('disabled', this.disabled);
        this.$el.toggleClass('editable', this.editable);
        this.$typeLabel.text(this._makeLabelText());
    },

    _makeLabelText: function()
    {
        if (this.typeOfWorkId === TypeOfWorkMenu.BILLING_TYPE_NOT_SELECTED_VALUE)
            return messageResource.getMessage('billing_type.not_selected');
        if (this.typeOfWorkId === BillingTypeCommon.NON_BILLABLE_DEFAULT_TYPE_ID)
            return this.typeOfWorkInfo.name;

        return messageResource.getMessage((this.typeOfWorkInfo.billable) ?
                                          'billing_type.billable' : 'billing_type.non_billable') + ': ' + this.typeOfWorkInfo.name;
    },

    getTypeOfWorkId: function()
    {
        return this.typeOfWorkId;
    },

    setTypeOfWorkId: function(id)
    {
        this.typeOfWorkId = id;
        var type = BillingTypeStore.get(id);
        this.typeOfWorkInfo = {name: type.name, billable: type.billable};
        this.update();
    },

    setTypeOfWorkInfo: function(typeOfWorkInfo)
    {
        this.typeOfWorkId = (typeOfWorkInfo) ? typeOfWorkInfo.id : TypeOfWorkMenu.BILLING_TYPE_NOT_SELECTED_VALUE;
        this.typeOfWorkInfo = typeOfWorkInfo;
        this.update();
    },

    isHidden: function()
    {
        return _.isNull(this.typeOfWorkInfo);
    },

    getMenu: function()
    {
        var menu = TypeOfWorkMenu.getInstance();
        menu.setTypeOfWorkId(this.typeOfWorkId);
        return menu;
    },

    _change: function(newId)
    {
        if (this.typeOfWorkId !== newId)
        {
            this.typeOfWorkId = newId;
            return true;
        }
        return false;
    }
});