Ext.namespace("AT");

AT.CustomerProjectSelectorTwoGenericOptionsPanel = Ext.extend(AT.CustomerProjectSelectorPanel, {

    allActiveItemsOptionValue: "all_active",
    genericCls: "generic twoGenericOptions",

    allActiveItemsOptionLabelKeyNotFiltered: "projects_customers_selector.all_active_projects_customers",
    allActiveItemsOptionLabelKeyFiltered: "projects_customers_selector.all_active_projects_customers_filtered",
    resetOnHide: false,

    createGenericOptions: function()
    {
        AT.CustomerProjectSelectorTwoGenericOptionsPanel.superclass.createGenericOptions.call(this);
        this.genericOptions.push(
            new Ext.form.Radio({
                                   boxLabel: this.getAllActiveItemsMessage(),
                                   name: this.realOptionsName,
                                   inputValue: this.allActiveItemsOptionValue
                               })
        );
    },

    getAllActiveItemsMessage: function()
    {
        return messageResource.getEscapedMessage(
            this.isCustomersProjectsFiltered ? this.allActiveItemsOptionLabelKeyFiltered :
            this.allActiveItemsOptionLabelKeyNotFiltered);
    },

    getOptionValueByStateValue: function(stateValue) {
        switch(stateValue)
        {
            case CoarseSelection.ALL:
                return this.allItemsOptionValue;
            case CoarseSelection.SPECIFIC:
                return this.customOptionValue;
            default:
                return this.allActiveItemsOptionValue;
        }
    },

    getStateValueByOptionValue: function(optionValue) {
        switch(optionValue)
        {
            case this.allItemsOptionValue:
                return CoarseSelection.ALL;
            case this.customOptionValue:
                return CoarseSelection.SPECIFIC;
            default:
                return CoarseSelection.ALL_ACTIVE;
        }
    }
});