CPTManagement.Store = {
    customers: [],
    projects: [],
    tasks: [],

    addCustomer: function(customer)
    {
        this.customers[customer.id] = customer;
    },

    addProject: function(project)
    {
        this.projects[project.id] = project;
    },

    addTask: function(task)
    {
        this.tasks[task.id] = task;
    },

    getCustomer: function(id)
    {
        return this.customers[id]
    },

    getProject: function(id)
    {
        return this.projects[id]
    },

    getTask: function(id)
    {
        return this.tasks[id]
    },

    getCustomers: function()
    {
        return this.customers
    },

    getProjects: function()
    {
        return this.projects
    },

    getTasks: function()
    {
        return this.tasks
    }
};

function CPTManagementEntity(id,
                             name)
{
    this.id = id;
    this.name = name;
    this.children = [];
}

CPTManagementEntity.prototype = {
    addChild: function(id)
    {
        this.children.push(id);
    },

    getChildren: function()
    {
        return this.children;
    },

    isContainChild: function(id)
    {
        return isArrayContains(this.children, id);
    },

    hasChild: function()
    {
        return this.children.length > 0;
    },

    getChildCount: function()
    {
        return this.children.length;
    }
};

function CustomerManagementEntity(id,
                                  name,
                                  isActive,
                                  taskCount,
                                  hiddenProjectCount)
{
    CPTManagementEntity.apply(this, arguments);
    this.isActive = isActive;
    this.taskCount = taskCount;
    this.hiddenProjectCount = hiddenProjectCount;
}

CustomerManagementEntity.prototype = _.create(CPTManagementEntity.prototype);

function EditDialogCustomerManagementEntity(id,
                                            name,
                                            isActive,
                                            taskCount,
                                            hiddenProjectCount,
                                            visibleProjectCount)
{
    CustomerManagementEntity.apply(this, arguments);
    this.visibleProjectCount = visibleProjectCount;
}

EditDialogCustomerManagementEntity.prototype = _.create(CustomerManagementEntity.prototype, {
    getChildCount: function()
    {
        return this.visibleProjectCount;
    }
});

function ProjectManagementEntity(id,
                                 name,
                                 isActive,
                                 taskCount,
                                 customerId)
{
    CPTManagementEntity.apply(this, arguments);
    this.customerId = customerId;
}

ProjectManagementEntity.prototype = _.create(CPTManagementEntity.prototype);

function TaskManagementEntity(id,
                              name,
                              projectId,
                              customerId)
{
    CPTManagementEntity.apply(this, arguments);
    this.projectId = projectId;
    this.customerId = customerId;
}

TaskManagementEntity.prototype = _.create(CPTManagementEntity.prototype);