CPTManagement.DeleteConfirmationDialog.BlockedList = function($containerEl, entities)
{
    DropdownTemplateView.call(this, $containerEl);
    this.entities = entities;
};

CPTManagement.DeleteConfirmationDialog.BlockedList.prototype = _.create(DropdownTemplateView.prototype, {
    html: "<div class='pointerWrapper'>" +
          "  <div class='deleteConfirmationDialogBlockedListScrollWrapper'>" +
          "    <div class='deleteConfirmationDialogBlockedList'></div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        this.$itemsContainer = this.find(".deleteConfirmationDialogBlockedList");
        _.each(this.entities, function(entity)
        {
            new CPTManagement.DeleteConfirmationDialog.BlockedListItem(this.$itemsContainer, this.getEntitySubtitle(entity), this.getEntityTitle(entity)).init();
        }, this);

        _.each(this.additionListItems(), function(entity)
        {
            new CPTManagement.DeleteConfirmationDialog.MoreElementsBlockedListItem(this.$itemsContainer, entity.title).init();
        }, this);

        this.verticalScroll = ScrollUtils.addVerticalScroll(this.find(".deleteConfirmationDialogBlockedListScrollWrapper"), {isFaded: false});
    },

    onShow: function()
    {
        DropdownTemplateView.prototype.onShow.call(this);
        ScrollUtils.refreshCustomScroll(this.verticalScroll);
    },

    additionListItems: function()
    {
        return [];
    },

    getEntitySubtitle: function(entity)
    {
        // Abstract
    },

    getEntityTitle: function(entity)
    {
        // Abstract
    }
});