CPTManagement.DeleteCustomerPopupConfirmationDialog = function(config)
{
    CPTManagement.DeleteConfirmationDialog.call(this, config);
    this.visibleProjectCount = config.visibleProjectCount;
    this.isCustomerActive = config.isCustomerActive;
};

CPTManagement.DeleteCustomerPopupConfirmationDialog.prototype = _.create(CPTManagement.DeleteConfirmationDialog.prototype, {
    titleText: function()
    {
        var withProjects = "";
        if (this.visibleProjectCount > 0)
        {
            var projectsCountText = messageResource.getMessage(this.isCustomerActive ? "common.active_multiple" : "common.archived_multiple",
                                                               [this.visibleProjectCount]);
            withProjects = messageResource.getMessage("delete.confirm.dialog.cp.popup.along_with_projects", [projectsCountText]);
        }
        return messageResource.getEscapedMessage("delete.confirm.dialog.cp.popup.customer", [this.entityName, withProjects]);
    },

    firstOrangeSentence: function()
    {
        return messageResource.getMessage("delete.confirm.dialog.cp.popup.first_orange_sentence", [messageResource.getMessage("common.Customer")]);
    },

    secondOrangeSentence: function()
    {
        return messageResource.getMessage(this.hasTimeTrack() ?
                                          "delete.confirm.dialog.cp.second_orange_sentence.please_confirm_actions" :
                                          "delete.confirm.dialog.cp.second_orange_sentence.please_confirm");
    },

    removeEntitiesPointText: function()
    {
        var pronoun = messageResource.getMessage("delete.confirm.dialog.their");
        return messageResource.getMessage("delete.confirm.dialog.cp.remove_entities_point_text.customers_and_projects",
                                          [messageResource.getMessage("common.customer"), pronoun]);
    },

    removeTimeTrackPointText: function()
    {
        return messageResource.getMessage("delete.confirm.dialog.cp.remove_time_track_point_text")
    },

    deleteButtonText: function()
    {
        if (this.hasTimeTrack())
            return messageResource.getMessage("delete.confirm.dialog.delete_task_with_entries");
        else
            return messageResource.getMessage("delete.confirm.dialog.cp.delete_button_text.no_tt")
    }
});