 CPTManagement.DeleteTasksConfirmationDialog = function(config)
{
    CPTManagement.DeleteConfirmationDialog.call(this, config);
    this.otherBlockedTaskCount = config.otherBlockedTaskCount;
};

CPTManagement.DeleteTasksConfirmationDialog.prototype = _.create(CPTManagement.DeleteConfirmationDialog.prototype, {
    createBlockedEntitiesList: function()
    {
        return new CPTManagement.DeleteConfirmationDialog.BlockedTasksList($("body"), this.entitiesBlocked, this.otherBlockedTaskCount).init();
    },

    titleText: function()
    {
        if (this.allBlocked())
        {
            return messageResource.getMessage("delete.confirm.dialog.task.all_blocked.title",
                                              [messageResource.getEscapedMessage(this.entitiesToDeleteCount > 1 ? "common.tasks" : "common.task")]);
        }
        else
        {
            if (this.entitiesToDeleteCount > 1)
                return messageResource.getEscapedMessage("delete.confirm.dialog.about_to_delete.more_one", [this.entitiesToDeleteCount]);
            else
                return messageResource.getEscapedMessage("delete.confirm.dialog.about_to_delete.one_task");
        }
    },

    firstOrangeSentence: function()
    {
        if (this.allBlocked())
        {
            return this.blockedWarningOtherText();
        }
        else
        {
            if (this.hasTimeTrack())
            {
                return messageResource.getMessage("delete.confirm.dialog.about_to_delete.warning");
            }
            else
            {
                return messageResource.getMessage("delete.confirm.dialog.about_to_delete", [this._getTaskOrTasksText()]);
            }
        }
    },

    secondOrangeSentence: function()
    {
        if (this.allBlocked())
        {
            return "";
        }
        else
        {
            if (this.hasTimeTrack())
                return messageResource.getMessage("delete.confirm.dialog.about_to_delete.confirm");
            else
                return messageResource.getMessage("delete.confirm.dialog.about_to_delete.warning");
        }
    },

    removeEntitiesPointText: function()
    {
        return messageResource.getMessage("delete.confirm.dialog.about_remove_task", [this._getTaskOrTasksText()]);
    },

    removeTimeTrackPointText: function()
    {
        return messageResource.getMessage("delete.confirm.dialog.about_remove_time_track", [this._getTaskOrTasksText()]);
    },

    blockedWarningLinkText: function()
    {
        return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_link_text");
    },

    blockedWarningOtherText: function()
    {
        if (this.entitiesBlockedDueToLockedTimeCount > 0 && this.entitiesBlockedDueToUnavailableToModifyTimeTrackCount == 0)
        {
            if (this.entitiesBlockedDueToLockedTimeCount == 1)
                return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_other_text.one_locked");
            return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_other_text.locked");
        }
        else if (this.entitiesBlockedDueToLockedTimeCount == 0 && this.entitiesBlockedDueToUnavailableToModifyTimeTrackCount > 0)
        {
            if (this.entitiesBlockedDueToUnavailableToModifyTimeTrackCount == 1)
                return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_other_text.cannot_modify_one_task");
            return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_other_text.cannot_modify");
        }
        else if (this.entitiesBlockedDueToLockedTimeCount > 0 && this.entitiesBlockedDueToUnavailableToModifyTimeTrackCount > 0)
        {
            if (this.entitiesBlockedCount == 1)
                return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_other_text.locked_and_cannot_modify_one_task");
            return messageResource.getMessage("delete.confirm.dialog.task.blocked_warning_other_text.locked_and_cannot_modify");
        }
    },

    deleteButtonText: function()
    {
        if (this.entitiesWithOtherUsersTimeTrackCount > 0 || this.entitiesWithManagerTimeTrackCount > 0)
        {
            return messageResource.getMessage("delete.confirm.dialog.delete_task_with_entries");
        }
        else
        {
            return messageResource.getMessage("delete.confirm.dialog.delete_task_permanently");
        }
    },

    _getTaskOrTasksText: function()
    {
        return messageResource.getMessage(this.entitiesToDeleteCount - this.entitiesBlockedCount == 1 ?
                                          "delete.confirm.dialog.this_task" :
                                          "delete.confirm.dialog.these_tasks");
    }
});
