function CreateProjectLightbox(){}

CreateProjectLightbox.prototype = new ProjectLightbox();
CreateProjectLightbox.CREATE_POPUP_DEFAULT_PROJECT_NAME = "";
CreateProjectLightbox.TASK_ERROR = "taskError";
CreateProjectLightbox.prototype.close_tab_confirmation_message_key = "project.add.js.close_tab_confirmation";

CreateProjectLightbox.prototype.init = function (customersInfo, customerId, billingTypes, defaultBillingTypeId,
                                                  weekStartDay, scheduleCalculator, estEnabled,
                                                 isEnabledPAS, projectsWithTasksExist, successHandler, failureHandler)
{
    this.cancel_confirmation_message_key ="project.add.js.cancel_confirmation";

    ProjectLightbox.prototype.init.call(this, customersInfo, customerId, true, isEnabledPAS, successHandler);

    this._popupEl.addClass("createMode");
    this.billingTypes = billingTypes;
    this.defaultBillingTypeId = defaultBillingTypeId;
    this.projectsWithTasksExist = projectsWithTasksExist;
    this.estEnabled = estEnabled;

    this.weekStartDay = weekStartDay;
    this.scheduleCalculator = scheduleCalculator;
    
    this.failureHandler = failureHandler;

    var self = this;
    self.setTitle(messageResource.getMessage("project.add.page.title"));
    self.setCommitButtonTitle(messageResource.getMessage("project.add.create_btn_title"),
                              messageResource.getMessage("project.add.default_create_btn_title" ),  17);
    this.initCreateTasksComponent();

    this.initPlaceholders();
    this.setSuccessCallback(
            function( projectData, teamProject,tasks ) {
                self._makeCreateProjectRequest( projectData, teamProject,tasks );
            }
    );

    $( ".tasksBlockHeaderWrapper" ).click( function ()
                                                  {
                                                      if (!sectionsStateController.isSectionHidden("createTasksBlock")){
                                                          var constantScroll = 140;
                                                          var scrollPosition = Math.max(self._innerContentEl.scrollTop(), constantScroll);
                                                          if (scrollPosition == constantScroll)
                                                              self._innerContentEl.animate( {scrollTop: scrollPosition}, 'fast' );
                                                      }
                                                      else{
                                                          saveOnPageDescription( true );
                                                      }
                                                  } );
    sectionsStateController.showOrHideBlock("createTasksBlock");
    return this;
};

CreateProjectLightbox.prototype.initCreateTasksComponent = function()
{
    var defaultRowsNumber = 3;
    var self = this;

    this.createTasksComponent = new CreateNewTasksComponent().init( this.popupId, this.billingTypes,
                                                                    this.defaultBillingTypeId, false,
                                                                    this.weekStartDay, this.scheduleCalculator,
                                                                    this.estEnabled, this.projectsWithTasksExist,
                                                                    defaultRowsNumber, true,
                                                                    self.changesCallback, this._validateCallback,
                                                                    this._innerContentEl );
};

CreateProjectLightbox.prototype.getDataToCommit = function()
{
    var self = this;
    var tasks = this.createTasksComponent.getTasks();
    return [{
             customerId:self.getCustomerId(),
             customerName: self.getCustomerName(),
             name: self.getProjectName(),
             description: self.getDescription()},
             self.getTeamProject(), tasks]
};
CreateProjectLightbox.prototype._customValidate = function() {
    this.errors[CreateProjectLightbox.TASK_ERROR] = !this.createTasksComponent.isEmpty() &&
                                                    !this.createTasksComponent.validate();

    return !this.errors[CreateProjectLightbox.TASK_ERROR];
};

CreateProjectLightbox.prototype._customValidateScroll = function(){
    this.scrollToFirstTaskWithError();
};

CreateProjectLightbox.prototype.scrollToTasksTable = function() {
    this.scrollToSection( $(this.getElementBySubId("importTasksContainer")) );
};

CreateProjectLightbox.prototype.scrollToFirstTaskWithError = function() {
    var taskWithErr = this._popupEl.find(".createTasksTable .nameCell .error");
    sectionsStateController.showBlock("createTasksBlock");
    if ( taskWithErr.get(0) )
        this.scrollToSection( taskWithErr );
    else
        this.scrollToTasksTable();
};

CreateProjectLightbox.prototype._makeCreateProjectRequest = function ( projectData, projectTeam, tasks ) {
    var self = this;
    this.disableUserInputWhileSaving();

    self.customSuccessCommitCallback = function ( result )
    {
        var self = this;

        if ( result.taskErrorCode)
        {
            self.createTasksComponent.handleTaskError( result.taskError, result.taskErrorRowNumber );
            self.scrollToFirstTaskWithError();
        }
        else if ( result.billingTypeError) {
            self.createTasksComponent.handleBillingTypeError( result.billingTypeError, result.billingTypes ? result.billingTypes.list : null );
            self.scrollToFirstTaskWithError();
        }

    };

    makeRpcCall( "ProjectInfoService.createProject", [projectData, projectTeam, tasks],
                 function(result){return self.successCommitCallback(result);},
                 function(jqXHR, textStatus, errorThrown) { return self.failureCommitCallback(jqXHR, textStatus, errorThrown);});
};

CreateProjectLightbox.prototype.failureCommitCallback = function(jqXHR, textStatus, errorThrown)
{

    if (ProjectLightbox.prototype.failureCommitCallback.call(this, jqXHR, textStatus, errorThrown))
        return true;

    return this.failureHandler(jqXHR, textStatus, errorThrown);
};

CreateProjectLightbox.prototype.show = function()
{
    ProjectLightbox.prototype.show.call( this );
    setFocusIntoFieldWithPlaceholder( this.projectNameField );
};

CreateProjectLightbox.prototype.hide = function()
{
    this.createTasksComponent.hideDescriptionPopup();
    this.createTasksComponent.restoreGetOnPageDescriptionFunction();
    ProjectLightbox.prototype.hide.call( this );
};

CreateProjectLightbox.prototype.commit = function()
{
    if ( this.createTasksComponent.hideDescriptionPopup( true ) )
        ProjectLightbox.prototype.commit.call( this );
};




