/*
 * Variables are needed to initialize messages on the page, because of hierarchy levels from settings are needed for this
 * initializing.
*/
var EC_EDIT_DESCRIPTION_POPUP_CAPTION;
var EC_MODIFICATIONS_NOT_SAVED_MESSAGE;
var EC_TIMEOUT_DESCRIPTION_SAVING_MESSAGE;
var EC_TIMEOUT_DESCRIPTION_LOADING_MESSAGE;
var EC_ERROR_DESCRIPTION_SAVING_MESSAGE;
var EC_ERROR_DESCRIPTION_LOADING_MESSAGE;
var EC_TOO_LONG_DESCRIPTION_MESSAGE;

function EditCommentUtil() {}

EditCommentUtil.EDIT_DESCRIPTION_POPUP_CAPTION = EC_EDIT_DESCRIPTION_POPUP_CAPTION;

EditCommentUtil.Messages = new Function();

EditCommentUtil.Messages.MODIFICATIONS_NOT_SAVED     = EC_MODIFICATIONS_NOT_SAVED_MESSAGE;
EditCommentUtil.Messages.TIMEOUT_DESCRIPTION_SAVING  = EC_TIMEOUT_DESCRIPTION_SAVING_MESSAGE;
EditCommentUtil.Messages.TIMEOUT_DESCRIPTION_LOADING = EC_TIMEOUT_DESCRIPTION_LOADING_MESSAGE;
EditCommentUtil.Messages.ERROR_DESCRIPTION_SAVING    = EC_ERROR_DESCRIPTION_SAVING_MESSAGE;
EditCommentUtil.Messages.ERROR_DESCRIPTION_LOADING   = EC_ERROR_DESCRIPTION_LOADING_MESSAGE;
EditCommentUtil.Messages.TOO_LONG_DESCRIPTION        = EC_TOO_LONG_DESCRIPTION_MESSAGE;


EditCommentUtil.checkServiceAvailable = function () {
    if (!jsonrpc.TaskCommentService) {
        /* service is unavailable, most likely we've been logged out */
        document.location.reload();
        return false;
    }

    return true;
}

EditCommentUtil.doLoadComment = function (taskId, timestamp, commentLoadedHandler, errorHandler) {
    try {
        if (!isRpcReady( [ 'TaskCommentService.getTimeCommentRecord' ] )) {
            var func = function() { EditCommentUtil.doLoadComment(taskId, timestamp, commentLoadedHandler, errorHandler); };
            window.setTimeout(func, 200);
            return;
        }

        if (!EditCommentUtil.checkServiceAvailable())
            return;

        var reqId = jsonrpc.TaskCommentService.getTimeCommentRecord(commentLoadedHandler, taskId, timestamp);
        if (editDescriptionState) editDescriptionState.setRequestId(reqId);
    } catch (e) {
        errorHandler(e);
    }
}

EditCommentUtil.doSaveComment = function (taskId, timestamp, comment, commentSavedHandler, errorHandler) {
    try {
        if (!isRpcReady( [ 'TaskCommentService.setComment' ] )) {
            var func = function() { EditCommentUtil.doSaveComment(taskId, timestamp, comment, commentSavedHandler, errorHandler); };
            window.setTimeout(func, 200);
            return;
        }

        if (!EditCommentUtil.checkServiceAvailable())
            return;

        var reqId = jsonrpc.TaskCommentService.setComment(commentSavedHandler, taskId, timestamp, comment);
        if (editDescriptionState) editDescriptionState.setRequestId(reqId);
    } catch (e) {
        errorHandler(e);
    }
}
