function AddGroupRenderer() {}

/**
 * @param config.addGroupTableId id for add group table
 * @param config.inputId id for group name input
 * @param config.buttonId id for add group button
 * @param config.spinnerId id for spinner placeholder
 * @param config.imageCellClassName class name for add group image cell
 * @param config.inputCellClassName class name for group name input cell
 * @param config.buttonCellClassName class name for add group button cell
 * @param config.spinnerCellClassName class name for spinner placeholder cell
 */
AddGroupRenderer.prototype.init = function(config)
{
    this.addGroupTableId = config.addGroupTableId;
    this.inputId = config.inputId;
    this.buttonId = config.buttonId;
    this.spinnerId = config.spinnerId;
    this.imageCellClassName = config.imageCellClassName;
    this.inputCellClassName = config.inputCellClassName;
    this.buttonCellClassName = config.buttonCellClassName;
    this.spinnerCellClassName = config.spinnerCellClassName;

    return this;
};

AddGroupRenderer.prototype.buildImageCell = function(tableTr)
{
    var imageTd = document.createElement('td');
    imageTd.className = this.imageCellClassName;
    var image = document.createElement('img');
    image.src = atDefImgPath('user_group_lightbox/add-group-icon.png');
    imageTd.appendChild(image);
    tableTr.appendChild(imageTd);
};

AddGroupRenderer.prototype.buildInputCell = function(tableTr)
{
    var inputTd = document.createElement('td');
    inputTd.className = this.inputCellClassName;
    var input = document.createElement('input');
    input.type = 'text';
    input.maxLength = '40';
    input.className = 'text';
    input.id = this.inputId;
    inputTd.appendChild(input);
    tableTr.appendChild(inputTd);
};

AddGroupRenderer.prototype.buildButtonCell = function(tableTr)
{
    var buttonTd = document.createElement('td');
    buttonTd.className = this.buttonCellClassName;
    var button = document.createElement('button');
    button.id = this.buttonId;
    button.innerHTML = messageResource.getMessage('group_management.add_button_caption');
    buttonTd.appendChild(button);
    tableTr.appendChild(buttonTd);
};

AddGroupRenderer.prototype.buildSpinnerCell = function(tableTr)
{
    var spinnerTd = document.createElement('td');
    spinnerTd.className = this.spinnerCellClassName;
    spinnerTd.id = this.spinnerId;
    tableTr.appendChild(spinnerTd);
};

AddGroupRenderer.prototype.buildCells = function(tableTr)
{
    // Abstract
};

AddGroupRenderer.prototype.generateContent = function()
{
    var table = document.createElement('table');
    table.width = '100%';
    table.cellspacing = '0';
    table.cellpadding = '0';
    table.id = this.addGroupTableId;

    var tr = document.createElement('tr');

    this.buildCells(tr);

    table.appendChild(tr);
    return table;
};
