function AddTimeZoneGroupController() {}

AddTimeZoneGroupController.prototype = new AddGroupController();

AddTimeZoneGroupController.prototype.init = function(config)
{
    AddGroupController.prototype.init.call(this, config);
    this.selectorId = config.addGroupSelectorId;
    this.editStateClassName = config.editStateClassName;

    return this;
};

AddTimeZoneGroupController.prototype.initAfterShowing = function(controller)
{
    AddGroupController.prototype.initAfterShowing.call(this, controller);

    var self = this;
    this.citySelector = new TimeZonesSelector().init(
            this.selectorId,
            null,
            function(data) { self.cityChanged(data, controller); },
            messageResource.getMessage('group_management.add_time_zone_group.empty_selector_text'),
            true,
            "addTimeZoneGroupSearch"
    );
};

AddTimeZoneGroupController.prototype.cityChanged = function(data, controller)
{
    this.cityData = data;
    this.changeStateIfNeeded(controller);
};

AddTimeZoneGroupController.prototype.resetRowIntoDefaultState = function()
{
    this.citySelector.resetToInit();
    this.cityData = null;
    AddGroupController.prototype.resetRowIntoDefaultState.call(this);
};

AddTimeZoneGroupController.prototype.changeStateIfNeeded = function(controller)
{
    if (this.cityData == null)
    {
        removeClass(this.newGroupInputCell, this.editStateClassName);
    }
    else
    {
        addClass(this.newGroupInputCell, this.editStateClassName);
        if (this.emptyFieldController.isEmpty())
        {
            this.emptyFieldController.hideGrayText();
            this.newGroupInput.value = this.cityData.name.substr(0,40);
        }
    }
    AddGroupController.prototype.changeStateIfNeeded.call(this, controller);
};

AddTimeZoneGroupController.prototype.getNewGroupData = function()
{
    return {
        id: -1,
        name: this.newGroupInput.value.trim(),
        cityPlaceId: this.cityData.placeId,
        cityName: this.cityData.name,
        timeZoneId: this.cityData.timeZoneId,
        rawOffset: this.cityData.rawOffset,
        currentTime: this.cityData.currentTime
    }
};

AddTimeZoneGroupController.prototype.getNewGroupFieldEmptyCaption = function()
{
    return messageResource.getMessage("group_management.new_group_name");
};