function AddTimeZoneGroupRenderer() {}

AddTimeZoneGroupRenderer.prototype = new AddGroupRenderer();

/**
 * @param config.selectorCellClassName class name for city selector cell
 * @param config.selectorId id for city selector div
 * @param config.timeZoneImageCellClassName class name for cell with time zone image
 */
AddTimeZoneGroupRenderer.prototype.init = function(config)
{
    AddGroupRenderer.prototype.init.call(this, config);
    this.selectorCellClassName = config.selectorCellClassName;
    this.selectorId = config.selectorId;
    this.timeZoneImageCellClassName = config.timeZoneImageCellClassName;
    return this;
};

AddTimeZoneGroupRenderer.prototype.buildCitySelectorCell = function(tableTr)
{
    var selectorTd = document.createElement('td');
    selectorTd.className = this.selectorCellClassName;
    var selectorDiv = document.createElement('div');
    selectorDiv.id = this.selectorId;
    selectorTd.appendChild(selectorDiv);
    tableTr.appendChild(selectorTd);
};

AddTimeZoneGroupRenderer.prototype.buildTimeZoneImageCell = function(tableTr)
{
    var imageTd = document.createElement('td');
    imageTd.className = this.timeZoneImageCellClassName;
    var image = document.createElement('img');
    image.src = atDefImgPath('user_group_lightbox/time-zone.png');
    imageTd.appendChild(image);
    tableTr.appendChild(imageTd);
};

AddTimeZoneGroupRenderer.prototype.buildCells = function(tableTr)
{
    this.buildImageCell(tableTr);
    this.buildCitySelectorCell(tableTr);
    this.buildTimeZoneImageCell(tableTr);
    this.buildInputCell(tableTr);
    this.buildButtonCell(tableTr);
    this.buildSpinnerCell(tableTr);
};
