function UserGroupRenderer() {}

UserGroupRenderer.prototype = new GroupRenderer();

UserGroupRenderer.prototype.buildFolderImgCell = function(group) {
    var folderImgTd = document.createElement("td");
    folderImgTd.className = this.folderImgClassName;
    var folderImg = document.createElement("img");
    if (this.validatorGroupStrategy.isNullGroup(group)) {
        folderImg.src = atDefImgPath("user_group_lightbox/no-group-icon.png");
    } else {
        folderImg.src = atDefImgPath("user_group_lightbox/group-folder-icon.png");
    }
    folderImgTd.appendChild(folderImg);

    return folderImgTd;
};

/**
 * Build columns for group row
 */
UserGroupRenderer.prototype.fillTable = function(table, group) {
    var tr = document.createElement('tr');
    tr.appendChild(this.buildFolderImgCell(group));
    tr.appendChild(this.buildNameCell(group));
    tr.appendChild(this.buildCountCell(group));
    tr.appendChild(this.buildDeleteCell(group));
    tr.appendChild(this.buildConfirmDeleteCell(group));
    tr.appendChild(this.buildWaitingAnimationCell(group));
    table.appendChild(tr);
};

UserGroupRenderer.prototype.generateDeleteConfirmMessage = function()
{
    return messageResource.getEscapedMessage("group_management.confirm_delete.message.part_1.user_groups") +
           " " + messageResource.getMessage("group_management.confirm_delete.message.part_2.user_groups");
};