function ApproverNodeRenderer( tree, selectorFilter, selectionHelper )
{
    SimpleCheckboxNodeRenderer.call(this, tree, selectorFilter, selectionHelper);
}

ApproverNodeRenderer.prototype = _.create(SimpleCheckboxNodeRenderer.prototype);

ApproverNodeRenderer.prototype.generateLabel = function ( treeNode, labelEl )
{
    var user = treeNode.getValue();

    var hlFirstName = user.firstName ;
    var hlLastName =  user.lastName ;

    labelEl.innerHTML = UserNameFormat.formatLFM( escapeHtmlSymbols( hlFirstName ), escapeHtmlSymbols( hlLastName ), escapeHtmlSymbols( user.middleInitial ) );

    labelEl.title = UserNameFormat.formatLFM(hlFirstName, hlLastName, user.middleInitial);
};

ApproverNodeRenderer.prototype.appendAdditionalElements = function ( targetEl, treeNode )
{
    var self = this;

    var warningDiv = document.createElement( "div" );
    warningDiv.className = "canManageAllUsersWarning";

    var tooltip = $("#approverManagesAllUsersTooltip");
    var approver = treeNode.getValue();
    var approverName = UserNameFormat.formatFML(approver.firstName, approver.lastName, approver.middleInitial);

    $(warningDiv).hover(
        function (e) {
            var approverSelected = $(warningDiv).closest("div.node").hasClass("selected");
            var tooltipText = messageResource.getEscapedMessage( approverSelected ?
                                                                "user_list.approver_manages_all_users.tooltip.text" :
                                                                "user_list.approver__no_longer_manages_all_users.tooltip.text",
                                                                [approverName]);

            tooltip.html(tooltipText);
            tooltip.zIndex($(warningDiv).closest("div.ui-dialog.approversDialog").zIndex()+1);
            self.showNodeTooltip(tooltip, e);
        },
        function () {
            self.hideNodeTooltip(tooltip);
        }
    );

    targetEl.appendChild( warningDiv );
};

ApproverNodeRenderer.prototype.getNodeClasses = function ( treeNode )
{
    var classes = SimpleCheckboxNodeRenderer.prototype.getNodeClasses.call(this, treeNode);
    if (treeNode.getValue().canManageAllUsers)
    {
        classes.push("canManageAllUsers");
    }
    return classes;
};