CertainUserFilter = function ( rootNode  ){
    TreeFilter.call(this);
    this._rootNode =  rootNode;
};

CertainUserFilter.prototype = _.create(TreeFilter.prototype);

CertainUserFilter.prototype.setUserIdToHide = function ( userId ){

  this._userIdToHide = userId;

};

CertainUserFilter.prototype.doFilter = function()
{
    var result = new TreeNodeSet();

    var node = this.findNodeWithId( this._rootNode,  this._userIdToHide );

    if( node )
        result.add( node );

    return result;
};

CertainUserFilter.prototype.findNodeWithId = function ( node, userIdToHide )
{
    if( node.level >0 && node.value.id === userIdToHide )
        return node;

    var children = node.getChildren();

    for( var i = 0; i < children.length; i++ )
    {
        var child = children[i];
        var found = this.findNodeWithId( child, userIdToHide );

        if( found )
            return found;
    }

    return false;
};

//todo this here due-to high cost of restructuring classes that are reused
CertainUserFilter.prototype.containsTokens = function (){
       return false;
};


