function DisabledNodesParentNodeRenderer(tree, selectorFilter, selectionHelper)
{
    SimpleCheckboxNodeRenderer.call(this, tree, selectorFilter, selectionHelper);
}

DisabledNodesParentNodeRenderer.prototype = _.create(SimpleCheckboxNodeRenderer.prototype, {
    generateLabel: function(treeNode, labelEl)
    {
        var text = messageResource.getMessage(this.labelMessageKey(), [this.labelCounterValue(treeNode)]);
        labelEl.innerHTML = escapeHtmlSymbols(text);
        labelEl.title = text;
    },

    labelMessageKey: function()
    {
        // Abstract
    },

    labelCounterValue: function(treeNode)
    {
        if (this.tree.hasActiveFilter())
        {
            var result = 0;
            _.each(treeNode.getChildren(), function(childNode)
            {
                if (this.tree.doesMatchFilterCriteria(childNode) || this.tree.doesContainChildrenMatchingFilterCriteria(childNode))
                    result++;
            }, this);
            return result;
        }
        else
        {
            return treeNode.getChildren().length;
        }
    },

    getNodeClasses: function(treeNode)
    {
        var classes = SimpleCheckboxNodeRenderer.prototype.getNodeClasses.call(this, treeNode);
        classes.push("disabledNodesParent");
        if (this.tree.hasActiveFilter() && !this.tree.doesContainChildrenMatchingFilterCriteria(treeNode))
            classes.push("emptyDisabledNodesParent");
        return classes;
    }
});