function HierarchySelectorNodeRenderer( tree, selectorFilter )
{
    TriStateCheckboxTreeNodeRenderer.call(this, tree);
    this.selectorFilter = selectorFilter;
    this.disabledClassName = "disabledNode";
}

HierarchySelectorNodeRenderer.prototype = _.create(TriStateCheckboxTreeNodeRenderer.prototype);

HierarchySelectorNodeRenderer.prototype.updateUI = function( treeNode )
{
    TriStateCheckboxTreeNodeRenderer.prototype.updateUI.call( this, treeNode );

    var uiObject = this.tree.getUIObjectForNode(treeNode);
    var shouldUpdateLabel = false;
    if( this.selectorFilter.containsTokens( treeNode ) )
    {
        shouldUpdateLabel = true;
        uiObject.hasHighlight = true;
    }
    else if( uiObject.hasHighlight )
    {
        shouldUpdateLabel = true;
        delete uiObject.hasHighlight;
    }
    else if (treeNode instanceof DisabledNodesParentTreeNode)
    {
        shouldUpdateLabel = true;
    }

    if (shouldUpdateLabel)
        this.updateLabel( treeNode );
};

HierarchySelectorNodeRenderer.prototype.getNodeClasses = function ( treeNode )
{
    var classes = TriStateCheckboxTreeNodeRenderer.prototype.getNodeClasses.call(this, treeNode);
    if (this.isNeedToPushDisabledClass(treeNode))
    {
        classes.push(this.getDisabledClassName());
    }
    if ( treeNode.children.length === 0 && treeNode.level === 1)
    {
        classes.push('childlessNode');
    }
    return classes;
};

HierarchySelectorNodeRenderer.prototype.isNeedToPushDisabledClass = function(treeNode)
{
    return false;
};

HierarchySelectorNodeRenderer.prototype.getDisabledClassName = function()
{
    return this.disabledClassName;
};

HierarchySelectorNodeRenderer.prototype.getTitle = function(entity) {
    //abstract
};
