// on child node selected ParentNodesAutoSelectedSelectionController checks for all it's parent nodes
// if all their child nodes are selected, and if true, it sets parent node to selected state
// (although user didn't select parent node directly).
// TriStateSelectionController would set all parents nodes to intermediate state in such case.
function ParentNodesAutoSelectedSelectionController(tree)
{
    TriStateSelectionController.call(this, tree);
}

ParentNodesAutoSelectedSelectionController.prototype = _.create(TriStateSelectionController.prototype);

ParentNodesAutoSelectedSelectionController.prototype.updateParentNodeStateOnSubtreeSelected = function (parentNode)
{
    var children = parentNode.getChildren();
    var allChildrenSelected = true;
    for ( var i=0; i < children.length; i++ )
        if ( !this.isSelected(children[i]))
        {
            allChildrenSelected = false;
            break;
        }

    if (allChildrenSelected)
        this.markSelected(parentNode);
    else
        TriStateSelectionController.prototype.updateParentNodeStateOnSubtreeSelected.call(this, parentNode);
};
