function SimpleCheckboxNodeRenderer(tree, selectorFilter, selectionHelper)
{
    HierarchySelectorNodeRenderer.call(this, tree, selectorFilter);
    this.selectionHelper = selectionHelper;
}

SimpleCheckboxNodeRenderer.prototype = _.create(HierarchySelectorNodeRenderer.prototype);

SimpleCheckboxNodeRenderer.prototype.getSpecificNodeClassName = function()
{
    return "simpleCheckboxNode";
};

SimpleCheckboxNodeRenderer.prototype.showNodeTooltip = function ( tooltip, event )
{
    tooltip.show();

    var tooltipInnerWidth = tooltip.width()+1;
    tooltip.css("width", tooltipInnerWidth);

    var tooltipHeight = tooltip.outerHeight();
    var tooltipWidth = tooltip.outerWidth();

    var top = event.pageY + 13;
    if ( top + tooltipHeight - getBodyScrollTop() > $(window).height() )
        top = event.pageY - 13 - tooltipHeight;
    var left = event.pageX + 15;
    if ( left + tooltipWidth - getBodyScrollLeft() > $(window).width() )
        left = event.pageX - tooltipWidth - 15;

    tooltip.offset({ top: top, left: left });
};

SimpleCheckboxNodeRenderer.prototype.hideNodeTooltip = function ( tooltip )
{
    tooltip.hide();

    tooltip.css("width", "");
    tooltip.css("top", "");
    tooltip.css("left", "");
};