/*

depends on:
 constants_js.jsp
 message_resources.js

*/

function UserSelectorAccessRight(
        id,
        nameKey,
        selectAllMessageKey,
        filterMessageKey,
        userNoRightsMessageKey )
{
    this.id = id;
    this.nameKey = nameKey;
    this.name = null;
    this.selectAllMessageKey = selectAllMessageKey ?
                               selectAllMessageKey : "common.users_selector.access_right.select_all";
    this.filterMessageKey = filterMessageKey ?
                            filterMessageKey : "common.users_selector.access_right.show_users_without_right";
    this.userNoRightsMessageKey = userNoRightsMessageKey ?
                                userNoRightsMessageKey : "common.users_selector.access_right.insufficient_rights";
    this.name = this.nameKey ? messageResource.getMessage(this.nameKey) : "";
}

UserSelectorAccessRight.prototype.getId = function ()
{
    return this.id;
};

/**
 * Determines whether passed access rights provide privileges of UserSelectorAccessRightsSet
 * @param userRights the set of rights to be verified
 */
UserSelectorAccessRight.prototype.isGranted = function ( userRights )
{
    return isArrayContains(userRights, this.id);
};

UserSelectorAccessRight.prototype.getSelectAllMessage = function ()
{
    return messageResource.getMessage(this.selectAllMessageKey,
                                      [this.name]);
};

UserSelectorAccessRight.prototype.getFilterMessage = function ()
{
    return messageResource.getMessage(this.filterMessageKey,
                                      [this.name]);
};

UserSelectorAccessRight.prototype.getUserNoRightsMessage = function ()
{
    return messageResource.getMessage(this.userNoRightsMessageKey,
                                      [this.name]);
};

UserSelectorAccessRight.prototype.getName = function ()
{
    return this.name;
};

function ManageTasksRight()
{
    UserSelectorAccessRight.call(this,
                          AccessRight.MANAGE_TASKS );
    this.name = messageResource.getMessage("common.users_selector.access_right.manage_tasks");
}

ManageTasksRight.prototype = _.create(UserSelectorAccessRight.prototype);


function GenerateMoneyReportRight()
{
    UserSelectorAccessRight.call(this,
                         AccessRight.GENERATE_MONEY_REPORTS,
                         "common.users_selector.access_right.generate_money_reports");
}

GenerateMoneyReportRight.prototype = new UserSelectorAccessRight();


function GenerateTimeReportRight()
{
    UserSelectorAccessRight.call(this,
                         AccessRight.GENERATE_TIME_REPORTS,
                         "common.users_selector.access_right.generate_time_reports");
}

GenerateTimeReportRight.prototype = new UserSelectorAccessRight();

function SubmitTimeTrackRight()
{
    UserSelectorAccessRight.call(this,
                         AccessRight.SUBMIT_TIME_TRACK,
                         "common.users_selector.access_right.submit_time_track");
}

SubmitTimeTrackRight.prototype = new UserSelectorAccessRight();








