function IntegrationPopup()
{
}

IntegrationPopup.JQUERY_RPC_TIMEOUT = 120000; // 2 minutes

IntegrationPopup.prototype = _.create(DHTMLPopupWithMoire.prototype);

IntegrationPopup.prototype.init = function ( data )
{
    this._popupId = "integrationPopup";
    this._popupEl = $("#"+this._popupId);

    DHTMLPopupWithMoire.call( this, this._popupId );

    this._integrationSection = this.getNewIntegrationSection();
    this._independentTrialSection = new IndependentTrialSection();

    this._integrationSection.init( "currentProductIntegration", data.integratedProductInfo, data.canIntegrate,
                                   data.canRenewLicense, data.licenseRenewalInfo);
    this._independentTrialSection.init( "independentIntegration", data.independentTrialInfo, data.hasEmail );

    this._integrationSection.setChangeStateCallback(_.bind(this._disableChecboxIfNeeded, this));
    this._independentTrialSection.setChangeStateCallback(_.bind(this._disableChecboxIfNeeded, this));

    this._closeButton = this._popupEl.find("#closeIntegrationPopupButton");
    this._closeButton.click(_.bind(this.hide, this));

    this._acceptAgreementCheckbox = this._popupEl.find("#integrationAgreementCheckbox");
    this._popupEl.addClass("agreementOn");
    var self = this;
    this._acceptAgreementCheckbox.click( function()
    {
        if ( this.checked )
        {
            self._popupEl.addClass("agreementOn");
            self._integrationSection.includeAbilityToIntegrate();
            self._independentTrialSection.includeAbilityToIntegrate();
        }
        else
        {
            self._popupEl.removeClass("agreementOn");
            self._integrationSection.turnOffAbilityToIntegrate();
            self._independentTrialSection.turnOffAbilityToIntegrate();
        }
    });
    this._disableChecboxIfNeeded();


    if ( !this._integrationSection.isCanIntegrate() &&
         !this._independentTrialSection.isCanIntegrate() )
        this._popupEl.find(".integrationAgreement").hide();

    this.hideOnMouseDown = function() { return false; };
    this.hideOnResize = function() { return false; };

    return this;
};

IntegrationPopup.prototype.getNewIntegrationSection = function(){
    return new IntegrationSection();
};

IntegrationPopup.prototype.show = function (  )
{
    DHTMLPopupWithMoire.prototype.show.call( this );
};

IntegrationPopup.prototype.hide = function (  )
{
    DHTMLPopupWithMoire.prototype.hide.call( this );
    this._abortAllRequests();
};

IntegrationPopup.prototype._abortAllRequests = function (  )
{
    this._integrationSection.abortAllRequests();
    this._independentTrialSection.abortAllRequests();
};

IntegrationPopup.prototype._disableChecboxIfNeeded = function(){
    var integrationTrialState = this._independentTrialSection.getState();
    var integrationState = this._integrationSection.getState();
    if((integrationTrialState == IntegrationStates.ACCOUNT_ACTIVE || integrationTrialState == IntegrationStates.ACCOUNT_DOES_NOT_EXIST)
       &&(integrationState == IntegrationStates.ACCOUNT_ACTIVE || integrationState == IntegrationStates.ACCOUNT_DOES_NOT_EXIST
          || integrationState == IntegrationStates.ACCOUNT_EXPIRED)){
        this._acceptAgreementCheckbox.prop("disabled" ,false);
    }
    else
    {
        this._acceptAgreementCheckbox.prop("disabled", true);
    }
};



