function LightboxTemplateView($containerEl, lightboxId, additionalClasses)
{
    TemplateView.call(this, $containerEl);
    this.lightboxId = lightboxId;
    this.additionalClasses = additionalClasses;
}

LightboxTemplateView.prototype = _.create(TemplateView.prototype, {
    html: "<div id='<%=id%>' class='lightbox <%=additionalClasses%>' style='display: none'>" +
          "  <div class='content'><%=createContent()%></div>" +
          "</div>",

    templateModel: function()
    {
        return {
            id: this.lightboxId,
            additionalClasses: _.isString(this.additionalClasses) ? this.additionalClasses : "",
            createContent: _.bind(this.createContent, this)
        }
    },

    createContent: function()
    {
        return _.template(this.getContentHtml())(_.extend(this.templateModel(), this.getAdditionalContentModel()));
    },

    getAdditionalContentModel: function()
    {
        return {}
    },

    getContentHtml: function()
    {
        return ""
    }
});