function BaseSelectionType()
{
}

BaseSelectionType.prototype = _.create(Object.prototype, {
    accept: function(visitor, selectedRegion)
    {
        //should be implemented in inheritors
    },

    getSelectedData: function(lockTable, selectedRegion)
    {
        //should be implemented in inheritors
    },

    canBeLocked: function(lockTable, selectedRegion)
    {
        //should be implemented in inheritors
    },

    canBeUnlocked: function(lockTable, selectedRegion)
    {
        //should be implemented in inheritors
    },

    getSelectionDateRange: function(datesRow, selectedRegion)
    {
        var dateFrom = datesRow.getCell(selectedRegion.colMin).getValue().date;
        var dateTo = datesRow.getCell(selectedRegion.colMax).getValue().date;
        return new DateRange(dateFrom, dateTo);
    }
});