function CellSelectionType()
{
}

CellSelectionType.prototype = _.create(BaseSelectionType.prototype, {
    accept: function(visitor, selectedRegion)
    {
        return visitor.visitCellSelection(selectedRegion);
    },
    
    getSelectedData: function(lockTable, selectedRegion)
    {
        var userIds = [];
        var userRows = lockTable.getUserRows(selectedRegion.rowMin, selectedRegion.rowMax);
        for (var i = 0; i < userRows.length; i++)
        {
            userIds.push(userRows[i].getHeaderCell().getValue().id);
        }

        return new SelectedData(this.getSelectionDateRange(lockTable.getDatesRow(), selectedRegion), userIds);
    },
    
    checkSelectedUserCells: function(lockTable, selectedRegion, cellChecker)
    {
        var userRows = lockTable.getUserRows(selectedRegion.rowMin, selectedRegion.rowMax);
        for (var i = 0; i < userRows.length; i++)
        {
            var row = userRows[i];
            for (var colIdx = selectedRegion.colMin; colIdx <= selectedRegion.colMax; colIdx++)
            {
                if (cellChecker(row.getCell(colIdx)))
                    return true;
            }
        }
        return false;
    },
    
    canBeLocked: function(lockTable, selectedRegion)
    {
        return this.checkSelectedUserCells(lockTable, selectedRegion, function(cell) { return !cell.getValue().locked; });
    },
    
    canBeUnlocked: function(lockTable, selectedRegion)
    {
        return this.checkSelectedUserCells(lockTable, selectedRegion, function(cell) { return cell.getValue().locked; });
    }
});
