function ColumnSelectionState(mouseEventsHandler)
{
    LockTableMouseEventsHandlerState.apply(this, arguments);
}

ColumnSelectionState.prototype = _.create(LockTableMouseEventsHandlerState.prototype, {
    resolveTargetCell: function(cell)
    {
        cell = cell.getRow().getTable().getLastSelectableRow().getCell(cell.getColIdx());

        // refine columns if we have a row header cell
        if (cell.getColIdx() == 0)
            cell = cell.getRow().getCell(1);

        return cell;
    },

    mouseOver: function(evt, cell)
    {
        this.mouseEventsHandler.getSelectionController().changeSelectionTo(this.resolveTargetCell(cell));
    },

    mouseUp: function(evt, cell)
    {
        this.mouseEventsHandler.setRangeSelectedState();
        this.mouseEventsHandler.fireSelectionFinished(evt);
    },

    mouseMove: function(evt, cell)
    {
        if (Ext.isIE && window.event && window.event.button == 0)
        {
            this.mouseEventsHandler.getSelectionController().clearSelection();
            this.mouseEventsHandler.setHoverState();
        }
    }
});
