function CommentsController(dateFormat)
{
    this.dateFormat = dateFormat;
    this.enabled = true;
    this.commentsShown = false;

    var self = this;
    this.viewCommentsListeners = [];
    descriptionPopup.setAfterShowHandler(function() { self.fireViewComments(); });
    descriptionPopup.setAfterHideHandler(function() { self.fireCloseComments(); });

    this.addViewCommentsListener({
                                     onViewComments: function() { self.commentsShown = true; },
                                     onCloseComments: function() { self.commentsShown = false; }
                                 });

    var prevHandler = document.onmousedown;
    document.onmousedown = function(evt)
    {
        if (prevHandler)
            prevHandler.call(this, evt);

        if (self.commentsShown && !isBusyState())
        {
            evt = getEventObj(evt);
            var targetElm = evt.target || evt.srcElement;

            while (targetElm)
            {
                if (targetElm.id == descriptionPopup.getDivId())
                    break;

                targetElm = targetElm.parentNode;
            }
        }
    };
}

CommentsController.prototype = _.create(Object.prototype, {
    addViewCommentsListener: function(listener)
    {
        this.viewCommentsListeners.push(listener);
    },

    fireViewComments: function()
    {
        for (var i = 0; i < this.viewCommentsListeners.length; i++)
            this.viewCommentsListeners[i].onViewComments();
    },

    fireCloseComments: function()
    {
        for (var i = 0; i < this.viewCommentsListeners.length; i++)
            this.viewCommentsListeners[i].onCloseComments();
    },

    registerCommentsEl: function(elm, cell)
    {
        var self = this;
        var commentsParameters = this.getCommentsParameters(cell);

        elm.onmousedown = function(evt)
        {
            if (self.enabled)
            {
                evt = getEventObj(evt);
                evt.cancelBubble = true;
            }
        };

        elm.onclick = function()
        {
            if (self.enabled)
            {
                showViewCommentsPopup(commentsParameters);
                self.fireViewComments();
            }
        };
    },

    getCommentsParameters: function(taskDayCell)
    {
        var userId = taskDayCell.getRow().getParentRow().getHeaderCell().getValue().id;
        var taskId = taskDayCell.getRow().getHeaderCell().getValue().id;
        var commentsDate = taskDayCell.getRow().getTable().getDatesRow().getCell(taskDayCell.getColIdx()).getValue().date;
        var commentsDateStr = this.dateFormat.formatDate(commentsDate);
        return new ViewCommentsParameters(taskId, userId, commentsDateStr)
    },

    enableComments: function(enable)
    {
        this.enabled = enable;
    }
});


