function DateSelectionType()
{
}

DateSelectionType.prototype = _.create(BaseSelectionType.prototype, {
    accept: function(visitor, selectedRegion)
    {
        return visitor.visitDateSelection(selectedRegion);
    },

    getSelectedData: function(lockTable, selectedRegion)
    {
        return new SelectedData(this.getSelectionDateRange(lockTable.getDatesRow(), selectedRegion), null);
    },

    canBeLocked: function(lockTable, selectedRegion)
    {
        var datesRow = lockTable.getDatesRow();
        for (var colIdx = selectedRegion.colMin; colIdx <= selectedRegion.colMax; colIdx++)
        {
            if (datesRow.getCell(colIdx).getValue().hasUnlockedInvisibleUser)
                return true;
        }

        var userRows = lockTable.getUserRows(selectedRegion.rowMin, selectedRegion.rowMax);
        for (var i = 0; i < userRows.length; i++)
        {
            var row = userRows[i];
            for (colIdx = selectedRegion.colMin; colIdx <= selectedRegion.colMax; colIdx++)
            {
                if (!row.getCell(colIdx).getValue().locked)
                    return true;
            }
        }
        return false;
    },

    canBeUnlocked: function(lockTable, selectedRegion)
    {
        var datesRow = lockTable.getDatesRow();
        for (var colIdx = selectedRegion.colMin; colIdx <= selectedRegion.colMax; colIdx++)
        {
            if (datesRow.getCell(colIdx).getValue().hasLockedInvisibleUser)
                return true;
        }

        var userRows = lockTable.getUserRows(selectedRegion.rowMin, selectedRegion.rowMax);
        for (var i = 0; i < userRows.length; i++)
        {
            var row = userRows[i];
            for (colIdx = selectedRegion.colMin; colIdx <= selectedRegion.colMax; colIdx++)
            {
                if (row.getCell(colIdx).getValue().locked)
                    return true;
            }
        }
        return false;
    }
});
