//dependence: at.js

function ExpandedUsersStorage()
{
    this.cookieName = "lockTableExpandedUsers";
    this.expandedUsers = this.loadExpandedUsers();
}

ExpandedUsersStorage.prototype = _.create(Object.prototype, {
    loadExpandedUsers: function()
    {
        return getArrayFromCookies(this.cookieName);
    },

    contains: function(userId)
    {
        for (var i = 0; i < this.expandedUsers.length; i++)
        {
            if (this.expandedUsers[i] == userId)
                return true;
        }
    },

    add: function(userId)
    {
        this.expandedUsers.push(userId);
        this.saveExpandedUsers();
    },

    remove: function(userId)
    {
        for (var i = 0; i < this.expandedUsers.length; i++)
        {
            if (this.expandedUsers[i] == userId)
            {
                this.expandedUsers.splice(i, 1);
                this.saveExpandedUsers();
                return;
            }
        }
    },

    saveExpandedUsers: function()
    {
        saveArrayIntoCookies(this.expandedUsers, this.cookieName);
    }
});
