function LockMenu(lockInfo, unlockInfo)
{
    this.menuItemSelected = false;

    this.lockItem = new Ext.menu.Item(lockInfo);
    this.unlockItem = new Ext.menu.Item(unlockInfo);

    var items = [this.lockItem, this.unlockItem];
    var lockMenu = this;
    this.menu = new Ext.menu.Menu({
        cls: "lock-unlock-menu",
        items: items,
        listeners: {
            show: function()
            {
                lockMenu.menuItemSelected = false;
            },
            itemclick: function()
            {
                lockMenu.menuItemSelected = true;
            },
            hide: function()
            {
                if (!lockMenu.menuItemSelected)
                {
                    lockMenu.cancelHandler.call(lockMenu.cancelHandlerScope);
                }
            }
        }
    });
}

LockMenu.prototype = _.create(Object.prototype, {
    /**
     * Specified handler will be user when user closes menu by pressing 'Esc' or by clicking outside of menu control.
     * @param handler handler
     * @param scope scope
     */
    setCancelHandler: function(handler, scope)
    {
        this.cancelHandler = handler;
        this.cancelHandlerScope = scope;
    },

    setLockEnabled: function(enabled)
    {
        this.lockItem.setDisabled(!enabled);
    },

    setLockHandler: function(handler, scope)
    {
        this.lockItem.setHandler(handler, scope);
    },

    setUnlockEnabled: function(enabled)
    {
        this.unlockItem.setDisabled(!enabled);
    },

    setUnlockHandler: function(handler, scope)
    {
        this.unlockItem.setHandler(handler, scope);
    },

    show: function(xPos, yPos)
    {
        this.menu.showAt([xPos, yPos]);
    },

    hide: function()
    {
        this.menu.hide();
    }
});
