function LockTableHoverController()
{
    this.hoverRegion = NullTableRegion.instance;
    this.listeners = [];
}

LockTableHoverController.prototype = _.create(Object.prototype, {
    addHoverChangeListener: function(listener)
    {
        this.listeners.push(listener);
    },

    fireHoverChangeEvent: function(oldHoverRegion)
    {
        var hoverChangeEvent = new TableRegionChangeEvent(oldHoverRegion, this.hoverRegion);
        for (var i = 0; i < this.listeners.length; i++)
            this.listeners[i].call(this.listeners[i], hoverChangeEvent);
    },

    hover: function(startCell, endCell)
    {
        var oldHoverRegion = this.hoverRegion;
        this.hoverRegion = TableRegion.prototype.createFromCells(startCell, endCell);
        if (!this.hoverRegion.equals(oldHoverRegion))
            this.fireHoverChangeEvent(oldHoverRegion);
    },

    unhover: function()
    {
        var oldHoverRegion = this.hoverRegion;
        this.hoverRegion = NullTableRegion.instance;
        this.fireHoverChangeEvent(oldHoverRegion);
    },

    isHovered: function(cell)
    {
        return this.hoverRegion != NullTableRegion.instance && this.hoverRegion.contains(cell.getRow().getRowIdx(), cell.getColIdx());
    },

    getHoverRegion: function()
    {
        return this.hoverRegion;
    }
});

