function LockTableRangeSelectedState(mouseEventsHandler)
{
    LockTableMouseEventsHandlerState.apply(this, arguments);
}

LockTableRangeSelectedState.prototype = _.create(LockTableMouseEventsHandlerState.prototype, {
    mouseDown: function(evt, cell)
    {
        if (cell.getColIdx() == 0)
        {
            this.mouseEventsHandler.getSelectionController().clearSelection();
            this.mouseEventsHandler.setHoverState();
            return;
        }

        var mouseEventsHandler = this.mouseEventsHandler;
        cell.getRow().accept(
                {
                    visitUserRow: function(cell)
                    {
                        mouseEventsHandler.getSelectionController().clearSelection();
                        mouseEventsHandler.setDelayedSelectionState(function()
                                                                    {
                                                                        mouseEventsHandler.setCellSelectionState(cell);
                                                                    });
                    },

                    visitDetailsRow: function(cell)
                    {
                        mouseEventsHandler.getSelectionController().clearSelection();
                        mouseEventsHandler.setDelayedSelectionState(function()
                                                                    {
                                                                        var parentCell = cell.getRow().getParentRow().getCell(cell.getColIdx());
                                                                        mouseEventsHandler.setCellSelectionState(parentCell);
                                                                    });
                    },

                    visitDatesRow: function(cell)
                    {
                        var singleDateSelected = mouseEventsHandler.getSelectionController().visitSelection({
                                                                                                                visitCellSelection: function(selection) { return false; },
                                                                                                                visitDateSelection: function(selection) { return selection.colMax == selection.colMin; },
                                                                                                                visitRunnerSelection: function(selection) { return false; }
                                                                                                            });
                        mouseEventsHandler.getSelectionController().clearSelection();
                        if (singleDateSelected)
                        {
                            mouseEventsHandler.setColumnSelectionState(cell);
                        }
                        else
                            mouseEventsHandler.setDelayedSelectionState(function()
                                                                        {
                                                                            mouseEventsHandler.setColumnSelectionState(cell);
                                                                        });
                    },

                    visitRunnerRow: function(cell)
                    {
                        var runnerPositionChanged = mouseEventsHandler.getSelectionController().visitSelection({
                                                                                                                   visitCellSelection: function(selection) { return false; },
                                                                                                                   visitDateSelection: function(selection) { return false; },
                                                                                                                   visitRunnerSelection: function(selection) { return true; }
                                                                                                               });

                        //clear selection after selection type checked
                        mouseEventsHandler.getSelectionController().clearSelection();
                        if (runnerPositionChanged)
                        {
                            mouseEventsHandler.setHoverState();
                            mouseEventsHandler.mouseOver(null, cell);
                        }
                        else
                        {
                            mouseEventsHandler.setDelayedSelectionState(function()
                                                                        {
                                                                            mouseEventsHandler.setHoverState();
                                                                        });
                        }
                    },

                    visitInactiveRow: function(cell)
                    {
                        mouseEventsHandler.getSelectionController().clearSelection();
                        mouseEventsHandler.setHoverState();
                    }
                },
                cell
        );
    },

    mouseOver: function(evt, cell)
    {
        if (!this.mouseEventsHandler.getSelectionController().hasSelection())
        {
            this.mouseEventsHandler.setHoverState();
            this.mouseEventsHandler.mouseOver(evt, cell);
        }
    }
});