function LockingSelectionUpdater(lockTable, selection, dateParser, selectionVeil)
{
    SelectionUpdater.call(this, lockTable, selection, messageResource.getMessage("lock_tt.table.veil.locking"), selectionVeil);
    this.dateParser = dateParser;
}

LockingSelectionUpdater.prototype = _.create(SelectionUpdater.prototype, {
    handleResult: function(result)
    {
        var userRowsMap = [];
        var userRows = this.lockTable.getUserRows(this.selection.rowMin, this.selection.rowMax);
        for (var i = 0; i < userRows.length; i++)
        {
            var currentRow = userRows[i];

            var userId = currentRow.getHeaderCell().getValue().id;
            userRowsMap[userId] = currentRow;
        }

        var datesRow = this.lockTable.getDatesRow();
        var columnDates = [];
        for (var colIdx = this.selection.colMin; colIdx <= this.selection.colMax; colIdx++)
        {
            columnDates[colIdx] = datesRow.getCell(colIdx).getValue().date;
        }

        for (var i = 0; i < result.length; i++)
        {
            var userLock = result[i];
            var userRow = userRowsMap[userLock.lockedUserId];
            var dateRange = new DateRange(this.dateParser.parse(userLock.dateFrom), this.dateParser.parse(userLock.dateTo));

            for (var colIdx = this.selection.colMin; colIdx <= this.selection.colMax; colIdx++)
            {
                if (dateRange.contains(columnDates[colIdx]))
                {
                    var userDayInfo = userRow.getCell(colIdx).getValue();
                    userDayInfo.locked = true;
                    userDayInfo.whoLocked = userLock.whoLockedId;
                    userDayInfo.lockDate = this.dateParser.parse(userLock.whenLockedDate);
                }
            }
        }

        this.runnerController.regionLocked(this.lockTable, this.selection);
    }
});
