function RunnerSelectionType()
{
}

RunnerSelectionType.prototype = _.create(BaseSelectionType.prototype, {
    accept: function(visitor, selectedRegion)
    {
        return visitor.visitRunnerSelection(selectedRegion);
    },
    
    getSelectedData: function(lockTable, selectedRegion)
    {
        return new SelectedData(lockTable.getRunnerController().getSelectedDateRange(), null);
    },
    
    isLocking: function(runnerController)
    {
        var lastLockedDate = runnerController.getLastLockedDate();
        if (lastLockedDate == null)
            return true;

        var newLastLockedDate = runnerController.getNewLastLockDate();
        return lastLockedDate.getTime() < newLastLockedDate.getTime();
    },
    
    canBeLocked: function(lockTable, selectedRegion)
    {
        return this.isLocking(lockTable.getRunnerController());
    },
    
    canBeUnlocked: function(lockTable, selectedRegion)
    {
        return !this.isLocking(lockTable.getRunnerController());
    }
});
