function SelectionUpdater(lockTable, selection, veilText, selectionVeil)
{
    this.lockTable = lockTable;
    this.selection = selection;
    this.veilText = veilText;
    this.selectionVeil = selectionVeil;

    if (lockTable)
        this.runnerController = lockTable.getRunnerController();
}

SelectionUpdater.prototype = _.create(Object.prototype, {
    beforeRpcCall: function()
    {
        this.selectionVeil.showOver(this.selection, this.veilText);
        this.lockTable.setIgnoreUserActivity(true);
    },

    afterRpcCall: function(success)
    {
        if (!success)
            this.onUpdateComplete();
    },

    handleRpcCallResult: function(result)
    {
        this.handleResult(result);
        this.onUpdateComplete();
    },

    onUpdateComplete: function()
    {
        this.selectionVeil.hide();
        this.lockTable.clearSelection();
        this.lockTable.setIgnoreUserActivity(false);
    },

    handleResult: function(result)
    {
        //depends on perfoming action (lock/unlock)
        //implemented in inheritors
    }
});
