function DateCellRenderer(weekDayNames)
{
    LockTableCellRenderer.apply(this, arguments);
    this.weekDayNames = weekDayNames;
}

DateCellRenderer.prototype = _.create(LockTableCellRenderer.prototype, {
    generateContent: function(cell)
    {
        var dateInfo = cell.getValue();
        cell.getCellEl().innerHTML = '<div class="columnWidthStrut"></div>' +
                                       this.weekDayNames[dateInfo.date.getDay()] + '<br/>' + dateInfo.date.getDate();
    },

    getCellClassName: function(cell)
    {
        var result = ["dateCell"];

        if (cell.getRow().isViewerTodayCell(cell))
            result.push("Today");

        if (this.isSelected(cell))
            result.push("Selected");
        else if (this.isHovered(cell))
            result.push("Hovered");
        else
        {
            if (!cell.getValue().working)
                result.push("Non");
            result.push("Working");

            if (this.isColumnIncludedIntoSelection(cell))
                result.push("MarkSelection");
        }

        return result.join("");
    },

    getLastCellRightBorderClassName: function()
    {
        return "lockTableLightRightBorder";
    },

    isColumnIncludedIntoSelection: function(cell)
    {
        return this.getSelectionController(cell).isColumnIncludedIntoSelection(cell.getColIdx());
    }
});
