function DayCellRenderer()
{
    LockTableCellRenderer.call(this);
}

DayCellRenderer.prototype = _.create(LockTableCellRenderer.prototype, {
    generateContent: function(cell)
    {
        this.buildContent(cell);
        this.addTooltip(cell);
    },

    buildContent: function(cell)
    {
        cell.getCellEl().innerHTML = this.parseTime(cell.getValue());
    },

    parseTime: function(time)
    {
        return time != 0 ? UserTime.formatTime(time) : "&nbsp;";
    },

    addTooltip: function(cell)
    {
        //Note: should be implemented in inheritor
    },

    getLeftBorderSpecificClassName: function(cell)
    {
        var prevColIdx = cell.getColIdx() - 1;
        if (this.isHovered(cell) || this.isHovered(cell.getRow().getCell(prevColIdx)))
        {
            return "hoveredDayCellLeftBorder";
        }
        return "";
    }
});


