function LeaveNameCellRenderer()
{
    LockTableCellRenderer.apply(this, arguments);
}

LeaveNameCellRenderer.prototype = _.create(LockTableCellRenderer.prototype, {
    generateContent: function(cell)
    {
        cell.getCellEl().innerHTML = ["<span class='lockTableEllipsis'>", cell.getValue(), "</span>"].join("");
    },

    getTopBorderClassName: function(cell)
    {
        if (cell.getRow().isFirstChildRow())
            return "detailsRowSeparator";
        else
            return "leaveNameTopBorder";
    },

    getComplicatedBorderClassName: function(cell)
    {
        var firstRow = cell.getRow().isFirstChildRow();
        var lastRow = cell.getRow().isLastChildRow();
        if (firstRow || lastRow)
            return (firstRow && lastRow) ? "singleDetailsRow" :
                   (firstRow ? "firstDetailsRow" : "lastDetailsRow");
        else
            return "";
    },

    getCellClassName: function(cell)
    {
        return "leaveNameCell";
    }
});
