function LeaveTimeCellRenderer(cssBaseClass, cssTopBorderClass)
{
    DayDetailsCellRenderer.call(this, cssBaseClass, cssTopBorderClass);
}

LeaveTimeCellRenderer.prototype = _.create(DayDetailsCellRenderer.prototype, {
    buildContent: function(cell)
    {
        if (cell.getValue().time > 0)
            cell.getCellEl().innerHTML = "<img src='" + cell.getValue().leaveInfo.printIconPath + "' class='for-print-only leavePrintIcon'/>" + this.parseTime(cell.getValue().time);
        else
            cell.getCellEl().innerHTML = this.parseTime(cell.getValue().time);
    },

    addTooltip: function(cell)
    {
        var leaveInfo = cell.getValue();
        cell.getRow().getTable().getTooltipController().addLeaveTooltip(cell.getCellEl(),
                                                                        cell.getRow().getParentRow().getHeaderCell().getValue().id,
                                                                        cell.getRow().getTable().getDatesRow().getCell(cell.getColIdx()).getValue().date,
                                                                        leaveInfo,
                                                                        cell.getRow().getParentRow().getCell(cell.getColIdx()).getValue());
    }
});


