function LockTableTaskNameCellRenderer(cssClassNames, taskDetailsFunc)
{
    LockTableCellRenderer.apply(this, arguments);
    this.cssClassNames = cssClassNames;
    this.taskDetailsFunc = taskDetailsFunc;
}

LockTableTaskNameCellRenderer.prototype = _.create(LockTableCellRenderer.prototype, {
    generateContent: function(cell)
    {
        var div = document.createElement("div");

        if (cell.getValue().completed)
            div.className = "completedTask";

        cell.getCellEl().appendChild(div);

        var tick = document.createElement("img");
        tick.src = imgPath("completed-task-png24.png");
        tick.className = "taskCompletionMark";
        div.appendChild(tick);

        var innerContent;
        if (cell.getValue().available && this.taskDetailsFunc)
        {
            innerContent = document.createElement("a");
            innerContent.href = 'javascript:void(0)';
            innerContent.onclick = this.taskDetailsFunc;

            innerContent.className = "lockTableEllipsis";
            innerContent.innerHTML = cell.getValue().name;
            cell.getRow().getTable().getTooltipController().addTaskTooltip(innerContent, cell.getValue());
        }
        else
        {
            innerContent = document.createElement("span");
            innerContent.className = "otherTasksNameCell";
            innerContent.innerHTML = cell.getValue().name;
            cell.getRow().getTable().getTooltipController().addNotAvailableTasksTooltip(cell.getCellEl());
        }
        div.appendChild(innerContent);
    },

    getComplicatedBorderClassName: function(cell)
    {
        var firstRow = cell.getRow().isFirstChildRow();
        var lastRow = cell.getRow().isLastChildRow();
        if (firstRow || lastRow)
            return (firstRow && lastRow) ? "singleDetailsRow" :
                   (firstRow ? "firstDetailsRow" : "lastDetailsRow");
        else
            return "";
    },

    getCellClassName: function(cell)
    {
        return this.cssClassNames;
    }
});
