function OvertimeCellRenderer(topBorderClass, cssAdditionalClass)
{
    LockTableCellRenderer.call(this);
    this.topBorderClass = topBorderClass;
    this.cssAdditionalClass = cssAdditionalClass;
}

OvertimeCellRenderer.prototype = _.create(LockTableCellRenderer.prototype, {
    generateContent: function(cell)
    {
        cell.getCellEl().innerHTML = "<div>" + cell.getValue() + "</div>";
    },

    getTopBorderClassName: function(cell)
    {
        return this.topBorderClass;
    },

    getComplicatedBorderClassName: function(cell)
    {
        var firstRow = cell.getRow().isFirstChildRow();
        var lastRow = cell.getRow().isLastChildRow();
        if (firstRow || lastRow)
            return (firstRow && lastRow) ? "singleDetailsRow" :
                   (firstRow ? "firstDetailsRow" : "lastDetailsRow");
        else
            return "";
    },

    getCellClassName: function(cell)
    {
        return "overtimeCell " + this.cssAdditionalClass;
    }
});
