function OvertimeDayDetailsCellRenderer(cssBaseClass, cssTopBorderClass, cssAdditionalClass)
{
    DayDetailsCellRenderer.call(this, cssBaseClass, cssTopBorderClass);
    this.cssAdditionalClass = cssAdditionalClass;
}

OvertimeDayDetailsCellRenderer.prototype = _.create(DayDetailsCellRenderer.prototype, {
    getCellClassName: function(cell)
    {
        var baseClass = DayDetailsCellRenderer.prototype.getCellClassName.call(this, cell)
        return baseClass + " " + this.cssAdditionalClass;
    },

    addTooltip: function(cell)
    {
        cell.getRow().getTable().getTooltipController().addDayTooltip(cell.getCellEl(),
                                                                      cell.getRow().getParentRow().getHeaderCell().getValue().id,
                                                                      cell.getRow().getTable().getDatesRow().getCell(cell.getColIdx()).getValue().date,
                                                                      undefined,
                                                                      {showOvertimeWhenZero: true, time: cell.getValue(), showTime: false, overtimeText: cell.getRow().getHeaderCell().getValue()},
                                                                      cell.getRow().getParentRow().getCell(cell.getColIdx()).getValue());
    }
});