function TaskDayCellRenderer(cssBaseClass, cssTopBorderClass, completed)
{
    DayDetailsCellRenderer.call(this, cssBaseClass, cssTopBorderClass);
    this.completed = completed;
}

TaskDayCellRenderer.prototype = _.create(DayDetailsCellRenderer.prototype, {
    getCellClassName: function(cell)
    {
        var baseClass = DayDetailsCellRenderer.prototype.getCellClassName.call(this, cell);
        return baseClass + (this.completed ? " completedTimeText" : "");
    },

    buildContent: function(cell)
    {
        var formatedTime = this.parseTime(cell.getValue().actuals);
        if (cell.getValue().hasComment)
        {
            //workaround: positioning of showComments element ignores td paddings under ie
            cell.getCellEl().style.padding = 0;
            var div = document.createElement("div");
            div.className = "showCommentsContainer";
            div.innerHTML = formatedTime;

            var commentsImg = document.createElement("img");
            commentsImg.className = "showComments";
            commentsImg.src = imgPath("lock_tt/small-comment.gif");

            cell.getRow().getTable().getCommentsController().registerCommentsEl(commentsImg, cell);

            div.appendChild(commentsImg);
            cell.getCellEl().appendChild(div);
        }
        else
        {
            cell.getCellEl().innerHTML = formatedTime;
        }
    },

    addTooltip: function(cell)
    {
        cell.getRow().getTable().getTooltipController().addTaskDayTooltip(cell.getCellEl(),
                                                                          cell.getRow().getParentRow().getHeaderCell().getValue().id,
                                                                          cell.getRow().getTable().getDatesRow().getCell(cell.getColIdx()).getValue().date,
                                                                          cell.getRow().getHeaderCell().getValue(),
                                                                          cell.getRow().getParentRow().getCell(cell.getColIdx()).getValue());
    }
});



