function UserNameCellRenderer()
{
    LockTableCellRenderer.apply(this, arguments);
}

UserNameCellRenderer.prototype = _.create(LockTableCellRenderer.prototype, {
    generateContent: function(cell)
    {
        var userBean = cell.getValue();
        var cellRow = cell.getRow();

        var expandCollapseDivClassNames = [];
        var expandCollapseDiv = document.createElement("div");
        if (cellRow.getChildRows().length > 0)
        {
            expandCollapseDivClassNames.push("expandCollapse");
            expandCollapseDiv.onclick = function()
            {
                cellRow.changeExpandCollapse();
            };
        }
        else
        {
            cell.getCellEl().title = messageResource.getMessage("lock_tt.table.tooltip.user_without_tt");
            expandCollapseDivClassNames.push("userWithoutTt");
        }

        if (userBean.isActive())
            expandCollapseDivClassNames.push("activeUserName");
        expandCollapseDivClassNames.push("lockTableEllipsis");

        expandCollapseDiv.className = expandCollapseDivClassNames.join(" ");
        expandCollapseDiv.innerHTML = ['&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;', escapeHtmlSymbols(userBean.formatNameLFM())].join('');
        cell.getCellEl().appendChild(expandCollapseDiv);
    },

    getCellClassName: function(cell)
    {
        var cssClass = "userCell";
        if (this.getSelectionController(cell).isRowIncludedIntoSelection(cell.getRow().getRowIdx()))
            cssClass += "MarkSelection";
        if (cell.getRow().isExpanded())
            cssClass += "Expanded";

        return cssClass;
    }
});
