function BaseTaskRow()
{
    DetailsRow.call(this);
}

BaseTaskRow.prototype = _.create(DetailsRow.prototype, {
    appendOddEvenPrefix: function(baseClass)
    {
        return (this.isOddRow() ? "odd" : "even") + " " + baseClass;
    },

    getTopBorderClass: function()
    {
        if (this.isFirstChildRow())
            return "detailsRowSeparator";

        if (this.hasRowSeparator())
            return "detailsInnerRowSeparator";
    },

    hasRowSeparator: function()
    {
        var childRows = this.getParentRow().getChildRows();
        for (var i = 0; i < childRows.length; i++)
        {
            var childRow = childRows[i];
            if (childRow instanceof BaseTaskRow)
            {
                return childRow.getRowIdx() == this.getRowIdx();
            }
        }
    },

    isOddRow: function()
    {
        var childRows = this.getParentRow().getChildRows();
        var firstTaskRow = null;
        for (var i = 0; i < childRows.length; i++)
        {
            var childRow = childRows[i];
            if (childRow instanceof BaseTaskRow)
            {
                if (firstTaskRow == null)
                    firstTaskRow = childRow;

                if (childRow.getRowIdx() == this.getRowIdx())
                    return (childRow.getRowIdx() - firstTaskRow.getRowIdx()) % 2;
            }
        }
    }
});
