function LockTableRow()
{
    TableRow.apply(this, arguments);
}

LockTableRow.prototype = _.create(TableRow.prototype, {
    createCellRenderer: function(cell)
    {
        if (cell.getColIdx() == 0)
            return this.createRowHeaderRenderer();
        else
            return this.createLockCellRenderer();
    },

    isRowHeaderCreated: function()
    {
        return this.cells.length > 0;
    },

    addCellObjWithoutAppend: function(cellObj)
    {
        cellObj.setRow(this);
        cellObj.setColIdx(this.cells.length);
        this.cells.push(cellObj);
    },

    getHeaderCell: function()
    {
        return this.getCell(0);
    },

    getTodayCell: function()
    {
        if (this.getTable().containsViewerTodayColumn())
        {
            return this.getCell(this.getTable().getViewerTodayColIdx());
        }
        return null;
    },

    isViewerTodayCell: function(cell)
    {
        if (this.getTable().containsViewerTodayColumn())
        {
            return cell.getColIdx() == this.getTable().getViewerTodayColIdx();
        }
        return false;
    },

    createRowHeaderRenderer: function()
    {
        //Note: should be implemented in inheritor
    },

    createLockCellRenderer: function()
    {
        //Note: should be implemented in inheritor
    }
});
