function OvertimeRow()
{
    DetailsRow.call(this);
}

OvertimeRow.prototype = _.create(DetailsRow.prototype, {
    createRowHeaderRenderer: function()
    {
        var topBorderClass = "";
        if (this.isFirstChildRow())
            topBorderClass = "detailsRowSeparator";
        else if (this.hasRowSeparator())
            topBorderClass = "overtimeTopBorder";
        return new OvertimeCellRenderer(topBorderClass, this.getAdditionalClass("Header"));
    },

    createLockCellRenderer: function()
    {
        return new OvertimeDayDetailsCellRenderer("odd DayDetailsCell",
                this.getTopBorderClassName(),
                this.getAdditionalClass(""));
    },

    getTopBorderClassName: function()
    {
        if (this.isFirstChildRow())
            return "detailsRowSeparator";
        if (this.hasRowSeparator())
            return "detailsInnerOvertimeRowSeparator";

        return ""
    },

    hasRowSeparator: function()
    {
        var childRows = this.getParentRow().getChildRows();
        for (var i = 0; i < childRows.length; i++)
        {
            var childRow = childRows[i];
            if (childRow instanceof OvertimeRow)
            {
                return childRow.getRowIdx() == this.getRowIdx();
            }
        }
    },

    getAdditionalClass: function(postfix)
    {
        if (!this.hasRowSeparator())
            return "secondOvertimeRow" + postfix;
        else if (this.getParentRow().getLastChildRow().getRowIdx() != this.getRowIdx())
            return "firstOvertimeRow" + postfix;

        return "";
    }
});
