function TaskRow(taskDetailsFunc)
{
    BaseTaskRow.call(this);
    this.taskDetailsFunc = taskDetailsFunc;
}

TaskRow.prototype = _.create(BaseTaskRow.prototype, {
    createRowHeaderRenderer: function()
    {
        var cssClasses = "TaskCell";
        if (this.getHeaderCell().getValue().available)
        {
            cssClasses = this.appendOddEvenPrefix(cssClasses);
        }
        else
        {
            cssClasses += " notAvailableTaskCell";
        }

        if (this.isFirstChildRow())
        {
            cssClasses += " detailsRowSeparator";
        }
        else if (this.hasRowSeparator())
        {
            cssClasses += " taskNameTopBorder";
        }
        else if (!this.getHeaderCell().getValue().available)
        {
            cssClasses += " notAvailableTaskTopBorder";
        }
        return new LockTableTaskNameCellRenderer(cssClasses, this.taskDetailsFunc);
    },

    getTopBorderClass: function(cell)
    {
        var topBorderClass = BaseTaskRow.prototype.getTopBorderClass.call(this);
        if (!topBorderClass && this.isFirstNotAvailableChildRow())
        {
            return "notAvailableTaskDetailsTopSeparator";
        }
        return topBorderClass;
    },

    isFirstNotAvailableChildRow: function()
    {
        if (this.getHeaderCell().getValue().available)
        {
            return false;
        }
        var childRows = this.getParentRow().getChildRows();
        for (var i = 0; i < childRows.length; i++)
        {
            var childRow = childRows[i];
            if (childRow instanceof BaseTaskRow && !childRow.getHeaderCell().getValue().available)
            {
                return childRow.getRowIdx() == this.getRowIdx();
            }
        }
        return false;
    },

    createLockCellRenderer: function()
    {
        return new TaskDayCellRenderer(this.appendOddEvenPrefix("DayDetailsCell"),
                                       this.getTopBorderClass(),
                                       this.getHeaderCell().getValue().completed);
    }
});
