function ScheduleSavingManager( schedule )
{
    this.schedule = schedule;
}

ScheduleSavingManager.prototype = new RpcControlManager();

ScheduleSavingManager.prototype.getService = function()
{
    return jsonrpc.MailNotificationsService;
};

ScheduleSavingManager.prototype.getMethods = function()
{
    return [ 'MailNotificationsService.saveSchedule' ];    
};

ScheduleSavingManager.prototype.beginSavingData = function()
{
    this.schedule.onBeginSaving( messageResource.getMessage("mail_notifications.schedule_popup.saving") );
};

ScheduleSavingManager.prototype.endSavingData = function()
{
    wait( this.schedule.rpcDelay );
    this.schedule.onEndSaving();
};

ScheduleSavingManager.prototype.onDataSavingComplete = function()
{
    this.schedule.onDataSavingComplete();
};

ScheduleSavingManager.prototype.handleSpecificError = function( exception )
{
    this.schedule.handelError( messageResource.getMessage("mail_notifications.schedule_popup.cannot_save") );
    return true;
};

ScheduleSavingManager.prototype.getRpcErrorMsg = function()
{
    return "cannot save"
};

ScheduleSavingManager.prototype.getTimeoutMsg = function()
{
    return  messageResource.getMessage("mail_notifications.schedule_popup.saving_timeout");
};

ScheduleSavingManager.prototype.makeRemoteCall = function( callback )
{
    var type = this.schedule.getNotificationType();
    var list = this.schedule.getScheduleList();
    this.getService().saveSchedule(callback,
                                   this.schedule.type,
                                   this.schedule.getScheduleList() );
};


