function SendNotificationsNowManager(statesManager, states)
{
    RpcControlManager.call(this);
    this.statesManager = statesManager;
    this.states = states;
}

SendNotificationsNowManager.prototype = new RpcControlManager();


SendNotificationsNowManager.prototype.getService = function()
{
    return jsonrpc.SendNotificationsNowService;
};

SendNotificationsNowManager.prototype.getMethods = function()
{
    return [ 'SendNotificationsNowService.sendNotifications' ];
};

SendNotificationsNowManager.prototype.handleSpecificError = function(exception)
{
    if(exception){
        this.setState(this.states.error);
        return true;
    }
    return false;
};

SendNotificationsNowManager.prototype.getTimeoutMsg = function()
{
    return messageResource.getMessage("mail_notifications.form.send_now.timeout_confirmation_message");
};

SendNotificationsNowManager.prototype.makeRemoteCall = function(callback)
{
    return this.getService().sendNotifications(callback);
};

SendNotificationsNowManager.prototype.beginSavingData = function()
{
    this.setState(this.states.sending);
};

SendNotificationsNowManager.prototype.endSavingData = function(success)
{
    if (RpcControlManager.isRpcBusy())
        this.setState(this.states.timeout);
};

SendNotificationsNowManager.prototype.onDataSavingComplete = function(result)
{
        this.setState(this.states.success);
};

SendNotificationsNowManager.prototype.setState = function(state)
{
    this.statesManager.setState(state);
};
