PanelDhtmlPopup.prototype = new DhtmlPopup();

function PanelDhtmlPopup(divId){

    // By default relative positioning is used for this type of popups
    DhtmlPopup.call(this, divId);

    // Specify events to be dereferenced
    this.addEventDereferencer("mousedown");
}

/**
 * Registers event handlers
 */
PanelDhtmlPopup.prototype.registerEventHandlers = function(){

    var closePopupHandler = this.getClosePopupHandler();

    KeyDownHandler.setOnKeyDownHandler(function(event) {

        // Popup is closed when 'Esc' button is pressed
        handleEscape(closePopupHandler, event);
        // Switching between elements by pressing "tab" button is blocked
        handleTab(function(){window.event.cancelBubble = true;}, event);
    });

    // Register "onmousedown" handler
    this.oldDocumentMousedown = document.onmousedown;
    var thisPopup = this;
    document.onmousedown = function ()
    {
        var target = event.target || event.srcElement;
        // if popup's owner is not defined or the user has clicked outside the owner then close the popup
        if (thisPopup.getOwner() == null || thisPopup.getOwner() != target)
            closePopupHandler();
    };

    // Set "onmousedown" handler to popup window. The purpose of the handler is to stop propagation of
    // the event thus preventing popup being closed by dosument's "onmousedown" handler
    this.getPopupDiv().onmousedown = function(event){

        window.event.cancelBubble = true;
    };

    // Register window's "onresize" handler
    this.oldWindowResize = window.onresize;
    window.onresize = closePopupHandler;
}

PanelDhtmlPopup.prototype.restoreEventHandlers = function(){

    KeyDownHandler.restoreOnKeyDownHandler();               // restoring keydown
    document.onmousedown = this.oldDocumentMousedown;   // restoring mousedown
    window.onresize = this.oldWindowResize;             // restoring onresize
}