EditCustomerPanel.Content = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

EditCustomerPanel.Content.prototype = _.create(TemplateView.prototype, {
    updateOnInit: false,

    html: "<div class='emptyLine'></div>" +
          "<div class='details'/>" +
          "<div class='description'>" +
          "  <div class='title'><%=description%></div>" +
          "  <div class='descriptionArea'></div>" +
          "</div>",

    messageKeys: function()
    {
        return {
            description: "task.edit_popup.task_description"
        }
    },

    afterRender: function()
    {
        this.$details = this.$containerEl.find(".details");
        this.details = new EditCustomerPanel.Details(this.$details).init();

        this.$description = this.$containerEl.find(".descriptionArea");
        var emptyFieldText = messageResource.getMessage('customer.edit_panel.name.empty');
        this.description = new SlidingPanel.DescriptionInput(this.$description, true, emptyFieldText).init();
    },

    update: function(isActive, totalTime, activeTime, archiveTime, description)
    {
        this.details.update(isActive, totalTime, activeTime, archiveTime);
        this.details.show();

        this.description.setDescription(description);
    }
});
