EditCustomerPanel.Details = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

EditCustomerPanel.Details.prototype = _.create(TemplateView.prototype, {
    updateOnInit: false,

    html: "<div class='detailsColumn'>" +
          "  <div class='title'><%=details%></div>" +
          "  <div class='status'><%=status%></div>" +
          "  <div class='statusButton'></div>" +
          "</div>" +
          "<div class='timeColumn'>" +
          "  <div class='totalSpentTime'>" +
          "    <span class='descriptionTime ellipsis'><%-totalTime%></span>" +
          "    <span class='time'></span>" +
          "  </div>" +
          "  <div class='activeProjects'>" +
          "    <span class='descriptionTime ellipsis'><%-activeTime%></span>" +
          "    <span class='time'></span>" +
          "  </div>" +
          "  <div class='archiveProjects'>" +
          "    <span class='descriptionTime ellipsis'><%-archiveTime%></span>" +
          "    <span class='time'></span>" +
          "  </div>" +
          "</div>",

    messageKeys: function()
    {
        return {
            totalTime: "customer.edit_panel.total_spent_time",
            activeTime: "customer.edit_panel.active_spent_time",
            archiveTime: "customer.edit_panel.archived_spent_time",
            status: "common.status",
            details: "customer.edit_panel.details"
        }
    },

    afterRender: function()
    {
        this.$totalTime = this.$containerEl.find(".totalSpentTime .time");
        this.$activeTime = this.$containerEl.find(".activeProjects .time");
        this.$archivedTime = this.$containerEl.find(".archiveProjects .time");
        this.$statusButton = this.$containerEl.find(".statusButton");

        this.statusButton = new CustomerStatusButton(this.$statusButton, true).init();
    },

    update: function(isActive, totalTime, activeTime, archiveTime)
    {
        this.$activeTime.text(UserTime.formatTimeWithDigitSeparator(activeTime));
        this.$totalTime.text(UserTime.formatTimeWithDigitSeparator(totalTime));
        this.$archivedTime.text(UserTime.formatTimeWithDigitSeparator(archiveTime));
        this.statusButton.setActive(isActive);
    }
});

