EditCustomerPanel.Header = function($containerEl, $panel)
{
    TemplateView.call(this, $containerEl);
    this.$panel = $panel;
};

EditCustomerPanel.Header.prototype = _.create(TemplateView.prototype, {

    updateOnInit: false,

    html:  "<div class='cpInfo'>" +
           "  <span class='customerName'><%-customers%></span>" +
           "</div>" +
           "<div class='customerNamePlaceHolder'/>" +
           "<div class='actions'></div>",

    messageKeys: function()
    {
        return {
            customers: "common.Customer",
            placeholder: "customer.edit.name.placeholder.text"
        }
    },

    afterRender: function()
    {
        var $namePlaceHolder = this.$containerEl.find('.customerNamePlaceHolder');
        var emptyFieldText = messageResource.getMessage('customer.edit_popup.name_placeholder');
        this.nameInput = new SlidingPanel.NameInput($namePlaceHolder, true, emptyFieldText, 191).init();

        var $actions = this.$containerEl.find(".actions");
        this.actions = new TaskManagement.EditActionButton($actions, this.$panel, this.$containerEl, false, false, true).init();
    },

    update: function(config)
    {
        this.nameInput.resetName(config.name);
        this.id = config.id;

        this.actions.disableDeleteButton(this.disableDeleteButtonText(config));

        this.actions.hideMenu();
    },

    disableDeleteButtonText: function(config)
    {
        var disableText = null;
        if (config.blockedDueToLockedTime)
        {
            disableText = messageResource.getMessage("customer.edit.cannot_delete_due_to_lock_time");
        }
        else if (config.blockedDueToUnavailableToModifyTimeTrack)
        {
            var customerText = messageResource.getMessage("common.customer");
            disableText = messageResource.getMessage(config.canManageAllUsersWithoutAutoApproved ?
                                                     "hierarchy_entity.edit_popup.cannot_delete_due_to_unavailable_modify_time_of_autoapproved_users" :
                                                     "hierarchy_entity.edit_popup.cannot_delete_due_to_unavailable_modify_time",
                                                     [customerText]);
        }
        return disableText;
    }
});


