TaskManagement.EditProjectPanel.AssignedUsers = function($containerEl, onUpdateObserver, uniqueId)
{
    this.postfix = uniqueId;

    this.itemKeyGenerator = new KeyGenerator();
    //function to create unique key for User object
    this.itemKeyGenerator.createKey = function(object)
    {
        return object.id;
    };

    this.onUpdateObserver = onUpdateObserver;
    
    TemplateView.call(this, $containerEl);
};

TaskManagement.EditProjectPanel.AssignedUsers.prototype = _.create(TemplateView.prototype, {

    GROUP_BY_SETTING_COOKIE_NAME: "projectTeamSelectorGroupBySetting",
    GROUP_BY_TIME_ZONE_GROUPS_SETTING_NAME: "groupByTimeZoneGroups",
    GROUP_BY_USER_GROUPS_SETTING_NAME: "groupByUserGroups",

    updateOnInit: false,

    html: '<div class="tab assignedUsersTab">' +
          '  <table class="dualSelector editPanelDualSelector" cellpadding="0" cellspacing="0" border="0">' +
          '    <tr>' +
          '      <td class="selecterHeader listtblcolheader ">' +
          '        <div class="keyHeader"><%-availableUsersHeader%></div>' +
          '        <div class="userGrouping">' +
          '          <span id="userGroupsContainerGrouping<%=postfix%>" class="container userGroups">' +
          '            <span class="text"><%-groupByUserGroup%> </span>' +
          '          </span>' +
          '          <span id="timeZoneGroupsContainerGrouping<%=postfix%>" class="container timeZoneGroups">' +
          '            <span class="text"><%-groupByTimeZoneGroup%></span>' +
          '          </span>' +
          '        </div>' +
          '      </td>' +
          '      <td> </td>' +
          '      <td class="selecterHeader listtblcolheader">' +
          '         <div class="keyHeader"><%-assignedHeader%></div> <span id="usersCounter<%=postfix%>"></span></td>' +
          '    </tr>' +
          '    <tr>' +
          '      <td valign="top" class="selectorArea">' +
          '        <div id="listOfAllUsers<%=postfix%>Container">' +
          '          <select id="listOfAllUsers<%=postfix%>" class="list" size="20" multiple="true" style="background-color: #ffffff; border:0;overflow-y: auto"></select>' +
          '        </div>' +
          '        <div id="emptyAllUsersList<%=postfix%>" class="list" style="display:none"></div>' +
          '        <div style="display:none">' +
          '          <select id="fake<%=postfix%>" style="border:0;"></select>' +
          '        </div>' +
          '        <table cellpadding="0" cellspacing="0" border="0" class="selectorCheckboxArea">' +
          '          <tr>' +
          '            <td valign="middle">' +
          '              <input type="checkbox" name="inAllUsers" id="inAllUsers<%=postfix%>"/>' +
          '            </td>' +
          '            <td class="selectorCheckboxArea_text">' +
          '              <label id="inAllUsersLabel<%=postfix%>" for="inAllUsers<%=postfix%>"><%-showUsersWithDisabledAccess%></label>' +
          '            </td>' +
          '          </tr>' +
          '        </table>' +
          '      </td>' +
          '      <td align="center" class="actionsControls">' +
          '        <br/>' +
          '        <div style="width: 32px">' +
          '          <div class="actionsButtons left">' +
          '          </div>' +
          '          <div class="actionsButtons right">' +
          '          </div>' +
          '        </div>' +
          '        <br/>' +
          '        <div class="controlSeparator">&nbsp;</div>' +
          '        <br/>' +
          '      </td>' +
          '      <td valign="top" class="selectorArea">' +
          '        <table cellpadding="0" cellspacing="0" border="0">' +
          '          <tr><td valign="top">' +
          '            <div id="listOfUsersInProject<%=postfix%>Container">' +
          '              <select id="listOfUsersInProject<%=postfix%>" class="list" size="20" multiple="true"  style="border:0;overflow-y: auto"/></select>' +
          '            </div>' +
          '            <div style="display:none">' +
          '              <select id="projectTeam<%=postfix%>" name="projectTeam" multiple="true" style="border:0;"></select>' +
          '            </div>' +
          '            <div id="emptyProjectTeam<%=postfix%>" style="display:none"></div>' +
          '            <table cellpadding="0" cellspacing="0" border="0" class="selectorCheckboxArea">' +
          '              <tr>' +
          '                <td valign="middle">' +
          '                  <input type="checkbox" name="inProjectTeam" id="inProjectTeam<%=postfix%>"/>' +
          '                </td>' +
          '                <td class="selectorCheckboxArea_text">' +
          '                  <label id="inProjectTeamLabel<%=postfix%>" for="inProjectTeam<%=postfix%>"><%-showUsersWithDisabledAccess%></label>' +
          '                </td>' +
          '              </tr>' +
          '            </table>' +
          '          </td></tr>' +
          '        </table>' +
          '      </td>' +
          '    </tr>' +
          '  </table>' +
          '</div>',

    templateModel: function()
    {
        return {
            postfix: this.postfix
        }
    },

    messageKeys: function()
    {
        return {
            availableUsersHeader: "usersselector.available.header",
            assignedHeader: "usersselector.asusers.header",
            groupByUserGroup: "usersselector.groupByUserGroup",
            groupByTimeZoneGroup: "usersselector.groupByTimeZoneGroup",
            showUsersWithDisabledAccess: "usersselector.checkbox.label.disabled.users"
        }
    },

    afterRender: function()
    {
        var self = this;

        this.find("#userGroupsContainerGrouping" + this.postfix).click(_.bind(this._updateGroupTypeWithUI, this, GroupType.USER_GROUP));
        this.find("#timeZoneGroupsContainerGrouping" + this.postfix).click(_.bind(this._updateGroupTypeWithUI, this, GroupType.TIME_ZONE_GROUP));

        var $listOfAllUsers = this.find("#listOfAllUsers" + this.postfix);
        $listOfAllUsers.on("change", function() { self._onChangeSelection(self.leftListController) });
        var listOfAllUsersClickFn = function () { self._setLastClickOption($listOfAllUsers[0]) };
        $listOfAllUsers.on("mousedown", listOfAllUsersClickFn);
        $listOfAllUsers.on("click", listOfAllUsersClickFn);
        $listOfAllUsers.on("dblclick", function(event) { self._moveRight(event, true)});
        fixIScrollInnerWheelEvent($listOfAllUsers);

        this.$inAllUsers = this.find("#inAllUsers" + this.postfix);
        this.$inAllUsers.click(_.bind(this._onLeftShowUsersWithoutAccessClick, this, this.$inAllUsers[0]));

        var $listOfUsersInProject = this.find("#listOfUsersInProject" + this.postfix);
        $listOfUsersInProject.on("change", function() { self._onChangeSelection(self.rightListController) });
        var listOfUsersInProjectClickFn = function() { self._setLastClickOption($listOfUsersInProject[0]) };
        $listOfUsersInProject.on("mousedown", listOfUsersInProjectClickFn);
        $listOfUsersInProject.on("click", listOfUsersInProjectClickFn);
        $listOfUsersInProject.on("dblclick", function(event) { self._moveLeft(event, true)});
        fixIScrollInnerWheelEvent($listOfUsersInProject);

        this.$inProjectTeam = this.find("#inProjectTeam" + this.postfix);
        this.$inProjectTeam.click(_.bind(this._onRightShowUsersWithoutAccessClick, this, this.$inProjectTeam[0]));

        this.find(".actionsButtons.right").click(_.bind(this._moveLeft, this));
        this.find(".actionsButtons.left").click(_.bind(this._moveRight, this));

        this.$userGrouping = this.find(".userGrouping");

        disableTextSelection(document.getElementById("inAllUsersLabel" + this.postfix));
        disableTextSelection(document.getElementById("inProjectTeamLabel" + this.postfix));
    },

    update: function(config)
    {
        var self = this;

        this.userGroupEnabled = !_.isNull(config.userGroups);
        this.timeZoneGroupEnabled = !_.isNull(config.timeZoneGroups);

        this.userGroups = this.userGroupEnabled ? config.userGroups.list : null;
        this.timeZoneGroups = this.timeZoneGroupEnabled ? config.timeZoneGroups.list : null;

        if (this.userGroupEnabled && this.timeZoneGroupEnabled)
            this.$userGrouping.show();
        else
            this.$userGrouping.hide();

        this.userSelectorChangeListener = {
            changed: false,
            setChanged: function()
            {
                if (!this.changed)
                {
                    this.changed = true;
                    this.callback();
                }
            },
            callback: function() {}
        };

        if (this.timeZoneGroupEnabled && this.userGroupEnabled)
        {
            var groupBySettingFromCookies = $.cookie(this.GROUP_BY_SETTING_COOKIE_NAME);
            this.groupTypeInSelector = groupBySettingFromCookies == this.GROUP_BY_TIME_ZONE_GROUPS_SETTING_NAME ?
                                       GroupType.TIME_ZONE_GROUP : GroupType.USER_GROUP;
        }
        else
        {
            this.groupTypeInSelector = this.userGroupEnabled ? GroupType.USER_GROUP : (this.timeZoneGroupEnabled ? GroupType.TIME_ZONE_GROUP : null);
        }

        this.assignmentUsers = [];
        var users = config.assignmentUsers.list;
        _.each(users, function(user)
        {
            self.assignmentUsers.push(new AssignmentUser(user.id,
                    user.formattedName,
                    user.activeInAT,
                    user.hasAccessToAllProjects,
                    user.userGroupId,
                    user.timeZoneGroupId));
        });
        this.assignedUsers = config.projectTeam.slice(0); //copy array

        //add to project team user who have access to allprojects of all customers.
        for (var i = 0; i < this.assignmentUsers.length; i++)
        {
            var user = this.assignmentUsers[i];
            if (user.isAllProjectsAvailable)
            {
                this.assignedUsers.push(this.itemKeyGenerator.createKey(user));
            }
        }

        //create duallist controller.
        this.rightUsersStatisticsCtrl = new UsersStatistics();
        this.leftUsersStatisticsCtrl = new UsersStatistics();
        this.leftPresentationController = new UsersPresentationController("listOfAllUsers" + this.postfix, "emptyAllUsersList" + this.postfix);
        this.rightPresentationController = new UsersPresentationController("listOfUsersInProject" + this.postfix, "emptyProjectTeam" + this.postfix);
        this.leftContentController = new UsersContentController();
        this.rightContentController = new UsersContentController();
        this.leftOutputDataController = new OutputDataController(false, "fake" + this.postfix);
        this.rightOutputDataController = new OutputDataController(true, "projectTeam" + this.postfix);


        this.leftPresentationController.getTextForEmptyList = function()
        {
            if (this.isShowDisabledUsers())
            {
                return messageResource.getEscapedMessage('usersselector.avusers.list.empty.withdisabledusers');
            }
            return messageResource.getEscapedMessage('usersselector.avusers.list.empty.withoutdisabledusers');
        };

        this.leftPresentationController.showEmptyList = function()
        {
            this.getElementContainer().style.display = "none";
            var divElement = this.emptyElement.getElement();
            divElement.style.display = "block";
            divElement.className = "EmptyDivStyle";
            divElement.innerHTML = this.getTextForEmptyList();
        };

        this.rightPresentationController.showEmptyList = function()
        {
            this.getElementContainer().style.display = "none";
            var divElement = this.emptyElement.getElement();
            divElement.style.display = "block";
            divElement.className = "RightEmptyDivStyle";
            divElement.innerHTML = this.getTextForEmptyList();
        };

        this.rightPresentationController.getTextForEmptyList = function ()
        {
            return "";
        };


        this.rightOutputDataController.isObjectIncludedToOutput = function(object)
        {
            return !object.isAllProjectsAvailable;
        };

        this.rightOutputDataController.getOutputDataForObject = function(object)
        {
            return object.id;
        };

        this.$inAllUsers[0].checked = false;
        this.$inProjectTeam[0].checked = false;

        this._initSelector();

        this.disableDoubleClick = true;
        this.lastSelectedIndex = -1;
        this.lastClickOption = document.createElement('option');

        this.rightPresentationController.setShowDisabledUsers(false);
        this.leftPresentationController.setShowDisabledUsers(false);
        this.dualSelector.update();
        this._updateUsersCounter();
        this._updateGroupingContainer();
    },

    _updateGroupTypeWithUI: function(groupType)
    {
        var selectedObjects = this.dualSelector.rightList.objects.getValues();
        this.assignedUsers = _.map(selectedObjects, function(item) { return item.id; });
        this.groupTypeInSelector = groupType;
        this._initSelector();
        this._updateGroupingContainer();
        this.dualSelector.update();
        this._saveGroupBySettingsToCookie(groupType);
    },

    _onChangeSelection: function(listController)
    {
        var pos = listController.objectPresentationController.getElement().scrollTop;
        listController.updateSelection();
        listController.objectPresentationController.getElement().scrollTop = pos;
    },

    _setLastClickOption: function(select)
    {
        if (select.selectedIndex !== -1)
            this.lastClickOption = select.options[select.selectedIndex];

        this.disableDoubleClick = ( select.selectedIndex === -1 ) && ( this.lastSelectedIndex === -1 );
        this.lastSelectedIndex = select.selectedIndex;
    },

    _notifyAboutChanges: function()
    {
        var teamProject = [];
        _.each(this.rightListController.objects.getValues(), function(user)
        {
            teamProject.push(user.id);
        });

        $(this).trigger("projectTeamChanged", [teamProject]);
    },

    _moveRight: function(event, isDblClick)
    {
        if (event && event.ctrlKey)
            return;

        if (isDblClick && !this.disableDoubleClick)
            this.lastClickOption.selected = true;

        this._onChangeSelection(this.leftListController);
        var du = this.rightUsersStatisticsCtrl.getDisabledUsersNumber();
        if (this.dualSelector.moveRight())
        {
            if (du != this.rightUsersStatisticsCtrl.getDisabledUsersNumber())
            {
                this.$inProjectTeam[0].checked = true;
                this.rightPresentationController.setShowDisabledUsers(true);
                this.dualSelector.rightList.getSelectedObjects();
                this.dualSelector.rightList.updateList();
            }

            this._updateUsersCounter();

            this.userSelectorChangeListener.setChanged();
        }

        this._notifyAboutChanges();
    },

    _onLeftShowUsersWithoutAccessClick: function(element)
    {
        this.leftPresentationController.setShowDisabledUsers(element.checked);
        this.dualSelector.leftList.updateList();
    },

    _moveLeft: function(event, isDblClick)
    {
        if (event && event.ctrlKey)
            return;

        if (isDblClick && !this.disableDoubleClick)
            this.lastClickOption.selected = true;

        this._onChangeSelection(this.rightListController);
        var du = this.leftUsersStatisticsCtrl.getDisabledUsersNumber();
        if (this.dualSelector.moveLeft())
        {
            this._updateUsersCounter();
            if (du != this.leftUsersStatisticsCtrl.getDisabledUsersNumber())
            {
                this.$inAllUsers[0].checked = true;
                this.leftPresentationController.setShowDisabledUsers(true);
                this.dualSelector.leftList.getSelectedObjects();
                this.dualSelector.leftList.updateList();
            }

            this._updateUsersCounter();

            this.userSelectorChangeListener.setChanged();
        }

        this._notifyAboutChanges();
    },

    _onRightShowUsersWithoutAccessClick: function(element)
    {
        this.rightPresentationController.setShowDisabledUsers(element.checked);
        this.dualSelector.rightList.updateList();
    },

    _initSelector: function()
    {
        if (this.groupTypeInSelector != null)
        {
            this.leftGroupPresentationController = new UsersGroupPresentationController("listOfAllUsers"+ this.postfix, false);
            this.rightGroupPresentationController = new UsersGroupPresentationController("listOfUsersInProject" + this.postfix, false);

            if (this.groupTypeInSelector == GroupType.TIME_ZONE_GROUP)
            {
                this.groups = this.timeZoneGroups;
                this.groupIdKey = "timeZoneGroupId";

                var defaultPresentation = UsersGroupPresentationController.prototype.getItemStringPresentation;
                var defaultTZGroupPresentation = function(group)
                {
                    var ret = defaultPresentation(group);
                    if (group.id == DEFAULT_TIME_ZONE_GROUP_ID)
                    {
                        ret = truncateStringByLength(ret, 32);
                        ret += ' ' + messageResource.getMessage("users_selector.default_group");
                    }
                    return ret;
                };
                this.leftGroupPresentationController.getItemStringPresentation = defaultTZGroupPresentation;
                this.rightGroupPresentationController.getItemStringPresentation = defaultTZGroupPresentation;
            }
            else
            {
                this.groups = this.userGroups;
                this.groupIdKey = "userGroupId";
            }


            this.userGroupKeyGenerator = new KeyGenerator();

            var self = this;

            //function to create unique group key for User object
            this.userGroupKeyGenerator.createKey = function(object)
            {
                return object[self.groupIdKey] === null ? USERS_WITHOUT_GROUP_ID : object[self.groupIdKey];
            };

            this.leftListController = new GroupListController(this.itemKeyGenerator,
                    this.userGroupKeyGenerator,
                    this.groups,
                    this.leftPresentationController,
                    this.leftGroupPresentationController,
                    this.leftContentController,
                    this.leftOutputDataController,
                    this.leftUsersStatisticsCtrl);
            this.rightListController = new GroupListController(this.itemKeyGenerator,
                    this.userGroupKeyGenerator,
                    this.groups,
                    this.rightPresentationController,
                    this.rightGroupPresentationController,
                    this.rightContentController,
                    this.rightOutputDataController,
                    this.rightUsersStatisticsCtrl);
        }
        else
        {
            this.leftListController = new ListController(this.itemKeyGenerator,
                    this.leftPresentationController,
                    this.leftContentController,
                    this.leftOutputDataController,
                    this.leftUsersStatisticsCtrl);
            this.rightListController = new ListController(this.itemKeyGenerator,
                    this.rightPresentationController,
                    this.rightContentController,
                    this.rightOutputDataController,
                    this.rightUsersStatisticsCtrl);
        }
        this.dualSelector = new DualListController(this.assignmentUsers,
                this.assignedUsers,
                this.leftListController,
                this.rightListController);
    },

    _getUserText: function()
    {
        return this.rightUsersStatisticsCtrl.getUsersNumber() == 1 ? "user" : "users";
    },

    _updateUsersCounter: function()
    {
        var assignedUsersNumber = this.rightUsersStatisticsCtrl.getUsersNumber();
        var summaryHtml = messageResource.getMessage('usersselector.asusers.summary.users.normal',
                                                     [assignedUsersNumber, this._getUserText()]);
        if (this.rightUsersStatisticsCtrl.getDisabledUsersNumber() > 0)
        {
            summaryHtml += " " + messageResource.getMessage('usersselector.asusers.summary.disabled_access',
                                                            [this.rightUsersStatisticsCtrl.getDisabledUsersNumber()]);
        }

        document.getElementById("usersCounter" + this.postfix).innerHTML = summaryHtml;
        this.onUpdateObserver({type: 'assignmentsUpdated', assignedUsersNumber: assignedUsersNumber});
    },

    _updateGroupingContainer: function()
    {
        if (this.userGroupEnabled && this.timeZoneGroupEnabled)
        {
            if (this.groupTypeInSelector == GroupType.USER_GROUP)
            {
                $("#userGroupsContainerGrouping" + this.postfix).addClass("selected");
                $("#timeZoneGroupsContainerGrouping" + this.postfix).removeClass("selected");
            }
            else
            {
                $("#userGroupsContainerGrouping" + this.postfix).removeClass("selected");
                $("#timeZoneGroupsContainerGrouping" + this.postfix).addClass("selected");
            }
        }
    },

    _saveGroupBySettingsToCookie: function(groupType)
    {
        var value = groupType == GroupType.TIME_ZONE_GROUP ? this.GROUP_BY_TIME_ZONE_GROUPS_SETTING_NAME : this.GROUP_BY_USER_GROUPS_SETTING_NAME;
        $.cookie(this.GROUP_BY_SETTING_COOKIE_NAME, value, {expires: 365});
    }
});

