TaskManagement.EditProjectPanel.Content = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskManagement.EditProjectPanel.Content.prototype = _.create(TemplateView.prototype, {
    updateOnInit: false,

    html: "<div class='tab detailsTab'>" +
          "  <div class='details section'/>" +
          "  <div class='description section'>" +
          "    <div class='title'><%=description%></div>" +
          "    <div class='descriptionArea'></div>" +
          "  </div>" +
          "</div>",

    messageKeys: function()
    {
        return {
            description: "task.edit_popup.task_description"
        }
    },

    afterRender: function()
    {
        this.$details = this.$containerEl.find(".details");
        this.details = new TaskManagement.EditProjectPanel.Details(this.$details).init();

        this.$description = this.$containerEl.find(".descriptionArea");
        var emptyFieldText = messageResource.getMessage('project.edit_panel.description.empty');
        this.description = new SlidingPanel.DescriptionInput(this.$description, true, emptyFieldText).init();
    },

    update: function(config)
    {
        this.details.update(config);
        this.details.show();

        this.description.setDescription(config.description);
    }
});
