TaskManagement.EditProjectPanel.Details = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskManagement.EditProjectPanel.Details.prototype = _.create(TemplateView.prototype, {
    updateOnInit: false,

    html: "<div class='details'>" +
          "  <div class='detailsColumn'>" +
          "    <div class='title'><%=details%></div>" +
          "    <div class='status'><%=status%></div>" +
          "    <div class='statusButton'></div>" +
          "  </div>" +
          "  <div class='timeColumn'>" +
          "    <div class='totalSpentTime'>" +
          "      <span class='descriptionTime ellipsis'><%-totalTime%></span>" +
          "      <span class='time'></span>" +
          "    </div>" +
          "    <div class='openTasks'>" +
          "      <span class='descriptionTime ellipsis'><%-openTime%></span>" +
          "      <span class='time'></span>" +
          "    </div>" +
          "    <div class='completedTasks'>" +
          "      <span class='descriptionTime ellipsis'><%-completedTime%></span>" +
          "      <span class='time'></span>" +
          "    </div>" +
          "  </div>" +
          "</div>",

    messageKeys: function()
    {
        return {
            totalTime: "project.edit_panel.total_spent_time",
            openTime: "project.edit_panel.open_spent_time",
            completedTime: "project.edit_panel.completed_spent_time",
            status: "common.status",
            details: "customer.edit_panel.details"
        }
    },

    afterRender: function()
    {
        this.$totalTime = this.$containerEl.find(".totalSpentTime .time");
        this.$openTime = this.$containerEl.find(".openTasks .time");
        this.$completedTime = this.$containerEl.find(".completedTasks .time");
        this.statusButton = new CustomerStatusButton(this.find(".statusButton"), true).init();
    },

    update: function(config)
    {
        var isActive = config.active;
        var totalTime = config.projectSpentTimeValues.spentTime;
        var openTime = config.projectSpentTimeValues.openTasks;
        var completedTime = config.projectSpentTimeValues.completedTasks;

        this.$totalTime.text(UserTime.formatTimeWithDigitSeparator(totalTime));
        this.$openTime.text(UserTime.formatTimeWithDigitSeparator(openTime));
        this.$completedTime.text(UserTime.formatTimeWithDigitSeparator(completedTime));

        this.statusButton.setActive(isActive);
    },

    setProjectId: function(projectId)
    {

    }
});

