function EditTaskServiceHelper(panel) {this.panel = panel;}

EditTaskServiceHelper.Methods = {
    STATUS: "EditTaskService.updateTaskStatus",
    ESTIMATED_TIME: "EditTaskService.updateTaskEstimatedTime",
    DEADLINE: "EditTaskService.updateTaskDeadline",
    BILLING_TYPE: "EditTaskService.updateBillingType",
    NAME: "EditTaskService.updateTaskName",
    DESCRIPTION: "EditTaskService.updateTaskDescription",
    TIME_COMMENTS: "EditTaskService.getTimeComments",
    MOVE_TASK: "EditTaskService.moveTask",
    DELETE_TASK: "EditTaskService.deleteTaskFromPanel"
};


EditTaskServiceHelper.prototype = {
    updateTask: function(method, params, onSuccess, onError)
    {
        var self = this;
        var taskId = self.panel.taskId;
        makeRpcCall(method, params,
                    function(result)
                    {
                        if (taskId !== self.panel.taskId)
                        {
                            return true;
                        }
                        if ( result.resultCode ===  EditTaskServiceHelper.ResultCodes.success )
                        {
                            onSuccess(result);
                            return true;
                        }

                        if (onError) return !!onError(result);
                    },_.bind(self._updateTaskErrorHandler, self, taskId, onError));
    },

    makeRequest: function(method, params, onSucces, onException)
    {
        var self = this;
        var taskId = self.panel.taskId;
        makeRpcCall(method, params,
                function(result)
                {
                    if (taskId !== self.panel.taskId)
                    {
                        return true;
                    }
                    onSucces(result);
                    return true;
                }
                ,function(jqXHR, textStatus, errorThrown)
                {
                    if (taskId !== self.panel.taskId)
                        return true;
                    if (errorThrown.exception === "com.actimind.actitime.services.EditTaskService$NoRightsToManageTaskException")
                    {
                        this._noRightsToManageTaskCallback();
                        return true;
                    }
                    if (errorThrown.exception === "com.actimind.actitime.task.TaskIsNotAssignedToUserException")
                    {
                        self._projectNotAssignedCallback(taskId);
                        return true;
                    }
                    if (errorThrown.exception === "com.actimind.actitime.task.NoSuchTaskException")
                    {
                        self._noSuchTaskCallback(taskId);
                        return true;
                    }
                    if (onException)
                        return !!onException(jqXHR, textStatus, errorThrown);

                });

    },
    
    setNoRightsToManageTaskCallback: function(callback)
    {
        this._noRightsToManageTaskCallback = callback;
    },

    setNoSuchTaskCallback: function(callback)
    {
        this._noSuchTaskCallback = callback;
    },

    setProjectNotAssignedCallback: function(callback)
    {
        this._projectNotAssignedCallback = callback;
    },

    setNoSuchProjectCallback: function(callback)
    {
        this._noSuchProjectCallback = callback;
    },

    _updateTaskErrorHandler: function(taskId, onError, jqXHR, textStatus, errorThrown)
    {
        if (taskId !== this.panel.taskId)
            return true;
        if (errorThrown.exception === "com.actimind.actitime.services.EditTaskService$NoRightsToManageTaskException")
        {
            this._noRightsToManageTaskCallback();
            return true;
        }
        if (errorThrown.exception === "com.actimind.actitime.task.NoSuchTaskException")
        {
            this._noSuchTaskCallback(taskId);
            return true;
        }
        if (errorThrown.exception === "com.actimind.actitime.task.TaskIsNotAssignedToUserException")
        {
            this._projectNotAssignedCallback(taskId);
            return true;
        }
        if (onError)
        {
            return !!onError(jqXHR, textStatus, errorThrown);
        }
    }
};
