TaskPanel.ReportedTime.TimeRow = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskPanel.ReportedTime.TimeRow.prototype = _.create(TemplateView.prototype, {

    updateOnInit: false,

    html: "<tr class='timeRow'>" +
          " <td class='dateColumn'><span class='dateCell'/></td>" +
          " <td class='userColumn'><div class='userCell'/></td>" +
          " <td class='timeColumn'><span class='timeCell'/></td>" +
          " <td class='commentColumn'><div class='commentCell'/></td>" +
          "</tr>",

    afterRender: function()
    {
        this.date = null;
        this.user = null;
        this.time = null;
        this.comment = null;
        this.dateFormat = TaskPanel.ReportedTime.TimeRow.dateFormat;

        this.$dateCell = this.find('.dateCell');
        this.$userCell = this.find('.userCell');
        this.$timeCell = this.find('.timeCell');
        this.$commnetCell = this.find('.commentCell');
    },
    
    setRowData: function(date, user, time, comment)
    {
        this.date = date;
        this.user = user;
        this.time = time;
        this.comment = comment;
        this.update();
    },
    
    update: function()
    {
        this.$dateCell.text(this.date.format(this.dateFormat));
        this.$userCell.text(this.user);
        this.$timeCell.text(UserTime.formatTimeWithDigitSeparator(this.time));
        this.$commnetCell.text((!_.isNull(this.comment)) ? escapeHtmlSymbols(this.comment) : "");
    },

    setDateFormat: function(dateFormat)
    {
        this.dateFormat = dateFormat;
    }
});

TaskPanel.ReportedTime.TimeRow.dateFormat = Date.convertSmartToExtDateFormat( SystemSettings.dateFormat ).replace(/F/, "M");