function BaseParametersFormattingStrategy() {}

BaseParametersFormattingStrategy.prototype.init = function(selectorsData, dateFormat)
{
    this.parametersFormatter = this.createParametersFormatter(selectorsData, dateFormat);
    this.dateParametersFormattingStrategy = this.createDateParametersFormattingStrategy(dateFormat);

    return this;
};

BaseParametersFormattingStrategy.prototype.createParametersFormatter = function(selectorsData, dateFormat)
{
    // abstract
};

BaseParametersFormattingStrategy.prototype.createDateParametersFormattingStrategy = function(dateFormat)
{
    // abstract
};

BaseParametersFormattingStrategy.prototype.formatMainPartOfLightboxTitle = function(selectedParameters)
{
    // abstract
};

BaseParametersFormattingStrategy.prototype.formatParametersText = function(selectedParameters)
{
    // abstract
};

BaseParametersFormattingStrategy.prototype.formatSpecifyingPartOfLightboxTitle = function(selectedParameters)
{
    return this.dateParametersFormattingStrategy.formatSpecifyingInformation(selectedParameters.dateParameters);
};
