function DateRangeFormattingStrategy () {}

DateRangeFormattingStrategy.prototype = new DateFormattingStrategy();

DateRangeFormattingStrategy.prototype.init = function ( dateFormat )
{
    DateFormattingStrategy.prototype.init.call(this, dateFormat);
    return this;
};

DateRangeFormattingStrategy.prototype.formatForDateInformation = function ( dateParameters )
{
    var dateRangeSelection = dateParameters.dateRangeSelection;

    var dateString;
    if (dateRangeSelection.qualifier == DateRangeSelectionQualifier.CUSTOM)
        dateString = this.formatDateRange(dateRangeSelection.fromDate, dateRangeSelection.toDate);
    else
        dateString = ( messageResource.getMessage("common.pdf.formatting.date.the") + " " + messageResource.getMessage(DateRangeStateUtil[dateRangeSelection.qualifier]).toLowerCase() );

    return messageResource.getMessage("common.pdf.formatting.date.range", [dateString]);
};

DateRangeFormattingStrategy.prototype.formatSpecifyingInformation = function ( dateParameters )
{
    var dateRangeSelection = dateParameters.dateRangeSelection;

    if (dateRangeSelection.qualifier == DateRangeSelectionQualifier.CUSTOM)
        return "";

    return " (" + this.formatDateRange(dateRangeSelection.fromDate, dateRangeSelection.toDate) + ")";
};

DateRangeFormattingStrategy.prototype.formatDateRange = function ( fromDate, toDate )
{
    return this.formatDate(fromDate) + " - " + this.formatDate(toDate);
};
