function ParametersFormatter(){}

ParametersFormatter.prototype = _.create(Object.prototype, {

    init: function(selectorsData, dateFormat, userGroupsFeatureEnabled, tzGroupsFeatureEnabled)
    {
        this.reportParamsStringBuilder = new ReportParamsStringBuilder().init(
                {
                    users: selectorsData.users,
                    userGroupsFeatureEnabled: userGroupsFeatureEnabled,
                    tzGroupsFeatureEnabled: tzGroupsFeatureEnabled,
                    userGroups: selectorsData.userGroups,
                    timeZoneGroups: selectorsData.timeZoneGroups,
                    cpList: selectorsData.customersProjects,
                    leaveTypes: selectorsData.leaveTypes,
                    leaveTypesMap: selectorsData.leaveTypesMap,
                    statuses: selectorsData.statuses
                },
                dateFormat
        );
        return this;
    },

    formatUsersSelection: function(userSelection, assignedInfo)
    {
        return this.reportParamsStringBuilder.getUserSelectionParamString(userSelection, assignedInfo);
    },

    formatOvertimeUsersSelection: function(userSelection)
    {
        return this.reportParamsStringBuilder.getUserSelectionParamString(userSelection);
    },

    formatCustomersAndProjectsSelection: function(cpSelection)
    {
        return this.reportParamsStringBuilder.getCPSelectionParamString(cpSelection);
    },

    formatLeaveTypesSelection: function(leaveTypeSelection)
    {
        return this.reportParamsStringBuilder.getLeaveTypeSelectionParamString(leaveTypeSelection);
    },

    formatStatusesSelection: function(statuses)
    {
        return this.reportParamsStringBuilder.getStatusesSelectionParamString(statuses);
    }
});