function SingleDateFormattingStrategy () {}

SingleDateFormattingStrategy.prototype = new DateFormattingStrategy();

SingleDateFormattingStrategy.prototype.init = function ( dateFormat )
{
    DateFormattingStrategy.prototype.init.call(this, dateFormat);
    return this;
};

SingleDateFormattingStrategy.prototype.formatForDateInformation = function ( dateParameters )
{
    var dateSelection = dateParameters.dateSelection;

    var qualifier = dateSelection.qualifier;
    var date = dateSelection.date;

    var dateString;
    if( qualifier == EvaDateQualifier.CUSTOM )
        dateString = this.formatDate( date );
    else
        dateString = ((qualifier == EvaDateQualifier.TODAY || qualifier == EvaDateQualifier.YESTERDAY) ?
                "" : (messageResource.getMessage("common.pdf.formatting.date.the") + " ")) +
           messageResource.getMessage( EvaDateStateUtil[qualifier] ).toLowerCase();

    return messageResource.getMessage("common.pdf.formatting.date.date_part.single", [dateString]);
};

SingleDateFormattingStrategy.prototype.formatSpecifyingInformation = function ( dateParameters )
{
    var dateSelection = dateParameters.dateSelection;

    if (dateSelection.qualifier == EvaDateQualifier.CUSTOM)
        return "";

    return " (" + this.formatDate(dateSelection.date) + ")";
};
