LeavesReportPDFGenerator.PDFDefinitionCreator.DataTableCreateDefinitionHelper = function(ddBuilder, tableData, config)
{
    this.ddBuilder = ddBuilder;
    this.tableData = tableData;
    this.config = config;

    this.labels = {
        titleMessage: "hello"
    };
};

LeavesReportPDFGenerator.PDFDefinitionCreator.DataTableCreateDefinitionHelper.prototype = {

    createTable: function()
    {
        var rows = [];
        var rowTypes = BaseTableDataConverter.RowType;

        var rowStrategies = {};
        rowStrategies[rowTypes.HEADER] = _.bind(this.makeHeader, this);
        rowStrategies[rowTypes.TOTALS] = _.bind(this.makeTotals, this);
        rowStrategies[rowTypes.FIRST_LEVEL] = _.bind(this.makeRow, this, 0);
        rowStrategies[rowTypes.SECOND_LEVEL] = _.bind(this.makeRow, this, 1);
        rowStrategies[rowTypes.THIRD_LEVEL] = _.bind(this.makeRow, this, 2);
        rowStrategies[rowTypes.FORTH_LEVEL] = _.bind(this.makeRow, this, 3);

        var headerData = this.tableData[0];
        var headerDefinition = rowStrategies[headerData.type](headerData);
        
        for (var i = 1; i < this.tableData.length; i++)
        {
            var rowData = this.tableData[i];
            var rowDefinition = rowStrategies[rowData.type](rowData);
            rows.push(rowDefinition);
        }

        this.ddBuilder.addDataTable(headerDefinition, rows);
    },

    makeHeader: function(row)
    {
        return this.ddBuilder.createHeaderDataRow(row);
    },

    makeTotals: function(row)
    {
        return this.ddBuilder.createTotalsRow(row);
    },

    makeRow: function(lvl, row)
    {
        return this.ddBuilder.createRow(lvl, row);
    }
};