OvertimeReport.PDFGenerator = function(){};

OvertimeReport.PDFGenerator.prototype = _.create(BaseReport.PDFGenerator.prototype, {
    
    init: function(store, generalStore, productSettingsValidator, reportRightsValidator)
    {
        BaseReport.PDFGenerator.prototype.init.call(this, store, generalStore, productSettingsValidator, reportRightsValidator);

        this.docDefinitionCreator = new OvertimeReport.PDFDefinitionCreator();
        this.generalStore = generalStore;
        
        return this;
    },

    _getParametersFormattingStrategy: function(config)
    {
        var dateFormatForFileName = new DateFormat('yyyy-MM-dd');
        return (new OvertimeReport.PDFParametersFormattingStrategy()).init(
                {
                    users: this.generalStore.getVisibleUsers(),
                    userGroups: this.generalStore.getUserGroups(),
                    timeZoneGroups: this.generalStore.getTimeZoneGroups(),
                    dateFormat: config.dateFormat, 
                    dateFormatForFile: dateFormatForFileName
                }
        );
    }
    
});