function ReportDetailsController(hiddenLinkText, shownLinkText, reportTableId, hiddenlinkTextId, shownlinkTextId,
                                   showDetailText, hideDetailText, detailParameterId,
                                   generateCSVLinkId, hideDetailsLevelValue)
{
    this.base = HidingController;
    this.base(false, hiddenLinkText, shownLinkText, reportTableId, hiddenlinkTextId, shownlinkTextId, "hide-details");
    this.showDetailText = showDetailText;
    this.hideDetailText = hideDetailText;
    this.detailParameterId = detailParameterId;
    this.generateCSVLinkId = generateCSVLinkId;
    this.hideDetailsLevelValue = hideDetailsLevelValue;
};
ReportDetailsController.prototype = new HidingController();

ReportDetailsController.prototype.getGenerateCSVLinkElement = function()
{
    return document.getElementById(this.generateCSVLinkId);
};

ReportDetailsController.prototype.getDetailParameterElement = function()
{
    return document.getElementById(this.detailParameterId);
};

ReportDetailsController.prototype.toggleDetails = function(detailsLevel)
{
    this.toggleHiding();
    if (this.isHidden)
    {
        this.hideDetailParametrInReportString();
        this.hideDetailsInCSVReport();
    }
    else
    {
        this.showDetailParametrInReportString();
        this.showDetailsInCSVReport(detailsLevel);
    }
};

ReportDetailsController.prototype.showDetailsInCSVReport = function(detailsLevel)
{
    this.replaceCsvLinkParameter("detailsLevel", detailsLevel);
};

ReportDetailsController.prototype.hideDetailsInCSVReport = function()
{
    this.replaceCsvLinkParameter("detailsLevel", this.hideDetailsLevelValue);
};

ReportDetailsController.prototype.showDetailParametrInReportString = function()
{
    if (this.detailParameterId != null)
    {
        var detailParameter = this.getDetailParameterElement();
        detailParameter.innerHTML = this.showDetailText;
    }
};

ReportDetailsController.prototype.hideDetailParametrInReportString = function()
{
    if (this.detailParameterId != null)
    {
        var detailParameter = this.getDetailParameterElement();
        detailParameter.innerHTML = this.hideDetailText;
    }
};

/**
 * Replaces parameter with specified value in 'export to CSV' link.
 * Creates the parameter if it doesn't exist.
 * @param parameter parameter name
 * @param value parameter value
 */
ReportDetailsController.prototype.replaceCsvLinkParameter = function(parameter, value)
{
    var linkElement = this.getGenerateCSVLinkElement();
    if (linkElement.href.indexOf(parameter) == -1)
    {
        linkElement.href = linkElement.href + "&" + parameter + "=" + value;
    }
    else
    {
        linkElement.href = linkElement.href.replace(new RegExp(parameter + "=[-0-9a-zA-Z]+"), parameter + '=' + value);
    }
}
