BaseReport.PDFSettingsPreview = function($containerEl, lightboxId, eventNamespace)
{
    PDFSettingsPreview.call(this, $containerEl, lightboxId);
    this.eventNamespace = eventNamespace;
};

BaseReport.PDFSettingsPreview.prototype = _.create(PDFSettingsPreview.prototype, {
    afterRender: function()
    {
        PDFSettingsPreview.prototype.afterRender.call(this);
        $(document.getElementById(this.lightboxId + "_numberOfPages")).hide();
    },

    subscribeToEvents: function()
    {
        PDFSettingsPreview.prototype.subscribeToEvents.call(this);

        var self = this;
        $(document).on(this.eventNamespace + ".pdfPreview.lightbox.show", function()
        {
            self.update();
            var printParametersForGenerate = self.collectPrintParametersForGenerate();
            self.triggerIntermediatePrintParametersChange(printParametersForGenerate);
            self.triggerPrintParametersForGenerateChange(printParametersForGenerate);
        })
    },

    unsubscribeFromEvents: function()
    {
        PDFSettingsPreview.prototype.unsubscribeFromEvents.call(this);
        $(document).off(this.eventNamespace + ".pdfPreview.lightbox.show");
    },

    updateNumberOfPagesInformation: function()
    {
        // do nothing
    },

    triggerPrintParametersForSaveChange: function(printParametersForSave)
    {
        $(document).trigger(this.eventNamespace + ".pdfPreview.printParametersForSaveChange", printParametersForSave);
    },

    triggerPrintParametersForGenerateChange: function(printParametersForGenerate)
    {
        $(document).trigger(this.eventNamespace + ".pdfPreview.printParametersForGenerateChange", printParametersForGenerate);
    }
});