/**
 * @author evdokimov
 */

function BillingSummaryFormMediator () {}

BillingSummaryFormMediator.prototype = new OldBaseFormMediator();

BillingSummaryFormMediator.prototype.init = function ( config ) {
    OldBaseFormMediator.prototype.init.call(this, config);

    return this;
};

BillingSummaryFormMediator.prototype.initParamsStringBuilder = function ( config )
{
    return new ReportParamsStringBuilder().init( {
                                                     cpList: config.cpList
                                                 } );
};

BillingSummaryFormMediator.prototype.initEditConfigController = function ( config ) {
    var self = this;
    return new BillingSummaryReportEditFormConfigController().init(
            {
                panelId: "mainContainer",
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback(); }
            } )
};

BillingSummaryFormMediator.prototype.initCsvGenerator = function()
{
    return new BillingSummaryCSVPreviewGenerator().init();
};

BillingSummaryFormMediator.prototype.initHtmlGenerator = function(){
    return new BillingSummaryHTMLPreviewGenerator().init();
};

