function BillingSummaryReportMediator ()
{
    this.constructor = BillingSummaryReportMediator;
}

BillingSummaryReportMediator.prototype = new OldReportMediator();

BillingSummaryReportMediator.prototype.init = function ( config )
{
    OldReportMediator.prototype.init.call(this, config);

    return this;
};

BillingSummaryReportMediator.prototype.getReportType = function()
{
    return ReportType.BILLING_SUMMARY;
};

BillingSummaryReportMediator.prototype.initEditConfigController = function( config )
{
    var self = this;
    return new BillingSummaryReportEditResultConfigController().init(
            {
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback(); }
            } );
};

BillingSummaryReportMediator.prototype._populateHeadersArray = function( headersArray ) {
    this.printableHeadersBuilder.addBillableReportTypeParamsStringToArray( this.reportParameters.reportType, headersArray ); //report type
    this.printableHeadersBuilder.addCPSelectionParamsStringToArray( this.reportParameters.customersProjectsSelection, headersArray ); //customers and projects
    this.printableHeadersBuilder.addBillableTaskSelectionParamsStringToArray( this.reportParameters.reportInfo, headersArray ); //tasks
    this.printableHeadersBuilder.addTimeApprovalStatusToArray( this.reportParameters.timeApprovalStatus, headersArray ); //time approval status
};

BillingSummaryReportMediator.prototype.initPrintableHeadersBuilder = function ( config ) {
    return new ReportPrintableHeadersBuilder().init(
            {
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                isFilteredByAssignments: config.isFilteredByAssignments
            }
    );
};
