/**
 * Created by filatov on 28.10.2015.
 */

function ChartColorSelector(){}

ChartColorSelector.prototype.init = function(selectorDivId, selectorColorPanel, chartColorId, changesCallback){
    this.iconSelectorPanel = selectorColorPanel;
    if (changesCallback)
        this.changesCallback = changesCallback;


    var self = this;
    this.selectorDiv = document.getElementById(selectorDivId);
    $( this.selectorDiv  ).empty();
    this.selectorDiv .className = "chartColorSelector";

    var requestColorDiv = document.createElement("div");
    requestColorDiv.className = "requestColorDiv";
    this.requestColorDiv = $(requestColorDiv);
    this.selectorDiv .appendChild(requestColorDiv);

    var arrowDiv = document.createElement("div");
    arrowDiv.className = "arrowDiv";
    this.selectorDiv .appendChild(arrowDiv);

    this.setColor(chartColorId);
    this.selectorDiv.onclick = function () {self.updateOpenState(true); self.iconSelectorPanel.initAndShow( self.selectedColorId, self.selectorDiv,
                                                                            function () { self.handlePanelClicking(self.iconSelectorPanel.getColorId()) } ) };
    return this;
};

ChartColorSelector.prototype.getColor = function(){
    return this.selectedColor;
};

ChartColorSelector.prototype.getColorId = function(){
    return this.selectedColorId;
};

ChartColorSelector.prototype.setColor = function(backgroundColorId){
    this.selectedColorId = backgroundColorId;
    this.selectedColor =ChartColor["" + backgroundColorId];
    $(this.requestColorDiv).css("background-color", this.selectedColor );
};

ChartColorSelector.prototype.handlePanelClicking = function ( backgroundColor ) {
    this.setColor(backgroundColor);
    if(this.changesCallback)
        this.changesCallback();
};

ChartColorSelector.prototype.updateOpenState = function(isOpen){
     $(this.selectorDiv).toggleClass("open", isOpen);
};

