function CostFormMediator () {}

CostFormMediator.prototype = new OldBaseFormMediator();

CostFormMediator.prototype.init = function ( config ) {
    OldBaseFormMediator.prototype.init.call(this, config);
    return this;
};

CostFormMediator.prototype.initParamsStringBuilder = function ( config )
{
    return new ReportParamsStringBuilder().init( {
                                                     users: config.users,
                                                     userGroups: config.userGroups,
                                                     timeZoneGroups: config.timeZoneGroups,
                                                     cpList: config.cpList
                                                 } );
};

CostFormMediator.prototype.initEditConfigController = function ( config ) {
    var self = this;
    return new CostReportEditFormConfigController().init(
            {
                panelId: "mainContainer",
                reportParameters: config.reportParameters,
                users: config.users,
                userGroups: config.userGroups,
                timeZoneGroups: config.timeZoneGroups,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback()}
            } )
};

CostFormMediator.prototype.initCsvGenerator = function(){
    return new CostCSVPreviewGenerator().init();
};

CostFormMediator.prototype.initHtmlGenerator = function(){
    return new CostHTMLPreviewGenerator().init();
};

