function CostReportMediator ()
{
    this.constructor = CostReportMediator;
}

CostReportMediator.prototype = new OldReportMediator();

CostReportMediator.prototype.init = function ( config )
{
    OldReportMediator.prototype.init.call(this, config);

    return this;
};

CostReportMediator.prototype.getReportType = function()
{
    return ReportType.COST_OF_WORK;
};

CostReportMediator.prototype.initEditConfigController = function( config )
{
    var self = this;
    return new CostReportEditResultConfigController().init(
            {
                reportParameters: config.reportParameters,
                users: config.users,
                userGroups: config.userGroups,
                timeZoneGroups: config.timeZoneGroups,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback(); }
            } );
};

CostReportMediator.prototype._populateHeadersArray = function( headersArray ) {
    this.printableHeadersBuilder.addCPSelectionParamsStringToArray( this.reportParameters.customersProjectsSelection, headersArray ); //customers and projects
    this.printableHeadersBuilder.addStaffSelectionParamsToArray( this.reportParameters.userSelection, headersArray ); //staff
};

CostReportMediator.prototype.initPrintableHeadersBuilder = function ( config ) {
    return new ReportPrintableHeadersBuilder().init(
            {
                users: config.users,
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                isFilteredByAssignments: config.isFilteredByAssignments,
                userGroups: config.userGroups,
                timeZoneGroups: config.timeZoneGroups
            }
    );
};
