function ErrorTooltipsForSectionsController() {}

ErrorTooltipsForSectionsController.prototype.init = function( tooltipId, errorsToSectionElsMap, getErrorMessageFunction )
{
    this.errorTooltip = new ReportEditConfigErrorTooltip().init( tooltipId );

    this.errorsToSectionElsMap = errorsToSectionElsMap;
    this.getErrorMessageFunction = getErrorMessageFunction;

    return this;
};

ErrorTooltipsForSectionsController.prototype.updateTooltips = function( errors )
{
    for ( var possibleError in this.errorsToSectionElsMap )
    {
        if ( this.errorsToSectionElsMap.hasOwnProperty( possibleError ) )
        {
            var error = isArrayContains( errors, possibleError ) ? possibleError : null;
            this.updateTooltipHandlersForSection( this.errorsToSectionElsMap[ possibleError ], error );
        }
    }
};

ErrorTooltipsForSectionsController.prototype.updateTooltipHandlersForSection = function( sectionEl, error )
{
    if ( !sectionEl )
        return;

    var self = this;
    if ( error )
    {
        sectionEl.hover( function( event ) { self.showErrorTooltip( event, error ) },
                         function() { self.hideErrorTooltip(); } );
        sectionEl.mousemove( function ( event ) { self.moveErrorTooltip( event ) } );
        sectionEl.click( function() { self.hideErrorTooltip(); }) ;
    }
    else
    {
        sectionEl.unbind( 'hover mousemove click' );
    }
};

ErrorTooltipsForSectionsController.prototype.showErrorTooltip = function( event, error )
{
    this.errorTooltip.updateUIAndShow( {errorMessage: this.getErrorMessageFunction( error ), styleClass: error + "Cls" },
                                       calculateTooltipOffset( this.errorTooltip, event ));
};

ErrorTooltipsForSectionsController.prototype.moveErrorTooltip = function( event )
{
    this.errorTooltip.move( calculateTooltipOffset( this.errorTooltip, event ) );
};

ErrorTooltipsForSectionsController.prototype.hideErrorTooltip = function()
{
    this.errorTooltip.hide();
};
