ExportPanel = function($containerEl, processPDF, processCSV)
{
    DropdownTemplateView.call(this, $containerEl);
    this.updateOnInit = false;
    this.processPDF = processPDF;
    this.processCSV = processCSV;
};


ExportPanel.prototype = _.create(DropdownTemplateView.prototype, {
    html: "<div class='exportSelector noprint menuZindex' style='display: none;'>" +
          "    <div class='row toCSV'><div class='type'><%-toCSV%></div></div>" +
          "    <div class='row toPDF'><div class='type'><%-toPDF%></div></div>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        this.isShown = false;

        if (this.processPDF)
        {
            this.findPDFButton().click(function()
            {
                self.hide();
                $(document).trigger(self.processPDF);
            });
        }
        else
        {
            this.$el.addClass("noPDF");
        }
        if (this.processCSV)
        {
            this.findAndBindClick(".toCSV", function()
            {
                self.hide();
                $(document).trigger(self.processCSV);
            });
        }
        else
        {
            this.$el.addClass("noCSV");
        }
    },


    messageKeys: function()
    {
        return {
            "toCSV": "report.config.export.to_csv",
            "toPDF": "report.config.export.to_pdf"
        }
    },
    
    findPDFButton: function()
    {
        return this.find(".toPDF")
    }
});
