/**
 * Created by filatov on 08.09.2015.
 */
function InvoicePreviewRenderer(){}

InvoicePreviewRenderer.prototype.init = function(){
    this.itemsTable = $("#itemsTable");
    return this;
};

InvoicePreviewRenderer.prototype.updateGrouping = function(reportParameters){

    this.itemsTable.find("tbody.itemsBody").empty();
    var levels = [];
    if (reportParameters.firstGroupingLevel !=  ReportGroupingLevel.NONE){
        levels.push(reportParameters.firstGroupingLevel);
    }
    if (reportParameters.secondGroupingLevel != ReportGroupingLevel.NONE){
        levels.push(reportParameters.secondGroupingLevel);
    }
    if (reportParameters.thirdGroupingLevel != ReportGroupingLevel.NONE){
        this._addLevelsDependsFromThirdLevel(levels, reportParameters.thirdGroupingLevel);
    }

    var templateRow = $("#itemsTable" ).find("tbody.template" ).find("tr.templateRow" ).clone();
    levels.length > 0 ? templateRow.find(".firstLayer" ).html( this._getEscapedLevelPreviewName(levels[0])) : templateRow.find(".firstLayer" ).hide();
    levels.length > 1 ?   templateRow.find( ".secondLayer" ).html( " - " + this._getEscapedLevelPreviewName(levels[1])) : templateRow.find( ".secondLayer" ).hide();
    levels.length > 2 ?  templateRow.find( ".thirdLayer" ).html( " - " +  this._getEscapedLevelPreviewName(levels[2])) :  templateRow.find( ".thirdLayer" ).hide();
    levels.length > 3 ?   templateRow.find(".fourthLayer" ).html(" - " + this._getEscapedLevelPreviewName(levels[3])) : templateRow.find(".fourthLayer" ).hide();

    var countRows = 0;
    if (levels.length == 1) countRows = 4;
    if (levels.length == 2) countRows = 3;
    if (levels.length > 2) countRows = 2;

    for(var  i = 0; i < countRows; i++){
        var row = templateRow.clone();
        this.itemsTable.find(".itemsBody").append(row);
    }
};

InvoicePreviewRenderer.prototype._addLevelsDependsFromThirdLevel = function( levels, thirdGroupingLevel) {
    switch ( thirdGroupingLevel ){
        case ReportGroupingLevel.TASK_AND_TT_COMMENTS:
            levels.push( ReportGroupingLevel.TASK);
            levels.push( ReportGroupingLevel.TT_COMMENTS );
            break;
        case ReportGroupingLevel.PROJECT_AND_TT_COMMENTS:
            levels.push( ReportGroupingLevel.PROJECT );
            levels.push( ReportGroupingLevel.TT_COMMENTS );
            break;
        case ReportGroupingLevel.CUSTOMER_AND_TT_COMMENTS:
            levels.push( ReportGroupingLevel.CUSTOMER );
            levels.push( ReportGroupingLevel.TT_COMMENTS );
            break;
        default:
            levels.push( thirdGroupingLevel );
    }
};

InvoicePreviewRenderer.prototype.getName = function(groupingLevelValue){
   switch (groupingLevelValue){
       case ReportGroupingLevel.CUSTOMER : return "customer";
       default :return "otherGrouping";
   }
};

InvoicePreviewRenderer.prototype._getEscapedLevelPreviewName = function( level ) {
    return escapeHtmlSymbols( ReportPreviewUtils.getLevelPreviewName( level ));
};