function InvoiceReportMediator ()
{
    this.constructor = InvoiceReportMediator;
}

InvoiceReportMediator.prototype = new OldReportMediator();

InvoiceReportMediator.prototype.init = function ( config )
{
    OldReportMediator.prototype.init.call(this, config);
    registerChangeHandlers();
    
    var self = this;

    this.exportEnabled = false;
    this.exportToPDFButton = $("#createPDFInvoiceButton");
    this.exportToPDFButton.click( function () { self.exportInvoiceToPDF();});
    setExitHandler(function(){ return  self.isFieldsChanged()});
    return this;
};

InvoiceReportMediator.prototype.getReportType = function()
{
    return ReportType.INVOICING;
};

InvoiceReportMediator.prototype.isFieldsChanged = function(){
     return this.fieldsWasChanged;
};

InvoiceReportMediator.prototype.initEditConfigController = function( config )
{
    var self = this;
    return new InvoiceEditResultConfigController().init(
            {
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback(); }
            } );
};

InvoiceReportMediator.prototype.exportInvoiceToPDF = function ()
{
    if ( this.exportEnabled && submitForm( true, this.reportConfigId ))
            this.setChangesFieldDetected(false);
};

InvoiceReportMediator.prototype.onDateRangeChanged = function() {
    if(!this.restoreDateRangeSelector && !this.validateFieldsAndConfirmation())
    {
        this.restoreDateRangeSelector = true;
        this.dateRangeSelector.setSelectedRangeJSON( this.reportParameters );
        return;
    }
    if(this.restoreDateRangeSelector)
    {
        this.restoreDateRangeSelector = false;
        return;
    }
    ReportMediator.prototype.onDateRangeChanged.call(this);
};

InvoiceReportMediator.prototype.registerFieldsWasChanged = function(){
    this.registerChanges();
    this.setChangesFieldDetected(true);
};
InvoiceReportMediator.prototype.editConfigApplied = function(){
    ReportMediator.prototype.editConfigApplied.call( this, $.proxy(this.validateFieldsAndConfirmation, this) );
};

InvoiceReportMediator.prototype.setChangesFieldDetected = function(isDetected){
    this.fieldsWasChanged = isDetected;
    setChangesDetected(isDetected);
};

InvoiceReportMediator.prototype._resetReport = function( reportParameters )
{
    if(!this.validateFieldsAndConfirmation()) return;
    return ReportMediator.prototype._resetReport.call(this, reportParameters);
};

InvoiceReportMediator.prototype.commonSuccessSaveHandler =function(newConfigName){
    this.setChangesFieldDetected(false);
    ReportMediator.prototype.commonSuccessSaveHandler.call(this, newConfigName);
};

InvoiceReportMediator.prototype.validateFieldsAndConfirmation = function(){
  return !this.isFieldsChanged() || confirm(this.getConfitmThatDataWasChanged())
};


ReportMediator.prototype.onReportLoadingError = function() {
    this.saveConfigControl.disableEditConfig();
};

InvoiceReportMediator.prototype.updateInvoiceReportPageAfterReportGeneration = function (
        items, discounts, taxes, predefinedTerms, defaultTerms, billToHistory
)
{
    init(items, discounts, taxes, predefinedTerms, defaultTerms, billToHistory);
};

InvoiceReportMediator.prototype.getConstructorSaveManager = function(){
    return new InvoiceSaveReportManager();
};

InvoiceReportMediator.prototype.getConfitmThatDataWasChanged = function(){
    return messageResource.getMessage("report.common.lost_modifications");
};

InvoiceReportMediator.prototype.generateReport = function ( ignoreHistory )
{
    var self = this;

    this.exportToPDFButton.addClass("disabled");
    this.exportEnabled = false;
    this.baseGenerateReport(
        ignoreHistory,
        function () {
            self.exportToPDFButton.removeClass("disabled");
            self.exportEnabled = true;
            self.saveConfigControl.enableEditConfig();
        }
    );
    this.setChangesFieldDetected(false);
};

InvoiceReportMediator.prototype.generateReportFromHistory = function () {
    if ( !this.validateFieldsAndConfirmation() ) 
        return;
    
    ReportMediator.prototype.generateReportFromHistory.call(this);
};

InvoiceReportMediator.prototype._createPrintableHeaders = function() {};
InvoiceReportMediator.prototype._createPrintableDateRangeHeader = function () {};