/**
 * @author evdokimov
 */

function ProfitLossFormMediator () {}

ProfitLossFormMediator.prototype = new OldBaseFormMediator();

ProfitLossFormMediator.prototype.init = function ( config ) {
    OldBaseFormMediator.prototype.init.call(this, config);

    return this;
};

ProfitLossFormMediator.prototype.initParamsStringBuilder = function ( config )
{
    return new ReportParamsStringBuilder().init( {
                                                     cpList: config.cpList
                                                 } );
};

ProfitLossFormMediator.prototype.initEditConfigController = function ( config ) {
    var self = this;
    return new ProfitLossReportEditFormConfigController().init(
            {
                panelId: "mainContainer",
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback(); }
            } )
};

ProfitLossFormMediator.prototype.initCsvGenerator = function(){
    return new ProfitLossCSVPreviewGenerator().init();
};

ProfitLossFormMediator.prototype.initHtmlGenerator = function(){
    return new ProfitLossHTMLPreviewGenerator().init();
};

