function ShowCommentsLightBox() {
    this.constructor = ShowCommentsLightBox;
}

ShowCommentsLightBox.prototype = new BasicLightbox();
ShowCommentsLightBox.superclass = BasicLightbox.prototype;

ShowCommentsLightBox.prototype.exist_invalid_fields_message_key = "";
ShowCommentsLightBox.prototype.close_tab_confirmation_message_key = "";

ShowCommentsLightBox.prototype.init = function( userCommentsData, popUpId ,timeFormat) {

    BasicLightbox.prototype.init.call( this, popUpId, "closeCommentsLightboxBtn");

    this.userCommentsLightBox = $("#" + popUpId);
    this.tableEl = this.userCommentsLightBox.find(".tableContentContainer").find("table");// find table for comments
    this.titleDiv = this.userCommentsLightBox.find(".lightBoxTitle"); // find title of light box
    this.tableRenderer = new CommentsTableRender().init(this.tableEl, userCommentsData.userComments, timeFormat ); // table render

    this._initTitle( userCommentsData );
    this.tableRenderer.render();
    return this;
};

// init title of popup
ShowCommentsLightBox.prototype._initTitle = function( usersCommentsData ) {
    var titleLabel = messageResource.getMessage("report_comments.comments_made_by_user", [escapeHtmlSymbols(usersCommentsData.userFullName)] );
    this.titleDiv.empty();
    this.titleDiv.append(titleLabel);
};

ShowCommentsLightBox.prototype.show = function() {
    ShowCommentsLightBox.superclass.show.call(this);
    this._resetScroll();
    this._initCellsWidth(); // init width on created table
};

/**
 * init correct width of all cells in table
 * @private
 */
ShowCommentsLightBox.prototype._initCellsWidth = function() {
    var commentCells = this.userCommentsLightBox.find(".commentsCell" + ".data");
    commentCells.addClass('breakWord'); // set break all words property
    var maxWidth = commentCells.width(); // read width of comments cell with breaking words
    commentCells.removeClass('breakWord'); // remove breaking words property
    commentCells.css('max-width', maxWidth); // set max-width of comments cell as with breaking words
    // after init header cells
    this._initHeaderCells();
};

/**
 * set correct width of header cells equals width of table cells
 * @private
 */
ShowCommentsLightBox.prototype._initHeaderCells = function() {
    var dataContainer = this.userCommentsLightBox.find(".tableContentContainer");
    var headerContainer = this.userCommentsLightBox.find(".tableHeaderContainer");

    var headerIdentityCellText = this.userCommentsLightBox.find(".identityCell.header").find(".identityText");
    headerIdentityCellText.text(this._getHeaderIdentityDescription()); // insert with escape html

    var cells = [".identityCell", ".dateCell", ".timeCell"]; // classes of table cells
    for (var i = 0; i < cells.length; i++) {
        var headerCell = headerContainer.find(cells[i] + ".header");
        var dataCell = dataContainer.find(cells[i] + ".data");
        headerCell.innerWidth(dataCell.innerWidth());
    }
};

/**
 * Reset scroll position in popup (need to chrome)
 * @private
 */
ShowCommentsLightBox.prototype._resetScroll = function() {
    this.userCommentsLightBox.find(".tableContentContainer").scrollTop(0);
};

// escape when write into cell
ShowCommentsLightBox.prototype._getHeaderIdentityDescription = function() {
    var text = messageResource.getMessage("common.Customer");
    text += " / ";
    text += messageResource.getMessage("common.Project");
    text += " / ";
    text += messageResource.getMessage("common.Task");
    return text;
};



