/**
 * @author evdokimov
 */

function StaffOutputFormMediator () {}

StaffOutputFormMediator.prototype = new OldBaseFormMediator();

StaffOutputFormMediator.prototype.init = function ( config ) {
    OldBaseFormMediator.prototype.init.call(this, config);

    return this;
};

StaffOutputFormMediator.prototype.initParamsStringBuilder = function ( config )
{
    return new ReportParamsStringBuilder().init( {
                                                     users: config.users,
                                                     userGroups: config.userGroups,
                                                     timeZoneGroups: config.timeZoneGroups,
                                                     cpList: config.cpList
                                                 } );
};

StaffOutputFormMediator.prototype.initEditConfigController = function ( config ) {
    var self = this;
    return new StaffOutputReportEditFormConfigController().init(
            {
                panelId: "mainContainer",
                reportParameters: config.reportParameters,
                users: config.users,
                userGroups: config.userGroups,
                timeZoneGroups: config.timeZoneGroups,
                cpList: config.cpList,
                changeCallback: function(){ self.changeParametersCallback(); }
            } );
};

StaffOutputFormMediator.prototype.initCsvGenerator = function(){
    return new StaffPerformanceCSVPreviewGenerator().init();
};

StaffOutputFormMediator.prototype.initHtmlGenerator = function(){
    return new StaffPerformanceHTMLPreviewGenerator().init();
};