function TTDetailFormMediator(){}
TTDetailFormMediator.prototype = new OldBaseFormMediator();
TTDetailFormMediator.superproto = BaseFormMediator.prototype;

TTDetailFormMediator.prototype.init = function( config ) {
    OldBaseFormMediator.prototype.init.call(this, config);
    this._showJoinedCommentsNote(config.reportParameters.joinCommentsByTask);
    return this;
};

TTDetailFormMediator.prototype.initParamsStringBuilder = function ( config )
{
    return new ReportParamsStringBuilder().init( {
                                                     cpList: config.cpList,
                                                     users: config.users,
                                                     userGroups: config.userGroups,
                                                     timeZoneGroups: config.timeZoneGroups
                                                 } );
};

TTDetailFormMediator.prototype.initEditConfigController = function ( config ) {
    var self = this;
    return new TTDetailReportEditFormConfigController().init(
        {
            panelId: "mainContainer",
            reportParameters: config.reportParameters,
            cpList: config.cpList,
            users: config.users,
            userGroups: config.userGroups,
            timeZoneGroups: config.timeZoneGroups,
            changeCallback: function(){ self.changeParametersCallback()}
        } )
};

TTDetailFormMediator.prototype.initCsvGenerator = function(){
    return new TTDetailCSVPreviewGenerator().init();
};

TTDetailFormMediator.prototype.initHtmlGenerator = function() {
    return new TTDetailHTMLPreviewGenerator().init();
};

TTDetailFormMediator.prototype.changeParametersCallback = function(){
    TTDetailFormMediator.superproto.changeParametersCallback.call(this);
    if (this.configController)
        this._showJoinedCommentsNote(this.configController.getJoinCommentsByTask());
};

TTDetailFormMediator.prototype._createJoinedCommentsNote = function() {
    var element = $(document.createElement("div"));
    element.addClass("joinCommentsNote");
    element.html(messageResource.getMessage("reports.comments_report.form.format.joined_comments_note"));
    $(".reportPreviewArea").append(element);
    return element;

};
TTDetailFormMediator.prototype._showJoinedCommentsNote = function( isShowed ) {
    if (!this.commentsNoteElement){
        this.commentsNoteElement = this._createJoinedCommentsNote();
    }
    var element = this.commentsNoteElement;
    if (isShowed){
        element.removeClass("hide");
    } else {
        element.addClass("hide");
    }
};
