function TTDetailReportMediator ()
{
    this.constructor = TTDetailReportMediator;
}

TTDetailReportMediator.prototype = new OldReportMediator();

TTDetailReportMediator.prototype.init = function ( config )
{
    OldReportMediator.prototype.init.call(this, config);

    return this;
};

TTDetailReportMediator.prototype.getReportType = function()
{
    return ReportType.TIME_TRACK_IN_DETAIL;
};

TTDetailReportMediator.prototype.initEditConfigController = function( config )
{
    var self = this;
    return new TTDetailReportEditResultConfigController().init(
            {
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                users: config.users,
                userGroups: config.userGroups,
                timeZoneGroups: config.timeZoneGroups,
                changeCallback: function(){ self.changeParametersCallback(); }
            } );
};

TTDetailReportMediator.prototype.initPrintableHeadersBuilder = function( config ) {
    return new ReportPrintableHeadersBuilder().init(
            {
                reportParameters: config.reportParameters,
                cpList: config.cpList,
                users: config.users,
                userGroups: config.userGroups,
                timeZoneGroups: config.timeZoneGroups,
                isFilteredByAssignments: config.isFilteredByAssignments
            }
    );
};

TTDetailReportMediator.prototype._populateHeadersArray = function( headersArray ) {
    this.printableHeadersBuilder.addCPSelectionParamsStringToArray( this.reportParameters.customersProjectsSelection, headersArray ); //customers and projects
    this.printableHeadersBuilder.addStaffSelectionParamsToArray( this.reportParameters.userSelection, headersArray ); //staff
    this.printableHeadersBuilder.addTimeApprovalStatusToArray( this.reportParameters.timeApprovalStatus, headersArray ); //time approval status
};