Ext.namespace("AT");

AT.CreateReportButton = Ext.extend(Ext.Container,
{
    //todo cnf
    buttonText: "",
    createConfigCallback: Ext.emptyFn,
    menuCategories: [],

    autoEl: "div",
    layout: "table",
    buttonClass: "graphicButton button createNewReportButton",
    dropdownControlClass: "graphicButton dropdownButton createReportDropdownButton",
    menuCls: "createReportControlMenu",
    menuItems:[],
    menu: null,
    menuShown: false, 
    hideOnResize: false,

    initComponent: function() {
        AT.CreateReportButton.superclass.initComponent.call(this);
        this.createMenu();

        if ( this.menuItems.length == 0 )
        {
            this.buttonClass += " withoutMenu";
            this.dropdownControlClass += " hidden";
        }

        this.baseButton = this.getBaseButton();
        this.dropdownButton = this.getDropdownButton();

        this.add(this.baseButton.button);
        this.add(this.dropdownButton.button);
    },

    createMenu: function()
    {
        this.menuItems = [];
        for (var i = 0; i < this.menuCategories.length; i++)
            addAll(this.menuItems, this.menuCategories[i].createMenuItems());

        this.menu = new Ext.menu.Menu({
            cls: this.menuCls,
            items: this.menuItems
        });
        
        
        this.menu.on("show", this.menuShownHandler, this);
        this.menu.on("hide", this.menuHidden, this);
    },

    menuShownHandler: function () {
        if ( !this.hideOnResize || this.resizeHandlerSet )
            return;

        var self = this;
        doOnceOnWindowResize( function () { self.menu.hide(); self.resizeHandlerSet = false;} );
        this.resizeHandlerSet = true;
    },
    
    menuHidden: function()
    {
        this.dropdownButton.deactivate();        
        this.menuShown = false;
        this.mouseOut();
    },

    toggleMenu: function()
    {
        this.menuShown = !this.menuShown;
        if (this.menuShown)
        {
            this.dropdownButton.activate();
            this.menu.show(this.el.child("table:first"), "tl-bl", null);
        }
        else
        {
            this.dropdownButton.deactivate();
            this.menu.hide();
        }
    },

    mouseOver: function()
    {
        this.baseButton.hover();
        this.dropdownButton.hover();
    },

    mouseOut: function()
    {
        if (!this.menuShown)
        {
            this.dropdownButton.unhover();
        }
        this.baseButton.reset();
    },

    afterRender: function() {
        this.baseButton.button.on("render", function()
        {
            this.baseButton.defineStandardEventHandlers(false, false, true, true);
            this.baseButton.button.el.on("mouseover", this.mouseOver, this);
            this.baseButton.button.el.on("mouseout", this.mouseOut, this);
            this.baseButton.button.el.on("click", this.baseButtonClick, this);
        }, this);

        this.dropdownButton.button.on("render", function()
        {
            this.dropdownButton.button.el.on("mouseover", this.mouseOver, this);
            this.dropdownButton.button.el.on("mouseout", this.mouseOut, this);
            this.dropdownButton.button.el.on("click", this.toggleMenu, this);
        }, this);
    },

    baseButtonClick: function()
    {
        this.baseButton.deactivate();
        this.createConfigCallback(makeHandler(this.dialogHide, this));
    },

    dialogHide: function()
    {
        this.baseButton.reset();
        this.dropdownButton.unhover();
    },

    getBaseButton: function()
    {
        return new GraphicButton(new AT.RectangularBox({
                            cls: this.buttonClass,
                            items: [{
                                xtype: "box",
                                autoEl: {
                                    tag: "div",
                                    html: "<span unselectable='on'>"+this.buttonText+"</span>"
                                }
                            }]
                        }));
    },

    getDropdownButton: function()
    {
        return new GraphicButton(new AT.RectangularBox({
                cls: this.dropdownControlClass,
                items: [{
                                xtype: "box",
                                autoEl: {
                                    tag: "span",
                                    html:"<img src='" + imgPath( "pixel.gif" ) + "' width='1' height='1'>" // IE doesn't draw table cell borders if there are no tags inside the cell
                                }
                            }]
            }));
    }
});