/**
 * Created by filatov on 14.08.2015.
 */
AT.ReportsSelectorUsersPanel = Ext.extend(AT.UsersSelectorPanel, {
    allItemsOptionLabelKey: "users_selector.reports.all_users",
    customOptionLabelKey: "users_selector.reports.selected_users",
    showInactiveLabelKey: "users_selector.reports.show_disabled",
    predefinedState: null,
    hasPanel: true,
    resetOnHide: false,

    makeSelectionHelper: function ()
    {
        AT.ReportsSelectorUsersPanel.superclass.makeSelectionHelper.call( this );
        this.selectionHelper.prefixTextForGroupsKey = "users_selector.reports.all_items_from";
    },

    initialize: function ( userGroupsEnabled, timeZoneGroupsEnabled, users, userGroups, timeZoneGroups )
    {
        var state =  this.isAlreadyShown() ? this.getState() : this.predefinedState;

        if( !state.optionValue && !state.showInactive )
        {
            var selectedUserIds = state.selection.getSecondLevel();

            for( var i = 0; i < users.length; i++ )
            {
                if( selectedUserIds.indexOf( users[i].id ) != -1 )
                {
                    if( !users[i].active )
                    {
                        state.showInactive = true;
                        break;
                    }
                }
            }
        }

        AT.ReportsSelectorUsersPanel.superclass.initialize.call( this, userGroupsEnabled, timeZoneGroupsEnabled, users, userGroups, timeZoneGroups );

        this.alreadyShown = false;
        this.clearPanel();
        
        this.loadState( state );

        this.selectorFilter.setShowInactive(state.showInactive);
    },

    setPredefinedState: function ( predefinedState )
    {
        this.predefinedState = predefinedState
    },

    validateIsUsersSelected: function(){
        return !this.isCustomOptionSelected() || !this.getSelection().isEmpty();
    },


    makeSelectionTree: function ()
    {
        //do nothing
    },

    setInitialValueFromCurrent: function(){

        if(this.isAlreadyShown())
        {
            this.setFilterFlag(this.getShowInactive());
            this.selectorTree.initializeByNodeSet(this.makeNodeSet(this.getSelection()));
            this.setInitialOptionValue( !this.isCustomOptionSelected());
            this.updateInitialTreeSet();
            this.updateInitialGroupType();
        }
    },

    initComponent: function() {
        AT.ReportsSelectorUsersPanel.superclass.initComponent.call( this );
        this.collapsedCookiesKey += "CollapsedUsers";
        this.on("afterlayout", function (){
            var parentNode = this.getEl().findParentNode( "div.at-selector-menu",10,true );
            if( parentNode ) parentNode.addClass("usersSelectorType");
        }, this);
    },

    isStateChanged: function() {
        if (this.isAlreadyShown()) {
            return AT.ReportsSelectorUsersPanel.superclass.isStateChanged.call(this);
        } else {
            return false;
        }
    }
} );