function ChartDataController() {
}

ChartDataController.prototype.init = function( chartPoints )
{
    this.chartPoints = chartPoints;
    this.values = this.getValues();
    this.calculateTotalMaxMin();
    return this;
};

ChartDataController.prototype.updateData = function( chartPoints )
{
    this.chartPoints = chartPoints;
    this.values = this.getValues();
    this.calculateTotalMaxMin();
};

ChartDataController.prototype.getValues = function () {
    return $.map( this.chartPoints, function ( x )
    {
        return x.value;
    } );
};

ChartDataController.prototype.getCountPoints = function () {
    return this.chartPoints.length;
};

ChartDataController.prototype.getTotal = function (){
    return this.total ? this.total : 0;
};
ChartDataController.prototype.getMaxValue = function (){
    return this.maxValue;
};
ChartDataController.prototype.getMinValue = function (){
    return this.minValue;
};

ChartDataController.prototype.calculateTotalMaxMin = function ()
{
    if (!this.values || !this.values.length) {
        return;
    }

    var min = this.values[0];
    var max = this.values[0];
    var total = 0;
    $.each( this.values, function ()
                         {
                             if(this > max)
                                 max = this;
                             if(this < min)
                                 min = this;
                             total += this;
                         } );

    this.total = total;
    this.minValue = min;
    this.maxValue = max;
};