function ChartMediator() {}

ChartMediator.prototype.init = function( createChartButtonElementId )
{
    var self = this;
    if ( createChartButtonElementId )
        Ext.apply( Ext.getCmp( createChartButtonElementId ), { clickAction: function(){self.loadNewChartData()} } );
    return this;
};

ChartMediator.prototype.showCreateChartLightbox = function(popupData, chartType, chartDataParameters, chartDisplayParameters,
                                                           chartPoints, makeChartPointsException, chartId, chartName)
{
    var ua = navigator.userAgent.toLowerCase();
    var isIE8 = ua.indexOf("msie 8") > -1;
    var isIE9 = ua.indexOf("msie 9") > -1;

    var createChartLightboxConstructor = isIE8 || isIE9 ? CreateChartWithoutExportLightbox : CreateChartLightbox;

    new createChartLightboxConstructor().init( {
                                        popupId: "createChartLightbox",
                                        closeBtnId: "closeCreateChartLightboxButton",
                                        chartContainerId: "chartContainer",
                                        partsContainerId: "chartPart",
                                        totalValueContainer: ".grandTotalValue",
                                        chartPopupData: popupData,
                                        chartType: chartType,
                                        chartDataParameters: chartDataParameters,
                                        chartDisplayParameters: chartDisplayParameters,
                                        chartPoints: chartPoints,
                                        makeChartPointsException: makeChartPointsException,
                                        chartId: chartId,
                                        chartName: chartName
                                    } ).show();
};

ChartMediator.prototype.loadNewChartData = function()
{
    var self = this;
    this.showLoadingPopup();
    makeRpcCall("ReportChartService.getNewChartData",
                [],
                function (result)
                {
                    self.hideLoadingPopup();
                    self.showCreateChartLightbox(result.popupData, result.chartType, result.chartDataParameters,
                                                 result.chartDisplayParameters, result.chartPoints,
                                                 result.makeChartPointsException, null, null);
                },
                function ( jqXHR, textStatus, errorThrown )
                {
                    self.hideLoadingPopup();
                    return false;
                }
    );
};

ChartMediator.prototype.showChart = function( configId )
{
    var self = this;
    this.showLoadingPopup();
    makeRpcCall("ReportChartService.getChartData",
                [ configId ],
                function (result)
                {
                    self.hideLoadingPopup();
                    self.showCreateChartLightbox(result.popupData, result.reportConfig.type,
                                                 result.reportConfig.configParams.dataParameters,
                                                 result.reportConfig.configParams.displayParameters,
                                                 result.chartPoints, result.makeChartPointsException,
                                                 result.reportConfig.id, result.reportConfig.name);
                },
                function ( jqXHR, textStatus, errorThrown )
                {
                    self.hideLoadingPopup();
                    if ( errorThrown.exception == "com.actimind.actitime.reports.NoSuchReportConfigException" ||
                         errorThrown.exception == "com.actimind.actitime.reports.charts.ReportConfigOfAnotherUserException")
                    {
                        alert( messageResource.getMessage( "saved_reports.load.no_such_chart_config" ) );
                        document.location.reload();
                        return true;
                    }
                    return false;
                }
    );
};

ChartMediator.prototype.showLoadingPopup = function ()
{
    this.loadingPopup = new LoadingPopup().init( "reportChartLoadingPopup" );
    this.loadingPopup.show();
};

ChartMediator.prototype.hideLoadingPopup = function ()
{
    this.loadingPopup.hide();
};
