/**
 * @author filatov
 */
function ChartThemeSelector(){}

ChartThemeSelector.prototype.init = function(selectorId,themeValue, changeCallback ){
    var themeSelectorItems = [
        {
            text: messageResource.getMessage("report.create_chart.theme.none"),
            value: ChartPieTheme.NONE
        },
        {
            text: messageResource.getMessage("report.create_chart.theme.light"),
            value: ChartPieTheme.LIGHT
        }
    ];
    this.themeSelectorEl = document.getElementById(selectorId);
    $(this.themeSelectorEl).empty();
    this.themeSelector = new ListSelector({
                                               menuCls: "themeSelectorId",
                                               renderTo: this.themeSelectorEl,
                                               value: themeValue,
                                               listItems: themeSelectorItems
                                           });
    this.themeSelector.on( "change", function () { if(changeCallback) changeCallback() });
    return this;
};

ChartThemeSelector.prototype.getThemeValue = function(){
    switch( this.themeSelector.getSelectedItem().value )
    {
        case ChartPieTheme.NONE: return "none";
        case ChartPieTheme.LIGHT: return "light";
    }
};

ChartThemeSelector.prototype.getThemeName = function(){
    return this.themeSelector.getSelectedItem().value;
};



