function CreateChartWithoutExportLightbox() {}

CreateChartWithoutExportLightbox.prototype = new CreateChartLightbox();

CreateChartWithoutExportLightbox.prototype.init = function ( config )
{
    CreateChartLightbox.prototype.init.call( this, config );
    $("#" + config.popupId ).addClass("withoutExport");
    this.successCallback = null;
    this.disableCommitButton();

    this.exportDisabledTooltip = new TableTooltip().init( "chartExportDisabledTooltip" );

    var self = this;
    $( this.commitButton ).hover( function( event ) { self.showExportDisabledTooltip( event ) },
                                  function() { self.hideExportDisabledTooltip(); } );
    $( this.commitButton ).mousemove( function ( event ) { self.moveExportDisabledTooltip( event ) } );

    return this;
};

CreateChartWithoutExportLightbox.prototype.initPdfPreviewViewController = function ( config )
{
    // do nothing
};

CreateChartWithoutExportLightbox.prototype.cancelAllExportingProcesses = function ()
{
    // do nothing
};

CreateChartWithoutExportLightbox.prototype.commit = function ( config )
{
    // do nothing
};

CreateChartWithoutExportLightbox.prototype.enableCommitButton = function ()
{
    // commit button is always disabled
};

CreateChartWithoutExportLightbox.prototype.showExportDisabledTooltip = function( event )
{
    this.exportDisabledTooltip.updateUIAndShow( null, calculateTooltipOffset( this.exportDisabledTooltip, event ));
};

CreateChartWithoutExportLightbox.prototype.moveExportDisabledTooltip = function( event )
{
    this.exportDisabledTooltip.move( calculateTooltipOffset( this.exportDisabledTooltip, event ) );
};

CreateChartWithoutExportLightbox.prototype.hideExportDisabledTooltip = function()
{
    this.exportDisabledTooltip.hide();
};
