function ChartParametersFormatter () {}

ChartParametersFormatter.prototype = _.create(ParametersFormatter.prototype, {
    formatChartTypeValue: function(chartType)
    {
        var key;
        switch (chartType)
        {
            case ReportChartType.TOTAL_WORKING_HOURS:
                key = "report.chart_type.total_working_hours";
                break;
            case ReportChartType.APPROVED_WORKING_HOURS:
                key = "report.chart_type.approved_working_hours";
                break;
            case ReportChartType.LEAVE_HOURS:
                key = "report.chart_type.leave_hours";
                break;
            case ReportChartType.PTO_BALANCE:
                key = "report.chart_type.pto_balance";
                break;
            case ReportChartType.SICK_DAYS_BALANCE:
                key = "report.chart_type.sick_days_balance";
                break;
            case ReportChartType.OVERTIME_HOURS:
                key = "report.chart_type.overtime_hours";
                break;
            case ReportChartType.COST_OF_WORK:
                key = "report.chart_type.cost_of_work";
                break;
            case ReportChartType.BILLABLE_AMOUNTS:
                key = "report.chart_type.billable_amounts";
        }
        return messageResource.getMessage(key);
    },

    formatGroupingLevelValue: function(groupingLevel)
    {
        var key;
        switch (groupingLevel)
        {
            case ReportGroupingLevel.USER:
                key = "report.chart_pdf_preview.users";
                break;
            case ReportGroupingLevel.USER_GROUP:
                key = "common.user_groups";
                break;
            case ReportGroupingLevel.TIME_ZONE_GROUP:
                key = "common.time_zone_groups";
                break;
            case ReportGroupingLevel.CUSTOMER:
                key = "common.customers";
                break;
            case ReportGroupingLevel.PROJECT:
                key = "common.projects";
                break;
            case ReportGroupingLevel.BILLING_TYPE:
                key = "report.chart_pdf_preview.types_of_work";
                break;
            case ReportGroupingLevel.MONTH:
                key = "report.chart_pdf_preview.months";
                break;
            case ReportGroupingLevel.WEEK:
                key = "report.chart_pdf_preview.weeks";
                break;
            case ReportGroupingLevel.DATE:
                key = "report.chart_pdf_preview.days";
        }
        return messageResource.getMessage(key);
    }
});