function ChartParametersFormattingStrategy () {}

ChartParametersFormattingStrategy.prototype = _.create(BaseParametersFormattingStrategy.prototype, {

    createParametersFormatter: function(selectorsData, dateFormat)
    {
        var ugrEnabled = selectorsData.enabledFeatures ?
                         selectorsData.enabledFeatures.hasOwnProperty(ReportChartConstants.UGRFeature) :
                         null;
        var tzgEnabled = selectorsData.enabledFeatures ?
                         selectorsData.enabledFeatures.hasOwnProperty(ReportChartConstants.TZGFeature) :
                         null;
        return new ChartParametersFormatter().init(selectorsData, dateFormat, ugrEnabled, tzgEnabled);
    },

    formatMainPartOfLightboxTitle: function(selectedParameters)
    {
        return messageResource.getMessage(
                "report.chart_pdf_preview.title",
                [
                    this.parametersFormatter.formatChartTypeValue(selectedParameters.chartTypeValue),
                    this.parametersFormatter.formatGroupingLevelValue(selectedParameters.groupingLevelValue),
                    this.dateParametersFormattingStrategy.formatForDateInformation(selectedParameters.dateParameters)
                ]
        );
    }
});
