ChartsPDFSettingsPreview.CustomSettingsSection = function($containerEl, printParameters, lightboxId, changesCallback)
{
    TemplateView.call(this, $containerEl);

    // these parameters are updated every time we update preview and saved only when we download pdf file
    this.printParameters = printParameters;
    this.lightboxId = lightboxId; //TODO: make this component markup independent from lightbox at some point
    this.changesCallback = changesCallback;
};

ChartsPDFSettingsPreview.CustomSettingsSection.prototype = _.create(TemplateView.prototype, {
    html: "<div class='dataLayoutSection'>" +
          "  <div class='parametersSectionHeader'><%=dataLayoutLabel%></div>" +
          "  <div class='chartSizeParameter'>" +
          "    <div class='selectorLabel'><%=chartSizeLabel%></div>" +
          "    <div id='<%=id%>_chartSizeSelector'></div>" +
          "    <div class='selectorLabel'><%=barsLabel%></div>" +
          "  </div>" +
          "  <div>" +
          "    <table>" +
          "      <tr>" +
          "        <td><input type='checkbox' id='<%=id%>_showListOfDataValues'/></td>" +
          "        <td><label for='<%=id%>_showListOfDataValues'><%=showDataValuesLabel%></label></td>" +
          "      </tr>" +
          "      <tr class='percentCheckboxTr'>" +
          "        <td><input type='checkbox' id='<%=id%>_showListOfPercentValues'/></td>" +
          "        <td><label for='<%=id%>_showListOfPercentValues'><%=showPercentValuesLabel%></label></td>" +
          "      </tr>" +
          "      <tr class='fitDataCheckboxTr'>" +
          "        <td><input type='checkbox' id='<%=id%>_fitDataToOnePage'/></td>" +
          "        <td><label for='<%=id%>_fitDataToOnePage'><%=fitDataLabel%></label></td>" +
          "      </tr>" +
          "    </table>" +
          "  </div>" +
          "</div>",

    templateModel: function()
    {
        return { id: this.lightboxId }
    },

    messageKeys: function()
    {
        return {
            "dataLayoutLabel": "report.chart_pdf_preview.data_layout",
            "chartSizeLabel": "report.chart_pdf_preview.chart_size",
            "barsLabel": "report.chart_pdf_preview.bars",
            "showDataValuesLabel": "report.chart_pdf_preview.show_data_values_list",
            "showPercentValuesLabel": "report.chart_pdf_preview.show_percent_values_list",
            "fitDataLabel": "report.chart_pdf_preview.fit_data_to_one_page"
        };
    },

    afterRender: function()
    {
        this.fitDataToOnePageCheckbox = this.initFitDataCheckBox();
        // chart size selector is reinitialized every time we switch lightbox to PDF Preview View if chart type is not PIE_CHART, so we do not initialize it here
        this.chartSizeSelectorContainer = document.getElementById(this.lightboxId + "_chartSizeSelector");

        this.initShowValuesCheckboxes();
        this.lastSavedShowListOfPercentValues = ReportChartsStore.getPrintParametersForSave().showListOfPercentValues;
    },

    update: function()
    {
        var printParameters = ReportChartsStore.getPrintParametersForSave();
        this.fitDataToOnePageCheckbox.checked = printParameters.fitDataToOnePage;
        this.showListOfDataValuesCheckbox.checked = printParameters.showListOfDataValues;
        this.showListOfPercentValuesCheckbox.checked = printParameters.showListOfPercentValues;
    },

    initFitDataCheckBox: function()
    {
        var checkBox = document.getElementById(this.lightboxId + "_fitDataToOnePage");
        checkBox.onchange = this.changesCallback;
        return checkBox;
    },

    initShowValuesCheckboxes: function()
    {
        this.showListOfDataValuesCheckbox = document.getElementById(this.lightboxId + "_showListOfDataValues");
        this.showListOfDataValuesCheckbox.onchange = this.changesCallback;

        this.showListOfPercentValuesCheckbox = document.getElementById(this.lightboxId + "_showListOfPercentValues");
        this.showListOfPercentValuesCheckbox.onchange = this.changesCallback;
        this.showListOfPercentValuesCheckboxIsVisible = true;
    }
});
