function ChartPDFParametersFormatter(){}

ChartPDFParametersFormatter.prototype = new ChartParametersFormatter();

ChartPDFParametersFormatter.prototype.init = function( selectorsData, dateFormat ){
    ChartParametersFormatter.prototype.init.call(this, selectorsData, dateFormat);
    return this;
};

ChartPDFParametersFormatter.prototype.formatGrandTotalValueType = function (chartTypeValue) {
    switch (chartTypeValue)
    {
        case ReportChartType.PTO_BALANCE:
            if (SystemSettings.showPTOInHours) {
                return messageResource.getMessage('report.chart_pdf.grand_total_hours');
            } else {
                return messageResource.getMessage('report.chart_pdf.grand_total_days');
            }
        case ReportChartType.SICK_DAYS_BALANCE:
            if (SystemSettings.showSickInHours) {
                return messageResource.getMessage('report.chart_pdf.grand_total_hours');
            } else {
                return messageResource.getMessage('report.chart_pdf.grand_total_days');
            }
        case ReportChartType.TOTAL_WORKING_HOURS:
        case ReportChartType.APPROVED_WORKING_HOURS:
        case ReportChartType.LEAVE_HOURS:
        case ReportChartType.OVERTIME_HOURS:
            return messageResource.getMessage('report.chart_pdf.grand_total_hours');
        case ReportChartType.COST_OF_WORK:
        case ReportChartType.BILLABLE_AMOUNTS:
            return messageResource.getMessage('report.chart_pdf.grand_total_amount');
    }
};

ChartPDFParametersFormatter.prototype.formatGrandTotalPostfix = function (chartTypeValue) {
    switch (chartTypeValue)
    {
        case ReportChartType.PTO_BALANCE:
        case ReportChartType.SICK_DAYS_BALANCE:
            return '';
        case ReportChartType.TOTAL_WORKING_HOURS:
        case ReportChartType.APPROVED_WORKING_HOURS:
        case ReportChartType.LEAVE_HOURS:
        case ReportChartType.OVERTIME_HOURS:
            return messageResource.getMessage('common.mh');
        case ReportChartType.COST_OF_WORK:
        case ReportChartType.BILLABLE_AMOUNTS:
            return SystemSettings.currencySign;
    }
};
