EVAReport.Store = {
    reportData: null,
    usersMap: null,
    projectsMap: null,
    projectNamesMap: null,
    taskNamesMap: null,
    tasksMap: null,
    customersMap: null,
    reportParams: null,
    groupingLevels: null,
    typesOfWorkMap: null,
    timeFormat: null,
    convertedData: null,
    groupingPresentationFlags: null,

    generatedPDF: null,
    fileName: "file.pdf",
    printParametersForSave: {
        paperOrientation: "PORTRAIT",
        paperSize: "A4",
        showHeaderOnEachPage: false,
        showLogoInHeader: true
    },
    printParametersForGenerate: null,

    setConvertedData: function(data)
    {
        this.convertedData = data;
    },

    getConvertedData: function()
    {
        return this.convertedData;
    },

    setGroupingPresentationFlags: function(groupingPresentationFlags)
    {
        this.groupingPresentationFlags = groupingPresentationFlags;
    },

    getGroupingPresentationFlags: function()
    {
        return this.groupingPresentationFlags;
    },

    getGeneratedPDF: function()
    {
        return this.generatedPDF;
    },

    setGeneratedPDF: function(generatedPDF)
    {
        this.generatedPDF = generatedPDF;
        $(this).trigger("generatedPDFChange");
    },

    getPDFFileName: function()
    {
        return this.fileName;
    },

    setPDFFileName: function(fileName)
    {
        this.fileName = fileName;
    },

    getPrintParametersForSave: function()
    {
        return this.printParametersForSave;
    },

    setPrintParametersForSave: function(printParametersForSave)
    {
        this.printParametersForSave = printParametersForSave;
        $(this).trigger("printParametersForSaveChange");
    },

    getPrintParametersForGenerate: function()
    {
        return this.printParametersForGenerate;
    },

    setPrintParametersForGenerate: function(printParametersForSave)
    {
        this.printParametersForGenerate = printParametersForSave;
    },
    
    getGroupingLevels: function()
    {
        return this.groupingLevels;
    },

    setReportData: function(reportData, customersMap, projectsMap, tasksMap, usersMap, projectNamesMap, taskNamesMap, typesOfWorkMap)
    {
        this.reportData = reportData;
        this.customersMap = customersMap;
        this.projectsMap = projectsMap;
        this.tasksMap = tasksMap;
        this.projectNamesMap = projectNamesMap;
        this.taskNamesMap = taskNamesMap;
        this.usersMap = usersMap;
        this.typesOfWorkMap = typesOfWorkMap;
    },

    getCustomers: function()
    {
        return this.customersMap;
    },

    getProjects: function()
    {
        return this.projectsMap;
    },

    getTasks: function()
    {
        return this.tasksMap;
    },

    getProjectNames: function()
    {
        return this.projectNamesMap;
    },

    getTaskNames: function()
    {
        return this.taskNamesMap;
    },

    getUsers: function()
    {
        return this.usersMap;
    },

    getTypesOfWork: function()
    {
        return this.typesOfWorkMap;
    },

    getTypeOfWork: function(id)
    {
        return this.typesOfWorkMap[id];
    },

    getCustomer: function(id)
    {
        return this.customersMap[id];
    },

    getTask: function(id)
    {
        return this.tasksMap[id];
    },

    getTaskName: function(id)
    {
        return this.taskNamesMap[id];
    },

    getUser: function(id)
    {
        return this.usersMap[id];
    },

    getProject: function(id)
    {
        return this.projectsMap[id];
    },

    getProjectName: function(id)
    {
        return this.projectNamesMap[id];
    },

    getReportData: function()
    {
        return this.reportData;
    },

    getReportParams: function()
    {
        return this.reportParams;
    },

    getTimeFormat: function()
    {
        return this.timeFormat;
    },

    setReportParams: function(reportParams)
    {
        this.reportParams = reportParams;
        this.timeFormat = reportParams.timeFormat;
        var levels = [];
        levels.push(reportParams.firstGroupingLevel);
        levels.push(reportParams.secondGroupingLevel);
        levels.push(reportParams.thirdGroupingLevel);
        levels.push(reportParams.fourthGroupingLevel);
        this.groupingLevels = levels;
    }
};