EVAReport.ParametersFormatter = function() {};

EVAReport.ParametersFormatter.prototype = _.create(ParametersFormatter.prototype, {

    init: function(selectorsData, dateFormat)
    {
        this.reportParamsStringBuilder = new ReportParamsStringBuilder().init(
                {
                    users: selectorsData.users,
                    cpList: selectorsData.cpList,
                    statuses: selectorsData.statuses
                },
                dateFormat
        );
        return this;
    },

    formatTaskSelectionParamsString: function(tasksConfig, includeNotEstimated, includeNotStarted, dateSelectionWrap)
    {
        var dateSelection = dateSelectionWrap.dateSelection;
        var showOpenTasks = tasksConfig == "ALL" || tasksConfig == "OPEN_ONLY";
        var showCompletedTasks = tasksConfig == "ALL" || tasksConfig == "COMPLETED_ONLY";

        var keyPrefix = '';

        if (showOpenTasks)
        {
            if (showCompletedTasks)
                keyPrefix = "report.budgeted_vs_actual.filter_view.open_and_completed_tasks";
            else
                keyPrefix = "report.budgeted_vs_actual.filter_view.open_tasks";
        }
        else if (showCompletedTasks)
            keyPrefix = "report.budgeted_vs_actual.filter_view.completed_tasks";

        var value = messageResource.getMessage(keyPrefix);

        var addition1 = "",
                addition2 = "",
                separator = "";

        if (!includeNotStarted)
        {
            var date = dateSelectionWrap.isParsed ? dateSelection.date : dateSelection.date.parseJSONDate();
            addition1 = messageResource.getMessage(
                    "report.budgeted_vs_actual.filter_view.tasks_started_after",
                    [new DateFormat(SystemSettings.dateFormat).formatDate(date) + ", " + Date.dayNames[date.getDay()]]
            );
        }

        if (!includeNotEstimated)
        {
            addition2 = messageResource.getMessage("report.budgeted_vs_actual.filter_view.not_budgeted_tasks");
        }

        if (addition1 || addition2)
        {
            if (addition1 && addition2)
                separator = " & ";
            value += " (" + messageResource.getMessage("report.budgeted_vs_actual.filter_view.except")
                     + " " + addition1 + separator + addition2 + ")";
        }
        return value;
    }
});