EVAReport.ParametersFormattingStrategy = function() {};

EVAReport.ParametersFormattingStrategy.prototype = _.create(BaseParametersFormattingStrategy.prototype, {

    init: function(selectorsData, dateFormat, productSettingsValidator, reportRightsValidator)
    {
        BaseParametersFormattingStrategy.prototype.init.call(this, selectorsData, dateFormat);
        this.productSettingsValidator = productSettingsValidator;
        this.reportRightsValidator = reportRightsValidator;
        this.assignedInfo = selectorsData.assignedInfo;

        return this;
    },

    createParametersFormatter: function(selectorsData, dateFormat)
    {
        return new EVAReport.ParametersFormatter().init(selectorsData, dateFormat);
    },

    createDateParametersFormattingStrategy: function(dateFormat)
    {
        return new SingleDateFormattingStrategy().init(dateFormat);
    },

    formatMainPartOfLightboxTitle: function(selectedParameters)
    {
        var showBy = BaseReport.FormatUtils.prototype.formatGroupingLevel(selectedParameters.firstGroupingLevel);
        var dateParameters = this.dateParametersFormattingStrategy.formatForDateInformation(selectedParameters.dateParameters);
        return messageResource.getMessage("estimate_vs_actual_report.title", [showBy, dateParameters]);
    },

    formatParametersText: function(selectedParameters)
    {
        return this.parametersFormatter.formatCustomersAndProjectsSelection(selectedParameters.customersProjectsSelection) + "; " +
               this.parametersFormatter.formatTaskSelectionParamsString(selectedParameters.tasksConfig,
                                                                        selectedParameters.includeNotEstimated,
                                                                        selectedParameters.includeNotStarted,
                                                                        {dateSelection: selectedParameters.dateParameters.dateSelection, isParsed: true});
    }
});