EVAReport.Table.HeaderRowFull = function($containerEl, groupingLevels)
{
    TemplateView.call(this, $containerEl);
    this.groupingLevels = groupingLevels;
};

EVAReport.Table.HeaderRowFull.prototype = _.create(TemplateView.prototype, {
    html: "<tr class='new_report_header'>" +
          "  <td rowspan='3' colspan='1'>" +
          "     <span class='groupingLevel1'><%-firstLevelName%></span>" +
          "     <span class='separatorGroupingLevel2'>/</span>" +
          "     <span class='groupingLevel2'><%-secondLevelName%></span>" +
          "     <span class='separatorGroupingLevel3'>/</span>" +
          "     <span class='groupingLevel3'><%-thirdLevelName%></span>" +
          "     <span class='separatorGroupingLevel4'>/</span>" +
          "     <span class='groupingLevel4'><%-fourthLevelName%></span>" +
          "  </td>" +
          "  <td class='data_column_header timeSpentColumn' rowspan='3'><%-timeSpent%></td>" +
          "  <td class='data_column_header timeForNotEstimateColumn' rowspan='3'><%-timeForNotEstimate%></td>" +
          "  <td class='data_column_superheader' rowspan='1' colspan='4'><%-estimatedTasks%></td>" +
          "</tr>" +
          "<tr class='new_report_header'>" +
          "    <td rowspan='2' class='data_column_header subheader' valign='middle' style='padding-top:6px'><%-spentTime%></td>" +
          "    <td rowspan='2' class='data_column_header subheader' valign='middle' style='padding-top:6px'><%-estimatedTime%></td>" +
          "    <td colspan='2' class='data_column_superheader subheader' nowrap=''>" +
          "        <%-variance%><br><span class='header_note'>(<%-estimatedMinusSpent%>)</span>" +
          "    </td>" +
          "</tr>" +
          "<tr class='new_report_header'>" +
          "    <td class='data_column_header subheader' style='font-size:10px;padding:2px'><%-mh%></td>" +
          "    <td class='data_column_header subheader' style='font-size:10px;padding:2px' ><%-percent%></td>" +
          "</tr>",

    messageKeys: function()
    {
        return {
            mh: "report.budgeted_vs_actual.variance.mh",
            percent: "report.budgeted_vs_actual.variance.percent",
            spentTime: "report.budgeted_vs_actual.spent_time",
            estimatedTime: "report.budgeted_vs_actual.budgeted",
            variance: "report.budgeted_vs_actual.variance",
            estimatedMinusSpent: "report.budgeted_vs_actual.budgeted_minus_spent",
            timeSpent: "report.budgeted_vs_actual.spent_time.total",
            timeForNotEstimate: "report.budgeted_vs_actual.spent_time.nonbudgeted",
            estimatedTasks: "report.budgeted_vs_actual.spent.budgeted_tasks"
        };
    },

    templateModel: function()
    {
        return {
            firstLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[0]),
            secondLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[1]),
            thirdLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[2]),
            fourthLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[3])
        }
    },

    afterRender: function()
    {
        if (this.groupingLevels[1] == ReportGroupingLevel.NONE) {
            $(".separatorGroupingLevel2").hide();
            $(".groupingLevel2").hide();
        }
        if (this.groupingLevels[2] == ReportGroupingLevel.NONE) {
            $(".separatorGroupingLevel3").hide();
            $(".groupingLevel3").hide();
        }
        if (this.groupingLevels[3] == ReportGroupingLevel.NONE) {
            $(".separatorGroupingLevel4").hide();
            $(".groupingLevel4").hide();
        }
    }
});