EVAReport.Table.HeaderRowParticle = function($containerEl, groupingLevels)
{
    TemplateView.call(this, $containerEl);
    this.groupingLevels = groupingLevels;
};

EVAReport.Table.HeaderRowParticle.prototype = _.create(TemplateView.prototype, {
    html: "<tr class='new_report_header'>" +
          "   <td rowspan='2' colspan='1' class='firstCell'>" +
          "     <span class='groupingLevel1'><%-firstLevelName%></span>" +
          "     <span class='separatorGroupingLevel2'>/</span>" +
          "     <span class='groupingLevel2'><%-secondLevelName%></span>" +
          "     <span class='separatorGroupingLevel3'>/</span>" +
          "     <span class='groupingLevel3'><%-thirdLevelName%></span>" +
          "     <span class='separatorGroupingLevel4'>/</span>" +
          "     <span class='groupingLevel4'><%-fourthLevelName%></span>" +
          "   </td>" +
          "   <td rowspan='2' class='data_column_header'><%-spentTime%></td>" +
          "   <td rowspan='2' class='data_column_header'><%-estimatedTime%></td>" +
          "   <td colspan='2' class='data_column_superheader' nowrap=''>" +
          "      <%-variance%><br><span class='header_note'>(<%-estimatedMinusSpent%>)</span>" +
          "   </td>" +
          "</tr>" +
          "<tr class='new_report_header bottom'>" +
          "    <td class='data_column_header'><%-mh%></td>" +
          "    <td class='data_column_header'><%-percent%></td>" +
          "</tr>",

    messageKeys: function()
    {
        return {
            mh: "report.budgeted_vs_actual.variance.mh",
            percent: "report.budgeted_vs_actual.variance.percent",
            spentTime: "report.budgeted_vs_actual.spent_time",
            estimatedTime: "report.budgeted_vs_actual.budgeted",
            variance: "report.budgeted_vs_actual.variance",
            estimatedMinusSpent: "report.budgeted_vs_actual.budgeted_minus_spent",
            timeSpent: "report.budgeted_vs_actual.spent_time.total",
            timeForNotEstimate: "report.budgeted_vs_actual.spent_time.nonbudgeted",
            estimatedTasks: "report.budgeted_vs_actual.spent.budgeted_tasks"
        };
    },

    templateModel: function()
    {
        return {
            firstLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[0]),
            secondLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[1]),
            thirdLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[2]),
            fourthLevelName: EVAReport.FormatUtils.formatGroupingLevel(this.groupingLevels[3])
        }
    },

    afterRender: function()
    {
        if (this.groupingLevels[1] == ReportGroupingLevel.NONE) {
            $(".separatorGroupingLevel2").hide();
            $(".groupingLevel2").hide();
        }
        if (this.groupingLevels[2] == ReportGroupingLevel.NONE) {
            $(".separatorGroupingLevel3").hide();
            $(".groupingLevel3").hide();
        }
        if (this.groupingLevels[3] == ReportGroupingLevel.NONE) {
            $(".separatorGroupingLevel4").hide();
            $(".groupingLevel4").hide();
        }
    }
});