EVAReport.Table = function($containerEl, store)
{
    TemplateView.call(this, $containerEl);
    this.store = store;
};

EVAReport.Table.prototype = _.create(TemplateView.prototype, {
    html: "<table class='display-for-print report-table' border='0' cellpadding='4' id='report-table'></table>",

    updateOnInit: false,

    update: function()
    {
        var reportData = this.store.getReportData();
        var reportParams = this.store.getReportParams();

        EVAReport.Store.setConvertedData(new EVAReport.TableDataConverter(reportData, reportParams).convert());
        EVAReport.Store.setGroupingPresentationFlags(EVAReport.FormatUtils.makeGroupingPresentationFlags(this.store.getGroupingLevels()));
        
        var rows = EVAReport.Store.getConvertedData();

        this.$el.empty();

        if (this.rowInsertProcessor)
            this.rowInsertProcessor.pause();

        this.rowInsertProcessor = new ChunkIterator(rows, 20, function(row)
        {
            var config = _.clone(row);
            var includeNotEstimated = reportParams.includeNotEstimated;
            var store = this.store;
            switch (row.type)
            {
                case BaseTableDataConverter.RowType.HEADER:
                    if (includeNotEstimated)
                        new EVAReport.Table.HeaderRowFull(this.$el, store.getGroupingLevels()).init();
                    else
                        new EVAReport.Table.HeaderRowParticle(this.$el, store.getGroupingLevels()).init();

                    break;
                case BaseTableDataConverter.RowType.TOTALS:
                    new EVAReport.Table.DataRow(this.$el, config, store, includeNotEstimated, "root").init();
                    break;
                case BaseTableDataConverter.RowType.FIRST_LEVEL:
                    new EVAReport.Table.DataRow(this.$el, config, store, includeNotEstimated, "level1").init();
                    break;
                case BaseTableDataConverter.RowType.SECOND_LEVEL:
                    new EVAReport.Table.DataRow(this.$el, config, store, includeNotEstimated, "level2").init();
                    break;
                case BaseTableDataConverter.RowType.THIRD_LEVEL:
                    new EVAReport.Table.DataRow(this.$el, config, store, includeNotEstimated,"level3").init();
                    break;
                case BaseTableDataConverter.RowType.FORTH_LEVEL:
                    new EVAReport.Table.DataRow(this.$el, config, store, includeNotEstimated,"details").init();
                    break;
            }
        }, this).start();
    }
});