EVAReport.TableDataConverter = function(data, params)
{
    BaseTableDataConverter.call(this, data, params);
    this.groupingLevels = [params.firstGroupingLevel,
                           params.secondGroupingLevel,
                           params.thirdGroupingLevel,
                           params.fourthGroupingLevel];
};

EVAReport.TableDataConverter.prototype = _.create(BaseTableDataConverter.prototype, {
    _createHeader: function()
    {
        return {
            type: BaseTableDataConverter.RowType.HEADER
        };
    },

    _createDataRow: function(level, type, groupingType, item)
    {
        var dataRow = _.pick(item,
                             'id',
                             'totalSpentTime',
                             'estimatedTime',
                             'spentTimeForEstimated',
                             'spentTimeForNotEstimated',
                             'varianceTime',
                             'varianceTimeInPercentage');
        dataRow.level = level;
        dataRow.type = type;
        dataRow.groupingType = groupingType;
        return dataRow;
    },

    getGroupingLevels: function(params)
    {
        var array = [];
        array.push(params.firstGroupingLevel);
        array.push(params.secondGroupingLevel);
        array.push(params.thirdGroupingLevel);
        array.push(params.fourthGroupingLevel);
        return array;
    },

    getGroupingLevelsCollapsed: function(groupingLevels)
    {
        return EVAReport.ConvertUtils.getGroupingLevelsCollapsed(groupingLevels)
    }
});

