/**
 * Has common store components for Leaves report, its PDF export etc
 */
LeavesReport.ReportStoreMixin = {
    reportData: null,
    reportParams: null,
    usersMap: null,
    userGroupsMap: null,
    timeZoneGroupsMap: null,
    defaultWorkDayDuration: null,
    generatedPDF: null,
    fileName: "file.pdf",
    printParametersForSave: {
        paperOrientation: "PORTRAIT",
        paperSize: "A4",
        showHeaderOnEachPage: false,
        showLogoInHeader: true
    },
    printParametersForGenerate: null,
    showAssignedOnlyEnabled: false,
    showAssignedOnly: false,
    viewerInfo: null,
    chartSectionConfig: {showChart: false},

    getReportData: function()
    {
        return this.reportData;
    },

    setReportData: function(reportData, usersMap, userGroupsMap, timeZoneGroupsMap)
    {
        this.reportData = reportData;
        this.usersMap = usersMap;
        this.userGroupsMap = userGroupsMap;
        this.timeZoneGroupsMap = timeZoneGroupsMap;
        $(this).trigger("reportDataChange");
    },

    getReportParams: function()
    {
        return this.reportParams;
    },

    setReportParams: function(reportParams)
    {
        this.reportParams = reportParams;
        $(this).trigger("reportParamsChange");
    },

    getUsers: function()
    {
        return this.usersMap;
    },

    getUserGroups: function()
    {
        return this.userGroupsMap;
    },

    getTimeZoneGroups: function()
    {
        return this.timeZoneGroupsMap;
    },

    getUser: function(id)
    {
        return this.usersMap[id]
    },

    getUserGroup: function(id)
    {
        return this.userGroupsMap[id]
    },

    getTimeZoneGroup: function(id)
    {
        return this.timeZoneGroupsMap[id]
    },

    getGeneratedPDF: function()
    {
        return this.generatedPDF;
    },

    setGeneratedPDF: function(generatedPDF)
    {
        this.generatedPDF = generatedPDF;
        $(this).trigger("generatedPDFChange");
    },

    getPDFFileName: function()
    {
        return this.fileName;
    },

    setPDFFileName: function(fileName)
    {
        this.fileName = fileName;
    },

    getPrintParametersForSave: function()
    {
        return this.printParametersForSave;
    },

    setPrintParametersForSave: function(printParametersForSave)
    {
        this.printParametersForSave = printParametersForSave;
        $(this).trigger("printParametersForSaveChange");
    },

    getPrintParametersForGenerate: function()
    {
        return this.printParametersForGenerate;
    },

    setPrintParametersForGenerate: function(printParametersForSave)
    {
        this.printParametersForGenerate = printParametersForSave;
    },

    isShowAssignedOnlyEnabled: function()
    {
        return this.showAssignedOnlyEnabled;
    },

    setShowAssignedOnlyEnabled: function(showAssignedOnlyEnabled)
    {
        this.showAssignedOnlyEnabled = showAssignedOnlyEnabled;
    },

    getViewerInfo: function()
    {
        return this.viewerInfo;
    },

    setViewerInfo: function(viewerInfo){
        this.viewerInfo = viewerInfo
    },

    isShowAssignedOnly: function()
    {
        return this.showAssignedOnly;
    },

    setShowAssignedOnly: function(showAssignedOnly)
    {
        this.showAssignedOnly = showAssignedOnly;
    },

    getChartSectionConfig: function()
    {
        return this.chartSectionConfig;
    },

    setChartSectionConfig: function(chartSectionConfig)
    {
        this.chartSectionConfig = chartSectionConfig;
        $(this).trigger("chartSectionConfigChange");
    },

    getDefaultWorkDayDuration: function()
    {
        return this.defaultWorkDayDuration;
    },

    setDefaultWorkDayDuration: function(defaultWorkDayDuration)
    {
        this.defaultWorkDayDuration = defaultWorkDayDuration;
    }
};