LeavesReport.ParametersFormattingStrategy = function() {};

LeavesReport.ParametersFormattingStrategy.prototype = _.create(BaseParametersFormattingStrategy.prototype, {

    init: function (selectorsData, dateFormat, productSettingsValidator, reportRightsValidator)
    {
        BaseParametersFormattingStrategy.prototype.init.call(this, selectorsData, dateFormat);
        this.productSettingsValidator = productSettingsValidator;
        this.reportRightsValidator = reportRightsValidator;
        this.assignedInfo = selectorsData.assignedInfo;

        return this;
    },
    
    createParametersFormatter: function(selectorsData, dateFormat)
    {
        return new ParametersFormatter().init(selectorsData, dateFormat, selectorsData.userGroupsEnabled, selectorsData.timeZoneGroupsEnabled);
    },

    createDateParametersFormattingStrategy: function(dateFormat)
    {
        return new DateRangeFormattingStrategy().init(dateFormat);
    },

    formatMainPartOfLightboxTitle: function(selectedParameters)
    {
        var enabledPTO =  this.productSettingsValidator.isPTOEnabled();
        var enabledSick =  this.productSettingsValidator.isSickEnabled();

        var reportTypeText = "";
        if (!this.reportRightsValidator.isCanViewBalances() || (!enabledPTO && !enabledSick))
        {
            reportTypeText = messageResource.getMessage('leave_and_balances_report.title.leave_time');    
        }    
        else
        {
            var balanceMessage = "";
            
            if (enabledPTO && enabledSick)
                balanceMessage = messageResource.getMessage("leave_and_balances_report.title.balances");
            else if (enabledPTO)
                balanceMessage = messageResource.getMessage("leave_and_balances_report.title.pto");
            else if (enabledSick)
                balanceMessage = messageResource.getMessage("leave_and_balances_report.title.sick");

            reportTypeText = messageResource.getMessage('leave_and_balances_report.title.leave_time_and_balances', [balanceMessage]);
        }
        
        var dateParameters = this.dateParametersFormattingStrategy.formatForDateInformation(selectedParameters.dateParameters);
        var grouping = LeavesReport.FormatUtils.formatGroupingLevel(selectedParameters.firstGroupingLevel);
        return messageResource.getMessage("leave_and_balances_report.title", [reportTypeText, grouping, dateParameters]);
    },

    formatParametersText: function(selectedParameters)
    {
        return this.parametersFormatter.formatUsersSelection(selectedParameters.userSelection, this.assignedInfo) + "; " +
               this.parametersFormatter.formatLeaveTypesSelection(selectedParameters.leaveTypeSelection);
    }
});