LeavesReport.Table.HeaderRow = function($containerEl, firstGroupingLevel, secondGroupingLevel, timeFormat, leaveTypeIds, balancesRange, hasPto, hasSick)
{
    TemplateView.call(this, $containerEl);
    this.firstGroupingLevel = firstGroupingLevel;
    this.secondGroupingLevel = secondGroupingLevel;
    this.timeFormat = timeFormat;
    this.leaveTypeIds = leaveTypeIds;
    this.balancesRange = balancesRange;
    this.hasPto = hasPto;
    this.hasSick = hasSick;
};

LeavesReport.Table.HeaderRow.prototype = _.create(TemplateView.prototype, {
    html: "<tr class='headerRow top'>" +
          "  <td class='listtblcolheader firstCell' rowspan='2'><%-firstLevelName%><span class='secondLevel'> / <%-secondLevelName%></span></td>" +
          "  <td class='listtblcolheader totalCell' rowspan='2'>Total<br/>Leave Time<br/><span class='format'>(<%-format%>)</span></td>" +
          "</tr>" +
          "<tr class='headerRow bottom'></tr>",

    afterRender: function()
    {
        this.$topRow = this.$el.eq(0);
        this.$bottomRow = this.$el.eq(1);

        _.each(this.leaveTypeIds, function(leaveTypeId)
        {
            new LeavesReport.Table.HeaderRow.LeaveTypeCell(this.$topRow, leaveTypeId).init();
        }, this);

        if (this.hasPto)
            this._addBalances(BalanceType.PTO);
        if (this.hasSick)
            this._addBalances(BalanceType.SICK);
    },

    templateModel: function()
    {
        return {
            firstLevelName: LeavesReport.FormatUtils.formatGroupingLevel(this.firstGroupingLevel),
            secondLevelName: LeavesReport.FormatUtils.formatGroupingLevel(this.secondGroupingLevel),
            format: LeavesReport.FormatUtils.formatTimeFormat(this.timeFormat)
        }
    },

    _addBalances: function(type)
    {
        if (this.leaveTypeIds && this.leaveTypeIds.length > 0)
            this.$topRow.append("<td class='separator' rowspan='2'></td>");
        new LeavesReport.Table.HeaderRow.BalancesCellTop(this.$topRow, this.balancesRange.startDate, this.balancesRange.endDate, type, this.firstGroupingLevel, this.secondGroupingLevel).init();
        new LeavesReport.Table.HeaderRow.BalancesCellBottom(this.$bottomRow, this.balancesRange.startDate, this.balancesRange.endDate, type, this.firstGroupingLevel, this.secondGroupingLevel).init();
    }
});