OvertimeReport.Store = {
    convertedData: null,
    reportData: null,
    reportParams: null,
    usersMap: null,
    userGroupsMap: null,
    timeZoneGroupsMap: null,

    generatedPDF: null,
    fileName: "file.pdf",
    printParametersForSave: {
        paperOrientation: "PORTRAIT",
        paperSize: "A4",
        showHeaderOnEachPage: false,
        showLogoInHeader: true
    },
    printParametersForGenerate: null,

    getReportData: function()
    {
        return this.reportData;
    },

    setReportData: function(reportData, usersMap, userGroupsMap, timeZoneGroupsMap)
    {
        this.reportData = reportData;
        this.usersMap = usersMap;
        this.userGroupsMap = userGroupsMap;
        this.timeZoneGroupsMap = timeZoneGroupsMap;
        $(this).trigger("reportDataChange");
    },

    getReportParams: function()
    {
        return this.reportParams;
    },

    setReportParams: function(reportParams)
    {
        this.reportParams = reportParams;
        $(this).trigger("reportParamsChange");
    },

    getUsers: function()
    {
        return this.usersMap;
    },

    getUserGroups: function()
    {
        return this.userGroupsMap;
    },

    getTimeZoneGroups: function()
    {
        return this.timeZoneGroupsMap;
    },

    getUser: function(id)
    {
        return this.usersMap[id]
    },

    getUserGroup: function(id)
    {
        return this.userGroupsMap[id]
    },

    getTimeZoneGroup: function(id)
    {
        return this.timeZoneGroupsMap[id]
    },

    getGeneratedPDF: function()
    {
        return this.generatedPDF;
    },

    setGeneratedPDF: function(generatedPDF)
    {
        this.generatedPDF = generatedPDF;
        $(this).trigger("generatedPDFChange");
    },

    getPDFFileName: function()
    {
        return this.fileName;
    },

    setPDFFileName: function(fileName)
    {
        this.fileName = fileName;
    },

    getPrintParametersForSave: function()
    {
        return this.printParametersForSave;
    },

    setPrintParametersForSave: function(printParametersForSave)
    {
        this.printParametersForSave = printParametersForSave;
        $(this).trigger("printParametersForSaveChange");
    },

    getPrintParametersForGenerate: function()
    {
        return this.printParametersForGenerate;
    },

    setPrintParametersForGenerate: function(printParametersForSave)
    {
        this.printParametersForGenerate = printParametersForSave;
    },
    
    getGroupingLevels: function()
    {
        return this.groupingLevels;
    },

    setConvertedData: function(data)
    {
        this.convertedData = data;
    },

    getConvertedData: function()
    {
        return this.convertedData;
    },
    
    getTimeFormat: function()
    {
        return this.timeFormat;
    }
};