OvertimeReport.ParametersFormattingStrategy = function() {};

OvertimeReport.ParametersFormattingStrategy.prototype = _.create(BaseParametersFormattingStrategy.prototype, {

    init: function(selectorsData, dateFormat, productSettingsValidator, reportRightsValidator)
    {
        BaseParametersFormattingStrategy.prototype.init.call(this, selectorsData, dateFormat);
        this.productSettingsValidator = productSettingsValidator;
        this.reportRightsValidator = reportRightsValidator;
        this.assignedInfo = selectorsData.assignedInfo;
        this.formatUtil = OvertimeReport.FormatUtils;

        return this;
    },

    createParametersFormatter: function(selectorsData, dateFormat)
    {
        return new OvertimeReport.ParametersFormatter().init(selectorsData, dateFormat);
    },

    createDateParametersFormattingStrategy: function(dateFormat)
    {
        return new DateRangeFormattingStrategy().init(dateFormat);
    },

    formatMainPartOfLightboxTitle: function(selectedParameters)
    {
        var reportName = this.formatUtil.makePDFTitle(selectedParameters);
        var showBy = this.formatUtil.formatGroupingLevel(selectedParameters.firstGroupingLevel);
        var dateParameters = this.dateParametersFormattingStrategy.formatForDateInformation(selectedParameters.dateParameters);
        return messageResource.getMessage("common_report.pdf.title", [reportName, showBy, dateParameters]);
    },

    formatParametersText: function(selectedParameters)
    {
        return this.parametersFormatter.formatUsersSelection(selectedParameters.userSelection);
    }
});