OvertimeReport.TableDataConverter = function(reportData, reportParams)
{
    BaseTableDataConverter.call(this, reportData, reportParams);
    this.hasTimeBalance = this.reportParams.columnsConfig !== OvertimeReport.ColumnsConfig.OVERTIME_ONLY;
    this.hasOvertime = this.reportParams.columnsConfig !== OvertimeReport.ColumnsConfig.TIME_BALANCE_ONLY;
};

OvertimeReport.TableDataConverter.prototype = _.create(BaseTableDataConverter.prototype, {
    _createHeader: function()
    {
        return {
            type: BaseTableDataConverter.RowType.HEADER,
            hasTimeBalance: this.hasTimeBalance,
            hasOvertime: this.hasOvertime
        }
    },

    _createDataRow: function(level, type, groupingType, item)
    {
        var workingTime = item["workingTime"];
        var leaveTime = item["leaveTime"];
        var scheduledTime = item["scheduled"];
        var reportedTime = null;
        var differenceTime = null;
        if (!_.isNull(workingTime) || !_.isNull(leaveTime)) 
        {
            reportedTime = workingTime + leaveTime;
            differenceTime = reportedTime - scheduledTime;
        }
        return {
            type: type,
            id: item["id"],
            scheduledTime: scheduledTime,
            reportedTime: reportedTime,
            workingTime: workingTime,
            leaveTime: leaveTime,
            differenceTime: differenceTime,
            reportedOvertime: item["reportedOvertime"],
            autoOvertime: item["autoCalculatedOvertime"],
            hasTimeBalance: this.hasTimeBalance,
            hasOvertime: this.hasOvertime
        };
    }
});