OvertimeReport.Table.DataRow = function($containerEl, store, level, groupingLevel, data, timeFormat)
{
    TemplateView.call(this, $containerEl);
    this.store = store;
    this.level = level;
    this.groupingLevel = groupingLevel;
    this.data = data;
    this.timeFormat = timeFormat;
};

OvertimeReport.Table.DataRow.prototype = _.create(TemplateView.prototype, {
    html: "<tr class='dataRow <%=rowClass%>'>" +
          "  <td class='<%=titleLevelClass%> titleCell'><%-title%></td>" +
          "</tr>",

    templateKey: "OvertimeReport.Table.DataRow",

    afterRender: function()
    {
        if (this.data.hasTimeBalance)
            this._addTimeBalance();
        if (this.data.hasOvertime)
            this._addOvertime();
    },

    templateModel: function()
    {
        return {
            rowClass: this.rowClass(),
            title: this._title(),
            titleLevelClass: "reportrow" + this.level,
            levelClass: "reportrow" + this.level + "num"
        }
    },

    rowClass: function()
    {
        // Abstract
    },

    _title: function()
    {
        switch (this.groupingLevel)
        {
            case ReportGroupingLevel.USER:
                return OvertimeReport.FormatUtils.formatUser(this.store.getUser(this.data.id));
            case ReportGroupingLevel.USER_GROUP:
                return OvertimeReport.FormatUtils.formatUserGroup(this.store.getUserGroup(this.data.id));
            case ReportGroupingLevel.TIME_ZONE_GROUP:
                return OvertimeReport.FormatUtils.formatTimeZoneGroup(this.store.getTimeZoneGroup(this.data.id));
        }
    },

    _addTimeBalance: function()
    {
        this.$el.append("<td class='separator'></td>");
        new OvertimeReport.Table.TimeCell(this.$el, this.level, this.data.scheduledTime, this.timeFormat).init();
        new OvertimeReport.Table.ReportedTimeCell(this.$el, this.level, this.data.reportedTime, this.data.workingTime, this.data.leaveTime, this.timeFormat).init();
        new OvertimeReport.Table.DifferenceTimeCell(this.$el, this.level, this.data.differenceTime, this.timeFormat).init();
    },

    _addOvertime: function()
    {
        this.$el.append("<td class='separator'></td>");
        new OvertimeReport.Table.TimeCell(this.$el, this.level, this.data.reportedOvertime, this.timeFormat).init();
        new OvertimeReport.Table.TimeCell(this.$el, this.level, this.data.autoOvertime, this.timeFormat).init();
    }
});