OvertimeReport.Table.ReportedTimeCell = function($containerEl, level, reportedTime, workingTime, leaveTime, timeFormat)
{
    TemplateView.call(this, $containerEl);
    this.level = level;
    this.reportedTime = reportedTime;
    this.workingTime = workingTime;
    this.leaveTime = leaveTime;
    this.timeFormat = timeFormat;
};

OvertimeReport.Table.ReportedTimeCell.prototype = _.create(TemplateView.prototype, {
    html: "<td class='reportedTimeCell <%=levelClass%>'>" +
          "  <div class='wrapper'>" +
          "    <div class='value'><%-time%></div>" +
          "  </div>" +
          "</td>",

    templateKey: "OvertimeReport.Table.ReportedTimeCell",

    afterRender: function()
    {
        if (EnabledFeatures.LVT && this.reportedTime != null && this.reportedTime > 0)
        {
            var self = this;
            this.$el.addClass("withTooltip");
            var tooltip = OvertimeReport.Table.ReportedTimeTooltip.getInstance();
            var $wrapper = this.find(".wrapper");
            tooltip.subscribeToMouseEvents($wrapper, function()
            {
                tooltip.updateBeforeShow($wrapper, self.workingTime, self.leaveTime, self.timeFormat)
            })
        }
    },

    templateModel: function()
    {
        return {
            time: OvertimeReport.FormatUtils.formatPureTime(this.reportedTime, this.timeFormat),
            levelClass: "reportrow" + this.level + "num"
        }
    }
});