OvertimeReport.Table.ReportedTimeTooltip = function($containerEl)
{
    Tooltip.call(this, $containerEl);
};

OvertimeReport.Table.ReportedTimeTooltip.prototype = _.create(Tooltip.prototype, {
    html: "<div class='reportedTimeTooltip noprint'>" +
          "  <div class='workingTime'>" +
          "    <div class='label'><%=workingTimeLabel%>:</div>" +
          "    <div class='value'></div>" +
          "  </div>" +
          "  <div class='leaveTime'>" +
          "    <div class='label'><%=leaveTimeLabel%>:</div>" +
          "    <div class='value'></div>" +
          "  </div>" +
          "</div>",

    autoFollowMouseCursor: false,

    afterRender: function()
    {
        this.$el.hide();
        this.$workingTimeValue = this.find(".workingTime .value");
        this.$leaveTimeValue = this.find(".leaveTime .value");
    },

    messageKeys: function()
    {
        return {
            workingTimeLabel: "report.overtime.total_time_track",
            leaveTimeLabel: "report.overtime.total_leave_time"
        }
    },

    updateBeforeShow: function($relativeEl, workingTime, leaveTime, timeFormat)
    {
        var relativeOffset = $relativeEl.offset();
        var relativeWidth = $relativeEl.outerWidth();
        var relativeHeight = $relativeEl.outerHeight();
        this.$el.css("top", px(relativeOffset.top + relativeHeight + 16));
        this.$el.css("left", px(relativeOffset.left + (relativeWidth - 180) / 2));

        this.$workingTimeValue.html(OvertimeReport.FormatUtils.formatPureTime(workingTime, timeFormat));
        this.$leaveTimeValue.html(OvertimeReport.FormatUtils.formatPureTime(leaveTime, timeFormat));
        this.$el.toggleClass("workingTimeZero", workingTime === 0);
        this.$el.toggleClass("leaveTimeZero", leaveTime === 0);
    }
});

OvertimeReport.Table.ReportedTimeTooltip.getInstance = function()
{
    if (!OvertimeReport.Table.ReportedTimeTooltip.instance)
        OvertimeReport.Table.ReportedTimeTooltip.instance = new OvertimeReport.Table.ReportedTimeTooltip($("body")).init();
    return OvertimeReport.Table.ReportedTimeTooltip.instance;
};