OvertimeReport.Table.HeaderRow = function($containerEl, firstGroupingLevel, secondGroupingLevel, hasTimeBalance, hasOvertime)
{
    TemplateView.call(this, $containerEl);
    this.firstGroupingLevel = firstGroupingLevel;
    this.secondGroupingLevel = secondGroupingLevel;
    this.hasTimeBalance = hasTimeBalance;
    this.hasOvertime = hasOvertime;
};

OvertimeReport.Table.HeaderRow.prototype = _.create(TemplateView.prototype, {
    html: "<tr class='headerRow top'>" +
          "  <td class='listtblcolheader firstCell' rowspan='2'><%-firstLevelName%><span class='secondLevel'> / <%-secondLevelName%></span></td>" +
          "</tr>" +
          "<tr class='headerRow bottom'></tr>",

    afterRender: function()
    {
        this.$topRow = this.$el.eq(0);
        this.$bottomRow = this.$el.eq(1);

        if (this.hasTimeBalance)
            this._addTimeBalance();
        if (this.hasOvertime)
            this._addOvertime();
    },

    templateModel: function()
    {
        return {
            firstLevelName: OvertimeReport.FormatUtils.formatGroupingLevel(this.firstGroupingLevel),
            secondLevelName: OvertimeReport.FormatUtils.formatGroupingLevel(this.secondGroupingLevel)
        }
    },

    _addTimeBalance: function()
    {
        this.$topRow.append("<td class='separator' rowspan='2'></td>");
        new OvertimeReport.Table.HeaderRow.TimeBalanceCellTop(this.$topRow).init();
        new OvertimeReport.Table.HeaderRow.TimeBalanceCellBottom(this.$bottomRow).init();
    },

    _addOvertime: function()
    {
        this.$topRow.append("<td class='separator' rowspan='2'></td>");
        new OvertimeReport.Table.HeaderRow.OvertimeCellTop(this.$topRow).init();
        new OvertimeReport.Table.HeaderRow.OvertimeCellBottom(this.$bottomRow).init();
    }
});