BaseReportPDF.PDFPreviewLightbox = function() {};

BaseReportPDF.PDFPreviewLightbox.prototype = _.create(BasicLightbox.prototype, {
    exist_invalid_fields_message_key: "",
    close_tab_confirmation_message_key: "",

    init: function( config )
    {
        BasicLightbox.prototype.init.call(this, config.popupId, config.closeBtnId);

        var self = this;
        this.titleEl = $(this.lightBoxEl).find(".lightBoxTitle");
        this.setCancelCallback( function() { self.hide(); } );
        this.eventNamespace = config.eventNamespace;

        this.pdfPreviewViewController = this.createPDFLightboxController(this.lightBoxEl, this.titleEl, config.popupId, config.eventNamespace);

        return this;
    },
    
    createPDFLightboxController: function(lightBoxEl, titleEl, popupId, eventNamespace)
    {
        //abstract    
    },

    show: function()
    {
        BasicLightbox.prototype.show.call(this);
        this.pdfPreviewViewController.onShow();
        $(document).trigger(this.eventNamespace + ".pdfPreview.lightbox.show");
    },

    hide: function ()
    {
        $(document).trigger(this.eventNamespace + ".pdfPreview.lightbox.hide");
        BasicLightbox.prototype.hide.call(this);
    },

    cancelAllExportingProcesses: function ()
    {
        this.pdfPreviewViewController.cancelAllExportingProcesses();
    }
});