TTDetailPreviewUtils = {};
/**
 * Select details column depending on features and grouping selection and join comments by task option
 * @returns {Array}
 */
TTDetailPreviewUtils.calculateTTCDetailCells = function( groupingSelection , joinCommentsByTask ){
    var detailCells = [];
    if (!ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.CUSTOMER, groupingSelection)) {
        detailCells.push(ReportGroupingLevel.CUSTOMER);
    }
    if (!ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.PROJECT, groupingSelection) &&
        !ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.PROJECT_NAME, groupingSelection)) {
        detailCells.push(ReportGroupingLevel.PROJECT);
    }
    if (!ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.TASK, groupingSelection) &&
        !ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.TASK_NAME, groupingSelection)){
        detailCells.push(ReportGroupingLevel.TASK);
    }
    if (EnabledFeatures.BTY && !ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.BILLING_TYPE, groupingSelection)){
        detailCells.push(ReportGroupingLevel.BILLING_TYPE);
    }
    if (!joinCommentsByTask && !ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.DATE, groupingSelection)) {
        detailCells.push(ReportGroupingLevel.DATE);
    }
    if (!joinCommentsByTask && !ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.USER, groupingSelection)) {
        detailCells.push(ReportGroupingLevel.USER);
    }
    if (groupingSelection.length == 0 && EnabledFeatures.UGR && !ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.USER_GROUP, groupingSelection)){
        detailCells.push(ReportGroupingLevel.USER_GROUP);
    }
    return detailCells;
};

/**
 * This method clear third grouping level if there is collision in grouping
 * Fro example if -task
 *                   -customers
 *                      -projects
 *                      and joined comments by tasks and BTY feature is OFF
 * @param groupingLevels
 * @param isNeedToJoinComments
 * @returns {*}
 */
TTDetailPreviewUtils.filterGroupingLevelsIfExistCollision = function( groupingLevels, isNeedToJoinComments){
    var ifExistsCollision = false;

    if (!EnabledFeatures.BTY && isNeedToJoinComments ) {
        ifExistsCollision =
            ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.CUSTOMER, groupingLevels) &&
            (ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.PROJECT, groupingLevels) || ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.PROJECT_NAME, groupingLevels)) &&
            (ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.TASK, groupingLevels) || ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.TASK_NAME, groupingLevels));
    }

    if(ifExistsCollision){
        groupingLevels[2] =  ReportGroupingLevel.NONE;

    }
    return groupingLevels;
};