function BillingSummaryCSVPreviewGroupingSection(){}
BillingSummaryCSVPreviewGroupingSection.prototype = new CSVPreviewSection();
BillingSummaryCSVPreviewGroupingSection.prototype.init = function(firstGroupingLevel, secondGroupingLevel, thirdGroupingLevel, columnsStrategy, numOfGroupingColumns, numOfGroupingRows){
    CSVPreviewSection.prototype.init.call( this );
    this.firstGroupingLevel = firstGroupingLevel;
    this.secondGroupingLevel = secondGroupingLevel;
    this.thirdGroupingLevel = thirdGroupingLevel;
    this.columnsStrategy = columnsStrategy;
    this.numOfGroupingColumns = numOfGroupingColumns;
    this.numOfGroupingRows = numOfGroupingRows;
    return this;
};

BillingSummaryCSVPreviewGroupingSection.prototype.addRows = function ( tBody )
{
    var emptyRow = this.createRow();

    var totalsRow = this.createRow();
    this.addCell( totalsRow, this.message("report.total") );

    for( var i = 0; i < this.numOfGroupingRows; i++ )
    {
        var row = this.createRow();
        BillingSummaryCSVPreviewUtils.addGroupingLevelsCells( row, this.firstGroupingLevel, this.secondGroupingLevel, this.thirdGroupingLevel, i == 0 );

        this.columnsStrategy.addDataCells( row );
        this.addRow( tBody, row );
    }

    for(i = 0; i < this.numOfGroupingColumns - 1; i++ ){
        ReportPreviewUtils.addEmptyCell( emptyRow );
        ReportPreviewUtils.addEmptyCell( totalsRow );
    }

    this.columnsStrategy.addEmptyCells( emptyRow );
    ReportPreviewUtils.addEmptyCell( emptyRow );
    this.columnsStrategy.addDataCells( totalsRow );
    this.addRow( tBody, emptyRow );
    this.addRow( tBody, totalsRow );
};