var BillingSummaryCSVPreviewUtils = {};

BillingSummaryCSVPreviewUtils.addGroupingLevelsCells = function( row, firstGroupingLevel, secondGroupingLevel, thirdGroupingLevel, useEmptyCommentsCell )
{
    if( firstGroupingLevel != ReportGroupingLevel.NONE )
        ReportPreviewUtils.addCell( row, ReportPreviewUtils.getLevelPreviewName( firstGroupingLevel ) );
    if( secondGroupingLevel != ReportGroupingLevel.NONE )
        ReportPreviewUtils.addCell( row, ReportPreviewUtils.getLevelPreviewName( secondGroupingLevel ) );
    if( thirdGroupingLevel != ReportGroupingLevel.NONE )
    {
        if ( thirdGroupingLevel == ReportGroupingLevel.TASK_AND_TT_COMMENTS ||
             thirdGroupingLevel == ReportGroupingLevel.PROJECT_AND_TT_COMMENTS || thirdGroupingLevel == ReportGroupingLevel.CUSTOMER_AND_TT_COMMENTS )
        {
            if ( thirdGroupingLevel == ReportGroupingLevel.TASK_AND_TT_COMMENTS )
                ReportPreviewUtils.addCell( row, ReportPreviewUtils.getLevelPreviewName( ReportGroupingLevel.TASK ) );
            if ( thirdGroupingLevel == ReportGroupingLevel.PROJECT_AND_TT_COMMENTS )
                ReportPreviewUtils.addCell( row, ReportPreviewUtils.getLevelPreviewName( ReportGroupingLevel.PROJECT ) );
            if ( thirdGroupingLevel == ReportGroupingLevel.CUSTOMER_AND_TT_COMMENTS )
                ReportPreviewUtils.addCell( row, ReportPreviewUtils.getLevelPreviewName( ReportGroupingLevel.CUSTOMER ) );
            ReportPreviewUtils.addCell( row, useEmptyCommentsCell ? "" : ReportPreviewUtils.getLevelPreviewName( ReportGroupingLevel.TT_COMMENTS ) );
        }
        else
        {
            ReportPreviewUtils.addCell( row, ReportPreviewUtils.getLevelPreviewName( thirdGroupingLevel ) );
        }
    }
};

BillingSummaryCSVPreviewUtils.getNumberOfGroupingLevelsCells = function( firstGroupingLevel, secondGroupingLevel, thirdGroupingLevel )
{
    var numberOfGroupingLevelsCells = ReportPreviewUtils.countNotEmptyLevels( [
                                                                           firstGroupingLevel,
                                                                           secondGroupingLevel,
                                                                           thirdGroupingLevel
                                                                       ] );
    if ( thirdGroupingLevel == ReportGroupingLevel.TASK_AND_TT_COMMENTS ||
         thirdGroupingLevel == ReportGroupingLevel.PROJECT_AND_TT_COMMENTS || thirdGroupingLevel == ReportGroupingLevel.CUSTOMER_AND_TT_COMMENTS )
    {
        numberOfGroupingLevelsCells++;
    }
    return numberOfGroupingLevelsCells;
};