/**
 * Created by filatov on 17.09.2015.
 */
function CostCSVPreviewUserByGroupsThreeLevels() {}
CostCSVPreviewUserByGroupsThreeLevels.prototype = new CostCSVPreviewBaseColumnsStrategy();
CostCSVPreviewUserByGroupsThreeLevels.prototype.init = function (showSpentTime, showAverageRates, showUserRates, showSubtotalsByDepartments)
{
    CostCSVPreviewBaseColumnsStrategy.prototype.init.call( this, showSpentTime, showAverageRates);
    this.showUserRates =  showUserRates;
    this.showSubtotalsByDepartments = showSubtotalsByDepartments;
    return this;
};

CostCSVPreviewUserByGroupsThreeLevels.prototype.getNumOfDetailsColumns = function ()
{
    return this._getNumOfSubtotalDetailsColumns() + this._getNumOfUserDetailsColumns();
};

CostCSVPreviewUserByGroupsThreeLevels.prototype._getNumOfUserDetailsColumns = function(){
    var countText = 1;
    if( this.showSpentTime )
        countText ++;
    if( this.showUserRates )
        countText ++;
    return countText;
};

CostCSVPreviewUserByGroupsThreeLevels.prototype._getNumOfSubtotalDetailsColumns = function() {
    var countText = 0;
    if ( this.showSubtotalsByDepartments ){
        countText++;

        if ( this.showSpentTime){
            countText++;
        }
    }
    return countText;
};

CostCSVPreviewUserByGroupsThreeLevels.prototype.addThirdHeaderRowDataCells = function(row){
    ReportPreviewUtils.addEmptyCells(row, this.getOverallColumnsCount());
    var countColumns = this.getNumOfDetailsColumns();
    for(var i = 0; i < countColumns; i++)
        this.addCell( row, this.message( "user.group" ));
};

CostCSVPreviewUserByGroupsThreeLevels.prototype.addSecondHeaderRowDataCells = function(row){
    ReportPreviewUtils.addEmptyCells(row, this.getOverallColumnsCount());
    var countUserColumns = this._getNumOfUserDetailsColumns();
    var countSubtotalColumns = this._getNumOfSubtotalDetailsColumns();
    for(var i = 0; i < countSubtotalColumns; i++){
        this.addCell( row, this.message( "report.subtotal" ));
    }
    for( i = 0; i < countUserColumns; i++)
        this.addCell( row, this.message( "report.user" ));
};

CostCSVPreviewUserByGroupsThreeLevels.prototype.addFirstHeaderRowDataCells = function( row )
{
    this.addOverallHeaderCells(row);
    if ( this.showSubtotalsByDepartments ) {
        if ( this.showSpentTime ) {
            this.addCell( row, this.message( "report.cost.spent" ), "spent" );
        }
        this.addCell( row, this.message( "report.cost.cost" ), "cost" );
    }
    if( this.showSpentTime )
        this.addCell( row, this.message( "report.cost.spent" ), "spent" );
    if( this.showUserRates )
        this.addCell( row, this.message( "report.cost.rate" ), "rate" );
    this.addCell( row, this.message( "report.cost.cost" ), "cost" );
};

CostCSVPreviewUserByGroupsThreeLevels.prototype.getCountGroupingRows = function ( colGroupingRow )
{
    return 3;
};