function EstimateVsActualCSVPreviewGroupingSection(){}

EstimateVsActualCSVPreviewGroupingSection.prototype = new CSVPreviewSection();

EstimateVsActualCSVPreviewGroupingSection.prototype.init = function( groupingLevelsArray, columnsConfig ){
    CSVPreviewSection.prototype.init.call( this );
    
    this.groupingLevelsArray = groupingLevelsArray;
    this.columnsConfig = columnsConfig;
    
    this.numOfDataColumns = 4 + this.columnsConfig.getNumOfDataColumns(); // total spent, est time, variance mh, variance %
    this.numOfGroupingRows = this.groupingLevelsArray.length;
    
    return this;
};

EstimateVsActualCSVPreviewGroupingSection.prototype.isGroupinRowWithEstimates = function ( groupingLevel ) {
    return ( groupingLevel != ReportGroupingLevel.USER );
};

EstimateVsActualCSVPreviewGroupingSection.prototype.addRows = function ( tBody )
{
    for( var i = 0; i < this.numOfGroupingRows; i++ )
    {
        var groupingLevel = this.groupingLevelsArray[i];
        var row = this.createRow();

        for ( var j = 0; j < this.numOfGroupingRows; ++j ) {
            if ( i == j )
                this.addCell( row, ReportPreviewUtils.getLevelPreviewName(groupingLevel) );
            else
                ReportPreviewUtils.addEmptyCell(row);
        }

        this.addValueCell( row, ReportPreviewUtils.getCSVTimeValue() ); // total time spent

        this.columnsConfig.addCellValues(row, groupingLevel); // total time spent

        if ( this.isGroupinRowWithEstimates(groupingLevel) ) {
            this.addValueCell( row, ReportPreviewUtils.getCSVTimeValue() ); // estimate time
            this.addValueCell( row, this.getCSVShortTimeValue() ); // variance mh
            this.addValueCell( row, this.getCSVPercentValue() ); // variance %
        } else {
            ReportPreviewUtils.addEmptyCell(row);
            ReportPreviewUtils.addEmptyCell(row);
            ReportPreviewUtils.addEmptyCell(row);
        }
        
        
        this.addRow( tBody, row );
    }

    var emptyRow = this.createRow();
    var totalColumnsNum = this.numOfGroupingRows + this.numOfDataColumns;
    
    for( i = 0; i < totalColumnsNum; i++ )
        ReportPreviewUtils.addEmptyCell( emptyRow );
    
    this.addRow( tBody, emptyRow );

    var totalRow = this.createRow();
    this.addCell( totalRow, this.message("report.budgeted_vs_actual.total") );
    for( i = 1; i < this.numOfGroupingRows; i++ )
        ReportPreviewUtils.addEmptyCell( totalRow );
    
    for( i = 0; i < this.numOfDataColumns; i++ )
        this.addValueCell( totalRow, ReportPreviewUtils.getCSVTimeValue() );
    
    this.addRow( tBody, totalRow );
};

EstimateVsActualCSVPreviewGroupingSection.prototype.getCSVShortTimeValue = function()
{
    return "1" + SystemSettings.decimalSeparator + "23";
};

EstimateVsActualCSVPreviewGroupingSection.prototype.getCSVPercentValue = function()
{
    return "1" + SystemSettings.decimalSeparator + "23%";
};