function EstimateVsActualCSVPreviewHeader(){}

EstimateVsActualCSVPreviewHeader.prototype = new CSVPreviewSection();

EstimateVsActualCSVPreviewHeader.prototype.init = function( groupingLevelsArray, columnsConfig ){
    CSVPreviewSection.prototype.init.call( this );
    this.groupingLevelsArray = groupingLevelsArray;
    this.columnsConfig = columnsConfig;
    
    return this;
};

EstimateVsActualCSVPreviewHeader.prototype.addRows = function( tBody )
{
    var mainHeaderRow = this.createRow("tableHeader");
    
    var length = this.groupingLevelsArray.length;
    for ( var i = 0; i < length; ++i ) {
        var level = this.groupingLevelsArray[i];
        ReportPreviewUtils.addCell( mainHeaderRow, ReportPreviewUtils.getLevelPreviewName(level) );
    }

    this.addCell( mainHeaderRow, this.message("report.budgeted_vs_actual.spent_time.total") );
    
    this.columnsConfig.addDataColumns(mainHeaderRow);
    
    this.addCell( mainHeaderRow, this.message("report.budgeted_vs_actual.estimated_time") );
    this.addCell( mainHeaderRow, this.message("report.budgeted_vs_actual.variance_mh") );
    this.addCell( mainHeaderRow, this.message("report.budgeted_vs_actual.variance_percent") );

    this.addRowWithAdditionalClass( tBody, mainHeaderRow );
};