function OvertimeCSVPreviewGenerator() {}
OvertimeCSVPreviewGenerator.prototype.init = function(){
    return this;
};

OvertimeCSVPreviewGenerator.prototype.generatePreviewTable = function( reportParameters, reportParamsStringBuilder) {

    var numOfGroupingColumns = ReportPreviewUtils.countNotEmptyLevels( [
        reportParameters.firstGroupingLevel,
        reportParameters.secondGroupingLevel
    ] );
    
    var columnNames = [];
    
    var numOfDataColumns = 0;
    if (reportParameters.columnsConfig != OvertimeReport.ColumnsConfig.OVERTIME_ONLY)
    {
        numOfDataColumns += 3;
        columnNames.push(messageResource.getMessage("report.overtime.csv.time_balance.scheduled"));
        columnNames.push(messageResource.getMessage("report.overtime.csv.time_balance.reported"));
        columnNames.push(messageResource.getMessage("report.overtime.csv.time_balance.difference"));
    }

    if (reportParameters.columnsConfig != OvertimeReport.ColumnsConfig.TIME_BALANCE_ONLY)
    {
        numOfDataColumns += 2;
        columnNames.push(messageResource.getMessage("report.overtime.csv.reported_by_user"));
        columnNames.push(messageResource.getMessage("report.overtime.csv.auto_calculated"));
    }

    var header = new OvertimeCSVPreviewHeader().init(
        reportParameters.firstGroupingLevel,
        reportParameters.secondGroupingLevel
    );

    var dataGroupingSection = new OvertimeCSVPreviewGroupingSection().init(
        reportParameters.firstGroupingLevel,
        reportParameters.secondGroupingLevel,
        numOfDataColumns,
        2
    );

    var table = document.createElement( "table" );
    table.className = "reportCsvPreviewTable overtime";
    var tBody = document.createElement( "tbody" );
    table.appendChild( tBody );

    var totalColumnsNum = numOfGroupingColumns + numOfDataColumns;
    ReportPreviewUtils.addSheetHeaderRow( tBody, totalColumnsNum );

    var paramsBuilder = new CSVParametersBuilder().init();
    paramsBuilder.addDateRangeParam( reportParameters.dateRangeSelection, reportParamsStringBuilder );
    paramsBuilder.addOvertimeUsersParam( reportParameters.userSelection, reportParamsStringBuilder );

    var parametersSection = new CSVParametersSection().init( paramsBuilder, totalColumnsNum );

    parametersSection.addRows( tBody );
    header.addRows(tBody, columnNames);
    dataGroupingSection.addRows( tBody );

    return table;
};
