function OvertimeCSVPreviewGroupingSection(){}
OvertimeCSVPreviewGroupingSection.prototype = new CSVPreviewSection();
OvertimeCSVPreviewGroupingSection.prototype.init = function(firstGroupingLevel, secondGroupingLevel, numOfDataColumns, numOfGroupingRows){
    CSVPreviewSection.prototype.init.call( this );
    this.firstGroupingLevel = firstGroupingLevel;
    this.secondGroupingLevel = secondGroupingLevel;
    this.numOfDataColumns = numOfDataColumns;
    this.numOfGroupingRows = numOfGroupingRows;
    return this;
};

OvertimeCSVPreviewGroupingSection.prototype.addRows = function(tBody)
{
    var withSecondLvl = this.secondGroupingLevel != ReportGroupingLevel.NONE;
    var groupingLvls = withSecondLvl ? 2 : 1;
    var numOfGroupingRows = withSecondLvl ? this.numOfGroupingRows / 2 : this.numOfGroupingRows;

    for (var i = 0; i < numOfGroupingRows; i++)
    {
        var row = this.createRow();
        ReportPreviewUtils.addCell(row, ReportPreviewUtils.getLevelPreviewName(this.firstGroupingLevel));

        if (withSecondLvl)
            ReportPreviewUtils.addEmptyCell(row);

        for (var j = 0; j < this.numOfDataColumns; j++)
            this.addTimeValueCell(row);

        this.addRow(tBody, row);

        if (withSecondLvl)
        {
            var row2 = this.createRow();
            ReportPreviewUtils.addEmptyCell(row2);
            ReportPreviewUtils.addCell(row2, ReportPreviewUtils.getLevelPreviewName(this.secondGroupingLevel));
            
            for (j = 0; j < this.numOfDataColumns; j++)
                this.addTimeValueCell(row2);

            this.addRow(tBody, row2);
        }
    }

    var emptyRow = this.createRow();
    var totalColumnsNum = this.numOfDataColumns + groupingLvls;

    for( i = 0; i < totalColumnsNum; i++ )
        ReportPreviewUtils.addEmptyCell( emptyRow );

    this.addRow( tBody, emptyRow );

    var totalRow = this.createRow();
    this.addCell( totalRow, this.message("report.total") );
    for( i = 1; i < groupingLvls; i++ )
        ReportPreviewUtils.addEmptyCell( totalRow );

    for( i = 0; i < this.numOfDataColumns; i++ )
        this.addValueCell( totalRow, ReportPreviewUtils.getCSVTimeValue() );

    this.addRow( tBody, totalRow );
};