function StaffPerformanceCSVPreviewColumnsStrategy() {}

StaffPerformanceCSVPreviewColumnsStrategy.prototype = new CSVColumnsStrategy();

StaffPerformanceCSVPreviewColumnsStrategy.prototype.init = function ( columnsConfig, numOfDataColumns, groupMessageProvider )
{
    CSVColumnsStrategy.prototype.init.call( this );
    this.columnsConfig = columnsConfig;
    this.numOfDataColumns = numOfDataColumns;
    this.groupMessageProvider = groupMessageProvider;
    return this;
};

StaffPerformanceCSVPreviewColumnsStrategy.prototype.addMainHeaderRowCells = function ( mainHeaderRow )
{
    this.addCell( mainHeaderRow, this.message("report.spent_time") );

    var colsNum = this.numOfDataColumns - 1;
    if( this.columnsConfig == StaffPerformanceColumnsConfig.USERS_BY_GROUPS_WITH_SUBTOTALS ||
         this.columnsConfig == StaffPerformanceColumnsConfig.USERS_BY_TIME_ZONE_GROUPS_WITH_SUBTOTALS )
    {
        this.addCell( mainHeaderRow, this.message("report.subtotal") );
        colsNum--;
    }

    var colTitle = this.columnsConfig == StaffPerformanceColumnsConfig.GROUPS_ONLY || this.columnsConfig == StaffPerformanceColumnsConfig.TZ_GROUPS_ONLY ?
                   this.message(this.groupMessageProvider.getGroupNameSingularKey()) :
                   this.message("report.user");
    for( var i = 0; i < colsNum; i++ )
        this.addCell( mainHeaderRow, colTitle );
};

StaffPerformanceCSVPreviewColumnsStrategy.prototype.addColumnGropingHeaderRowCells = function ( colGroupingRow )
{
    this.addCell( colGroupingRow, "" ); // above Spent Sum
    for( var i = 0; i < this.numOfDataColumns - 1; i++ )
        this.addCell( colGroupingRow, this.message(this.groupMessageProvider.getGroupNameSingularKey()) );
};

StaffPerformanceCSVPreviewColumnsStrategy.prototype.addDataCells = function ( row )
{
    for( var i = 0; i < this.numOfDataColumns; i++ )
        this.addTimeValueCell( row );
};

StaffPerformanceCSVPreviewColumnsStrategy.prototype.addEmptyCells = function ( row )
{
    ReportPreviewUtils.addEmptyCells( row, this.numOfDataColumns );
};
