function TTDetailCSVPreviewGenerator() {}

TTDetailCSVPreviewGenerator.prototype.init = function(){
  return this;
};

TTDetailCSVPreviewGenerator.prototype.generatePreviewTable = function( reportParameters, reportParamsStringBuilder ){

    // if there is collision clear third level
    var groupingLevels = TTDetailPreviewUtils.filterGroupingLevelsIfExistCollision(
        [reportParameters.firstGroupingLevel, reportParameters.secondGroupingLevel, reportParameters.thirdGroupingLevel],
        reportParameters.joinCommentsByTask
    );

    var notEmptyGroupingLevels = ReportPreviewUtils.filterNotEmptyLevels(groupingLevels);

    var columnStrategy = new TTDetailCSVPreviewColumnsStrategy().init(notEmptyGroupingLevels, reportParameters.joinCommentsByTask);

    var headerSection = new TTDetailCSVPreviewHeader().init(
        columnStrategy
    );

    var numberOfDataRows = 6 - notEmptyGroupingLevels.length;
    var groupingSection = new TTDetailCSVPreviewGroupingSection().init(
        notEmptyGroupingLevels.length,
        columnStrategy
    );
    var totalSection = new TTDetailCSVPreviewTotalSection().init(columnStrategy);

    var table = document.createElement( "table" );
    table.className = "reportCsvPreviewTable ttdetail";
    var tBody = document.createElement( "tbody" );
    table.appendChild( tBody );

    var totalColumnsNum = notEmptyGroupingLevels.length + columnStrategy.getNumberOfDetailsCells() + 1 + 1; // + total column + comments
    ReportPreviewUtils.addSheetHeaderRow( tBody, totalColumnsNum );

    var paramsBuilder = new CSVParametersBuilder().init();
    paramsBuilder.addDateRangeParam( reportParameters.dateRangeSelection, reportParamsStringBuilder );
    paramsBuilder.addCPParam( reportParameters.customersProjectsSelection, reportParamsStringBuilder );
    paramsBuilder.addUsersParam( reportParameters.userSelection, reportParamsStringBuilder );
    if ( EnabledFeatures.TTA )
        paramsBuilder.addTimeTrackStatusParam( reportParameters.timeApprovalStatus );

    var parametersSection = new CSVParametersSection().init( paramsBuilder, totalColumnsNum );

    parametersSection.addRows( tBody );
    new CSVPreviewEmptySection().init(1, totalColumnsNum).addRows(tBody);
    headerSection.addRows(tBody);
    groupingSection.addRows( tBody );
    new CSVPreviewEmptySection().init(1, totalColumnsNum).addRows(tBody);
    totalSection.addRows(tBody);

    return table;
};