function BSHtmlBaseBTStrategy() {}

BSHtmlBaseBTStrategy.prototype = new BaseHTMLColumnStrategy();

BSHtmlBaseBTStrategy.prototype.getLevelsNumber = function () {
    return 1;
};

BSHtmlBaseBTStrategy.prototype.getColspan = function () {
    return 1;
};

BSHtmlBaseBTStrategy.prototype.addFirstHeaderRowCells = function ( row, levelsNumber ) {
    // do nothing
};

BSHtmlBaseBTStrategy.prototype.addSecondHeaderRowCells = function ( row, levelsNumber ) {
    // do nothing
};

BSHtmlBaseBTStrategy.prototype.addColumnValueCells = function ( row ) {
    // abstract
};

BSHtmlBaseBTStrategy.prototype.addTimeColumnValueCells = function ( row ) {
    this.addTimeValueCell(row);
};

BSHtmlBaseBTStrategy.prototype.addMoneyColumnValueCells = function ( row ) {
    this.addMoneyValueCell(row);
};

BSHtmlBaseBTStrategy.prototype.createNonBillableCell = function ( levelsNumber ) {
    return ReportPreviewUtils.createCell(
            this.message( "report.billing_summary.billing_type.html" ) +
            "&nbsp; <span class='smallText'>" + this.message( "report.billing_summary.non_billable.html" ) +
            "</span>",
            "typeOfWork nonBillable", this.getColspan(), levelsNumber );
};

BSHtmlBaseBTStrategy.prototype.createBillableCell = function ( levelsNumber, typeClass ) {
    return ReportPreviewUtils.createCell( this.message( "report.billing_summary.billing_type.html" ),
                                          "typeOfWork " + typeClass, this.getColspan(), levelsNumber );
};


// -------------------------------------

function BSHtmlBillableBTMoneyStrategy() {}

BSHtmlBillableBTMoneyStrategy.prototype = new BSHtmlBaseBTStrategy();

BSHtmlBillableBTMoneyStrategy.prototype.addFirstHeaderRowCells = function ( row, levelsNumber ) {
    this.addCreatedCell( row, this.createBillableCell(levelsNumber, "moneyType") );
};

BSHtmlBillableBTMoneyStrategy.prototype.addColumnValueCells = function ( row ) {
    this.addMoneyColumnValueCells(row);
};


// -------------------------------------

function BSHtmlBillableBTTimeStrategy() {}

BSHtmlBillableBTTimeStrategy.prototype = new BSHtmlBaseBTStrategy();

BSHtmlBillableBTTimeStrategy.prototype.addFirstHeaderRowCells = function ( row, levelsNumber ) {
    this.addCreatedCell( row, this.createBillableCell(levelsNumber, "timeType") );
};

BSHtmlBillableBTTimeStrategy.prototype.addColumnValueCells = function ( row ) {
    this.addTimeColumnValueCells(row);
};

// -------------------------------------

function BSHtmlNonBillableBTStrategy() {}

BSHtmlNonBillableBTStrategy.prototype = new BSHtmlBaseBTStrategy();

BSHtmlNonBillableBTStrategy.prototype.addFirstHeaderRowCells = function ( row, levelsNumber ) {
    this.addCreatedCell( row, this.createNonBillableCell(levelsNumber) );
};

BSHtmlNonBillableBTStrategy.prototype.addColumnValueCells = function ( row ) {
    this.addTimeColumnValueCells(row);
};


// -------------------------------------

function BSHtmlBTWithAmountStrategy() {}

BSHtmlBTWithAmountStrategy.prototype = new BSHtmlBaseBTStrategy();

BSHtmlBTWithAmountStrategy.prototype.addFirstHeaderRowCells = function ( row /*, levelsNumber*/ ) {
    this.addCreatedCell( row, this.createBillableCell(1, "moneyType") );
};

BSHtmlBTWithAmountStrategy.prototype.getLevelsNumber = function () {
    return 2;
};

BSHtmlBTWithAmountStrategy.prototype.getColspan = function () {
    return 2;
};

BSHtmlBTWithAmountStrategy.prototype.createSpentCell = function ( row, rowSpan ) {
    return ReportPreviewUtils.createCell( this.message( "report.billing_summary.spent" ), "spentTime", 1, rowSpan );
};

BSHtmlBTWithAmountStrategy.prototype.createAmountCell = function ( row, rowSpan ) {
    return ReportPreviewUtils.createCell( this.message( "report.billing_summary.amount" ), "subAmount", 1, rowSpan );
};

BSHtmlBTWithAmountStrategy.prototype.addSecondHeaderRowCells = function ( row, levelsNumber ) {
    var rowSpan = levelsNumber - 1;
    
    this.addCreatedCell( row, this.createSpentCell(rowSpan) );
    this.addCreatedCell( row, this.createAmountCell(rowSpan) );
};

BSHtmlBTWithAmountStrategy.prototype.addColumnValueCells = function ( row ) {
    this.addTimeValueCell(row);
    this.addMoneyValueCell(row, "darkMoneyValueCell");
};