function CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy() {}
CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype = new CostHTMLPreviewBaseColumnsStrategy();
CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.init = function( timeFormat, showSpentTime, showAverageRates, showUserRates, showSubtotals )
{
    CostHTMLPreviewBaseColumnsStrategy.prototype.init.call( this, timeFormat, showSpentTime, showAverageRates );
    this.showUserRates = showUserRates;
    this.showSubtotals = showSubtotals;
    return this;
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.addFirstHeaderRowDataCells = function( row )
{
    this.addOverallHeaderCells( row );
    var colSpan = 1;
    if( this.showSpentTime )
        colSpan ++;
    if( this.showUserRates )
        colSpan ++;
    if( this.showSubtotals )
    {
        colSpan ++;
        if( this.showSpentTime )
            colSpan ++;
    }
    else
    {
        colSpan = colSpan * 2;
    }
    this.addCell( row, SystemSettings.userGroupNamingSingular, "userGroup " + ( this.showSpentTime ? "darkHeaderCell" : "darkGreenHeaderCell" ), colSpan );
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.addSecondHeaderRowDataCells = function( row )
{
    var userCellColSpan = this.showSpentTime && this.showUserRates ? 3 : 2;
    if( this.showSubtotals )
    {
        var rowSpan = this.showSpentTime ? 1 : 2;
        var colSpan = this.showSpentTime ? 2 : 1;
        this.addCell( row, this.message( "report.subtotal" ), this.showSpentTime ? "darkHeaderCell" : "darkGreenHeaderCell", colSpan, rowSpan );
    }
    else
        this.addCell( row, this.message( "report.user" ), this.getUserHeaderCellClassName(), userCellColSpan );
    this.addCell( row, this.message( "report.user" ), this.getUserHeaderCellClassName(), userCellColSpan );
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.addThirdHeaderRowDataCells = function( row )
{
    if( this.showSubtotals )
    {
        if( this.showSpentTime )
        {
            this.addCell( row, this.message( "report.cost.spent" ), "spent" );
            this.addCell( row, this.message( "report.cost.cost" ), "cost" );
        }
    }
    else
    {
        this.addThirdLevelUserCols( row )
    }
    this.addThirdLevelUserCols( row )
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.addThirdLevelUserCols = function( row )
{
    if( this.showSpentTime )
        this.addCell( row, this.message( "report.cost.spent" ), "spent" );
    if( this.showUserRates )
        this.addCell( row, this.message( "report.cost.rate" ), "rate" );
    this.addCell( row, this.message( "report.cost.cost" ), "cost" );
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.addUserCols = function( row )
{
    if( this.showSpentTime )
        this.addTimeValueCell( row );
    if( this.showUserRates )
        this.addMoneyValueCell( row );
    this.addCostDataCell( row );
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.addDataCells = function( row )
{
    this.addOverallDataCells( row );
    if( this.showSubtotals )
    {
        if( this.showSpentTime )
            this.addTimeValueCell( row );
        this.showSpentTime ? this.addCostDataCell( row ) : this.addMoneyValueCell( row );
    }
    else
    {
        this.addUserCols( row )
    }
    this.addUserCols( row );
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.getDataColumnsCount = function()
{
    var userCols = this.showSpentTime && this.showUserRates ? 3 : 2;
    var count = userCols;
    if( this.showSubtotals )
    {
        count ++;
        if( this.showSpentTime ) count ++;
    }
    else
    {
        count += userCols;
    }
    return this.getOverallColumnsCount() + count;
};

CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.prototype.getUserHeaderCellClassName = function ()
{
    return this.showSpentTime ? "lightHeaderCell" : "lightGreenHeaderCell";
};
