function EstimateVsActualHTMLPreviewGenerator() {}

EstimateVsActualHTMLPreviewGenerator.prototype.init = function()
{
    return this;
};

EstimateVsActualHTMLPreviewGenerator.prototype.generatePreviewTable = function( reportParameters )
{
    var table = document.createElement( "table" );
    var tBody = document.createElement( "tbody" );
    table.appendChild( tBody );
    
    var groupingLevelsArray = [
        reportParameters.firstGroupingLevel,
        reportParameters.secondGroupingLevel,
        reportParameters.thirdGroupingLevel,
        reportParameters.fourthGroupingLevel
    ];

    var filteredLevelsArray = ReportPreviewUtils.filterNotEmptyLevels(groupingLevelsArray);
    var columnsStrategy = this.createPreviewStrategy(reportParameters);
    
    var headerSection = new EstimateVsActualHTMLPreviewHeaderSection().init(filteredLevelsArray, columnsStrategy);
    var groupingSection = new EstimateVsActualHTMLPreviewGroupingSection().init(
            filteredLevelsArray, reportParameters.fourthGroupingLevel != ReportGroupingLevel.NONE, columnsStrategy, reportParameters.timeFormat);

    headerSection.addRows( tBody );
    groupingSection.addRows( tBody );

    table.className = "reportHtmlPreviewTable eva " + columnsStrategy.getTableClass();
    
    return table;
};

EstimateVsActualHTMLPreviewGenerator.prototype.createPreviewStrategy = function ( reportParameters )
{
    if ( reportParameters.includeNotEstimated )
        return new AllTasksEvAHTMLPreviewStrategy().init(reportParameters.timeFormat);
    
    return new EstimatedTasksEvAHTMLPreviewStrategy().init(reportParameters.timeFormat);
};
