/**
 * Created by filatov on 16.09.2015.
 */
function LeaveHTMLPreviewBaseColumnsStrategy() {}

LeaveHTMLPreviewBaseColumnsStrategy.prototype = new HTMLColumnsStrategy();

LeaveHTMLPreviewBaseColumnsStrategy.prototype.init = function( timeFormat )
{
    HTMLColumnsStrategy.prototype.init.call( this, timeFormat );
    return this;
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype.addFirstHeaderRowCells = function( firstHeaderRow )
{
    // abstract
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype.addSecondHeaderRowCells = function( secondHeaderRow )
{
    // abstract
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype.addDataCells = function( row )
{
    //abstract
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype.getStrategyCssClass = function ()
{
    //abstract
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype.createLeaveHeaderCell = function()
{
    return ReportPreviewUtils.createCell( this.message("report.common.leave_type"), "leaveType", 1, 2 );
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype.createTotalLeaveTimeCell = function ()
{
    return ReportPreviewUtils.createCell( this.message("report.leaves.total.html_csv"), "leaveTypeTotal", 1, 2 );
};

LeaveHTMLPreviewBaseColumnsStrategy.prototype._initBalanceColumnsRenderConstructor = function(balanceQualifier, withSpaces){
    switch(balanceQualifier){
        case LeaveTypeBalanceQualifier.SICK_DAYS_ONLY : return new LeaveHTMLPreviewSickDaysOnlyBalanceColumnsRender().init(withSpaces);
        case LeaveTypeBalanceQualifier.PTO_ONLY : return new LeaveHTMLPreviewPTOOnlyBalanceColumnsRender().init(withSpaces);
        default: return new LeaveHTMLPreviewBothBalanceColumnsRender().init(withSpaces);
    }
};