/**
 * Created by filatov on 16.09.2015.
 */
function LeaveHTMLPreviewGenerator() {}

LeaveHTMLPreviewGenerator.prototype.init = function()
{
    return this;
};
LeaveHTMLPreviewGenerator.prototype.generatePreviewTable = function( reportParameters )
{
    var columnsStrategy = this.createPreviewStrategy(reportParameters);

    var header = new LeaveHTMLPreviewHeaderSection().init(
            reportParameters.firstGroupingLevel, reportParameters.secondGroupingLevel,
            columnsStrategy
    );

    var dataGroupingSection = new LeaveHTMLPreviewGroupingSection().init(
            reportParameters.firstGroupingLevel, reportParameters.secondGroupingLevel,
            columnsStrategy
    );

    var table = document.createElement( "table" );
    table.className = "reportHtmlPreviewTable leave " + columnsStrategy.getStrategyCssClass();
    var tBody = document.createElement( "tbody" );
    table.appendChild( tBody );
    header.addRows( tBody );
    dataGroupingSection.addRows( tBody );

    return table;
};

LeaveHTMLPreviewGenerator.prototype.createPreviewStrategy = function ( reportParameters)
{
    switch ( reportParameters.columnsConfig )
    {
        case LeaveTypeColumnConfig.LEAVE_TIME_ONLY:
            return new LeaveHTMLPreviewTimeOnlyStrategy().init(reportParameters.timeFormat);
        case LeaveTypeColumnConfig.BALANCES_ONLY:
            return new LeaveHTMLPreviewBalanceOnlyStrategy().init(reportParameters.timeFormat, reportParameters.balanceQualifier);
        case LeaveTypeColumnConfig.LEAVE_TIME_AND_BALANCES:
            return new LeaveHTMLPreviewTimeAndBalanceOnlyStrategy().init(reportParameters.timeFormat, reportParameters.balanceQualifier);
    }
};