function OvertimeHTMLPreviewGroupingSection() {}

OvertimeHTMLPreviewGroupingSection.prototype = _.create(PreviewSection.prototype, {
    init: function(firstGroupingLevel, secondGroupingLevel, timeFormat, hasTimeBalance, hasOvertime)
    {
        PreviewSection.prototype.init.call(this);
        this.firstGroupingLevel = firstGroupingLevel;
        this.secondGroupingLevel = secondGroupingLevel;
        this.timeFormat = timeFormat;
        this.hasTimeBalance = hasTimeBalance;
        this.hasOvertime = hasOvertime;
        this.dataColsNum = EnabledFeatures.LVT ? 4 : 3;
        return this;
    },

    addRows: function(tBody)
    {
        this.addRowWithMainCell(tBody, this.message("report.total"), "totalCell", "totalRow");
        this.addFirstGroupingRow(tBody);
        if (this.secondGroupingLevel !== ReportGroupingLevel.NONE)
        {
            this.addSecondGroupingRow(tBody);
            if (ReportPreviewUtils.isLevelCanBeAddedMoreThanOnce(this.secondGroupingLevel, [this.firstGroupingLevel]))
                this.addSecondGroupingRow(tBody);
            else
                this.addFirstGroupingRow(tBody);
        }
        else
        {
            this.addFirstGroupingRow(tBody);
            this.addFirstGroupingRow(tBody);
        }
    },

    addFirstGroupingRow: function(tBody)
    {
        this.addRowWithMainCell(tBody, ReportPreviewUtils.getLevelPreviewName(this.firstGroupingLevel), "firstLevel", "firstGrouping");
    },

    addSecondGroupingRow: function(tBody)
    {
        this.addRowWithMainCell(tBody, ReportPreviewUtils.getLevelPreviewName(this.secondGroupingLevel), "secondLevel");
    },

    addRowWithMainCell: function(tBody, text, mainCellClassName, rowClassName)
    {
        var row = this.createRow(rowClassName);
        this.addCell(row, text, mainCellClassName);
        this.addDataCells(row);
        this.addRow(tBody, row);
    },

    addDataCells: function(row)
    {
        var i;

        if (this.hasTimeBalance)
        {
            if (this.hasOvertime)
                this.addCell(row, "", "emptyCell");
            for (i = 0; i < 3; i++)
                ReportPreviewUtils.addHTMLTimeValueCell(row, this.timeFormat);
        }

        if (this.hasOvertime)
        {
            if (this.hasTimeBalance)
                this.addCell(row, "", "emptyCell");
            for (i = 0; i < 2; i++)
                ReportPreviewUtils.addHTMLTimeValueCell(row, this.timeFormat);
        }
    }
});
