function TTDetailHTMLPreviewGenerator() {}

TTDetailHTMLPreviewGenerator.prototype.init = function()
{
    return this;
};

TTDetailHTMLPreviewGenerator.prototype.generatePreviewTable = function( reportParameters )
{

    // if there is collision clear third level
    var groupingLevels = TTDetailPreviewUtils.filterGroupingLevelsIfExistCollision(
        [reportParameters.firstGroupingLevel, reportParameters.secondGroupingLevel, reportParameters.thirdGroupingLevel],
        reportParameters.joinCommentsByTask
    );

    var notEmptyGroupingLevels = ReportPreviewUtils.filterNotEmptyLevels(groupingLevels);
    var joinCommentsByTask = reportParameters.joinCommentsByTask;
    var detailsLevels = TTDetailPreviewUtils.calculateTTCDetailCells(notEmptyGroupingLevels, joinCommentsByTask);

    var headerSection = new TTDetailHTMLPreviewHeader().init(notEmptyGroupingLevels, detailsLevels, joinCommentsByTask);
    var totalSection = new TTDetailHTMLPreviewTotalSection().init(detailsLevels.length, reportParameters.timeFormat);
    var groupingSection = new TTDetailHTMLPreviewGroupingSection().init(notEmptyGroupingLevels, detailsLevels, joinCommentsByTask, reportParameters.timeFormat);

    var table = document.createElement( "table" );
    table.className = "reportHtmlPreviewTable ttdetail";
    var tBody = document.createElement( "tbody" );
    table.appendChild( tBody );

    headerSection.addRows( tBody );
    totalSection.addRows( tBody);
    groupingSection.addRows(tBody);

    return table;
};
