function TTDetailHTMLPreviewGroupingSection() {}

TTDetailHTMLPreviewGroupingSection.prototype = new PreviewSection();
TTDetailHTMLPreviewGroupingSection.prototype.constructor = TTDetailHTMLPreviewGroupingSection;

TTDetailHTMLPreviewGroupingSection.TOTAL_ROWS_NUMBER = 5;

TTDetailHTMLPreviewGroupingSection.prototype.init = function( notEmptyGroupingLevels, detailCells, joinCommentsByTask, timeFormat){
    PreviewSection.prototype.init.call( this );

    this.notEmptyGroupingLevels = notEmptyGroupingLevels;
    this.detailCells = detailCells;
    this.joinCommentsByTask= joinCommentsByTask;
    this.timeFormat = timeFormat;

    return this;
};

TTDetailHTMLPreviewGroupingSection.prototype.addRows = function( tBody) {
    var currentRowsNumber = 0;
    for ( var i = 0; i < this.notEmptyGroupingLevels.length; i++ )
    {
        this.addRow( tBody, this._createDataLevelRow( i, this.notEmptyGroupingLevels[i] ) );
        currentRowsNumber++;
    }
    this.addRow(tBody, this._createDataRow());
    currentRowsNumber++;

    if (ReportPreviewUtils.isLevelCanBeAddedMoreThanOnce(this.detailCells[0], this.notEmptyGroupingLevels))
    {
        while ( currentRowsNumber < TTDetailHTMLPreviewGroupingSection.TOTAL_ROWS_NUMBER)
        {
            this.addRow(tBody, this._createDataRow());
            currentRowsNumber++;
        }
    }
    else
    {
        while (true)
        {
            for( i = 0; i < this.notEmptyGroupingLevels.length; i++ )
            {
                this.addRow( tBody, this._createDataLevelRow( i, this.notEmptyGroupingLevels[i] ) );
                currentRowsNumber++;
                if( currentRowsNumber >= TTDetailHTMLPreviewGroupingSection.TOTAL_ROWS_NUMBER )
                    break;
            }
            if( currentRowsNumber >= TTDetailHTMLPreviewGroupingSection.TOTAL_ROWS_NUMBER )
                break;

            this.addRow( tBody, this._createDataRow() );
            currentRowsNumber++;
            if( currentRowsNumber >= TTDetailHTMLPreviewGroupingSection.TOTAL_ROWS_NUMBER )
                break;
        }
    }
};

TTDetailHTMLPreviewGroupingSection.prototype._createDataRow = function() {
    var row = this.createRow("dataRow");

    for (var i = 0; i < this.detailCells.length; i++) {
        // add css classes only for first cell in row, if groupingLevels are present
        var cellClass = null;
        if (i == 0 && this.notEmptyGroupingLevels.length != 0){
            cellClass = "firstDetailsCellAfterGrouping levelsAmount"+this.notEmptyGroupingLevels.length;
        }
        this.addCell(row, ReportPreviewUtils.getLevelPreviewName(this.detailCells[i]), cellClass);
    }

    this.addSpentCell(row);
    this.addCommentsCell(row);

    return row;
};

TTDetailHTMLPreviewGroupingSection.prototype.addCommentsCell = function ( row )  {
    var commentsCellClass = "commentCell";
    if (this.joinCommentsByTask) {
        commentsCellClass += " joined";
        this.addCell(
                row,
                ReportPreviewUtils.checkGroupingLevel(ReportGroupingLevel.USER, this.notEmptyGroupingLevels) ?
                    this.message("reports.comments_report.form.format.comments_joined_by_dates_without_format") :
                    this.message("reports.comments_report.form.format.comments_joined_by_users_without_format"),
                commentsCellClass
        );
    } else {
        this.addCell( row, this.message("report.common.tt_comments"), commentsCellClass );
    }
};

TTDetailHTMLPreviewGroupingSection.prototype.addSpentCell = function ( row ) {
    ReportPreviewUtils.addHTMLTimeValueCell( row, this.timeFormat, "spent" );
};

/**
 *
 * @param position 0 to 2
 * @param groupingLevel
 * @private
 */
TTDetailHTMLPreviewGroupingSection.prototype._createDataLevelRow = function ( position, groupingLevel ) {
    var row = this.createRow("groupingLevel_" + (position + 1));
    this.addCell(
        row,
        ReportPreviewUtils.getLevelPreviewName(groupingLevel),
        "groupingLevelName",
        this.detailCells.length
    );
    this.addSpentCell(row);
    ReportPreviewUtils.addEmptyCell(row);
    return row;
};