/*
    this page requires included page="/js/message_resources.js"
    with "general_settings.edit.mail.send_test_message" among prefixes
    (var messageResource used)
*/

// noteImgPath is differ in at and ap
function SendTestMessageButtonStatesController (button, icon, note, userEmail, enableOrDisableSendTestMessageButton, noteImgPath)
{
    this.button = button;
    this.icon = icon;
    this.note = note;
    this.userEmail = userEmail;
    this.states = {
        sending: {
            inputsDisabled: true,
            iconUrl: atImgPath("sending-progress.gif"),
            msgId: "general_settings.edit.mail.send_test_message.sending_message",
            msgClass: "sendingTestMail"
        },
        success: {
            inputsDisabled: undefined,
            iconUrl: atImgPath("success.gif"),
            msgId: "general_settings.edit.mail.send_test_message.success_message",
            msgClass: "successmsg"
        },
        error: {
            inputsDisabled: undefined,
            iconUrl: atImgPath("error.gif"),
            msgId: "general_settings.edit.mail.send_test_message.error_message",
            msgClass: "errormsg"
        },
        cancel: {
            inputsDisabled: undefined,
            iconUrl: noteImgPath,
            msgId: "general_settings.edit.mail.send_test_message.note",
            msgClass: "notemsg"
        }
    };
    this.enableOrDisableSendTestMessageButton = enableOrDisableSendTestMessageButton ? enableOrDisableSendTestMessageButton : function () {};

}

SendTestMessageButtonStatesController.prototype.getStates = function () {
    return this.states;
};

SendTestMessageButtonStatesController.prototype.setState = function ( state, userEmail, errorMessage, additionalMessage )
{
    this.setButtonDisabled( state.inputsDisabled );
    this.icon.src = state.iconUrl;

    if (errorMessage || additionalMessage)
        this.note.innerHTML = this.getStateMessage( state, [userEmail ? userEmail : this.userEmail] ) + (errorMessage && isNotEmpty(errorMessage) ? ":" + " \"" + errorMessage + "\"" : "")
                + (additionalMessage ? additionalMessage : "");
    else
        this.note.innerHTML = this.getStateMessage( state, [userEmail ? userEmail : this.userEmail] );
    this.note.className = state.msgClass;
};

SendTestMessageButtonStatesController.prototype.setButtonDisabled = function ( isDisabled )
{
    this.button.disabled = isDisabled;
    if( !isDisabled )
        this.enableOrDisableSendTestMessageButton();
};

SendTestMessageButtonStatesController.prototype.getStateMessage = function ( state, messageParams )
{
        return messageResource.getMessage( state.msgId, messageParams );
};
