/*------------------------------------------------- CONSTANTS -------------------------------------------------*/

    var marginDiff = 9;

/*
 * Names of controls on the page to modify hierarchy levels values.
 */
    var FIRST_HIERARCHY_LEVEL_SELECT_NAME          = "firstHierarchyLevelCode";
    var FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME  = "firstHierarchyLevelSingularForm";
    var FIRST_HIERARCHY_LEVEL_PLURAL_INPUT_NAME    = "firstHierarchyLevelPluralForm";
    var SECOND_HIERARCHY_LEVEL_SELECT_NAME         = "secondHierarchyLevelCode";
    var SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME = "secondHierarchyLevelSingularForm";
    var SECOND_HIERARCHY_LEVEL_PLURAL_INPUT_NAME   = "secondHierarchyLevelPluralForm";
    var THIRD_HIERARCHY_LEVEL_SELECT_NAME          = "thirdHierarchyLevelCode";
    var THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME  = "thirdHierarchyLevelSingularForm";
    var THIRD_HIERARCHY_LEVEL_PLURAL_INPUT_NAME    = "thirdHierarchyLevelPluralForm";
    var FOURTH_HIERARCHY_LEVEL_SELECT_NAME          = "fourthHierarchyLevelCode";
    var FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME  = "fourthHierarchyLevelSingularForm";
    var FOURTH_HIERARCHY_LEVEL_PLURAL_INPUT_NAME    = "fourthHierarchyLevelPluralForm";

    var USER_GROUP_NAMING_SELECT_NAME          = "userGroupNamingCode";
    var USER_GROUP_NAMING_SINGULAR_INPUT_NAME  = "userGroupNamingSingularForm";
    var USER_GROUP_NAMING_PLURAL_INPUT_NAME  = "userGroupNamingPluralForm";

/*
 * Mapping selects controls to singular inputs controls.
 */
    var CUSTOM_LEVEL_NAMINGS_INPUTS = {};
    CUSTOM_LEVEL_NAMINGS_INPUTS[FIRST_HIERARCHY_LEVEL_SELECT_NAME]  = FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME;
    CUSTOM_LEVEL_NAMINGS_INPUTS[SECOND_HIERARCHY_LEVEL_SELECT_NAME] = SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME;
    CUSTOM_LEVEL_NAMINGS_INPUTS[THIRD_HIERARCHY_LEVEL_SELECT_NAME]  = THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME;

    CUSTOM_LEVEL_NAMINGS_INPUTS[USER_GROUP_NAMING_SELECT_NAME]      = USER_GROUP_NAMING_SINGULAR_INPUT_NAME;
    CUSTOM_LEVEL_NAMINGS_INPUTS[FOURTH_HIERARCHY_LEVEL_SELECT_NAME]  = FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME;

/*
 * Mapping selects controls to tables containing input controls for custom hierarchy levels typing.
 */
    var CUSTOM_LEVEL_NAMINGS_TABLES = {};
    CUSTOM_LEVEL_NAMINGS_TABLES[FIRST_HIERARCHY_LEVEL_SELECT_NAME]  = "firstCustomHierarchyLevel";
    CUSTOM_LEVEL_NAMINGS_TABLES[SECOND_HIERARCHY_LEVEL_SELECT_NAME] = "secondCustomHierarchyLevel";
    CUSTOM_LEVEL_NAMINGS_TABLES[THIRD_HIERARCHY_LEVEL_SELECT_NAME]  = "thirdCustomHierarchyLevel";

    CUSTOM_LEVEL_NAMINGS_TABLES[USER_GROUP_NAMING_SELECT_NAME]  = "customUserGroupNaming";
    CUSTOM_LEVEL_NAMINGS_TABLES[FOURTH_HIERARCHY_LEVEL_SELECT_NAME]  = "fourthCustomHierarchyLevel";

/*
 * Mapping selects and inputs controls to css styles to display hierarchy levels titles in preview panel.
 */
    var HIERARCHY_LEVELS_STYLES = {};
    HIERARCHY_LEVELS_STYLES[FIRST_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_STYLES[FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = "firstLevel";
    HIERARCHY_LEVELS_STYLES[SECOND_HIERARCHY_LEVEL_SELECT_NAME] =
    HIERARCHY_LEVELS_STYLES[SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME] = "secondLevel";
    HIERARCHY_LEVELS_STYLES[THIRD_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_STYLES[THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = "thirdLevel";
    HIERARCHY_LEVELS_STYLES[FOURTH_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_STYLES[FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = "fourthLevel";

/*
 * Mapping selects and inputs controls to rows numbers in preview panel to display hierarchy levels titles.
 */
    var HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS = {};
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[FIRST_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = 0;
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[SECOND_HIERARCHY_LEVEL_SELECT_NAME] =
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME] = 1;
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[THIRD_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = 2;
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[FOURTH_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = 3;

/*
 * Mapping selects and inputs controls to margins in preview panel to display hierarchy levels titles with indents.
 */
    var HIERARCHY_LEVELS_PREVIEW_MARGINS = {};
    HIERARCHY_LEVELS_PREVIEW_MARGINS[FIRST_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_PREVIEW_MARGINS[FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = 0;
    HIERARCHY_LEVELS_PREVIEW_MARGINS[SECOND_HIERARCHY_LEVEL_SELECT_NAME] =
    HIERARCHY_LEVELS_PREVIEW_MARGINS[SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME] = marginDiff;
    HIERARCHY_LEVELS_PREVIEW_MARGINS[THIRD_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_PREVIEW_MARGINS[THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = marginDiff + 22;
    HIERARCHY_LEVELS_PREVIEW_MARGINS[FOURTH_HIERARCHY_LEVEL_SELECT_NAME]  =
    HIERARCHY_LEVELS_PREVIEW_MARGINS[FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = marginDiff + 44;

/*
 * Mapping inputs controls to selects controls to determine whether select control has
 * ATNamings.CUSTOM_LEVEL_NAMING_CODE value.
*/
    var CUSTOM_LEVEL_NAMINGS_SELECTS = {};
    CUSTOM_LEVEL_NAMINGS_SELECTS[FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  =
    CUSTOM_LEVEL_NAMINGS_SELECTS[FIRST_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]    = {
        name : FIRST_HIERARCHY_LEVEL_SELECT_NAME,
        hidden : false
    };
    CUSTOM_LEVEL_NAMINGS_SELECTS[SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME] =
    CUSTOM_LEVEL_NAMINGS_SELECTS[SECOND_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]   = {
        name : SECOND_HIERARCHY_LEVEL_SELECT_NAME,
        hidden : false
    };
    CUSTOM_LEVEL_NAMINGS_SELECTS[THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  =
    CUSTOM_LEVEL_NAMINGS_SELECTS[THIRD_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]    = {
        name : THIRD_HIERARCHY_LEVEL_SELECT_NAME,
        hidden : false
    };

    CUSTOM_LEVEL_NAMINGS_SELECTS[FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  =
    CUSTOM_LEVEL_NAMINGS_SELECTS[FOURTH_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]    = {
        name : FOURTH_HIERARCHY_LEVEL_SELECT_NAME,
        hidden : false
    };

    CUSTOM_LEVEL_NAMINGS_SELECTS[USER_GROUP_NAMING_SINGULAR_INPUT_NAME]  =
    CUSTOM_LEVEL_NAMINGS_SELECTS[USER_GROUP_NAMING_PLURAL_INPUT_NAME]    = {
        name : USER_GROUP_NAMING_SELECT_NAME,
        hidden : false
    };

/*
 * Mapping selects and inputs controls to their labels to mark them as invalid/valid when it is needed.
 */
    var LEVEL_NAMINGS_LABELS_IDS = {};
    LEVEL_NAMINGS_LABELS_IDS[FIRST_HIERARCHY_LEVEL_SELECT_NAME]          = "firstHierarchyLevelCodeLabel";
    LEVEL_NAMINGS_LABELS_IDS[FIRST_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = "firstHierarchyLevelSingularFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[FIRST_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]    = "firstHierarchyLevelPluralFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[SECOND_HIERARCHY_LEVEL_SELECT_NAME]         = "secondHierarchyLevelCodeLabel";
    LEVEL_NAMINGS_LABELS_IDS[SECOND_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME] = "secondHierarchyLevelSingularFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[SECOND_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]   = "secondHierarchyLevelPluralFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[THIRD_HIERARCHY_LEVEL_SELECT_NAME]          = "thirdHierarchyLevelCodeLabel";
    LEVEL_NAMINGS_LABELS_IDS[THIRD_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = "thirdHierarchyLevelSingularFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[THIRD_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]    = "thirdHierarchyLevelPluralFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[FOURTH_HIERARCHY_LEVEL_SELECT_NAME]          = "fourthHierarchyLevelCodeLabel";
    LEVEL_NAMINGS_LABELS_IDS[FOURTH_HIERARCHY_LEVEL_SINGULAR_INPUT_NAME]  = "fourthHierarchyLevelSingularFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[FOURTH_HIERARCHY_LEVEL_PLURAL_INPUT_NAME]    = "fourthHierarchyLevelPluralFormLabel";

    LEVEL_NAMINGS_LABELS_IDS[USER_GROUP_NAMING_SELECT_NAME]          = "userGroupNamingCodeLabel";
    LEVEL_NAMINGS_LABELS_IDS[USER_GROUP_NAMING_SINGULAR_INPUT_NAME]  = "userGroupNamingSingularFormLabel";
    LEVEL_NAMINGS_LABELS_IDS[USER_GROUP_NAMING_PLURAL_INPUT_NAME]    = "userGroupNamingPluralFormLabel";





/*------------------------------------------------- VARIABLES -------------------------------------------------*/
/*
 * It is needed for addElementsToControlMissedData() and checkMissedData() functions. See those functions for additional
 * information.
 */
    var customLevelsInputsArray = [];
/*
 * It is needed for addElementsToControlDuplication() and checkDuplication() functions. See those functions for additional
 * information.
 */
    var levelsControlsArray = [];

/*
 * Names of fields having errors. This array is needed for ClientSideErrors class.
 */
    var fieldErrors = {};

/*
 * Names of fields having duplication error. This array is needed to mark as valid fields having duplication errors.
 */
    var duplicationErrorFieldsNames = {};

    /**
     * Specifies if there were errors on submit and decimal separator input field set
     * is highlighted as erroneous.
     */
    var isDecimalSeparatorRowHighlightedOnSubmit = false;

/*------------------------------------------------- FUNCTIONS -------------------------------------------------*/
/*-------------------------------------------------  PUBLIC  -------------------------------------------------*/

/*
 * Adds inputsArray to customLevelsInputsArray to control empty fields to avoid posting of empty fields.
 * inputsArray looks like:
 * [first hierarchy level singular form input field,
 *  first hierarchy level plural form input field,
 *  second hierarchy level singular form input field,
 *  second hierarchy level plural form input field,
 *  third hierarchy level singular form input field,
 *  third hierarchy level plural form input field,
 *  ... etc.]
 */
    function addNamingsToControlMissedData(inputsArray) {
        customLevelsInputsArray = customLevelsInputsArray.concat(inputsArray);
    }

/*
 * Adds levelsControls to levelsControlsArray to control duplicated fields to avoid posting of duplicated data.
 * Each levelsControls is array of elements those values can be duplicated.
 * levelsControls looks like:
 * [first hierarchy level select field,
 *  first hierarchy level singular form input field,
 *  first hierarchy level plural form input field,
 *  second hierarchy level select field,
 *  second hierarchy level singular form input field,
 *  second hierarchy level plural form input field,
 *  third hierarchy level select field,
 *  third hierarchy level singular form input field,
 *  third hierarchy level plural form input field,
 *  ... etc.]
 */
    function addElementsToControlDuplication(levelsControls) {
        levelsControlsArray = levelsControlsArray.concat(levelsControls);
    }

/*
 * It is needed to control modifications of form controls. If some control state will be changed after this function
 * calling func function will be called.
 */
    function setHandlersForControls(controls, func) {
        for(var i = 0; i < controls.length; i++) {
            controls[i].onchange = func;
            controls[i].click    = func;
            controls[i].onblur   = func;
        }
        func();
    }

    function isFormElement( element )
    {
        return element.tagName == "INPUT" || element.tagName == "SELECT" || element.tagName == "BUTTON";
    }

/*
 * Update user group naming controls
 */
    function changeUserGroupNaming() {
        showHideCustomATNamingInputs(USER_GROUP_NAMING_SELECT_NAME);
    }

    function validateWorkdayDuration()
    {
        checkDuration(document.getElementById("workdayDurationId"));
    }


/*
 * Function is needed to register checkDuplication() as handler and to skip value returned by it. If checkDuplication()
 * is used simpliciter and its returned value is "false" then event will not occur.
 */
    function duplicationHandler() {
        checkDuplication();
    }



/*------------------------------------------------- PRIVATE -------------------------------------------------*/

/*
 * Calls functions from funcs array.
 */
    function callFunctions(funcs) {
        for (var i = 0; i < funcs.length; i++) {
            funcs[i]();
        }
    }

/*
 * Gets element of the page by its name.
 */
    function getElementByName(elementName) {
        return getElementById('settingsForm')[elementName];
    }

/*
 * Determine whether the specified hierarchyLevelCode is the code of the custom hierarchy level.
 */
    function isCustomATNaming(namingLevelCode) {
        return namingLevelCode == ATNamings.CUSTOM_LEVEL_NAMING_CODE;
    }

/*
 * Show (if they are hidden) or hide (if they are shown) inputs for typing custom hierarchy level names.
 */
    function showHideCustomATNamingInputs(namingSelectName) {
        var namingValue  = getElementByName([namingSelectName]).value;
        if (isCustomATNaming(namingValue)) {
            getElementById(CUSTOM_LEVEL_NAMINGS_TABLES[namingSelectName]).style.display = "";
        } else {
            getElementById(CUSTOM_LEVEL_NAMINGS_TABLES[namingSelectName]).style.display = "none";
        }
    }

/*
 * Returns the value of custom hierarchy level or general_settings.edit.undefined_hierarchy_level message if is
 * empty.
 */
    function getUndefinedStringIfNeeded(customHierarchyLevelValue) {
        return isNotEmpty(customHierarchyLevelValue) ?
               escapeHtmlSymbols(customHierarchyLevelValue) :
               messageResource.getMessage( "general_settings.edit.undefined_hierarchy_level" );
    }

/*
 * Returns the name of a hierarchy level to display in preview panel.
 */
    function getPreviewTitle(element) {
        if (isSelectElement(element)) {
            var hierarchyLevelCode = element.value;

            if (hierarchyLevelCode > ATNamings.CUSTOM_LEVEL_NAMING_CODE) {
                return previewTitles[hierarchyLevelCode];
            } else {
                var customHierarchyLevelValue = getElementByName([CUSTOM_LEVEL_NAMINGS_INPUTS[element.name]]).value;

                return getUndefinedStringIfNeeded(customHierarchyLevelValue);
            }
        }

        return getUndefinedStringIfNeeded(element.value);
    }

/*
 * Displays one row of the hierarchy levels in the preview panel. elementName is the name of select or input control
 * from which value to display is given.
 */
    function printPreviewRow(elementName){
        var table = getElementById("previewArea");

        table.getElementsByTagName("tr")[HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[elementName]].firstChild.className =
        HIERARCHY_LEVELS_STYLES[elementName];

        table.getElementsByTagName("tr")[HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[elementName]].firstChild.style.paddingLeft =
        HIERARCHY_LEVELS_PREVIEW_MARGINS[elementName] + "px";

        if (HIERARCHY_LEVELS_PREVIEW_MARGINS[elementName] > 0) {
            table.getElementsByTagName("tr")[HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[elementName]].firstChild.innerHTML =
            "<img src='" + defImgPath( "dialogs/hierarchy_levels_preview/preview_angle.gif" ) + "' width='14px' height='17px'/>" +
            "&nbsp;" +
            getPreviewTitle(getElementByName([elementName]));
        } else {
            table.getElementsByTagName("tr")[HIERARCHY_LEVELS_PREVIEW_ROW_NUMBERS[elementName]].firstChild.innerHTML =
            getPreviewTitle(getElementByName([elementName]));
        }
    }

/*
 * Returns all empty level fields from customLevelsInputsArray.
 */
    function getEmptyCustomLevelFields() {
        var emptyFields = [];
        for (var i = 0; i < customLevelsInputsArray.length; i++) {
            if (isEqualsIgnoreCase(trim(customLevelsInputsArray[i].value), "") && !CUSTOM_LEVEL_NAMINGS_SELECTS[customLevelsInputsArray[i].name].hidden &&
                getElementByName([CUSTOM_LEVEL_NAMINGS_SELECTS[customLevelsInputsArray[i].name].name]).value == ATNamings.CUSTOM_LEVEL_NAMING_CODE) {
                emptyFields[emptyFields.length] = customLevelsInputsArray[i];
            }
        }

        return emptyFields;
    }

/*
 * Marks emptyFields as invalid, i.e. outlines them by red border and adds error title.
 */
    function markEmptyFieldsAsInvalid(emptyFields, message) {
        for (var j = 0; j < emptyFields.length; j++) {
            emptyFields[j].value = "";
            ClientSideErrors.markFieldLabelsAsInvalid(getElementById(LEVEL_NAMINGS_LABELS_IDS[emptyFields[j].name]), message);

            ClientSideErrors.markTextFieldAsInvalid(emptyFields[j], message);
            setModificationsHandler(emptyFields[j]);
        }
    }

/*
 * Returns array with one value of the element if it is input control and array of singular and plural forms if it is
 * select control.
 */
    function getElementValue(element) {
        if (isSelectElement(element)) {
            var hierarchyLevelCode = element.value;

            if (hierarchyLevelCode > ATNamings.CUSTOM_LEVEL_NAMING_CODE) {
                return [previewTitles[hierarchyLevelCode], standartPluralForms[hierarchyLevelCode]];
            } else {
                return [""];
            }
        }

        return [trim(element.value)];
    }

/*
 * Returns array where hierarchy levels values are indexes and elements are arrays of page controls (selects and inputs)
 * having these values.
 */
    function getLevelValueControlsMap() {
        /*
         * Mapping of currently selected hierarchy levels values to hierarchy levels controls (inputs and selects).
         * For instance:
         * [[HierarchyLevelValue1] - [Select1, Input3],
         *  [HierarchyLevelValue2] - [Select2],
         *  ... etc.]
         *
         * It means, that every hierarchy level value is confronted with controls having this value.
         */
        var levelValueControlsMap = {};

        for (var i = 0; i < levelsControlsArray.length; i++) {
            var customLevelObj = CUSTOM_LEVEL_NAMINGS_SELECTS[levelsControlsArray[i].name];
            var customLevelName = (customLevelObj) ? customLevelObj.name : undefined;
            var bundledWithInputSelect = getElementByName([customLevelName]);

            if ((typeof(bundledWithInputSelect) == typeof undefined) ||
                bundledWithInputSelect.value == ATNamings.CUSTOM_LEVEL_NAMING_CODE) {
                var elementValue = getElementValue(levelsControlsArray[i]);
                for (var j = 0; j < elementValue.length; j++) {
                    if (isNotEmpty(elementValue[j])) {
                        var lowerCaseValue = elementValue[j].toLowerCase();
                        if (levelValueControlsMap[lowerCaseValue] == null) {
                            levelValueControlsMap[lowerCaseValue] = [];
                        }

                        levelValueControlsMap[lowerCaseValue] = levelValueControlsMap[lowerCaseValue].concat(levelsControlsArray[i]);
                    }
                }
            }
        }

        return levelValueControlsMap;
    }

/*
 * Marks duplicated fields as invalid and return true if at least one field was marked and false otherwise.
 */
    function markDuplicatedFieldsAsInvalid(levelValueControlsMap) {
        var someFieldsWereMarkedAsInvalid = false;

        for (var levelValueControlsKey in levelValueControlsMap) {
            var levelValueControlsArray = levelValueControlsMap[levelValueControlsKey];

            if (levelValueControlsArray.length > 1) {
                if (!isEqualHierarchyLevel(levelValueControlsArray)) {
                    someFieldsWereMarkedAsInvalid = true;

                    for (var i = 0; i < levelValueControlsArray.length; i++) {
                        ClientSideErrors.markFieldLabelsAsInvalid(getElementById(LEVEL_NAMINGS_LABELS_IDS[levelValueControlsArray[i].name]),
                                                                  messageResource.getMessage("general_settings.edit.duplicated_forms"));

                        if (isSelectElement(levelValueControlsArray[i])) {
                            ClientSideErrors.markSelectFieldAsInvalid(levelValueControlsArray[i],
                                                                      messageResource.getMessage("general_settings.edit.duplicated_forms"));
                        } else {
                            ClientSideErrors.markTextFieldAsInvalid(levelValueControlsArray[i],
                                                                    messageResource.getMessage("general_settings.edit.duplicated_forms"));
                        }
                        duplicationErrorFieldsNames[levelValueControlsArray[i].name] = levelValueControlsArray[i];

                        setModificationsHandler(levelValueControlsArray[i], true);
                        if (!isSelectElement(levelValueControlsArray[i])) {
                            setModificationsHandler(getElementByName([CUSTOM_LEVEL_NAMINGS_SELECTS[levelValueControlsArray[i].name].name]), true);
                        }
                    }
                }
            }
        }

        return someFieldsWereMarkedAsInvalid;
    }

/*
 * Determines whether form fields has duplicated values.
 */
    function checkDuplication() {
        return !markDuplicatedFieldsAsInvalid(getLevelValueControlsMap());
    }

/*
 * Determine whether controls from levelsControlsArray represent the same hierarchy level or not. Controls represent
 * the same hierarchy level if they are located in the same table.
 */
    function isEqualHierarchyLevel(levelsControlsArray) {
        var firstControlTable = levelsControlsArray[0].parentNode.parentNode.parentNode;

        for (var i = 1; i < levelsControlsArray.length; i++) {
            if (levelsControlsArray[i].parentNode.parentNode.parentNode != firstControlTable) {
                return false;
            }
        }

        return true;
    }

/*
 * Sets handler to a field having an error. This handler calls function to mark this field as valid when field is changed.
 * isDuplicationControl is needed to dermine whether is control of duplication or not.
 */
    function setModificationsHandler(element, isDuplicationControl) {

        var onchangeFunction;

        if(typeof element.prevFunc != typeof undefined) {
            onchangeFunction = element.prevFunc; // restoring of the remembered onchange handler
        } else {
            element.prevFunc = element.onchange; // remembering of the previous onchange handler to restore it when this function will be called for this elemet again
            onchangeFunction = element.onchange; // remembering of the previous onchange handler to restore it after new handler calling
        }

        element.onchange = function() {
            if (isDuplicationControl) {
                removeDuplicationErrors();
                checkDuplication();
            } else {
                markFieldAsValid(this);
            }
            hideClientSideErrorMessageIfNoErrors();

            // The next line is needed to call the previous onchange listener. It is needed if element is select
            // control having onchange listener to show/hide appropriate input fields (bundled with it select). If do not do
            // it (the code snippet below is meant) then bundled with select input fields will not be hided/shown after the
            // code above executed when select control is changed.
            if (typeof onchangeFunction != typeof undefined && onchangeFunction != null) {
                onchangeFunction();
            }
        };
    }

/*
 * Removes from array inputs bundled with select having selectName name.
 */
    function markAsValidBundledWithSelectInputs(selectName) {
        for (var inputName in CUSTOM_LEVEL_NAMINGS_SELECTS) {
            if (isEqualsIgnoreCase(CUSTOM_LEVEL_NAMINGS_SELECTS[inputName].name, selectName)) {
                markFieldAsValid(getElementByName(inputName));
            }
        }
        hideClientSideErrorMessageIfNoErrors();
    }

/*
 * Removes error tooltip and border around previously invalid field.
 */
    function markFieldAsValid(field) {
        ClientSideErrors.markFieldLabelsAsValid(getElementById(LEVEL_NAMINGS_LABELS_IDS[field.name]));
        ClientSideErrors.markFieldLabelsAsValid(document.getElementById(field.name+"FieldLabel"));

        if (isSelectElement(field)) {
            ClientSideErrors.markSelectFieldAsValid(field, "#ffffff");
        } else {
            ClientSideErrors.markTextFieldAsValid(field);
        }
    }

/*
 * Determine whether the page has errors.
 */
    function isNoErrors() {
        var count = 0;
        for(var i in fieldErrors) {
            count++;
        }

        return count == 0;
    }

/*
 * Removes client-side notification if there is no more errors on the page.
 */
    function hideClientSideErrorMessageIfNoErrors() {
        if (isNoErrors()) {
            ClientSideErrors.hideClientSideErrorMessage();
        }
    }

/*
 * Removes error tooltip and border around all invalid fields. If there is no more errors on the page client-side
 * notification is removed too.
 */
    function removeClientSideErrors() {
        for (var fieldError in fieldErrors) {
            markFieldAsValid(getElementByName(fieldError));
        }
        hideClientSideErrorMessageIfNoErrors();
    }

/*
 * Removes error tooltip and border around fields having duplication error.
 */
    function removeDuplicationErrors() {
        for (var duplicationErrorFieldName in duplicationErrorFieldsNames) {
            markFieldAsValid(getElementByName(duplicationErrorFieldName));
        }
    }

    /**
     * Returns true if decimal field is not empty (not trims)
     */
    function isDecimalFieldIsNotEmpty()
    {
        var decimal = decimalSeparatorField.getValue();
        return decimal.length > 0;
    }

    /**
     * Updates format preview from current field values.
     */
    function updateFormatPreview()
    {
        var previewField = document.getElementById('numbersFormatPreviewField');

        var decimal = decimalSeparatorField.getValue();
        var digit = digitGroupingSymbolField.getValue();

        previewField.innerHTML = '123' +digit + "456" + decimal + "78 ";
    }


    /**
     * Validates format fields. Checks differ condition, marks invalid or valid fields.
     * @return true if there are not any errors, false otherwise.
     */
    function validateFormatFields()
    {
        var decimal = decimalSeparatorField.getValue();
        var digit = digitGroupingSymbolField.getValue();
        var message;
        var wasDecimalErrors = false;
        var wasDigitErrors = false;

        if ((digit.match( /^\d+$/ ) != null) || !isSeparatorValid(digit) )
        {
            ClientSideErrors.markTextFieldAsInvalid(document.getElementById(digitGroupingSymbolField.getCustomFieldName()),
                                                    messageResource.getMessage("general_settings.edit.invalid_digit_char", [digit]));
            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("digitGroupingSymbolLabel"),
                                                      messageResource.getMessage("general_settings.edit.invalid_digit_char", [digit]));
            wasDigitErrors = true;
        }

        if ((decimal.match( /^\d+$/ ) != null) || !isSeparatorValid(decimal) )
        {
            ClientSideErrors.markTextFieldAsInvalid(document.getElementById(decimalSeparatorField.getCustomFieldName()),
                                                    messageResource.getMessage("general_settings.edit.invalid_decimal_char", [decimal]));
            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("decimalSeparatorFieldLabel"),
                                                      messageResource.getMessage("general_settings.edit.invalid_decimal_char", [decimal]));
            wasDecimalErrors = true;
        }

        // testing for white spaces
        if ( (decimal.length > 0) && (trim(decimal).length == 0) )
        {
            ClientSideErrors.markTextFieldAsInvalid(document.getElementById(decimalSeparatorField.getCustomFieldName()),
                                                    messageResource.getMessage("general_settings.edit.invalid_decimal_char", ["(space)"]));
            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("decimalSeparatorFieldLabel"),
                                                      messageResource.getMessage("general_settings.edit.invalid_decimal_char", ["(space)"]));
            wasDecimalErrors = true;
        }

        if (decimal != "")
            isDecimalSeparatorRowHighlightedOnSubmit = false;

        if ( (decimal == digit) && (decimal != "") && (!wasDigitErrors) && (!wasDecimalErrors) )
        {
            message = messageResource.getMessage("general_settings.edit.fields_must_differ");

            if ( document.getElementById(decimalSeparatorField.getPredefinedFieldName()).value != SystemSettings.CUSTOM_VALUE_STRING )
            {
                ClientSideErrors.markTextFieldAsValid(document.getElementById(decimalSeparatorField.getCustomFieldName()));
                ClientSideErrors.markSelectFieldAsInvalid(document.getElementById(decimalSeparatorField.getPredefinedFieldName()), message, true);
            }
            else
            {
                ClientSideErrors.markSelectFieldAsValid(document.getElementById(decimalSeparatorField.getPredefinedFieldName()), true);

                ClientSideErrors.markTextFieldAsInvalid(document.getElementById(decimalSeparatorField.getCustomFieldName()), message);
            }

            if ( document.getElementById(digitGroupingSymbolField.getPredefinedFieldName()).value != SystemSettings.CUSTOM_VALUE_STRING )
                ClientSideErrors.markSelectFieldAsInvalid(document.getElementById(digitGroupingSymbolField.getPredefinedFieldName()), message, true);
            else
            {
                ClientSideErrors.markSelectFieldAsValid(document.getElementById(digitGroupingSymbolField.getPredefinedFieldName()),
                                                        "#ffffff");
                ClientSideErrors.markTextFieldAsInvalid(document.getElementById(digitGroupingSymbolField.getCustomFieldName()), message);
            }

            wasDecimalErrors = true;
            wasDigitErrors = true;

            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("digitGroupingSymbolLabel"), message);
            ClientSideErrors.markFieldLabelsAsInvalid(document.getElementById("decimalSeparatorFieldLabel"), message);
        }

        if (!wasDecimalErrors)
        {
            if (! (isDecimalSeparatorRowHighlightedOnSubmit && !isDecimalFieldIsNotEmpty()) )
            {
                ClientSideErrors.markTextFieldAsValid(document.getElementById(decimalSeparatorField.getCustomFieldName()));
                ClientSideErrors.markFieldLabelsAsValid(document.getElementById("decimalSeparatorFieldLabel"));
            }

            ClientSideErrors.markSelectFieldAsValid(document.getElementById(decimalSeparatorField.getPredefinedFieldName()),
                                                    "#ffffff");
        }

        if (!wasDigitErrors)
        {
            ClientSideErrors.markSelectFieldAsValid(document.getElementById(digitGroupingSymbolField.getPredefinedFieldName()),
                                                    "#ffffff");
            ClientSideErrors.markTextFieldAsValid(document.getElementById(digitGroupingSymbolField.getCustomFieldName()));
            ClientSideErrors.markFieldLabelsAsValid(document.getElementById("digitGroupingSymbolLabel"));
        }

        hideClientSideErrorMessageIfNoErrors();

        return (!(wasDecimalErrors || wasDigitErrors));
    }

    function isSeparatorValid(value)
    {
        if ( (value == undefined) || (value == "") ) return true;

        var invalidChars = ["/", "]", "[", "+", "*", "\\", "{", "}", ":", "^", "/"];

        for(var i=0; i<invalidChars.length; i++)
        {
            if (value.indexOf(invalidChars[i]) >= 0)
            {
                return false;
            }
        }

        return true;
    }

    function userGroupsEnabledChanged( checked ) {
        CUSTOM_LEVEL_NAMINGS_SELECTS[USER_GROUP_NAMING_SINGULAR_INPUT_NAME].hidden = !checked;
        CUSTOM_LEVEL_NAMINGS_SELECTS[USER_GROUP_NAMING_PLURAL_INPUT_NAME].hidden = !checked;
        featureEnabledChanged('userGroupsSettingsHeaderBlock', "userGroupNamingSection", checked);
    }

    function ptoEnabledChanged( checked ) {
        featureEnabledChanged('ptoSettingsHeaderBlock', "ptoBlock", checked);
    }

    function sickEnabledChanged( checked ) {
        featureEnabledChanged('sickSettingsHeaderBlock', "sickBlock", checked);
    }

    function featureEnabledChanged( headerId, sectionId, checked )
    {
        $('#' + headerId).toggleClass("disabledImg", !checked);
        $('#' + sectionId).toggleClass("visibleBlock", checked);
    }

function apSettingsClosure( config ) {

    var workdayDurationsEditor;

    this.canSubmit = function canSubmit()
    {
        userGroupNamingSingularFormController.hideGrayTextIfShown();
        userGroupNamingPluralFormController.hideGrayTextIfShown();

        return baseCanSubmit();
    };

    function registerChangeable()
    {
        baseRegisterChangeable();

        var settingsForm = document.getElementById('settingsForm');

        registerChangeableControl(settingsForm['userGroupNamingCode']);
        registerChangeableControl(settingsForm['userGroupNamingSingularForm']);
        registerChangeableControl(settingsForm['userGroupNamingPluralForm']);

        setHandlersForControls([settingsForm['userGroupNamingCode'],
                                settingsForm['userGroupNamingSingularForm']],
                               changeUserGroupNaming);

        $( '#userGroupNamingCodeSelect' ).change( updateUserGroupsNamingLabelErrorState );
        $( '#userGroupNamingSingularFormId').blur( updateUserGroupsNamingLabelErrorState );
        $( '#userGroupNamingPluralFormId').blur( updateUserGroupsNamingLabelErrorState );

        var missedDataArray = [settingsForm['userGroupNamingSingularForm'],
                               settingsForm['userGroupNamingPluralForm']];

        addNamingsToControlMissedData(missedDataArray);
        registerChangeableControl(form().ptoShowInHours[0]);
        registerChangeableControl(form().ptoShowInHours[1]);
        registerChangeableControl( settingsForm['ptoUserEnabled'] );
        registerChangeableControl( settingsForm['ptoRoundBalanceOnUserlist'] );


        registerChangeableControl(form().sickShowInHours[0]);
        registerChangeableControl(form().sickShowInHours[1]);
        registerChangeableControl( settingsForm['sickUserEnabled'] );
        registerChangeableControl( settingsForm['sickRoundBalanceOnUserlist'] );

        registerChangeableControl(form().userGroupsEnabled);

        registerChangeableControl(form().colleaguesVisibility[0]);
        registerChangeableControl(form().colleaguesVisibility[1]);
        registerChangeableControl(form().colleaguesVisibility[2]);
        registerChangeableControl(form().userCanEditRequestsInPast);
        registerChangeableControl(form().ltmCanSeeAutoApproved);
        registerChangeableControl(form().ltmCanManageAutoApproved);
        registerChangeableControl(form().ltmCanSeeAllRequests);
        if (form().pastLeaveRequestsProcessType)
        {
            registerChangeableControl(form().pastLeaveRequestsProcessType[0]);
            registerChangeableControl(form().pastLeaveRequestsProcessType[1]);
        }

        var tzGroupField = form()['defaultTZGroupName'];
        registerChangeableControl(tzGroupField);
        $(tzGroupField).on("blur", function() {checkDefaultTZGroupNameField(false)});

    }

    this.onLoadHandler =  function onLoadHandler()
    {
        initCustomizedFields("decimalSeparatorField", config.decimalSeparatorField,
                "digitGroupingSymbolField", config.digitGroupingSymbolField);

        updateFormatPreview();

        var userGroupsSwitchererHandler = function( isEnabled ) {
            onUserGroupEnabledChange( isEnabled, tzSwitcher.isEnabled() );
            handleChange(true);
        };

        var isEnabledGroups = config.isEnabledGroups;
        var isEnabledTZGroups = config.isEnabledTZGroups;

        var userGroupsSwitcher = new TumblerSwitch(isEnabledGroups, userGroupsSwitchererHandler, true );
        userGroupsSwitcher.appendAsChildTo( document.getElementById("userGroupsSwitcher" ) );

        onUserGroupEnabledChange(isEnabledGroups, isEnabledTZGroups);

        var ptoSwitchererHandler = function( isEnabled ) {
            onPTOEnabledChange( isEnabled );
            handleChange(true);
        };
        var isPtoEnabled = config.isPtoEnabled;

        var ptoSwitcher = new TumblerSwitch(isPtoEnabled, ptoSwitchererHandler, true );
        ptoSwitcher.appendAsChildTo( document.getElementById("ptoSwitcher" ) );

        onPTOEnabledChange( isPtoEnabled );

        var isSickBalanceEnabled = config.isSickBalanceEnabled;
        var sickBalanceSwitcherHandler = function ( isEnabled ) {
            onSickEnabledChange( isEnabled );
            handleChange(true);
        };

        var sickSwitcher = new TumblerSwitch(isSickBalanceEnabled, sickBalanceSwitcherHandler, true );
        sickSwitcher.appendAsChildTo( document.getElementById("sickSwitcher" ) );
        
        onSickEnabledChange(isSickBalanceEnabled);

        var defaultTZGroupField = form()['defaultTZGroupName'];
        var initDefaultTZGroupName = defaultTZGroupField.value;
        var tzGroupSwitcherHandler = function ( isEnabled ) {
            onTzGroupEnabledChange( isEnabled, userGroupsSwitcher.isEnabled() );
            switchTimeZoneAndTimeZoneGroupsElements( isEnabled );
            if (!isEnabled)
            {
                defaultTZGroupNameController.hideGrayTextIfShown();
                defaultTZGroupField.value = initDefaultTZGroupName;
                checkDefaultTZGroupNameField(false);
            }
            handleChange(true);
        };

        var tzSwitcher = new TumblerSwitch(isEnabledTZGroups, tzGroupSwitcherHandler, true );
        tzSwitcher.appendAsChildTo( document.getElementById("tzGroupSwitcher" ) );

        onTzGroupEnabledChange(isEnabledTZGroups, isEnabledGroups);
        switchTimeZoneAndTimeZoneGroupsElements(isEnabledTZGroups);
        updateDefaultTZGroupTime(config.defaultTZGroupCurrentTime);

        initDefaultTZGroupTimeZoneSelector(
                "tzSelector",
                config.defaultTZGroupCityName,
                config.defaultTZGroupTimeZoneId,
                config.defaultTZGroupTimeZoneOffset
        );

        workdayDurationsEditor = initWorkdayDurationsEditor(config.wdDurations, config.wdWeekStartDay);

        var ptoRulesValues = {};
        ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_ENABLED] = config.isPtoAccrualRuleEnabled;
        ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_VALUE] = config.ptoAccrualRuleValue;
        ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_FREQUENCY_TYPE] = config.ptoAccrualRuleFrequencyTypeName;
        ptoRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_PARAMETERS] = config.ptoAccrualRuleParameters;

        ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_ENABLED] = config.isPtoResetRuleEnabled;
        ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_VALUE] = config.ptoResetRuleValue;
        ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_FREQUENCY_TYPE] = config.ptoResetRuleFrequencyTypeName;
        ptoRulesValues[BALANCE_RULES_VALUES.RESET_RULE_PARAMETERS] = config.ptoResetRuleParameters;

        ptoRulesValues[BALANCE_RULES_VALUES.CAP_RULE_ENABLED] = config.isPtoCapRuleEnabled;
        ptoRulesValues[BALANCE_RULES_VALUES.CAP_RULE_VALUE] = config.ptoCapRuleValue;
        initPtoRulesEditor(ptoRulesValues, config.workdayDuration, config.isPtoShowInHours);


        var sickRulesValues = {};
        sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_ENABLED] = config.isSickAccrualRuleEnabled;
        sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_VALUE] = config.sickAccrualRuleValue;
        sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_FREQUENCY_TYPE] = config.sickAccrualRuleFrequencyTypeName;
        sickRulesValues[BALANCE_RULES_VALUES.ACCRUAL_RULE_PARAMETERS] = config.sickAccrualRuleParameters;

        sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_ENABLED] = config.isSickResetRuleEnabled;
        sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_VALUE] = config.sickResetRuleValue;
        sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_FREQUENCY_TYPE] = config.sickResetRuleFrequencyTypeName;
        sickRulesValues[BALANCE_RULES_VALUES.RESET_RULE_PARAMETERS] = config.sickResetRuleParameters;

        sickRulesValues[BALANCE_RULES_VALUES.CAP_RULE_ENABLED] = config.isSickCapRuleEnabled;
        sickRulesValues[BALANCE_RULES_VALUES.CAP_RULE_VALUE] = config.sickCapRuleValue;

        initSDBRulesEditor(sickRulesValues, config.workdayDuration, config.isSickShowInHours);

        if(isPtoEnabled || isSickBalanceEnabled){
            initDWDModificationsHandler();
        }

        registerChangeable();

        checkDuplication();

        if (ClientSideErrors.hasErrors())
            ClientSideErrors.showClientSideErrorMessage();

        var images = config.images;
        var preloader = new ImagePreloader( images );

        sectionsStateController = new SectionsStateController().init( "aP_settingSections" );
        sectionsStateController.loadSectionsStateFromCookies();

        $( '.collapsibleGroupHeaderBlock' ).each( function ()
                                                  {
                                                      disableTextSelection( this, true );
                                                  } );

        $("#ltmCanManageAutoApprovedId").click( function() { updateLTMBlockCheckboxesState(); } );
        updateLTMBlockCheckboxesState();

        ExitConfirmation.setUpBaseExitConfirmation( "general_settings.exit_confirmation", false );
    };

    function onUserGroupEnabledChange( enabled, timeZoneGroupsEnabled )
    {
        form().elements["userGroupsEnabled"].value = enabled;
        $("#colleaguesUserGroupsVisibility" ).toggle( enabled );
        if (!timeZoneGroupsEnabled)
            $("#colleaguesVisibilityBlock" ).toggle( enabled );
        if ( !enabled && $(form().colleaguesVisibility[1] ).prop('checked') )
            form().colleaguesVisibility[0].checked = true;

        userGroupsEnabledChanged( enabled );
    }

    function onPTOEnabledChange( enabled ) {
        form().elements["ptoEnabled"].value = enabled;
        ptoEnabledChanged(enabled);
    }

    function onSickEnabledChange( enabled ) {
        form().elements["sickEnabled"].value = enabled;
        sickEnabledChanged(enabled);
    }

    function onTzGroupEnabledChange( enabled, userGroupsEnabled ) {
        form().elements["timeZoneGroupsEnabled"].value = enabled;
        $("#colleaguesTimeZoneGroupsVisibility" ).toggle( enabled );
        if (!userGroupsEnabled)
            $("#colleaguesVisibilityBlock" ).toggle( enabled );
        if ( !enabled && $(form().colleaguesVisibility[2] ).prop('checked') )
            form().colleaguesVisibility[0].checked = true;
    }

    function updateLTMBlockCheckboxesState()
    {
        var checked = $("#ltmCanManageAutoApprovedId").prop('checked');
        var showAutoApprovedCheckbox = $("#showAutoApprovedId");
        if (checked)
            showAutoApprovedCheckbox.prop('checked', true);
        showAutoApprovedCheckbox.prop('disabled', checked);
    }
    
    return this;

} 