// TODO: refactor:
//       - Remove dependency from the pages where this script is used. It must know nothing of such things as
//         userSelectorMenu, markNameIsInvalid, saveAsPopup and such. It must not decide how to handle
//         success and failure. Instead, it must provide ways to subscribe to these events.
//       - 'Save As' is not 'Share', so SaveAsReportConfigManager must not be derived from BaseShareReportConfigManager.
//       - It is not clear what's the difference between ShareReportConfigManager and ShareSavedReportConfigManager
//         (the 1st copies config using the given bean, the 2nd copies config using the given config Id),
//         so something must be renamed here.

var rpcDelay = 1000;

function BaseShareReportConfigManager(userSelectorMenu)
{
    RpcControlManager.call(this);
    this.userSelectorMenu = userSelectorMenu;
}

BaseShareReportConfigManager.prototype = new RpcControlManager();


BaseShareReportConfigManager.prototype.getService = function()
{
    return jsonrpc.PersonalReportsService;
};

BaseShareReportConfigManager.prototype.getMethods = function()
{
    return [ 'PersonalReportsService.copySavedConfig' ];
};

BaseShareReportConfigManager.prototype.handleSpecificError = function(exception)
{
    if(exception && exception.name && ( exception.name.indexOf( 'NoSuchReportConfigException' ) >= 0 ))
    {
        alert(messageResource.getMessage("report.common.user_selector.no_such_config",
                                         [this.getReportTypeText(this.isChartOption())]));
        document.location.reload();
        return true;
    }
    if(exception && exception.name && ( exception.name.indexOf( 'AllSelectedUsersWereDeletedException' ) >= 0 ))
    {
        alert(messageResource.getMessage("report.common.selected_users_was_deleted"));
        document.location.reload();
        return true;
    }
    return false;
};

BaseShareReportConfigManager.prototype.handleNoRightsError = function(exception) {
    if (exception.name.indexOf('com.actimind.actitime.services.NoRightsForRemoteCallException') != -1) {
        alert( JQUERY_RPC_ERROR_MESSAGES.NO_RIGHTS );
        document.location.reload();
        return true;
    }
    return false;
};

BaseShareReportConfigManager.prototype.getTimeoutMsg = function()
{
    return messageResource.getMessage("report.common.share_config.timeout",
                                      [this.getReportTypeText(this.isChartOption())]);
};

BaseShareReportConfigManager.prototype.isChartOption = function(){
    return this.userSelectorMenu.getCurrentSaveOptions().isChart;
};

BaseShareReportConfigManager.prototype.beginSavingData = function()
{
    
};

BaseShareReportConfigManager.prototype.endSavingData = function(success)
{
    wait( rpcDelay );
    this.userSelectorMenu.close();
    this.userSelectorMenu.clearSelection();
};

BaseShareReportConfigManager.prototype.onDataSavingComplete = function(result)
{

};

BaseShareReportConfigManager.prototype.getReportTypeText = function(isChart){
    var key = isChart ? "report.dashboard.chart":"report.dashboard.report";
    return messageResource.getMessage(key);
};

BaseShareReportConfigManager.prototype.getRpcErrorMsg = function()
{
   return messageResource.getMessage("report.common.share_config.error",
                                      [this.getReportTypeText(this.isChartOption())]);
};


function ShareSavedReportConfigManager( userSelectorMenu )
{
    BaseShareReportConfigManager.call(this, userSelectorMenu);
}

ShareSavedReportConfigManager.prototype = new BaseShareReportConfigManager();

ShareSavedReportConfigManager.prototype.makeRemoteCall = function( callback )
{
    var selection = this.userSelectorMenu.getSelection(false);
    this.getService().copySavedConfig(callback, this.userSelectorMenu.getCurrentSaveOptions().configId,
                                      selection.getFirstLevel(), selection.groupType, selection.getSecondLevel());
};
