TaskStore = _.create(EntityWithIdStore.prototype).init();

function Task(id, name, projectId, customerId, completed, estimatedTime, deadline, lastTrackingDate)
{
    this.id = id;
    this.name = name;
    this.projectId = projectId;
    this.customerId = customerId;
    this.completed = completed;
    this.estimatedTime = estimatedTime;
    this.deadline = deadline;
    this.lastTrackingDate = lastTrackingDate;
}

Task.fromRPC = function(data)
{
    return new Task(
            data["id"],
            data["name"],
            data["projectId"],
            data["customerId"],
            _.isUndefined(data["open"]) ? data["completed"] : !data["open"],
            _.isUndefined(data["estimatedTime"]) ? data["budgetedTime"] : data["estimatedTime"],
            _.isString(data["deadline"]) ? Date.parseJSONDate(data["deadline"]) : null,
            _.isString(data["lastTTDate"]) ? Date.parseJSONDate(data["lastTTDate"]) : null
    );
};