/**
 * @author filatov
 */
function RemoveDemoDataBlock(){}

RemoveDemoDataBlock.prototype.init = function(containerId)
{
    var self = this;
    this.demoContainer = $(containerId);
    if(this.demoContainer.length == 0) return;

    this.demoContainer.on("click", function(event){event.stopPropagation();}) ;
    this.cleanDemoButton = this.demoContainer.find("#cleanDemoDataButton");
    this.cancelDemoButton = this.demoContainer.find("#cancelDemoDataClenup");
    this.proceedCleanupDemoDataButton = this.demoContainer.find("#proceedCleanDemoDataButton");
    this.firstDemoContainerStep = true;
    this.proceedCleanupDemoDataButton.on("click", function(event)
    {
        event.stopPropagation();
        TransformedScreenMoire.showAndTransformTo("removeDemoDataMoire", 0.9, "1s", "ease-out", null, self.showPacmanAndRemoveDemoData);
    });

    this.cleanDemoButton.on("click", function(event)
                            {
                                event.stopPropagation();
                                if (self.firstDemoContainerStep)
                                {
                                    self.demoContainer.parent().addClass("demoDataContainer_secondPart");
                                    self.demoContainer.addClass("secondPart");
                                    self.firstDemoContainerStep = false;
                                }
                            }
    );

    this.cancelDemoButton.on("click", function(event)
                             {
                                 event.stopPropagation();
                                 if (!self.firstDemoContainerStep)
                                 {
                                     self.demoContainer.parent().removeClass("demoDataContainer_secondPart");
                                     self.demoContainer.removeClass("secondPart");
                                     self.firstDemoContainerStep = true;
                                 }
                             }
    );

    return this;
};

RemoveDemoDataBlock.prototype.showPacmanAndRemoveDemoData = function(){
    var pacmanImage = $("<div id='pacman' class='pacman'></div>");
    pacmanImage.appendTo("body");
    pacmanImage.css('top',$(window).outerHeight()/2);
    makeRpcCall("DemoDataService.removeDemoData", [],
                function(removeResult)
                {
                    pacmanImage.addClass("not-eat");
                    pacmanImage.css("top", pacmanImage.position().top - 100);
                    pacmanImage.atAnimation().oneTransitionEnd(function()
                                                               {
                                                                   pacmanImage.removeClass("not-eat");
                                                                   pacmanImage.addClass("smile");
                                                                   pacmanImage.append("<span class='demoDataRemovedText'>" + messageResource.getMessage(
                                                                                              "menu.support.demo_data_removed") + "</span>");
                                                                   pacmanImage.append("<span class='productReadyText'>" + messageResource.getMessage(
                                                                                              "menu.support.product_ready") + "</span>");
                                                                   setTimeout(function() {document.location.href = BASE_PATH + removeResult["afterRemoveURL"] },
                                                                              2000);
                                                               });
                },
                function()
                {
                    window.location.reload();
                    return false;
                });
};