/**
 * @author filatov
 */

function HelpAndSupportPopup(){}


HelpAndSupportPopup.prototype.init = function(config)
{
    this.containerId = config.containerId;
    this.innerPopupMenu = $.extend({}, PopupMenu);
    var self = this;

    // close menu on esc only if submitContactBlock dropDown is already hidden
    // else only hide submitContactBlock
    this.innerPopupMenu.handleEsc = function(event) {
        // self is HelpAndSupportPopup
        if(!self.submitContactBlock.hide())
        {
            // this is innerPopupMenu
            PopupMenu.handleEsc.call(this,event);
        }
    };
    this.initRemoveDemoDataBlock();
    this.initInviteColleaguesBlock();
    this.initPhoneContainer();
    this.demoContainer = $("#demoDataContainer");

    var containerEl = $("#" + this.containerId);

    // This element contains all the subcontainers and needs to know which one is on top
    var popupMenuContentEl = $(".popup_menu_support");

    if (this.demoContainer.length != 0)
    {
        containerEl.find(".popup_menu_title").html(messageResource.getMessage("menu.support.item.help_and_suuport"));
        popupMenuContentEl.addClass("demoDataContainerIsTop");
    }
    else
    {
        popupMenuContentEl.addClass("inviteUserFromHelpPopupIsTop");
    }

    this.innerPopupMenu.__stopHideAnimation = function(atAnimation) {
        atAnimation.stopTransition();
    };

    // dynamic transition example
    // if we don`t know height, we can use max-height
    this.innerPopupMenu.animationHide = function(target,cb) {
        var h = target.height();
        // 0.2 - .popup_menu_slide_up animation duration
        var seconds = h>600?((h-600) / 3600 + 0.2):0.2;

        //// we can do it jquery way.
        // target.slideUp(seconds * 1000, cb);

        target.css('height', h);
        target.css(AtAnimation.getVendorPrefixedCssName('transition'), 'height ' + seconds + 's ease-out');
        // needed to start transition without using of timeout
        target.css('height');
        target.css('height', 0);

        target.atAnimation().oneTransitionEnd(function() {
            cb();
            target.hide();
            target.css('height','');
            target.css('transition','');
        });
    };

    return this;
};

HelpAndSupportPopup.prototype.initInviteColleaguesBlock = function(){
    new InviteColleaguesBlock().init({containerId: this.containerId});
};

HelpAndSupportPopup.prototype.initPhoneContainer = function(){
    this.submitContactBlock = new SubmitContactBlock();
    this.submitContactBlock.init("_support", true);
};

HelpAndSupportPopup.prototype.initRemoveDemoDataBlock = function()
{
    new RemoveDemoDataBlock().init("#demoDataContainer");
};

HelpAndSupportPopup.prototype.show = function (event, target) {
    this.innerPopupMenu.show(event, target);
};