/************************************************ BUG REPORT ************************************************/

function openReportBugPopup(prefilledText)
{
    var url = SupportMenuConstants.reportBugURL;
    if (prefilledText) url += '?text=' + encodeURIComponent(prefilledText);
    loadPopupContent(url, function() { new SupportPopup().init().show(); }, true);
}

/**
 * Opens "Report Bug" popup window with exception description prefilled into
 * bug description text area
 */
function sendExceptionReport() {
    var url = SupportMenuConstants.reportBugURL + '?exc=';
    loadPopupContent(url, function() { new SupportPopup().init().show(); }, true);
}

function openUserGuidePage( page ) {
    var specs = undefined;
    if( isMSIE() )
        specs="scrollbars=yes, resizable=yes";
    windowOpen(USER_GUIDE_URL + page, "_blank", specs);
}

function createOpenAboutPopupHandler()
{
    var aboutPopup = undefined;
    return function()
    {
        if (_.isUndefined(aboutPopup)) {
            aboutPopup = new AboutPopup('aboutPopup').init();
        }
        aboutPopup.show();
    };
}

var MenuHandler = {

    openAbout: createOpenAboutPopupHandler(),

    contactSupport: function() {
        openReportBugPopup();
    },
    reportABug: function() {
        MenuHandler.contactSupport();
    },
    openFaq: function() {
        // Open popup and set focus to it
        windowOpen(SupportMenuConstants.faqURL, "faqWnd",
                "directories=no,height=500, width=920, location=no, menubar=no, resizable=yes, scrollbars=no, " +
                        "status=yes, titlebar=yes, toolbar=no");
    },
    sendAQuestionToVendor: function() {
        MenuHandler.contactSupport();
    },
    openUserGuide: function() {
        openUserGuidePage( "index.html" );
    },
    openUserGuidePage: function( page ) {
        openUserGuidePage( page );
    },

    openIntroVideo: function(videoCode)
    {
        TransformedScreenMoire.showAndTransformTo("supportMenuVideoMoire noprint", 0.95, "0.5s", "ease-in-out");

        var introVideoBoxId = "introVideoBoxId";
        var introVideoPlayerId = "introVideoPlaceholderId";

        var $videoBox = $("#"+introVideoBoxId);
        if($videoBox.length == 0)
        {
            $videoBox = $("<div></div>")
                    .attr("id", introVideoBoxId)
                    .addClass("noprint")
                    .appendTo("body");
        }
        else{
            $videoBox.empty();
        }
        $("<div class='introVideoHeader'>" + messageResource.getMessage("menu.support.item.video_intro.header") + "</div>").appendTo($videoBox);
        $("<div class='introVideoPlaceholder'></div>")
                .append("<div id='" + introVideoPlayerId + "'></div>")
                .appendTo($videoBox);

        // cb that calls when need to close intro video
        var onCloseVideo = function()
        {
            videoBox.hide();
            TransformedScreenMoire.hide("0.5s", "ease-in-out");
            if (videoPlayer)
            {
                videoPlayer.stopVideo();
            }
        };

        $("<div class='closeIntroVideoBtn'><span>" + messageResource.getMessage("menu.support.item.video_intro.close") + "</span></div>")
                .on("click", onCloseVideo)
                .appendTo($videoBox);

        var videoBox = new DHTMLPopupWithMoire(introVideoBoxId);
        videoBox.hideOnMouseDown = function() { return false; };
        videoBox.hideOnEscape = function() { return false; };
        videoBox.hideOnResize = function() { return false; };
        videoBox.onEscape = onCloseVideo;

        videoBox.show();
        $(videoBox.getMoireDiv()).hide();

        var videoPlayer;
        YouTubeVideoPlayerHelper.showYTPlayer(
                introVideoPlayerId,
                videoCode,
                function(player)
                {
                    videoPlayer = player;
                }
        );
    }
};

var PopupMenu = {
    hide_all:function (except,buttonExcept) {
        var body = $(".popup_menu_body");
        if (except)
            body = body.not(except);

        var self = this;
        body.each(function() {
            self.stopAnimation(this);
        });
        body.hide();

        var pressed = $('.popup_menu_button_pressed');
        if(buttonExcept)
            pressed = pressed.not(buttonExcept);

        pressed.removeClass('popup_menu_button_pressed');

        $(document).off("click.popup_menu");
        $(document.body).off("keydown.popup_menu");
    },
    show:function (event, target) {
        stopEventPropagation(event);
        var triggerButton = target.siblings('.popup_menu_button');
        this.hide_all(target,triggerButton);
        triggerButton.toggleClass('popup_menu_button_pressed');

        this.stopAnimation(target[0]);

        if (target.is(":hidden"))
            this.animationShow(target,this.initShowAnimationCallback(target));
        else
            this.animationHide(target,this.initHideAnimationCallback(target));

        var self = this;
        $(document).on("click.popup_menu", function() { self.hide_all();});
        $(document.body).on("keydown.popup_menu", function(e){handleEscape(function(){self.handleEsc(e)},e);});
    },
    handleEsc: function(e) {
        stopEventPropagation(e);
        this.hide_all();
    },
    animationShow: function(target,cb) {
        target.atAnimation().showAnimated('popup_menu_slide_down',cb);
    },
    animationHide: function(target,cb) {
        target.atAnimation().hideAnimated('popup_menu_slide_up',cb);
    },
    stopAnimation: function(el) {
        this.stopShowAnimation(el);
        this.stopHideAnimation(el);
    },
    stopShowAnimation: function(el) {
        if(el.animShowInProgress)
            this.__stopShowAnimation($(el).atAnimation());
    },
    __stopShowAnimation: function(atAnimation) {
        atAnimation.stopAnimation();
    },
    stopHideAnimation: function(el) {
        if(el.animHideInProgress)
            this.__stopHideAnimation($(el).atAnimation());
    },
    __stopHideAnimation: function(atAnimation) {
        atAnimation.stopAnimation();
    },
    initShowAnimationCallback: function(target) {
        target[0].animShowInProgress = true;
        return function() {
            target[0].animShowInProgress = false;
        }
    },
    initHideAnimationCallback: function(target) {
        target[0].animHideInProgress = true;
        return function() {
            target[0].animHideInProgress = false;
        }
    }
};

function openApIntegrationPopup(){
    openIntegrationPopup(function(){
        return new APIntegrationPopup();
    });
}

function openAtIntegrationPopup(){
    openIntegrationPopup(function(){
        return new IntegrationPopup();
    });
}

function openIntegrationPopup(popupConstructorFunction)
{
    loadPopupContent(SupportMenuConstants.integrationPopupURL, function() { showIntegrationPopup(popupConstructorFunction); }, true);
}

function openHelpAndSupportMenu(event){
    if(_.isUndefined(window.helpAndSupportMenu))
    {
        window.helpAndSupportMenu = new HelpAndSupportPopup().init({containerId:"popup_menu_support"});
    }
    event = event || window.event;
    helpAndSupportMenu.show(event, $('#popup_menu_support'));
}
