function HoverController()
{
    this.hoverRegion = NullTableRegion.instance;
    this.listeners = [];
}

HoverController.prototype = {
    addHoverChangeListener: function(listener)
    {
        this.listeners.push(listener);
    },

    fireHoverChangeEvent: function(oldHoverRegion, mouseEvent)
    {
        var hoverChangeEvent = new TableRegionChangeEvent(oldHoverRegion, this.hoverRegion);
        for (var i = 0; i < this.listeners.length; i++)
            this.listeners[i].call(this.listeners[i], hoverChangeEvent, mouseEvent);
    },

    hover: function(startCell, endCell, mouseEvent)
    {
        var oldHoverRegion = this.hoverRegion;
        this.hoverRegion = TableRegion.prototype.createFromCells(startCell, endCell);
        if (!this.hoverRegion.equals(oldHoverRegion))
            this.fireHoverChangeEvent(oldHoverRegion, mouseEvent);
    },

    unhover: function(mouseEvent)
    {
        var oldHoverRegion = this.hoverRegion;
        this.hoverRegion = NullTableRegion.instance;
        this.fireHoverChangeEvent(oldHoverRegion, mouseEvent);
    },

    isHovered: function(cell)
    {
        return this.hoverRegion.contains(cell.getRow().getRowIdx(), cell.getColIdx());
    },

    getHoverRegion: function()
    {
        return this.hoverRegion;
    }
};
