TaskManagement.Page = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskManagement.Page.LEFT_MIN_WIDTH = 360;
TaskManagement.Page.RIGHT_MIN_WIDTH = 900;

TaskManagement.Page.prototype = _.create(WindowSizeDependedView.prototype, {
    html: "<div id='taskManagementPage'>" +
          "  <div id='cpTreeBlock' class='ui-widget-content'></div>" +
          "  <div id='taskListBlock'></div>" +
          "</div>",

    afterRender: function()
    {
        this.$cpTreeBlock = this.find("#cpTreeBlock");
        var cpBlockWidthFromCookie = $.cookie("tm_cp_panel_width");
        if (cpBlockWidthFromCookie)
            this.$cpTreeBlock.width(cpBlockWidthFromCookie);
        this.$cpTreeBlock.css("min-width", px(TaskManagement.Page.LEFT_MIN_WIDTH));
        this.$cpTreeBlock.resizable({
                                        handles: 'e',
                                        minWidth: TaskManagement.Page.LEFT_MIN_WIDTH,
                                        maxWidth: this._leftMaxWidth(),
                                        stop: function(event, ui)
                                        {
                                            $.cookie("tm_cp_panel_width", ui.element.width(), {expires: 30});
                                            // Remove unwanted side-effect of jQuery UI resizable
                                            ui.element.css("height", "");
                                        }
                                    });

        this.$taskListBlock = this.find("#taskListBlock");
        this.$taskListBlock.css("min-width", TaskManagement.Page.RIGHT_MIN_WIDTH);

        this.resizableInitialized = true;
        WindowSizeDependedView.prototype.afterRender.call(this);
    },

    adjustSize: function()
    {
        WindowSizeDependedView.prototype.adjustSize.call(this);
        if (this.resizableInitialized)
        {
            this.$cpTreeBlock.resizable("option", "maxWidth", this._leftMaxWidth());
            this.$cpTreeBlock.find('.ui-resizable-handle').adjustHeightToWindowSize();
        }
    },

    _leftMaxWidth: function()
    {
        var maxWidth = $(window).width() - TaskManagement.Page.RIGHT_MIN_WIDTH;
        if (maxWidth < TaskManagement.Page.LEFT_MIN_WIDTH)
            maxWidth = TaskManagement.Page.LEFT_MIN_WIDTH;
        return maxWidth;
    }
});