TaskManagement.SearchField = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskManagement.SearchField.prototype = _.create(TemplateView.prototype, {
    html: "<div class='searchField'>" +
          "  <table class='containerTable' cellspacing='0' cellpadding='0'>" +
          "    <tr>" +
          "      <td class='inputColumn'>" +
          "        <div class='cellWrapper'><input type='text' placeholder='<%=placeholder%>' maxlength='255'/></div>" +
          "      </td>" +
          "      <td class='iconColumn'><div class='icon'>&nbsp;</div></td>" +
          "    </tr>" +
          "  </table>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        this.$input = this.find("input");
        this.$icon = this.find(".icon");
        this.$input.placeholder();
        this.$input.valueChanged(function()
                                 {
                                     var text = self.$input.pVal();
                                     self.$el.toggleClass("hasText", !!text);

                                     clearTimeout(self.timer);
                                     self.timer = setTimeout(function()
                                                             {
                                                                 self._triggerEvent(text);
                                                             }, 500);
                                 });
        this.$input.keyup(function(e)
                          {
                              if (isEscapePressed(e))
                                  self.clear()
                          });
        this.$input.focus(function(e)
                          {
                              self.$el.addClass('focusing');
                          });

        this.$input.blur(function(e)
                          {
                              self.$el.removeClass('focusing');
                          });
        this.$icon.click(function()
                         {
                             self.clear();
                         });
    },

    messageKeys: function()
    {
        return {
            placeholder: "task.list.search_placeholder"
        }
    },

    clear: function()
    {
        var text = this.$input.pVal();
        if (text)
        {
            this.$input.pVal("");
            this.$input[0].prevValue = "";
            this.$el.removeClass("hasText");
            clearTimeout(this.timer);
            this._triggerEvent("");
        }
    },

    eventName: function()
    {
        // Abstract
    },

    _triggerEvent: function(text)
    {
        $(document).trigger(this.eventName(), text);
    }
});