TaskManagement.SortableTableHeader = function($containerEl, active, asc, titleLabel)
{
    TemplateView.call(this, $containerEl);
    this.active = active;
    this.asc = asc;
    this.titleLabel = titleLabel;
};

TaskManagement.SortableTableHeader.prototype = _.create(TemplateView.prototype, {
    html: "<div class='sortableTableHeader'>" +
          "  <span class='titleLabel'><%-titleLabel%></span>" +
          "  <div class='arrowContainer'>" +
          "    <div class='ascArrow'><img src='<%=ascArrow%>'/> <span class='for-print-only'>&darr;</span></div>" +
          "    <div class='descArrow'><img src='<%=descArrow%>'/> <span class='for-print-only'>&uarr;</span></div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        this.bindClick(function()
                       {
                           if (!this.active)
                               this.active = true;
                           else
                               this.asc = !this.asc;

                           this.update();

                           $(this).trigger("click");
                       });
    },

    update: function()
    {
        this.$el.toggleClass("active", this.active);
        this.$el.toggleClass("asc", this.asc);
        this.$el.toggleClass("desc", !this.asc);
    },

    templateModel: function()
    {
        return {
            ascArrow: atDefImgPath("taskManagement/sort-down.png"),
            descArrow: atDefImgPath("taskManagement/sort-up.png")
        }
    },

    messageKeys: function()
    {
        return {
            titleLabel: this.titleLabel
        }
    },

    isActive: function()
    {
        return this.active;
    },

    setActive: function(active)
    {
        this.active = active;
        this.update();
    },

    isAsc: function()
    {
        return this.asc;
    },

    setAsc: function(asc)
    {
        this.asc = asc;
        this.update();
    }
});