TaskManagement.TaskSelectionLabel = function($containerEl, editable)
{
    TemplateView.call(this, $containerEl);
    this.isSelected = false;
    this.isDisabled = !editable;
    this.ediatable = editable;
    this.$containerEl = $containerEl;
};


TaskManagement.TaskSelectionLabel.prototype = _.create(TemplateView.prototype, {
    html: "<div class='checkbox'>" +
          "  <div class='img'></div>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        self.$el = self.$containerEl.find(".checkbox");
        this.bindClick(function()
                       {
                           if (!self.isDisabled)
                           {
                               self.setSelection(!self.isSelected);
                               $(self).trigger("change", self.isSelected);
                           }
                       });
    },

    setSelection: function(isSelected)
    {
        if (isSelected !== this.isSelected)
        {
            this.isSelected = isSelected;
            this.update();
        }
    },

    setDisabled: function(isDisabled)
    {
        if (this.ediatable && isDisabled !== this.isDisabled)
        {
            this.isDisabled = isDisabled;
            this.update();
        }
    },

    setEditable: function(editable)
    {
        this.ediatable = editable;
        if (!editable)
            this.isDisabled = true;
    },

    update: function()
    {
        this.$el.toggleClass("disabled", this.isDisabled);
        this.$el.toggleClass("active", this.isSelected);
        this.$el.toggleClass("inactive", !this.isSelected);
    }
});