TaskManagement.CustomersProjectsPanel.AddNewMenu = function($containerEl)
{
    DropdownTemplateView.call(this, $containerEl);
};

TaskManagement.CustomersProjectsPanel.AddNewMenu.prototype = _.create(DropdownTemplateView.prototype, {
    html: "<div class='dropdownContainer addNewMenu'>" +
          "  <div class='item createNewCustomer ellipsis'><%-newCustomer%></div>" +
          "  <div class='item createNewProject ellipsis'><%-newProject%></div>" +
          "</div>",

    eventPrefix: "taskManagement_customersProjectsPanel_addNewMenu_",
    
    afterRender: function()
    {
        var self = this;
        this.findAndBindClick(".createNewCustomer", function() { self._itemClick("createNewCustomer") });
        this.findAndBindClick(".createNewProject", function() { self._itemClick("createNewProject") });
    },

    messageKeys: function()
    {
        return {
            "newCustomer": "task.list.add_new.customer",
            "newProject": "task.list.add_new.project"
        }
    },

    _itemClick: function(eventName)
    {
        this.hide();
        $(document).trigger(this.eventPrefix + eventName);
    }
});