TaskManagement.CustomersProjectsPanel = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskManagement.CustomersProjectsPanel.prototype = _.create(TemplateView.prototype, {
    html: "<div class='customersProjectsPanel'>" +
          "  <div class='header'>" +
          "    <div class='title ellipsis'><%-customers_and_projects%></div>" +
          "    <div class='addNewContainer'></div>" +
          "    <div class='searchFieldContainer'></div>" +
          "  </div>" +
          "  <div class='customersProjectsTreeContainer'></div>" +
          "</div>",

    templateModel: function()
    {
        return {
            customers_and_projects: messageResource.getMessage("projects_customers_selector.customers_and_projects")
        }
    },

    afterRender: function()
    {
        if (TaskManagement.Store.canManageCP())
            new TaskManagement.CustomersProjectsPanel.AddNewButton(this.find(".addNewContainer")).init();
        new TaskManagement.CustomersProjectsPanel.SearchField(this.find(".searchFieldContainer")).init();
        this.tree = new TaskManagement.CustomersProjectsPanel.Tree(this.find(".customersProjectsTreeContainer")).init();
        this.updateCpSelector();
    },

    updateCpSelector: function()
    {
        var self = this;

        $("#customersProjectsPanelFilterCPSelectorContainer").empty();

        this.cpSelector = new CPReportSelector({showEmptyCustomers: true});
        this.currentCpSelection = TaskManagement.Store.getFilterCustomerProjectSelection();
        this.cpSelector.init(this.currentCpSelection,
                             "customersProjectsPanelFilterCPSelectorContainer",
                             function()
                             {
                                 var cpSelection = CustomerProjectSelection.fromPlainObject(self.cpSelector.getCpSelection());
                                 if (cpSelection.isEmpty())
                                 {
                                     self.cpSelector.resetSelection();
                                 }
                                 else if (!cpSelection.equals(self.currentCpSelection))
                                 {
                                     self.currentCpSelection = cpSelection;
                                     self.cpSelector.saveState();
                                     $(document).trigger("taskManagement_customersProjectsPanel_cpSelectorFilter_change", cpSelection);
                                 }
                             });
        this.cpSelector.initializeData({
                                           customers: CustomerStore.getAll(),
                                           projects: ProjectStore.getAll()
                                       });
    }
});