TaskManagement.CustomersProjectsPanel.Tree.CustomerNode = function(tokensHighlighter, customerId, collapsed)
{
    TaskManagement.CustomersProjectsPanel.Tree.EntityNode.call(this, tokensHighlighter);
    this.customerId = customerId;
    this.collapsed = collapsed;
};

TaskManagement.CustomersProjectsPanel.Tree.CustomerNode.prototype = _.create(TaskManagement.CustomersProjectsPanel.Tree.EntityNode.prototype, {
    html: "<div class='node customerNode'>" +
          "  <div class='collapseButton'></div>" +
          "  <div class='icon'></div>" +
          "  <div class='title'><%=title%> <span class='archived'>&nbsp;<%-archivedLabel%></span></div>" +
          "  <div class='editButton'></div>" +
          "</div>",

    templateKey: "TaskManagement.CustomersProjectsPanel.Tree.CustomerNode",

    afterRender: function()
    {
        TaskManagement.CustomersProjectsPanel.Tree.EntityNode.prototype.afterRender.call(this);

        var self = this;
        this.$collapseButton = this.find(".collapseButton");
        this.$editButton = this.find(".editButton");
        this.$collapseButton.click(function()
                                   {
                                       var newCollapsedValue = !self.collapsed;
                                       self.setCollapsed(newCollapsedValue);
                                       $(self).trigger("collapse", newCollapsedValue);
                                   });

        if (TaskManagement.Store.canManageCP())
        {
            this.$editButton.addClass("available");
            this.$editButton.click(function(e)
                                   {
                                       e.originalEvent._at_edit_customer_sliding_panel_preventHidding = true;
                                       $(document).trigger("taskManagement_editCustomer", self.customerId);
                                       $(self).trigger("hide_tooltip");
                                       self.preventSelecting = true;
                                   });
        }

    },

    update: function()
    {
        if (this.rendered)
        {
            TaskManagement.CustomersProjectsPanel.Tree.EntityNode.prototype.update.call(this);
            this.$el.toggleClass("collapsed", this.collapsed);
            this.$el.toggleClass("archived", CustomerStore.get(this.customerId).archived);
        }
    },

    messageKeys: function()
    {
        return {
            archivedLabel: "common.archived"
        }
    },

    title: function()
    {
        return CustomerStore.get(this.customerId).name;
    },

    isCollapsed: function()
    {
        return this.collapsed
    },

    setCollapsed: function(collapsed)
    {
        this.collapsed = collapsed;
        this.update();
    },

    editTooltip: function()
    {
        if (!TaskManagement.CustomersProjectsPanel.Tree.CustomerNode.tooltip)
            TaskManagement.CustomersProjectsPanel.Tree.CustomerNode.tooltip = new SimpleTooltip($("body"), messageResource.getMessage("task.list.tooltip.customer_edit")).init();
        return TaskManagement.CustomersProjectsPanel.Tree.CustomerNode.tooltip;
    },

    isAvailableToUpdateSelection: function()
    {
        return !_.isUndefined(CustomerStore.get(this.customerId));
    }
});