TaskManagement.CustomersProjectsPanel.Tree.EntityNode = function(tokensHighlighter)
{
    TaskManagement.CustomersProjectsPanel.Tree.Node.call(this);
    this.tokensHighlighter = tokensHighlighter;
    this.editing = false;
};

TaskManagement.CustomersProjectsPanel.Tree.EntityNode.prototype = _.create(TaskManagement.CustomersProjectsPanel.Tree.Node.prototype, {
    afterRender: function()
    {
        TaskManagement.CustomersProjectsPanel.Tree.Node.prototype.afterRender.call(this);

        this.$editButton = this.find(".editButton");
        if (TaskManagement.Store.canManageCP())
        {
            this.$editButton.addClass("available");
            var editTooltip = this.editTooltip();
            editTooltip.subscribeToMouseEvents(this.$editButton);
            $(this).on("hide_tooltip", function() { editTooltip.hide() });
        }
    },

    update: function()
    {
        TaskManagement.CustomersProjectsPanel.Tree.Node.prototype.update.call(this);

        if (this.rendered)
        {
            this.$el.toggleClass("editing", this.editing);
        }
    },

    templateModel: function()
    {
        return {title: this.tokensHighlighter ? this.tokensHighlighter.highlightTokens(this.title()) : escapeHtmlSymbols(this.title())}
    },

    title: function()
    {
        // Abstract
    },

    /**
     * @return {Tooltip}
     */
    editTooltip: function()
    {
        // Abstract
    },

    getEditing: function()
    {
        return this.editing
    },

    setEditing: function(editing)
    {
        this.editing = editing;
        this.update();
    }
});