TaskManagement.CustomersProjectsPanel.Tree.ProjectNode = function(tokensHighlighter, projectId)
{
    TaskManagement.CustomersProjectsPanel.Tree.EntityNode.call(this, tokensHighlighter);
    this.projectId = projectId;
};

TaskManagement.CustomersProjectsPanel.Tree.ProjectNode.prototype = _.create(TaskManagement.CustomersProjectsPanel.Tree.EntityNode.prototype, {
    html: "<div class='node projectNode'>" +
          "  <div class='icon'></div>" +
          "  <div class='title'><%=title%> <span class='archived'>&nbsp;<%-archivedLabel%></span></div>" +
          "  <div class='editButton'></div>" +
          "</div>",

    templateKey: "TaskManagement.CustomersProjectsPanel.Tree.ProjectNode",

    messageKeys: function()
    {
        return {
            archivedLabel: "common.archived"
        }
    },

    title: function()
    {
        return ProjectStore.get(this.projectId).name;
    },

    afterRender: function()
    {
        TaskManagement.CustomersProjectsPanel.Tree.EntityNode.prototype.afterRender.call(this);

        var self = this;
        if (TaskManagement.Store.canManageCP())
        {
            this.$editButton.click(function(e)
                                   {
                                       e.originalEvent._at_edit_project_sliding_panel_preventHidding = true;
                                       $(document).trigger("taskManagement_customersProjectsPanel_editProject", self.projectId);
                                       $(self).trigger("hide_tooltip");
                                       self.preventSelecting = true;
                                   });
        }

        this.$el.toggleClass("archived", ProjectStore.get(this.projectId).archived);
    },

    editTooltip: function()
    {
        if (!TaskManagement.CustomersProjectsPanel.Tree.ProjectNode.tooltip)
            TaskManagement.CustomersProjectsPanel.Tree.ProjectNode.tooltip = new SimpleTooltip($("body"), messageResource.getMessage("task.list.tooltip.project_edit")).init();
        return TaskManagement.CustomersProjectsPanel.Tree.ProjectNode.tooltip;
    },

    isAvailableToUpdateSelection: function()
    {
        return !_.isUndefined(ProjectStore.get(this.projectId));
    }
});