TaskManagement.TasksTable.StatusFilterButton = function($containerEl, taskStatusFilter)
{
    TemplateView.call(this, $containerEl);
    this.taskStatusFilter = taskStatusFilter;
};

TaskManagement.TasksTable.StatusFilterButton.prototype = _.create(TemplateView.prototype, {
    html: "<div class='statusFilterButton'>" +
          "  <div class='mainIcon'>&nbsp;</div>" +
          "  <div class='label'></div>" +
          "  <div class='downIcon'>&nbsp;</div>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        this.$label = this.find(".label");
        this.bindClick(function()
                       {
                           var statusFilterMenu = TaskManagement.TasksTable.StatusFilterMenu.getInstance();
                           statusFilterMenu.setTaskStatusFilter(self.taskStatusFilter);
                           if (!statusFilterMenu.ignoreNextShowing)
                               self.$el.addClass("pressed");
                           statusFilterMenu.showAt(this.$el, {offset: "0px 1px"}, function(taskStatusFilter)
                           {
                               self.$el.removeClass("pressed");
                               if (self.taskStatusFilter != taskStatusFilter)
                               {
                                   self.taskStatusFilter = taskStatusFilter;
                                   self.update();
                                   $(document).trigger("taskManagement_tasksTable_statusFilterChange", taskStatusFilter);
                               }
                           })
                       });
    },

    update: function()
    {
        var label = "";
        if (this.taskStatusFilter == TaskStatusFilter.ALL)
            label = "task.list.status_filter.all_short";
        else if (this.taskStatusFilter == TaskStatusFilter.OPEN)
            label = "task.list.status_filter.open_short";
        else if (this.taskStatusFilter == TaskStatusFilter.COMPLETED)
            label = "task.list.status_filter.completed_short";
        this.$label.text(messageResource.getMessage(label));
    }
});