TaskManagement.TasksTable.StatusFilterMenu = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

TaskManagement.TasksTable.StatusFilterMenu.getInstance = function()
{
    if (!TaskManagement.TasksTable.StatusFilterMenu.instance)
        TaskManagement.TasksTable.StatusFilterMenu.instance = new TaskManagement.TasksTable.StatusFilterMenu($("body")).init();
    return TaskManagement.TasksTable.StatusFilterMenu.instance;
};

TaskManagement.TasksTable.StatusFilterMenu.prototype = _.create(DropdownTemplateView.prototype, {
    html: "<div class='dropdownContainer statusFilterMenu'>" +
          "  <div class='item all'><%-allLabel%></div>" +
          "  <div class='item open'><%-openLabel%></div>" +
          "  <div class='item completed'><%-completedLabel%></div>" +
          "</div>",

    afterRender: function()
    {
        var self = this;
        this.findAndBindClick(".all", function() { self._itemClick(TaskStatusFilter.ALL) });
        this.findAndBindClick(".open", function() { self._itemClick(TaskStatusFilter.OPEN) });
        this.findAndBindClick(".completed", function() { self._itemClick(TaskStatusFilter.COMPLETED) });
    },

    update: function()
    {
        this.$el.toggleClass("all", this.taskStatusFilter == TaskStatusFilter.ALL);
        this.$el.toggleClass("open", this.taskStatusFilter == TaskStatusFilter.OPEN);
        this.$el.toggleClass("completed", this.taskStatusFilter == TaskStatusFilter.COMPLETED);
    },

    showAt: function($element, positionParams, callback)
    {
        DropdownTemplateView.prototype.showAt.call(this, $element, positionParams);
        this.update();
        this.callback = callback;
    },

    messageKeys: function()
    {
        return {
            allLabel: "task.list.status_filter.all",
            openLabel: "task.list.status_filter.open",
            completedLabel: "task.list.status_filter.completed"
        }
    },

    onHide: function()
    {
        DropdownTemplateView.prototype.onHide.call(this);
        this.callback(this.taskStatusFilter);
    },

    getTaskStatusFilter: function()
    {
        return this.taskStatusFilter;
    },

    setTaskStatusFilter: function(taskStatusFilter)
    {
        this.taskStatusFilter = taskStatusFilter;
    },

    _itemClick: function(taskStatusFilter)
    {
        this.taskStatusFilter = taskStatusFilter;
        this.hide();
    }
});