LockTTPage.ConfigurationPanel = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

LockTTPage.ConfigurationPanel.prototype = _.create(TemplateView.prototype, {
    html: "<table>" +
          "  <tbody>" +
          "    <tr class='reportHeaderFooterTr noprint report'>" +
          "       <td id='dateRangeSelectorCell' class='headerFooterCell cellWithBorder'>" +
          "          <div id='dateRangeSelector' class='customDateRangeSelectorPanel'></div>" +
          "          <div id='incorrectDateTooltip' class='yellowTooltip' style='display: none;'>" +
          "             <div id='incorrectDateTooltip_textPlaceholder'/>" +
          "          </div>" +
          "       </td>" +
          "       <td class='headerFooterCell cellWithBorder chooseUserButton'>" +
          "          <div id='usersSelector'><div class='errorIcon'></div></div>" +
          "       </td>" +
          "       <td class='headerFooterCell cellWithBorder emptyCell'>" +
          "          <div id='clearButton'>" +
          "             <div><%=clearButton%></div>" +
          "          </div>" +
          "       </td>" +
          "    </tr>" +
          "  </tbody>" +
          "</table>",

    messageKeys: function()
    {
        return {
            "clearButton": "view_tt.filter.clear_button.label"
        };
    },

    update: function()
    {
        var width = this._configurationPanelWidth(LockTTStore.getDateRangeConfig());
        this.setHeaderWidth(width);
    },

    _configurationPanelWidth: function(dateRange)
    {
        var columnWidth = 49;
        var nameColumnWidth = 293;

        var from = dateRange.fromDate;
        var to = dateRange.toDate;
        var numberDays = to.offsetInDaysFrom(from) + 1;

        return columnWidth * numberDays + nameColumnWidth;
    },

    setHeaderWidth: function(tableWidth)
    {
        var minWidth = 900;
        $("#lockHeader").width(Math.max(tableWidth, minWidth));
    },

    afterRender: function()
    {

    }
});