LockTTPage.FilterController = function() {};

LockTTPage.FilterController.parseDateRangeConfig = function(dateRangeConfig)
{
    return DateRangeSelectorController.prototype.parseJSON.call(this, dateRangeConfig);
};

LockTTPage.FilterController.prototype = {
    _triggerDateRangeChange: function()
    {
        $(document).trigger("dateRangeSelector.changed", this.getDateRange());
    },

    getDateRange: function()
    {
        return this.dateSelectorController.getSelectedRange();
    },

    init: function()
    {
        // date range selector
        this.dateSelectorController = new DateRangeSelectorController().init(
                {
                    dateRangeSelection: LockTTStore.getDateRangeConfig(),
                    dateRangeParsed: true,
                    rangeMinDays: 7,
                    rangeMaxDays: 62,
                    rangeTooLongMessageKey: "date_range_selector.range_error.longer_than_2_months",
                    renderTo: 'dateRangeSelector',
                    menuStates: this._createDateRangeMenu()
                });
        this.dateSelectorController.setOnChangeCallback(_.bind(this._triggerDateRangeChange, this));
        $(document).on("updateDateRange", _.bind(this.updateDateRangeSelector, this));

        // user selector
        var selectorConfig = {
            selectorId: "usersSelector",
            userSelection: LockTTStore.getUsersSelectorConfig(),
            changeCallback: function() { $(document).trigger("usersSelector.changed") }
        };
        this.userSelector = new LockTTUsersButton().init(selectorConfig);
        var usersGroupFeature = LockTTStore.getUserGroupFeatureForSelector();
        var timeZoneGroupFeature = LockTTStore.getTimeZoneGroupFeatureForSelector();
        this.userSelector.initializeData(usersGroupFeature,
                                         timeZoneGroupFeature,
                                         LockTTStore.getUsersForSelector(),
                                         LockTTStore.getUsersGroupsForSelector(),
                                         LockTTStore.getTimeZonesForSelector());


        this.errorTooltip = LockTTPage.ErrorTooltip.getInstance();
        var userButton = $("#lockTableFilter").find(".chooseUserButton");
        this.errorTooltip.subscribeToMouseEvents(userButton);
        this.errorTooltip.disable();

        return this;
    },

    setErrorTooltipEnabled: function(isEnabled)
    {
        this.errorTooltip.setEnabled(isEnabled);
    },

    getUserSelection: function()
    {
        return this.userSelector.getSelection();
    },

    setUserSelection: function(config)
    {
        this.userSelector.setSelection(config);
    },

    updateDateRangeSelector: function()
    {
        this.dateSelectorController.setSelectedRange(LockTTStore.getDateRangeConfig());
    },

    _createDateRangeMenu: function()
    {
        return [
            new AT.CurrentWeekMenuItem(),
            new AT.CurrentAndPreviousWeeksMenuItem(),
            new AT.CurrentAndTwoPreviousWeeksMenuItem(),
            AT.DateRangeSelectorSeparator,
            new AT.Last7DaysMenuItem(),
            new AT.Last14DaysMenuItem(),
            AT.DateRangeSelectorSeparator,
            new AT.CurrentMonthMenuItem(),
            new AT.PreviousMonthMenuItem(),
            AT.DateRangeSelectorSeparator,
            new AT.CustomDateRangeMenuItem()
        ];
    }
};