function LockTTTopInfo($containerEl)
{
    TemplateView.call(this, $containerEl);
    this.dateFormat = new DateFormat(SystemSettings.dateFormat);
}

LockTTTopInfo.prototype = _.create(TemplateView.prototype, {
    html: "<table class='topInfo' border='0' cellpadding='0' cellspasing='0' id='topPagerWidthStruct'>" +
          "  <tr>" +
          "    <td></td>" +
          "    <td class='text lockedTillDateColumn'>" +
          "      <span>" +
          "        <img src='<%=unlockImg%>' class='lockImg'/>" +
          "        <span class='ttOfSelectedUsersText'></span>" +
          "        <span id='lockedTillDate'></span>" +
          "      </span>" +
          "    </td>" +
          "    <td class='lockTTLegend' style='float: right'>" +
          "      <table>" +
          "        <tr>" +
          "          <td style='width:18px;'>" +
          "            <span class='legendSeparator'></span>" +
          "          </td>" +
          "          <td style='padding-right: 20px'>" +
          "            <div class='legendCell lockedCell'></div>" +
          "            <span class='legendTextType'><%=legendLocked%></span>" +
          "          </td>" +
          "          <td style='padding-right: 20px'>" +
          "            <div class='legendCell approveAndLockedCell'></div>" +
          "            <span class='legendTextType'><%=legendApproveAndLocked%></span>" +
          "          </td>" +
          "          <td width='75px'>" +
          "            <div class='legendCell approveCell'></div>" +
          "            <span class='legendTextType'><%=legendApproved%></span>" +
          "          </td>" +
          "        </tr>" +
          "      </table>" +
          "    </td>" +
          "  </tr>" +
          "</table>",

    updateOnInit: false,

    templateModel: function()
    {
        return {
            unlockImg: atImgPath("/unlock.png")
        }
    },

    messageKeys: function()
    {
        return {
            "legendLocked": "lock_tt.legend.locked",
            "legendApproveAndLocked": "lock_tt.legend.approve_and_locked",
            "legendApproved": "lock_tt.legend.approved"
        }
    },

    afterRender: function()
    {
        this.$ttOfSelectedUsersText = this.find(".ttOfSelectedUsersText");
        this.$lockedTillDate = this.find("#lockedTillDate");
    },

    update: function()
    {
        var pagerConfig = LockTTStore.getPagerConfig();
        if (_.isNull(pagerConfig) || pagerConfig.recordsNumber <= 0)
        {
            this.$el.hide();
            return;
        }
        this.$el.toggleClass("hideLegend", !LockTTStore.getEnabledFeatures().TTA);
        this.updateTillDate();
        this.$el.show();
    },

    updateTillDate: function()
    {
        var lockedTillDate = LockTTStore.getLockedTillDate();
        var pagerConfig = LockTTStore.getPagerConfig();
        var hideLockedTillDate = _.isNull(lockedTillDate);
        this.$el.toggleClass("hideLockedTillDate", hideLockedTillDate);
        if (!hideLockedTillDate)
        {
            var ttOfSelectedUsersText = pagerConfig.recordsNumber == 1 ?
                                        messageResource.getMessage("lock_tt.tt_of_selected_user_is_completely_locked_till") :
                                        messageResource.getMessage("lock_tt.tt_of_selected_users_is_completely_locked_till", [pagerConfig.recordsNumber]);
            this.$ttOfSelectedUsersText.empty();
            this.$ttOfSelectedUsersText.append(ttOfSelectedUsersText);

            this.$lockedTillDate.empty();
            var dateRangeConfig = LockTTStore.getDateRangeConfig();
            if (lockedTillDate >= dateRangeConfig.fromDate && lockedTillDate <= dateRangeConfig.toDate) // lockedTillDate inside dateRange
            {
                this.$lockedTillDate.append($("<b>" + this.dateFormat.formatDate(lockedTillDate) +"</b>"));
            }
            else
            {
                var $link = $("<a href='javascript:void(0);'>" + this.dateFormat.formatDate(lockedTillDate) + "</a>");
                $link.click(function()
                            {
                                $(document).trigger("navigate.till_lock_date");
                            });
                this.$lockedTillDate.append($link);
            }
        }
    }
});