var UserSelectionUtils = {
    empty: function(config)
    {
        return config.allUsers == false &&
               config.selectedGroups.length == 0 &&
               config.selectedUsers.length == 0;
    },

    equals: function(firstSelection, secondSelection)
    {
        if (firstSelection.allUsers == secondSelection.allUsers && secondSelection.allUsers == true)
            return true;

        return firstSelection.allUsers == secondSelection.allUsers &&
               this._arrayEquals(firstSelection.selectedGroups, secondSelection.selectedGroups) &&
               this._arrayEquals(firstSelection.selectedUsers, secondSelection.selectedUsers) &&
               firstSelection.showDisabled == secondSelection.showDisabled &&
               firstSelection.groupType == secondSelection.groupType;
    },

    _arrayEquals: function(firstArray, secondArray)
    {
        if (firstArray === secondArray)
            return true;

        if (firstArray == null || secondArray == null)
            return false;

        if (firstArray.length != secondArray.length)
            return false;

        firstArray.sort();
        secondArray.sort();

        for (var i = 0; i < firstArray.length; i++)
        {
            if (firstArray[i] != secondArray[i])
                return false;
        }
        return true;
    },

    defaultUserSelector: function()
    {
        return {
            allUsers: true,
            selectedGroups: [],
            selectedUsers: [],
            groupType: "USER_GROUP",
            showDisabled: true
        }
    }
};