ViewTTPage.BalancesViewerController = function($containerEl) { BaseBalancesViewerController.call(this, $containerEl) };

ViewTTPage.BalancesViewerController.prototype = _.create(BaseBalancesViewerController.prototype, {

    init: function()
    {
        BaseBalancesViewerController.prototype.init.call(this);

        $(ViewTTStore).on("balancesDataChange", _.bind(this._updateBalances, this));

        return this;
    },

    createBalanceViewer: function($containerEl)
    {
        return new BalancesViewer($containerEl);
    },

    getUserWorkScheduleData: function()
    {
        return ViewTTStore.getBalancesViewerConfig();
    },

    getFormatterSettings: function()
    {
        return ViewTTStore.getFormatterConfig();
    },

    onDateChange: function(e, selectedDate)
    {
        $(document).trigger("viewTT.balancesViewerDateChange", selectedDate)
    },

    _updateBalances: function()
    {
        var data = ViewTTStore.getBalancesData();
        var balanceDate = ViewTTStore.getBalancesViewerDate();

        var wasPtoEnabled = this.balancesViewer.isDisplayedPto();
        var wasSickEnabled = this.balancesViewer.isDisplayedSick();

        var ptoFeatureEnabled = ViewTTPageUtils.isFeatureEnabled(Features["PTO"]);
        var sickFeatureEnabled = ViewTTPageUtils.isFeatureEnabled(Features["SDB"]);

        var selectedUserId = ViewTTStore.getSelectedUserId();

        if ((!ptoFeatureEnabled && wasPtoEnabled) || (!sickFeatureEnabled && wasSickEnabled))
        {
            var balancesKey;
            if (!sickFeatureEnabled && !ptoFeatureEnabled)
                balancesKey = "view_tt.balances_viewer.all_calculations";
            else if (!ptoFeatureEnabled)
                balancesKey = "view_tt.balances_viewer.pto_calculation";
            else
                balancesKey = "view_tt.balances_viewer.sick_calculation";

            alert(messageResource.getMessage("view_tt.balances_viewer.turn_off", [messageResource.getMessage(balancesKey)]));
        } else if (selectedUserId === this.previousUserId && (!data.displayPto && wasPtoEnabled || !data.displaySick && wasSickEnabled)) {
            if (!data.displayPto && !data.displaySick)
                balancesKey = "view_tt.balances_viewer.all_controls";
            else if (!data.displayPto)
                balancesKey = "view_tt.balances_viewer.pto_control";
            else
                balancesKey = "view_tt.balances_viewer.sick_control";

            alert(messageResource.getMessage("view_tt.balances_viewer.turn_off_controls", [messageResource.getMessage(balancesKey)]));
        }

        this.previousUserId = selectedUserId;

        BaseBalancesViewerController.prototype.updateBalances.call(this, balanceDate, data);
        $(document).trigger("viewTT.balanceViewer.update");
    },

    hide: function()
    {
        this.balancesViewer.hide();
        this.spinner.stop();
        $(document).trigger("viewTT.balanceViewer.hide");
    },

    getViewerDate: function()
    {
        return this.balancesViewer.getDate();
    },

    setDate: function(date)
    {
        this.balancesViewer.setDate(date);
    }
});