ViewTTPage.ParametersFormattingStrategy = function() {};

ViewTTPage.ParametersFormattingStrategy.prototype = _.create(BaseParametersFormattingStrategy.prototype, {

    createParametersFormatter: function(selectorsData, dateFormat)
    {
        return new ParametersFormatter().init(selectorsData, dateFormat);
    },

    createDateParametersFormattingStrategy: function(dateFormat)
    {
        return new DateRangeFormattingStrategy().init(dateFormat);
    },

    formatMainPartOfLightboxTitle: function(selectedParameters)
    {
        var dateParameters = this.dateParametersFormattingStrategy.formatForDateInformation(selectedParameters.dateParameters);
        if (selectedParameters.pageOwnerData.otherUser)
        {
            var user = selectedParameters.pageOwnerData.user;
            var userAsString = UserNameFormat.formatFML(user.firstName, user.lastName, user.middleName);
            return messageResource.getMessage("view_tt.pdf_preview.other_user_title", [userAsString, dateParameters]);
        }
        return messageResource.getMessage("view_tt.pdf_preview.my_title", [dateParameters]);
    },

    formatParametersText: function(selectedParameters)
    {
        var statusesFilter = ViewTTPageUtils.makeStatusFilterToDisplay(selectedParameters.statuses);
        var statuses = _.isNull(statusesFilter) ? "" : this.parametersFormatter.formatStatusesSelection(statusesFilter) +  "; ";
        return statuses + this.parametersFormatter.formatCustomersAndProjectsSelection(selectedParameters.cpSelection);
    }
});