function ViewTTPage($containerEl)
{
    TemplateView.call(this, $containerEl);
}

ViewTTPage.prototype = _.create(TemplateView.prototype, {
    html: "<div id='viewTTContent' style='display: none'>" +
          "  <div id='viewTTPrintHeaderContainer'></div>" +
          "  <table class='viewTTHeader noprint' cellpadding='0' cellspacing='0'><tr>" +
          "    <td class='viewTimeTrackTitle pagetitle'><span><%=viewTTFor%></span></td>" +
          "    <td class='userSelectorTd pagetitle'><table cellpadding='0' cellspacing='0'><tr>" +
          "         <td class='selectorInputTd'><div id='singleUserSelector'></div></td>" +
          "         <td class='userSelectorButton'><div class='userNameWrapper'><span class='dashedLink'></span></div><span class='arrow'></span></td>" +
          "         <td class='backToMySheet'><span class='backToMyTTSeparator'></span></td>" +
          "         <td class='backToMySheet backToMyTTImg'></td>" +
          "         <td class='backToMySheet backToMyTTLabel'><a class='backToMyTtText link'><%=backToMe%></a></td>" +
          "    </tr></table></td>" +
          "    <td class='balancesViewerOuterPlaceholder'>" +
          "      <div id='balancesViewerSpinner'></div>" +
          "      <div id='balancesViewerPlaceholder'></div>" +
          "    </td>" +
          "  </tr></table>" +
          "  <div class='viewTTChartPanel'>" +
          "    <table class='viewTTFilterPanel noprint' cellspacing='0' cellpadding='0'>" +
          "         <tr>" +
          "            <td id='dateRangeSelectorCell' class='dateRangeSelectorCell headerFooterCell cellWithBorder'>" +
          "                <div id='viewTTDateSelector' class='viewTTDateSelector customDateRangeSelectorPanel'></div>" +
          "            </td>" +
          "            <td class='filterPane cellWithBorder'><table class='filterPaneContent'  cellspacing='0' cellpadding='0'><tr id='viewTTFilterContainer'>" +
          "                <td class='filterEditButton headerFooterCell activeButton'>" +
          "                    <div class='filterButtonContainer'><div class='errorIcon'></div><div class='filterIcon'><span class='dropDownIcon'><%=viewTTFilterEdit%></span></div></div>" +
          "                </td>" +
          "                <td class='noTTACPSelector activeButton'>" +
          "                    <div class='filterButtonContainer'><div class='errorIcon'></div><div class='filterIcon'><div class='dropDownIcon'><div class='label'/></div></div></div>" +
          "                </td>" +
          "                <td class='filterClearButtonWrap headerFooterCell'>" +
          "                    <div class='filterClearButton clearIcon' title='<%=viewTTFilterClear%>'><div class='text'><%=viewTTFilterClear%></div></div>" +
          "                </td>" +
          "                <td style='display:none'>" +
          "                    <div id='noTTACPSelector'/>" +
          "                </td>" +
          "            </tr></table></td>" +
          "            <td class='generatePDF headerFooterCell activeButton cellWithBorder'>" +
          "                <%=exportPdfLabel%>" +
          "            </td>" +
          "         </tr>" +
          "    </table>" +
          "    <div id='filterDialog' class='viewTTFilterDialog noprint'></div>" +
          "    <div class='chartPanelContent'>" +
          "        <div id='viewTTTotals' class='viewTTTotals'></div>" +
          "        <div id='viewTTChartSectionContainer'></div>" +
          "    </div>" +
          "  </div>" +
          "  <div id='viewTTExportPdfDisabledTooltip' class='yellowTooltip' style='display: none;'>" +
          "    <div id='viewTTExportPdfDisabledTooltip_textPlaceholder'><%=exportPdfDisabledTooltip%></div>" +
          "  </div>" +
          "  <div id='viewTTDetailsTableContainer' class='viewTTDetailsTableContainer'></div>" +
          "  <div id='viewTTPrintFooter' class='for-print-only'>" +
          "    <span class='signatureField'>Signature</span>" +
          "    <span class='gapField'></span>" +
          "    <span class='signatureField'>Date</span>" +
          "  </div>" +
          "  <div id='viewTTUsersSelectorWarning'></div>" +
          "  <div id='incorrectDateTooltip' class='yellowTooltip tooltipText' style='display: none;'>" +
          "     <div id='incorrectDateTooltip_textPlaceholder'/>" +
          "  </div>" +
          "</div>",

    templateModel: function()
    {
        return {};
    },

    templateKeys: function()
    {
        return {};
    },

    messageKeys: function()
    {
        return {
            "viewTTFilterEdit": "view_tt.filter.edit_button.label",
            "viewTTFilterClear": "view_tt.filter.clear_button.label",
            "exportPdfLabel": "view_tt.export.pdf.label",
            "viewTTFor": "view_tt.title",
            "backToMe": "usersselector.back_to_me",
            "exportPdfDisabledTooltip": "common.export.pdf.disabled_tooltip"
        };
    },

    update: function()
    {
        this.$chartPanel.toggleClass("chartVisible", ViewTTStore.getChartSectionConfig()["showChart"]);
    },

    afterRender: function()
    {
        this.$chartPanel = this.find(".chartPanelContent");

        var chartPanelMoire = new LoadingMoire(this.$chartPanel, ViewTTPageUtils.SPINNER_SETTINGS).init();

        $(document).on("viewTT.beginLoadData", function()
        {
            chartPanelMoire.show()
        });
        $(document).on("viewTT.endLoadData", function()
        {
            chartPanelMoire.hide();
        });

        var self = this;
        $(ViewTTStore).on("chartSectionConfigChange", function()
        {
            self.update();
        });

        var generatePdfButton = this.find(".generatePDF");

        if (isOldIE())
        {
            var exportPdfDisabledTooltip = new TableTooltip().init("viewTTExportPdfDisabledTooltip");

            generatePdfButton.addClass("disabled");
            generatePdfButton.hover(
                    function() { exportPdfDisabledTooltip.show() },
                    function() { exportPdfDisabledTooltip.hide() }
            );
            generatePdfButton.mousemove(function(event) { exportPdfDisabledTooltip.move(calculateTooltipOffset(exportPdfDisabledTooltip, event)); });
        }
        else
        {
            var generatePdfEnabled = true;

            $(document).on("viewTT.beginLoadData", function()
            {
                generatePdfEnabled = false;
                generatePdfButton.toggleClass("disabled", true);
            });
            $(document).on("viewTT.endLoadData", function()
            {
                generatePdfEnabled = true;
                generatePdfButton.toggleClass("disabled", false);
            });

            this.findAndBindClick(".generatePDF", function()
            {
                if(generatePdfEnabled)
                    $(document).trigger("viewTT.showPDFPreview")
            });
        }

        $(document).on("viewTT.init", function()
        {
            self.update();
            self.$el.atAnimation().fadeIn();
        })
    },

    showPageComponents: function()
    {
        this.find(".viewTTChartPanel").addClass("showViewTTChartPanel");
    }
});