ViewTTPage.UsersSelector = function()
{
    BaseUsersSelector.call(this);
};

ViewTTPage.UsersSelector.prototype = _.create(TTUsersSelector.prototype, {
    init: function(users, groups, selectedUserId)
    {
        var emptyText = messageResource.getMessage("usersselector.please_select_a_user");
        var initialValue = (selectedUserId == -1) ? null : selectedUserId;
        TTUsersSelector.prototype.init.call(this, users, groups, initialValue, emptyText, "", 0, "usersSelectorOnTT", EnabledFeatures.UGR, EnabledFeatures.TZG);
        $(".viewTimeTrackTitle").html("<span>" + messageResource.getMessage("view_tt.title.for") + "</span>");
        $(ViewTTStore).on("dataConfigRestored", _.bind(this._reInit, this));
    },

    _getLoggedInUserId: function()
    {
        return ViewTTStore.getViewerId();
    },

    _reInit: function()
    {
        this.usersCombo.setValue(ViewTTStore.getSelectedUserId());
        this.updateUI();
    },

    onUserSelect: function(selected)
    {
        $(document).trigger("viewTT.selectedUserChange", selected);
        this.usersCombo.setValue(selected);
        this.updateUI();
    },

    needToRenderSelector: function()
    {
        return ViewTTStore.isNeedToRenderUsersSelector();
    }
});