ViewTTPage.ChartSection.ChartTypeSelector = function($containerEl, selectedChartType)
{
    DropdownTemplateView.call(this, $containerEl);
    this._selectedChartType = selectedChartType;
    this.updateOnInit = false;
};


ViewTTPage.ChartSection.ChartTypeSelector.prototype = _.create(DropdownTemplateView.prototype, {

    html: "<div class='viewTTChartTypeSelector noprint menuZindex' style='display: none;'>" +
          "    <div class='row byDays'><div class='type'><%-byDays%></div></div>" +
          "    <div class='separator'></div>" +
          "    <div class='row byCustomers'><div class='type'><%-byCustomers%></div></div>" +
          "    <div class='row byProjects'><div class='type'><%-byProjects%></div></div>" +
          "</div>",

    afterRender: function()
    {
        this.isShown = false;

        this._bindRowClickFunction(ViewTTChartType.BY_DAYS);
        this._bindRowClickFunction(ViewTTChartType.BY_CUSTOMERS);
        this._bindRowClickFunction(ViewTTChartType.BY_PROJECTS);
    },

    messageKeys: function()
    {
        return {
            "byDays": "view_tt.chart.view_by_days",
            "byCustomers": "view_tt.chart.view_by_customers",
            "byProjects": "view_tt.chart.view_by_projects"
        }
    },

    update: function()
    {
        this.find(".selected").removeClass("selected");
        this._getRowByType(this._selectedChartType).addClass("selected");
    },

    _getRowByType: function(chartType)
    {
        switch (chartType)
        {
            case ViewTTChartType.BY_DAYS:
                return this.find(".byDays");
            case ViewTTChartType.BY_CUSTOMERS:
                return this.find(".byCustomers");
            case ViewTTChartType.BY_PROJECTS:
                return this.find(".byProjects");
        }
    },

    _bindRowClickFunction: function(chartType)
    {
        this._getRowByType(chartType).on(
                "click",
                _.bind(function()
                       {
                           this.hide();
                           this._onChartTypeSelected(chartType);
                       },
                       this)
        )
    },

    _onChartTypeSelected: function(chartType)
    {
        if (this._selectedChartType != chartType)
        {
            this._selectedChartType = chartType;
            $(this).trigger("chartTypeChanged", chartType);
        }
    }
});