ViewTTPage.PieChartByCustomersGenerator = function() {};

ViewTTPage.PieChartByCustomersGenerator.prototype = _.create(ViewTTPage.PieChartGenerator.prototype, {
    _getDataProvider: function(chartData, config)
    {
        var dataProvider = [];
        var customersTTData = chartData["customersTTData"];
        for (var i = 0; i < customersTTData.length; i++)
        {
            var currentItem = customersTTData[i];
            dataProvider.push({
                                  "category": this._formattedCategory(currentItem, config),
                                  "value": currentItem["totalSpent"]
                              });
        }
        var otherTTInfo = chartData["otherTTInfo"];
        if (!_.isNull(otherTTInfo))
        {
            dataProvider.push({
                                  "category": messageResource.getMessage("view_tt.chart.other_tt_customers"),
                                  "value": otherTTInfo["spent"],
                                  "sectorColor": "#dbdbdb"
                              });
        }

        return dataProvider;
    },

    _formattedCategory: function(currentItem, config)
    {
        var customersMap = config["customersMap"];
        return customersMap[currentItem["customerId"]].name;
    }
});