ViewTTPage.PieChartByProjectsGenerator = function() {};

ViewTTPage.PieChartByProjectsGenerator.prototype = _.create(ViewTTPage.PieChartGenerator.prototype, {
    _getDataProvider: function(chartData, config)
    {
        var dataProvider = [];
        var customersData = chartData["customersTTData"];

        for (var i = 0; i < customersData.length; i++)
        {
            var oneCustomerData = customersData[i];
            for (var j = 0; j < oneCustomerData["projectTTData"].length; j++)
            {
                var projectData = oneCustomerData["projectTTData"][j];
                dataProvider.push({
                                      "category": this._formattedCategory(oneCustomerData, projectData, config),
                                      "value": projectData["totalSpent"]
                                  });
            }
        }
        var otherTTInfo = chartData["otherTTInfo"];
        if(!_.isNull(otherTTInfo))
        {
            dataProvider.push({
                                  "category": messageResource.getMessage("view_tt.chart.other_tt_projects"),
                                  "value": otherTTInfo["spent"],
                                  "sectorColor": "#dbdbdb"
                              });
        }
        return dataProvider;
    },

    _formattedCategory: function(customerData, projectData, config)
    {
        var customersMap = config["customersMap"];
        var projectsMap = config["projectsMap"];
        return projectsMap[projectData["projectId"]].name + " (" + customersMap[customerData["customerId"]].name + ")";
    }
});
