ViewTTPage.DetailsTable.ConfigPanel = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

ViewTTPage.DetailsTable.ConfigPanel.prototype = _.create(TemplateView.prototype, {
    html: "<div class='configPanel'>" +
          "  <span class='viewByLabel'><%=viewByLabel%></span>" +
          "  <div class='viewByDaysContainer'></div>" +
          "  <span class='separator'></span>" +
          "  <div class='viewByCPContainer'></div>" +
          "  <div class='showTasksContainer'>" +
          "    <label><input type='checkbox' class='showTasks'/><%-showTasksLabel%></label>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        this.configModel = ViewTTStore.getDetailsTableConfig();

        this.viewByDaysButton = new ViewTTPage.DetailsTable.ConfigPanel.SortButton(
                this.find(".viewByDaysContainer"),
                this.configModel.viewByDays,
                this.configModel.asc,
                "view_tt.details_table.view_by_days",
                this.bind(this._onViewByDaysButtonClick)).init();

        this.viewByCPButton = new ViewTTPage.DetailsTable.ConfigPanel.SortButton(
                this.find(".viewByCPContainer"),
                !this.configModel.viewByDays,
                this.configModel.asc,
                "view_tt.details_table.view_by_cp",
                this.bind(this._onViewByCPButtonClick)).init();

        this.$showTasksCheckbox = this.findAndBindClick(".showTasks", this._onShowTasksCheckboxClick);
        if (this.configModel.showTasks)
            this.$showTasksCheckbox.attr("checked", true);
        else
            this.$showTasksCheckbox.removeAttr("checked");
    },

    messageKeys: function()
    {
        return {
            viewByLabel: "view_tt.details_table.view_by",
            showTasksLabel: "view_tt.details_table.show_tasks"
        }
    },

    _onViewByDaysButtonClick: function()
    {
        this.configModel.viewByDays = true;
        this.configModel.asc = this.viewByDaysButton.isAsc();
        this.viewByCPButton.setActive(false);
        this._triggerChange();
    },

    _onViewByCPButtonClick: function()
    {
        this.configModel.viewByDays = false;
        this.configModel.asc = this.viewByCPButton.isAsc();
        this.viewByDaysButton.setActive(false);
        this._triggerChange();
    },

    _onShowTasksCheckboxClick: function()
    {
        this.configModel.showTasks = !!this.$showTasksCheckbox.attr("checked");
        this._triggerChange();
    },

    _triggerChange: function()
    {
        $(document).trigger("viewTT.detailsTable.configPanel.change", this.configModel);
    }
});