ViewTTPage.DetailsTable.ConfigPanel.SortButton = function($containerEl, active, asc, titleLabel, onClick)
{
    TemplateView.call(this, $containerEl);
    this.active = active;
    this.asc = asc;
    this.titleLabel = titleLabel;
    this.onClick = onClick;
};

ViewTTPage.DetailsTable.ConfigPanel.SortButton.prototype = _.create(TemplateView.prototype, {
    html: "<div class='sortButton'>" +
          "  <span class='titleLabel'><%-titleLabel%></span>" +
          "  <div class='arrowContainer'>" +
          "    <div class='ascArrow'><img src='<%=ascArrow%>'/> <span class='for-print-only'>&darr;</span></div>" +
          "    <div class='descArrow'><img src='<%=descArrow%>'/> <span class='for-print-only'>&uarr;</span></div>" +
          "  </div>" +
          "</div>",

    afterRender: function()
    {
        this.bindClick(this._onClick);
    },

    update: function()
    {
        this.$el.toggleClass("active", this.active);
        this.$el.toggleClass("asc", this.asc);
        this.$el.toggleClass("desc", !this.asc);
    },
    templateModel: function()
    {
        return {
            ascArrow: atDefImgPath("arrow-down.png"),
            descArrow: atDefImgPath("arrow-up.png")
        }
    },

    messageKeys: function()
    {
        return {titleLabel: this.titleLabel}
    },

    isActive: function()
    {
        return this.active;
    },

    setActive: function(active)
    {
        this.active = active;
        this.update();
    },

    isAsc: function()
    {
        return this.asc;
    },

    _onClick: function()
    {
        if (!this.active)
            this.active = true;
        else
            this.asc = !this.asc;

        this.update();
        this.onClick();
    }
});