ViewTTPage.DetailsTable.TaskRow = function($containerEl, taskModel, last)
{
    TemplateView.call(this, $containerEl);
    this.taskModel = taskModel;
    this.last = last;
};

ViewTTPage.DetailsTable.TaskRow.prototype = _.create(TemplateView.prototype, {
    afterRender: function()
    {
        var task = ViewTTStore.getTask(this.taskModel.taskId);
        this.$el.toggleClass("nonLast", !this.last);
        this.$el.toggleClass("completed", task.completed);
        var isAvailable = ViewTTStore.getProject(task.projectId).available;
        if (isAvailable)
        {
            this.$el.click(this.bind(this._onClick));
        }
        else
        {
            this.tooltip = ViewTTPage.DetailsTable.TaskTooltip.getInstance();
            this.tooltip.subscribeToMouseEvents(this.$el);
        }
        this.$el.toggleClass("available", isAvailable);
    },

    getTaskModel: function()
    {
        return this.taskModel;
    },

    _onClick: function()
    {
        $(document).trigger("viewTT.detailsTable.taskClick", this.taskModel.taskId);
    }
});

