ViewTTPage.DetailsTable.ViewByDaysTaskRow = function($containerEl, dayModel, taskModel, last)
{
    TemplateView.call(this, $containerEl);
    this.dayModel = dayModel;
    this.taskModel = taskModel;
    this.last = last;
};

ViewTTPage.DetailsTable.ViewByDaysTaskRow.prototype = _.create(ViewTTPage.DetailsTable.TaskRow.prototype, {
    html: "<tr class='taskRow'>" +
          "  <td class='nameColumn'>" +
          "    <div class='subContainer'>" +
          "      <div class='name'><%-name%></div>" +
          "      <div class='subtitle'><%-customerName%> / <%-projectName%></div>" +
          "    </div>" +
          "  </td>" +
          "  <td class='totalColumn'><div class='subContainer'><%-total%></div></td>" +
          "  <td class='detailsColumn'><div class='subContainer'><%-comment%></div></td>" +
          "</tr>",

    templateKey: "ViewTTPage.DetailsTable.ViewByDaysTaskRow",

    afterRender: function()
    {
        ViewTTPage.DetailsTable.TaskRow.prototype.afterRender.call(this);
        this.$el.toggleClass("locked", this.dayModel.locked);
        this.$el.toggleClass("nonWorking", this.dayModel.workdayDuration == 0);
    },

    templateModel: function()
    {
        return {
            name: ViewTTStore.getTask(this.taskModel.taskId).name,
            customerName: ViewTTStore.getCustomer(this.taskModel.customerId).name,
            projectName: ViewTTStore.getProject(this.taskModel.projectId).name,
            total: UserTime.formatTimeWithDigitSeparator(this.taskModel.spent),
            comment: this.taskModel.comment
        }
    }
});