ViewTTPage.ViewTTCPSelector = function() {};

ViewTTPage.ViewTTCPSelector.prototype = _.create(CPReportSelector.prototype, {
    _createDropDownButton: function(buttonConfig)
    {
        return new ViewTTPage.ViewTTCPSelectorDropDownButton(buttonConfig);
    },

    _initDropDownButton: function(changedCallback)
    {
        CPReportSelector.prototype._initDropDownButton.call(this,changedCallback);
        this.button.init(this);
    },

    _removeDeletedCPFromSelection: function(cpList, cpSelection)
    {
        var customersMap = arrayToMapById(cpList.customers);
        var projectsMap  = arrayToMapById(cpList.projects);

        this._removeObsoleteItems(cpSelection.customers, customersMap);
        this._removeObsoleteItems(cpSelection.projects, projectsMap);

        var state = this.predefinedState;
        this._removeObsoleteItems(state.selection.getFirstLevel(), customersMap);
        this._removeObsoleteItems(state.selection.getSecondLevel(), projectsMap);
    },

    _removeObsoleteItems: function(items, itemsMap)
    {
        for (var i = items.length - 1; i >= 0; i--)
        {
            if (!itemsMap[items[i]])
                items.splice(i, 1);
        }
    },

    remakeSelector: function()
    {
        // if treePanel not defined, then we never opened selector
        if(this.panel.isAlreadyShown())
        {
            $(this.panel.treePanel).empty();
            this.panel.initializeSelector(this.preloadedData);
            
            var cpSelection = ViewTTStore.getFilter().cpSelection;
            var showArchived = cpSelection.showArchivedProjects;

            // need to refilter correctly
            this.panel.activeOnlySet = showArchived;
            this.panel.selectorFilter.setShowInactiveAndReFilter(showArchived, true);

            this.setInitialValueFromCurrent();
        }
    },

    markAsInvalid: function()
    {
        this.button._invalidateCPListStatus();
    },

    isValid: function()
    {
        return this.button.isCPListValid;
    }
});
