ViewTTPage.PDFParametersFormattingStrategy = function() {};

ViewTTPage.PDFParametersFormattingStrategy.prototype = _.create(ChartPDFParametersFormattingStrategy.prototype, {
    init: function(selectorsData, dateFormat, dateFormatForFile)
    {
        ChartPDFParametersFormattingStrategy.prototype.init.call(this, selectorsData, dateFormat, dateFormatForFile);

        return this;
    },

    createDateParametersFormattingStrategy: function(dateFormat, dateFormatForFile)
    {
        return new ChartPDFDateRangeFormattingStrategy().init(dateFormat, dateFormatForFile);
    },

    formatChartPDFFilterInformation: function(selectedParameters)
    {
        var statusesFilter = ViewTTPageUtils.makeStatusFilterToDisplay(selectedParameters.statuses);
        return {
            firstRow: this.parametersFormatter.formatCustomersAndProjectsSelection(selectedParameters.hierarchicalSelectorsParameters.customersProjectsSelection),
            secondRow: _.isNull(statusesFilter) ? "" : this.parametersFormatter.formatStatusesSelection(statusesFilter)
        }
    },

    formatChartPDFFileName: function(selectedParameters)
    {
        var fileNameParts = [];
        var user = selectedParameters.user;
        var formattedName = UserNameFormat.formatFML(user.firstName, user.lastName, user.middleName);
        fileNameParts.push(formattedName);
        fileNameParts.push(this.dateParametersFormattingStrategy.formatDateForFileName(selectedParameters.dateParameters));
        return messageResource.getMessage('view_tt.pdf.file_name', fileNameParts);/*.replace(/[^a-z0-9]/gi, '_').toLowerCase()*/
    },

    formatChartPDFHeaderTitle: function(selectedParameters)
    {
        var user = selectedParameters.user;
        var formattedName = UserNameFormat.formatFML(user.firstName, user.lastName, user.middleName);
        return messageResource.getMessage('view_tt.pdf.header', [formattedName]);
    }
});
