ViewTTPage.PDFSettingsPreview = function($containerEl, lightboxId)
{
    PDFSettingsPreview.call(this, $containerEl, lightboxId);
};

ViewTTPage.PDFSettingsPreview.prototype = _.create(PDFSettingsPreview.prototype, {
    afterRender: function()
    {
        PDFSettingsPreview.prototype.afterRender.call(this);

        $(document.getElementById(this.lightboxId + "_numberOfPages")).hide();
        
        var self = this;
        this.signatureSettingsSection = new ViewTTPage.PDFSettingsPreview.SignatureSettingsSection(
                this.getCustomSettingsSectionContainer(),
                this.lightboxId
        ).init();
        $(this.signatureSettingsSection).on("change", function()
        {
            self.handleParameterChange();
        });
    },

    update: function()
    {
        PDFSettingsPreview.prototype.update.call(this);
        this.signatureSettingsSection.update();
    },

    subscribeToEvents: function()
    {
        PDFSettingsPreview.prototype.subscribeToEvents.call(this);

        var self = this;
        $(document).on("viewTT.pdfPreview.lightbox.show", function()
        {
            self.update();
            var printParametersForGenerate = self.collectPrintParametersForGenerate();
            self.triggerIntermediatePrintParametersChange(printParametersForGenerate);
            self.triggerPrintParametersForGenerateChange(printParametersForGenerate);
        })
    },

    unsubscribeFromEvents: function()
    {
        PDFSettingsPreview.prototype.unsubscribeFromEvents.call(this);
        $(document).off("viewTT.pdfPreview.lightbox.show");
    },

    getStore: function()
    {
        return ViewTTStore;
    },

    updateNumberOfPagesInformation: function()
    {
        // do nothing
    },

    triggerIntermediatePrintParametersChange: function(newPrintParameters)
    {
        $(document).trigger("viewTT.pdfPreview.intermediatePrintParametersChange", newPrintParameters);
    },

    triggerPrintParametersForSaveChange: function(printParametersForSave)
    {
        $(document).trigger("viewTT.pdfPreview.printParametersForSaveChange", printParametersForSave);
    },

    triggerPrintParametersForGenerateChange: function(printParametersForGenerate)
    {
        $(document).trigger("viewTT.pdfPreview.printParametersForGenerateChange", printParametersForGenerate);
    },

    collectPrintParametersForGenerate: function()
    {
        var printParametersForGenerate = PDFSettingsPreview.prototype.collectPrintParametersForGenerate.call(this);
        return _.extend(printParametersForGenerate, this.signatureSettingsSection.collectPrintParameters());
    },

    collectPrintParametersForSave: function()
    {
        return this.collectPrintParametersForGenerate();
    }
});