ViewTTPage.PrintableHeader = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

ViewTTPage.PrintableHeader.prototype = _.create(TemplateView.prototype, {
    html: "<div class='printHeader'>" +
          "  <table class='for-print-only-table'>" +
          "     <tbody>" +
          "       <tr>" +
          "         <td class='pageTitle'>" +
          "            <div class='printableTitle'></div>" +
          "            <div class='printableDateRangeHeader'></div>" +
          "         </td>" +
          "       </tr>" +
          "       <tr>" +
          "         <td class='statusesList'>" +
          "            <div class='filterProject'></div>" +
          "            <div class='timeTrackStatuses'></div>" +
          "         </td>" +
          "       </tr>" +
          "  </table>" +
          "</div>",

    afterRender: function()
    {
        this.$pageTitle = this.find(".printableTitle");
        this.$dateRange = this.find(".printableDateRangeHeader");
        this.$filters = this.find(".filterProject");
        this.$statuses = this.find(".timeTrackStatuses");

        this.dateFormat = new DateFormat(SystemSettings.dateFormat);
        this.formatDateStrategy = new DateRangeFormattingStrategy().init(this.dateFormat);


        $(ViewTTStore).on("dataChange", this.bind(this.update));
    },

    update: function()
    {
        var user = ViewTTStore.getSelectedUser();
        var pageTitle = "Time-Track of " + UserNameFormat.formatFML(user.firstName, user.lastName, user.middleName);
        this.$pageTitle.text(pageTitle);

        var dateRangeConfig = ViewTTStore.getDateRangeConfig();
        var dateRangeText = this.formatDateStrategy.formatForDateInformation({dateRangeSelection: dateRangeConfig}) +
                            this.formatDateStrategy.formatSpecifyingInformation({dateRangeSelection: dateRangeConfig});
        this.$dateRange.text(dateRangeText);

        var cpList = ViewTTStore.getMergedCpList();
        var cpSelection = ViewTTStore.getFilter().cpSelection;
        var reportStringBuilder = new ReportParamsStringBuilder().init({cpList: cpList}, this.dateFormat);
        var filterText = reportStringBuilder.getCPSelectionParamString(cpSelection);
        this.$filters.text(filterText);

        if (ViewTTPageUtils.isFeatureEnabled(Features["TTA"]))
        {
            var statuses = ViewTTStore.getFilter().weekApprovalStatuses;
            var statusesText = reportStringBuilder.getStatusesSelectionParamString(statuses);
            this.$statuses.text(statusesText);
            this.$statuses.show();
        } else {
            this.$statuses.hide();
        }
    }
});
