ViewTTPage.Totals = function($containerEl)
{
    TemplateView.call(this, $containerEl);
};

ViewTTPage.Totals.prototype = _.create(TemplateView.prototype, {
    
    html: "<div class='totalsRow'>" +
          "     <div class='totalsForPeriodCell totalsCell'><div id='totalsForPeriod' class='totalsForPeriod'>" +
          "         <div id='totalsForPeriodLabel' class='totalsLabel'><%=totalsLabel%></div>" +
          // "         <div class='totalsForPeriodValue'><span id='totalsSpent' class='totalsSpent'/><span id='totalsAll' class='totalsAll grayscale'/></div>" +
          "          <div id='totalsForPeriodTable' class='totalTimeTablePlaceholder'/>" +
          "     </div></div>" +
          "     <div id='totalsWorking' class='totalsWorkingCell totalsCell'><div class='workingTime dl'>" +
          "         <span><%=totalsWorkingTime%></span>" +
          // "         <div class='marker markerWT dt'><img src='<%=markerWTUrl%>'/><span><%=totalsWorkingTime%></span></div>" +
          "         <span id='totalsWorkingTime' class='totalValue'/></div>" +
          "         <div class='regularWorking dl'>" +
          "             <div class='marker markerWT dt'><img src='<%=markerWTUrl%>'/><span><%=workingHours%></span></div>" +
          "             <div class='markedTotal dd'><span id='regularWorkingTime'/></div>" +
          "         </div>" +
          "     </div>" +
          "     <div id='totalsLeave' class='totalsLeaveCell totalsCell'><div class='leaveTime dl'>" +
          "         <div class='totalsList totalsTimeHeader'>" +
          "             <span><%=totalsLeaveTime%></span>" +
          "             <span id='totalsLeaveTime' class='totalValue'/>" +
          "         </div>" +
          "         <div id='totalsLeaveTypesWrap' class='leaveTypes'><div class='totalsList'><div id='totalsLeaveTypes'/></div></div>" +
          "     </div></div>" +
          "     <div id='totalsOvertimeList' class='overtime dl'>" +
          "         <div>" +
          "             <div class='marker markerOT dt'><img src='<%=markerOTUrl%>'/><span><%=totalsOvertime%></span></div>" +
          "             <div class='markedTotal dd'><span id='totalsOvertime'/></div>" +
          "         </div>" +
          "         <div class='totalAutoOvertimeRow'>" +
          "             <div class='dt'><span><%=totalsAutoOvertime%></span></div>" +
          "             <div class='dd'><span id='totalsAutoOvertime'/></div>" +
          "         </div>" +
          "     </div>" +
          "</div>",

    messageKeys: function()
    {
        return {
            "totalsWorkingTime": "view_tt.totals.total_working_time",
            "workingHours": "view_tt.totals.regular_working",
            "totalsOvertime": "view_tt.totals.overtime",
            "totalsAutoOvertime": "view_tt.totals.auto_overtime",
            "totalsLeaveTime": "view_tt.totals.leave_time",
            "totalsLabel": 'view_tt.totals.period'
        };
    },

    templateModel: function()
    {
        return {
            markerWTUrl: atImgPath("viewtt/marker_wt.png"),
            markerLTUrl: atImgPath("viewtt/marker_lt.png"),
            markerOTUrl: atImgPath("viewtt/marker_ot.png")
        };
    },

    afterRender: function()
    {
        this.totalTimeTable = new ViewTTPage.TotalTimeTable($("#totalsForPeriodTable")).init();
        this.totalsForPeriod = new ViewTTPage.TotalsForPeriod().init($('#totalsForPeriod'));
        this.totalsWorkingTime = new ViewTTPage.TotalsWorkingTime().init($('#totalsWorking'));
        this.totalsLeaveTime = new ViewTTPage.TotalsLeaveTime().init($('#totalsLeave'));
        this.totalsOvertime = new ViewTTPage.TotalsOvertime().init($('#totalsOvertimeList'));

        var $store = $(ViewTTStore);
        $store.on("dataChange", _.bind(this._changeTotals, this));
    },

    _changeTotals: function()
    {
        var data = ViewTTStore.getData();
        if (!data) // nothing to set
            return;

        var overtimeEnabled = data.totalOvertimeInfo !== null;
        var leaveTimeEnabled = data.totalLeaveTime !== null;
        var showScheduled = data.effectiveDuration !== null;

        this.totalsLeaveTime.$containerEl.toggleClass('withLeaveTime', leaveTimeEnabled);
        this.totalsWorkingTime.$containerEl.toggleClass('withWorkingTime', overtimeEnabled || leaveTimeEnabled);
        this.totalsForPeriod.$containerEl.parent().toggleClass('single', !(overtimeEnabled || leaveTimeEnabled));
        this.$el.toggleClass('withScheduled', showScheduled);

        this.totalsWorkingTime.$containerEl.toggleClass('withOvertime', overtimeEnabled);
        this.totalsWorkingTime.$containerEl.append(this.totalsOvertime.$containerEl);

        this.totalsOvertime.changeTotals(data);
        this.totalsForPeriod.changeTotals(data);
        this.totalsWorkingTime.changeTotals(data);
        this.totalsLeaveTime.changeTotals(data);
    },

    update: function()
    {
        this.totalsForPeriod._changeDateRange();
        this._changeTotals();
    }
});
