ViewTTPage.TotalsLeaveTime = function() {};

ViewTTPage.TotalsLeaveTime.prototype = {
    init: function($containerEl)
    {
        this.$containerEl = $containerEl;
        this.$leaveTime = $('#totalsLeaveTime');
        this.$leaveTypes = $('#totalsLeaveTypes');

        this.leaveTypeTemplate = _.template("<div class='marker markerLT dt' title='<%-name%>'><img src='<%=markerLTUrl%>'/><span><%-name%></span></div>" +
                                            "<div class='markedTotal dd'><span><%=value%></span></div>");

        var $scrollWrap = $('#totalsLeaveTypesWrap');
        this.customScroll = ScrollUtils.addVerticalScroll($scrollWrap, {isFaded: false});

        return this;
    },

    /**
     * @param data - not empty data
     */
    changeTotals: function(data)
    {
        this.$leaveTime.text(UserTime.formatTimeWithDigitSeparator(data.totalLeaveTime || 0));
        this.$leaveTypes.empty();

        var leaveTimeTotals = data["leaveTimeTotals"];
        if (leaveTimeTotals)
        {
            // show leave types in the right order
            var self = this;
            ViewTTPageUtils.leaveTotalsOrderedIterate(leaveTimeTotals, function(leaveType, leaveTime)
            {
                self.addLeaveType(leaveType["name"], leaveTime);
            });
        }

        ScrollUtils.refreshCustomScroll(this.customScroll);
    },

    addLeaveType: function(leaveTypeName, leaveTime)
    {
        this.$leaveTypes.append(this.leaveTypeTemplate({
                                                           name: leaveTypeName,
                                                           value: UserTime.formatTimeWithDigitSeparator(leaveTime),
                                                           markerLTUrl: atImgPath("viewtt/marker_lt.png")
                                                       }));
    }

};