function UserATProfileSection()
{
}

UserATProfileSection.prototype = _.create(UserProfileSection.prototype);

UserATProfileSection.prototype.init = function( lightBoxEl, userData, changesCallback, validateCallback, isInstantValidation, enabledFeatures, mailSettingsSpecified, isUserCannotSeenAnyPages )
{
    var self = this;

    var isPTOEnabled = enabledFeatures.hasOwnProperty(FeaturesNames.PTOFeature);
    var isSickEnabled = enabledFeatures.hasOwnProperty(FeaturesNames.SDBFeature);
    UserProfileSection.prototype.init.call(this, lightBoxEl, userData, changesCallback, validateCallback, isInstantValidation, isPTOEnabled, isSickEnabled, mailSettingsSpecified);

    if (enabledFeatures.hasOwnProperty(FeaturesNames.PASFeature) && userData.assignedProjects.list.length > 0)
    {
        var projectsGroupedByCustomers = _.groupBy(userData.assignedProjects.list, function(project) { return _.escape(project.customer.name); });
        var tableTemplate = "<div>" +
                            "<div class='projectsList_header' >" +
                            messageResource.getEscapedMessage('profile.right_section.block_projects_assignments_projects_list_header') +
                            "</div>" +
                            "<% _.each(customers, function(customer, index) { %> " +
                            "   <div class='projectsList_customerName'><span title='<%= customer %>'><%= customer %></span></div>" +
                            "       <% _.each(projects[index], function(project) { %> " +
                            "           <div  class='projectsList_projectName'><span title='<%= project %>'><%= project %></span></div>" +
                            "       <% }); %>" +
                            "<% }); %>" +
                            "</div>";
        var compiledProjectsTemplate = _.template(tableTemplate);

        var projectsListInnerContent = compiledProjectsTemplate(
                {
                    customers: _.keys(projectsGroupedByCustomers),
                    projects: _.map(_.values(projectsGroupedByCustomers), function(projects) {
                        return _.map(projects,function(project){
                            return _.escape(project.name); 
                        });
                    })
                });

        this.preventNextOpening = false;
        $("#projectsNumberLabel").click(function(el)
                                        {
                                            if(self.preventNextOpening == true)
                                            {
                                                self.preventNextOpening = false;
                                                return;
                                            }

                                            var projectsListPanelEl = document.createElement("div");
                                            projectsListPanelEl.className = "profileProjectsList";
                                            $(projectsListPanelEl).width("420px");
                                            projectsListPanelEl.innerHTML = projectsListInnerContent;
                                            ScrollUtils.addVerticalScroll($(projectsListPanelEl), {isFaded: false});
                                            var projectsListPanel = new DropdownDialog({
                                                wrapperClass: "projectsListPopup",
                                                dialogDiv: projectsListPanelEl,
                                                notModal: true,
                                                hideButtons: true,
                                                hideOnResize: true,
                                                showEmptyTitleBar: false,
                                                closeOnEscape: false,
                                                zIndex: 1100,

                                                onClose: function()
                                                {
                                                    this.parentNode.parentNode.removeChild(this.parentNode);
                                                    KeyDownHandler.restoreOnKeyDownHandler();
                                                    $(document).off("mousedown.projectNumberList");
                                                }
                                            });

                                            projectsListPanel.showAt(this, {
                                                offset: "-120px 15px",
                                                my: "left top",
                                                at: "left bottom",
                                                collision: "none flip"
                                            });

                                            var panelTop = $(projectsListPanelEl).offset().top;
                                            var panelWrapper = $(".projectsListPopup");
                                            if (panelTop < $(el.target).offset().top)
                                            {
                                                panelWrapper.addClass("toTop");
                                                panelWrapper.removeClass("toBottom");
                                            }
                                            else
                                            {
                                                panelWrapper.addClass("toBottom");
                                                panelWrapper.removeClass("toTop");
                                            }

                                            KeyDownHandler.setOnKeyDownHandler(
                                                    function(event)
                                                    {
                                                        handleEscape(function() {projectsListPanel.hide(); }, event);
                                                    }
                                            );

                                            $(document).on("mousedown.projectNumberList",
                                                           function(event)
                                                           {
                                                               if( $(event.target).parents().index($(".profileProjectsList")) == -1 )
                                                               {
                                                                   if (event.target == el.target)
                                                                   {
                                                                       self.preventNextOpening = true; // prevent next opening if list closed by click on list label                                                        }
                                                                   }
                                                                   projectsListPanel.hide();
                                                               }
                                                           }
                                            );

                                            if (self.rightSectionScroll)
                                            {
                                                self.rightSectionScroll.on(
                                                        "scrollStart",
                                                        function()
                                                        {
                                                            projectsListPanel.hide();
                                                        }
                                                );
                                            }
                                            else
                                            {
                                                $(".rightSection").scroll(function() { projectsListPanel.hide(); });
                                            }
                                        });
    }

    this.startingNewWeekRadio = $('input[name="'+this.lightBoxEl.id+'_startingNewWeekRadio"]');
    this.startingNewWeekRadio.change( function () { self.changesDetected(); } );
    this.startingNewWeekRadio.filter('[value="'+userData.keepAllTasksFromPreviousWeek+'"]' ).prop('checked', true);

    if(isUserCannotSeenAnyPages)
    {
        $(".rightSection").find(".noPermissionsWarning").show();
    }

    return this;
};

UserATProfileSection.prototype.getStartingNewWeekOption = function()
{
    return this.startingNewWeekRadio.filter(':checked').val();
};

UserATProfileSection.prototype.scrollToPermissionsSection = function()
{
    if (this.rightSectionScroll)
    {
        ScrollUtils.scrollIntoViewVertical(this.rightSectionScroll, $("#profilePermissionsSection")[0], ScrollUtils.POSITIONS.TOP, false, 500);
    }
};