UserSelectorUtils = {};

UserSelectorUtils.convertSelectedGroupsIntoSelectedUsersIfNecessary = function(allUserList, groupType, allUsersSelected, showDisabled, selectedGroups, UGREnabled, TZGEnabled)
{
    // this logic must be the same as in ReportParamsUtil.convertSelectedGroupsToSelectedUsersIfNecessary (ReportParamsUtil.java)
    if (allUsersSelected ||
        selectedGroups.length == 0 ||
        UGREnabled && groupType == GroupType.USER_GROUP ||
        TZGEnabled && groupType == GroupType.TIME_ZONE_GROUP)
    {
        return [];
    }

    var selectedUsers = [];
    for (var groupId in selectedGroups)
    {
        //noinspection JSUnfilteredForInLoop
        var usersInGroup = this.getUsersByGroup(allUserList, selectedGroups[groupId], groupType);
        selectedUsers = $.merge(selectedUsers, this.getActiveAndSelectedDisabledUsers(showDisabled, usersInGroup));
    }
    
    return selectedUsers;
};

UserSelectorUtils.getActiveAndSelectedDisabledUsers = function(showDisabled, users)
{
    if (showDisabled)
        return users;

    return $.grep(users, function(user)
    { /*see Bug 53301*/
        return user.active || user.enabled;
    });
};

UserSelectorUtils.getUsersByGroup = function(allUserList, groupId, groupType)
{
    var groupTypeName = ( groupType == GroupType.USER_GROUP ) ? "userGroupId" : "timeZoneGroupId";
    return $.grep(allUserList, function(user) { return user[groupTypeName] == groupId; });
}; 
