Ext.namespace("AT");

/**
 * Drop-down button intended for use with user selector panels.
 * Creates single instance of the menu for each type of the selector
 * and the reuses it
 *
 * @constructor
 */
AT.SimpleDropdownButtonForSharedSelector = Ext.extend(AT.AbstractDropdownButton,
{
    template: new Ext.Template(
        '<table border="0" cellpadding="0" cellspacing="0" class="x-btn-wrap"><tbody><tr>',
        '<td class="x-btn-left"><i>&#160;</i></td><td class="x-btn-center"><em unselectable="on"><a href="#" class="x-btn-text" type="{1}">{0}</a></em></td><td class="x-btn-right"><i>&#160;</i></td>',
        "</tr></tbody></table>"),

    buttonSelector: "a:first-child",
    cls: "at-dropdown-list-btn share-button",
    ctCls: "at-dropdown-list-btn-ct",
    menuAlign:'tr-br?',
    onMenuShowCallback: Ext.emptyFn,
    onMenuHideCallback: Ext.emptyFn,

    initComponent: function()
    {
        AT.AbstractDropdownButton.superclass.initComponent.call(this);
        this.menu.setCurrentParent(this, true);
        this.onMenuShow = this.menu.makeHandlerForSpecificParent(this, this.onMenuShow);
        this.onMenuHide = this.menu.makeHandlerForSpecificParent(this, this.onMenuHide);
    },

    onMenuShow: function()
    {
        this.onMenuShowCallback();
        AT.AbstractDropdownButton.superclass.onMenuShow.apply(this, arguments);
    },

    onMenuHide: function()
    {
        this.onMenuHideCallback();
        AT.AbstractDropdownButton.superclass.onMenuHide.apply(this, arguments);
    },

    showMenu: Ext.emptyFn
});

Ext.reg("at_simple_dropdown_button_for_shared_selector", AT.SimpleDropdownButtonForSharedSelector);