Ext.namespace("AT");

AT.EnabledOnlyUsersSelectorPanel = Ext.extend(AT.UsersSelectorPanel, {

    allItemsOptionLabelKey: "users_selector.all_active_users",

    getUserNodeRenderer: function() {
        return new EmailCheckUserNodeRenderer( this.selectorTree, this.selectorFilter, this.getSelectionHelper(), this.checkEmail, this.treeItemTooltipMessageParams);
    },

    getFilterCallback: function() {
        return function(user) {
            return user.isActive();
        }
    },

    makeSelectionHelper: function() {
        this.selectionHelper = new AT.ComplicateUsersAndGroupsSelectionHelper( {
                                                                                   userSelectorGroupsStrategy: this.userSelectorGroupsStrategy,
                                                                                   accessRight: null,
                                                                                   maxLength: this.maxLabelLength,
                                                                                   checkEmail: this.checkEmail
                                                                               });
    }
});

Ext.reg("at_users_selector_panel_enabled_only", AT.EnabledOnlyUsersSelectorPanel);
