function UserSelectorTreeBuilder(rootNode, users, groupsMap, groupsOrder, observer, getGroupIdFromUserCallback)
{
    TreeBuilder.call(this, rootNode, users, groupsMap, groupsOrder);
    this.observer = observer;
    this.getGroupIdFromUserCallback = getGroupIdFromUserCallback;
}

UserSelectorTreeBuilder.prototype = _.create(TreeBuilder.prototype, {
    createTreeNodeForFirstLevelEntity: function(group)
    {
        return new GroupTreeNode(group);
    },

    createTreeNodeForSecondLevelEntity: function(user)
    {
        return new UserTreeNode(user);
    },

    createDisabledNodesParentForSecondLevelEntity: function(parentId)
    {
        return new DisabledUsersParentTreeNode(parentId);
    },

    getSecondLevelEntityParentId: function(user)
    {
        return this.getGroupIdFromUserCallback(user);
    },

    isFirstLevelEntityEnabled: function()
    {
        return true;
    },

    isSecondLevelEntityEnabled: function(user)
    {
        return user.isActive();
    },

    onTreeNodeForFirstLevelEntityAdded: function(treeNode)
    {
        this.observer.groupNodeAdded(treeNode);
    },

    onTreeNodeForSecondLevelEntityAdded: function(treeNode)
    {
        this.observer.userNodeAdded(treeNode);
    },

    onDisabledNodesParentForSecondLevelEntitiesAdded: function(treeNode)
    {
        this.observer.disabledUsersParentNodeAdded(treeNode);
    }
});