function UserWithAccessRightSelectorTreeBuilderObserver(searchIndex, allActiveSet, accessRights)
{
    UserSelectorTreeBuilderObserver.call(this, searchIndex, allActiveSet);
    this.allAccessRightGrantedMap = {};
    this.accessRightsMap = {};
    for (var i = 0; i < accessRights.length; i++)
    {
        this.allAccessRightGrantedMap[accessRights[i].getId()] = new TreeNodeSet();
        this.accessRightsMap[accessRights[i].getId()] = accessRights[i];
    }
}

UserWithAccessRightSelectorTreeBuilderObserver.prototype = _.create(UserSelectorTreeBuilderObserver.prototype, {
    userNodeAdded: function(userNode)
    {
        UserSelectorTreeBuilderObserver.prototype.userNodeAdded.call(this, userNode);
        for (var key in this.accessRightsMap)
        {
            //noinspection JSUnfilteredForInLoop
            if (this.accessRightsMap[key].isGranted(userNode.getValue().accessRight))
            {
                //noinspection JSUnfilteredForInLoop
                this.allAccessRightGrantedMap[key].add(userNode);
            }
        }
    },

    groupNodeAdded: function(groupNode)
    {
        UserSelectorTreeBuilderObserver.prototype.groupNodeAdded.call(this, groupNode);
        for (var key in this.allAccessRightGrantedMap)
        {
            //noinspection JSUnfilteredForInLoop
            this.allAccessRightGrantedMap[key].add(groupNode);
        }
    },

    disabledUsersParentNodeAdded: function(parentNode)
    {
        UserSelectorTreeBuilderObserver.prototype.disabledUsersParentNodeAdded.call(this, parentNode);
        for (var key in this.allAccessRightGrantedMap)
        {
            //noinspection JSUnfilteredForInLoop
            this.allAccessRightGrantedMap[key].add(parentNode);
        }
    }
});
