Ext.namespace("AT");

/*  Requires:
* - collapsedCookiesKey*/

AT.ThreePositionUserSelectorPanel = Ext.extend(AT.UsersSelectorPanel, {
    
    groupBySettingCookieName: "threePositionUserSelectorGroupBySetting",
    
    createComponents: function() {
        AT.ThreePositionUserSelectorPanel.superclass.createComponents.call(this);

        this.viewByPanel = new AT.ExtendedGroupSelectorSwitcher();
    },

    buildGroupByUsersTreeData: function () {
        var rootNode = new TreeRootNode();
        var searchIndex = new StringIndex();
        var allActiveSet = new TreeNodeSet();

        var treeBuilder = new UserSelectorTreeBuilder(rootNode, this.users, null, null, new UserSelectorTreeBuilderObserver( searchIndex, allActiveSet ), null );
        treeBuilder.buildTree();

        this.groupByUsersTreeData = {
            rootNode: rootNode,
            searchIndex: searchIndex,
            allActiveSet: allActiveSet
        };
    },

    groupByUser: function ()
    {
        if (this.groupType == null)
            return;

        var settings = this.collectCurrentSettings();
        this.prepareForGroupByChange();

        this.changeUserSelectorGroupsStrategy( this.initHideUserGroupsStrategy() );

        if (!this.groupByUsersTreeData)
            this.buildGroupByUsersTreeData();

        this.setTreeData(this.groupByUsersTreeData);

        this.recreateTreeSetSelectorSettingsAndBuildTree(settings);

        this.groupType = null;
        this.viewByPanel.updateUI(this.groupType);
        this.saveGroupBySettingsToCookie("groupByUsers");
    },

    getGroupTypeFromString: function(groupBySettingsString)
    {
        if (groupBySettingsString == "groupByUsers")
            return null;
        else
            return AT.ThreePositionUserSelectorPanel.superclass.getGroupTypeFromString.call(this, groupBySettingsString);
    },

    regroupUsers: function(newGroupType)
    {
        if (newGroupType == null)
        {
            this.groupType = null;
            this.groupByUser();
        }
        else
            AT.ThreePositionUserSelectorPanel.superclass.regroupUsers.call(this, newGroupType);
    },

    initTreeData: function()
    {
        if (this.groupType == null)
        {
            this.userSelectorGroupsStrategy = this.initHideUserGroupsStrategy();
            this.buildGroupByUsersTreeData();
            this.setTreeData(this.groupByUsersTreeData);
        }
        else
        {
            AT.ThreePositionUserSelectorPanel.superclass.initTreeData.call(this);
        }
    },

    initializeViewByPanel: function()
    {
        var self = this;
        this.viewByPanel.init(
                this.userGroupsEnabled,
                this.timeZoneGroupsEnabled,
                function() { self.treeActionHandler($.proxy(self.groupByUser, self), true, false) },
                function() { self.treeActionHandler($.proxy(self.groupByUserGroup, self), true, false) },
                function() { self.treeActionHandler($.proxy(self.groupByTimeZoneGroup, self), true, false) });
    },

    createGroupsUsersMaps: function()
    {
        // do nothing
    },

    addSelectorTreeChangeListener: function()
    {
        // do nothing
    },

    beforeResetAction: function(){
        var self = this;
        if (!this.groupTypeInit)
        {
            self.groupByUser();
        }
        AT.ThreePositionUserSelectorPanel.superclass.beforeResetAction.call(this);
    }

});