Ext.namespace("AT");

AT.UsersForApproverBaseSelectorPanel = Ext.extend(AT.UsersSelectorPanel, {
    showInactiveLabelKey: "userlist.user_for_approver_selector.show_disabled",
    onAllOptionSelected: null,
    onCustomOptionSelected :null,

    renderOnPage: function(div) {
        this.render(div);
        this.showCallback();
    },

    createFooterButtons: function() {
        //do nothing
    },

    getUserNodeRenderer: function() {
        return new UserForApproverNodeRenderer( this.selectorTree, this.selectorFilter, this.getSelectionHelper() );
    },

    getFooterSection: function() {
        return [];
    },

    getCanManageAllUsers: function () {
        return this.getStateValueByOptionValue(this.getCurrentOptionValue());
    },

    getSelectedUserIds: function() {
        var selectedUsers = this.getOnlyUsersSelection();
        var result = [];

        var arrayLength = selectedUsers.length;
        for ( var i = 0; i < arrayLength; i++ ) {
            result.push(selectedUsers[i].id);
        }

        return result;
    },

    onGenericOptionSelect: function(option, checked) {
        if(this.onAllOptionSelected && checked){
            this.onAllOptionSelected();
        }
        AT.UsersForApproverBaseSelectorPanel.superclass.onGenericOptionSelect.call(this, option, checked);
    },

    onCustomOptionSelect: function(option, checked) {
        if(this.onCustomOptionSelected && checked){
            this.onCustomOptionSelected();
        }
        AT.UsersForApproverBaseSelectorPanel.superclass.onCustomOptionSelect.call(this, option, checked);
    }

});