function ViewStateSwitcher(container, config)
{
    this.config = _.defaults(config, {
        index: 0,
        hideAnimatedClass: "anim-fade-out",
        showAnimatedClass: "anim-fade-in"
    });

    this.container = container;
    this.divs = container.children();
    this.index = this.config.index;
    
    for (var i = 0; i < this.divs.length; i++)
    {
        var div = this.divs.eq(i);
        if (i == this.index)
            div.show();
        else
            div.hide();
    }
}

ViewStateSwitcher.prototype = _.create(Object.prototype, {
    switchState: function(toIndex) { }
});

function QueueViewStateSwitcher(container, divs, config)
{
    ViewStateSwitcher.call(this, container, divs, config);
    this.queue = [];
}

QueueViewStateSwitcher.prototype = _.create(ViewStateSwitcher.prototype, {
    switchState: function(toIndex)
    {
        this.queue.push(toIndex);
        if (this.queue.length == 1) this.processQueue();
    },

    processQueue: function()
    {
        if (this.queue.length == 0) return;

        var fromDiv = this.divs.eq(this.index);
        var toIndex = this.queue[0];

        if (this.index == toIndex) return;

        var toDiv = this.divs.eq(toIndex);

        var self = this;
        fromDiv.atAnimation().hideAnimated(this.config.hideAnimatedClass);
        toDiv.atAnimation().showAnimated(this.config.showAnimatedClass, function()
        {
            self.queue = self.queue.slice(1);
            if (self.queue.length > 0) self.processQueue();
        });

        this.index = toIndex;
    }
});