function User(id, firstName, lastName, middleName, userName, active, emailExists, userGroupId, timeZoneGroupId)
{
    this.init(id, firstName, lastName, middleName, userName, active, emailExists, userGroupId, timeZoneGroupId);
}

User.prototype.init=function (id, firstName, lastName, middleName, userName, active, emailExists, userGroupId, timeZoneGroupId){
    this.id = id;
    this.firstName = firstName;
    this.lastName = lastName;
    this.middleName = middleName;
    this.userName = userName;
    this.active = active;
    this.emailExists = emailExists;
    this.userGroupId = userGroupId;
    this.timeZoneGroupId = timeZoneGroupId;
};

User.prototype.isActive = function()
{
    return this.active;
};

User.prototype.formatNameFMLU = function()
{
    return UserNameFormat.formatFMLU(this.firstName, this.lastName, this.middleName, this.userName);
};

User.prototype.formatNameFML = function()
{
    return UserNameFormat.formatFML(this.firstName, this.lastName, this.middleName);
};

User.prototype.formatNameLFMU = function()
{
    return UserNameFormat.formatLFMU(this.firstName, this.lastName, this.middleName, this.userName);
};

User.prototype.formatNameLFM = function()
{
    return UserNameFormat.formatLFM(this.firstName, this.lastName, this.middleName);
};

User.prototype.getUserGroupId = function()
{
    return this.userGroupId;
};

User.prototype.getTimeZoneGroupId = function()
{
    return this.timeZoneGroupId;
};

User.prototype.clone = function( )
{
    return new User(this.id, this.firstName, this.lastName, this.middleName, this.userName, this.active, this.emailExists, this.userGroupId, this.timeZoneGroupId);
};

User.prototype.hasEmail = function( )
{
    return this.emailExists ? true : false;
};

User.prototype.setRequiresTTApproval = function(isRequiresTTApproval){
  this.isRequiresTTApproval = isRequiresTTApproval;
};

function UserWithAccessRights(id, firstName, lastName, middleName, userName, active, emailExists, userGroupId, timeZoneGroupId, accessRights)
{
    User.call(this, id, firstName, lastName, middleName, userName, active, emailExists, userGroupId, timeZoneGroupId);

    this.accessRight = accessRights;
    this.assignedProjects = [];
}

//noinspection JSCheckFunctionSignatures
UserWithAccessRights.prototype = new User();

UserWithAccessRights.prototype.setAssignedProjects = function( projects )
{
    this.assignedProjects = projects ? projects : [];
};

UserWithAccessRights.prototype.setAllProjectAssigned = function ( flag )
{
    this.allProjectsAssigned = flag;
};

UserWithAccessRights.prototype.setOvertimeEnabled = function ( flag )
{
    this.overtimeEnabled = flag;
};

UserWithAccessRights.prototype.isOvertimeEnabled = function ( flag )
{
    return this.overtimeEnabled;
};

UserWithAccessRights.prototype.hasProjectsAssigned = function ( projects )
{
    if ( this.allProjectsAssigned )
        return true;
    if ( !this.assignedProjects )
        return false;
    for( var i = 0; i < this.assignedProjects.length; i++)
    {
        if ( contains( projects, this.assignedProjects[i] ) )
            return true;
    }
    return false
};

UserWithAccessRights.prototype.clone = function( )
{
    var res = new UserWithAccessRights(this.id, this.firstName, this.lastName, this.middleName, this.userName, this.active,
                                       this.emailExists, this.userGroupId, this.timeZoneGroupId, this.accessRight);
    res.allProjectsAssigned = this.allProjectsAssigned;
    res.assignedProjects = this.assignedProjects;
    return res;
};