function ViewTaskPopup()
{
}

ViewTaskPopup.prototype = _.create(BaseTaskPopup.prototype);

ViewTaskPopup.prototype.titleMessageKey = "task.edit_popup.view_title";
ViewTaskPopup.prototype.description_tooltip_message_key = "task.edit_popup.view_task_description.title";

//this constants must be rewrite in this class but will not use
ViewTaskPopup.prototype.exist_invalid_fields_message_key = "";
ViewTaskPopup.prototype.close_tab_confirmation_message_key = "";

ViewTaskPopup.prototype.init = function( viewTaskPopupData, estEnabled, btyEnabled, sortConstants,
                                         taskNotAssignedCallback, taskWasDeletedCallback )
{
    BaseTaskPopup.prototype.init.call( this, "viewTaskPopup", viewTaskPopupData,
                                       estEnabled, btyEnabled, sortConstants,
                                       taskNotAssignedCallback, taskWasDeletedCallback );

    return this;
};

ViewTaskPopup.prototype.setTaskName = function( taskName ) {
    this.findElementBySubId("taskName").text(taskName).prop('title', taskName);
};

ViewTaskPopup.prototype.initCustomerProjectSelector = function() {
    var customerTitle = this.customer.name.concat(this.customer.activeCustomer ? "" : " "+messageResource.getMessage("common.archived"));
    var projectTitle = this.project.name.concat(this.project.activeProject ? "" : " "+messageResource.getMessage("common.archived"));
    this.findElementBySubId("customerSelector").text(customerTitle).prop('title', customerTitle);
    this.findElementBySubId("projectSelector").text(projectTitle).prop('title', projectTitle);
};

ViewTaskPopup.prototype.initBillingTypeSelector = function() {
    this.findElementBySubId("taskBillingType").text(this.task.billingType.name).prop('title', this.task.billingType.name);
};

ViewTaskPopup.prototype.setTaskStatus = function( isOpenTask ) {
    var statusClass = isOpenTask ? "openTask" : "completedTask";
    var statusMessage = isOpenTask ? this.statusOpenMessage : this.statusCompletedMessage;

    this.findElementBySubId("statusSelectorPlaceholder").text(statusMessage).addClass(statusClass);
};

ViewTaskPopup.prototype.initDeadlineDate = function( isOpenTask ) {
    var taskDeadline = this.task.deadlineDate;
    var taskDeadlineStr = ( taskDeadline != null ) ? taskDeadline.parseJSONDate().format(this.dateFormat) :
                          messageResource.getMessage("task.edit_popup.not_set");
    this.taskDeadlineEl = this.findElementBySubId("taskDeadline").text(taskDeadlineStr);

    var today = currentUserTime().clearTime().getTime();
    if ( taskDeadline != null && !this.task.completed && today > taskDeadline.parseJSONDate() ) {
        this.taskDeadlineEl.addClass("deadlineInPast");
        this.taskDeadlineEl.get(0).title = messageResource.getMessage("task.edit_popup.deadline_is_in_past");
    }
};

ViewTaskPopup.prototype.initCompletionDateSelector = function()
{
    var completionDateStr = ( this.task.completionDate != null ) ? this.task.completionDate.parseJSONDate().format(this.dateFormat) : null;
    this.taskComletionDateValueEl.text(completionDateStr);
};

ViewTaskPopup.prototype.initDescriptionField = function () {
    this.description.attr("readonly", "readonly");
    this.description.addClass("readonly");
};