<%
    // Many people made bookmarks to login.jsp and start their session from it.
    // But now this scenario doesn't work since now we have two modules - one for actiTIME and another one for actiPLANS,
    // and if this JSP is loaded without action, then none of the modules is selected and the following <html:form> tag
    // is unable to find the corresponding action.

    // So, we check if the module was selected, and if not, redirect to the login action.
    if( request.getAttribute( org.apache.struts.Globals.MODULE_KEY ) == null )
    {
        response.sendRedirect( "login.do" );
        return;
    }

    boolean isOl = ATGlobals.isOl();
%><!doctype html>
<%@ page import="com.actimind.actitime.*" %>
<%@ page import="com.actimind.actitime.colors.ColorHelper" %>
<%@ page import="com.actimind.common.licensing.LicenseKeyUtils"%>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.beans.PasswordRecoveryTokenBean" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="com.actimind.common.*" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap"%>
<%@ page errorPage="/error.jsp" %>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="productName" name="<%= Keys.PRODUCT_CONFIG %>" property="productName" type="java.lang.String"/>
<%
    String scriptsPath = productName.equals( Product.actiPLANS.name() ) ? "/actiplans/include_scripts.jsp" : "/include_scripts.jsp";
%>
<html style="height: 100%">
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="login.page.title"/></title>
    <META NAME="keywords" CONTENT="actitimever<%=LicenseKeyUtils.getFullActualVersionStr( request, isOl )%>">
    <META HTTP-EQUIV="keywords" CONTENT="actitimever<%=LicenseKeyUtils.getFullActualVersionStr( request, isOl )%>">
    <META NAME="description" CONTENT="actiTIME_software_<%=LicenseKeyUtils.getFullActualVersionStr( request, isOl )%>">
    <meta name="robots" content="noindex,nofollow"/>
    <%@include file="css/scheme_styles.jsp"%>
    <jsp:include page="<%=scriptsPath%>"/>
    <script>
        LoginPage = {};

        LoginPage.BROWSER_TIMEOUT_MINUTES = 2;

        // Rounded box messages and tooltips
        LoginPage.ADMIN_MANAGER_TOOLTIP =
            '            <div class="tooltip adminManagerTooltip"> ' +
            '                       <div class="tooltip-content"> '+
            '                           <p id="loginFirstTimeMsg"><bean:message key="login.form.first_login_tooltip.main_text"/></p>  ' +
            '                           <p class="tooltipText userInfo"><bean:message key="login.form.first_login_tooltip.credentials.username" arg0="<%=LoginForm.FIRST_LOGIN_USERNAME%>"/></p> ' +
            '                           <p class="userInfo"><bean:message key="login.form.first_login_tooltip.credentials.password" arg0="<%=LoginForm.FIRST_LOGIN_PASSWORD%>"/></p>     ' +
            '                            <table class="warning tooltipText">             ' +
            '                               <tr>                  ' +
            '                                   <td id="warningMarkContainer"><at:img page="login/warning_orange_mark.png" /></td>   ' +
            '                                    <td class="warnMessage"><bean:message key="login.form.first_login_tooltip.security_warning"/></td>        ' +
            '                               </tr>                  ' +
            '                            </table>              ' +
            '                       </div>               ' +
            '                </div>                ';


        LoginPage.PASSWORD_SUCCESSFULLY_RESET_TOOLTIP =
            '  <div class="tooltip passwordResetSuccessTooltip"> ' +
            '          <div class="tooltip-content">                                                                     ' +
            '                <p><b><bean:message key="password_recovery.password.reset.successfully.title"/></b></p>        ' +
            '                <p class="tooltipText"><bean:message key="password_recovery.password.reset.successfully.note"/></p>               ' +
            '          </div>'+
            '  </div>';

        LoginPage.LOGIN_INFO_SUCCESSFULLY_SENT_TOOLTIP =
            '  <div class="tooltip infoSentTooltip"> ' +
            '       <div class="tooltip-content">  '  +
            '            <div>{0}</div> ' +
            '        </div>  '  +
            '  </div>';

        LoginPage.DEMO_TOOLTIP =
            '<div class="tooltip demo">'+
            '<div class="tooltip-content">'+
            '<table id="demoCredentials">'+
            '<tr>'+
            '<td rowspan="2" id="adminCredentialsHeader"><bean:message key="login.tooltip.administrator"/></td>'+
            '<td ><bean:message key="login.form.first_login_tooltip.credentials.username" arg0="<%=LoginForm.FIRST_LOGIN_USERNAME%>"/></td>'+
            '</tr>'+
            '<tr>'+
            '<td ><bean:message key="login.form.first_login_tooltip.credentials.password" arg0="<%=LoginForm.FIRST_LOGIN_PASSWORD%>"/></td>'+
            '</tr>'+

            '<tr>'+
            '<td rowspan="2" id="userCredentialsHeader"><bean:message key="login.form.first_demo_tooltip.user_instruction"/></td>'+
            '<td id="userCredentialsUsername"><bean:message key="login.form.first_demo_tooltip.user_credentials.username"/> </td>'+
            '</tr>'+
            '<tr>'+
            '<td ><bean:message key="login.form.first_demo_tooltip.user_credentials.password"/></td>'+
            '</tr>'+
            '</table>'+
            '</div>'+
            '</div>';

    </script>

    <at:script page='/js/md5.js'/>
    <at:script page='/js/login.js'/>
    <at:script page='/js/login_page_controller.js'/>

    <!--[if IE 8]>
    <style type="text/css">
        .tooltip:before,
        .tooltip:after {
            display: none;
        }
    </style>
    <![endif]-->

    <%
        String pageState = ( String ) request.getAttribute( Keys.LOGIN_PAGE_STATE );
        if( StringUtils.isNullOrEmpty( pageState ) )
            pageState = Constants.LOGIN_PAGE_LOGIN_STATE;

        boolean showAdminManagerTooltip = request.getAttribute( Keys.SHOW_ADMIN_MANAGER_TOOLTIP ) != null;
        boolean isPasswordReset = Boolean.parseBoolean( (String) session.getAttribute( Keys.USER_PASSWORD_RESET ) );
        if( isPasswordReset )
            session.removeAttribute( Keys.USER_PASSWORD_RESET );
    %>


    <script language="JavaScript">
        <% String errorKey =  LoginActionUtil.getFirstError( request ); %>
        show_in_main_window(<%= (errorKey == null ? "null" : "encodeURIComponent('" + Base64.encodeBytes( errorKey.getBytes() ) + "')") %>);

        var CHALLENGE_URL = '<html:rewrite page="/getChallenge"/>';

        var LOGIN_PAGE_STATES = {};
        var LOGIN_STATE = '<%=Constants.LOGIN_PAGE_LOGIN_STATE%>';
        var FORGET_PASSWORD_STATE = '<%=Constants.LOGIN_PAGE_FORGET_PASSWORD_STATE%>';
        var RESET_PASSWORD_STATE = '<%=Constants.LOGIN_PAGE_RESET_PASSWORD_STATE%>';
        var RESET_PASSWORD_LINK_EXPIRED_STATE = '<%=Constants.LOGIN_PAGE_RESET_PASSWORD_LINK_EXPIRED_STATE%>';
        var pageController;

    </script>
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" onLoad="initPage();" style="height:100%"
        class="loginPage">

<jsp:include page="/white_box_with_logo.jsp">
    <jsp:param name="contentJsp" value='/login_page_content.jsp'/>
    <jsp:param name="urlForReload" value="login.do?"/>
</jsp:include>

<script type="text/javascript">

function initPlaceHolders(){

    var usernamePlaceholderText = "<bean:message key="login.form.field_title.username"/>" ;
    var passwordPlaceholderText = "<bean:message key="login.form.field_title.password"/>" ;
    var forgotPasswordText = "<bean:message key="password_recovery.forgot_your_password.form.field_title"/>" ;
    var newPwdText = "<bean:message key="password_recovery.reset_password.form.password.field_title"/>" ;
    var confirmNewPwdText = "<bean:message key="password_recovery.reset_password.form.password_confirm.field_title"/>" ;
    $("#username").attr('placeholder', usernamePlaceholderText).placeholder();
    $("input[name=pwd]").attr('placeholder', passwordPlaceholderText).placeholder();
    $("#forgetPasswordEmailOrUsername").attr('placeholder', forgotPasswordText).placeholder();
    $("#newPwd").attr('placeholder', newPwdText).placeholder();
    $("#newPwdConfirm").attr('placeholder', confirmNewPwdText).placeholder();
}
function initPage()
{
    LOGIN_PAGE_STATES[LOGIN_STATE] = new LoginState( {
        buttonId : "loginButton",
        formId : "loginForm",
        formContainerId : "loginFormContainer",
        progressTextId : "inProgressText",
        inputElementNames : [ "username", "pwd", "keepLoggedInCheckBox" ],
        focusElementName : "username",
        showAdminManagerTooltip : <%=String.valueOf( showAdminManagerTooltip )%>,
        showPasswordResetTooltip :  <%=isPasswordReset%>,
        isDemoMode : <%=ATGlobals.isDemoMode()%>,
        changeStateLinkId : "toPasswordRecoveryPageLink",
        titleKey: "login.page.title.login"
    } );

    LOGIN_PAGE_STATES[FORGET_PASSWORD_STATE] = new ForgetPasswordState( {
        buttonId : "forgetPasswordButton",
        formId : "forgetPasswordForm",
        formContainerId : "forgotPasswordFormContainer",
        progressTextId : "forgetPasswordInProgressText",
        inputElementNames : [ "forgetPasswordEmailOrUsername" ],
        focusElementName : "forgetPasswordEmailOrUsername",
        changeStateLinkId : "toLoginPageLink",
        changeStateLinkContainerId : "changeStateLinkContainer"
    } ) ;

    <bean:define id="userFirstName" name="ResetPasswordForm" property="userFirstName" type="java.lang.String" />
    LOGIN_PAGE_STATES[RESET_PASSWORD_STATE] = new ResetPasswordState( {
        buttonId : "resetPasswordButton",
        formId : "resetPasswordForm",
        formContainerId : "resetPasswordFormContainer",
        progressTextId : "resetPasswordInProgressText",
        inputElementNames : [ "newPwd", "newPwdConfirm" ],
        focusElementName : "newPwd",
        changeStateLinkId : null,
        changeStateLinkContainerId : null,
        tooltipText : '<%=ATMessageResources.jsMessage( request, "password_recovery.reset_password.tooltip", userFirstName )%>',
        titleKey: "login.page.title.reset"
    } );

    LOGIN_PAGE_STATES[RESET_PASSWORD_LINK_EXPIRED_STATE] = new ErrorState( {
        buttonId : null,
        formId : null,
        formContainerId : null,
        progressTextId : null,
        inputElementNames : [  ],
        focusElementName : null,
        changeStateLinkId : "toLoginPageLink",
        changeStateLinkContainerId : "changeStateLinkContainer",
        message : messageResource.getMessage( "password_recovery.reset_password.link_expired",
                                                [ "<%=PasswordRecoveryTokenBean.TOKEN_LIVE_TIME_HOURS%>" ] ),
        titleKey: "login.page.title.reset"
    } );

    pageController = new LoginPageController( LOGIN_PAGE_STATES['<%=pageState%>'] );
    pageController.showPageContent();
    initPlaceHolders();
}
</script>

</body>
</html>