<!doctype html>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ page import="com.actimind.actitime.notifications.MailNotificationsForm" %>
<%@ page import="com.actimind.actitime.notifications.MailNotificationsFormHelper" %>
<%@ page import="com.actimind.actitime.notifications.rules.Rule" %>
<%@ page import="java.util.Map" %>
<%@ page import="com.actimind.actitime.*" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="com.actimind.actitime.beans.CustomersProjectsOutputData" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.actitime.beans.ProjectBean" %>
<%@ page import="com.actimind.actitime.beans.CustomerBean" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<bean:define id="form" name="MailNotificationsForm" type="com.actimind.actitime.notifications.MailNotificationsForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<%
    boolean mailSettingsSpecified = MailServerSettingsGlobalInstance.getMailServerSettings().areMailSettingsSpecified();
%>
<html>

<head>

    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="mail_notifications.page.title"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <script type="text/javascript">
    <!--
        PageOverlayTipsManager.setInstance(new NotificationsPageOverlayTipsManager());

        var mailSettingsSpecified = <%=mailSettingsSpecified%>;

        function isInputEvent(event)
        {
            var targetElem = event.srcElement || event.target;
            return (targetElem && targetElem.tagName && (targetElem.tagName.toLowerCase() == 'input'));
        }
        showTable = function()
        {
            var rulesTable = getElementById("rulesTable");
            removeClass( rulesTable, "hidden");
        };

        function remainOnPageFnc(){
            currentEditRule.scrollWindowIfNeeded();
        }

        function exitHandlerFunc() {
            return currentEditRule != null && !currentEditRule.stopEdit();
        }

        function leavePageFnc() {
            window.location.href = getRedirectUrl();
        }

        function doSubmit() {
            var saveRule =  currentEditRule.saveAndCallBack(leavePageFnc);
        }
        preparePage = function ()
        {
            initSendNotificationsNowButton();
            showTable();
            confirmDlg = new ConfirmExitDlg(500, messageResource.getMessage("mail_notifications.modification_not_saved"),
                                       messageResource.getMessage("common.messages.confirm_leave_page"),
                                       messageResource.getMessage("common.buttons.save_changes"), messageResource.getMessage("common.buttons.discard_changes"), messageResource.getMessage("common.buttons.remain_on_page"));
            setCancelHandler(remainOnPageFnc);
            setExitHandler(exitHandlerFunc);
            setDiscardHandler(leavePageFnc);
            setSubmitHandler(doSubmit);
            subscribeChangeAndExitHandlersOnMouseClick();
        };

        addListener(document, "load", function()
        {
            var images = [ '<at:imgpath page="sending-progress.gif"/>',
                           '<at:imgpath page="success.gif"/>',
                           '<at:imgpath page="error.gif"/>'];
            var preloader = new ImagePreloader( images );
        });

        function initSendNotificationsNowButton() {
            var createCustomerButton = new GraphicButton( GraphicButton.getRoundedBox('sendNotificationsNowDiv',
                messageResource.getMessage('mail_notifications.form.send_now.button_text') ));
            createCustomerButton.defineStandardEventHandlers(true, true, true, true);
            if (mailSettingsSpecified) {
                createCustomerButton.button.el.on("click", SendNotificationsNow);
            } else {
                $("#sendNotificationsNowDiv .graphicButton").addClass("disabled");
            }
        }

        function SendNotificationsNow()
        {
            if (ruleFactory.isEdited())
            {
                alert("<%=jsMessage(request, "mail_notifications.form.send_now.not_all_rules_saved")%>");
                return;
            }
            if (ruleFactory.isEmpty())
            {
                alert("<%=jsMessage(request, "mail_notifications.form.send_now.no_rules_message")%>");
                return;
            }
            var button = document.getElementById("sendNotificationsNowDiv");
            var note = document.getElementById("sendNotificationsNow_progress_note");

            var statesManager = new SendNotificationsNowButtonStatesController(button, note, "<%=jsMessage(request, "mail_notifications.form.send_now.success_message")%>");
            var manager = new SendNotificationsNowManager(statesManager, statesManager.getStates());
            RpcControlManager.saveRpcControlBoundData(manager);
        }

        function getAllProjects() {
            <%
                @SuppressWarnings("unchecked")
                List<ProjectBean> allProjects = (List<ProjectBean>) request.getAttribute(Keys.PROJECTS_LIST_KEY);
            %>
            var result = [];
            <%
                for (ProjectBean project : allProjects)
                { %>
            result.push(<%=project.getId()%>);
            <% }
            %>
            return result;
        }

    function getAllCustomers() {
        <%
            @SuppressWarnings("unchecked")
            List<CustomerBean> allCustomers = (List<CustomerBean>) request.getAttribute(Keys.CUSTOMERS_LIST_KEY);
        %>
            var result = [];
        <%
       for (CustomerBean customer : allCustomers)
       { %>
            result.push(<%=customer.getId()%>);
        <% }
        %>
            return result;
     }

    //-->
    </script>

</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      onunload="closeAllOpenedPopups();"
      onload="preparePage();"
      class="mail_notifications with-navigation">

<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected"    value="<%=Navigator.MAIL_NOTIFICATIONS_KEY%>"/>
    <jsp:param name="submenuSelected" value="<%=Navigator.MAIL_NOTIFICATIONS_SUBMENU_KEY%>"/>
</jsp:include>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/notifications/mail_notifications.js" />

<%@ include file="/js/description_util_entities_init_js.jsp"%>
<at:script page="/js/hierarchySelector/userSelector/accessRight/AccessRightUserGroupNodeRenderer.js" />
<at:script page="/js/hierarchySelector/userSelector/EmailCheckUserNodeRenderer.js" />
<at:script page="/js/hierarchySelector/userSelector/accessRight/AccessRightFilter.js" />
<at:script page="/js/hierarchySelector/userSelector/accessRight/AccessRightUserNodeRenderer.js" />
<at:script page="/js/controls/selectorControls/selectionHelpers/complicate_users_and_groups_selection_helper.js" />
<at:script page="/js/usersSelector/builder/UserWithAccessRightSelectorTreeBuilderObserver.js" />

<at:script page="/js/usersSelector/at_user_selector_panel_with_ar.js" />
<at:script page="/js/usersSelector/at_user_selector_panel_enabled_only.js" />

<%-- Load users to JS, for use in the users selectors --%>
<jsp:include page="/util/users-with-access-rights.jsp"/>
<jsp:include page="/util/user_groups.jsp"/>
<jsp:include page="/util/time_zone_groups.jsp"/>

<at:script page="/cp_selector/MailNotificationsCustomerProjectSelectorHolder.js"/>

<div id="mainContent" class="mainContentPadding" style="display: block; padding-bottom: 20px">
<table style="width:847px; _width: 825px;" align="center" cellspacing="0" cellpadding="0" border="0" class="display-for-print rightPadding">
    <tr>
        <td colspan="2" class="sendNotificationsNow_buttonCell">
            <span class="pagetitle"><bean:message key="mail_notifications.page.title"/></span>
        </td>
    </tr>
    <tr>
        <td valign="top">
            <%-- Email Notifications settings note section --%>
            <table id="notification-settings-note" width="100%" align="center" cellspacing="0" cellpadding="0"
                   border="0">
                <%
                    String messageText = message(request, "mail_notifications.warning.settings" );
                    String iconPath = "warning.gif";
                    String messageClass = "warningmsg";
                    // Check if Email Notifications settings were configured
                    if( mailSettingsSpecified )
                    {
                        messageText = message(request, "mail_notifications.note.settings",
                            settings.getDayTimeToSendNotificationAtStr() );
                        iconPath = "note_mark.gif";
                        messageClass = "notemsg";
                    }
                %>
                <tr>
                    <td class="settings-note-icon">
                        <%   if( mailSettingsSpecified ){ %>
                            <at:img page="<%=iconPath%>"/>
                        <% } else { %>
                            <at:defImg page="<%=iconPath%>"/>
                        <%}%>
                    </td>
                    <td class="settings-note-message">
                        <div style="white-space:nowrap; padding-top:10px" class="<%=messageClass%>"><%=messageText%></div>
                    </td>
                    <td>
                        <div id="sendNotificationsNowDiv"><!--Place for rendering "Send notifications now" button--></div>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td style="padding-right: 0; padding-top:0; height:29px;white-space: nowrap" valign="top" >
            <div id="sendNotificationsNow_progress_note">&nbsp;</div>
        </td>
    </tr>
    <tr>
        <td colspan="2">
            <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td class="noprint" style="padding:0px;">
                        <div id="ClientSideErrorMessage" style="margin-top:6px;margin-bottom:6px; display:none;">
                            <bean:define id="details" value="testetst" toScope="request"/>
                            <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
                        </div>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td colspan="2"><at:img page="pixel.gif" height="7"/></td>
    </tr>
</table>



<at:form action="/administration/notifications" >  <%--to avoid submitting when user hits Enter key--%>
    <input type="hidden" name="submitted" value="1"/>
    <html:hidden name="form" property="redirectUrl" value=""/>
    <html:hidden name="form" property="pageAction" value=""/>
<%
    MailNotificationsFormHelper.RuleTable[] tables = MailNotificationsFormHelper.getOrderedTables( request );
%>
<script type="text/javascript">
    var rpcErrorRedirect = '<%=ActionForwards.SHOW_ERROR_FWD%>';
    var exceptionBeanClass = '<%=ExceptionInfoBean.class.getName()%>';
    var scheduleButtons = new Array(); /* array of references to buttons for SchedulePanel manipulation */
    var scheduleControllers = new Array() /* array of references to ScheduleController objects */;
    var schedulePanel = new ScheduleDhtmlPanel("schedule-panel-wrapper",
                                               "week-day-checkbox",
                                               "schedule-panel-message-box",
                                               "saveScheduleButton",
                                               "cancelScheduleButton",
                                               "schedule-saving-message",
                                               "schedule-panel-form");
    var currentEditRule = null; /* the Rule is being edited at the moment */
</script>



<table id="rulesTable" style="width:847px; _width: 825px;" align="center" cellpadding="0" cellspacing="0" class="rightPadding" style="display: none">
    <col width="275" />
    <col />

    <%
        for ( MailNotificationsFormHelper.RuleTable table : tables ) {
    %>
        <jsp:include page="mail_notifications_notification_header.jsp">
            <jsp:param name="title" value="<%=table.title%>" />
            <jsp:param name="notification_type" value="<%=table.typeId%>" />
        </jsp:include>

        <jsp:include page="mail_notifications_add_rule.jsp" >
            <jsp:param name="notification_type" value="<%=table.typeId%>" />
            <jsp:param name="hidden" value="<%=!table.addRulePresent%>" />
        </jsp:include>
    <% } %>

</table>

<%--Tooltip element to be shown if invalid data has been passed to the input--%>
<div id="form-field-tooltip" class="dhtml_title" style="display: none; z-index: 2002"></div>

<script type="text/javascript">
    var NotificationTitle = new Array();
    <%
        for ( MailNotificationsFormHelper.RuleTable table : tables ) {
    %>
        NotificationTitle[<%=table.typeId%>] = "<%=StringUtils.getStringEscapedForJS(table.title)%>";
    <%
        }
    %>

</script>

<%--Rule prototypes--%>
<table border="0" cellpadding="0" cellspacing="0" style="display: none">
    <col width="280" />
    <col />

    <%
        for ( MailNotificationsFormHelper.RuleTable table : tables ) {
    %>
        <jsp:include page="mail_notifications_rule.jsp" >
            <jsp:param name="notification_type" value="<%=table.typeId%>" />
            <jsp:param name="row_1_title" value="<%=table.row1.title%>" />
            <jsp:param name="row_1_jsp"   value="<%=table.row1.jsp%>" />
            <jsp:param name="row_2_title" value="<%=table.row2.title%>" />
            <jsp:param name="row_2_jsp"   value="<%=table.row2.jsp%>" />
            <jsp:param name="row_3_title" value="<%=table.row3.title%>" />
            <jsp:param name="row_3_jsp"   value="<%=table.row3.jsp%>" />
        </jsp:include>
    <%
        }
    %>
</table>

<script type="text/javascript">
    var ruleFactory = new RuleFactory(users, userGroups, timeZoneGroups);

    var rulesLoadCompleted = false; //determines whether row for each stored rule has been created

    Ext.onReady(function() {

        var userGroupsTreeData = {
            rootNode: new TreeRootNode(),
            searchIndex: new StringIndex(),
            allActiveSet: new TreeNodeSet()
        };
        var timeZoneGroupsTreeData = {
            rootNode: new TreeRootNode(),
            searchIndex: new StringIndex(),
            allActiveSet: new TreeNodeSet()
        };

        var userGroupsData = EnabledFeatures.UGR ? makeMapAndOrderForEntitiesArray(userGroups) : null;
        var timeZoneGroupsData = EnabledFeatures.TZG ? makeMapAndOrderForEntitiesArray(timeZoneGroups) : null;

        var accessRights = [new SubmitTimeTrackRight(), new ManageTasksRight(), new GenerateTimeReportRight(), new GenerateMoneyReportRight()];
        var observer = new UserWithAccessRightSelectorTreeBuilderObserver( userGroupsTreeData.searchIndex, userGroupsTreeData.allActiveSet, accessRights );
        var allAccessRightGrantedMapForUserGroups = observer.allAccessRightGrantedMap;
        buildUserSelectorTreeWithUserGroupsData(users, userGroupsData, userGroupsTreeData.rootNode, observer, null);

        observer = new UserWithAccessRightSelectorTreeBuilderObserver( timeZoneGroupsTreeData.searchIndex, timeZoneGroupsTreeData.allActiveSet, accessRights );
        var allAccessRightGrantedMapForTimeZoneGroups = observer.allAccessRightGrantedMap;
        buildUserSelectorTreeWithTimeZoneGroupsData(users, timeZoneGroupsData, timeZoneGroupsTreeData.rootNode, observer, null);

        UsersSelector.selectorsCache = new MailNotificationsUserSelectorCache(EnabledFeatures.UGR, EnabledFeatures.TZG,users, userGroups, timeZoneGroups, userGroupsTreeData,
                                                                              timeZoneGroupsTreeData, allAccessRightGrantedMapForUserGroups, allAccessRightGrantedMapForTimeZoneGroups);

        window.customerProjectSelectorHolder = new MailNotificationsCustomerProjectSelectorHolder();

        <%
            @SuppressWarnings( "unchecked" )
            Map<Integer, CustomersProjectsOutputData> customerProjectOutputDataMap = (Map<Integer, CustomersProjectsOutputData>) request.getAttribute( Keys.CUSTOMER_PROJECT_OUTPUT_DATA_MAP );
            for( MailNotificationsForm.NotificationInfo notification : form.getNotificationInfo() ) {
                if( !notification.getType().isEnabled( getServletConfig().getServletContext() ) )
                    continue;
                for( Rule rule : notification.getRules() ) {
        %>
                    var params = {};
        <%
                    CustomersProjectsOutputData outputData = customerProjectOutputDataMap.get( rule.getId() );
                    Map<String, String> params = rule.getParams();
                    for( Map.Entry<String, String> entry : params.entrySet() ) {
        %>
                        params['<%=entry.getKey()%>'] = '<%=entry.getValue()%>';
        <%          } %>

                    params.id = <%=rule.getId()%>;
                    params.lastChangeTimestamp = new Date(<%=rule.getLastChangeTimestamp().getTime() %>);
                    params.active = <%=rule.isActive()%>
                    <% if (outputData != null) { %>
                        params.customerProjectOutputData = new CustomerProjectOutputData('<%=StringUtils.getStringEscapedForJS(outputData.getCustomerName())%>',
                                                                                         '<%=StringUtils.getStringEscapedForJS(outputData.getProjectName())%>', <%=outputData.isSingleSelectedEntityArchived()%>);
                    <% } %>
                    ruleFactory.addRule( <%=rule.getType().getTypeId()%>, params );
        <%
            }
         }
        %>
        document.getElementById("rulesTable").style.display = "";
        rulesLoadCompleted = true;
    })
</script>


</at:form>

<jsp:include page="/form_changed_confirm.jsp"/>
<jsp:include page="mail_notifications_schedule_panel.jsp"/>
</div>
</body>
</html>
