
create table user_task_comment (
    user_id int not null,
    task_id int not null,
    comment_date date not null,
    comments longtext not null,
    constraint pk_ui_ti_cd primary key (user_id, task_id, comment_date),
    constraint fk_comment_userid foreign key (user_id) references at_user(id),
    constraint fk_comment_taskid foreign key (task_id) references task(id)
);

alter table at_user
add column workday_duration int null;

alter table at_user
add column overtime_tracking bit null;

create table w_days(
    w_date date not null,
    constraint pk_wdate primary key(w_date)
);

create table overtime(
    user_id int not null,
    overtime_date date not null,
    overtime int null,
    constraint pk_ui_od primary key (user_id, overtime_date),
    constraint fk_userid foreign key (user_id) references at_user(id)
);

insert into access_right (id, name, description) values (10, 'system.manage_calendar_prefs', 'Manage Calendar Prefs');

create table system_prefs(
   cal_layout char(2) not null,
   default_worktime int not null
);

insert into system_prefs (cal_layout, default_worktime) values ('EU', 480);

insert into patch_history(patch, patch_timestamp)
    values(2, now());
