create table user_task_comment (
    user_id int(3) unsigned not null,
    task_id int(5) not null,
    comment_date date not null,
    comments text not null,
    primary key (user_id, task_id, comment_date),
    index(user_id),
    index(task_id),
    foreign key (user_id) references at_user(id),
    foreign key (task_id) references task(id)
) ENGINE=InnoDB comment='User comments for dates and tasks';

alter table at_user
add column workday_duration int null,
add column overtime_tracking bit null;

drop table if exists w_days;
create table w_days(
    w_date date not null,
    primary key(w_date)
) ENGINE=InnoDB comment='Working or non-working days';

drop table if exists overtime;
create table overtime(
    user_id int(3) unsigned not null,
    overtime_date date not null,
    overtime int unsigned null,
    index(user_id),
    primary key (user_id, overtime_date),
    foreign key (user_id) references at_user(id)
) ENGINE=InnoDB comment='Overtime records for users';

insert into access_right (id, name, description) values (10, 'system.manage_calendar_prefs', 'Manage Calendar Prefs');

drop table if exists system_prefs;
create table system_prefs(
   cal_layout char(2) not null,
   default_worktime int unsigned not null
) ENGINE=InnoDB comment='System preferences';

insert into system_prefs (cal_layout, default_worktime) values ('EU', 480);

insert into patch_history(patch, patch_timestamp)
    values(2, now());

commit;
