-- insert hire date to existing users

alter table at_user add column hire_date date;
alter table at_user add column release_date date;

create table tmpus
(
    id int not null,
    hire_date date
);

insert
    into
        tmpus
    select
        user_id as id, min(ggg.ddd) as hire_date
    from
    (
        select user_id, record_date as ddd from tt_record ttr
        union
        select user_id, comment_date as ddd from user_task_comment utc
    ) ggg
    group by user_id;

update
    at_user
    inner join tmpus on tmpus.id = at_user.id
    set at_user.hire_date = tmpus.hire_date
    where at_user.overtime_tracking = true;

update at_user set hire_date = now() where overtime_tracking = true and hire_date is null;

drop table tmpus;



alter table task
  add customer_id int
    constraint task_customer_fk
      references customer (id);

update task
       inner join project on task.project_id = project.id
  set task.customer_id = project.customer_id;



create index task_customer_name_i
  on task (customer_id, name_lower);


create table task_filter_customer
(
    customer_id int not null,
    constraint task_filter_customer_pk
        primary key (customer_id)
);


create table task_filter_project
(
    project_id int not null,
    constraint task_filter_project_pk
        primary key (project_id)
);


create index project_customer_archts_i
  on project (customer_id, archiving_timestamp);

create index customer_archts_i
  on customer (archiving_timestamp);


-- as of now, we keep the pack's version in the database

create table tmp_patch_history
(
    patch int not null,
    patch_timestamp date not null
);

insert into tmp_patch_history
  select patch, patch_timestamp
  from patch_history;

drop table patch_history;

create table patch_history
(
    patch int not null,
    pack_version int not null,
    patch_timestamp date not null,
    constraint pk_patch_history primary key(patch, pack_version)
);

insert into patch_history
  select patch, 0 as pack_version, patch_timestamp
    from tmp_patch_history;

drop table tmp_patch_history;

drop table feature_patch_history;



insert into patch_history(patch, pack_version, patch_timestamp)
    values(11, 0, now());
