-- create leave type icon table --

CREATE TABLE `leave_type_icon` (
  `id` int NOT NULL,
  `background_color` varchar(8),
  PRIMARY KEY (`id`)
);

insert into leave_type_icon(id, background_color) values(1, 'f2dede');
insert into leave_type_icon(id, background_color) values(2, null);


-- update leave type table --

alter table leave_type
    alter column name varchar(80) not null;
alter table leave_type
    add name_lower varchar(80) not null;
alter table leave_type
    add is_planned bit not null;
alter table leave_type
    add is_active bit not null;
alter table leave_type
    add icon_id int not null;
alter table leave_type
    add whole_day_text varchar(9);
alter table leave_type
    add `position` int not null;

update leave_type
    set name='Sick Leave', name_lower='sick leave', is_planned=1, is_active=1, icon_id=1, whole_day_text='sick day', `position`=1
    where id=1;

update leave_type
    set name='Time Off', name_lower='time off', is_planned=1, is_active=1, icon_id=2, whole_day_text='day off', `position`=2
    where id=2;

alter table leave_type
    add constraint fk_leave_type_icon_id foreign key(icon_id) references leave_type_icon(id);

alter table leave_type
    add constraint leave_type_name unique (name_lower);

create table license
(
  id counter not null,
  issue_date datetime not null,
  body longtext,
  PRIMARY key(id)
);

create table report_configs
(
  id counter not null,
  name varchar(209) not null,
  name_lower varchar(209) not null,
  report_form int not null,
  constraint pk_report_configs primary key(id),
  constraint nr_report_configs unique(name_lower, report_form)
);

create table report_params
(
  config_id int not null,
  param_name varchar(255) not null,
  param_value varchar(255) not null,
  constraint fk_report_configs foreign key(config_id) references report_configs(id)
);

alter table project
    drop constraint fk_project_customer;
alter table project
    add constraint fk_project_customer foreign key(customer_id) references customer(id) on delete cascade;

alter table task
    drop constraint fk_task_project;
alter table task
    add constraint fk_task_project foreign key(project_id) references project(id) on delete cascade;

alter table tt_record
    drop constraint fk_tt_task;
alter table tt_record
    add constraint fk_tt_task foreign key(task_id) references task(id) on delete cascade;

alter table user_task_comment
    drop constraint fk_comment_taskid;
alter table user_task_comment
    add constraint fk_comment_taskid foreign key (task_id) references task(id) on delete cascade;

alter table user_task
    drop constraint fk_ut_task;
alter table user_task
    add constraint fk_ut_task foreign key(task_id) references task(id) on delete cascade;

update system_settings set property_value='yellowgreen' where property_name='color_scheme' and property_value='green';

insert into patch_history(patch, pack_version, patch_timestamp)
    values(12, 3, now());
