CREATE TABLE `leave_type_icon` (
  `id` int(4) unsigned NOT NULL,
  `background_color` varchar(8),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

insert into leave_type_icon(id, background_color) values(1, 'f2dede');
insert into leave_type_icon(id, background_color) values(2, null); 
commit;

alter table leave_type
    modify name varchar(80) not null,
    add name_lower varchar(80) not null default '',
    add is_planned bit not null default 0,
    add is_active bit not null default 1,
    add icon_id int(4) unsigned not null default 0,
    add whole_day_text varchar(9) default null,
    add position int(3) unsigned not null;

update leave_type
    set name='Sick Leave', name_lower='sick leave', is_planned=1, icon_id=1, whole_day_text='sick day', position=1
    where id=1;

update leave_type
    set name='Time Off', name_lower='time off', is_planned=1, icon_id=2, whole_day_text='day off', position=2
    where id=2;
commit;

alter table leave_type
  change icon_id icon_id int(4) unsigned not null;
commit;

alter table leave_type
    add unique key leave_type_name (name_lower);
commit;

alter table leave_type
    add constraint fk_icon_id foreign key(icon_id) references leave_type_icon(id);

create table license
(
  id int(3) not null,
  issue_date datetime not null,
  body text,
  PRIMARY key(id)
);
commit;

create table report_configs
(
  id int(3) not null auto_increment,
  name varchar(209) not null,
  name_lower varchar(209) not null,
  report_form int not null,
  primary key(id),
  unique(name_lower, report_form)
) engine=InnoDB;

create table report_params
(
  config_id int(3) not null,
  param_name varchar(255) not null,
  param_value varchar(255) not null,
  index(config_id),
  foreign key(config_id) references report_configs(id)
) engine=InnoDB;

alter table project
    add constraint fk_project_customer foreign key(customer_id) references customer(id) on delete cascade;
alter table task
    add constraint fk_task_project foreign key(project_id) references project(id) on delete cascade;
alter table tt_record
    add constraint fk_tt_task foreign key(task_id) references task(id) on delete cascade;
alter table user_task_comment
    add constraint fk_comment_taskid foreign key (task_id) references task(id) on delete cascade;
alter table user_task
    add constraint fk_ut_task foreign key(task_id) references task(id) on delete cascade;

update system_settings set property_value='yellowgreen' where property_name='color_scheme' and property_value='green';

insert
  into patch_history (patch, pack_version, patch_timestamp)
  values (12, 3, now());

commit;
