ALTER TABLE task CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci;

alter table leave_type
  modify column rate_coefficient double(10,2) unsigned not null default 1;
  
-- Invoices ------------------------------------------

create table invoice_bill_to_recent_entry
(
  entry            text          not null,
  normalized_entry text          not null,
  position         int unsigned  not null comment 'the more recent, the larger number',

  constraint unique key uk_invoice_bill_to_recent_entry_position (position)
)
engine=InnoDB
default character set=utf8
default collate=utf8_general_ci;

create table invoice_terms
(
  entry            varchar(255)   not null,
  normalized_entry varchar(255)   not null,
  position         int            not null,

  constraint unique key uk_invoice_terms_position (position)
)
engine=InnoDB
default character set=utf8
default collate=utf8_general_ci;

insert into invoice_terms (entry, normalized_entry, position) values ('Net 60', 'net 60', 1);
insert into invoice_terms (entry, normalized_entry, position) values ('Net 30', 'net 30', 2);
insert into invoice_terms (entry, normalized_entry, position) values ('Net 15', 'net 15', 3);
insert into invoice_terms (entry, normalized_entry, position) values ('Net 10', 'net 10', 4);
insert into invoice_terms (entry, normalized_entry, position) values ('Net 7',  'net 7',  5);
insert into invoice_terms (entry, normalized_entry, position) values ('Due on receipt', 'due on receipt', 6);

create table invoice_tax
(
  position int          not null,
  name     text         not null,
  rate     double(12,4) null,
  is_percent bit        not null default 0,

  constraint unique key uk_invoice_tax_position (position)
)
engine=InnoDB
default character set=utf8
default collate=utf8_general_ci;

create table invoice_discount
(
  position  int    not null,
  name      text   not null,

  constraint unique key uk_invoice_discount_position (position)
)
engine=InnoDB
default character set=utf8
default collate=utf8_general_ci;

insert into invoice_tax (position, name, rate, is_percent) values (1, 'Tax', null, 0);
insert into invoice_discount (position, name) values (1, 'Discount');

create table invoice_params
(
  param_name  varchar(255) not null,
  param_value text         not null,

  constraint unique key uk_invoice_params_param_name (param_name)
)
engine=InnoDB
default character set=utf8
default collate=utf8_general_ci;

insert into invoice_params (param_name, param_value) values ('title', 'INVOICE');
insert into invoice_params (param_name, param_value) values ('POLabel', 'PO#');
insert into invoice_params (param_name, param_value) values ('refCodeLabel', 'Reference Code');

-- ----------------------------------------------------

insert
  into patch_history (patch, pack_version, patch_timestamp)
  values (14, 6, now());
commit;