
update mail_template
    set template = '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
<table style=''width: 560px;$css_text font-size: 12px;'' cellspacing=''0''>
<tr>
<td valign=''middle''>Dear $recipient.fullNameWithoutUserNameEscaped,<br><br>
This is an automatic email message sent by actiTIME to test email settings.
<br>If you received it, then Outgoing mail server, port, and &#8220;From&#8221; address have been correctly set up.
<br><br>Please verify that the following notification parameters are configured as you expected:
<ol>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' > &#8220;From&#8221; address<br><br>
&#8220;From&#8221; address will be shown to all notification recipients in the same way as
in this message. Make sure that it is shown in the required format.<br>
</li>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Prefix to add to the notification subject field<br><br>
Use of a prefix for actiTIME messages simplifies creation of
mail filtering rules in your email client.
$prefixNote
</li>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Links to actiTIME interfaces<br><br>
Please follow the link below to make sure that notification recipients will be able
to open links in the notification messages.<br>
<a href=''$url'' style=''$css_link_color''>Sample link to &quot;General Settings&quot; interface</a><br>
</li>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Standard message footer<br><br>
Standard message footer will be added to all notification messages (including this one).
$footerNote
</li>
</ol>
#showYourActiTIMEFooter()
</td>
</tr>
#if(!($!footer == ""))
<tr>
<td>#showFooter($footer)</td>
</tr>
#end
</table>
</body>
</html>', last_modified_timestamp = now()
        where name = 'test_message.html';

update mail_template
    set template = '## some email clients do not support embedded or external css, so we define several commonly used
## rules here as velocity variables to re-use them later for inline css
#macro( initStyles )
    #set($css_details_font_size=''font-size: 13px; '')
    #set($css_report_link_font_size=''font-size: 13px; '')
    #set($css_details_header_color=''color: #595959; '')
    #set($css_light_border=''1px solid #e9e9e9 '')
    #set($css_dark_border=''1px solid #d9d9d9 '')
    #set($css_outer_border=''1px solid #cccccc '')
    #set($css_darkest_border=''1px solid #999999 '')
    #set($css_range_total_border=''1px solid #8799af '')
    #set($css_link_color=''color: #003399 '')
    #set($css_light_border_left=''border-left: '' + $css_light_border + ''; '')
    #set($css_light_border_right=''border-right: '' + $css_light_border + ''; '')
    #set($css_outer_border_left=''border-left: '' + $css_outer_border + ''; '')
    #set($css_outer_border_right=''border-right: '' + $css_outer_border + ''; '')
    #set($css_outer_border_bottom=''border-bottom: '' + $css_outer_border + ''; '')
    #set($css_outer_border_top=''border-top: '' + $css_outer_border + ''; '')
    #set($css_dark_border_left=''border-left: '' + $css_dark_border + ''; '')
    #set($css_dark_border_right=''border-right: '' + $css_dark_border + ''; '')
    #set($css_dark_border_top=''border-top: '' + $css_dark_border + ''; '')
    #set($css_darkest_border_bottom=''border-bottom: '' + $css_darkest_border + ''; '')
    #set($css_cp_border_bottom=''border-bottom: '' + $css_dark_border + ''; '')
    #set($css_range_total_border_bottom=''border-bottom: '' + $css_range_total_border + ''; '')
    #set($css_range_total_border_top=''border-top: '' + $css_range_total_border + ''; '')
    #set($css_bg_header=''background-color: #366A98; '')
    #set($css_bg_total=''background-color: #f8f4e9; '')
    #set($css_bg_total_middle=''background-color: #f1eee5; '')
    #set($css_bg_range_total=''background-color: #eef2f7; '')
    #set($css_bg_range_total_middle=''background-color: #e9edf1; '')
    #set($css_even_row_border_top=''border-top: 1px solid #f0eee7; '')
    #set($css_even_row_border_bottom=''border-bottom: 1px solid #f0eee7; '')
    #set($css_text=''font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; '')
    #set($css_header_text=$css_text + '' color: white; font-size: 14px; '')
    #set($css_total_text=$css_text + '' color: #665946; '')
    #set($textValueColor=''#366A98'')
    #set($css_parameters_text=$css_text + '' font-size: 14px; '')
    #set($css_parameters_name_text=$css_parameters_text + '' color: '' + $textValueColor + '';'')
    #set($css_table_title_text=$css_text + '' color: #6A573B; font-size: 14px; font-weight: bold; '')
    #set($missedColor=''#C00000'')
#end
#macro( drawHeader )
    <thead>
        <tr>
            <th valign=''middle'' style=''
                                       text-align: left;
                                       padding: 10px 8px 10px 15px;
                                       $css_bg_header
                                       $css_header_text
                                       $css_outer_border_top
                                       $css_outer_border_left''>
                <span style=''font-size: 14px; margin-bottom: 7px; margin-top: 10px''><b>$hls.Customer() / $hls.Project()</b></span><br>
                <span style=''font-size: 12px;''>$hls.Tasks()</span>
            </th>
            <th valign=''middle'' style=''
                                       text-align: center;
                                       padding: 10px 8px;
                                       $css_bg_header
                                       $css_header_text
                                       $css_outer_border_top
                                       $css_light_border_right
                                       $css_light_border_left''><b>Spent</b></th>
            <th valign=''middle'' style=''
                                       text-align: left;
                                       padding: 17px 8px 17px 8px;
                                       $css_bg_header
                                       $css_header_text
                                       $css_outer_border_top
                                       $css_outer_border_right''><b><span>Comments</span></b></th>
        </tr>
    </thead>
#end
#macro( drawDayTT $day)
    #set( $oddRow = true )
    #set( $drawCPEntryTopBorder = false )
    #if( $day.leaveTime > 0)
        <tr>
            <td valign=''bottom'' style=''
                                       text-align: left;
                                       background-color: #FCF8EF;
                                       $css_details_header_color
                                       padding: 20px 8px 8px 15px;
                                       $css_text
                                       $css_outer_border_left
                                       border-bottom: 1px dashed #AFAFAF ;
                                       ''><b><span style=''font-size: 14px;''>$day.leaveName</span></b></td>
            <td valign=''bottom'' style=''
                                       text-align: right;
                                       font-size: 14px;
                                       padding: 20px 15px 8px 8px;
                                       background-color: #F5F1EA;
                                       $css_text
                                       border-bottom: 1px dashed #BFBFBF ;
                                       $css_light_border_right
                                       $css_light_border_left
                                       ''><b>$day.formattedLeaveTime</b></td>
            <td style=''
                       background-color: #FCF8EF;
                       padding: 20px 8px 8px 15px;
                       $css_outer_border_right
                       border-bottom: 1px dashed #AFAFAF ;
                       ''>&nbsp;</td>
        </tr>
    #end
    #foreach( $cpEntry in $day.rows.entrySet() )
        <tr>
            <td valign=''bottom'' style=''
                                       text-align: left;
                                       background-color: #f2f2f2;
                                       padding: 20px 8px 8px 15px;
                                       $css_text
                                       $css_outer_border_left
                                       $css_cp_border_bottom
                                       #if($drawCPEntryTopBorder) $css_dark_border_top #end''>
                <b><span style=''font-size: 14px; $css_details_header_color''>$cpEntry.key.customerName /</span>
                    <span style=''$css_parameters_name_text font-weight: bold; ''>$cpEntry.key.projectName</span></b>
            </td>
            <td valign=''bottom'' style=''
                                       text-align: right;
                                       font-size: 14px;
                                       padding: 20px 15px 8px 8px;
                                       background-color: #ededed;
                                       $css_text
                                       $css_cp_border_bottom
                                       $css_light_border_right
                                       $css_light_border_left
                                       #if($drawCPEntryTopBorder) $css_dark_border_top #end''>
                <b>$day.getFormattedSubTotal($cpEntry.key)</b></td>
            <td style=''
                       background-color: #f2f2f2;
                       padding: 20px 8px 8px 15px;
                       $css_outer_border_right
                       $css_cp_border_bottom
                       #if($drawCPEntryTopBorder) $css_dark_border_top #end''>&nbsp;</td>
        </tr>
        #set( $drawCPEntryTopBorder = true )
        #set ( $rowNumber = 0 )
        #foreach( $ttRow in $cpEntry.value.values() )
            #set ( $drawEvenBorderTop = ($rowNumber != 0) )
            #set ( $drawEvenBorderBottom = ($rowNumber < ($cpEntry.value.values().size() - 1)) )
            #if( $oddRow  )
                <tr>
                    <td valign=''middle'' style=''
                                               text-align: left;
                                               padding: 8px 8px 8px 35px;
                                               font-size: 13px;
                                               background-color: #ffffff;
                                               $css_text
                                               $css_outer_border_left''>$ttRow.taskName</td>
                    <td valign=''middle'' style=''
                                               text-align: right;
                                               font-size: 13px;
                                               background-color: #f7f7f7;
                                               padding: 8px 15px 8px 8px;
                                               $css_text
                                               $css_light_border_right
                                               $css_light_border_left''>$ttRow.formattedSpent</td>
                    <td valign=''middle'' style=''
                                               text-align: left;
                                               font-size: 13px;
                                               background-color: #ffffff;
                                               padding: 8px 8px 8px 18px;
                                               $css_text
                                               $css_outer_border_right''>$ttRow.comments</td>
                </tr>
            #else
                <tr>
                    <td valign=''middle'' style=''
                                               text-align: left;
                                               padding: 8px 8px 8px 35px;
                                               font-size: 13px;
                                               background-color: #fcfaf3;
                                               $css_text
                                               $css_outer_border_left
                                               #if($drawEvenBorderTop) $css_even_row_border_top #end
                                               #if($drawEvenBorderBottom) $css_even_row_border_bottom #end
                                               ''>$ttRow.taskName</td>
                    <td valign=''middle'' style=''
                                               text-align: right;
                                               font-size: 13px;
                                               background-color: #f5f3ed;
                                               padding: 8px 15px 8px 8px;
                                               $css_text
                                               #if($drawEvenBorderTop) $css_even_row_border_top #end
                                               #if($drawEvenBorderBottom) $css_even_row_border_bottom #end
                                               $css_light_border_right
                                               $css_light_border_left
                                               ''>$ttRow.formattedSpent</td>
                    <td valign=''middle'' style=''
                                               text-align: left;
                                               font-size: 13px;
                                               background-color: #fcfaf3;
                                               $css_text
                                               padding: 8px 8px 8px 18px;
                                               $css_outer_border_right
                                               #if($drawEvenBorderTop) $css_even_row_border_top #end
                                               #if($drawEvenBorderBottom) $css_even_row_border_bottom #end
                                               ''>$ttRow.comments</td>
                </tr>
            #end
            #set( $oddRow = !$oddRow )
            #set( $rowNumber = ( $rowNumber + 1 ) )
        #end
    #end
#end
#macro( drawDayTotal $day $displaySettings $drawTopBorder)
    <tr>
        <td valign=''middle'' style=''text-align: right;
                                   font-size: 15px;
                                   padding: 10px 8px 6px 18px;
                                   $css_total_text
                                   $css_bg_total
                                   $css_outer_border_left
                                   #if($drawTopBorder) $css_outer_border_top #end
                                   #if(!$displaySettings.showCalculatedOvertime) $css_outer_border_bottom #end''>
            <b>Total:</b></td>
        <td valign=''middle'' style=''
                                   text-align: right;
                                   font-size: 15px;
                                   $css_text
                                   padding: 10px 15px 6px 8px;
                                   $css_bg_total_middle
                                   $css_light_border_left
                                   $css_light_border_right
                                   #if($drawTopBorder) $css_outer_border_top #end
                                   #if(!$displaySettings.showCalculatedOvertime) $css_outer_border_bottom #end''>
            <b>$day.total.formattedTotal</b></td>
        <td valign=''middle'' style=''text-align: left;
                                   font-size: 13px;
                                   padding: 10px 18px 6px 18px;
                                   $css_text
                                   $css_bg_total
                                   $css_outer_border_right
                                   #if($drawTopBorder) $css_outer_border_top #end
                                   #if(!$displaySettings.showCalculatedOvertime) $css_outer_border_bottom #end''>
            <table border=''0'' cellpadding=''0'' cellspacing=''0''>
                <tr>
                    <td width=''80'' style=''
                                          text-align: left;
                                          font-size: 13px;
                                          $css_total_text
                                          $css_bg_total''>
                        <span style=''white-space: nowrap;''>Working&nbsp;Time:</span></td>
                    <td width=''40'' style=''
                                          text-align: right;
                                          font-size: 13px;
                                          padding-left: 5px;
                                          $css_text
                                          $css_bg_total''>$day.total.formattedWorking</td>
         #if($displaySettings.showLeaveTime)
             <td style=''
                        padding-left: 25px;
                        text-align: left;
                        font-size: 13px;
                        $css_total_text
                        $css_bg_total''>
              #if( $day.total.leaveName )${day.total.leaveName}#{else}Leave&nbsp;Time#end:</td>
             <td width=''40'' style=''
                                   text-align: right;
                                   font-size: 13px;
                                   padding-left: 5px;
                                   $css_text
                                   $css_bg_total''>$day.total.formattedLeave</td>
            #end
            <td> </td>
        </tr>
        </table>
        </td>
    </tr>
    #if($displaySettings.showReportedOvertime)
        <tr>
            <td valign=''top'' style=''
                                    text-align: right;
                                    font-size: 14px;
                                    padding: 0 8px 6px 15px;
                                    $css_total_text
                                    $css_bg_total
                                    $css_outer_border_left''>
                <span style=''white-space: nowrap;''>Reported&nbsp;Overtime #if($displaySettings.undertimeTracking)&nbsp;/&nbsp;Undertime #end:</span></td>
            <td valign=''top'' style=''
                                    text-align: right;
                                    font-size: 14px;
                                    padding: 0 15px 8px 8px;
                                    $css_text
                                    $css_bg_total_middle
                                    $css_light_border_left
                                    $css_light_border_right''>$day.total.formattedReportedOvertime</td>
            <td valign=''top'' style=''
                                    text-align: left;
                                    font-size: 14px;
                                    $css_text
                                    $css_bg_total
                                    $css_outer_border_right''>&nbsp;</td>
        </tr>
    #end
    #if($displaySettings.showCalculatedOvertime)
    <tr>
        <td valign=''top'' style=''
                                text-align: right;
                                font-size: 14px;
                                padding: 0 8px 14px 15px;
                                $css_total_text
                                $css_bg_total
                                $css_outer_border_left
                                $css_outer_border_bottom''><span style=''white-space: nowrap;''>Auto-calculated&nbsp;Overtime#if($displaySettings.undertimeTracking)&nbsp;/&nbsp;Undertime #end:</span></td>
        <td valign=''top'' style=''
                                text-align: right;
                                font-size: 14px;
                                padding: 0 15px 8px 8px;
                                $css_text
                                $css_bg_total_middle
                                $css_light_border_left
                                $css_light_border_right
                                $css_outer_border_bottom''>$day.total.formattedCalculatedOvertime</td>
        <td valign=''top'' style=''
                                text-align: left;
                                font-size: 14px;
                                $css_text
                                $css_bg_total
                                $css_outer_border_right
                                $css_outer_border_bottom''>&nbsp;</td>
    </tr>
    #end
#end

#macro ( drawCustomerProjectsTable $customerProjects )
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''width: 100%; border-collapse:collapse;''>
    <thead>
        <tr>
            <th valign=''middle''
                style=''
                       text-align: left;
                       padding: 10px 8px 10px 15px;
                       $css_bg_header
                       $css_header_text
                       $css_outer_border_top
                       $css_outer_border_left''>
                    <b>$hls.Customer() / $hls.Projects()</b>
                </th>
          </tr>
    </thead>
    <tbody>
    #set($drawTopCPBorder = false)
    #set($customerNumber = 0)
    #set( $oddRow = true )
    #foreach( $customer in $customerProjects.keySet())
        #set( $rowNumber = 0 )
        #set( $projectsNumber = $customerProjects.get($customer).size() )
        <tr>
            <td style=''text-align: left;
                                       background-color: #f2f2f2;
                                       padding: 20px 8px 8px 15px;
                                       $css_details_header_color
                                       $css_details_font_size
                                       $css_text
                                       $css_outer_border_left
                                       $css_outer_border_right
                                       $css_cp_border_bottom
                                       font-weight: normal;
                                       #if($drawTopCPBorder) $css_dark_border_top #else $css_outer_border_top #end''>
                <b>$escapeUtil.getNameEscaped($customer)</b> ($projectsNumber #if ($projectsNumber > 1) $hls.projects() #else $hls.project() #end )
            </td>
        </tr>
        #set($drawTopCPBorder = true)
        #foreach( $project in $customerProjects.get($customer) )
            #set( $drawEvenBorderTop = ($rowNumber != 0) )
            #set( $drawEvenBorderBottom = ($rowNumber < ($projectsNumber - 1)) )
            #set( $drawOuterBorderBottom = (($customerNumber == ($customerProjects.keySet().size() - 1)) && !$drawEvenBorderBottom) )
            <tr>
                #if($oddRow)
                    <td valign=''bottom''
                        style=''
                                   text-align: left;
                                   $css_details_font_size
                                   background-color: #ffffff;
                                   padding: 8px 8px 8px 35px;
                                   $css_text
                                   $css_outer_border_left
                                   $css_outer_border_right
                                   #if($drawOuterBorderBottom) $css_outer_border_bottom #end''>
                        $escapeUtil.getNameEscaped($project)
                    </td>
                #else
                    <td valign=''bottom''
                        style=''
                                   text-align: left;
                                   $css_details_font_size
                                   background-color: #fcfaf3;
                                   padding: 8px 8px 8px 35px;
                                   $css_text
                                   $css_outer_border_left
                                   $css_outer_border_right
                                   #if($drawEvenBorderTop) $css_even_row_border_top #end
                                   #if($drawEvenBorderBottom) $css_even_row_border_bottom #end
                                   #if($drawOuterBorderBottom) $css_outer_border_bottom #end''>
                        $escapeUtil.getNameEscaped($project)
                    </td>
                #end
                #set($oddRow = !$oddRow)
                #set($rowNumber = ($rowNumber + 1))
            </tr>
        #end
        #set($customerNumber = ($customerNumber + 1))
    #end
    </tbody>
</table>
#end

#macro ( showFooter $footer )
    <br/>
    <hr noshade size="1" style="background-color: #333333; color: #333333;" />
    <pre style=''font-family: Arial Unicode MS, Arial, sans-serif; font-size: 12px;''>$footer</pre>
#end

#macro ( showYourActiTIMEFooter )
&ndash;&ndash;&ndash;<br/>Your actiTIME
#end
#macro ( showYourActiTIMEFooterPlainText )
- - -
Your actiTIME
#end
', last_modified_timestamp = now()
        where name = 'shared_macro.vm';

update mail_template
    set template = '<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#set($css_cp_border=''1px solid #d9d9d9 '')
#initStyles( )
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
Dear <b>$recipient.fullNameWithoutUserNameEscaped</b>,<br>
<br> You have not recorded sufficient time for #if($displaySettings.showDateRangePrefix)date range<br>#end $displaySettings.formattedDateRange.<br> <br>
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''border-collapse: collapse;font-weight: bold; $css_parameters_text''>
<tr><td><b>Expected time-track:</b></td> <td style=''padding-left: 35px;''><b>$rule.ttLimit.hours:00</b></td></tr><tr><td><b>Recorded time-track:</b></td><td style=''color:red;padding-left: 35px;''><b>$total.formattedTotal</b></td></tr>
</table>
<br>
Please make sure that you entered all working and leave time for the specified date range.<br><br>
<table cellpadding=''0'' cellspacing=''0'' border=''0''
style=''font-size: 11px;
width: 100%;
border-collapse: collapse;
''>
<col/>
<col width=''60''/>
<col/>
#drawHeader( )
<tbody>
#foreach( $day in $days )
#set( $drawTotalTopBorder = ($day.rows.size() != 0) )
<tr>
<td colspan=''2'' valign=''bottom''
style=''
$css_text
$css_outer_border_left
$css_darkest_border_bottom
font-size: 18px;
padding: 30px 8px 10px 15px;
text-align: left; ''>
$day.formattedDay
</td>
<td valign=''bottom''
style=''
font-size: 13px;
text-align: right;
padding: 30px 15px 10px;
$css_text
$css_outer_border_right
$css_darkest_border_bottom
''>
<a href=''${displaySettings.getEditTTLink($day.day)}'' style=''$css_link_color''>Edit time-track</a>
</td>
</tr>
#drawDayTT( $day )
#drawDayTotal( $day $displaySettings $drawTotalTopBorder )
#end
<tr>
<td colspan=''3''><span style=''font-size: 12px; line-height:18px;''>&nbsp;<br></span></td>
</tr>
<tr>
<td valign=''middle''
style=''
text-align: right;
font-size: 15px;
padding: 12px 8px 6px 18px;
$css_text
$css_bg_range_total
$css_dark_border_left
$css_range_total_border_top
#if(!$displaySettings.showCalculatedOvertime) $css_range_total_border_bottom #end''>
<b>Total&nbsp;for&nbsp;the&nbsp;date&nbsp;range:</b></td>
<td valign=''middle''
style=''
text-align: right;
font-size: 15px;
$css_text
padding: 12px 15px 6px 8px;
$css_bg_range_total_middle
$css_light_border_left
$css_light_border_right
$css_range_total_border_top
#if(!$displaySettings.showCalculatedOvertime) $css_range_total_border_bottom #end''>
<b>$total.formattedTotal</b></td>
<td valign=''middle''
style=''
text-align: left;
font-size: 13px;
padding: 12px 8px 6px 18px;
$css_text
$css_bg_range_total
$css_dark_border_right
$css_range_total_border_top
#if(!$displaySettings.showCalculatedOvertime) $css_range_total_border_bottom #end''>
<table border=''0'' cellpadding=''0'' cellspacing=''0''>
<tr>
<td width=''80''
style=''
text-align: left;
font-size: 13px;
$css_text
$css_bg_range_total''>
Working&nbsp;Time:</td>
<td width=''40''
style=''
text-align: right;
font-size: 13px;
padding-left: 5px;
$css_text
$css_bg_range_total''>
$total.formattedWorking
</td>
#if($displaySettings.showLeaveTime)
<td style=''
padding-left: 25px;
text-align: left;
font-size: 13px;
$css_text
$css_bg_range_total''>
Leave&nbsp;Time:</td>
<td width=''40''
style=''
text-align: right;
font-size: 13px;
padding-left: 5px;
$css_text
$css_bg_range_total''>
$total.formattedLeave
</td>
#end
<td></td>
</tr>
</table>
</td>
</tr>
#if($displaySettings.showReportedOvertime)
<tr>
<td valign=''top''
style=''
text-align: right;
font-size: 14px;
padding: 0 8px 8px 15px;
$css_text
$css_bg_range_total
$css_dark_border_left''>
<span style=''white-space: nowrap;''>Reported&nbsp;Overtime&nbsp;#if($displaySettings.undertimeTracking)/&nbsp;Undertime#end:</span>
</td>
<td valign=''top''
style='' text-align: right;
font-size: 14px;
padding: 0 15px 8px 8px;
$css_text
$css_bg_range_total_middle
$css_light_border_left
$css_light_border_right''>
$total.formattedReportedOvertime
</td>
<td valign=''top''
style='' text-align: left;
font-size: 14px;
$css_text
$css_bg_range_total
$css_dark_border_right''>
&nbsp;</td>
</tr>
#end #if($displaySettings.showCalculatedOvertime)
<tr>
<td valign=''top''
style='' text-align: right;
font-size: 14px;
padding: 0 8px 16px 15px;
$css_text
$css_bg_range_total
$css_dark_border_left
$css_range_total_border_bottom''>
<span style=''white-space: nowrap;''>Auto-calculated&nbsp;Overtime#if($displaySettings.undertimeTracking)&nbsp;/&nbsp;Undertime#end:</span>
</td>
<td valign=''top''
style='' text-align: right;
font-size: 14px;
padding: 0 15px 8px 8px;
$css_text
$css_bg_range_total_middle
$css_light_border_left
$css_light_border_right
$css_range_total_border_bottom''>
$total.formattedCalculatedOvertime
</td>
<td valign=''top''
style=''text-align: left;
font-size: 14px;
$css_text
$css_bg_range_total
$css_dark_border_right
$css_range_total_border_bottom''>
&nbsp;</td>
</tr>
#end
</tbody>
</table>
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
        where name = 'personal_tt.html';

update mail_template
    set template = '<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#set($css_cp_border=''1px solid #d9d9d9 '')
#initStyles()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
Dear <b>$recipient.fullNameWithoutUserNameEscaped</b>,<br><br>
There#if($usersWithUnsubmittedTTCount > 1) are users#else is a user#end whose time-track is incomplete.<br><br>
#set($shouldDrawSeparator = false)
#foreach( $rule in $rules)
#if($shouldDrawSeparator)
<div style='' font-size:1px; line-height:1px;''><div style=''margin:25px 0px 25px 0px; width:100%; font-size:1px; height: 1px; border-top: 1px solid #BFBFBF; line-height: 1px;''>&nbsp;</div></div>
#end
#set($shouldDrawSeparator = true)
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''border-collapse:collapse; text-align: left;''>
<tr>
<td style=''$css_parameters_name_text; padding-left: 0px; margin-left:0px;''>
<b style="white-space: nowrap;">Date#if(!($ruleBeans.get($rule).isOneDayDateRange())) Range#end:</b>
</td>
<td style=''$css_parameters_text padding-left: 25px;''>
<b style="white-space: nowrap; ">$ruleBeans.get($rule).formattedDateRange</b>
</td>
</tr>
<tr>
<td style=''$css_parameters_name_text; padding-left: 0px; margin-left:0px;''>
<b style="white-space: nowrap;">Expected Time-Track:</b>
</td>
<td style=''$css_parameters_text padding-left: 25px;''>
<b style="white-space: nowrap;">$rule.ttLimit.hours:00</b>
</td>
</tr>
</table>
<br>
<b><span style=''$css_table_title_text''>Time-Track Reported by User#if ($ruleBeans.get($rule).all.size() > 1)s#end:</span></b>
<br>
<br>
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''width: 100%; border-collapse:collapse;''>
<col/> <col width=''80''/> <col width=''80''/>
<thead>
<tr>
<th valign=''middle''
style=''
text-align: left;
padding: 0px 8px 0px 15px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_left''>
<b>User</b></th>
<th valign=''middle''
style='' width: 80px;
text-align: center;
padding: 0px 8px 0px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>Spent</b></th>
<th valign=''middle''
style='' width: 80px;
text-align: center;
padding: 10px 8px 10px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_right
$css_light_border_left''>
<b>Missing<br>
Hours</b></th>
</tr>
</thead>
<tbody>
#set( $oddRow = true )
#set( $rowNumber = 0)
#foreach( $userInn in $ruleBeans.get($rule).all )
#set ( $drawEvenBorderTop = ($rowNumber != 0) )
#set ( $drawEvenBorderBottom = ($rowNumber < ($ruleBeans.get($rule).all.size() - 1)))
#set ( $drawBorderBottom = ($rowNumber == ($ruleBeans.get($rule).all.size() - 1)))
#if($oddRow)
<tr>
<td valign=''middle''
style=''
text-align: left;
font-size: 13px;
background-color: #ffffff;
padding: 8px 8px 8px 15px;
$css_text
$css_outer_border_left
#if($drawBorderBottom) $css_outer_border_bottom #end
''>
$userInn.user.formattedNameEscaped
</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #ffffff;
$css_text
$css_dark_border_left
#if($drawBorderBottom) $css_outer_border_bottom #end''>
$userInn.formattedActuals</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #ffffff;
$css_text
$css_outer_border_right
$css_dark_border_left
#if($drawBorderBottom) $css_outer_border_bottom #end''>
<span style=''color:red;''>$userInn.formattedMissed</span></td>
</tr>
#else
<tr>
<td valign=''middle''
style=''
text-align: left;
font-size: 13px;
background-color: #fcfaf3;
padding: 8px 8px 8px 15px;
$css_text
$css_outer_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawBorderBottom) $css_outer_border_bottom #end
''>
$userInn.user.formattedNameEscaped
</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #fcfaf3;
$css_text
$css_dark_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawBorderBottom) $css_outer_border_bottom #end
''>
$userInn.formattedActuals</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #fcfaf3;
$css_text
$css_outer_border_right
$css_dark_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawBorderBottom) $css_outer_border_bottom #end''>
<span style=''color:red;''>$userInn.formattedMissed</span></td>
</tr>
#end
#set($oddRow = !$oddRow)
#set($rowNumber = ($rowNumber + 1))
#end
</tbody>
</table>
<br>
<a href=''$ruleBeans.get($rule).link'' style=''$css_link_color; $css_report_link_font_size''>View detailed time-track data in the Staff Output Report</a>
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
        where name = 'unsubmitted_tt.html';


insert into mail_template (name, template, last_modified_timestamp)
       values( 'test_message_online.html', '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
<table style=''width: 560px;$css_text font-size: 12px;'' cellspacing=''0''>
<tr>
<td valign=''middle''>Dear $recipient.fullNameWithoutUserNameEscaped,<br><br>
This is an automatic email message sent by actiTIME to test email settings.
<br>Please verify that the following notification parameters are configured as you expected:
<ol>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Prefix to add to the notification subject field<br><br>
Use of a prefix for actiTIME messages simplifies creation of
mail filtering rules in your email client.
$prefixNote
</li>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Standard message footer<br><br>
Standard message footer will be added to all notification messages (including this one).
$footerNote
</li>
</ol>
#showYourActiTIMEFooter()
</td>
</tr>
#if(!($!footer == ""))
<tr>
<td>#showFooter($footer)</td>
</tr>
#end
</table>
</body>
</html>', now() );

insert into mail_template (name, template, last_modified_timestamp)
       values( 'test_message_basic.html', '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
<table style=''width: 560px;$css_text font-size: 12px;'' cellspacing=''0''>
<tr>
<td valign=''middle''>Dear $recipient.fullNameWithoutUserNameEscaped,<br><br>
This is an automatic email message sent by actiTIME to test email settings.
If you received it, then Outgoing mail server, port, and &#8220;From&#8221; address have been correctly set up.
<br/>
<br/>Please verify that address of your actiTIME installation is configured properly.
<br/>Follow the link below to make sure that recipients will be able to open links in the system messages.
<a href=''$url'' style=''$css_link_color''>Sample link to &quot;General Settings&quot; interface</a><br><br>
#showYourActiTIMEFooter()
</td>
</tr>
</table>
</body>
</html>', now() );

insert into mail_template (name, template, last_modified_timestamp)
       values( 'password_recovery_link.txt',
               CHR(10) & 'Hello $recipient.firstName,' &
               CHR(10) & CHR(10) & 'There was a request to reset password on your actiTIME account.' &
               CHR(10) & CHR(10) & 'If you requested this password change,' & CHR(10) & 'please follow the link below to set a new password:' &
               CHR(10) & CHR(10) & '$url$token' &
               CHR(10) & CHR(10) & 'If you didn''t request to reset your password,' & CHR(10) & 'you can safely disregard this email.' &
               CHR(10) & CHR(10) & '#showYourActiTIMEFooterPlainText()',
               now() );

insert into mail_template (name, template, last_modified_timestamp)
       values( 'password_reset.txt',
               CHR(10) & 'Hello $recipient.firstName,' &
               CHR(10) & CHR(10) & 'Your actiTIME password has been changed successfully.' & CHR(10) & 'Your username is: $recipient.name' &
               CHR(10) & CHR(10) & 'Keep on trackin''' &
               CHR(10) & CHR(10) & '#showYourActiTIMEFooterPlainText()',
               now() );

-- Delete user without mobile button functionality
drop table user_without_mobile_button;

-- Create password_recovery_token
create table password_recovery_token (
    user_id int NOT NULL,
    creation_timestamp datetime NOT NULL,
    token varchar(255) NOT NULL,

    unique(token),
    unique(user_id),
    CONSTRAINT fk_token_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE
);

-- ----------------------------------------------------

--  -- Increase length of username from 32 to 255 symbols
alter table at_user alter column username varchar(255) not null;
alter table at_user alter column username_lower varchar(255) not null;

-- ----------------------------------------------------

insert
  into patch_history (patch, pack_version, patch_timestamp)
  values (19, 0, now());
