insert into user_access_right (user_id, access_right_id)
	select 1, id from access_right where id <> 9;

alter table billing_type add column is_default bit null;

update task set billing_type_id=null
where id in (select t.id from task t, project p, customer c where t.project_id=p.id 
            and p.customer_id=c.id and (c.billing_status = 0 or p.billing_status = 0 or t.billing_status = 0));

alter table customer drop column billing_status;
alter table project drop column billing_status;
alter table project drop constraint fk_project_billing_type;
alter table project drop column default_billing_type_id;
alter table task drop column billing_status;

create table _temp_rights(
    user_id int not null,
    access_right_id int not null
);

insert into _temp_rights(user_id, access_right_id)
    select user_id, 2 from user_access_right where access_right_id in (2,3,4) group by user_id;

delete from user_access_right where access_right_id in (2,3,4);

insert into user_access_right(user_id, access_right_id)
    select user_id, access_right_id from _temp_rights;

drop table _temp_rights;

delete from access_right where id in (3,4);

update access_right set name='tasks.manage_customers_projects_tasks', description='Manage Customers, Projects & Tasks' where id = 2;

update access_right set name='system.manage_work_schedule', description='Manage Work Schedule' where id = 10;

insert into access_right (id, name, description) values (11, 'system.manage_general_settings', 'Manage General Settings');

insert into user_access_right (user_id, access_right_id)
    select user_id, 11 from user_access_right where access_right_id = 10;

create table system_settings
(
    property_name varchar(32) not null,
    property_value varchar(255),
    constraint n_unique unique(property_name)
);

insert into system_settings(property_name, property_value) values ('date_format', 'MMM dd, yyyy');
insert into system_settings(property_name, property_value) values ('maximum_hours_per_day', '1440');
insert into system_settings(property_name, property_value) values ('overtime_undertime_tracking', 'overtime');
insert into system_settings(property_name, property_value) values ('tt_approval_enabled', 'true');

insert into system_settings(property_name, property_value)
    select 'calendar_layout', cal_layout from system_prefs;
insert into system_settings(property_name, property_value)
    select 'workday_duration', default_worktime from system_prefs;

drop table system_prefs;

alter table customer add column archiving_timestamp datetime;
alter table project add column archiving_timestamp datetime;

alter table at_user drop column is_root;

alter table at_user add column overtime_level int null;

update at_user set overtime_level = 2 where not overtime_tracking = 0;
update at_user set overtime_level = 0 where overtime_tracking = 0;

delete from overtime where overtime is null;
alter table overtime alter column overtime int not null;

insert into patch_history(patch, patch_timestamp)
    values(3, now());
