-- bin_data : bin_data_id
alter table bin_data_chunk drop foreign key bin_data_chunk_bin_data_id;
alter table mail_message drop foreign key mail_message_body_bin_data_id;
alter table mail_message_attachment drop foreign key mail_message_attachment_bin_data_id;
alter table bin_data modify bin_data_id int(3) unsigned not null auto_increment;
alter table bin_data_chunk add constraint bin_data_chunk_bin_data_id_fk_bin_data_bin_data_id foreign key (bin_data_id)
    references bin_data (bin_data_id) on delete cascade;
alter table mail_message add constraint mail_message_body_bin_data_id_fk_bin_data_bin_data_id foreign key (body_bin_data_id)
    references bin_data (bin_data_id) on delete no action;
alter table mail_message_attachment add constraint mail_message_attachment_bin_data_id_fk_bin_data_bin_data_id foreign key (bin_data_id)
    references bin_data (bin_data_id) on delete cascade;

-- mail_message : message_id
alter table mail_message_recipient drop foreign key mail_message_recipient_message_id;
alter table mail_message_attachment drop foreign key mail_message_attachment_message_id;
alter table mail_message modify message_id int(3) unsigned not null auto_increment;
alter table mail_message_recipient add constraint mail_message_recipient_message_id
        foreign key (message_id) references mail_message (message_id) on delete cascade;
alter table mail_message_attachment add constraint mail_message_attachment_message_id
        foreign key (message_id) references mail_message (message_id) on delete cascade;

alter table `mail_message`
        add from_personal varchar(255),
        add from_address varchar(255) not null;

-- notification_rule : id
alter table notification_rule_params drop foreign key notification_rule_params_rule_id;
alter table user_notif_rule_send drop foreign key fk_user_notif_rule_send_rule;
alter table notification_rule modify id int(3) unsigned not null auto_increment;
alter table notification_rule_params add constraint notification_rule_params_rule_id
        foreign key (rule_id) references notification_rule (id) on delete cascade;
alter table user_notif_rule_send add constraint fk_user_notif_rule_send_rule
        foreign key (rule_id) references notification_rule (id) on delete cascade;


-- user_notif_rule_send : id
alter table project_user_notif_rule_send drop foreign key fk_project_user_notif_rule_send_id;
alter table user_user_notif_rule_send drop foreign key fk_user_user_notif_rule_send_id;
alter table task_user_notif_rule_send drop foreign key fk_task_user_notif_rule_send_id;
alter table user_notif_rule_send modify id int(5) unsigned not null auto_increment;
alter table project_user_notif_rule_send add constraint fk_project_user_notif_rule_send_id
        foreign key (user_notif_rule_send_id) references user_notif_rule_send (id) on delete cascade;
alter table user_user_notif_rule_send add constraint fk_user_user_notif_rule_send_id
        foreign key (user_notif_rule_send_id) references user_notif_rule_send (id) on delete cascade;
alter table task_user_notif_rule_send add constraint fk_task_user_notif_rule_send_id
        foreign key (user_notif_rule_send_id) references user_notif_rule_send (id) on delete cascade;


-- at_user_revision : id
alter table at_user drop foreign key fk_at_user_revision;
alter table at_user_revision modify id int(10) unsigned not null auto_increment;
alter table at_user add constraint fk_at_user_revision
        foreign key (id) references at_user_revision (id) on delete no action;


-- task_revision : id
alter table task drop foreign key fk_task_revision;
alter table task_revision modify id int(3) not null auto_increment;
alter table task  add constraint fk_task_revision
        foreign key (id) references task_revision (id) on delete no action;


-- project_revision : id
alter table project drop foreign key fk_project_revision;
alter table project_revision modify id int(3) not null auto_increment;
alter table project add constraint fk_project_revision
        foreign key (id) references project_revision (id) on delete no action;


-- customer_revision : id
alter table customer drop foreign key fk_customer_revision;
alter table customer_revision modify id int(3) not null auto_increment;
alter table customer add constraint fk_customer_revision
        foreign key (id) references customer_revision (id) on delete no action;


-- billing_type_revision : id
alter table billing_type drop foreign key fk_billing_type_revision;
alter table billing_type_revision modify id int(3) unsigned not null auto_increment;
alter table billing_type add constraint fk_billing_type_revision
        foreign key (id) references billing_type_revision (id) on delete no action;


-- leave_type_revision : id
alter table leave_type drop foreign key fk_leave_type_revision;
alter table leave_type_revision modify id int(3) unsigned not null auto_increment;
alter table leave_type add constraint fk_leave_type_revision
        foreign key (id) references leave_type_revision (id) on delete no action;

-- license : id
set @lid=(select max(id)+1 from license);
update license set id=@lid where id=0;
alter table license modify id int(3) not null auto_increment;

-- user_rate : id
alter table leave_rate drop foreign key leave_rate_rate_id_fk_user_rate_id;
alter table user_rate modify id int(5) unsigned not null auto_increment;
alter table leave_rate add constraint leave_rate_rate_id_fk_user_rate_id
        foreign key (rate_id) references user_rate (id) on delete cascade;


-- user_group : id
alter table at_user drop foreign key fk_at_user_user_group;
alter table user_group modify id int(3) unsigned not null auto_increment;
alter table at_user add constraint fk_at_user_user_group
        foreign key (user_group_id) references user_group(id) on delete set null;

-- report_configs : id
alter table report_params drop foreign key fk_report_configs;
alter table report_params_customer drop foreign key fk_rpc_config_id;
alter table report_params_project drop foreign key fk_rpp_config_id;
alter table invoice_params drop foreign key fk_invoice_params_config_id;
alter table invoice_tax drop foreign key fk_invocie_tax_config_id;
alter table invoice_discount drop foreign key fk_invoice_discount_config_id;

alter table report_configs modify id int(3) not null auto_increment;

alter table report_params add constraint fk_report_configs
        foreign key (config_id) references report_configs (id) on delete cascade;
alter table report_params_customer add constraint fk_rpc_config_id
        foreign key (config_id) references report_configs(id) on delete cascade;
alter table report_params_project add constraint fk_rpp_config_id
        foreign key (config_id) references report_configs(id) on delete cascade;
alter table invoice_params add constraint fk_invoice_params_config_id
        foreign key (config_id) references report_configs(id) on delete cascade;
alter table invoice_tax add constraint fk_invoice_tax_config_id
        foreign key (config_id) references report_configs(id) on delete cascade;
alter table invoice_discount add constraint fk_invoice_discount_config_id
        foreign key (config_id) references report_configs(id) on delete cascade;


INSERT INTO `access_right` VALUES (20,'role.account_settings_manager'),
                                  (21,'role.leave_time_manager'),
                                  (22,'role.pto_manager'),
                                  (14,'system.manage_pto');

-- grant Manage PTO to all users with Mange Users
insert into user_access_right (user_id, access_right_id)
  select user_id, 14 from user_access_right where access_right_id = 5;

alter table `at_user`
        add `requires_approval` tinyint(1) NOT NULL DEFAULT 0,
        add `is_pto` tinyint(1) NOT NULL DEFAULT 0,
        add `def_pto_rules` tinyint(1) NOT NULL DEFAULT 1,
        add KEY `is_pto` (`is_pto`);

update at_user set is_pto=false, def_pto_rules=true, requires_approval=false;

alter table `leave_type`
        add is_pto tinyint(1) NOT NULL DEFAULT 0,
        add `pto_coeff` double(10,2) unsigned NOT NULL DEFAULT 1.00,
        add `requires_approval` tinyint(1) NOT NULL DEFAULT 1;

update leave_type set is_pto=false, pto_coeff=1.00, requires_approval=true;

CREATE TABLE user_approver (
  user_id int(3) unsigned NOT NULL,
  approver_id int(3) unsigned NOT NULL,
  PRIMARY KEY (user_id, approver_id),
  CONSTRAINT fk_user_approver_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT fk_user_approver_approver_id FOREIGN KEY (approver_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `user_leave_time_request` (
  `id` int(3) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(3) unsigned NOT NULL,
  `leave_type_id` int(3) unsigned NOT NULL,
  `status` int(3) unsigned NOT NULL,
  `status_message` text,
  `status_timestamp` datetime NOT NULL,
  `approver_id` int(3) unsigned DEFAULT NULL,
  `first_date` date NOT NULL,
  `last_date` date NOT NULL,
  `first_date_duration` int(10) NOT NULL,
  `last_date_duration` int(10) NOT NULL,
  `duration` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  CONSTRAINT `fk_user_leave_time_request_user_id` FOREIGN KEY (`user_id`) REFERENCES `at_user` (`id`)
    ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `fk_user_leave_time_request_approver_id` FOREIGN KEY (`approver_id`) REFERENCES `at_user_revision` (`id`),
  CONSTRAINT `fk_user_leave_time_request_leave_type_id` FOREIGN KEY (`leave_type_id`) REFERENCES `leave_type` (`id`)
    ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE user_pto_rule (
  id int(5) unsigned NOT NULL AUTO_INCREMENT,
  user_id int(3) unsigned NOT NULL,
  type tinyint(1) unsigned NOT NULL,
  value double NOT NULL,
  frequency varchar(255) NOT NULL,
  frequency_params varchar(255) NOT NULL DEFAULT '',
  effective_start_date date NOT NULL,
  effective_finish_date date DEFAULT NULL,
  mgr_id int(3) unsigned DEFAULT NULL,
  mgr_comment text,
  PRIMARY KEY (id),
  CONSTRAINT user_pto_rule_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT user_pto_rule_mgr_id_at_user_id FOREIGN KEY (mgr_id) REFERENCES at_user_revision (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE user_pto_cap (
  id int(5) unsigned NOT NULL AUTO_INCREMENT,
  user_id int(3) unsigned NOT NULL,
  cap double NULL,
  effective_date date NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_user_pto_cap_effective_date UNIQUE(user_id, effective_date),
  CONSTRAINT user_pto_cap_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


INSERT INTO mail_template (name, template, last_modified_timestamp) VALUES
        ('shared_macro_ap.vm',       '## some email clients do not support embedded or external css, so we define several commonly used
## rules here as velocity variables to re-use them later for inline css
#macro( initStyles )
#set($css_h_width=''width: 150px'')
#set($css_link_color=''color: #003399 '')
#set($css_text=''font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; '')
#end
#macro ( personLine $request)
<span style="$css_h_width">Person: </span><span>$request.owner.fullNameWithoutUserNameEscaped</span><br>
#end
#macro ( leaveTypeLine $request)
<span style="$css_h_width">Leave Type: </span><span>$request.leaveTypeName</span><br>
#end
#macro ( datesLine $request)
<span style="$css_h_width">Date#if(!$request.oneDayRequest)s#end: </span><span>$request.getFirstDate("EEE, MMM d")#if(!$request.oneDayRequest) - $request.getLastDate("EEE, MMM d")#end</span><br>
#end
#macro ( timeRequestedLine $request $showUnaffectedPTOMessage)
<span style="$css_h_width">Time Requested: </span><span>$request.leaveTimeTotal h#if($request.showPTO) ($request.requestedPTODays PTO days) #elseif($showUnaffectedPTOMessage) (this request does not affect PTO balance)#end</span><br>
#end
#macro ( statusLine $request)
<span style="$css_h_width">Request Status: </span><span>$request.status</span><br>
#end
#macro ( printRequestInfo $request $showUnaffectedPTOMessage )
#personLine( $request )
#leaveTypeLine($request)
#datesLine( $request )
#timeRequestedLine( $request $showUnaffectedPTOMessage )
#end
#macro ( header $recipient )
#initStyles()<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''><span style="font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; font-size: 14px">
#greetByName( $recipient )
#end
#macro ( greetByName $recipient )
Dear $recipient.firstNameEscaped,<br><br>
#end
#macro ( showFooter $footer )
<br/>
<hr noshade size="1" style="background-color: #333333; color: #333333;" />
<pre style=''font-family: Arial Unicode MS, Arial, sans-serif; font-size: 12px;''>$footer</pre>
#end
#macro ( showYourActiPLANSFooterPlainText )
- - -
Your actiPLANS
#end
#macro ( andOtherProduct $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
and actiTIME #end
#end
#macro ( showOtherProductPasswordChangeNote $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
Please note, that the password will be changed for your actiTIME account too.
#end
#end
',        now()),
        ('request_mgmt_to_ltm.html', '#header( $recipient )
#if($action == "revoke")
$actor.fullNameWithoutUserNameEscaped revoked approval for the following leave time request:
#elseif($action == "approve")
$actor.fullNameWithoutUserNameEscaped approved the following leave time request:
#elseif($action == "reject")
$actor.fullNameWithoutUserNameEscaped rejected the following leave time request:
#elseif($action == "rollback")
$actor.fullNameWithoutUserNameEscaped rolled back rejection for the following leave time request:
#elseif($action == "create")
#if($request.approved)
$actor.fullNameWithoutUserNameEscaped created new leave time request that does not require approval.
#else
$actor.fullNameWithoutUserNameEscaped submitted new leave time request requiring your approval.
#end
#elseif($action == "edit")
#if($request.approved)
$actor.fullNameWithoutUserNameEscaped edited planned leave time.
#else
$actor.fullNameWithoutUserNameEscaped has edited leave time request waiting for your approval.
#end
<br>Request summary after editing:
#else
$actor.fullNameWithoutUserNameEscaped has deleted the following leave time request:
#end
<br><br>
#printRequestInfo( $request, false )
#if($action=="delete")
#statusLine( $request )
#end
<br>
#if($action=="approve")
#if($request.hasStatusMessage)
Approval Comments: $request.statusMessage
<br><br>
#end
#elseif($action=="reject")
#if($request.hasStatusMessage)
Reason: $request.statusMessage
<br><br>
#end
#end
#if( $action == "create" || $action == "edit" || $action == "rollback" )
#if($request.ownerPTOAffected)
$request.owner.firstName''s PTO Balance as of $request.getFirstDate("MMM d") (before request): $request.ownerBalanceBeforeRequest d<br>
$request.owner.firstName''s PTO Balance as of $request.getLastDate("MMM d") (after request): $request.ownerBalanceAfterRequest d
#else
This request does not affect $request.owner.firstName''s PTO balance.
#end
<br><br>
#end
<a href="$linkGenerator.leaveTimePlanningLink" style="$css_link_color;">View leave time chart</a><br>
<a href="$linkGenerator.leaveTimeRequestsLink" style="$css_link_color;">View leave time requests</a><br>
<br>
#if(!($!footer == ""))
#showFooter($footer)
#end',  now()),
        ('request_mgmt_to_user.html','#header( $recipient )
#if($action == "revoke")
$actor.fullNameWithoutUserNameEscaped revoked approval for your leave time request.
#elseif($action == "approve")
$actor.fullNameWithoutUserNameEscaped approved your leave time request.
#elseif($action == "reject")
$actor.fullNameWithoutUserNameEscaped rejected your leave time request.
#elseif($action == "rollback")
$actor.fullNameWithoutUserNameEscaped rolled back rejection for your leave time request.
#elseif($action == "create")
#if($request.approved)
$actor.fullNameWithoutUserNameEscaped planned the following leave time for you:
#else
$actor.fullNameWithoutUserNameEscaped submitted the following leave time request for you:
#end
#elseif($action == "edit")
#if($request.approved)
$actor.fullNameWithoutUserNameEscaped edited planned leave time for you.
#else
$actor.fullNameWithoutUserNameEscaped edited leave time request for you.
#end
<br>Request summary after editing:
#else
$actor.fullNameWithoutUserNameEscaped deleted your leave time request:
#end
<br><br>
#leaveTypeLine($request)
#datesLine( $request )
#timeRequestedLine( $request false )
#if($action=="delete")
#statusLine( $request )
#end
<br>
#if($action=="approve")
#if($request.hasStatusMessage)
Approval Comments: $request.statusMessage
<br><br>
#end
#elseif($action=="reject")
#if($request.hasStatusMessage)
Reason: $request.statusMessage
<br><br>
#end
#elseif( $action == "create" || $action == "edit" )
#if($request.ownerPTOAffected)
Your PTO Balance as of $request.getFirstDate("MMM d") (before request): $request.ownerBalanceBeforeRequest d<br>
Your PTO Balance as of $request.getLastDate("MMM d") (after request): $request.ownerBalanceAfterRequest d
#else
This request does not affect your PTO balance.
#end
<br><br>
#end
<a href="$linkGenerator.myScheduleLink" style="$css_link_color;">View your leave time requests in actiPLANS</a><br>
<br>
#if(!($!footer == ""))
#showFooter($footer)
#end', now()),
        ('n_days_to_ltm.html',       '#header( $recipient )
There are leave time requests waiting for your approval.<br>
<br>
#foreach($request in $requests)
#printRequestInfo( $request, true )
<br>
#end
Please remember that not approved requests will be automatically rejected in 24 hours after their start.<br>
<br>
<a href="$linkGenerator.leaveTimePlanningLink" style="$css_link_color;">View leave time chart</a><br>
<a href="$linkGenerator.leaveTimeRequestsLink" style="$css_link_color;">View leave time requests</a><br>
<br>
#if(!($!footer == ""))
#showFooter($footer)
#end',        now()),
        ('ap_test_message.html',     '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
<table style=''width: 560px;$css_text font-size: 12px;'' cellspacing=''0''>
<tr>
<td valign=''middle''>#greetByName($recipient)
This is an automatic email message sent by actiPLANS to test email settings.
<br>Please verify that the following notification parameters are configured as you expected:
<ol>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Prefix to add to the notification subject field<br><br>
Use of a prefix for actiPLANS messages simplifies creation of
mail filtering rules in your email client.
$prefixNote
</li>
<li style=''margin-left: 0; padding-left: 0; margin-bottom: 20px;'' >
Standard message footer<br><br>
Standard message footer will be added to all notification messages (including this one).
$footerNote
</li>
</ol>
</td>
</tr>
#if(!($!footer == ""))
<tr>
<td>#showFooter($footer)</td>
</tr>
#end
</table>
</body>
</html>',      now());

insert into mail_template (name, template, last_modified_timestamp)
       values( 'ap_password_recovery_link.txt',
               concat( CHAR(10), 'Hello $recipient.firstName,',
               CHAR(10), CHAR(10), 'There was a request to reset password on your actiPLANS account.',
               CHAR(10), CHAR(10), 'If you requested this password change,', CHAR(10), 'please follow the link below to set a new password:',
               CHAR(10), CHAR(10), '$url$token',
               CHAR(10), '#showOtherProductPasswordChangeNote($bothPasswordsChangeNote)', CHAR(10), CHAR(10), 'If you didn''t request to reset your password,', CHAR(10), 'you can safely disregard this email.',
               CHAR(10), CHAR(10), '#showYourActiPLANSFooterPlainText()' ),
               now() );

insert into mail_template (name, template, last_modified_timestamp)
       values( 'ap_password_reset.txt',
               concat( CHAR(10), 'Hello $recipient.firstName,',
               CHAR(10), CHAR(10), 'Your actiPLANS #andOtherProduct($bothPasswordsChangeNote)password has been changed successfully.', CHAR(10), 'Your username is: $recipient.name',
               CHAR(10), CHAR(10), 'Keep on plannin''',
               CHAR(10), CHAR(10), '#showYourActiPLANSFooterPlainText()' ),
               now() );

CREATE TABLE user_cur_pto_balance (
  user_id int(3) unsigned NOT NULL,
  balance double NOT NULL,
  expiry datetime NOT NULL,
  PRIMARY KEY (user_id),
  CONSTRAINT user_cur_pto_balance_at_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

ALTER TABLE user_cur_pto_balance ADD INDEX user_cur_pto_balance_user_id_expiry (user_id, expiry);


create table default_workday_duration_history (
  duration int unsigned not null,
  effective_date date not null primary key
) engine=InnoDB default charset=utf8 collate=utf8_unicode_ci;

insert into default_workday_duration_history (duration, effective_date) values (
  (select property_value from system_settings where property_name = "workday_duration"),
  '1970-01-01'
);

delete from system_settings where property_name = "workday_duration";

alter table user_date_leave modify column leave_duration int not null;
alter table leave_type drop column whole_day_text;

-- update revisions of all leaves except deleted
set @rev=(select max(revision) from user_date_leave_revision);
update user_date_leave_revision as udlr inner join user_date_leave as udl on udlr.user_id = udl.user_id and udlr.leave_date = udl.leave_date set udlr.revision = (@rev:=@rev+1);

alter table leave_type drop column is_planned;


create table deleted_user (
  id          int unsigned not null primary key,
  username    varchar(255) not null,
  first_name  varchar(32)  not null,
  middle_name varchar(32)  default null,
  last_name   varchar(32)  not null,
  constraint fk_deleted_user_id foreign key (id) references at_user_revision(id)
) engine=InnoDB default charset=utf8 collate=utf8_unicode_ci;

alter table tt_lock drop foreign key tt_lock_who_locked_id;
alter table tt_lock add constraint tt_lock_who_locked_id foreign key (who_locked_id) references at_user_revision (id);


create table user_context_name (
  user_id int unsigned not null,
  at_context_name varchar(100) default null,
  ap_context_name varchar(100) default null,
  PRIMARY KEY (user_id),
  constraint user_context_name_at_user_id foreign key (user_id) references at_user(id) ON DELETE CASCADE ON UPDATE CASCADE
) engine=InnoDB default charset=utf8 collate=utf8_unicode_ci;


-- update param name and param value of leave types selection in Leave Report
update report_params set param_name = 'leaveTypesOption' where param_name = 'allLeaveTypes';
update report_params set param_value = 'all' where param_name = 'leaveTypesOption' and param_value = 'true';
update report_params set param_value = 'specific' where param_name = 'leaveTypesOption' and param_value = 'false';

alter table overtime drop foreign key overtime_ibfk_1;
alter table overtime add constraint overtime_ibfk_1 foreign key (user_id) references at_user(id) ON DELETE CASCADE ON UPDATE CASCADE;

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
  values (22, 0, now());

commit;