update mail_template
  set template = '## some email clients do not support embedded or external css, so we define several commonly used
## rules here as velocity variables to re-use them later for inline css
#macro( initStyles )
#set($css_h_width=''width: 150px'')
#set($css_link_color=''color: #003399 '')
#set($css_text=''font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; '')
#set($css_hidden_mark=''display: none;'')
#end
#macro ( personLine $request)
<span style="$css_h_width">Person: </span><span>$request.owner.fullNameWithoutUserNameEscaped</span><br>
#end
#macro ( leaveTypeLine $request)
<span style="$css_h_width">Leave Type: </span><span>$request.leaveTypeName</span><br>
#end
#macro ( datesLine $request)
<span style="$css_h_width">Date#if(!$request.oneDayRequest)s#end: </span><span>$request.getFirstDate("EEE, MMM d")#if(!$request.oneDayRequest) - $request.getLastDate("EEE, MMM d")#end</span><br>
#end
#macro ( timeRequestedLine $request $showUnaffectedPTOMessage)
<span style="$css_h_width">Time Requested: </span><span>$request.leaveTimeTotal h#if($request.showPTO) ($request.requestedPTODays PTO days) #elseif($showUnaffectedPTOMessage) (this request does not affect PTO balance)#end</span><br>
#end
#macro ( statusLine $request)
<span style="$css_h_width">Request Status: </span><span>$request.status</span><br>
#end
#macro ( printRequestInfo $request $showUnaffectedPTOMessage )
#personLine( $request )
#leaveTypeLine($request)
#datesLine( $request )
#timeRequestedLine( $request $showUnaffectedPTOMessage )
#end
#macro ( header $recipient )
#initStyles()<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''><span style="font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; font-size: 14px">
#placeForInfoAboutMessageToAdmin()
#greetByName( $recipient )
#end
#macro ( greetByName $recipient )
Dear $recipient.firstNameEscaped,<br><br>
#end
#macro ( placeForInfoAboutMessageToAdmin )
<span id=''infoForAdminMark'' style="$css_hidden_mark"></span>
#end
#macro ( showFooter $footer )
<br/>
<hr noshade size="1" style="background-color: #333333; color: #333333;" />
<pre style=''font-family: Arial Unicode MS, Arial, sans-serif; font-size: 12px;''>$footer</pre>
#end
#macro ( showYourActiPLANSFooterPlainText )
- - -
Your actiPLANS
#end
#macro ( andOtherProduct $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
and actiTIME #end
#end
#macro ( showOtherProductPasswordChangeNote $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
Please note, that the password will be changed for your actiTIME account too.
#end
#end
', last_modified_timestamp = now()
    where name = 'shared_macro_ap.vm';


update mail_template
  set template = '## some email clients do not support embedded or external css, so we define several commonly used
## rules here as velocity variables to re-use them later for inline css
#macro( initStyles )
#set($css_details_font_size=''font-size: 13px; '')
#set($css_report_link_font_size=''font-size: 13px; '')
#set($css_details_header_color=''color: #595959; '')
#set($css_light_border=''1px solid #e9e9e9 '')
#set($css_dark_border=''1px solid #d9d9d9 '')
#set($css_outer_border=''1px solid #cccccc '')
#set($css_darkest_border=''1px solid #999999 '')
#set($css_range_total_border=''1px solid #8799af '')
#set($css_link_color=''color: #003399 '')
#set($css_light_border_left=''border-left: '' + $css_light_border + ''; '')
#set($css_light_border_right=''border-right: '' + $css_light_border + ''; '')
#set($css_outer_border_left=''border-left: '' + $css_outer_border + ''; '')
#set($css_outer_border_right=''border-right: '' + $css_outer_border + ''; '')
#set($css_outer_border_bottom=''border-bottom: '' + $css_outer_border + ''; '')
#set($css_outer_border_top=''border-top: '' + $css_outer_border + ''; '')
#set($css_dark_border_left=''border-left: '' + $css_dark_border + ''; '')
#set($css_dark_border_right=''border-right: '' + $css_dark_border + ''; '')
#set($css_dark_border_top=''border-top: '' + $css_dark_border + ''; '')
#set($css_darkest_border_bottom=''border-bottom: '' + $css_darkest_border + ''; '')
#set($css_cp_border_bottom=''border-bottom: '' + $css_dark_border + ''; '')
#set($css_range_total_border_bottom=''border-bottom: '' + $css_range_total_border + ''; '')
#set($css_range_total_border_top=''border-top: '' + $css_range_total_border + ''; '')
#set($css_bg_header=''background-color: #366A98; '')
#set($css_bg_total=''background-color: #f8f4e9; '')
#set($css_bg_total_middle=''background-color: #f1eee5; '')
#set($css_bg_range_total=''background-color: #eef2f7; '')
#set($css_bg_range_total_middle=''background-color: #e9edf1; '')
#set($css_even_row_border_top=''border-top: 1px solid #f0eee7; '')
#set($css_even_row_border_bottom=''border-bottom: 1px solid #f0eee7; '')
#set($css_text=''font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; '')
#set($css_header_text=$css_text + '' color: white; font-size: 14px; '')
#set($css_total_text=$css_text + '' color: #665946; '')
#set($textValueColor=''#366A98'')
#set($css_parameters_text=$css_text + '' font-size: 14px; '')
#set($css_parameters_name_text=$css_parameters_text + '' color: '' + $textValueColor + '';'')
#set($css_table_title_text=$css_text + '' color: #6A573B; font-size: 14px; font-weight: bold; '')
#set($missedColor=''#C00000'')
#set($css_hidden_mark=''display: none;'')
#end
#macro ( placeForInfoAboutMessageToAdmin )
<span id=''infoForAdminMark'' style="$css_hidden_mark"></span>
#end
#macro( drawHeader )
<thead>
<tr>
<th valign=''middle'' style=''
text-align: left;
padding: 10px 8px 10px 15px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_left''>
<span style=''font-size: 14px; margin-bottom: 7px; margin-top: 10px''><b>$hls.Customer() / $hls.Project()</b></span><br>
<span style=''font-size: 12px;''>$hls.TasksAMPSubtasks()</span>
</th>
<th valign=''middle'' style=''
text-align: center;
padding: 10px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_right
$css_light_border_left''><b>Spent</b></th>
<th valign=''middle'' style=''
text-align: left;
padding: 17px 8px 17px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_right''><b><span>Comments</span></b></th>
</tr>
</thead>
#end
#macro( drawDayTT $day)
#set( $oddRow = true )
#set( $drawCPEntryTopBorder = false )
#if( $day.leaveTime > 0)
<tr>
<td valign=''bottom'' style=''
text-align: left;
background-color: #FCF8EF;
$css_details_header_color
padding: 20px 8px 8px 15px;
$css_text
$css_outer_border_left
border-bottom: 1px dashed #AFAFAF ;
''><b><span style=''font-size: 14px;''>$day.leaveName</span></b></td>
<td valign=''bottom'' style=''
text-align: right;
font-size: 14px;
padding: 20px 15px 8px 8px;
background-color: #F5F1EA;
$css_text
border-bottom: 1px dashed #BFBFBF ;
$css_light_border_right
$css_light_border_left
''><b>$day.formattedLeaveTime</b></td>
<td style=''
background-color: #FCF8EF;
padding: 20px 8px 8px 15px;
$css_outer_border_right
border-bottom: 1px dashed #AFAFAF ;
''>&nbsp;</td>
</tr>
#end
#foreach( $cpEntry in $day.rows.entrySet() )
<tr>
<td valign=''bottom'' style=''
text-align: left;
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_text
$css_outer_border_left
$css_cp_border_bottom
#if($drawCPEntryTopBorder) $css_dark_border_top #end''>
<b><span style=''font-size: 14px; $css_details_header_color''>$cpEntry.key.customerName /</span>
<span style=''$css_parameters_name_text font-weight: bold; ''>$cpEntry.key.projectName</span></b>
</td>
<td valign=''bottom'' style=''
text-align: right;
font-size: 14px;
padding: 20px 15px 8px 8px;
background-color: #ededed;
$css_text
$css_cp_border_bottom
$css_light_border_right
$css_light_border_left
#if($drawCPEntryTopBorder) $css_dark_border_top #end''>
<b>$day.getFormattedSubTotal($cpEntry.key)</b></td>
<td style=''
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_outer_border_right
$css_cp_border_bottom
#if($drawCPEntryTopBorder) $css_dark_border_top #end''>&nbsp;</td>
</tr>
#set( $drawCPEntryTopBorder = true )
#set ( $rowNumber = 0 )
#foreach( $ttRow in $cpEntry.value )
#set ( $drawEvenBorderTop = ($rowNumber != 0) )
#set ( $drawEvenBorderBottom = ($rowNumber < ($cpEntry.value.size() - 1)) )
#if( $oddRow )
<tr>
<td valign=''middle'' style=''
text-align: left;
padding: 8px 8px 8px 35px;
font-size: 13px;
background-color: #ffffff;
$css_text
$css_outer_border_left''>$ttRow.taskName</td>
<td valign=''middle'' style=''
text-align: right;
font-size: 13px;
background-color: #f7f7f7;
padding: 8px 15px 8px 8px;
$css_text
$css_light_border_right
$css_light_border_left''>$ttRow.formattedSpent</td>
<td valign=''middle'' style=''
text-align: left;
font-size: 13px;
background-color: #ffffff;
padding: 8px 8px 8px 18px;
$css_text
$css_outer_border_right''>$ttRow.comments</td>
</tr>
#else
<tr>
<td valign=''middle'' style=''
text-align: left;
padding: 8px 8px 8px 35px;
font-size: 13px;
background-color: #fcfaf3;
$css_text
$css_outer_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
''>$ttRow.taskName</td>
<td valign=''middle'' style=''
text-align: right;
font-size: 13px;
background-color: #f5f3ed;
padding: 8px 15px 8px 8px;
$css_text
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
$css_light_border_right
$css_light_border_left
''>$ttRow.formattedSpent</td>
<td valign=''middle'' style=''
text-align: left;
font-size: 13px;
background-color: #fcfaf3;
$css_text
padding: 8px 8px 8px 18px;
$css_outer_border_right
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
''>$ttRow.comments</td>
</tr>
#end
#set( $oddRow = !$oddRow )
#set( $rowNumber = ( $rowNumber + 1 ) )
#end
#end
#end
#macro( drawDayTotal $day $displaySettings $drawTopBorder)
<tr>
<td valign=''middle'' style=''text-align: right;
font-size: 15px;
padding: 10px 8px 6px 18px;
$css_total_text
$css_bg_total
$css_outer_border_left
#if($drawTopBorder) $css_outer_border_top #end
#if(!$displaySettings.showCalculatedOvertime) $css_outer_border_bottom #end''>
<b>Total:</b></td>
<td valign=''middle'' style=''
text-align: right;
font-size: 15px;
$css_text
padding: 10px 15px 6px 8px;
$css_bg_total_middle
$css_light_border_left
$css_light_border_right
#if($drawTopBorder) $css_outer_border_top #end
#if(!$displaySettings.showCalculatedOvertime) $css_outer_border_bottom #end''>
<b>$day.total.formattedTotal</b></td>
<td valign=''middle'' style=''text-align: left;
font-size: 13px;
padding: 10px 18px 6px 18px;
$css_text
$css_bg_total
$css_outer_border_right
#if($drawTopBorder) $css_outer_border_top #end
#if(!$displaySettings.showCalculatedOvertime) $css_outer_border_bottom #end''>
<table border=''0'' cellpadding=''0'' cellspacing=''0''>
<tr>
<td width=''80'' style=''
text-align: left;
font-size: 13px;
$css_total_text
$css_bg_total''>
<span style=''white-space: nowrap;''>Working&nbsp;Time:</span></td>
<td width=''40'' style=''
text-align: right;
font-size: 13px;
padding-left: 5px;
$css_text
$css_bg_total''>$day.total.formattedWorking</td>
#if($displaySettings.showLeaveTime)
<td style=''
padding-left: 25px;
text-align: left;
font-size: 13px;
$css_total_text
$css_bg_total''>
#if( $day.total.leaveName )${day.total.leaveName}#{else}Leave&nbsp;Time#end:</td>
<td width=''40'' style=''
text-align: right;
font-size: 13px;
padding-left: 5px;
$css_text
$css_bg_total''>$day.total.formattedLeave</td>
#end
<td> </td>
</tr>
</table>
</td>
</tr>
#if($displaySettings.showReportedOvertime)
<tr>
<td valign=''top'' style=''
text-align: right;
font-size: 14px;
padding: 0 8px 6px 15px;
$css_total_text
$css_bg_total
$css_outer_border_left''>
<span style=''white-space: nowrap;''>Reported&nbsp;Overtime #if($displaySettings.undertimeTracking)&nbsp;/&nbsp;Undertime #end:</span></td>
<td valign=''top'' style=''
text-align: right;
font-size: 14px;
padding: 0 15px 8px 8px;
$css_text
$css_bg_total_middle
$css_light_border_left
$css_light_border_right''>$day.total.formattedReportedOvertime</td>
<td valign=''top'' style=''
text-align: left;
font-size: 14px;
$css_text
$css_bg_total
$css_outer_border_right''>&nbsp;</td>
</tr>
#end
#if($displaySettings.showCalculatedOvertime)
<tr>
<td valign=''top'' style=''
text-align: right;
font-size: 14px;
padding: 0 8px 14px 15px;
$css_total_text
$css_bg_total
$css_outer_border_left
$css_outer_border_bottom''><span style=''white-space: nowrap;''>Auto-calculated&nbsp;Overtime#if($displaySettings.undertimeTracking)&nbsp;/&nbsp;Undertime #end:</span></td>
<td valign=''top'' style=''
text-align: right;
font-size: 14px;
padding: 0 15px 8px 8px;
$css_text
$css_bg_total_middle
$css_light_border_left
$css_light_border_right
$css_outer_border_bottom''>$day.total.formattedCalculatedOvertime</td>
<td valign=''top'' style=''
text-align: left;
font-size: 14px;
$css_text
$css_bg_total
$css_outer_border_right
$css_outer_border_bottom''>&nbsp;</td>
</tr>
#end
#end
#macro ( drawCustomerProjectsTable $customerProjects )
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''width: 100%; border-collapse:collapse;''>
<thead>
<tr>
<th valign=''middle''
style=''
text-align: left;
padding: 10px 8px 10px 15px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_left''>
<b>$hls.Customer() / $hls.Projects()</b>
</th>
</tr>
</thead>
<tbody>
#set($drawTopCPBorder = false)
#set($customerNumber = 0)
#set( $oddRow = true )
#foreach( $customer in $customerProjects.keySet())
#set( $rowNumber = 0 )
#set( $projectsNumber = $customerProjects.get($customer).size() )
<tr>
<td style=''text-align: left;
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_details_header_color
$css_details_font_size
$css_text
$css_outer_border_left
$css_outer_border_right
$css_cp_border_bottom
font-weight: normal;
#if($drawTopCPBorder) $css_dark_border_top #else $css_outer_border_top #end''>
<b>$escapeUtil.getNameEscaped($customer)</b> ($projectsNumber #if ($projectsNumber > 1) $hls.projects() #else $hls.project() #end )
</td>
</tr>
#set($drawTopCPBorder = true)
#foreach( $project in $customerProjects.get($customer) )
#set( $drawEvenBorderTop = ($rowNumber != 0) )
#set( $drawEvenBorderBottom = ($rowNumber < ($projectsNumber - 1)) )
#set( $drawOuterBorderBottom = (($customerNumber == ($customerProjects.keySet().size() - 1)) && !$drawEvenBorderBottom) )
<tr>
#if($oddRow)
<td valign=''bottom''
style=''
text-align: left;
$css_details_font_size
background-color: #ffffff;
padding: 8px 8px 8px 35px;
$css_text
$css_outer_border_left
$css_outer_border_right
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''>
$escapeUtil.getNameEscaped($project)
</td>
#else
<td valign=''bottom''
style=''
text-align: left;
$css_details_font_size
background-color: #fcfaf3;
padding: 8px 8px 8px 35px;
$css_text
$css_outer_border_left
$css_outer_border_right
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''>
$escapeUtil.getNameEscaped($project)
</td>
#end
#set($oddRow = !$oddRow)
#set($rowNumber = ($rowNumber + 1))
</tr>
#end
#set($customerNumber = ($customerNumber + 1))
#end
</tbody>
</table>
#end
#macro ( greetByName $recipient )
Dear $recipient.firstNameEscaped,<br><br>
#end
#macro ( greetByNameBold $recipient )
Dear <b>$recipient.firstNameEscaped</b>,<br><br>
#end
#macro ( showFooter $footer )
<br/>
<hr noshade size="1" style="background-color: #333333; color: #333333;" />
<pre style=''font-family: Arial Unicode MS, Arial, sans-serif; font-size: 12px;''>$footer</pre>
#end
#macro ( showYourActiTIMEFooter )
&ndash;&ndash;&ndash;<br/>Your actiTIME
#end
#macro ( showYourActiTIMEFooterPlainText )
- - -
Your actiTIME
#end
#macro ( andOtherProduct $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
and actiPLANS #end
#end
#macro ( showOtherProductPasswordChangeNote $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
Please note, that the password will be changed for your actiPLANS account too.
#end
#end', last_modified_timestamp = now()
    where name = 'shared_macro_at.vm';

update mail_template
  set template = '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
#set($tasksCount = $taskCount)
#if($deadlineStatusKey) There#if($tasksCount > 1) are $tasksCount $hls.tasksSLASHsubtasks()#else is $tasksCount $hls.taskSLASHsubtask()#end with $messageUtil.message($deadlineStatusKey) deadline.<br><br>#end
#set($shouldDrawSeparator = false)
#foreach( $bean in $ruleBeans)
#foreach ( $dateRange in $bean.projectTasksMap.keySet() )
#if($shouldDrawSeparator)
<div style='' font-size:1px; line-height:1px;''><div style=''margin:25px 0px 25px 0px; width:100%; font-size:1px; height: 1px; border-top: 1px solid #BFBFBF; line-height: 1px;''>&nbsp;</div></div>
#end
#set($shouldDrawSeparator = true)
<div style=''$css_table_title_text''>$bean.getFormattedRuleTitle($messageUtil, $dateRange, $textValueColor, $missedColor)</div><br>
<table style=''width:100%; border-collapse:collapse;''>
<thead>
<tr>
<th valign=''middle''
style=''
text-align: left;
padding: 10px 8px 10px 15px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_left''>
<b>$hls.Customer() / $hls.Project() / $hls.TasksAMPSubtasks()</b>
</th>
</tr>
</thead>
<tbody>
#set($drawTopCPBorder = false)
#set($projectNumber = 0)
#set( $oddRow = true )
#set( $projectTasks = $bean.projectTasksMap.get($dateRange) )
#foreach( $project in $projectTasks.keySet())
<tr>
<td style=''text-align: left;
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_text
$css_outer_border_left
$css_outer_border_right
$css_cp_border_bottom
#if($drawTopCPBorder) $css_dark_border_top #else $css_outer_border_top #end''>
<b style=''font-size:14px; $css_details_header_color''>$escapeUtil.getNameEscaped($project.customer)</b> / <span style=''$css_parameters_name_text font-weight: bold;''> $escapeUtil.getNameEscaped($project) </span>
</td>
</tr>
#set($drawTopCPBorder = true)
#set( $rowNumber = 0)
#foreach( $task in $projectTasks.get($project))
<tr>
#set ( $drawOuterBorderBottom = ($projectNumber == ($projectTasks.keySet().size() - 1) && $rowNumber == ($projectTasks.get($project).size() - 1)) )
#if($oddRow)
#set ($bgColorFirst = ''#ffffff'')
#set ($bgColorSecond = ''#f7f7f7'')
#set ( $drawEvenBorderTop = false )
#set ( $drawEvenBorderBottom = false )
#else
#set ($bgColorFirst = ''#fcfaf3'')
#set ($bgColorSecond = ''#f5f3ed'')
#set ( $drawEvenBorderTop = ($rowNumber != 0) )
#set ( $drawEvenBorderBottom = ($rowNumber < ($projectTasks.get($project).size() - 1)) )
#end
<td valign=''middle''
style=''
text-align: left;
$css_details_font_size
background-color: $bgColorFirst;
padding: 8px 8px 8px 35px;
$css_text
$css_outer_border_left
$css_outer_border_right
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''>
<a href=''$bean.getLinkToTask($task)'' style=''$css_link_color''>$escapeUtil.getNameEscaped($task)</a>
</td>
#set($oddRow = !$oddRow)
#set($rowNumber = ($rowNumber + 1))
</tr>
#end
#set($projectNumber = ($projectNumber + 1))
#end
</tbody>
</table>
<br>
<a href=''$bean.getLinkReport($dateRange)'' style=''$css_link_color; $css_report_link_font_size''>View Estimated vs. Actual Time Report for the listed#if($projectTasks.keySet().size() > 1) $hls.projects()#else $hls.project()#end</a>
#end
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'deadline.html';

update mail_template
  set template = '#set($css_cp_border=''1px solid #d9d9d9 '')
#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
#set($shouldDrawSeparator = false)
#foreach( $rule in $rules)
#set( $bean = $ruleBeans.get($rule) )
#set( $numberOfTasks = $bean.numberOfTasks)
#if($shouldDrawSeparator)
<br>
<div style=''font-size:1px; line-height:1px;''><div style=''margin:5px 0px 5px 0px; width:100%; font-size:1px; height: 1px; border-top: 1px solid #BFBFBF; line-height: 1px;''>&nbsp;</div></div>
<br>
#end
#set($shouldDrawSeparator = true)
<div style=''$css_table_title_text''><b>Time reported for the following
<span style=''$css_parameters_name_text font-weight: bold;''>$numberOfTasks</span>#if($numberOfTasks>1) $hls.tasksSLASHsubtasks()#else $hls.taskSLASHsubtask()#end reached
<span style=''$css_parameters_name_text font-weight: bold;''>$rule.estimatePercents%</span> of estimate:</b></div><br>
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''width: 100%; border-collapse:collapse;''>
<thead>
<tr>
<th rowspan=''2'' valign=''middle''
style=''
text-align: left;
padding: 10px 8px 10px 15px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_left''>
<b>$hls.Customer() / $hls.Project() / $hls.TasksAMPSubtasks()</b>
</th>
<th colspan=''2'' valign=''middle''
style=''
text-align: center;
padding: 10px 8px 10px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>Spent on $bean.formattedRuleDateToShort</b></th>
<th rowspan=''2'' valign=''middle''
style=''
text-align: center;
padding: 0px 8px 0px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>Estimated<br>Hours</b></th>
<th colspan=''2'' valign=''middle''
style=''
text-align: center;
padding: 5px 8px 5px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_right
$css_light_border_left''>
<b>Variance on $bean.formattedRuleDateToShort</b><br>
<span style=''font-size: 12px;''>(Estimated Hours - Spent)</span>
</th>
</tr>
<tr>
<th valign=''middle''
style=''width:90px;
text-align: center;
padding: 5px 8px 5px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>mh</b>
</th>
<th valign=''middle''
style=''width:90px;
text-align: center;
padding: 5px 8px 5px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>%</b>
</th>
<th valign=''middle''
style=''width:90px;
text-align: center;
padding: 5px 8px 5px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>mh</b>
</th>
<th valign=''middle''
style=''width:90px;
text-align: center;
padding: 5px 8px 5px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_right
$css_light_border_left''>
<b>%</b>
</th>
</tr>
</thead>
<tbody>
#set($drawTopCPBorder = false)
#set($taskNumber = 0)
#set( $oddRow = true )
#foreach( $project in $bean.projectTasks.keySet())
<tr>
<td style=''text-align: left;
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_text
$css_outer_border_left
$css_cp_border_bottom
#if($drawTopCPBorder) $css_dark_border_top #end''>
<b style=''font-size:14px; $css_details_header_color''>$escapeUtil.getNameEscaped($project.customer)</b> / <span style=''$css_parameters_name_text font-weight: bold;''> $escapeUtil.getNameEscaped($project) </span>
</td>
<td colspan=''2'' style=''text-align: left;
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_text
$css_cp_border_bottom
#if($drawTopCPBorder) $css_dark_border_top #end''>
&nbsp;
</td>
<td style=''text-align: left;
background-color: #ededed;
padding: 20px 8px 8px 15px;
$css_text
$css_cp_border_bottom
$css_light_border_right
$css_light_border_left
#if($drawTopCPBorder) $css_dark_border_top #end'' >
&nbsp;
</td>
<td colspan=''2'' style=''text-align: left;
background-color: #f2f2f2;
padding: 20px 8px 8px 15px;
$css_text
$css_cp_border_bottom
$css_outer_border_right
#if($drawTopCPBorder) $css_dark_border_top #end''>
&nbsp;
</td>
</tr>
#set($drawTopCPBorder = true)
#set( $rowNumber = 0)
#foreach( $task in $bean.projectTasks.get($project))
<tr>
#set ( $drawOuterBorderBottom = ($taskNumber == ($numberOfTasks - 1)) )
#if($oddRow)
#set ($bgColorFirst = ''#ffffff'')
#set ($bgColorSecond = ''#f7f7f7'')
#set ( $drawEvenBorderTop = false )
#set ( $drawEvenBorderBottom = false )
#else
#set ($bgColorFirst = ''#fcfaf3'')
#set ($bgColorSecond = ''#f5f3ed'')
#set ( $drawEvenBorderTop = ($rowNumber != 0) )
#set ( $drawEvenBorderBottom = ($rowNumber < ($bean.projectTasks.get($project).size() - 1)) )
#end
<td valign=''middle''
style=''
text-align: left;
$css_details_font_size
background-color: $bgColorFirst;
padding: 8px 8px 8px 35px;
$css_text
$css_outer_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''>
<a href=''$task.link'' style=''$css_link_color''>$task.getFullNameEscaped()</a>
</td>
<td nowrap valign=''middle''
style=''
text-align: right;
$css_details_font_size
background-color: $bgColorFirst;
padding: 8px 25px 8px 8px;
$css_text
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''
><div>$task.formattedSpent</div></td>
<td nowrap valign=''middle''
style=''
text-align: right;
$css_details_font_size
background-color: $bgColorFirst;
padding: 8px;
$css_text
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''
><div style=''margin-right:16px;''>$task.ofEstimate%</div></td>
<td nowrap valign=''middle''
style=''text-align: right;
$css_details_font_size
padding: 8px;
background-color: $bgColorSecond;
$css_text
$css_light_border_right
$css_light_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''
><div style=''margin-right:16px;''>$task.formattedBudgetTime</div></td>
<td nowrap valign=''middle''
style=''
text-align: right;
$css_details_font_size
background-color: $bgColorFirst;
padding: 8px;
$css_text
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''
><div style=''margin-right:16px;''>$task.formattedVariance</div></td>
<td nowrap valign=''middle''
style=''
text-align: right;
$css_details_font_size
background-color: $bgColorFirst;
padding: 8px;
$css_text
$css_outer_border_right
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawOuterBorderBottom) $css_outer_border_bottom #end''
><div style=''margin-right:16px;''>$task.percentVariance%</div></td>
#set($oddRow = !$oddRow)
#set($rowNumber = ($rowNumber + 1))
#set($taskNumber = ($taskNumber + 1))
</tr>
#end
#end
</tbody>
</table>
<br>
<a href=''$bean.link'' style=''$css_link_color; $css_report_link_font_size''>View Estimated vs. Actual Time Report for the listed#if($bean.projectTasks.keySet().size() > 1) $hls.projects()#else $hls.project()#end</a>
<br>
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'estimate.html';

update mail_template
  set template = '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#set($grantedColor = ''#688037'')
#set($revokedColor = ''#772F28'')
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
#if(!$addedAssignments && !$removedAssignments)
#if($assignments)
You no longer have access to all $hls.projects() of all $hls.customers().<br><br>
#else
You have been granted access to all $hls.projects() of all $hls.customers().
#end
#else
#if($addedAssignments && !$addedAssignments.isEmpty())
<div>Your were <span style=''color: $grantedColor;''>granted access</span> to the following #if($addedAssignments.size() > 1) $hls.projects()#else $hls.project()#end:</div>
<div><ul style=''padding-top:5px; padding-bottom: 5px;''>
#foreach($project in $addedAssignments)
<li style=''padding-top:2px; padding-bottom:3px;padding-left:10px;''>
<span style=''color: $grantedColor;''>$escapeUtil.getNameEscaped($project)</span> ($escapeUtil.getNameEscaped($project.customer))
</li>
#end
</ul></div>
#end
#if($removedAssignments && !$removedAssignments.isEmpty())
<div>Your access to the following #if($removedAssignments.size() > 1) $hls.projects() #else $hls.project() #end has been <span style=''color: $revokedColor;''>restricted</span>:</div>
<div><ul style=''padding-top:5px; padding-bottom: 5px;''>
#foreach($project in $removedAssignments)
<li style=''padding-top:2px; padding-bottom:3px;padding-left:10px;''>
<span style=''color: $revokedColor;''>$escapeUtil.getNameEscaped($project)</span> ($escapeUtil.getNameEscaped($project.customer))
</li>
#end
</ul></div>
#end
#end
#if($assignments)
#if (!$assignments.isEmpty())
<div style=''$css_table_title_text;margin-bottom: 0; padding-bottom: 0;''>Your current $hls.project() assignments:</div><br>
#drawCustomerProjectsTable($assignments)
#else
Currently you do not have access to any $hls.projects().
#end
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'assignments.html';

update mail_template
  set template = '<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#set($css_cp_border=''1px solid #d9d9d9 '')
#initStyles()
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
There#if($usersWithUnsubmittedTTCount > 1) are users#else is a user#end whose time-track is incomplete.<br><br>
#set($shouldDrawSeparator = false)
#foreach( $rule in $rules)
#if($shouldDrawSeparator)
<div style='' font-size:1px; line-height:1px;''><div style=''margin:25px 0px 25px 0px; width:100%; font-size:1px; height: 1px; border-top: 1px solid #BFBFBF; line-height: 1px;''>&nbsp;</div></div>
#end
#set($shouldDrawSeparator = true)
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''border-collapse:collapse; text-align: left;''>
<tr>
<td style=''$css_parameters_name_text; padding-left: 0px; margin-left:0px;''>
<b style="white-space: nowrap;">Date#if(!($ruleBeans.get($rule).isOneDayDateRange())) Range#end:</b>
</td>
<td style=''$css_parameters_text padding-left: 25px;''>
<b style="white-space: nowrap; ">$ruleBeans.get($rule).formattedDateRange</b>
</td>
</tr>
<tr>
<td style=''$css_parameters_name_text; padding-left: 0px; margin-left:0px;''>
<b style="white-space: nowrap;">Expected Time-Track:</b>
</td>
<td style=''$css_parameters_text padding-left: 25px;''>
<b style="white-space: nowrap;">$rule.ttLimit.hours:00</b>
</td>
</tr>
</table>
<br>
<b><span style=''$css_table_title_text''>Time-Track Reported by User#if ($ruleBeans.get($rule).all.size() > 1)s#end:</span></b>
<br>
<br>
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''width: 100%; border-collapse:collapse;''>
<col/> <col width=''80''/> <col width=''80''/>
<thead>
<tr>
<th valign=''middle''
style=''
text-align: left;
padding: 0px 8px 0px 15px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_outer_border_left''>
<b>User</b></th>
<th valign=''middle''
style='' width: 80px;
text-align: center;
padding: 0px 8px 0px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_left''>
<b>Spent</b></th>
<th valign=''middle''
style='' width: 80px;
text-align: center;
padding: 10px 8px 10px 8px;
$css_bg_header
$css_header_text
$css_outer_border_top
$css_light_border_right
$css_light_border_left''>
<b>Missing<br>
Hours</b></th>
</tr>
</thead>
<tbody>
#set( $oddRow = true )
#set( $rowNumber = 0)
#foreach( $userInn in $ruleBeans.get($rule).all )
#set ( $drawEvenBorderTop = ($rowNumber != 0) )
#set ( $drawEvenBorderBottom = ($rowNumber < ($ruleBeans.get($rule).all.size() - 1)))
#set ( $drawBorderBottom = ($rowNumber == ($ruleBeans.get($rule).all.size() - 1)))
#if($oddRow)
<tr>
<td valign=''middle''
style=''
text-align: left;
font-size: 13px;
background-color: #ffffff;
padding: 8px 8px 8px 15px;
$css_text
$css_outer_border_left
#if($drawBorderBottom) $css_outer_border_bottom #end
''>
$userInn.user.formattedNameEscaped
</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #ffffff;
$css_text
$css_dark_border_left
#if($drawBorderBottom) $css_outer_border_bottom #end''>
$userInn.formattedActuals</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #ffffff;
$css_text
$css_outer_border_right
$css_dark_border_left
#if($drawBorderBottom) $css_outer_border_bottom #end''>
<span style=''color:red;''>$userInn.formattedMissed</span></td>
</tr>
#else
<tr>
<td valign=''middle''
style=''
text-align: left;
font-size: 13px;
background-color: #fcfaf3;
padding: 8px 8px 8px 15px;
$css_text
$css_outer_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawBorderBottom) $css_outer_border_bottom #end
''>
$userInn.user.formattedNameEscaped
</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #fcfaf3;
$css_text
$css_dark_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawBorderBottom) $css_outer_border_bottom #end
''>
$userInn.formattedActuals</td>
<td valign=''middle''
style=''text-align: right;
font-size: 13px;
padding: 8px 15px 8px 8px;
background-color: #fcfaf3;
$css_text
$css_outer_border_right
$css_dark_border_left
#if($drawEvenBorderTop) $css_even_row_border_top #end
#if($drawEvenBorderBottom) $css_even_row_border_bottom #end
#if($drawBorderBottom) $css_outer_border_bottom #end''>
<span style=''color:red;''>$userInn.formattedMissed</span></td>
</tr>
#end
#set($oddRow = !$oddRow)
#set($rowNumber = ($rowNumber + 1))
#end
</tbody>
</table>
<br>
<a href=''$ruleBeans.get($rule).link'' style=''$css_link_color; $css_report_link_font_size''>View detailed time-track data in the Staff Performance Report</a>
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'unsubmitted_tt.html';

update mail_template
  set template = '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
#set($shouldDrawSeparator = false)
#foreach( $rangeBean in $rangeBeans)
#if($shouldDrawSeparator)
<div style='' font-size:1px; line-height:1px;''><div style=''margin:25px 0px 25px 0px; width:100%; font-size:1px; height: 1px; border-top: 1px solid #BFBFBF; line-height: 1px;''>&nbsp;</div></div>
#end
#set($shouldDrawSeparator = true)
$rangeBean.getRangeStatus($messageUtil, $textValueColor)<br>
<ul style=''padding-top:5px; padding-bottom: 5px;''>
#foreach( $user in $rangeBean.usersExceededPersonalEarnings )
<li style=''padding-top:2px; padding-bottom:3px;padding-left:9px;''>
$user.formattedNameEscaped
</li>
#end
</ul>
<a href=''$rangeBean.link'' style=''$css_link_color; $css_report_link_font_size''>View Cost Report for the listed user#if($rangeBean.hasMultipleUsers())s#end</a>
<br>
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'personal_earnings.html';

update mail_template
  set template = '<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#set($css_cp_border=''1px solid #d9d9d9 '')
#initStyles( )
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
You have not recorded sufficient time for #if($displaySettings.showDateRangePrefix)date range<br>#end $displaySettings.formattedDateRange.<br> <br>
<table cellpadding=''0'' cellspacing=''0'' border=''0'' style=''border-collapse: collapse;font-weight: bold; $css_parameters_text''>
<tr><td><b>Expected time-track:</b></td> <td style=''padding-left: 35px;''><b>$rule.ttLimit.hours:00</b></td></tr><tr><td><b>Recorded time-track:</b></td><td style=''color:red;padding-left: 35px;''><b>$total.formattedTotal</b></td></tr>
</table>
<br>
Please make sure that you entered all working and leave time for the specified date range.<br><br>
<table cellpadding=''0'' cellspacing=''0'' border=''0''
style=''font-size: 11px;
width: 100%;
border-collapse: collapse;
''>
<col/>
<col width=''60''/>
<col/>
#drawHeader( )
<tbody>
#foreach( $day in $days )
#set( $drawTotalTopBorder = ($day.rows.size() != 0) )
<tr>
<td colspan=''2'' valign=''bottom''
style=''
$css_text
$css_outer_border_left
$css_darkest_border_bottom
font-size: 18px;
padding: 30px 8px 10px 15px;
text-align: left; ''>
$day.formattedDay
</td>
<td valign=''bottom''
style=''
font-size: 13px;
text-align: right;
padding: 30px 15px 10px;
$css_text
$css_outer_border_right
$css_darkest_border_bottom
''>
<a href=''${displaySettings.getEditTTLink($day.day)}'' style=''$css_link_color''>Edit time-track</a>
</td>
</tr>
#drawDayTT( $day )
#drawDayTotal( $day $displaySettings $drawTotalTopBorder )
#end
<tr>
<td colspan=''3''><span style=''font-size: 12px; line-height:18px;''>&nbsp;<br></span></td>
</tr>
<tr>
<td valign=''middle''
style=''
text-align: right;
font-size: 15px;
padding: 12px 8px 6px 18px;
$css_text
$css_bg_range_total
$css_dark_border_left
$css_range_total_border_top
#if(!$displaySettings.showCalculatedOvertime) $css_range_total_border_bottom #end''>
<b>Total&nbsp;for&nbsp;the&nbsp;date&nbsp;range:</b></td>
<td valign=''middle''
style=''
text-align: right;
font-size: 15px;
$css_text
padding: 12px 15px 6px 8px;
$css_bg_range_total_middle
$css_light_border_left
$css_light_border_right
$css_range_total_border_top
#if(!$displaySettings.showCalculatedOvertime) $css_range_total_border_bottom #end''>
<b>$total.formattedTotal</b></td>
<td valign=''middle''
style=''
text-align: left;
font-size: 13px;
padding: 12px 8px 6px 18px;
$css_text
$css_bg_range_total
$css_dark_border_right
$css_range_total_border_top
#if(!$displaySettings.showCalculatedOvertime) $css_range_total_border_bottom #end''>
<table border=''0'' cellpadding=''0'' cellspacing=''0''>
<tr>
<td width=''80''
style=''
text-align: left;
font-size: 13px;
$css_text
$css_bg_range_total''>
Working&nbsp;Time:</td>
<td width=''40''
style=''
text-align: right;
font-size: 13px;
padding-left: 5px;
$css_text
$css_bg_range_total''>
$total.formattedWorking
</td>
#if($displaySettings.showLeaveTime)
<td style=''
padding-left: 25px;
text-align: left;
font-size: 13px;
$css_text
$css_bg_range_total''>
Leave&nbsp;Time:</td>
<td width=''40''
style=''
text-align: right;
font-size: 13px;
padding-left: 5px;
$css_text
$css_bg_range_total''>
$total.formattedLeave
</td>
#end
<td></td>
</tr>
</table>
</td>
</tr>
#if($displaySettings.showReportedOvertime)
<tr>
<td valign=''top''
style=''
text-align: right;
font-size: 14px;
padding: 0 8px 8px 15px;
$css_text
$css_bg_range_total
$css_dark_border_left''>
<span style=''white-space: nowrap;''>Reported&nbsp;Overtime&nbsp;#if($displaySettings.undertimeTracking)/&nbsp;Undertime#end:</span>
</td>
<td valign=''top''
style='' text-align: right;
font-size: 14px;
padding: 0 15px 8px 8px;
$css_text
$css_bg_range_total_middle
$css_light_border_left
$css_light_border_right''>
$total.formattedReportedOvertime
</td>
<td valign=''top''
style='' text-align: left;
font-size: 14px;
$css_text
$css_bg_range_total
$css_dark_border_right''>
&nbsp;</td>
</tr>
#end #if($displaySettings.showCalculatedOvertime)
<tr>
<td valign=''top''
style='' text-align: right;
font-size: 14px;
padding: 0 8px 16px 15px;
$css_text
$css_bg_range_total
$css_dark_border_left
$css_range_total_border_bottom''>
<span style=''white-space: nowrap;''>Auto-calculated&nbsp;Overtime#if($displaySettings.undertimeTracking)&nbsp;/&nbsp;Undertime#end:</span>
</td>
<td valign=''top''
style='' text-align: right;
font-size: 14px;
padding: 0 15px 8px 8px;
$css_text
$css_bg_range_total_middle
$css_light_border_left
$css_light_border_right
$css_range_total_border_bottom''>
$total.formattedCalculatedOvertime
</td>
<td valign=''top''
style=''text-align: left;
font-size: 14px;
$css_text
$css_bg_range_total
$css_dark_border_right
$css_range_total_border_bottom''>
&nbsp;</td>
</tr>
#end
</tbody>
</table>
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'personal_tt.html';

update mail_template
  set template = '#initStyles()
<html>
<body>
<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''>
#placeForInfoAboutMessageToAdmin()
<table style=''width: 95%;$css_text font-size: 12px;''>
<tr>
<td style=''$css_text font-size: 14px; line-height:130%; background-color: #ffffff''>
#greetByNameBold($recipient)
#set($shouldDrawSeparator = false)
#foreach( $rangeBean in $rangeBeans)
#if($shouldDrawSeparator)
<div style='' font-size:1px; line-height:1px;''><div style=''margin:25px 0px 25px 0px; width:100%; font-size:1px; height: 1px; border-top: 1px solid #BFBFBF; line-height: 1px;''>&nbsp;</div></div>
#end
#set($shouldDrawSeparator = true)
<div style=''$css_table_title_text;padding-bottom:0; margin-bottom:0;''>$rangeBean.getRangeStatus($messageUtil, $textValueColor)</div><br>
#drawCustomerProjectsTable( $rangeBean.customerProjects )
<br>
<a href=''$rangeBean.link'' style=''$css_link_color; $css_report_link_font_size''>View Cost Report for the listed#if($rangeBean.getProjectsCount() > 1) $hls.projects()#else $hls.project()#end</a>
#end
</td>
</tr>
<tr>
<td>#showFooter($footer)</td>
</tr>
</table>
</body>
</html>', last_modified_timestamp = now()
    where name = 'project_budget.html';

update mail_template
  set template = concat( CHAR(10), 'Hello $recipient.firstName,',
                         CHAR(10), CHAR(10), 'There was a request to reset password on your actiTIME account.',
                         CHAR(10), CHAR(10), 'If you requested this password change,', CHAR(10), 'please follow the link below to set a new password:',
                         CHAR(10), CHAR(10), '$url$token',
                         CHAR(10), '#showOtherProductPasswordChangeNote($bothPasswordsChangeNote)', CHAR(10), CHAR(10), 'If you didn''t request to reset your password,', CHAR(10), 'you can safely disregard this email.',
                         CHAR(10), CHAR(10), '#showYourActiTIMEFooterPlainText()' ), last_modified_timestamp = now()
    where name = 'password_recovery_link.txt';

update mail_template
  set template = concat( CHAR(10), 'Hello $recipient.firstName,',
                         CHAR(10), CHAR(10), 'Your actiTIME #andOtherProduct($bothPasswordsChangeNote)password has been changed successfully.', CHAR(10), 'Your username is: $recipient.name',
                         CHAR(10), CHAR(10), 'Keep on trackin''',
                         CHAR(10), CHAR(10), '#showYourActiTIMEFooterPlainText()' ), last_modified_timestamp = now()
    where name = 'password_reset.txt';


alter table leave_type drop foreign key fk_icon_id;
create index k_icon_id ON leave_type (icon_id);
drop table leave_type_icon;


alter table at_user_revision modify revision bigint unsigned not null;
alter table customer_revision modify revision bigint unsigned not null;
alter table project_revision modify revision bigint unsigned not null;
alter table task_revision modify revision bigint unsigned not null;
alter table billing_type_revision modify revision bigint unsigned not null;
alter table leave_type_revision modify revision bigint unsigned not null;
alter table user_project_revision modify revision bigint unsigned not null;
alter table tt_revision modify revision bigint unsigned not null;
alter table user_date_leave_revision modify revision bigint unsigned not null;
alter table w_days_revision modify revision bigint unsigned not null;
alter table system_settings_revision modify revision bigint unsigned not null;


create table revision_seq ( val int(10) unsigned not null auto_increment, primary key(val) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
insert into revision_seq
  select coalesce(max( revision ), 1) from (
    select max(revision) as revision from at_user_revision union
    select max(revision) as revision from billing_type_revision union
    select max(revision) as revision from customer_revision union
    select max(revision) as revision from leave_type_revision union
    select max(revision) as revision from project_revision union
    select max(revision) as revision from system_settings_revision union
    select max(revision) as revision from task_revision union
    select max(revision) as revision from tt_revision union
    select max(revision) as revision from user_date_leave_revision union
    select max(revision) as revision from user_project_revision union
    select max(revision) as revision from w_days_revision
  ) as r;

delimiter //

create function next_revision() returns int
sql security invoker
begin
 insert into revision_seq values();
 return last_insert_id();
end
//

delimiter ;

-- these indexes help in last_tt_date calculations
alter table tt_record add index tt_record_task_id_record_date_idx (task_id, record_date);
alter table user_task_comment add index user_task_comment_task_id_comment_date_idx (task_id, comment_date);

-- this index helps in reports
alter table tt_record add index tt_record_user_id_record_date_idx (user_id, record_date);

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
  values (23, 0, now());

commit;