alter table user_leave_time_request
    add comment text;

update mail_template
  set template = '## some email clients do not support embedded or external css, so we define several commonly used
## rules here as velocity variables to re-use them later for inline css
#macro( initStyles )
#set($css_h_width=''width: 150px'')
#set($css_link_color=''color: #003399 '')
#set($css_text=''font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; '')
#set($css_hidden_mark=''display: none;'')
#end
#macro ( personLine $request)
<span style="$css_h_width">Person: </span><span>$request.owner.fullNameWithoutUserNameEscaped</span><br>
#end
#macro ( leaveTypeLine $request)
<span style="$css_h_width">Leave Type: </span><span>$request.leaveTypeName</span><br>
#end
#macro ( datesLine $request)
<span style="$css_h_width">Date#if(!$request.oneDayRequest)s#end: </span><span>$request.getFirstDate("EEE, MMM d")#if(!$request.oneDayRequest) - $request.getLastDate("EEE, MMM d")#end</span><br>
#end
#macro ( timeRequestedLine $request $showUnaffectedPTOMessage)
<span style="$css_h_width">Time Requested: </span><span>$request.leaveTimeTotal h#if($request.showPTO) ($request.requestedPTODays PTO days) #elseif($showUnaffectedPTOMessage) (this request does not affect PTO balance)#end</span><br>
#end
#macro ( commentsLine $request)
#if ($request.hasComments)
<span style="css_h_width">Comments: </span><span> $request.comments</span><br>
#end
#end
#macro ( statusLine $request)
<span style="$css_h_width">Request Status: </span><span>$request.status</span><br>
#end
#macro ( printRequestInfo $request $showUnaffectedPTOMessage $showPersonLine )
#if ($showPersonLine)
#personLine( $request )
#end
#leaveTypeLine($request)
#datesLine( $request )
#timeRequestedLine( $request $showUnaffectedPTOMessage )
#commentsLine ($request)
#end
#macro ( header $recipient )
#initStyles()<meta http-equiv=''Content-Type'' content=''text/html; charset=utf-8''><span style="font-family: Arial Unicode MS, Arial, sans-serif; font-weight: normal; font-size: 14px">
#placeForInfoAboutMessageToAdmin()
#greetByName( $recipient )
#end
#macro ( greetByName $recipient )
Dear $recipient.firstNameEscaped,<br><br>
#end
#macro ( placeForInfoAboutMessageToAdmin )
<span id=''infoForAdminMark'' style="$css_hidden_mark"></span>
#end
#macro ( showFooter $footer )
<br/>
<hr noshade size="1" style="background-color: #333333; color: #333333;" />
<pre style=''font-family: Arial Unicode MS, Arial, sans-serif; font-size: 12px;''>$footer</pre>
#end
#macro ( showYourActiPLANSFooterPlainText )
- - -
Your actiPLANS
#end
#macro ( andOtherProduct $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
and actiTIME #end
#end
#macro ( showOtherProductPasswordChangeNote $bothPasswordsChangeNote )
#if ($bothPasswordsChangeNote)
Please note, that the password will be changed for your actiTIME account too.
#end
#end
', last_modified_timestamp = now()
    where name = 'shared_macro_ap.vm';

update mail_template
  set template = '#header( $recipient )
#if($action == "revoke")
$actor.fullNameWithoutUserNameEscaped revoked approval for your leave time request.
#elseif($action == "approve")
$actor.fullNameWithoutUserNameEscaped approved your leave time request.
#elseif($action == "reject")
$actor.fullNameWithoutUserNameEscaped rejected your leave time request.
#elseif($action == "rollback")
$actor.fullNameWithoutUserNameEscaped rolled back rejection for your leave time request.
#elseif($action == "create")
#if($request.approved)
$actor.fullNameWithoutUserNameEscaped planned the following leave time for you:
#else
$actor.fullNameWithoutUserNameEscaped submitted the following leave time request for you:
#end
#elseif($action == "edit")
#if($oldRequest.approved)
$actor.fullNameWithoutUserNameEscaped edited planned leave time for you.
#else
$actor.fullNameWithoutUserNameEscaped edited leave time request for you.
#end
<br>Request summary after editing:
#else
$actor.fullNameWithoutUserNameEscaped deleted your leave time request:
#end
<br><br>
#printRequestInfo( $request, false, false )
#statusLine( $request )
<br>
#if($action=="approve")
#if($request.hasStatusMessage)
Approval Comments: $request.statusMessage
<br><br>
#end
#elseif($action=="reject")
#if($request.hasStatusMessage)
Reason: $request.statusMessage
<br><br>
#end
#elseif( $action == "create" || $action == "edit" )
#if($request.ownerPTOAffected)
Your PTO Balance as of $request.getFirstDate("MMM d") (before request): $request.ownerBalanceBeforeRequest d<br>
Your PTO Balance as of $request.getLastDate("MMM d") (after request): $request.ownerBalanceAfterRequest d
#else
This request does not affect your PTO balance.
#end
<br><br>
#end
<a href="$linkGenerator.myScheduleLink" style="$css_link_color;">View your leave time requests in actiPLANS</a><br>
<br>
#if(!($!footer == ""))
#showFooter($footer)
#end', last_modified_timestamp = now()
    where name = 'request_mgmt_to_user.html';

update mail_template
  set template = '#header( $recipient )
#if($action == "revoke")
$actor.fullNameWithoutUserNameEscaped revoked approval for the following leave time request:
#elseif($action == "approve")
$actor.fullNameWithoutUserNameEscaped approved the following leave time request:
#elseif($action == "reject")
$actor.fullNameWithoutUserNameEscaped rejected the following leave time request:
#elseif($action == "rollback")
$actor.fullNameWithoutUserNameEscaped rolled back rejection for the following leave time request:
#elseif($action == "create")
#if($request.approved)
$actor.fullNameWithoutUserNameEscaped created new leave time request that does not require approval.
#else
$actor.fullNameWithoutUserNameEscaped submitted new leave time request requiring your approval.
#end
#elseif($action == "edit")
#if($oldRequest.approved)
$actor.fullNameWithoutUserNameEscaped edited planned leave time.
#else
$actor.fullNameWithoutUserNameEscaped has edited leave time request waiting for your approval.
#end
<br>Request summary after editing:
#else
$actor.fullNameWithoutUserNameEscaped has deleted the following leave time request:
#end
<br><br>
#printRequestInfo( $request, false, true )
#statusLine( $request )
<br>
#if($action=="approve")
#if($request.hasStatusMessage)
Approval Comments: $request.statusMessage
<br><br>
#end
#elseif($action=="reject")
#if($request.hasStatusMessage)
Reason: $request.statusMessage
<br><br>
#end
#end
#if( $action == "create" || $action == "edit" || $action == "rollback" )
#if($request.ownerPTOAffected)
$request.owner.firstName''s PTO Balance as of $request.getFirstDate("MMM d") (before request): $request.ownerBalanceBeforeRequest d<br>
$request.owner.firstName''s PTO Balance as of $request.getLastDate("MMM d") (after request): $request.ownerBalanceAfterRequest d
#else
This request does not affect $request.owner.firstName''s PTO balance.
#end
<br><br>
#end
<a href="$linkGenerator.leaveTimePlanningLink" style="$css_link_color;">View leave time chart</a><br>
<a href="$linkGenerator.leaveTimeRequestsLink" style="$css_link_color;">View leave time requests</a><br>
<br>
#if(!($!footer == ""))
#showFooter($footer)
#end', last_modified_timestamp = now()
    where name = 'request_mgmt_to_ltm.html';

update mail_template
  set template = '#header( $recipient )
There are leave time requests waiting for your approval.<br>
<br>
#foreach($request in $requests)
#printRequestInfo( $request, true, true)
<br>
#end
Please remember that not approved requests will be automatically rejected in 24 hours after their start.<br>
<br>
<a href="$linkGenerator.leaveTimePlanningLink" style="$css_link_color;">View leave time chart</a><br>
<a href="$linkGenerator.leaveTimeRequestsLink" style="$css_link_color;">View leave time requests</a><br>
<br>
#if(!($!footer == ""))
#showFooter($footer)
#end', last_modified_timestamp = now()
    where name = 'n_days_to_ltm.html';

alter table revision_seq modify val bigint unsigned not null auto_increment;

drop function next_revision;

delimiter //

create function next_revision() returns bigint unsigned
sql security invoker
begin
 insert into revision_seq values();
 return last_insert_id();
end
//

delimiter ;

alter table task add index task_completion_date_idx (completion_date);

drop index user_id on overtime;

alter table tt_lock add index tt_lock_date_from_date_to_idx (date_from, date_to);

alter table task drop column last_tt_date;

create table task_last_tt_date (
   task_id int(3) not null,
   last_tt_date date,
   primary key(task_id)
   -- foreign key to task(id) was not created intentionally - it is not required as
   -- this table is used in very rare cases and its content is wiped and re-created every time.
   -- More over, absence of this FK prevents s_locks on task table
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 'Manaus' time zone was removed from TimeZoneInfo
update system_settings set property_value = "America/La_Paz"
   where property_name = "default_time_zone" and property_value = "America/Manaus";
update at_user set time_zone = "America/La_Paz" where time_zone = "America/Manaus";

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
  values (24, 0, now());

commit;