alter table user_leave_time_request add primary key (id);

CREATE TABLE ap_leave_status (
  user_id int not null,
  status_type int not null,
  status_date date not null,
  time_from datetime,
  time_to datetime,
  comments text,
  primary key (user_id, status_date)
);

-- convert report parameters
create table report_params_convert (type int, old_name varchar(50), old_value varchar(50), new_name varchar(50), new_value varchar(50), primary key (old_name, type, old_value));
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.first.half.of.current.month', 'dateRangeSelection.qualifier', 'CURRENT_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.second.half.of.current.month', 'dateRangeSelection.qualifier', 'CURRENT_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.second.half.of.previous.month', 'dateRangeSelection.qualifier', 'PREVIOUS_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.previous.year', 'dateRangeSelection.qualifier', 'PREVIOUS_YEAR');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.next.week', 'dateRangeSelection.qualifier', 'NEXT_WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'timeFormat', 'decimal', 'timeFormat', 'DECIMAL');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.last.7.days', 'dateRangeSelection.qualifier', 'LAST_7_DAYS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.week.till.today', 'dateRangeSelection.qualifier', 'CURRENT_WEEK_TILL_TODAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'customersProjectsSelector.coarseSelection', 'all', 'customersProjectsSelection.qualifier', 'ALL');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.previous.week', 'dateRangeSelection.qualifier', 'PREVIOUS_WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.month.till.today', 'dateRangeSelection.qualifier', 'CURRENT_MONTH_TILL_TODAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.year.till.today', 'dateRangeSelection.qualifier', 'CURRENT_YEAR_TILL_TODAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.next.month', 'dateRangeSelection.qualifier', 'NEXT_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.and.2.previous.weeks', 'dateRangeSelection.qualifier', 'CURRENT_AND_TWO_PREVIOUS_WEEKS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.week', 'dateRangeSelection.qualifier', 'CURRENT_WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'customersProjectsSelector.coarseSelection', 'all_active', 'customersProjectsSelection.qualifier', 'ALL_ACTIVE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'customersProjectsSelector.coarseSelection', 'specific', 'customersProjectsSelection.qualifier', 'SELECTED');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'timeFormat', 'hhmm', 'timeFormat', 'TIME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.last.21.days', 'dateRangeSelection.qualifier', 'LAST_21_DAYS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.and.previous.weeks', 'dateRangeSelection.qualifier', 'CURRENT_AND_PREVIOUS_WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.month', 'dateRangeSelection.qualifier', 'CURRENT_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.current.year', 'dateRangeSelection.qualifier', 'CURRENT_YEAR');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.last.14.days', 'dateRangeSelection.qualifier', 'LAST_14_DAYS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'filterByApprovedTimeTrack', '3', 'timeApprovalStatus', 'BOTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.previous.month', 'dateRangeSelection.qualifier', 'PREVIOUS_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'filterByApprovedTimeTrack', '1', 'timeApprovalStatus', 'APPROVED');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'filterByApprovedTimeTrack', '2', 'timeApprovalStatus', 'NOT_APPROVED');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.dateRangeState', 'range.state.custom', 'dateRangeSelection.qualifier', 'CUSTOM');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'users', '', 'userSelection.selectedUsers', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.fromDate.internalText', '', 'dateRangeSelection.fromDate', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'allUsers', '', 'userSelection.allUsers', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'dateRangeSelector.toDate.internalText', '', 'dateRangeSelection.toDate', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'userGroups', '', 'userSelection.selectedGroups', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'customersProjectsSelector.showArchived', '', 'customersProjectsSelection.showArchivedProjects', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (-1, 'showDisabledUsers', '', 'userSelection.showDisabled', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'showLeaves', 'false', 'showLeaveTime', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'columnsDisplayFormat', '1', 'columnsConfig', 'USERS_ONLY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'columnsDisplayFormat', '2', 'columnsConfig', 'GROUPS_ONLY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'columnsDisplayFormat', '3', 'columnsConfig', 'USERS_BY_GROUPS_WITHOUT_SUBTOTALS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'columnsDisplayFormat', '4', 'columnsConfig', 'USERS_BY_GROUPS_WITH_SUBTOTALS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'showLeaves', 'on', 'showLeaveTime', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'showLeaves', 'true', 'showLeaveTime', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (1, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'firstLevel', '3', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'firstLevel', '4', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'firstLevel', '5', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'firstLevel', '0', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'firstLevel', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'detailsLevel', '0', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'firstLevel', '2', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'detailsLevel', '2', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'detailsLevel', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'detailsLevel', '4', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'detailsLevel', '3', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'detailsLevel', '5', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (4, 'selectedUserIds', '', 'userSelection.selectedUsers', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'firstLevel', '3', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'firstLevel', '4', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'firstLevel', '5', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'columnsDisplayFormat', '7', 'columnsConfig', 'BALANCES_ONLY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'firstLevel', '0', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'firstLevel', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'firstLevel', '2', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'detailsLevel', '2', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'detailsLevel', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'detailsLevel', '4', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'detailsLevel', '3', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'leaveTypesOption', 'all', 'leaveTypeSelection.qualifier', 'ALL');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'detailsLevel', '5', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'leaveTypesOption', 'all_pto', 'leaveTypeSelection.qualifier', 'ONLY_WITH_BALANCE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'leaveTypesOption', 'specific', 'leaveTypeSelection.qualifier', 'SELECTED');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'detailsLevel', '0', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'columnsDisplayFormat', '5', 'columnsConfig', 'LEAVE_TIME_ONLY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'columnsDisplayFormat', '6', 'columnsConfig', 'LEAVE_TIME_AND_BALANCES');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'showArchivedTypes', '', 'leaveTypeSelection.showArchived', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'selectedLeaves', '', 'leaveTypeSelection.leaveTypes', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (10, 'selectedUserIds', '', 'userSelection.selectedUsers', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '4', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '3', 'thirdGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '2', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '1', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '8', 'thirdGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '7', 'thirdGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '6', 'thirdGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '5', 'thirdGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '0', 'thirdGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'joinCommentsByTask', 'true', 'joinCommentsByTask', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '-1', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '12', 'thirdGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'joinCommentsByTask', 'on', 'joinCommentsByTask', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '11', 'thirdGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '10', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '5', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '4', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '7', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '10', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '6', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '1', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '0', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '3', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '2', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'joinCommentsByTask', 'false', 'joinCommentsByTask', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '8', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '-1', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '5', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '4', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '-1', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '7', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '6', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'thirdGrouping', '9', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '8', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '12', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '11', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '11', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '1', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '10', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'firstGrouping', '12', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '0', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '3', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'secondGrouping', '2', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (6, 'levelsCount', '', 'groupingLevelsCount', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '4', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '3', 'thirdGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '2', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '1', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '8', 'thirdGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'includeNotBudgetedTasks', 'true', 'includeNotEstimated', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '7', 'thirdGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '6', 'thirdGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '5', 'thirdGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '0', 'thirdGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'includeNotBudgetedTasks', 'on', 'includeNotEstimated', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_sunday', 'dateSelection.qualifier', 'LAST_SUNDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'includeNotBudgetedTasks', 'false', 'includeNotEstimated', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '5', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'detailsLevel', '10', 'fourthGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_thursday', 'dateSelection.qualifier', 'LAST_THURSDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '4', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.custom', 'dateSelection.qualifier', 'CUSTOM');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '7', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '6', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '1', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '0', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '3', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '2', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'detailsLevel', '-1', 'fourthGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'includeNotStartedTasks', 'true', 'includeNotStarted', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '8', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '5', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '4', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_saturday', 'dateSelection.qualifier', 'LAST_SATURDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '7', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '6', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_wednesday', 'dateSelection.qualifier', 'LAST_WEDNESDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '8', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'tasksOption', '1', 'tasksConfig', 'OPEN_ONLY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '1', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'tasksOption', '0', 'tasksConfig', 'ALL');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '0', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '3', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'tasksOption', '2', 'tasksConfig', 'COMPLETED_ONLY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '2', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'includeNotStartedTasks', 'on', 'includeNotStarted', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_tuesday', 'dateSelection.qualifier', 'LAST_TUESDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'includeNotStartedTasks', 'false', 'includeNotStarted', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '-1', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '12', 'thirdGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '11', 'thirdGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '10', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.yesterday', 'dateSelection.qualifier', 'YESTERDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '10', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.end_of_the_previous_month', 'dateSelection.qualifier', 'END_OF_PREVIOUS_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_monday', 'dateSelection.qualifier', 'LAST_MONDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'detailsLevel', '7', 'fourthGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '-1', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '-1', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'thirdGrouping', '9', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.today', 'dateSelection.qualifier', 'TODAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.beginning_of_the_current_month', 'dateSelection.qualifier', 'BEGINNING_OF_CURRENT_MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '12', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '11', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '11', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'secondGrouping', '10', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.dateRangeState', 'date.state.last_friday', 'dateSelection.qualifier', 'LAST_FRIDAY');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'firstGrouping', '12', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (9, 'dateRangeSelector.toDate.internalText', '', 'dateSelection.date', '');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'dateRangeType', '1', 'reportType', 'ALL_TIME_WITHIN_DATE_RANGE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'dateRangeType', '2', 'reportType', 'ONLY_FOR_COMPLETED_TASKS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (3, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'dateRangeType', '1', 'reportType', 'ALL_TIME_WITHIN_DATE_RANGE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'dateRangeType', '2', 'reportType', 'ONLY_FOR_COMPLETED_TASKS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (12, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showUserRates', 'on', 'showUserRates', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showOvertime', 'on', 'showOvertimeAddition', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showUserRates', 'false', 'showUserRates', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showUserRates', 'true', 'showUserRates', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showLeaves', 'false', 'showLeaveTimeCosts', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showSpentTime', 'true', 'showSpentTime', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showOvertime', 'false', 'showOvertimeAddition', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'columnsDisplayFormat', '1', 'columnsConfig', 'USERS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'columnsDisplayFormat', '2', 'columnsConfig', 'GROUPS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'columnsDisplayFormat', '3', 'columnsConfig', 'USERS_BY_GROUPS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showAverageRates', 'true', 'showAverageRates', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showOvertime', 'true', 'showOvertimeAddition', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showAverageRates', 'false', 'showAverageRates', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showSpentTime', 'false', 'showSpentTime', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showSubtotalByDepartments', 'true', 'showSubtotalsByDepartments', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showLeaves', 'on', 'showLeaveTimeCosts', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showSubtotalByDepartments', 'on', 'showSubtotalsByDepartments', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showAverageRates', 'on', 'showAverageRates', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showLeaves', 'true', 'showLeaveTimeCosts', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showSpentTime', 'on', 'showSpentTime', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'showSubtotalByDepartments', 'false', 'showSubtotalsByDepartments', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (7, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showOvertime', 'on', 'showOvertimeAddition', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showLeaves', 'false', 'showLeaveTimeCosts', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showSpentTime', 'true', 'showSpentTime', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '1', 'firstGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showOvertime', 'false', 'showOvertimeAddition', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '1', 'secondGroupingLevel', 'USER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showAverageRates', 'true', 'showAverageRates', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showOvertime', 'true', 'showOvertimeAddition', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showAverageRates', 'false', 'showAverageRates', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showSpentTime', 'false', 'showSpentTime', 'false');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showLeaves', 'on', 'showLeaveTimeCosts', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showAverageRates', 'on', 'showAverageRates', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showLeaves', 'true', 'showLeaveTimeCosts', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'showSpentTime', 'on', 'showSpentTime', 'true');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS');
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values (8, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS');

create table report_params_new
(
  config_id int not null,
  param_name varchar(255) not null,
  param_value text not null
);

delete from report_params where config_id not in (select id from report_configs);
delete from report_params_customer where config_id not in (select id from report_configs);
delete from report_params_project where config_id not in (select id from report_configs);

insert into report_params_new (config_id, param_name, param_value)
  select c.id, conv.new_name, Switch(conv.new_value='', p.param_value, not(conv.new_value=''), conv.new_value)
  from (report_params p
    inner join report_configs c on c.id = p.config_id)
    inner join report_params_convert conv on mid(conv.old_name,1,50)=mid(p.param_name,1,50) and (conv.old_value='' or mid(conv.old_value,1,50)=mid(p.param_value,1,50)) and (conv.type=-1 or conv.type=c.report_form);

drop table report_params_convert;

insert into report_params_new (config_id, param_name, param_value)
  select c.id, 'reportInfo',
    switch(p1.param_value='show_time', switch(p2.param_value='1','TIME_ON_BILLABLE_TASKS',p2.param_value='2','TIME_ON_NON_BILLABLE_TASKS',p2.param_value='3','TIME_ON_BOTH_BILLABLE_AND_NON_BILLABLE_TASKS'),
           p1.param_value='show_amount','BILLABLE_AMOUNT',
           p1.param_value='show_time_and_amount', switch(p3.param_value='true','BILLABLE_TIME_AND_BILLABLE_AMOUNT_WITH_AVERAGE_RATES',True,'BILLABLE_TIME_AND_BILLABLE_AMOUNT'))
  from ((report_configs c inner join report_params p1 on p1.config_id = c.id)
    left outer join (select config_id, param_value from report_params where param_name='billingStatusFilter') p2 on p2.config_id = c.id)
    left outer join (select config_id, param_value from report_params where param_name='showAverageRates') p3 on p3.config_id = c.id
  where c.report_form=3 and p1.param_name='infoToShow';

insert into report_params_new (config_id, param_name, param_value) select config_id, 'customersProjectsSelection.customers', customer_id from report_params_customer;
insert into report_params_new (config_id, param_name, param_value) select config_id, 'customersProjectsSelection.projects', project_id from report_params_project;
drop table report_params;
drop table report_params_customer;
drop table report_params_project;

create table report_params
(
  config_id int not null,
  param_name varchar(255) not null,
  param_value varchar(255) not null,
  constraint fk_report_configs foreign key(config_id) references report_configs(id) on delete cascade
);
insert into report_params select * from report_params_new;
drop table report_params_new;

-- delete groupingLevelCounter from TTD ---------------
create table grouping_counters (
  config_id int,
  counter_value varchar(255),
  primary key (config_id)
);

INSERT INTO grouping_counters(config_id, counter_value) SELECT config_id, param_value FROM report_params WHERE param_name = 'groupingLevelsCount';
-- update grouping levels
UPDATE report_params
SET param_value = 'NONE'
WHERE
  config_id in (SELECT config_id FROM grouping_counters WHERE CInt(counter_value) < 1)
  and
  param_name = 'firstGroupingLevel'
  or
  config_id in (SELECT config_id FROM grouping_counters WHERE CInt(counter_value) < 2)
  and
  param_name = 'secondGroupingLevel'
  or
  config_id in (SELECT config_id FROM grouping_counters WHERE CInt(counter_value) < 3)
  and
  param_name = 'thirdGroupingLevel';
-- update join comments value
UPDATE report_params
SET param_value = 'false'
WHERE
  config_id in (SELECT config_id FROM grouping_counters WHERE CInt(counter_value) = 0)
  and
  param_name = 'joinCommentsByTask';

drop table grouping_counters;

delete from report_params where param_name = 'groupingLevelsCount';

-- ----------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
values (29, 0, now());