CREATE TABLE ap_leave_status (
  user_id int(3) unsigned not null,
  status_type int(3) unsigned not null,
  status_date date not null,
  time_from time,
  time_to time,
  comments text,
  primary key (user_id, status_date),
  CONSTRAINT fk_ap_absence_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- convert report parameters
create table report_params_convert (type int, old_name varchar(255), old_value varchar(255), new_name varchar(255), new_value varchar(255), primary key (type, old_name, old_value)) engine=InnoDB default character set=utf8 default collate=utf8_unicode_ci;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(-1, 'dateRangeSelector.dateRangeState', 'range.state.first.half.of.current.month', 'dateRangeSelection.qualifier', 'CURRENT_MONTH')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.second.half.of.current.month', 'dateRangeSelection.qualifier', 'CURRENT_MONTH')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.second.half.of.previous.month', 'dateRangeSelection.qualifier', 'PREVIOUS_MONTH')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.previous.year', 'dateRangeSelection.qualifier', 'PREVIOUS_YEAR')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.next.week', 'dateRangeSelection.qualifier', 'NEXT_WEEK')
,(-1, 'timeFormat', 'decimal', 'timeFormat', 'DECIMAL')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.last.7.days', 'dateRangeSelection.qualifier', 'LAST_7_DAYS')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.week.till.today', 'dateRangeSelection.qualifier', 'CURRENT_WEEK_TILL_TODAY')
,(-1, 'customersProjectsSelector.coarseSelection', 'all', 'customersProjectsSelection.qualifier', 'ALL')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.previous.week', 'dateRangeSelection.qualifier', 'PREVIOUS_WEEK')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.month.till.today', 'dateRangeSelection.qualifier', 'CURRENT_MONTH_TILL_TODAY')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.year.till.today', 'dateRangeSelection.qualifier', 'CURRENT_YEAR_TILL_TODAY')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.next.month', 'dateRangeSelection.qualifier', 'NEXT_MONTH')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.and.2.previous.weeks', 'dateRangeSelection.qualifier', 'CURRENT_AND_TWO_PREVIOUS_WEEKS')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.week', 'dateRangeSelection.qualifier', 'CURRENT_WEEK')
,(-1, 'customersProjectsSelector.coarseSelection', 'all_active', 'customersProjectsSelection.qualifier', 'ALL_ACTIVE')
,(-1, 'customersProjectsSelector.coarseSelection', 'specific', 'customersProjectsSelection.qualifier', 'SELECTED')
,(-1, 'timeFormat', 'hhmm', 'timeFormat', 'TIME')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.last.21.days', 'dateRangeSelection.qualifier', 'LAST_21_DAYS')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.and.previous.weeks', 'dateRangeSelection.qualifier', 'CURRENT_AND_PREVIOUS_WEEK')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.month', 'dateRangeSelection.qualifier', 'CURRENT_MONTH')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.current.year', 'dateRangeSelection.qualifier', 'CURRENT_YEAR')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.last.14.days', 'dateRangeSelection.qualifier', 'LAST_14_DAYS')
,(-1, 'filterByApprovedTimeTrack', '3', 'timeApprovalStatus', 'BOTH')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.previous.month', 'dateRangeSelection.qualifier', 'PREVIOUS_MONTH')
,(-1, 'filterByApprovedTimeTrack', '1', 'timeApprovalStatus', 'APPROVED')
,(-1, 'filterByApprovedTimeTrack', '2', 'timeApprovalStatus', 'NOT_APPROVED')
,(-1, 'dateRangeSelector.dateRangeState', 'range.state.custom', 'dateRangeSelection.qualifier', 'CUSTOM')
,(-1, 'users', '--', 'userSelection.selectedUsers', '--')
,(-1, 'dateRangeSelector.fromDate.internalText', '--', 'dateRangeSelection.fromDate', '--')
,(-1, 'allUsers', '--', 'userSelection.allUsers', '--')
,(-1, 'dateRangeSelector.toDate.internalText', '--', 'dateRangeSelection.toDate', '--')
,(-1, 'userGroups', '--', 'userSelection.selectedGroups', '--')
,(-1, 'customersProjectsSelector.showArchived', '--', 'customersProjectsSelection.showArchivedProjects', '--')
,(-1, 'showDisabledUsers', '--', 'userSelection.showDisabled', '--')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(1, 'showLeaves', 'false', 'showLeaveTime', 'false')
,(1, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE')
,(1, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT')
,(1, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS')
,(1, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE')
,(1, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER')
,(1, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE')
,(1, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE')
,(1, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(1, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK')
,(1, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(1, 'firstGrouping', '1', 'firstGroupingLevel', 'USER')
,(1, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(1, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE')
,(1, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE')
,(1, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME')
,(1, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME')
,(1, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT')
,(1, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER')
,(1, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE')
,(1, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK')
,(1, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME')
,(1, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME')
,(1, 'columnsDisplayFormat', '1', 'columnsConfig', 'USERS_ONLY')
,(1, 'columnsDisplayFormat', '2', 'columnsConfig', 'GROUPS_ONLY')
,(1, 'secondGrouping', '1', 'secondGroupingLevel', 'USER')
,(1, 'columnsDisplayFormat', '3', 'columnsConfig', 'USERS_BY_GROUPS_WITHOUT_SUBTOTALS')
,(1, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE')
,(1, 'columnsDisplayFormat', '4', 'columnsConfig', 'USERS_BY_GROUPS_WITH_SUBTOTALS')
,(1, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE')
,(1, 'showLeaves', 'on', 'showLeaveTime', 'true')
,(1, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE')
,(1, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH')
,(1, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK')
,(1, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP')
,(1, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER')
,(1, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK')
,(1, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT')
,(1, 'showLeaves', 'true', 'showLeaveTime', 'true')
,(1, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP')
,(1, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(1, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(1, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH')
,(1, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(1, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK')
,(1, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS')
,(1, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS')
,(1, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE')
,(1, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(1, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(1, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(4, 'firstLevel', '3', 'firstGroupingLevel', 'MONTH')
,(4, 'firstLevel', '4', 'firstGroupingLevel', 'USER_GROUP')
,(4, 'firstLevel', '5', 'firstGroupingLevel', 'WEEK')
,(4, 'firstLevel', '0', 'firstGroupingLevel', 'NONE')
,(4, 'firstLevel', '1', 'firstGroupingLevel', 'USER')
,(4, 'detailsLevel', '0', 'secondGroupingLevel', 'NONE')
,(4, 'firstLevel', '2', 'firstGroupingLevel', 'DATE')
,(4, 'detailsLevel', '2', 'secondGroupingLevel', 'DATE')
,(4, 'detailsLevel', '1', 'secondGroupingLevel', 'USER')
,(4, 'detailsLevel', '4', 'secondGroupingLevel', 'USER_GROUP')
,(4, 'detailsLevel', '3', 'secondGroupingLevel', 'MONTH')
,(4, 'detailsLevel', '5', 'secondGroupingLevel', 'WEEK')
,(4, 'selectedUserIds', '--', 'userSelection.selectedUsers', '--')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(10, 'firstLevel', '3', 'firstGroupingLevel', 'MONTH')
,(10, 'firstLevel', '4', 'firstGroupingLevel', 'USER_GROUP')
,(10, 'firstLevel', '5', 'firstGroupingLevel', 'WEEK')
,(10, 'columnsDisplayFormat', '7', 'columnsConfig', 'BALANCES_ONLY')
,(10, 'firstLevel', '0', 'firstGroupingLevel', 'NONE')
,(10, 'firstLevel', '1', 'firstGroupingLevel', 'USER')
,(10, 'firstLevel', '2', 'firstGroupingLevel', 'DATE')
,(10, 'detailsLevel', '2', 'secondGroupingLevel', 'DATE')
,(10, 'detailsLevel', '1', 'secondGroupingLevel', 'USER')
,(10, 'detailsLevel', '4', 'secondGroupingLevel', 'USER_GROUP')
,(10, 'detailsLevel', '3', 'secondGroupingLevel', 'MONTH')
,(10, 'leaveTypesOption', 'all', 'leaveTypeSelection.qualifier', 'ALL')
,(10, 'detailsLevel', '5', 'secondGroupingLevel', 'WEEK')
,(10, 'leaveTypesOption', 'all_pto', 'leaveTypeSelection.qualifier', 'ONLY_WITH_BALANCE')
,(10, 'leaveTypesOption', 'specific', 'leaveTypeSelection.qualifier', 'SELECTED')
,(10, 'detailsLevel', '0', 'secondGroupingLevel', 'NONE')
,(10, 'columnsDisplayFormat', '5', 'columnsConfig', 'LEAVE_TIME_ONLY')
,(10, 'columnsDisplayFormat', '6', 'columnsConfig', 'LEAVE_TIME_AND_BALANCES')
,(10, 'showArchivedTypes', '--', 'leaveTypeSelection.showArchived', '--')
,(10, 'selectedLeaves', '--', 'leaveTypeSelection.leaveTypes', '--')
,(10, 'selectedUserIds', '--', 'userSelection.selectedUsers', '--')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(6, 'thirdGrouping', '4', 'thirdGroupingLevel', 'TASK')
,(6, 'thirdGrouping', '3', 'thirdGroupingLevel', 'PROJECT_NAME')
,(6, 'thirdGrouping', '2', 'thirdGroupingLevel', 'PROJECT')
,(6, 'thirdGrouping', '1', 'thirdGroupingLevel', 'CUSTOMER')
,(6, 'thirdGrouping', '8', 'thirdGroupingLevel', 'USER_GROUP')
,(6, 'thirdGrouping', '7', 'thirdGroupingLevel', 'USER')
,(6, 'thirdGrouping', '6', 'thirdGroupingLevel', 'BILLING_TYPE')
,(6, 'thirdGrouping', '5', 'thirdGroupingLevel', 'TASK_NAME')
,(6, 'thirdGrouping', '0', 'thirdGroupingLevel', 'DATE')
,(6, 'joinCommentsByTask', 'true', 'joinCommentsByTask', 'true')
,(6, 'thirdGrouping', '-1', 'thirdGroupingLevel', 'NONE')
,(6, 'thirdGrouping', '12', 'thirdGroupingLevel', 'WEEK')
,(6, 'joinCommentsByTask', 'on', 'joinCommentsByTask', 'true')
,(6, 'thirdGrouping', '11', 'thirdGroupingLevel', 'MONTH')
,(6, 'thirdGrouping', '10', 'thirdGroupingLevel', 'TASK')
,(6, 'firstGrouping', '5', 'firstGroupingLevel', 'TASK_NAME')
,(6, 'firstGrouping', '4', 'firstGroupingLevel', 'TASK')
,(6, 'firstGrouping', '7', 'firstGroupingLevel', 'USER')
,(6, 'firstGrouping', '10', 'firstGroupingLevel', 'TASK')
,(6, 'firstGrouping', '6', 'firstGroupingLevel', 'BILLING_TYPE')
,(6, 'firstGrouping', '1', 'firstGroupingLevel', 'CUSTOMER')
,(6, 'firstGrouping', '0', 'firstGroupingLevel', 'DATE')
,(6, 'firstGrouping', '3', 'firstGroupingLevel', 'PROJECT_NAME')
,(6, 'firstGrouping', '2', 'firstGroupingLevel', 'PROJECT')
,(6, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK')
,(6, 'joinCommentsByTask', 'false', 'joinCommentsByTask', 'false')
,(6, 'firstGrouping', '8', 'firstGroupingLevel', 'USER_GROUP')
,(6, 'secondGrouping', '-1', 'secondGroupingLevel', 'NONE')
,(6, 'secondGrouping', '5', 'secondGroupingLevel', 'TASK_NAME')
,(6, 'secondGrouping', '4', 'secondGroupingLevel', 'TASK')
,(6, 'firstGrouping', '-1', 'firstGroupingLevel', 'NONE')
,(6, 'secondGrouping', '7', 'secondGroupingLevel', 'USER')
,(6, 'secondGrouping', '6', 'secondGroupingLevel', 'BILLING_TYPE')
,(6, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK')
,(6, 'thirdGrouping', '9', 'thirdGroupingLevel', 'TASK')
,(6, 'secondGrouping', '8', 'secondGroupingLevel', 'USER_GROUP')
,(6, 'secondGrouping', '12', 'secondGroupingLevel', 'WEEK')
,(6, 'secondGrouping', '11', 'secondGroupingLevel', 'MONTH')
,(6, 'firstGrouping', '11', 'firstGroupingLevel', 'MONTH')
,(6, 'secondGrouping', '1', 'secondGroupingLevel', 'CUSTOMER')
,(6, 'secondGrouping', '10', 'secondGroupingLevel', 'TASK')
,(6, 'firstGrouping', '12', 'firstGroupingLevel', 'WEEK')
,(6, 'secondGrouping', '0', 'secondGroupingLevel', 'DATE')
,(6, 'secondGrouping', '3', 'secondGroupingLevel', 'PROJECT_NAME')
,(6, 'secondGrouping', '2', 'secondGroupingLevel', 'PROJECT')
,(6, 'levelsCount', '--', 'groupingLevelsCount', '--')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(9, 'thirdGrouping', '4', 'thirdGroupingLevel', 'TASK')
,(9, 'thirdGrouping', '3', 'thirdGroupingLevel', 'PROJECT_NAME')
,(9, 'thirdGrouping', '2', 'thirdGroupingLevel', 'PROJECT')
,(9, 'thirdGrouping', '1', 'thirdGroupingLevel', 'CUSTOMER')
,(9, 'thirdGrouping', '8', 'thirdGroupingLevel', 'USER_GROUP')
,(9, 'includeNotBudgetedTasks', 'true', 'includeNotEstimated', 'true')
,(9, 'thirdGrouping', '7', 'thirdGroupingLevel', 'USER')
,(9, 'thirdGrouping', '6', 'thirdGroupingLevel', 'BILLING_TYPE')
,(9, 'thirdGrouping', '5', 'thirdGroupingLevel', 'TASK_NAME')
,(9, 'thirdGrouping', '0', 'thirdGroupingLevel', 'DATE')
,(9, 'includeNotBudgetedTasks', 'on', 'includeNotEstimated', 'true')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_sunday', 'dateSelection.qualifier', 'LAST_SUNDAY')
,(9, 'includeNotBudgetedTasks', 'false', 'includeNotEstimated', 'false')
,(9, 'firstGrouping', '5', 'firstGroupingLevel', 'TASK_NAME')
,(9, 'detailsLevel', '10', 'fourthGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_thursday', 'dateSelection.qualifier', 'LAST_THURSDAY')
,(9, 'firstGrouping', '4', 'firstGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.custom', 'dateSelection.qualifier', 'CUSTOM')
,(9, 'firstGrouping', '7', 'firstGroupingLevel', 'USER')
,(9, 'firstGrouping', '6', 'firstGroupingLevel', 'BILLING_TYPE')
,(9, 'firstGrouping', '1', 'firstGroupingLevel', 'CUSTOMER')
,(9, 'firstGrouping', '0', 'firstGroupingLevel', 'DATE')
,(9, 'firstGrouping', '3', 'firstGroupingLevel', 'PROJECT_NAME')
,(9, 'firstGrouping', '2', 'firstGroupingLevel', 'PROJECT')
,(9, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK')
,(9, 'detailsLevel', '-1', 'fourthGroupingLevel', 'NONE')
,(9, 'includeNotStartedTasks', 'true', 'includeNotStarted', 'true')
,(9, 'firstGrouping', '8', 'firstGroupingLevel', 'USER_GROUP')
,(9, 'secondGrouping', '5', 'secondGroupingLevel', 'TASK_NAME')
,(9, 'secondGrouping', '4', 'secondGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_saturday', 'dateSelection.qualifier', 'LAST_SATURDAY')
,(9, 'secondGrouping', '7', 'secondGroupingLevel', 'USER')
,(9, 'secondGrouping', '6', 'secondGroupingLevel', 'BILLING_TYPE')
,(9, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_wednesday', 'dateSelection.qualifier', 'LAST_WEDNESDAY')
,(9, 'secondGrouping', '8', 'secondGroupingLevel', 'USER_GROUP')
,(9, 'tasksOption', '1', 'tasksConfig', 'OPEN_ONLY')
,(9, 'secondGrouping', '1', 'secondGroupingLevel', 'CUSTOMER')
,(9, 'tasksOption', '0', 'tasksConfig', 'ALL')
,(9, 'secondGrouping', '0', 'secondGroupingLevel', 'DATE')
,(9, 'secondGrouping', '3', 'secondGroupingLevel', 'PROJECT_NAME')
,(9, 'tasksOption', '2', 'tasksConfig', 'COMPLETED_ONLY')
,(9, 'secondGrouping', '2', 'secondGroupingLevel', 'PROJECT')
,(9, 'includeNotStartedTasks', 'on', 'includeNotStarted', 'true')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_tuesday', 'dateSelection.qualifier', 'LAST_TUESDAY')
,(9, 'includeNotStartedTasks', 'false', 'includeNotStarted', 'false')
,(9, 'thirdGrouping', '-1', 'thirdGroupingLevel', 'NONE')
,(9, 'thirdGrouping', '12', 'thirdGroupingLevel', 'WEEK')
,(9, 'thirdGrouping', '11', 'thirdGroupingLevel', 'MONTH')
,(9, 'thirdGrouping', '10', 'thirdGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.yesterday', 'dateSelection.qualifier', 'YESTERDAY')
,(9, 'firstGrouping', '10', 'firstGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.end_of_the_previous_month', 'dateSelection.qualifier', 'END_OF_PREVIOUS_MONTH')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_monday', 'dateSelection.qualifier', 'LAST_MONDAY')
,(9, 'detailsLevel', '7', 'fourthGroupingLevel', 'USER')
,(9, 'secondGrouping', '-1', 'secondGroupingLevel', 'NONE')
,(9, 'firstGrouping', '-1', 'firstGroupingLevel', 'NONE')
,(9, 'thirdGrouping', '9', 'thirdGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.today', 'dateSelection.qualifier', 'TODAY')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.beginning_of_the_current_month', 'dateSelection.qualifier', 'BEGINNING_OF_CURRENT_MONTH')
,(9, 'secondGrouping', '12', 'secondGroupingLevel', 'WEEK')
,(9, 'secondGrouping', '11', 'secondGroupingLevel', 'MONTH')
,(9, 'firstGrouping', '11', 'firstGroupingLevel', 'MONTH')
,(9, 'secondGrouping', '10', 'secondGroupingLevel', 'TASK')
,(9, 'dateRangeSelector.dateRangeState', 'date.state.last_friday', 'dateSelection.qualifier', 'LAST_FRIDAY')
,(9, 'firstGrouping', '12', 'firstGroupingLevel', 'WEEK')
,(9, 'dateRangeSelector.toDate.internalText', '--', 'dateSelection.date', '--')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(3, 'dateRangeType', '1', 'reportType', 'ALL_TIME_WITHIN_DATE_RANGE')
,(3, 'dateRangeType', '2', 'reportType', 'ONLY_FOR_COMPLETED_TASKS')
,(3, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE')
,(3, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS')
,(3, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT')
,(3, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE')
,(3, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER')
,(3, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE')
,(3, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(3, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE')
,(3, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE')
,(3, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(3, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK')
,(3, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH')
,(3, 'firstGrouping', '1', 'firstGroupingLevel', 'USER')
,(3, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(3, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK')
,(3, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP')
,(3, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE')
,(3, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE')
,(3, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER')
,(3, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK')
,(3, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME')
,(3, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT')
,(3, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME')
,(3, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT')
,(3, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER')
,(3, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE')
,(3, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK')
,(3, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME')
,(3, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME')
,(3, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(3, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP')
,(3, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(3, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(3, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH')
,(3, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS')
,(3, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK')
,(3, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE')
,(3, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS')
,(3, 'secondGrouping', '1', 'secondGroupingLevel', 'USER')
,(3, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(3, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(3, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE')
,(3, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(3, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(12, 'dateRangeType', '1', 'reportType', 'ALL_TIME_WITHIN_DATE_RANGE')
,(12, 'dateRangeType', '2', 'reportType', 'ONLY_FOR_COMPLETED_TASKS')
,(12, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE')
,(12, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS')
,(12, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT')
,(12, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE')
,(12, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER')
,(12, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE')
,(12, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(12, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE')
,(12, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE')
,(12, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(12, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK')
,(12, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH')
,(12, 'firstGrouping', '1', 'firstGroupingLevel', 'USER')
,(12, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(12, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK')
,(12, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP')
,(12, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE')
,(12, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE')
,(12, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER')
,(12, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK')
,(12, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME')
,(12, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT')
,(12, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME')
,(12, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT')
,(12, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER')
,(12, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE')
,(12, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK')
,(12, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME')
,(12, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME')
,(12, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(12, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP')
,(12, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(12, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(12, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH')
,(12, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS')
,(12, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK')
,(12, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE')
,(12, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS')
,(12, 'secondGrouping', '1', 'secondGroupingLevel', 'USER')
,(12, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(12, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(12, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE')
,(12, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(12, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(7, 'showUserRates', 'on', 'showUserRates', 'true')
,(7, 'showOvertime', 'on', 'showOvertimeAddition', 'true')
,(7, 'showUserRates', 'false', 'showUserRates', 'false')
,(7, 'showUserRates', 'true', 'showUserRates', 'true')
,(7, 'showLeaves', 'false', 'showLeaveTimeCosts', 'false')
,(7, 'showSpentTime', 'true', 'showSpentTime', 'true')
,(7, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT')
,(7, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS')
,(7, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE')
,(7, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER')
,(7, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE')
,(7, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE')
,(7, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(7, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE')
,(7, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK')
,(7, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(7, 'firstGrouping', '1', 'firstGroupingLevel', 'USER')
,(7, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(7, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE')
,(7, 'showOvertime', 'false', 'showOvertimeAddition', 'false')
,(7, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE')
,(7, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME')
,(7, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME')
,(7, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT')
,(7, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER')
,(7, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE')
,(7, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK')
,(7, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME')
,(7, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME')
,(7, 'columnsDisplayFormat', '1', 'columnsConfig', 'USERS')
,(7, 'columnsDisplayFormat', '2', 'columnsConfig', 'GROUPS')
,(7, 'secondGrouping', '1', 'secondGroupingLevel', 'USER')
,(7, 'columnsDisplayFormat', '3', 'columnsConfig', 'USERS_BY_GROUPS')
,(7, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE')
,(7, 'showAverageRates', 'true', 'showAverageRates', 'true')
,(7, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE')
,(7, 'showOvertime', 'true', 'showOvertimeAddition', 'true')
,(7, 'showAverageRates', 'false', 'showAverageRates', 'false')
,(7, 'showSpentTime', 'false', 'showSpentTime', 'false')
,(7, 'showSubtotalByDepartments', 'true', 'showSubtotalsByDepartments', 'true')
,(7, 'showLeaves', 'on', 'showLeaveTimeCosts', 'true')
,(7, 'showSubtotalByDepartments', 'on', 'showSubtotalsByDepartments', 'true')
,(7, 'showAverageRates', 'on', 'showAverageRates', 'true')
,(7, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE')
,(7, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH')
,(7, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK')
,(7, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP')
,(7, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER')
,(7, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK')
,(7, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT')
,(7, 'showLeaves', 'true', 'showLeaveTimeCosts', 'true')
,(7, 'showSpentTime', 'on', 'showSpentTime', 'true')
,(7, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP')
,(7, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(7, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(7, 'showSubtotalByDepartments', 'false', 'showSubtotalsByDepartments', 'false')
,(7, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH')
,(7, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(7, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK')
,(7, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS')
,(7, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS')
,(7, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE')
,(7, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(7, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(7, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
;
insert into report_params_convert (type, old_name, old_value, new_name, new_value) values
(8, 'showOvertime', 'on', 'showOvertimeAddition', 'true')
,(8, 'showLeaves', 'false', 'showLeaveTimeCosts', 'false')
,(8, 'showSpentTime', 'true', 'showSpentTime', 'true')
,(8, 'firstGrouping', '5', 'firstGroupingLevel', 'PROJECT')
,(8, 'detailsLevel', '11', 'thirdGroupingLevel', 'TT_COMMENTS')
,(8, 'detailsLevel', '-4', 'thirdGroupingLevel', 'NONE')
,(8, 'firstGrouping', '4', 'firstGroupingLevel', 'CUSTOMER')
,(8, 'detailsLevel', '-5', 'thirdGroupingLevel', 'NONE')
,(8, 'firstGrouping', '7', 'firstGroupingLevel', 'NONE')
,(8, 'detailsLevel', '13', 'thirdGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(8, 'detailsLevel', '-6', 'thirdGroupingLevel', 'NONE')
,(8, 'firstGrouping', '6', 'firstGroupingLevel', 'TASK')
,(8, 'detailsLevel', '12', 'thirdGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(8, 'firstGrouping', '1', 'firstGroupingLevel', 'USER')
,(8, 'detailsLevel', '14', 'thirdGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(8, 'firstGrouping', '3', 'firstGroupingLevel', 'DATE')
,(8, 'showOvertime', 'false', 'showOvertimeAddition', 'false')
,(8, 'firstGrouping', '2', 'firstGroupingLevel', 'BILLING_TYPE')
,(8, 'firstGrouping', '9', 'firstGroupingLevel', 'TASK_NAME')
,(8, 'firstGrouping', '8', 'firstGroupingLevel', 'PROJECT_NAME')
,(8, 'secondGrouping', '5', 'secondGroupingLevel', 'PROJECT')
,(8, 'secondGrouping', '4', 'secondGroupingLevel', 'CUSTOMER')
,(8, 'secondGrouping', '7', 'secondGroupingLevel', 'NONE')
,(8, 'secondGrouping', '6', 'secondGroupingLevel', 'TASK')
,(8, 'secondGrouping', '9', 'secondGroupingLevel', 'TASK_NAME')
,(8, 'secondGrouping', '8', 'secondGroupingLevel', 'PROJECT_NAME')
,(8, 'secondGrouping', '1', 'secondGroupingLevel', 'USER')
,(8, 'secondGrouping', '3', 'secondGroupingLevel', 'DATE')
,(8, 'showAverageRates', 'true', 'showAverageRates', 'true')
,(8, 'secondGrouping', '2', 'secondGroupingLevel', 'BILLING_TYPE')
,(8, 'showOvertime', 'true', 'showOvertimeAddition', 'true')
,(8, 'showAverageRates', 'false', 'showAverageRates', 'false')
,(8, 'showSpentTime', 'false', 'showSpentTime', 'false')
,(8, 'showLeaves', 'on', 'showLeaveTimeCosts', 'true')
,(8, 'showAverageRates', 'on', 'showAverageRates', 'true')
,(8, 'firstGrouping', '10', 'firstGroupingLevel', 'USER_RATE')
,(8, 'secondGrouping', '17', 'secondGroupingLevel', 'MONTH')
,(8, 'secondGrouping', '18', 'secondGroupingLevel', 'WEEK')
,(8, 'secondGrouping', '15', 'secondGroupingLevel', 'USER_GROUP')
,(8, 'detailsLevel', '4', 'thirdGroupingLevel', 'CUSTOMER')
,(8, 'detailsLevel', '6', 'thirdGroupingLevel', 'TASK')
,(8, 'detailsLevel', '5', 'thirdGroupingLevel', 'PROJECT')
,(8, 'showLeaves', 'true', 'showLeaveTimeCosts', 'true')
,(8, 'showSpentTime', 'on', 'showSpentTime', 'true')
,(8, 'firstGrouping', '15', 'firstGroupingLevel', 'USER_GROUP')
,(8, 'secondGrouping', '14', 'secondGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
,(8, 'secondGrouping', '13', 'secondGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(8, 'firstGrouping', '17', 'firstGroupingLevel', 'MONTH')
,(8, 'secondGrouping', '12', 'secondGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(8, 'firstGrouping', '18', 'firstGroupingLevel', 'WEEK')
,(8, 'secondGrouping', '11', 'secondGroupingLevel', 'TT_COMMENTS')
,(8, 'firstGrouping', '11', 'firstGroupingLevel', 'TT_COMMENTS')
,(8, 'secondGrouping', '10', 'secondGroupingLevel', 'USER_RATE')
,(8, 'firstGrouping', '12', 'firstGroupingLevel', 'TASK_AND_TT_COMMENTS')
,(8, 'firstGrouping', '13', 'firstGroupingLevel', 'PROJECT_AND_TT_COMMENTS')
,(8, 'firstGrouping', '14', 'firstGroupingLevel', 'CUSTOMER_AND_TT_COMMENTS')
;

create table report_params_new
(
  config_id int(3) not null,
  param_name varchar(255) not null,
  param_value text not null
) engine=InnoDB default character set=utf8 default collate=utf8_unicode_ci;

delete from report_params where config_id not in (select id from report_configs);
delete from report_params_customer where config_id not in (select id from report_configs);
delete from report_params_project where config_id not in (select id from report_configs);

insert into report_params_new (config_id, param_name, param_value) select c.id, conv.new_name, IF(conv.new_value='--', p.param_value, conv.new_value) from report_params p inner join report_configs c on c.id = p.config_id inner join report_params_convert conv on conv.old_name=p.param_name and (conv.old_value='--' or conv.old_value=p.param_value) and (conv.type=-1 or conv.type=c.report_form);
drop table report_params_convert;
insert into report_params_new (config_id, param_name, param_value) select c.id, 'reportInfo',case p1.param_value  when 'show_time' then     case p2.param_value       when '1' then 'TIME_ON_BILLABLE_TASKS'       when '2' then 'TIME_ON_NON_BILLABLE_TASKS'       when '3' then 'TIME_ON_BOTH_BILLABLE_AND_NON_BILLABLE_TASKS'     end   when 'show_amount' then 'BILLABLE_AMOUNT'  when 'show_time_and_amount' then     case       when p3.param_value='true' then 'BILLABLE_TIME_AND_BILLABLE_AMOUNT_WITH_AVERAGE_RATES'       else 'BILLABLE_TIME_AND_BILLABLE_AMOUNT'     end end from report_configs c inner join report_params p1 on p1.config_id = c.id and p1.param_name='infoToShow' left outer join report_params p2 on p2.config_id = c.id and p2.param_name='billingStatusFilter' left outer join report_params p3 on p3.config_id = c.id and p3.param_name='showAverageRates' where c.report_form=3;
insert into report_params_new (config_id, param_name, param_value) select config_id, 'customersProjectsSelection.customers', customer_id from report_params_customer;
insert into report_params_new (config_id, param_name, param_value) select config_id, 'customersProjectsSelection.projects', project_id from report_params_project;
drop table report_params;
drop table report_params_customer;
drop table report_params_project;

rename table report_params_new to report_params;
alter table report_params
 add constraint fk_report_configs foreign key (config_id) references report_configs (id) on delete cascade;

-- delete groupingLevelCounter from TTD ---------------
create table grouping_counters (
  config_id int,
  counter_value varchar(255),
  primary key (config_id)
) engine=InnoDB default character set=utf8 default collate=utf8_unicode_ci;

INSERT INTO grouping_counters(config_id, counter_value) SELECT config_id, param_value FROM report_params WHERE param_name = 'groupingLevelsCount';
-- update grouping levels
UPDATE report_params
SET param_value = 'NONE'
WHERE
  config_id in (SELECT config_id FROM grouping_counters WHERE CAST(counter_value AS SIGNED) < 1)
  and
  param_name = 'firstGroupingLevel'
  or
  config_id in (SELECT config_id FROM grouping_counters WHERE CAST(counter_value AS SIGNED) < 2)
  and
  param_name = 'secondGroupingLevel'
  or
  config_id in (SELECT config_id FROM grouping_counters WHERE CAST(counter_value AS SIGNED) < 3)
  and
  param_name = 'thirdGroupingLevel';
-- update join comments value
UPDATE report_params
SET param_value = 'false'
WHERE
  config_id in (SELECT config_id FROM grouping_counters WHERE CAST(counter_value AS SIGNED) = 0)
  and
  param_name = 'joinCommentsByTask';

drop table grouping_counters;

delete from report_params where param_name = 'groupingLevelsCount';

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
values (29, 0, now());

commit;