-- patch only for convert mysql database to utf8mb4 (in access db only need to shorten some fields)

-- change some text fields to varchar(191) (in mysql in utf8mb4 encoding it is maximum for index fields)

-- at_user.username, at_user.username_lower
create table temp (id int, cnt int, n int);

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.username_lower <= a.username_lower, 1, True, 0)) as n
  from at_user a
  inner join at_user a2 on left(a.username_lower, 188) = left(a2.username_lower, 188)
  group by a.id
  having max(len(a2.username_lower)) > 191;

update at_user
  inner join temp on at_user.id = temp.id
set at_user.username_lower = switch(temp.cnt > 1, left(at_user.username_lower, 188) & format(temp.n, '000'), True, left(at_user.username_lower, 191)),
    at_user.username       = switch(temp.cnt > 1, left(at_user.username      , 188) & format(temp.n, '000'), True, left(at_user.username      , 191));

-- deleted_user.username
delete from temp;

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.username <= a.username, 1, True, 0)) as n
  from deleted_user a
  inner join deleted_user a2 on left(a.username, 188) = left(a2.username, 188)
  group by a.id
  having max(len(a2.username)) > 191;

update deleted_user
  inner join temp on deleted_user.id = temp.id
set deleted_user.username = switch(temp.cnt > 1, left(deleted_user.username, 188) & format(temp.n, '000'), True, left(deleted_user.username, 191));

-- billing_type.name, billing_type.name_lower
delete from temp;

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.name_lower <= a.name_lower, 1, True, 0)) as n
  from billing_type a
  inner join billing_type a2 on left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(len(a2.name_lower)) > 191;

update billing_type
  inner join temp on billing_type.id = temp.id
set billing_type.name_lower = switch(temp.cnt > 1, left(billing_type.name_lower, 188) & format(temp.n, '000'), True, left(billing_type.name_lower, 191)),
    billing_type.name       = switch(temp.cnt > 1, left(billing_type.name      , 188) & format(temp.n, '000'), True, left(billing_type.name      , 191));

-- report_configs.name, report_configs.name_lower
delete from temp;

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.name_lower <= a.name_lower, 1, True, 0)) as n
  from report_configs a
  inner join report_configs a2 on a.report_form = a2.report_form and a.user_id = a2.user_id and left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(len(a2.name_lower)) > 191;

update report_configs
  inner join temp on report_configs.id = temp.id
set report_configs.name_lower = switch(temp.cnt > 1, left(report_configs.name_lower, 188) & format(temp.n, '000'), True, left(report_configs.name_lower, 191)),
    report_configs.name       = switch(temp.cnt > 1, left(report_configs.name      , 188) & format(temp.n, '000'), True, left(report_configs.name      , 191));

-- customer.name, customer.name_lower
delete from temp;

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.name_lower <= a.name_lower, 1, True, 0)) as n
  from customer a
  inner join customer a2 on left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(len(a2.name_lower)) > 191;

update customer
  inner join temp on customer.id = temp.id
set customer.name_lower = switch(temp.cnt > 1, left(customer.name_lower, 188) & format(temp.n, '000'), True, left(customer.name_lower, 191)),
    customer.name       = switch(temp.cnt > 1, left(customer.name      , 188) & format(temp.n, '000'), True, left(customer.name      , 191));

-- project.name, project.name_lower
delete from temp;

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.name_lower <= a.name_lower, 1, True, 0)) as n
  from project a
  inner join project a2 on a.customer_id = a2.customer_id and left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(len(a2.name_lower)) > 191;

update project
  inner join temp on project.id = temp.id
set project.name_lower = switch(temp.cnt > 1, left(project.name_lower, 188) & format(temp.n, '000'), True, left(project.name_lower, 191)),
    project.name       = switch(temp.cnt > 1, left(project.name      , 188) & format(temp.n, '000'), True, left(project.name      , 191));

-- task.name, task.name_lower
delete from temp;

insert into temp (id, cnt, n)
  select
    a.id as id,
    sum(1) as cnt,
    sum(switch(a2.name_lower <= a.name_lower, 1, True, 0)) as n
  from task a
  inner join task a2 on a.project_id = a2.project_id and left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(len(a2.name_lower)) > 191;

update task
  inner join temp on task.id = temp.id
set task.name_lower = switch(temp.cnt > 1, left(task.name_lower, 188) & format(temp.n, '000'), True, left(task.name_lower, 191)),
    task.name       = switch(temp.cnt > 1, left(task.name      , 188) & format(temp.n, '000'), True, left(task.name      , 191));

drop table temp;

alter table password_recovery_token alter column token varchar(191) not null;
alter table invoice_params alter column param_name varchar(191) not null;
alter table at_user alter column username varchar(191) not null;
alter table at_user alter column username_lower varchar(191) not null;
alter table deleted_user alter column username varchar(191) not null;
alter table billing_type alter column name varchar(191) not null;
alter table billing_type alter column name_lower varchar(191) not null;
alter table customer alter column name varchar(191) not null;
alter table customer alter column name_lower varchar(191) not null;
alter table project alter column name varchar(191) not null;
alter table project alter column name_lower varchar(191) not null;
alter table task alter column name varchar(191) not null;
alter table task alter column name_lower varchar(191) not null;
alter table report_configs alter column name varchar(191) not null;
alter table report_configs alter column name_lower varchar(191) not null;
alter table user_settings alter column param_category varchar(191) not null;

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
values (33, 0, now());