-- this patch only for convert database to utf8mb4

-- change some text fields to varchar(191) (in mysql in utf8mb4 encoding it is maximum for index fields)

-- at_user.username, at_user.username_lower
create table temp (id int, cnt int, n int);

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.username_lower <= a.username_lower) n
  from at_user a
  inner join at_user a2 on left(a.username_lower, 188) = left(a2.username_lower, 188)
  group by a.id
  having max(length(a2.username_lower)) > 191;

update at_user
  inner join temp on at_user.id = temp.id
set at_user.username_lower = if(temp.cnt > 1, concat(left(at_user.username_lower, 188), lpad(temp.n, 3, '0')), left(at_user.username_lower, 191)),
    at_user.username       = if(temp.cnt > 1, concat(left(at_user.username      , 188), lpad(temp.n, 3, '0')), left(at_user.username      , 191));

-- deleted_user.username
truncate table temp;

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.username <= a.username) n
  from deleted_user a
  inner join deleted_user a2 on left(a.username, 188) = left(a2.username, 188)
  group by a.id
  having max(length(a2.username)) > 191;

update deleted_user
  inner join temp on deleted_user.id = temp.id
set deleted_user.username = if(temp.cnt > 1, concat(left(deleted_user.username, 188), lpad(temp.n, 3, '0')), left(deleted_user.username, 191));

-- billing_type.name, billing_type.name_lower
truncate table temp;

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.name_lower <= a.name_lower) n
  from billing_type a
  inner join billing_type a2 on left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(length(a2.name_lower)) > 191;

update billing_type
  inner join temp on billing_type.id = temp.id
set billing_type.name_lower = if(temp.cnt > 1, concat(left(billing_type.name_lower, 188), lpad(temp.n, 3, '0')), left(billing_type.name_lower, 191)),
    billing_type.name       = if(temp.cnt > 1, concat(left(billing_type.name      , 188), lpad(temp.n, 3, '0')), left(billing_type.name      , 191));

-- report_configs.name, report_configs.name_lower
truncate table temp;

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.name_lower <= a.name_lower) n
  from report_configs a
  inner join report_configs a2 on a.report_form = a2.report_form and a.user_id = a2.user_id and left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(length(a2.name_lower)) > 191;

update report_configs
  inner join temp on report_configs.id = temp.id
set report_configs.name_lower = if(temp.cnt > 1, concat(left(report_configs.name_lower, 188), lpad(temp.n, 3, '0')), left(report_configs.name_lower, 191)),
    report_configs.name       = if(temp.cnt > 1, concat(left(report_configs.name      , 188), lpad(temp.n, 3, '0')), left(report_configs.name      , 191));

-- customer.name, customer.name_lower
truncate table temp;

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.name_lower <= a.name_lower) n
  from customer a
  inner join customer a2 on left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(length(a2.name_lower)) > 191;

update customer
  inner join temp on customer.id = temp.id
set customer.name_lower = if(temp.cnt > 1, concat(left(customer.name_lower, 188), lpad(temp.n, 3, '0')), left(customer.name_lower, 191)),
    customer.name       = if(temp.cnt > 1, concat(left(customer.name      , 188), lpad(temp.n, 3, '0')), left(customer.name      , 191));

-- project.name, project.name_lower
truncate table temp;

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.name_lower <= a.name_lower) n
  from project a
  inner join project a2 on a.customer_id = a2.customer_id and left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(length(a2.name_lower)) > 191;

update project
  inner join temp on project.id = temp.id
set project.name_lower = if(temp.cnt > 1, concat(left(project.name_lower, 188), lpad(temp.n, 3, '0')), left(project.name_lower, 191)),
    project.name       = if(temp.cnt > 1, concat(left(project.name      , 188), lpad(temp.n, 3, '0')), left(project.name      , 191));

-- task.name, task.name_lower
truncate table temp;

insert into temp (id, cnt, n)
  select
    a.id id,
    sum(1) cnt,
    sum(a2.name_lower <= a.name_lower) n
  from task a
  inner join task a2 on a.project_id = a2.project_id and left(a.name_lower, 188) = left(a2.name_lower, 188)
  group by a.id
  having max(length(a2.name_lower)) > 191;

update task
  inner join temp on task.id = temp.id
set task.name_lower = if(temp.cnt > 1, concat(left(task.name_lower, 188), lpad(temp.n, 3, '0')), left(task.name_lower, 191)),
    task.name       = if(temp.cnt > 1, concat(left(task.name      , 188), lpad(temp.n, 3, '0')), left(task.name      , 191));

drop table temp;

alter table password_recovery_token modify token varchar(191) not null;
alter table invoice_params modify param_name varchar(191) not null;
alter table at_user modify username varchar(191) not null default '';
alter table at_user modify username_lower varchar(191) not null default '';
alter table deleted_user modify username varchar(191) not null;
alter table billing_type modify name varchar(191) not null;
alter table billing_type modify name_lower varchar(191) not null;
alter table customer modify name varchar(191) not null;
alter table customer modify name_lower varchar(191) not null;
alter table project modify name varchar(191) not null;
alter table project modify name_lower varchar(191) not null;
alter table task modify name varchar(191) not null;
alter table task modify name_lower varchar(191) not null;
alter table report_configs modify name varchar(191) not null;
alter table report_configs modify name_lower varchar(191) not null;
alter table user_settings modify param_category varchar(191) not null;

-- change encoding to utf8mb4 if mysql version greater or equals 5.5.3
/*!50503 alter database character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table access_right convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table ap_leave_status convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table at_user convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table at_user_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table billing_type convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table billing_type_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table bin_data convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table bin_data_chunk convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table customer convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table customer_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table default_workday_duration_history convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table deleted_user convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table gui_notification convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table invoice_bill_to_recent_entry convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table invoice_discount convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table invoice_last_used_number convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table invoice_params convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table invoice_tax convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table invoice_terms convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table leave_rate convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table leave_type convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table leave_type_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table license convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table mail_message convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table mail_message_attachment convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table mail_message_recipient convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table notification_last_date convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table notification_rule convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table notification_rule_params convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table notification_schedule convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table overtime convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table password_recovery_token convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table patch_history convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table project convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table project_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table project_user_notif_rule_send convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table registration_info convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table report_configs convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table report_params convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table revision_seq convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table system_settings convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table system_settings_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table task convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table task_last_tt_date convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table task_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table task_user_notif_rule_send convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table tt_lock convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table tt_metadata convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table tt_record convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table tt_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_access_right convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_balance_cap convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_balance_rule convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_balance_stats convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_context_name convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_cur_balance convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_date_leave convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_date_leave_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_group convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_leave_time_request convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_ltr_approver convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_notif_rule_send convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_project convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_project_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_rate convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_schedule convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_seen_gui_notif convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_settings convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_task convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_task_comment convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_tt_approver convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_user_notif_rule_send convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table user_work_schedule_calendar convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table w_days convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table w_days_revision convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table week_approval_current_status convert to character set utf8mb4 collate utf8mb4_unicode_ci */;
/*!50503 alter table week_approval_status_history convert to character set utf8mb4 collate utf8mb4_unicode_ci */;

-- recreate function next_revision to change its database collation
/*!50503 drop function next_revision */;
delimiter //
/*!50503 create function next_revision() returns bigint unsigned
sql security invoker
begin
 insert into revision_seq values();
 return last_insert_id();
end
*/ //
delimiter ;

-- change text columns back to TEXT (from MEDIUMTEXT)
/*!50503 ALTER TABLE ap_leave_status MODIFY comments TEXT */;
/*!50503 ALTER TABLE customer MODIFY description TEXT */;
/*!50503 ALTER TABLE gui_notification MODIFY contents TEXT NOT NULL */;
/*!50503 ALTER TABLE invoice_bill_to_recent_entry MODIFY entry TEXT NOT NULL */;
/*!50503 ALTER TABLE invoice_bill_to_recent_entry MODIFY normalized_entry TEXT NOT NULL */;
/*!50503 ALTER TABLE invoice_discount MODIFY name TEXT NOT NULL */;
/*!50503 ALTER TABLE invoice_params MODIFY param_value TEXT NOT NULL */;
/*!50503 ALTER TABLE invoice_tax MODIFY name TEXT NOT NULL */;
/*!50503 ALTER TABLE license MODIFY body TEXT */;
/*!50503 ALTER TABLE mail_message MODIFY subject TEXT */;
/*!50503 ALTER TABLE mail_message MODIFY last_failure_reason TEXT */;
/*!50503 ALTER TABLE notification_rule_params MODIFY param_value TEXT NOT NULL */;
/*!50503 ALTER TABLE project MODIFY description TEXT */;
/*!50503 ALTER TABLE report_configs MODIFY description TEXT */;
/*!50503 ALTER TABLE report_params MODIFY param_value TEXT NOT NULL */;
/*!50503 ALTER TABLE system_settings MODIFY property_value TEXT */;
/*!50503 ALTER TABLE task MODIFY description TEXT */;
/*!50503 ALTER TABLE user_balance_rule MODIFY mgr_comment TEXT */;
/*!50503 ALTER TABLE user_leave_time_request MODIFY status_message TEXT */;
/*!50503 ALTER TABLE user_leave_time_request MODIFY comment TEXT */;
/*!50503 ALTER TABLE user_settings MODIFY param_value TEXT */;
/*!50503 ALTER TABLE user_task_comment MODIFY comments TEXT NOT NULL */;
/*!50503 ALTER TABLE week_approval_current_status MODIFY comment TEXT */;
/*!50503 ALTER TABLE week_approval_status_history MODIFY comment TEXT */;

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
values (33, 0, now());

commit;