update system_settings set property_name = 'ap_sick_days_balance_enabled' where property_name = 'sick_days_balance_enabled';
update system_settings set property_name = 'sick_days_balance_enabled' where property_name = 'at_sick_days_balance_enabled';

alter table at_user add is_activated bit not null;
update at_user set is_activated=true;

drop table mail_template;
drop table user_work_schedule_calendar;

alter table at_user alter column md5_password varchar(32) null;

 -- Create activate_user_token
create table activation_info(
    user_id int NOT NULL,
    token varchar(191),
    owner_id int NOT NULL,
    product_name VARCHAR(9) NOT NULL,

    unique(token),
    unique(user_id)

    -- these constraints are processed by the application due to the constraints limitation (32) in ms access
    -- CONSTRAINT fk_activate_token_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE ON UPDATE CASCADE,
);

-- Create table for last login dates
create table user_last_login_time(
    user_id int NOT NULL,
    product_name VARCHAR(9) NOT NULL,
    login_timestamp DATETIME NOT NULL,

    PRIMARY KEY (user_id, product_name)
);
--rename password_recovery_token
create table password_token (
    user_id int NOT NULL,
    creation_timestamp datetime,
    token varchar(191) NOT NULL,
    unique(token),
    unique(user_id)
);
--foreign key to at_user not exists (while deleted user password_token deleted by resource method)

INSERT INTO password_token SELECT * FROM password_recovery_token prt WHERE EXISTS(SELECT 1 FROM at_user WHERE id=prt.user_id);
DROP TABLE password_recovery_token;

-- Create table for save custom logos
create table custom_logo (
   logo_type VARCHAR(9) NOT NULL,
   bin_data INT NOT NULL,

  PRIMARY KEY (logo_type),
  CONSTRAINT fk_custom_logo_bin_data_id FOREIGN KEY (bin_data) REFERENCES bin_data (bin_data_id) ON DELETE CASCADE
);

insert into system_settings ( property_name, property_value ) values ( 'time_zone_groups_enabled', 'true' );

create table time_zone_group2 (
  id autoincrement not null primary key,
  name varchar(40) not null,
  place_id VARCHAR(255) not null,
  tz_id VARCHAR(40) not null,
  city_name VARCHAR(255) not null
);

insert into time_zone_group2 (id, name, place_id, city_name, tz_id) values (-1, 'Default Time Zone Group', 'ChIJOwg_06VPwokRYv534QaPC8g', 'New York', 'America/New_York');

-- start update users time_zone to time_zone_groups
create table temp_city (
  tz_id VARCHAR(40) PRIMARY KEY NOT NULL ,
  city_name VARCHAR(255) NOT NULL,
  place_id VARCHAR(255) NOT NULL
);
-- insert temp cities
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kamchatka','Petropavlovsk-Kamchatsky','ChIJzZJKYvqZ4VgRIUrRvHH0MAE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Mexico_City','Mexico City','ChIJB3UJ2yYAzoURQeheJnYQBlQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Dili','Dili','ChIJFYEoMg3nAS0R2RJpVOlunT0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Rio_Branco','Rio Branco','ChIJ85bMirZ7f5ERPJsdfx2PuIo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Anguilla','The Valley','ChIJw4OtEaZjDowRZCw_jCcczqI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Yellowknife','Yellowknife','ChIJyYJGoyzx0VMRge9xQyQ3wbQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Kigali','Kigali','ChIJl-fYjiWk3BkRyAsdQaU2K_M');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Montevideo','Montevideo','ChIJ0_c7xv-An5URmexbNS4bMms');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/El_Aaiun','Dakhla','ChIJQ2KgOjlIIgwRcgFf7vLbciU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Lisbon','Lisbon','ChIJO_PkYRozGQ0R0DaQ5L3rAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Guayaquil','Guayaquil','ChIJX4BV6MsTLZARc6T89JKkFYA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Dominica','Roseau','ChIJi-_ydpHVFIwRc7Ors5wyL1o');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/La_Paz','La Paz','ChIJD6T1BArfXpERs4pFtHb821c');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Vancouver','Vancouver','ChIJs0-pQ_FzhlQRi_OBm-qWkbs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Recife','Recife','ChIJi0DllG8ZqwcRpuO9gvcOgOU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Sofia','Sofia','ChIJ9Xsxy4KGqkARYF6_aRKgAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/North_Dakota/Center','Center','ChIJ0S1T1Ak82FIRfLrGXKDUnx0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Nouakchott','Nouakchott','ChIJvensFmxSlg4R-eHBU70FACc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Taipei','Taipei','ChIJmQrivHKsQjQR4MIK3c41aj8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Comoro','Moroni','ChIJsUvj463-mBgRPi0ueW3ZQzk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Guadalcanal','Honiara','ChIJu6IGNI9bKG8R3ATs9q89-kM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Blanc-Sablon','Lévis','ChIJkVJUZCKVuEwRQCZNrq0MBAU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Faroe','Tórshavn','ChIJlUCZXxwuvEgRqSUCjJgJrt0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Johannesburg','Johannesburg','ChIJUWpA8GgMlR4RQUDTsdnJiiM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Moscow','Moscow','ChIJybDUc_xKtUYRTM9XV8zWRD0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Manaus','Manaus','ChIJt0d2s8gbbJIRzKll959cSCs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Qyzylorda','Kyzylorda','ChIJeddRN-D990ERS-CxjOQjI48');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Jayapura','Jayapura','ChIJa__GTh5YbGgRkgWSwPwLAyY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kuwait','Al Aḩmadī','ChIJ9bfmoOmnzz8RKq06x4In2yk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/St_Johns','St. John''s','ChIJYaIKa46jDEsRHyYSHwDUH54');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Simferopol','Simferopol','ChIJxRyZ397d6kARQAt4vC9CKZw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Los_Angeles','Los Angeles','ChIJE9on3F3HwoAR9AhGJW_fL-I');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Guadeloupe','Les Abymes','ChIJNfJk6oZIE4wRk3tuoYKN91w');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Puerto_Rico','Bayamón','ChIJxyvnWxJqA4wR2qP6mDSH8iw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Detroit','Detroit','ChIJdR3LEAHKJIgR0sS5NU6Gdlc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Brazzaville','Brazzaville','ChIJO7gbRKwyahoRQ-R9vrrqPas');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Belize','Belize City','ChIJz3czSEtYXI8RIv8SkG7c2-E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Urumqi','Ürümqi','ChIJq017_YwABjgRinB6rOtSWao');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Mahe','Victoria','ChIJaRjJelQo4CIR3jxsfn7g42I');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Kosrae','Tofol','ChIJezR9uLBcwGURC90xxERfRow');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Mayotte','Mamoudzou','ChIJ661CnZsTCiIRst9x52pu418');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Ho_Chi_Minh','Ho Chi Minh City','ChIJ0T2NLikpdTERKxE8d61aX_E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/New_York','New York City','ChIJOwg_06VPwokRYv534QaPC8g');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Tegucigalpa','Tegucigalpa','ChIJUT10v7qib48R08lqIDgiz2g');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Hermosillo','Hermosillo','ChIJ5a7femiEzoYR-X-I6ZVTPbM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Stanley','Stanley','ChIJtziJO5HSgb4RBsMqaH6coRw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Sarajevo','Sarajevo','ChIJ0Ztx7bHLWEcRPrOH3qbNLlY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Monaco','Monaco','ChIJQ1dYAInCzRIRs_8Cnm0YeKc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Addis_Ababa','Addis Ababa','ChIJLUCr9c6FSxYRSU2iN7C2Z4Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Luxembourg','Luxembourg','ChIJVyzznc1IlUcREG0F0dbRAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Tripoli','Tripoli','ChIJ2UMcwcSSqBMRhuxce5TYmY0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Rio_Gallegos','Río Gallegos','ChIJ5WYcslL5tr0RAnFkR_JBfKs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Baghdad','Baghdad','ChIJk0GnoGd_VxURLG-xo9Kp7Z0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Dawson_Creek','Dawson Creek','ChIJuYcHfjaZkVMRMDF7KhU1AQU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Denver','Denver','ChIJzxcfI6qAa4cR1jaKJ_j0jhE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Vilnius','Vilnius','ChIJ9QhkXPuT3UYRQNzpcIzRAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Cambridge_Bay','Kugluktuk','ChIJk0rD6gMCg1ERa7dLIiUa1w4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Samara','Samara','ChIJ03nYK-IYZkERCwM6u6nNlbo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Halifax','Halifax','ChIJwfrbBxQhWksR3C2LQ6bja2Y');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Sakhalin','Yuzhno-Sakhalinsk','ChIJN1cZT2sBGV8RSzlJu-cqjIQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Tallinn','Tallinn','ChIJvxZW35mUkkYRcGL8GG2zAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Aqtobe','Aqtöbe','ChIJ-YkcuEshgkERLXxMcoE_4P8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Blantyre','Blantyre','ChIJXwDAyxNF2BgR5hHY5NpYYyM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Kiritimati','Tabwakea Village','ChIJzSB82umjAnoRIX1Ii0c5PVo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Lima','Lima','ChIJZ5ZTHtvIBZERKdp7oIpTRU8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kathmandu','Kathmandu','ChIJv6p7MIoZ6zkR6rGN8Rt8E7U');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Hebron','Hebron','ChIJ-2PE7CfkAhURTBMvalxNRr4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Vevay','Vevay','ChIJc9ym8hUOaogRXArN0_bljT0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Grenada','Gouyave','ChIJDV2k1xU9OIwRupaXRVcd7xY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Isle_of_Man','Douglas','ChIJ1YEuRDCFY0gRhVR0dqBoyOY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Yakutsk','Yakutsk','ChIJfcTSoDk59lsR-6KvXLPEtGk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Paramaribo','Paramaribo','ChIJQ_cD4iA1CI0RY0A_2nkgz5c');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Port-au-Prince','Port-au-Prince','ChIJkao-UFfduY4RCKop-V2B1Tw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Casablanca','Casablanca','ChIJOxGqeEfNpw0R0w8xT9jBBgs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Amsterdam','Amsterdam','ChIJVXealLU_xkcRja_At0z9AGY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Maputo','Maputo','ChIJVdpmtiOX5h4RQrRrmld_SUI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Tirane','Durrës','ChIJx7y7X3zZTxMR7oHN5up383c');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Indianapolis','Indianapolis','ChIJA2p5p_9Qa4gRfOq5QPadjtY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Nicosia','Nicosia','ChIJVU1JymcX3hQRpcARA5ykXls');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Palau','Koror','ChIJsZZCLr0M1TIRCCEyug412Ig');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Uzhgorod','Uzhhorod','ChIJ2eO2RLkZOUcRPCoEMAGupg0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Catamarca','San Fernando del Valle de Catamarca','ChIJzZ8PHb8oJJQRGoYJFkvdHn4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Jamaica','Kingston','ChIJodLehJc_244RQK-3q78h8yQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Tell_City','Tell City','ChIJlcpY2mfkbogR-erzK9meRZQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Boise','Boise','ChIJnbRH6XLxrlQRm51nNpuYW5o');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Reykjavik','Reykjavík','ChIJw-3c7rl01kgRcWDSMKIskew');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Prague','Prague','ChIJi3lwCZyTC0cRkEAWZg-vAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Muscat','Muscat','ChIJya-ah6j_kT4RLKd5DW2HU9s');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Busingen','Büsingen','ChIJr6m2ngmBmkcRffmQypLVlVM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Brussels','Brussels','ChIJZ2jHc-2kw0cRpwJzeGY6i8E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Madeira','Funchal','ChIJq4sfUMNfYAwROaHNFSxN2P8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Ndjamena','N''Djamena','ChIJT_f8GM1jGRERO6rSdizpo7g');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Dubai','Dubai','ChIJRcbZaklDXz4RYlEphFBu5r0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Monrovia','Monrovia','ChIJwfyp1AP4CQ8Rr5SWBtdNbFs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Bogota','Bogotá','ChIJKcumLf2bP44RFDmjIFVjnSM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Nauru','Arijejen','ChIJE2gnpaYefW8Rn5XlqN_s0-c');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Antarctica/McMurdo','McMurdo Station','ChIJTbOlrXM5d68RUcVJZXHyQeI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Canary','Las Palmas de Gran Canaria','ChIJ0ZfAkQ6VQAwRZbo4U6y1Nqs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Amman','Amman','ChIJr4F5XbhfGxUR6GXc-MAwHGM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Tehran','Tehran','ChIJ2dzzH0kAjj8RvCRwVnxps_A');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Knox','Knox','ChIJ169K0d9gEYgRpg8yGM05FN0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Salta','Salta','ChIJ-bdRUaPDG5QRBvKH1SyZzaU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Cuiaba','Cuiabá','ChIJxU_YcGalnZMRDlEOkAhOUE4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Vienna','Vienna','ChIJn8o2UZ4HbUcRRluiUYrlwv0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Ojinaga','Ojinaga','ChIJQbnGwoiF7oYRQeh52jccTZw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Chuuk','Weno Town','ChIJoQ6WwVKmZ2YRe7oUN5fqb14');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Tijuana','Tijuana','ChIJ03tYJgI52YARViTmpK9LchQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/South_Georgia','Grytviken','ChIJzS-oq8Jky74RuwSGs50QxVg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Pangnirtung','Pangnirtung','ChIJGXGRrnzJf04RuU5pdocC_p0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Metlakatla','Metlakatla','ChIJj7T4kPE1DFQRczY3dom-v30');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Gaborone','Gaborone','ChIJv6nuLDxbux4RoRGul5N2oUk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Martinique','Fort-de-France','ChIJIzlHgRmnaowRy5LEV9b6kxY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Mazatlan','Mazatlán','ChIJwTcYaEFTn4YRsnI88arEpGI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Noumea','Nouméa','ChIJyzIaP2niJ2wRAN0S8yqy8Xs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Kentucky/Monticello','Monticello','ChIJtdFZV_9dXYgRkIVx-dTqaKk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Riga','Riga','ChIJ7T0H5bDP7kYRMP7yaM3PAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Niamey','Niamey','ChIJZfzdwGx10BERTrd32q9LzoE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Porto-Novo','Porto-Novo','ChIJn0veCvFZOxARVlpR2g3nZOE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Santa_Isabel','Ejido General Leandro Valle','ChIJlS0BlRvaJ4ERxUA84Dqd2e8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Azores','Ponta Delgada','ChIJlw6wdswqQwsRFsRvTvKAVXY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Manila','Manila','ChIJi8MeVwPKlzMRH8FpEHXV0Wk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Tahiti','Papeete','ChIJlWZPhxw6mnYRKzaBKFPb1mI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Kinshasa','Kinshasa','ChIJi2oG_jAxahoRjTdSH05-ixY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Cancun','Cancún','ChIJ21P2rgUrTI8Ris1fYjy3Ms4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Kentucky/Louisville','Louisville','ChIJEdVbsxoLaYgRMv1xICi009Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Oral','Oral','ChIJfUv5dji6cUERG8xqWfPwcWc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Lusaka','Lusaka','ChIJSaq8PH3zQBkR6xMgRsGT0NA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Libreville','Libreville','ChIJ7fM4VIo7fxARwivSfPLiwns');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Anchorage','Anchorage','ChIJQT-zBHaRyFYR42iEp1q6fSU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Belem','Belém','ChIJkaz7qQC5rQcR-G0mePwSC98');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Wallis','Mata-Utu','ChIJPUsabgaxyHERahbb1ENhoH8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Bahrain','Manama','ChIJLaZ2J3KvST4RwmAPB6Y4Z4s');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Juneau','Juneau','ChIJjzpqb2zeAFQREfNprlryXgY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Reunion','La Possession','ChIJOxhqeEyGgiER_LtVNDX0U4g');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Kampala','Kampala','ChIJm7N0nQ-8fRcR7G9r2T2QOEU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Windhoek','Windhoek','ChIJ7QEMs1wbCxwRO11EzEBJuOQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Andorra','les Escaldes','ChIJaxpK9OKKpRIRtp4e8lTF3v0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Menominee','Menominee','ChIJ_cWIDgihUk0R7IC-Ef0ptEo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Kralendijk','Kralendijk','ChIJJ1kXc7Abg44RUlePIm2dJys');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Pyongyang','Pyongyang','ChIJN0NP5toCfjURlapxF-J3BtQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Helsinki','Helsinki','ChIJkQYhlscLkkYRY_fiO4S9Ts0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/San_Luis','San Luis','ChIJzaZsGVQ51JURg8ye1LTjwn8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Panama','Panamá','ChIJYwPo2_GorI8RDsFC8PFdoqs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Anadyr','Anadyr','ChIJG00a1K-f_FkRR_AkXgQyGgU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/St_Kitts','Basseterre','ChIJy4VyQoobEowRz0-rkEv6xOQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Darwin','Darwin','ChIJPwRZn_ygwCwRIHwkKqgXAgM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Kerguelen','Port-aux-Français','ChIJMZFHlla-FLMROCuA2BT0e5Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Bahia','Salvador','ChIJeREjE6hQmQcRnjmRBBPvSOE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Bahia_Banderas','Valle de Banderas','ChIJpRNe0UQ4IYQRDV00G6u4MIY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Guyana','Georgetown','ChIJs8LYYK_vr40RfesAC0SkwnI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Novosibirsk','Novosibirsk','ChIJl03MkOHl30IRhenT4XMGOps');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/St_Thomas','Saint Croix','ChIJ4VdxpH3qbogRhVhqr6Gf8aE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Sitka','Sitka','ChIJuWN1b4NmBFQRdBzIn0jaQSU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Godthab','Nuuk','ChIJJSezGs4Nok4RBiNpTfsl5D0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Tashkent','Tashkent','ChIJw-l5wwyLrjgRmMulSjsyqaU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Norfolk','Kingston','ChIJq7I0n4bXS2wRk10DiFO0mxk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Paris','Paris','ChIJD7fiBh9u5kcRYJSMaMOCCwQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Malta','Qormi','ChIJ00tAlXRQDhMRzMW4X2jlbeE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Istanbul','İstanbul','ChIJawhoAASnyhQR0LABvJj-zOE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Banjul','Banjul','ChIJBzivZSmcwg4RUiyu-1EX46E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Juba','Juba','ChIJ-bXzvEqAEhcRM8RGYyg5mNg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Sao_Tome','São Tomé','ChIJg_L91l9qdhARFt6heLBTVtA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Matamoros','Heroica Matamoros','ChIJhwDRk8eUb4YRXsoTOXB4IXM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/St_Lucia','Castries','ChIJT9SmOKhnQIwRmYvFh179_zo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Yerevan','Yerevan','ChIJW4v8uNqiakARalLah655FD0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Guatemala','Guatemala City','ChIJRTNcZYChiYURJXuGW4HHcko');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Perth','Perth','ChIJc9U7KdW6MioR4E7fNbXwBAU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Mogadishu','Mogadishu','ChIJU2vOVVlCWD0R2VnMUqrqILs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Colombo','Colombo','ChIJA3B6D9FT4joRjYPTMk0uCzI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Miquelon','Miquelon','ChIJszom2yXZbUsRNIldouv_I2k');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Vincennes','Vincennes','ChIJh2QBtzLibYgReOtF1Y1dBfM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Freetown','Freetown','ChIJMwbms1bCBA8RHjwBr8jIt5c');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Baku','Baku','ChIJ-Rwh1mt9MEARa2zlel5rPzQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Pohnpei','Kolonia','ChIJnwy8NLfL2WURUO6ndwFipa8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Havana','Havana','ChIJ4QD2vUx3zYgRYA13Gn5NKU4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Asmara','Asmara','ChIJqTPJtDvybRYRxfVjryezwbg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Qatar','Doha','ChIJf-jc_zTFRT4RsdTPeJ8x2UQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Luanda','Luanda','ChIJfSyN3FzxURoRklrMXlwcDIU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Lagos','Lagos','ChIJwYCC5iqLOxARy9nDZ6OHntw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Santiago','Santiago','ChIJuzrymgbQYpYRl0jtCfRZnYc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Omsk','Omsk','ChIJCwkB9uL9qkMRGpumYTjD714');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Malabo','Malabo','ChIJHyxxSOSeZhARDN-xZtaegJc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Vaduz','Vaduz','ChIJ_S9HHUQxm0cRlxaUzj6Ulrc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Vientiane','Vientiane','ChIJIXvtBoZoJDER3-7BGIaxkx8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Cocos','West Island','ChIJdfevzszIDi8R-PQJrxM6ufg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Regina','Regina','ChIJ6z2l-0AeHFMRsVR7t5YySjU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Antananarivo','Antananarivo','ChIJs04fT-N98CER-YLAvAgGEd8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Niue','Alofi','ChIJO7duNyolnXERNt51uzaQOAk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Hong_Kong','Hong Kong','ChIJByjqov3-AzQR2pT0dDW0bUg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Accra','Accra','ChIJc6e3soSQ3w8R0y0OZdhO0b4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Whitehorse','Whitehorse','ChIJgVO8gJhEVFERSzXQZOq3PeQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Kaliningrad','Kaliningrad','ChIJqSF8S40940YR024SFgCWUFA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Kiev','Kiev','ChIJBUVa4U7P1EAR_kYBF9IxSXY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Eirunepe','Eirunepé','ChIJqTWfOFFNjpERtLXnPU-tSj8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Ushuaia','Ushuaia','ChIJvwnRurUiTLwR_OtDuj1HmFQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Zaporozhye','Zaporizhzhya','ChIJA7uF-j1n3EARSj9NB9lcZ34');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Dar_es_Salaam','Dar es Salaam','ChIJ8dabFq5LXBgR3aGGoCZrD5Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Jujuy','San Salvador de Jujuy','ChIJL6bXi04PG5QRmeT2V-BQUTE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Brunei','Kuala Belait','ChIJu52tQvyqGDIRyykNk1wixWc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Atikokan','Atikokan','ChIJi6Hs-OX2o1IRRtqeZn8J1cA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Damascus','Damascus','ChIJp8Y8QdzmGBUR8pTj0etmn2s');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Tongatapu','Nuku‘alofa','ChIJA3qajcSj9HERyVkHNwrJbzQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/North_Dakota/New_Salem','Mandan','ChIJ5Tgi0r2F11IRwHlpf1TQFLg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Apia','Apia','ChIJAxDsZKMTpXERYvcKx8jIPIk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Barbados','Bridgetown','ChIJPflM-sL2Q4wRaXCGlWrmwX0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Maseru','Maseru','ChIJczbLRjE1jB4RwCiMvILPAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Hovd','Khovd','ChIJp3_tehhhTl0RUF5r3dIAcpc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kuching','Kuching','ChIJEb-MJYQH-zERcn6xGllXctM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Makassar','Makassar','ChIJcUZs2Snjvi0RsHD3yvsLAwM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Porto_Velho','Porto Velho','ChIJC1KYWWZbMpIRixnF0lry0HU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Maldives','Male','ChIJIdbzVahMazsRfVd0CcW4B8Y');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Toronto','Toronto','ChIJpTvG15DL1IkRd8S0KlBVNTI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Tunis','Tunis','ChIJQ_V-Xn8z_RIRdQJKcU6ScdY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Majuro','Majuro','ChIJ-UL0NIMED2URe27CdEydJMQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Gambier','Rikitea','ChIJHzRpokmIJ54R5Qas3r5SA9I');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Marigot','Marigot','ChIJSSCpgKS-aowRO51TcHFKtX8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Copenhagen','Copenhagen','ChIJIz2AXDxTUkYRuGeU5t1-3QQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/San_Marino','San Marino','ChIJD6FyZLbsLBMRwPCg95vzAAo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Lubumbashi','Lubumbashi','ChIJ2ct0SKM-chkRL1uAT6f1xqE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Chisinau','Chişinău','ChIJoWm3KDZ8yUARPN1JVzDW0Tc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Samarkand','Samarqand','ChIJ930HYBkZTT8RVy8_0dk2dkg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Cordoba','Córdoba','ChIJaVuPR1-YMpQRkrBmU5pPorA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Antigua','Saint John’s','ChIJpRuO60uSEowRTzfbYy8SRnw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Efate','Port-Vila','ChIJE2CSyF5giW4RlscpI2eU5zw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Djibouti','Djibouti','ChIJsx453s8AIxYRrCEofTqaKqE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Pitcairn','Adamstown','ChIJiweo3H8POJ4RfadZONAOwA0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Cairo','Cairo','ChIJ674hC6Y_WBQRujtC6Jay33k');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Tokyo','Tokyo','ChIJXSModoWLGGARILWiCfeu2M0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Marquesas','Atuona','ChIJG7VY5eUhN3YRKiTHUDX8c5Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Santarem','Santarém','ChIJ1UqwPCH5iJIRR9Zn150_voA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Ashgabat','Ashgabat','ChIJ2YQ2qxv-bz8R6a3TYj8B3jw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kabul','Kabul','ChIJSW0ePExp0TgRKUQheDVH3-s');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Saipan','Saipan','ChIJUVyZkDSx2GYR0OGWcyirmE8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Oslo','Oslo','ChIJOfBn8mFuQUYRmh4j019gkn4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Aqtau','Zhanaozen','ChIJURbKF_bEyUER7U8X_FEUruk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Riyadh','Riyadh','ChIJmZNIDYkDLz4R1Z_nmBxNl7o');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Ouagadougou','Ouagadougou','ChIJzUSqzuyVLg4Rizt0nHlnn3k');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Sydney','Sydney','ChIJP3Sa8ziYEmsRUKgyFmh9AQM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Arctic/Longyearbyen','Longyearbyen','ChIJ31dFT9hSnEUR7JVkocqyhto');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Caracas','Caracas','ChIJB0iCza1YKowRg4SZCq4u3ZM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Mariehamn','Mariehamn','ChIJ7TXGu5vDikYRzZqPbAILQkY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kolkata','Kolkata','ChIJZ_YISduC-DkRvCxsj-Yw40M');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Belgrade','Belgrade','ChIJvT-116N6WkcR5H4X8lxkuB0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Nassau','Nassau','ChIJyduBuZl8L4kR0lBeSNMB7yo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Currie','Currie','ChIJ-3oxdPvYgKoRoPnd0E3JAwQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Bissau','Bissau','ChIJC1Q2MN7a5g4RhUjTg4gMYHw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Bamako','Bamako','ChIJkQpFJxLNUQ4RFWBQUuFAPJ4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Cayman','George Town','ChIJmZYfTPaGJY8R3b-2izzuUYw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Dhaka','Dhaka','ChIJgWsCh7C4VTcRwgRZ3btjpY8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Sao_Paulo','São Paulo','ChIJ0WGkg4FEzpQRrlsz_whLqZs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Asuncion','Asunción','ChIJ9dtpbgeoXZQRyTYZv0Z666w');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Jakarta','Jakarta','ChIJnUvjRenzaS4RoobX2g-_cVM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Melbourne','Melbourne','ChIJ90260rVG1moRkM2MIXVWBAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Bujumbura','Bujumbura','ChIJozWgKA-DwRkRw6RQe7mp6w8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Phoenix','Phoenix','ChIJy3mhUO0SK4cRrBtKNfjHaYw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Curacao','Willemstad','ChIJVy-mDF-ChI4R701VMbSSSR8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Fortaleza','Fortaleza','ChIJL1zB9iFPxwcRqid5ywZnbf0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Mauritius','Port Louis','ChIJ7wHWQUlQfCERPbu9kWwYxf0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Inuvik','Inuvik','ChIJ0Zb5lT-SFFERhLevN6KRI1I');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Almaty','Almaty','ChIJq8vFFn1ugzgRdm2YrY9mRD0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Galapagos','Puerto Ayora','ChIJa7-U-0NdqpoRNWGGLDX6QZg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Broken_Hill','Broken Hill','ChIJzcJS3mAz72oRcAFEkLQJBgQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/El_Salvador','San Salvador','ChIJXXcRtGcwY48Rllz7k4iXdR8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Nome','Nome','ChIJeVU4FigaMVcRTIR2WHExdUE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Boa_Vista','Boa Vista','ChIJ26Sqy8oFk40RRV_XqcdlLrc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Monterrey','Monterrey','ChIJ9fg3tDGVYoYRlJjIasrT06M');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Conakry','Conakry','ChIJKeGIoyrRHA8R1EHTaRXeZoo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Tucuman','San Miguel de Tucumán','ChIJA2nF1pI3IpQRJ2XFtZJbjfg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Rangoon','Yangon','ChIJaxk-Ip6UwTARtAsI-HHS-1Y');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Bougainville','Arawa','ChIJ4-9aWf-TzmgRC8wL4bCd6ps');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Kuala_Lumpur','Kuala Lumpur','ChIJ5-rvAcdJzDERfSgcL1uO2fQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Algiers','Algiers','ChIJP5ogelFybogRjznXJdcrHy8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Chicago','Chicago','ChIJ7cv00DwsDogRAMDACa2m4K8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Rome','Rome','ChIJu46S-ZZhLxMROG5lkwZ3D7k');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Dublin','Dublin','ChIJL6wn6oAOZ0gRoHExl6nHAAo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Chihuahua','Chihuahua','ChIJM0BIXZ1E6oYRex3dBqen8bc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Aden','Aden','ChIJL8JeUdYcHhYR6W9pI8OzX5Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Guernsey','Saint Peter Port','ChIJLdcIRv1yDUgRamGVynA3wYE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Abidjan','Abidjan','ChIJIZGVEVPqwQ8RpiGS4dwN5z8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Swift_Current','Swift Current','ChIJh28IX7TfEFMR0_rE2ZHGqh4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Bratislava','Bratislava','ChIJl2HKCjaJbEcRaEOI_YKbH2M');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Marengo','English','ChIJJ9ljo_e3bogRv9HAma9Kl9M');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Merida','Mérida','ChIJFw1Fq1xxVo8RCeurFVcV_F0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Auckland','Auckland','ChIJ' & CHR(45) & CHR(45) & 'acWvtHDW0RF5miQ2HvAAU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Athens','Athens','ChIJ8UNwBh-9oRQR3Y1mdkU1Nic');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Port_of_Spain','Port of Spain','ChIJScNLF94HNowRhUINFlP23t0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Novokuznetsk','Novokuznetsk','ChIJ5Z4iV1fA0EIRQNl8enxpDiM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Zagreb','Zagreb','ChIJOcwCyZLWZUcRisL7KJYkRTo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Madrid','Madrid','ChIJgTwKgJcpQg0RaSKMYcHeNsQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Cape_Verde','Mindelo','ChIJF_xJA68eTwkR8_S4kyktBcc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Adelaide','Adelaide','ChIJP7Mmxcc1t2oRQMaOYlQ2AwQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Vladivostok','Vladivostok','ChIJhdRJUrqcs18RNX6W3dQEZxg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Chatham','Waitangi','ChIJkSUkCGEtK20RAFt5hIbvAAU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Thimphu','Thimphu','ChIJtzcglhmU4TkR0WAFZuL_AXw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Gibraltar','Gibraltar','ChIJNb4UJ3a_DA0R63QwjEmqPW8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Managua','Managua','ChIJC4gH2Q1WcY8RakxPFKL0Xmw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Mendoza','Mendoza','ChIJv3lRxD4JfpYROvoO0vZ4WiA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Brisbane','Brisbane','ChIJM9KTrJpXkWsRQK_e81qjAgQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Cayenne','Cayenne','ChIJnbdK2zo9Eo0RKLaviyl-VnM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Port_Moresby','Port Moresby','ChIJq5JWHNQwAmkRxJifiIG0pj8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Dakar','Dakar','ChIJcbvFs_VywQ4RH7JdLdkXfLE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Vatican','Vatican City','ChIJJTk-DGZgLxMRPGxQNTiMSQA');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Winnipeg','Winnipeg','ChIJESsa-ftz6lIRZMq5xvoaKis');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Podgorica','Podgorica','ChIJfYYGlgfoTRMR6YpY6naK92s');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Tarawa','Tarawa','ChIJA4cCwpF8ZGURhONuQKhpddU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Costa_Rica','San José','ChIJxRUNxULjoI8RgrgRn2pqdOY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Volgograd','Volgograd','ChIJZ3ZbuHUzBUERQdpXzpwXDYg');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Pago_Pago','Pago Pago','ChIJyf1IkreEpnERK0EVzuwzjjU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Magadan','Magadan','ChIJ6UpSLYGEaVkRWwac4edMyTk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Harare','Harare','ChIJNdvdG-6kMRkRL08T5Zs7FKU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Goose_Bay','Labrador City','ChIJoe3xmnZL9UwRY9CUc9V8SzE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Ceuta','Ceuta','ChIJ76wp6eejDA0RQMahjP1jBAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Pontianak','Pontianak','ChIJm3mwBPZYHS4R4__JH1D5HlE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Bucharest','Bucharest','ChIJT608vzr5sUARKKacfOMyBqw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Dawson','Dawson City','ChIJt7X11MvjSFER_R-tXLl6jUo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Beirut','Beirut','ChIJj6eAWCEXHxURtDaY6bqCkXI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/La_Rioja','La Rioja','ChIJ5feWM4fZJ5QRysdyiTScHD4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Thunder_Bay','Thunder Bay','ChIJjekWTHchWU0RdIsdjzRXBT0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Honolulu','Honolulu','ChIJTUbDjDsYAHwRbJen81_1KEs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Moncton','Moncton','ChIJZRfUGCm5oEwRxGNOOjMKwQ0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Grand_Turk','Cockburn Town','ChIJv9PjLU7Uso4Rn2cP6wvkvQc');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Easter','Остров Пасхи','ChIJ26i2Z57iJpcRgZArfxCG2_E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Araguaina','Araguaína','ChIJ-0-MXd4N2ZIR_MRN5hXoMEo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Rankin_Inlet','Rankin Inlet','ChIJKTAgDGD9C1IRp8tHbsKAPY4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/North_Dakota/Beulah','Beulah','ChIJOe6TNwmJJ1MRZe5G4VwXk2Q');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Montserrat','Brades','ChIJS9X5cRlTEowRWhWea9Lgfpk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Fiji','Suva','ChIJrU8RQiLeG24RyddNu3R1B-I');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Mbabane','Mbabane','ChIJBw8yR-HO6B4Rn93hevKYv3o');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Maceio','Maceió','ChIJSYho1vxGAQcRU3bgQ1tyLO4');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/London','London','ChIJdd4hrwug2EcRmSrV3Vo6llI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Guam','Hagåtña','ChIJO8V-KoF3H2cRH_Xu-PRVp5w');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Creston','Creston','ChIJjaASpuFiY1MRxocXVm-rB3U');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Lome','Lomé','ChIJGVQYE8HhIxARHUGvLEK1JDI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Singapore','Singapore','ChIJyY4rtGcX2jERIKTarqz3AAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Krasnoyarsk','Krasnoyarsk','ChIJ4zf_ocmv11wR_0fWj0bhl9U');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/Bermuda','Saint George','ChIJ2-ZT6I5yLYoRd-VeQN-TdLo');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Irkutsk','Irkutsk','ChIJZfbiU9M6qF0RTunYVhTN1jE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Seoul','Seoul','ChIJzWXFYYuifDUR64Pq5LTtioU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Bangkok','Bangkok','ChIJ82ENKDJgHTERIEjiXbIAAQE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Budapest','Budapest','ChIJyc_U0TTDQUcRYBEeDCnEAAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Yekaterinburg','Yekaterinburg','ChIJS9tioOplwUMRIH9W99dDAtU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Santo_Domingo','Santo Domingo','ChIJq6V-EPGJr44RZMEVJ7iHxdY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Atlantic/St_Helena','Jamestown','ChIJ19zk64Ti6gQRib0Wbx7aWdY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Skopje','Skopje','ChIJpaKajKUVVBMRICCHYMKI7bI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Glace_Bay','Glace Bay','ChIJt2_q3snhZ0sRaNZPIXYopAk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Douala','Douala','ChIJbf7h4osSYRARi8SBR0Sh2pI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Zurich','Zürich','ChIJGaK-SZcLkEcRA9wf5_GNbuY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Fakaofo','Atafu Village','ChIJz7IEMfk2TnAR3i0p4eF7cTw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Bangui','Bangui','ChIJA6pX7RzvuBARGVX-9l1svQk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Karachi','Karachi','ChIJv0sdZQY-sz4RIwxaVUQv-Zw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/San_Juan','San Juan','ChIJl9Q8oylAgZYRs_w8I6Cj878');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Nairobi','Nairobi','ChIJp0lN2HIRLxgRTJKXslQCz_c');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Stockholm','Stockholm','ChIJywtkGTF2X0YRZnedZ9MnDag');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Adak','Dutch Harbor','ChIJd3MWwaKwq1cRPvcITptO5G8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Edmonton','Edmonton','ChIJI__egEUioFMRXRX2SgygH0E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Iqaluit','Iqaluit','ChIJB9qKcEcW000RwimRfAbQHh8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Winamac','Winamac','ChIJ08WQUsDCE4gRpptaqfrOqMI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Dushanbe','Dushanbe','ChIJm_h70m_RtTgRRP2h3o03-d0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Phnom_Penh','Phnom Penh','ChIJ42tqxz1RCTERuyW1WugOAZw');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Choibalsan','Choibalsan','ChIJOXXp3IxT3F0RivSQ_f-G52E');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Shanghai','Shanghai','ChIJMzz1sUBwsjURoWTDI5QSlQI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Ljubljana','Ljubljana','ChIJ0YaYlvUxZUcRIOw_ghz4AAQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Indian/Christmas','Flying Fish Cove','ChIJzSMEi12b9S4RFBQdct2nE8U');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Berlin','Berlin','ChIJAVkDPzdOqEcRcDteW0YgIQQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Argentina/Buenos_Aires','Buenos Aires','ChIJvQz5TjvKvJURh47oiC6Bs6A');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Ulaanbaatar','Ulan Bator','ChIJq4qx4luSll0Rf4ShZHiSBuY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Warsaw','Warsaw','ChIJAZ-GmmbMHkcR_NPqiCq-8HI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Jerusalem','Jerusalem','ChIJS_zBNNbXAhURy-FuRT5ib9k');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Gaza','Gaza','ChIJZydUTgV__RQRkmMEE8mN-X8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Africa/Khartoum','Khartoum','ChIJv8o3mN6PjhYRQNtnft5VHxk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Jersey','Saint Helier','ChIJFZrZ4KBSDEgRHarF21WFdPM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/St_Vincent','Kingstown','ChIJF1yH11BRR4wR_OIsbeKqZS8');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Macau','Macau','ChIJmY8AduF6ATQRrXXv59PpHbk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Tbilisi','Tbilisi','ChIJa2JP5tcMREARo25X4u2E0GE');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Europe/Minsk','Minsk','ChIJ02oeW9PP20YR2XC13VO4YQs');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Campo_Grande','Campo Grande','ChIJJ58ra3LmhpQRwdKEvJ5GqPU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Pacific/Rarotonga','Avarua','ChIJYW7jFIjRV3ERb-IakbCs6os');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indiana/Petersburg','Petersburg','ChIJqVBRdcoNbogRZq4XMNMv2AQ');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Bishkek','Bishkek','ChIJgcizkdy3njgRfeLefPW6Lkk');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Australia/Hobart','Hobart','ChIJ7c8s5YR1bqoRMBXe0E3JAwU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('GMT-1100','Pago Pago','ChIJyf1IkreEpnERK0EVzuwzjjU');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('GMT-0200','Nuuk','ChIJJSezGs4Nok4RBiNpTfsl5D0');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Indianapolis','Indianapolis','ChIJA2p5p_9Qa4gRfOq5QPadjtY');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('America/Buenos_Aires','Buenos Aires','ChIJvQz5TjvKvJURh47oiC6Bs6A');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('UTC','London','ChIJdd4hrwug2EcRmSrV3Vo6llI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('GMT','London','ChIJdd4hrwug2EcRmSrV3Vo6llI');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Calcutta','Calcutta','ChIJZ_YISduC-DkRvCxsj-Yw40M');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Katmandu','Katmandu','ChIJv6p7MIoZ6zkR6rGN8Rt8E7U');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('Asia/Srednekolymsk','Srednekolymsk','ChIJbfF5Du_ZLFoRmUrZ7lZxpqM');
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES ('GMT+1200','Suva','ChIJrU8RQiLeG24RyddNu3R1B-I');
-- end of insert temp cities

CREATE TABLE temp_tz_city (
  id    autoincrement NOT NULL  PRIMARY KEY,
  tz_id VARCHAR(40) UNIQUE
);

INSERT INTO temp_tz_city (tz_id)
  SELECT time_zone
  FROM at_user
  WHERE time_zone IS NOT NULL and exists (select * from temp_city where tz_id = time_zone)
  GROUP BY time_zone;

INSERT INTO time_zone_group2 (id, name, place_id, tz_id, city_name)
    SELECT
    temp_tz_city.id,
    temp_city.city_name & ' Office',
    place_id,
    temp_tz_city.tz_id,
    city_name
  FROM temp_city INNER   JOIN temp_tz_city ON temp_tz_city.tz_id = temp_city.tz_id;

create table time_zone_group (
  id autoincrement not null primary key,
  name varchar(40) not null,
  place_id VARCHAR(255) not null,
  tz_id VARCHAR(40) not null,
  city_name VARCHAR(255) not null,
  ct int
);

UPDATE time_zone_group2, temp_city set
  time_zone_group2.place_id = temp_city.place_id,
  time_zone_group2.tz_id = temp_city.tz_id,
  time_zone_group2.city_name = temp_city.city_name,
  time_zone_group2.name =  temp_city.city_name & ' Office'
where time_zone_group2.id = -1
and exists
 ( SELECT property_value
    FROM system_settings
    WHERE property_name = 'default_time_zone' AND property_value = temp_city.tz_id);

insert into time_zone_group
 select id, name, place_id, tz_id, city_name
 from time_zone_group2 g1;

create table counters(
  id int,
  ct int
);

insert into counters
    select g1.id as id, count(g1.id) as ct
    from time_zone_group2 g2
            left  join
         time_zone_group2 g1 on g2.name = g1.name  where g2.id < g1.id
  group by g1.id;

update time_zone_group left join counters on time_zone_group.id = counters.id  set  time_zone_group.ct = counters.ct;

drop table time_zone_group2;
drop table counters;

update time_zone_group set name = name & " " & ct where ct is not null ;

alter table time_zone_group drop column ct;
alter table time_zone_group ADD CONSTRAINT  unique_time_zone_group_name unique (name);

alter table at_user add column time_zone_group_id int not null;
update at_user set time_zone_group_id = -1;

UPDATE at_user
  INNER JOIN temp_tz_city ON at_user.time_zone = temp_tz_city.tz_id
SET time_zone_group_id = temp_tz_city.id;

UPDATE at_user
SET time_zone_group_id = -1
WHERE time_zone IS NULL OR NOT exists( SELECT tz_id
                                       FROM temp_tz_city
                                       WHERE time_zone = tz_id );

 --disable feature tzg if exists only default tzg
update system_settings set property_value = false
	where (select count(*) from time_zone_group) = 1 and  not exists (select username from at_user WHERE (select count(*) from at_user) = 1 and username = 'admin')
    and property_name = 'time_zone_groups_enabled';


DROP TABLE temp_tz_city;
DROP TABLE temp_city;

DELETE FROM system_settings WHERE property_name = "default_time_zone";
ALTER TABLE at_user DROP COLUMN time_zone;
--end update users time_zone to time_zone_groups


insert into notification_rule_params (rule_id, param_name, param_value)
  select rule_id, left(param_name, len(param_name) - 18) & 'selectedGroupType', 'USER_GROUP' from notification_rule_params where param_name like '*.selectedUserGroups'
    group by rule_id, param_name;
update notification_rule_params set param_name = left(param_name, len(param_name) - 18) & 'selectedGroups'
  where param_name like '*.selectedUserGroups';

insert into user_settings (user_id, param_name, param_value, param_category)
  select user_id, 'filter.groupType', 'USER_GROUP', 'user_list' from user_settings where param_name = 'filter.userGroupIds' and param_category = 'user_list'
    group by user_id;
update user_settings set param_name = 'filter.groupIds'
  where param_name = 'filter.userGroupIds' and param_category = 'user_list';

insert into user_settings (user_id, param_name, param_value, param_category)
  select user_id, 'groupType', 'USER_GROUP', 'lock_tt' from user_settings where param_name = 'selectedUserGroups' and param_category = 'lock_tt'
    group by user_id;
update user_settings set param_name = 'selectedGroups'
  where param_name = 'selectedUserGroups' and param_category = 'lock_tt';

insert into user_settings (user_id, param_name, param_value, param_category)
  select user_id, 'groupType', 'USER_GROUP', 'lt_planning' from user_settings where param_name = 'userGroupsFilter' and param_category = 'lt_planning'
    group by user_id;
update user_settings set param_name = 'groupsFilter'
  where param_name = 'userGroupsFilter' and param_category = 'lt_planning';

INSERT INTO report_params (config_id, param_name, param_value)
  SELECT DISTINCT config_id, 'userSelection.groupType', 'USER_GROUP' FROM report_params WHERE param_name = 'userSelection.selectedGroups';

delete from user_tt_approver where not exists (select id from at_user where id = user_id);
delete from user_tt_approver where not exists (select id from at_user where id = approver_id);
delete from user_ltr_approver where not exists (select id from at_user where id = user_id);
delete from user_ltr_approver where not exists (select id from at_user where id = approver_id);

-- actiPLANS push notifications

create table ap_mobile_notification (
  id autoincrement not null primary key,
  user_id int not null,
  leave_date date not null
  -- Cannot add constraint due to MS Access limitation. Hopefully, we won't need it since actiPLANS doesn't use Access.
  -- constraint fk_ap_mobile_notification_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE
);

-- permissions templates

CREATE TABLE permissions_template (
  id  AUTOINCREMENT NOT NULL PRIMARY KEY ,
  name VARCHAR(191) NOT NULL UNIQUE
);

CREATE TABLE permissions_template_param (
  perm_template_id INT NOT NULL,
  permission_id    INT NOT NULL,

  CONSTRAINT fk_permissions_template_param_permissions_template_id FOREIGN KEY (perm_template_id) REFERENCES permissions_template (id)
    ON DELETE CASCADE,
  CONSTRAINT fk_permissions_template_param_access_right_id FOREIGN KEY (permission_id) REFERENCES access_right (id)
    ON DELETE CASCADE
);

INSERT INTO permissions_template (id,name) VALUES (-1,'New user');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,12);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,5);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,11);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,14);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,1);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,13);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,8);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,2);

INSERT INTO permissions_template (id,name) VALUES (1,'Regular user');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(1,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(1,13);

INSERT INTO permissions_template (id,name) VALUES (2,'Manager');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,8);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,2);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,12);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,1);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,13);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,5);

INSERT INTO permissions_template (id,name) VALUES (3,'actiTIME administrator');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,12);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,5);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,11);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,14);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,1);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,13);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,8);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,2);

-- delete Project Assignments notification rules
delete from notification_rule where type = 5;

ALTER TABLE mail_message ALTER COLUMN subject VARCHAR(255) NOT NULL;
ALTER TABLE license ALTER COLUMN body LONGTEXT NOT NULL ;

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
values (34, 0, now());