update system_settings set property_name = 'ap_sick_days_balance_enabled' where property_name = 'sick_days_balance_enabled';
update system_settings set property_name = 'sick_days_balance_enabled' where property_name = 'at_sick_days_balance_enabled';

alter table at_user add column is_activated tinyint(1) not null default 1;
update at_user set is_activated=1;

drop table if exists mail_template;

-- Moved to user_settings with 'default_schedule' param_category
drop table if exists user_work_schedule_calendar;

alter table at_user modify  md5_password varchar(32) null;

-- Create activate_user_token
create table activation_info(
    user_id int(3) unsigned NOT NULL UNIQUE,
    token varchar(191) UNIQUE,
    owner_id int(3) unsigned NOT NULL,
    product_name VARCHAR(9) NOT NULL,
    CONSTRAINT fk_activate_token_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE
) ENGINE=InnoDB;

-- Create table for last login dates
create table user_last_login_time(
    user_id int(3) unsigned NOT NULL,
    product_name VARCHAR(9) NOT NULL,
    login_timestamp DATETIME NOT NULL,

    PRIMARY KEY (user_id, product_name)
) ENGINE=InnoDB;

-- Create table for save custom logos
create table custom_logo (
   logo_type VARCHAR(9) NOT NULL,
   bin_data INT(3) UNSIGNED NOT NULL,

  PRIMARY KEY (logo_type),
  CONSTRAINT fk_custom_logo_bin_data_id FOREIGN KEY (bin_data) REFERENCES bin_data (bin_data_id) ON DELETE CASCADE

) ENGINE=InnoDB;

-- Create password_recovery_token
create table password_token (
    user_id int(3) unsigned NOT NULL UNIQUE,
    creation_timestamp timestamp,
    token varchar(191) NOT NULL UNIQUE,
    CONSTRAINT fk_password_token_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE
)
ENGINE=InnoDB;

INSERT INTO password_token SELECT * FROM password_recovery_token prt WHERE EXISTS(SELECT 1 FROM at_user WHERE id=prt.user_id);
DROP TABLE password_recovery_token;

insert into system_settings ( property_name, property_value ) values ( 'time_zone_groups_enabled', 'true' );

create table time_zone_group2 (
 id int(3) not null auto_increment primary key,
 name varchar(40) not null,
 place_id VARCHAR(255) not null,
 tz_id VARCHAR(40) not null,
 city_name VARCHAR(255) not null
) engine = InnoDB;


insert into time_zone_group2 (id, name, place_id, city_name, tz_id) values (-1, 'Default Time Zone Group', 'ChIJOwg_06VPwokRYv534QaPC8g', 'New York', 'America/New_York');

/*start update users time_zone to time_zone_groups    */
create table temp_city (
  tz_id VARCHAR(40) PRIMARY KEY NOT NULL ,
  city_name VARCHAR(255) NOT NULL,
  place_id VARCHAR(255) NOT NULL
);
-- insert temp cities
INSERT INTO temp_city (tz_id,city_name,place_id) VALUES
  ('Asia/Kamchatka','Petropavlovsk-Kamchatsky','ChIJzZJKYvqZ4VgRIUrRvHH0MAE'),
  ('America/Mexico_City','Mexico City','ChIJB3UJ2yYAzoURQeheJnYQBlQ'),
  ('Asia/Dili','Dili','ChIJFYEoMg3nAS0R2RJpVOlunT0'),
  ('America/Rio_Branco','Rio Branco','ChIJ85bMirZ7f5ERPJsdfx2PuIo'),
  ('America/Anguilla','The Valley','ChIJw4OtEaZjDowRZCw_jCcczqI'),
  ('America/Yellowknife','Yellowknife','ChIJyYJGoyzx0VMRge9xQyQ3wbQ'),
  ('Africa/Kigali','Kigali','ChIJl-fYjiWk3BkRyAsdQaU2K_M'),
  ('America/Montevideo','Montevideo','ChIJ0_c7xv-An5URmexbNS4bMms'),
  ('Africa/El_Aaiun','Dakhla','ChIJQ2KgOjlIIgwRcgFf7vLbciU'),
  ('Europe/Lisbon','Lisbon','ChIJO_PkYRozGQ0R0DaQ5L3rAAQ'),
  ('America/Guayaquil','Guayaquil','ChIJX4BV6MsTLZARc6T89JKkFYA'),
  ('America/Dominica','Roseau','ChIJi-_ydpHVFIwRc7Ors5wyL1o'),
  ('America/La_Paz','La Paz','ChIJD6T1BArfXpERs4pFtHb821c'),
  ('America/Vancouver','Vancouver','ChIJs0-pQ_FzhlQRi_OBm-qWkbs'),
  ('America/Recife','Recife','ChIJi0DllG8ZqwcRpuO9gvcOgOU'),
  ('Europe/Sofia','Sofia','ChIJ9Xsxy4KGqkARYF6_aRKgAAQ'),
  ('America/North_Dakota/Center','Center','ChIJ0S1T1Ak82FIRfLrGXKDUnx0'),
  ('Africa/Nouakchott','Nouakchott','ChIJvensFmxSlg4R-eHBU70FACc'),
  ('Asia/Taipei','Taipei','ChIJmQrivHKsQjQR4MIK3c41aj8'),
  ('Indian/Comoro','Moroni','ChIJsUvj463-mBgRPi0ueW3ZQzk'),
  ('Pacific/Guadalcanal','Honiara','ChIJu6IGNI9bKG8R3ATs9q89-kM'),
  ('America/Blanc-Sablon','Lévis','ChIJkVJUZCKVuEwRQCZNrq0MBAU'),
  ('Atlantic/Faroe','Tórshavn','ChIJlUCZXxwuvEgRqSUCjJgJrt0'),
  ('Africa/Johannesburg','Johannesburg','ChIJUWpA8GgMlR4RQUDTsdnJiiM'),
  ('Europe/Moscow','Moscow','ChIJybDUc_xKtUYRTM9XV8zWRD0'),
  ('America/Manaus','Manaus','ChIJt0d2s8gbbJIRzKll959cSCs'),
  ('Asia/Qyzylorda','Kyzylorda','ChIJeddRN-D990ERS-CxjOQjI48'),
  ('Asia/Jayapura','Jayapura','ChIJa__GTh5YbGgRkgWSwPwLAyY'),
  ('Asia/Kuwait','Al Aḩmadī','ChIJ9bfmoOmnzz8RKq06x4In2yk'),
  ('America/St_Johns','St. John''s','ChIJYaIKa46jDEsRHyYSHwDUH54'),
  ('Europe/Simferopol','Simferopol','ChIJxRyZ397d6kARQAt4vC9CKZw'),
  ('America/Los_Angeles','Los Angeles','ChIJE9on3F3HwoAR9AhGJW_fL-I'),
  ('America/Guadeloupe','Les Abymes','ChIJNfJk6oZIE4wRk3tuoYKN91w'),
  ('America/Puerto_Rico','Bayamón','ChIJxyvnWxJqA4wR2qP6mDSH8iw'),
  ('America/Detroit','Detroit','ChIJdR3LEAHKJIgR0sS5NU6Gdlc'),
  ('Africa/Brazzaville','Brazzaville','ChIJO7gbRKwyahoRQ-R9vrrqPas'),
  ('America/Belize','Belize City','ChIJz3czSEtYXI8RIv8SkG7c2-E'),
  ('Asia/Urumqi','Ürümqi','ChIJq017_YwABjgRinB6rOtSWao'),
  ('Indian/Mahe','Victoria','ChIJaRjJelQo4CIR3jxsfn7g42I'),
  ('Pacific/Kosrae','Tofol','ChIJezR9uLBcwGURC90xxERfRow'),
  ('Indian/Mayotte','Mamoudzou','ChIJ661CnZsTCiIRst9x52pu418'),
  ('Asia/Ho_Chi_Minh','Ho Chi Minh City','ChIJ0T2NLikpdTERKxE8d61aX_E'),
  ('America/New_York','New York City','ChIJOwg_06VPwokRYv534QaPC8g'),
  ('America/Tegucigalpa','Tegucigalpa','ChIJUT10v7qib48R08lqIDgiz2g'),
  ('America/Hermosillo','Hermosillo','ChIJ5a7femiEzoYR-X-I6ZVTPbM'),
  ('Atlantic/Stanley','Stanley','ChIJtziJO5HSgb4RBsMqaH6coRw'),
  ('Europe/Sarajevo','Sarajevo','ChIJ0Ztx7bHLWEcRPrOH3qbNLlY'),
  ('Europe/Monaco','Monaco','ChIJQ1dYAInCzRIRs_8Cnm0YeKc'),
  ('Africa/Addis_Ababa','Addis Ababa','ChIJLUCr9c6FSxYRSU2iN7C2Z4Q'),
  ('Europe/Luxembourg','Luxembourg','ChIJVyzznc1IlUcREG0F0dbRAAQ'),
  ('Africa/Tripoli','Tripoli','ChIJ2UMcwcSSqBMRhuxce5TYmY0'),
  ('America/Argentina/Rio_Gallegos','Río Gallegos','ChIJ5WYcslL5tr0RAnFkR_JBfKs'),
  ('Asia/Baghdad','Baghdad','ChIJk0GnoGd_VxURLG-xo9Kp7Z0'),
  ('America/Dawson_Creek','Dawson Creek','ChIJuYcHfjaZkVMRMDF7KhU1AQU'),
  ('America/Denver','Denver','ChIJzxcfI6qAa4cR1jaKJ_j0jhE'),
  ('Europe/Vilnius','Vilnius','ChIJ9QhkXPuT3UYRQNzpcIzRAAQ'),
  ('America/Cambridge_Bay','Kugluktuk','ChIJk0rD6gMCg1ERa7dLIiUa1w4'),
  ('Europe/Samara','Samara','ChIJ03nYK-IYZkERCwM6u6nNlbo'),
  ('America/Halifax','Halifax','ChIJwfrbBxQhWksR3C2LQ6bja2Y'),
  ('Asia/Sakhalin','Yuzhno-Sakhalinsk','ChIJN1cZT2sBGV8RSzlJu-cqjIQ'),
  ('Europe/Tallinn','Tallinn','ChIJvxZW35mUkkYRcGL8GG2zAAQ'),
  ('Asia/Aqtobe','Aqtöbe','ChIJ-YkcuEshgkERLXxMcoE_4P8'),
  ('Africa/Blantyre','Blantyre','ChIJXwDAyxNF2BgR5hHY5NpYYyM'),
  ('Pacific/Kiritimati','Tabwakea Village','ChIJzSB82umjAnoRIX1Ii0c5PVo'),
  ('America/Lima','Lima','ChIJZ5ZTHtvIBZERKdp7oIpTRU8'),
  ('Asia/Kathmandu','Kathmandu','ChIJv6p7MIoZ6zkR6rGN8Rt8E7U'),
  ('Asia/Hebron','Hebron','ChIJ-2PE7CfkAhURTBMvalxNRr4'),
  ('America/Indiana/Vevay','Vevay','ChIJc9ym8hUOaogRXArN0_bljT0'),
  ('America/Grenada','Gouyave','ChIJDV2k1xU9OIwRupaXRVcd7xY'),
  ('Europe/Isle_of_Man','Douglas','ChIJ1YEuRDCFY0gRhVR0dqBoyOY'),
  ('Asia/Yakutsk','Yakutsk','ChIJfcTSoDk59lsR-6KvXLPEtGk'),
  ('America/Paramaribo','Paramaribo','ChIJQ_cD4iA1CI0RY0A_2nkgz5c'),
  ('America/Port-au-Prince','Port-au-Prince','ChIJkao-UFfduY4RCKop-V2B1Tw'),
  ('Africa/Casablanca','Casablanca','ChIJOxGqeEfNpw0R0w8xT9jBBgs'),
  ('Europe/Amsterdam','Amsterdam','ChIJVXealLU_xkcRja_At0z9AGY'),
  ('Africa/Maputo','Maputo','ChIJVdpmtiOX5h4RQrRrmld_SUI'),
  ('Europe/Tirane','Durrës','ChIJx7y7X3zZTxMR7oHN5up383c'),
  ('America/Indiana/Indianapolis','Indianapolis','ChIJA2p5p_9Qa4gRfOq5QPadjtY'),
  ('Asia/Nicosia','Nicosia','ChIJVU1JymcX3hQRpcARA5ykXls'),
  ('Pacific/Palau','Koror','ChIJsZZCLr0M1TIRCCEyug412Ig'),
  ('Europe/Uzhgorod','Uzhhorod','ChIJ2eO2RLkZOUcRPCoEMAGupg0'),
  ('America/Argentina/Catamarca','San Fernando del Valle de Catamarca','ChIJzZ8PHb8oJJQRGoYJFkvdHn4'),
  ('America/Jamaica','Kingston','ChIJodLehJc_244RQK-3q78h8yQ'),
  ('America/Indiana/Tell_City','Tell City','ChIJlcpY2mfkbogR-erzK9meRZQ'),
  ('America/Boise','Boise','ChIJnbRH6XLxrlQRm51nNpuYW5o'),
  ('Atlantic/Reykjavik','Reykjavík','ChIJw-3c7rl01kgRcWDSMKIskew'),
  ('Europe/Prague','Prague','ChIJi3lwCZyTC0cRkEAWZg-vAAQ'),
  ('Asia/Muscat','Muscat','ChIJya-ah6j_kT4RLKd5DW2HU9s'),
  ('Europe/Busingen','Büsingen','ChIJr6m2ngmBmkcRffmQypLVlVM'),
  ('Europe/Brussels','Brussels','ChIJZ2jHc-2kw0cRpwJzeGY6i8E'),
  ('Atlantic/Madeira','Funchal','ChIJq4sfUMNfYAwROaHNFSxN2P8'),
  ('Africa/Ndjamena','N''Djamena','ChIJT_f8GM1jGRERO6rSdizpo7g'),
  ('Asia/Dubai','Dubai','ChIJRcbZaklDXz4RYlEphFBu5r0'),
  ('Africa/Monrovia','Monrovia','ChIJwfyp1AP4CQ8Rr5SWBtdNbFs'),
  ('America/Bogota','Bogotá','ChIJKcumLf2bP44RFDmjIFVjnSM'),
  ('Pacific/Nauru','Arijejen','ChIJE2gnpaYefW8Rn5XlqN_s0-c'),
  ('Antarctica/McMurdo','McMurdo Station','ChIJTbOlrXM5d68RUcVJZXHyQeI'),
  ('Atlantic/Canary','Las Palmas de Gran Canaria','ChIJ0ZfAkQ6VQAwRZbo4U6y1Nqs'),
  ('Asia/Amman','Amman','ChIJr4F5XbhfGxUR6GXc-MAwHGM'),
  ('Asia/Tehran','Tehran','ChIJ2dzzH0kAjj8RvCRwVnxps_A'),
  ('America/Indiana/Knox','Knox','ChIJ169K0d9gEYgRpg8yGM05FN0'),
  ('America/Argentina/Salta','Salta','ChIJ-bdRUaPDG5QRBvKH1SyZzaU'),
  ('America/Cuiaba','Cuiabá','ChIJxU_YcGalnZMRDlEOkAhOUE4'),
  ('Europe/Vienna','Vienna','ChIJn8o2UZ4HbUcRRluiUYrlwv0'),
  ('America/Ojinaga','Ojinaga','ChIJQbnGwoiF7oYRQeh52jccTZw'),
  ('Pacific/Chuuk','Weno Town','ChIJoQ6WwVKmZ2YRe7oUN5fqb14'),
  ('America/Tijuana','Tijuana','ChIJ03tYJgI52YARViTmpK9LchQ'),
  ('Atlantic/South_Georgia','Grytviken','ChIJzS-oq8Jky74RuwSGs50QxVg'),
  ('America/Pangnirtung','Pangnirtung','ChIJGXGRrnzJf04RuU5pdocC_p0'),
  ('America/Metlakatla','Metlakatla','ChIJj7T4kPE1DFQRczY3dom-v30'),
  ('Africa/Gaborone','Gaborone','ChIJv6nuLDxbux4RoRGul5N2oUk'),
  ('America/Martinique','Fort-de-France','ChIJIzlHgRmnaowRy5LEV9b6kxY'),
  ('America/Mazatlan','Mazatlán','ChIJwTcYaEFTn4YRsnI88arEpGI'),
  ('Pacific/Noumea','Nouméa','ChIJyzIaP2niJ2wRAN0S8yqy8Xs'),
  ('America/Kentucky/Monticello','Monticello','ChIJtdFZV_9dXYgRkIVx-dTqaKk'),
  ('Europe/Riga','Riga','ChIJ7T0H5bDP7kYRMP7yaM3PAAQ'),
  ('Africa/Niamey','Niamey','ChIJZfzdwGx10BERTrd32q9LzoE'),
  ('Africa/Porto-Novo','Porto-Novo','ChIJn0veCvFZOxARVlpR2g3nZOE'),
  ('America/Santa_Isabel','Ejido General Leandro Valle','ChIJlS0BlRvaJ4ERxUA84Dqd2e8'),
  ('Atlantic/Azores','Ponta Delgada','ChIJlw6wdswqQwsRFsRvTvKAVXY'),
  ('Asia/Manila','Manila','ChIJi8MeVwPKlzMRH8FpEHXV0Wk'),
  ('Pacific/Tahiti','Papeete','ChIJlWZPhxw6mnYRKzaBKFPb1mI'),
  ('Africa/Kinshasa','Kinshasa','ChIJi2oG_jAxahoRjTdSH05-ixY'),
  ('America/Cancun','Cancún','ChIJ21P2rgUrTI8Ris1fYjy3Ms4'),
  ('America/Kentucky/Louisville','Louisville','ChIJEdVbsxoLaYgRMv1xICi009Q'),
  ('Asia/Oral','Oral','ChIJfUv5dji6cUERG8xqWfPwcWc'),
  ('Africa/Lusaka','Lusaka','ChIJSaq8PH3zQBkR6xMgRsGT0NA'),
  ('Africa/Libreville','Libreville','ChIJ7fM4VIo7fxARwivSfPLiwns'),
  ('America/Anchorage','Anchorage','ChIJQT-zBHaRyFYR42iEp1q6fSU'),
  ('America/Belem','Belém','ChIJkaz7qQC5rQcR-G0mePwSC98'),
  ('Pacific/Wallis','Mata-Utu','ChIJPUsabgaxyHERahbb1ENhoH8'),
  ('Asia/Bahrain','Manama','ChIJLaZ2J3KvST4RwmAPB6Y4Z4s'),
  ('America/Juneau','Juneau','ChIJjzpqb2zeAFQREfNprlryXgY'),
  ('Indian/Reunion','La Possession','ChIJOxhqeEyGgiER_LtVNDX0U4g'),
  ('Africa/Kampala','Kampala','ChIJm7N0nQ-8fRcR7G9r2T2QOEU'),
  ('Africa/Windhoek','Windhoek','ChIJ7QEMs1wbCxwRO11EzEBJuOQ'),
  ('Europe/Andorra','les Escaldes','ChIJaxpK9OKKpRIRtp4e8lTF3v0'),
  ('America/Menominee','Menominee','ChIJ_cWIDgihUk0R7IC-Ef0ptEo'),
  ('America/Kralendijk','Kralendijk','ChIJJ1kXc7Abg44RUlePIm2dJys'),
  ('Asia/Pyongyang','Pyongyang','ChIJN0NP5toCfjURlapxF-J3BtQ'),
  ('Europe/Helsinki','Helsinki','ChIJkQYhlscLkkYRY_fiO4S9Ts0'),
  ('America/Argentina/San_Luis','San Luis','ChIJzaZsGVQ51JURg8ye1LTjwn8'),
  ('America/Panama','Panamá','ChIJYwPo2_GorI8RDsFC8PFdoqs'),
  ('Asia/Anadyr','Anadyr','ChIJG00a1K-f_FkRR_AkXgQyGgU'),
  ('America/St_Kitts','Basseterre','ChIJy4VyQoobEowRz0-rkEv6xOQ'),
  ('Australia/Darwin','Darwin','ChIJPwRZn_ygwCwRIHwkKqgXAgM'),
  ('Indian/Kerguelen','Port-aux-Français','ChIJMZFHlla-FLMROCuA2BT0e5Q'),
  ('America/Bahia','Salvador','ChIJeREjE6hQmQcRnjmRBBPvSOE'),
  ('America/Bahia_Banderas','Valle de Banderas','ChIJpRNe0UQ4IYQRDV00G6u4MIY'),
  ('America/Guyana','Georgetown','ChIJs8LYYK_vr40RfesAC0SkwnI'),
  ('Asia/Novosibirsk','Novosibirsk','ChIJl03MkOHl30IRhenT4XMGOps'),
  ('America/St_Thomas','Saint Croix','ChIJ4VdxpH3qbogRhVhqr6Gf8aE'),
  ('America/Sitka','Sitka','ChIJuWN1b4NmBFQRdBzIn0jaQSU'),
  ('America/Godthab','Nuuk','ChIJJSezGs4Nok4RBiNpTfsl5D0'),
  ('Asia/Tashkent','Tashkent','ChIJw-l5wwyLrjgRmMulSjsyqaU'),
  ('Pacific/Norfolk','Kingston','ChIJq7I0n4bXS2wRk10DiFO0mxk'),
  ('Europe/Paris','Paris','ChIJD7fiBh9u5kcRYJSMaMOCCwQ'),
  ('Europe/Malta','Qormi','ChIJ00tAlXRQDhMRzMW4X2jlbeE'),
  ('Europe/Istanbul','İstanbul','ChIJawhoAASnyhQR0LABvJj-zOE'),
  ('Africa/Banjul','Banjul','ChIJBzivZSmcwg4RUiyu-1EX46E'),
  ('Africa/Juba','Juba','ChIJ-bXzvEqAEhcRM8RGYyg5mNg'),
  ('Africa/Sao_Tome','São Tomé','ChIJg_L91l9qdhARFt6heLBTVtA'),
  ('America/Matamoros','Heroica Matamoros','ChIJhwDRk8eUb4YRXsoTOXB4IXM'),
  ('America/St_Lucia','Castries','ChIJT9SmOKhnQIwRmYvFh179_zo'),
  ('Asia/Yerevan','Yerevan','ChIJW4v8uNqiakARalLah655FD0'),
  ('America/Guatemala','Guatemala City','ChIJRTNcZYChiYURJXuGW4HHcko'),
  ('Australia/Perth','Perth','ChIJc9U7KdW6MioR4E7fNbXwBAU'),
  ('Africa/Mogadishu','Mogadishu','ChIJU2vOVVlCWD0R2VnMUqrqILs'),
  ('Asia/Colombo','Colombo','ChIJA3B6D9FT4joRjYPTMk0uCzI'),
  ('America/Miquelon','Miquelon','ChIJszom2yXZbUsRNIldouv_I2k'),
  ('America/Indiana/Vincennes','Vincennes','ChIJh2QBtzLibYgReOtF1Y1dBfM'),
  ('Africa/Freetown','Freetown','ChIJMwbms1bCBA8RHjwBr8jIt5c'),
  ('Asia/Baku','Baku','ChIJ-Rwh1mt9MEARa2zlel5rPzQ'),
  ('Pacific/Pohnpei','Kolonia','ChIJnwy8NLfL2WURUO6ndwFipa8'),
  ('America/Havana','Havana','ChIJ4QD2vUx3zYgRYA13Gn5NKU4'),
  ('Africa/Asmara','Asmara','ChIJqTPJtDvybRYRxfVjryezwbg'),
  ('Asia/Qatar','Doha','ChIJf-jc_zTFRT4RsdTPeJ8x2UQ'),
  ('Africa/Luanda','Luanda','ChIJfSyN3FzxURoRklrMXlwcDIU'),
  ('Africa/Lagos','Lagos','ChIJwYCC5iqLOxARy9nDZ6OHntw'),
  ('America/Santiago','Santiago','ChIJuzrymgbQYpYRl0jtCfRZnYc'),
  ('Asia/Omsk','Omsk','ChIJCwkB9uL9qkMRGpumYTjD714'),
  ('Africa/Malabo','Malabo','ChIJHyxxSOSeZhARDN-xZtaegJc'),
  ('Europe/Vaduz','Vaduz','ChIJ_S9HHUQxm0cRlxaUzj6Ulrc'),
  ('Asia/Vientiane','Vientiane','ChIJIXvtBoZoJDER3-7BGIaxkx8'),
  ('Indian/Cocos','West Island','ChIJdfevzszIDi8R-PQJrxM6ufg'),
  ('America/Regina','Regina','ChIJ6z2l-0AeHFMRsVR7t5YySjU'),
  ('Indian/Antananarivo','Antananarivo','ChIJs04fT-N98CER-YLAvAgGEd8'),
  ('Pacific/Niue','Alofi','ChIJO7duNyolnXERNt51uzaQOAk'),
  ('Asia/Hong_Kong','Hong Kong','ChIJByjqov3-AzQR2pT0dDW0bUg'),
  ('Africa/Accra','Accra','ChIJc6e3soSQ3w8R0y0OZdhO0b4'),
  ('America/Whitehorse','Whitehorse','ChIJgVO8gJhEVFERSzXQZOq3PeQ'),
  ('Europe/Kaliningrad','Kaliningrad','ChIJqSF8S40940YR024SFgCWUFA'),
  ('Europe/Kiev','Kiev','ChIJBUVa4U7P1EAR_kYBF9IxSXY'),
  ('America/Eirunepe','Eirunepé','ChIJqTWfOFFNjpERtLXnPU-tSj8'),
  ('America/Argentina/Ushuaia','Ushuaia','ChIJvwnRurUiTLwR_OtDuj1HmFQ'),
  ('Europe/Zaporozhye','Zaporizhzhya','ChIJA7uF-j1n3EARSj9NB9lcZ34'),
  ('Africa/Dar_es_Salaam','Dar es Salaam','ChIJ8dabFq5LXBgR3aGGoCZrD5Q'),
  ('America/Argentina/Jujuy','San Salvador de Jujuy','ChIJL6bXi04PG5QRmeT2V-BQUTE'),
  ('Asia/Brunei','Kuala Belait','ChIJu52tQvyqGDIRyykNk1wixWc'),
  ('America/Atikokan','Atikokan','ChIJi6Hs-OX2o1IRRtqeZn8J1cA'),
  ('Asia/Damascus','Damascus','ChIJp8Y8QdzmGBUR8pTj0etmn2s'),
  ('Pacific/Tongatapu','Nuku‘alofa','ChIJA3qajcSj9HERyVkHNwrJbzQ'),
  ('America/North_Dakota/New_Salem','Mandan','ChIJ5Tgi0r2F11IRwHlpf1TQFLg'),
  ('Pacific/Apia','Apia','ChIJAxDsZKMTpXERYvcKx8jIPIk'),
  ('America/Barbados','Bridgetown','ChIJPflM-sL2Q4wRaXCGlWrmwX0'),
  ('Africa/Maseru','Maseru','ChIJczbLRjE1jB4RwCiMvILPAAQ'),
  ('Asia/Hovd','Khovd','ChIJp3_tehhhTl0RUF5r3dIAcpc'),
  ('Asia/Kuching','Kuching','ChIJEb-MJYQH-zERcn6xGllXctM'),
  ('Asia/Makassar','Makassar','ChIJcUZs2Snjvi0RsHD3yvsLAwM'),
  ('America/Porto_Velho','Porto Velho','ChIJC1KYWWZbMpIRixnF0lry0HU'),
  ('Indian/Maldives','Male','ChIJIdbzVahMazsRfVd0CcW4B8Y'),
  ('America/Toronto','Toronto','ChIJpTvG15DL1IkRd8S0KlBVNTI'),
  ('Africa/Tunis','Tunis','ChIJQ_V-Xn8z_RIRdQJKcU6ScdY'),
  ('Pacific/Majuro','Majuro','ChIJ-UL0NIMED2URe27CdEydJMQ'),
  ('Pacific/Gambier','Rikitea','ChIJHzRpokmIJ54R5Qas3r5SA9I'),
  ('America/Marigot','Marigot','ChIJSSCpgKS-aowRO51TcHFKtX8'),
  ('Europe/Copenhagen','Copenhagen','ChIJIz2AXDxTUkYRuGeU5t1-3QQ'),
  ('Europe/San_Marino','San Marino','ChIJD6FyZLbsLBMRwPCg95vzAAo'),
  ('Africa/Lubumbashi','Lubumbashi','ChIJ2ct0SKM-chkRL1uAT6f1xqE'),
  ('Europe/Chisinau','Chişinău','ChIJoWm3KDZ8yUARPN1JVzDW0Tc'),
  ('Asia/Samarkand','Samarqand','ChIJ930HYBkZTT8RVy8_0dk2dkg'),
  ('America/Argentina/Cordoba','Córdoba','ChIJaVuPR1-YMpQRkrBmU5pPorA'),
  ('America/Antigua','Saint John’s','ChIJpRuO60uSEowRTzfbYy8SRnw'),
  ('Pacific/Efate','Port-Vila','ChIJE2CSyF5giW4RlscpI2eU5zw'),
  ('Africa/Djibouti','Djibouti','ChIJsx453s8AIxYRrCEofTqaKqE'),
  ('Pacific/Pitcairn','Adamstown','ChIJiweo3H8POJ4RfadZONAOwA0'),
  ('Africa/Cairo','Cairo','ChIJ674hC6Y_WBQRujtC6Jay33k'),
  ('Asia/Tokyo','Tokyo','ChIJXSModoWLGGARILWiCfeu2M0'),
  ('Pacific/Marquesas','Atuona','ChIJG7VY5eUhN3YRKiTHUDX8c5Q'),
  ('America/Santarem','Santarém','ChIJ1UqwPCH5iJIRR9Zn150_voA'),
  ('Asia/Ashgabat','Ashgabat','ChIJ2YQ2qxv-bz8R6a3TYj8B3jw'),
  ('Asia/Kabul','Kabul','ChIJSW0ePExp0TgRKUQheDVH3-s'),
  ('Pacific/Saipan','Saipan','ChIJUVyZkDSx2GYR0OGWcyirmE8'),
  ('Europe/Oslo','Oslo','ChIJOfBn8mFuQUYRmh4j019gkn4'),
  ('Asia/Aqtau','Zhanaozen','ChIJURbKF_bEyUER7U8X_FEUruk'),
  ('Asia/Riyadh','Riyadh','ChIJmZNIDYkDLz4R1Z_nmBxNl7o'),
  ('Africa/Ouagadougou','Ouagadougou','ChIJzUSqzuyVLg4Rizt0nHlnn3k'),
  ('Australia/Sydney','Sydney','ChIJP3Sa8ziYEmsRUKgyFmh9AQM'),
  ('Arctic/Longyearbyen','Longyearbyen','ChIJ31dFT9hSnEUR7JVkocqyhto'),
  ('America/Caracas','Caracas','ChIJB0iCza1YKowRg4SZCq4u3ZM'),
  ('Europe/Mariehamn','Mariehamn','ChIJ7TXGu5vDikYRzZqPbAILQkY'),
  ('Asia/Kolkata','Kolkata','ChIJZ_YISduC-DkRvCxsj-Yw40M'),
  ('Europe/Belgrade','Belgrade','ChIJvT-116N6WkcR5H4X8lxkuB0'),
  ('America/Nassau','Nassau','ChIJyduBuZl8L4kR0lBeSNMB7yo'),
  ('Australia/Currie','Currie','ChIJ-3oxdPvYgKoRoPnd0E3JAwQ'),
  ('Africa/Bissau','Bissau','ChIJC1Q2MN7a5g4RhUjTg4gMYHw'),
  ('Africa/Bamako','Bamako','ChIJkQpFJxLNUQ4RFWBQUuFAPJ4'),
  ('America/Cayman','George Town','ChIJmZYfTPaGJY8R3b-2izzuUYw'),
  ('Asia/Dhaka','Dhaka','ChIJgWsCh7C4VTcRwgRZ3btjpY8'),
  ('America/Sao_Paulo','São Paulo','ChIJ0WGkg4FEzpQRrlsz_whLqZs'),
  ('America/Asuncion','Asunción','ChIJ9dtpbgeoXZQRyTYZv0Z666w'),
  ('Asia/Jakarta','Jakarta','ChIJnUvjRenzaS4RoobX2g-_cVM'),
  ('Australia/Melbourne','Melbourne','ChIJ90260rVG1moRkM2MIXVWBAQ'),
  ('Africa/Bujumbura','Bujumbura','ChIJozWgKA-DwRkRw6RQe7mp6w8'),
  ('America/Phoenix','Phoenix','ChIJy3mhUO0SK4cRrBtKNfjHaYw'),
  ('America/Curacao','Willemstad','ChIJVy-mDF-ChI4R701VMbSSSR8'),
  ('America/Fortaleza','Fortaleza','ChIJL1zB9iFPxwcRqid5ywZnbf0'),
  ('Indian/Mauritius','Port Louis','ChIJ7wHWQUlQfCERPbu9kWwYxf0'),
  ('America/Inuvik','Inuvik','ChIJ0Zb5lT-SFFERhLevN6KRI1I'),
  ('Asia/Almaty','Almaty','ChIJq8vFFn1ugzgRdm2YrY9mRD0'),
  ('Pacific/Galapagos','Puerto Ayora','ChIJa7-U-0NdqpoRNWGGLDX6QZg'),
  ('Australia/Broken_Hill','Broken Hill','ChIJzcJS3mAz72oRcAFEkLQJBgQ'),
  ('America/El_Salvador','San Salvador','ChIJXXcRtGcwY48Rllz7k4iXdR8'),
  ('America/Nome','Nome','ChIJeVU4FigaMVcRTIR2WHExdUE'),
  ('America/Boa_Vista','Boa Vista','ChIJ26Sqy8oFk40RRV_XqcdlLrc'),
  ('America/Monterrey','Monterrey','ChIJ9fg3tDGVYoYRlJjIasrT06M'),
  ('Africa/Conakry','Conakry','ChIJKeGIoyrRHA8R1EHTaRXeZoo'),
  ('America/Argentina/Tucuman','San Miguel de Tucumán','ChIJA2nF1pI3IpQRJ2XFtZJbjfg'),
  ('Asia/Rangoon','Yangon','ChIJaxk-Ip6UwTARtAsI-HHS-1Y'),
  ('Pacific/Bougainville','Arawa','ChIJ4-9aWf-TzmgRC8wL4bCd6ps'),
  ('Asia/Kuala_Lumpur','Kuala Lumpur','ChIJ5-rvAcdJzDERfSgcL1uO2fQ'),
  ('Africa/Algiers','Algiers','ChIJP5ogelFybogRjznXJdcrHy8'),
  ('America/Chicago','Chicago','ChIJ7cv00DwsDogRAMDACa2m4K8'),
  ('Europe/Rome','Rome','ChIJu46S-ZZhLxMROG5lkwZ3D7k'),
  ('Europe/Dublin','Dublin','ChIJL6wn6oAOZ0gRoHExl6nHAAo'),
  ('America/Chihuahua','Chihuahua','ChIJM0BIXZ1E6oYRex3dBqen8bc'),
  ('Asia/Aden','Aden','ChIJL8JeUdYcHhYR6W9pI8OzX5Q'),
  ('Europe/Guernsey','Saint Peter Port','ChIJLdcIRv1yDUgRamGVynA3wYE'),
  ('Africa/Abidjan','Abidjan','ChIJIZGVEVPqwQ8RpiGS4dwN5z8'),
  ('America/Swift_Current','Swift Current','ChIJh28IX7TfEFMR0_rE2ZHGqh4'),
  ('Europe/Bratislava','Bratislava','ChIJl2HKCjaJbEcRaEOI_YKbH2M'),
  ('America/Indiana/Marengo','English','ChIJJ9ljo_e3bogRv9HAma9Kl9M'),
  ('America/Merida','Mérida','ChIJFw1Fq1xxVo8RCeurFVcV_F0'),
  ('Pacific/Auckland','Auckland','ChIJ--acWvtHDW0RF5miQ2HvAAU'),
  ('Europe/Athens','Athens','ChIJ8UNwBh-9oRQR3Y1mdkU1Nic'),
  ('America/Port_of_Spain','Port of Spain','ChIJScNLF94HNowRhUINFlP23t0'),
  ('Asia/Novokuznetsk','Novokuznetsk','ChIJ5Z4iV1fA0EIRQNl8enxpDiM'),
  ('Europe/Zagreb','Zagreb','ChIJOcwCyZLWZUcRisL7KJYkRTo'),
  ('Europe/Madrid','Madrid','ChIJgTwKgJcpQg0RaSKMYcHeNsQ'),
  ('Atlantic/Cape_Verde','Mindelo','ChIJF_xJA68eTwkR8_S4kyktBcc'),
  ('Australia/Adelaide','Adelaide','ChIJP7Mmxcc1t2oRQMaOYlQ2AwQ'),
  ('Asia/Vladivostok','Vladivostok','ChIJhdRJUrqcs18RNX6W3dQEZxg'),
  ('Pacific/Chatham','Waitangi','ChIJkSUkCGEtK20RAFt5hIbvAAU'),
  ('Asia/Thimphu','Thimphu','ChIJtzcglhmU4TkR0WAFZuL_AXw'),
  ('Europe/Gibraltar','Gibraltar','ChIJNb4UJ3a_DA0R63QwjEmqPW8'),
  ('America/Managua','Managua','ChIJC4gH2Q1WcY8RakxPFKL0Xmw'),
  ('America/Argentina/Mendoza','Mendoza','ChIJv3lRxD4JfpYROvoO0vZ4WiA'),
  ('Australia/Brisbane','Brisbane','ChIJM9KTrJpXkWsRQK_e81qjAgQ'),
  ('America/Cayenne','Cayenne','ChIJnbdK2zo9Eo0RKLaviyl-VnM'),
  ('Pacific/Port_Moresby','Port Moresby','ChIJq5JWHNQwAmkRxJifiIG0pj8'),
  ('Africa/Dakar','Dakar','ChIJcbvFs_VywQ4RH7JdLdkXfLE'),
  ('Europe/Vatican','Vatican City','ChIJJTk-DGZgLxMRPGxQNTiMSQA'),
  ('America/Winnipeg','Winnipeg','ChIJESsa-ftz6lIRZMq5xvoaKis'),
  ('Europe/Podgorica','Podgorica','ChIJfYYGlgfoTRMR6YpY6naK92s'),
  ('Pacific/Tarawa','Tarawa','ChIJA4cCwpF8ZGURhONuQKhpddU'),
  ('America/Costa_Rica','San José','ChIJxRUNxULjoI8RgrgRn2pqdOY'),
  ('Europe/Volgograd','Volgograd','ChIJZ3ZbuHUzBUERQdpXzpwXDYg'),
  ('Pacific/Pago_Pago','Pago Pago','ChIJyf1IkreEpnERK0EVzuwzjjU'),
  ('Asia/Magadan','Magadan','ChIJ6UpSLYGEaVkRWwac4edMyTk'),
  ('Africa/Harare','Harare','ChIJNdvdG-6kMRkRL08T5Zs7FKU'),
  ('America/Goose_Bay','Labrador City','ChIJoe3xmnZL9UwRY9CUc9V8SzE'),
  ('Africa/Ceuta','Ceuta','ChIJ76wp6eejDA0RQMahjP1jBAQ'),
  ('Asia/Pontianak','Pontianak','ChIJm3mwBPZYHS4R4__JH1D5HlE'),
  ('Europe/Bucharest','Bucharest','ChIJT608vzr5sUARKKacfOMyBqw'),
  ('America/Dawson','Dawson City','ChIJt7X11MvjSFER_R-tXLl6jUo'),
  ('Asia/Beirut','Beirut','ChIJj6eAWCEXHxURtDaY6bqCkXI'),
  ('America/Argentina/La_Rioja','La Rioja','ChIJ5feWM4fZJ5QRysdyiTScHD4'),
  ('America/Thunder_Bay','Thunder Bay','ChIJjekWTHchWU0RdIsdjzRXBT0'),
  ('Pacific/Honolulu','Honolulu','ChIJTUbDjDsYAHwRbJen81_1KEs'),
  ('America/Moncton','Moncton','ChIJZRfUGCm5oEwRxGNOOjMKwQ0'),
  ('America/Grand_Turk','Cockburn Town','ChIJv9PjLU7Uso4Rn2cP6wvkvQc'),
  ('Pacific/Easter','Остров Пасхи','ChIJ26i2Z57iJpcRgZArfxCG2_E'),
  ('America/Araguaina','Araguaína','ChIJ-0-MXd4N2ZIR_MRN5hXoMEo'),
  ('America/Rankin_Inlet','Rankin Inlet','ChIJKTAgDGD9C1IRp8tHbsKAPY4'),
  ('America/North_Dakota/Beulah','Beulah','ChIJOe6TNwmJJ1MRZe5G4VwXk2Q'),
  ('America/Montserrat','Brades','ChIJS9X5cRlTEowRWhWea9Lgfpk'),
  ('Pacific/Fiji','Suva','ChIJrU8RQiLeG24RyddNu3R1B-I'),
  ('Africa/Mbabane','Mbabane','ChIJBw8yR-HO6B4Rn93hevKYv3o'),
  ('America/Maceio','Maceió','ChIJSYho1vxGAQcRU3bgQ1tyLO4'),
  ('Europe/London','London','ChIJdd4hrwug2EcRmSrV3Vo6llI'),
  ('Pacific/Guam','Hagåtña','ChIJO8V-KoF3H2cRH_Xu-PRVp5w'),
  ('America/Creston','Creston','ChIJjaASpuFiY1MRxocXVm-rB3U'),
  ('Africa/Lome','Lomé','ChIJGVQYE8HhIxARHUGvLEK1JDI'),
  ('Asia/Singapore','Singapore','ChIJyY4rtGcX2jERIKTarqz3AAQ'),
  ('Asia/Krasnoyarsk','Krasnoyarsk','ChIJ4zf_ocmv11wR_0fWj0bhl9U'),
  ('Atlantic/Bermuda','Saint George','ChIJ2-ZT6I5yLYoRd-VeQN-TdLo'),
  ('Asia/Irkutsk','Irkutsk','ChIJZfbiU9M6qF0RTunYVhTN1jE'),
  ('Asia/Seoul','Seoul','ChIJzWXFYYuifDUR64Pq5LTtioU'),
  ('Asia/Bangkok','Bangkok','ChIJ82ENKDJgHTERIEjiXbIAAQE'),
  ('Europe/Budapest','Budapest','ChIJyc_U0TTDQUcRYBEeDCnEAAQ'),
  ('Asia/Yekaterinburg','Yekaterinburg','ChIJS9tioOplwUMRIH9W99dDAtU'),
  ('America/Santo_Domingo','Santo Domingo','ChIJq6V-EPGJr44RZMEVJ7iHxdY'),
  ('Atlantic/St_Helena','Jamestown','ChIJ19zk64Ti6gQRib0Wbx7aWdY'),
  ('Europe/Skopje','Skopje','ChIJpaKajKUVVBMRICCHYMKI7bI'),
  ('America/Glace_Bay','Glace Bay','ChIJt2_q3snhZ0sRaNZPIXYopAk'),
  ('Africa/Douala','Douala','ChIJbf7h4osSYRARi8SBR0Sh2pI'),
  ('Europe/Zurich','Zürich','ChIJGaK-SZcLkEcRA9wf5_GNbuY'),
  ('Pacific/Fakaofo','Atafu Village','ChIJz7IEMfk2TnAR3i0p4eF7cTw'),
  ('Africa/Bangui','Bangui','ChIJA6pX7RzvuBARGVX-9l1svQk'),
  ('Asia/Karachi','Karachi','ChIJv0sdZQY-sz4RIwxaVUQv-Zw'),
  ('America/Argentina/San_Juan','San Juan','ChIJl9Q8oylAgZYRs_w8I6Cj878'),
  ('Africa/Nairobi','Nairobi','ChIJp0lN2HIRLxgRTJKXslQCz_c'),
  ('Europe/Stockholm','Stockholm','ChIJywtkGTF2X0YRZnedZ9MnDag'),
  ('America/Adak','Dutch Harbor','ChIJd3MWwaKwq1cRPvcITptO5G8'),
  ('America/Edmonton','Edmonton','ChIJI__egEUioFMRXRX2SgygH0E'),
  ('America/Iqaluit','Iqaluit','ChIJB9qKcEcW000RwimRfAbQHh8'),
  ('America/Indiana/Winamac','Winamac','ChIJ08WQUsDCE4gRpptaqfrOqMI'),
  ('Asia/Dushanbe','Dushanbe','ChIJm_h70m_RtTgRRP2h3o03-d0'),
  ('Asia/Phnom_Penh','Phnom Penh','ChIJ42tqxz1RCTERuyW1WugOAZw'),
  ('Asia/Choibalsan','Choibalsan','ChIJOXXp3IxT3F0RivSQ_f-G52E'),
  ('Asia/Shanghai','Shanghai','ChIJMzz1sUBwsjURoWTDI5QSlQI'),
  ('Europe/Ljubljana','Ljubljana','ChIJ0YaYlvUxZUcRIOw_ghz4AAQ'),
  ('Indian/Christmas','Flying Fish Cove','ChIJzSMEi12b9S4RFBQdct2nE8U'),
  ('Europe/Berlin','Berlin','ChIJAVkDPzdOqEcRcDteW0YgIQQ'),
  ('America/Argentina/Buenos_Aires','Buenos Aires','ChIJvQz5TjvKvJURh47oiC6Bs6A'),
  ('Asia/Ulaanbaatar','Ulan Bator','ChIJq4qx4luSll0Rf4ShZHiSBuY'),
  ('Europe/Warsaw','Warsaw','ChIJAZ-GmmbMHkcR_NPqiCq-8HI'),
  ('Asia/Jerusalem','Jerusalem','ChIJS_zBNNbXAhURy-FuRT5ib9k'),
  ('Asia/Gaza','Gaza','ChIJZydUTgV__RQRkmMEE8mN-X8'),
  ('Africa/Khartoum','Khartoum','ChIJv8o3mN6PjhYRQNtnft5VHxk'),
  ('Europe/Jersey','Saint Helier','ChIJFZrZ4KBSDEgRHarF21WFdPM'),
  ('America/St_Vincent','Kingstown','ChIJF1yH11BRR4wR_OIsbeKqZS8'),
  ('Asia/Macau','Macau','ChIJmY8AduF6ATQRrXXv59PpHbk'),
  ('Asia/Tbilisi','Tbilisi','ChIJa2JP5tcMREARo25X4u2E0GE'),
  ('Europe/Minsk','Minsk','ChIJ02oeW9PP20YR2XC13VO4YQs'),
  ('America/Campo_Grande','Campo Grande','ChIJJ58ra3LmhpQRwdKEvJ5GqPU'),
  ('Pacific/Rarotonga','Avarua','ChIJYW7jFIjRV3ERb-IakbCs6os'),
  ('America/Indiana/Petersburg','Petersburg','ChIJqVBRdcoNbogRZq4XMNMv2AQ'),
  ('Asia/Bishkek','Bishkek','ChIJgcizkdy3njgRfeLefPW6Lkk'),
  ('Australia/Hobart','Hobart','ChIJ7c8s5YR1bqoRMBXe0E3JAwU'),
  ('GMT-1100','Pago Pago','ChIJyf1IkreEpnERK0EVzuwzjjU'),
  ('GMT-0200','Nuuk','ChIJJSezGs4Nok4RBiNpTfsl5D0'),
  ('America/Indianapolis','Indianapolis','ChIJA2p5p_9Qa4gRfOq5QPadjtY'),
  ('America/Buenos_Aires','Buenos Aires','ChIJvQz5TjvKvJURh47oiC6Bs6A'),
  ('UTC','London','ChIJdd4hrwug2EcRmSrV3Vo6llI'),
  ('GMT','London','ChIJdd4hrwug2EcRmSrV3Vo6llI'),
  ('Asia/Calcutta','Calcutta','ChIJZ_YISduC-DkRvCxsj-Yw40M'),
  ('Asia/Katmandu','Katmandu','ChIJv6p7MIoZ6zkR6rGN8Rt8E7U'),
  ('Asia/Srednekolymsk','Srednekolymsk','ChIJbfF5Du_ZLFoRmUrZ7lZxpqM'),
  ('GMT+1200','Suva','ChIJrU8RQiLeG24RyddNu3R1B-I');
-- end of insert temp cities

CREATE TABLE temp_tz_city (
  id    INT(3) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  tz_id VARCHAR(191) UNIQUE
);

INSERT INTO temp_tz_city (tz_id)
  SELECT time_zone
  FROM at_user
  WHERE time_zone IS NOT NULL and exists (select * from temp_city where tz_id = time_zone)
  GROUP BY time_zone;

INSERT INTO time_zone_group2 (id, name, place_id, tz_id, city_name)
  SELECT
    temp_tz_city.id,
    concat( city_name, " Office" ),
    place_id,
    temp_tz_city.tz_id,
    city_name
  FROM temp_city
    JOIN temp_tz_city ON temp_tz_city.tz_id = temp_city.tz_id;

UPDATE time_zone_group2, temp_city set
  time_zone_group2.place_id = temp_city.place_id,
  time_zone_group2.tz_id = temp_city.tz_id,
  time_zone_group2.city_name = temp_city.city_name,
  time_zone_group2.name =  concat(temp_city.city_name, " Office")
where time_zone_group2.id = -1
and exists
 ( SELECT property_value
    FROM system_settings
    WHERE property_name = 'default_time_zone' AND property_value = temp_city.tz_id);

create table time_zone_group (
 id int(3) not null auto_increment primary key,
 name varchar(40) not null,
 place_id VARCHAR(255) not null,
 tz_id VARCHAR(40) not null,
 city_name VARCHAR(255) not null,
 counter int(3) not null default 0
) engine = InnoDB;

insert into time_zone_group
 select id, name, place_id, tz_id, city_name, (select count(id) from time_zone_group2 g2 where g2.name=g1.name and g2.id < g1.id )
 from time_zone_group2 g1;

drop table time_zone_group2;

update time_zone_group
set name=concat(name, " ", counter)
where counter>0;

alter table time_zone_group drop column counter;
alter table time_zone_group add constraint unique key unique_time_zone_group_name (name);

alter table at_user add column time_zone_group_id int(3) not null default -1;
alter table at_user add constraint fk_at_user_time_zone_group foreign key (time_zone_group_id) references time_zone_group(id);

UPDATE at_user
  INNER JOIN temp_tz_city ON at_user.time_zone = temp_tz_city.tz_id
SET time_zone_group_id = temp_tz_city.id;

UPDATE at_user
SET time_zone_group_id = -1
WHERE time_zone IS NULL OR NOT exists( SELECT tz_id
                                       FROM temp_tz_city
                                       WHERE time_zone = tz_id );

/* disable feature tzg if exists only default tzg*/
update system_settings set property_value = false
	where (select count(*) from time_zone_group) = 1 and
	  not exists (select username from at_user WHERE (select count(*) from at_user) = 1 and username = 'admin')
    and property_name = 'time_zone_groups_enabled';

DROP TABLE temp_tz_city;
DROP TABLE temp_city;

DELETE FROM system_settings WHERE property_name = "default_time_zone";
ALTER TABLE at_user DROP COLUMN time_zone;

/*end update users time_zone to time_zone_groups    */

insert into notification_rule_params (rule_id, param_name, param_value)
  select rule_id, replace(param_name, '.selectedUserGroups', '.selectedGroupType' ), 'USER_GROUP' from notification_rule_params where param_name like '%.selectedUserGroups'
    group by rule_id, param_name;
update notification_rule_params set param_name = replace(param_name, '.selectedUserGroups', '.selectedGroups')
  where param_name like '%.selectedUserGroups';

insert into user_settings (user_id, param_name, param_value, param_category)
  select user_id, 'filter.groupType', 'USER_GROUP', 'user_list' from user_settings where param_name = 'filter.userGroupIds' and param_category = 'user_list'
    group by user_id;
update user_settings set param_name = 'filter.groupIds'
  where param_name = 'filter.userGroupIds' and param_category = 'user_list';

insert into user_settings (user_id, param_name, param_value, param_category)
  select user_id, 'groupType', 'USER_GROUP', 'lock_tt' from user_settings where param_name = 'selectedUserGroups' and param_category = 'lock_tt'
    group by user_id;
update user_settings set param_name = 'selectedGroups'
  where param_name = 'selectedUserGroups' and param_category = 'lock_tt';

insert into user_settings (user_id, param_name, param_value, param_category)
  select user_id, 'groupType', 'USER_GROUP', 'lt_planning' from user_settings where param_name = 'userGroupsFilter' and param_category = 'lt_planning'
    group by user_id;
update user_settings set param_name = 'groupsFilter'
  where param_name = 'userGroupsFilter' and param_category = 'lt_planning';

INSERT INTO report_params (config_id, param_name, param_value)
  SELECT DISTINCT config_id, 'userSelection.groupType', 'USER_GROUP' FROM report_params WHERE param_name = 'userSelection.selectedGroups';

-- actiPLANS push notifications

create table ap_mobile_notification (
  id int(10) primary key auto_increment,
  user_id int(3) unsigned not null,
  leave_date date not null,
  constraint fk_ap_mobile_notification_user_id FOREIGN KEY (user_id) REFERENCES at_user (id) ON DELETE CASCADE
) ENGINE=InnoDB;

-- permissions templates

CREATE TABLE permissions_template (
  id   INT(3)       NOT NULL AUTO_INCREMENT PRIMARY KEY,
  name VARCHAR(191) NOT NULL UNIQUE
)
  ENGINE = InnoDB;

CREATE TABLE permissions_template_param (
  perm_template_id INT(3)          NOT NULL,
  permission_id    INT(3) UNSIGNED NOT NULL,

  CONSTRAINT fk_permissions_template_param_permissions_template_id FOREIGN KEY (perm_template_id) REFERENCES permissions_template (id)
    ON DELETE CASCADE,
  CONSTRAINT fk_permissions_template_param_access_right_id FOREIGN KEY (permission_id) REFERENCES access_right (id)
    ON DELETE CASCADE
)
  ENGINE = InnoDB;

INSERT INTO permissions_template (id,name) VALUES (-1,'New user');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,12);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,5);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,11);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,14);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,1);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,13);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,8);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(-1,2);

INSERT INTO permissions_template (id,name) VALUES (1,'Regular user');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(1,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(1,13);

INSERT INTO permissions_template (id,name) VALUES (2,'Manager');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,8);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,2);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,12);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,1);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,13);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(2,5);

INSERT INTO permissions_template (id,name) VALUES (3,'actiTIME administrator');
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,12);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,5);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,11);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,14);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,1);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,9);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,13);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,8);
INSERT INTO permissions_template_param (perm_template_id,permission_id) VALUES(3,2);

-- delete Project Assignments notification rules
delete from notification_rule where type = 5;

ALTER TABLE mail_message MODIFY subject TEXT NOT NULL;
ALTER TABLE license MODIFY body TEXT NOT NULL ;

-- -----------------------------------------------------------------------------------------------------------

insert
into patch_history (patch, pack_version, patch_timestamp)
values (34, 0, now());

commit;