CREATE TABLE user_seen_welcome_screen (
  user_id INT NOT NULL UNIQUE,
  is_seen BIT NOT NULL

-- no fk to at_user
);

INSERT INTO user_seen_welcome_screen (user_id, is_seen) SELECT id, true FROM at_user;

CREATE TABLE temp_upload
(
  bin_data_id INT NOT NULL,
  [timestamp] TIMESTAMP NOT NULL,
  session_id VARCHAR(64) NOT NULL,
  CONSTRAINT pk_temp_upload PRIMARY KEY (bin_data_id),
  CONSTRAINT fk_temp_upload_bin_data_id FOREIGN KEY (bin_data_id) REFERENCES bin_data (bin_data_id) ON DELETE CASCADE
);

CREATE TABLE getting_started_settings (
  property_name  VARCHAR(32) NOT NULL UNIQUE,
  property_value TEXT
);

-- remove parent_id from unique key in tasks and rename tasks if they names equals
alter table task drop constraint task_project_name_uk;

create table temp (id int, len int, cnt int, n int);

insert into temp (id, len, cnt, n)
  select
    a.id as id,
    len(a.name_lower) as len,
    sum(1) as cnt,
    sum(switch(a2.id < a.id, 1, True, 0)) as n
  from task a
  inner join task a2 on a.project_id = a2.project_id and a.id <> a2.id and a.name_lower = a2.name_lower
  group by a.id, a.name_lower;

update task
  inner join temp on task.id = temp.id
set task.name_lower = switch(temp.len = 191, left(task.name_lower, 190), True, task.name_lower) & temp.n,
    task.name       = switch(temp.len = 191, left(task.name      , 190), True, task.name      ) & temp.n;

drop table temp;

alter table task add constraint task_project_name_uk unique (project_id, name_lower);

alter table tt_record
    drop constraint fk_tt_user;
alter table tt_record
    add constraint fk_tt_user foreign key(user_id) references at_user(id) on delete cascade;

alter table user_task_comment
    drop constraint fk_comment_userid;
alter table user_task_comment
    add constraint fk_comment_userid foreign key (user_id) references at_user(id) on delete cascade;

  -- -----------------------------------------------------------------------------------------------------------

INSERT
INTO patch_history (patch, pack_version, patch_timestamp)
VALUES ( 36, 0, now( ) );