CREATE TABLE user_seen_welcome_screen (
  user_id INT(3) UNSIGNED NOT NULL UNIQUE,
  is_seen TINYINT(1)      NOT NULL,

  CONSTRAINT fk_user_seen_welcome_screen_at_user_id FOREIGN KEY (user_id) REFERENCES at_user (id)
    ON DELETE CASCADE
)
  ENGINE = InnoDB;

INSERT INTO user_seen_welcome_screen (user_id, is_seen) SELECT id, true FROM at_user;

CREATE TABLE temp_upload
(
  bin_data_id INT UNSIGNED PRIMARY KEY NOT NULL,
  timestamp TIMESTAMP NOT NULL,
  session_id VARCHAR(64) NOT NULL,
  CONSTRAINT fk_temp_upload_bin_data_id FOREIGN KEY (bin_data_id) REFERENCES bin_data (bin_data_id) ON DELETE CASCADE
)
  ENGINE = InnoDB;

CREATE TABLE getting_started_settings (
  property_name  VARCHAR(32) NOT NULL UNIQUE,
  property_value TEXT
)
  ENGINE = InnoDB;

-- remove parent_id from unique key in tasks and rename tasks if they names equals
alter table task drop foreign key fk_task_project;
alter table task drop key task_project_name_uk;

create table temp (id int, len int, cnt int, n int);

insert into temp (id, len, cnt, n)
  select
    a.id id,
    length(a.name_lower) len,
    sum(1) cnt,
    sum(a2.id < a.id) n
  from task a
  inner join task a2 on a.project_id = a2.project_id and a.id <> a2.id and a.name_lower = a2.name_lower
  group by a.id, a.name_lower;

update task
  inner join temp on task.id = temp.id
set task.name_lower = concat(if (temp.len = 191, left(task.name_lower, 190), task.name_lower), temp.n),
    task.name       = concat(if (temp.len = 191, left(task.name      , 190), task.name      ), temp.n);

drop table temp;

alter table task add unique key task_project_name_uk (project_id, name_lower);
alter table task add constraint fk_task_project foreign key (project_id) references project(id) on delete cascade;

-- -----------------------------------------------------------------------------------------------------------

INSERT
INTO patch_history (patch, pack_version, patch_timestamp)
VALUES ( 36, 0, now( ) );

COMMIT;