drop table tt_lock_revision;

create table tt_lock_revision
(
  locked_user_id integer not null,
  `date` date not null,
  revision counter not null,
  constraint uk_tt_lock_revision unique(revision)
);

-- see comment in mysql patch
insert into tt_lock_revision(`date`, locked_user_id)
select distinct d.selected_date, tt_lock.locked_user_id from tt_lock,
(select DateAdd("d", t4.i*10000 + t3.i*1000 + t2.i*100 + t1.i*10 + t0.i, #1970/01/01#) as selected_date from
(select 0 as i from tt_lock union select 1 from tt_lock union select 2 from tt_lock union select 3 from tt_lock union select 4 from tt_lock union select 5 from tt_lock union select 6 from tt_lock union select 7 from tt_lock union select 8 from tt_lock union select 9 from tt_lock) as t0,
(select 0 as i from tt_lock union select 1 from tt_lock union select 2 from tt_lock union select 3 from tt_lock union select 4 from tt_lock union select 5 from tt_lock union select 6 from tt_lock union select 7 from tt_lock union select 8 from tt_lock union select 9 from tt_lock) as t1,
(select 0 as i from tt_lock union select 1 from tt_lock union select 2 from tt_lock union select 3 from tt_lock union select 4 from tt_lock union select 5 from tt_lock union select 6 from tt_lock union select 7 from tt_lock union select 8 from tt_lock union select 9 from tt_lock) as t2,
(select 0 as i from tt_lock union select 1 from tt_lock union select 2 from tt_lock union select 3 from tt_lock union select 4 from tt_lock union select 5 from tt_lock union select 6 from tt_lock union select 7 from tt_lock union select 8 from tt_lock union select 9 from tt_lock) as t3,
(select 0 as i from tt_lock union select 1 from tt_lock union select 2 from tt_lock) as t4) as d
where d.selected_date between tt_lock.date_from and tt_lock.date_to and not date_from is null;

alter table tt_lock_revision alter column revision long not null;
alter table tt_lock_revision add constraint pk_tt_lock_revision primary key (locked_user_id, `date`);


-- update leave time csv report to html
update report_configs set format_id = 1 where format_id = 2 and report_form = 10;

-- remove my_leave_time_history user settings
delete from user_settings where param_category='my_leave_time_history';

-- IMPORT_LICENSE_KEY_PLACEHOLDER
-- -----------------------------------------------------------------------------------------------------------

INSERT
INTO patch_history (patch, pack_version, patch_timestamp)
VALUES (41, 0, now());