insert into access_right (id, name ) values (10, 'user.lock_time_track');

insert into permissions_template_param (perm_template_id, permission_id)
  select distinct perm_template_id, 10 from permissions_template_param where permission_id in (2,5);

DELETE FROM `system_settings` WHERE `property_name`='overtime_undertime_tracking';


update
      overtime_revision as ovr left join  overtime as ovt on
                                                      ovr.user_id = ovt.user_id and
                                                      ovr.overtime_date = ovt.overtime_date
      set revision = next_revision()  where overtime < 0;
delete from overtime where overtime < 0;

insert into user_access_right (user_id, access_right_id)
      select distinct user_id, 10 from user_access_right
          where access_right_id in (2,5) and user_id not in
                                             (select distinct user_id from user_access_right where access_right_id = 10);

alter table user_seen_welcome_screen add column is_seen_ap TINYINT(1) NOT NULL DEFAULT FALSE;
alter table user_seen_welcome_screen alter column is_seen set default FALSE;
insert into user_seen_welcome_screen(user_id, is_seen, is_seen_ap) select id, false, false from at_user on duplicate key update user_id = user_id;
update user_seen_welcome_screen, at_user set is_seen_ap = true where at_user.id = user_seen_welcome_screen.user_id and at_user.is_enabled_ap;

-- create lock revisions for users who don't have any, otherwise these users won't get lock updates to their mobile app
insert into tt_lock_revision (locked_user_id, `date`, revision)
  select id, (select coalesce(date_add(max(date_to), INTERVAL 1 DAY), curdate()) from tt_lock), next_revision() from at_user
  where not exists (SELECT locked_user_id FROM tt_lock_revision WHERE locked_user_id = id);

update user_seen_welcome_screen set is_seen = false where not exists (select 1 from user_last_login_time where user_last_login_time.user_id = user_seen_welcome_screen.user_id and product_name = 'actiTIME');
update user_seen_welcome_screen set is_seen_ap = false where not exists (select 1 from user_last_login_time where user_last_login_time.user_id = user_seen_welcome_screen.user_id and product_name = 'actiPLANS');

-- IMPORT_LICENSE_KEY_PLACEHOLDER
-- -----------------------------------------------------------------------------------------------------------

INSERT
INTO patch_history (patch, pack_version, patch_timestamp)
VALUES (42, 0, now());

COMMIT;