-- update overtime csv report to html
update report_configs set format_id = 1 where format_id = 2 and report_form = 4;

CREATE TABLE report_config_id ( config_id INT NOT NULL );

insert into report_config_id (config_id) select rc.id from report_configs rc where rc.report_form = 4;

update report_params rp set rp.param_value = 'NONE'
  where rp.param_name = 'secondGroupingLevel' and rp.param_value in ('MONTH', 'WEEK', 'DATE')
    and exists (select 1 from report_config_id rci where rci.config_id = rp.config_id);

create table second_grouping_level (config_id int not null, param_value text not null);

insert into second_grouping_level (config_id, param_value)
  select rp.config_id, rp.param_value from report_params rp inner join report_params rp2 on rp.config_id = rp2.config_id
    where rp.param_name = 'secondGroupingLevel' and rp.param_value <> 'NONE'
      and rp2.param_name = 'firstGroupingLevel' and rp2.param_value in ('MONTH', 'WEEK', 'DATE')
      and exists (select 1 from report_config_id rci where rci.config_id = rp.config_id);

update report_params rp, second_grouping_level sgl set rp.param_value = sgl.param_value
  where rp.param_name = 'firstGroupingLevel' and sgl.config_id = rp.config_id;

update report_params rp, second_grouping_level sgl set rp.param_value = 'NONE'
  where rp.param_name = 'secondGroupingLevel' and sgl.config_id = rp.config_id;

drop table second_grouping_level;

update report_params rp set rp.param_value = 'USER'
  where rp.param_name = 'firstGroupingLevel' and rp.param_value in ('MONTH', 'WEEK', 'DATE')
    and exists (select 1 from report_config_id rci where rci.config_id = rp.config_id);

insert into report_params (config_id, param_name, param_value)
  select rci.config_id, 'columnsConfig', 'TIME_BALANCE_AND_OVERTIME' from report_config_id rci;

create table config_id_with_all_users_selector (config_id int not null);

insert into config_id_with_all_users_selector (config_id)
  select rp.config_id from report_params rp
    where rp.param_name = 'userSelection.allUsers' and rp.param_value = 'true'
      and exists (select 1 from report_config_id rci where rci.config_id = rp.config_id);

delete from report_params rp
  where rp.config_id in (select cia.config_id from config_id_with_all_users_selector cia) and
    rp.param_name in ('userSelection.groupType', 'userSelection.selectedGroups', 'userSelection.selectedUsers');

insert into report_params (config_id, param_name, param_value)
  select cia.config_id, 'userSelection.selectedUsers', u.id from config_id_with_all_users_selector cia, at_user u
    where u.is_enabled = true and u.overtime_tracking = true;

update report_params rp set rp.param_value = 'false'
  where rp.param_name = 'userSelection.allUsers' and rp.config_id in (select cia.config_id from config_id_with_all_users_selector cia);

drop table config_id_with_all_users_selector;

DROP TABLE report_config_id;

-- IMPORT_LICENSE_KEY_PLACEHOLDER
-- -----------------------------------------------------------------------------------------------------------

INSERT
INTO patch_history (patch, pack_version, patch_timestamp)
VALUES (45, 0, now());