-- update overtime csv report to html
update report_configs set format_id = 1 where format_id = 2 and report_form = 4;

-- remove time related second grouping level
update report_params rp join report_configs conf on rp.config_id = conf.id and conf.report_form = 4
set rp.param_value = 'NONE' where rp.param_name = 'secondGroupingLevel' and rp.param_value in ('MONTH', 'WEEK', 'DATE');

-- replace time related first grouping level by second
UPDATE report_params rp JOIN report_params rp2 ON rp.config_id = rp2.config_id AND rp2.param_name='secondGroupingLevel' AND rp2.param_value <> 'NONE'
join report_configs conf on rp.config_id = conf.id and conf.report_form = 4
SET rp.param_value = rp2.param_value, rp2.param_value = 'NONE'
WHERE rp.param_name='firstGroupingLevel' AND rp.param_value in ('MONTH', 'WEEK', 'DATE');

-- set USER for time related first grouping level
update report_params rp join report_configs conf on rp.config_id = conf.id and conf.report_form = 4
set rp.param_value = 'USER' where rp.param_name = 'firstGroupingLevel' and rp.param_value in ('MONTH', 'WEEK', 'DATE');

-- all time related grouping levels removed now

insert into report_params (config_id, param_name, param_value)
select conf.id, 'columnsConfig', 'TIME_BALANCE_AND_OVERTIME' from report_configs conf where conf.report_form = 4;

create table config_id_with_all_users_selector (config_id int not null);

insert into config_id_with_all_users_selector (config_id)
  select conf.id from report_params rp join report_configs conf on rp.config_id = conf.id and conf.report_form = 4
    and rp.param_name = 'userSelection.allUsers' and rp.param_value = 'true';

delete from report_params
  where config_id in (select cia.config_id from config_id_with_all_users_selector cia) and
    param_name in ('userSelection.groupType', 'userSelection.selectedGroups', 'userSelection.selectedUsers');

insert into report_params (config_id, param_name, param_value)
  select cia.config_id, 'userSelection.selectedUsers', u.id from config_id_with_all_users_selector cia, at_user u
    where u.is_enabled = true and u.overtime_tracking = true;

update report_params rp set rp.param_value = 'false'
  where rp.param_name = 'userSelection.allUsers' and rp.config_id in (select cia.config_id from config_id_with_all_users_selector cia);

drop table config_id_with_all_users_selector;

-- IMPORT_LICENSE_KEY_PLACEHOLDER
-- -----------------------------------------------------------------------------------------------------------

INSERT
INTO patch_history (patch, pack_version, patch_timestamp)
VALUES (45, 0, now());

COMMIT;