<!doctype html>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.util.UserUtils" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>

<%
    final String reportTitle = message(request, "report.budgeted_vs_actual.title");
    ReportConfig reportConfig = (ReportConfig) request.getAttribute(Keys.REPORT_CONFIG_KEY);
%>
<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <%=reportTitle%>
    </title>
    <%@include file="../../css/scheme_styles.jsp" %>

    <!--[if !IE]> -->
    <!-- IMPORTANT!! need to include pdfmake BEFORE "/include_scripts.jsp" -->
    <at:script page="/js/pdfmake/pdfmake.min.js"/>
    <at:script page="/js/pdfmake/vfs_fonts.js"/>
    <!-- <![endif]-->
    
    <jsp:include page="/include_scripts.jsp"/>

    <!--[if !IE]> -->
    <at:script page="/js/amcharts/amcharts.js"/>
    <at:script page="/js/amcharts/themes/light.js"/>
    <at:script page="/js/amcharts/serial.js"/>
    
    <at:script page="/js/amcharts/plugins/export/export.min.js"/>
    <at:style page="/js/amcharts/plugins/export/export.css"/>

    <at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
    <!-- <![endif]-->
    
    <!--[if !IE]> -->
    <at:script page="/js/pdfjs/compatibility.js"/>
    <at:script page="/js/pdfjs/pdf.worker.js"/>
    <at:script page="/js/pdfjs/pdf.js"/>
    <!-- <![endif]-->
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" id="estimatedVsActualReport"
      class="budget_report report reportResultsPage reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <div class="mainContentPadding rightPadding">
        <div class="reportPageContentDiv">

            <jsp:include page="../report_leave_header.jsp">
                <jsp:param name="reportName" value="<%=reportTitle%>"/>
            </jsp:include>
            <div id="reportPlaceholder" class="empty"></div>
            <jsp:include page="../report_leave_footer.jsp"/>
        </div>
    </div>

    <div id="editReportConfigurationPanel" style="display: none;" class="budgetActualReportConfigurationPanel">

        <table>
            <tr>
                <td class="editReportConfigurationHeader">
                    <bean:message key="report.selector_label.edit_report_configuration"/>
                </td>
                <td id="spinnerPlaceholderId"></td>
            </tr>
        </table>

        <jsp:include page="estimated_vs_actual_config.jsp"/>

        <div class="buttonsPanel">
            <input type="button" id="cancelReportConfiguration" class="cancelReportConfiguration" value="<bean:message key='common.approvers_dialog.cancel'/>"/>
            <input type="button" id="applyReportConfiguration" class="applyReportConfiguration" value="<bean:message key='common.approvers_dialog.apply'/>"/>
            <div class="errorMessage"></div>
        </div>
    </div>

    <div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
        <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
    </div>

    <div id='reportOverlay' class='reportOverlay'></div>
    <div id='spinnerReportOverlay'></div>


    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>

    <%@include file="/js/util/server_date_time_utils_js.jsp" %>

    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/single_date_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

    <at:script page='/js/reports/save_configuration_control.js'/>
    <at:script page="/js/reports/SaveReportManager.js"/>
    <at:script page="/js/reports/saveDialogControl.js"/>

    <%@ include file="/js/description_util_entities_init_js.jsp" %>

    <jsp:include page="/reports/create_report_controls.jsp">
        <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
    </jsp:include>


    <script type="text/javascript">
        var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
        
        var reportParameters = <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>;
        reportParameters.dateSelection.date = Date.parseJSONDate(reportParameters.dateSelection.date);
        
        var reportMediator = new BudgetedVsActualReportMediator().init(
                {
                    editConfigurationButton: ".editConfiguration",
                    panelId: "#editReportConfigurationPanel",
                    reportTitle: "<%=reportTitle%>",
                    reportConfigId: <%= reportConfig.getId() %>,
                    reportConfigName: "<%= reportConfig.getName() == null ? "" : reportConfig.getName() %>",
                    reportParameters: reportParameters,
                    generateReportUrl: '<html:rewrite page="/reports/estimatedvsactualgenerate.do"/>',
                    isFilteredByAssignments: <%= !UserUtils.isAllProjectsAvailableToLoggedInUser( request ) %>,
                    cpList: cpList
                }
        );

        $(document).ready(
                function()
                {
                    reportMediator.generateReport(true);
                }
        );
    </script>

</body>
</html>