<!doctype html>
<%@ page import="com.actimind.actitime.Keys,com.actimind.actitime.Navigator"%>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/><bean:message key="report.budgeted_vs_actual.title"/></title>
    <%@include file="/css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
    <!--[if !IE]> -->
    <at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
    <!-- <![endif]-->
</head>
<body class="evaform report reportForm reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <jsp:include page="../base_report_form_container.jsp">
        <jsp:param name="title" value="report.budgeted_vs_actual.title"/>
        <jsp:param name="dateSelectorMessageKey" value="report.budgeted_vs_actual.view.date_selector"/>
        <jsp:param name="configPage" value="budgeted_vs_actual/estimated_vs_actual_config.jsp"/>
    </jsp:include>

    <at:form action="/reports/estimatedvsactual" method="post" styleId="actionForm">
        <html:hidden property="submitted" value="1"/>
        <html:hidden property="reportParameters"/>
    </at:form>
    
</div>


<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<%@ include file="/js/description_util_entities_init_js.jsp"%>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<at:script page="/js/reports/preview/csv/eva/EstimateVsActualCSVPreviewGenerator.js"/>
<at:script page="/js/reports/preview/csv/eva/EstimateVsActualCSVPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/csv/eva/EstimateVsActualCSVPreviewHeader.js"/>
<at:script page="/js/reports/preview/html/eva/EstimateVsActualHTMLPreviewGenerator.js"/>
<at:script page="/js/reports/preview/html/eva/EstimateVsActualHTMLPreviewHeaderSection.js"/>

<at:script page="/js/reports/preview/html/eva/BaseTasksEvAHTMLPreviewStrategy.js"/>
<at:script page="/js/reports/preview/html/eva/EstimatedTasksEvAHTMLPreviewStrategy.js"/>
<at:script page="/js/reports/preview/html/eva/AllTasksEvAHTMLPreviewStrategy.js"/>
<at:script page="/js/reports/preview/html/eva/EstimateVsActualHTMLPreviewGroupingSection.js"/>


<script>
    PageOverlayTipsManager.setInstance(new ReportPageOverlayTipsManager("tips.report.estimated_actual.title"));

    <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new EstimatedVsActualFormMediator().init(
            {
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                cpList: cpList
            }
    );

</script>

</body>
</html>
