<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.reports.budget.BudgetedVsActualReportHtmlViewSettings" %>
<%@ page import="com.actimind.actitime.reports.newengine.view.html.HtmlCellBean" %>
<%@ page import="com.actimind.actitime.util.TimeUtils" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%-- This is a tweaked version of /reports/new_engine/report_table.jsp.
     The tweak is to render custom report column headers.
     The tweak is needed, because the new report engine currently doesn't support multileveled headers.
     TODO: 'superheader' support in the New Report Engine (kostenko)
     Also, there are some changes in rendering value cells.
--%>

<bean:define id="report" name="<%=Keys.REPORT_KEY%>" type="com.actimind.actitime.reports.newengine.view.html.HtmlGroupingReportView"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings"
             type="com.actimind.actitime.resources.SystemSettings"/>

<%
    boolean headerRendered = false;

    BudgetedVsActualReportHtmlViewSettings reportSettings = (BudgetedVsActualReportHtmlViewSettings) report.getSettings();

    String dateTo = TimeUtils.formatDate(reportSettings.getDateTo(), settings.getDateFormat());
%>

<table cellpadding="4" border="0" class="display-for-print report-table" id="report-table">
    <logic:iterate id="row" name="report" property="rows" type="com.actimind.actitime.reports.newengine.view.html.HtmlRowBean" >

          <% if (!headerRendered) { %>

                <tr class="<bean:write name="row" property="cssClassesJoined"/>">
                    <%
                        HtmlCellBean cellBean = (HtmlCellBean) row.getCells().next();
                        int rowspan = reportSettings.isNonBudgetedTasksIncluded() ? 3 : 2;
                    %>
                    <td rowspan="<%=rowspan%>" colspan="<%=cellBean.getColspan()%>" class="<%=cellBean.getCssClassesJoined()%>">
                        <div style="padding-left: <%=cellBean.getIndent() * 30%>px;">
                            <% request.setAttribute("cell", cellBean);%>
                            <jsp:include page='<%=cellBean.getRendererJsp()%>'/>
                        </div>
                    </td>
                    <% if (reportSettings.isNonBudgetedTasksIncluded()) { %>
                        <td rowspan="3" class="data_column_header">
                            <bean:message key="report.budgeted_vs_actual.spent_time.total"/>
                        </td>
                        <td rowspan="3" class="data_column_header">
                            <bean:message key="report.budgeted_vs_actual.spent_time.nonbudgeted"/>
                        </td>
                        <td colspan="4" class="data_column_superheader">
                            <bean:message key="report.budgeted_vs_actual.spent.budgeted_tasks"/>
                        </td>
                    <% } else { %>
                        <td rowspan="2" class="data_column_header">
                            <bean:message key="report.budgeted_vs_actual.spent_time"/>
                        </td>
                        <td rowspan="2" class="data_column_header">
                            <bean:message key="report.budgeted_vs_actual.budgeted"/>
                        </td>
                        <td colspan="2" class="data_column_superheader" nowrap>
                            <bean:message key="report.budgeted_vs_actual.variance"/><br>
                            <span class="header_note">(<bean:message key="report.budgeted_vs_actual.budgeted_minus_spent"/>)</span>
                        </td>
                    <% } %>
                </tr>

                <tr class="<bean:write name="row" property="cssClassesJoined"/>">
                    <% if (reportSettings.isNonBudgetedTasksIncluded()) { %>
                        <td rowspan="2" class="data_column_header subheader" valign="middle" style="padding-top: 6px">
                            <bean:message key="report.budgeted_vs_actual.spent_time"/>
                        </td>
                        <td rowspan="2" class="data_column_header subheader" valign="middle" style="padding-top: 6px">
                            <bean:message key="report.budgeted_vs_actual.budgeted"/>
                        </td>
                        <td colspan="2" class="data_column_superheader subheader" nowrap>
                            <bean:message key="report.budgeted_vs_actual.variance"/><br>
                            <span class="header_note">(<bean:message key="report.budgeted_vs_actual.budgeted_minus_spent"/>)</span>
                        </td>
                    <% } else { %>
                        <td class="data_column_header">
                            <bean:message key="report.budgeted_vs_actual.mh"/>
                        </td>
                        <td class="data_column_header">
                            %
                        </td>
                    <% } %>
                </tr>

                <% if (reportSettings.isNonBudgetedTasksIncluded()) { %>
                    <tr class="<bean:write name="row" property="cssClassesJoined"/>">
                        <td class="data_column_header subheader" style="font-size: 10px; padding: 2px">
                            <bean:message key="report.budgeted_vs_actual.mh"/>
                        </td>
                        <td class="data_column_header subheader" style="font-size: 10px; padding: 2px">
                            %
                        </td>
                    </tr>
                <% } %>

              <%
                headerRendered = true;
              }
              else
              {
                %>
                    <tr class="<bean:write name="row" property="cssClassesJoined"/>">
                      <logic:iterate id="cellBean" name="row" property="cells" type="com.actimind.actitime.reports.newengine.view.html.HtmlCellBean">
                          <td colspan="<bean:write name="cellBean" property="colspan"/>"
                              class="<bean:write name="cellBean" property="cssClassesJoined"/>"
                              style="padding-left: <%=4 + cellBean.getIndent() * 30%>px;">
                                  <bean:define id="cell" name="cellBean" toScope="request" type="com.actimind.actitime.reports.newengine.view.html.HtmlCellBean"/>
                                  <jsp:include page='<%=cellBean.getRendererJsp()%>'/>
                          </td>
                      </logic:iterate>
                    </tr>
                <%
              }
          %>
    </logic:iterate>
</table>
