<%@ taglib prefix="logic" uri="http://struts.apache.org/tags-logic" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ page import="com.actimind.actitime.services.beans.report.BillingSummaryReportInfo" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings"
             type="com.actimind.actitime.resources.SystemSettings"/>

<script type="text/javascript">
    var BillingSummaryReportInfo = {
        TIME_ON_BILLABLE_TASKS: "<%=BillingSummaryReportInfo.TIME_ON_BILLABLE_TASKS%>",
        TIME_ON_NON_BILLABLE_TASKS: "<%=BillingSummaryReportInfo.TIME_ON_NON_BILLABLE_TASKS%>",
        TIME_ON_BOTH_BILLABLE_AND_NON_BILLABLE_TASKS: "<%=BillingSummaryReportInfo.TIME_ON_BOTH_BILLABLE_AND_NON_BILLABLE_TASKS%>",
        BILLABLE_AMOUNT: "<%=BillingSummaryReportInfo.BILLABLE_AMOUNT%>",
        BILLABLE_TIME_AND_BILLABLE_AMOUNT: "<%=BillingSummaryReportInfo.BILLABLE_TIME_AND_BILLABLE_AMOUNT%>",
        BILLABLE_TIME_AND_BILLABLE_AMOUNT_WITH_AVERAGE_RATES: "<%=BillingSummaryReportInfo.BILLABLE_TIME_AND_BILLABLE_AMOUNT_WITH_AVERAGE_RATES%>"
    }
</script>


<table class="displayedDataControl" cellpadding="0" cellspacing="0" border="0">
    
    <tr id="billingTimeSelector_showTime" style="display: none;">
        <td class="aligned_radio_button_cell"><input type="radio" id="radio_show_time" class="radio"
                                                     name="infoToShow" value=""/>
        </td>
        <td class="aligned_radio_button_text">
            <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td class="text" nowrap><label for="radio_show_time"><bean:message
                            key="report.billing_summary.report_config.show_time_reported_on"/></label>&nbsp;</td>
                    <td class="text" nowrap>
                        <select id="billingStatusFilter">
                            <option value="<%=BillingSummaryReportInfo.TIME_ON_BILLABLE_TASKS%>">
                                <bean:message key="report.billing_sumamry.filter.billable_only"/></option>
                            <option value="<%= BillingSummaryReportInfo.TIME_ON_NON_BILLABLE_TASKS %>">
                                <bean:message key="report.billing_summary.filter.nonbillable_only"/></option>
                            <option value="<%=BillingSummaryReportInfo.TIME_ON_BOTH_BILLABLE_AND_NON_BILLABLE_TASKS%>" selected="selected">
                                <bean:message
                                        key="report.billing_summary.filter.billable_and_nonbillable"/></option>
                        </select>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr id="billingTimeSelector_billableAmount" style="display: none;">
        <td class="aligned_radio_button_cell"><input type="radio" class="radio" name="infoToShow"
                                                     value="<%=BillingSummaryReportInfo.BILLABLE_AMOUNT%>"
                                                     id="radio_show_amount"/></td>
        <td class="aligned_radio_button_text"><label
                for="radio_show_amount"><%=message( request, "report.billing_summary.report_config.show_billable_amount", settings.getCurrencySign() )%>
        </label></td>
    </tr>
    <tr id="billingTimeSelector_timeAndAmount" style="display: none;">
        <td class="aligned_radio_button_cell"><input type="radio" class="radio" name="infoToShow"
                                                     value="<%=BillingSummaryReportInfo.BILLABLE_TIME_AND_BILLABLE_AMOUNT%>"
                                                     id="radio_show_time_and_amount"/></td>
        <td class="aligned_radio_button_text"><label
                for="radio_show_time_and_amount"><%=message( request, "report.billing_summary.report_config.show_billable_time_and_amount",  settings.getCurrencySign() )%>
        </label>&nbsp;&nbsp;&nbsp;</td>
    </tr>
    <tr id="billingTimeSelector_rates" style="display: none;">
        <td colspan="2">
            <table class="showAverageRatesTable" cellpadding="0" cellspacing="0" border="0">
                <tr class="checkbox">
                    <td class="text" nowrap>
                    <td>
                        <input type="checkbox" id="checkbox_show_average_rates"
                               value="<%=BillingSummaryReportInfo.BILLABLE_TIME_AND_BILLABLE_AMOUNT_WITH_AVERAGE_RATES%>"
                               onclick="document.getElementById('radio_show_time_and_amount').checked = true"/>
                    </td>
                    <td class="text" nowrap><label for="checkbox_show_average_rates"><bean:message
                            key="report.billing_summary.show_average_rates"/></label></td>
                </tr>
            </table>
        <td>
    </tr>

    <tr id="billingTimeSelector_billable" style="display: none;">
        <td class="aligned_radio_button_cell">
            <input type="radio" class="radio" name="infoToShow"
                   value="<%=BillingSummaryReportInfo.TIME_ON_BILLABLE_TASKS %>"
                   id="radio_billable_status_filter"/>
        </td>
        <td class="aligned_radio_button_text">
            <label for="radio_billable_status_filter">
                <bean:message key="report.billing_summary.report_config.show_time_reported_on"/>
                <bean:message key="report.billing_sumamry.filter.billable_only"/>
            </label>
        </td>
    </tr>
    <tr id="billingTimeSelector_nonBillable" style="display: none;">
        <td class="aligned_radio_button_cell">
            <input type="radio" class="radio" name="infoToShow"
                   value="<%= BillingSummaryReportInfo.TIME_ON_NON_BILLABLE_TASKS%>"
                   id="radio_non_billable_status_filter"/>
        </td>
        <td class="aligned_radio_button_text">
            <label for="radio_non_billable_status_filter">
                <bean:message key="report.billing_summary.report_config.show_time_reported_on"/>
                <bean:message key="report.billing_summary.filter.nonbillable_only"/>
            </label>
        </td>
    </tr>
    <tr id="billingTimeSelector_anyStatus" style="display: none;">
        <td class="aligned_radio_button_cell">
            <input type="radio" class="radio" name="infoToShow"
                   value="<%= BillingSummaryReportInfo.TIME_ON_BOTH_BILLABLE_AND_NON_BILLABLE_TASKS%>"
                   id="radio_any_billing_status_filter"/>
        </td>
        <td class="aligned_radio_button_text">
            <label for="radio_any_billing_status_filter">
                <bean:message key="report.billing_summary.report_config.show_time_reported_on"/>
                <bean:message key="report.billing_summary.filter.billable_and_nonbillable"/>
            </label>
        </td>
    </tr>
    
</table>
