<!doctype html>
<%@ page import="com.actimind.actitime.Navigator"%>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<%
    final String reportName = message( request, "report.cost.title" );
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <%=reportName%></title>

    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <%-- Load users and groups to JS, for use in the users selectors --%>
    <jsp:include page="/util/users.jsp"/>
    <jsp:include page="/util/user_groups.jsp"/>
    <jsp:include page="/util/time_zone_groups.jsp"/>

    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
</head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      class="costform report reportForm reportConfigPage with-navigation">

<div id="container">

<jsp:include page="../top.jsp" flush="false">
    <jsp:param name="menuSelected"    value="<%=Navigator.REPORTS_KEY%>"/>
</jsp:include>

    <jsp:include page="base_report_form_container.jsp">
        <jsp:param name="title" value="report.cost.title"/>
        <jsp:param name="configPage" value="cost_config.jsp"/>
    </jsp:include>

    <at:form action="/reports/cost" method="post" styleId="actionForm">
        <html:hidden property="submitted" value="1"/>
        <html:hidden property="reportParameters"/>
    </at:form>

    <at:form action="/reports/costcsvfromform" method="post" styleId="reportExportToCSVForm">
        <html:hidden property="reportParameters"/>
    </at:form>
</div>



<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<%@ include file="/js/description_util_entities_init_js.jsp"%>

<at:script page="/js/controls/displayed_data_radiogroup_controls_bs_report.js"/>
<at:script page="/js/controls/ReportColumnsSelctorButtonsCostOfWork.js"/>

<at:script page="/js/reports/preview/csv/CSVPreviewCostProfitLossAdditionalSection.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewBaseColumnsStrategy.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewHeaderSection.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewOneLevelsColumnsStrategy.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewTwoLevelsColumnsStrategy.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewTwoLevelsUsersOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewTwoLevelsGroupsOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewUserByGroupsOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewUserByGroupsThreeLevels.js"/>
<at:script page="/js/reports/preview/csv/cost/CostCSVPreviewGenerator.js"/>

<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewBaseColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewBaseSection.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewGeneralCostsSection.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewGrandTotalSection.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewHeaderSection.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewOneLevelHeaderBaseColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewOneLevelHeaderUsersOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewOneLevelHeaderGroupsOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewTwoLevelsHeaderBaseColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewTwoLevelsHeaderUsersOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewTwoLevelsHeaderGroupsOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewUsersByGroupsCostOnlyColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewUsersByGroupsThreeLevelsColumnsStrategy.js"/>
<at:script page="/js/reports/preview/html/cost/CostHTMLPreviewGenerator.js"/>

<script>
    PageOverlayTipsManager.setInstance(new ReportPageOverlayTipsManager("tips.report.cost.title"));

    <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new CostFormMediator().init(
            {
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                users: users,
                userGroups:  EnabledFeatures.UGR ? userGroups : null,
                timeZoneGroups:  EnabledFeatures.TZG ? timeZoneGroups : null,
                cpList: cpList
            }
    );

</script>

</body>
</html>
