<!doctype html>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.reports.ReportEntry" %>
<%@ page import="com.actimind.actitime.reports.renderers.CostReportHtmlRenderer" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="java.util.List" %>

<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>


<bean:define id="report" name="<%=Keys.REPORT_KEY%>" type="com.actimind.actitime.reports.ReportInfo"/>
<bean:define id="params" name="<%=Keys.REPORT_PARAMETERS%>" type="com.actimind.actitime.services.beans.report.CostReportParameters"/>

<%
    CostReportHtmlRenderer renderer = new CostReportHtmlRenderer( out, request, response, report, params );
%>

<table cellpadding="4" border="0" class='<%=renderer.getMainTableClasses()%> display-for-print report-table' id="report-table">

    <%
        final ReportEntry rootEntry = report.getRootEntry();
    %>

    <%-- Costs for the Selected Customers and Projects table --%>

    <tr id="workCostsHeader">
        <td nowrap valign="center" class="listtblcolheader headerFirstCell" rowspan="<%=renderer.hasGroupReportColumns() ? 3 : 2%>" style="text-align: left;" width="440">
            <at:img page="pixel.gif" width="1" height="10" alt=""/><br>
            <span><%=ATMessageResources.message( request, "report.cost_items" )%></span><br>
            <at:img page="pixel.gif" width="1" height="10"/>
        </td>
        <%
            renderer.printOverallColumnHeader();
            renderer.printRegularColumnHeaders();
        %>
    </tr>
    <% if( renderer.hasGroupReportColumns() ) { %>
    <tr>
        <%
            renderer.printChildRegularColumnHeaders();
        %>
    </tr>
    <% } %>
    <tr>
        <%
            renderer.printRegularColumnSubHeaders();
        %>
    </tr>


    <%
        final ReportEntry timeTrackEntry = rootEntry.findChildEntry(ReportEntry.TOTAL_TIME_TRACK_REPORT_ENTRY_KEY);

        renderer.printTotalRow(timeTrackEntry);
        renderer.printTimeTrackRows(request, timeTrackEntry);
    %>

    <%
        ReportEntry totalLeaveReportEntry = params.isShowLeaveTimeCosts() ? rootEntry.findChildEntry( ReportEntry.TOTAL_LEAVE_REPORT_ENTRY_KEY ) : null;
        ReportEntry totalOvertimeReportEntry = params.isShowOvertimeAddition() ? rootEntry.findChildEntry( ReportEntry.OVERTIME_BONUS_REPORT_ENTRY_KEY ) : null;

        if( totalLeaveReportEntry != null || totalOvertimeReportEntry != null ) { %>
    <%-- General Costs table --%>

    <tr>
        <td class="generalCostsTitle rowTitleCell" colspan="<%=renderer.getTotalColumnsCount()%>" >
            <%=renderer.getGeneralCostsTableTitle()%>
            <div class='rowSubtitle notemsg'>
                <%=renderer.getGeneralCostsTableSubtitle()%>
            </div>
        </td>
    </tr>

    <%
        if (totalLeaveReportEntry != null)
        {
            List leaves = totalLeaveReportEntry.getChildEntries();

            if (leaves.size() > 1)
            {
                renderer.printTotalRow(totalLeaveReportEntry);
            }
            else if (leaves.size() == 0)
            {
                renderer.printNoLeaveRow(totalLeaveReportEntry);
            }

            boolean singleRow = leaves.size() == 1;
            for( Object leave : leaves )
            {
                renderer.printLeaveRow( ( ReportEntry ) leave, singleRow );
            }
        }

        if( totalOvertimeReportEntry != null )
        {
            renderer.printTotalRow( totalOvertimeReportEntry );
        }
    %>

    <%
        }
    %>

    <tr>
        <td class="reportTableBottom" colspan="<%=renderer.getTotalColumnsCount()%>" id="fullrowCell4">&nbsp;</td>
    </tr>

    <%-- Total Cost table --%>

    <%
        renderer.printTotalRow(rootEntry);
    %>

</table>