<%@ page contentType="text/html;"%>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>
<%@ page import="java.util.Collection" %>
<%@ page import="java.util.Map" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="com.actimind.actitime.util.PRO" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="com.actimind.common.ProductWebSiteURLs" %>
<%@ page import="com.actimind.common.Product" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<bean:cookie id="showUnavailableReportsCookie" name="showAllReports" value="true"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<%
    String id = request.getParameter("id");
    UserAccessRightsBean  userAr = UserAccessRightsBean.getUserRights(request);

    final boolean showUnavailableReports = "true".equals( showUnavailableReportsCookie.getValue() );

    Map<ReportType.Category, Collection<ReportType>> reportsMap = ReportType.getValuesGrouped();
%>
<script type="text/javascript">

    Report = function(id, available, labelIdPreffix, descIdPeffix,
                      hiddenClass, activeClass, hoverClass, url)
    {
        this.id = id;
        this.available = available;
        this.labelIdPreffix = labelIdPreffix;
        this.descIdPeffix = descIdPeffix;
        this.hiddenClass = hiddenClass;
        this.activeClass = activeClass;
        this.hoverClass = hoverClass;
        this.url = url;
    };

    Report.prototype =
    {
        getId: function()
        {
            return this.id;
        },
        isAvailable: function()
        {
            return this.available;
        },
        getDescriptionElement: function ()
        {
            return document.getElementById(this.descIdPeffix + this.id);
        },
        getLabelElement: function ()
        {
            return document.getElementById(this.labelIdPreffix + this.id);
        },
        getUrl: function ()
        {
            return this.url;
        },

        hide: function()
        {
            addClass( this.getLabelElement(), this.hiddenClass );
            addClass( this.getDescriptionElement(), this.hiddenClass );
        },

        show: function()
        {
            removeClass( this.getLabelElement(), this.hiddenClass );
            removeClass( this.getDescriptionElement(), this.hiddenClass );
        },

        activate: function()
        {
            this.active = true;
            this.unhover();
            addClass(this.getLabelElement(), this.activeClass);
            addClass(this.getDescriptionElement(), this.activeClass);
        },

        deactivate: function()
        {
            this.active = false;
            removeClass(this.getLabelElement(), this.activeClass);
            removeClass(this.getDescriptionElement(), this.activeClass);
        },

        hover: function()
        {
            if(!this.active)
            {
                addClass(this.getLabelElement(), this.hoverClass);
                addClass(this.getDescriptionElement(), this.hoverClass);
            }
        },

        unhover: function()
        {
            removeClass(this.getLabelElement(), this.hoverClass);
            removeClass(this.getDescriptionElement(), this.hoverClass);
        }
    };


    ReportCategory = function(id, labelIdPreffix, hiddenClass)
    {
        this.id = id;
        this.labelIdPreffix = labelIdPreffix;
        this.hiddenClass = hiddenClass;
        this.reports = [];
    };
    
    ReportCategory.prototype =
    {
        getId: function()
        {
            return this.id;
        },
        getReports: function()
        {
            return this.reports;
        },
        addReport: function (report)
        {
            this.reports.push(report);
        },

        getCategoryLabelElement: function ()
        {
            return document.getElementById(this.labelIdPreffix + this.id);
        },
        hideUnavailable: function()
        {
            var hasAvailableReports = false;
            for (var i = 0; i < this.reports.length; i++)
                if (!this.reports[i].isAvailable())
                    this.reports[i].hide();
                else
                    hasAvailableReports = true;
            if (!hasAvailableReports)
                addClass(this.getCategoryLabelElement(), this.hiddenClass);
        },
        showUnavailable: function()
        {
            for (var i = 0; i < this.reports.length; i++)
                this.reports[i].show();
            removeClass(this.getCategoryLabelElement(), this.hiddenClass);
        }
    };

    CreateReportDialogController = function(categoryLabelIdPreffix, reportLabelIdPreffix, reportDescrIdPreffix,
                                            activeClass, hoverClass, hiddenClass, createButtonId,
                                            isUnavailableShown, toggleUnavailableButtonId,
                                            hideUnavailableMessage, showUnavailableMessage,
                                            descriptionContainerId)
    {
        this.categoryLabelIdPreffix = categoryLabelIdPreffix;
        this.reportLabelIdPreffix = reportLabelIdPreffix;
        this.reportDescrIdPreffix = reportDescrIdPreffix;

        this.descriptionContainerId = descriptionContainerId;
        this.hiddenClass = hiddenClass;
        this.hideUnavailableMessage = hideUnavailableMessage;
        this.showUnavailableMessage = showUnavailableMessage;
        this.activeClass = activeClass;
        this.hoverClass = hoverClass;
        this.createButtonId = createButtonId;
        this.isUnavailableShown = isUnavailableShown;
        this.toggleUnavailableButtonId = toggleUnavailableButtonId;
        this.categories = [];
        this.shownReport = null;
    };
    CreateReportDialogController.prototype =
    {
        //private
        getCategory: function(id)
        {
            for (var i = 0; i < this.categories.length ; i++)
                if (this.categories[i].getId() == id)
                    return this.categories[i];
            return null;
        },

        //private
        getReport: function(id)
        {
            for (var i = 0; i < this.categories.length ; i++)
            {
                var reports = this.categories[i].getReports();
                for( var j = 0; j < reports.length; j++ )
                    if (reports[j].getId() == id)
                        return reports[j];
            }
            return null;
        },

        addReportType: function(categoryId, id, available, url)
        {
            var category = this.getCategory(categoryId);
            if (category == null)
            {
                category = new ReportCategory(categoryId, this.categoryLabelIdPreffix, this.hiddenClass);
                this.categories.push(category);
            }
            var report = new Report(id, available, this.reportLabelIdPreffix, this.reportDescrIdPreffix,
                this.hiddenClass, this.activeClass, this.hoverClass, url);
            category.addReport(report);
            addListener(report.getLabelElement(), "click", makeHandler(function()
            {
                this.switchTo(id);
            }, this));
            addListener(report.getLabelElement(), "mouseover", makeHandler(function(){
                this.getReport(id).hover();
            }, this));
            addListener(report.getLabelElement(), "mouseout", makeHandler(function(){
                this.getReport(id).unhover();    
            }, this));

        },
        //private
        updateCreateButton: function(isEnabled, callback)
        {
            this.createButton.disabled = (isEnabled ? undefined : "disabled");
            this.createButton.onclick = callback;
        },
        switchTo: function(id)
        {
            if (this.shownReport != null)
                this.shownReport.deactivate();
            this.shownReport = this.getReport(id);
            this.shownReport.activate();
            var that = this;
            this.updateCreateButton(this.shownReport.isAvailable(), function()
            {
                createConfig(that.shownReport.getUrl());
            });
            this.updateDescriptionCellClassName();
        },
        //private
        updateToggleUnavailableButton: function()
        {
            this.toggleUnavailableButton.innerHTML = (this.isUnavailableShown) ? this.hideUnavailableMessage : this.showUnavailableMessage;
        },
        initialize: function()
        {
            this.toggleUnavailableButton = document.getElementById(this.toggleUnavailableButtonId);
            this.createButton = document.getElementById(this.createButtonId);
            this.updateToggleUnavailableButton();
            this.updateReportVisibility();
            this.switchToFirst(!this.isUnavailableShown);
            this.updateDescriptionCellClassName();
        },
        switchToFirst: function( checkAvailable )
        {
            for (var i = 0; i < this.categories.length ; i++)
            {
                var reports = this.categories[i].getReports();
                for (var j = 0; j < reports.length; j++)
                    if (!checkAvailable || reports[j].isAvailable())
                    {
                        this.switchTo(reports[j].getId());
                        return;
                    }
            }

            if (this.shownReport)
                this.shownReport.deactivate();
            this.shownReport = null;
        },
        //private
        updateReportVisibility: function()
        {
            for (var i = 0; i < this.categories.length; i++)
            {
                if (this.isUnavailableShown)
                    this.categories[i].showUnavailable();
                else
                {
                    this.categories[i].hideUnavailable();
                    if (this.shownReport != null && !this.shownReport.isAvailable())
                        this.switchToFirst(true);
                }
            }
            this.updateToggleUnavailableButton();
        },
        updateDescriptionCellClassName: function()
        {
            var descriptionContainer = document.getElementById(this.descriptionContainerId);
            $(descriptionContainer).toggleClass("noAvailableReports", !this.shownReport);
        },
        toggleUnavailable: function()
        {
            this.isUnavailableShown = !this.isUnavailableShown;
            this.updateReportVisibility();
            this.storeShowHideButtonState(this.isUnavailableShown);
            this.updateDescriptionCellClassName();
        },
        storeShowHideButtonState: function(value)
        {
            setCookie("showAllReports", value);
        }
    };

    var createReportDialogController = new CreateReportDialogController("reportCategory_","reportName_", "reportDescription_",
        "active", "hover", "hidden", "configureReportParametersButton", <%=showUnavailableReports%>, "toggleUnavailableButton",
        "<%=jsMessage(request, "saved_reports.create_dialog.hide_unavailable" )%>",
        "<%=jsMessage(request, "saved_reports.create_dialog.show_unavailable" )%>", "descriptionContainer");

</script>
<table class="dialog-header">
    <tr>
        <td class="lightBoxTitle"><%=message(request, "saved_reports.create_dialog.title")%></td>
        <td class="close-button">
            <div id="<%=id + "_closeLightbox"%>" class="closeButton"></div>
            <div class="disabledCloseButton"></div>
        </td>
    </tr>
</table>

<div class="innerContent">
    <table class="mainTable" cellspacing="0" cellpadding="0" border="0">
                    <tr>
                        <td class="report-types">
                            <div class="report-categories">
                                 <div class="inner">
                                <%
                                    boolean hasNotAvailable = false;
                                    for (Map.Entry<ReportType.Category, Collection<ReportType>> entry: reportsMap.entrySet())
                                        if (!PRO.isAvailable() || userAr.hasRight(entry.getKey().getAccessRight() ))
                                        {
                                            boolean hasAvailableReports = false;
                                            for (ReportType reportType: entry.getValue())
                                                if (reportType.isFeatureEnabled())
                                                {
                                                    hasAvailableReports = true;
                                                    break;
                                                }
                                            %><div class="category-header <%=(hasAvailableReports ? "" : "unavailable")%> <%=entry.getKey()%>" id="reportCategory_<%=entry.getKey()%>"><%=message( request, entry.getKey().getNameKey() )%></div><div class="category-items"><%
                                            for (ReportType reportType: entry.getValue())
                                            {
                                                boolean isEnabled = reportType.isFeatureEnabled();
                                                if (!isEnabled)
                                                    hasNotAvailable = true;
                                                %><div id="reportName_<%=reportType.getId()%>" class="report-type <%=(isEnabled ? "" : "unavailable")%> <%=entry.getKey()%>">
                                                        <span><%=message( request, reportType.getNameKey( request ) )%></span>
                                                    </div>
                                                    <script type="text/javascript">createReportDialogController.addReportType("<%=entry.getKey()%>", <%=reportType.getId()%>, <%=isEnabled%>, "<html:rewrite page='<%=reportType.getFullActionPath()%>'/>")</script>
                                          <% } %>
                                            </div>
                                        <%}
                                    %>
                                </div>
                                <div class="toggleUnavailable <%=(hasNotAvailable ? "" : "hidden")%>"><a href="#" id="toggleUnavailableButton" onclick="createReportDialogController.toggleUnavailable();return false;">&nbsp;</a></div>
                            </div>
                        </td>
                        <td class="description" id="descriptionContainer">
                            <table  class="description-wrapper" cellspacing="0" cellpadding="0" border="0">
                                <tr>
                                    <td class="descriptions-area">
                                        <%
                                            for (Map.Entry<ReportType.Category, Collection<ReportType>> entry: reportsMap.entrySet())
                                                for (ReportType reportType: entry.getValue())
                                                {%>
                                                    <div id="reportDescription_<%=reportType.getId()%>" class="report-description">
                                                        <div class="report-description-header"><%=message( request, reportType.getTitleKey( request ) )%></div>
                                                        
                                                        <%=message( request, reportType.getDescriptionKey( request ) )%>
                                                        
                                                        <p class="examples-link"><a href="javascript:void(0)" onclick="openUserGuidePage('<%=reportType.getUserGuidePage()%>')"><%=message( request, "saved_reports.create_dialog.see_examples" )%></a> &gt;&gt;</p>


                                                        <% if( !reportType.isFeatureAvailable() ) { %>
                                                            <%=message( request, "saved_reports.create_dialog.presence", ProductWebSiteURLs.get( Product.actiTIME ).getWebSiteURL() )%>
                                                        <% } else if(!reportType.isFeatureEnabled() && reportType.getFeatureBlockKey() != null ) { %>
                                                            <%=message( request, reportType.getFeatureBlockKey() )%>
                                                        <% } %>
                                                    </div>
                                                <%}
                                        %>
                                        <div class="noAvailableReports"><bean:message key="saved_reports.create_dialog.no_available_reports"/></div>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="create-report-area">
                                        <div class="blue-wrapper">
                                            <input type="button" id="configureReportParametersButton" class="reportButton" style="width:215px;" value="<%=filteredMessage( request, "saved_reports.create_dialog.create_button" )%>">
                                        </div>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
</div>
<script type="text/javascript">
    createReportDialogController.initialize();
</script>