<%@ page contentType="text/xml;charset=UTF-8" language="java" %><?xml version="1.0" encoding="utf-8"?>
<%@ page import="com.actimind.actitime.Keys" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<bean:define id="form" name="PrepareInvoiceForm" type="com.actimind.actitime.reports.PrepareInvoiceForm"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<invoice
    dateFrom="<bean:write name="form" property="dateFrom"/>"
    dateTo="<bean:write name="form" property="dateTo"/>"
    xmlns="http://www.actitime.com/xsd/2.1/invoice.xsd"
    xmlns:xsi="http://www.actitime.com/xsd/2.1/invoice.xsd">
    <header><bean:write name="form" property="invoiceHeader"/></header>
    <company>
        <name><bean:write name="form" property="companyName"/></name>
        <logoURI><bean:write name="form" property="logoURI"/></logoURI>
        <address><bean:write name="form" property="companyAddress"/></address>
    </company>
    <invoiceFields>
        <field name="<bean:message key='report.prepare_invoice.number'/>"><bean:write name="form" property="invoiceNumber"/></field>
        <field name="<bean:message key='common.date'/>"><bean:write name="form" property="date"/></field>

        <logic:iterate id="field" name="form" property="notEmptyExtraFields"
                       type="com.actimind.actitime.reports.PrepareInvoiceForm.Field">
        <field name="<bean:write name='field' property='name'/>"><bean:write name='field' property='value'/></field>
        </logic:iterate>
    </invoiceFields>
    <currencySign><bean:write name="settings" property="currencySign"/></currencySign>
    <billingSummary>
        <billTo><bean:write name="form" property="billTo"/></billTo>
        <terms><bean:write name="form" property="terms"/></terms>
        <subtotal><bean:write name="form" property="subtotal"/></subtotal>
        <total><bean:write name="form" property="total"/></total>
    </billingSummary>
    <items>
        <logic:iterate id="item" name="form" property="items"
                       type="com.actimind.actitime.reports.PrepareInvoiceForm.Item">
            <item taxable="<bean:write name='item' property='taxable'/>">
                <name><bean:write name='item' property='name'/></name>
                <description><bean:write name='item' property='description'/></description>
                <quantity><bean:write name='item' property='quantity'/></quantity>
                <rate><bean:write name='item' property='rate'/></rate>
                <amount><bean:write name='item' property='amount'/></amount>
            </item>
        </logic:iterate>
    </items>
    <discounts>
        <logic:iterate id="discount" name="form" property="discounts"
                       type="com.actimind.actitime.reports.PrepareInvoiceForm.Discount">
            <discount>
                <name><bean:write name='discount' property='name'/></name>
                <rate><bean:write name='discount' property='rate'/></rate>
                <amount><bean:write name='discount' property='amount'/></amount>
            </discount>
        </logic:iterate>
    </discounts>
    <taxes>
        <logic:iterate id="tax" name="form" property="taxes"
                       type="com.actimind.actitime.reports.PrepareInvoiceForm.Tax">
            <tax>
                <name><bean:write name='tax' property='name'/></name>
                <rate><bean:write name='tax' property='rate'/></rate>
                <amount><bean:write name='tax' property='amount'/></amount>
            </tax>
        </logic:iterate>
    </taxes>
    <customerMessage><bean:write name="form" property="customerMessage"/></customerMessage>
    <additionalInfo><bean:write name="form" property="additionalInfo"/></additionalInfo>
</invoice>