<!doctype html>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings"
             type="com.actimind.actitime.resources.SystemSettings"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/><bean:message key="report.invoice.title"/></title>

    <%@include file="../css/scheme_styles.jsp" %>
    <jsp:include page="/include_scripts.jsp"/>


    <at:script page="/invertedDays.js" preserveSessionID="true"
               timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
</head>
<body topmargin="0" leftmargin="0"
      marginheight="0" marginwidth="0" class="invoiceform reportForm report reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>
    <div class="outerContainer">
    <div id="mainContainer" class="mainContainer">
        <div class="pagetitle"><bean:message key="report.common.create"/>&nbsp;<bean:message key="report.invoice.title"/></div>
        <div id="createReportButton" class="createReportButton noprint"></div>

        <div class="reportConfigContainer">
            <div class="leftContainer">
                <div class="dateRangeTitile"><bean:message key="report.view.common.date_range"/></div>
                <div id="dateSelector" class="customDateRangeSelectorPanel"></div>
                <jsp:include page="invoice_config.jsp"/>
            </div>
            <div class="rightContainer">
                <jsp:include page="reportPreviewArea.jsp">
                    <jsp:param name="textPreviewKey" value="report.invoice.preview"/>
                    <jsp:param name="predefinedPreviewArea" value="invoicePreview.jsp"/>
                </jsp:include>
            </div>
        </div>
        <div class="buttonsPanel">
            <div class="errorMessage"></div>
            <span id="applyReportConfiguration" class="actionButton greyButton"><bean:message key="report.invoice.generate_button.label"/></span>
            <span id="cancelReportConfiguration" class="actionButton greyButton cancel"><bean:message key="common.approvers_dialog.cancel"/></span>
        </div>

        <div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
            <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
        </div>

        <at:form action="/reports/invoice" method="post" styleId="actionForm">
            <html:hidden property="submitted" value="1"/>
            <html:hidden property="reportParameters"/>
        </at:form>
    </div>
    </div>
</div>

<div id="incorrectDateTooltip" class="yellowTooltip tooltipText" style="display: none;">
    <div id="incorrectDateTooltip_textPlaceholder"></div>
</div>


    <jsp:include page="/reports/create_report_controls.jsp">
        <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
    </jsp:include>

  <%-- ChooseType Selector--%>
    <at:script page="/js/controls/invoice_billing_summary_choose_type.js"/>

   <%-- Preview Renderer &ndash;--%>
    <at:script page="/js/reports/InvoicePreviewRenderer.js"/>

    <%@ include file="/js/description_util_entities_init_js.jsp"%>

    <%@include file="/js/util/server_date_time_utils_js.jsp"%>


    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/single_date_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

    <script>
        PageOverlayTipsManager.setInstance(new InvoiceReportPageOverlayTipsManager());

        <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

         var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
         var reportMediator = new InvoiceFormMediator().init(
         {
            reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
            cpList: cpList
         }
         );
    </script>

</body>
</html>
