<!doctype html>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.*" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<%
    String reportName = message(request, "report.prepare_invoice.title");
    ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY );
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <%=reportName%></title>
    <%@include file="/css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
        class="prepareinvoice report reportResultsPage reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected"    value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <div id="mainContent" class="mainContentPadding rightPadding">
        <div class="reportPageContentDiv">
            <jsp:include page="report_header.jsp">
                <jsp:param name="reportName" value="<%=reportName%>"/>
            </jsp:include>
            <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td class="noprint" style="padding-top:2px;padding-bottom:2px;">
                        <div id="ClientSideErrorMessage" style="display:none;padding-bottom:7px">
                            <bean:define id="details" value="<%=message(request, \"report.prepare_invoice.details_suffix\")%>" toScope="request"/>
                            <jsp:include page="/client_side_errors_message.jsp" flush="false"/>
                        </div>
                        <div id="EmptyInvoiceError" style="display:none;">
                            <table cellpadding="0" cellspacing="0" border="0">
                                <tr>
                                    <td valign="top"><at:img page="error.gif"/></td>
                                    <td valign="top">
                                        <table border="0" cellspacing="0" cellpadding="0">
                                            <tr>
                                                <td valign="top" style="padding-left:6px;">
                                                    <span class="errormsg"><bean:message key="report.prepare_invoice.empty_invoice_error_message" /></span>
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>
            </table>
            <div id="reportPlaceholder" class="empty"></div>
            <div class="reportPageFooter reportPageHeaderFooter invoiceFooter">
                <table>
                    <tr class="reportHeaderFooterTr">
                        <td class="cellWithBorder">
                            <div id="createPDFInvoiceButton" class="greyButton withIcon disabled"><div class="buttonIcon"><span class="buttonTitle"><bean:message key="report.invoice.create_pdf"/></span></div></div>
                        </td>
                    </tr>
                </table>
            </div>
            &nbsp;<%-- This &nbsp; is a fix for ie8 bug 53103 --%>

            <jsp:include page="/form_changed_confirm.jsp"/>
        </div>
    </div>

    <%-- -- INVOICE ROW PROTOTYPES -- --%>
    <table style="display:none">
        <tr id="itemRowPrototype" onmouseover="onRowMouseOver(this, event)" onmouseout="onRowMouseOut(this, event)">
            <td valign="top" class="leftMost">
            <textarea style="width:324px" name="itemDescriptions"
                      onfocus="onRowFieldFocus(this)" onblur="onRowFieldBlur(this)" onchange="onItemFieldChange(this)"></textarea>
            </td>
            <td valign="top">
            <textarea style="width:104px" name="itemNames"
                      onfocus="onRowFieldFocus(this)" onblur="onRowFieldBlur(this)" onchange="onItemFieldChange(this)"></textarea>
            </td>
            <td valign="top">
                <input style="width:69px" class="numeric" type="text" name="itemQuantities" maxlength="13"
                       onfocus="onItemQuantityFocus(this)" onblur="onItemQuantityBlur(this)"/>
            </td>
            <td valign="top">
                <input style="width:64px" class="numeric" type="text" name="itemRates" maxlength="11"
                       onfocus="onItemRateFocus(this)" onblur="onItemRateBlur(this)"/>
            </td>
            <td valign="top" align="right" class="rightMost">
                <input style="width:101px; padding-right: 7px" type="text" class="numeric readonly" readonly="yes" name="itemAmounts"/><br>
                <select name="itemTaxableFlags" onchange="onItemTaxableFlagChange(this)">
                    <option value="1"><bean:message key="report.prepare_invoice.taxable"/></option>
                    <option value="0"><bean:message key="report.prepare_invoice.non_taxable"/></option>
                </select>
            </td>
            <td valign="top" class="hiddenColumn">
                <span><a href="#" onclick="deleteItemRow(this); return false"><at:defImg page="delete_row.gif" title="<%=message(request, \"report.prepare_invoice.delete_line_tooltip\")%>"/></a></span>
            </td>
        </tr>
        <tr id="discountRowPrototype" onmouseover="onRowMouseOver(this, event)" onmouseout="onRowMouseOut(this, event)">
            <td valign="top" class="leftMost">
            <textarea style="width:324px" name="discountNames"
                      onfocus="onRowFieldFocus(this)" onchange="onTextareaChange(this)" onblur="onRowFieldBlur(this); onLongTextareaBlur(this, [messageResource.getMessage('report.prepare_invoice.error.too_long_discount_name')])"></textarea>
            </td>
            <td valign="middle" colspan="2" class="noLeftBorder">
                <div align="right" style="width:195px" class="smallnote">
                    <bean:message key="report.prepare_invoice.enter_discount"/>
                </div>
            </td>
            <td valign="top">
                <input style="width:64px" class="numeric" type="text" name="discountRates" maxlength="14"
                       onfocus="onDiscountOrTaxValueFocus(this)" onblur="onDiscountValueBlur(this)">
            </td>
            <td valign="top" class="rightMost">
                <input style="width:111px" type="text" class="numeric readonly" readonly="yes" name="discountAmounts"/>
            </td>
            <td valign="top" class="hiddenColumn">
                <span><a href="#" onclick="deleteRow(this); return false"><at:defImg page="delete_row.gif" title="<%=message(request, \"report.prepare_invoice.delete_line_tooltip\")%>"/></a></span>
            </td>
        </tr>
        <tr id="taxRowPrototype" onmouseover="onRowMouseOver(this, event)" onmouseout="onRowMouseOut(this, event)">
            <td valign="top" class="leftMost">
            <textarea style="width:324px" name="taxNames"
                      onfocus="onRowFieldFocus(this)" onchange="onTextareaChange(this)" onblur="onRowFieldBlur(this); onLongTextareaBlur(this,[messageResource.getMessage('report.prepare_invoice.error.too_long_tax_name')])"></textarea>
            </td>
            <td valign="middle" colspan="2" class="noLeftBorder">
                <div align="right" style="width:195px" class="smallnote">
                    <bean:message key="report.prepare_invoice.enter_tax"/>
                </div>
            </td>
            <td valign="top">
                <input style="width:64px" class="numeric" type="text" name="taxRates" maxlength="14"
                       onfocus="onDiscountOrTaxValueFocus(this)" onblur="onTaxValueBlur(this)" />
            </td>
            <td valign="top" class="rightMost">
                <input style="width:111px" type="text" class="numeric readonly" readonly="yes" name="taxAmounts"/>
            </td>
            <td valign="top" class="hiddenColumn">
                <span><a href="#" onclick="deleteRow(this); return false"><at:defImg page="delete_row.gif" title="<%=message(request, \"report.prepare_invoice.delete_line_tooltip\")%>"/></a></span>
            </td>
        </tr>
    </table>

    <div id="editReportConfigurationPanel" class="invoiceReportConfigurationPanel" style="display: none;">

        <table>
            <tr>
                <td class="editReportConfigurationHeader">
                    <bean:message key="report.selector_label.edit_report_configuration"/>
                </td>
                <td id="spinnerPlaceholderId"></td>
            </tr>
        </table>

        <jsp:include page="invoice_config.jsp"/>

        <div class="buttonsPanel">
            <input type="button" id="cancelReportConfiguration" class="cancelReportConfiguration" value="<bean:message key='common.approvers_dialog.cancel'/>"/>
            <input type="button" id="applyReportConfiguration" class="applyReportConfiguration" value="<bean:message key='common.approvers_dialog.apply'/>"/>
            <div class="errorMessage"></div>
        </div>
    </div>

    <div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
        <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
    </div>

    <div id='reportOverlay' class='reportOverlay'></div>
    <div id='spinnerReportOverlay' ></div>
</div>

<at:script page="/js/numbers_validator_2.js"/>

<at:script page="/js/prepareinvoice.js"/>

<%-- Users selector files --%>
<at:script page="/js/usersSelector/at_simple_dropdown_for_shared_selector.js"/>

<at:script page="/js/share_reports_config_manager.js" />

<%@ include file="/js/description_util_entities_init_js.jsp"%>
<at:script page="/js/usersSelector/builder/UsersFilter.js" />
<at:script page="/js/usersSelector/builder/UsersFilterByAccessRight.js" />
<at:script page="/js/usersSelector/at_user_selector_panel_one_time_select.js" />

<%--ChooseType Selector--%>
<at:script page="/js/controls/invoice_billing_summary_choose_type.js"/>

<%-- DateRangeSelector files --%>
<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
<%@include file="/js/util/server_date_time_utils_js.jsp"%>
<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>
<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<at:script page="/js/reports/save_configuration_control.js"/>
<at:script page="/js/reports/SaveReportManager.js"/>
<at:script page="/js/reports/saveDialogControl.js"/>
<at:script page="/js/reports/invoiceSaveReportManager.js"/>

<%-- DateRangeSelector files end --%>


<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<script type="text/javascript">
    var rateValidator = new NumbersValidator(
            "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
            "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>",
            <%=Constants.MAX_RATE%>);

    var rateOrPercentValidator = new MoneyOrPercentValidator(
            "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
            "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>",
            <%=Constants.MAX_RATE%>);

    var quantityValidator = new NumbersValidator(
            "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
            "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>",
            <%=Constants.MAX_INVOICE_ITEM_QUANTITY%>,
            false, 4, true);

    var amountValidator = new NumbersValidator(
            "<%=StringUtils.escapeQuoteCharacter(settings.getDecimalSeparatorAsString())%>",
            "<%=StringUtils.escapeQuoteCharacter(settings.getDigitGroupingSymbolAsString())%>",
            <%=Constants.MAX_RATE%>);

    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new InvoiceReportMediator().init(
            {
                editConfigurationButton: ".editConfiguration",
                panelId: "#editReportConfigurationPanel",
                additionalPanelClass: "widthPanel",
                reportTitle: "<%=reportName%>",
                reportConfigId: <%= reportConfig.getId() %>,
                reportConfigName: "<%= reportConfig.getName() == null ? "" : reportConfig.getName() %>",
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                generateReportUrl: '<html:rewrite page="/reports/invoicegenerate.do"/>',
                cpList: cpList
            }
    );
    $( document ).ready(
        function ()
        {
            reportMediator.generateReport(true);
        }
    );
    Ext.onReady(
        function()
        {
            Ext.EventManager.onWindowResize( function () {Ext.menu.MenuMgr.hideAll();} );
        }
    );
</script>

</body>
</html>
