<!doctype html>
<%@ page import="com.actimind.actitime.AccessRight" %>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.Features" %>
<%@ page import="com.actimind.actitime.util.UserUtils" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%
    String reportTitleKey = ReportType.LEAVE_TIME.getTitleKey(request);
    String reportName = ATMessageResources.message(request, reportTitleKey);
    ReportConfig reportConfig = (ReportConfig) request.getAttribute(Keys.REPORT_CONFIG_KEY);

    Features enabledFeatures = FeaturesUtil.getFeatures();
    boolean ptoEnabled = enabledFeatures.isEnabled(Feature.PTO);
    boolean sdbEnabled = enabledFeatures.isEnabled(Feature.SDB);

    boolean canManageBalances = UserAccessRightsBean.getUserRights(request).hasRight( AccessRight.MANAGE_PTO_AND_SICK );

    String noteMsgKey = null;
    if (canManageBalances)
    {
        noteMsgKey = (ptoEnabled && sdbEnabled) ? "report.leaves.balances_shown_within_date_range" :
                     ptoEnabled ? "report.leaves.pto_shown_within_date_range" :
                     sdbEnabled ? "report.leaves.sick_shown_within_date_range" : null;
    }
%>
<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/>
        <%=reportName%>
    </title>

    <!--[if !IE]> -->
    <!-- IMPORTANT!! need to include pdfmake BEFORE "/include_scripts.jsp" -->
    <at:script page="/js/pdfmake/pdfmake.min.js"/>
    <at:script page="/js/pdfmake/vfs_fonts.js"/>
    <!-- <![endif]-->

    <%@include file="../css/scheme_styles.jsp" %>
    <jsp:include page="/include_scripts.jsp"/>

    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

    <!--[if !IE]> -->
    <at:script page="/js/pdfjs/compatibility.js"/>
    <at:script page="/js/pdfjs/pdf.worker.js"/>
    <at:script page="/js/pdfjs/pdf.js"/>
    <!-- <![endif]-->

</head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      class="leavesReport overtimeLeavesReport report reportResultsPage reportConfigPage with-navigation">
<div id="container">
    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>
</div>

<jsp:include page="report_leave_results.jsp">
    <jsp:param name="reportName" value="<%=reportName%>"/>
    <jsp:param name="noteText"
               value='<%=noteMsgKey != null ? "<div class=\\"noteMark\\">" + ATMessageResources.message(request, noteMsgKey) + "</div>" : ""%>'/>
</jsp:include>

<div id="editReportConfigurationPanel" style="display: none;">
    <table>
        <tr>
            <td class="editReportConfigurationHeader">
                <bean:message key="report.selector_label.edit_report_configuration"/>
            </td>
            <td id="spinnerPlaceholderId"></td>
        </tr>
    </table>
    <jsp:include page="leavetime_config.jsp"/>
    <div class="buttonsPanel">
        <input type="button" id="cancelReportConfiguration" class="cancelReportConfiguration" value="<bean:message key='common.approvers_dialog.cancel'/>"/>
        <input type="button" id="applyReportConfiguration" class="applyReportConfiguration" value="<bean:message key='common.approvers_dialog.apply'/>"/>
        <div class="errorMessage"></div>
    </div>
</div>


<div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
    <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
</div>

<div id='reportOverlay' class='reportOverlay'></div>
<div id='spinnerReportOverlay'></div>


<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@include file="/js/util/server_date_time_utils_js.jsp" %>

<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>

<at:script page='/js/controls/LeaveReportColumnsFormatSelector.js'/>

<at:script page='/js/reports/save_configuration_control.js'/>
<at:script page="/js/reports/SaveReportManager.js"/>
<at:script page="/js/reports/saveDialogControl.js"/>

<%-- Load users and groups to JS, for use in the users selectors --%>
<%@ include file="/js/description_util_entities_init_js.jsp" %>

<at:script page="/js/controls/selectorControls/at_report_leaves_selector_panel.js"/>
<at:script page="/js/controls/ReportLeaveTypesSelectorButton.js"/>

<at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>


<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>


<jsp:include page="/util/user_groups.jsp"/>
<jsp:include page="/util/time_zone_groups.jsp"/>
<jsp:include page="/util/users.jsp"/>

<script type="text/javascript">

    var UserRights = {
        MANAGE_PTO_AND_SICK: <%=canManageBalances%>
    };
    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;

    var reportParameters = <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>;
    reportParameters.dateRangeSelection.fromDate = Date.parseJSONDate(reportParameters.dateRangeSelection.fromDate);
    reportParameters.dateRangeSelection.toDate = Date.parseJSONDate(reportParameters.dateRangeSelection.toDate);
    
    var reportMediator = new LeavesReportMediator().init(
            {
                editConfigurationButton: ".editConfiguration",
                panelId: "#editReportConfigurationPanel",
                leavesData: LeaveTypeStore.getLeaveTypesOrdered(),
                reportTitle: "<%=reportName%>",
                reportConfigId: <%= reportConfig.getId() %>,
                reportConfigName: "<%= reportConfig.getName() == null ? "" : reportConfig.getName() %>",
                reportParameters: reportParameters,
                generateCSVUrl: '<html:rewrite page="/reports/leavesreportcsv.do"/>',
                isFilteredByAssignments: <%= !UserUtils.isAllProjectsAvailableToLoggedInUser( request ) %>,
                cpList: cpList,
                users: users,
                userGroups: EnabledFeatures.UGR ? userGroups : null,
                timeZoneGroups: EnabledFeatures.TZG ? timeZoneGroups : null
            }
    );

    $(document).ready(
            function()
            {
                reportMediator.generateReport(true);
            }
    );
</script>

</body>
</html>
