<!doctype html>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>
<%@ page import="com.actimind.actitime.*" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.beans.LeaveTypeBean" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings"
             type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="users" name="<%= Keys.USERS_LIST_KEY %>"/>

<%
    String titleKey = ReportType.LEAVE_TIME.getTitleKey( request );
    String reportName = message( request, titleKey );
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <%=reportName%>
    </title>
    <%@include file="../css/scheme_styles.jsp" %>
    <jsp:include page="/include_scripts.jsp"/>

    <at:script page="/invertedDays.js" preserveSessionID="true"
               timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

    <%-- Load users and groups to JS, for use in the users selectors --%>
    <jsp:include page="/util/users.jsp"/>
    <jsp:include page="/util/user_groups.jsp"/>
    <jsp:include page="/util/time_zone_groups.jsp"/>
    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

</head>
<body topmargin="0" leftmargin="0"
      marginheight="0" marginwidth="0"
      class="leavesform report reportForm reportConfigPage  with-navigation">
<div id="container">

    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>
    <jsp:include page="base_report_form_container.jsp">
        <jsp:param name="title" value="<%=titleKey%>"/>
        <jsp:param name="configPage" value="leavetime_config.jsp"/>
    </jsp:include>
</div>

    <at:form action="/reports/leaves" method="post" styleId="actionForm">
        <html:hidden property="submitted" value="1"/>
        <html:hidden property="reportParameters"/>
    </at:form>

    <jsp:include page="/reports/create_report_controls.jsp">
        <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
    </jsp:include>


    <%@include file="/js/util/server_date_time_utils_js.jsp"%>

    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>

    <at:script page='/js/controls/LeaveReportColumnsFormatSelector.js'/>

    <%@ include file="/js/description_util_entities_init_js.jsp"%>

    <at:script page="/js/controls/selectorControls/at_report_leaves_selector_panel.js"/>
    <at:script page="/js/controls/ReportLeaveTypesSelectorButton.js"/>

    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>

    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewBalanceColumnsRender.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewGenerator.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewGroupingSection.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewHeader.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewColumnsStrategy.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewBalancesOnlyStrategy.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewTimeOnlyStrategy.js"/>
    <at:script page="/js/reports/preview/csv/leave/LeaveCSVPreviewTimeAndBalancesStrategy.js"/>

<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewBalanceColumnsRender.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewGenerator.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewBaseSection.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewHeaderSection.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewBaseStrategy.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewTimeOnlyStrategy.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewTimeAndBalanceStrategy.js"/>
<at:script page="/js/reports/preview/html/leave/LeaveHTMLPreviewBalanceOnlyStrategy.js"/>


<script>
    PageOverlayTipsManager.setInstance(new ReportPageOverlayTipsManager("tips.report.leaves.title"));

    var UserRights = {
        MANAGE_PTO_AND_SICK : <%=UserAccessRightsBean.getUserRights(request).hasRight( AccessRight.MANAGE_PTO_AND_SICK )%>
    };


    <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new LeaveTimeFormMediator().init(
            {
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                users: users,
                userGroups:  EnabledFeatures.UGR ? userGroups : null,
                timeZoneGroups:  EnabledFeatures.TZG ? timeZoneGroups : null,
                leavesData: _.map(LeaveTypeStore.getLeaveTypes(), function(value){return value})
            }
    );

</script>

</body>
</html>
