<!doctype html>
<%@ page import="com.actimind.actitime.Navigator"%>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>


<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/><bean:message key="<%=ReportType.OVERTIME.getFullNameKey(request)%>"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <%-- Load users and groups to JS, for use in the users selectors --%>
    <jsp:include page="/util/users.jsp"/>
    <jsp:include page="/util/user_groups.jsp"/>
    <jsp:include page="/util/time_zone_groups.jsp"/>

    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
</head>

<body topmargin="0" leftmargin="0"
      marginheight="0" marginwidth="0" class="overtimeReport report reportForm reportConfigPage with-navigation">

<div id="container">

<jsp:include page="/top.jsp" flush="false">
    <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
</jsp:include>

    <jsp:include page="base_report_form_container.jsp">
        <jsp:param name="title" value="<%=ReportType.OVERTIME.getFullNameKey(request)%>"/>
        <jsp:param name="configPage" value="overtime_config.jsp"/>
    </jsp:include>

    <at:form action="/reports/overtime" method="post" styleId="actionForm">
        <html:hidden property="submitted" value="1"/>
        <html:hidden property="reportParameters"/>
    </at:form>

</div>

<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<%--UsersSelector --%>
<%@ include file="/js/description_util_entities_init_js.jsp"%>
<at:script page="/js/usersSelector/at_overtime_report_selector_panel.js"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<!--[if !IE]> -->
<at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
<at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
<at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
<!-- <![endif]-->

<at:script page="/js/reports/preview/csv/overtime/OvertimeCSVPreviewGenerator.js"/>
<at:script page="/js/reports/preview/csv/overtime/OvertimeCSVPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/csv/overtime/OvertimeCSVPreviewHeader.js"/>

<at:script page="/js/reports/preview/html/overtime/OvertimeHTMLPreviewHeaderSection.js"/>
<at:script page="/js/reports/preview/html/overtime/OvertimeHTMLPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/html/overtime/OvertimeHTMLPreviewGenerator.js"/>

<script>
    PageOverlayTipsManager.setInstance(new ReportPageOverlayTipsManager(EnabledFeatures.OVR ?
                                                                        "tips.report.time_balances_and_overtime.title" :
                                                                        "tips.report.time_balances.title"));

    <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

    var reportMediator = new OvertimeFormMediator().init(
            {
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                users: users,
                userGroups:  EnabledFeatures.UGR ? userGroups : null,
                timeZoneGroups:  EnabledFeatures.TZG ? timeZoneGroups : null
            }
    );

</script>
</body>
</html>
