<!doctype html>
<%@ page import="com.actimind.actitime.Navigator"%>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.actitime.util.messages.ATMessageResources" %>
<%@ page import="com.actimind.actitime.resources.SystemSettings" %>
<%@ page import="com.actimind.actitime.util.OvertimeLeavesUtil" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%
    final String reportName = ATMessageResources.message( request, ReportType.OVERTIME.getFullNameKey(request) );
    ReportConfig reportConfig = (ReportConfig) request.getAttribute( Keys.REPORT_CONFIG_KEY );
%>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/>
        <bean:message key="<%=ReportType.OVERTIME.getFullNameKey(request)%>"/>
    </title>
    <%@include file="../css/scheme_styles.jsp"%>
    
    <!--[if !IE]> -->
    <!-- IMPORTANT!! need to include pdfmake BEFORE "/include_scripts.jsp" -->
    <at:script page="/js/pdfmake/pdfmake.min.js"/>
    <at:script page="/js/pdfmake/vfs_fonts.js"/>
    <!-- <![endif]-->

    <jsp:include page="/include_scripts.jsp"/>

    <!--[if !IE]> -->
    <at:script page="/js/amcharts/amcharts.js"/>
    <at:script page="/js/amcharts/themes/light.js"/>
    <at:script page="/js/amcharts/serial.js"/>

    <at:script page="/js/amcharts/plugins/export/export.min.js"/>
    <at:style page="/js/amcharts/plugins/export/export.css"/>

    <at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
    <!-- <![endif]-->

    <!--[if !IE]> -->
    <at:script page="/js/pdfjs/compatibility.js"/>
    <at:script page="/js/pdfjs/pdf.worker.js"/>
    <at:script page="/js/pdfjs/pdf.js"/>
    <!-- <![endif]-->
</head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      class="overtimeReport overtimeLeavesReport report reportResultsPage reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected"    value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <div class="mainContentPadding rightPadding">
        <div class="reportPageContentDiv">

            <jsp:include page="report_leave_header.jsp">
                <jsp:param name="reportName" value="<%=reportName%>"/>
            </jsp:include>
            <div id="reportPlaceholder" class="empty"></div>
            <jsp:include page="report_leave_footer.jsp"/>

            <div id="overtimeExtraNotes" style="display: none">
                <table cellpadding="0" cellspacing="0" border="0" align="center" class="overtimeReportInfo display-for-print">
                    <tr>
                        <td align="center">
                            <table width="100%" align="center" cellspacing="0" cellpadding="0" border="0">
                                <tr>
                                    <td nowrap valign="top" width="1%"><span
                                            class="asterisk">*&nbsp;&nbsp;&nbsp;</span>
                                    </td>
                                    <td class="notemsg">
                                        <bean:message key="report.overtime.overtime_shown_only_for_note"
                                                      arg0='<%=ATMessageResources.message( request, OvertimeLeavesUtil.getCapitalizedOvertimeMessageKey())%>'
                                                      arg1='<%=ATMessageResources.message( request, OvertimeLeavesUtil.getOvertimeMessageWithExtraSpaceKey() )%>'/>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2"><at:img page="pixel.gif" width="50" height="10"/></td>
                                </tr>
                                <tr>
                                    <td nowrap valign="top" width="1%"><span class="asterisk">**&nbsp;&nbsp;</span></td>
                                    <td class="notemsg">
                                        <bean:message key="report.overtime.auto_calculated_for_user"/><br/>
                                            <logic:equal value="true" name="settings" property="enableLeaveTT">
                                                <bean:message key="report.overtime.overtime_with_leaves_calculation_note"/>
                                            </logic:equal>

                                            <logic:notEqual value="true" name="settings" property="enableLeaveTT">
                                                <bean:message key="report.overtime.overtime_calculation_note"/>
                                            </logic:notEqual>
                                        <br/><br/>
                                        <div class="noteMark"><bean:message key="report.overtime.auto_calculated_within_date_range"/></div>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </table>
            </div>
            </div>
        </div>
    </div>

<div id="editReportConfigurationPanel" style="display: none;">

    <table>
        <tr>
            <td class="editReportConfigurationHeader">
                <bean:message key="report.selector_label.edit_report_configuration"/>
            </td>
            <td id="spinnerPlaceholderId"></td>
        </tr>
    </table>

    <jsp:include page="overtime_config.jsp"/>

    <div class="buttonsPanel">
        <input type="button" id="cancelReportConfiguration" class="cancelReportConfiguration" value="<bean:message key='common.approvers_dialog.cancel'/>"/>
        <input type="button" id="applyReportConfiguration" class="applyReportConfiguration" value="<bean:message key='common.approvers_dialog.apply'/>"/>
        <div class="errorMessage"></div>
    </div>
</div>

<div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
    <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
</div>

<div id='reportOverlay' class='reportOverlay'></div>
<div id='spinnerReportOverlay'></div>



<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>



<%--UsersSelector --%>
<%@ include file="/js/description_util_entities_init_js.jsp"%>

<at:script page="/js/usersSelector/at_overtime_report_selector_panel.js"/>

<at:script page="/js/reports/save_configuration_control.js"/>
<at:script page="/js/reports/SaveReportManager.js"/>
<at:script page="/js/reports/saveDialogControl.js"/>


<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<jsp:include page="/util/user_groups.jsp"/>
<jsp:include page="/util/time_zone_groups.jsp"/>
<jsp:include page="/util/users.jsp"/>

<script type="text/javascript">
    var reportParameters = <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>;

    reportParameters.dateRangeSelection.fromDate = Date.parseJSONDate(reportParameters.dateRangeSelection.fromDate);
    reportParameters.dateRangeSelection.toDate = Date.parseJSONDate(reportParameters.dateRangeSelection.toDate);
    
    var reportMediator = new OvertimeReportMediator().init(
            {
                editConfigurationButton: ".editConfiguration",
                panelId: "#editReportConfigurationPanel",
                reportTitle: "<%=reportName%>",
                reportConfigId: <%= reportConfig.getId() %>,
                reportConfigName: "<%= reportConfig.getName() == null ? "" : reportConfig.getName() %>",
                reportParameters: reportParameters,
                users: users,
                userGroups:  EnabledFeatures.UGR ? userGroups : null,
                timeZoneGroups:  EnabledFeatures.TZG ? timeZoneGroups : null
            }
    );

    $( document ).ready(
            function ()
            {
                reportMediator.generateReport(true);
            }
    );

</script>

<p>&nbsp;</p>
</body>
</html>
