<!doctype html>
<%@ page import="com.actimind.actitime.Keys,com.actimind.actitime.Navigator"%>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/><bean:message key="report.profit_loss.title"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>
    
    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

</head>
<body class="profitlossform report reportForm reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <jsp:include page="base_report_form_container.jsp">
        <jsp:param name="title" value="report.profit_loss.title"/>
        <jsp:param name="configPage" value="profitloss_config.jsp"/>
    </jsp:include>

    <at:form action="/reports/profitloss" method="post" styleId="actionForm">
        <html:hidden property="submitted" value="1"/>
        <html:hidden property="reportParameters"/>
    </at:form>

    <at:form action="/reports/profitlosscsvfromform" method="post" styleId="reportExportToCSVForm">
        <html:hidden property="reportParameters"/>
    </at:form>
</div>


<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<%@ include file="/js/description_util_entities_init_js.jsp"%>

<at:script page="/js/reports/ProfitLossDisplayedDataSelector.js"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<at:script page="/js/reports/preview/csv/CSVPreviewCostProfitLossAdditionalSection.js"/>


<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewBaseStrategy.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewShowRatesStrategy.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewHideRatesStrategy.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewGenerator.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewBaseSection.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewHeaderSection.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewGeneralCostsSection.js"/>
<at:script page="/js/reports/preview/html/profitloss/ProfitLossHTMLPreviewGrandTotalSection.js"/>

<at:script page="/js/reports/preview/csv/profitloss/ProfitLossCSVPreviewGenerator.js"/>
<at:script page="/js/reports/preview/csv/profitloss/ProfitLossCSVPreviewGroupingSection.js"/>
<at:script page="/js/reports/preview/csv/profitloss/ProfitLossCSVPreviewHeader.js"/>


<script>
    PageOverlayTipsManager.setInstance(new ReportPageOverlayTipsManager("tips.report.profit_loss.title"));

    <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new ProfitLossFormMediator().init(
            {
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                cpList: cpList
            }
    );

</script>

</body>
</html>
