<!doctype html>
<%@ page import="com.actimind.actitime.Keys,
                 com.actimind.actitime.reports.ReportEntry,
                 com.actimind.actitime.reports.renderers.OutputReportHtmlRenderer2"%>
<%@ page import="com.actimind.actitime.reports.renderers.ProfitLossReportHtmlRenderer" %>
<%@ page import="java.util.List" %>

<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>


<bean:define id="report" name="<%=Keys.REPORT_KEY%>" type="com.actimind.actitime.reports.ReportInfo"/>
<bean:define id="params" name="<%=Keys.REPORT_PARAMETERS%>" type="com.actimind.actitime.services.beans.report.ProfitLossReportParameters"/>

<%
    OutputReportHtmlRenderer2 renderer =
            new ProfitLossReportHtmlRenderer( out, params, request, response, report );
%>

<table cellpadding="4" border="0" class='<%=renderer.getMainTableClasses()%> report-table display-for-print' id="report-table">

    <tr>
        <% int headerRowSpan = params.isShowAverageRates() ? 2 : 1; %>
        <td nowrap valign="center" class="listtblcolheader headerFirstCell" colspan = "2" rowspan="<%=headerRowSpan%>" style="text-align: left;">
            <bean:message key="report.cost_items"/>
        </td>
        <%
            renderer.printOverallColumnHeader();
            renderer.printRegularColumnHeaders();
        %>
    </tr>
    <tr>
        <%
            renderer.printOverallColumnSubHeader();
            renderer.printRegularColumnSubHeaders();
        %>
    </tr>

    <%

        final ReportEntry timeTrackEntry = report.getRootEntry().findChildEntry(ReportEntry.TOTAL_TIME_TRACK_REPORT_ENTRY_KEY);

        renderer.printTotalRow(timeTrackEntry);
        renderer.printTimeTrackRows(request, timeTrackEntry);
     %>

    <%
        ReportEntry totalLeaveReportEntry = params.isShowLeaveTimeCosts() ? report.getRootEntry().findChildEntry( ReportEntry.TOTAL_LEAVE_REPORT_ENTRY_KEY ) : null;
        ReportEntry totalOvertimeReportEntry = params.isShowOvertimeAddition() ? report.getRootEntry().findChildEntry( ReportEntry.OVERTIME_BONUS_REPORT_ENTRY_KEY ) : null;

        if( totalLeaveReportEntry != null || totalOvertimeReportEntry != null ) { %>
        <tr>
            <td colspan="8" class="generalCostsTitle">
                <bean:message key="report.general_costs"/>
                <div class='rowSubtitle notemsg'>
                    <bean:message key="report.profit_loss.tooltip.general_costs"/>
                </div>
            </td>
        </tr>
    <% } %>

    <%
        if (totalLeaveReportEntry != null)
        {
            renderer.printTotalRow(totalLeaveReportEntry);

            List<ReportEntry> leaves = totalLeaveReportEntry.getChildEntries();

            for( ReportEntry leave : leaves )
                renderer.printLeaveRow( leave, false );
        }

        if( totalOvertimeReportEntry != null )
        {
            renderer.printTotalRow( totalOvertimeReportEntry );
        }
    %>

        <tr>
            <td colspan="8" style="padding:0;"><at:img page="pixel.gif" height="13px"/></td>
        </tr>

    <%
        renderer.printTotalRow(report.getRootEntry());
    %>

</table>