<!doctype html>
<%@ page import="com.actimind.actitime.Navigator,
                 com.actimind.actitime.services.beans.report.ReportConfig,
                 com.actimind.actitime.util.UserUtils"%>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>

<%@ page errorPage="/error.jsp" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%
    final String reportName = message(request, "report.profit_loss.title");
    ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY );
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <%=reportName%></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>
</head>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
      onunload="closeAllOpenedPopups();" id="profitLossReport"
      class="profitloss report reportResultsPage reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected"    value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <jsp:include page="report_results.jsp">
        <jsp:param name="reportName" value="<%=reportName%>"/>
    </jsp:include>

</div>

<div id="overtimeBonusTip" class="dhtml_title" style="display: none;"></div>

<div id="editReportConfigurationPanel" style="display: none;">

    <table>
        <tr>
            <td class="editReportConfigurationHeader">
                <bean:message key="report.selector_label.edit_report_configuration"/>
            </td>
            <td id="spinnerPlaceholderId"></td>
        </tr>
    </table>

    <jsp:include page="profitloss_config.jsp"/>

    <div class="buttonsPanel">
        <input type="button" id="cancelReportConfiguration" class="cancelReportConfiguration" value="<bean:message key='common.approvers_dialog.cancel'/>"/>
        <input type="button" id="applyReportConfiguration" class="applyReportConfiguration" value="<bean:message key='common.approvers_dialog.apply'/>"/>
        <div class="errorMessage"></div>
    </div>
</div>

<div id="reportEditConfigErrorTooltip" class="yellowTooltip" style="display: none;">
    <div id="reportEditConfigErrorTooltip_textPlaceholder"></div>
</div>

<div id='reportOverlay' class='reportOverlay'></div>
<div id='spinnerReportOverlay' ></div>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>

<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<%@ include file="/js/description_util_entities_init_js.jsp"%>

<at:script page="/js/reports/save_configuration_control.js"/>
<at:script page="/js/reports/SaveReportManager.js"/>
<at:script page="/js/reports/saveDialogControl.js"/>

<at:script page="/js/reports/ProfitLossDisplayedDataSelector.js"/>


<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<script type="text/javascript" language="JavaScript">

    var overtimeBonusTip = new DhtmlTitle('overtimeBonusTip');

    function showOvertimeBonusTip(srcElement)
    {
        overtimeBonusTip.show(messageResource.getMessage("report.common.overtime_bonus.tip_text"), srcElement, 0, 20);
    }

</script>


<script type="text/javascript">
    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new ProfitLossReportMediator().init(
            {
                editConfigurationButton: ".editConfiguration",
                panelId: "#editReportConfigurationPanel",
                additionalPanelClass: "widthPanel",
                reportTitle: "<%=reportName%>",
                reportConfigId: <%= reportConfig.getId() %>,
                reportConfigName: "<%= reportConfig.getName() == null ? "" : reportConfig.getName() %>",
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                generateReportUrl: '<html:rewrite page="/reports/profitlossgenerate.do"/>',
                generateCSVUrl: '<html:rewrite page="/reports/profitlosscsvfromresults.do"/>',
                isFilteredByAssignments: <%= !UserUtils.isAllProjectsAvailableToLoggedInUser( request ) %>,
                cpList: cpList
            }
    );

    $( document ).ready(
            function ()
            {
                reportMediator.generateReport(true);
            }
    );

</script>
</body>
</html>
