<!doctype html>
<%@ page import="com.actimind.actitime.reports.SortingOrder" %>
<%@ page import="java.util.Collection" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="com.actimind.actitime.*" %>
<%@ page import="com.actimind.actitime.colors.*" %>
<%@ page import="com.actimind.actitime.services.beans.report.AnalyzedReportConfig" %>
<%@ page import="com.actimind.actitime.reports.charts.ReportChartType" %>
<%@ page import="com.actimind.actitime.reports.ReportType" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="navigator.reports_submenu_item"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <at:script page="/js/amcharts/amcharts.js"/>
    <at:script page="/js/amcharts/pie.js"/>
    <at:script page="/js/amcharts/themes/light.js"/>
    <at:script page="/js/amcharts/serial.js"/>
    <!--[if !IE]> -->
    <at:script page="/js/amcharts/plugins/export/export.min.js"/>
    <at:style page="/js/amcharts/plugins/export/export.css"/>

    <at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
    <at:script page="/js/pdfmake/pdfmake.min.js"/>
    <at:script page="/js/pdfmake/vfs_fonts.js"/>
    <!-- <![endif]-->


    <script type="text/javascript">
        var LOGGED_IN_USER_ID = <%= String.valueOf( AuthController.getLoggedInUser( session ) == null ? -1 : AuthController.getLoggedInUser( session ).getId() ) %>;

        PageOverlayTipsManager.setInstance(new ReportsDashboardPageOverlayTipsManager());
    </script>

    <%-- Load users to JS, for use in the users selectors --%>
    <jsp:include page="/reports/users_with_access_rights.jsp">
        <jsp:param name="isNeedShowOvertime" value="<%=com.actimind.actitime.AuthController.getLoggedInUserWithAccessRights( request ).isCanGenerateTimeReports()%>"/>
    </jsp:include>
    <jsp:include page="/util/user_groups.jsp"/>
    <jsp:include page="/util/time_zone_groups.jsp"/>
    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

    <script type="text/javascript">
    function preloadImages()
    {
        var images = [ '<at:defImgpath page="/report_configs/calendar.png"/>',
                       '<at:defImgpath page="/report_configs/delete_active.gif"/>',
                        '<at:defImgpath page="/report_configs/delete_hover.gif"/>',
                       '<at:imgpath page="/report_configs/edit_active.png"/>',
                        '<at:imgpath page="/report_configs/edit_hover.gif"/>',
                        '<at:defImgpath page="/report_configs/filter.png"/>',
                        '<at:defImgpath page="/extjs/s.gif"/>',
                        '<at:imgpath page="/report_configs/create_dialog/name_bg_hover.gif"/>',
                        '<at:defImgpath page="/report_configs/create_dialog/name_bg_active.gif"/>',
                        '<at:imgpath page="/report_configs/create_dialog/name_bg_money.gif"/>',
                        '<at:imgpath page="/report_configs/create_dialog/name_bg_time.gif"/>',
                        '<at:imgpath page="/report_configs/create_dialog/name_bg_unavailable.gif"/>',
                        '<at:imgpath page="/dialogs/lightbox/close.gif"/>'];
        var preloader = new ImagePreloader( images );
    }
    </script>
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
        class="report_configs with-navigation">
<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>" />
        <jsp:param name="submenuSelected" value="<%=Navigator.REPORTS_SUBMENU_KEY%>" />
    </jsp:include>

    <%-- Users selector files --%>
    <at:script page="/js/usersSelector/at_simple_dropdown_for_shared_selector.js"/>

    <%@ include file="/js/description_util_entities_init_js.jsp"%>
    <at:script page="/js/usersSelector/builder/UsersFilter.js" />
    <at:script page="/js/usersSelector/builder/UsersFilterByAccessRight.js" />
    <at:script page="/js/usersSelector/at_user_selector_panel_one_time_select.js" />


    <at:script page="/js/share_reports_config_manager.js" />
    <at:script page="/js/reports/report_configurations.js"/>

    <at:script page="/js/usersSelector/at_overtime_report_selector_panel.js" />
    <at:script page="/js/controls/selectorControls/at_selector_panel_with_apply_button_object.js"/>

    <at:script page="/js/controls/selectorControls/at_report_leaves_selector_panel.js"/>
    <at:script page="/js/controls/ReportLeaveTypesSelectorButton.js"/>

    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

    <%@include file="/js/util/server_date_time_utils_js.jsp"%>

    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>
    <at:script page="/js/controls/dateControls/single_date_selector.js"/>



    <at:script page="/js/reports/save_configuration_control.js"/>
    <at:script page="/js/reports/SaveReportManager.js"/>
    <at:script page="/js/reports/charts/SaveReportChartManager.js"/>
    <at:script page="/js/reports/saveDialogControl.js"/>

    <!--[if !IE]> -->
    <at:script page="/js/pdfjs/compatibility.js"/>
    <at:script page="/js/pdfjs/pdf.worker.js"/>
    <at:script page="/js/pdfjs/pdf.js"/>
    <!-- <![endif]-->

    <%
        Collection<AnalyzedReportConfig> reportConfigs = (Collection<AnalyzedReportConfig>)request.getAttribute( Keys.REPORT_CONFIGURATIONS );
    %>

    <div id="mainContent" class="mainContentPadding" style="display: block; padding-bottom: 20px">
        <table class="header-table <% if (reportConfigs.size() < 2) { %> lessThanTwo <% } %>">
            <tr>
                <td class="pageTitleIcon">
                    <div class="starHeaderIcon"></div>
                </td>
                <td class="pagetitle"><bean:message key="saved_reports.title"/></td>
                <td class="sort-button">
                    <% if (reportConfigs.size() >= 2) { %>
                            <html:form action="/reports/reports" styleId="sortingOrderForm" method="get">
                                <span id="sortLabel"><bean:message key="report.common.sort"/>: </span>
                                <div id="sortButton">
                                    <html:select property="sortingOrder" styleId="sortingOrderSelect">
                                        <html:option value="<%=SortingOrder.BY_REPORT_TYPE.toString()%>"><bean:message key="saved_reports.sorting.by_report_type"/></html:option>
                                        <html:option value="<%=SortingOrder.BY_CONFIG_NAME.toString()%>"><bean:message key="saved_reports.sorting.by_config_name"/></html:option>
                                    </html:select>
                                </div>
                            </html:form>
                        <script type="text/javascript">
                            var sortingOrderButton = new AT.DropdownListButton({
                                applyTo: "sortingOrderSelect", menuCls: 'sortReportMenu'
                            });

                            sortingOrderButton.on({
                                'change': {
                                    fn: submitSortingOrderForm
                                }
                            });
                        </script>
                    <% } %>
                </td>
                <td class="create-chart-button">
                    <div id="createChartButton"></div>
                </td>
                <td class="create-button">
                    <div id="createReportButton"></div>
                </td>
            </tr>
            <tr>
                <td class="noprint" colspan="3" style="padding-top:6px;padding-bottom:6px;">
                    <%@ include file="/messages.jsp" %>
                </td>
            </tr>
        </table>

        <jsp:include page="/reports/create_report_controls.jsp">
            <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
        </jsp:include>

        <jsp:include page="/reports/create_chart_button.jsp">
            <jsp:param name="createChartButtonId" value="createChartButton"/>
            <jsp:param name="createChartButtonTitle" value="report.create_chart_button.title"/>
        </jsp:include>

        <html:form action="/reports/reports" method="post" styleId="actionForm">
            <html:hidden property="submitted" value="1"/>
            <html:hidden property="pageAction"/>
            <html:hidden property="chart"/>
            <html:hidden property="configId"/>
        </html:form>

        <script>
            var ReportChartNames = {};
            ReportChartNames["<%=ReportChartType.APPROVED_WORKING_HOURS%>"] = "report.chart_type.approved_working_hours";
            ReportChartNames["<%=ReportChartType.BILLABLE_AMOUNTS%>"] = "report.chart_type.billable_amounts";
            ReportChartNames["<%=ReportChartType.LEAVE_HOURS%>"] = "report.chart_type.leave_hours";
            ReportChartNames["<%=ReportChartType.COST_OF_WORK%>"] = "report.chart_type.cost_of_work";
            ReportChartNames["<%=ReportChartType.PTO_BALANCE%>"] = "report.chart_type.pto_balance";
            ReportChartNames["<%=ReportChartType.SICK_DAYS_BALANCE%>"] = "report.chart_type.sick_days_balance";
            ReportChartNames["<%=ReportChartType.OVERTIME_HOURS%>"] = "report.chart_type.overtime_hours";
            ReportChartNames["<%=ReportChartType.TOTAL_WORKING_HOURS%>"] = "report.chart_type.total_working_hours";
            ReportChartNames["<%=ReportType.BILLING_SUMMARY%>"] = "<%=ReportType.BILLING_SUMMARY.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.INVOICING%>"] = "<%=ReportType.INVOICING.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.COST_OF_WORK%>"] = "<%=ReportType.COST_OF_WORK.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.PROFIT_LOSS%>"] = "<%=ReportType.PROFIT_LOSS.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.STAFF_PERFORMANCE%>"] = "<%=ReportType.STAFF_PERFORMANCE.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.OVERTIME%>"] = "<%=ReportType.OVERTIME.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.LEAVE_TIME%>"] = "<%=ReportType.LEAVE_TIME.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.TIME_TRACK_IN_DETAIL%>"] = "<%=ReportType.TIME_TRACK_IN_DETAIL.getNameKey(request)%>";
            ReportChartNames["<%=ReportType.ESTIMATED_VS_ACTUAL%>"] = "<%=ReportType.ESTIMATED_VS_ACTUAL.getNameKey(request)%>";
        </script>
        <div style="display: absolute;" <%--fix for IE8, see bug #45542--%>>
            <div id="title_div" class="dhtml_title" style="cursor: default; position: absolute; display:none;"></div>
        </div>
        <%
            if (reportConfigs.size() > 0)
            {
        %>
                <table id="configs" cellspacing="0" cellpadding="0" border="0" <% if (reportConfigs.size() < 2) { %> class="lessThanTwo" <% } %> >


                    <script>
                        var reports = [];
                    </script>
        <%
                    int i = 0;
                    for (AnalyzedReportConfig conf: reportConfigs)
                    {
        %>
                    <script>
                        reports.push({
                                         id:<%=conf.getId()%>,
                                         type:"<%=jsHelper.toJSON(conf.getType())%>",
                                         params:<%=jsHelper.toJSON( conf.getConfigParams() )%>,
                                         isChart: <%=jsHelper.toJSON(conf.getType().isChart())%>
                                     })
                    </script>

                    <% if (i % 2 == 0) { %>
                        <tr class="configsTableRow">

                    <% } %>

                    <td class="configsTableRowCell">

                        <jsp:include page="/reports/single_report_config.jsp">
                            <jsp:param name="configId" value="<%=conf.getId()%>"/>
                            <jsp:param name="configType" value="<%=conf.getType()%>"/>
                            <jsp:param name="configFormat" value="<%=conf.getReportFormat()%>"/>
                            <jsp:param name="configName" value="<%=conf.getName()%>"/>
                            <jsp:param name="isTimeType" value="<%=Arrays.asList(conf.getType().getRequiredRights()).contains(AccessRight.GENERATE_TIME_REPORTS)%>"/>
                            <jsp:param name="available" value="<%=conf.isAvailable()%>"/>
                            <jsp:param name="disabledReason" value="<%=conf.getAnalysisResult()%>"/>
                        </jsp:include>

                    </td>

                    <% if (i % 2 == 1 || i == reportConfigs.size() - 1) { %>
                        </tr>
                    <%
                    } %>
        <%
                        i++;
                    }
        %>
                    <script type="text/javascript">
                        var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
                        leaveTypes = _.map(LeaveTypeStore.getLeaveTypes(), function(value){return value});
                        var reportConfigs = new ReportConfigs().init(reports, users, userGroups, timeZoneGroups, cpList, leaveTypes);
                    </script>

                </table>
        <%
            }
            else
            {
        %>

            <table id="configs" cellspacing="0" cellpadding="0" border="0" class="lessThanTwo empty">
                <tr class="configsTableRow">
                    <td class="configsTableRowCell">
                        <table class="configItemContainer">
                            <tr class="topRow">
                                <td colspan="2">
                                    <table class="config">
                                        <tr class="configHeader">
                                        </tr>
                                        <tr>
                                            <td class="content-cell">
                                                <div><bean:message key="saved_reports.no_saved_configs"/></div>
                                            </td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                            <tr class="bottomRow">
                                <td class="leftBottomCell"></td>
                                <td class="rightBottomCell"></td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        <%
            }
        %>
    </div>
&nbsp;<%-- Do not remove this &nbsp! Otherwise moire will be broken in IE --%>
</div>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='createChartLightbox'/>
    <jsp:param name="innerJsp" value='/reports/create_chart_lightbox_content.jsp'/>
    <jsp:param name="additionalClasses" value='lightboxWithWhiteContent pdfPreviewLightbox createChartMode'/>
</jsp:include>

<jsp:include page="/loading_popup.jsp">
    <jsp:param name="id" value='reportChartLoadingPopup'/>
</jsp:include>

<div id="incorrectDateTooltip" class="yellowTooltip tooltipText" style="display: none;">
    <div id="incorrectDateTooltip_textPlaceholder"></div>
</div>

<div id="createChartErrorTooltip" class="yellowTooltip" style="display: none;">
    <div id="createChartErrorTooltip_textPlaceholder"></div>
</div>

<div id="chartExportDisabledTooltip" class="yellowTooltip exportDisabledTooltip" style="display: none;">
    <div id="chartExportDisabledTooltip_textPlaceholder"><bean:message key="report.create_chart.disabled_export_tooltip"/></div>
</div>

<form action="" id="csvConfigForm" method="post">
    <input type="hidden" name="configId">
</form>

<script type="text/javascript">
    var reportCSVPathFromDB = {};

    //important LeaveTime csv did not support in saved reports
    reportCSVPathFromDB["<%=ReportType.STAFF_PERFORMANCE%>"] ='<html:rewrite page="/reports/staffperformancecsvfromdashboard.do"/>';
    reportCSVPathFromDB["<%=ReportType.TIME_TRACK_IN_DETAIL%>"] ='<html:rewrite page="/reports/commentsreportcsvfromdashboard.do"/>';
    reportCSVPathFromDB["<%=ReportType.ESTIMATED_VS_ACTUAL%>"] ='<html:rewrite page="/reports/estimatedvsactualcsvfromdashboard.do"/>';
    reportCSVPathFromDB["<%=ReportType.BILLING_SUMMARY%>"] ='<html:rewrite page="/reports/billingsummarycsvfromdashboard.do"/>';
    reportCSVPathFromDB["<%=ReportType.COST_OF_WORK%>"] ='<html:rewrite page="/reports/costcsvfromdashboard.do"/>';
    reportCSVPathFromDB["<%=ReportType.PROFIT_LOSS%>"] ='<html:rewrite page="/reports/profitlosscsvfromdashboard.do"/>';

    var ReportChartConstants = {};
    ReportChartConstants.UGRFeature = '<%=Feature.UGR.name()%>';
    ReportChartConstants.PTOFeature = '<%=Feature.PTO.name()%>';
    ReportChartConstants.SDBFeature = '<%=Feature.SDB.name()%>';
    ReportChartConstants.URAFeature = '<%=Feature.URA.name()%>';
    ReportChartConstants.OVRFeature = '<%=Feature.OVR.name()%>';
    ReportChartConstants.LVTFeature = '<%=Feature.LVT.name()%>';
    ReportChartConstants.BTYFeature = '<%=Feature.BTY.name()%>';
    ReportChartConstants.TTAFeature = '<%=Feature.TTA.name()%>';
    ReportChartConstants.BRAFeature = '<%=Feature.BRA.name()%>';
    ReportChartConstants.TZGFeature = '<%=Feature.TZG.name()%>';

    var ReportChartTitle = {
        TOTAL_WORKING_HOURS: '<%=jsMessage(request, "report.chart_type.total_working_hours")%>' + ' (mh)',
        APPROVED_WORKING_HOURS: '<%=jsMessage(request, "report.chart_type.approved_working_hours")%>' + ' (mh)',
        LEAVE_HOURS: '<%=jsMessage(request, "report.chart_type.leave_hours")%>' + ' (mh)',
        PTO_BALANCE: '<%= settings.isShowPTOInHours() ? jsMessage(request, "report.chart_type.pto_balance_hours") : jsMessage(request, "report.chart_type.pto_balance_days")%>',
        SICK_DAYS_BALANCE: '<%= settings.isShowSickInHours() ? jsMessage(request, "report.chart_type.sick_days_balance_hours") : jsMessage(request, "report.chart_type.sick_days_balance_days")%>',
        OVERTIME_HOURS: '<%=jsMessage(request, "report.chart_type.overtime_hours")%>' + ' (mh)',
        COST_OF_WORK: '<%=jsMessage(request, "report.chart_type.cost_of_work")%>' + ' (' + (SystemSettings.currencySign) + ')',
        BILLABLE_AMOUNTS: '<%=jsMessage(request, "report.chart_type.billable_amounts")%>' + ' (' + (SystemSettings.currencySign) + ')'
    };

    <%
        String reportLogoUrl = com.actimind.actitime.colors.LogosConfig.getLogosConfig( request ).getReportLogoPath();
        reportLogoUrl = reportLogoUrl + (reportLogoUrl.contains( "?" ) ? "&" : "?");
        reportLogoUrl = reportLogoUrl + "ts=" + TimestampsCacheUtils.getTimestamp(TimestampsCacheUtils.SETTINGS_CHANGE_TIMESTAMP_KEY);
    %>
    var PDFCustomLogoURL = '<html:rewrite page="<%=reportLogoUrl%>"/>';
    var DEFAULT_WORKDAY_DURATION = <%=((Integer) request.getAttribute( Keys.DEFAULT_WORKDAY_DURATION ))%>;

    var chartMediator;

    Ext.onReady(function (){
    Ext.EventManager.onWindowResize(function(){Ext.menu.MenuMgr.hideAll();});

    setTimeout( preloadImages, 500 );

    chartMediator = new ChartMediator().init( createNewChartButtonElementId );

    });
</script>

</body>
</html>

