<!doctype html>
<%@ page import="com.actimind.actitime.Keys,com.actimind.actitime.Navigator"%>
<%@ page import="com.actimind.actitime.services.beans.report.ReportConfig" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/><bean:message key="report.staffoutput.staff_report"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

</head>
<body class="staffOutputReport staffoutputform report reportForm reportConfigPage with-navigation">

<div id="container">

    <jsp:include page="../top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.REPORTS_KEY%>"/>
    </jsp:include>

    <jsp:include page="base_report_form_container.jsp">
        <jsp:param name="title" value="report.staffoutput.staff_report"/>
        <jsp:param name="configPage" value="staffoutput_config.jsp"/>
    </jsp:include>

    <at:form action="/reports/staffperformance" method="post" styleId="actionForm">
        <html:hidden property="submitted" value="1"/>
        <html:hidden property="reportParameters"/>
    </at:form>

    <at:form action="/reports/staffperformancecsvfromform" method="post" styleId="reportExportToCSVForm">
        <html:hidden property="reportParameters"/>
    </at:form>
</div>

<jsp:include page="/reports/create_report_controls.jsp">
    <jsp:param name="buttonTextKey" value="report.common.button.new.title"/>
</jsp:include>

<%-- Load users and groups to JS, for use in the users selectors --%>
<jsp:include page="/util/users.jsp"/>
<jsp:include page="/util/user_groups.jsp"/>
<jsp:include page="/util/time_zone_groups.jsp"/>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<%@ include file="/js/description_util_entities_init_js.jsp"%>

<at:script page="/js/controls/ReportTimeTrackStatusFilter.js"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
<at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
<at:script page="/js/controls/dateControls/single_date_selector.js"/>
<at:script page="/js/controls/dateControls/date_range_selector.js"/>
<at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>

<script>
    PageOverlayTipsManager.setInstance(new ReportPageOverlayTipsManager("tips.report.staff_performance.title"));

    <% ReportConfig reportConfig = ( ReportConfig ) request.getAttribute( Keys.REPORT_CONFIG_KEY ); %>

    var cpList = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_PROJECTS_DATA_KEY ) )%>;
    var reportMediator = new StaffOutputFormMediator().init(
            {
                reportParameters: <%=jsHelper.toJSON( reportConfig.getConfigParams() )%>,
                users: users,
                userGroups: EnabledFeatures.UGR ? userGroups : null,
                timeZoneGroups: EnabledFeatures.TZG ? timeZoneGroups : null,
                cpList: cpList
            }
    );
    
</script>

</body>
</html>
