<%@ page import="com.actimind.actitime.reports.ReportInfo" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.reports.renderers.StaffOutputReportHtmlRenderer" %>
<%@ page import="com.actimind.actitime.services.beans.report.StaffPerformanceReportParameters" %>
<%@ page import="com.actimind.actitime.reports.ReportEntry" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.List" %>
<%@ page import="com.actimind.actitime.services.beans.report.GroupingLevel" %>
<%@ page import="com.actimind.actitime.reports.renderers.GroupingLevelsTitleHelper" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%
    ReportInfo report = (ReportInfo) request.getAttribute( Keys.REPORT_KEY );
    StaffPerformanceReportParameters params = ( StaffPerformanceReportParameters ) request.getAttribute( Keys.REPORT_PARAMETERS );

    StaffOutputReportHtmlRenderer renderer = new StaffOutputReportHtmlRenderer(out, request, response, report, params );
%>

<table cellpadding="4" border="0" class='<%=renderer.getMainTableClasses()%> report-table staffOutput display-for-print' id="report-table">
    <tr>
        <td nowrap valign="center" class="headerFirstCell listtblcolheader" rowspan="<%= renderer.hasGroupReportColumns() ? '2' : '1' %>" width="440" style="text-align:left!important"><nobr>
            <at:img page="pixel.gif" width="1" height="10" alt=""/>
            <br>
            <%= GroupingLevelsTitleHelper.getBaseTitle(request, params.getFirstGroupingLevel(), params.getSecondGroupingLevel()) %>
            <% if ( params.getThirdGroupingLevel() != GroupingLevel.NONE ) { %>
                <span class="column-header-details"> / <%=GroupingLevelsTitleHelper.getFilteredTitle(request, params.getThirdGroupingLevel())%> </span></nobr>
            <% } %>
            <br>
            <at:img page="pixel.gif" width="1" height="10"/>
        </td>
        <%
            renderer.printOverallColumnHeader();
            renderer.printRegularColumnHeaders();
        %>
    </tr>

    <% if( renderer.hasGroupReportColumns() ) { %>
    <tr>
        <%
            renderer.printChildRegularColumnHeaders();
        %>
    </tr>
    <% } %>

    <%

        renderer.printTotalRow(report.getRootEntry());

        final List subTotals = report.getRootEntry().getChildEntries();
        final Iterator subTotalsIt = subTotals.iterator();
        while (subTotalsIt.hasNext())
        {
            ReportEntry re = (ReportEntry) subTotalsIt.next();

            // do not show subtotals if it is only one of them
            if (subTotals.size() > 1)
            {
                if (re.getId().equals(ReportEntry.TOTAL_LEAVE_REPORT_ENTRY_KEY))
                {
                    if ( params.isShowLeaveTime())
                    {
                        List leaveEntries = re.getChildEntries();
                        if (leaveEntries.size() == 0)
                        {
                            renderer.printNoLeaveRow(re);
                        }
                        else
                        {
                            boolean singleRow = leaveEntries.size() == 1;
                            Iterator leavesIter = leaveEntries.iterator();
                            while (leavesIter.hasNext())
                            {
                                renderer.printLeaveRow((ReportEntry)leavesIter.next(), singleRow);
                            }
                        }
                    }
                }
                else
                    renderer.printTotalRow(re);
            }

            if (re.getId().equals( ReportEntry.TOTAL_TIME_TRACK_REPORT_ENTRY_KEY))
            {
                renderer.printTimeTrackRows(request, re);
            }
        }
    %>

</table>