Function isDbEmpty(dbConn)
    Dim result, tablesName, tablesNum
    isDbEmpty = False

    tablesNum = 0
    On Error Resume Next
    Set result = dbConn.OpenSchema(20) ' 20 is adSchemaTables
    If (Err.Number = 0) Then
        'WScript.Echo "result.EOF: " & result.EOF
        do until result.EOF
            tablesName = result.Fields.Item("TABLE_NAME")
            'WScript.Echo "Table name: " & tablesName
            if left(tablesName, 4) <> "MSys" then
                tablesNum = tablesNum + 1
            end if
            result.MoveNext
        loop
    End If
    On Error GoTo 0

    'WScript.Echo "Table num: " & tablesNum

    isDbEmpty = (tablesNum = 0)
End Function

' Checks if the user's database is an actiTIME database.
' A database is considered to be an actiTIME database if it has two tables: at_user and patch_history.
function isActitimeDb(dbConn)
    Dim result
    isActitimeDb = False

    On Error Resume Next
    dbConn.execute("select count(*) from at_user, patch_history;")
    If (Err.Number = 0) Then ' successful select => schema exists
        isActitimeDb = True
    End If
    On Error GoTo 0
end function

function getMaxPatchVersion(byref maxPatchDbVer)
    dim files, file, matches

    set re = new RegExp
    set re_new = new RegExp
    re.Global = true
    re_new.Global = true
    re.IgnoreCase = true
    re_new.IgnoreCase = true

    maxPatchDbVer = 0

    re.Pattern = "patch_[0-9]+-([0-9]+)\.0\.access97\.sql"
    re_new.Pattern = "patch_([0-9]+)\.access97\.sql"

    set f = fso.GetFolder(ROOT)
    set files = f.Files
    for each file in files
        set matches = re.Execute(file.Name)
        if matches.Count = 1 then
            maxPatchDbVer = max(maxPatchDbVer, parseInt(matches.Item(0).SubMatches(0)))
		Else
			set matches = re_new.Execute(file.Name)
            If matches.Count = 1 then
				maxPatchDbVer = max(maxPatchDbVer, parseInt(matches.Item(0).SubMatches(0)))
			End If
        end if
    next
end function

Function getDbVersion(dbConn, byref dbVer, byref packVer)
    Dim sql, result

    dbVer = 0
    packVer = 0

    On Error Resume Next
    Set result = dbConn.execute("select max(patch) from patch_history;")
    If (Err.Number = 0) Then ' successful select => schema exists
        If (result.EOF = False) Then
            dbVer = result(0)
        End If
        result.close()
    End If
    On Error GoTo 0

    On Error Resume Next
    Set result = dbConn.execute("select max(pack_version) from patch_history where patch = " & dbVer & ";")
    If (Err.Number = 0) Then
        If (result.EOF = False) Then
            packVer = result(0)
        End If
        result.close()
    End If
    On Error GoTo 0

    If (dbVer = 10) and (packVer = 0) Then
        ' an old database, try to find out the pack version from the data
        ' taken from feature_patch_history table.

        sql = "select (matched_features.num = 3) and                         " & _
              "       (matched_features.num = all_features.num)              " & _
              "  from (select count(feature_code) as num                     " & _
              "          from feature_patch_history                          " & _
              "          where feature_code in                               " & _
              "            ('aCv97P', 'g7rcD5', 'pAo3bZ')) matched_features, " & _
              "       (select count(feature_code) as num                     " & _
              "          from feature_patch_history) all_features            "

        On Error Resume Next
        Set result = dbConn.execute(sql)
        If (Err.Number = 0) Then
            If (result.EOF = False) Then
                If (result(0) <> 0) Then
                    packVer = 2
                End If
            End If
            result.close()
        End If
        On Error GoTo 0

        If packVer = 0 Then
            sql = "select (matched_features.num = 2) and               " & _
                  "       (matched_features.num = all_features.num)    " & _
                  "  from (select count(feature_code) as num           " & _
                  "          from feature_patch_history                " & _
                  "          where feature_code in                     " & _
                  "            ('aCv97P', 'pAo3bZ')) matched_features, " & _
                  "       (select count(feature_code) as num           " & _
                  "          from feature_patch_history) all_features  "

            On Error Resume Next
            Set result = dbConn.execute(sql)
            If (Err.Number = 0) Then
                If (result.EOF = False) Then
                    If (result(0) <> 0) Then
                        packVer = 1
                    End If
                End If
                result.close()
            End If
            On Error GoTo 0
        End If
    End If
End Function

Function isAllQuotesClosed(sqlQuery)
	Dim i
	i = 1
	isAllQuotesClosed = True
	While isAllQuotesClosed
		aPos = InStr(i, sqlQuery, "'")
		qPos = InStr(i, sqlQuery, """")
		If (aPos > 0 And (aPos < qPos Or qPos = 0)) Then
			i = InStr(aPos + 1, sqlQuery, "'")
		ElseIf (qPos > 0 And (qPos < aPos Or aPos = 0)) Then
			i = InStr(qPos + 1, sqlQuery, """")
		Else
			Exit Function
		End If		
		isAllQuotesClosed = i > 0
		i = i + 1
	WEnd	
End Function

Function executeSqlFile(dbConn, fileName)
    Dim textStream, sqlLine, sqlQuery, regEx
	Set regEx = new RegExp
	regEx.Pattern = ".*;\s*$"	

    Set sqlFileStream = CreateObject("ADODB.Stream")
    sqlFileStream.Open
    sqlFileStream.Type = 2 'text
    sqlFileStream.Charset = "utf-8"
    sqlFileStream.LoadFromFile ROOT & "/" & fileName

    While Not sqlFileStream.EOS
        sqlLine = sqlFileStream.readText(-2) 'line by line

        If (Len(sqlLine) > 0 And (Not InStr(sqlLine, "--") > 0)) Then

            sqlQuery = sqlQuery & sqlLine & vbNewLine

            If (regEx.Test(sqlLine) And isAllQuotesClosed(sqlQuery)) Then
                dbConn.execute (sqlQuery)
                sqlQuery = ""
            End If

        End If
    Wend

    sqlFileStream.Close

End Function

Function genBackupPath(dbPath)
    cur = Now
    fmt = Year(cur) & lz(Month(cur)) & lz(Day(cur)) & lz(Hour(cur)) & lz(Minute(cur)) & lz(Second(cur))
    genBackupPath = ROOT & "/" & fso.GetFileName(dbPath & ".backup_" & fmt)
End Function

Function lz(num)
    lz = ""
    If (num < 10) Then
        lz = lz & "0"
    End If
    lz = lz & num
End Function

function parseInt(intStr)
    Dim intNum, i, ch

    intNum = ""
    for i = 1 to Len(intStr)
        ch = Mid(intStr, i, 1)
        if Asc(ch) >= 48 and Asc(ch) <= 57 then intNum = intNum & ch
    next

    parseInt = CInt(intNum)

end function

function max(n1, n2)
    if n1 > n2 then
        max = n1
    else
        max = n2
    end if
end function

Function die(msg)
    WScript.Echo msg
    WScript.Quit 1
End Function

Function CreateAccessDatabase(FilePath)
    Dim eng
    LangArray = Array(";LANGID=0x0401;CP=1256;COUNTRY=0", ";LANGID=0x0405;CP=1250;COUNTRY=0", _
";LANGID=0x0413;CP=1252;COUNTRY=0", ";LANGID=0x0409;CP=1252;COUNTRY=0", _
";LANGID=0x0408;CP=1253;COUNTRY=0", ";LANGID=0x040D;CP=1255;COUNTRY=0", _
";LANGID=0x040E;CP=1250;COUNTRY=0", ";LANGID=0x040F;CP=1252;COUNTRY=0", _
";LANGID=0x041D;CP=1252;COUNTRY=0", ";LANGID=0x0406;CP=1252;COUNTRY=0", _
";LANGID=0x0415;CP=1250;COUNTRY=0", ";LANGID=0x0419;CP=1251;COUNTRY=0", _
";LANGID=0x040A;CP=1252;COUNTRY=0", ";LANGID=0x041D;CP=1252;COUNTRY=0", _
";LANGID=0x041F;CP=1254;COUNTRY=0", ";LANGID=0x0411;CP=932;COUNTRY=0", _
";LANGID=0x0804;CP=936;COUNTRY=0", ";LANGID=0x0404;CP=950;COUNTRY=0", _
";LANGID=0x0412;CP=949;COUNTRY=0", ";LANGID=0x041E;CP=874;COUNTRY=0", _
";LANGID=0x0424;CP=1250;COUNTRY=0", ";LANGID=0x0409;CP=1252;COUNTRY=0")
' Last item is "General", so it will be used if nothing is found.
    On Error Resume Next
    ' Look over all DBEngine versions because various users can have various versions of it
    Set eng = CreateObject("DAO.DBEngine.36")
    If Err.Number <> 0 Then
                ' Install DAO and get engine
                installDao36()
                Set eng = CreateObject("DAO.DBEngine.36")
    End If

    LocaleSubStr = ";LANGID=0x0" & Hex(GetLocale) & ";"
    For i = LBound(LangArray) To UBound(LangArray) - 1
        If InStr(LangArray(i), LocaleSubStr) <> 0 Then Exit For
    Next
    ' General used if nothing is found

    Call eng.CreateDatabase(FilePath, LangArray(i))
    If Err.Number <> 0 Then
    Dim msg
    msg = "Error creating database. Error Number : " & Err.Number & ". "
    If length(Err.Number) > 0 Then msg = msg & "Error Description : " & Err.Description
    die (msg)
    End If

End Function

' If the specified parameter is False (it means that actiTIME is
' installed over an older version one) confirmation window
' informing about an older installed actiTIME database is shown.
' In this case the function returns True if user presses 'Yes',
' and False if user presses 'No'. If the specified "schemaJustCreated"
' is True True is returned.
' Parameter is needed not to show confirmation window if it is not
' needed (in conditional clause).
function confirmDbPatchesApplying(schemaJustCreated)
    confirmDbPatchesApplying = True

    if (not schemaJustCreated) then
        confirmDbPatchesApplying = MsgBox ("Setup has detected that the actiTIME database already contains actiTIME data." & vbNewLine & _
                                           "The database will be updated to correspond to the actiTIME version you are installing." & vbNewLine & vbNewLine & _
                                           "Are you sure you want to proceed?", _
                                           vbYesNo + vbExclamation, "actiTIME database already contains actiTIME data") = vbYes
    end if
end function

function confirmSchemaCreationInDifferentDb()
    confirmSchemaCreationInDifferentDb = MsgBox("Setup has detected that the actiTIME database contains some data not related to actiTIME." & vbNewLine & _
                                                "If you proceed, setup will add actiTIME data to the actiTIME database." & vbNewLine & _
                                                "After the installation actiTIME will work fine, but the initial data stored in the actiTIME database may become unusable." & vbNewLine & vbNewLine & _
                                                "Are you sure you want to proceed?", _
                                                vbYesNo + vbExclamation, "actiTIME database contains some data not related to actiTIME") = vbYes
end function

'Calculates patches which will be applied to database.
'Return amount of patches or -1 if one or more paches not found.
function calculatePatchChainLinks(initDbVer, initPackVer, targetDbVer)
    dim curDbVer, curPackVer, nextDbVer, nextPackVer, fileName
    curDbVer = initDbVer
    curPackVer = initPackVer
    calculatePatchChainLinks = 0

    'check vertical patches
    while curDbVer < targetDbVer
        nextDbVer = curDbVer + 1
        fileName = "patch_" & curDbVer & "-" & nextDbVer & "." & curPackVer & ".access97.sql"
        fileName_new = "patch_" & nextDbVer & ".access97.sql"
        if (not fso.FileExists(ROOT & "\\" & fileName)) And (Not fso.FileExists(ROOT & "\\" & fileName_new)) then
            calculatePatchChainLinks = -1
            exit function
        else
            calculatePatchChainLinks = calculatePatchChainLinks + 1
        end if
        curDbVer = nextDbVer
    wend
end function

' Scans patch files in format: patch_[dbVer].[packVer]-[X].access97.sql
'   where dbVer - current base version,
'         packVer - current package version
'         X - next package version
' Return max X or 0 if patch files not found
function getNextPackVer(dbVer, packVer)
    dim files, file, matches, result

    set re = new RegExp
    re.Global = true
    re.IgnoreCase = true

    re.Pattern = "patch_" & dbVer & "\." & packVer & "-([0-9]+)\.access97\.sql"

    set f = fso.GetFolder(ROOT)
    set files = f.Files
    result = 0
    for each file in files
        set matches = re.Execute(file.Name)
        if matches.Count = 1 then
            result = max(result, parseInt(matches.Item(0).SubMatches(0)))
        end if
    next

    getNextPackVer = result
end function

'Creates database schema.
'
'param dbPath - path to actiTIME database where schema should be prepared.
'param defaultPathToDb - path to actiTIME database in its installation directory. It is needed to know whether actiTIME database .mdb
'                        file can be re-created or not.
'return - True if schema has been successfully prepared and False otherwise.
Function prepareSchema(dbPath, defaultPathToDb)
    Dim dbVer, packVer, dbBackedUp, dbEmpty, actitimeDb, schemaJustCreated, patchFileName

    dbBackedUp = False

    fileName = "actitime.access97.sql"

    dbFileExists = fso.fileExists(dbPath)

    If Not dbFileExists Then
        If (StrComp(defaultPathToDb, dbPath) = 0) Then 'if actiTIME database is placed in default path
            CreateAccessDatabase dbPath
            WScript.Echo "Created file " & dbPath
        Else
            'it is possible when ODBC Data source is set to non-default place and
            'setupODBC function has been already called during upgrading and database
            '.mdb file was deleted before prepareSchema calling
            die ("Cannot update database because ODBC Data Source references non-exisiting database file: " & dbPath)
        End If
    Else 'Upgrade database format to Jet4 if needed
            installDao36()
        dbBackedUp = BackupDb(dbPath)
        UpgradeDb(dbPath)
    End If

    On Error Resume Next
    Set dbConn = CreateObject("ADODB.Connection")
    If (Err.Number <> 0) Then
        die ("Please install Microsoft Data Access Components. Installation terminated.")
    End If
    On Error GoTo 0

    dbConn.open ("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & dbPath & ";")

    dbEmpty = isDbEmpty(dbConn)
    actitimeDb = isActitimeDb(dbConn)

    'WScript.Echo "dbEmpty: " & dbEmpty
    'WScript.Echo "actitimeDb: " & actitimeDb

    ' fill in it by schema
    schemaJustCreated = False
    If dbEmpty Then
        executeSqlFile dbConn, fileName
        WScript.Echo "Created database schema"
        actitimeDb = True
        schemaJustCreated = True
    End If

    prepareSchema = False
    if actitimeDb then
        getDbVersion dbConn, dbVer, packVer

        getMaxPatchVersion maxPatchDbVer

        'WScript.Echo dbVer & "." & packVer
        'WScript.Echo maxPatchDbVer

        patchCount = calculatePatchChainLinks(dbVer, packVer, maxPatchDbVer)

        ' downgrade prohibition
        if maxPatchDbVer < dbVer or _
           patchCount = -1 then

            MsgBox "Setup has detected that actiTIME database cannot be upgraded" & vbNewLine & _
                   "using this installation package." & vbNewLine & vbNewLine & _
                   "Installation terminated.", vbOKOnly or vbExclamation, "actiTIME - Setup Access"
            exit function
        end if

        if maxPatchDbVer <> dbVer then
            if confirmDbPatchesApplying(schemaJustCreated) then

                if (not schemaJustCreated) and (not dbBackedUp) then
                    makeDbBackup
                end if

                curDbVer = dbVer
                patchInd = 0

                while curDbVer < maxPatchDbVer
                    nextDbVer = curDbVer + 1
                    patchInd = patchInd + 1
			        patchFileName = "patch_" & curDbVer & "-" & nextDbVer & "." & packVer & ".access97.sql"
					If fso.FileExists(ROOT & "\\" & patchFileName) Then
						applyPatchIfExistsOrDie dbConn, patchFileName, patchInd, patchCount
					Else
						applyPatchIfExistsOrDie dbConn, "patch_" & nextDbVer & ".access97.sql", patchInd, patchCount
					End If
                    curDbVer = nextDbVer
                wend
            end if
        end if

        prepareSchema = True
        dbConn.Close()
    end if
end function

function applyPatchIfExistsOrDie(dbConn, patch, patchInd, patchCount)
    dim patchNum, matches

    set re = new RegExp
    re.Global = true
    re.IgnoreCase = true
    re.Pattern = "patch_(.*)\.access97\.sql"
    set matches = re.Execute(patch)
    if matches.Count = 1 then
        patchNum = matches.Item(0).SubMatches(0)
    else
        patchNum = patch
    end if

    if not fso.FileExists(ROOT & "\\" & patch) then
        die("Failed to apply patch " & patchNum & ":" & vbNewLine & "Error: " & "The patch " & patchNum & " does not exist. Could not upgrade the database." & vbNewLine)
    end if

    executeSqlFile dbConn, patch

    MsgBox "Applied patch " & patchNum & " (" & patchInd & " of " & patchCount & ")", vbOKOnly + vbInformation, "actiTIME - Setup Access"
end function

function BackupDb(dbPath)
        On Error Resume Next
        dbBackupPath = genBackupPath(dbPath)
        fso.CopyFile dbPath, dbBackupPath
        if Err.Number <> 0 then
                WScript.Echo Err.Description
                die "Database backup failed. Installation aborted."
        else
                WScript.Echo "Saved database backup to file " & dbBackupPath
                BackupDb = True
        end if
        On Error Goto 0
end function

'Sets path to actiTIME database in registry.
'
'param shell            - object to work with registry.
'param regKey           - key to set path to actiTIME database in registry.
'param regValue         - value to set in regKey.
'param defaultPathToDb  - path to actiTIME database in its installation directory.
'return - path which was set in registry.
Function setPathToDb(shell, regKey, defaultPathToDb)
    On Error Resume Next
    Dim oldPathToDB
    oldPathToDB = shell.RegRead(regKey)
    Dim oldDbFileExists
    oldDbFileExists = fso.fileExists(oldPathToDB)
    setPathToDb = oldPathToDB

    If (StrComp(oldPathToDB, "") = 0 Or Not oldDbFileExists) Then
        shell.RegWrite regKey, defaultPathToDb
        setPathToDb = defaultPathToDb
    End If
    On Error GoTo 0
End Function

'Sets ODBC Data Source using the specified shell. ODBC is created with regKey key and regValue value.
'
'param shell    - object to work with registry.
'param regKey   - key to set actiTME ODBC in registry.
'param regValue - value to set in regKey.
'return - ODBC Data Source name if it was created and Null if it already exists.
Function setOdbc(shell, regKey, regValue)
    setOdbc = Null

    On Error Resume Next
    Dim actitimeOdbc
    actitimeOdbc = shell.RegRead(regKey)
    If (StrComp(actitimeOdbc, "") = 0) Then
        setOdbc = Mid(regKey, InStrRev(regKey, "\") + 1)
        shell.RegWrite regKey, regValue
    End If
    On Error GoTo 0
End Function

'Setups actiTIME ODBC Data Source.
'
'param defaultPathToDb  - path to actiTIME database in its installation directory.
'param pathToDbToReturn - path to actiTIME database which was really set in ODBC Data Source. This value can be different from
'                         defaultPathToDb if user changed ODBC Data Source manually. Parameter is passed by reference.
'return - True if ODBC was re-created and False otherwise.
Function setupODBC(defaultPathToDb, pathToDbToReturn)
    Set sh = CreateObject("WScript.Shell")
    setupODBC = Null

    odbc = "HKEY_LOCAL_MACHINE\SOFTWARE\ODBC\ODBC.INI\"
    Key = "HKEY_LOCAL_MACHINE\SOFTWARE\ODBC\ODBC.INI\actitimedb\"

    sh.RegWrite Key & "Driver", "%windir%\System32\odbcjt32.dll"
    pathToDbToReturn = setPathToDb(sh, Key & "DBQ", defaultPathToDb)
    sh.RegWrite Key & "DriverId", 25, "REG_DWORD"
    sh.RegWrite Key & "FIL", "MS Access;"
    sh.RegWrite Key & "SafeTransactions", 0, "REG_DWORD"
    sh.RegWrite Key & "UID", ""

    jkey = Key & "Engines\Jet\"

    sh.RegWrite jkey & "ImplicitCommitSync", ""
    sh.RegWrite jkey & "MaxBufferSize", 2048, "REG_DWORD"
    sh.RegWrite jkey & "PageTimeout", 5, "REG_DWORD"
    sh.RegWrite jkey & "Threads", 3, "REG_DWORD"
    sh.RegWrite jkey & "UserCommitSync", "Yes"

    setupODBC = setOdbc(sh, odbc & "ODBC Data Sources\actitimedb", "Microsoft Access Driver (*.mdb)")
End Function

Function fileContainsString(fileName, str)
    Dim textStream, strLine, strFound

    Set textStream = fso.OpenTextFile(fileName)

    strFound = False
    While Not textStream.atEndOfStream
        strLine = textStream.readLine()

        If (InStr(strLine, str) > 0) Then
            strFound = True
        End If
    Wend

    fileContainsString = strFound
End Function

Function deleteFileIfExists(fileName)
    If fso.fileExists(fileName) Then
        fso.deleteFile (fileName)
    End If
End Function

function getCommandLineArguments
    dim i, args, argName

    set args = WScript.Arguments
    set getCommandLineArguments = CreateObject("Scripting.Dictionary")

    for i = 0 to args.Count - 1
        if left(args(i), 1) = "/" then
            argName = lcase(right(args(i), len(args(i)) - 1))
            if not getCommandLineArguments.Exists(argName) then
                getCommandLineArguments.Add argName, ""
            end if
        else
            getCommandLineArguments.Item(argName) = args(i)
        end if
    next
end function

Function getArgValue(args, argName, defaultValue)
    if args.Exists(argName) then
        getArgValue = args.Item(argName)
    else
        getArgValue = defaultValue
    end if
End Function

Function installDao36()

        On Error Resume Next

        doInstallDao36()

        ' If error occurs during DAO installation show error message and exit
        If Err.Number <> 0 then

                die _
                "Setup has failed to install the following required software" & Chr(13) & _
                "on your computer:" & Chr(13) & Chr(13) & _
                "    Microsoft DAO 3.6 Object Library" & Chr(13) & Chr(13) & _
                "Please contact actiTIME support team at support@actitime.com " & Chr(13) & _
                "for information how to resolve this problem."
        End If

End Function

Function doInstallDao36()

        set systemPath = fso.GetSpecialFolder(1)
        set systemFolder = fso.GetFolder(systemPath)
        daoPath = systemFolder.Drive & "\Program Files\Common Files\Microsoft Shared\DAO\"
        if not fso.FolderExists(daoPath) then
                fso.CreateFolder(daoPath)
        end if
        if not fso.FileExists(daoPath & "\dao360.dll") then
                fso.CopyFile ROOT & "\tools\dao360.dll", daoPath
        end if
        returnCode = wShell.Run("regsvr32.exe /s """ & daoPath & "dao360.dll""", 0, True)
        if returnCode <> 0 then
                WScript.Echo "Microsoft DAO 3.6 Object Library failed to register"
        end If

End Function

Function VersionToInteger(version)
        Dim  versionTokens
        versionTokens = Split(version, ".")
        'We allocate one byte for each major and minor version, for build version we allocate 2 bytes
        VersionToInteger = (versionTokens(0)*256 + versionTokens(1))*256*256 + versionTokens(2)
End Function

'Returns True if versionA is higher then versionB
Function IsVersionHigher(versionA, versionB)
        IsVersionHigher = VersionToInteger(versionA) > VersionToInteger(versionB)
End Function

Function IsVersionLower(versionA, versionB)
        IsVersionLower = VersionToInteger(versionA) < VersionToInteger(versionB)
End Function

'We don't exactly know Microsoft Jet file name (msjet30.dll, msjet35.dll or msjet40.dll)
'So we search system folder for our pattern matching files and determine their versions
'Thus we can always determine higest version, if ms jet not found 0.0.0 is returned
'We get the exact version in order to determine what SP and security patches have been applied, is it suitable for our purpose
Function GetHighJetVersion
        Set fso = CreateObject("Scripting.FileSystemObject")
        Set systemPath = fso.GetSpecialFolder(1) 'System folder
        Set systemFolder = fso.GetFolder(systemPath)
        highVersion = "0.0.0"

        For Each objFile In systemFolder.Files
                strTemp = Left(objFile.Name, 5)
                'all known versions of ms jet have the following pattern msjetXX.dll
                If UCase(strTemp) = "MSJET" AND Len(objFile.Name) = 11 Then 'Got one msjetXX.dll
                        fileVersion = fso.GetFileVersion(objFile.Path)
                        If IsVersionHigher(fileVersion, highVersion) Then
                                highVersion = fileVersion
                        End If
                End If
        Next
        GetHighJetVersion = highVersion
End Function

Function UpgradeDb(dbPath)
        Const SUCCESS = 0                       'Success
        Const VALID_FORMAT = 1                  'Database is already in Jet4.0 format
        Const DATABASE_IN_USE = 2               'Database file is in use
        Const CONVERT_USER_OBJECTS_ERROR = 3    'Error converting user-defined objects (forms, reports, etc.)
        Const DATABASE_NOT_FOUND = 4            'Database file not found
        Const FILE_PERMISSION_ERROR = 5         'File create/copy/delete operation permission error
        Const DATABASE_ACCESS_ERROR = 6         'Database file corrupted or you don't have the permissions
        Const CONVERT_ERROR = 7                 'Error converting database

        'Full path (quoted in case it contains spaces) to "Converter" should be specified otherwise produces error in Vista (See bug #20751)
        returnCode = wShell.Run("""" & ROOT & "\tools\mdbconvert.exe " & """" & dbPath, 0, True)

        If returnCode = SUCCESS Then
                WScript.Echo "actiTIME database has been successfully converted to the Access 2000 format"
        ElseIf returnCode = DATABASE_IN_USE Then
                die "Setup has detected that actiTIME database file is blocked:" & vbNewLine & vbNewLine & _
                    dbPath & vbNewLine & vbNewLine & _
                    "Please close all programs that may use the database file and restart the upgrade procedure." & vbNewLine & vbNewLine & _
                    "One of these programs may be an instance of Tomcat servlet container."
        ElseIf returnCode = CONVERT_USER_OBJECTS_ERROR Then
                WScript.Echo "actiTIME database has been converted to the Access 2000 format." & vbNewLine & vbNewLine & _
                                "actiTIME data has been converted successfully." & vbNewLine & _
                                "However setup has failed to convert some of additional Access objects (forms, queries, reports, etc.)." & vbNewLine & vbNewLine & _
                                "You may need to convert these objects manually after the upgrade procedure is completed." & vbNewLine & vbNewLine & _
                                "The previous version of the database was backed up to the following location:" & vbNewLine & _
                                dbPath & ".copy"
        ElseIf returnCode = DATABASE_NOT_FOUND Then
                die "The upgrade procedure has been terminated because the actiTIME database" & vbNewLine & _
                                "cannot be found at the following location:" & vbNewLine & vbNewLine & _
                                dbPath
        ElseIf returnCode = FILE_PERMISSION_ERROR Then
                die "Not enough permissions to complete conversion of actiTIME database to the Access 2000 format." & vbNewLine & _
                                "The upgrade procedure has been terminated." & vbNewLine & vbNewLine & _
                                "actiTIME database file:" & vbNewLine & _
                                dbPath
        ElseIf returnCode = DATABASE_ACCESS_ERROR Then
                die "Setup has detected that actiTIME database file is corrupted." & vbNewLine & _
                                "The upgrade procedure has been terminated." & vbNewLine & vbNewLine & _
                                "For information how to resolve this problem please contact actiTIME support team at support@actitime.com." & vbNewLine & vbNewLine & _
                                "actiTIME database file:" & vbNewLine & _
                                dbPath
        ElseIf returnCode = CONVERT_ERROR Then
                die "Setup has failed to convert actiTIME database to the Access 2000 format." & vbNewLine & _
                                "The upgrade procedure has been terminated." & vbNewLine & vbNewLine & _
                                "For information how to resolve this problem please contact actiTIME support team at support@actitime.com." & vbNewLine & vbNewLine & _
                                "Note: The previous version of actiTIME database was backed up to the following location:" & vbNewLine & _
                                dbPath
        End If
End Function

'BEGIN
Set fso = CreateObject("Scripting.FileSystemObject")
Set wShell = CreateObject("WScript.Shell")
Set args = getCommandLineArguments

ROOT = getArgValue(args, "script_base", fso.getFolder("."))

ATPROPS_PATH = ROOT & "/WEB-INF/classes/com/actimind/actitime"
ATPROPS = ATPROPS_PATH & "/AT.properties"

If Not fso.folderExists(ATPROPS_PATH) Then
    die "Cannot find required components. Installation terminated."
End If

If fso.fileExists(ATPROPS) Then
    If fileContainsString(ATPROPS, "org.gjt.mm.mysql.Driver") Then
        die _
"Warning! Your current actiTIME installation is configured to work with MySQL database, " & _
"but you have launched script for MS Access database (setup_access.vbs)." & Chr(13) & Chr(13) & _
"To upgrade actiTIME to a newer version, launch setup_mysql.vbs." & Chr(13) & Chr(13) & _
"To install actiTIME with MS Access support, unzip installation package into another " & _
"directory and launch setup_access.vbs." & Chr(13) & Chr(13) & _
"Installation terminated."
    End If
End If

jadoZoomDllPath = fso.BuildPath(ROOT, "tools\izmjniado.dll")

If Not fso.fileExists(jadoZoomDllPath) Then
    die _
        "Setup has detected that the actiTIME installation package is corrupted. " & Chr(13) & _
        "The following required component of the installation package cannot be found:" & Chr(13) & Chr(13) & _
        jadoZoomDllPath & Chr(13) & Chr(13) & _
        "Please extract actiTIME files once again and restart the installation procedure."
End If


if IsVersionLower(GetHighJetVersion, "4.0.0") then
die _
        "Setup has detected that the following required software" & Chr(13) & _
    "is not installed on your computer:" & Chr(13) & Chr(13) & _
    "    Microsoft Jet 4.0 Database Engine" & Chr(13) & Chr(13) & _
    "Please install Microsoft Jet 4.0 Database Engine and then"& Chr(13) & _
    "restart the upgrade procedure." & Chr(13) & Chr(13) & _
    "The instruction describing how to install MS Jet 4.0" & Chr(13) & _
    "is available at http://support.microsoft.com/kb/239114/"
end if

deleteFileIfExists ROOT & "/license_v1.0.txt"
deleteFileIfExists ROOT & "/mysql.props"

jadoZoomDllPath = Replace(jadoZoomDllPath,"\","\\")

Dim defaultDbPath 'The path to actitime database in actitime installation directory
defaultDbPath = ROOT & "\actitime.access97.mdb"
Dim dbPathFromOdbc 'The path set in setupODBC function
Dim createdOdbc 'Remembers value returned from setupODBC to determine whether ODBC Data Source was re-created or not
createdOdbc = setupODBC(defaultDbPath, dbPathFromOdbc) 'passing dbPathFromOdbc by reference
If (Not IsNull(createdOdbc)) Then
    WScript.Echo "ODBC Data Source """ & createdOdbc & """ has been created."
End If

if prepareSchema(dbPathFromOdbc, defaultDbPath) then

    Set out = fso.CreateTextFile(ATPROPS, True) 'Overwrites old file if it exists
    out.WriteLine ("DBdriver=com.inzoom.jdbcado.Driver")
    out.WriteLine ("DBurl=jdbc:izmado:actitimedb;IzmRoyaltyFree=643425963;IzmDllPath=" & jadoZoomDllPath)
    out.WriteLine ("DBuser=none")
    out.WriteLine ("DBpassword=none")
    out.Close

    WScript.Echo "Setup completed successfully"
end if

'END
