    usageMsg = _
    "Usage: setup_mysql.vbs [OPTIONS]" & vbNewLine & _
    vbNewLine & _
    "  /?, /help                                    Displays this help message." & vbNewLine & vbNewLine & _
    "  /mysqlpath <MYSQLPATH>   The path to the MySQL executable files. Required." & vbNewLine & vbNewLine & _
    "  /username <USERNAME>        The MySQL user name which will be used to create a database" & vbNewLine & _
    "                                                    and to connect with the database from actiTIME. Required." & vbNewLine & _
    "  /password <PASSWORD>        The password of the user <USERNAME>. Can be empty." & vbNewLine & _
    "                                                    Required. " & vbNewLine & _
    "  /host <HOST>                          Host name of the the server where the MySQL is running." & vbNewLine & _
    "                                                    If not specified the localhost is assumed." & vbNewLine & _
    "  /port <PORT>                          Port on which the MySQL server is listening. If not" & vbNewLine & _
    "                                                    specified the default MySQL port (3306) will be used." & vbNewLine & _
    "  /dbname <DBNAME>               The name to use for the database. If not" & vbNewLine & _
    "                                                    specified 'actitime' will be used as the database" & vbNewLine & _
    "                                                    name." & vbNewLine & vbNewLine & _
    ""

dim args

set fso = CreateObject("Scripting.FileSystemObject")
set shell = CreateObject("WScript.Shell")

set args = getCommandLineArguments

if args.Exists("help") or args.Exists("?") then
    'MsgBox usageMsg, vbOKOnly or vbInformation, "actiTIME - Setup MySQL"
    WScript.Echo usageMsg
    WScript.Quit 0
end if

MIN_MYSQL_VERSION = Array(5, 0, 0)
quot = chr(34)
ROOT = getArgValue(args, "script_base", fso.getFolder("."))
ATPROPS_PATH = ROOT & "/WEB-INF/classes/com/actimind/actitime"
ATPROPS = ATPROPS_PATH & "/AT.properties"
SCHEMASQL = "actitime.mysql4.sql"
SH = "%comspec% /C" 'Actually cmd.exe is used with /C option

Dim mysqlPath, MYSQLEXE, MYSQLDUMPEXE, MYSQLADMINEXE, USERNAME, PASSWORD, HOST, PORT, DBNAME, URL

if not fso.folderExists(ATPROPS_PATH) then
    die "Directory structure of actiTIME installation is corrupted." & vbNewLine & _
        "You may need to extract actiTIME files once again."
end if


MYSQLPATH = ""
USERNAME  = ""
PASSWORD  = ""
HOST      = ""
PORT      = ""
DBNAME    = ""

dim dbParams
dbParams = readATProperties(ATPROPS)

dim ATDBName

if ubound(dbParams) = 6 then
    if dbParams(5) = "sun.jdbc.odbc.JdbcOdbcDriver" or dbParams(5) = "com.inzoom.jdbcado.Driver" then
        die "Warning! Your current actiTIME installation is configured to work with MS Access database, " & _
            "but you have launched script for mysql database (setup_mysql.vbs)." & vbNewLine & vbNewLine & _
            "To upgrade actiTIME to a newer version, launch setup_access.vbs." & vbNewLine & vbNewLine & _
            "To install actiTIME with mysql support, unzip installation package into another " & _
            "directory and launch setup_mysql.vbs." & vbNewLine
    end if
    USERNAME = dbParams(0)
    PASSWORD = dbParams(1)
    HOST     = dbParams(2)
    PORT     = dbParams(3)
    DBNAME   = dbParams(4)
    URL      = dbParams(6)
end if

ATDBName = DBName

safeRemoveFile(ROOT & "/license_v1.0.txt")
safeRemoveFile(ROOT & "/WEB-INF/lib/mysql-connector-java-3.?.?-*bin.jar")


'MsgBox  "USERNAME: " & USERNAME & vbNewLine & _
'        "PASSWORD: " & PASSWORD & vbNewLine & _
'        "HOST: " & HOST & vbNewLine & _
'        "PORT: " & PORT & vbNewLine & _
'        "DBNAME: " & DBNAME

MYSQLPATH = getArgValue(args, "mysqlpath", MYSQLPATH)
USERNAME  = getArgValue(args, "username", USERNAME)
PASSWORD  = getArgValue(args, "password", PASSWORD)
HOST      = getArgValue(args, "host", HOST)
PORT      = getArgValue(args, "port", PORT)
DBNAME    = getArgValue(args, "dbname", DBNAME)

if MYSQLPATH = "" then
    MYSQLPATH = InputBox("Enter path to the MySQL executable files")
end if

MYSQLEXE  =  MYSQLPATH & "\" & "mysql.exe"

'try threat the given path as the MySQL home directory
if not fso.FileExists(MYSQLEXE) then
  MYSQLPATH2 = MYSQLPATH & "\" & "bin"
  MYSQLEXE2 = MYSQLPATH2 & "\" & "mysql.exe"
  if fso.FileExists(MYSQLEXE2) then
    MYSQLPATH = MYSQLPATH2
    MYSQLEXE = MYSQLEXE2
  else
    die "Could not find mysql.exe in " & MYSQLPATH & vbNewLine & vbNewLine
  end if
end if

if USERNAME = "" then
    USERNAME = InputBox("Enter MySQL user name under which actiTIME will create and use the database")
end if
'if username is finally empty, just guess that we are cool root user
if USERNAME = "" then
    USERNAME = "root"
end if

if Not(args.Exists("password")) And PASSWORD = "" then
    PASSWORD = InputBox("Enter password of MySQL user " & USERNAME)
end if
if DBNAME = "" then
    DBNAME = "actitime"
end if
if HOST = "" then
    HOST = "localhost"
end if
URL = HOST
if PORT = "" then
    PORT = "3306"
end if
URL = URL & ":" & PORT


MYSQLDUMPEXE    = quot & mysqlPath & "\mysqldump.exe" & quot
'MYSQLADMINEXE   = quot & mysqlPath & "\mysqladmin.exe" & quot



dim mysqlVars, errorMsg

Set mysqlVars = CreateObject("Scripting.Dictionary")

errorMsg = getMySQLVariables(mysqlVars)
if len(errorMsg) then die(errorMsg)

if not checkMysqlVersion(mysqlVars.Item("version")) then
    die("Setup has detected that you are using MySQL version " & mysqlVars.Item("version") & "," & vbNewLine & _
        "which is no longer supported by actiTIME. " & vbNewLine & vbNewLine & _
        "This version of actiTIME supports MySQL 5.0 and higher." & vbNewLine & vbNewLine & _
        "For information on how to proceed with actiTIME installation" & vbNewLine & _
        "please contact actiTIME support team at support@actitime.com." & vbNewLine)
end if

if not isInnoDBEnabled() then
	die("Your MySQL server does not support InnoDB tables or InnoDB support is disabled.")
end if

if (not prepareSchema) then ' if schema cannot be prepared installation should be aborted
        WScript.Quit 1
end if

DBURL = "jdbc:mysql://" & URL & "/" & DBNAME & "?useUnicode=yes&characterEncoding=UTF-8"

set out = fso.CreateTextFile(ATPROPS, True)
out.WriteLine("DBdriver=org.gjt.mm.mysql.Driver")
out.WriteLine("DBurl=" & DBURL)
out.WriteLine("DBuser=" & EscapeParamForPropsFile(USERNAME))
out.WriteLine("DBpassword=" & EscapeParamForPropsFile(PASSWORD))
out.close
'MsgBox ""Updated " & ATPROPS, vbOKOnly + vbInformation, "actiTIME - Setup MySQL"

MsgBox "Setup completed successfully", vbOKOnly + vbInformation, "actiTIME - Setup MySQL"




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''                                  FUNCTIONS                                 ''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Const ForReading = 1, ForWriting = 2, ForAppending = 8
Const WindowsFolder = 0, SystemFolder = 1, TemporaryFolder = 2

function die(msg)
    MsgBox msg & vbNewLine & "Installation terminated.", vbOKOnly or vbCritical, "actiTIME - Setup MySQL"
    WScript.Quit 1
end function

function getCommandLineArguments
    dim i, args, argName

    set args = WScript.Arguments
    set getCommandLineArguments = CreateObject("Scripting.Dictionary")

    for i = 0 to args.Count - 1
        if left(args(i), 1) = "/" then
            argName = lcase(right(args(i), len(args(i)) - 1))
            if not getCommandLineArguments.Exists(argName) then
                getCommandLineArguments.Add argName, ""
            end if
        else
            getCommandLineArguments.Item(argName) = args(i)
        end if
    next
end function

function getArgValue(args, argName, defaultValue)
    if args.Exists(argName) then
        getArgValue = args.Item(argName)
    else
        getArgValue = defaultValue
    end if
end function

' If the specified parameter is False (it means that actiTIME is
' installed over an older version one) confirmation window
' informing about an older installed actiTIME database is shown.
' In this case the function returns True if user presses 'Yes',
' and False if user presses 'No'. If the specified "schemaJustCreated"
' is True True is returned.
' Parameter is needed not to show confirmation window if it is not
' needed (in conditional clause).
function confirmDbPatchesApplying(schemaJustCreated)
        confirmDbPatchesApplying = True

        if (not schemaJustCreated) then
                confirmDbPatchesApplying = MsgBox ("Setup has detected that the """ & DBNAME & """ database already contains actiTIME data." & vbNewLine & _
                                                                                   "The database will be updated to correspond to the actiTIME version you are installing." & vbNewLine & vbNewLine & _
                                                                                   "Are you sure you want to proceed?", _
                                                                                   vbYesNo + vbExclamation, """" & DBNAME & """ database already contains actiTIME data") = vbYes
        end if
end function

' Shows confirmation window informing about existent
' database with given name.
' Returns True if user presses "Yes" and False otherwise.
function confirmSchemaCreationInDifferentDb()
        confirmSchemaCreationInDifferentDb = MsgBox ("Setup has detected that the """ & DBNAME & """ database contains some data not related to actiTIME." & vbNewLine & _
                                                                                                 "If you proceed, setup will add actiTIME data to the """ & DBNAME & """ database." & vbNewLine & _
                                                                                                 "After the installation actiTIME will work fine, but the initial data stored in the """ & DBNAME & """ database may become unusable." & vbNewLine & vbNewLine & _
                                                                                                 "Are you sure you want to proceed?", _
                                                                                                 vbYesNo + vbExclamation, """" & DBNAME & """ database contains some data not related to actiTIME") = vbYes
end function

' Creates database with the specified for the script "DBNAME"
' if it does not exist. If some error occured during database
' creation the script dies with cause error message.
sub createDb
    if (not checkDBexists) then
        execOrDie "", "create database " & DBNAME
        MsgBox "Created database " & DBNAME, vbOKOnly + vbInformation, "actiTIME - Setup MySQL"
    end if
end sub

' Fills in the database having the specified for the script
' DBNAME using the specified for the script SCHEMASQL.
' If some error occured during database schema creation
' the script dies with cause error message.
sub createDbSchema
        execFileOrDie DBNAME, SCHEMASQL, "Failed to create database schema"
    MsgBox "Created database schema", vbOKOnly + vbInformation, "actiTIME - Setup MySQL"
end sub

' Makes database dump and saves it in path generated by genBackupPath().
sub makeDbBackup
        dbBackupName = genBackupName()
        dbBackupPath = genBackupPath(dbBackupName)

        dumpParams = " -f -R -h " & HOST & " -u " & escapeParamForCommandLine(USERNAME) & " -r """ & dbBackupPath & """"
        'if password is finally empty, we dont need -p option
        if (PASSWORD <> "") then
                dumpParams = dumpParams & " -p" & escapeParamForCommandLine(PASSWORD)
        end if

    if (PORT <> "") then
        dumpParams = dumpParams & " -P " & PORT
    end if
    dbBackupCmdLine = SH & " """ & MYSQLDUMPEXE & dumpParams  & " " & DBNAME & """"
    'MsgBox dbBackupCmdLine
    execHuman dbBackupCmdLine, "Failed to backup database " & DBNAME & " to file " & dbBackupPath, "mysqldump", "mysql is not installed or misconfigured"
    MsgBox "Made database backup to " & dbBackupPath, vbOKOnly + vbInformation, "actiTIME - Setup MySQL"
end sub

'Calculates patches which will be applied to database.
'Return amount of patches or -1 if one or more paches not found.
function calculatePatchChainLinks(initDbVer, initPackVer, targetDbVer)
    dim curDbVer, curPackVer, nextDbVer, nextPackVer, fileName
    curDbVer = initDbVer
    curPackVer = initPackVer
    calculatePatchChainLinks = 0

    'check vertical patches
    while curDbVer < targetDbVer
        nextDbVer = curDbVer + 1
        fileName = "patch_" & curDbVer & "-" & nextDbVer & "." & curPackVer & ".mysql4.sql"
        fileName_new = "patch_" & nextDbVer & ".mysql4.sql"
        if (not fso.FileExists(ROOT & "\\" & fileName)) And (Not fso.FileExists(ROOT & "\\" & fileName_new)) then
            calculatePatchChainLinks = -1
            exit function
        else
            calculatePatchChainLinks = calculatePatchChainLinks + 1
        end if
        curDbVer = nextDbVer
    wend
end function

' Scans patch files in format: patch_[dbVer].[packVer]-[X].mysql4.sql
'   where dbVer - current base version,
'         packVer - current package version
'         X - next package version
' Return max X or 0 if patch files not found
function getNextPackVer(dbVer, packVer)
    dim files, file, matches, result

    set re = new RegExp
    re.Global = true
    re.IgnoreCase = true

    re.Pattern = "patch_" & dbVer & "\." & packVer & "-([0-9]+)\.mysql4\.sql"

    set f = fso.GetFolder(ROOT)
    set files = f.Files
    result = 0
    for each file in files
        set matches = re.Execute(file.Name)
        if matches.Count = 1 then
            result = max(result, parseInt(matches.Item(0).SubMatches(0)))
        end if
    next

    getNextPackVer = result
end function

' Creates actiTIME database if it is needed, fills in it by schema if it is needed and
' applies database patches if appropriate ones exist. The function returns True if all
' actions were done or were omitted as not wanted. False is returned in the next cases:
' - user canceled schema creation in a non-actiTIME database;
' - user canceled actiTIME database upgrade.
function prepareSchema
    dim dbVer, packVer, maxPatchDbVer, curDbVer, nextDbVer, nextPackVer, errorMsg, dumpParams, patchFileName

    ' create database
    createDb

    dbEmpty = isDBempty
    actitimeDb = isActitimeDbExists

    ' confirm schema creation in different database
    schemaCreationInDifferentDbConfirmed = False
    if (not actitimeDb) and (not dbEmpty) then
        schemaCreationInDifferentDbConfirmed = confirmSchemaCreationInDifferentDb()
    end if

    ' fill in it by schema
    schemaJustCreated = False
    if (dbEmpty or schemaCreationInDifferentDbConfirmed) then ' after schema creation actitimeDb is set to True even if it was False because the database become actiTIME
        createDbSchema
        actitimeDb = True
        schemaJustCreated = True
    end if

    prepareSchema = False
    if actitimeDb then
        ' apply database patches
        getDbVersion dbVer, packVer

        getMaxPatchVersion maxPatchDbVer

        'WScript.Echo dbVer & " " & packVer
        'WScript.Echo maxPatchDbVer

        patchCount = calculatePatchChainLinks(dbVer, packVer, maxPatchDbVer)

        ' downgrade prohibition
        if maxPatchDbVer < dbVer or _
           patchCount = -1 then

            MsgBox "Setup has detected that actiTIME database cannot be upgraded" & vbNewLine & _
                   "using this installation package." & vbNewLine & vbNewLine & _
                   "Installation terminated.", vbOKOnly or vbExclamation, "actiTIME - Setup MySQL"
            exit function
        end if

        if maxPatchDbVer <> dbVer then
            if confirmDbPatchesApplying(schemaJustCreated) then

                if (not schemaJustCreated) then
                    makeDbBackup
                end if

                curDbVer = dbVer
                patchInd = 0

                while curDbVer < maxPatchDbVer
                    nextDbVer = curDbVer + 1
                    patchInd = patchInd + 1
                    patchFileName = "patch_" & curDbVer & "-" & nextDbVer & "." & packVer & ".mysql4.sql"
					If fso.FileExists(ROOT & "\\" & patchFileName) Then
                        applyPatchIfExistsOrDie patchFileName, patchInd, patchCount
					Else
						applyPatchIfExistsOrDie "patch_" & nextDbVer & ".mysql4.sql", patchInd, patchCount
					End If
                    curDbVer = nextDbVer
                wend
            end if
        end if

        prepareSchema = True
    end if
end function

function applyPatchIfExistsOrDie(patch, patchInd, patchCount)
    dim patchNum, matches

    set re = new RegExp
    re.Global = true
    re.IgnoreCase = true
    re.Pattern = "patch_(.*)\.mysql4\.sql"
    set matches = re.Execute(patch)
    if matches.Count = 1 then
        patchNum = matches.Item(0).SubMatches(0)
    else
        patchNum = patch
    end if

    if not fso.FileExists(ROOT & "\\" & patch) then
        die("Failed to apply patch " & patchNum & ":" & vbNewLine & "Error: " & "The patch " & patchNum & " does not exist. Could not upgrade the database." & vbNewLine)
    end if

    execFileOrDie DBNAME, patch, "Failed to apply patch " & patchNum

    MsgBox "Applied patch " & patchNum & " (" & patchInd & " of " & patchCount & ")", vbOKOnly + vbInformation, "actiTIME - Setup MySQL"
end function


function parseInt(intStr)
    Dim intNum, i, ch

    intNum = ""
    for i = 1 to Len(intStr)
        ch = Mid(intStr, i, 1)
        if Asc(ch) >= 48 and Asc(ch) <= 57 then intNum = intNum & ch
    next

    parseInt = CInt(intNum)

end function

function max(n1, n2)
    if n1 > n2 then
        max = n1
    else
        max = n2
    end if
end function

function compareVersions(verLeft, verRight)
    Dim i, versNum, curVerL, curVerR
    i = 0
    versNum = max(UBound(verLeft), UBound(verRight))
    compareVersions = 0
    while (compareVersions = 0) and (i <= versNum)
        if i <= UBound(verLeft) then
            curVerL = verLeft(i)
        else
            curVerL = 0
        end if
        if i <= UBound(verRight) then
            curVerR = verRight(i)
        else
            curVerR = 0
        end if

        if curVerR > curVerL then
            compareVersions = 1
        elseif curVerR < curVerL then
            compareVersions = -1
        end if
        i = i + 1
    wend
end function

function checkMysqlVersion(verStr)

    ver = Split(verStr, ".", -1, vbTextCompare)

    mysqlVer = Array(0, 0, 0)

    On Error Resume Next
    mysqlVer(0) = parseInt(ver(0))
    mysqlVer(1) = parseInt(ver(1))
    mysqlVer(2) = parseInt(ver(2))
    On Error Goto 0

    'Wscript.Echo mysqlVer(0), mysqlVer(1), mysqlVer(2)

    checkMysqlVersion = compareVersions(MIN_MYSQL_VERSION, mysqlVer) >= 0

end function

function execOrDie(db, sql)
    Dim errorMsg
    errorMsg = sqlExecUpdate(mysqlexe, HOST, PORT, USERNAME, PASSWORD, db, sql)
    if Len(errorMsg) then die(errorMsg)
end function

function execFileOrDie(db, sqlFile, errTitle)
    Dim result, errorMsg
    result = sqlExecFile(mysqlexe, HOST, PORT, USERNAME, PASSWORD, db, ROOT & "/" & sqlFile)
    if sqlHasErrors(result) then
        errorMsg = sqlGetError(result)
    end if
    sqlClose(result)

    if Len(errorMsg) > 0 then
        die(errTitle & ":" & vbNewLine & "Error: " & errorMsg & vbNewLine)
    end if
end function

function getMySQLVariables(vars)
    Dim result, resultSet, errstr

    result = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, "", "show variables;")

    if sqlHasErrors(result) then
        errstr = sqlGetError(result)
    else
        while sqlHasNext(result)
            resultSet = sqlNext(result)

            varName = sqlGet(resultSet, 0)
            varValue = sqlGet(resultSet, 1)

            vars.Add LCase(varName), varValue
        wend
    end if
    sqlClose(result)

    getMySQLVariables = errstr

end function

function isInnoDBEnabled()
    Dim result, resultSet, errstr, found

	found=false
	
    result = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, "", "show engines;")

    if sqlHasErrors(result) then
        errstr = sqlGetError(result)
    else
        while sqlHasNext(result)
            resultSet = sqlNext(result)
            varName = sqlGet(resultSet, 0)
            varValue = sqlGet(resultSet, 1)
			if (StrComp("InnoDB", varName, 1)=0) and ((StrComp("YES", varValue, 1)=0) or (StrComp("DEFAULT", varValue, 1)=0)) then
				found = true
			end if
        wend
    end if
    sqlClose(result)

    isInnoDBEnabled = found
end function

function checkDBexists
    Dim result
    result = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, DBNAME, "show tables;")
    checkDBexists = not sqlHasErrors(result)
    sqlClose(result)
end function

' Determines whether the database having "DBNAME" name is created by actiTIME or not.
' Database is created by actiTIME if it has two tables: at_user and patch_history.
function isActitimeDbExists
        Dim result

        result = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, DBNAME, "select count(*) from at_user, patch_history;")

        isActitimeDbExists = not sqlHasErrors(result)

        sqlClose(result)
end function

' Determines whether the database "DBNAME" is empty or not. Database is empty
' if it has no tables (has 0 tables).
function isDBempty
    Dim result, resultSet, tableNum

    result = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, DBNAME, "show tables;")

    tableNum = 0
    if sqlHasErrors(result) then
        errstr = sqlGetError(result) ' skip it here...
    else
        while sqlHasNext(result)
            resultSet = sqlNext(result)

            tableName = sqlGet(resultSet, 0)
            ' TODO: check tableNames here
            tableNum = tableNum + 1
        wend
    end if
    sqlClose(result)

    isDBempty = tableNum = 0

end function

function execHuman(path, errMsg, prog, suggestion)
    dim exitCode

    On Error Resume Next
    exitCode = shell.Run(path, 0, true)
    'MsgBox exitCode
    if Err.Number <> 0 then
        die("Failed to run " & prog & ", probably " & suggestion)
    end if
    on Error goto 0
    if exitCode <> 0 then
        die(errMsg)
    end if

end function

function generateTmpFileName
    dim tfolder
    set tfolder = fso.GetSpecialFolder(TemporaryFolder)
    generateTmpFileName = tFolder.Path & "\" & fso.GetTempName
end function

function safeRemoveFile(filename)
    On Error Resume Next
    fso.DeleteFile filename, True
    on Error goto 0
end function

function getMaxPatchVersion(byref maxPatchDbVer)
    dim files, file, matches

    set re = new RegExp
    set re_new = new RegExp
    re.Global = true
    re_new.Global = true
    re.IgnoreCase = true
    re_new.IgnoreCase = true

    maxPatchDbVer = 0

    re.Pattern = "patch_[0-9]+-([0-9]+)\.0\.mysql4\.sql"
    re_new.Pattern = "patch_([0-9]+)\.mysql4\.sql"

    set f = fso.GetFolder(ROOT)
    set files = f.Files
    for each file in files
        set matches = re.Execute(file.Name)
        if matches.Count = 1 then
            maxPatchDbVer = max(maxPatchDbVer, parseInt(matches.Item(0).SubMatches(0)))
        else
			set matches = re_new.Execute(file.Name)
            If matches.Count = 1 then
				maxPatchDbVer = max(maxPatchDbVer, parseInt(matches.Item(0).SubMatches(0)))
			End If
        end if
    next
end function

function getDbVersion(byref dbVer, byref packVer)
    Dim errstr, result, resultSet, tableNum, patchHistoryExists, features, featuresNum

    dbVer = 0
    packVer = 0

    ' check that patch_history table exists
    patchHistoryExists = doesTableExist("patch_history")

    if patchHistoryExists then
        result = executeSql("select max(patch) from patch_history;")

        if sqlHasErrors(result) then
            errstr = sqlGetError(result)
            die("Failed to obtain version of current database schema." & vbNewLine & "Error: " & errstr & vbNewLine)
        elseif sqlHasNext(result) then
            dbVer = parseInt(sqlGet(sqlNext(result), 0))
        end if
        sqlClose(result)

        result = executeSql("select max(pack_version) from patch_history where patch = '" & dbVer & "';")
        if not sqlHasErrors(result) then
            if sqlHasNext(result) then
                packVer = parseInt(sqlGet(sqlNext(result), 0))
            end if
        end if
        sqlClose(result)

        if (dbVer = 10) and (packVer = 0) then
            ' an old database, try to find out the pack version from the data
            ' taken from feature_patch_history table.
            
            result = executeSql("select group_concat(                 " & _
                                "         distinct feature_code       " & _
                                "         order by feature_code       " & _
                                "         separator '_') as features, " & _
                                "       count(distinct feature_code)  " & _
                                "         as features_num             " & _
                                "  from feature_patch_history;")
    
            if (not sqlHasErrors(result)) and sqlHasNext(result) then
                resultSet = sqlNext(result)
                features = sqlGet(resultSet, 0)
                featuresNum = sqlGet(resultSet, 1)

                if ((features = "aCv97P_g7rcD5_pAo3bZ") and (featuresNum = 3)) then
                    packVer = 2
                elseif ((features = "aCv97P_pAo3bZ") and (featuresNum = 2)) then
                    packVer = 1
                end if
            end if
            sqlClose(result)
        end if
    end if
end function

function genBackupPath(backupName)
    genBackupPath = ROOT & "\" & backupName
end function

function genBackupName()
    cur = Now
    fmt = Year(cur) & lz(Month(cur)) & lz(Day(cur)) & lz(Hour(cur)) & lz(Minute(cur)) & lz(Second(cur))
    genBackupName = "actitime.mysql4.sql.backup_" & fmt
end function

function lz(num)
    lz = ""
    if (num < 10) then
        lz = lz & "0"
    end if
    lz = lz & num
end function

' Tries to read database connection params from the file propFile.
' Returns an array of 6 elements:
'  - 1st element - username
'  - 2nd element - password
'  - 3rd element - host
'  - 4th element - port
'  - 5th element - database
'  - 6th element - DB driver
'  - 7th element - JDBC URL
' If the file does not exist returns empty array.
' If any of the properties could not be read (does not exists or contains slashes inside)
' the value at the corresponding index will be empty.
function readATProperties(propFile)
    dim url, hostAndPort
    dim params()
    redim params(0)

    if fso.fileExists(propFile) then
        redim params(6)

        params(0) = getPropertyValue(propFile, "DBuser")
        params(1) = getPropertyValue(propFile, "DBpassword")
        params(5) = getPropertyValue(propFile, "DBdriver")
        url = getPropertyValue(propFile, "DBurl")

        if inStrRev(url, "?") > 0 Then
            url = left(url, inStrRev(url, "?") - 1)
        End if
        params(6) = url
        if Len(url) > 0 then
            if inStrRev(url, "/") > 0 and _
               left(url, 13) = "jdbc:mysql://" and _
               inStrRev(url, "/") > 13 then
                hostAndPort = mid(url, 14, inStrRev(url, "/") - 14)
                if inStr(hostAndPort, ":") > 0 then
                    params(2) = left(hostAndPort, inStr(hostAndPort, ":") - 1)
                    params(3) = right(hostAndPort, len(hostAndPort) - inStr(hostAndPort, ":"))
                else
                    params(2) = hostAndPort
                end if
                params(4) = trim(right(url, len(url) - inStrRev(url, "/")))
            end if
        end if
    end if

    readATProperties = params
end function

function getPropertyValue(fileName, propertyName)
    dim stream, strLine, res

    set stream = fso.OpenTextFile(fileName)

    res = ""
    do while not stream.atEndOfStream
        strLine = trim(stream.readLine())

        if (inStr(strLine, "=") > 0) and (left(strLine, len(propertyName)) = propertyName) then
            if inStr(strLine, "\") = 0 then
                res = trim(right(strLine, len(strLine) - inStr(strLine, "=")))
            end if
            exit do
        end if
    loop

    getPropertyValue = res
end function



' MySQL functions

Function executeSql(sql)
        executeSql = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, DBNAME, sql)
End Function 

function escapeParamForSql(param)
        escapeParamForSql = replace(param, "'", "''")
end function

function doesTableExist(tablename)
    dim sql, result
    sql = "SHOW TABLES LIKE '" & escapeParamForSql(tablename) & "';"
    result = executeSql(sql)
    doesTableExist = sqlHasNext(result)
end function

function sqlHasNext(result)
    'sqlHasNext = (not IsNull(result(1))) and (not result(1).AtEndOfStream)
    sqlHasNext = false
    On Error Resume Next
    sqlHasNext = not result(1).AtEndOfStream
    On Error Goto 0
end function

function sqlNext(result)
    sqlNext = null
    if sqlHasNext(result) then
        sqlNext = result(1).ReadLine
    end if
end function

function sqlGet(resultSet, index)
    Dim columns
    columns = Split(resultSet, vbTab, -1, vbTextCompare)

    sqlGet = null
    if UBound(columns) >= index then
        sqlGet = columns(index)
    end if
end function

function sqlSelectOneValue(sql, byref errstr)
    Dim result, resultSet

    result = sqlExec(mysqlexe, HOST, PORT, USERNAME, PASSWORD, DBNAME, sql)

    if sqlHasErrors(result) then
        errstr = sqlGetError(result)
    elseif sqlHasNext(result) then
        resultSet = sqlNext(result)
        sqlSelectOneValue = sqlGet(resultSet, 0)
    end if
    sqlClose(result)
end function

function sqlHasErrors(result)
    sqlHasErrors = (not IsNull(result(2))) and (Len(result(2)) > 0)
end function

function sqlGetError(result)
    sqlGetError = result(2)
end function

Sub sqlClose(result)
    if not IsNull(result(1)) then
        result(1).Close
    end if
    if not IsNull(result(0)) then
        safeRemoveFile(result(0))
    end if
    result = Array(null, null, null)
End Sub

function sqlExecUpdate(mysqlexe, mysqlHost, mysqlPort, mysqlUser, mysqlPassword, mysqlDatabase, sqlQuery)
    Dim sqlResult
    sqlResult = sqlExec(mysqlexe, mysqlHost, mysqlPort, mysqlUser, mysqlPassword, mysqlDatabase, sqlQuery)
    sqlExecUpdate = sqlGetError(sqlResult)
    sqlClose(sqlResult)
end function

function sqlExec(mysqlexe, mysqlHost, mysqlPort, mysqlUser, mysqlPassword, mysqlDatabase, sqlQuery)
    Dim sqlQueryFileName, sqlQueryFile

    sqlQueryFileName  = fso.GetSpecialFolder(TemporaryFolder) & "\" & fso.GetTempName
    set sqlQueryFile = fso.OpenTextFile(sqlQueryFileName, ForWriting, true)
    sqlQueryFile.Write sqlQuery
    sqlQueryFile.Close

    sqlExec = sqlExecFile(mysqlexe, mysqlHost, mysqlPort, mysqlUser, mysqlPassword, mysqlDatabase, sqlQueryFileName)

    safeRemoveFile(sqlQueryFileName)

end function

function sqlExecFile(mysqlexe, mysqlHost, mysqlPort, mysqlUser, mysqlPassword, mysqlDatabase, sqlQueryFile)

    Dim mysql, cmd, options

    if not fso.FileExists(mysqlexe) then
        sqlExecFile = Array(null, null, "Failed to run mysql. File " & mysql & " is not found.")
        exit function
    end if

    if not fso.FileExists(sqlQueryFile) then
        sqlExecFile = Array(null, null, "Failed to run mysql. File " & sqlQueryFile & " is not found.")
        exit function
    end if

    Dim stdOutFileName, stdErrFileName, stdErrFile
    Dim tmpBatchFileName, tmpOptionsFileName

    stdOutFileName = generateTmpFileName
    stdErrFileName = generateTmpFileName
    tmpBatchFileName = generateTmpFileName & ".bat"
    tmpOptionsFileName = generateTmpFileName
   
    cmd = quot & mysqlexe & quot & " --defaults-file=" & quot & tmpOptionsFileName & quot & " --default-character-set=utf8 -B -f "
    cmd = cmd & " 1> " & quot & stdOutFileName & quot & " 2> " & quot & stdErrFileName & quot & " < " & quot & sqlQueryFile & quot

    options = "[client]" & Chr(10)
    If Len(mysqlPort) > 0 Then options = options & "port=" & mysqlPort & Chr(10)
    If Len(mysqlHost) > 0 Then options = options & "host=" & mysqlHost & Chr(10)
    If Len(mysqlUser) > 0 Then options = options & "user=" & mysqlUser & Chr(10)
    If Len(mysqlPassword) > 0 Then options = options & "password=" & mysqlPassword & Chr(10)
    If Len(mysqlDatabase) > 0 Then options = options & "database=" & mysqlDatabase & Chr(10)
    
    Dim f
    set f = fso.OpenTextFile(tmpBatchFileName, ForWriting, true)
    f.Write cmd
    f.Close
    set f = fso.OpenTextFile(tmpOptionsFileName, ForWriting, true)
    f.Write options
    f.Close

    On Error Resume Next

    dim errCode
    errCode = shell.Run(tmpBatchFileName, 0, true)

    if Err.Number <> 0 then
        sqlExecFile = Array(null, null, "Failed to run mysql, probably mysql is not installed or misconfigured.")
    else
        set stdErrFile = fso.OpenTextFile(stdErrFileName, ForReading)
        If (errCode > 0) or (Not stdErrFile.AtEndOfStream) Then
            errstr = stdErrFile.ReadAll
            safeRemoveFile(stdOutFileName)
            sqlExecFile = Array(null, null, errstr)
        Else
            errstr = null
            sqlExecFile = Array(stdOutFileName, fso.OpenTextFile(stdOutFileName, ForReading), errstr)
            sqlNext(sqlExecFile) ' skip titles
        End If
        stdErrFile.Close
    end if

    safeRemoveFile(tmpBatchFileName)
    safeRemoveFile(tmpOptionsFileName)
    safeRemoveFile(stdErrFileName)

    On Error Goto 0

end function

' This function is needed because SQL to execute is written to batch file firstly where some symbols should be escaped
Function escapeParamForBatch(param)
    Dim result
    Dim escapeSymbol

    result = param

    ' Escape trailing slashes and slashes that stand before 'symbol'.
    set re = new RegExp
    re.global = true
    re.pattern = "(\\+)(""|$)"
    result = re.replace(result, "$1$1$2")

    result = replace(result, """", """^""""")
    result = replace(result, "%", "%%")

    EscapeParamForBatch = """" & result & """"
End Function

Function isQuote(character)
    isQuote = (character = """")
End Function

Function isWhitespace(character)
    set whiteSpaceRE = new RegExp
    whiteSpaceRE.global = true
    whiteSpaceRE.pattern = "\s"
    Set matches = whiteSpaceRE.Execute(character)
    isWhitespace = (matches.Count > 0)
End Function


' MySQL parameters should be escaped by this function for using them in command line.
Function escapeParamForCommandLine(param)
    Dim result, regExpResult, char, prevChar, nextChar

    regExpResult = param

    set re = new RegExp
    re.global = true

    ' Wrap strings of spaces with quotes
    re.pattern = "(\s+)"
    regExpResult = re.replace(regExpResult, """$1""")

    ' Double slashes that stand before quote.
    re.pattern = "(\\+)"""
    regExpResult = re.replace(regExpResult, "$1$1""")

    ' Escape quotes. Quotes that stand before spaces should not be escaped.
    for charNum = 1 to Len(regExpResult)
        char = Mid(regExpResult, charNum, 1)
        ' equals to "^""(?!\s)"
        if charNum = 1 Then
            if isQuote(char) and not isWhitespace(char) Then
                result = result & "\"
            end if
        elseif charNum = Len(regExpResult) Then
            ' equals to "(\S)""(?!\s)"
            prevChar = Mid(regExpResult, charNum - 1, 1)
            if isQuote(char) and not isWhitespace(prevChar) Then
                result = result & "\"
            end if
        else
            ' equals to "(\S)""(?!\s)"
            prevChar = Mid(regExpResult, charNum - 1, 1)
            nextChar = Mid(regExpResult, charNum + 1, 1)
            if isQuote(char) and not isWhitespace(prevChar) and not isWhitespace(nextChar) Then
                result = result & "\"
            end if
        end if
        result = result & char

    next

    EscapeParamForCommandLine = result
End Function

' MySQL parameters should be escaped by this function for using them in properties file.
Function EscapeParamForPropsFile(param)
    EscapeParamForPropsFile = replace(param, "\",  "\\")
End Function

function execCmd(cmd)
    dim results(2)

    set shell = CreateObject("WScript.Shell")

    WScript.Sleep 100
    results(1) = ""
    results(2) = ""
    'msgbox cmd
    set oExec = shell.Exec(cmd)
    do while not oExec.StdOut.AtEndOfStream
        results(1) = results(1) & oExec.StdOut.ReadLine & vbNewLine
    loop
    do while not oExec.StdErr.AtEndOfStream
        results(2) = results(2) & oExec.StdErr.ReadLine & vbNewLine
    loop
    do while oExec.Status <> 1
        WScript.Sleep 100
    loop
    results(0) = oExec.ExitCode

    execCmd = results
end function

function max(v1, v2)
    if v1 < v2 then
        max = v2
    else
        max = v1
    end if
end function

