<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.PackageInformation" %>
<%@ page import="com.actimind.common.licensing.License" %>
<%@ page import="com.actimind.common.Product" %>

<%@ page import="com.actimind.common.licensing.LicenseKeyUtils" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="com.actimind.common.ProductWebSiteURLs" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.common.ATGlobals" %>
<%@ page import="com.actimind.actitime.PackageInformationUtil" %>
<%@ page import="com.actimind.common.licensing.LicenseHelper" %>
<%@ page import="com.actimind.common.licensing.ActiveLicenseUtils" %>

<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="/WEB-INF/ap.tld" prefix="ap"%>
<bean:define id="environmentInfo" name="<%= Keys.ENVIRONMENT_INFO_KEY %>" scope="application"
             type="com.actimind.actitime.EnvironmentInfoBean"/>
<%
    Product product = ( Product ) request.getAttribute( Keys.PRODUCT );
    ProductWebSiteURLs siteURLs = ProductWebSiteURLs.get( product );
    License lic = ActiveLicenseUtils.getActiveLicenseNoLoad(product);
    String licensedTo = lic != null
                        ? ( !StringUtils.isNullOrEmpty( lic.getCompanyName() ) ? lic.getCompanyName() :
                            ( !StringUtils.isNullOrEmpty( lic.getFormattedName() ) ? lic.getFormattedName() : "" ) )
                        : "";
    String hasLicensedTo = !StringUtils.isNullOrEmpty( licensedTo ) ? "hasLicensedTo" : "";
    boolean isAT = product == Product.actiTIME;
    boolean isOl = ATGlobals.isOl();
    String onlineVersion = isOl ? "online" : "not-online";
%>

<table class="dialog-header">
    <tr>
        <td class="close-button">
            <div id="aboutPopupCloseButtonId" class="closeButton"></div>
        </td>
    </tr>
</table>


    <table cellspacing="0" cellpadding="0" border="0" style="margin-top: -12px;" class="<%=onlineVersion%>">
    <tr>
        <td>
            <table cellspacing="0" cellpadding="0" border="0" class="aboutContentTable">
                <tr>
                    <td width="1%" valign="top" class="logo">
                        <% if ( isAT ) { %>
                            <at:img page="support/about/at-logo.png"/>
                        <% } else { %>
                            <ap:img page="support/about/ap-logo.png"/>
                        <% } %>
                    </td>
                    <td width="99%" valign="top" id="aboutContentCell" class="aboutContentCell productInfoTabSelected">
                        <table cellpadding="0" cellspacing="0" border="0" class="tabs">
                            <tr>
                                <td class="emptyTab firstEmptyTab">
                                    &nbsp;
                                </td>
                                <td id="productInfoTab" class="infoTab productInfoTab">
                                    <div>
                                        <span class="productInfoTabHeader"><bean:message key="about.tab.product_info"/></span>
                                    </div>
                                </td>
                                <td class="emptyTab secondEmptyTab">
                                    &nbsp;
                                </td>
                                <td id="systemInfoTab" class="infoTab systemInfoTab">
                                    <div>
                                        <span class="systemInfoTabHeader"><bean:message key="about.tab.system_info"/></span>
                                    </div>
                                </td>
                                <td class="emptyTab lastEmptyTab">
                                    &nbsp;
                                </td>
                            </tr>
                        </table>
                        <div id="infoTablesDiv">
                        <table cellpadding="0" cellspacing="0" border="0" id="aboutProductInfoTable" class="productInfoTable environmentInfo <%=hasLicensedTo%>">
                            <tr class="productVersionInfo">
                                <td class="infoTitle">
                                    <bean:message key="about.product_version"/>
                                </td>
                                <td>
                                    <span class="productVersion"><%=LicenseKeyUtils.getFullActualVersionStr(request, isOl)%></span><br> <span>(<bean:message key="about.build"/> <%=PackageInformation.BUILD%>)</span>
                                    <br>
                                    <% if (!isOl) { %>
                                    <%= PackageInformation.PACKAGE_TYPE %> <bean:message key="about.package"/>
                                    <% } %>
                                </td>
                            </tr>
                            <% if( lic != null ) { %>
                                <tr>
                                    <td class="infoTitle">
                                        <bean:message key="about.license.users_header"/>
                                    </td>
                                    <td>
                                        <%
                                        String usersNumberKey = lic.isUnlimitedActiveUsersNumber() ? "about.license.unlimited.number" : "about.license.limited.number";
                                        String usersAccessKey = lic.isTrial() ? "about.license.trial.access" : "about.license.access";
                                        %>
                                        <span class="usersNumber">
                                            <bean:message key="<%=usersNumberKey%>" arg0="<%=String.valueOf( lic.getAllowedActiveUsersNumber() )%>"/>
                                        </span><br>
                                        <bean:message key="<%=usersAccessKey%>"/><br>
                                        <div id="aboutPopup_usedUserAccounts">&nbsp;</div>
                                    </td>
                                </tr>
                                <% if( !StringUtils.isNullOrEmpty( licensedTo ) ) { %>
                                    <tr class="mainInfo">
                                        <td class="infoTitle">
                                            <bean:message key="about.license.licensed_to_header"/>
                                        </td>
                                        <td><div class="companyName"><%=ResponseUtils.filter( licensedTo )%></div></td>
                                    </tr>
                                <% } %>
                            <% } %>
                        </table>
                        <% if (!isOl) { %>
                            <table id="aboutSystemInfoTable" class="systemInfoTable environmentInfo">
                                <tr class="technicalInfo">
                                    <td class="infoTitle">
                                        <bean:message key="about.os_platform"/>
                                    </td>
                                    <td><bean:write name="environmentInfo" property="osInfo"/></td>
                                </tr>
                                <tr class="technicalInfo">
                                    <td class="infoTitle">
                                        <bean:message key="about.servlet_container"/>
                                    </td>
                                    <td>
                                        <bean:write name="environmentInfo" property="servletContainerInfo"/><br>
                                        <bean:message key="about.servlet_api_version"/> <bean:write name="environmentInfo" property="servletApiVersion"/>
                                    </td>
                                </tr>
                                <tr class="technicalInfo">
                                    <td class="infoTitle">
                                        <bean:message key="about.java"/>
                                    </td>
                                    <td><bean:write name="environmentInfo" property="jdkRuntimeVersion"/></td>
                                </tr>
                                <tr class="technicalInfo">
                                    <td class="infoTitle">
                                        <bean:message key="about.database"/>
                                    </td>
                                    <td>
                                        <bean:write name="environmentInfo" property="databaseInfo"/><br>
                                        <bean:message key="about.driver"/> <bean:write name="environmentInfo" property="databaseDriverInfo"/><br>
                                        <bean:message key="about.patch_level"/> <bean:write name="environmentInfo" property="databasePatchLevelInfo"/>
                                    </td>
                                </tr>
                            </table>
                        <% } %>
                        </div>
                    </td>
                </tr>
                <tr>
                    <td colspan="2"><div class="footerDelimiter"></div></td>
                </tr>
                <tr>
                    <td colspan="2" class="aboutFooter">
                        <table>
                            <tr>
                                <td class="aboutLinks">
                                    <a href="<%=siteURLs.getWebSiteURL()%>" target="_blank"><%=siteURLs.getWebSiteDomain().trim()%></a>
                                    <span class="separator"></span>
                                    <%
                                        String licMsg = message(request, isOl ? "about.service.agreement" : "about.license.agreement");
                                        String link;
                                        if(isOl) {
                                            link = LicenseHelper.getOnlineServiceAgreementURL(product);
                                        } else
                                        {
                                            link = lic == null || lic.isTrial() ? null : LicenseHelper.getDownloadableLicenseURL(lic);
                                            if (link == null)
                                                link = response.encodeURL(request.getContextPath() + "/license.jsp");
                                        }
                                    %>
                                    <a href="javascript:void(0)" onclick="window.open('<%=link%>', '_blank');"><%=licMsg%></a>
                                </td>
                                <td class="aboutCopyright">
                                    <span>&copy; <%= PackageInformationUtil.getDisplayedReleaseYear() %> actiTIME Inc. All rights reserved.</span>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        </td>
    </tr>

</table>