<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.beans.UserBean" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="logic" uri="http://struts.apache.org/tags-logic" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%@ taglib prefix="tiles" uri="http://struts.apache.org/tags-tiles" %>

<%
    String id = request.getParameter("id");
    String prefilledText = "";
%>

<logic:present parameter="prefilledText" scope="request">
    <% prefilledText = request.getParameter("prefilledText"); %>
</logic:present>
<logic:present name="<%=Keys.LOGGEDIN_USER_KEY%>">
    <bean:define id="user" name="<%=Keys.LOGGEDIN_USER_KEY%>" type="com.actimind.actitime.beans.UserBean" scope="session"/>
</logic:present>
<logic:present name="<%=Keys.REGISTRATION_INFO_KEY%>" scope="session">
    <bean:define id="registrationInfo" name="<%=Keys.REGISTRATION_INFO_KEY%>" type="com.actimind.actitime.beans.RegistrationInfoBean" scope="session"/>
</logic:present>

<script type="text/javascript">
    UPLOAD_SUPPORT_FILE_URL = '<html:rewrite page="/uploadsupportfile.do"/>';
    CONTACT_SUPPORT_SHOW_EXTRA_FIELDS = true;
    <%
    UserBean loggedInUser = AuthController.getLoggedInUser(session);
    if (loggedInUser != null && loggedInUser.hasEmail()) {
    %>
    CONTACT_SUPPORT_SHOW_EXTRA_FIELDS = false;
    <% } %>
</script>

<table class="dialog-header">
    <tr>
        <td class="close-button">
            <div id="supportPopupCloseButton" class="closeButton"></div>
        </td>
    </tr>
</table>

<div class="innerContent">
    <div id="<%=id%>_mainContent" class="mainContent">
        <at:verticallyCentered>
        <div id="<%=id%>_supportForm">
            <div class="title"><bean:message key="contact_support.main.title"/></div>

            <div class="descriptionContainer">
                <p class="descriptionTitle"><bean:message key="contact_support.main.description_title"/></p>
                <textarea id="<%=id%>_description" name="description" cols="80" rows="8" class="text_area" tabindex="20"><%=prefilledText%></textarea>
                <% String descLengthId = id + "_descLength"; %>
                <jsp:include page="/textarea_length_note.jsp">
                    <jsp:param name="note_id" value="<%=descLengthId%>"/>
                    <jsp:param name="use_coloured_img" value="true"/>
                    <jsp:param name="message_pattern" value="textarea_length_note.short"/>
                </jsp:include>
            </div>

            <div class="dropzoneContainer">
                <p><bean:message key="contact_support.main.dropzone_title"/></p>
                <div class="dropzone"></div>
            </div>

            <div class="dropzoneTemplate dz-preview dz-file-preview" style="display: none">
                <div class="dz-progress">
                    <div class="dz-upload" data-dz-uploadprogress></div>
                    <div class="dz-details">
                        <div class="dz-filename" data-dz-name></div>
                        <div class="dz-size" data-dz-size></div>
                        <div class="button dz-remove" data-dz-remove></div>
                    </div>
                </div>
            </div>

            <div class="contactInformationContainer">
                <p><bean:message key="support.contact_information"/></p>
                <div class="contactInformationInputs">
                    <input id="<%=id%>_first_name" class="top left" type="text" value="<bean:write name="user" property="firstName" ignore="true"/>" placeholder="<bean:message key="user.first_name"/>" maxlength="32"/>
                    <input id="<%=id%>_last_name" class="top right" type="text" value="<bean:write name="user" property="lastName" ignore="true"/>" placeholder="<bean:message key="user.last_name"/>" maxlength="32"/>
                    <input id="<%=id%>_email" class="bottom left" type="text" value="<bean:write name="user" property="email" ignore="true"/>" placeholder="<bean:message key="user.email"/>" maxlength="32"/>
                    <input id="<%=id%>_company_name" class="bottom right" type="text" value="<bean:write name="registrationInfo" property="companyName" ignore="true"/>" placeholder="<bean:message key="support.company_name"/>" maxlength="32"/>
                </div>
            </div>

            <div class="clientSideErrorContainer">
                <div id="<%=id%>_clientSideErrorMessage" class="clientSideError" style="display: none;">
                    <table cellpadding="0" cellspacing="0" border="0">
                        <tr>
                            <td class="errorImgCell">
                                <at:img page="error.gif"/>
                            </td>
                            <td class="errorMsgCell">
                                <span id="<%=id%>_errorMsgContainer" class="errormsg"></span>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>

            <div class="submitButtonContainer">
                <div id="<%=id%>_submitButton" class="button blueButton"><bean:message key="contact_support.main.send"/></div>
            </div>
        </div>
        </at:verticallyCentered>
    </div>

    <div id="<%=id%>_progressContent" class="progressContent">
        <at:verticallyCentered>
            <at:img page="dialogs/support/envelope.png"/>
            <div class="messageUnderPicture"><bean:message key="contact_support.progress.title"/></div>
        </at:verticallyCentered>
    </div>

    <div id="<%=id%>_successContent" class="successContent">
        <at:verticallyCentered>
            <at:img page="dialogs/support/envelope.png"/>
            <div class="messageUnderPicture"><bean:message key="contact_support.success.title"/></div>
            <p><bean:message key="contact_support.success.thank_you"/></p>
            <div class="button sendAgain" id="<%=id%>_sendAgain"><bean:message key="contact_support.success.send_again"/></div>
        </at:verticallyCentered>
    </div>
</div>