<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.common.AjaxActionErrorCodes" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="logic" uri="http://struts.apache.org/tags-logic" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%@ taglib prefix="tiles" uri="http://struts.apache.org/tags-tiles" %>

<%
    String id = request.getParameter("id");
    String prefilledText = "";
%>
<logic:present parameter="prefilledText" scope="request">
    <% prefilledText = request.getParameter("prefilledText"); %>
</logic:present>
<logic:present parameter="text" scope="request">
    <% prefilledText = request.getParameter("text"); %>
</logic:present>


<bean:define id="productName" name="<%= Keys.PRODUCT_CONFIG %>" property="productName" type="java.lang.String"/>

<logic:present name="<%=Keys.LOGGEDIN_USER_KEY%>"><bean:define id="user" name="<%=Keys.LOGGEDIN_USER_KEY%>" type="com.actimind.actitime.beans.UserBean" scope="session"/></logic:present>
<logic:present name="<%=Keys.REGISTRATION_INFO_KEY%>" scope="session">
    <bean:define id="registrationInfo" name="<%=Keys.REGISTRATION_INFO_KEY%>" type="com.actimind.actitime.beans.RegistrationInfoBean" scope="session"/>
</logic:present>

<script type="text/javascript">
    var SupportPopupConstants = {};
    SupportPopupConstants.SUBMIT_QUESTION_FORM_ACTION_URL = '<html:rewrite page="/submitquestionform.do"/>';
    SupportPopupConstants.SUBMIT_FEATURE_FORM_ACTION_URL = '<html:rewrite page="/submitfeatureform.do"/>';
    SupportPopupConstants.SUBMIT_BUG_FORM_ACTION_URL = '<html:rewrite page="/submitbugform.do"/>';

    SupportPopupConstants.HMS_PWS_COMMUNICATION_ERROR_CODE = <%=AjaxActionErrorCodes.HMS_PWS_COMMUNICATION_ERROR_CODE%>;
    SupportPopupConstants.SUPPORT_FORM_VERIFICATION_ERROR_CODE = <%=AjaxActionErrorCodes.SUPPORT_FORM_VERIFICATION_ERROR_CODE%>;
</script>


<table class="dialog-header">
    <tr>
        <td class="lightBoxTitle">
            <bean:message key="support.submitQuestion.title"/>
        </td>
        <td class="close-button">
            <div id="supportPopupCloseButton" class="closeButton"></div>
        </td>
    </tr>
</table>
<div class="innerContent">

    <div id="<%=id%>_progressSuccessContainer" class="progressOrSuccess">
        <div class="delimiter"></div>
        <div class="progressOrSuccessContent">
            <div id="<%=id%>_progress" class="progress">
                <at:img page="support/process-icon.png"/>
                <div class="processing"><bean:message key="support.progress.form_submit_msg"/></div>
            </div>

            <div id="<%=id%>_success" class="success">
                <at:defImg page="support/tick.png"/>
                <div class="successMessage"><bean:message key="support.submitQuestion.success_msg"/></div>
                <div class="answerInfo"><bean:message key="support.success.answer_info" arg0="<%=productName%>"/></div>
                <div class="sendAgain" id="<%=id%>_sendAgain"><bean:message key="support.submitQuestion.linkText"/></div>
            </div>
        </div>
        <div class="delimiter"></div>
    </div>

    <div id="<%=id%>_mainContent" class="mainContent">

        <form id="<%=id%>_supportForm" name="supportForm" action="" method="POST" enctype="multipart/form-data">

            <div class="noteContainer">
                <at:img page="note_mark.gif" styleClass="noteImage"/>
                <span class="notemsg"><bean:message key="support.note" arg0="<%=productName%>"/></span>
            </div>

            <div class="delimiter"></div>

            <div class="subHeader firstSubHeader"><bean:message key="support.submitQuestion.question"/></div>

            <div class="descriptionContainer">
                <textarea id="<%=id%>_description" name="description" cols="80" rows="8" class="text_area" tabindex="20"><%=prefilledText%></textarea>
                <% String descLengthId = id + "_descLength"; %>
                <jsp:include page="/textarea_length_note.jsp">
                    <jsp:param name="note_id" value="<%=descLengthId%>"/>
                    <jsp:param name="use_coloured_img" value="true"/>
                </jsp:include>
            </div>

            <div id="<%=id%>_uploadFilePlaceholder" style="display: none;">
                <table cellpadding="0" cellspacing="0" border="0">
                    <tr>
                        <td class="subHeader">
                            <bean:message key="support.reportBug.attach_screenshot"/>
                        </td>
                        <td class="uploadFileCell"></td>
                    </tr>
                </table>
            </div>

            <div class="subHeader contactInformationSubHeader"><bean:message key="support.contact_information"/></div>

            <table class="contactInformationTable" cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td class="leftContactInformationCell">
                        <input id="<%=id%>_firstName" name="firstName" value="<bean:write name="user" property="firstName" ignore="true"/>" type="text"
                               maxlength="32" placeholder="<bean:message key="user.first_name"/>" tabindex="22"/>
                    </td>
                    <td class="rightContactInformationCell">
                        <input id="<%=id%>_lastName" name="lastName" value="<bean:write name="user" property="lastName" ignore="true"/>" type="text"
                               maxlength="32" placeholder="<bean:message key="user.last_name"/>" tabindex="23">
                    </td>
                </tr>
                <tr>
                    <td class="leftContactInformationCell">
                        <input id="<%=id%>_emailAddress" name="email" type="text" maxlength="255" placeholder="<bean:message key="user.email_address"/>"
                               value="<bean:write name="user" property="email" ignore="true"/>" tabindex="24"/>
                    </td>
                    <td class="rightContactInformationCell">
                        <input id="<%=id%>_companyName" name="companyName" value="<bean:write name="registrationInfo" property="companyName" ignore="true"/>"
                               type="Text" maxlength="255" placeholder="<bean:message key="support.company_name"/>" tabindex="25"/>
                    </td>
                </tr>
            </table>

            <div class="delimiter"></div>

        </form>

    </div>

</div>

<div id="<%=id%>_footer">
    <div id="<%=id%>_clientSideErrorMessage" class="clientSideError" style="display: none;">
        <table cellpadding="0" cellspacing="0" border="0">
            <tr>
                <td class="errorImgCell">
                    <at:img page="error.gif"/>
                </td>
                <td class="errorMsgCell">
                    <span id="<%=id%>_errorMsgContainer" class="errormsg"></span>
                </td>
            </tr>
        </table>
    </div>

    <div class="buttonPane">
        <div id="<%=id%>_submitButton" class="greyButton"></div>
    </div>
</div>