<%@ page import="com.actimind.actitime.gettingstarted.GettingStartedShortcut" %>
<%@ page import="com.actimind.common.ATGlobals" %>
<%@ page import="com.actimind.actitime.gettingstarted.GettingStartedShortcutsManager" %>
<%@ page import="com.actimind.actitime.gettingstarted.GettingStartedHelper" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<%
    boolean isJustInitShortcuts = GettingStartedHelper.isJustInitShortcuts(session);
%>
<div id="gettingStartedShortcutsPanelId" class="gettingStartedShortcutsPanel noCloseable <%=isJustInitShortcuts ? "hidden" : ""%>">
    <div class="gettingStartedShortcutsLabel"><bean:message key="getting_started_shortcuts.label"/></div>
    <div id="gettingStartedShortcutsClose" class="gettingStartedShortcutsClose"></div>
    <div id="gettingStartedShortcutsMenuWrapper" class="gettingStartedShortcutsMenuWrapper">
        <div class="gettingStartedShortcutsMenu">
            <div class="gettingStartedShortcutsMenuHeader">
                <div id="gettingStartedShortcutsMenuCloseId" class="gettingStartedShortcutsMenuClose"></div>
                <div class="gettingStartedShortcutsMenuHeaderText"><bean:message key="getting_started_shortcuts.menu.header"/></div>
            </div>
            <div class="gettingStartedShortcutsMenuLinks">
                <div id="gettingStartedShortcutLink_<%=GettingStartedShortcut.FEATURES%>" class="gettingStartedShortcutsMenuLink"><bean:message key="getting_started_shortcuts.link.features"/></div>
                <div id="gettingStartedShortcutLink_<%=GettingStartedShortcut.SETTINGS%>" class="gettingStartedShortcutsMenuLink"><bean:message key="getting_started_shortcuts.link.settings"/></div>
                <div id="gettingStartedShortcutLink_<%=GettingStartedShortcut.TASKS%>" class="gettingStartedShortcutsMenuLink"><bean:message key="getting_started_shortcuts.link.import_tasks"/></div>
                <div id="gettingStartedShortcutLink_<%=GettingStartedShortcut.USERS%>" class="gettingStartedShortcutsMenuLink">
                    <%if(ATGlobals.isOl()) {%>
                    <bean:message key="getting_started_shortcuts.link.invite_team"/>
                    <%} else {%>
                    <bean:message key="getting_started_shortcuts.link.add_users"/>
                    <%}%>
                </div>
            </div>
            <jsp:include page="request_phone_call_section.jsp">
                <jsp:param name="blockIdSuffix" value="_gettingStarted"/>
            </jsp:include>
        </div>
        <div class="gettingStartedShortcutsMenuBottom"></div>
    </div>
</div>

<%--Do not move this script to minify, because it used only for one user in system.--%>
<at:script page="/js/support/GettingStartedShortcuts.js"/>

<script type="text/javascript">

    var GettingStartedShortcut = {};
    <%for(GettingStartedShortcut shortcut : GettingStartedShortcut.values()){%>
    GettingStartedShortcut['<%=shortcut%>'] = {};
    GettingStartedShortcut['<%=shortcut%>'].type = '<%=shortcut%>';
    GettingStartedShortcut['<%=shortcut%>'].url = '<html:rewrite action="<%=shortcut.getActionUrl()%>"/>';
    <%}%>

    var checkedShortcuts = {};
    // fill js object from java object
    <%for(GettingStartedShortcut checkedShortcut : GettingStartedShortcutsManager.getCheckedShortcuts(session)){%>
    checkedShortcuts['<%=checkedShortcut%>'] = true;
    <%}%>

    <%GettingStartedShortcut justCheckedShortcut = GettingStartedHelper.getJustCheckedShortcutIfExists(session);%>

    var initFunction = function()
    {
        var contBlock = new SubmitContactBlock();
        contBlock.init("_gettingStarted", true, true);
        contBlock.onBlockHighlightChanged = function(isOn) {$(".gettingStartedShortcutsMenuBottom").toggleClass("blockHighlighted", isOn);};

        var gettingStartedShortcutsPanel = new GettingStartedShortcuts(checkedShortcuts);
        window.gettingStartedShortcutsPanel = gettingStartedShortcutsPanel; // set getting shortcuts panel into global variables
        <%if(isJustInitShortcuts) {%>
        var afterInitShowing = function()
        {
            setTimeout(
                    function()
                    {
                        gettingStartedShortcutsPanel.showPanelAfterInit();
                    },
                    500
            );
        };
        if (isIE8())
        {
            afterInitShowing();
        }
        else
        {
            $(document).on("ready", function()
            {
                afterInitShowing();
            });
        }
        <%} else if(justCheckedShortcut != null){%>
        // if there is just checked shortcut in session - mark it
        gettingStartedShortcutsPanel.showMenuWithMarkCheckedShortcut('<%=justCheckedShortcut%>');
        <%} else {%>
        // show menu if it will be open on previous page
        gettingStartedShortcutsPanel.showMenuIfNeed();
        // check if there is not showed but checked before reload page shortcut
        GettingStartedShortcuts.showJustCheckedShortcutIfExists();
        <%}%>
    };

    if (isIE8())
    {
        $(document).on("ready", initFunction);
    }
    else
    {
        initFunction();
    }
</script>