<%
    ResponseUtil.sendCompatibilityHeaders( response );
%>
<!DOCTYPE html>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<%@ page import="com.actimind.actitime.colors.ColorHelper" %>
<%@ page import="com.actimind.actitime.util.ResponseUtil" %>
<%@ page import="com.actimind.common.ProductWebSiteURLs" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.util.RequestUtil" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.actimind.common.licensing.LicenseKeyUtils" %>
<%@ page import="com.actimind.actitime.PackageInformationUtil" %>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>

<html style="height: 100%">
<head>
    <title><bean:message key="support.faq.title"/></title>
    <link rel="SHORTCUT ICON" href='<at:rewrite page="/favicon2.ico"/>'>
    <meta name="robots" content="noindex,nofollow"/>
    <at:style page="/support/css/support.css"/>
    <%--
        Functions from support_js are used in CrossDomainController and ProgramRegistrator
        JSON is used in ProgramRegistrator and SupportPageLoader.
        SupportPageLoader ---> SupportController ---> CrossDomainController
    --%>

    <bean:define id="product" name="<%= Keys.PRODUCT %>" type="com.actimind.common.Product"/>
    <%--<bean:define id="registrationInfo" name="<%=Keys.REGISTRATION_INFO_KEY%>" type="com.actimind.actitime.beans.RegistrationInfoBean" scope="session"/>--%>
    <script>
        var CrossDomainControllerConstants = {
            serviceURL: "<%=request.getScheme()%>://<%=ProductWebSiteURLs.get( product ).getWebSiteDomain()%>/support/requestControl15.php",
            workerFrameSrc: '<html:rewrite page="/support/controller/crossdomain_frame.jsp"/>'
        };
        var ProgramRegistratorConstants = {
            registrationServiceURL: "<%=request.getScheme()%>://<%=ProductWebSiteURLs.get( product ).getWebSiteDomain()%>/createRegistrationId15.php",
            workerFrameSrc: '<html:rewrite page="/support/controller/registration_frame.jsp"/>',
            <%--registrationId: <%= StringUtils.getJSStringValue(registrationInfo.getRegistrationId())%>--%>
        };
        var SupportPageLoaderConstants = {
            appURL: "<%=RequestUtil.getApplicationURL(request)%>",
            programEdition: "<%=URLEncoder.encode(LicenseKeyUtils.getFullEditionCodeStr( request ), "UTF-8")%>"
        };

    </script>

    <at:script page='/js/util/jsonrpc.min.js'/>
    <at:script page='/js/at_jsonrpc.js'/>
    <at:script page="/support/support.js"/>
    <at:script page="/support/controller/ProgramRegistrator.js"/>
    <at:script page="/support/controller/CrossDomainController.js"/>
    <at:script page="/support/controller/SupportController.js"/>
    <at:script page="/support/controller/SupportPageLoader.js"/>
</head>

<script type="text/javascript">

    // FAQ page URL
    var pageURL = "<%=request.getScheme()%>://<%=ProductWebSiteURLs.get( Product.actiTIME ).getWebSiteDomain()%>/support/faq/faq_20174.php";

    // Create "page loader"; variable must be named "controller"
    var controller = new SupportPageLoader(pageURL, "pageContainer", "documentContainer", "progressScreen", "failScreen");

    /**
     * Loads FAQ page
     */
    function loadPage(){

        controller.loadPage();
    }

</script>

<body style="margin: 0; padding: 0; height: 100%; font-size: 0;" onload="loadPage();">

<%-- Include fail screen --%>
<div id="failScreen" style="display:none; height: 100%;">
    <jsp:include page="/support/controller/fail.jsp">
        <jsp:param name="docNameKey" value="support.faq.name"/>
    </jsp:include>
</div>

<%-- Include progress screen --%>
<div id="progressScreen" style="display:none; height: 100%;">
    <jsp:include page="/support/controller/progress.jsp">
        <jsp:param name="docType" value="page"/>
    </jsp:include>
</div>

<table id="pageContainer" cellSpacing="0" cellPadding="0" border="0" style="width: 100%; height: 100%;">
    <tr>
        <td class="supportPageHeader">
            <at:img page="support/help_and_support.png" vspace="4" width="149" height="25" alt="" border="0"/>
        </td>
    </tr>
    <tr>
        <td height="100%">
            <%-- Document is appended here --%>
            <div id="documentContainer" style="width: 100%; height: 100%; background-color: #ffffff;"/>
        </td>
    </tr>
    <tr>
        <td style="height: 20px; background-color: <%=ColorHelper.getColor("helpandsupport.bg.color", request )%>; color: #ffffff; font-family: Arial, Helvetica; font-size: 8pt; padding-left: 16px; white-space: nowrap;">
            <bean:message key="support.document.copyright_info" arg0="<%= PackageInformationUtil.getDisplayedReleaseYear() %>"/></td>
    </tr>
</table>
</body>
</html>