<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="com.actimind.actitime.MailServerSettingsGlobalInstance" %>
<%@ page import="static com.actimind.actitime.util.Feature.BTY" %>
<%@ page import="static com.actimind.actitime.util.Feature.CLT" %>
<%@ page import="static com.actimind.actitime.util.Feature.LVT" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>

<%
        boolean isCanManageUsers = AuthController.getLoggedInUserWithAccessRights( request ).isCanManageUsersInProduct( Product.actiTIME );
        boolean areMailSettingsSpecified = MailServerSettingsGlobalInstance.getMailServerSettings().areMailSettingsSpecified();
%>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>

<div class='popup_menu_container'>
    <div class='popup_menu_button popup_menu_button_settings' onclick="PopupMenu.show(event, $('#popup_menu_settings'));">
        <div class='popup_menu_icon settings_icon'>
            <% if( !areMailSettingsSpecified ) { %>
            <div class='popup_menu_icon warning_icon' title='<%=filteredMessage(request, "password_recovery.notifications_not_configured")%>'></div>
            <% } %>
        </div>
        <div class='popup_menu_label'>
            <bean:message key="navigator.settings_menu_item"/>
            <div class='popup_menu_arrow'>&nbsp;</div>
        </div>
    </div>

    <div id='popup_menu_settings' class='popup_menu_body'>
        <div class="popup_beak"></div>
        <div class="popup_menu_content popup_menu_settings">
            <div class="popup_menu_ul">
                <div class="popup_menu_title">
                    <bean:message key="navigator.settings_menu_title"/>
                </div>
                <ul id="popup_menu_items_content" class="popup_menu_items">
                    <li class='popup_menu_separator'></li>

                    <li class='popup_menu_item' id="popup_menu_item_1"><html:link styleClass='item_link' action='/administration/features'>
                        <div class="item_title"><bean:message key="menu.settings.item.custom_features"/></div>
                        <div class="item_descr"><bean:message key="menu.settings.item.custom_features.descr"/></div>
                    </html:link></li>

                    <li class='popup_menu_separator'></li>

                    <li class='popup_menu_item' id="popup_menu_item_6">
                        <html:link styleClass='item_link' page='/administration/settings.do?noReload=false'>
                            <div class="item_title">
                                <% if (!areMailSettingsSpecified) { %>
                                <span class="errorMessageEmailSettings">
                                <at:defImg page="warning_red_mark.png" alt='' titleKey='password_recovery.notifications_not_configured'
                                           styleClass="icon_right"/>
                                    <span class="errorText"> <bean:message
                                            key="password_recovery.notifications_not_configured.configure_email.text"/>
                                    </span>
                                </span>
                                <% } %>
                                <bean:message key="menu.settings.item.general_settings"/>
                            </div>
                            <div class="item_descr"><bean:message key="menu.settings.item.general_settings.descr"/></div>
                        </html:link>
                    </li>

                    <li class='popup_menu_separator'></li>

                    <% if (FeaturesUtil.isAvailable(BTY)) {
                        boolean result = FeaturesUtil.isEnabled(BTY);
                    %>
                    <li class='popup_menu_item' id="popup_menu_item_2" style='<%=result ? "" : "display: none;"%> '><html:link
                            styleClass='item_link' action='/administration/btlist'><bean:message key="menu.settings.item.billing_types"/></html:link></li>
                    <% } %>

                    <% if (FeaturesUtil.isAvailable(CLT)) {
                        boolean result = FeaturesUtil.isEnabled(LVT);
                        boolean result1 = FeaturesUtil.isEnabled(CLT);
                    %>
                    <li class='popup_menu_item' id="popup_menu_item_3"
                        style='<%=result1 && result ? "" : "display: none;"%> '><html:link
                            styleClass='item_link' action='/administration/ltlist'><bean:message key="menu.settings.item.leave_types"/></html:link></li>
                    <% } %>

                    <li class='popup_menu_item' id="popup_menu_item_4"><html:link styleClass='item_link' action='/administration/workingdays'><bean:message
                            key="menu.settings.item.work_schedule"/></html:link></li>

                    <% if (FeaturesUtil.isAvailable(Feature.EMA) && isCanManageUsers) {%>
                    <li class='popup_menu_item' id="popup_menu_item_5"><html:link styleClass='item_link' action='/administration/notifications'><bean:message
                            key="menu.settings.item.notifications"/></html:link></li>
                    <% } %>

                    <li class='popup_menu_separator'></li>

                    <li class='popup_menu_item' id="popup_menu_item_7"><html:link styleClass='item_link' action='/administration/customization'><bean:message
                            key="menu.settings.item.logo_and_color_scheme"/></html:link></li>

                    <li class='popup_menu_item' id="popup_menu_item_8"><html:link styleClass='item_link' action='/administration/manage_licenses'><bean:message
                            key="menu.settings.item.licenses"/></html:link></li>
                </ul>
            </div>
        </div>
    </div>
</div>