<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="static com.actimind.actitime.util.Feature.EST" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="com.actimind.actitime.task.CreateTasksLightboxSettings" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ page import="com.actimind.actitime.services.BaseNewTasksService" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="html" uri="http://struts.apache.org/tags-html" %>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />

<%
    String customerId = request.getParameter( "customerId" );
    String projectId = request.getParameter( "projectId" );
    CreateTasksLightboxSettings userSettings = (CreateTasksLightboxSettings) request.getAttribute(Keys.CREATE_TASKS_POPUP_SETTINGS);

    boolean isOpenedFromOpenTasks = request.getParameter( "openedFromOpenTasks" ) != null;
%>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='createTasksPopup'/>
    <jsp:param name="innerJsp" value='/tasks/create_tasks_popup_content.jsp'/>
    <jsp:param name="additionalClasses" value='taskProjectOrCustomerLightbox lightboxWithWhiteContent scrollable'/>
</jsp:include>
<%
    boolean result = FeaturesUtil.isEnabled(EST);
%>

<script type="text/javascript">

    var createTasksPopup;

    function showCreateTasksPopup( serviceName, successTaskCreationCallback, userId, dayOnWeek )
    {
        var newTasksPopupData = <%=jsHelper.toJSON( request.getAttribute( Keys.CREATE_NEW_TASKS_POPUP_DATA_KEY ) )%>;
        var customers = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_LIST_KEY ) )%>.list;
        var projects = <%=jsHelper.toJSON( request.getAttribute( Keys.PROJECTS_LIST_KEY ) )%>.list;

        var billingTypes = newTasksPopupData.billingTypes ? newTasksPopupData.billingTypes.list : null;
        var defaultBillingTypeId = newTasksPopupData.defaultBillingTypeId;

        var corporateSchedule = <%=jsHelper.toJSON( settings.getDefaultWorkSchedule()) %>;
        var scheduleCalculator = new CorporateScheduleCalculator().init(invertedDaysDateMap, corporateSchedule);

        var tasksTableConstructionRow = document.getElementById("tasksTableConstructionRow");

        var weekStartDay = <%=settings.getWeekStartDay() - 1%>;
        var nonworkingDays = [<%=settings.getNonworkingDaysString( 0 )%>];

        var canAddTasksToUser = newTasksPopupData.canSubmitTimeTrack;
        var canManageCustomersProjects = newTasksPopupData.canManageCustomersProjects;

        var estEnabled = <%=String.valueOf( result )%>;

        var selectedCustomerId = <%=customerId%>;
        var selectedProjectId = <%=projectId%>;
        var selectedCustomerIdFromSettings = <%=userSettings.getLastCustomerId()%>;
        var selectedProjectIdFromSettings = <%=userSettings.getLastProjectId()%>;

        if (selectedCustomerId == null && CreateTasksPopup.isCustomerIdValid(customers, selectedCustomerIdFromSettings))
        {
            selectedCustomerId = selectedCustomerIdFromSettings;
            if (selectedProjectId == null && CreateTasksPopup.isProjectIdValid(projects, selectedProjectIdFromSettings))
            {
                selectedProjectId = selectedProjectIdFromSettings;
            }
        }

        var projectsWithTasksExist = newTasksPopupData.projectsWithTasksExist;

        var isOpenedFromOpenTasks = <%=String.valueOf( isOpenedFromOpenTasks )%>;

        createTasksPopup = new CreateTasksPopup();
        createTasksPopup.init( serviceName, customers, projects, billingTypes, defaultBillingTypeId, canManageCustomersProjects,
                               canAddTasksToUser, weekStartDay, scheduleCalculator, estEnabled, projectsWithTasksExist,
                               isOpenedFromOpenTasks, selectedCustomerId, selectedProjectId,
                               successTaskCreationCallback, userId, dayOnWeek ).show();
    }

    var CREATE_TASKS_CONSTANTS = {};
    CREATE_TASKS_CONSTANTS.SELECT_CUSTOMER_OPTION_INDEX = <%=BaseNewTasksService.CUSTOMER_NOT_SELECTED%>;
    CREATE_TASKS_CONSTANTS.NEW_CUSTOMER_OPTION_INDEX = <%=BaseNewTasksService.NEW_CUSTOMER%>;
    CREATE_TASKS_CONSTANTS.ALL_ACTIVE_CUSTOMERS_OPTION_INDEX = <%=BaseNewTasksService.ALL_ACTIVE_CUSTOMERS%>;

    CREATE_TASKS_CONSTANTS.SELECT_PROJECT_OPTION_INDEX = <%=BaseNewTasksService.PROJECT_NOT_SELECTED%>;
    CREATE_TASKS_CONSTANTS.NEW_PROJECT_OPTION_INDEX = <%=BaseNewTasksService.NEW_PROJECT%>;
    CREATE_TASKS_CONSTANTS.ALL_ACTIVE_PROJECTS_OPTION_INDEX = <%=BaseNewTasksService.ALL_ACTIVE_PROJECTS%>;
    CREATE_TASKS_CONSTANTS.SELECTED_PROJECTS_OPTION_INDEX = <%=BaseNewTasksService.SELECTED_PROJECTS%>;

    CREATE_TASKS_CONSTANTS.CUSTOMER_IS_NOT_EXIST_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.CUSTOMER_IS_NOT_EXIST_ERR%>;
    CREATE_TASKS_CONSTANTS.CUSTOMER_EXISTS_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.CUSTOMER_EXISTS_ERR%>;
    CREATE_TASKS_CONSTANTS.CUSTOMER_IS_ARCHIVED_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.CUSTOMER_IS_ARCHIVED_ERR%>;
    CREATE_TASKS_CONSTANTS.NO_ACTIVE_CUSTOMERS_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.NO_ACTIVE_CUSTOMERS_ERR%>;

    CREATE_TASKS_CONSTANTS.PROJECT_IS_NOT_EXIST_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.PROJECT_IS_NOT_EXIST_ERR%>;
    CREATE_TASKS_CONSTANTS.PROJECT_EXISTS_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.PROJECT_EXISTS_ERR%>;
    CREATE_TASKS_CONSTANTS.PROJECT_IS_ARCHIVED_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.PROJECT_IS_ARCHIVED_ERR%>;
    CREATE_TASKS_CONSTANTS.NO_ACTIVE_PROJECTS_ERROR = <%=BaseNewTasksService.BaseNewTasksInvocationResult.NO_ACTIVE_PROJECTS_ERR%>;

</script>