<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="com.actimind.actitime.beans.UserBean" %>
<%@ page import="com.actimind.actitime.util.NameUtil" %>

<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>

<% String id = request.getParameter("id"); %>

<table class="dialog-header">
    <tr>
        <td>
            <div class="close-button">
                <div id="closeCreateTasksPopupButton" class="closeButton"></div>
                <div class="disabledCloseButton"></div>
            </div>

            <div class="lightBoxTitle">
                <bean:message key="add_new_tasks.title"/>
            </div>
        </td>
    </tr>
</table>
<div class="innerContent">

    <div id="<%=id%>_selectCustomerAndProject" class="selectCustomerAndProject">
        <div class="selectCPTitle"><bean:message key="add_new_tasks.select_customer_and_project"/></div>

        <table cellpadding=0 cellspacing=0>
            <tr class="selectCustomerRow">
                <td>
                    <div id="<%=id%>_customerSelector" class="customerOrProjectSelector selectorWithPlaceholderContainer"></div>
                </td>
                <td class="selectCustomerErrorCell">
                    <div class="errorMsg"><bean:message key="add_new_tasks.err.customerid_not_selected"/></div>
                    <div class="warningMsg"><bean:message key="add_new_tasks.no_active_customers"/></div>
                </td>
            </tr>
            <tr class="selectCustomerRow">
                <td>
                    <input id="<%=id%>_newCustomer" class="newCustomerProjectField inputFieldWithPlaceholder" maxlength="191"
                           placeholder='<bean:message key="add_new_tasks.new_customer_name.placeholder"/>'/>
                </td>
                <td class="newCustomerErrorCell">
                    <div class="errorMsg emptyName"><bean:message key="add_new_tasks.err_customer_name_empty"/></div>
                    <div class="errorMsg alreadyExist"><bean:message key="add_new_tasks.err_customer_exists"/></div>
                </td>
            </tr>
            <tr class="selectProjectRow projectSelectorRow">
                <td>
                    <div id="<%=id%>_projectSelector" class="customerOrProjectSelector selectorWithPlaceholderContainer"></div>
                </td>
                <td class="selectProjectErrorCell">
                    <div class="errorMsg"><bean:message key="add_new_tasks.err.projectid_not_selected"/></div>
                    <div class="warningMsg"><bean:message key="add_new_tasks.no_active_projects"/></div>
                </td>
            </tr>
            <tr class="selectProjectRow">
                <td>
                    <input id="<%=id%>_newProject" class="newCustomerProjectField inputFieldWithPlaceholder" maxlength="191"
                           placeholder='<bean:message key="add_new_tasks.new_project_name.placeholder"/>'/>
                </td>
                <td class="newProjectErrorCell">
                    <div class="errorMsg emptyName"><bean:message key="add_new_tasks.err_project_name_empty"/></div>
                    <div class="errorMsg alreadyExist"><bean:message key="add_new_tasks.err_project_exists"/></div>
                </td>
            </tr>
            <tr class="selectProjectRow">
                <td>
                    <div id="<%=id%>_projectList" class="projectList"></div>
                </td>
                <td class="emptyProjectListErrorCell">
                    <div class="errorMsg emptyProjectList"><bean:message key="add_new_tasks.err.select_one_or_more_project_names"/></div>
                </td>
            </tr>
        </table>

    </div>

    <jsp:include page="/tasks/create_tasks_table.jsp" />

</div>
<div id="<%=id%>_footer">
        <table cellpadding=0 cellspacing=0 border=0 style="width: 100%;">
            <tr>
                <td class="errorMessageBox">
                    <at:img page="error.gif"/>
                    <span class="errormsg"></span>
                </td>
                <td class="buttonsBox">
                    <span class="changesMsg"><bean:message key="add_new_tasks.not_saved"/></span>
                    <span class="savingMsg"><bean:message key="add_new_tasks.saving"/></span>
                    <div id="<%=id%>_commitBtn" class="greyButton withIcon commitBtn"><div class="buttonIcon"><span class="buttonTitle"></span></div></div>
                    <div id="<%=id%>_cancelBtn" class="greyButton cancelBtn"><bean:message key="common.cancel"/></div>
                </td>
            </tr>
        </table>
    </div>

<div id="<%=id%>_estimateTooltip" style="display: none; width: 220px;">
    <bean:message key="add_new_tasks.estimate_tooltip_info"/>
</div>

<div id="<%=id%>_addToTTTooltip" style="display: none; width: 220px;">
    <bean:message key="add_new_tasks.add_task_to_enter_tt_note.me"/>
</div>

<jsp:include page="importTasksTooltip.jsp">
    <jsp:param name="id" value="<%=id%>"/>
</jsp:include>

<% UserBean user = AuthController.getLoggedInUser( request );
   String buttonId = "#" + id + "_importTasks";
   String scrollableId = "#" + id + " .content .innerContent"; %>
<script>
    function onTasksChosen( taskIds, needDescription, customerId, projectId, isInActiveProjects )
    {
        createTasksPopup.createTasksComponent.importTasksRequest( taskIds, needDescription, customerId, projectId, isInActiveProjects );
    }
</script>
<jsp:include page="/user/add_tasks/task_select_control_import.jsp">
    <jsp:param name="id" value="taskSelectControl"/>
    <jsp:param name="outerButton" value="<%= buttonId %>"/>
    <jsp:param name="scrollableContainer" value="<%= scrollableId %>"/>
    <jsp:param name="selectedUserId" value="<%=user.getId()%>"/>
    <jsp:param name="selectedUserName" value="<%=user.getFormattedName( NameUtil.Format.FML )%>"/>
    <jsp:param name="onTasksChosen" value="onTasksChosen"/>
</jsp:include>
