<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.task.TimeCommentsRecordSortOrder" %>
<%@ page import="com.actimind.actitime.task.DeleteConfirmMsgUtils" %>
<%@ page import="com.actimind.actitime.services.EditTaskService" %>
<%@ page import="static com.actimind.actitime.util.Feature.EST" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ page import="static com.actimind.actitime.util.Feature.BTY" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld"%>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

<% if (!"true".equals(request.getParameter("fromTM"))) { %>
<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='editTaskPopup'/>
    <jsp:param name="additionalClasses" value='editTaskPopup taskProjectOrCustomerLightbox lightboxWithWhiteContent scrollable'/>
    <jsp:param name="innerJsp" value='/tasks/edit_task_popup_content.jsp'/>
</jsp:include>
<%}%>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" /><%
    boolean estEnabled = FeaturesUtil.isEnabled(EST);
    boolean btyEnabled = FeaturesUtil.isEnabled(BTY);
%>

<script type="text/javascript">

    EditTaskServiceHelper.ResultCodes = {
        success: <%=EditTaskService.EditTaskServiceInvocationResult.SUCCESS%>,
        taskNotExists: <%=EditTaskService.EditTaskServiceInvocationResult.TASK_NOT_EXISTS_ERR%>,
        billingTypeNotExists: <%=EditTaskService.EditTaskServiceInvocationResult.BILLING_TYPE_NOT_EXISTS_ERR%>,
        billingTypeIsArchived: <%=EditTaskService.EditTaskServiceInvocationResult.BILLING_TYPE_IS_ARCHIVED_ERR%>,
        projectNotExists: <%=EditTaskService.EditTaskServiceInvocationResult.PROJECT_IS_NOT_EXIST_ERR%>,
        projectIsArchived: <%=EditTaskService.EditTaskServiceInvocationResult.PROJECT_IS_ARCHIVED_ERR%>,
        projectNotAvailable: <%=EditTaskService.EditTaskServiceInvocationResult.PROJECT_IS_NOT_AVAILABLE_ERR%>,
        taskExists: <%=EditTaskService.EditTaskServiceInvocationResult.TASK_EXISTS_ERR%>,
        noRightsToReopenProject: <%=EditTaskService.EditTaskServiceInvocationResult.NO_RIGHTS_TO_REOPEN_PROJECT_ERR%>,
        billingTypeFeatureOff: <%=EditTaskService.EditTaskServiceInvocationResult.BILLING_TYPE_FEATURE_OFF%>,
        estimateFeatureOff: <%=EditTaskService.EditTaskServiceInvocationResult.ESTIMATE_FEATURE_OFF%>
    };

    function showEditTaskPopup( successTaskEditCallback, failureTaskEditCallback, taskDeleteCallback )
    {
        var estEnabled = <%=String.valueOf( estEnabled )%>;
        var sortConstants = {
            byDate: '<%=TimeCommentsRecordSortOrder.SORT_BY_DATE%>',
            byUser: '<%=TimeCommentsRecordSortOrder.SORT_BY_USERNAME%>',
            asc: '<%=TimeCommentsRecordSortOrder.SORT_ORDER_ASC%>',
            desc: '<%=TimeCommentsRecordSortOrder.SORT_ORDER_DESC%>'
        };

        var resultCodes = EditTaskServiceHelper.ResultCodes;

        var taskData = getEditTaskData();

        if ( !successTaskEditCallback )
            successTaskEditCallback = function() { window.location.reload(); };

        if ( !failureTaskEditCallback )
            failureTaskEditCallback = function() { window.location.reload(); };

        if ( !taskDeleteCallback )
            taskDeleteCallback = function() { window.location.reload(); };

        new EditTaskPopup().init( taskData.taskDetails, estEnabled, sortConstants, resultCodes, taskData.customers, taskData.projects,
                                  taskData.billingTypes, taskData.defaultBillingTypeId, taskData.weekStartDay, taskData.scheduleCalculator,
                                  successTaskEditCallback, failureTaskEditCallback, taskDeleteCallback ).show();
    }

    function getEditTaskData()
    {
        var editTaskPopupData = <%=jsHelper.toJSON( request.getAttribute( Keys.TASK_DETAILS_DATA_KEY ) )%>;

        var customers = <%=jsHelper.toJSON( request.getAttribute( Keys.CUSTOMERS_LIST_KEY ) )%>.list;
        var projects = <%=jsHelper.toJSON( request.getAttribute( Keys.PROJECTS_LIST_KEY ) )%>.list;

        var corporateSchedule = <%=jsHelper.toJSON( settings.getDefaultWorkSchedule()) %>;
        var scheduleCalculator = new CorporateScheduleCalculator().init(invertedDaysDateMap, corporateSchedule);
        return {
            canEdit: true,
            taskDetails: editTaskPopupData,
            customers: customers,
            projects: projects,
            billingTypes: editTaskPopupData.billingTypes ? editTaskPopupData.billingTypes.list : null,
            defaultBillingTypeId: editTaskPopupData.defaultBillingTypeId,
            corporateSchedule: corporateSchedule,
            scheduleCalculator: scheduleCalculator,
            weekStartDay: <%=settings.getWeekStartDay() - 1%>,
            btyEnabled: <%=String.valueOf( btyEnabled )%>
        }
    }

</script>