<script type="text/javascript">

    function EstimateSlider() {
        this.estimateSlider = $("#estimateSlider");
        this.estimateLeftSide = this.estimateSlider.find("#estimateLeftSide");
        this.estimateTopSide = this.estimateSlider.find("#estimateTopSide");
        this.estimateLeftMiddleSide = this.estimateSlider.find("#estimateLeftMiddleSide");
        this.estimateBottomSide = this.estimateSlider.find("#estimateBottomSide");
        this.estimateSliderValue = this.estimateSlider.find("#estimateSliderValue");
        this.overtimeSlide = this.estimateSlider.find("#overtimeSlide");
        this.noOvertimeSlide = this.estimateSlider.find("#noOvertimeSlide");
        this.estimateNoOvertimeLeft = this.estimateSlider.find("#estimateNoOvertimeLeft");
        this.estimateNoOvertimeRight = this.estimateSlider.find("#estimateNoOvertimeRight");
        this.estimateNoOvertimeLeftText = this.estimateSlider.find("#estimateNoOvertimeLeftText");
        this.estimateNoOvertimeRightText = this.estimateSlider.find("#estimateNoOvertimeRightText");

        this.formatter = new NumberFormatter(SystemSettings.decimalSeparator, SystemSettings.digitGroupingSymbol, 1, true, '', '%');

        return this;
    }

    EstimateSlider.prototype.update = function ( spentTime, estimatedTime, taskIsCompleted ) {
        var isOvertime = spentTime > estimatedTime;
        var zeroEstimate = ( estimatedTime == 0 );

        var completedZeroBudgetTask = taskIsCompleted && zeroEstimate;
        var percentage = zeroEstimate ? 0 : spentTime / estimatedTime * 100;

        var leftColumnWidth = isOvertime ? Math.round(estimatedTime / spentTime * 100) : percentage;

        if ( leftColumnWidth == 100 && estimatedTime != spentTime)
            leftColumnWidth = 99;

        var rightColumnWidth = 100 - leftColumnWidth;

        if ( isOvertime && !zeroEstimate )
            percentage -= 100;

        var percentageStr = this.formatter.format(percentage);

        if ( isOvertime ) {
            this.estimateLeftSide.toggleClass("noEstimate", zeroEstimate);
            this.setWidth(this.estimateLeftSide, leftColumnWidth);
            this.setWidth(this.estimateTopSide, rightColumnWidth);
            this.setWidth(this.estimateLeftMiddleSide, rightColumnWidth);
            this.setWidth(this.estimateBottomSide, rightColumnWidth);

            this.estimateSliderValue.text(percentageStr + " " + messageResource.getMessage("task.edit_popup.task_details.budget_exceeded"));
            this.overtimeSlide.show();
            this.noOvertimeSlide.hide();
        } else {
            this.estimateNoOvertimeLeft.toggleClass("noEstimate", zeroEstimate);

            this.setWidth(this.estimateNoOvertimeLeft, leftColumnWidth);
            this.setWidth(this.estimateNoOvertimeRight, rightColumnWidth);

            if ( percentage > 0) {
                this.setWidth(this.estimateNoOvertimeLeftText, leftColumnWidth);
                this.estimateNoOvertimeLeftText.text(percentageStr).show();
            } else {
                this.estimateNoOvertimeLeftText.hide();
            }

            this.setWidth(this.estimateNoOvertimeRightText, rightColumnWidth);
            if ( percentage == 0 && !completedZeroBudgetTask )
                this.estimateNoOvertimeRightText.text(percentageStr);

            this.overtimeSlide.hide();
            this.noOvertimeSlide.show();
        }

        this.estimateSlider.show();
    };

    EstimateSlider.prototype.setWidth = function ( element, width ) {
        if ( width > 0 )
            element.width(width).show();
        else
            element.hide();
    };

</script>

<div id="estimateSlider" class="estimateSlider">
    <div id="overtimeSlide">
        <div class="estimate_layer1">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tbody>
                    <tr>
                        <td id="estimateLeftSide" rowspan="3"></td>
                        <td id="estimateTopSide"></td>
                    </tr>
                    <tr>
                        <td id="estimateLeftMiddleSide"></td>
                    </tr>
                    <tr>
                        <td id="estimateBottomSide"></td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class="estimate_layer2">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tbody>
                    <tr>
                        <td id="estimateSliderValue" align="center" style="width:100%"></td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <div id="noOvertimeSlide">
        <div class="estimate_layer1">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tbody>
                    <tr>
                        <td id="estimateNoOvertimeLeft"></td>
                        <td id="estimateNoOvertimeRight"></td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class="estimate_layer2">
            <table border="0" cellpadding="0" cellspacing="0" width="100%">
                <tbody>
                    <tr>
                        <td id="estimateNoOvertimeLeftText" align="center"></td>
                        <td id="estimateNoOvertimeRightText"align="center"></td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</div>