<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.beans.UserBeanWithAccessRights" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>

<%--
 @param useArchived - if true, then 'Show all customers & projects' radio and 'Show archived' checkbox will be shown
 @param useCompletionDateRange - if true, then 'Completion date' selectors will be shown
 @param filterWidth - filter table width. It is value of 'width' attribute. Default - 100%.
 @param formName - name of the action form
--%>
<%
    String formName = request.getParameter("formName");
    boolean useArchived = Boolean.parseBoolean(request.getParameter("useArchived"));

    UserBeanWithAccessRights pageOwner = (UserBeanWithAccessRights) request.getAttribute(Keys.USER_KEY);
    int pageOwnerId = 0;
    boolean hasPageOwnerAccessToAllProjects = false;
    if (pageOwner != null)
    {
        pageOwnerId = pageOwner.getId();
        hasPageOwnerAccessToAllProjects = pageOwner.isHasAccessToAllProjects(FeaturesUtil.getFeatures().isEnabled(Feature.PAS ) );
    }
%>
<bean:define id="form" name="<%=formName%>" scope="session" type="com.actimind.actitime.CustomerProjectSelectorForm"/>

<at:script page='/js/hourglass_on_submit.js'/>

<script language="JavaScript">
    /**
     * Form submit handler for the task filter.
     * This function should be called from the form onsubmit handler.
     * @return false if the submit should be cancelled.
     */
    function taskFilterOnFormSubmit()
    {
        // TODO: this is a rather obscure design. We could somehow improve it. For example, embed the form into this JSP.
        // (kostenko)

        <logic:equal value="true" parameter="useCompletionDateRange" scope="request">
        // parse completion dates and fill hidden fields.
        process_completionDateTo();
        process_completionDateFrom();
        </logic:equal>

        // Workaround for bug# 23223.
        // We call this before proceeding with submit, because in IE the textbox "onchange" event will not be fired on
        // 'Enter' keypress, so the entered data will be lost.
        updateWordFilterStringHidden();
        if (CPSelectorServerUtil.checkCustomersProjectsSelected(window.customerProjectSelector))
        {
            CPSelectorServerUtil.setCpSelectorParameters(document.getElementById("filterForm"), window.customerProjectSelector);
            showHourglassCursorForSubmit([document.body, document.getElementById("tasksFilterSubmitButton")]);
            return true;
        }
        else
        {
            return false;
        }
    }

    function onTaskFilterDataChange()
    {
        updateWordFilterStringHidden();
    }

    function onCPSelectorChange()
    {
        if (window.customerProjectSelector.isStateChanged())
        {
            displayFilterNotAppliedNote();
        }
    }

    function onCompletionDateChange()
    {
        displayFilterNotAppliedNote();
    }

    function updateWordFilterStringHidden()
    {
        var hiddenField = document.getElementById('filterForm').wordFilterString;
        var visibleField = document.getElementById('filterForm').visiableFilterString;
                                
        if (hiddenField.value != visibleField.value)
        {
            hiddenField.value = visibleField.value;
            displayFilterNotAppliedNote();
        }
    }

    function displayFilterNotAppliedNote()
    {
        document.getElementById("filter-not-applied-note").style.visibility="visible";    
    }

    function adjustWordFilterWidth()
    {
        // We cannot use "width: 100%" because IE7 expands the text field not only to
        // the size of its container but to the size of the value string as well (and
        // the latter is unwanted).
        // We cannot use a fixed width also because we want the text field to occupy
        // all the available space.
        // So we have to expand the text field to the size of its container manually.
        document.getElementById('filterForm').visiableFilterString.value = document.getElementById('filterForm').wordFilterString.value;
    }    
</script>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />

<%
    String filterWidth = (request.getParameter("filterWidth") != null) ?
                       request.getParameter("filterWidth") : "100%";
%>

<style>
    .titlecell
    {
        text-align: right;
        vertical-align: top;
        padding-top: 3px;
    }
</style>

<table cellspacing="0" cellpadding="0" border="0" width="100%" class="formbuttonpane" >
<tr>
    <td>
        <table cellspacing="10" cellpadding="0" border="0" width="<%=filterWidth%>" >
        <tr>
            <td class="formblocktitle titlecell" nowrap="true">
                <bean:message key="projects_customers_selector.customers_and_projects"/>:
            </td>
            <td style="text-align: left; width: 100%; height: 26px;" colspan="2">
                <div id="cpSelectorButton"><!--Place for render customer-project selector button--></div>
            </td>
        </tr>
        <tr>
            <td class="formblocktitle titlecell">
                <bean:message key="task.list.tasks_filter"/>
            </td>
            <td valign="top" width="100%">
                <table cellspacing="0" cellpadding="0" border="0" width="100%" style="table-layout: fixed;">
                    <tr>
                        <td width="100%" id="wordFilterStringContainer">
                            <html:hidden property="wordFilterString" />
                            <input class="controlBorder" type="text" name="visiableFilterString" maxlength="80" onchange="onTaskFilterDataChange()" style="width:100%"/>
                            <%-- Note: the maxlength attribute should be the same as the TaskResource.WordFilterWordsCountLimit constant. --%>
                            <div class="noteContainer" style="margin-top: 6px;">
                                <at:img page="note_mark.gif" styleClass="noteImage"/>
                                <span class="notemsg"><bean:message key="task.list.task_filter_note"/></span>
                            </div>
                        </td>
                        <logic:equal value="true" parameter="useCompletionDateRange" scope="request">
                            <td valign="top" style="padding-left: 10px; width: 298px;">
                                <jsp:include page="/tasks/filter_calendar.jsp">
                                    <jsp:param name="onChangeHandler" value="onCompletionDateChange()"/>
                                    <jsp:param name="scheduleCalculatorVariableName" value='<%=request.getParameter("scheduleCalculatorVariableName")%>'/>
                                </jsp:include>
                            </td>
                        </logic:equal>
                    </tr>
                </table>
            </td>
            <td valign="top" align="right" style="width: 150px;">
                <html:submit property="searchTasks" styleId="tasksFilterSubmitButton"><bean:message key="task.list.filter.apply_filter"/></html:submit>
                <div class="modified-small" align="right" style="padding-top: 10px; padding-bottom: 0">&nbsp;<span id="filter-not-applied-note" style="visibility:hidden;"><bean:message key="common.filter_not_applied_caps"/></span></div>
            </td>
        </tr>
    </table>
    </td>
</tr>
</table>

<script type="text/javascript">
    setTimeout("adjustWordFilterWidth()",1);
    Ext.onReady(function()
                {
                    var panelCtrConfig = {collapsedCookiesKey: "<%=formName%>", resetOnHide: false};
                    var panelCtr;
                    var rpcManager;
                    if (<%=useArchived%>)
                    {
                        panelCtr = AT.CustomerProjectSelectorTwoGenericOptionsPanel;
                        rpcManager = new RetrieveAllCustomersProjectsRPCManager(true);
                    }
                    else
                    {
                        panelCtr = AT.CustomerProjectSelectorActiveOnlyPanel;
                        rpcManager = new RetrieveActiveCustomersProjectsRPCManager();
                    }
                    var button = CPSelectorServerUtil.createCPSelectorButton(panelCtr, rpcManager, null, panelCtrConfig);

                    window.customerProjectSelector = button.menu.getSelectorPanel();

                    button.setMenuHideCallback(onCPSelectorChange);
                    button.setPermitToShowCallback( closeAllPopups );
                });
</script>
