<%@ page import="com.actimind.actitime.task.Constants" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%--
  @author: kamenev
  Date: 6/29/12
  Time: 5:20 PM

  @param isDescriptionEditable      {Boolean} specifies whether task's description should be editable.
                                    [Optional] FALSE by default
  @param isTaskWithSubtasks         {Boolean} specifies whether task's description should be editable.
                                    [Optional] FALSE by default
  @param subTaskId                  {Integer} subtask's ID with which parent task's name is beening displayed.
                                    [Optional]
  @param isTaskWithParent           {Boolean} specifies whether task's description should be editable.
                                    [Optional] FALSE by default
  @param hierarchyLevelSuffix       {String} "task" or "subtask"
                                    [Required]
  @param allowToChangeOtherDescriptionImages if true, description images of one parent task synchronizes

--%>
<bean:define id="task" name="taskToDisplay" scope="request" type="com.actimind.actitime.beans.TaskBean"/>
<%
    boolean isDescriptionEditable = Boolean.parseBoolean( request.getParameter( "isDescriptionEditable" ) );
    boolean isParentTask = Boolean.parseBoolean( request.getParameter( "isTaskWithSubtasks" ) );
    boolean isSubTask = Boolean.parseBoolean( request.getParameter( "isTaskWithParent" ) );
    boolean isRegularTask = !isParentTask && !isSubTask;
    String hierarchyLevelSuffix = request.getParameter( "hierarchyLevelSuffix" );
    String subTaskId = request.getParameter( "subTaskId" );
    boolean allowToChangeOtherDescriptionImages = Boolean.parseBoolean(request.getParameter("allowToChangeOtherDescriptionImages"));
    String customClass = isParentTask ? "parent-task-name " : "";
    customClass += isSubTask ? "sub-task-name " : "";
    String domElementId =  isRegularTask ? "taskNameCell" + task.getId() :
                                           "taskNameDescription" + task.getId();
    if( isParentTask )
        domElementId += "_" + subTaskId;
    String imageDomElementId = domElementId + "_image_" + task.getId();

    String descriptionEntity = isSubTask ? "SUB_TASK_ENTITY" : "TASK_ENTITY";
%>
<script>
    var allowToChangeOtherDescriptionImages = <%=allowToChangeOtherDescriptionImages%>;
    var descriptionImageChangeCallback = (allowToChangeOtherDescriptionImages) ? document.changeImageCallback : undefined;
</script>

<tr><td style="border:none;" <%=(isRegularTask ? "" : "id=\"" + domElementId + "\"")%> class="<%=customClass%>"
    style="padding: 3px;"><div style="float:right;height:16px;"
     ><% if( isDescriptionEditable ){
        if (isParentTask) { %>
            <script>
                if (document.taskDescriptionIdMap)
                {
                    var parentTaskId = <%=task.getId()%>;
                    if (!document.taskDescriptionIdMap[parentTaskId])
                    {
                        document.taskDescriptionIdMap[parentTaskId] = new Array();
                    }
                    document.taskDescriptionIdMap[parentTaskId].push('<%=imageDomElementId%>');
                }

            </script>
        <% } %>
    <logic:equal value="false" name="task" property="descriptionEmpty"><a
                href="javascript:void(0)"
                onclick="if (closeAllPopups()) showSavingDescriptionWithDefaultOffset(<%=task.getId()%>, this, new DescriptionUtil(<%=descriptionEntity%>, TASK_ENTITY), document.getElementById('<%=domElementId%>'), undefined, undefined, undefined, descriptionImageChangeCallback)"
                title="<%=message(request, "task.edit.click_to_edit_description." + hierarchyLevelSuffix)%>"><at:img styleId="<%=imageDomElementId%>"
                page="dialogs/comments/comment_entered.png" width="16" height="16" border="0"/></a></logic:equal
        ><logic:equal value="true" name="task" property="descriptionEmpty"><a
                href="javascript:void(0)"
                onclick="if (closeAllPopups()) showSavingDescriptionWithDefaultOffset(<%=task.getId()%>, this, new DescriptionUtil(<%=descriptionEntity%>, TASK_ENTITY), document.getElementById('<%=domElementId%>'), undefined, undefined, undefined, descriptionImageChangeCallback)"
                title="<%=message(request, "task.edit.click_to_edit_description." + hierarchyLevelSuffix)%>"><at:img styleId="<%=imageDomElementId%>"
                page="dialogs/comments/comment_blank.png" width="16" height="16" border="0"/></a></logic:equal
        ><%
        } else { %><logic:equal value="false" name="task" property="descriptionEmpty"><a
                href="javascript:void(0)"
                onclick="if (closeAllPopups()) showDescriptionWithDefaultOffset(<%=task.getId()%>, this, new DescriptionUtil(<%=descriptionEntity%>, TASK_ENTITY), document.getElementById('<%=domElementId%>'))"
                title="<%=message(request, "task.edit.click_to_view_description." + hierarchyLevelSuffix)%>"><at:img
                page="dialogs/comments/view_comment.png" width="16" height="16" border="0"/></a></logic:equal
    ><% } %></div>
        <a href='javascript:void(0)' onclick="editTask(<%=task.getId()%>); return false;">
            <bean:write name="task" property="name"/>
        </a>
    </td>
</tr>