<!doctype html>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="com.actimind.actitime.util.jsHelper" %>
<%@ page import="com.actimind.actitime.beans.UserBeanWithAccessRights" %>
<%@ page import="com.actimind.common.AjaxActionErrorCodes" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessageNoFilterArgs" %>
<%@ page import="com.actimind.actitime.beans.UserAccessRightsBean" %>
<%@ page import="com.actimind.actitime.*" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="task.list.page.title"/></title>
    <%@include file="../css/scheme_styles.jsp" %>
    <jsp:include page="/include_scripts.jsp"/>
    <at:script page="/invertedDays.js" preserveSessionID="true"
               timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
    <%@include file="/js/util/server_date_time_utils_js.jsp" %>

    <%@ include file="/js/description_util_entities_init_js.jsp"%>
    <at:script page='/js/addNewTasks/CreateNewTasksComponent.js'/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>

    <%@ include file="/util/users_selector_js_imports.jsp"%>

</head>
<body class="task_list with-navigation navBottomSpaceHidden" topmargin="0" leftmargin="0" marginheight="0" marginwidth="0">
    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.TASKS_KEY%>"/>
        <jsp:param name="submenuSelected" value="<%=Navigator.TASKS_SUBMENU_KEY%>"/>
    </jsp:include>
    <div class='deleteTaskPopupContainer'></div>
    <jsp:include page="/edit_description_popup.jsp"/>

    <jsp:include page="/lightbox.jsp">
        <jsp:param name="id" value='loadTasksFromCSVPopup'/>
        <jsp:param name="innerJsp" value='/tasks/load_tasks_from_csv_popup_content.jsp'/>
        <jsp:param name="additionalClasses" value='lightboxWithWhiteContent noFooter'/>
    </jsp:include>

    <script type="text/javascript">
        <%UserBeanWithAccessRights manager = AuthController.getLoggedInUserWithAccessRights(request);%>
        <%UserAccessRightsBean managerRights = UserAccessRightsBean.getUserRights(request);%>
        
        PageOverlayTipsManager.setInstance(new TaskManagementPageOverlayTipsManager());

        $(function()
          {
              var cpData = <%=jsHelper.toJSON(request.getAttribute(Keys.CUSTOMERS_PROJECTS_DATA_KEY))%>;
              var corporateSchedule = <%=jsHelper.toJSON(settings.getDefaultWorkSchedule())%>;
              var canManageTasks = <%=managerRights.hasRight(com.actimind.actitime.AccessRight.MANAGE_TASKS)%>;
              var canManageCP = <%=managerRights.hasRight(AccessRight.MANAGE_CUSTOMERS_PROJECTS)%>;
              var canAccessCompleteTaskInformation = <%=request.getAttribute(Keys.CAN_ACCESS_COMPLETE_TASK_INFORMATION)%>;
              var pageSettings = <%=jsHelper.toJSON(request.getAttribute(Keys.TASKS_MANAGEMENT_PAGE_SETTINGS_KEY))%>;

              CorporateScheduleCalculator.instance = new CorporateScheduleCalculator().init(invertedDaysDateMap, corporateSchedule);
              var mediator = new TaskManagement.Mediator({
                                                             cpData: cpData,
                                                             pageSettings: pageSettings,
                                                             importCsv: {
                                                                 actionUrl: '<html:rewrite page="/csvImportTasks.do"/>',
                                                                 errorCodes: _.extend(AJAX_USER_ACTION_ERROR_CODES, {
                                                                     UNKNOWN_ENCODING: <%=AjaxActionErrorCodes.UNKNOWN_ENCODING%>,
                                                                     UNKNOWN_CSV_FORMAT: <%=AjaxActionErrorCodes.UNKNOWN_CSV_FORMAT%>,
                                                                     FILE_UPLOAD_ERROR: <%=AjaxActionErrorCodes.FILE_UPLOAD_ERROR%>
                                                                 }),
                                                                 errorMessages: _.extend(AJAX_USER_ACTION_ERROR_MESSAGES, {
                                                                     SESSION_EXPIRED: '<%=jsMessageNoFilterArgs(request, "error.js.json_rpc.session_expired")%>',
                                                                     NO_RIGHTS: '<%=jsMessageNoFilterArgs(request, "import_csv_tasks.error.no_rights")%>',
                                                                     UNKNOWN_ENCODING: '<%=jsMessageNoFilterArgs(request, "import_csv_tasks.error.incorrect_encoding")%>',
                                                                     UNKNOWN_CSV_FORMAT: '<%=jsMessageNoFilterArgs(request, "import_csv_tasks.error.incorrect_csv")%>',
                                                                     FILE_UPLOAD_ERROR: '<%=jsMessageNoFilterArgs(request, "import_csv_tasks.error.loading_failed")%>'
                                                                 })
                                                             },
                                                             managementSettings: {
                                                                 canManageTasks: canManageTasks,
                                                                 canManageCP: canManageCP,
                                                                 canAccessCompleteTaskInformation: canAccessCompleteTaskInformation
                                                             }
                                                         });
              TaskManagement.Store.setManagerNeedApproval(<%=manager.isRequiresTTApproval()%>);
              mediator.openTaskFromLink = _.once(function()
              {
                  <%String taskId = request.getParameter(Keys.TASK_ID_TO_SHOW);
                     if (taskId != null) {
                  %>
                     mediator.selectRowAndOpenTaskPanel(<%=Integer.parseInt(taskId)%>);
                  <% } %>
              });
              mediator.openPage();

//              TODO: remove after create tasks and create project popups deletion
              editDescriptionPopup.showAboveBasicPopups();
          });
    </script>

</body>
</html>
