<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%--
    Task search control.

    Requires: task_search_control.js

    Default styles: add_tasks.css

    @param id - HTML id that the control instance will be given. Must be unique on the page.
    @param selectedUserId - selected user id
    @param selectedUserName - display name of the selected user
    @param isOwnTimeTrack - whether it is logged in user's own time-track page (true/false)
    @param alreadyAddedTaskIds - ids of task which are already added to TT (in JS array presentation)
    @param onTaskChosen - name of the JS function(taskId) that will be called when the user selects a task
    @param isEnabled - whether the selector is enabled.
    @param spinnerPlaceholderId - id of the element in which to render spinner when doing an initial task list request
                                  (as opposed to the 'Show more' request)
--%>

<bean:parameter id="id" name="id"/>
<bean:parameter id="selectedUserId" name="selectedUserId"/>
<bean:parameter id="selectedUserName" name="selectedUserName"/>
<bean:parameter id="isOwnTimeTrack" name="isOwnTimeTrack"/>
<bean:parameter id="alreadyAddedTaskIds" name="alreadyAddedTaskIds"/>
<bean:parameter id="onTaskChosen" name="onTaskChosen"/>
<bean:parameter id="isEnabled" name="isEnabled"/>
<bean:parameter id="spinnerPlaceholderId" name="spinnerPlaceholderId"/>

<% boolean bIsEnabled = Boolean.valueOf( isEnabled ); %>

<table id="<%=id%>" class="taskSearchControl" style="border-collapse: collapse">
    <tr>
        <td style="padding: 0"><label for="<%=id%>_field"><at:img page='<%=(bIsEnabled ? "search_add.png" : "search_add_disabled.png")%>' style="display: block"/></label></td>
        <td style="padding: 0 0 0 9px">
            <input class="taskSearchField" type="text" id="<%=id%>_field" autocomplete="off" maxlength="80">
            <div class="taskList" style="display: none">
                <div class="noMatches">#</div>
                <div class="templates" style="display: none">
                    <div class="row task">
                        <span class="taskId" style="display: none">#</span>
                        <span class="taskName">#</span>
                        <span class="alreadyAdded" style="display: none"><bean:message key="submit_tt.task_search.already_added"/></span>
                        <br>
                        <span class="details">#</span>
                    </div>
                    <div class="row showMore last">
                        <div class="panelDiv">
                            <div class="resultsContainDiv">#</div>
                            <div class="showMoreLinkDiv">
                                <span class="showMoreLink"><bean:message key="submit_tt.task_search.show_more"/></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </td>
    </tr>
</table>

<script type="text/javascript">
    $( function()
    {
        //noinspection JSCheckFunctionSignatures
        initTaskSearchControl(
                "<%=id%>",
                <%=selectedUserId%>,
                "<%=StringUtils.getStringEscapedForJS(selectedUserName)%>",
                <%=isOwnTimeTrack%>,
                <%=alreadyAddedTaskIds%>,
                <%=onTaskChosen%>,
                "<%=spinnerPlaceholderId%>",
                <%=bIsEnabled%>
        );
    });
</script>