<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%--
    Task selector.

    Requires: task_select_control.js

    Default styles: add_tasks.css

    @param id - HTML id that the control instance will be given. Must be unique on the page.
    @param selectedUserId - selected user id
    @param selectedUserName - display name of the selected user
    @param isOwnTimeTrack - whether it is logged in user's own time-track page (true/false)
    @param alreadyAddedTaskIds - ids of task which are already added to TT (in JS array presentation)
    @param onTasksChosen - name of the JS function(taskIds) that will be called when user submits tasks to add
    @param isEnabled - whether the selector is enabled.
--%>

<bean:parameter id="id" name="id"/>
<bean:parameter id="selectedUserId" name="selectedUserId"/>
<bean:parameter id="selectedUserName" name="selectedUserName"/>
<bean:parameter id="isOwnTimeTrack" name="isOwnTimeTrack"/>
<bean:parameter id="alreadyAddedTaskIds" name="alreadyAddedTaskIds"/>
<bean:parameter id="onTasksChosen" name="onTasksChosen"/>
<bean:parameter id="isEnabled" name="isEnabled"/>

<% boolean bIsEnabled = Boolean.valueOf( isEnabled ); %>

<div id="<%=id%>">
    <div class="addTasksButton <%=(bIsEnabled ? "" : "disabled")%>">
        <span class="dashedLink <%=(bIsEnabled ? "" : "disabled")%>"><bean:message key="submit_tt.task_selector.button"/></span>
    </div>
    <div class="addTasksPanel hidden">
        <div style="margin-top: 5px; margin-bottom: 10px" class="label">
            <bean:message key="submit_tt.task_selector.select_customer_or_project"/>
        </div>
        <div>
            <jsp:include page="cp_selector_controller.jsp">
                <jsp:param name="styleClass" value="customerProjectSelector activeProjects"/>
            </jsp:include>
            <jsp:include page="cp_selector_controller.jsp">
                <jsp:param name="styleClass" value="customerProjectSelector archivedProjects"/>
            </jsp:include>
        </div>
        <div style="margin-top: 12px; margin-bottom: 8px">
            <table cellpadding="0" cellspacing="0" style="width: 100%">
                <tr>
                    <td style="white-space: nowrap" class="label">
                        <div class="selectTasksLabel">
                            <bean:message key="submit_tt.task_selector.select_tasks"/>
                        </div>
                        <div class="spinnerPlaceholder"></div>
                    </td>
                    <td style="width: 195px; text-align: right;">
                        <div style="position: relative">
                            <button class="selectorFilterButton" disabled></button>
                            <div class="filterPanel" style="display: none">
                                <input maxlength="191" class="filterField" type="text" autocomplete="off">
                                <button class="closeButton"></button>
                            </div>
                        </div>
                    </td>
                </tr>
            </table>
        </div>
        <div class="taskList" style="position: relative"><%--relative position is essential for correct autoscrolling inside--%>
            <div class="pleaseSelectCustomerOrProject">
                <table cellpadding="0" cellspacing="0" style="width: 100%">
                    <tr>
                        <td style="max-width: 100px">
                                <bean:message key="submit_tt.task_selector.to_view_tasks"/>
                        </td>
                    </tr>
                </table>
            </div>
            <div>
                <table cellpadding="0" cellspacing="0" style="width: 100%">
                    <tr>
                        <td class="noMatches" style="display: none; max-width: 100px">#</td>
                    </tr>
                </table>
            </div>
            <div class="templates" style="display: none">
                <div class="row task">
                    <table cellpadding="0" cellspacing="0">
                        <tr>
                            <td class="checkboxCol">
                                <input type="checkbox">
                            </td>
                            <td class="infoCol">
                                <span class="taskId" style="display: none">#</span>
                                <span class="taskName">#</span>
                                <span class="alreadyAdded" style="display: none"><bean:message key="submit_tt.task_search.already_added"/></span>
                                <br>
                                <span class="details">#</span>
                            </td>
                        </tr>
                    </table>
                </div>
                <div class="row showMore last">
                    <div class="panelDiv">
                        <div class="resultsContainDiv">#</div>
                        <div class="showMoreLinkDiv">
                            <span class="showMoreLink"><bean:message key="submit_tt.task_search.show_more"/></span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div style="text-align: center; margin-top: 13px; margin-bottom: 5px">
            <button class="addSelectedButton" disabled><bean:message key="submit_tt.task_selector.add_selected"/></button>
        </div>
    </div>
</div>
<% if( bIsEnabled ) {%>
    <script type="text/javascript">
        $( function()
        {
            //noinspection JSCheckFunctionSignatures
            initTaskSelectControl(
                    "<%=id%>",
                    "#<%=id%> .addTasksButton",
                    <%=selectedUserId%>,
                    "<%=StringUtils.getStringEscapedForJS(selectedUserName)%>",
                    <%=isOwnTimeTrack%>,
                    false,
                    <%=alreadyAddedTaskIds%>,
                    <%=onTasksChosen%> );
        });
    </script>
<% } %>
