<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%--
    Task selector.

    Requires: task_select_control.js

    Default styles: add_tasks.css

    @param id - HTML id that the control instance will be given. Must be unique on the page.
    @param outerButton - HTML element of the import button
    @param scrollableContainer - container in which this control located. Import popup hide when container is scrolling
    @param selectedUserId - selected user id
    @param selectedUserName - display name of the selected user
    @param onTasksChosen - name of the JS function(taskIds) that will be called when user submits tasks to add
--%>


<bean:parameter id="id" name="id"/>
<bean:parameter id="outerButton" name="outerButton"/>
<bean:parameter id="scrollableContainer" name="scrollableContainer"/>
<bean:parameter id="selectedUserId" name="selectedUserId"/>
<bean:parameter id="selectedUserName" name="selectedUserName"/>
<bean:parameter id="onTasksChosen" name="onTasksChosen"/>

<div id="<%=id%>">
    <div class="addTasksPanel taskImportPanel hidden">
            <div style="margin-top: 5px; margin-bottom: 10px" class="label">
                <span class="selectCustomerProjectLabel"><bean:message key="submit_tt.task_selector.select_customer_or_project"/></span>
                <span class="importArchivedLabel"></span>
                <input type="checkbox" id="importArchivedCheckbox"/>
            </div>
            <div>
                <jsp:include page="cp_selector_controller.jsp">
                    <jsp:param name="styleClass" value="customerProjectSelector activeProjects"/>
                </jsp:include>
                <jsp:include page="cp_selector_controller.jsp">
                    <jsp:param name="styleClass" value="customerProjectSelector archivedProjects"/>
                </jsp:include>
            </div>
            <div style="margin-top: 12px; margin-bottom: 8px">
                <table cellpadding="0" cellspacing="0" style="width: 100%">
                    <tr>
                        <td style="white-space: nowrap" class="label">
                            <div class="selectTasksLabel">
                                <bean:message key="submit_tt.task_selector.select_tasks"/>
                            </div>
                            <div class="spinnerPlaceholder"></div>
                        </td>
                        <td  style="width: 195px; text-align: right;">
                            <div class="buttonWrapper panelButton">
                                <div class="selectorButton selectAllButton"></div>
                            </div>
                            <div class="vertical_separator"></div>
                            <div class="buttonWrapper panelButton">
                                <div class="selectorButton unselectAllButton"></div>
                            </div>
                            <div class="vertical_separator"></div>
                            <div class="buttonWrapper" style="position: relative">
                                <button class="selectorFilterButton"  onclick="return false;" disabled></button>
                                <div class="filterPanel" style="display: none">
                                    <input maxlength="191" class="filterField" type="text" autocomplete="off">
                                    <button class="closeButton" onclick="return false;"></button>
                                </div>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="taskList" style="position: relative"><%--relative position is essential for correct autoscrolling inside--%>
                <div class="pleaseSelectCustomerOrProject">
                    <bean:message key="submit_tt.task_selector.to_view_tasks"/>
                </div>
                <div>
                    <table cellpadding="0" cellspacing="0" style="width: 100%">
                        <tr>
                            <td class="noMatches" style="display: none; max-width: 100px">#</td>
                        </tr>
                    </table>
                </div>
                <div class="templates" style="display: none">
                    <div class="row task">
                        <table cellpadding="0" cellspacing="0" style="width: 100%">
                            <tr>
                                <td class="checkboxCol">
                                    <input type="checkbox">
                                </td>
                                <td class="infoCol">
                                    <span class="taskId" style="display: none">#</span>
                                    <span class="taskName">#</span>
                                    <span class="alreadyAdded" style="display: none"><bean:message key="submit_tt.task_search.already_added"/></span>
                                    <br>
                                    <span class="details">#</span>
                                </td>
                            </tr>
                        </table>
                    </div>
                    <div class="row showMore last">
                        <div class="panelDiv">
                            <div class="resultsContainDiv">#</div>
                            <div class="showMoreLinkDiv">
                                <span class="showMoreLink"><bean:message key="submit_tt.task_search.show_more"/></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div style="margin-top: 12px">
                <table class="bottomTable"><tr>
                    <td class="checkboxTd"><input type="checkbox" id="importDescriptionsCheckbox"/></td>
                    <td><label for="importDescriptionsCheckbox" class="importDescriptionsLabel"><bean:message key="task_selector.import_descriptions"/></label></td>
                    <td>
                        <div class="greyButton withIcon importSelectedButton disabled">
                            <span class="buttonIcon">
                                <span class="buttonImportTitle"></span>
                            </span>
                        </div>
                    </td>
                </tr></table>
            </div>
    </div>
</div>
<script type="text/javascript">
    $( function()
    {
        //noinspection JSCheckFunctionSignatures
        initTaskSelectControl(
                "<%=id%>",
                "<%=outerButton%>",
                <%=selectedUserId%>,
                "<%=StringUtils.getStringEscapedForJS(selectedUserName)%>",
                true,
                true,
                [],
                <%=onTasksChosen%>,
                "<%=scrollableContainer%>" );
    });
</script>
