<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.user.SubmitTTForm" %>
<%@ page import="com.actimind.actitime.util.WorkingDaysUtils" %>
<%@ page import="com.actimind.actitime.util.StringUtils" %>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.common.licensing.LicenseHelper" %>
<%@ page import="com.actimind.actitime.user.SubmitTTWeekInfo" %>
<%@ page import="com.actimind.actitime.user.SubmitTTFormValidator" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />
<bean:define id="form" scope="request" name="SubmitTTForm" type="com.actimind.actitime.user.SubmitTTForm"/>
<bean:define id="user" name="<%=Keys.SUBMIT_TT_USER_KEY%>" type="com.actimind.actitime.beans.UserBean" scope="session"/>
<bean:define id="data" name="<%= Keys.SUBMIT_TT_DATA_KEY %>" type="com.actimind.actitime.user.SubmitTTData"/>

<%--
    The button control for displaying and editing leave info for a day.

    Requires: leave.js.

    @param dayOfWeek - day of week number that this button is associated with.
    @param onChangeHandler - name of the function that will be called when user changes information in the button.
                             This function should accept day of week number as a parameter.
    @param leaveError - specifies error string from constants SubmitTTForm.ERROR_*, not null, can be empty
--%>


<%
    String dayOfWeek = request.getParameter("dayOfWeek");
    int iDayOfWeek = Integer.parseInt(dayOfWeek);
    String idPrefix = "leaveButton_" + dayOfWeek + "_";
    String tableId = idPrefix + "table";
    String textElemId = idPrefix + "mainContentTd";
    String onChangeHandler = request.getParameter("onChangeHandler");
    String leaveError = request.getParameter("leaveError");

    SubmitTTWeekInfo weekInfo = data.getWeekInfo();

    String dayOfWeekName = message( request, WorkingDaysUtils.getPrintableDayOfWeek_FullNameKey( weekInfo.getWeekStartDay(), iDayOfWeek ) );

    String disabledReason = null;

    boolean isAPIntegrated = LicenseHelper.isOtherProductIntegrated(Product.actiTIME );

    boolean isDisabled;

    if (data.isDayBeforeHireDate(user, iDayOfWeek))
    {
        //if a day is before hire date will not show title with a reason
        isDisabled = true;
        disabledReason = "";
    }
    else
    {
        if( weekInfo.isFutureDay(iDayOfWeek) && isAPIntegrated && user.isActiveInAP() )
            disabledReason = message( request, "submit_tt.leave.button.tooltip.future_disabled" );
        else if( data.isDayLocked(iDayOfWeek) )
            disabledReason = message( request, "submit_tt.leave.button.tooltip.locked", dayOfWeekName );
        else if( data.isHoliday( iDayOfWeek ) )
            disabledReason = message( request, "submit_tt.leave.button.tooltip.holiday", dayOfWeekName );

        isDisabled = disabledReason != null;
    }
    boolean isNeedToResetLeaveType = SubmitTTFormValidator.ERROR_LEAVE_TYPE_NOT_AVAILABLE.equals(leaveError);
%>


<table id="<%=tableId%>" class="leaveButton" cellspacing="0" cellpadding="0"
       width="100%" height="33"
       onclick="<%="LeaveButtons.onClick(" + dayOfWeek + ")"%>"
       onmouseover="<%="LeaveButtons.onMouseOver(" + dayOfWeek + ")"%>"
       onmouseout="<%="LeaveButtons.onMouseOut(" + dayOfWeek + ")"%>">
   <tr>
       <td valign="middle">
           <div class="leaveButton_timeOffImg" id="leaveButton_timeOffImgDiv[<%=iDayOfWeek%>]" align="center" style="height: 17px;"><img src="<at:imgpath page="pixel.gif"/>"
                                     width="15px" height="15px" alt="" id="leaveButton_timeOffImg[<%=iDayOfWeek%>]"/></div>
           <div class="leaveButton_text" id="<%=textElemId%>"> </div>
       </td>
       <td class="leaveButton_arrowCell" align="left" valign="middle" width="6" style="padding-top:3px">
           <at:img styleClass="leaveButton_arrowBlack" page="dialogs/submit_tt/small_arrow.gif"/>
           <at:img styleClass="leaveButton_arrowGray" page="dialogs/submit_tt/small_arrow_gray.gif"/>
       </td>
   </tr>
</table>
<% if (!isDisabled) { %>
<%
    if (isNeedToResetLeaveType)
    {
%>
<input type="hidden"
       name='<%="leaves[" + dayOfWeek + "].leaveType"%>'
       id='<%="leaves[" + dayOfWeek + "].leaveType"%>'
       value="0"/>
<%
    }
       else
    {
%>
<html:hidden property='<%="leaves[" + dayOfWeek + "].leaveType"%>' name="form"
             styleId='<%="leaves[" + dayOfWeek + "].leaveType"%>'/>
<%
    }
%>
<html:hidden property='<%="leaves[" + dayOfWeek + "].duration"%>' name="form"
             styleId='<%="leaves[" + dayOfWeek + "].duration"%>'/>
<% } %>

<script type="text/javascript">

    LeaveButtons.addButton(new LeaveButton(<%=isNeedToResetLeaveType%>,
                                           <%=isNeedToResetLeaveType ? 0 : form.getLeaves()[iDayOfWeek].getLeaveType()%>,
                                           <%=isNeedToResetLeaveType ? 0 : form.getLeaves()[iDayOfWeek].getDuration()%>,
                                           <%=iDayOfWeek%>,
                                           "<%=dayOfWeekName%>",
                                           <%=weekInfo.isFutureDay(iDayOfWeek)%>,
                                           document.getElementById("<%=tableId%>"),
                                           document.getElementById("<%=textElemId%>"),
                                           document.getElementById("leaves[<%=iDayOfWeek%>].leaveType"),
                                           document.getElementById("leaves[<%=iDayOfWeek%>].duration"),
                                           document.getElementById("leaveButton_timeOffImgDiv[<%=iDayOfWeek%>]"),
                                           document.getElementById("leaveButton_timeOffImg[<%=iDayOfWeek%>]"),
                                           <%=onChangeHandler%>,
                                           <%=isDisabled%>,
                                           "<%=StringUtils.getStringEscapedForJS( disabledReason )%>",
                                           <%=data.isHoliday(iDayOfWeek)%>,
                                           <%=data.getMaxLeaveDurations()[iDayOfWeek]%>,
                                           <%=weekInfo.isToday(iDayOfWeek)%> )
    );

</script>



