<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.colors.ColorHelper" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>

<bean:define id="user" name="<%=Keys.SUBMIT_TT_USER_KEY%>" type="com.actimind.actitime.beans.UserBean" scope="session"/>

<%--
    Popup panel for editing day leave info.

    Requires: leave.js.
--%>

<%
    final String OK_BUTTON_TEXT = filteredMessage( request, "common.ok" );
    final String CANCEL_BUTTON_TEXT = filteredMessage( request, "common.cancel");
    final String HH_MM = filteredMessage( request, "common.hh_mm");
%>
<style type="text/css">
    tr#leaveRow2
	{
		padding-right:4px;
	}

    div.leaveTypeSelect {
        border-width: 2px;
        border-style: solid;
        border-color: <%= ColorHelper.getColor("leave.popup.bg.color", request ) %>;
    }

    input#LeaveTimeSpent
    {
        width: 58px;
        font-size: 9pt;
        font-family: Geneva, Arial, Helvetica, sans-serif;
        padding: 2px 2px 2px 2px;
        border: 1px solid <%=ColorHelper.getColor("submit_tt.input_tt.border", request )%>;
    }

    input#LeaveTimeSpent.placeholder { color: <%=ColorHelper.getColor("leave.popup.placeholder.color", request )%>; }
</style>

<div id="LeavePopup" class="leavePopup" style="display: none; z-index:1001;">
    <div class="leavePopupInnerDiv" width="100%">
        <form name="LeavePopupForm" onsubmit="LeavePopup.validateAndSave(); return false;">
            <table cellspacing="0" cellpadding="0" id="leavePopupTable">
                <tr>
                    <td>
                        <table class="text leavePopupTable" border=0 cellspacing="0" cellpadding="2" width="100%">
                            <tr>
                                <td class="popupTableRadioCell"><input type="radio" name="LeavePopupRadios" id="LeavePopupRadio_NoLeave" value="0"
                                        onclick="LeavePopup.onLeaveRadioButtonClick()"></td>
                                <td colspan="4">
                                    <label for="LeavePopupRadio_NoLeave" id="LeavePopupRadio_NoLeave_label"> </label>
                                </td>
                            </tr>

                            <tr><td height="1px" colspan="5"> </td></tr>

                            <tr id="leaveRow1">
                                <td class="popupTableRadioCell"><input type="radio" name="LeavePopupRadios" id="LeavePopupRadio_TimeOff" value="4"
                                           onclick="LeavePopup.onLeaveRadioButtonClick()"></td>
                                <td colspan="2">
                                    <label for="LeavePopupRadio_TimeOff" id="LeavePopupRadio_TimeOff_label">
                                        <bean:message key="submit_tt.leave.radio.time_off"/>
                                    </label>
                                </td>
                                <td align="center">(<%=HH_MM%>)</td>
                            </tr>
                            <tr id="leaveRow2">
                                <td> </td>
                                <td style="height:30px; width:144px;">
                                    <div class="leaveTypeSelect">
                                        <select name="LeaveTypeSelect" style="width:140px;"
                                                onfocus="LeavePopup.onTimeOffFieldFocus()"
                                                onchange="LeavePopup.onLeaveTypeChange()"
                                                >
                                        </select>
                                    </div>
                                </td>
                                <td style="padding: 0 2px;  width:15px;"><img src="<at:imgpath page="pixel.gif"/>" alt="" id="leaveTimeOffIcon" width="15" height="15"/></td>
                                <td align="center"><input name="LeaveTimeSpent" id="LeaveTimeSpent" type="text"
                                           onchange="LeavePopup.onTimeOffFieldChange()"
                                           onfocus="LeavePopup.onTimeOffFieldFocus()"
                                           size="6" maxlength="6" placeholder="<%=filteredMessage( request, "submit_tt.leave.whole_day")%>"></td>
                            </tr>
                            <tr>
                                <td colspan="5" style="padding:0 3px 0 0"><hr></td>
                            </tr>
                        </table>
                        <div id="leavePopupMessageBlockDiv" style="display:none">
                            <table class="text leavePopupMessageTable" cellspacing="0" cellpadding="0" width="100%">
                                <tr>
                                    <td align="center">
                                        <div id="leavePopupMessageTextDiv"> </div>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="5" style="padding-bottom: 5px;" ><hr></td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>

                <tr align="right">
                    <td style="padding: 1px 3px 0 3px;">
                        <input style="width: 60px" type="button" class="text" name="LeavePopupOK" onclick="LeavePopup.leavePopup.okClickHandler(this);" value="<%=OK_BUTTON_TEXT%>">
                        <span id="leavePopupCancelButtonSpan">
                            &nbsp;
                            <input style="width: 60px" type="button" class="text" name="LeavePopupCancel" onclick="LeavePopup.leavePopup.cancelClickHandler(this);" value="<%=CANCEL_BUTTON_TEXT%>">
                        </span>
                    </td>
                </tr>

                <tr>
                    <td style="padding-top:5px">
                        <table style="display:none; width: 263px;" id="LeavePopupErrorTable" border="0">
                            <tr>
                                <td valign="top">
                                    <at:img page="error.gif"/>
                                </td>
                                <td valign="top">
                                    <span id="LeavePopupErrorSpan" class="errormsg"></span>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        </form>
    </div>
</div>

<script type="text/javascript">
    var leavePopupRadiosLabels = [];

    for (var i = 0; i < 5; i++)
    {
        leavePopupRadiosLabels[i] = document.getElementById("LeavePopupRadios" + i + "_label")
    }

    disableTextSelection(document.getElementById("LeavePopupRadio_NoLeave_label"));
    disableTextSelection(document.getElementById("LeavePopupRadio_TimeOff_label"));

    var leaveDurationInput = document.LeavePopupForm.LeaveTimeSpent;
    $(leaveDurationInput).placeholder();

    LeavePopup.init( leaveDurationInput,
                    document.LeavePopupForm.LeaveTypeSelect,
                    document.getElementById("LeavePopupRadio_NoLeave"),
                    document.getElementById("LeavePopupRadio_TimeOff"),
                    document.getElementById("LeavePopupErrorTable"),
                    document.getElementById("LeavePopupErrorSpan"),
                    document.getElementById("LeavePopupRadio_NoLeave_label"),
            [
                document.getElementById("leaveRow1"),
                document.getElementById("leaveRow2")
            ],
                    document.getElementById("leaveTimeOffIcon"),

                    document.getElementById("leavePopupMessageBlockDiv"),
                    document.getElementById("leavePopupMessageTextDiv"),
                    document.getElementById("leavePopupCancelButtonSpan"),
                    277 );
</script>