<%@ page import="com.actimind.actitime.Keys"%>
<%@ page import="java.util.List"%>
<%@ page import="com.actimind.actitime.beans.LeaveTypeBean"%>
<%@ page import="com.actimind.actitime.util.StringUtils"%>
<%@ page import="com.actimind.actitime.administration.LeaveTypeIconHelper" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>


<script type="text/javascript">

/**
 * Initializes new {@link LeaveTypeBean} instance 
 * @param id
 * @param name of leave type
 * @param iconUrl is http url to the icon
 * @param iconBackgroundColor is background color (#XXXXXX)
 * @param isActive is true if leave type active else false.
 */
function LeaveTypeBean(id, name, iconUrl, iconBackgroundColor, isActive)
{
    this.id = id;
    this.name = name;
    this.iconUrl = iconUrl;
    this.iconBackgroundColor = iconBackgroundColor;
    this.isActive = isActive;
}

var LeaveTypesList = {};

/**
 * leaveTypes is array of LeaveTypeBean objects sorted in user specified order.
 */
LeaveTypesList.leaveTypes = [];

/**
 * leaveTypesIdMap is 'map' for projection ids of leave types to a {@link #leaveTypes} list index.
 */
LeaveTypesList.leaveTypesIdMap = {};

/**
 * Gets leave type by specified id from {@link #leaveTypes} array.
 *
 * @param id is leave type id
 * @return LeaveTypeBean object or undefined if nothing found.
 */
LeaveTypesList.getLeaveTypeById = function(id)
{
    return LeaveTypesList.leaveTypes[ LeaveTypesList.leaveTypesIdMap[ id ] ];
};

<%
    @SuppressWarnings( "unchecked" )
    List<LeaveTypeBean> leaveTypes = (List<LeaveTypeBean>)request.getAttribute(Keys.LEAVE_TYPE_LIST_KEY);

    if (leaveTypes != null)
    {
        for(LeaveTypeBean ltb: leaveTypes) {
%>
    LeaveTypesList.leaveTypesIdMap[<%=ltb.getId()%>] = LeaveTypesList.leaveTypes.length;
    LeaveTypesList.leaveTypes[LeaveTypesList.leaveTypes.length] =
      new LeaveTypeBean(<%=ltb.getId()%>,
                   '<%=StringUtils.getStringEscapedForJS(ltb.getName())%>',
                   '<at:imgpath page="<%=LeaveTypeIconHelper.getIconPath(ltb.getIconId())%>"/>',
                   '<%=LeaveTypeIconHelper.getIconBackgroundColor(ltb)%>',
                    <%=(ltb.isActive()?"true":"false")%>
              );
<%        
        }
    }
%>

</script>