<!doctype html>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.user.LockTTSettings" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page import="static com.actimind.actitime.util.Feature.UGR" %>
<%@ page import="static com.actimind.actitime.util.Feature.TZG" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>

<%@ page contentType="text/html;charset=UTF-8" language="java" %>


<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"/>
<bean:define id="userList" name="<%=Keys.USERS_LIST_KEY%>" type="java.util.List"/>
<bean:define id="timeZone" name="<%=Keys.USER_TIME_ZONE%>" scope="request" type="java.util.TimeZone"/>
<bean:define id="lockTTSettings" name="<%=Keys.LOCK_TT_SETTINGS%>" scope="request" type="com.actimind.actitime.user.LockTTSettings"/>
<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="lock_tt.page.title"/></title>
    <%@include file="../../css/scheme_styles.jsp" %>
    <jsp:include page="/include_scripts.jsp"/>

    <%-- Load users and groups to JS, for use in the users selector and in table rendering JS. --%>
    <%@ include file="/util/users_util.jsp" %>
    <jsp:include page="/util/user_groups.jsp"/>
    <jsp:include page="/util/time_zone_groups.jsp"/>

    <jsp:include page="/administration/editTaskFunction.jsp"/>

    <%-- scripts for dateRangeSelector --%>
    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
    <%@include file="/js/util/server_date_time_utils_js.jsp" %>

    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/single_date_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>
    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
    <%-- end of scripts for dateRangeSelector --%>
</head>

<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0" onunload="closeAllOpenedPopups();"
      class="lock_tt with-navigation">

<div id="container">

    <%-- Navigation --%>
    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.TT_KEY%>"/>
        <jsp:param name="submenuSelected" value="<%=Navigator.LOCK_TT_KEY%>"/>
    </jsp:include>

    <div id="pageContent"></div>

    <jsp:include page="/view_description_popup.jsp"/>

    <jsp:include page="/operation_confirm_dialog.jsp"/>

    <%-- Order of popup script definitions: dhtml_popup.js, titled_text_dhtml_popup.js --%>
    <%@ include file="/js/description_util_entities_init_js.jsp" %>
    <%@include file="/js/util/server_date_time_utils_js.jsp" %>

    <div id="form-field-tooltip" class="dhtml_title" style="display: none; z-index: 2002"></div>
    <div id="lockDayTitle" class="yellowTooltip" style="display: none;"></div>
</div>

<at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>

<script type="text/javascript">
    PageOverlayTipsManager.setInstance(new LockTTPageOverlayTipsManager());

    $(function()
      {
          <%
            printUserBeanListAsJSArray(out, userList, "usersForSelector");
            boolean isUGREnabled = FeaturesUtil.isEnabled(UGR);
            boolean isTZGEnabled = FeaturesUtil.isEnabled(TZG);
          %>
          new LockTTMediator().init({
                                        "dateRangeConfig": {
                                            "fromDate": Date.parseJSONDate("<%=TimeUtils.formatDate(lockTTSettings.getDateRangeFromDate(), TimeUtils.UNIFORM_DATE_FORMAT)%>"),
                                            "toDate": Date.parseJSONDate("<%=TimeUtils.formatDate(lockTTSettings.getDateRangeToDate(), TimeUtils.UNIFORM_DATE_FORMAT)%>"),
                                            "qualifier": _.invert(DateRangeStateUtil)["<%=lockTTSettings.getDateRangeState()%>"]
                                        },
                                        "userSelectorConfig": {
                                            "groupType": "<%=lockTTSettings.getGroupType().name()%>",
                                            "allUsers": <%=lockTTSettings.isAllUsers()%>,
                                            "showDisabled": <%=lockTTSettings.isShowDisabled()%>,
                                            "selectedGroups": <%=jsHelper.toJSON(lockTTSettings.getSelectedGroups())%>,
                                            "selectedUsers": <%=jsHelper.toJSON(lockTTSettings.getSelectedUsers())%>
                                        },
                                        "sortingOrder": "<%=lockTTSettings.getUserListSortConstant()%>",
                                        "selectionVeilImages": ['<at:imgpath page="/lock_tt/locking-animation/00.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/01.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/02.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/03.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/04.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/05.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/06.png"/>',
                                                                '<at:imgpath page="/lock_tt/locking-animation/07.png"/>'],
                                        "usersForSelector": usersForSelector,
                                        "timeZonesForSelector": timeZoneGroups,
                                        "usersGroupsForSelector": userGroups,
                                        "usersGroupFeature": <%=isUGREnabled%>,
                                        "timeZoneGroupFeature": <%=isTZGEnabled%>,
                                        "dateFormat": new DateFormat(TimeUtils.UNIFORM_DATE_FORMAT),
                                        "pagerConfig": {
                                            "recordsPerPage": <%=lockTTSettings.getRecordsPerPage()%>,
                                            "selectOptions": <%=jsHelper.toJSON(Pager.DEFAULT_PAGES)%>,
                                            "shownRecord": <%=lockTTSettings.getShownRecord()%>
                                        }
                                    });
      });
</script>

<script type="text/javascript">
    function gotoPrevWeek()
    {
        $(document).trigger("navigate.previous_week");
    }

    function gotoNextWeek()
    {
        $(document).trigger("navigate.next_week");
    }

    function lockSelectedDates(fromDate, toDate)
    {
        submitLockUnlockForm(fromDate, toDate, "<%=LockTTSettings.ACTION_LOCK%>", "<%=LockTTSettings.MODE_DATERANGE%>");
    }

    function unlockSelectedDates(fromDate, toDate)
    {
        submitLockUnlockForm(fromDate, toDate, "<%=LockTTSettings.ACTION_UNLOCK%>", "<%=LockTTSettings.MODE_DATERANGE%>");
    }

    function lockByRunner(fromDate, toDate)
    {
        submitLockUnlockForm(fromDate, toDate,
                             "<%=LockTTSettings.ACTION_LOCK%>", "<%=LockTTSettings.MODE_BY_RUNNER%>");
    }

    function unlockByRunner(fromDate, toDate)
    {
        submitLockUnlockForm(fromDate, toDate,
                             "<%=LockTTSettings.ACTION_UNLOCK%>", "<%=LockTTSettings.MODE_BY_RUNNER%>");
    }

    function submitLockUnlockForm(fromDate, toDate, action, mode)
    {
        var dateFormat = LockTTStore.getDateFormat();
        var params = {
            "lockUnlockFromDate": fromDate != null ? dateFormat.formatDate(fromDate) : null,
            "lockUnlockToDate": dateFormat.formatDate(toDate),
            "lockUnlockMode": mode,
            "pageAction": action
        };
        $(document).trigger("lock.submitted", params);
    }

    function changeSortingOrder(link)
    {
        $(document).trigger("order.changed", link.getAttribute("data-sortBy"));
    }

    function preloadLockTableImages()
    {
        var images = ['<at:imgpath page="/lock_tt/locking-animation/00.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/01.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/02.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/03.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/04.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/05.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/06.png"/>',
                      '<at:imgpath page="/lock_tt/locking-animation/07.png"/>',
                      '<at:imgpath page="/lock_tt/lock-icon.png"/>',
                      '<at:imgpath page="/lock_tt/unlock-icon.png"/>',
                      '<at:imgpath page="/lock_tt/veil.png"/>'];
        var preloader = new ImagePreloader(images);
    }
</script>

</body>
</html>
