<!doctype html>
<%@ page import="com.actimind.actitime.AuthController"%>
<%@ page import="com.actimind.actitime.Navigator"%>
<%@ page import="com.actimind.actitime.colors.ColorHelper,
                 com.actimind.actitime.resources.SystemSettings"%>
<%@ page import="com.actimind.actitime.user.*"%>
<%@ page import="com.actimind.common.Product" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>
<%@ page import="java.util.*"%>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.messageNoFilterArgs" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.filteredMessage" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="com.actimind.actitime.beans.*" %>
<%@ page import="com.actimind.actitime.services.EnterTTService" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.common.AjaxActionErrorCodes" %>
<%@ page import="com.actimind.common.licensing.LicenseHelper" %>
<%@ page import="com.actimind.common.ATGlobals" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>
<%@ page errorPage="/error.jsp" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>

<%@ include file="/cp_selector/cp_selector_params_generator.jsp" %>

<bean:define id="form" scope="request" name="SubmitTTForm" type="com.actimind.actitime.user.SubmitTTForm"/>
<bean:define id="data" name="<%= Keys.SUBMIT_TT_DATA_KEY %>" type="com.actimind.actitime.user.SubmitTTData"/>
<bean:define id="user" name="<%=Keys.SUBMIT_TT_USER_KEY%>" type="com.actimind.actitime.beans.UserBeanWithAccessRights" scope="session"/>
<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings" />
<bean:define id="loggedInUser" name="<%=Keys.LOGGEDIN_USER_KEY%>" type="com.actimind.actitime.beans.UserBean"/>

<%
    Features enabledFeatures = FeaturesUtil.getFeatures();

    boolean isOvertimeTrackingEnabled = enabledFeatures.isEnabled( Feature.OVR ) && user.isOvertimeTracking();

    boolean isWeekStatusIsPresent = enabledFeatures.isEnabled( Feature.TTA ) && form.getEffectiveWeekStatusName() != null;

    boolean projectAssignmentsFeatureEnabled = FeaturesUtil.getFeatures().isEnabled(Feature.PAS );

    UserBeanWithAccessRights loggedInUserWithRighs = com.actimind.actitime.AuthController.getLoggedInUserWithAccessRights( request );

    StringBuilder naOvertimeBeforeHireDateTooltip = new StringBuilder();
    StringBuilder naOvertimeAfterReleaseDateTooltip = new StringBuilder();
    StringBuilder naOvertimeInFutureTooltip = new StringBuilder();

    if (user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_TRUSTED)
    {
        String autocalculationIsDisabled =
                message(request, "submit_tt.autocalculation_is_disabled_for_this_day",
                        message( request, "overtime.overtime_lower_case" ));
        naOvertimeBeforeHireDateTooltip.append(autocalculationIsDisabled).append("\n");
        naOvertimeAfterReleaseDateTooltip.append(autocalculationIsDisabled).append("\n");
        naOvertimeInFutureTooltip.append(autocalculationIsDisabled).append(" ");
    }
    else
    {
        String notCalculated =
                message( request, "submit_tt.not_calculated_for_this_day",
                         message( request, "overtime.overtime" ));
        naOvertimeBeforeHireDateTooltip.append(notCalculated).append(" ");
        naOvertimeAfterReleaseDateTooltip.append(notCalculated).append(" ");
        naOvertimeInFutureTooltip.append(notCalculated).append(" ");
    }

    if (form.getUsersSelector().getSelectedUser() == UsersSelector.TT_LOGGED_IN_USER_SELECTED )
    {
        naOvertimeBeforeHireDateTooltip.append( message( request, "submit_tt.because_it_before_your_hire_date" ) );
        naOvertimeAfterReleaseDateTooltip.append( message( request, "submit_tt.because_it_after_your_release_date" ) );
    }
    else
    {
        String userName = user.getFormattedName( NameUtil.Format.FML );
        naOvertimeBeforeHireDateTooltip.append( messageNoFilterArgs( request, "submit_tt.because_it_before_hire_date_for", userName ) );
        naOvertimeAfterReleaseDateTooltip.append( messageNoFilterArgs( request, "submit_tt.because_it_after_release_date_for", userName ) );
    }

    naOvertimeInFutureTooltip.append(message( request, "submit_tt.because_it_in_future" ));

    if (user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_TRUSTED)
    {
        String autocalcPostfix = message( request, "submit_tt.auto-calculated_value_is_0" );
        naOvertimeBeforeHireDateTooltip.append("\n\n").append(autocalcPostfix);
        naOvertimeAfterReleaseDateTooltip.append("\n\n").append(autocalcPostfix);
        naOvertimeInFutureTooltip.append("\n\n").append(autocalcPostfix);
    }

    String hideAddRecentTaskSelector = user.isKeepAllTasksFromPreviousWeek() ? "hideAddRecentTaskSelector" : "";

    boolean isMyOwnTT = user.getId() == loggedInUser.getId();

    String weekStatusStyle = "";
    if( "NOT_READY".equals( form.getEffectiveWeekStatusName() ) )
        weekStatusStyle = "notReady";
    if( "READY".equals( form.getEffectiveWeekStatusName() ) )
        weekStatusStyle = "ready";
    if( "APPROVED".equals( form.getEffectiveWeekStatusName() ) )
        weekStatusStyle = "approved";
    if( "REJECTED".equals( form.getEffectiveWeekStatusName() ) )
        weekStatusStyle = "rejected";
    if( "AUTO_APPROVED".equals( form.getEffectiveWeekStatusName() ) )
        weekStatusStyle = "autoApproved";

    SubmitTTChanges ttChanges = data.getTTChanges();
    SubmitTTWeekInfo weekInfo = data.getWeekInfo();
    TimeZone selectedUserTimeZone = weekInfo.getTimeZone();
    long localTimeInMillis = TimeUtils.getLocalTimeInMillis(selectedUserTimeZone);

    boolean wholeWeekDisabled = data.isWholeWeekDisabled(user);
%>

<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="submit_tt.page.title"/></title>
    <%@include file="../css/scheme_styles.jsp"%>
    <jsp:include page="/include_scripts.jsp"/>

    <script language="JavaScript">
        // array of field-related errors
        var fieldErrors = {};
        // array of day-related errors
        var dayErrors = {};
        // array of current day changes
        var weekTTChanges = {};
        
        var readOnlyComments = {};

        <%
        SubmitTTFormValidator.ValidationResults validationErrors = (SubmitTTFormValidator.ValidationResults) session.getAttribute(SubmitTTFormValidator.VALIDATION_ERRORS_KEY);
        if(validationErrors == null) validationErrors = new SubmitTTFormValidator.ValidationResults();
        for (int taskId: form.getTimeTrackTaskIDs()){
            for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++)
            {
                if(validationErrors.getErrorForTTField(taskId, day) != null)
                {
        %>
                    fieldErrors["timeTrack[<%=taskId%>].spentStr[<%=day%>]"] = true;
        <%      }
                if(ttChanges.isTimeForTaskChangedWithinDay(taskId, day)){
        %>
                    weekTTChanges["timeTrack[<%=taskId%>].spentStr[<%=day%>]"] = true;
                    <%-- We also need to call registerModifiedTTField(), but we can't do this yet, since the field
                         doesn't exist yet. See below "Workaround for bug 23140". (kostenko) --%>
        <%      }
                if(isOvertimeTrackingEnabled && user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_TRUSTED
                    && ttChanges.isOvertimeChangedWithinDay(day) && !weekInfo.isFutureDayAndRestricted(day)) {
        %>
                    weekTTChanges["overtime[<%=day%>].overtimeStr"] = true;
        <%      }
            }
        }
        for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++) {
            if( ttChanges.isLeaveChangedWithinDay( day ) ) {
                %>weekTTChanges["leaveInfo_<%=day%>"] = true;<%  
            }
        } 
        %>

        <%
            boolean isAllTasksCompleted = data.isAllTasksCompleted();
            boolean [] disableOvertimeInputs = new boolean[7];
            for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++)
            {
                disableOvertimeInputs[day] = isAllTasksCompleted && form.getDayTotal(day, settings) == 0;
                if(validationErrors.getErrorForDay(day) != null)
                {
         %> dayErrors["<%=day%>"] = true;
         <%

                }
                if(validationErrors.getOvertimeError(day) != null)
                {
         %> fieldErrors["overtime[<%=day%>].overtimeStr"] = true;
         <%
                }
            }
         %>


        // array of task ids
        var taskIds = new Array();
        <logic:iterate id="task" name="data" property="tasks" type="com.actimind.actitime.user.SubmitTTTaskBean">
        taskIds[taskIds.length] = <%=task.getId()%>;
        </logic:iterate>


        var isHoursPerDayLimited  = <%=settings.isHoursPerDayLimited()%>;
        var maxMinutesPerDay      = <%=(settings.isHoursPerDayLimited() ? settings.getMaximumMinutesPerDay().toString() : "0")%>;
        var maxMinutesPerDayStr   = '<%=(settings.isHoursPerDayLimited() ? TimeUtils.formatWork(settings.getMaximumMinutesPerDay()) : "")%>';

        var calLayout = new Array(<%for(int i = 0; i < 7; i++) {%>"<%=jsMessage( request, WorkingDaysUtils.getPrintableDayOfWeek_FullNameKey(i, weekInfo.getWeekStartDay()))%>"<%if(i != 6) {%>,<%}}%>);

    </script>
    <%-- Order of popup script definitions: dhtml_popup.js, titled_text_dhtml_popup.js --%>
    <at:script page="/js/submit_tt.js"/>
    <at:script page='/js/overtime.js'/>
    <%@ include file="/js/description_util_entities_init_js.jsp"%>

    <at:script page="/invertedDays.js" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>

    <jsp:include page="/top.jsp" flush="false">
        <jsp:param name="menuSelected" value="<%=Navigator.TT_KEY%>"/>
        <jsp:param name="submenuSelected" value="<%=Navigator.SUBMIT_TT_KEY%>"/>
    </jsp:include>

    <%
        boolean hasSubmitOtherUserTTRight = SubmitTTAccessRightsUtils.hasSubmitOtherUserTTRight(request);
        boolean hasSubmitTTRight = SubmitTTAccessRightsUtils.hasSubmitMyTTRight( request );
        Integer selectedUserId = form.getUsersSelector().getSelectedUser();
        boolean isShowTTArea = (selectedUserId != UsersSelector.TT_OTHER_USER_NOT_SELECTED || selectedUserId == UsersSelector.TT_LOGGED_IN_USER_SELECTED && hasSubmitTTRight );
        boolean canManageTasks = SubmitTTAccessRightsUtils.hasManageTasksRight(request);
        boolean isOtherUserSelected = selectedUserId != UsersSelector.TT_LOGGED_IN_USER_SELECTED ;
        
        int visibleUserId = isOtherUserSelected ? selectedUserId : loggedInUser.getId();
        @SuppressWarnings( "unchecked" )
        List<UserBean> users = ( List<UserBean> ) request.getAttribute( Keys.USERS_LIST_KEY );

        List<Integer> addedTaskIds = new ArrayList<Integer>();
        List<SubmitTTTaskBean> tasks = data.getTasks();
        String noTasksClass = tasks.size() == 0 ? "noTasksOnTheWeek" : "";
        for( SubmitTTTaskBean task: tasks )
            addedTaskIds.add(task.getId());

        boolean isNoUsersToEnterTT = !hasSubmitTTRight && (users == null || users.size() == 0);
    %>

    <%if (hasSubmitOtherUserTTRight && FeaturesUtil.getFeatures().isEnabled(Feature.TZG)){%>
    <%@ include file="/util/time_zone_groups.jsp" %>
    <%}%>

    <script language="JavaScript">
    SubmitTTErrors.INCORRECT_OT_VALUE  = unescapeHtmlSymbols("<%=SubmitTTFormValidator.getInvalidOTValueErrorMessage(request, settings)%>");
    SubmitTTErrors.INCORRECT_TT_VALUE  = messageResource.getMessage("submit_tt.error_invalid_tt", [SystemSettings.decimalSeparator]);
    SubmitTTErrors.TOO_GREAT_OVERTIME  = messageResource.getMessage("submit_tt.error_too_great_overtime");

    SubmitTTConstants.thirdHierarchyLevelNameSingular =
        "<%=jsMessage(request, "common.task")%>";

    SubmitTTConstants.secondHierarchyLevelNameSingular =
        "<%=jsMessage(request, "common.project")%>";

    SubmitTTConstants.secondHierarchyLevelNamePlural =
        "<%=jsMessage(request, "common.projects")%>";

    SubmitTTConstants.thirdHierarchyLevelNamePlural =
        "<%=jsMessage(request, "common.tasks")%>";

    SubmitTTConstants.thirdHierarchyLevelNameSingularCapitalized =
        "<%=jsMessage(request, "common.Task")%>";

    SubmitTTConstants.TASK_LIST_ORDER_BY_TASK_NAME = <%=SubmitTTOrder.BY_TASK_NAME%>;
    SubmitTTConstants.TASK_LIST_ORDER_BY_PROJECT_NAME = <%=SubmitTTOrder.BY_PROJECT_NAME%>;
    SubmitTTConstants.TASK_LIST_ORDER_BY_CUSTOMER_NAME = <%=SubmitTTOrder.BY_CUSTOMER_NAME%>;

    SubmitTTConstants.WARNING_STATUS_HAS_ALREADY_BEEN_SET = <%=EnterTTService.ChangeWeekApprovalStatusResult.WARNING_STATUS_HAS_ALREADY_BEEN_SET%>;
    SubmitTTConstants.WARNING_STATUS_HAS_BEEN_CHANGED_CONCURRENTLY = <%=EnterTTService.ChangeWeekApprovalStatusResult.WARNING_STATUS_HAS_BEEN_CHANGED_CONCURRENTLY%>;
    SubmitTTConstants.WARNING_TTA_FEATURE_IS_DISABLED = <%=EnterTTService.ChangeWeekApprovalStatusResult.WARNING_TTA_FEATURE_IS_DISABLED%>;
    SubmitTTConstants.ENTER_TT_RELOAD_ACTION = '<%=SubmitTTForm.ENTER_TT_RELOAD_ACTION%>';

    function openAddNewTasksPopup()
    {
        var successTaskCreationCallback = function( result )
        {
            var createdTaskIds = result.createdTaskIdsList.list;
            var cannotAddTasksForOtherUserDisabledOrDeletedError = result.cannotAddTasksForOtherUserDisabledOrDeletedError;

            if (typeof window.disableWarningOnUnloadPage != typeof undefined)
                window.disableWarningOnUnloadPage();

            if (cannotAddTasksForOtherUserDisabledOrDeletedError)
            {
                document.location.href='<html:rewrite page="/user/submit_tt.do"/>';
            }
            else
            {
                if( !createdTaskIds )
                    createdTaskIds = [];

                document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.HIGHLIGHT_TASKS_ACTION %>';
                document.SubmitTTForm.addTaskList.value = createdTaskIds.join( "," );
                document.SubmitTTForm.submit();
            }
        };

        var userId = <%=user.getId()%>;
        var dayOnWeek = '<%=form.getDateStr()%>';
        loadPopupContent( '<html:rewrite page="/tasks/add_new_tasks_popup.do"/>',
                          function() { showCreateTasksPopup( "AddNewTasksService", successTaskCreationCallback, userId, dayOnWeek ); },
                          true,
                          function( status, responseText ) {
                              if ( status == <%=AjaxActionErrorCodes.CREATE_TASKS_NO_ASSIGNED_PROJECTS_ERROR_CODE%> ) {
                                  alert(messageResource.getMessage( "add_new_tasks.no_projects_assigned.error" ));
                                  window.location.reload();
                                  return true;
                              }
                              return false;
                          },
                          true );
    }

    function leavePageWithConfirm(url){
        if(checkModified())
        {
            showConfirmExitDlg();
            setRedirectUrl(url);
        }
        else
        {
            window.location.href = url;
            return false;
        }

    }

    function leavePageWithConfirmAndAnimation(url){
        if(!closeAllPopups())
            return;

        if(checkModified())
        {
            <% if (hasSubmitOtherUserTTRight) {%>
            setAnimatedHandlers();
            <% } %>
            showConfirmExitDlg();
            setRedirectUrl(url);
        }
        else
        {
        <% if (hasSubmitOtherUserTTRight) {%>
            usersSelector.leaveAndShowAnimationSpinner();
        <% } %>
            window.location.href = url;
        }

    }

    function selectDate(date, returnPreviousDateFunction)
    {
        <%
            String selectedUserParam = form.getUsersSelector().isOtherUserSelected() ?
                "?usersSelector.selectedUser=" + form.getUsersSelector().getSelectedUser() + "&" : "?";
        %>

        var isOtherUserSelected = <%=form.getUsersSelector().isOtherUserSelected()%>;
        var currentDate = isOtherUserSelected ? calculateLocalTime(<%=localTimeInMillis%>).clearTime() : currentUserTime().clearTime();
        
        var url = datesIsOnTheSameWeek(currentDate, date) ?
                    '<%=response.encodeURL( "submit_tt.do" + selectedUserParam )%>' :
                    '<%=response.encodeURL( "submit_tt.do" + selectedUserParam + "&dateStr=" )%>' + date.getFullYear() + leadZero(date.getMonth() + 1) + leadZero(date.getDate());

        if ( !leavePageWithConfirm(url) )
            returnPreviousDateFunction();
    }

    function exitHandlerFunc(){
        if ( editDescriptionState && editDescriptionState.isDescriptionModified() ) {
            return false;
        }
        
        return formModified || LeavePopup.isOpenedAndChanged();
    }

    /*
     * It is called when "Discard" button is pressed in "Modifications not saved" pop-up. Hides users drop-down and
     * shows text field instead of that one with text informing about user's time-track loading. Then requested page is
     * loaded (URL from redirectUrl).
     */
    function discardHandler() {
        disableWarningOnUnloadPage();
        window.location.href = getRedirectUrl();
    }

    function doSubmit()
    {
        return SubmitTimeTrack(event, <%=settings.isHoursPerDayLimited()%>,
                                                    <%=(settings.isHoursPerDayLimited() ? settings.getMaximumMinutesPerDay().toString() : "0")%>,
                                                    '<%=(settings.isHoursPerDayLimited() ? TimeUtils.formatWork(settings.getMaximumMinutesPerDay().intValue()) : "")%>');
    }

    function discardHandlerWithAnimation() {
        <% if (hasSubmitOtherUserTTRight) {%>
        usersSelector.leaveAndShowAnimationSpinner();
        setNormalHandlers();
        <% } %>
        discardHandler();
    }

    function saveChangesHandlerWithAnimation() {
        var submitTimeTrackResult = doSubmit();
        <% if (hasSubmitOtherUserTTRight) {%>
        if(submitTimeTrackResult)
            usersSelector.leaveAndShowAnimationSpinner();
        else
            setNormalHandlers();
        <% } %>
    }

    function stayOnPageHandler() {
        setNormalHandlers();
    }

    function closeAllPopups() {
        descriptionPopup.hide();

        if (!editDescriptionPopup.hide())
            return false;

        if (!LeavePopup.validateAndSave())
        {
            return false;
        }
        else
        {
            LeavePopup.leavePopup.hide();
        }

        return true;
    }

    function showSubmitTTTaskDescription(taskid, link, descriptionEntity) {
        window.event.cancelBubble = true;

        if (!closeAllPopups()) return false;

        showDescriptionWithDefaultOffset(taskid, link, new DescriptionUtil(descriptionEntity, TASK_ENTITY), document.getElementById("taskNameCell" + taskid));
        return false;
    }

    function getOnPageDescription(hiddenName) {
        var hiddenObj = document.SubmitTTForm.elements[hiddenName];
        return hiddenObj.value;
    }

    var submitTTCommentsManager = new SubmitTTCommentsManager().init( 
            { 
                userId: <%=visibleUserId%>, 
                reloadPageFunction: function () {
                    reloadSubmitTTPageWithoutFormReloading();
                },
                updateImgFunction: function () {
                    if ( editDescriptionState ) {
                        editDescriptionState.updateImage();
                    }
                },
                updateFormFunction: function (taskId, day, comment) {
                    var s = "timeTrack[" + taskId + "].hasComments[" + day + "]";
                    document.SubmitTTForm.elements[s].value = ( !!comment && comment != "" ) ? "true" : "false";
                }
            });
    
    function showEditableComments( taskId, day, date, cellId, link ) {
        if ( isTaskMarkedForDeletion(taskId) )
            return;

        if ( !closeAllPopups() )
            return;
        
        submitTTCommentsManager.showEditableComment(taskId, day, date, cellId, link);
    }

    function showReadOnlyComments( taskId, day, date, cellId, link ) {
        if ( !closeAllPopups() ) 
            return;

        submitTTCommentsManager.showReadOnlyComment(taskId, day, date, cellId, link);
    }


    function setNormalHandlers() {
        setDiscardHandler(discardHandler);
        setSubmitHandler(doSubmit);
        setCancelHandler(function() {})
    }

    function setAnimatedHandlers() {
        setDiscardHandler(discardHandlerWithAnimation);
        setSubmitHandler(saveChangesHandlerWithAnimation);
        setCancelHandler(stayOnPageHandler);
    }

    function prepare()
    {
        confirmDlg = new ConfirmExitDlg(500, messageResource.getMessage("submit_tt.modification_not_finished_warning"),
                                       messageResource.getMessage("submit_tt.save_modification_confirm"),
                                       messageResource.getMessage("common.buttons.save_changes"), messageResource.getMessage("common.buttons.discard_changes"), messageResource.getMessage("common.buttons.remain_on_page"));
        document.SubmitTTForm.autocomplete='off';
        document.SubmitTTForm.autocomplete = 'off';
        setNormalHandlers();
        setExitHandler(exitHandlerFunc);
        registerHandlers();

        Overtime.overtimeShown = <%=isOvertimeTrackingEnabled && user.getOvertimeTrackingLevel() != UserBean.OVERTIME_TRACKING_HIDDEN%>;
        Overtime.trustedMode = <%=user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_TRUSTED%>;
        Overtime.workdayDuration = [<%=data.getWorkdayDurationsString()%>];
        Overtime.maxLeaveDuration = [<%=data.getMaxLeaveDurationsString()%>];
        <% for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++) { %>
            Overtime.holidays[<%=day%>] = !( Overtime.workdayDuration[<%=day%>] > 0 );
        <% } %>
        Overtime.weekStart = <%=Week.FIRST_DAY%>;
        Overtime.weekEnd = <%=Week.LAST_DAY%>;
        Overtime.autoValue = '<%=jsMessage(request, "submit_tt.autocalculated_message" )%>';
        Overtime.caption = '<%=jsMessage( request, OvertimeLeavesUtil.getCapitalizedOvertimeMessageKey() )%>';
<% if(isShowTTArea) {%>
<logic:equal name="data" property="tasks.empty" value="false">
<% if (isOvertimeTrackingEnabled) { %>
<logic:notEqual value="<%=String.valueOf(UserBean.OVERTIME_TRACKING_HIDDEN)%>" property="overtimeTrackingLevel" name="user">
    <%

    // initialize hire day to 'before this week'
    int hireDay = Week.FIRST_DAY - 1;

    // initialize release day to 'after this week'
    int releaseDay = Week.LAST_DAY + 1;

    // initialize today to 'after this week'
    int today = Week.LAST_DAY + 1;

    boolean hiredOnThisWeek = false;
    boolean releasedOnThisWeek = false;
    boolean todayOnThisWeek = false;

    for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++) {
        if (!weekInfo.isFutureDayAndRestricted(day)) {
            SubmitTTForm.Overtime ovr = form.getOvertime(day);
            if (!ovr.isAutocalculated() && !disableOvertimeInputs[day]) {
            %>Overtime.values[<%=day%>] = new Overtime.OvertimeValue(<%=day%>, "<%=ovr.getOvertimeStr()%>", false);<%
            } else {
            %>Overtime.values[<%=day%>] = new Overtime.OvertimeValue(<%=day%>, 0, true);<%
            }

            %>
                Overtime.disabledInputs[<%=day%>] = <%=disableOvertimeInputs[day]%>;
                Overtime.disabledDays[<%=day%>] = <%=data.isDayLockedOrBeforeHireDate(user, day)%>;
            <%
        }

        // reinitialize hire and/or release day, if they are on this week
        Date date = weekInfo.getDayOfWeek( day );
        if( date.equals( user.getHireDate() ) )
        {
            hireDay = day;
            hiredOnThisWeek = true;
        }
        if( date.equals( user.getReleaseDate() ) )
        {
            releaseDay = day;
            releasedOnThisWeek = true;
        }
        // reinitialize today, if it is on this week
        if (weekInfo.isToday(day))
        {
            today = day;
            todayOnThisWeek = true;
        }
    }

    // if hire day is not on this week, then check if it is in future and reinitialize if needed
    if (!hiredOnThisWeek &&
        user.getHireDate() != null && user.getHireDate().compareTo(weekInfo.getDayOfWeek(Week.LAST_DAY)) > 0)
    {
        hireDay = Week.LAST_DAY + 1;
    }

    // if release day is not on this week, then check if it is in past and reinitialize if needed
    if (!releasedOnThisWeek &&
        user.getReleaseDate() != null && user.getReleaseDate().compareTo(weekInfo.getDayOfWeek(Week.FIRST_DAY)) < 0)
    {
        releaseDay = Week.FIRST_DAY - 1;
    }

    // if today is not on this week, then check if it is in past and reinitialize if needed
    if (!todayOnThisWeek && TimeUtils.today(weekInfo.getTimeZone()).compareTo(weekInfo.getDayOfWeek(Week.FIRST_DAY)) < 0)
    {
        today = Week.FIRST_DAY - 1;
    }

    %>

    Overtime.dayBeforeHireDateTooltip = "<%=StringUtils.getStringEscapedForJS(naOvertimeBeforeHireDateTooltip.toString())%>";
    Overtime.dayAfterReleaseDateTooltip = "<%=StringUtils.getStringEscapedForJS(naOvertimeAfterReleaseDateTooltip.toString())%>";
    Overtime.dayInFutureTooltip = "<%=StringUtils.getStringEscapedForJS(naOvertimeInFutureTooltip.toString())%>";

    Overtime.userHireDay = [<%=hireDay%>];
    Overtime.userReleaseDay = [<%=releaseDay%>];
    Overtime.today = <%=today%>;
    Overtime.updateFieldsAndTotal();
</logic:notEqual>
<% } %>
</logic:equal>

<%
    for(SubmitTTTaskBean task : data.getTasks())
    {
        TaskWeekTTInfo info = form.getTimeTrack(task.getId());

        if (info.isMarkedToDelete() &&
            task.isCanBeRemoved())
        {
%>
            initDeletedTaskRow(<%=task.getId()%>, '<%=TaskUtils.getHierarchyLevelNameSuffix(task)%>');
            weekTTChanges["rowDeleted_<%=task.getId()%>"] = true;
<%
        } else if (info.isMarkedToComplete()) {
%>
            setCompletedStatusForRowItems(<%=task.getId()%>, true);
            weekTTChanges["taskCompleted_<%=task.getId()%>"] = true;
<%
        }
    }
%>
        if(SubmitTTErrors.hasErrors())
        {
            ClientSideErrors.showClientSideErrorMessage();
        }
    <%}%>
    }

    PageOverlayTipsManager.setInstance(new EnterTTPageOverlayTipsManager(<%=wholeWeekDisabled%>));
    </script>
</head>
<%!

    void antiJitteringFix(HttpServletRequest request, JspWriter out) throws java.io.IOException
        {
            //invisible spacer with all of the button titles, to avoid jittering when buttons' visibility changes
            out.println("<div class='selectionCursorRightLug spacer'><div class='taskButton'><span>" + message(request, "submit_tt.button.remove" ) + "</span></div></div>");
            out.println("<div class='selectionCursorRightLug spacer'><div class='taskButton'><span>" + message(request, "submit_tt.button.complete") + "</span></div></div>");
        }
%>
<body topmargin="0" leftmargin="0" marginheight="0" marginwidth="0"
    onDragStart="return false" onunload="closeAllOpenedPopups();"
    <logic:equal value="<%=String.valueOf(UsersSelector.TT_LOGGED_IN_USER_SELECTED)%>" name="form" property="<%=SubmitTTForm.SELECTED_USER_FIELD_NAME%>">
        class="submit_tt myTT with-navigation"
    </logic:equal>
    <logic:notEqual value="<%=String.valueOf(UsersSelector.TT_LOGGED_IN_USER_SELECTED)%>" name="form" property="<%=SubmitTTForm.SELECTED_USER_FIELD_NAME%>">
        class="submit_tt other_tt with-navigation"
    </logic:notEqual>>
<div id="container">


<jsp:include page="/operation_confirm_dialog.jsp"/>


<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:form action="/user/submit_tt" method="post"
           onsubmit="return false; // For Opera to prevent form submitting by Return key pressing"
         autocomplete="off">
<html:hidden property="submitted" value="true"/>
<html:hidden property="dateStr"/>
<html:hidden property="weekStartDay"/>
<html:hidden property="pageAction" value=""/>
<html:hidden property="addTaskList" value=""/>
<html:hidden property="deletedTaskList" value=""/>
<html:hidden property="autoAssignProjects"/>
<html:hidden property="redirectUrl"/>
<html:hidden property="formDataModified"/>
<html:hidden property="afterReloginUrl"/>
<html:hidden property="beforeReloginUsername"/>
<html:hidden property="taskToReopen" styleId="task_id_to_reopen" />
<% if( isWeekStatusIsPresent ) { %>
    <html:hidden property="effectiveWeekStatusName"/>
    <html:hidden property="timeEntriesChanged"/>
    <html:hidden property="doSaveWeekStatusValue"/>
    <html:hidden property="rejectWeekComment"/>
    <html:hidden property="lastChangesTimestampStr"/>
<% } %>
<table
    align="center" width="890px" cellspacing="0" cellpadding="0" border="0" class="display-for-print">
<tr><td id="enterTTMainContent" class="mainContentPadding rightPadding <%= isMyOwnTT ? "myOwnTT" : "" %> <%=isWeekStatusIsPresent ? "weekStatusPresent " + weekStatusStyle + " " : ""%> <%=noTasksClass%>">
<table width="100%" align="center" cellspacing="0" cellpadding="0" border="0" class="mainSidesPadding">
    <logic:present name="<%=Keys.LOADED_DEMO_DATA_NAME%>" scope="session">
    <% if( ATGlobals.isOl() ) { %>
        <jsp:include page="/user/demo_data_loaded.jsp"/>
    <% } else { %>
    <tr>
        <td colspan="2" height="40px" valign="top" style="padding-top:4px; padding-bottom: 10px;" class="noprint">
            <jsp:include page="/user/demo_data_loaded.jsp"/>
        </td>
        <td>&nbsp;</td>
    </tr>
    <% } %>
    </logic:present>
    <tr>
    <td valign="top" style="width: 100%">
            <div class="pagetitle" style="padding:16px 0 9px 0;">
                <table cellpadding="0" cellspacing="0" class="noprint" style="height: 38px;">
                    <tr>
                        <td class="pagetitle" nowrap><bean:message key="submit_tt.page.title"/></td>
                        <%  //last verification needed if me has hasSubmitOtherUserTTRight and hasSubmitTTRight but concurrently we see only himself
                            if (hasSubmitOtherUserTTRight && users != null && ( hasSubmitTTRight &&  users.size() > 1 || !hasSubmitTTRight && users.size() > 0
                            || !form.getUsersSelector().isCurrentUserSelected() && users.size() == 1)) {%>
                        <% String redirectUrlParams = "dateStr=" + form.getDateStr(); %>
                        <jsp:include page="/user/usersSelector.jsp">
                            <jsp:param name="hasSubmitTTRight" value="<%=hasSubmitTTRight %>"/>
                            <jsp:param name="hasSubmitOtherUserTTRight" value="<%=hasSubmitOtherUserTTRight %>"/>
                            <jsp:param name="isOtherUserSelected" value="<%=isOtherUserSelected%>"/>
                            <jsp:param name="selectedUser" value="<%= form.getUsersSelector().getSelectedUser()%>"/>
                            <jsp:param name="submitCallback" value="leavePageWithConfirmAndAnimation"/>
                            <jsp:param name="redirectUrl" value="submit_tt.do"/>
                            <jsp:param name="redirectUrlParams" value="<%=redirectUrlParams%>"/>
                            <jsp:param name="selectedUserParamName" value="<%=SubmitTTForm.SELECTED_USER_FIELD_NAME%>"/>
                        </jsp:include>
                    <% } %>
                    </tr>
                </table>
            </div>
                 <% if( hasSubmitOtherUserTTRight && isOtherUserSelected && isShowTTArea && !user.isCanSubmitTimeTrack() ) {%>
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tr>
                            <td valign="top" style="padding-right:5px;"><at:defImg page="warning.gif"/></td>
                            <td valign="top" class="warningmsg">
                                <bean:message key="submit_tt.user_cannot_submit_tt_warning"
                                              arg0="<%=ResponseUtils.filter(user.getFormattedName( NameUtil.Format.FML ))%>"/>
                            </td>
                        </tr>
                    </table>
                 <% } %>

                <table cellspacing="0" cellpadding="0" border="0" class="for-print-only-table">
                    <tr>
                        <td class="pagetitle-for-print-only" nowrap><bean:message key="submit_tt.time_track_for.print"/></td>
                        <td width="100%" class="user-name-for-print-only"><%=ResponseUtils.filter(user.getFormattedName( NameUtil.Format.FML ))%></td>
                    </tr>
                </table>
    </td>
    <td align="right" style="vertical-align: top; padding-top: 20px;">
        <div id="fromDateSelector"></div>
        <% if( isWeekStatusIsPresent && isShowTTArea ) { %>
        <div class="weekApprovalStatusControlOuterContainer top <%= request.getHeader( "User-Agent" ).toLowerCase().contains( "msie 8" ) ? "simpleStyle" : "" %>">
            <jsp:include page="/controls/change_week_approval_status_control.jsp">
                <jsp:param name="isMyOwnTT" value="<%= isMyOwnTT %>"/>
                <jsp:param name="currentStatusStyle" value="<%= weekStatusStyle %>"/>
            </jsp:include>
        </div>
        <% if (!EffectiveWeekApprovalStatus.AUTO_APPROVED.name().equals( form.getEffectiveWeekStatusName() ) && !isMyOwnTT) { %>
            <div class="weekSwitcher">
                <% if (data.isPrevReadyWeekExists()) { %>
                <a href=javascript:void(0) class="enabled prevReadyWeek" onclick="showPrevReadyWeek()">
                <% } %>
                <% if (!data.isPrevReadyWeekExists()) { %>
                <a class="disabled prevReadyWeek">
                <% } %>
                    <span class="prevWeekArrow"></span>
                    <span class="prevWeekText"><bean:message key="submit_tt.week_switcher.prev_ready_week_link"/></span>
                </a>
                <span class="chooseWeekText <% if (!data.isNextReadyWeekExists() && !data.isPrevReadyWeekExists()) { %> disabled <% } %>">
                    <bean:message key="submit_tt.week_switcher.description"/>
                </span>
                <% if (data.isNextReadyWeekExists()) { %>
                <a href=javascript:void(0) class="enabled nextReadyWeek" onclick="showNextReadyWeek()">
                <% } %>
                <% if (!data.isNextReadyWeekExists()) { %>
                <a class="disabled nextReadyWeek">
                <% } %>
                    <span class="nextWeekText"><bean:message key="submit_tt.week_switcher.next_ready_week_link"/></span>
                    <span class="nextWeekArrow"></span>
                </a>
            </div>
            <% } %>
        <% } %>

        <script language="JavaScript">
            $( document ).ready(
                    function ()
                    {
                        FirefoxFormCacheFix.apply();

                        var fromDateSelector = document.getElementById( "fromDateSelector" );
                        disableTextSelection(fromDateSelector);
                        <%
                            Calendar dateFrom = Calendar.getInstance();
                            dateFrom.setTime( weekInfo.getWeekStart() );
                            Calendar dateTo = Calendar.getInstance();
                            dateTo.setTime( weekInfo.getWeekEnd() );
                        %>
                        var dateFrom = Date.create( <%=String.valueOf( dateFrom.get( Calendar.YEAR ) )%>, <%=String.valueOf( dateFrom.get( Calendar.MONTH ) )%>, <%=String.valueOf( dateFrom.get( Calendar.DAY_OF_MONTH ) )%> );
                        var dateTo = Date.create( <%=String.valueOf( dateTo.get( Calendar.YEAR ) )%>, <%=String.valueOf( dateTo.get( Calendar.MONTH ) )%>, <%=String.valueOf( dateTo.get( Calendar.DAY_OF_MONTH ) )%> );
                        var weekStartDay = SystemSettings.weekStartDay - 1;
                        var minDay = new Date(1970, 0, 5);
                        var maxDay = MAX_ALLOWED_DATE_FOR_TIME_TRACK;
                        <% if (isShowTTArea) { %>
                        var dateSelector = new WeekSelectorWithRange( {
                                                                 minValue: minDay.getWeekStartDate( weekStartDay ),
                                                                 maxValue: maxDay,
                                                                 weekStartDay: <%=weekInfo.getWeekStartDay() - 1%>,
                                                                 renderTo: fromDateSelector,
                                                                 scheduleCalculator: new UserScheduleCalculator().init(
                                                                         invertedDaysDateMap,
                                                                         <%=Arrays.toString( data.getUserInitialSchedule() )%>,
                                                                         <%=jsHelper.toJSON( data.getUserOtherSchedules() )%>
                                                                 ),
                                                                 date: dateFrom,
                                                                 scrollableContainer: window
                                                             } );
                        dateSelector.on( "change",
                                         function ()
                                         {
                                             selectDate( dateSelector.getValue(), function () { dateSelector.setValue(dateFrom); } );
                                         } );
                         <% } %>
                        $("#actualTTRows").find("td.taskNameColumn").each(
                            function() {
                                $(this).hover(
                                        function() { $(this).addClass("hovered"); },
                                        function() { $(this).removeClass("hovered"); }
                                );
                                var self = this;
                                $(this).find(".task_description").hover(
                                        function() { $(self).removeClass("hovered"); },
                                        function() { $(self).addClass("hovered"); }
                                );
                            }
                        );

                        if( SubmitTTChanges.hasChanges() )
                            submitTTManager.handleChange( false, true );


                        $(".submitTTPanel .cancelButton").click(submitTTManager.cancelButtonFunction);

                        <% if( isWeekStatusIsPresent ) { %>
                            <% if( isMyOwnTT ) { %>
                                var weekStatusMediator = new ChangeMyWeekApprovalStatusMediator().init(
                                        <%= user.getId() %>,
                                        "<%=form.getEffectiveWeekStatusName()%>",
                                        <%=data.isWholeWeekBeforeHireDate(user)%>,
                                        dateFrom,
                                        dateTo
                                );
                                submitTTManager.setOnTimeEntriesChangedCallback(
                                        function() { weekStatusMediator.showSwitcherIfNeeded(); }
                                );
                            <% } else { %>
                                var changeOtherWeekStatusMediator = new ChangeOtherWeekApprovalStatusMediator().init(
                                        {
                                            userId: <%=user.getId()%>,
                                            firstName: "<%=StringUtils.getStringEscapedForJS(user.getFirstName())%>",
                                            middleName: "<%=StringUtils.getStringEscapedForJS(user.getMiddleName())%>",
                                            lastName: "<%=StringUtils.getStringEscapedForJS(user.getLastName())%>"
                                        },

                                        dateFrom,
                                        dateTo,
                                        "<%=form.getEffectiveWeekStatusName()%>",
                                        <%=data.isWholeWeekBeforeHireDate(user)%>,
                                        <%=loggedInUser.getId()%>,
                                        <%= form.getLastChangesTimestampStr() == null ? "null" : "\"" + form.getLastChangesTimestampStr() + "\"" %>
                                );
                                submitTTManager.setOnTimeEntriesChangedCallback(
                                        function () { document.SubmitTTForm.timeEntriesChanged.value = true; changeOtherWeekStatusMediator.setTimeEntriesChanged(); }
                                );
                            <% } %>
                        <% } %>
                        prepare();
                    }
            );
        </script>
    </td>
    <td class="selectionRightContainer" rowspan="3">
        <% antiJitteringFix(request, out); %>
    </td>
</tr>
<tr>
    <td style="vertical-align: top; padding: 4px 0 20px 0; height: 16px;" class="noprint" colspan="2">
        <%@ include file="/messages.jsp" %>
        <div id="ClientSideErrorMessage" style="display:none;">
            <table border="0" cellspacing="0" cellpadding="0">
                <tr>
                    <td valign="top">
                        <at:img page="error.gif"/>
                    </td>
                    <td valign="top" style="padding-left: 6px;">
                        <span class="errormsg"><bean:message key="submit_tt.client_side_errors_message"/></span>
                    </td>
                </tr>
            </table>
        </div>
    </td>
</tr>

<% if (isNoUsersToEnterTT) { %>
<tr>
    <td colspan="2">
        <div class="noPageDataForViewingNote">
            <div><bean:message key="submit_tt.no_users_to_enter_tt"/></div>
        </div>
    </td>
</tr>
<% } else if (!isShowTTArea) { %>
<tr>
    <td colspan="2">
        <div class="userIsNotSelectedNote noPageDataForViewingNote">
            <div class="wizardSelectionImg"></div>
            <div class='userIsNotSelectedText'><bean:message key="submit_tt.user_is_not_selected"/></div>
        </div>
    </td>
</tr>
<%}%>

<tr>
    <% if(isShowTTArea) {
        boolean isEnabledAddTasksControls = !wholeWeekDisabled;
    %>
    <td>
        <table cellspacing="0" cellpadding="0" border="0" class="<%=hideAddRecentTaskSelector%>">
            <tr>
                <td>
                    <jsp:include page="/user/add_tasks/task_search_control.jsp">
                        <jsp:param name="id" value="taskSearchControl"/>
                        <jsp:param name="selectedUserId" value="<%=user.getId()%>"/>
                        <jsp:param name="selectedUserName" value="<%=user.getFormattedName( NameUtil.Format.FML )%>"/>
                        <jsp:param name="isOwnTimeTrack" value="<%=( user.getId() == loggedInUser.getId() )%>"/>
                        <jsp:param name="alreadyAddedTaskIds" value="<%=addedTaskIds%>"/>
                        <jsp:param name="onTaskChosen" value="taskSearchControl_taskChosen"/>
                        <jsp:param name="isEnabled" value="<%=isEnabledAddTasksControls%>"/>
                        <jsp:param name="spinnerPlaceholderId" value="addTasksSpinnerPlaceholder"/>
                    </jsp:include>
                </td>
                <td style="padding-left: 5px; padding-right: 3px">
                    <div id="addTasksSpinnerPlaceholder" style="width: 16px">&nbsp;</div>
                </td>
                <td class="recentTaskSelectorSection">
                    <jsp:include page="/user/add_tasks/recent_tasks_control.jsp">
                        <jsp:param name="id" value="recentTasksControl"/>
                        <jsp:param name="selectedUserId" value="<%=user.getId()%>"/>
                        <jsp:param name="selectedUserName" value="<%=user.getFormattedName( NameUtil.Format.FML )%>"/>
                        <jsp:param name="isOwnTimeTrack" value="<%=( user.getId() == loggedInUser.getId() )%>"/>
                        <jsp:param name="alreadyAddedTaskIds" value="<%=addedTaskIds%>"/>
                        <jsp:param name="onTaskChosen" value="recentTasksControl_taskChosen"/>
                        <jsp:param name="isEnabled" value="<%=isEnabledAddTasksControls%>"/>
                        <jsp:param name="spinnerPlaceholderId" value="addTasksSpinnerPlaceholder"/>
                    </jsp:include>
                </td>
                <td class="recentTaskSelectorSection" style="padding-left: 5px; padding-right: 5px;">
                    <div class="addTasksControlsSeparator"></div>
                </td>
                <td style="padding-right: 5px">
                    <jsp:include page="/user/add_tasks/task_select_control.jsp">
                        <jsp:param name="id" value="taskSelectControl"/>
                        <jsp:param name="selectedUserId" value="<%=user.getId()%>"/>
                        <jsp:param name="selectedUserName" value="<%=user.getFormattedName( NameUtil.Format.FML )%>"/>
                        <jsp:param name="isOwnTimeTrack" value="<%=( user.getId() == loggedInUser.getId() )%>"/>
                        <jsp:param name="alreadyAddedTaskIds" value="<%=addedTaskIds%>"/>
                        <jsp:param name="onTasksChosen" value="taskSelectControl_tasksChosen"/>
                        <jsp:param name="isEnabled" value="<%=isEnabledAddTasksControls%>"/>
                    </jsp:include>
                </td>
                <% if (canManageTasks) {%>
                <td valign="middle" style="padding-left: 16px;"><% if (isEnabledAddTasksControls) { %><!--
                    --><a href="javascript:void(0)" onclick="openAddNewTasksPopup(); return false;"><at:img border="0" page="add_new_tasks.png" style="display:block"/></a><!--
                --><% } else { %><!--
                    --><at:img border="0" page="add_new_tasks_disabled.png" style="display:block"/><!--
                --><% } %></td>
                <td valign="middle" style="padding-left: 4px;">
                    <nobr>
                        <% if (isEnabledAddTasksControls) { %>
                            <span class="dashedLink" onclick="openAddNewTasksPopup();"><bean:message key="submit_tt.caption.new"/></span>
                        <% } else { %>
                            <span class="dashedLink disabled"><bean:message key="submit_tt.caption.new"/></span>
                        <% } %>
                    </nobr>
                </td>
                <% } %>
            </tr>
        </table>
    </td>
    <% } else {%>
    <td>&nbsp;</td>
    <% }%>
    <td align="right">
        <div id="FormModifiedDiv" style="visibility:hidden;">
            <table cellpadding="0" cellspacing="0" border="0">
                <tr valign="middle">
                    <td>
                        <span class="submitTTPanel">
                            <div id="FormModifiedDivButton" onclick="doSubmit();" class="saveButton save-changes-link"><bean:message key="common.save"/></div>
                            <div class="save-changes-link savingButton"><bean:message key="submit_tt.saving"/></div>
                            <span class="submitTTButtonsSeparator">&nbsp;</span>                                               
                            <span class="cancelTTEditingButton customLink cancelButton"><bean:message key="submit_tt.cancel"/></span>
                        </span>
                    </td>
                </tr>
            </table>
        </div>
    </td>
</tr>
</table>

<%
    if(isShowTTArea) {
%>

<jsp:include page="leave_type_list_js.jsp" />

<script type="text/javascript">
    var leaveTypeImagesToPreload;
    leaveTypeImagesToPreload = Array();

    for(var i = 0; i < LeaveTypesList.leaveTypes.length; i++)
    {
        leaveTypeImagesToPreload[leaveTypeImagesToPreload.length] = LeaveTypesList.leaveTypes[i].iconUrl;
    }

    var leaveTypeImagesPreloader;
    leaveTypeImagesPreloader = new ImagePreloader(leaveTypeImagesToPreload);
</script>
<table align="center" class="tt-table hide-element-before-sorting-tasks" id="tt-table" cellpadding="0" border="0" width="100%">
<tr class="submitTTHead"><%-- Do not remove such comments (see bug #45782)
--%><td class="selectionLeftContainer"><at:img page="pixel.gif" width="21" height="1"/></td><%--
--%><td class="listtblcolheader_submit_tt firstInRow taskNameHeader">
        <span id="sortByTaskNameLink" class="sortByTaskNameLink"><bean:message key="common.Task"/></span>
        <span class="taskNameSortArrow"></span>
        <div class="customerProjectBlock">
            <span id="sortByCustomerNameLink" class="sortByCustomerNameLink"><bean:message key="common.Customer"/></span>
            <span class="customerNameSortArrow"></span>
            <%=message(request, "common.hierarchy_levels_separator")%>
            <span id="sortByProjectNameLink" class="sortByProjectNameLink"><bean:message key="common.Project"/></span>
            <span class="projectNameSortArrow"></span>
        </div>
    </td><%--
--%><td width="76px" class="listtblcolheader_submit_tt"><bean:message key="submit_tt.deadline"/></td><%--
--%><%
    for(int day = 0; day <= 6; day++)
    {
        String className;
        String titleMessageKey = null;
        boolean isDayLocked = data.isDayLocked(day);
        boolean isDayBeforeHireDate = data.isDayBeforeHireDate(user, day);
        if (isDayLocked || isDayBeforeHireDate) {
            className = (data.isHoliday(day)) ? "calendarWeekendDayHeaderDisabled" : "calendarWorkingDayHeaderDisabled";
            titleMessageKey = isDayBeforeHireDate ?
                              (isOtherUserSelected ? "submit_tt.day_before_user_hire_date_tooltip" : "submit_tt.day_before_your_hire_date_tooltip") :
                              "submit_tt.day_locked_tooltip";
        } else {
            className = (data.isHoliday(day)) ? "calendarWeekendDayHeaderNormal" : "calendarWorkingDayHeaderNormal";
        }

        if (weekInfo.isToday(day))
            className += "_today";
    %><%--
--%><td align="center" class="<%=className%> headerDateCell <% if(day==6) { %>lastInRow<% } %>" style="padding-top: 2px; width:1%;"<% if (titleMessageKey != null) {%> title='<%=filteredMessage(request, titleMessageKey)%>'<%} %>>
        <table border="0" cellspacing="0" cellpadding="0" width="60px">
            <tr>
                <td width="30%">&nbsp;</td>
                <td align="center" class="<%=className%> dateDay"><%=weekInfo.getPrintableDayOfMonth(day)%></td>
                <td width="30%" align="right"><% if (isDayLocked && !isDayBeforeHireDate) {%><at:img page='<%=(isOtherUserSelected ? "lockother.gif" : "lock.gif")%>' style='vertical-align: middle;'/><%} %></td>
            </tr>
            <tr>
                <td colspan="3" align="center" class="<%=className%> dateMonth <% if(day==6) { %>lastInRow<% } %>"><%=message( request, WorkingDaysUtils.getPrintableDayOfWeekKey(day, weekInfo.getWeekStartDay()))%></td>
            </tr>
        </table>
    </td><%--
--%><% } %><%--
--%><td class="selectionRightSeparator" style="width: 13px"><at:img page="pixel.gif" width="13" height="1"/></td><%--
--%><td class="selectionRightContainer">
        <% antiJitteringFix(request, out); %>
    </td>
</tr>
<html:hidden property="containsLeaves"/>
<logic:equal value="true" name="form" property="containsLeaves">
<tr>
    <td class="selectionLeftContainer"></td><%--
--%><td class="leaveTimeTotal firstInRow" align="right" colspan="2">
        <table cellpadding="0" cellspacing="0" border="0" >
            <tr>
                <td class="leaveTimeTotalHeader"><bean:message key="submit_tt.leave_time_total"/>:</td>
                <td class="leaveTimeTotalHeader" align="right" width="62"><nobr>
                    &nbsp;<span id="leaveTimeTotal"><%=form.getWeekLeaveTimeTotal(settings, data.getWorkdayDurations())%></span>&nbsp;</nobr></td>
            </tr>
        </table>
    </td><%--
--%><%
   for(int day = 0; day <= 6; day++)
   {
%><%--
--%><td align="center" style="padding: 0; width:1%;" class="leaveButtonCell <% if(day==6) { %>lastInRow<% } %>" ><jsp:include page="leave_button.jsp">
            <jsp:param name="dayOfWeek" value="<%=day%>"/>
            <jsp:param name="onChangeHandler" value="onDayLeaveInfoChange"/>
            <jsp:param name="leaveError" value="<%=validationErrors.getLeaveError(day) %>" />
        </jsp:include></td><%--
--%><%
        if (validationErrors.getLeaveError(day) != null)
        {
%><%--
         --%><script language="JavaScript">SubmitTTErrors.markDayLeaveInfoAsInvalid(<%=day%>,
                    "<%=StringUtils.getStringEscapedForJS(
                            validationErrors.getLeaveError(day)
                            )%>"  );</script><%--
--%><%
        }

        if (ttChanges.isLeaveChangedWithinDay(day))
        {
%><%--
         --%><script language="JavaScript">LeaveButtons.setDayChanged(<%=day%>, true);</script><%--
--%><%
        }
    }
%><%--
--%><td class="selectionRightSeparator"></td><%--
--%><td class="selectionRightContainer"></td>
</tr>
</logic:equal>
<script>
    function onMouseOverRowTimeout(row, taskId, isMouseOverButton)
    {
        mouseOverRowTimeout = null;

        clearSelectedRow();

        if (currentSelectedRow != row) {
            currentSelectedRowStatus = isMouseOverButton ? TaskRowStatus.SELECTED : TaskRowStatus.SLIGHTLY_SELECTED;
            setRowStatus(row, currentSelectedRowStatus);
            if (currentSelectedRow) {
                setRowStatus(currentSelectedRow, TaskRowStatus.NORMAL);
            }
            currentSelectedRow = row;
        } else {
            if (isMouseOverButton) {
                if (currentSelectedRowStatus != TaskRowStatus.SELECTED) {
                    currentSelectedRowStatus = TaskRowStatus.SELECTED;
                    setRowStatus(currentSelectedRow, TaskRowStatus.SELECTED);
                }
            } else if (currentSelectedRowStatus != TaskRowStatus.SLIGHTLY_SELECTED) {
                currentSelectedRowStatus = TaskRowStatus.SLIGHTLY_SELECTED;
                setRowStatus(currentSelectedRow, TaskRowStatus.SLIGHTLY_SELECTED);
            }
        }
    }

    function clearSelectedRow()
    {
        if (currentSelectedRow)
        {
            setRowStatus(currentSelectedRow, TaskRowStatus.NORMAL);
            currentSelectedRowStatus = TaskRowStatus.NORMAL;
            currentSelectedRow = null;
        }
    }

    function onMouseOverRow(row, taskId, event) {

        if (Ext.isIE)
        {
            clearTimeout(mouseOverRowTimeout); // cancel previous mouseOverRow event handling
            clearTimeout(mouseOutRowTimeout);  // and cancel mouseOutRow event, because cursor will be hidden in the new
                                               // mouseOverRow handler - don't need to hide it before that,
                                               // as it would cause it to blink
            if (mouseWheelEngaged > 0)
            {
                mouseWheelEngaged--;   // if user scrolls the page with mouse wheel, then don't handle mouseOver,
                return false;          // so the scrolling is smoother.
                                       // Anyway, IE handles mouseOver incorrectly while scrolling.
            }
        }

        if (isCursorMovingForbidden()) return false;

        var taskButtonContainer = document.getElementById("selectionRightContainer" + taskId);
        var taskButtonseparator = document.getElementById("selectionRightSeparator" + taskId);
        var isMouseOverButton = isMouseOverElement(taskButtonContainer, event) ||
                                isMouseOverElement(taskButtonseparator, event);

        if (Ext.isIE)
        {
            mouseOverRowTimeout = setTimeout( function () {        // defer event handling to improve performance in IE
                onMouseOverRowTimeout(row, taskId, isMouseOverButton);
            }, 1);
        }
        else
        {
            onMouseOverRowTimeout(row, taskId, isMouseOverButton); // execute immediately in other browsers
        }

        return true;
    }

    function onMouseOutRow(row, event) {

        if (Ext.isIE)
            clearTimeout(mouseOutRowTimeout);                       // cancel previous mouseOutRow event handling
        
        if (isCursorMovingForbidden()) return false;

        if (isMouseOutElement(row, event) && currentSelectedRow == row)
        {
            if (Ext.isIE)                                           // defer event handling to improve performance in IE
                mouseOutRowTimeout = setTimeout(clearSelectedRow, 1);
            else
                clearSelectedRow();                                 // execute immediately in other browsers
        }

        return true;
    }

    function onMouseWheelOverRow()
    {
        mouseWheelEngaged = 2;       // ignore next 2 mouseover events under IE to make scrolling smoother
    }

    /**
     * Adds or removes selection for the given row.
     * @param row HTMLTableRow.
     * @param status One of TaskRowStatus enum.
     */
    function setRowStatus(row, status) {
        switch (status) {
            case TaskRowStatus.SLIGHTLY_SELECTED:
                addClass(row, "slightlySelectedRow");
                replaceClass(row, "selectedRow", null);
                setRowBorders(row, false);
                break;
            case TaskRowStatus.SELECTED:
                addClass(row, "selectedRow");
                replaceClass(row, "slightlySelectedRow", null);
                setRowBorders(row, true);
                break;
            case TaskRowStatus.NORMAL:
                replaceClass(row, "slightlySelectedRow", null);
                replaceClass(row, "selectedRow", null);
                setRowBorders(row, false);
                break;
        }
    }

    /**
     * Hides or shows darker borders for selected row.
     * @param row HTMLTableRow selected row.
     * @param isShown true to show borders, false to hide.
     */
    function setRowBorders(row, isShown) {
        var table = document.getElementById("tt-table");
        if (!table || !table.rows) return;

        var previousRow = (row.rowIndex > 0 ) ? table.rows[row.rowIndex - 1] : null;
        var nextRow = (row.rowIndex < table.rows.length - 1) ? table.rows[row.rowIndex + 1] : null;

        if (isShown) {
            if (previousRow) {
                addClass(previousRow, "beforeSelectedRow");
            }
            if (nextRow) {
                addClass(nextRow, "afterSelectedRow");
            }
        } else {
            if (previousRow) {
                replaceClass(previousRow, "beforeSelectedRow", null);
            }
            if (nextRow) {
                replaceClass(nextRow, "afterSelectedRow", null);
            }
        }
    }

    /**
     * Returns task ID for the given row
     * @param row HTMLTableRow
     */
    function getTaskIdByRow(row) {
        // row IDs are formed in this way: "taskRow<task_id>"
        return row.id.substr(7);
    }

    function reviseRowSelectionIfNeeded(row, taskId, event) {
        if (isCursorMovingForbidden()) return false;

        return onMouseOverRow(row, taskId, event);
    }

    function editTask( taskId ) {
        var taskEditCallback = function()
        {
            if ( typeof window.disableWarningOnUnloadPage != typeof undefined )
                window.disableWarningOnUnloadPage();

            document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.HIGHLIGHT_TASKS_ACTION %>';
            document.SubmitTTForm.addTaskList.value = taskId;
            document.SubmitTTForm.submit();
        };

        var taskDeleteCallback = function()
        {
            if ( typeof window.disableWarningOnUnloadPage != typeof undefined )
                window.disableWarningOnUnloadPage();

            document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.REMOVE_DELETED_TASK %>';
            document.SubmitTTForm.deletedTaskList.value = taskId;
            document.SubmitTTForm.submit();
        };

        loadPopupContent( '<html:rewrite page="/tasks/edit_task_popup.do"/>' + '?<%=Keys.TASK_ID_KEY%>=' + taskId,
                          function() { showEditTaskPopup(taskEditCallback, taskEditCallback, taskDeleteCallback); },
                          true,
                          function (status, responseText) {
                              if (status == <%=AjaxActionErrorCodes.TASK_CONCURRENTLY_DELETED%>) {
                                  alert(messageResource.getMessage("task.edit_popup.error.concurrently_deleted"));
                                  taskEditCallback();
                                  return true;
                              } else if (status == <%=AjaxActionErrorCodes.TASK_IS_NOT_ASSIGED%>) {
                                  alert(messageResource.getMessage("common.errors.task_not_assined"));
                                  taskEditCallback();
                                  return true;
                              }
                              return false;
                          },
                          true );
    }
</script>
<logic:equal name="data" property="tasks.empty" value="false">
    <script type="text/javascript">

                var title = new DhtmlTitle("taskTitle");
                function showTaskToolTip(message, object)
                {
                    title.showDelayed(message, object, -10, 10);
                }

                function hideTaskToolTip()
                {
                    title.cancelDelayedShow();
                }
    </script>
    <%
        String completeButtonText = message(request, "submit_tt.button.complete");
        String undoCompleteButtonText = message(request, "submit_tt.button.undo_complete");
        String removeButtonText = message(request, "submit_tt.button.remove");
        String undoRemoveButtonText = message(request, "submit_tt.button.undo_remove");
        String reopenButtonText = message(request, "submit_tt.button.reopen");
    %>
    <tbody id="actualTTRows">
    <%
        boolean evenRow = false;
    %>
    <logic:iterate id="task" name="data" property="tasks" type="com.actimind.actitime.user.SubmitTTTaskBean">

    <%
        boolean notAssignedTask = !(loggedInUserWithRighs.isHasAccessToAllProjects(projectAssignmentsFeatureEnabled) || (task.isBelongToProjectAssignedToPageViewer() != null && task
                .isBelongToProjectAssignedToPageViewer()));
    %>

    <tr id="taskRow<%=task.getId()%>" class="taskRow actualRow <%=(evenRow ? "even" : "odd")%> <%=notAssignedTask ? "notAssignedTaskRow" : "assignedTaskRow"%> <%=task.isCompleted() ? "completedTaskRow" : ""%>" height="35"
        onmousedown="return reviseRowSelectionIfNeeded(this, <%=task.getId()%>, event);"
        onmousemove="return reviseRowSelectionIfNeeded(this, <%=task.getId()%>, event);"
        onmouseover="return onMouseOverRow(this, <%=task.getId()%>, event);"
        onmouseout="return onMouseOutRow(this, event);"
        onmousewheel="return onMouseWheelOverRow()"><%--
--%><%
        String descriptionEntity = task.hasParentTask() ? "SUB_TASK_ENTITY" : "TASK_ENTITY";

        String backgroundClass = "listtblcell_submit_tt_background";
        String taskTitle = "";
        String taskNameCellTitle = "";
        String taskDescription = StringUtils.encodeQuoteCharacter(message(request, "submit_tt.taskline.task.description"));
        String taskDeadLine = StringUtils.encodeQuoteCharacter(message(request, "submit_tt.taskline.task.deadline.past"));

        boolean haveRightsToViewTask = !notAssignedTask && (isOtherUserSelected || user.isHasAccessToAllProjects(projectAssignmentsFeatureEnabled) || task.isBelongToProjectAssignedToPageOwner());
        String disabledClass = haveRightsToViewTask ? "" : "disabled";

        if (notAssignedTask)
        {
            taskTitle = StringUtils.encodeQuoteCharacter(message(request, "submit_tt.task_not_available"));
            taskNameCellTitle = StringUtils.encodeQuoteCharacter(message(request, "common.tooltip.not_assigned_task"));
        }

        if (isOtherUserSelected && !(user.isHasAccessToAllProjects(projectAssignmentsFeatureEnabled) || task.isBelongToProjectAssignedToPageOwner()))
        {
            backgroundClass+="_pink";
            taskTitle = StringUtils.encodeQuoteCharacter(message(request, "submit_tt.hint_for_task_from_not_assigned_project",
                                                user.getFormattedName( NameUtil.Format.FML ),
                                                task.getProject().getName()
                                ));
            taskNameCellTitle = taskTitle;
        }

        if (task.isCompleted()) {
            taskTitle = StringUtils.encodeQuoteCharacter(message( request, "submit_tt.task_completed" ));
            taskNameCellTitle = taskTitle;
        }

        String completeButtonTip = message(request, "submit_tt.button.complete.tip.task");
        String undoCompleteButtonTip = message(request, "submit_tt.button.undo_complete.tip.task");
        String removeButtonTip = message(request, "submit_tt.button.remove.tip.task");
        String undoRemoveButtonTip = message(request, "submit_tt.button.undo_remove.tip");
        String reopenButtonTip = message(request, "submit_tt.button.reopen.tip.task");
    %><%--
      --%><bean:define id="taskInfo" name="form" property='<%="timeTrack["+task.getId()+"]"%>'
                 type="com.actimind.actitime.user.TaskWeekTTInfo"/><%--
      --%><td class="selectionLeftContainer" id="<%=("selectionLeftContainer"+task.getId())%>">
            <div class="selectionCursorLeftLug" id="<%=("selectionLeftLug"+task.getId())%>">
                <!--do not remove the comment inside empty div, otherwise IE will insert a whitespace instead of it-->
                <div class="selectionCursorLeftTopCorner"><!----></div>
                <div class="selectionCursorLeftBottomCorner" id="<%=("selectionLeftBottom"+task.getId())%>"><!----></div>
            </div>
          </td><%--
      --%><td class="listtblcell_submit_tt <%=backgroundClass%> <%=disabledClass%> taskNameColumn firstInRow"
            id="taskNameCell<%=task.getId()%>"
            title="<%=taskNameCellTitle%>"
            <% if (haveRightsToViewTask) { %>
                onclick="editTask(<%=task.getId()%>); return false;"
            <% } %>
        >
            <input type="hidden" name="<%="timeTrack["+task.getId()+"].markedToDelete"%>"
                   id="<%="isRowDeleted" + task.getId()%>" value="0" />
            <input type="hidden" name="<%="timeTrack["+task.getId()+"].markedToComplete"%>"
                   id="<%="isTaskCompleted" + task.getId()%>" value="0" />
            <input type="hidden" id="isInArchivedProject<%=task.getId()%>"
                   value="<%=(task.isInArchivedProject() ? "1" : "0")%>" />
            <table cellpadding="0" cellspacing="0" border="0" width="100%" style="font-size: inherit !important; color: inherit !important;">
                <tr><%--
                --%><td valign="middle" style="padding-right:5px;" class="taskNameBlock">
                        <logic:equal name="task" property="completed" value="true">
                            <%
                                String imgPath = "completed-task-png24.png";
                                String imgStyleId = "completedTaskMark" + task.getId();
                            %>
                            <div style="position: relative;"><at:img styleClass="completedTaskMark" page="<%=imgPath%>"
                                                                     styleId="<%=imgStyleId%>"/></div>
                        </logic:equal>
                        <% if (haveRightsToViewTask) { %>
                            <% if( task.hasParentTask() ) { %>
                                <span class="parent-task-name">
                                    <%=ResponseUtils.filter( ( ( TaskWithParentTaskBean ) task.getTask() ).getParentTask().getName() )%>
                                </span>
                                <%=message(request, "common.hierarchy_levels_separator")%>
                            <% } %>
                            <span class="<%=task.hasParentTask() ? "sub-task-name" : ""%>" >
                                <span class="task"><bean:write name="task" property="name"/></span>
                            </span>
                        <% } else { %>
                            <% if( task.hasParentTask() ) { %>
                                <%=ResponseUtils.filter( ( ( TaskWithParentTaskBean ) task.getTask() ).getParentTask().getName() )%>
                                <%=message(request, "common.hierarchy_levels_separator")%>
                            <% } %>
                            <bean:write name="task" property="name"/>
                        <% } %>
                    </td><%--
                --%><% if (haveRightsToViewTask && !task.isDescriptionEmpty()) { %><%--
                   --%><td valign="middle" align="right" rowspan="2"
                            ><a href="javascript:void(0)" class="task_description"
                                onclick=" return showSubmitTTTaskDescription(<%=task.getId()%>, this, <%=descriptionEntity%>)"
                                title="<%=taskDescription%>"
                            ><at:img page="dialogs/comments/view_comment.png"
                                     width="16" height="16" border="0"/></a
                            ></td>
                    <% } %>
                </tr>
                <tr>
                    <td class="task-customer-and-project">
                        <span class="customer"><%=ResponseUtils.filter(task.getProject().getCustomer().getName())%></span>
                        <%=message(request, "common.hierarchy_levels_separator")%>
                        <span class="project"><%=ResponseUtils.filter(task.getProject().getName())%></span>
                    </td>
                </tr>
             </table>
        </td><%--
    --%><td width="" class="listtblcell_submit_tt <%=backgroundClass%> deadlineCell" title="<%=taskTitle%>">
            <logic:empty name="task" property="deadlineDate"><span class="deadline_NA"><bean:message key="common.not_available"/></span></logic:empty>
            <logic:notEmpty name="task" property="deadlineDate">
                <logic:equal value="false" property="completed" name="task">
                    <span id="deadline<%=task.getId()%>" class="<%=(task.isDeadlineInThePast( weekInfo.getTimeZone() ) ? "deadline_in_the_past" : "deadline")%>"
                          title="<%=(task.isDeadlineInThePast( weekInfo.getTimeZone() ) ? taskDeadLine : "")%>">
                        <%=task.getDeadlineDate() == null ? message( request, "common.not_available" ) : TimeUtils.formatDate(task.getDeadlineDate(), settings.getDateFormat())%>
                    </span>
                </logic:equal>
                <logic:equal value="true" property="completed" name="task">
                    <%=task.getDeadlineDate() == null ? message( request, "common.not_available" ) : TimeUtils.formatDate(task.getDeadlineDate(), settings.getDateFormat())%>
                </logic:equal>
            </logic:notEmpty>
        </td><%--
--%><%
       for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++)
       {
         boolean today = weekInfo.isToday(day);
         String className = today ? "calendarCurrentDayNormal" : (data.isUserWorkingDay( day )) ? "calendarWorkingDayNormal" : "calendarWeekendDayNormal";

         int taskID = task.getId();
         String spentProp = "timeTrack["+taskID+"].spentStr["+day+"]";
         String hasCommentHidden = "timeTrack["+taskID+"].hasComments[" + day + "]";
         String hilightObjId = "timeTrack[" + taskID + "].obj[" + day + "]";
         String onBlur = "return checkSpent(" + day + ", this, true);";
         String inputStyle = "";
         String spanStyle = "";
         String completedTaskId = "complTask[" + taskID + "].day[" + day + "]";
         String title = "";
         Date date = weekInfo.getDayOfWeek(day);
         
         if(validationErrors.getErrorForTTField(taskID, day) != null)
         {
             inputStyle += "border-color: " + ColorHelper.getColor(  "error.control.color", request ) + "; border-style:solid";
             title = validationErrors.getErrorForTTField(taskID, day);
         }
         else if(validationErrors.getErrorForDay(day) != null)
         {
             title = validationErrors.getErrorForDay(day);
             inputStyle += "color:" + ColorHelper.getColor(  "error.control.color", request );
             spanStyle = "color:" + ColorHelper.getColor(  "error.control.color", request );
         }
    %><%--
      --%><td align="center" class="<%=className%> <% if(day==Week.LAST_DAY) { %>lastInRow<% } %> <% if (today) { %>today<% } %>" nowrap id="<%=hilightObjId%>" valign="middle" title="<%=taskTitle%>">
            <html:hidden name="form" property='<%=hasCommentHidden%>'/>
        <%
            boolean isReadOnlyCell = !data.canEdit(AuthController.getLoggedInUserWithAccessRights( request), user, task, day, isOtherUserSelected, projectAssignmentsFeatureEnabled );
            boolean hasTTOrComments = form.getTimeTrack(taskID).getSpent(day) > 0 || taskInfo.getCommentAvailable(day);
                if ( (!weekInfo.isFutureDayAndRestricted(day) && isReadOnlyCell) ||
                     (weekInfo.isFutureDayAndRestricted(day) && hasTTOrComments)) {
        %>
                <table width="100%" cellspacing="0" cellpadding="0">
                    <tr>
                        <logic:notEmpty name="form" property="<%=spentProp%>">
                            <td align="right">
                                <span class="text completedTimeText" id="<%=completedTaskId%>" style="<%=spanStyle%>"
                                      >&nbsp;<%=TimeUtils.formatWork(form.getTimeTrack(taskID).getSpent(day), settings)%>
                                </span>
                            </td>
                        </logic:notEmpty>
                        <logic:empty name="form" property="<%=spentProp%>">
                            <td align="right">
                                <span class="text completedTimeText">
                                    <nobr>--&nbsp;&nbsp;&nbsp;</nobr>
                                </span>
                            </td>
                        </logic:empty>
                        <td align="right" width="1">
                            <logic:equal value="true" property='<%="commentAvailable[" + day + "]"%>' name="taskInfo">
                                <a title='<bean:message key="submit_tt.comments.title"/>'
                                   href="javascript:void(0);"
                                   onclick="showReadOnlyComments(<%=taskID%>, <%=day%>, '<%=TimeUtils.formatUniformDate(date)%>', '<%=hilightObjId%>', this);">
                                    <at:img page="dialogs/comments/view_comment.png"
                                          border="0"
                                          align="absmiddle"
                                          hspace="3"/>
                                </a>
                            </logic:equal>
                            <logic:notEqual value="true" property='<%="commentAvailable[" + day + "]"%>' name="taskInfo">
                                <at:img page="pixel.gif" border="0" align="absmiddle" hspace="3" width="16" height="18"/>
                            </logic:notEqual>
                        </td>
                    </tr>
                </table>
            <%} else if(!weekInfo.isFutureDayAndRestricted(day)){%>
                <%
                     String imageName = "timeTrack[" + taskID + "].commentImg[" + day + "]";
                %>
                <table width="100%" cellspacing="0" cellpadding="0" class="inputTTContaner" style="padding: 0 0 0 0; margin: 0 0 0 0;">
                  <tr>
                      <td align="right"><html:text styleId='<%="spent_" + taskID + "_" + day%>' style="<%=inputStyle%>" title="<%=title%>" styleClass="text inputTT" property="<%=spentProp%>" onblur="<%=onBlur%>" onfocus="focusSpent(this);" size="5" maxlength="6"/></td>
                      <td align="right" width="15px"><a href="javascript:void(0)" class="cursorImageLink" onclick="showEditableComments(<%=taskID%>, <%=day%>, '<%=TimeUtils.formatUniformDate(date)%>', '<%=hilightObjId%>', this); return false;"><at:img page='<%=taskInfo.getCommentAvailable(day)?"dialogs/comments/comment_entered.png":"dialogs/comments/comment_blank.png"%>' title='<%=message(request, "submit_tt.description_tooltip")%>' style="margin: 6px 2px 6px 3px" align="absmiddle" border="0" styleId="<%=imageName%>" /></a></td>
                  </tr>
                </table>

                <%-- Workaround for bug 23140: Pers. Shed: Error is hidden when it should not (kostenko) --%>
                <% if (ttChanges.isTimeForTaskChangedWithinDay(taskID, day)) { %>
                    <script type="text/javascript">
                        var field = document.getElementById("<%="spent_" + taskID + "_" + day%>");
                        registerModifiedTTField(<%=day%>, field);
                    </script>
                <% } %>

        <% } else { %>
            &nbsp;
        <% } %>
        </td><%--
--%><% } %><%--
    --%><td class="selectionRightSeparator" id="<%=("selectionRightSeparator"+task.getId())%>"></td><%--
    --%><td class="selectionRightContainer" id="<%=("selectionRightContainer"+task.getId())%>">
            <div class="selectionCursorRightLug" id="<%=("selectionRightLug"+task.getId())%>">
                <%
                    String cantRemoveTip = "";
                    if (!task.isCanBeRemoved())
                    {
                        if (task.isCompleted())
                            cantRemoveTip = message( request, ( "submit_tt.button.remove.completed.tip.task" ) );
                        else if (data.hasLockedTimeOrComments(task.getId(), form.getTimeTrackMap()))
                            cantRemoveTip = message( request, "submit_tt.button.remove.locked.tip.task"  );
                        else if (data.hasFutureAndRestrictedTimeOrComments( task.getId(), form.getTimeTrackMap() ))
                            cantRemoveTip = message( request, "submit_tt.button.remove.future.tip.task" );
                        else if (isOtherUserSelected)
                            cantRemoveTip = message( request, "submit_tt.button.remove.he_noaccess.tip.task",
                                                     ResponseUtils.filter( user.getFormattedName( NameUtil.Format.FML ) ) );
                        else
                            cantRemoveTip = message( request, "submit_tt.button.remove.you_noaccess.tip.task" );
                    }

                    String cantCompleteTip = "";
                    if (!task.isCanBeCompleted()) {
                        cantCompleteTip = message( request, "submit_tt.button.cannot_complete_unassgined.tooltip.task" );
                    }

                    String cantReopenTip = "";
                    if (!task.isCanBeReopened()) {
                        if (SubmitTTAccessRightsUtils.canViewerAccessTask( request, task ))
                            cantReopenTip = message( request, "submit_tt.button.cannot_reopen_archived.tooltip.task" );
                        else
                            cantReopenTip = message( request, "submit_tt.button.cannot_reopen_unassigned.tooltip.task" );
                    }
                %>
                <logic:equal value="false" name="task" property="completed">
                    <% if (canManageTasks) { %>
                        <logic:equal value="true" name="task" property="canBeCompleted">
                            <div class="taskButton completeTaskButton" title="<%=completeButtonTip%>"><a href="javascript:" onclick="completeTask(<%=task.getId()%>); return false;"><%=completeButtonText%></a></div>
                            <div class="taskButton undoCompleteTaskButton" title="<%=undoCompleteButtonTip%>"><a href="javascript:" onclick="completeTask(<%=task.getId()%>); return false;"><%=undoCompleteButtonText%></a></div>
                        </logic:equal>
                        <logic:equal value="false" name="task" property="canBeCompleted">
                            <div class="taskButton completeTaskButtonDisabled" title="<%=cantCompleteTip%>"><span class="disabledButtonText"><%=completeButtonText%></span></div>
                        </logic:equal>
                    <% } %>
                    <logic:equal value="true" name="task" property="canBeRemoved">
                        <div class="taskButton removeTaskButton" title="<%=removeButtonTip%>"><a href="javascript:" onclick="deleteTimeTrack(<%=task.getId()%>); return false;"><%=removeButtonText%></a></div>
                        <div class="taskButton undoRemoveTaskButton" title="<%=undoRemoveButtonTip%>"><a href="javascript:" onclick="deleteTimeTrack(<%=task.getId()%>); return false;"><%=undoRemoveButtonText%></a></div>
                    </logic:equal>
                    <logic:equal value="false" name="task" property="canBeRemoved">
                        <div class="taskButton removeTaskButtonDisabled" title="<%=cantRemoveTip%>"><span class="disabledButtonText"><%=removeButtonText%></span></div>
                    </logic:equal>
                </logic:equal>
                <logic:equal value="true" name="task" property="completed">
                    <% if (canManageTasks) { %>
                        <logic:equal value="true" name="task" property="canBeReopened">
                            <div class="taskButton reopenTaskButton" title="<%=reopenButtonTip%>"><a href="#reopenTask" onclick="reopenTask(<%=task.getId()%>)"><%=reopenButtonText%></a></div>
                        </logic:equal>
                        <logic:equal value="false" name="task" property="canBeReopened">
                            <div class="taskButton reopenTaskButtonDisabled" title="<%=cantReopenTip%>"><span class="disabledButtonText"><%=reopenButtonText%></span></div>
                        </logic:equal>
                    <% } else { %>
                        <div class="taskButton removeTaskButtonDisabled" title="<%=cantRemoveTip%>"><span class="disabledButtonText"><%=removeButtonText%></span></div>
                    <% } %>
                </logic:equal>
            </div>
        </td>
    </tr>
    <%
        evenRow = !evenRow;
    %>
    </logic:iterate>
    </tbody>
</logic:equal>
<%
    if (isOtherUserSelected && settings.isHideNotAssignedTTDetails() && data.getNotAssignedTasksCount() > 0) {
%>
<tr class="taskRow notAssignedTaskRow collapsed">
    <td class="selectionLeftContainer"></td>
    <td class="listtblcell_submit_tt listtblcell_submit_tt_background taskNameColumn firstInRow" colspan="2"><bean:message key="submit_tt.not_available_tasks_collapsed" arg0="<%=String.valueOf(data.getNotAssignedTasksCount())%>"/></td>
    <%
        for (int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++)
        {
            String spentProp = "notAssignedTimeTrack.spentStr[" + day + "]";
    %>
    <td class="day <% if (day == Week.LAST_DAY) { %>lastInRow<% } %> <% if (weekInfo.isToday(day)) { %>today<% } %>" align="center" nowrap valign="middle">
        <table width="100%" cellspacing="0" cellpadding="0">
            <tr>
                <logic:notEmpty name="form" property="<%=spentProp%>">
                    <td align="right">
                        <span class="text completedTimeText"
                        >&nbsp;<%=TimeUtils.formatWork(form.getNotAssignedTimeTrack().getSpent(day), settings)%>
                        </span>
                    </td>
                </logic:notEmpty>
                <logic:empty name="form" property="<%=spentProp%>">
                    <td align="right">
                        <span class="text completedTimeText">
                          <nobr>--&nbsp;&nbsp;&nbsp;</nobr>
                        </span>
                    </td>
                </logic:empty>
                <td align="right" width="1"></td>
            </tr>
        </table>
    </td>
    <% } %>
    <td class="selectionRightContainer" colspan="2"></td>
</tr>
<% } %>
<%
    PreviousWeekTasksBlock previousWeekTasksBlock = data.getPreviousWeekTasksBlock();
%>
<% if ( previousWeekTasksBlock.isBlockVisible() ) {
    String myOtherSuffix = isOtherUserSelected ? "other" : "my";
%>
    <tr><%--
    --%><td class="selectionLeftContainer" width="21px"></td><%--
    --%><td align="center" colspan="9" class="noTasksForWeekBlock firstInRow lastInRow <% if (previousWeekTasksBlock.isTextVisible()) { %>bigBlock<% } else { %>onlyButtonsBlock<% } %>">
            <table style="width: 100%;">
                <% if (previousWeekTasksBlock.isNewUser()) { %>
                    <tr>
                        <td class="text hintLabel">
                            <div class="newTTUserBlock">
                                <%
                                    List<String> waysToAddTasks = new ArrayList<String>();
                                    waysToAddTasks.add( message( request, "submit_tt.new_user_msg.add_task.find_in_search" ) );
                                    waysToAddTasks.add( message( request, "submit_tt.new_user_msg.add_task.add_from_list" ) );
                                    if( canManageTasks )
                                    {
                                        waysToAddTasks.add( message( request, "submit_tt.new_user_msg.add_task.create_new_task" ) );
                                    }
                                %>
                                <div class="newTTUserBlockHeader">
                                    <%=message( request, "submit_tt.new_user_msg.big_label.first_line." + myOtherSuffix, user.getFormattedName( NameUtil.Format.FML ) )%><br>
                                    <%=message( request,
                                                waysToAddTasks.size() == 3 ?
                                                "submit_tt.new_user_msg.big_label.second_line.three_ways" :
                                                "submit_tt.new_user_msg.big_label.second_line.two_ways"
                                    )%>
                                </div>
                                <ul class="waysToAddTask">
                                    <% for (String wayToAddTask: waysToAddTasks) { %>
                                        <li class="wayToAddTask"><%=wayToAddTask%></li>
                                    <% } %>
                                </ul>
                            </div>
                        </td>
                    </tr>
                <% } else { %>
                    <% if (previousWeekTasksBlock.isTextVisible()) { %>
                        <% if (previousWeekTasksBlock.isDisabledWeek()) {
                            String textKey = previousWeekTasksBlock.isWholeWeekBeforeHireDate() ?
                                             (isOtherUserSelected ? "submit_tt.no_tasks_for_week.before_user_hire_date_week" : "submit_tt.no_tasks_for_week.before_your_hire_date_week") :
                                             "submit_tt.no_tasks_for_week.locked_week";
                        %>
                            <tr>
                                <td class="text hintLabel secondLine">
                                    <%=message(request, textKey)%>
                                </td>
                            </tr>
                        <% } else { %>
                            <tr>
                                <td class="text hintLabel firstLine">
                                    <bean:message key="submit_tt.no_tasks_for_week.big_label"/>
                                </td>
                            </tr>
                            <tr>
                                <td class="text hintLabel secondLine">
                                    <% if (previousWeekTasksBlock.isExistEnabledButton()) { %>
                                        <%=message( request, "submit_tt.no_tasks_for_week.help_caption.enabled_buttons_exist." + myOtherSuffix, user.getFormattedName( NameUtil.Format.FML ) )%>
                                    <% } else { %>
                                        <bean:message key="submit_tt.no_tasks_for_week.help_caption.enabled_buttons_does_not_exist"/>
                                    <% } %>
                                </td>
                            </tr>
                        <% } %>
                    <% } %>
                    <% if (previousWeekTasksBlock.isButtonsVisible()) {
                            String addReportedTasksButtonLabel = message( request, "submit_tt.button.add_previous_week_reported_tasks." + myOtherSuffix, user.getFormattedName( NameUtil.Format.FML ) );
                            String addAllTasksButtonLabel = message( request, "submit_tt.button.add_previous_all_tasks." + myOtherSuffix, user.getFormattedName( NameUtil.Format.FML ) );
                            String tooltipText = (!previousWeekTasksBlock.isDisabledWeek()) ? message(request, "submit_tt.button.disabled.tooltip") : "";
                    %>
                        <tr>
                            <td style="text-align: center;">
                                <div class="addPreviousWeekTasks_buttonsContainer">
                                    <table style="height: 100%;" cellpadding="0" cellspacing="0" border="0">
                                        <tr>
                                            <% if( previousWeekTasksBlock.isEnabledReportedTasksButton() ) { %>
                                                <td id="addPreviousWeekReportedTasksButton" class="taskListButton activeButton" onclick="addReportedPreviousWeekTasks()">
                                                    <div class="buttonPic_OnlyReportedTasks"></div><%=addReportedTasksButtonLabel%>
                                                </td>
                                            <% } else { %>
                                                <td id="addPreviousWeekReportedTasksButton" class="taskListButton disabledButton" title="<%=tooltipText%>">
                                                    <div class="buttonPic_OnlyReportedTasks"></div><%=addReportedTasksButtonLabel%>
                                                </td>
                                            <% } %>
                                            <td>
                                                <div class="addPreviousWeekTasks_orContainer">
                                                    <%=( previousWeekTasksBlock.isTextVisible() && previousWeekTasksBlock.isExistEnabledButton() ) ? message( request, "submit_tt.no_tasks_for_week.or" ) : ""%>
                                                </div>
                                            </td>
                                            <% if( previousWeekTasksBlock.isEnabledAllTasksButton() ) { %>
                                                <td id="addPreviousWeekAllTasksButton" class="taskListButton activeButton" onclick="addAllPreviousWeekTasks()">
                                                    <div class="buttonPic_AllTasks"></div><%=addAllTasksButtonLabel%>
                                                </td>
                                            <% } else { %>
                                                <td id="addPreviousWeekAllTasksButton" class="taskListButton disabledButton" title="<%=tooltipText%>">
                                                    <div class="buttonPic_AllTasks"></div><%=addAllTasksButtonLabel%>
                                                </td>
                                            <% } %>
                                        </tr>
                                        <% if (user.getId() == loggedInUser.getId()) { %>
                                            <tr>
                                                <td colspan="3">
                                                    <div id="chooseDefaultWayDiv">
                                                        <at:defImg page="cog.png" onclick="openMyProfilePopup()" styleClass="chooseDefaultWayImg"/>
                                                        <span class="chooseDefaultWayLink" onclick="openMyProfilePopup()"><span class="dashedLink"><bean:message key="submit_tt.choose_default_way.label"/></span></span>
                                                    </div>
                                                </td>
                                            </tr>
                                        <% } %>
                                    </table>
                                </div>
                            </td>
                        </tr>
                    <% } %>
                <% } %>
            </table>
        </td><%--
    --%><td class="selectionRightSeparator" width="1px"></td><%--
    --%><td class="selectionRightContainer" width="1px"></td>
    </tr>
<% } %>
<logic:equal name="data" property="tasks.empty" value="false">
<tr class="summaryTotal"><%--
--%><td class="selectionLeftContainer"></td><%--
--%><td class="summaryheader firstInRow" align="right" colspan="2">
        <table cellpadding="0" cellspacing="0" border="0" >
            <tr>
                <td class="weektotalheader"><bean:message key="submit_tt.work_total"/>:  </td>
                <td class="weektotalheader" align="right" width="62"><nobr>
                    &nbsp;<span id="weekTotal" value="<%=form.getWeekTotal(settings)%>"><%=form.getFormattedWeekTotal(settings)%></span>&nbsp;</nobr></td>
            </tr>
        </table>
    </td><%--
--%><% for(int day = 0; day <= 6; day++)
   {
     String className = getSummaryCellClassName(data, user, day);
     String align = (user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_TRUSTED && !data.isDayLockedOrBeforeHireDate(user, day)) ? "left" : "right";
     String title = validationErrors.getErrorForDay(day) == null ? "" : validationErrors.getErrorForDay(day);
     String style = validationErrors.getErrorForDay(day) == null ? "" : "color:" + ColorHelper.getColor(  "error.control.color", request );
%><%--
--%><td align="<%=align%>" class="<%=className%> <% if(day==6) { %>lastInRow<% } %>">
     <% if (!weekInfo.isFutureDayAndRestricted(day)) { %>
        <nobr><span class="daytotal" id="dayTotal[<%=day%>]" style="<%=style%>" title="<%=title%>" value="<%=form.getDayTotalStr(day, settings)%>"><%=form.getFormattedDayTotalStr(day, settings)%></span>&nbsp;</nobr>
    <% } else  { %>
        <at:img page="pixel.gif" width="58" height="1" alt=""/>
   <%  } %>
   </td><%--
--%><%}%><%--
--%><td class="selectionRightSeparator"></td><%--
--%><td class="selectionRightContainer"></td>
</tr>

<% if (isOvertimeTrackingEnabled) { %>
<logic:notEqual name="user" property="overtimeTrackingLevel" value="<%=Integer.toString(UserBean.OVERTIME_TRACKING_HIDDEN)%>">
    <logic:notEqual name="user" property="overtimeTrackingLevel" value="<%=Integer.toString(UserBean.OVERTIME_TRACKING_READONLY)%>">
        <% if (!wholeWeekDisabled) { %>
            <tr><%--
            --%><td class="selectionLeftContainer"></td><%--
            --%><% if (!weekInfo.isFutureDayAndRestricted(Week.FIRST_DAY)) { %><%--
            --%><td class="firstInRow" colspan="2" align="right" bgcolor="<%=ColorHelper.getColor("submittime.auto.overtime.row.bg.color", request )%>"><span class="commentmsg"><%=message( request,  "submit_tt.overtime.click_to_calculate_automatically", message( request, OvertimeLeavesUtil.getOvertimeMessageWithExtraSpaceKey()) )%> </span></td><%--
            --%><% } else  { %><%--
            --%><td class="firstInRow" colspan="2" bgcolor="<%=ColorHelper.getColor("submittime.auto.overtime.row.bg.color", request )%>"><span class="text">&nbsp;</span></td><%--
            --%><% }
                    for(int day = 0; day <= 6; day++)
                    {
                        String printableDayOfWeek = message( request, WorkingDaysUtils.getPrintableDayOfWeek_FullNameKey(day, weekInfo.getWeekStartDay()));
                        String overtimeButtonClass = "overtimebuttontd" + (weekInfo.isToday(day) ? "_today" : "");

                        if (!weekInfo.isFutureDayAndRestricted(day) && !data.isDayLockedOrBeforeHireDate(user, day))
                        { %><%--
                        --%><td align="left" class="<%=overtimeButtonClass%> <% if(day==6) { %>lastInRow<% } %>">&nbsp;&nbsp;
                            <% if(!disableOvertimeInputs[day])
                                {%>
                                    <a title="<%=message( request,  "submit_tt.overtime.click_to_set_automatic_mode_of_calculation", message(request, OvertimeLeavesUtil.getOvertimeMessageKey() ), printableDayOfWeek )%>" href="javascript:void(0)" onclick="Overtime.markDayAsAutocalculated(<%=day%>); return false;">
                                         <at:img page="overtime_button.gif" border="0" hspace="0"/>
                                    </a>
                            <% }
                                else
                            { %>
                                <at:img page="overtime_button_disabled.gif" border="0" hspace="0"/>
                         <% } %>
                </td><%--
            --%><%      }
                    else
                    { %><%--
            --%><td align="left" class="<%=overtimeButtonClass%> <% if(day==6) { %>lastInRow<% } %>">
                    <at:img page="pixel.gif" width="40" height="1"/><%--
            --%></td><%--
            --%><%  } %><%--
            --%><% } %><%--
            --%><td class="selectionRightSeparator"></td><%--
            --%><td class="selectionRightContainer"></td>
            </tr>
        <% } %>
    </logic:notEqual>
    <tr class="overtimeheader"><%--
--%><td class="selectionLeftContainer"></td><%--
--%><td class="firstInRow" align="right" colspan="2" >
        <table cellpadding="0" cellspacing="0" border="0">
            <tr>
                <logic:equal name="user" property="overtimeTrackingLevel" value="<%=Integer.toString(UserBean.OVERTIME_TRACKING_READONLY)%>">
                    <td class="overtimeheader"><bean:message key="submit_tt.overtime.auto-calculated" arg0="<%=message( request, OvertimeLeavesUtil.getCapitalizedOvertimeMessageKey())%>"/>: </td>
                </logic:equal>
                <logic:notEqual name="user" property="overtimeTrackingLevel" value="<%=Integer.toString(UserBean.OVERTIME_TRACKING_READONLY)%>">
                    <td class="overtimeheader"><%=message( request, OvertimeLeavesUtil.getCapitalizedOvertimeMessageKey() )%>: </td>
                </logic:notEqual>
                <% String totalOvertime = TimeUtils.formatWork(form.getTotalOvertime(data.getWorkdayDurations(), weekInfo, settings)); %>
                <td class="overtimeheader" align="right" width="62" nowrap><nobr>&nbsp;<span id="overtimeTotal"><%=totalOvertime%></span>&nbsp;</nobr></td>
            </tr>
        </table>
    </td><%--
--%><% for(int day = Week.FIRST_DAY; day <= Week.LAST_DAY; day++)
   {
       String title = "";
       String style = "font-family: monospace; width: 100%";
       if(validationErrors.getOvertimeError(day) != null)
       {
            style += " border-style:solid; border-color: " + ColorHelper.getColor(  "error.control.color", request );
            title = validationErrors.getOvertimeError(day);
       }

%><%--
--%><% String className = getSummaryCellClassName(data, user, day); %><%--
--%><% if (!weekInfo.isFutureDayAndRestricted(day)) { %><%--
--%><% if(user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_READONLY || data.isDayLockedOrBeforeHireDate(user, day))
      {
          if (!data.isDayInDateInterval(day, user.getHireDate(), user.getReleaseDate()) &&
              user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_READONLY)
          {
              String tooltip = weekInfo.getDayOfWeek(day).compareTo(user.getHireDate()) < 0 ?
                      naOvertimeBeforeHireDateTooltip.toString() :
                      naOvertimeAfterReleaseDateTooltip.toString();
        %><%--
          --%><td align="center" title='<%=ResponseUtils.filter(tooltip)%>' class="naOvertime <%=className%> <% if(day==Week.LAST_DAY) { %>lastInRow<% } %>">
                  <span><nobr><%=StringUtils.encodeNewLineSymbols(message( request, "submit_tt.overtime.not_employed" ))%></nobr></span>
              </td><%--
   --%><% } else if (weekInfo.isFutureDay(day) && user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_READONLY) { %><%--
            --%><td align="center" title="<%=ResponseUtils.filter(naOvertimeInFutureTooltip.toString())%>" class="naOvertime <% if(day==Week.LAST_DAY) { %>lastInRow<% } %>">
                    <span><nobr><%=StringUtils.encodeNewLineSymbols(message( request, "submit_tt.overtime.future_date" ))%></nobr></span>
                </td><%--
   --%><% } else {
              String overtimeValue = TimeUtils.formatWork(form.getAutocalculatedOvertime(day, data.getWorkdayDurations(), settings));
        %><%--
          --%><td align="right" class="<%=className%> <% if(day==Week.LAST_DAY) { %>lastInRow<% } %>">
                  <nobr><span class="daytotal" id="overtime[<%=day%>].overtimeStr"><%=overtimeValue%></span>&nbsp;</nobr>
              </td><%--
--%><%
          }
      }
      else
      {
    %><%--
     --%><td align="left" class="<%=className%> <% if(day==Week.LAST_DAY) { %>lastInRow<% } %>" >
            <table cellspacing="0" cellpadding="0" width="100%" class="inputTTContaner">
                <tr align="right">
                    <td align="right" nowrap style="padding-right: 4px;">
                        <html:text style="<%=style%>"
                                   title="<%=title%>"
                                   styleClass="text inputTT"
                                   property='<%="overtime[" + day + "].overtimeStr"%>'
                                   styleId='<%="overtime[" + day + "].overtimeStr"%>'
                                   value='<%=form.getOvertime( day ).isAutocalculated() ? message(request, "submit_tt.autocalculated_message" ) : form.getOvertime( day ).getOvertimeStr() %>'
                                   onfocus='<%="Overtime.startEditingDay(this, " + day + "); focusSpent(this);"%>'
                                   onblur='<%="Overtime.endEditingDay(this, " + day + ")"%>'
                                   size="5"
                                   maxlength="6"
                                   disabled="<%=disableOvertimeInputs[day]%>"/>
                    </td>
                    <td valign="middle" style="width: 21px;" align="right">
                    <at:img styleId='<%="overtimeMarkPlaceholder" + day%>' page="pixel.gif" width="17" height="17" border="0"/>
                    <script type="text/javascript"> var thirdHierarchyLevelName = "<%=jsMessage(request, "common.tasks")%>";</script>
                    <a id="overtimeQuestionMark<%=day%>" style="display: none;" href="javascript:void(0)" onclick="Overtime.showQuestionHint(<%=day%>, thirdHierarchyLevelName, this)" onmouseover="Overtime.showDelayedHint(<%=day%>, thirdHierarchyLevelName, this, Overtime.getQuestionMarkMessage)" onmouseout="Overtime.dhtmlTitle.cancelDelayedShow()"><at:img page="question.gif" width="17" height="17" border="0" hspace="2"/></a>
                    <a id="overtimeExclamationMark<%=day%>" style="display: none;" href="javascript:void(0)" onclick="Overtime.showExclamationHint(<%=day%>, this)" onmouseover="Overtime.showDelayedHint(<%=day%>, thirdHierarchyLevelName, this, Overtime.getExclamationMarkMessage)" onmouseout="Overtime.dhtmlTitle.cancelDelayedShow()"><at:img page="exclamation.gif" width="17" height="17" border="0" hspace="2"/></a>
                    </td>
                </tr>
            </table>
        </td><%--
--%><%}
    } else  { %><%--
--%><td align="left" class="<%=className%> <% if(day==Week.LAST_DAY) { %>lastInRow<% } %>">
        <at:img page="pixel.gif" width="40" height="1"/>
    </td><%--
--%><% }
   } %><%--
--%><td class="selectionRightSeparator"></td><%--
--%><td class="selectionRightContainer"></td>
</tr>

</logic:notEqual>
<% } %>
</logic:equal>
</table>
<%
    boolean isAPIntegrated = LicenseHelper.isOtherProductIntegrated(Product.actiTIME );
    if (form.isContainsLeaves() && (!weekInfo.isFutureDay(Week.FIRST_DAY) || !isAPIntegrated)  || !data.getTasks().isEmpty())
    {
        boolean submitButtonDisabled = data.isSubmitButtonDisabled(user, form.isContainsLeaves());
        String submitButtonTitle = message(request, "submit_tt.submit_button.save_changes");
        String savingButtonTitle = message(request, "submit_tt.saving");
%>
<br>
<table class="mainSidesPadding hide-element-before-sorting-tasks"  cellspacing="0" cellpadding="0" border="0"  width="100%" style="width:expression(navigator.appVersion && navigator.appVersion.indexOf('MSIE') > -1 ? '100%' : 'auto')">
<tr><td width="100%">
<table width="100%" bgcolor="<%=ColorHelper.getColor("default.bg.color", request )%>" align="center" cellspacing="0" cellpadding="6" border="0">
<tr>
    <td align="center" class="formbuttonpane wideButtonPane">
        <span class="submitTTPanel bottomPanel">
            <input type="button" id="SubmitTTButton" class="saveButton submitTTSaveButton" value="<%=submitButtonTitle%>"
                <% if(!submitButtonDisabled || isWeekStatusIsPresent) { %>
                onclick="SubmitTimeTrack(event, <%=settings.isHoursPerDayLimited()%>, <%=(settings.isHoursPerDayLimited() ? settings.getMaximumMinutesPerDay().toString() : "0")%>, '<%=(settings.isHoursPerDayLimited() ? TimeUtils.formatWork(settings.getMaximumMinutesPerDay().intValue()) : "")%>');"
                <% }
                 if (submitButtonDisabled) { %>
                    disabled="true"
                <% } %>
            >
            <input type="button" class="savingButton submitTTSavingButton" value="<%=savingButtonTitle%>" disabled="true">
            <span class="submitTTButtonsSeparator">&nbsp;</span>
            <span class="cancelTTEditingButton customLink cancelButton"><bean:message key="submit_tt.cancel"/></span>
            <% if ( isWeekStatusIsPresent ) { %>
                <div class="weekApprovalStatusControlOuterContainer bottom">
                    <jsp:include page="/controls/change_week_approval_status_control.jsp">
                        <jsp:param name="isMyOwnTT" value="<%= isMyOwnTT %>"/>
                        <jsp:param name="currentStatusStyle" value="<%= weekStatusStyle %>"/>
                    </jsp:include>
                </div>
            <% } %>
        </span>
    </td>
</tr>
</table>
</td><td><% antiJitteringFix(request, out); %></td></tr>
</table>
<%
    }
%>

<logic:equal name="data" property="tasks.empty" value="false">
<%
    boolean weekContainsUnemployedDays =
            user.getHireDate() != null && weekInfo.getDayOfWeek(Week.FIRST_DAY).compareTo(user.getHireDate()) < 0 ||
            user.getReleaseDate() != null && weekInfo.getDayOfWeek(Week.LAST_DAY).compareTo(user.getReleaseDate()) > 0 && user.getReleaseDate().compareTo(TimeUtils.today( weekInfo.getTimeZone() )) < 0;

    boolean showCantTrackInFutureNote =
            weekInfo.isFutureDayAndRestricted(Week.LAST_DAY);

    boolean showManualOvertimeNote =
            isOvertimeTrackingEnabled && user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_TRUSTED &&
            !weekInfo.isFutureDayAndRestricted(Week.FIRST_DAY) &&
            !data.isDayLocked(Week.LAST_DAY);

    boolean showUnemployedDaysOvertimeInTrustedModeNote =
            showManualOvertimeNote && weekContainsUnemployedDays;

    boolean showGeneralEditingNote =
            !weekInfo.isFutureDayAndRestricted(Week.FIRST_DAY) &&
            !isAllTasksCompleted &&
            !data.isDayLocked(Week.LAST_DAY);

    boolean showUnemployedDaysOvertimeInReadOnlyModeNote =
            isOvertimeTrackingEnabled && user.getOvertimeTrackingLevel() == UserBean.OVERTIME_TRACKING_READONLY &&
            !weekInfo.isFutureDayAndRestricted(Week.FIRST_DAY) &&
            weekContainsUnemployedDays;

    boolean hasNotes =
                showCantTrackInFutureNote ||
                showManualOvertimeNote ||
                showUnemployedDaysOvertimeInTrustedModeNote ||
                showGeneralEditingNote ||
                showUnemployedDaysOvertimeInReadOnlyModeNote;

    if(hasNotes) {
%>
<table width="100%" class="mainSidesMargin hide-element-before-sorting-tasks" bgcolor="<%=ColorHelper.getColor("default.bg.color", request )%>" align="center" cellspacing="0" cellpadding="4" border="0">
<tr><td><at:img page="pixel.gif" height="1" width="50"/></td></tr>
<% if (showCantTrackInFutureNote) { %>
<tr>
    <td valign="top" class="mainSidesMarginIE">
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td valign="top" style="padding-right:6px;"><at:img page="note_mark.gif"/></td>
                <td valign="top">
                   <div class="notemsg"><bean:message key="submit_tt.enter_tt_for_future.note"/></div>
                </td>
            </tr>
        </table>
    </td>
</tr>
<% } %>
<% if (showManualOvertimeNote) { %>
<tr>
    <td class="mainSidesMarginIE">
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td valign="top" style="padding-right: 6px; padding-top: 0;"><at:img page="note_mark.gif"/></td>
                <td valign="top">
                        <div class="notemsg">
                            <%=message( request, "submit_tt.overtime.manual.note.part1", message( request, OvertimeLeavesUtil.getCapitalizedOvertimeMessageKey()))%>
                            &quot;<at:img page="exclamation.gif" align="absmiddle"/>&quot;
                            <% if (form.isContainsLeaves()) { %>
                            <%=message( request, "submit_tt.overtime.manual.note.part2.with_leaves", message( request, OvertimeLeavesUtil.getOvertimeMessageWithExtraSpaceKey()))%>
                            <% } else { %>
                            <%=message( request, "submit_tt.overtime.manual.note.part2", message( request, OvertimeLeavesUtil.getOvertimeMessageWithExtraSpaceKey()))%>
                            <% } %>
                            &quot;<at:img page="question.gif" align="absmiddle"/>&quot;
                            <bean:message key="submit_tt.overtime.manual.note.part3"/>
                        </div>
                </td>
            </tr>
        </table>
    </td>
</tr>
<% } %>
<% if (showUnemployedDaysOvertimeInTrustedModeNote) { %>
<tr>
    <td class="mainSidesMarginIE">
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td valign="top" style="padding-right: 6px; padding-top: 0;"><at:img page="note_mark.gif"/></td>
                <td valign="top">
                    <div class="notemsg">
                        <%=message( request, "submit_tt.overtime.auto.note", message( request, OvertimeLeavesUtil.getOvertimeMessageWithExtraSpaceKey() ))%>
                    </div>
                </td>
            </tr>
        </table>
    </td>
</tr>
<% } %>
<% if(showGeneralEditingNote) { %>
<tr>
    <td valign="top" class="mainSidesMarginIE">
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td valign="top" style="padding-right:6px;"><at:img page="note_mark.gif"/></td>
                <td valign="top">
                        <div class="notemsg">
                            <bean:message key="submit_tt.general_edit.note.part1"/><at:img page="pixel.gif" width="12" height="7" style="border: 1px solid red"/><bean:message key="submit_tt.general_edit.note.part2"/>
                        </div>
                          <% if(settings.isHoursPerDayLimited()) { %>
                           <div class="notemsg">
                           <%=message( request, "submit_tt.general_edit.note.part3", TimeUtils.formatWork(settings.getMaximumMinutesPerDay()))%>
                        </div>
                        <% } %>
                </td>
            </tr>
        </table>
    </td>
</tr>
<% } %>
<% if (showUnemployedDaysOvertimeInReadOnlyModeNote) { %>
<tr>
    <td class="mainSidesMarginIE">
        <table border="0" cellpadding="0" cellspacing="0">
            <tr>
                <td valign="top" style="padding-right: 6px; padding-top: 0;"><at:img page="note_mark.gif"/></td>
                <td valign="top">
                    <div class="notemsg">
                        <%=message(request, "submit_tt.overtime.read_only.note", message( request, OvertimeLeavesUtil.getCapitalizedOvertimeMessageKey() ))%>
                    </div>
                </td>
            </tr>
        </table>
    </td>
</tr>
<% } %>
</table>
<% } %>
</logic:equal>
<%}%>

<at:img page="pixel.gif" width="900" height="1"/><br/><!-- IE td whitespace fix -->

</td></tr>
</table>
</at:form>

<script>
    FirefoxFormCacheFix.init(document.SubmitTTForm);
</script>

<at:script page="/user/submit_tt/task_list.js"/>
<at:script page="/user/submit_tt/TaskListTableController.js"/>

<%@include file="/js/util/server_date_time_utils_js.jsp"%>

<at:script page='/js/addNewTasks/CreateNewTasksComponent.js'/>

<script>
    <%
    Set<Integer> addedTasks = new HashSet<Integer>();
    Set<Integer> addedProjects = new HashSet<Integer>();
    Set<Integer> addedCustomers = new HashSet<Integer>();
    for (SubmitTTTaskBean task: data.getTasks()) {
        boolean notAssigned = !(loggedInUserWithRighs.isHasAccessToAllProjects(projectAssignmentsFeatureEnabled) ||
                               (task.isBelongToProjectAssignedToPageViewer() != null && task.isBelongToProjectAssignedToPageViewer()));

        CustomerBean customer = task.getProject().getCustomer();
        if (!addedCustomers.contains( customer.getId() )){
            %>SubmitTTData.addCustomer( <%=customer.getId()%>, '<%=StringUtils.getStringEscapedForJS(customer.getName())%>' );<%
            addedCustomers.add( customer.getId() );
        }

        ProjectBean project = task.getProject();
        if (!addedProjects.contains( project.getId() )){
            %>SubmitTTData.addProject( <%=project.getId()%>, '<%=StringUtils.getStringEscapedForJS(project.getName())%>', <%=project.getCustomerId()%> );<%
            addedProjects.add( project.getId() );
        }
        if (task.hasParentTask()){
            TaskBean parentTask = task.getTask().getParentTask();
            if (!addedTasks.contains( parentTask.getId() )){
                %>SubmitTTData.addTask( <%=parentTask.getId()%>, '<%=StringUtils.getStringEscapedForJS(parentTask.getName())%>', <%=notAssigned%>, <%=parentTask.getProject().getId()%>, SubmitTTData.TASK_WITHOUT_PARENT_ID );<%
                addedTasks.add( parentTask.getId() );
            }
        }
        if (!addedTasks.contains( task.getId() )){
            %>SubmitTTData.addTask( <%=task.getId()%>, '<%=StringUtils.getStringEscapedForJS(task.getName())%>', <%=notAssigned%>, <%=task.getProject().getId()%>,
               <% if (task.hasParentTask()){%><%=task.getTask().getParentTaskId()%><%}else{%>SubmitTTData.TASK_WITHOUT_PARENT_ID<%}%> ); <%
            addedTasks.add( task.getId() );
        }
    }
    %>

    SubmitTTData.notAssignedTasksCount = <%=data.getNotAssignedTasksCount()%>;

    Ext.onReady(function(){
        var container = document.getElementById("container");
        if (container) {
            container.onmousedown = hideSelectionCursorIfNeeded;
            container.onmousemove = hideSelectionCursorIfNeeded;
        }

        function getActualPageSettings()
        {
            return {
                taskOrder: taskListTableController.getCurrentState().taskOrder
            };
        }

        var submitTTSettings = <%=jsHelper.toJSON( request.getAttribute(  Keys.SUBMIT_TT_SETTINGS_KEY ) )%>;

        var taskListTableController = new TaskListTableController().init( submitTTSettings );
        taskListTableController.sortTasks();

        function onChangeSortOrderFunction( sortOrder )
        {
            return function ( event )
            {
                taskListTableController.changeSortOrder( sortOrder );
                makeRpcCall( "EnterTTService.savePageSettings",
                             [
                                 getActualPageSettings()
                             ],
                             function () {return true;}, function () {return true;} // do not to respond in any case
                );
            };
        }

        $( '#sortByTaskNameLink' ).click( onChangeSortOrderFunction( SubmitTTConstants.TASK_LIST_ORDER_BY_TASK_NAME ) );
        $( '#sortByProjectNameLink' ).click( onChangeSortOrderFunction( SubmitTTConstants.TASK_LIST_ORDER_BY_PROJECT_NAME ) );
        $( '#sortByCustomerNameLink' ).click( onChangeSortOrderFunction( SubmitTTConstants.TASK_LIST_ORDER_BY_CUSTOMER_NAME ) );

        $( '.hide-element-before-sorting-tasks' ).removeClass( 'hide-element-before-sorting-tasks' );

        $( '.taskListButton' ).each( function ()
                                     {
                                         disableTextSelection( this, true );
                                     } );

        highlightJustAddedTasks();
    } );

    window.onresize = function() {
        if ( !isAndroid() )
            closeAllPopups();
    };

    /**
     * Marks given task for reopening and submits the form.
     * @param taskId Task ID
     */
    function reopenTask(taskId)
    {
        if (!closeAllPopups()) return false;
        if (isTaskInArchivedProject(taskId))
        {
            forbidMovingCursor();

            var msg = messageResource.getMessage("submit_tt.reopen.task.from.archived.project.confirm");

            var confirmed = confirm(msg);

            allowMovingCursor();

            if (!confirmed) return;
        }

        document.SubmitTTForm.taskToReopen.value = taskId;
        document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.REOPEN_TASK_ACTION %>';
        submitSubmitTTForm()
    }

    function addAllPreviousWeekTasks()
    {
        document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.ADD_ALL_PREVIOUS_WEEK_TASKS_ACTION %>';
        submitSubmitTTForm();
    }

    function showNextReadyWeek()
    {
        document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.SHOW_NEXT_READY_WEEK %>';
        document.SubmitTTForm.submit();
    }

    function showPrevReadyWeek()
    {
        document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.SHOW_PREV_READY_WEEK %>';
        document.SubmitTTForm.submit();
    }

    function addReportedPreviousWeekTasks()
    {
        document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.ADD_REPORTED_PREVIOUS_WEEK_TASKS_ACTION %>';
        submitSubmitTTForm();
    }

    function reloadSubmitTTPageWithoutFormReloading()
    {
        document.SubmitTTForm.pageAction.value = '<%=SubmitTTForm.ENTER_TT_RELOAD_ACTION%>';
        submitSubmitTTForm();
    }

    function setApprovalStatusToSubmitTTForm( status )
    {
        document.SubmitTTForm.effectiveWeekStatusName.value = status;
    }

    function submitSubmitTTFormWithApprovalStatusAndComment( status, comment )
    {
        document.SubmitTTForm.rejectWeekComment.value = comment;
        submitSubmitTTFormWithApprovalStatus(status);
    }
    function submitSubmitTTFormWithApprovalStatus( status )
    {
        var oldWeekStatusValue = document.SubmitTTForm.effectiveWeekStatusName.value;

        document.SubmitTTForm.effectiveWeekStatusName.value = status;
        document.SubmitTTForm.doSaveWeekStatusValue.value = true;

        // if there are errors on page and submit won't be done, we should reset doSaveWeekStatusValue flag to false
        // and return to status value that is currently visible
        // in order not to save incorrect status, if later after correcting errors user will click on save button and form will be submitted.
        if (!doSubmit())
        {
            document.SubmitTTForm.doSaveWeekStatusValue.value = false;
            document.SubmitTTForm.effectiveWeekStatusName.value = oldWeekStatusValue;
            return false;
        }
        
        return true;
    }

    /**
     * Highlights the task. When it becomes visible in the viewport, unhighlights it (with a short delay).
     *
     * @param taskId task id
     * @param autoScroll whether to auto-scroll to the task
     */
    function highlightTask(taskId, autoScroll)
    {
        var taskRow = $("tr#taskRow" + taskId);

        if ( !taskRow.get(0) )
            return;

        var prevRow = taskRow.prevAll("tr").first();   // can't use simply prev() because there are scripts between rows

        if( prevRow.length == 0 )
            prevRow = taskRow.parent("tbody").prev().find("tr"); // if it is the first task, then find the header row(s)

        taskRow.addClass('searchHighlight');
        prevRow.addClass('beforeSearchHighlight');

        $(window).scroll( function()
        {
            if( isElementInViewPort( taskRow[0] ) )
                setTimeout( function() {
                    taskRow.removeClass('searchHighlight');
                    prevRow.removeClass('beforeSearchHighlight')
                }, 1500);
        });

        if( autoScroll )
            smoothlyScrollDownToElement( taskRow, 50 );

        $(window).scroll(); // in case the element is already in view and no scrolling needed,
                            // we still need the scroll event to trigger unhighlighting
    }

    function highlightJustAddedTasks()
    {
        <% for( int i: data.getTaskIdsToHighlight() ) { %>
            highlightTask(<%=i%>, false);
        <% } %>
    }

    function addOrHighlightTask(taskId)
    {
        var addedTaskIds = <%=addedTaskIds%>;

        if( $.inArray( taskId, addedTaskIds ) == -1 )
        {
            document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.ADD_TASKS_ACTION %>';
            document.SubmitTTForm.addTaskList.value = taskId;
            document.SubmitTTForm.autoAssignProjects.value = false;
            submitSubmitTTForm();
        }
        else
        {
            highlightTask(taskId, true);
        }
    }

    function taskSearchControl_taskChosen(taskId)
    {
        addOrHighlightTask(taskId);
    }

    function recentTasksControl_taskChosen(taskId)
    {
        addOrHighlightTask(taskId);
    }

    function taskSelectControl_tasksChosen(taskIds)
    {
        document.SubmitTTForm.pageAction.value = '<%= SubmitTTForm.ADD_TASKS_ACTION %>';
        document.SubmitTTForm.addTaskList.value = taskIds.join(",");
        document.SubmitTTForm.autoAssignProjects.value = false;
        submitSubmitTTForm();
    }

    function submitSubmitTTForm() {
        disableWarningOnUnloadPage();
        document.SubmitTTForm.submit();
    }

    function openMyProfilePopup() {
        loadPopupContent( '<html:rewrite page="/profile.do"/>', function() { showUserATProfilePopup(true); }, true );
    }

    function onloadLightbox(){

        if( LeavePopup.validateAndSave() && editDescriptionPopup.hide()){
            editDescriptionPopup.showAboveBasicPopups();
            LeavePopup.leavePopup.hide();
            setSaveHandler("OK", saveOnPageDescription);
            return true;
        }
        return false;
    }

    function onHideLightBox(){
        editDescriptionPopup.showUnderBasicPopups();
        setOldButtonInDescriptionPopup();
    }
</script>

<%-- Do not insert leave_popup.jsp before the form, because there's another form inside, and a lot of existing code
     supposes that the main form is placed first. --%>
<jsp:include page="leave_popup.jsp"/>

<script type="text/javascript" language="JavaScript">
    LeavePopup.setBeforeShowHandler(function() { return closeAllPopups(); })
</script>

<div id="overtimeTitle" class="dhtml_title" style="display: none;"></div>
<div id="taskTitle" class="dhtml_title" style="display: none;"></div>

<jsp:include page="/view_description_popup.jsp"/>
<jsp:include page="/edit_description_popup.jsp">
    <jsp:param name="saveButtonTitle" value="OK"/>
    <jsp:param name="saveButtonFunction" value="saveDescription()"/>
</jsp:include>
<jsp:include page="/controls/tta_history_dialog.jsp"/>

<% if (isWeekStatusIsPresent) { %>
    <jsp:include page="/controls/reject_week_comment_dialog.jsp"/>
    <div id="changeWeekApprovalStatusButtonsTooltip" class="yellowTooltip tooltipText" style="display: none;"></div>
<% } %>

<jsp:include page="/form_changed_confirm.jsp"/>
<br>
<br>
</div>
</body>
</html>

<%!
    /**
     * Generates class name for a cell in summary section depending on the day type.
     * @param data SubmitTTData
     * @param day Day that the cell corresponds to.
     * @return Class name
     */
    public static String getSummaryCellClassName (SubmitTTData data, UserBean user, int day) {
        String className;
        if (data.isDayLockedOrBeforeHireDate(user, day)) {
            className = data.isHoliday(day) ? "calendarDisabledWeekendDayTotal" : "calendarDisabledWorkingDayTotal";
        } else {
            className = data.isHoliday(day) ? "calendarWeekendDayTotal" : "calendarWorkingDayTotal";
        }

        if (data.getWeekInfo().isToday(day))
            className += "_today";
        
        return className;
    }
%>
