SubmitTTData = {};
SubmitTTData.tasks = new AtMap();
SubmitTTData.projects = new AtMap();
SubmitTTData.customers = new AtMap();
SubmitTTData.notAssignedTasksCount = 0;

SubmitTTData.getTaskById = function ( id )
{
    return SubmitTTData.tasks.get( id );
};

SubmitTTData.TASK_WITHOUT_PARENT_ID = -1;

SubmitTTData.TaskBean = function TaskBean( id, name, notAssigned, projectId, parentTaskId )
{
    this.id = id;
    this.name = name;
    this.notAssigned = notAssigned;
    this.project = SubmitTTData.projects.get( projectId );
    this.parentTask = (parentTaskId == SubmitTTData.TASK_WITHOUT_PARENT_ID ? null : SubmitTTData.getTaskById( parentTaskId ));
};

SubmitTTData.TaskBean.prototype.hasParentTask = function ()
{
    return this.parentTask != null;
};

SubmitTTData.TaskBean.prototype.getParentTask = function ()
{
    return this.parentTask;
};

SubmitTTData.TaskBean.prototype.getProject = function ()
{
    return this.project;
};


SubmitTTData.ProjectBean = function ( id, name, customerId )
{
    this.id = id;
    this.name = name;
    this.customer = SubmitTTData.customers.get( customerId );
};

SubmitTTData.ProjectBean.prototype.getCustomer = function ()
{
    return this.customer;
};

SubmitTTData.CustomerBean = function( id, name )
{
    this.id = id;
    this.name = name;
};


SubmitTTData.addCustomer = function( id, name )
{
    SubmitTTData.customers.put( id, new SubmitTTData.CustomerBean( id, name ) );
};

SubmitTTData.addProject = function( id, name, customerId )
{
    SubmitTTData.projects.put( id, new SubmitTTData.ProjectBean( id, name, customerId ) );
};

SubmitTTData.addTask = function( id, name, notAssigned, projectId, parentTaskId )
{
    SubmitTTData.tasks.put( id, new SubmitTTData.TaskBean( id, name, notAssigned, projectId, parentTaskId ) );
};