<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.user.UsersSelector" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="java.util.*" %>
<%@ page import="com.actimind.common.beans.GroupBean" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="static com.actimind.actitime.util.Feature.TTA" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ include file="/user/users_selector_util.jsp"%>

<%--

  @param selectedUserParamName - required, name of selected user parameter
  @param hasSubmitTTRight - required, should be set to true if current user has rights to submit his own time track
  @param hasSubmitOtherUserTTRight - required, should be set to true if user has rights to submit time track for others
  @param isOtherUserSelected - required, should be set to true if currently selected user differs from logged in
  @param selectedUser - required, should be set to id of the selected user
  @param submitCallback - optional, should be set to javascript function name that will be executed after user has been selected.
                            The function should accept single parameter - url of the page where user should be redirected.
                            The final url contains following parts: absolute redirect url + redirectUrlParams + selectedUser parameter.
                            If callback is not specified than redirect to the page will be done after user has been selected.
  @param redirectUrl - required, the url where user should be redirected after selecting different user in selector
                                (the url should be passed without parameters, for example "submit_tt.do")
  @param redirectUrlParams - optional, the list of parameters that should be appended to redirect url. If multiple parameters should be
                                passed, they should be separated with '&'.


--%>
<%
    String selectedUserParamName = request.getParameter("selectedUserParamName");
    boolean hasSubmitTTRight = Boolean.parseBoolean(request.getParameter("hasSubmitTTRight"));
    boolean hasSubmitOtherUserTTRight = Boolean.parseBoolean(request.getParameter("hasSubmitOtherUserTTRight"));
    boolean isOtherUserSelected = Boolean.parseBoolean(request.getParameter("isOtherUserSelected"));
    int selectedUser = Integer.parseInt(request.getParameter("selectedUser"));
    String callback = request.getParameter("submitCallback");
    String redirectUrl = request.getParameter("redirectUrl");
    String params = request.getParameter("redirectUrlParams");
    if(params == null)
        params = "";

    int loggedInUserId = AuthController.getLoggedInUserId( request );

    //noinspection unchecked
    List<UserBean> users = ( List<UserBean> ) request.getAttribute( Keys.USERS_LIST_KEY );
    //noinspection unchecked
    List<GroupBean> groups = ( List<GroupBean> ) request.getAttribute( Keys.USER_GROUPS_LIST_KEY );
%>


<td class="pagetitle"><span><%=message(request, "submit_tt.enter_tt.for")%></span></td>
<td class="userSelectorTd" style="padding-top: 3px"><table cellpadding="0" cellspacing="0"><tr>
    <td class="selectorInputTd">
        <div id="singleUserSelector"></div>
    </td>

    <td class="userSelectorButton"><div class="userNameWrapper"><span class="dashedLink"> </span></div><span class="arrow"></span></td>
    <% if(isOtherUserSelected && hasSubmitTTRight) {%>
    <td class="backToMySheet"><span class="backToMyTTSeparator"></span></td>
    <td class="backToMySheet backToMyTTImg"></td>
    <td class="backToMySheet backToMyTTLabel"><a class="backToMyTtText link"><bean:message key="usersselector.back_to_me"/></a></td>
    <% } %>
    <td><span class="userSelectorSpinnerPlaceholder"></span></td>
</tr></table></td>

<script type="text/javascript">
    var users = [];
    var groups = [];

    <%
        Features enabledFeatures = FeaturesUtil.getFeatures();
        boolean isTTAEnabled = enabledFeatures.isEnabled(TTA);

        if( groups == null )
        {
            addUsersSortedByUserName( out, users, isTTAEnabled );
        }
        else
        {
            List<GroupBean> groupsWithPseudoGroupFirst = new ArrayList<GroupBean>( groups.size() + 1 );
            if(enabledFeatures.isEnabled(Feature.UGR))
                groupsWithPseudoGroupFirst.add( GroupUtils.createUsersWithoutGroupUserGroup( request ) );
            groupsWithPseudoGroupFirst.addAll( groups );
            addUsersSortedByGroupNameUserName( out, users, groupsWithPseudoGroupFirst, isTTAEnabled );
            addGroups( out, groupsWithPseudoGroupFirst );
        }
    %>
    var initialValue;
    <%
        Integer selUserId = null;
        if (selectedUser == UsersSelector.TT_LOGGED_IN_USER_SELECTED )
            selUserId = loggedInUserId;
        else if( selectedUser > 0 )
            selUserId = selectedUser;
        if( selUserId != null ) {
            %> initialValue = <%=selUserId.toString()%>; <%
                        }
                    %>

    var emptyText = "<bean:message key="usersselector.please_select_a_user"/>";
    var hiddenName = "<%=selectedUserParamName%>";
    usersSelector = new SubmitTTUsersSelector(<%=loggedInUserId%>);
    usersSelector.onUserSelect = function(selected)
    {
        var selectedUserParam = (selected > 0 && selected != <%=loggedInUserId%>) ? '&<%=selectedUserParamName + "="%>' + selected : '';

        var url = '<%=response.encodeURL( redirectUrl ) + "?" + params %>' + selectedUserParam;
        if(<%=callback%>) {
            // restore previously selected user in combo-box
            // to ensure consistent behaviour if the callback shows page leaving confirmation
            // (otherwise data may be saved for the wrong user)
            this.usersCombo.setValue(<%=selectedUser%>);
            <%=callback%>(url);
        } else {
            this.leaveAndShowAnimationSpinner();
            window.location.href = url;
        }
    };
    var selectorGroups = EnabledFeatures.UGR ? groups : EnabledFeatures.TZG ? timeZoneGroups :null;
    usersSelector.init( users,selectorGroups , initialValue, emptyText, hiddenName, 0, "usersSelectorOnTT", EnabledFeatures.UGR, EnabledFeatures.TZG);
</script>
