<!doctype html>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at" %>
<%@ page import="com.actimind.actitime.AuthController" %>
<%@ page import="com.actimind.actitime.Navigator" %>
<%@ page import="com.actimind.actitime.beans.UserBean" %>
<%@ page import="com.actimind.actitime.beans.UserScheduleBean" %>
<%@ page import="com.actimind.actitime.util.*" %>
<%@ page import="com.actimind.actitime.user.SubmitTTAccessRightsUtils" %>
<%@ page import="com.actimind.common.beans.GroupBean" %>
<%@ page import="com.actimind.actitime.services.beans.viewtt.ViewTTPageSettings" %>
<%@ page import="com.actimind.common.util.TimestampsCacheUtils" %>

<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<html>
<head>
    <title><bean:write name="<%=Keys.PRODUCT_TITLE_PREFIX%>"/> <bean:message key="view_tt.title"/></title>
    <%@include file="../css/scheme_styles.jsp" %>
    <%@include file="/user/users_selector_util.jsp"%>

    <!--[if !IE]> -->
    <!-- IMPORTANT!! need to include pdfmake BEFORE "/include_scripts.jsp" -->
    <at:script page="/js/pdfmake/pdfmake.min.js"/>
    <at:script page="/js/pdfmake/vfs_fonts.js"/>
    <!-- <![endif]-->

    <jsp:include page="/include_scripts.jsp"/>
    <jsp:include page="/operation_confirm_dialog.jsp"/>

    <at:script page="/js/amcharts/amcharts.js"/>
    <at:script page="/js/amcharts/pie.js"/>
    <at:script page="/js/amcharts/themes/light.js"/>
    <at:script page="/js/amcharts/serial.js"/>

    <!--[if !IE]> -->
    <at:script page="/js/amcharts/plugins/export/export.min.js"/>
    <at:style page="/js/amcharts/plugins/export/export.css"/>

    <at:script page="/js/amcharts/plugins/export/libs/blob.js/blob.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/fabric.js/fabric.min.js"/>
    <at:script page="/js/amcharts/plugins/export/libs/FileSaver.js/FileSaver.min.js"/>
    <!-- <![endif]-->

    <!--[if !IE]> -->
    <at:script page="/js/pdfjs/compatibility.js"/>
    <at:script page="/js/pdfjs/pdf.worker.js"/>
    <at:script page="/js/pdfjs/pdf.js"/>

    <!-- <![endif]-->

    <%-- scripts for dateRangeSelector --%>
    <at:script page="/invertedDays.js" preserveSessionID="true"
               timestampAttributeName="<%=TimestampsCacheUtils.WORK_SCHEDULE_LAST_UPDATE_TIMESTAMP_KEY%>"/>
    <%@include file="/js/util/server_date_time_utils_js.jsp" %>

    <at:script page="/js/controls/dateControls/dropdown_date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/date_range_selector.js"/>
    <at:script page="/js/controls/dateControls/single_date_selector.js"/>
    <at:script page="/js/controls/dateControls/DateRangeSelectorController.js"/>
    <at:script page="/js/controls/dateControls/DateRangeMenuItemsUtil.js"/>
    <%-- end of scripts for dateRangeSelector --%>

    <at:script page="/util/leaveTypesJS.do" preserveSessionID="true" timestampAttributeName="<%=TimestampsCacheUtils.LEAVE_TYPES_CHANGE_TIMESTAMP_KEY%>"/>
</head>
<body class="view_tt with-navigation" topmargin="0" leftmargin="0" marginheight="0" marginwidth="0">

<jsp:include page="/top.jsp" flush="false">
    <jsp:param name="menuSelected" value="<%=Navigator.TT_KEY%>"/>
    <jsp:param name="submenuSelected" value="<%=Navigator.VIEW_TIME_TRACK_KEY%>"/>
</jsp:include>

<jsp:include page="/lightbox.jsp">
    <jsp:param name="id" value='viewTTPdfPreviewLightbox'/>
    <jsp:param name="innerJsp" value='/user/view_tt_pdf_preview_content.jsp'/>
    <jsp:param name="additionalClasses" value='lightboxWithWhiteContent pdfPreviewLightbox noprint'/>
</jsp:include>

<%
    UserBean loggedInUser = AuthController.getLoggedInUser(request);
    Features enabledFeatures = FeaturesUtil.getFeatures();
    boolean hasSubmitOtherUserTTRight = SubmitTTAccessRightsUtils.hasSubmitOtherUserTTRight(request);
    boolean hasSubmitTTRight = SubmitTTAccessRightsUtils.hasSubmitMyTTRight( request );
    boolean isTTAEnabled = enabledFeatures.isEnabled(Feature.TTA);
    ViewTTPageSettings pageSettings = (ViewTTPageSettings) request.getAttribute(Keys.VIEW_TT_PAGE_SETTINGS_KEY);
    //noinspection unchecked
    List<UserBean> users = ( List<UserBean> ) request.getAttribute( Keys.USERS_LIST_KEY );
    //noinspection unchecked
    List<GroupBean> groups = ( List<GroupBean> ) request.getAttribute(Keys.USER_GROUPS_LIST_KEY );
    if ( enabledFeatures.isEnabled(Feature.UGR) && groups != null )
    {
        groups.add(0, GroupUtils.createUsersWithoutGroupUserGroup(request));
    }
    boolean showUsersSelector = hasSubmitOtherUserTTRight && users != null && ( hasSubmitTTRight &&  users.size() > 1 || !hasSubmitTTRight && users.size() > 0
        || pageSettings.getSelectedUserId() != loggedInUser.getId() && users.size() == 1);

    List<UserScheduleBean> userSchedules = (List<UserScheduleBean>) request.getAttribute(Keys.USER_SCHEDULES);

    UserBean selectedUser = null;
    if (pageSettings.getSelectedUserId() != -1)
    {
        for (UserBean userBean : users)
        {
            if (userBean.getId() == pageSettings.getSelectedUserId())
            {
                selectedUser = userBean;
                break;
            }
        }
    }

    boolean displayPto = false;
    boolean displaySick = false;
    String hireDateAsString = null;
    String releaseDateAsString = null;
    int[] initialSchedule = null;
    if (selectedUser != null)
    {
        displayPto = selectedUser.isPTO() && enabledFeatures.isEnabled(Feature.PTO);
        displaySick = selectedUser.isSick() && enabledFeatures.isEnabled(Feature.SDB);
        hireDateAsString = TimeUtils.formatUniformDate(selectedUser.getHireDate());
        releaseDateAsString = TimeUtils.formatUniformDate(selectedUser.getReleaseDate());
        initialSchedule = selectedUser.getInitialSchedule();
    }
%>
<%
    boolean hasTimeZoneGroups = hasSubmitOtherUserTTRight && enabledFeatures.isEnabled(Feature.TZG);
    if (hasTimeZoneGroups) {
%>
    <jsp:include page="/util/time_zone_groups.jsp"/>
<%}%>


<script type="text/javascript">
    PageOverlayTipsManager.setInstance(new ViewTTPageOverlayTipsManager());

    $(function()
      {
          var viewTTData = <%=jsHelper.toJSON(request.getAttribute(Keys.VIEW_TT_DATA))%>;
          var viewTTDisplaySettings = <%=jsHelper.toJSON(request.getAttribute(Keys.VIEW_TT_DISPLAY_SETTINGS_KEY))%>;
          var viewTTPageSettings = <%=jsHelper.toJSON(request.getAttribute(Keys.VIEW_TT_PAGE_SETTINGS_KEY))%>;
          var assignedCPList = <%=jsHelper.toJSON(request.getAttribute(Keys.CUSTOMERS_PROJECTS_DATA_KEY))%>;
          var userInitialSchedule = <% if (initialSchedule == null) { %>null<% } else { %><%=jsHelper.toJSON(initialSchedule)%><% } %>;
          var userSchedules = <% if (userSchedules == null) { %>null<% } else { %><%=jsHelper.toJSON(userSchedules)%><% } %>;
          var hoursPerDay = <%=jsHelper.toJSON(request.getAttribute(Keys.HOURS_PER_DAY))%>;
          var hireDate = <% if (hireDateAsString == null) { %>null<% } else { %>'<%=hireDateAsString%>'<% } %>;
          var releaseDate = <% if (releaseDateAsString == null) { %>null<% } else { %>'<%=releaseDateAsString%>'<% } %>;
          var loggedInUserId = <%=loggedInUser.getId()%>;
          var hasTimeZoneGroups = <%=hasTimeZoneGroups%>;
          var users = [];
          var user;
          var groups = [];
          var group;
          <%
          if (users != null)
          {
            addUsersSortedByUserName( out, users, isTTAEnabled );
          }
          if ( groups != null )
          {
            addGroups(out, groups);
          }
          %>
          var balancesViewerConfig = <% if (selectedUser != null) { %>
          {
              "hireDate": hireDate,
              "releaseDate": releaseDate,
              "initialSchedule": userInitialSchedule,
              "schedules": userSchedules,
              "displayPto": <%=displayPto%>,
              "displaySick": <%=displaySick%>
          }
          <% } else { %>null<% } %>;
//_.noConflict();
          new ViewTTMediator().init({
                                        "viewerId": loggedInUserId,
                                        "data": viewTTData,
                                        "displaySettings": viewTTDisplaySettings,
                                        "pageSettings": viewTTPageSettings,
                                        "assignedCPList": assignedCPList,
                                        "users": users,
                                        "groups": EnabledFeatures.UGR ? groups : hasTimeZoneGroups ? timeZoneGroups : null,
                                        "needToRenderUsersSelector": <%=showUsersSelector%>,
                                        "balancesViewerConfig" : balancesViewerConfig,
                                        "formatterConfig":
                                        {
                                            "workHoursPerDay": hoursPerDay
                                        }
                                    });
      });
</script>

</body>
</html>
