<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ page import="com.actimind.actitime.ATProfileData" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="com.actimind.actitime.AccessRight" %>
<%@ page import="static com.actimind.actitime.util.Feature.PTO" %>
<%@ page import="static com.actimind.actitime.util.Feature.SDB" %>
<%@ page import="static com.actimind.actitime.util.Feature.PAS" %>
<%@ page import="com.actimind.actitime.util.Features" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>

<%
    String id = request.getParameter("id");
    Features features = FeaturesUtil.getFeatures();
    boolean isPTOEnabled = features.isEnabled(PTO);
    boolean isSickEnabled = features.isEnabled(SDB);
    ATProfileData profileData = (ATProfileData) request.getAttribute(Keys.USER_PROFILE_POPUP_DATA_KEY );
%>
<%if (features.isEnabled(PAS)) {
    int numOfAssignedProjects = profileData.getAssignedProjects().size();
%>
    <div class="profileRightSectionBlock" id="profileAssignmentsSection">
        <div class="sectionHeader">
            <bean:message key="profile.right_section.block_header_projects_assignments"/>
        </div>
        <div>
            <%if(numOfAssignedProjects != 0 ) {%>
            <span>
                <bean:message key="profile.right_section.block_projects_assignments_access"/>
            </span>
            <span id="projectsNumberLabel">
                <% if (profileData.isAllProjectsAssigned()) { %>
                    <bean:message key="userlist.js.project_assignments.all_projects"/>
                <% } else { %>
                    <%if(numOfAssignedProjects == 1) {%>
                        <bean:message key="userlist.js.project_assignments.one_project"/>
                    <%} else {%>
                        <bean:message key="userlist.js.project_assignments.some_projects" arg0="<%=String.valueOf(numOfAssignedProjects) %>"/>
                    <%}%>
                <% } %>
            </span>
            <%} else {%>
            <span>
                <bean:message key="profile.right_section.block_projects_assignments_no_access"/>
            </span>
            <%}%>
        </div>
    </div>
<% } %>

<div class="profileRightSectionBlock" id="profilePermissionsSection">
    <div class="sectionHeader">
        <bean:message key="profile.right_section.block_header_permissions"/>
    </div>
    <div id="profilePopup_permissionsTable">
        <div class="noPermissionsWarning">
            <div class="permissionsBlock errormsg"><bean:message key="profile.cannot_seen_any_pages_warning"/></div>
        </div>
        <div class="permission-time-track">
            <%
                boolean isCanSubmitTT = profileData.getUserRights().contains(AccessRight.SUBMIT_TIME_TRACK);
                boolean isCanSubmitTTOther = profileData.getUserRights().contains(AccessRight.SUBMIT_OTHER_USER_TIME_TRACK);
                boolean isCanLockTT = profileData.getUserRights().contains(AccessRight.LOCK_TIME_TRACK);
                boolean isTTSectionInactive = !(isCanSubmitTT || isCanSubmitTTOther || isCanLockTT);
            %>
            <div class="permissionsBlock">
                <table>
                    <tr>
                        <th colspan="2" class="sectionSubHeader <%if( isTTSectionInactive ){%>inactive<%}%>">
                            <bean:message key="userlist.userdata.time_track_submission"/>
                        </th>
                    </tr>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanSubmitTT) {%> active rowWithTick <%}%>">
                            <label>
                                <bean:message key="userlist.userdata.enter_time_track"/>
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanSubmitTTOther) {%> active rowWithTick <%}%>">
                            <label>
                                <% if( FeaturesUtil.getFeatures().isEnabled(Feature.TTA ) ){ %>
                                <bean:message key="userlist.userdata.modify_data_of_other_users_tta_enabled"/>
                                <%}else{%>
                                <bean:message key="userlist.userdata.modify_data_of_other_users_tta_disabled"/>
                                <%} %>
                            </label>
                        </td>
                    </tr>
                    <% if ( FeaturesUtil.getFeatures().isEnabled(Feature.LTT)) { %>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanLockTT) {%> active rowWithTick <%}%>">
                            <label>
                                <bean:message key="userlist.userdata.lock_time_track"/>
                            </label>
                        </td>
                    </tr>
                    <% } %>
                </table>
            </div>
        </div>
        <%
            boolean isCanManageCP = profileData.getUserRights().contains(AccessRight.MANAGE_CUSTOMERS_PROJECTS);
            boolean isCanManageTasks = profileData.getUserRights().contains(AccessRight.MANAGE_TASKS);
            boolean isHierarchySectionInactive = !(isCanManageCP || isCanManageTasks);
        %>
        <div class="permission-hierarchy">
            <div class="permissionsBlock">
                <table>
                    <tr>
                        <th colspan="2" class="sectionSubHeader <%if (isHierarchySectionInactive) {%>inactive<%}%>">
                            <bean:message key="userlist.userdata.hierarchy_management"/>
                        </th>
                    </tr>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanManageCP) {%> active rowWithTick <%}%>">
                            <label>
                                <bean:message key="userlist.userdata.manage_customers_projects" />
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanManageTasks) {%> active rowWithTick <%}%>">
                            <label>
                                <bean:message key="userlist.userdata.manage_tasks"/>
                            </label>
                        </td>
                    </tr>
                </table>
            </div>
        </div>

        <%
            boolean isCanGenerateTimeReports = profileData.getUserRights().contains(AccessRight.GENERATE_TIME_REPORTS);
            boolean isCanGenerateMoneyReports = profileData.getUserRights().contains(AccessRight.GENERATE_MONEY_REPORTS);
            boolean isMoneyReportsEnabled = features.isEnabled(Feature.BTY) || features.isEnabled(Feature.URA);
            boolean isReportingSectionInactive = !(isCanGenerateTimeReports || (isCanGenerateMoneyReports && isMoneyReportsEnabled));
        %>
        <div class="bottomPane permission-reporting">
            <div class="permissionsBlock">
                <table>
                    <tr>
                        <th colspan="2" class="sectionSubHeader <%if (isReportingSectionInactive) {%>inactive<%}%>">
                            <bean:message key="userlist.userdata.reporting"/>
                        </th>
                    </tr>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanGenerateTimeReports) {%> active rowWithTick <%}%>">
                            <label id="<%=id%>_generateTimeReportsLabel">
                                <bean:message key="<%=AccessRight.GENERATE_TIME_REPORTS.getDescriptionKey( application )%>"/>
                            </label>
                        </td>
                    </tr>
                    <%if(isMoneyReportsEnabled){%>
                    <tr id="<%=id%>_generateMoneyReportRightContainer">
                        <td class="permissionLabelContainer <%if (isCanGenerateMoneyReports) {%> active rowWithTick <%}%>">
                            <label id="<%=id%>_generateMoneyReportsLabel">
                                <bean:message key="<%=AccessRight.GENERATE_MONEY_REPORTS.getDescriptionKey( application )%>"/>
                            </label>
                        </td>
                    </tr>
                    <%}%>
                </table>
            </div>
        </div>
        <%
            boolean isCanManagePTOAndSDB = profileData.getUserRights().contains(AccessRight.MANAGE_PTO_AND_SICK);
            boolean isCanManageUsers = profileData.getUserRights().contains(AccessRight.MANAGE_USERS);
            boolean isCanManageGS = profileData.getUserRights().contains(AccessRight.MANAGE_GENERAL_SETTINGS);
            boolean isManagementSectionInactive = !(isCanManagePTOAndSDB && (isPTOEnabled || isSickEnabled) || isCanManageUsers || isCanManageGS);
        %>
        <div class="bottomPane permission-management">
            <div class="permissionsBlock">
                <table>
                    <tr>
                        <th colspan="2" class="sectionSubHeader <%if (isManagementSectionInactive) {%>inactive<%}%>">
                            <bean:message key="userlist.userdata.user_management_settings"/>
                        </th>
                    </tr>
                    <%if(isPTOEnabled || isSickEnabled) {%>
                    <tr id="<%=id%>_ptoRightContainer">
                        <td class="permissionLabelContainer <%if (isCanManagePTOAndSDB) {%> active rowWithTick <%}%>">
                            <label>
                                <% if ( isPTOEnabled && isSickEnabled ) { %>
                                <bean:message key="userlist.userdata.pto_and_sick_settings"/>
                                <% } else if ( isSickEnabled ) { %>
                                <bean:message key="userlist.userdata.sick_settings"/>
                                <% } else { %>
                                <bean:message key="userlist.userdata.pto_settings"/>
                                <% } %>
                            </label>
                        </td>
                    </tr>
                    <%}%>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanManageUsers) {%> active rowWithTick <%}%>">
                            <label id="<%=id%>_manageAccountsLabel">
                                <bean:message key="userlist.userdata.accounts_permissions"/>
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td class="permissionLabelContainer <%if (isCanManageGS) {%> active rowWithTick <%}%>">
                            <label>
                                <bean:message key="userlist.userdata.manage_system_settings"/>
                            </label>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</div>


