<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.message" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.common.ProfileData" %>
<%@ page import="org.apache.struts.util.ResponseUtils" %>

<%@ taglib prefix="at" uri="/WEB-INF/at.tld" %>
<%@ taglib prefix="bean" uri="http://struts.apache.org/tags-bean" %>
<%@ taglib prefix="tiles" uri="http://struts.apache.org/tags-tiles" %>

<%
    String id = request.getParameter("id");
    String productsIntegrated = (Boolean) request.getAttribute( Keys.PRODUCTS_INTEGRATED ) ? Keys.PRODUCTS_INTEGRATED : "";
    String includedLeftSection = request.getParameter( "includedSection" );
    String includedRightSection = request.getParameter( "includedRightSection" );
    ProfileData profileData = (ProfileData) request.getAttribute(Keys.USER_PROFILE_POPUP_DATA_KEY );

    boolean isUGREnabled = Boolean.valueOf(request.getParameter("isUGREnabled"));
    boolean isTZGEnabled = Boolean.valueOf(request.getParameter("isTZGEnabled"));
    boolean isPTOEnabled = Boolean.valueOf(request.getParameter("isPTOEnabled"));
    boolean isSickEnabled = Boolean.valueOf(request.getParameter("isSickEnabled"));

    boolean areMailSettingsSpecified = Boolean.valueOf(request.getParameter("areMailSettingsSpecified"));
    String mailSettingsNotSpecified = areMailSettingsSpecified ? "" : "mailSettingsNotSpecified";
%>

<table class="dialog-header <%=productsIntegrated%>">
    <tr>
        <td class="lightBoxTitle">
            <span class="pageTitleWithSharedSettingsImage"><%=message( request, "profile.page.header")%></span>
            <span class="sharedSettingsImage" title='<bean:message key="general_settings.shared_settings"/>'></span>
        <div class="close-button">
            <div id="closeUserProfilePopupButton" class="closeButton"></div>
            <div class="disabledCloseButton"></div>
        </div>
        </td>
    </tr>
</table>
<div class="innerContent <%=mailSettingsNotSpecified%>">
    <div class="leftSection" style="float: left;">
        <jsp:include page="<%=includedLeftSection%>"/>
    </div>
    <div class="rightSection">
        <div class="scrollableContainer">
            <div class="profileRightSectionBlock first" id="profilePopupGroupsSection">
                <div class="sectionHeader">
                    <%if (isUGREnabled && isTZGEnabled) { %>
                        <bean:message key="profile.right_section.block_header_user_and_time_zone_group"/>
                    <% } else if (isUGREnabled) { %>
                        <bean:message key="profile.right_section.block_header_user_group"/>
                    <% } else if (isTZGEnabled) { %>
                        <bean:message key="profile.right_section.block_header_time_zone_group"/>
                    <% } else { %>
                        <bean:message key="profile.right_section.block_header_time_zone"/>
                    <% } %>
                </div>
                <%if (isUGREnabled) { %>
                    <div class="profileRightSectionRow">
                        <bean:message key="profile.right_section.block_department.department"/>
                        <span id="profilePopup_DepartmentName"><%=ResponseUtils.filter(profileData.getGroupName())%></span>
                    </div>
                <% } %>
                <div class="profileRightSectionRow">
                    <bean:message key='<%= isTZGEnabled ? "profile.right_section.block_department.tz_group" : "profile.right_section.block_department.tz" %>'/>
                    <span id="profilePopup_TimeZoneGroup"><%=ResponseUtils.filter(profileData.getTimeZoneGroupName())%></span>
                    <span id="profileCurrentTime"></span>
                </div>
            </div>

            <div class="profileRightSectionBlock <%if (!isUGREnabled && !isTZGEnabled) {%>first <% } %>" id="profilePopupWorkScheduleSection">
                <div class="sectionHeader">
                    <bean:message key="profile.right_section.block_header_work_schedule"/>
                </div>
                <table>
                    <tr>
                        <td>
                            <div id="schedulePlaceholder"></div>
                        </td>
                        <td style="vertical-align: bottom; ">
                            <div id="workScheduleRightCell">
                                <div id="weekTotalPlaceholder"></div>
                                <% if (profileData.isDefaultEffectiveSchedule()) {%> <div id="defaultScheduleMessage"><bean:message key="profile.right_section.block_work_schedule.default"/></div> <% } %>
                            </div>
                        </td>
                    </tr>
                </table>


            </div>

            <%if (isSickEnabled || isPTOEnabled) {%>
                <div class="profileRightSectionBlock" id="profileBalanceRulesSection">
                    <div class="sectionHeader">
                        <bean:message key="profile.right_section.block_header_pto_sick_rules"/>
                    </div>

                    <%if (isPTOEnabled) { %>
                        <div id="ptoRulesSection">
                            <div class="sectionSubHeader">
                                <bean:message key="profile.right_section.block__pto_sick_rules.pto"/>
                                <span class="defaultRulesMessage" id="defaultPtoRulesSettings">
                                    <bean:message key="profile.right_section.block_work_schedule.default"/>
                                </span>
                            </div>
                            <div class="readOnlyResetRule ruleRow rowWithTick"></div>
                            <div class="readOnlyAccrualRule ruleRow rowWithTick"></div>
                            <div class="readOnlyCapRule ruleRow rowWithTick"></div>
                        </div>
                    <% } %>

                    <%if (isSickEnabled) { %>
                        <div id="sickDaysRulesSection">
                            <div class="sectionSubHeader">
                                <bean:message key="profile.right_section.block__pto_sick_rules.sick"/>
                                <span class="defaultRulesMessage" id="defaultSickDaysRulesSettings">
                                    <bean:message key="profile.right_section.block_work_schedule.default"/>
                                </span>
                            </div>
                            <div class="readOnlyResetRule ruleRow rowWithTick"></div>
                            <div class="readOnlyAccrualRule ruleRow rowWithTick"></div>
                            <div class="readOnlyCapRule ruleRow rowWithTick"></div>
                        </div>
                    <% } %>
                </div>
            <% } %>

            <% if (includedRightSection != null) {%>
                <jsp:include page="<%=includedRightSection%>"/>
            <% } %>
        </div>
    </div>
</div>
<div id="<%=id%>_footer">
    <div class="footerLeftSection">
        <table cellpadding=0 cellspacing=0 border=0 style="width: 100%;">
            <tr>
                <td class="errorMessageBox">
                    <at:img page="error.gif"/>
                    <span class="errormsg"></span>
                </td>
                <td class="buttonsBox">
                    <span class="changesMsg"><bean:message key="profile.not_saved"/></span>
                    <span class="savingMsg"><bean:message key="profile.saving"/></span>
                    <div id="<%=id%>_commitBtn" class="greyButton commitBtn"><bean:message key="profile.save"/></div>
                    <div id="<%=id%>_cancelBtn" class="greyButton cancelBtn"><bean:message key="profile.cancel"/></div>
                </td>
            </tr>
        </table>
    </div>
    <div class="footerRightSection">
    </div>
</div>
