<%@ page import="com.actimind.actitime.Constants" %>
<%@ page import="com.actimind.actitime.Keys" %>
<%@ page import="com.actimind.actitime.util.Feature" %>
<%@ page import="static com.actimind.actitime.util.messages.ATMessageResources.jsMessage" %>
<%@ page import="com.actimind.actitime.util.Features" %>
<%@ page import="com.actimind.actitime.util.FeaturesUtil" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="/WEB-INF/at.tld" prefix="at"%>
<%--
  User: bandurin
  Date: 25.08.2008
--%>

<%@ page contentType="text/html;charset=UTF-8" language="java" %>

<%
    Features enabledFeatures = FeaturesUtil.getFeatures();
    boolean isUserGroupEnabled = enabledFeatures.isEnabled(Feature.UGR);
    boolean isTimeZoneGroupsEnabled = enabledFeatures.isEnabled(Feature.TZG);
%>

<bean:define id="settings" name="<%=Keys.SYSTEM_SETTINGS_LOADER%>" property="systemSettings" type="com.actimind.actitime.resources.SystemSettings"  />

<div id="projectTeamSelector" class="dualSelector createPanelDualSelector">
    <jsp:include page="/util/assigned_users.jsp"/>
    <% if( isUserGroupEnabled ) { %>
        <jsp:include page="/util/user_groups.jsp"/>
    <% } %>
    <% if( isTimeZoneGroupsEnabled ) { %>
        <jsp:include page="/util/time_zone_groups.jsp"/>
    <% } %>
    <script type="text/javascript">
        var GROUP_BY_SETTING_COOKIE_NAME = "projectTeamSelectorGroupBySetting";
        var GROUP_BY_TIME_ZONE_GROUPS_SETTING_NAME = "groupByTimeZoneGroups";
        var GROUP_BY_USER_GROUPS_SETTING_NAME = "groupByUserGroups";

        var dualSelector;
        var leftGroupPresentationController;
        var rightGroupPresentationController;
        var leftListController;
        var rightListController;
        var groupIdKey;

        var userSelectorChangeListener = {
            changed:false,
            setChanged:function() {
                if(!this.changed) {
                    this.changed = true;
                    this.callback();
                }
            },
            callback:function(){}
        };

        var itemKeyGenerator = new KeyGenerator();
        //function to create unique key for User object
        itemKeyGenerator.createKey = function(object)
        {
            return object.id;
        };
        var userGroupEnabled = "<%=isUserGroupEnabled%>" == 'true';
        var timeZoneGroupEnabled = "<%=isTimeZoneGroupsEnabled%>" == 'true';

        //get Project Team from server
        var assignedUsers = [];
        var i = 0;

        var groupTypeInSelector;
        if (timeZoneGroupEnabled && userGroupEnabled)
        {
            var groupBySettingFromCookies = $.cookie(GROUP_BY_SETTING_COOKIE_NAME);
            groupTypeInSelector = groupBySettingFromCookies == GROUP_BY_TIME_ZONE_GROUPS_SETTING_NAME ?  GroupType.TIME_ZONE_GROUP : GroupType.USER_GROUP;
        }
        else
        {
            groupTypeInSelector = userGroupEnabled ? GroupType.USER_GROUP : timeZoneGroupEnabled ? GroupType.TIME_ZONE_GROUP : null;
        }

        <%
        Integer[] teamUsers = (Integer[]) request.getAttribute("teamUsers");
        for(int i = 0; i < teamUsers.length; i++)
        {
        %>
            assignedUsers[i++] = <%=teamUsers[i]%>;
        <%
        }
        %>
        //add to project team user who have access to allprojects of all customers.
        for(i = 0; i < assignmentUsers.length; i++)
        {
            var  user = assignmentUsers[i];
            if (user.isAllProjectsAvailable)
            {
                assignedUsers.push(itemKeyGenerator.createKey(user));
            }
        }

        //create duallist controller.
        var rightUsersStatisticsCtrl = new UsersStatistics();
        var leftUsersStatisticsCtrl = new UsersStatistics();
        var leftPresentationController = new UsersPresentationController("listOfAllUsers", "emptyAllUsersList");
        var rightPresentationController = new UsersPresentationController("listOfUsersInProject", "emptyProjectTeam");
        var leftContentController = new UsersContentController();
        var rightContentController = new UsersContentController();
        var leftOutputDataController = new OutputDataController(false, "fake");
        var rightOutputDataController = new OutputDataController(true, "projectTeam");

        var secondHierarchyLevelLowerCaseSingularForm = "<%=jsMessage(request, "common.project")%>";

        leftPresentationController.getTextForEmptyList = function()
        {
            if (this.isShowDisabledUsers())
            {
                return messageResource.getEscapedMessage('usersselector.avusers.list.empty.withdisabledusers');
            }
            return messageResource.getEscapedMessage('usersselector.avusers.list.empty.withoutdisabledusers');
        };

        leftPresentationController.showEmptyList = function()
        {
            this.getElementContainer().style.display = "none";
            var divElement = this.emptyElement.getElement();
            divElement.style.display = "block";
            divElement.className = "EmptyDivStyle";
            divElement.innerHTML = this.getTextForEmptyList();
        };

        rightPresentationController.showEmptyList = function()
        {
            this.getElementContainer().style.display = "none";
            var divElement = this.emptyElement.getElement();
            divElement.style.display = "block";
            divElement.className = "RightEmptyDivStyle";
            divElement.innerHTML = this.getTextForEmptyList();
        };

        rightPresentationController.getTextForEmptyList = function ()
        {
            return "";    
        };


        rightOutputDataController.isObjectIncludedToOutput = function(object)
        {
            return !object.isAllProjectsAvailable;
        };

        rightOutputDataController.getOutputDataForObject = function(object)
        {
            return object.id;
        };


        function initSelector() {

        if( groupTypeInSelector != null )
        {
            leftGroupPresentationController = new UsersGroupPresentationController("listOfAllUsers", false);
            rightGroupPresentationController = new UsersGroupPresentationController("listOfUsersInProject", false);

            if(groupTypeInSelector == GroupType.TIME_ZONE_GROUP) {
                groups = timeZoneGroups;
                groupIdKey = "timeZoneGroupId";

                var defaultPresentation = UsersGroupPresentationController.prototype.getItemStringPresentation;
                var defaultTZGroupPresentation = function(group) {
                    var ret = defaultPresentation(group);
                    if(group.id == DEFAULT_TIME_ZONE_GROUP_ID)
                    {
                        ret = truncateStringByLength(ret, 32);
                        ret += ' ' + messageResource.getMessage("users_selector.default_group");
                    }
                    return ret;
                };
                leftGroupPresentationController.getItemStringPresentation = defaultTZGroupPresentation;
                rightGroupPresentationController.getItemStringPresentation = defaultTZGroupPresentation;
            }
            else {
                groups = userGroups;
                groupIdKey = "userGroupId";
            }


            userGroupKeyGenerator = new KeyGenerator();

            //function to create unique group key for User object
            userGroupKeyGenerator.createKey = function(object)
            {
                return object[groupIdKey] === null ? <%=Constants.USERS_WITHOUT_GROUP_ID%> : object[groupIdKey];
            };

            leftListController = new GroupListController(itemKeyGenerator,
                    userGroupKeyGenerator,
                    groups,
                    leftPresentationController,
                    leftGroupPresentationController,
                    leftContentController,
                    leftOutputDataController,
                    leftUsersStatisticsCtrl);
            rightListController = new GroupListController(itemKeyGenerator,
                    userGroupKeyGenerator,
                    groups,
                    rightPresentationController,
                    rightGroupPresentationController,
                    rightContentController,
                    rightOutputDataController,
                    rightUsersStatisticsCtrl);
        }
            else
        {
            leftListController = new ListController(itemKeyGenerator,
                    leftPresentationController,
                    leftContentController,
                    leftOutputDataController,
                    leftUsersStatisticsCtrl);
            rightListController = new ListController(itemKeyGenerator,
                    rightPresentationController,
                    rightContentController,
                    rightOutputDataController,
                    rightUsersStatisticsCtrl);
        }
             dualSelector = new DualListController( assignmentUsers,
                                                   assignedUsers,
                                                   leftListController,
                                                   rightListController);
        }
        initSelector();
        function onChangeSelection(listController)
        {
            var pos = listController.objectPresentationController.getElement().scrollTop;
            listController.updateSelection();
            listController.objectPresentationController.getElement().scrollTop = pos;
        }

        var disableDoubleClick = true;
        var lastSelectedIndex = -1;
        var lastClickOption = document.createElement('option');

        function setLastClickOption(select)
        {
            if (select.selectedIndex !== -1)
                lastClickOption = select.options[select.selectedIndex];

            disableDoubleClick = ( select.selectedIndex === -1 ) && ( lastSelectedIndex === -1 );
            lastSelectedIndex = select.selectedIndex;
        }

        function moveRight( event, isDblClick )
        {
            if (event && event.ctrlKey)
                return;

            if ( isDblClick && !disableDoubleClick )
                lastClickOption.selected = true;

            onChangeSelection(leftListController);
            var du = rightUsersStatisticsCtrl.getDisabledUsersNumber();
            if(dualSelector.moveRight())
            {
                if (du != rightUsersStatisticsCtrl.getDisabledUsersNumber())
                {
                    document.getElementById("inProjectTeam").checked = true;
                    rightPresentationController.setShowDisabledUsers(true);
                    dualSelector.rightList.getSelectedObjects();
                    dualSelector.rightList.updateList();
                }

                updateUsersCounter();

                userSelectorChangeListener.setChanged();
            }


            if (onChangeAssignTeamUserSelectorCallback != undefined){
                onChangeAssignTeamUserSelectorCallback();
            }
        }

        function moveLeft( event, isDblClick )
        {
            if (event && event.ctrlKey)
                return;

            if ( isDblClick && !disableDoubleClick )
                lastClickOption.selected = true;

            onChangeSelection(rightListController);
            var du = leftUsersStatisticsCtrl.getDisabledUsersNumber();
            if(dualSelector.moveLeft())
            {
                updateUsersCounter();
                if (du != leftUsersStatisticsCtrl.getDisabledUsersNumber())
                {
                    document.getElementById("inAllUsers").checked = true;
                    leftPresentationController.setShowDisabledUsers(true);
                    dualSelector.leftList.getSelectedObjects();
                    dualSelector.leftList.updateList();
                }

                updateUsersCounter();

                userSelectorChangeListener.setChanged();
            }


            if (onChangeAssignTeamUserSelectorCallback != undefined){
                onChangeAssignTeamUserSelectorCallback();
            }
       }

        function getUserText()
        {
            return rightUsersStatisticsCtrl.getUsersNumber() == 1 ? "user" : "users";
        }

       function updateUsersCounter()
       {
           var summaryHtml = messageResource.getMessage('usersselector.asusers.summary.users.normal',
                                                        [rightUsersStatisticsCtrl.getUsersNumber(), getUserText()]);
           if (rightUsersStatisticsCtrl.getDisabledUsersNumber() > 0)
           {
               summaryHtml += " " + messageResource.getMessage('usersselector.asusers.summary.disabled_access',
                                                               [rightUsersStatisticsCtrl.getDisabledUsersNumber()]);
           }

           document.getElementById("usersCounter").innerHTML = summaryHtml;
       }

        function updateGroupingContainer(){
            if (userGroupEnabled && timeZoneGroupEnabled){
                if(groupTypeInSelector == GroupType.USER_GROUP){
                    $("#userGroupsContainerGrouping").addClass("selected");
                    $("#timeZongGroupsContainerGrouping").removeClass("selected");
                }
                else{
                    $("#userGroupsContainerGrouping").removeClass("selected");
                    $("#timeZongGroupsContainerGrouping").addClass("selected");
                }
            }
        }

        function updateGroupTypeWithUI(groupType)
        {
            var selectedObjects = dualSelector.rightList.objects.getValues();
            assignedUsers = _.map(selectedObjects,function(item) { return item.id; });
            groupTypeInSelector = groupType;
            initSelector();
            updateGroupingContainer();
            dualSelector.update();
            saveGroupBySettingsToCookie(groupType);
        }

        function saveGroupBySettingsToCookie(groupType)
        {
            var value = groupType == GroupType.TIME_ZONE_GROUP ? GROUP_BY_TIME_ZONE_GROUPS_SETTING_NAME : GROUP_BY_USER_GROUPS_SETTING_NAME;
            $.cookie(GROUP_BY_SETTING_COOKIE_NAME, value, { expires: 365 });
        }

       function  reloadSelector(users){
           assignmentUsers = [];
           assignmentUsersId = [];
           assignedUsers =[];
           var rightListUsers = rightListController.objects.getValues();
           for( i = 0; i < rightListUsers.length; ++i )
               assignedUsers.push( rightListUsers[i].id );

           var newAssignedUsers =[];
           for( var i = 0; i < users.length; ++i )
           {
               assignmentUsers.push( new AssignmentUser( users[i].id,
                                                         users[i].formattedName,
                                                         users[i].activeInAT,
                                                         users[i].hasAccessToAllProjects,
                                                         users[i].userGroupId,
                                                         users[i].timeZoneGroupId   ) );
               if (jQuery.inArray( users[i].id, assignedUsers ) != -1 || users[i].hasAccessToAllProjects)
                   newAssignedUsers.push( itemKeyGenerator.createKey(users[i]));
           }

           assignedUsers = newAssignedUsers;
           initSelector();
           dualSelector.update();
           updateUsersCounter();
        }
    </script>
    <table cellpadding="0" cellspacing="0" border="0">
        <tr>
            <td class="selecterHeader listtblcolheader ">
                <div class="keyHeader"><bean:message key="usersselector.available.header"/></div>
                <% if (isUserGroupEnabled && isTimeZoneGroupsEnabled){ %>
                <div class="userGrouping">
                    <span id="userGroupsContainerGrouping" class="container userGroups" onclick="updateGroupTypeWithUI(GroupType.USER_GROUP)">
                        <span class="text"><bean:message key="usersselector.groupByUserGroup"/> </span>
                    </span>
                    <span id="timeZongGroupsContainerGrouping" class="container timeZoneGroups"  onclick="updateGroupTypeWithUI(GroupType.TIME_ZONE_GROUP)">
                        <span class="text"><bean:message key="usersselector.groupByTimeZoneGroup"/></span>
                    </span>
                </div>
                <% } %>
            </td>
            <td> </td>
            <td class="selecterHeader listtblcolheader">
                <div class="keyHeader"><bean:message key="usersselector.asusers.header"/></div>
                <span id="usersCounter"></span>
            </td>
        </tr>
        <tr>
            <td valign="top" class="selectorArea">
                <div id="listOfAllUsersContainer">
                    <select id="listOfAllUsers" class="list" size="20" multiple="true" style="background-color: #ffffff; border:0;overflow-y: auto"
                            onchange="onChangeSelection(leftListController);"
                            onmousedown="setLastClickOption(this);"
                            onclick="setLastClickOption(this);"
                            ondblclick="moveRight(event, true);">
                    </select>
                </div>
                <div id="emptyAllUsersList" class="list" style="display:none">
                </div>
                <div style="display:none">
                    <select id="fake" style="border:0;">
                    </select>
                </div>
                <table cellpadding="0" cellspacing="0" border="0" class="selectorCheckboxArea">
                    <tr>
                        <td valign="middle">
                            <input type="checkbox" name="inAllUsers" id="inAllUsers"
                                   onclick="leftPresentationController.setShowDisabledUsers(this.checked);
                                            dualSelector.leftList.updateList();"/>
                        </td>
                        <td class="selectorCheckboxArea_text">
                            <label id="inAllUsersLabel" for="inAllUsers"><bean:message key="usersselector.checkbox.label.disabled.users"/></label>
                        </td>
                    </tr>
                </table>
            </td>
            <td width="60px" align="center" class="actionsControls">
                <br/>
                <div style="width: 32px">
                <div class="actionsButtons left" onclick="moveRight();">
                </div>
                <div class="actionsButtons right" onclick="moveLeft();">
                </div>
               </div>
                <br/>
                <div class="controlSeparator">&nbsp;</div>
                <br/>
            </td>
            <td valign="top" class="selectorArea">
                <table cellpadding="0" cellspacing="0" border="0">
                    <tr><td valign="top">
                        <div id="listOfUsersInProjectContainer">
                            <select id="listOfUsersInProject" class="list" size="20" multiple="true"  style="border:0;overflow-y: auto"
                                onchange="onChangeSelection(rightListController);"
                                onmousedown="setLastClickOption(this);"
                                onclick="setLastClickOption(this);"
                                ondblclick="moveLeft(event, true);">
                            </select>
                        </div>
                        <div style="display:none">
                            <select id="projectTeam" name="projectTeam" multiple="true" style="border:0;">
                            </select>
                        </div>
                        <div id="emptyProjectTeam" style="display:none">
                        </div>
                        <table cellpadding="0" cellspacing="0" border="0" class="selectorCheckboxArea">
                            <tr>
                                <td valign="middle">
                                    <input type="checkbox" name="inProjectTeam" id="inProjectTeam"
                                           onclick="rightPresentationController.setShowDisabledUsers(this.checked);
                                                    dualSelector.rightList.updateList();"/>
                                </td>
                                <td class="selectorCheckboxArea_text">
                                    <label id="inProjectTeamLabel" for="inProjectTeam"><bean:message key="usersselector.checkbox.label.disabled.users"/></label>
                                </td>
                            </tr>
                        </table>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
   <script type="text/javascript">
       disableTextSelection(document.getElementById("inAllUsersLabel"));
       disableTextSelection(document.getElementById("inProjectTeamLabel"));
       rightPresentationController.setShowDisabledUsers(false);
       leftPresentationController.setShowDisabledUsers(false);
       dualSelector.update();
       updateUsersCounter();
       updateGroupingContainer();
   </script>
</div>